/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ie=["require","exports","vs/editor/common/core/range","vs/base/common/errors","vs/editor/common/core/offsetRange","vs/editor/common/core/position","vs/base/common/arrays","vs/base/common/strings","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/diffAlgorithm","vs/base/common/arraysFind","vs/base/common/lifecycle","vs/base/common/event","vs/editor/common/core/lineRange","vs/base/common/assert","vs/base/common/objects","vs/editor/common/diff/defaultLinesDiffComputer/utils","vs/editor/common/diff/rangeMapping","vs/base/common/platform","vs/base/common/uri","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/map","vs/base/common/stopwatch","vs/base/common/cancellation","vs/base/common/diff/diff","vs/base/common/types","vs/base/common/codiconsUtil","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/myersDiffAlgorithm","vs/editor/common/diff/defaultLinesDiffComputer/linesSliceCharSequence","vs/editor/common/diff/linesDiffComputer","vs/editor/common/diff/legacyLinesDiffComputer","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/cache","vs/base/common/hash","vs/base/common/codiconsLibrary","vs/base/common/codicons","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/diff/defaultLinesDiffComputer/heuristicSequenceOptimizations","vs/editor/common/diff/defaultLinesDiffComputer/lineSequence","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/dynamicProgrammingDiffing","vs/editor/common/diff/defaultLinesDiffComputer/computeMovedLines","vs/editor/common/diff/defaultLinesDiffComputer/defaultLinesDiffComputer","vs/editor/common/diff/linesDiffComputers","vs/editor/common/languages/defaultDocumentColorsComputer","vs/editor/common/languages/linkComputer","vs/editor/common/languages/supports/inplaceReplaceSupport","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/unicodeTextModelHighlighter","vs/editor/common/standalone/standaloneEnums","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/platform","vs/nls","vs/nls!vs/editor/common/services/editorSimpleWorker","vs/base/common/process","vs/base/common/path","vs/nls!vs/editor/common/languages","vs/editor/common/languages","vs/editor/common/services/editorBaseApi","vs/css","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],se=function(V){for(var t=[],i=0,P=V.length;i<P;i++)t[i]=ie[V[i]];return t};const He=this,Ge=typeof global=="object"?global:{};var ge;(function(V){V.global=He;class t{get isWindows(){return this._detect(),this._isWindows}get isNode(){return this._detect(),this._isNode}get isElectronRenderer(){return this._detect(),this._isElectronRenderer}get isWebWorker(){return this._detect(),this._isWebWorker}get isElectronNodeIntegrationWebWorker(){return this._detect(),this._isElectronNodeIntegrationWebWorker}constructor(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}_detect(){this._detected||(this._detected=!0,this._isWindows=t._isWindows(),this._isNode=typeof module<"u"&&!!module.exports,this._isElectronRenderer=typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="renderer",this._isWebWorker=typeof V.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="worker")}static _isWindows(){return typeof navigator<"u"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process<"u"?process.platform==="win32":!1}}V.Environment=t})(ge||(ge={}));var ge;(function(V){class t{constructor(f,p,h){this.type=f,this.detail=p,this.timestamp=h}}V.LoaderEvent=t;class i{constructor(f){this._events=[new t(1,"",f)]}record(f,p){this._events.push(new t(f,p,V.Utilities.getHighPerformanceTimestamp()))}getEvents(){return this._events}}V.LoaderEventRecorder=i;class P{record(f,p){}getEvents(){return[]}}P.INSTANCE=new P,V.NullLoaderEventRecorder=P})(ge||(ge={}));var ge;(function(V){class t{static fileUriToFilePath(P,y){if(y=decodeURI(y).replace(/%23/g,"#"),P){if(/^file:\/\/\//.test(y))return y.substr(8);if(/^file:\/\//.test(y))return y.substr(5)}else if(/^file:\/\//.test(y))return y.substr(7);return y}static startsWith(P,y){return P.length>=y.length&&P.substr(0,y.length)===y}static endsWith(P,y){return P.length>=y.length&&P.substr(P.length-y.length)===y}static containsQueryString(P){return/^[^\#]*\?/gi.test(P)}static isAbsolutePath(P){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(P)}static forEachProperty(P,y){if(P){let f;for(f in P)P.hasOwnProperty(f)&&y(f,P[f])}}static isEmpty(P){let y=!0;return t.forEachProperty(P,()=>{y=!1}),y}static recursiveClone(P){if(!P||typeof P!="object"||P instanceof RegExp||!Array.isArray(P)&&Object.getPrototypeOf(P)!==Object.prototype)return P;let y=Array.isArray(P)?[]:{};return t.forEachProperty(P,(f,p)=>{p&&typeof p=="object"?y[f]=t.recursiveClone(p):y[f]=p}),y}static generateAnonymousModule(){return"===anonymous"+t.NEXT_ANONYMOUS_ID+++"==="}static isAnonymousModule(P){return t.startsWith(P,"===anonymous")}static getHighPerformanceTimestamp(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=V.global.performance&&typeof V.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?V.global.performance.now():Date.now()}}t.NEXT_ANONYMOUS_ID=1,t.PERFORMANCE_NOW_PROBED=!1,t.HAS_PERFORMANCE_NOW=!1,V.Utilities=t})(ge||(ge={}));var ge;(function(V){function t(y){if(y instanceof Error)return y;const f=new Error(y.message||String(y)||"Unknown Error");return y.stack&&(f.stack=y.stack),f}V.ensureError=t;class i{static validateConfigurationOptions(f){function p(h){if(h.phase==="loading"){console.error('Loading "'+h.moduleId+'" failed'),console.error(h),console.error("Here are the modules that depend on it:"),console.error(h.neededBy);return}if(h.phase==="factory"){console.error('The factory function of "'+h.moduleId+'" has thrown an exception'),console.error(h),console.error("Here are the modules that depend on it:"),console.error(h.neededBy);return}}if(f=f||{},typeof f.baseUrl!="string"&&(f.baseUrl=""),typeof f.isBuild!="boolean"&&(f.isBuild=!1),typeof f.paths!="object"&&(f.paths={}),typeof f.config!="object"&&(f.config={}),typeof f.catchError>"u"&&(f.catchError=!1),typeof f.recordStats>"u"&&(f.recordStats=!1),typeof f.urlArgs!="string"&&(f.urlArgs=""),typeof f.onError!="function"&&(f.onError=p),Array.isArray(f.ignoreDuplicateModules)||(f.ignoreDuplicateModules=[]),f.baseUrl.length>0&&(V.Utilities.endsWith(f.baseUrl,"/")||(f.baseUrl+="/")),typeof f.cspNonce!="string"&&(f.cspNonce=""),typeof f.preferScriptTags>"u"&&(f.preferScriptTags=!1),f.nodeCachedData&&typeof f.nodeCachedData=="object"&&(typeof f.nodeCachedData.seed!="string"&&(f.nodeCachedData.seed="seed"),(typeof f.nodeCachedData.writeDelay!="number"||f.nodeCachedData.writeDelay<0)&&(f.nodeCachedData.writeDelay=1e3*7),!f.nodeCachedData.path||typeof f.nodeCachedData.path!="string")){const h=t(new Error("INVALID cached data configuration, 'path' MUST be set"));h.phase="configuration",f.onError(h),f.nodeCachedData=void 0}return f}static mergeConfigurationOptions(f=null,p=null){let h=V.Utilities.recursiveClone(p||{});return V.Utilities.forEachProperty(f,(o,a)=>{o==="ignoreDuplicateModules"&&typeof h.ignoreDuplicateModules<"u"?h.ignoreDuplicateModules=h.ignoreDuplicateModules.concat(a):o==="paths"&&typeof h.paths<"u"?V.Utilities.forEachProperty(a,(g,B)=>h.paths[g]=B):o==="config"&&typeof h.config<"u"?V.Utilities.forEachProperty(a,(g,B)=>h.config[g]=B):h[o]=V.Utilities.recursiveClone(a)}),i.validateConfigurationOptions(h)}}V.ConfigurationOptionsUtil=i;class P{constructor(f,p){if(this._env=f,this.options=i.mergeConfigurationOptions(p),this._createIgnoreDuplicateModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""&&this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){let h=this.options.nodeRequire.main.filename,o=Math.max(h.lastIndexOf("/"),h.lastIndexOf("\\"));this.options.baseUrl=h.substring(0,o+1)}}_createIgnoreDuplicateModulesMap(){this.ignoreDuplicateModulesMap={};for(let f=0;f<this.options.ignoreDuplicateModules.length;f++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[f]]=!0}_createSortedPathsRules(){this.sortedPathsRules=[],V.Utilities.forEachProperty(this.options.paths,(f,p)=>{Array.isArray(p)?this.sortedPathsRules.push({from:f,to:p}):this.sortedPathsRules.push({from:f,to:[p]})}),this.sortedPathsRules.sort((f,p)=>p.from.length-f.from.length)}cloneAndMerge(f){return new P(this._env,i.mergeConfigurationOptions(f,this.options))}getOptionsLiteral(){return this.options}_applyPaths(f){let p;for(let h=0,o=this.sortedPathsRules.length;h<o;h++)if(p=this.sortedPathsRules[h],V.Utilities.startsWith(f,p.from)){let a=[];for(let g=0,B=p.to.length;g<B;g++)a.push(p.to[g]+f.substr(p.from.length));return a}return[f]}_addUrlArgsToUrl(f){return V.Utilities.containsQueryString(f)?f+"&"+this.options.urlArgs:f+"?"+this.options.urlArgs}_addUrlArgsIfNecessaryToUrl(f){return this.options.urlArgs?this._addUrlArgsToUrl(f):f}_addUrlArgsIfNecessaryToUrls(f){if(this.options.urlArgs)for(let p=0,h=f.length;p<h;p++)f[p]=this._addUrlArgsToUrl(f[p]);return f}moduleIdToPaths(f){if(this._env.isNode&&this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(f))return this.isBuild()?["empty:"]:["node|"+f];let p=f,h;if(!V.Utilities.endsWith(p,".js")&&!V.Utilities.isAbsolutePath(p)){h=this._applyPaths(p);for(let o=0,a=h.length;o<a;o++)this.isBuild()&&h[o]==="empty:"||(V.Utilities.isAbsolutePath(h[o])||(h[o]=this.options.baseUrl+h[o]),!V.Utilities.endsWith(h[o],".js")&&!V.Utilities.containsQueryString(h[o])&&(h[o]=h[o]+".js"))}else!V.Utilities.endsWith(p,".js")&&!V.Utilities.containsQueryString(p)&&(p=p+".js"),h=[p];return this._addUrlArgsIfNecessaryToUrls(h)}requireToUrl(f){let p=f;return V.Utilities.isAbsolutePath(p)||(p=this._applyPaths(p)[0],V.Utilities.isAbsolutePath(p)||(p=this.options.baseUrl+p)),this._addUrlArgsIfNecessaryToUrl(p)}isBuild(){return this.options.isBuild}shouldInvokeFactory(f){return!!(!this.options.isBuild||V.Utilities.isAnonymousModule(f)||this.options.buildForceInvokeFactory&&this.options.buildForceInvokeFactory[f])}isDuplicateMessageIgnoredFor(f){return this.ignoreDuplicateModulesMap.hasOwnProperty(f)}getConfigForModule(f){if(this.options.config)return this.options.config[f]}shouldCatchError(){return this.options.catchError}shouldRecordStats(){return this.options.recordStats}onError(f){this.options.onError(f)}}V.Configuration=P})(ge||(ge={}));var ge;(function(V){class t{constructor(a){this._env=a,this._scriptLoader=null,this._callbackMap={}}load(a,g,B,d){if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new y;else if(this._env.isElectronRenderer){const{preferScriptTags:e}=a.getConfig().getOptionsLiteral();e?this._scriptLoader=new i:this._scriptLoader=new f(this._env)}else this._env.isNode?this._scriptLoader=new f(this._env):this._scriptLoader=new i;let m={callback:B,errorback:d};if(this._callbackMap.hasOwnProperty(g)){this._callbackMap[g].push(m);return}this._callbackMap[g]=[m],this._scriptLoader.load(a,g,()=>this.triggerCallback(g),e=>this.triggerErrorback(g,e))}triggerCallback(a){let g=this._callbackMap[a];delete this._callbackMap[a];for(let B=0;B<g.length;B++)g[B].callback()}triggerErrorback(a,g){let B=this._callbackMap[a];delete this._callbackMap[a];for(let d=0;d<B.length;d++)B[d].errorback(g)}}class i{attachListeners(a,g,B){let d=()=>{a.removeEventListener("load",m),a.removeEventListener("error",e)},m=v=>{d(),g()},e=v=>{d(),B(v)};a.addEventListener("load",m),a.addEventListener("error",e)}load(a,g,B,d){if(/^node\|/.test(g)){let m=a.getConfig().getOptionsLiteral(),e=p(a.getRecorder(),m.nodeRequire||V.global.nodeRequire),v=g.split("|"),j=null;try{j=e(v[1])}catch(L){d(L);return}a.enqueueDefineAnonymousModule([],()=>j),B()}else{let m=document.createElement("script");m.setAttribute("async","async"),m.setAttribute("type","text/javascript"),this.attachListeners(m,B,d);const{trustedTypesPolicy:e}=a.getConfig().getOptionsLiteral();e&&(g=e.createScriptURL(g)),m.setAttribute("src",g);const{cspNonce:v}=a.getConfig().getOptionsLiteral();v&&m.setAttribute("nonce",v),document.getElementsByTagName("head")[0].appendChild(m)}}}function P(o){const{trustedTypesPolicy:a}=o.getConfig().getOptionsLiteral();try{return(a?self.eval(a.createScript("","true")):new Function("true")).call(self),!0}catch{return!1}}class y{constructor(){this._cachedCanUseEval=null}_canUseEval(a){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=P(a)),this._cachedCanUseEval}load(a,g,B,d){if(/^node\|/.test(g)){const m=a.getConfig().getOptionsLiteral(),e=p(a.getRecorder(),m.nodeRequire||V.global.nodeRequire),v=g.split("|");let j=null;try{j=e(v[1])}catch(L){d(L);return}a.enqueueDefineAnonymousModule([],function(){return j}),B()}else{const{trustedTypesPolicy:m}=a.getConfig().getOptionsLiteral();if(!(/^((http:)|(https:)|(file:))/.test(g)&&g.substring(0,self.origin.length)!==self.origin)&&this._canUseEval(a)){fetch(g).then(v=>{if(v.status!==200)throw new Error(v.statusText);return v.text()}).then(v=>{v=`${v}
//# sourceURL=${g}`,(m?self.eval(m.createScript("",v)):new Function(v)).call(self),B()}).then(void 0,d);return}try{m&&(g=m.createScriptURL(g)),importScripts(g),B()}catch(v){d(v)}}}}class f{constructor(a){this._env=a,this._didInitialize=!1,this._didPatchNodeRequire=!1}_init(a){this._didInitialize||(this._didInitialize=!0,this._fs=a("fs"),this._vm=a("vm"),this._path=a("path"),this._crypto=a("crypto"))}_initNodeRequire(a,g){const{nodeCachedData:B}=g.getConfig().getOptionsLiteral();if(!B||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;const d=this,m=a("module");function e(v){const j=v.constructor;let L=function(b){try{return v.require(b)}finally{}};return L.resolve=function(b,u){return j._resolveFilename(b,v,!1,u)},L.resolve.paths=function(b){return j._resolveLookupPaths(b,v)},L.main=process.mainModule,L.extensions=j._extensions,L.cache=j._cache,L}m.prototype._compile=function(v,j){const L=m.wrap(v.replace(/^#!.*/,"")),$=g.getRecorder(),b=d._getCachedDataPath(B,j),u={filename:j};let l;try{const A=d._fs.readFileSync(b);l=A.slice(0,16),u.cachedData=A.slice(16),$.record(60,b)}catch{$.record(61,b)}const n=new d._vm.Script(L,u),s=n.runInThisContext(u),N=d._path.dirname(j),c=e(this),w=[this.exports,c,this,j,N,process,Ge,Buffer],E=s.apply(this.exports,w);return d._handleCachedData(n,L,b,!u.cachedData,g),d._verifyCachedData(n,L,b,l,g),E}}load(a,g,B,d){const m=a.getConfig().getOptionsLiteral(),e=p(a.getRecorder(),m.nodeRequire||V.global.nodeRequire),v=m.nodeInstrumenter||function(L){return L};this._init(e),this._initNodeRequire(e,a);let j=a.getRecorder();if(/^node\|/.test(g)){let L=g.split("|"),$=null;try{$=e(L[1])}catch(b){d(b);return}a.enqueueDefineAnonymousModule([],()=>$),B()}else{g=V.Utilities.fileUriToFilePath(this._env.isWindows,g);const L=this._path.normalize(g),$=this._getElectronRendererScriptPathOrUri(L),b=!!m.nodeCachedData,u=b?this._getCachedDataPath(m.nodeCachedData,g):void 0;this._readSourceAndCachedData(L,u,j,(l,n,s,N)=>{if(l){d(l);return}let c;n.charCodeAt(0)===f._BOM?c=f._PREFIX+n.substring(1)+f._SUFFIX:c=f._PREFIX+n+f._SUFFIX,c=v(c,L);const w={filename:$,cachedData:s},E=this._createAndEvalScript(a,c,w,B,d);this._handleCachedData(E,c,u,b&&!s,a),this._verifyCachedData(E,c,u,N,a)})}}_createAndEvalScript(a,g,B,d,m){const e=a.getRecorder();e.record(31,B.filename);const v=new this._vm.Script(g,B),j=v.runInThisContext(B),L=a.getGlobalAMDDefineFunc();let $=!1;const b=function(){return $=!0,L.apply(null,arguments)};return b.amd=L.amd,j.call(V.global,a.getGlobalAMDRequireFunc(),b,B.filename,this._path.dirname(B.filename)),e.record(32,B.filename),$?d():m(new Error(`Didn't receive define call in ${B.filename}!`)),v}_getElectronRendererScriptPathOrUri(a){if(!this._env.isElectronRenderer)return a;let g=a.match(/^([a-z])\:(.*)/i);return g?`file:///${(g[1].toUpperCase()+":"+g[2]).replace(/\\/g,"/")}`:`file://${a}`}_getCachedDataPath(a,g){const B=this._crypto.createHash("md5").update(g,"utf8").update(a.seed,"utf8").update(process.arch,"").digest("hex"),d=this._path.basename(g).replace(/\.js$/,"");return this._path.join(a.path,`${d}-${B}.code`)}_handleCachedData(a,g,B,d,m){a.cachedDataRejected?this._fs.unlink(B,e=>{m.getRecorder().record(62,B),this._createAndWriteCachedData(a,g,B,m),e&&m.getConfig().onError(e)}):d&&this._createAndWriteCachedData(a,g,B,m)}_createAndWriteCachedData(a,g,B,d){let m=Math.ceil(d.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),e=-1,v=0,j;const L=()=>{setTimeout(()=>{j||(j=this._crypto.createHash("md5").update(g,"utf8").digest());const $=a.createCachedData();if(!($.length===0||$.length===e||v>=5)){if($.length<e){L();return}e=$.length,this._fs.writeFile(B,Buffer.concat([j,$]),b=>{b&&d.getConfig().onError(b),d.getRecorder().record(63,B),L()})}},m*Math.pow(4,v++))};L()}_readSourceAndCachedData(a,g,B,d){if(!g)this._fs.readFile(a,{encoding:"utf8"},d);else{let m,e,v,j=2;const L=$=>{$?d($):--j===0&&d(void 0,m,e,v)};this._fs.readFile(a,{encoding:"utf8"},($,b)=>{m=b,L($)}),this._fs.readFile(g,($,b)=>{!$&&b&&b.length>0?(v=b.slice(0,16),e=b.slice(16),B.record(60,g)):B.record(61,g),L()})}}_verifyCachedData(a,g,B,d,m){d&&(a.cachedDataRejected||setTimeout(()=>{const e=this._crypto.createHash("md5").update(g,"utf8").digest();d.equals(e)||(m.getConfig().onError(new Error(`FAILED TO VERIFY CACHED DATA, deleting stale '${B}' now, but a RESTART IS REQUIRED`)),this._fs.unlink(B,v=>{v&&m.getConfig().onError(v)}))},Math.ceil(5e3*(1+Math.random()))))}}f._BOM=65279,f._PREFIX="(function (require, define, __filename, __dirname) { ",f._SUFFIX=`
});`;function p(o,a){if(a.__$__isRecorded)return a;const g=function(d){o.record(33,d);try{return a(d)}finally{o.record(34,d)}};return g.__$__isRecorded=!0,g}V.ensureRecordedNodeRequire=p;function h(o){return new t(o)}V.createScriptLoader=h})(ge||(ge={}));var ge;(function(V){class t{constructor(o){let a=o.lastIndexOf("/");a!==-1?this.fromModulePath=o.substr(0,a+1):this.fromModulePath=""}static _normalizeModuleId(o){let a=o,g;for(g=/\/\.\//;g.test(a);)a=a.replace(g,"/");for(a=a.replace(/^\.\//g,""),g=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;g.test(a);)a=a.replace(g,"/");return a=a.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),a}resolveModule(o){let a=o;return V.Utilities.isAbsolutePath(a)||(V.Utilities.startsWith(a,"./")||V.Utilities.startsWith(a,"../"))&&(a=t._normalizeModuleId(this.fromModulePath+a)),a}}t.ROOT=new t(""),V.ModuleIdResolver=t;class i{constructor(o,a,g,B,d,m){this.id=o,this.strId=a,this.dependencies=g,this._callback=B,this._errorback=d,this.moduleIdResolver=m,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}static _safeInvokeFunction(o,a){try{return{returnedValue:o.apply(V.global,a),producedError:null}}catch(g){return{returnedValue:null,producedError:g}}}static _invokeFactory(o,a,g,B){return o.shouldInvokeFactory(a)?o.shouldCatchError()?this._safeInvokeFunction(g,B):{returnedValue:g.apply(V.global,B),producedError:null}:{returnedValue:null,producedError:null}}complete(o,a,g,B){this._isComplete=!0;let d=null;if(this._callback)if(typeof this._callback=="function"){o.record(21,this.strId);let m=i._invokeFactory(a,this.strId,this._callback,g);d=m.producedError,o.record(22,this.strId),!d&&typeof m.returnedValue<"u"&&(!this.exportsPassedIn||V.Utilities.isEmpty(this.exports))&&(this.exports=m.returnedValue)}else this.exports=this._callback;if(d){let m=V.ensureError(d);m.phase="factory",m.moduleId=this.strId,m.neededBy=B(this.id),this.error=m,a.onError(m)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null}onDependencyError(o){return this._isComplete=!0,this.error=o,this._errorback?(this._errorback(o),!0):!1}isComplete(){return this._isComplete}}V.Module=i;class P{constructor(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}getMaxModuleId(){return this._nextId}getModuleId(o){let a=this._strModuleIdToIntModuleId.get(o);return typeof a>"u"&&(a=this._nextId++,this._strModuleIdToIntModuleId.set(o,a),this._intModuleIdToStrModuleId[a]=o),a}getStrModuleId(o){return this._intModuleIdToStrModuleId[o]}}class y{constructor(o){this.id=o}}y.EXPORTS=new y(0),y.MODULE=new y(1),y.REQUIRE=new y(2),V.RegularDependency=y;class f{constructor(o,a,g){this.id=o,this.pluginId=a,this.pluginParam=g}}V.PluginDependency=f;class p{constructor(o,a,g,B,d=0){this._env=o,this._scriptLoader=a,this._loaderAvailableTimestamp=d,this._defineFunc=g,this._requireFunc=B,this._moduleIdProvider=new P,this._config=new V.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[],this._requireFunc.moduleManager=this}reset(){return new p(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)}getGlobalAMDDefineFunc(){return this._defineFunc}getGlobalAMDRequireFunc(){return this._requireFunc}static _findRelevantLocationInStack(o,a){let g=m=>m.replace(/\\/g,"/"),B=g(o),d=a.split(/\n/);for(let m=0;m<d.length;m++){let e=d[m].match(/(.*):(\d+):(\d+)\)?$/);if(e){let v=e[1],j=e[2],L=e[3],$=Math.max(v.lastIndexOf(" ")+1,v.lastIndexOf("(")+1);if(v=v.substr($),v=g(v),v===B){let b={line:parseInt(j,10),col:parseInt(L,10)};return b.line===1&&(b.col-=53),b}}}throw new Error("Could not correlate define call site for needle "+o)}getBuildInfo(){if(!this._config.isBuild())return null;let o=[],a=0;for(let g=0,B=this._modules2.length;g<B;g++){let d=this._modules2[g];if(!d)continue;let m=this._buildInfoPath[d.id]||null,e=this._buildInfoDefineStack[d.id]||null,v=this._buildInfoDependencies[d.id];o[a++]={id:d.strId,path:m,defineLocation:m&&e?p._findRelevantLocationInStack(m,e):null,dependencies:v,shim:null,exports:d.exports}}return o}getRecorder(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new V.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=V.NullLoaderEventRecorder.INSTANCE),this._recorder}getLoaderEvents(){return this.getRecorder().getEvents()}enqueueDefineAnonymousModule(o,a){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");let g=null;this._config.isBuild()&&(g=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:g,dependencies:o,callback:a}}defineModule(o,a,g,B,d,m=new t(o)){let e=this._moduleIdProvider.getModuleId(o);if(this._modules2[e]){this._config.isDuplicateMessageIgnoredFor(o)||console.warn("Duplicate definition of module '"+o+"'");return}let v=new i(e,o,this._normalizeDependencies(a,m),g,B,m);this._modules2[e]=v,this._config.isBuild()&&(this._buildInfoDefineStack[e]=d,this._buildInfoDependencies[e]=(v.dependencies||[]).map(j=>this._moduleIdProvider.getStrModuleId(j.id))),this._resolve(v)}_normalizeDependency(o,a){if(o==="exports")return y.EXPORTS;if(o==="module")return y.MODULE;if(o==="require")return y.REQUIRE;let g=o.indexOf("!");if(g>=0){let B=a.resolveModule(o.substr(0,g)),d=a.resolveModule(o.substr(g+1)),m=this._moduleIdProvider.getModuleId(B+"!"+d),e=this._moduleIdProvider.getModuleId(B);return new f(m,e,d)}return new y(this._moduleIdProvider.getModuleId(a.resolveModule(o)))}_normalizeDependencies(o,a){let g=[],B=0;for(let d=0,m=o.length;d<m;d++)g[B++]=this._normalizeDependency(o[d],a);return g}_relativeRequire(o,a,g,B){if(typeof a=="string")return this.synchronousRequire(a,o);this.defineModule(V.Utilities.generateAnonymousModule(),a,g,B,null,o)}synchronousRequire(o,a=new t(o)){let g=this._normalizeDependency(o,a),B=this._modules2[g.id];if(!B)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+o+"'. This is the first mention of this module!");if(!B.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+o+"'. This module has not been resolved completely yet.");if(B.error)throw B.error;return B.exports}configure(o,a){let g=this._config.shouldRecordStats();a?this._config=new V.Configuration(this._env,o):this._config=this._config.cloneAndMerge(o),this._config.shouldRecordStats()&&!g&&(this._recorder=null)}getConfig(){return this._config}_onLoad(o){if(this._currentAnonymousDefineCall!==null){let a=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(o),a.dependencies,a.callback,null,a.stack)}}_createLoadError(o,a){let g=this._moduleIdProvider.getStrModuleId(o),B=(this._inverseDependencies2[o]||[]).map(m=>this._moduleIdProvider.getStrModuleId(m));const d=V.ensureError(a);return d.phase="loading",d.moduleId=g,d.neededBy=B,d}_onLoadError(o,a){const g=this._createLoadError(o,a);this._modules2[o]||(this._modules2[o]=new i(o,this._moduleIdProvider.getStrModuleId(o),[],()=>{},null,null));let B=[];for(let e=0,v=this._moduleIdProvider.getMaxModuleId();e<v;e++)B[e]=!1;let d=!1,m=[];for(m.push(o),B[o]=!0;m.length>0;){let e=m.shift(),v=this._modules2[e];v&&(d=v.onDependencyError(g)||d);let j=this._inverseDependencies2[e];if(j)for(let L=0,$=j.length;L<$;L++){let b=j[L];B[b]||(m.push(b),B[b]=!0)}}d||this._config.onError(g)}_hasDependencyPath(o,a){let g=this._modules2[o];if(!g)return!1;let B=[];for(let m=0,e=this._moduleIdProvider.getMaxModuleId();m<e;m++)B[m]=!1;let d=[];for(d.push(g),B[o]=!0;d.length>0;){let e=d.shift().dependencies;if(e)for(let v=0,j=e.length;v<j;v++){let L=e[v];if(L.id===a)return!0;let $=this._modules2[L.id];$&&!B[L.id]&&(B[L.id]=!0,d.push($))}}return!1}_findCyclePath(o,a,g){if(o===a||g===50)return[o];let B=this._modules2[o];if(!B)return null;let d=B.dependencies;if(d)for(let m=0,e=d.length;m<e;m++){let v=this._findCyclePath(d[m].id,a,g+1);if(v!==null)return v.push(o),v}return null}_createRequire(o){let a=(g,B,d)=>this._relativeRequire(o,g,B,d);return a.toUrl=g=>this._config.requireToUrl(o.resolveModule(g)),a.getStats=()=>this.getLoaderEvents(),a.hasDependencyCycle=()=>this._hasDependencyCycle,a.config=(g,B=!1)=>{this.configure(g,B)},a.__$__nodeRequire=V.global.nodeRequire,a}_loadModule(o){if(this._modules2[o]||this._knownModules2[o])return;this._knownModules2[o]=!0;let a=this._moduleIdProvider.getStrModuleId(o),g=this._config.moduleIdToPaths(a),B=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(a.indexOf("/")===-1||B.test(a))&&g.push("node|"+a);let d=-1,m=e=>{if(d++,d>=g.length)this._onLoadError(o,e);else{let v=g[d],j=this.getRecorder();if(this._config.isBuild()&&v==="empty:"){this._buildInfoPath[o]=v,this.defineModule(this._moduleIdProvider.getStrModuleId(o),[],null,null,null),this._onLoad(o);return}j.record(10,v),this._scriptLoader.load(this,v,()=>{this._config.isBuild()&&(this._buildInfoPath[o]=v),j.record(11,v),this._onLoad(o)},L=>{j.record(12,v),m(L)})}};m(null)}_loadPluginDependency(o,a){if(this._modules2[a.id]||this._knownModules2[a.id])return;this._knownModules2[a.id]=!0;let g=B=>{this.defineModule(this._moduleIdProvider.getStrModuleId(a.id),[],B,null,null)};g.error=B=>{this._config.onError(this._createLoadError(a.id,B))},o.load(a.pluginParam,this._createRequire(t.ROOT),g,this._config.getOptionsLiteral())}_resolve(o){let a=o.dependencies;if(a)for(let g=0,B=a.length;g<B;g++){let d=a[g];if(d===y.EXPORTS){o.exportsPassedIn=!0,o.unresolvedDependenciesCount--;continue}if(d===y.MODULE){o.unresolvedDependenciesCount--;continue}if(d===y.REQUIRE){o.unresolvedDependenciesCount--;continue}let m=this._modules2[d.id];if(m&&m.isComplete()){if(m.error){o.onDependencyError(m.error);return}o.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(d.id,o.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(d.id)+"' and '"+this._moduleIdProvider.getStrModuleId(o.id)+"'. The cyclic path follows:");let e=this._findCyclePath(d.id,o.id,0)||[];e.reverse(),e.push(d.id),console.warn(e.map(v=>this._moduleIdProvider.getStrModuleId(v)).join(` => 
`)),o.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[d.id]=this._inverseDependencies2[d.id]||[],this._inverseDependencies2[d.id].push(o.id),d instanceof f){let e=this._modules2[d.pluginId];if(e&&e.isComplete()){this._loadPluginDependency(e.exports,d);continue}let v=this._inversePluginDependencies2.get(d.pluginId);v||(v=[],this._inversePluginDependencies2.set(d.pluginId,v)),v.push(d),this._loadModule(d.pluginId);continue}this._loadModule(d.id)}o.unresolvedDependenciesCount===0&&this._onModuleComplete(o)}_onModuleComplete(o){let a=this.getRecorder();if(o.isComplete())return;let g=o.dependencies,B=[];if(g)for(let v=0,j=g.length;v<j;v++){let L=g[v];if(L===y.EXPORTS){B[v]=o.exports;continue}if(L===y.MODULE){B[v]={id:o.strId,config:()=>this._config.getConfigForModule(o.strId)};continue}if(L===y.REQUIRE){B[v]=this._createRequire(o.moduleIdResolver);continue}let $=this._modules2[L.id];if($){B[v]=$.exports;continue}B[v]=null}const d=v=>(this._inverseDependencies2[v]||[]).map(j=>this._moduleIdProvider.getStrModuleId(j));o.complete(a,this._config,B,d);let m=this._inverseDependencies2[o.id];if(this._inverseDependencies2[o.id]=null,m)for(let v=0,j=m.length;v<j;v++){let L=m[v],$=this._modules2[L];$.unresolvedDependenciesCount--,$.unresolvedDependenciesCount===0&&this._onModuleComplete($)}let e=this._inversePluginDependencies2.get(o.id);if(e){this._inversePluginDependencies2.delete(o.id);for(let v=0,j=e.length;v<j;v++)this._loadPluginDependency(o.exports,e[v])}}}V.ModuleManager=p})(ge||(ge={}));var re,ge;(function(V){const t=new V.Environment;let i=null;const P=function(h,o,a){typeof h!="string"&&(a=o,o=h,h=null),(typeof o!="object"||!Array.isArray(o))&&(a=o,o=null),o||(o=["require","exports","module"]),h?i.defineModule(h,o,a,null,null):i.enqueueDefineAnonymousModule(o,a)};P.amd={jQuery:!0};const y=function(h,o=!1){i.configure(h,o)},f=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){y(arguments[0]);return}if(typeof arguments[0]=="string")return i.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){i.defineModule(V.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};f.config=y,f.getConfig=function(){return i.getConfig().getOptionsLiteral()},f.reset=function(){i=i.reset()},f.getBuildInfo=function(){return i.getBuildInfo()},f.getStats=function(){return i.getLoaderEvents()},f.define=P;function p(){if(typeof V.global.require<"u"||typeof require<"u"){const h=V.global.require||require;if(typeof h=="function"&&typeof h.resolve=="function"){const o=V.ensureRecordedNodeRequire(i.getRecorder(),h);V.global.nodeRequire=o,f.nodeRequire=o,f.__$__nodeRequire=o}}t.isNode&&!t.isElectronRenderer&&!t.isElectronNodeIntegrationWebWorker?module.exports=f:(t.isElectronRenderer||(V.global.define=P),V.global.require=f)}V.init=p,(typeof V.global.define!="function"||!V.global.define.amd)&&(i=new V.ModuleManager(t,V.createScriptLoader(t),P,f,V.Utilities.getHighPerformanceTimestamp()),typeof V.global.require<"u"&&typeof V.global.require!="function"&&f.config(V.global.require),re=function(){return P.apply(null,arguments)},re.amd=P.amd,typeof doNotInitLoader>"u"&&p())})(ge||(ge={})),re(ie[71],se([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.load=i;function i(h,o,a,g){if(g=g||{},(g["vs/css"]||{}).disabled){a({});return}const d=o.toUrl(h+".css");P(h,d,()=>{a({})},m=>{typeof a.error=="function"&&a.error("Could not find "+d+".")})}function P(h,o,a,g){if(y(h,o)){a();return}f(h,o,a,g)}function y(h,o){const a=window.document.getElementsByTagName("link");for(let g=0,B=a.length;g<B;g++){const d=a[g].getAttribute("data-name"),m=a[g].getAttribute("href");if(d===h||m===o)return!0}return!1}function f(h,o,a,g){const B=document.createElement("link");B.setAttribute("rel","stylesheet"),B.setAttribute("type","text/css"),B.setAttribute("data-name",h),p(h,B,a,g),B.setAttribute("href",o),(window.document.head||window.document.getElementsByTagName("head")[0]).appendChild(B)}function p(h,o,a,g){const B=()=>{o.removeEventListener("load",d),o.removeEventListener("error",m)},d=e=>{B(),a()},m=e=>{B(),g(e)};o.addEventListener("load",d),o.addEventListener("error",m)}}),re("vs/nls",["require","exports"],function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.localize=g,t.localize2=B,t.getConfiguredDefaultLocale=d,t.setPseudoTranslation=m,t.create=e,t.load=v;let i=typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;const P="i-default";function y(j,L){let $;return L.length===0?$=j:$=j.replace(/\{(\d+)\}/g,(b,u)=>{const l=u[0],n=L[l];let s=b;return typeof n=="string"?s=n:(typeof n=="number"||typeof n=="boolean"||n===void 0||n===null)&&(s=String(n)),s}),i&&($="\uFF3B"+$.replace(/[aouei]/g,"$&$&")+"\uFF3D"),$}function f(j,L){let $=j[L];return $||($=j["*"],$)?$:null}function p(j){return j.charAt(j.length-1)==="/"?j:j+"/"}async function h(j,L,$){const b=p(j)+p(L)+"vscode/"+p($),u=await fetch(b);if(u.ok)return await u.json();throw new Error(`${u.status} - ${u.statusText}`)}function o(j){return function(L,$){const b=Array.prototype.slice.call(arguments,2);return y(j[L],b)}}function a(j){return(L,$,...b)=>({value:y(j[L],b),original:y($,b)})}function g(j,L,...$){return y(L,$)}function B(j,L,...$){const b=y(L,$);return{value:b,original:b}}function d(j){}function m(j){i=j}function e(j,L){return{localize:o(L[j]),localize2:a(L[j]),getConfiguredDefaultLocale:L.getConfiguredDefaultLocale??($=>{})}}function v(j,L,$,b){const u=b["vs/nls"]??{};if(!j||j.length===0)return $({localize:g,localize2:B,getConfiguredDefaultLocale:()=>u.availableLanguages?.["*"]});const l=u.availableLanguages?f(u.availableLanguages,j):null,n=l===null||l===P;let s=".nls";n||(s=s+"."+l);const N=c=>{Array.isArray(c)?(c.localize=o(c),c.localize2=a(c)):(c.localize=o(c[j]),c.localize2=a(c[j])),c.getConfiguredDefaultLocale=()=>u.availableLanguages?.["*"],$(c)};typeof u.loadBundle=="function"?u.loadBundle(j,l,(c,w)=>{c?L([j+".nls"],N):N(w)}):u.translationServiceUrl&&!n?(async()=>{try{const c=await h(u.translationServiceUrl,l,j);return N(c)}catch(c){if(!l.includes("-"))return console.error(c),L([j+".nls"],N);try{const w=l.split("-")[0],E=await h(u.translationServiceUrl,w,j);return u.availableLanguages??={},u.availableLanguages["*"]=w,N(E)}catch(w){return console.error(w),L([j+".nls"],N)}}})():L([j+s],N,c=>{if(s===".nls"){console.error("Failed trying to load default language strings",c);return}console.error(`Failed to load message bundle for language ${l}. Falling back to the default language:`,c),L([j+".nls"],N)})}}),function(){const V=globalThis.MonacoEnvironment,t=V&&V.baseUrl?V.baseUrl:"../../../";function i(g,B){if(V?.createTrustedTypesPolicy)try{return V.createTrustedTypesPolicy(g,B)}catch(d){console.warn(d);return}try{return self.trustedTypes?.createPolicy(g,B)}catch(d){console.warn(d);return}}const P=i("amdLoader",{createScriptURL:g=>g,createScript:(g,...B)=>{const d=B.slice(0,-1).join(","),m=B.pop().toString();return`(function anonymous(${d}) { ${m}
})`}});function y(){try{return(P?globalThis.eval(P.createScript("","true")):new Function("true")).call(globalThis),!0}catch{return!1}}function f(){return new Promise((g,B)=>{if(typeof globalThis.define=="function"&&globalThis.define.amd)return g();const d=t+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(d)&&d.substring(0,globalThis.origin.length)!==globalThis.origin)&&y()){fetch(d).then(e=>{if(e.status!==200)throw new Error(e.statusText);return e.text()}).then(e=>{e=`${e}
//# sourceURL=${d}`,(P?globalThis.eval(P.createScript("",e)):new Function(e)).call(globalThis),g()}).then(void 0,B);return}P?importScripts(P.createScriptURL(d)):importScripts(d),g()})}function p(){require.config({baseUrl:t,catchError:!0,trustedTypesPolicy:P,amdModulesPattern:/^vs\//})}function h(g){f().then(()=>{p(),require([g],function(B){setTimeout(function(){const d=B.create((m,e)=>{globalThis.postMessage(m,e)},null);for(globalThis.onmessage=m=>d.onmessage(m.data,m.ports);a.length>0;){const m=a.shift();d.onmessage(m.data,m.ports)}},0)})})}typeof globalThis.define=="function"&&globalThis.define.amd&&p();let o=!0;const a=[];globalThis.onmessage=g=>{if(!o){a.push(g);return}o=!1,h(g.data)}}(),re(ie[9],se([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$mb=void 0,t.$fb=i,t.$gb=P,t.$hb=y,t.$ib=f,t.$jb=p,t.$kb=h,t.$lb=o,t.$nb=g,t.$ob=B,t.$pb=d,t.$qb=m,t.$rb=e;function i(v,j,L){const $=P(v,j);if($!==-1)return v[$]}function P(v,j,L=v.length-1){for(let $=L;$>=0;$--){const b=v[$];if(j(b))return $}return-1}function y(v,j){const L=f(v,j);return L===-1?void 0:v[L]}function f(v,j,L=0,$=v.length){let b=L,u=$;for(;b<u;){const l=Math.floor((b+u)/2);j(v[l])?b=l+1:u=l}return b-1}function p(v,j){const L=h(v,j);return L===v.length?void 0:v[L]}function h(v,j,L=0,$=v.length){let b=L,u=$;for(;b<u;){const l=Math.floor((b+u)/2);j(v[l])?u=l:b=l+1}return b}function o(v,j,L=0,$=v.length){const b=h(v,j,L,$);return b===v.length?-1:b}class a{static{this.assertInvariants=!1}constructor(j){this.e=j,this.c=0}findLastMonotonous(j){if(a.assertInvariants){if(this.d){for(const $ of this.e)if(this.d($)&&!j($))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=j}const L=f(this.e,j,this.c);return this.c=L+1,L===-1?void 0:this.e[L]}}t.$mb=a;function g(v,j){if(v.length===0)return;let L=v[0];for(let $=1;$<v.length;$++){const b=v[$];j(b,L)>0&&(L=b)}return L}function B(v,j){if(v.length===0)return;let L=v[0];for(let $=1;$<v.length;$++){const b=v[$];j(b,L)>=0&&(L=b)}return L}function d(v,j){return g(v,(L,$)=>-j(L,$))}function m(v,j){if(v.length===0)return-1;let L=0;for(let $=1;$<v.length;$++){const b=v[$];j(b,v[L])>0&&(L=$)}return L}function e(v,j){for(const L of v){const $=j(L);if($!==void 0)return $}}}),re(ie[35],se([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$K=i,t.$L=P,t.$M=y,t.$N=f;function i(p,h){const o=Object.create(null);for(const a of p){const g=h(a);let B=o[g];B||(B=o[g]=[]),B.push(a)}return o}function P(p,h){const o=[],a=[];for(const g of p)h.has(g)||o.push(g);for(const g of h)p.has(g)||a.push(g);return{removed:o,added:a}}function y(p,h){const o=[],a=[];for(const[g,B]of p)h.has(g)||o.push(B);for(const[g,B]of h)p.has(g)||a.push(B);return{removed:o,added:a}}function f(p,h){const o=new Set;for(const a of h)p.has(a)&&o.add(a);return o}}),re(ie[36],se([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ft=t.$Et=t.$Dt=t.$Ct=void 0;function i(h,o){const a=Math.pow(10,o);return Math.round(h*a)/a}class P{constructor(o,a,g,B=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,o))|0,this.g=Math.min(255,Math.max(0,a))|0,this.b=Math.min(255,Math.max(0,g))|0,this.a=i(Math.max(Math.min(1,B),0),3)}static equals(o,a){return o.r===a.r&&o.g===a.g&&o.b===a.b&&o.a===a.a}}t.$Ct=P;class y{constructor(o,a,g,B){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,o),0)|0,this.s=i(Math.max(Math.min(1,a),0),3),this.l=i(Math.max(Math.min(1,g),0),3),this.a=i(Math.max(Math.min(1,B),0),3)}static equals(o,a){return o.h===a.h&&o.s===a.s&&o.l===a.l&&o.a===a.a}static fromRGBA(o){const a=o.r/255,g=o.g/255,B=o.b/255,d=o.a,m=Math.max(a,g,B),e=Math.min(a,g,B);let v=0,j=0;const L=(e+m)/2,$=m-e;if($>0){switch(j=Math.min(L<=.5?$/(2*L):$/(2-2*L),1),m){case a:v=(g-B)/$+(g<B?6:0);break;case g:v=(B-a)/$+2;break;case B:v=(a-g)/$+4;break}v*=60,v=Math.round(v)}return new y(v,j,L,d)}static i(o,a,g){return g<0&&(g+=1),g>1&&(g-=1),g<1/6?o+(a-o)*6*g:g<1/2?a:g<2/3?o+(a-o)*(2/3-g)*6:o}static toRGBA(o){const a=o.h/360,{s:g,l:B,a:d}=o;let m,e,v;if(g===0)m=e=v=B;else{const j=B<.5?B*(1+g):B+g-B*g,L=2*B-j;m=y.i(L,j,a+1/3),e=y.i(L,j,a),v=y.i(L,j,a-1/3)}return new P(Math.round(m*255),Math.round(e*255),Math.round(v*255),d)}}t.$Dt=y;class f{constructor(o,a,g,B){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,o),0)|0,this.s=i(Math.max(Math.min(1,a),0),3),this.v=i(Math.max(Math.min(1,g),0),3),this.a=i(Math.max(Math.min(1,B),0),3)}static equals(o,a){return o.h===a.h&&o.s===a.s&&o.v===a.v&&o.a===a.a}static fromRGBA(o){const a=o.r/255,g=o.g/255,B=o.b/255,d=Math.max(a,g,B),m=Math.min(a,g,B),e=d-m,v=d===0?0:e/d;let j;return e===0?j=0:d===a?j=((g-B)/e%6+6)%6:d===g?j=(B-a)/e+2:j=(a-g)/e+4,new f(Math.round(j*60),v,d,o.a)}static toRGBA(o){const{h:a,s:g,v:B,a:d}=o,m=B*g,e=m*(1-Math.abs(a/60%2-1)),v=B-m;let[j,L,$]=[0,0,0];return a<60?(j=m,L=e):a<120?(j=e,L=m):a<180?(L=m,$=e):a<240?(L=e,$=m):a<300?(j=e,$=m):a<=360&&(j=m,$=e),j=Math.round((j+v)*255),L=Math.round((L+v)*255),$=Math.round(($+v)*255),new P(j,L,$,d)}}t.$Et=f;class p{static fromHex(o){return p.Format.CSS.parseHex(o)||p.red}static equals(o,a){return!o&&!a?!0:!o||!a?!1:o.equals(a)}get hsla(){return this.i?this.i:y.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:f.fromRGBA(this.rgba)}constructor(o){if(o)if(o instanceof P)this.rgba=o;else if(o instanceof y)this.i=o,this.rgba=y.toRGBA(o);else if(o instanceof f)this.j=o,this.rgba=f.toRGBA(o);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(o){return!!o&&P.equals(this.rgba,o.rgba)&&y.equals(this.hsla,o.hsla)&&f.equals(this.hsva,o.hsva)}getRelativeLuminance(){const o=p.k(this.rgba.r),a=p.k(this.rgba.g),g=p.k(this.rgba.b),B=.2126*o+.7152*a+.0722*g;return i(B,4)}static k(o){const a=o/255;return a<=.03928?a/12.92:Math.pow((a+.055)/1.055,2.4)}getContrastRatio(o){const a=this.getRelativeLuminance(),g=o.getRelativeLuminance();return a>g?(a+.05)/(g+.05):(g+.05)/(a+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(o){const a=this.getRelativeLuminance(),g=o.getRelativeLuminance();return a>g}isDarkerThan(o){const a=this.getRelativeLuminance(),g=o.getRelativeLuminance();return a<g}lighten(o){return new p(new y(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*o,this.hsla.a))}darken(o){return new p(new y(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*o,this.hsla.a))}transparent(o){const{r:a,g,b:B,a:d}=this.rgba;return new p(new P(a,g,B,d*o))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new p(new P(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(o){const a=o.rgba,g=this.rgba.a,B=a.a,d=g+B*(1-g);if(d<1e-6)return p.transparent;const m=this.rgba.r*g/d+a.r*B*(1-g)/d,e=this.rgba.g*g/d+a.g*B*(1-g)/d,v=this.rgba.b*g/d+a.b*B*(1-g)/d;return new p(new P(m,e,v,d))}makeOpaque(o){if(this.isOpaque()||o.rgba.a!==1)return this;const{r:a,g,b:B,a:d}=this.rgba;return new p(new P(o.rgba.r-d*(o.rgba.r-a),o.rgba.g-d*(o.rgba.g-g),o.rgba.b-d*(o.rgba.b-B),1))}flatten(...o){const a=o.reduceRight((g,B)=>p.o(B,g));return p.o(this,a)}static o(o,a){const g=1-o.rgba.a;return new p(new P(g*a.rgba.r+o.rgba.a*o.rgba.r,g*a.rgba.g+o.rgba.a*o.rgba.g,g*a.rgba.b+o.rgba.a*o.rgba.b))}toString(){return this.u||(this.u=p.Format.CSS.format(this)),this.u}static getLighterColor(o,a,g){if(o.isLighterThan(a))return o;g=g||.5;const B=o.getRelativeLuminance(),d=a.getRelativeLuminance();return g=g*(d-B)/d,o.lighten(g)}static getDarkerColor(o,a,g){if(o.isDarkerThan(a))return o;g=g||.5;const B=o.getRelativeLuminance(),d=a.getRelativeLuminance();return g=g*(B-d)/B,o.darken(g)}static{this.white=new p(new P(255,255,255,1))}static{this.black=new p(new P(0,0,0,1))}static{this.red=new p(new P(255,0,0,1))}static{this.blue=new p(new P(0,0,255,1))}static{this.green=new p(new P(0,255,0,1))}static{this.cyan=new p(new P(0,255,255,1))}static{this.lightgrey=new p(new P(211,211,211,1))}static{this.transparent=new p(new P(0,0,0,0))}}t.$Ft=p,function(h){let o;(function(a){let g;(function(B){function d(n){return n.rgba.a===1?`rgb(${n.rgba.r}, ${n.rgba.g}, ${n.rgba.b})`:h.Format.CSS.formatRGBA(n)}B.formatRGB=d;function m(n){return`rgba(${n.rgba.r}, ${n.rgba.g}, ${n.rgba.b}, ${+n.rgba.a.toFixed(2)})`}B.formatRGBA=m;function e(n){return n.hsla.a===1?`hsl(${n.hsla.h}, ${(n.hsla.s*100).toFixed(2)}%, ${(n.hsla.l*100).toFixed(2)}%)`:h.Format.CSS.formatHSLA(n)}B.formatHSL=e;function v(n){return`hsla(${n.hsla.h}, ${(n.hsla.s*100).toFixed(2)}%, ${(n.hsla.l*100).toFixed(2)}%, ${n.hsla.a.toFixed(2)})`}B.formatHSLA=v;function j(n){const s=n.toString(16);return s.length!==2?"0"+s:s}function L(n){return`#${j(n.rgba.r)}${j(n.rgba.g)}${j(n.rgba.b)}`}B.formatHex=L;function $(n,s=!1){return s&&n.rgba.a===1?h.Format.CSS.formatHex(n):`#${j(n.rgba.r)}${j(n.rgba.g)}${j(n.rgba.b)}${j(Math.round(n.rgba.a*255))}`}B.formatHexA=$;function b(n){return n.isOpaque()?h.Format.CSS.formatHex(n):h.Format.CSS.formatRGBA(n)}B.format=b;function u(n){const s=n.length;if(s===0||n.charCodeAt(0)!==35)return null;if(s===7){const N=16*l(n.charCodeAt(1))+l(n.charCodeAt(2)),c=16*l(n.charCodeAt(3))+l(n.charCodeAt(4)),w=16*l(n.charCodeAt(5))+l(n.charCodeAt(6));return new h(new P(N,c,w,1))}if(s===9){const N=16*l(n.charCodeAt(1))+l(n.charCodeAt(2)),c=16*l(n.charCodeAt(3))+l(n.charCodeAt(4)),w=16*l(n.charCodeAt(5))+l(n.charCodeAt(6)),E=16*l(n.charCodeAt(7))+l(n.charCodeAt(8));return new h(new P(N,c,w,E/255))}if(s===4){const N=l(n.charCodeAt(1)),c=l(n.charCodeAt(2)),w=l(n.charCodeAt(3));return new h(new P(16*N+N,16*c+c,16*w+w))}if(s===5){const N=l(n.charCodeAt(1)),c=l(n.charCodeAt(2)),w=l(n.charCodeAt(3)),E=l(n.charCodeAt(4));return new h(new P(16*N+N,16*c+c,16*w+w,(16*E+E)/255))}return null}B.parseHex=u;function l(n){switch(n){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(g=a.CSS||(a.CSS={}))})(o=h.Format||(h.Format={}))}(p||(t.$Ft=p={}))}),re(ie[37],se([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$et=void 0;class i{constructor(y,f,p,h){this.originalStart=y,this.originalLength=f,this.modifiedStart=p,this.modifiedLength=h}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.$et=i}),re(ie[3],se([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cb=t.$bb=t.$ab=t.$_=t.$$=t.$9=t.$5=t.$X=t.$W=void 0,t.setUnexpectedErrorHandler=P,t.$Z=y,t.$1=f,t.$2=p,t.$3=h,t.$4=a,t.$6=B,t.$7=d,t.$8=m,t.$0=v;class i{constructor(){this.b=[],this.a=function(n){setTimeout(()=>{throw n.stack?b.isErrorNoTelemetry(n)?new b(n.message+`

`+n.stack):new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.b.push(n),()=>{this.d(n)}}c(n){this.b.forEach(s=>{s(n)})}d(n){this.b.splice(this.b.indexOf(n),1)}setUnexpectedErrorHandler(n){this.a=n}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(n){this.a(n),this.c(n)}onUnexpectedExternalError(n){this.a(n)}}t.$W=i,t.$X=new i;function P(l){t.$X.setUnexpectedErrorHandler(l)}function y(l){if(!l||typeof l!="object")return!1;const n=l;return n.code==="EPIPE"&&n.syscall?.toUpperCase()==="WRITE"}function f(l){a(l)||t.$X.onUnexpectedError(l)}function p(l){a(l)||t.$X.onUnexpectedExternalError(l)}function h(l){if(l instanceof Error){const{name:n,message:s}=l,N=l.stacktrace||l.stack;return{$isError:!0,name:n,message:s,stack:N,noTelemetry:b.isErrorNoTelemetry(l)}}return l}const o="Canceled";function a(l){return l instanceof g?!0:l instanceof Error&&l.name===o&&l.message===o}class g extends Error{constructor(){super(o),this.name=this.message}}t.$5=g;function B(){const l=new Error(o);return l.name=l.message,l}function d(l){return l?new Error(`Illegal argument: ${l}`):new Error("Illegal argument")}function m(l){return l?new Error(`Illegal state: ${l}`):new Error("Illegal state")}class e extends TypeError{constructor(n){super(n?`${n} is read-only and cannot be changed`:"Cannot change read-only property")}}t.$9=e;function v(l){return l?l.message?l.message:l.stack?l.stack.split(`
`)[0]:String(l):"Error"}class j extends Error{constructor(n){super("NotImplemented"),n&&(this.message=n)}}t.$$=j;class L extends Error{constructor(n){super("NotSupported"),n&&(this.message=n)}}t.$_=L;class $ extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.$ab=$;class b extends Error{constructor(n){super(n),this.name="CodeExpectedError"}static fromError(n){if(n instanceof b)return n;const s=new b;return s.message=n.message,s.stack=n.stack,s}static isErrorNoTelemetry(n){return n.name==="CodeExpectedError"}}t.$bb=b;class u extends Error{constructor(n){super(n||"An unexpected bug occurred."),Object.setPrototypeOf(this,u.prototype)}}t.$cb=u}),re(ie[6],se([0,1,3,9]),function(V,t,i,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bc=t.$ac=t.$_b=t.$0b=t.$9b=t.CompareResult=void 0,t.$sb=y,t.$tb=f,t.$ub=p,t.$vb=h,t.$wb=o,t.$xb=a,t.$yb=g,t.$zb=B,t.$Ab=d,t.$Bb=m,t.$Cb=e,t.$Db=v,t.$Eb=j,t.top=L,t.$Gb=$,t.$Hb=u,t.$Ib=l,t.$Jb=n,t.$Kb=s,t.$Lb=N,t.$Mb=c,t.$Nb=w,t.$Ob=E,t.$Pb=A,t.$Qb=M,t.$Rb=T,t.$Sb=S,t.$Tb=F,t.$Ub=R,t.$Vb=x,t.$Wb=I,t.$Xb=H,t.$Yb=K,t.$Zb=_,t.$1b=X,t.$2b=Z,t.$3b=k,t.$4b=z,t.$5b=ue,t.$6b=oe,t.$7b=ve,t.$8b=Le,t.$$b=xe;function y(O,C=0){return O[O.length-(1+C)]}function f(O){if(O.length===0)throw new Error("Invalid tail call");return[O.slice(0,O.length-1),O[O.length-1]]}function p(O,C,W=(Y,ee)=>Y===ee){if(O===C)return!0;if(!O||!C||O.length!==C.length)return!1;for(let Y=0,ee=O.length;Y<ee;Y++)if(!W(O[Y],C[Y]))return!1;return!0}function h(O,C){const W=O.length-1;C<W&&(O[C]=O[W]),O.pop()}function o(O,C,W){return a(O.length,Y=>W(O[Y],C))}function a(O,C){let W=0,Y=O-1;for(;W<=Y;){const ee=(W+Y)/2|0,Q=C(ee);if(Q<0)W=ee+1;else if(Q>0)Y=ee-1;else return ee}return-(W+1)}function g(O,C,W){if(O=O|0,O>=C.length)throw new TypeError("invalid index");const Y=C[Math.floor(C.length*Math.random())],ee=[],Q=[],J=[];for(const ne of C){const te=W(ne,Y);te<0?ee.push(ne):te>0?Q.push(ne):J.push(ne)}return O<ee.length?g(O,ee,W):O<ee.length+J.length?J[0]:g(O-(ee.length+J.length),Q,W)}function B(O,C){const W=[];let Y;for(const ee of O.slice(0).sort(C))!Y||C(Y[0],ee)!==0?(Y=[ee],W.push(Y)):Y.push(ee);return W}function*d(O,C){let W,Y;for(const ee of O)Y!==void 0&&C(Y,ee)?W.push(ee):(W&&(yield W),W=[ee]),Y=ee;W&&(yield W)}function m(O,C){for(let W=0;W<=O.length;W++)C(W===0?void 0:O[W-1],W===O.length?void 0:O[W])}function e(O,C){for(let W=0;W<O.length;W++)C(W===0?void 0:O[W-1],O[W],W+1===O.length?void 0:O[W+1])}function v(O,C,W){const Y=[];function ee(ne,te,le){if(te===0&&le.length===0)return;const fe=Y[Y.length-1];fe&&fe.start+fe.deleteCount===ne?(fe.deleteCount+=te,fe.toInsert.push(...le)):Y.push({start:ne,deleteCount:te,toInsert:le})}let Q=0,J=0;for(;;){if(Q===O.length){ee(Q,0,C.slice(J));break}if(J===C.length){ee(Q,O.length-Q,[]);break}const ne=O[Q],te=C[J],le=W(ne,te);le===0?(Q+=1,J+=1):le<0?(ee(Q,1,[]),Q+=1):le>0&&(ee(Q,0,[te]),J+=1)}return Y}function j(O,C,W){const Y=v(O,C,W),ee=[],Q=[];for(const J of Y)ee.push(...O.slice(J.start,J.start+J.deleteCount)),Q.push(...J.toInsert);return{removed:ee,added:Q}}function L(O,C,W){if(W===0)return[];const Y=O.slice(0,W).sort(C);return b(O,C,Y,W,O.length),Y}function $(O,C,W,Y,ee){return W===0?Promise.resolve([]):new Promise((Q,J)=>{(async()=>{const ne=O.length,te=O.slice(0,W).sort(C);for(let le=W,fe=Math.min(W+Y,ne);le<ne;le=fe,fe=Math.min(fe+Y,ne)){if(le>W&&await new Promise(ce=>setTimeout(ce)),ee&&ee.isCancellationRequested)throw new i.$5;b(O,C,te,le,fe)}return te})().then(Q,J)})}function b(O,C,W,Y,ee){for(const Q=W.length;Y<ee;Y++){const J=O[Y];if(C(J,W[Q-1])<0){W.pop();const ne=(0,P.$kb)(W,te=>C(J,te)<0);W.splice(ne,0,J)}}}function u(O){return O.filter(C=>!!C)}function l(O){let C=0;for(let W=0;W<O.length;W++)O[W]&&(O[C]=O[W],C+=1);O.length=C}function n(O,C,W){O.splice(W,0,O.splice(C,1)[0])}function s(O){return!Array.isArray(O)||O.length===0}function N(O){return Array.isArray(O)&&O.length>0}function c(O,C=W=>W){const W=new Set;return O.filter(Y=>{const ee=C(Y);return W.has(ee)?!1:(W.add(ee),!0)})}function w(O){const C=new Set;return W=>{const Y=O(W);return C.has(Y)?!1:(C.add(Y),!0)}}function E(O,C){return O.length>0?O[0]:C}function A(O,C){return O.length>0?O[O.length-1]:C}function M(O,C,W=(Y,ee)=>Y===ee){let Y=0;for(let ee=0,Q=Math.min(O.length,C.length);ee<Q&&W(O[ee],C[ee]);ee++)Y++;return Y}function T(O){return[].concat(...O)}function S(O,C){let W=typeof C=="number"?O:0;typeof C=="number"?W=O:(W=0,C=O);const Y=[];if(W<=C)for(let ee=W;ee<C;ee++)Y.push(ee);else for(let ee=W;ee>C;ee--)Y.push(ee);return Y}function F(O,C,W){return O.reduce((Y,ee)=>(Y[C(ee)]=W?W(ee):ee,Y),Object.create(null))}function R(O,C){return O.push(C),()=>x(O,C)}function x(O,C){const W=O.indexOf(C);if(W>-1)return O.splice(W,1),C}function I(O,C,W){const Y=O.slice(0,C),ee=O.slice(C);return Y.concat(W,ee)}function H(O,C){let W;if(typeof C=="number"){let Y=C;W=()=>{const ee=Math.sin(Y++)*179426549;return ee-Math.floor(ee)}}else W=Math.random;for(let Y=O.length-1;Y>0;Y-=1){const ee=Math.floor(W()*(Y+1)),Q=O[Y];O[Y]=O[ee],O[ee]=Q}}function K(O,C){const W=O.indexOf(C);W>-1&&(O.splice(W,1),O.unshift(C))}function _(O,C){const W=O.indexOf(C);W>-1&&(O.splice(W,1),O.push(C))}function X(O,C){for(const W of C)O.push(W)}function Z(O,C){return Array.isArray(O)?O.map(C):C(O)}function k(O){return Array.isArray(O)?O:[O]}function z(O){return O[Math.floor(Math.random()*O.length)]}function ue(O,C,W){const Y=r(O,C),ee=O.length,Q=W.length;O.length=ee+Q;for(let J=ee-1;J>=Y;J--)O[J+Q]=O[J];for(let J=0;J<Q;J++)O[J+Y]=W[J]}function oe(O,C,W,Y){const ee=r(O,C);let Q=O.splice(ee,W);return Q===void 0&&(Q=[]),ue(O,ee,Y),Q}function r(O,C){return C<0?Math.max(C+O.length,0):Math.min(C,O.length)}var $e;(function(O){function C(Q){return Q<0}O.isLessThan=C;function W(Q){return Q<=0}O.isLessThanOrEqual=W;function Y(Q){return Q>0}O.isGreaterThan=Y;function ee(Q){return Q===0}O.isNeitherLessOrGreaterThan=ee,O.greaterThan=1,O.lessThan=-1,O.neitherLessOrGreaterThan=0})($e||(t.CompareResult=$e={}));function ve(O,C){return(W,Y)=>C(O(W),O(Y))}function Le(...O){return(C,W)=>{for(const Y of O){const ee=Y(C,W);if(!$e.isNeitherLessOrGreaterThan(ee))return ee}return $e.neitherLessOrGreaterThan}}const Fe=(O,C)=>O-C;t.$9b=Fe;const pe=(O,C)=>(0,t.$9b)(O?1:0,C?1:0);t.$0b=pe;function xe(O){return(C,W)=>-O(C,W)}class Ie{constructor(C){this.g=C,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(C){let W=this.c;for(;W<this.g.length&&C(this.g[W]);)W++;const Y=W===this.c?null:this.g.slice(this.c,W);return this.c=W,Y}takeFromEndWhile(C){let W=this.d;for(;W>=0&&C(this.g[W]);)W--;const Y=W===this.d?null:this.g.slice(W+1,this.d+1);return this.d=W,Y}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const C=this.g[this.c];return this.c++,C}removeLast(){const C=this.g[this.d];return this.d--,C}takeCount(C){const W=this.g.slice(this.c,this.c+C);return this.c+=C,W}}t.$_b=Ie;class Ae{static{this.empty=new Ae(C=>{})}constructor(C){this.iterate=C}forEach(C){this.iterate(W=>(C(W),!0))}toArray(){const C=[];return this.iterate(W=>(C.push(W),!0)),C}filter(C){return new Ae(W=>this.iterate(Y=>C(Y)?W(Y):!0))}map(C){return new Ae(W=>this.iterate(Y=>W(C(Y))))}some(C){let W=!1;return this.iterate(Y=>(W=C(Y),!W)),W}findFirst(C){let W;return this.iterate(Y=>C(Y)?(W=Y,!1):!0),W}findLast(C){let W;return this.iterate(Y=>(C(Y)&&(W=Y),!0)),W}findLastMaxBy(C){let W,Y=!0;return this.iterate(ee=>((Y||$e.isGreaterThan(C(ee,W)))&&(Y=!1,W=ee),!0)),W}}t.$ac=Ae;class ye{constructor(C){this.c=C}static createSortPermutation(C,W){const Y=Array.from(C.keys()).sort((ee,Q)=>W(C[ee],C[Q]));return new ye(Y)}apply(C){return C.map((W,Y)=>C[this.c[Y]])}inverse(){const C=this.c.slice();for(let W=0;W<this.c.length;W++)C[this.c[W]]=W;return new ye(C)}}t.$bc=ye}),re(ie[13],se([0,1,3]),function(V,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=P,t.$0c=y,t.$$c=f,t.$_c=p,t.$ad=h,t.$bd=o;function P(a,g){if(!a)throw new Error(g?`Assertion failed (${g})`:"Assertion Failed")}function y(a,g="Unreachable"){throw new Error(g)}function f(a){if(!a)throw new i.$cb("Assertion Failed")}function p(a){a||(0,i.$1)(new i.$cb("Soft Assertion Failed"))}function h(a){if(!a()){debugger;a(),(0,i.$1)(new i.$cb("Assertion Failed"))}}function o(a,g){let B=0;for(;B<a.length-1;){const d=a[B],m=a[B+1];if(!g(d,m))return!1;B++}return!0}}),re(ie[19],se([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$db=i;function i(P,y){const f=this;let p=!1,h;return function(){if(p)return h;if(p=!0,y)try{h=P.apply(f,arguments)}finally{y()}else h=P.apply(f,arguments);return h}}}),re(ie[20],se([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var i;(function(P){function y(n){return n&&typeof n=="object"&&typeof n[Symbol.iterator]=="function"}P.is=y;const f=Object.freeze([]);function p(){return f}P.empty=p;function*h(n){yield n}P.single=h;function o(n){return y(n)?n:h(n)}P.wrap=o;function a(n){return n||f}P.from=a;function*g(n){for(let s=n.length-1;s>=0;s--)yield n[s]}P.reverse=g;function B(n){return!n||n[Symbol.iterator]().next().done===!0}P.isEmpty=B;function d(n){return n[Symbol.iterator]().next().value}P.first=d;function m(n,s){for(const N of n)if(s(N))return!0;return!1}P.some=m;function e(n,s){for(const N of n)if(s(N))return N}P.find=e;function*v(n,s){for(const N of n)s(N)&&(yield N)}P.filter=v;function*j(n,s){let N=0;for(const c of n)yield s(c,N++)}P.map=j;function*L(...n){for(const s of n)yield*s}P.concat=L;function $(n,s,N){let c=N;for(const w of n)c=s(c,w);return c}P.reduce=$;function*b(n,s,N=n.length){for(s<0&&(s+=n.length),N<0?N+=n.length:N>n.length&&(N=n.length);s<N;s++)yield n[s]}P.slice=b;function u(n,s=Number.POSITIVE_INFINITY){const N=[];if(s===0)return[N,n];const c=n[Symbol.iterator]();for(let w=0;w<s;w++){const E=c.next();if(E.done)return[N,P.empty()];N.push(E.value)}return[N,{[Symbol.iterator](){return c}}]}P.consume=u;async function l(n){const s=[];for await(const N of n)s.push(N);return Promise.resolve(s)}P.asyncToArray=l})(i||(t.Iterable=i={}))}),re(ie[38],se([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.KeyMod=t.KeyCodeUtils=t.$mr=t.$lr=t.$kr=t.$jr=t.$ir=t.ScanCode=t.KeyCode=void 0,t.$nr=m;var i;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(i||(t.KeyCode=i={}));var P;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(P||(t.ScanCode=P={}));class y{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(v,j){this._keyCodeToStr[v]=j,this._strToKeyCode[j.toLowerCase()]=v}keyCodeToStr(v){return this._keyCodeToStr[v]}strToKeyCode(v){return this._strToKeyCode[v.toLowerCase()]||0}}const f=new y,p=new y,h=new y;t.$ir=new Array(230),t.$jr={};const o=[],a=Object.create(null),g=Object.create(null);t.$kr={lowerCaseToEnum:e=>g[e]||0,toEnum:e=>a[e]||0,toString:e=>o[e]||"None"},t.$lr=[],t.$mr=[];for(let e=0;e<=193;e++)t.$lr[e]=-1;for(let e=0;e<=132;e++)t.$mr[e]=-1;(function(){const e="",v=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[1,1,"Hyper",0,e,0,e,e,e],[1,2,"Super",0,e,0,e,e,e],[1,3,"Fn",0,e,0,e,e,e],[1,4,"FnLock",0,e,0,e,e,e],[1,5,"Suspend",0,e,0,e,e,e],[1,6,"Resume",0,e,0,e,e,e],[1,7,"Turbo",0,e,0,e,e,e],[1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[1,9,"WakeUp",0,e,0,e,e,e],[0,10,"KeyA",31,"A",65,"VK_A",e,e],[0,11,"KeyB",32,"B",66,"VK_B",e,e],[0,12,"KeyC",33,"C",67,"VK_C",e,e],[0,13,"KeyD",34,"D",68,"VK_D",e,e],[0,14,"KeyE",35,"E",69,"VK_E",e,e],[0,15,"KeyF",36,"F",70,"VK_F",e,e],[0,16,"KeyG",37,"G",71,"VK_G",e,e],[0,17,"KeyH",38,"H",72,"VK_H",e,e],[0,18,"KeyI",39,"I",73,"VK_I",e,e],[0,19,"KeyJ",40,"J",74,"VK_J",e,e],[0,20,"KeyK",41,"K",75,"VK_K",e,e],[0,21,"KeyL",42,"L",76,"VK_L",e,e],[0,22,"KeyM",43,"M",77,"VK_M",e,e],[0,23,"KeyN",44,"N",78,"VK_N",e,e],[0,24,"KeyO",45,"O",79,"VK_O",e,e],[0,25,"KeyP",46,"P",80,"VK_P",e,e],[0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[0,27,"KeyR",48,"R",82,"VK_R",e,e],[0,28,"KeyS",49,"S",83,"VK_S",e,e],[0,29,"KeyT",50,"T",84,"VK_T",e,e],[0,30,"KeyU",51,"U",85,"VK_U",e,e],[0,31,"KeyV",52,"V",86,"VK_V",e,e],[0,32,"KeyW",53,"W",87,"VK_W",e,e],[0,33,"KeyX",54,"X",88,"VK_X",e,e],[0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[0,36,"Digit1",22,"1",49,"VK_1",e,e],[0,37,"Digit2",23,"2",50,"VK_2",e,e],[0,38,"Digit3",24,"3",51,"VK_3",e,e],[0,39,"Digit4",25,"4",52,"VK_4",e,e],[0,40,"Digit5",26,"5",53,"VK_5",e,e],[0,41,"Digit6",27,"6",54,"VK_6",e,e],[0,42,"Digit7",28,"7",55,"VK_7",e,e],[0,43,"Digit8",29,"8",56,"VK_8",e,e],[0,44,"Digit9",30,"9",57,"VK_9",e,e],[0,45,"Digit0",21,"0",48,"VK_0",e,e],[1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,e,0,e,e,e],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[1,64,"F1",59,"F1",112,"VK_F1",e,e],[1,65,"F2",60,"F2",113,"VK_F2",e,e],[1,66,"F3",61,"F3",114,"VK_F3",e,e],[1,67,"F4",62,"F4",115,"VK_F4",e,e],[1,68,"F5",63,"F5",116,"VK_F5",e,e],[1,69,"F6",64,"F6",117,"VK_F6",e,e],[1,70,"F7",65,"F7",118,"VK_F7",e,e],[1,71,"F8",66,"F8",119,"VK_F8",e,e],[1,72,"F9",67,"F9",120,"VK_F9",e,e],[1,73,"F10",68,"F10",121,"VK_F10",e,e],[1,74,"F11",69,"F11",122,"VK_F11",e,e],[1,75,"F12",70,"F12",123,"VK_F12",e,e],[1,76,"PrintScreen",0,e,0,e,e,e],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",e,e],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[1,80,"Home",14,"Home",36,"VK_HOME",e,e],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[1,83,"End",13,"End",35,"VK_END",e,e],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",e,e],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",e,e],[1,94,"NumpadEnter",3,e,0,e,e,e],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",e,e],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",e,e],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",e,e],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",e,e],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",e,e],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",e,e],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",e,e],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",e,e],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",e,e],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",e,e],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",e,e],[1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[1,108,"Power",0,e,0,e,e,e],[1,109,"NumpadEqual",0,e,0,e,e,e],[1,110,"F13",71,"F13",124,"VK_F13",e,e],[1,111,"F14",72,"F14",125,"VK_F14",e,e],[1,112,"F15",73,"F15",126,"VK_F15",e,e],[1,113,"F16",74,"F16",127,"VK_F16",e,e],[1,114,"F17",75,"F17",128,"VK_F17",e,e],[1,115,"F18",76,"F18",129,"VK_F18",e,e],[1,116,"F19",77,"F19",130,"VK_F19",e,e],[1,117,"F20",78,"F20",131,"VK_F20",e,e],[1,118,"F21",79,"F21",132,"VK_F21",e,e],[1,119,"F22",80,"F22",133,"VK_F22",e,e],[1,120,"F23",81,"F23",134,"VK_F23",e,e],[1,121,"F24",82,"F24",135,"VK_F24",e,e],[1,122,"Open",0,e,0,e,e,e],[1,123,"Help",0,e,0,e,e,e],[1,124,"Select",0,e,0,e,e,e],[1,125,"Again",0,e,0,e,e,e],[1,126,"Undo",0,e,0,e,e,e],[1,127,"Cut",0,e,0,e,e,e],[1,128,"Copy",0,e,0,e,e,e],[1,129,"Paste",0,e,0,e,e,e],[1,130,"Find",0,e,0,e,e,e],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,136,"KanaMode",0,e,0,e,e,e],[0,137,"IntlYen",0,e,0,e,e,e],[1,138,"Convert",0,e,0,e,e,e],[1,139,"NonConvert",0,e,0,e,e,e],[1,140,"Lang1",0,e,0,e,e,e],[1,141,"Lang2",0,e,0,e,e,e],[1,142,"Lang3",0,e,0,e,e,e],[1,143,"Lang4",0,e,0,e,e,e],[1,144,"Lang5",0,e,0,e,e,e],[1,145,"Abort",0,e,0,e,e,e],[1,146,"Props",0,e,0,e,e,e],[1,147,"NumpadParenLeft",0,e,0,e,e,e],[1,148,"NumpadParenRight",0,e,0,e,e,e],[1,149,"NumpadBackspace",0,e,0,e,e,e],[1,150,"NumpadMemoryStore",0,e,0,e,e,e],[1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[1,152,"NumpadMemoryClear",0,e,0,e,e,e],[1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",e,e],[1,156,"NumpadClearEntry",0,e,0,e,e,e],[1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[1,0,e,6,"Alt",18,"VK_MENU",e,e],[1,0,e,57,"Meta",91,"VK_COMMAND",e,e],[1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[1,165,"BrightnessUp",0,e,0,e,e,e],[1,166,"BrightnessDown",0,e,0,e,e,e],[1,167,"MediaPlay",0,e,0,e,e,e],[1,168,"MediaRecord",0,e,0,e,e,e],[1,169,"MediaFastForward",0,e,0,e,e,e],[1,170,"MediaRewind",0,e,0,e,e,e],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,174,"Eject",0,e,0,e,e,e],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,180,"SelectTask",0,e,0,e,e,e],[1,181,"LaunchScreenSaver",0,e,0,e,e,e],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[1,189,"ZoomToggle",0,e,0,e,e,e],[1,190,"MailReply",0,e,0,e,e,e],[1,191,"MailForward",0,e,0,e,e,e],[1,192,"MailSend",0,e,0,e,e,e],[1,0,e,114,"KeyInComposition",229,e,e,e],[1,0,e,116,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,0,e,96,"OEM_8",223,"VK_OEM_8",e,e],[1,0,e,0,e,0,"VK_KANA",e,e],[1,0,e,0,e,0,"VK_HANGUL",e,e],[1,0,e,0,e,0,"VK_JUNJA",e,e],[1,0,e,0,e,0,"VK_FINAL",e,e],[1,0,e,0,e,0,"VK_HANJA",e,e],[1,0,e,0,e,0,"VK_KANJI",e,e],[1,0,e,0,e,0,"VK_CONVERT",e,e],[1,0,e,0,e,0,"VK_NONCONVERT",e,e],[1,0,e,0,e,0,"VK_ACCEPT",e,e],[1,0,e,0,e,0,"VK_MODECHANGE",e,e],[1,0,e,0,e,0,"VK_SELECT",e,e],[1,0,e,0,e,0,"VK_PRINT",e,e],[1,0,e,0,e,0,"VK_EXECUTE",e,e],[1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[1,0,e,0,e,0,"VK_HELP",e,e],[1,0,e,0,e,0,"VK_APPS",e,e],[1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[1,0,e,0,e,0,"VK_PACKET",e,e],[1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[1,0,e,0,e,0,"VK_ATTN",e,e],[1,0,e,0,e,0,"VK_CRSEL",e,e],[1,0,e,0,e,0,"VK_EXSEL",e,e],[1,0,e,0,e,0,"VK_EREOF",e,e],[1,0,e,0,e,0,"VK_PLAY",e,e],[1,0,e,0,e,0,"VK_ZOOM",e,e],[1,0,e,0,e,0,"VK_NONAME",e,e],[1,0,e,0,e,0,"VK_PA1",e,e],[1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],j=[],L=[];for(const $ of v){const[b,u,l,n,s,N,c,w,E]=$;if(L[u]||(L[u]=!0,o[u]=l,a[l]=u,g[l.toLowerCase()]=u,b&&(t.$lr[u]=n,n!==0&&n!==3&&n!==5&&n!==4&&n!==6&&n!==57&&(t.$mr[n]=u))),!j[n]){if(j[n]=!0,!s)throw new Error(`String representation missing for key code ${n} around scan code ${l}`);f.define(n,s),p.define(n,w||s),h.define(n,E||w||s)}N&&(t.$ir[N]=n),c&&(t.$jr[c]=n)}t.$mr[3]=46})();var B;(function(e){function v(l){return f.keyCodeToStr(l)}e.toString=v;function j(l){return f.strToKeyCode(l)}e.fromString=j;function L(l){return p.keyCodeToStr(l)}e.toUserSettingsUS=L;function $(l){return h.keyCodeToStr(l)}e.toUserSettingsGeneral=$;function b(l){return p.strToKeyCode(l)||h.strToKeyCode(l)}e.fromUserSettings=b;function u(l){if(l>=98&&l<=113)return null;switch(l){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return f.keyCodeToStr(l)}e.toElectronAccelerator=u})(B||(t.KeyCodeUtils=B={}));var d;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(d||(t.KeyMod=d={}));function m(e,v){const j=(v&65535)<<16>>>0;return(e|j)>>>0}}),re(ie[39],se([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$V=void 0;class i{constructor(y){this.d=y,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(y){this.c=y}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}t.$V=i}),re(ie[21],se([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5c=void 0;class i{static{this.Undefined=new i(void 0)}constructor(f){this.element=f,this.next=i.Undefined,this.prev=i.Undefined}}class P{constructor(){this.a=i.Undefined,this.b=i.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===i.Undefined}clear(){let f=this.a;for(;f!==i.Undefined;){const p=f.next;f.prev=i.Undefined,f.next=i.Undefined,f=p}this.a=i.Undefined,this.b=i.Undefined,this.c=0}unshift(f){return this.d(f,!1)}push(f){return this.d(f,!0)}d(f,p){const h=new i(f);if(this.a===i.Undefined)this.a=h,this.b=h;else if(p){const a=this.b;this.b=h,h.prev=a,a.next=h}else{const a=this.a;this.a=h,h.next=a,a.prev=h}this.c+=1;let o=!1;return()=>{o||(o=!0,this.e(h))}}shift(){if(this.a!==i.Undefined){const f=this.a.element;return this.e(this.a),f}}pop(){if(this.b!==i.Undefined){const f=this.b.element;return this.e(this.b),f}}e(f){if(f.prev!==i.Undefined&&f.next!==i.Undefined){const p=f.prev;p.next=f.next,f.next.prev=p}else f.prev===i.Undefined&&f.next===i.Undefined?(this.a=i.Undefined,this.b=i.Undefined):f.next===i.Undefined?(this.b=this.b.prev,this.b.next=i.Undefined):f.prev===i.Undefined&&(this.a=this.a.next,this.a.prev=i.Undefined);this.c-=1}*[Symbol.iterator](){let f=this.a;for(;f!==i.Undefined;)yield f.element,f=f.next}}t.$5c=P}),re(ie[22],se([0,1]),function(V,t){"use strict";var i,P,y;Object.defineProperty(t,"__esModule",{value:!0}),t.$Hc=t.$Gc=t.$Fc=t.$Ec=t.$Dc=t.Touch=t.$Cc=t.$Bc=void 0,t.$yc=f,t.$zc=p,t.$Ac=h,t.$Ic=$;function f(b,u,l){let n=b.get(u);return n===void 0&&(n=l,b.set(u,n)),n}function p(b){const u=[];return b.forEach((l,n)=>{u.push(`${n} => ${l}`)}),`Map(${b.size}) {${u.join(", ")}}`}function h(b){const u=[];return b.forEach(l=>{u.push(l)}),`Set(${b.size}) {${u.join(", ")}}`}class o{constructor(u,l){this.uri=u,this.value=l}}function a(b){return Array.isArray(b)}class g{static{this.c=u=>u.toString()}constructor(u,l){if(this[i]="ResourceMap",u instanceof g)this.d=new Map(u.d),this.e=l??g.c;else if(a(u)){this.d=new Map,this.e=l??g.c;for(const[n,s]of u)this.set(n,s)}else this.d=new Map,this.e=u??g.c}set(u,l){return this.d.set(this.e(u),new o(u,l)),this}get(u){return this.d.get(this.e(u))?.value}has(u){return this.d.has(this.e(u))}get size(){return this.d.size}clear(){this.d.clear()}delete(u){return this.d.delete(this.e(u))}forEach(u,l){typeof l<"u"&&(u=u.bind(l));for(const[n,s]of this.d)u(s.value,s.uri,this)}*values(){for(const u of this.d.values())yield u.value}*keys(){for(const u of this.d.values())yield u.uri}*entries(){for(const u of this.d.values())yield[u.uri,u.value]}*[(i=Symbol.toStringTag,Symbol.iterator)](){for(const[,u]of this.d)yield[u.uri,u.value]}}t.$Bc=g;class B{constructor(u,l){this[P]="ResourceSet",!u||typeof u=="function"?this.c=new g(u):(this.c=new g(l),u.forEach(this.add,this))}get size(){return this.c.size}add(u){return this.c.set(u,u),this}clear(){this.c.clear()}delete(u){return this.c.delete(u)}forEach(u,l){this.c.forEach((n,s)=>u.call(l,s,s,this))}has(u){return this.c.has(u)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.$Cc=B;var d;(function(b){b[b.None=0]="None",b[b.AsOld=1]="AsOld",b[b.AsNew=2]="AsNew"})(d||(t.Touch=d={}));class m{constructor(){this[y]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(u){return this.c.has(u)}get(u,l=0){const n=this.c.get(u);if(n)return l!==0&&this.l(n,l),n.value}set(u,l,n=0){let s=this.c.get(u);if(s)s.value=l,n!==0&&this.l(s,n);else{switch(s={key:u,value:l,next:void 0,previous:void 0},n){case 0:this.j(s);break;case 1:this.i(s);break;case 2:this.j(s);break;default:this.j(s);break}this.c.set(u,s),this.f++}return this}delete(u){return!!this.remove(u)}remove(u){const l=this.c.get(u);if(l)return this.c.delete(u),this.k(l),this.f--,l.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const u=this.d;return this.c.delete(u.key),this.k(u),this.f--,u.value}forEach(u,l){const n=this.g;let s=this.d;for(;s;){if(l?u.bind(l)(s.value,s.key,this):u(s.value,s.key,this),this.g!==n)throw new Error("LinkedMap got modified during iteration.");s=s.next}}keys(){const u=this,l=this.g;let n=this.d;const s={[Symbol.iterator](){return s},next(){if(u.g!==l)throw new Error("LinkedMap got modified during iteration.");if(n){const N={value:n.key,done:!1};return n=n.next,N}else return{value:void 0,done:!0}}};return s}values(){const u=this,l=this.g;let n=this.d;const s={[Symbol.iterator](){return s},next(){if(u.g!==l)throw new Error("LinkedMap got modified during iteration.");if(n){const N={value:n.value,done:!1};return n=n.next,N}else return{value:void 0,done:!0}}};return s}entries(){const u=this,l=this.g;let n=this.d;const s={[Symbol.iterator](){return s},next(){if(u.g!==l)throw new Error("LinkedMap got modified during iteration.");if(n){const N={value:[n.key,n.value],done:!1};return n=n.next,N}else return{value:void 0,done:!0}}};return s}[(y=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(u){if(u>=this.size)return;if(u===0){this.clear();return}let l=this.d,n=this.size;for(;l&&n>u;)this.c.delete(l.key),l=l.next,n--;this.d=l,this.f=n,l&&(l.previous=void 0),this.g++}i(u){if(!this.d&&!this.e)this.e=u;else if(this.d)u.next=this.d,this.d.previous=u;else throw new Error("Invalid list");this.d=u,this.g++}j(u){if(!this.d&&!this.e)this.d=u;else if(this.e)u.previous=this.e,this.e.next=u;else throw new Error("Invalid list");this.e=u,this.g++}k(u){if(u===this.d&&u===this.e)this.d=void 0,this.e=void 0;else if(u===this.d){if(!u.next)throw new Error("Invalid list");u.next.previous=void 0,this.d=u.next}else if(u===this.e){if(!u.previous)throw new Error("Invalid list");u.previous.next=void 0,this.e=u.previous}else{const l=u.next,n=u.previous;if(!l||!n)throw new Error("Invalid list");l.previous=n,n.next=l}u.next=void 0,u.previous=void 0,this.g++}l(u,l){if(!this.d||!this.e)throw new Error("Invalid list");if(!(l!==1&&l!==2)){if(l===1){if(u===this.d)return;const n=u.next,s=u.previous;u===this.e?(s.next=void 0,this.e=s):(n.previous=s,s.next=n),u.previous=void 0,u.next=this.d,this.d.previous=u,this.d=u,this.g++}else if(l===2){if(u===this.e)return;const n=u.next,s=u.previous;u===this.d?(n.previous=void 0,this.d=n):(n.previous=s,s.next=n),u.next=void 0,u.previous=this.e,this.e.next=u,this.e=u,this.g++}}}toJSON(){const u=[];return this.forEach((l,n)=>{u.push([n,l])}),u}fromJSON(u){this.clear();for(const[l,n]of u)this.set(l,n)}}t.$Dc=m;class e extends m{constructor(u,l=1){super(),this.m=u,this.n=Math.min(Math.max(0,l),1)}get limit(){return this.m}set limit(u){this.m=u,this.o()}get ratio(){return this.n}set ratio(u){this.n=Math.min(Math.max(0,u),1),this.o()}get(u,l=2){return super.get(u,l)}peek(u){return super.get(u,0)}set(u,l){return super.set(u,l,2),this.o(),this}o(){this.size>this.m&&this.h(Math.round(this.m*this.n))}}t.$Ec=e;class v{constructor(){this.c=new Map}add(u){return this.c.set(u,(this.c.get(u)||0)+1),this}delete(u){let l=this.c.get(u)||0;return l===0?!1:(l--,l===0?this.c.delete(u):this.c.set(u,l),!0)}has(u){return this.c.has(u)}}t.$Fc=v;class j{constructor(u){if(this.c=new Map,this.d=new Map,u)for(const[l,n]of u)this.set(l,n)}clear(){this.c.clear(),this.d.clear()}set(u,l){this.c.set(u,l),this.d.set(l,u)}get(u){return this.c.get(u)}getKey(u){return this.d.get(u)}delete(u){const l=this.c.get(u);return l===void 0?!1:(this.c.delete(u),this.d.delete(l),!0)}forEach(u,l){this.c.forEach((n,s)=>{u.call(l,n,s,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}t.$Gc=j;class L{constructor(){this.c=new Map}add(u,l){let n=this.c.get(u);n||(n=new Set,this.c.set(u,n)),n.add(l)}delete(u,l){const n=this.c.get(u);n&&(n.delete(l),n.size===0&&this.c.delete(u))}forEach(u,l){const n=this.c.get(u);n&&n.forEach(l)}get(u){const l=this.c.get(u);return l||new Set}}t.$Hc=L;function $(b,u){if(b===u)return!0;if(b.size!==u.size)return!1;for(const[l,n]of b)if(!u.has(l)||u.get(l)!==n)return!1;for(const[l]of u)if(!b.has(l))return!1;return!0}}),re(ie[10],se([0,1,6,35,22,19,20]),function(V,t,i,P,y,f,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4c=t.$2c=t.$1c=t.$Zc=t.$Yc=t.$Xc=t.$Wc=t.$Vc=t.$Uc=t.$Tc=t.$Jc=void 0,t.$Kc=g,t.$Lc=B,t.$Mc=d,t.$Nc=v,t.$Oc=j,t.$Pc=L,t.$Qc=$,t.$Rc=b,t.$Sc=u,t.$3c=T;const h=!1;let o=null;class a{constructor(){this.b=new Map}static{this.a=0}c(R){let x=this.b.get(R);return x||(x={parent:null,source:null,isSingleton:!1,value:R,idx:a.a++},this.b.set(R,x)),x}trackDisposable(R){const x=this.c(R);x.source||(x.source=new Error().stack)}setParent(R,x){const I=this.c(R);I.parent=x}markAsDisposed(R){this.b.delete(R)}markAsSingleton(R){this.c(R).isSingleton=!0}f(R,x){const I=x.get(R);if(I)return I;const H=R.parent?this.f(this.c(R.parent),x):R;return x.set(R,H),H}getTrackedDisposables(){const R=new Map;return[...this.b.entries()].filter(([,I])=>I.source!==null&&!this.f(I,R).isSingleton).flatMap(([I])=>I)}computeLeakingDisposables(R=10,x){let I;if(x)I=x;else{const Z=new Map,k=[...this.b.values()].filter(ue=>ue.source!==null&&!this.f(ue,Z).isSingleton);if(k.length===0)return;const z=new Set(k.map(ue=>ue.value));if(I=k.filter(ue=>!(ue.parent&&z.has(ue.parent))),I.length===0)throw new Error("There are cyclic diposable chains!")}if(!I)return;function H(Z){function k(ue,oe){for(;ue.length>0&&oe.some(r=>typeof r=="string"?r===ue[0]:ue[0].match(r));)ue.shift()}const z=Z.source.split(`
`).map(ue=>ue.trim().replace("at ","")).filter(ue=>ue!=="");return k(z,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),z.reverse()}const K=new y.$Hc;for(const Z of I){const k=H(Z);for(let z=0;z<=k.length;z++)K.add(k.slice(0,z).join(`
`),Z)}I.sort((0,i.$7b)(Z=>Z.idx,i.$9b));let _="",X=0;for(const Z of I.slice(0,R)){X++;const k=H(Z),z=[];for(let ue=0;ue<k.length;ue++){let oe=k[ue];oe=`(shared with ${K.get(k.slice(0,ue+1).join(`
`)).size}/${I.length} leaks) at ${oe}`;const $e=K.get(k.slice(0,ue).join(`
`)),ve=(0,P.$K)([...$e].map(Le=>H(Le)[ue]),Le=>Le);delete ve[k[ue]];for(const[Le,Fe]of Object.entries(ve))z.unshift(`    - stacktraces of ${Fe.length} other leaks continue with ${Le}`);z.unshift(oe)}_+=`


==================== Leaking disposable ${X}/${I.length}: ${Z.value.constructor.name} ====================
${z.join(`
`)}
============================================================

`}return I.length>R&&(_+=`


... and ${I.length-R} more leaking disposables

`),{leaks:I,details:_}}}t.$Jc=a;function g(F){o=F}if(h){const F="__is_disposable_tracked__";g(new class{trackDisposable(R){const x=new Error("Potentially leaked disposable").stack;setTimeout(()=>{R[F]||console.log(x)},3e3)}setParent(R,x){if(R&&R!==n.None)try{R[F]=!0}catch{}}markAsDisposed(R){if(R&&R!==n.None)try{R[F]=!0}catch{}}markAsSingleton(R){}})}function B(F){return o?.trackDisposable(F),F}function d(F){o?.markAsDisposed(F)}function m(F,R){o?.setParent(F,R)}function e(F,R){if(o)for(const x of F)o.setParent(x,R)}function v(F){return o?.markAsSingleton(F),F}function j(F){return typeof F.dispose=="function"&&F.dispose.length===0}function L(F){if(p.Iterable.is(F)){const R=[];for(const x of F)if(x)try{x.dispose()}catch(I){R.push(I)}if(R.length===1)throw R[0];if(R.length>1)throw new AggregateError(R,"Encountered errors while disposing of store");return Array.isArray(F)?[]:F}else if(F)return F.dispose(),F}function $(F){for(const R of F)j(R)&&R.dispose();return[]}function b(...F){const R=u(()=>L(F));return e(F,R),R}function u(F){const R=B({dispose:(0,f.$db)(()=>{d(R),F()})});return R}class l{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,B(this)}dispose(){this.g||(d(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{L(this.f)}finally{this.f.clear()}}add(R){if(!R)return R;if(R===this)throw new Error("Cannot register a disposable on itself!");return m(R,this),this.g?l.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(R),R}delete(R){if(R){if(R===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(R),R.dispose()}}deleteAndLeak(R){R&&this.f.has(R)&&(this.f.delete(R),m(R,null))}}t.$Tc=l;class n{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new l,B(this),m(this.q,this)}dispose(){d(this),this.q.dispose()}B(R){if(R===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(R)}}t.$Uc=n;class s{constructor(){this.b=!1,B(this)}get value(){return this.b?void 0:this.a}set value(R){this.b||R===this.a||(this.a?.dispose(),R&&m(R,this),this.a=R)}clear(){this.value=void 0}dispose(){this.b=!0,d(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const R=this.a;return this.a=void 0,R&&m(R,null),R}}t.$Vc=s;class N{constructor(R){this.a=new s,this.b=!1,this.a.value=R}get value(){return this.a.value}set value(R){this.b||R===this.a.value||(this.a.value=R)}dispose(){this.b=!0,this.a.dispose()}}t.$Wc=N;class c{constructor(R){this.b=R,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}t.$Xc=c;class w{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,B(this)}set(R){let x=R;return this.unset=()=>x=void 0,this.isset=()=>x!==void 0,this.dispose=()=>{x&&(x(),x=void 0,d(this))},this}}t.$Yc=w;class E{constructor(){this.a=new Map}acquire(R,...x){let I=this.a.get(R);I||(I={counter:0,object:this.b(R,...x)},this.a.set(R,I));const{object:H}=I,K=(0,f.$db)(()=>{--I.counter===0&&(this.c(R,I.object),this.a.delete(R))});return I.counter++,{object:H,dispose:K}}}t.$Zc=E;class A{constructor(R){this.a=R}async acquire(R,...x){const I=this.a.acquire(R,...x);try{return{object:await I.object,dispose:()=>I.dispose()}}catch(H){throw I.dispose(),H}}}t.$1c=A;class M{constructor(R){this.object=R}dispose(){}}t.$2c=M;function T(F){const R=new l;try{F(R)}finally{R.dispose()}}class S{constructor(){this.a=new Map,this.b=!1,B(this)}dispose(){d(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{L(this.a.values())}finally{this.a.clear()}}has(R){return this.a.has(R)}get size(){return this.a.size}get(R){return this.a.get(R)}set(R,x,I=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),I||this.a.get(R)?.dispose(),this.a.set(R,x)}deleteAndDispose(R){this.a.get(R)?.dispose(),this.a.delete(R)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}t.$4c=S}),re(ie[23],se([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3d=void 0;const i=globalThis.performance&&typeof globalThis.performance.now=="function";class P{static create(f){return new P(f)}constructor(f){this.c=i&&f===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}t.$3d=P}),re(ie[11],se([0,1,3,19,10,21,23]),function(V,t,i,P,y,f,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$de=t.$ce=t.$be=t.$ae=t.$_d=t.$$d=t.$0d=t.$9d=t.$8d=t.$7d=t.$5d=t.Event=void 0,t.$6d=m;const h=!1,o=!1,a=!1;var g;(function(F){F.None=()=>y.$Uc.None;function R(Q){if(a){const{onDidAddListener:J}=Q,ne=v.create();let te=0;Q.onDidAddListener=()=>{++te===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ne.print()),J?.()}}}function x(Q,J){return oe(Q,()=>{},0,void 0,!0,void 0,J)}F.defer=x;function I(Q){return(J,ne=null,te)=>{let le=!1,fe;return fe=Q(ce=>{if(!le)return fe?fe.dispose():le=!0,J.call(ne,ce)},null,te),le&&fe.dispose(),fe}}F.once=I;function H(Q,J,ne){return z((te,le=null,fe)=>Q(ce=>te.call(le,J(ce)),null,fe),ne)}F.map=H;function K(Q,J,ne){return z((te,le=null,fe)=>Q(ce=>{J(ce),te.call(le,ce)},null,fe),ne)}F.forEach=K;function _(Q,J,ne){return z((te,le=null,fe)=>Q(ce=>J(ce)&&te.call(le,ce),null,fe),ne)}F.filter=_;function X(Q){return Q}F.signal=X;function Z(...Q){return(J,ne=null,te)=>{const le=(0,y.$Rc)(...Q.map(fe=>fe(ce=>J.call(ne,ce))));return ue(le,te)}}F.any=Z;function k(Q,J,ne,te){let le=ne;return H(Q,fe=>(le=J(le,fe),le),te)}F.reduce=k;function z(Q,J){let ne;const te={onWillAddFirstListener(){ne=Q(le.fire,le)},onDidRemoveLastListener(){ne?.dispose()}};J||R(te);const le=new l(te);return J?.add(le),le.event}function ue(Q,J){return J instanceof Array?J.push(Q):J&&J.add(Q),Q}function oe(Q,J,ne=100,te=!1,le=!1,fe,ce){let de,me,Pe,De=0,ke;const Ne={leakWarningThreshold:fe,onWillAddFirstListener(){de=Q(Ve=>{De++,me=J(me,Ve),te&&!Pe&&(Te.fire(me),me=void 0),ke=()=>{const We=me;me=void 0,Pe=void 0,(!te||De>1)&&Te.fire(We),De=0},typeof ne=="number"?(clearTimeout(Pe),Pe=setTimeout(ke,ne)):Pe===void 0&&(Pe=0,queueMicrotask(ke))})},onWillRemoveListener(){le&&De>0&&ke?.()},onDidRemoveLastListener(){ke=void 0,de.dispose()}};ce||R(Ne);const Te=new l(Ne);return ce?.add(Te),Te.event}F.debounce=oe;function r(Q,J=0,ne){return F.debounce(Q,(te,le)=>te?(te.push(le),te):[le],J,void 0,!0,void 0,ne)}F.accumulate=r;function $e(Q,J=(te,le)=>te===le,ne){let te=!0,le;return _(Q,fe=>{const ce=te||!J(fe,le);return te=!1,le=fe,ce},ne)}F.latch=$e;function ve(Q,J,ne){return[F.filter(Q,J,ne),F.filter(Q,te=>!J(te),ne)]}F.split=ve;function Le(Q,J=!1,ne=[],te){let le=ne.slice(),fe=Q(me=>{le?le.push(me):de.fire(me)});te&&te.add(fe);const ce=()=>{le?.forEach(me=>de.fire(me)),le=null},de=new l({onWillAddFirstListener(){fe||(fe=Q(me=>de.fire(me)),te&&te.add(fe))},onDidAddFirstListener(){le&&(J?setTimeout(ce):ce())},onDidRemoveLastListener(){fe&&fe.dispose(),fe=null}});return te&&te.add(de),de.event}F.buffer=Le;function Fe(Q,J){return(te,le,fe)=>{const ce=J(new xe);return Q(function(de){const me=ce.evaluate(de);me!==pe&&te.call(le,me)},void 0,fe)}}F.chain=Fe;const pe=Symbol("HaltChainable");class xe{constructor(){this.f=[]}map(J){return this.f.push(J),this}forEach(J){return this.f.push(ne=>(J(ne),ne)),this}filter(J){return this.f.push(ne=>J(ne)?ne:pe),this}reduce(J,ne){let te=ne;return this.f.push(le=>(te=J(te,le),te)),this}latch(J=(ne,te)=>ne===te){let ne=!0,te;return this.f.push(le=>{const fe=ne||!J(le,te);return ne=!1,te=le,fe?le:pe}),this}evaluate(J){for(const ne of this.f)if(J=ne(J),J===pe)break;return J}}function Ie(Q,J,ne=te=>te){const te=(...de)=>ce.fire(ne(...de)),le=()=>Q.on(J,te),fe=()=>Q.removeListener(J,te),ce=new l({onWillAddFirstListener:le,onDidRemoveLastListener:fe});return ce.event}F.fromNodeEventEmitter=Ie;function Ae(Q,J,ne=te=>te){const te=(...de)=>ce.fire(ne(...de)),le=()=>Q.addEventListener(J,te),fe=()=>Q.removeEventListener(J,te),ce=new l({onWillAddFirstListener:le,onDidRemoveLastListener:fe});return ce.event}F.fromDOMEventEmitter=Ae;function ye(Q){return new Promise(J=>I(Q)(J))}F.toPromise=ye;function O(Q){const J=new l;return Q.then(ne=>{J.fire(ne)},()=>{J.fire(void 0)}).finally(()=>{J.dispose()}),J.event}F.fromPromise=O;function C(Q,J,ne){return J(ne),Q(te=>J(te))}F.runAndSubscribe=C;class W{constructor(J,ne){this._observable=J,this.f=0,this.g=!1;const te={onWillAddFirstListener:()=>{J.addObserver(this)},onDidRemoveLastListener:()=>{J.removeObserver(this)}};ne||R(te),this.emitter=new l(te),ne&&ne.add(this.emitter)}beginUpdate(J){this.f++}handlePossibleChange(J){}handleChange(J,ne){this.g=!0}endUpdate(J){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function Y(Q,J){return new W(Q,J).emitter.event}F.fromObservable=Y;function ee(Q){return(J,ne,te)=>{let le=0,fe=!1;const ce={beginUpdate(){le++},endUpdate(){le--,le===0&&(Q.reportChanges(),fe&&(fe=!1,J.call(ne)))},handlePossibleChange(){},handleChange(){fe=!0}};Q.addObserver(ce),Q.reportChanges();const de={dispose(){Q.removeObserver(ce)}};return te instanceof y.$Tc?te.add(de):Array.isArray(te)&&te.push(de),de}}F.fromObservableLight=ee})(g||(t.Event=g={}));class B{static{this.all=new Set}static{this.f=0}constructor(R){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${R}_${B.f++}`,B.all.add(this)}start(R){this.g=new p.$3d,this.listenerCount=R}stop(){if(this.g){const R=this.g.elapsed();this.durations.push(R),this.elapsedOverall+=R,this.invocationCount+=1,this.g=void 0}}}t.$5d=B;let d=-1;function m(F){const R=d;return d=F,{dispose(){d=R}}}class e{constructor(R,x=Math.random().toString(18).slice(2,5)){this.threshold=R,this.name=x,this.g=0}dispose(){this.f?.clear()}check(R,x){const I=this.threshold;if(I<=0||x<I)return;this.f||(this.f=new Map);const H=this.f.get(R.value)||0;if(this.f.set(R.value,H+1),this.g-=1,this.g<=0){this.g=I*.5;let K,_=0;for(const[X,Z]of this.f)(!K||_<Z)&&(K=X,_=Z);console.warn(`[${this.name}] potential listener LEAK detected, having ${x} listeners already. MOST frequent listener (${_}):`),console.warn(K)}return()=>{const K=this.f.get(R.value)||0;this.f.set(R.value,K-1)}}}class v{static create(){return new v(new Error().stack??"")}constructor(R){this.value=R}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let j=0;class L{constructor(R){this.value=R,this.id=j++}}const $=2,b=(F,R)=>{if(F instanceof L)R(F);else for(let x=0;x<F.length;x++){const I=F[x];I&&R(I)}},u=h?new FinalizationRegistry(F=>{typeof F=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(F))}):void 0;class l{constructor(R){this.w=0,this.f=R,this.g=d>0||this.f?.leakWarningThreshold?new e(this.f?.leakWarningThreshold??d):void 0,this.j=this.f?._profName?new B(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(o){const R=this.t;queueMicrotask(()=>{b(R,x=>x.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(R,x,I)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),y.$Uc.None;if(this.m)return y.$Uc.None;x&&(R=R.bind(x));const H=new L(R);let K,_;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(H.stack=v.create(),K=this.g.check(H.stack,this.w+1)),o&&(H.stack=_??v.create()),this.t?this.t instanceof L?(this.u??=new s,this.t=[this.t,H]):this.t.push(H):(this.f?.onWillAddFirstListener?.(this),this.t=H,this.f?.onDidAddFirstListener?.(this)),this.w++;const X=(0,y.$Sc)(()=>{u?.unregister(X),K?.(),this.x(H)});if(I instanceof y.$Tc?I.add(X):Array.isArray(I)&&I.push(X),u){const Z=new Error().stack.split(`
`).slice(2).join(`
`).trim();u.register(X,Z,X)}return X},this.q}x(R){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const x=this.t,I=x.indexOf(R);if(I===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,x[I]=void 0;const H=this.u.current===this;if(this.w*$<=x.length){let K=0;for(let _=0;_<x.length;_++)x[_]?x[K++]=x[_]:H&&(this.u.end--,K<this.u.i&&this.u.i--);x.length=K}}y(R,x){if(!R)return;const I=this.f?.onListenerError||i.$1;if(!I){R.value(x);return}try{R.value(x)}catch(H){I(H)}}z(R){const x=R.current.t;for(;R.i<R.end;)this.y(x[R.i++],R.value);R.reset()}fire(R){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof L)this.y(this.t,R);else{const x=this.u;x.enqueue(this,R,this.t.length),this.z(x)}this.j?.stop()}hasListeners(){return this.w>0}}t.$7d=l;const n=()=>new s;t.$8d=n;class s{constructor(){this.i=-1,this.end=0}enqueue(R,x,I){this.i=0,this.end=I,this.current=R,this.value=x}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class N extends l{async fireAsync(R,x,I){if(this.t)for(this.h||(this.h=new f.$5c),b(this.t,H=>this.h.push([H.value,R]));this.h.size>0&&!x.isCancellationRequested;){const[H,K]=this.h.shift(),_=[],X={...K,token:x,waitUntil:Z=>{if(Object.isFrozen(_))throw new Error("waitUntil can NOT be called asynchronous");I&&(Z=I(Z,H)),_.push(Z)}};try{H(X)}catch(Z){(0,i.$1)(Z);continue}Object.freeze(_),await Promise.allSettled(_).then(Z=>{for(const k of Z)k.status==="rejected"&&(0,i.$1)(k.reason)})}}}t.$9d=N;class c extends l{get isPaused(){return this.h!==0}constructor(R){super(R),this.h=0,this.s=new f.$5c,this.A=R?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const R=Array.from(this.s);this.s.clear(),super.fire(this.A(R))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(R){this.w&&(this.h!==0?this.s.push(R):super.fire(R))}}t.$0d=c;class w extends c{constructor(R){super(R),this.k=R.delay??100}fire(R){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(R)}}t.$$d=w;class E extends l{constructor(R){super(R),this.h=[],this.k=R?.merge}fire(R){this.hasListeners()&&(this.h.push(R),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(x=>super.fire(x)),this.h=[]}))}}t.$_d=E;class A{constructor(){this.g=!1,this.h=[],this.f=new l({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(R){const x={event:R,listener:null};this.h.push(x),this.g&&this.m(x);const I=()=>{this.g&&this.o(x);const H=this.h.indexOf(x);this.h.splice(H,1)};return(0,y.$Sc)((0,P.$db)(I))}j(){this.g=!0,this.h.forEach(R=>this.m(R))}k(){this.g=!1,this.h.forEach(R=>this.o(R))}m(R){R.listener=R.event(x=>this.f.fire(x))}o(R){R.listener?.dispose(),R.listener=null}dispose(){this.f.dispose();for(const R of this.h)R.listener?.dispose();this.h=[]}}t.$ae=A;class M{constructor(R,x,I,H){this.f=new y.$Tc;const K=this.f.add(new A),_=this.f.add(new y.$4c);function X(Z){_.set(Z,K.add(H(Z)))}for(const Z of R)X(Z);this.f.add(x(Z=>{X(Z)})),this.f.add(I(Z=>{_.deleteAndDispose(Z)})),this.event=K.event}dispose(){this.f.dispose()}}t.$be=M;class T{constructor(){this.f=[]}wrapEvent(R){return(x,I,H)=>R(K=>{const _=this.f[this.f.length-1];_?_.push(()=>x.call(I,K)):x.call(I,K)},void 0,H)}bufferEvents(R){const x=[];this.f.push(x);const I=R();return this.f.pop(),x.forEach(H=>H()),I}}t.$ce=T;class S{constructor(){this.f=!1,this.g=g.None,this.h=y.$Uc.None,this.j=new l({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(R){this.g=R,this.f&&(this.h.dispose(),this.h=R(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}t.$de=S}),re(ie[24],se([0,1,11]),function(V,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ee=t.CancellationToken=void 0;const P=Object.freeze(function(h,o){const a=setTimeout(h.bind(o),0);return{dispose(){clearTimeout(a)}}});var y;(function(h){function o(a){return a===h.None||a===h.Cancelled||a instanceof f?!0:!a||typeof a!="object"?!1:typeof a.isCancellationRequested=="boolean"&&typeof a.onCancellationRequested=="function"}h.isCancellationToken=o,h.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:i.Event.None}),h.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:P})})(y||(t.CancellationToken=y={}));class f{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?P:(this.b||(this.b=new i.$7d),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class p{constructor(o){this.f=void 0,this.g=void 0,this.g=o&&o.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new f),this.f}cancel(){this.f?this.f instanceof f&&this.f.cancel():this.f=y.Cancelled}dispose(o=!1){o&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof f&&this.f.dispose():this.f=y.None}}t.$ee=p}),re(ie[40],se([0,1,24]),function(V,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Re=t.$Qe=t.$Pe=void 0;class P{constructor(h){this.b=h,this.a=null}get(){if(this.a)return this.a;const h=new i.$ee,o=this.b(h.token);return this.a={promise:o,dispose:()=>{this.a=null,h.cancel(),h.dispose()}},this.a}}t.$Pe=P;class y{constructor(h){this.c=h,this.a=void 0,this.b=void 0}get(h){const o=JSON.stringify(h);return this.b!==o&&(this.b=o,this.a=this.c(h)),this.a}}t.$Qe=y;class f{get cachedValues(){return this.a}constructor(h){this.b=h,this.a=new Map}get(h){if(this.a.has(h))return this.a.get(h);const o=this.b(h);return this.a.set(h,o),o}}t.$Re=f}),re(ie[7],se([0,1,40,39]),function(V,t,i,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Tf=t.$Sf=t.$Rf=t.GraphemeBreakType=t.$Hf=t.$Bf=t.$uf=t.$tf=void 0,t.$Ue=y,t.$Ve=p,t.$We=o,t.$Xe=a,t.$Ye=g,t.$Ze=B,t.$1e=d,t.$2e=m,t.$3e=e,t.$4e=v,t.$5e=j,t.$6e=L,t.$7e=$,t.$8e=b,t.$9e=u,t.$0e=l,t.$$e=n,t.$_e=s,t.$af=N,t.$bf=c,t.$cf=w,t.$df=E,t.$ef=A,t.$ff=M,t.$gf=T,t.$hf=S,t.$if=F,t.$jf=R,t.$kf=x,t.$lf=I,t.$mf=H,t.$nf=K,t.$of=_,t.$pf=X,t.$qf=Z,t.$rf=k,t.$sf=z,t.$vf=$e,t.$wf=ve,t.$xf=Le,t.$yf=Fe,t.$zf=Ie,t.$Af=ye,t.$Cf=O,t.$Df=C,t.$Ef=W,t.$Ff=Y,t.$Gf=J,t.$If=ne,t.$Jf=te,t.$Kf=le,t.$Lf=fe,t.$Mf=ce,t.$Nf=de,t.$Of=me,t.$Pf=Pe,t.$Qf=Ve;function y(D){return!D||typeof D!="string"?!0:D.trim().length===0}const f=/{(\d+)}/g;function p(D,...q){return q.length===0?D:D.replace(f,function(G,U){const ae=parseInt(U,10);return isNaN(ae)||ae<0||ae>=q.length?G:q[ae]})}const h=/{([^}]+)}/g;function o(D,q){return Object.keys(q).length===0?D:D.replace(h,(G,U)=>q[U]??G)}function a(D){return D.replace(/[<>"'&]/g,q=>{switch(q){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return q})}function g(D){return D.replace(/[<>&]/g,function(q){switch(q){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return q}})}function B(D){return D.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function d(D,q){let G=0;const U=q.charCodeAt(0);for(let ae=D.length-1;ae>=0;ae--)D.charCodeAt(ae)===U&&G++;return G}function m(D,q,G="\u2026"){return D.length<=q?D:`${D.substr(0,q)}${G}`}function e(D,q,G="\u2026"){if(D.length<=q)return D;const U=Math.ceil(q/2)-G.length/2,ae=Math.floor(q/2)-G.length/2;return`${D.substr(0,U)}${G}${D.substr(D.length-ae)}`}function v(D,q=" "){const G=j(D,q);return L(G,q)}function j(D,q){if(!D||!q)return D;const G=q.length;if(G===0||D.length===0)return D;let U=0;for(;D.indexOf(q,U)===U;)U=U+G;return D.substring(U)}function L(D,q){if(!D||!q)return D;const G=q.length,U=D.length;if(G===0||U===0)return D;let ae=U,he=-1;for(;he=D.lastIndexOf(q,ae-1),!(he===-1||he+G!==ae);){if(he===0)return"";ae=he}return D.substring(0,ae)}function $(D){return D.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function b(D){return D.replace(/\*/g,"")}function u(D,q,G={}){if(!D)throw new Error("Cannot create regex from empty string");q||(D=B(D)),G.wholeWord&&(/\B/.test(D.charAt(0))||(D="\\b"+D),/\B/.test(D.charAt(D.length-1))||(D=D+"\\b"));let U="";return G.global&&(U+="g"),G.matchCase||(U+="i"),G.multiline&&(U+="m"),G.unicode&&(U+="u"),new RegExp(D,U)}function l(D){return D.source==="^"||D.source==="^$"||D.source==="$"||D.source==="^\\s*$"?!1:!!(D.exec("")&&D.lastIndex===0)}function n(D){return D.split(/\r\n|\r|\n/)}function s(D){const q=[],G=D.split(/(\r\n|\r|\n)/);for(let U=0;U<Math.ceil(G.length/2);U++)q.push(G[2*U]+(G[2*U+1]??""));return q}function N(D){for(let q=0,G=D.length;q<G;q++){const U=D.charCodeAt(q);if(U!==32&&U!==9)return q}return-1}function c(D,q=0,G=D.length){for(let U=q;U<G;U++){const ae=D.charCodeAt(U);if(ae!==32&&ae!==9)return D.substring(q,U)}return D.substring(q,G)}function w(D,q=D.length-1){for(let G=q;G>=0;G--){const U=D.charCodeAt(G);if(U!==32&&U!==9)return G}return-1}function E(D,q,G){const U=[];let ae=0;for(const he of D.matchAll(q)){if(U.push(D.slice(ae,he.index)),he.index===void 0)throw new Error("match.index should be defined");ae=he.index+he[0].length,U.push(G(he[0],...he.slice(1),he.index,D,he.groups))}return U.push(D.slice(ae)),Promise.all(U).then(he=>he.join(""))}function A(D,q){return D<q?-1:D>q?1:0}function M(D,q,G=0,U=D.length,ae=0,he=q.length){for(;G<U&&ae<he;G++,ae++){const Be=D.charCodeAt(G),je=q.charCodeAt(ae);if(Be<je)return-1;if(Be>je)return 1}const be=U-G,Re=he-ae;return be<Re?-1:be>Re?1:0}function T(D,q){return S(D,q,0,D.length,0,q.length)}function S(D,q,G=0,U=D.length,ae=0,he=q.length){for(;G<U&&ae<he;G++,ae++){let Be=D.charCodeAt(G),je=q.charCodeAt(ae);if(Be===je)continue;if(Be>=128||je>=128)return M(D.toLowerCase(),q.toLowerCase(),G,U,ae,he);R(Be)&&(Be-=32),R(je)&&(je-=32);const we=Be-je;if(we!==0)return we}const be=U-G,Re=he-ae;return be<Re?-1:be>Re?1:0}function F(D){return D>=48&&D<=57}function R(D){return D>=97&&D<=122}function x(D){return D>=65&&D<=90}function I(D,q){return D.length===q.length&&S(D,q)===0}function H(D,q){const G=q.length;return q.length>D.length?!1:S(D,q,0,G)===0}function K(D,q){const G=Math.min(D.length,q.length);let U;for(U=0;U<G;U++)if(D.charCodeAt(U)!==q.charCodeAt(U))return U;return G}function _(D,q){const G=Math.min(D.length,q.length);let U;const ae=D.length-1,he=q.length-1;for(U=0;U<G;U++)if(D.charCodeAt(ae-U)!==q.charCodeAt(he-U))return U;return G}function X(D){return 55296<=D&&D<=56319}function Z(D){return 56320<=D&&D<=57343}function k(D,q){return(D-55296<<10)+(q-56320)+65536}function z(D,q,G){const U=D.charCodeAt(G);if(X(U)&&G+1<q){const ae=D.charCodeAt(G+1);if(Z(ae))return k(U,ae)}return U}function ue(D,q){const G=D.charCodeAt(q-1);if(Z(G)&&q>1){const U=D.charCodeAt(q-2);if(X(U))return k(U,G)}return G}class oe{get offset(){return this.e}constructor(q,G=0){this.c=q,this.d=q.length,this.e=G}setOffset(q){this.e=q}prevCodePoint(){const q=ue(this.c,this.e);return this.e-=q>=65536?2:1,q}nextCodePoint(){const q=z(this.c,this.d,this.e);return this.e+=q>=65536?2:1,q}eol(){return this.e>=this.d}}t.$tf=oe;class r{get offset(){return this.c.offset}constructor(q,G=0){this.c=new oe(q,G)}nextGraphemeLength(){const q=Ne.getInstance(),G=this.c,U=G.offset;let ae=q.getGraphemeBreakType(G.nextCodePoint());for(;!G.eol();){const he=G.offset,be=q.getGraphemeBreakType(G.nextCodePoint());if(De(ae,be)){G.setOffset(he);break}ae=be}return G.offset-U}prevGraphemeLength(){const q=Ne.getInstance(),G=this.c,U=G.offset;let ae=q.getGraphemeBreakType(G.prevCodePoint());for(;G.offset>0;){const he=G.offset,be=q.getGraphemeBreakType(G.prevCodePoint());if(De(be,ae)){G.setOffset(he);break}ae=be}return U-G.offset}eol(){return this.c.eol()}}t.$uf=r;function $e(D,q){return new r(D,q).nextGraphemeLength()}function ve(D,q){return new r(D,q).prevGraphemeLength()}function Le(D,q){q>0&&Z(D.charCodeAt(q))&&q--;const G=q+$e(D,q);return[G-ve(D,G),G]}function Fe(D){const q=new r(D);let G=0;for(;!q.eol();)G++,q.nextGraphemeLength();return G}let pe;function xe(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function Ie(D){return pe||(pe=xe()),pe.test(D)}const Ae=/^[\t\n\r\x20-\x7E]*$/;function ye(D){return Ae.test(D)}t.$Bf=/[\u2028\u2029]/;function O(D){return t.$Bf.test(D)}function C(D){return D>=11904&&D<=55215||D>=63744&&D<=64255||D>=65281&&D<=65374}function W(D){return D>=127462&&D<=127487||D===8986||D===8987||D===9200||D===9203||D>=9728&&D<=10175||D===11088||D===11093||D>=127744&&D<=128591||D>=128640&&D<=128764||D>=128992&&D<=129008||D>=129280&&D<=129535||D>=129648&&D<=129782}function Y(D,q,G=""){const U=D.trimStart();if(U.length<q)return U;const ae=/\b/g;let he=0;for(;ae.test(U)&&!(U.length-ae.lastIndex<q);)he=ae.lastIndex,ae.lastIndex+=1;return he===0?U:G+U.substring(he).trimStart()}const ee=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,Q=/\x1b\].*?\x07/g;function J(D){return D&&(D=D.replace(ee,"").replace(Q,"")),D}t.$Hf="\uFEFF";function ne(D){return!!(D&&D.length>0&&D.charCodeAt(0)===65279)}function te(D){return ne(D)?D.substr(1):D}function le(D,q){if(!D||!q||D.length<q.length)return!1;const G=q.length,U=D.toLowerCase();let ae=0,he=-1;for(;ae<G;){const be=U.indexOf(q[ae],he+1);if(be<0)return!1;he=be,ae++}return!0}function fe(D,q=!1){return D?(q&&(D=D.replace(/\\./g,"")),D.toLowerCase()!==D):!1}function ce(D){return D.charAt(0).toUpperCase()+D.slice(1)}function de(D,q=1){if(q===0)return"";let G=-1;do G=D.indexOf(`
`,G+1),q--;while(q>0&&G>=0);return G===-1?D:(D[G-1]==="\r"&&G--,D.substr(0,G))}function me(D){return D=D%(2*26),D<26?String.fromCharCode(97+D):String.fromCharCode(65+D-26)}function Pe(D){return Ne.getInstance().getGraphemeBreakType(D)}function De(D,q){return D===0?q!==5&&q!==7:D===2&&q===3?!1:D===4||D===2||D===3||q===4||q===2||q===3?!0:!(D===8&&(q===8||q===9||q===11||q===12)||(D===11||D===9)&&(q===9||q===10)||(D===12||D===10)&&q===10||q===5||q===13||q===7||D===1||D===13&&q===14||D===6&&q===6)}var ke;(function(D){D[D.Other=0]="Other",D[D.Prepend=1]="Prepend",D[D.CR=2]="CR",D[D.LF=3]="LF",D[D.Control=4]="Control",D[D.Extend=5]="Extend",D[D.Regional_Indicator=6]="Regional_Indicator",D[D.SpacingMark=7]="SpacingMark",D[D.L=8]="L",D[D.V=9]="V",D[D.T=10]="T",D[D.LV=11]="LV",D[D.LVT=12]="LVT",D[D.ZWJ=13]="ZWJ",D[D.Extended_Pictographic=14]="Extended_Pictographic"})(ke||(t.GraphemeBreakType=ke={}));class Ne{static{this.c=null}static getInstance(){return Ne.c||(Ne.c=new Ne),Ne.c}constructor(){this.d=Te()}getGraphemeBreakType(q){if(q<32)return q===10?3:q===13?2:4;if(q<127)return 0;const G=this.d,U=G.length/3;let ae=1;for(;ae<=U;)if(q<G[3*ae])ae=2*ae;else if(q>G[3*ae+1])ae=2*ae+1;else return G[3*ae+2];return 0}}function Te(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ve(D,q){if(D===0)return 0;const G=We(D,q);if(G!==void 0)return G;const U=new oe(q,D);return U.prevCodePoint(),U.offset}function We(D,q){const G=new oe(q,D);let U=G.prevCodePoint();for(;Xe(U)||U===65039||U===8419;){if(G.offset===0)return;U=G.prevCodePoint()}if(!W(U))return;let ae=G.offset;return ae>0&&G.prevCodePoint()===8205&&(ae=G.offset),ae}function Xe(D){return 127995<=D&&D<=127999}var ze;(function(D){D[D.zwj=8205]="zwj",D[D.emojiVariantSelector=65039]="emojiVariantSelector",D[D.enclosingKeyCap=8419]="enclosingKeyCap"})(ze||(ze={})),t.$Rf="\xA0";class Se{static{this.c=new P.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new i.$Qe(q=>{function G(we){const Me=new Map;for(let Ee=0;Ee<we.length;Ee+=2)Me.set(we[Ee],we[Ee+1]);return Me}function U(we,Me){const Ee=new Map(we);for(const[Oe,Ce]of Me)Ee.set(Oe,Ce);return Ee}function ae(we,Me){if(!we)return Me;const Ee=new Map;for(const[Oe,Ce]of we)Me.has(Oe)&&Ee.set(Oe,Ce);return Ee}const he=this.c.value;let be=q.filter(we=>!we.startsWith("_")&&we in he);be.length===0&&(be=["_default"]);let Re;for(const we of be){const Me=G(he[we]);Re=ae(Re,Me)}const Be=G(he._common),je=U(Be,Re);return new Se(je)})}static getInstance(q){return Se.d.get(Array.from(q))}static{this.e=new P.$V(()=>Object.keys(Se.c.value).filter(q=>!q.startsWith("_")))}static getLocales(){return Se.e.value}constructor(q){this.f=q}isAmbiguous(q){return this.f.has(q)}getPrimaryConfusable(q){return this.f.get(q)}getConfusableCodePoints(){return new Set(this.f.keys())}}t.$Sf=Se;class qe{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(qe.c())),this.d}static isInvisibleCharacter(q){return qe.e().has(q)}static get codePoints(){return qe.e()}}t.$Tf=qe}),re(ie[41],se([0,1,7]),function(V,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bj=t.$_i=void 0,t.$8i=P,t.$9i=y,t.$0i=f,t.$$i=h,t.$aj=v;function P(L){return y(L,0)}function y(L,$){switch(typeof L){case"object":return L===null?f(349,$):Array.isArray(L)?o(L,$):a(L,$);case"string":return h(L,$);case"boolean":return p(L,$);case"number":return f(L,$);case"undefined":return f(937,$);default:return f(617,$)}}function f(L,$){return($<<5)-$+L|0}function p(L,$){return f(L?433:863,$)}function h(L,$){$=f(149417,$);for(let b=0,u=L.length;b<u;b++)$=f(L.charCodeAt(b),$);return $}function o(L,$){return $=f(104579,$),L.reduce((b,u)=>y(u,b),$)}function a(L,$){return $=f(181387,$),Object.keys(L).sort().reduce((b,u)=>(b=h(u,b),y(L[u],b)),$)}class g{constructor(){this.g=0}get value(){return this.g}hash($){return this.g=y($,this.g),this.g}}t.$_i=g;var B;(function(L){L[L.BLOCK_SIZE=64]="BLOCK_SIZE",L[L.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(B||(B={}));function d(L,$,b=32){const u=b-$,l=~((1<<u)-1);return(L<<$|(l&L)>>>u)>>>0}function m(L,$=0,b=L.byteLength,u=0){for(let l=0;l<b;l++)L[$+l]=u}function e(L,$,b="0"){for(;L.length<$;)L=b+L;return L}function v(L,$=32){return L instanceof ArrayBuffer?Array.from(new Uint8Array(L)).map(b=>b.toString(16).padStart(2,"0")).join(""):e((L>>>0).toString(16),$/4)}class j{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update($){const b=$.length;if(b===0)return;const u=this.p;let l=this.r,n=this.u,s,N;for(n!==0?(s=n,N=-1,n=0):(s=$.charCodeAt(0),N=0);;){let c=s;if(i.$pf(s))if(N+1<b){const w=$.charCodeAt(N+1);i.$qf(w)?(N++,c=i.$rf(s,w)):c=65533}else{n=s;break}else i.$qf(s)&&(c=65533);if(l=this.w(u,l,c),N++,N<b)s=$.charCodeAt(N);else break}this.r=l,this.u=n}w($,b,u){return u<128?$[b++]=u:u<2048?($[b++]=192|(u&1984)>>>6,$[b++]=128|(u&63)>>>0):u<65536?($[b++]=224|(u&61440)>>>12,$[b++]=128|(u&4032)>>>6,$[b++]=128|(u&63)>>>0):($[b++]=240|(u&1835008)>>>18,$[b++]=128|(u&258048)>>>12,$[b++]=128|(u&4032)>>>6,$[b++]=128|(u&63)>>>0),b>=64&&(this.y(),b-=64,this.t+=64,$[0]=$[64],$[1]=$[65],$[2]=$[66]),b}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),v(this.h)+v(this.l)+v(this.m)+v(this.n)+v(this.o)}x(){this.p[this.r++]=128,m(this.p,this.r),this.r>56&&(this.y(),m(this.p));const $=8*this.t;this.q.setUint32(56,Math.floor($/4294967296),!1),this.q.setUint32(60,$%4294967296,!1),this.y()}y(){const $=j.g,b=this.q;for(let A=0;A<64;A+=4)$.setUint32(A,b.getUint32(A,!1),!1);for(let A=64;A<320;A+=4)$.setUint32(A,d($.getUint32(A-12,!1)^$.getUint32(A-32,!1)^$.getUint32(A-56,!1)^$.getUint32(A-64,!1),1),!1);let u=this.h,l=this.l,n=this.m,s=this.n,N=this.o,c,w,E;for(let A=0;A<80;A++)A<20?(c=l&n|~l&s,w=1518500249):A<40?(c=l^n^s,w=1859775393):A<60?(c=l&n|l&s|n&s,w=2400959708):(c=l^n^s,w=3395469782),E=d(u,5)+c+N+w+$.getUint32(A*4,!1)&4294967295,N=s,s=n,n=d(l,30),l=u,u=E;this.h=this.h+u&4294967295,this.l=this.l+l&4294967295,this.m=this.m+n&4294967295,this.n=this.n+s&4294967295,this.o=this.o+N&4294967295}}t.$bj=j}),re(ie[25],se([0,1,37,41]),function(V,t,i,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ht=t.$ft=void 0,t.$gt=f;class y{constructor(d){this.a=d}getElements(){const d=this.a,m=new Int32Array(d.length);for(let e=0,v=d.length;e<v;e++)m[e]=d.charCodeAt(e);return m}}t.$ft=y;function f(B,d,m){return new g(new y(B),new y(d)).ComputeDiff(m).changes}class p{static Assert(d,m){if(!d)throw new Error(m)}}class h{static Copy(d,m,e,v,j){for(let L=0;L<j;L++)e[v+L]=d[m+L]}static Copy2(d,m,e,v,j){for(let L=0;L<j;L++)e[v+L]=d[m+L]}}var o;(function(B){B[B.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(o||(o={}));class a{constructor(){this.a=[],this.b=1073741824,this.c=1073741824,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new i.$et(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=1073741824,this.c=1073741824}AddOriginalElement(d,m){this.b=Math.min(this.b,d),this.c=Math.min(this.c,m),this.d++}AddModifiedElement(d,m){this.b=Math.min(this.b,d),this.c=Math.min(this.c,m),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class g{constructor(d,m,e=null){this.a=e,this.b=d,this.c=m;const[v,j,L]=g.o(d),[$,b,u]=g.o(m);this.d=L&&u,this.e=v,this.f=j,this.g=$,this.h=b,this.k=[],this.m=[]}static n(d){return d.length>0&&typeof d[0]=="string"}static o(d){const m=d.getElements();if(g.n(m)){const e=new Int32Array(m.length);for(let v=0,j=m.length;v<j;v++)e[v]=(0,P.$$i)(m[v],0);return[m,e,!0]}return m instanceof Int32Array?[[],m,!1]:[[],new Int32Array(m),!1]}p(d,m){return this.f[d]!==this.h[m]?!1:this.d?this.e[d]===this.g[m]:!0}q(d,m){if(!this.p(d,m))return!1;const e=g.r(this.b,d),v=g.r(this.c,m);return e===v}static r(d,m){return typeof d.getStrictElement=="function"?d.getStrictElement(m):null}s(d,m){return this.f[d]!==this.f[m]?!1:this.d?this.e[d]===this.e[m]:!0}u(d,m){return this.h[d]!==this.h[m]?!1:this.d?this.g[d]===this.g[m]:!0}ComputeDiff(d){return this.v(0,this.f.length-1,0,this.h.length-1,d)}v(d,m,e,v,j){const L=[!1];let $=this.w(d,m,e,v,L);return j&&($=this.z($)),{quitEarly:L[0],changes:$}}w(d,m,e,v,j){for(j[0]=!1;d<=m&&e<=v&&this.p(d,e);)d++,e++;for(;m>=d&&v>=e&&this.p(m,v);)m--,v--;if(d>m||e>v){let n;return e<=v?(p.Assert(d===m+1,"originalStart should only be one more than originalEnd"),n=[new i.$et(d,0,e,v-e+1)]):d<=m?(p.Assert(e===v+1,"modifiedStart should only be one more than modifiedEnd"),n=[new i.$et(d,m-d+1,e,0)]):(p.Assert(d===m+1,"originalStart should only be one more than originalEnd"),p.Assert(e===v+1,"modifiedStart should only be one more than modifiedEnd"),n=[]),n}const L=[0],$=[0],b=this.y(d,m,e,v,L,$,j),u=L[0],l=$[0];if(b!==null)return b;if(!j[0]){const n=this.w(d,u,e,l,j);let s=[];return j[0]?s=[new i.$et(u+1,m-(u+1)+1,l+1,v-(l+1)+1)]:s=this.w(u+1,m,l+1,v,j),this.H(n,s)}return[new i.$et(d,m-d+1,e,v-e+1)]}x(d,m,e,v,j,L,$,b,u,l,n,s,N,c,w,E,A,M){let T=null,S=null,F=new a,R=m,x=e,I=N[0]-E[0]-v,H=-1073741824,K=this.k.length-1;do{const _=I+d;_===R||_<x&&u[_-1]<u[_+1]?(n=u[_+1],c=n-I-v,n<H&&F.MarkNextChange(),H=n,F.AddModifiedElement(n+1,c),I=_+1-d):(n=u[_-1]+1,c=n-I-v,n<H&&F.MarkNextChange(),H=n-1,F.AddOriginalElement(n,c+1),I=_-1-d),K>=0&&(u=this.k[K],d=u[0],R=1,x=u.length-1)}while(--K>=-1);if(T=F.getReverseChanges(),M[0]){let _=N[0]+1,X=E[0]+1;if(T!==null&&T.length>0){const Z=T[T.length-1];_=Math.max(_,Z.getOriginalEnd()),X=Math.max(X,Z.getModifiedEnd())}S=[new i.$et(_,s-_+1,X,w-X+1)]}else{F=new a,R=L,x=$,I=N[0]-E[0]-b,H=1073741824,K=A?this.m.length-1:this.m.length-2;do{const _=I+j;_===R||_<x&&l[_-1]>=l[_+1]?(n=l[_+1]-1,c=n-I-b,n>H&&F.MarkNextChange(),H=n+1,F.AddOriginalElement(n+1,c+1),I=_+1-j):(n=l[_-1],c=n-I-b,n>H&&F.MarkNextChange(),H=n,F.AddModifiedElement(n+1,c+1),I=_-1-j),K>=0&&(l=this.m[K],j=l[0],R=1,x=l.length-1)}while(--K>=-1);S=F.getChanges()}return this.H(T,S)}y(d,m,e,v,j,L,$){let b=0,u=0,l=0,n=0,s=0,N=0;d--,e--,j[0]=0,L[0]=0,this.k=[],this.m=[];const c=m-d+(v-e),w=c+1,E=new Int32Array(w),A=new Int32Array(w),M=v-e,T=m-d,S=d-e,F=m-v,x=(T-M)%2===0;E[M]=d,A[T]=m,$[0]=!1;for(let I=1;I<=c/2+1;I++){let H=0,K=0;l=this.J(M-I,I,M,w),n=this.J(M+I,I,M,w);for(let X=l;X<=n;X+=2){X===l||X<n&&E[X-1]<E[X+1]?b=E[X+1]:b=E[X-1]+1,u=b-(X-M)-S;const Z=b;for(;b<m&&u<v&&this.p(b+1,u+1);)b++,u++;if(E[X]=b,b+u>H+K&&(H=b,K=u),!x&&Math.abs(X-T)<=I-1&&b>=A[X])return j[0]=b,L[0]=u,Z<=A[X]&&1447>0&&I<=1448?this.x(M,l,n,S,T,s,N,F,E,A,b,m,j,u,v,L,x,$):null}const _=(H-d+(K-e)-I)/2;if(this.a!==null&&!this.a(H,_))return $[0]=!0,j[0]=H,L[0]=K,_>0&&1447>0&&I<=1448?this.x(M,l,n,S,T,s,N,F,E,A,b,m,j,u,v,L,x,$):(d++,e++,[new i.$et(d,m-d+1,e,v-e+1)]);s=this.J(T-I,I,T,w),N=this.J(T+I,I,T,w);for(let X=s;X<=N;X+=2){X===s||X<N&&A[X-1]>=A[X+1]?b=A[X+1]-1:b=A[X-1],u=b-(X-T)-F;const Z=b;for(;b>d&&u>e&&this.p(b,u);)b--,u--;if(A[X]=b,x&&Math.abs(X-M)<=I&&b<=E[X])return j[0]=b,L[0]=u,Z>=E[X]&&1447>0&&I<=1448?this.x(M,l,n,S,T,s,N,F,E,A,b,m,j,u,v,L,x,$):null}if(I<=1447){let X=new Int32Array(n-l+2);X[0]=M-l+1,h.Copy2(E,l,X,1,n-l+1),this.k.push(X),X=new Int32Array(N-s+2),X[0]=T-s+1,h.Copy2(A,s,X,1,N-s+1),this.m.push(X)}}return this.x(M,l,n,S,T,s,N,F,E,A,b,m,j,u,v,L,x,$)}z(d){for(let m=0;m<d.length;m++){const e=d[m],v=m<d.length-1?d[m+1].originalStart:this.f.length,j=m<d.length-1?d[m+1].modifiedStart:this.h.length,L=e.originalLength>0,$=e.modifiedLength>0;for(;e.originalStart+e.originalLength<v&&e.modifiedStart+e.modifiedLength<j&&(!L||this.s(e.originalStart,e.originalStart+e.originalLength))&&(!$||this.u(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const u=this.q(e.originalStart,e.modifiedStart);if(this.q(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!u)break;e.originalStart++,e.modifiedStart++}const b=[null];if(m<d.length-1&&this.I(d[m],d[m+1],b)){d[m]=b[0],d.splice(m+1,1),m--;continue}}for(let m=d.length-1;m>=0;m--){const e=d[m];let v=0,j=0;if(m>0){const n=d[m-1];v=n.originalStart+n.originalLength,j=n.modifiedStart+n.modifiedLength}const L=e.originalLength>0,$=e.modifiedLength>0;let b=0,u=this.G(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let n=1;;n++){const s=e.originalStart-n,N=e.modifiedStart-n;if(s<v||N<j||L&&!this.s(s,s+e.originalLength)||$&&!this.u(N,N+e.modifiedLength))break;const w=(s===v&&N===j?5:0)+this.G(s,e.originalLength,N,e.modifiedLength);w>u&&(u=w,b=n)}e.originalStart-=b,e.modifiedStart-=b;const l=[null];if(m>0&&this.I(d[m-1],d[m],l)){d[m-1]=l[0],d.splice(m,1),m++;continue}}if(this.d)for(let m=1,e=d.length;m<e;m++){const v=d[m-1],j=d[m],L=j.originalStart-v.originalStart-v.originalLength,$=v.originalStart,b=j.originalStart+j.originalLength,u=b-$,l=v.modifiedStart,n=j.modifiedStart+j.modifiedLength,s=n-l;if(L<5&&u<20&&s<20){const N=this.A($,u,l,s,L);if(N){const[c,w]=N;(c!==v.originalStart+v.originalLength||w!==v.modifiedStart+v.modifiedLength)&&(v.originalLength=c-v.originalStart,v.modifiedLength=w-v.modifiedStart,j.originalStart=c+L,j.modifiedStart=w+L,j.originalLength=b-j.originalStart,j.modifiedLength=n-j.modifiedStart)}}}return d}A(d,m,e,v,j){if(m<j||v<j)return null;const L=d+m-j+1,$=e+v-j+1;let b=0,u=0,l=0;for(let n=d;n<L;n++)for(let s=e;s<$;s++){const N=this.B(n,s,j);N>0&&N>b&&(b=N,u=n,l=s)}return b>0?[u,l]:null}B(d,m,e){let v=0;for(let j=0;j<e;j++){if(!this.p(d+j,m+j))return 0;v+=this.e[d+j].length}return v}C(d){return d<=0||d>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[d])}D(d,m){if(this.C(d)||this.C(d-1))return!0;if(m>0){const e=d+m;if(this.C(e-1)||this.C(e))return!0}return!1}E(d){return d<=0||d>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[d])}F(d,m){if(this.E(d)||this.E(d-1))return!0;if(m>0){const e=d+m;if(this.E(e-1)||this.E(e))return!0}return!1}G(d,m,e,v){const j=this.D(d,m)?1:0,L=this.F(e,v)?1:0;return j+L}H(d,m){const e=[];if(d.length===0||m.length===0)return m.length>0?m:d;if(this.I(d[d.length-1],m[0],e)){const v=new Array(d.length+m.length-1);return h.Copy(d,0,v,0,d.length-1),v[d.length-1]=e[0],h.Copy(m,1,v,d.length,m.length-1),v}else{const v=new Array(d.length+m.length);return h.Copy(d,0,v,0,d.length),h.Copy(m,0,v,d.length,m.length),v}}I(d,m,e){if(p.Assert(d.originalStart<=m.originalStart,"Left change is not less than or equal to right change"),p.Assert(d.modifiedStart<=m.modifiedStart,"Left change is not less than or equal to right change"),d.originalStart+d.originalLength>=m.originalStart||d.modifiedStart+d.modifiedLength>=m.modifiedStart){const v=d.originalStart;let j=d.originalLength;const L=d.modifiedStart;let $=d.modifiedLength;return d.originalStart+d.originalLength>=m.originalStart&&(j=m.originalStart+m.originalLength-d.originalStart),d.modifiedStart+d.modifiedLength>=m.modifiedStart&&($=m.modifiedStart+m.modifiedLength-d.modifiedStart),e[0]=new i.$et(v,j,L,$),!0}else return e[0]=null,!1}J(d,m,e,v){if(d>=0&&d<v)return d;const j=e,L=v-e-1,$=m%2===0;if(d<0){const b=j%2===0;return $===b?0:1}else{const b=L%2===0;return $===b?v-1:v-2}}}t.$ht=g}),re(ie[26],se([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Uf=i,t.$Vf=P,t.$Wf=y,t.$Xf=f,t.$Yf=p,t.$Zf=h,t.$1f=o,t.$2f=a,t.$3f=g,t.$4f=B,t.$5f=d,t.$6f=m,t.$7f=e,t.$8f=j,t.$9f=L,t.$0f=$,t.$$f=b,t.$_f=u;function i(l){return typeof l=="string"}function P(l){return Array.isArray(l)&&l.every(n=>i(n))}function y(l){return typeof l=="object"&&l!==null&&!Array.isArray(l)&&!(l instanceof RegExp)&&!(l instanceof Date)}function f(l){const n=Object.getPrototypeOf(Uint8Array);return typeof l=="object"&&l instanceof n}function p(l){return typeof l=="number"&&!isNaN(l)}function h(l){return!!l&&typeof l[Symbol.iterator]=="function"}function o(l){return l===!0||l===!1}function a(l){return typeof l>"u"}function g(l){return!B(l)}function B(l){return a(l)||l===null}function d(l,n){if(!l)throw new Error(n?`Unexpected type, expected '${n}'`:"Unexpected type")}function m(l){if(B(l))throw new Error("Assertion Failed: argument is undefined or null");return l}function e(...l){const n=[];for(let s=0;s<l.length;s++){const N=l[s];if(B(N))throw new Error(`Assertion Failed: argument at index ${s} is undefined or null`);n.push(N)}return n}const v=Object.prototype.hasOwnProperty;function j(l){if(!y(l))return!1;for(const n in l)if(v.call(l,n))return!1;return!0}function L(l){return typeof l=="function"}function $(...l){return l.length>0&&l.every(L)}function b(l,n){const s=Math.min(l.length,n.length);for(let N=0;N<s;N++)u(l[N],n[N])}function u(l,n){if(i(n)){if(typeof l!==n)throw new Error(`argument does not match constraint: typeof ${n}`)}else if(L(n)){try{if(l instanceof n)return}catch{}if(!B(l)&&l.constructor===n||n.length===1&&n.call(void 0,l)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),re(ie[27],se([0,1,26]),function(V,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Bj=y,t.$Cj=f;const P=Object.create(null);function y(p,h){if((0,i.$Uf)(h)){const o=P[h];if(o===void 0)throw new Error(`${p} references an unknown codicon: ${h}`);h=o}return P[p]=h,{id:p}}function f(){return P}}),re(ie[42],se([0,1,27]),function(V,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Dj=void 0,t.$Dj={add:(0,i.$Bj)("add",6e4),plus:(0,i.$Bj)("plus",6e4),gistNew:(0,i.$Bj)("gist-new",6e4),repoCreate:(0,i.$Bj)("repo-create",6e4),lightbulb:(0,i.$Bj)("lightbulb",60001),lightBulb:(0,i.$Bj)("light-bulb",60001),repo:(0,i.$Bj)("repo",60002),repoDelete:(0,i.$Bj)("repo-delete",60002),gistFork:(0,i.$Bj)("gist-fork",60003),repoForked:(0,i.$Bj)("repo-forked",60003),gitPullRequest:(0,i.$Bj)("git-pull-request",60004),gitPullRequestAbandoned:(0,i.$Bj)("git-pull-request-abandoned",60004),recordKeys:(0,i.$Bj)("record-keys",60005),keyboard:(0,i.$Bj)("keyboard",60005),tag:(0,i.$Bj)("tag",60006),gitPullRequestLabel:(0,i.$Bj)("git-pull-request-label",60006),tagAdd:(0,i.$Bj)("tag-add",60006),tagRemove:(0,i.$Bj)("tag-remove",60006),person:(0,i.$Bj)("person",60007),personFollow:(0,i.$Bj)("person-follow",60007),personOutline:(0,i.$Bj)("person-outline",60007),personFilled:(0,i.$Bj)("person-filled",60007),gitBranch:(0,i.$Bj)("git-branch",60008),gitBranchCreate:(0,i.$Bj)("git-branch-create",60008),gitBranchDelete:(0,i.$Bj)("git-branch-delete",60008),sourceControl:(0,i.$Bj)("source-control",60008),mirror:(0,i.$Bj)("mirror",60009),mirrorPublic:(0,i.$Bj)("mirror-public",60009),star:(0,i.$Bj)("star",60010),starAdd:(0,i.$Bj)("star-add",60010),starDelete:(0,i.$Bj)("star-delete",60010),starEmpty:(0,i.$Bj)("star-empty",60010),comment:(0,i.$Bj)("comment",60011),commentAdd:(0,i.$Bj)("comment-add",60011),alert:(0,i.$Bj)("alert",60012),warning:(0,i.$Bj)("warning",60012),search:(0,i.$Bj)("search",60013),searchSave:(0,i.$Bj)("search-save",60013),logOut:(0,i.$Bj)("log-out",60014),signOut:(0,i.$Bj)("sign-out",60014),logIn:(0,i.$Bj)("log-in",60015),signIn:(0,i.$Bj)("sign-in",60015),eye:(0,i.$Bj)("eye",60016),eyeUnwatch:(0,i.$Bj)("eye-unwatch",60016),eyeWatch:(0,i.$Bj)("eye-watch",60016),circleFilled:(0,i.$Bj)("circle-filled",60017),primitiveDot:(0,i.$Bj)("primitive-dot",60017),closeDirty:(0,i.$Bj)("close-dirty",60017),debugBreakpoint:(0,i.$Bj)("debug-breakpoint",60017),debugBreakpointDisabled:(0,i.$Bj)("debug-breakpoint-disabled",60017),debugHint:(0,i.$Bj)("debug-hint",60017),terminalDecorationSuccess:(0,i.$Bj)("terminal-decoration-success",60017),primitiveSquare:(0,i.$Bj)("primitive-square",60018),edit:(0,i.$Bj)("edit",60019),pencil:(0,i.$Bj)("pencil",60019),info:(0,i.$Bj)("info",60020),issueOpened:(0,i.$Bj)("issue-opened",60020),gistPrivate:(0,i.$Bj)("gist-private",60021),gitForkPrivate:(0,i.$Bj)("git-fork-private",60021),lock:(0,i.$Bj)("lock",60021),mirrorPrivate:(0,i.$Bj)("mirror-private",60021),close:(0,i.$Bj)("close",60022),removeClose:(0,i.$Bj)("remove-close",60022),x:(0,i.$Bj)("x",60022),repoSync:(0,i.$Bj)("repo-sync",60023),sync:(0,i.$Bj)("sync",60023),clone:(0,i.$Bj)("clone",60024),desktopDownload:(0,i.$Bj)("desktop-download",60024),beaker:(0,i.$Bj)("beaker",60025),microscope:(0,i.$Bj)("microscope",60025),vm:(0,i.$Bj)("vm",60026),deviceDesktop:(0,i.$Bj)("device-desktop",60026),file:(0,i.$Bj)("file",60027),fileText:(0,i.$Bj)("file-text",60027),more:(0,i.$Bj)("more",60028),ellipsis:(0,i.$Bj)("ellipsis",60028),kebabHorizontal:(0,i.$Bj)("kebab-horizontal",60028),mailReply:(0,i.$Bj)("mail-reply",60029),reply:(0,i.$Bj)("reply",60029),organization:(0,i.$Bj)("organization",60030),organizationFilled:(0,i.$Bj)("organization-filled",60030),organizationOutline:(0,i.$Bj)("organization-outline",60030),newFile:(0,i.$Bj)("new-file",60031),fileAdd:(0,i.$Bj)("file-add",60031),newFolder:(0,i.$Bj)("new-folder",60032),fileDirectoryCreate:(0,i.$Bj)("file-directory-create",60032),trash:(0,i.$Bj)("trash",60033),trashcan:(0,i.$Bj)("trashcan",60033),history:(0,i.$Bj)("history",60034),clock:(0,i.$Bj)("clock",60034),folder:(0,i.$Bj)("folder",60035),fileDirectory:(0,i.$Bj)("file-directory",60035),symbolFolder:(0,i.$Bj)("symbol-folder",60035),logoGithub:(0,i.$Bj)("logo-github",60036),markGithub:(0,i.$Bj)("mark-github",60036),github:(0,i.$Bj)("github",60036),terminal:(0,i.$Bj)("terminal",60037),console:(0,i.$Bj)("console",60037),repl:(0,i.$Bj)("repl",60037),zap:(0,i.$Bj)("zap",60038),symbolEvent:(0,i.$Bj)("symbol-event",60038),error:(0,i.$Bj)("error",60039),stop:(0,i.$Bj)("stop",60039),variable:(0,i.$Bj)("variable",60040),symbolVariable:(0,i.$Bj)("symbol-variable",60040),array:(0,i.$Bj)("array",60042),symbolArray:(0,i.$Bj)("symbol-array",60042),symbolModule:(0,i.$Bj)("symbol-module",60043),symbolPackage:(0,i.$Bj)("symbol-package",60043),symbolNamespace:(0,i.$Bj)("symbol-namespace",60043),symbolObject:(0,i.$Bj)("symbol-object",60043),symbolMethod:(0,i.$Bj)("symbol-method",60044),symbolFunction:(0,i.$Bj)("symbol-function",60044),symbolConstructor:(0,i.$Bj)("symbol-constructor",60044),symbolBoolean:(0,i.$Bj)("symbol-boolean",60047),symbolNull:(0,i.$Bj)("symbol-null",60047),symbolNumeric:(0,i.$Bj)("symbol-numeric",60048),symbolNumber:(0,i.$Bj)("symbol-number",60048),symbolStructure:(0,i.$Bj)("symbol-structure",60049),symbolStruct:(0,i.$Bj)("symbol-struct",60049),symbolParameter:(0,i.$Bj)("symbol-parameter",60050),symbolTypeParameter:(0,i.$Bj)("symbol-type-parameter",60050),symbolKey:(0,i.$Bj)("symbol-key",60051),symbolText:(0,i.$Bj)("symbol-text",60051),symbolReference:(0,i.$Bj)("symbol-reference",60052),goToFile:(0,i.$Bj)("go-to-file",60052),symbolEnum:(0,i.$Bj)("symbol-enum",60053),symbolValue:(0,i.$Bj)("symbol-value",60053),symbolRuler:(0,i.$Bj)("symbol-ruler",60054),symbolUnit:(0,i.$Bj)("symbol-unit",60054),activateBreakpoints:(0,i.$Bj)("activate-breakpoints",60055),archive:(0,i.$Bj)("archive",60056),arrowBoth:(0,i.$Bj)("arrow-both",60057),arrowDown:(0,i.$Bj)("arrow-down",60058),arrowLeft:(0,i.$Bj)("arrow-left",60059),arrowRight:(0,i.$Bj)("arrow-right",60060),arrowSmallDown:(0,i.$Bj)("arrow-small-down",60061),arrowSmallLeft:(0,i.$Bj)("arrow-small-left",60062),arrowSmallRight:(0,i.$Bj)("arrow-small-right",60063),arrowSmallUp:(0,i.$Bj)("arrow-small-up",60064),arrowUp:(0,i.$Bj)("arrow-up",60065),bell:(0,i.$Bj)("bell",60066),bold:(0,i.$Bj)("bold",60067),book:(0,i.$Bj)("book",60068),bookmark:(0,i.$Bj)("bookmark",60069),debugBreakpointConditionalUnverified:(0,i.$Bj)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,i.$Bj)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,i.$Bj)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,i.$Bj)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,i.$Bj)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,i.$Bj)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,i.$Bj)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,i.$Bj)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,i.$Bj)("debug-breakpoint-log-disabled",60075),briefcase:(0,i.$Bj)("briefcase",60076),broadcast:(0,i.$Bj)("broadcast",60077),browser:(0,i.$Bj)("browser",60078),bug:(0,i.$Bj)("bug",60079),calendar:(0,i.$Bj)("calendar",60080),caseSensitive:(0,i.$Bj)("case-sensitive",60081),check:(0,i.$Bj)("check",60082),checklist:(0,i.$Bj)("checklist",60083),chevronDown:(0,i.$Bj)("chevron-down",60084),chevronLeft:(0,i.$Bj)("chevron-left",60085),chevronRight:(0,i.$Bj)("chevron-right",60086),chevronUp:(0,i.$Bj)("chevron-up",60087),chromeClose:(0,i.$Bj)("chrome-close",60088),chromeMaximize:(0,i.$Bj)("chrome-maximize",60089),chromeMinimize:(0,i.$Bj)("chrome-minimize",60090),chromeRestore:(0,i.$Bj)("chrome-restore",60091),circleOutline:(0,i.$Bj)("circle-outline",60092),circle:(0,i.$Bj)("circle",60092),debugBreakpointUnverified:(0,i.$Bj)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,i.$Bj)("terminal-decoration-incomplete",60092),circleSlash:(0,i.$Bj)("circle-slash",60093),circuitBoard:(0,i.$Bj)("circuit-board",60094),clearAll:(0,i.$Bj)("clear-all",60095),clippy:(0,i.$Bj)("clippy",60096),closeAll:(0,i.$Bj)("close-all",60097),cloudDownload:(0,i.$Bj)("cloud-download",60098),cloudUpload:(0,i.$Bj)("cloud-upload",60099),code:(0,i.$Bj)("code",60100),collapseAll:(0,i.$Bj)("collapse-all",60101),colorMode:(0,i.$Bj)("color-mode",60102),commentDiscussion:(0,i.$Bj)("comment-discussion",60103),creditCard:(0,i.$Bj)("credit-card",60105),dash:(0,i.$Bj)("dash",60108),dashboard:(0,i.$Bj)("dashboard",60109),database:(0,i.$Bj)("database",60110),debugContinue:(0,i.$Bj)("debug-continue",60111),debugDisconnect:(0,i.$Bj)("debug-disconnect",60112),debugPause:(0,i.$Bj)("debug-pause",60113),debugRestart:(0,i.$Bj)("debug-restart",60114),debugStart:(0,i.$Bj)("debug-start",60115),debugStepInto:(0,i.$Bj)("debug-step-into",60116),debugStepOut:(0,i.$Bj)("debug-step-out",60117),debugStepOver:(0,i.$Bj)("debug-step-over",60118),debugStop:(0,i.$Bj)("debug-stop",60119),debug:(0,i.$Bj)("debug",60120),deviceCameraVideo:(0,i.$Bj)("device-camera-video",60121),deviceCamera:(0,i.$Bj)("device-camera",60122),deviceMobile:(0,i.$Bj)("device-mobile",60123),diffAdded:(0,i.$Bj)("diff-added",60124),diffIgnored:(0,i.$Bj)("diff-ignored",60125),diffModified:(0,i.$Bj)("diff-modified",60126),diffRemoved:(0,i.$Bj)("diff-removed",60127),diffRenamed:(0,i.$Bj)("diff-renamed",60128),diff:(0,i.$Bj)("diff",60129),diffSidebyside:(0,i.$Bj)("diff-sidebyside",60129),discard:(0,i.$Bj)("discard",60130),editorLayout:(0,i.$Bj)("editor-layout",60131),emptyWindow:(0,i.$Bj)("empty-window",60132),exclude:(0,i.$Bj)("exclude",60133),extensions:(0,i.$Bj)("extensions",60134),eyeClosed:(0,i.$Bj)("eye-closed",60135),fileBinary:(0,i.$Bj)("file-binary",60136),fileCode:(0,i.$Bj)("file-code",60137),fileMedia:(0,i.$Bj)("file-media",60138),filePdf:(0,i.$Bj)("file-pdf",60139),fileSubmodule:(0,i.$Bj)("file-submodule",60140),fileSymlinkDirectory:(0,i.$Bj)("file-symlink-directory",60141),fileSymlinkFile:(0,i.$Bj)("file-symlink-file",60142),fileZip:(0,i.$Bj)("file-zip",60143),files:(0,i.$Bj)("files",60144),filter:(0,i.$Bj)("filter",60145),flame:(0,i.$Bj)("flame",60146),foldDown:(0,i.$Bj)("fold-down",60147),foldUp:(0,i.$Bj)("fold-up",60148),fold:(0,i.$Bj)("fold",60149),folderActive:(0,i.$Bj)("folder-active",60150),folderOpened:(0,i.$Bj)("folder-opened",60151),gear:(0,i.$Bj)("gear",60152),gift:(0,i.$Bj)("gift",60153),gistSecret:(0,i.$Bj)("gist-secret",60154),gist:(0,i.$Bj)("gist",60155),gitCommit:(0,i.$Bj)("git-commit",60156),gitCompare:(0,i.$Bj)("git-compare",60157),compareChanges:(0,i.$Bj)("compare-changes",60157),gitMerge:(0,i.$Bj)("git-merge",60158),githubAction:(0,i.$Bj)("github-action",60159),githubAlt:(0,i.$Bj)("github-alt",60160),globe:(0,i.$Bj)("globe",60161),grabber:(0,i.$Bj)("grabber",60162),graph:(0,i.$Bj)("graph",60163),gripper:(0,i.$Bj)("gripper",60164),heart:(0,i.$Bj)("heart",60165),home:(0,i.$Bj)("home",60166),horizontalRule:(0,i.$Bj)("horizontal-rule",60167),hubot:(0,i.$Bj)("hubot",60168),inbox:(0,i.$Bj)("inbox",60169),issueReopened:(0,i.$Bj)("issue-reopened",60171),issues:(0,i.$Bj)("issues",60172),italic:(0,i.$Bj)("italic",60173),jersey:(0,i.$Bj)("jersey",60174),json:(0,i.$Bj)("json",60175),kebabVertical:(0,i.$Bj)("kebab-vertical",60176),key:(0,i.$Bj)("key",60177),law:(0,i.$Bj)("law",60178),lightbulbAutofix:(0,i.$Bj)("lightbulb-autofix",60179),linkExternal:(0,i.$Bj)("link-external",60180),link:(0,i.$Bj)("link",60181),listOrdered:(0,i.$Bj)("list-ordered",60182),listUnordered:(0,i.$Bj)("list-unordered",60183),liveShare:(0,i.$Bj)("live-share",60184),loading:(0,i.$Bj)("loading",60185),location:(0,i.$Bj)("location",60186),mailRead:(0,i.$Bj)("mail-read",60187),mail:(0,i.$Bj)("mail",60188),markdown:(0,i.$Bj)("markdown",60189),megaphone:(0,i.$Bj)("megaphone",60190),mention:(0,i.$Bj)("mention",60191),milestone:(0,i.$Bj)("milestone",60192),gitPullRequestMilestone:(0,i.$Bj)("git-pull-request-milestone",60192),mortarBoard:(0,i.$Bj)("mortar-board",60193),move:(0,i.$Bj)("move",60194),multipleWindows:(0,i.$Bj)("multiple-windows",60195),mute:(0,i.$Bj)("mute",60196),noNewline:(0,i.$Bj)("no-newline",60197),note:(0,i.$Bj)("note",60198),octoface:(0,i.$Bj)("octoface",60199),openPreview:(0,i.$Bj)("open-preview",60200),package:(0,i.$Bj)("package",60201),paintcan:(0,i.$Bj)("paintcan",60202),pin:(0,i.$Bj)("pin",60203),play:(0,i.$Bj)("play",60204),run:(0,i.$Bj)("run",60204),plug:(0,i.$Bj)("plug",60205),preserveCase:(0,i.$Bj)("preserve-case",60206),preview:(0,i.$Bj)("preview",60207),project:(0,i.$Bj)("project",60208),pulse:(0,i.$Bj)("pulse",60209),question:(0,i.$Bj)("question",60210),quote:(0,i.$Bj)("quote",60211),radioTower:(0,i.$Bj)("radio-tower",60212),reactions:(0,i.$Bj)("reactions",60213),references:(0,i.$Bj)("references",60214),refresh:(0,i.$Bj)("refresh",60215),regex:(0,i.$Bj)("regex",60216),remoteExplorer:(0,i.$Bj)("remote-explorer",60217),remote:(0,i.$Bj)("remote",60218),remove:(0,i.$Bj)("remove",60219),replaceAll:(0,i.$Bj)("replace-all",60220),replace:(0,i.$Bj)("replace",60221),repoClone:(0,i.$Bj)("repo-clone",60222),repoForcePush:(0,i.$Bj)("repo-force-push",60223),repoPull:(0,i.$Bj)("repo-pull",60224),repoPush:(0,i.$Bj)("repo-push",60225),report:(0,i.$Bj)("report",60226),requestChanges:(0,i.$Bj)("request-changes",60227),rocket:(0,i.$Bj)("rocket",60228),rootFolderOpened:(0,i.$Bj)("root-folder-opened",60229),rootFolder:(0,i.$Bj)("root-folder",60230),rss:(0,i.$Bj)("rss",60231),ruby:(0,i.$Bj)("ruby",60232),saveAll:(0,i.$Bj)("save-all",60233),saveAs:(0,i.$Bj)("save-as",60234),save:(0,i.$Bj)("save",60235),screenFull:(0,i.$Bj)("screen-full",60236),screenNormal:(0,i.$Bj)("screen-normal",60237),searchStop:(0,i.$Bj)("search-stop",60238),server:(0,i.$Bj)("server",60240),settingsGear:(0,i.$Bj)("settings-gear",60241),settings:(0,i.$Bj)("settings",60242),shield:(0,i.$Bj)("shield",60243),smiley:(0,i.$Bj)("smiley",60244),sortPrecedence:(0,i.$Bj)("sort-precedence",60245),splitHorizontal:(0,i.$Bj)("split-horizontal",60246),splitVertical:(0,i.$Bj)("split-vertical",60247),squirrel:(0,i.$Bj)("squirrel",60248),starFull:(0,i.$Bj)("star-full",60249),starHalf:(0,i.$Bj)("star-half",60250),symbolClass:(0,i.$Bj)("symbol-class",60251),symbolColor:(0,i.$Bj)("symbol-color",60252),symbolConstant:(0,i.$Bj)("symbol-constant",60253),symbolEnumMember:(0,i.$Bj)("symbol-enum-member",60254),symbolField:(0,i.$Bj)("symbol-field",60255),symbolFile:(0,i.$Bj)("symbol-file",60256),symbolInterface:(0,i.$Bj)("symbol-interface",60257),symbolKeyword:(0,i.$Bj)("symbol-keyword",60258),symbolMisc:(0,i.$Bj)("symbol-misc",60259),symbolOperator:(0,i.$Bj)("symbol-operator",60260),symbolProperty:(0,i.$Bj)("symbol-property",60261),wrench:(0,i.$Bj)("wrench",60261),wrenchSubaction:(0,i.$Bj)("wrench-subaction",60261),symbolSnippet:(0,i.$Bj)("symbol-snippet",60262),tasklist:(0,i.$Bj)("tasklist",60263),telescope:(0,i.$Bj)("telescope",60264),textSize:(0,i.$Bj)("text-size",60265),threeBars:(0,i.$Bj)("three-bars",60266),thumbsdown:(0,i.$Bj)("thumbsdown",60267),thumbsup:(0,i.$Bj)("thumbsup",60268),tools:(0,i.$Bj)("tools",60269),triangleDown:(0,i.$Bj)("triangle-down",60270),triangleLeft:(0,i.$Bj)("triangle-left",60271),triangleRight:(0,i.$Bj)("triangle-right",60272),triangleUp:(0,i.$Bj)("triangle-up",60273),twitter:(0,i.$Bj)("twitter",60274),unfold:(0,i.$Bj)("unfold",60275),unlock:(0,i.$Bj)("unlock",60276),unmute:(0,i.$Bj)("unmute",60277),unverified:(0,i.$Bj)("unverified",60278),verified:(0,i.$Bj)("verified",60279),versions:(0,i.$Bj)("versions",60280),vmActive:(0,i.$Bj)("vm-active",60281),vmOutline:(0,i.$Bj)("vm-outline",60282),vmRunning:(0,i.$Bj)("vm-running",60283),watch:(0,i.$Bj)("watch",60284),whitespace:(0,i.$Bj)("whitespace",60285),wholeWord:(0,i.$Bj)("whole-word",60286),window:(0,i.$Bj)("window",60287),wordWrap:(0,i.$Bj)("word-wrap",60288),zoomIn:(0,i.$Bj)("zoom-in",60289),zoomOut:(0,i.$Bj)("zoom-out",60290),listFilter:(0,i.$Bj)("list-filter",60291),listFlat:(0,i.$Bj)("list-flat",60292),listSelection:(0,i.$Bj)("list-selection",60293),selection:(0,i.$Bj)("selection",60293),listTree:(0,i.$Bj)("list-tree",60294),debugBreakpointFunctionUnverified:(0,i.$Bj)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,i.$Bj)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,i.$Bj)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,i.$Bj)("debug-stackframe-active",60297),circleSmallFilled:(0,i.$Bj)("circle-small-filled",60298),debugStackframeDot:(0,i.$Bj)("debug-stackframe-dot",60298),terminalDecorationMark:(0,i.$Bj)("terminal-decoration-mark",60298),debugStackframe:(0,i.$Bj)("debug-stackframe",60299),debugStackframeFocused:(0,i.$Bj)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,i.$Bj)("debug-breakpoint-unsupported",60300),symbolString:(0,i.$Bj)("symbol-string",60301),debugReverseContinue:(0,i.$Bj)("debug-reverse-continue",60302),debugStepBack:(0,i.$Bj)("debug-step-back",60303),debugRestartFrame:(0,i.$Bj)("debug-restart-frame",60304),debugAlt:(0,i.$Bj)("debug-alt",60305),callIncoming:(0,i.$Bj)("call-incoming",60306),callOutgoing:(0,i.$Bj)("call-outgoing",60307),menu:(0,i.$Bj)("menu",60308),expandAll:(0,i.$Bj)("expand-all",60309),feedback:(0,i.$Bj)("feedback",60310),gitPullRequestReviewer:(0,i.$Bj)("git-pull-request-reviewer",60310),groupByRefType:(0,i.$Bj)("group-by-ref-type",60311),ungroupByRefType:(0,i.$Bj)("ungroup-by-ref-type",60312),account:(0,i.$Bj)("account",60313),gitPullRequestAssignee:(0,i.$Bj)("git-pull-request-assignee",60313),bellDot:(0,i.$Bj)("bell-dot",60314),debugConsole:(0,i.$Bj)("debug-console",60315),library:(0,i.$Bj)("library",60316),output:(0,i.$Bj)("output",60317),runAll:(0,i.$Bj)("run-all",60318),syncIgnored:(0,i.$Bj)("sync-ignored",60319),pinned:(0,i.$Bj)("pinned",60320),githubInverted:(0,i.$Bj)("github-inverted",60321),serverProcess:(0,i.$Bj)("server-process",60322),serverEnvironment:(0,i.$Bj)("server-environment",60323),pass:(0,i.$Bj)("pass",60324),issueClosed:(0,i.$Bj)("issue-closed",60324),stopCircle:(0,i.$Bj)("stop-circle",60325),playCircle:(0,i.$Bj)("play-circle",60326),record:(0,i.$Bj)("record",60327),debugAltSmall:(0,i.$Bj)("debug-alt-small",60328),vmConnect:(0,i.$Bj)("vm-connect",60329),cloud:(0,i.$Bj)("cloud",60330),merge:(0,i.$Bj)("merge",60331),export:(0,i.$Bj)("export",60332),graphLeft:(0,i.$Bj)("graph-left",60333),magnet:(0,i.$Bj)("magnet",60334),notebook:(0,i.$Bj)("notebook",60335),redo:(0,i.$Bj)("redo",60336),checkAll:(0,i.$Bj)("check-all",60337),pinnedDirty:(0,i.$Bj)("pinned-dirty",60338),passFilled:(0,i.$Bj)("pass-filled",60339),circleLargeFilled:(0,i.$Bj)("circle-large-filled",60340),circleLarge:(0,i.$Bj)("circle-large",60341),circleLargeOutline:(0,i.$Bj)("circle-large-outline",60341),combine:(0,i.$Bj)("combine",60342),gather:(0,i.$Bj)("gather",60342),table:(0,i.$Bj)("table",60343),variableGroup:(0,i.$Bj)("variable-group",60344),typeHierarchy:(0,i.$Bj)("type-hierarchy",60345),typeHierarchySub:(0,i.$Bj)("type-hierarchy-sub",60346),typeHierarchySuper:(0,i.$Bj)("type-hierarchy-super",60347),gitPullRequestCreate:(0,i.$Bj)("git-pull-request-create",60348),runAbove:(0,i.$Bj)("run-above",60349),runBelow:(0,i.$Bj)("run-below",60350),notebookTemplate:(0,i.$Bj)("notebook-template",60351),debugRerun:(0,i.$Bj)("debug-rerun",60352),workspaceTrusted:(0,i.$Bj)("workspace-trusted",60353),workspaceUntrusted:(0,i.$Bj)("workspace-untrusted",60354),workspaceUnknown:(0,i.$Bj)("workspace-unknown",60355),terminalCmd:(0,i.$Bj)("terminal-cmd",60356),terminalDebian:(0,i.$Bj)("terminal-debian",60357),terminalLinux:(0,i.$Bj)("terminal-linux",60358),terminalPowershell:(0,i.$Bj)("terminal-powershell",60359),terminalTmux:(0,i.$Bj)("terminal-tmux",60360),terminalUbuntu:(0,i.$Bj)("terminal-ubuntu",60361),terminalBash:(0,i.$Bj)("terminal-bash",60362),arrowSwap:(0,i.$Bj)("arrow-swap",60363),copy:(0,i.$Bj)("copy",60364),personAdd:(0,i.$Bj)("person-add",60365),filterFilled:(0,i.$Bj)("filter-filled",60366),wand:(0,i.$Bj)("wand",60367),debugLineByLine:(0,i.$Bj)("debug-line-by-line",60368),inspect:(0,i.$Bj)("inspect",60369),layers:(0,i.$Bj)("layers",60370),layersDot:(0,i.$Bj)("layers-dot",60371),layersActive:(0,i.$Bj)("layers-active",60372),compass:(0,i.$Bj)("compass",60373),compassDot:(0,i.$Bj)("compass-dot",60374),compassActive:(0,i.$Bj)("compass-active",60375),azure:(0,i.$Bj)("azure",60376),issueDraft:(0,i.$Bj)("issue-draft",60377),gitPullRequestClosed:(0,i.$Bj)("git-pull-request-closed",60378),gitPullRequestDraft:(0,i.$Bj)("git-pull-request-draft",60379),debugAll:(0,i.$Bj)("debug-all",60380),debugCoverage:(0,i.$Bj)("debug-coverage",60381),runErrors:(0,i.$Bj)("run-errors",60382),folderLibrary:(0,i.$Bj)("folder-library",60383),debugContinueSmall:(0,i.$Bj)("debug-continue-small",60384),beakerStop:(0,i.$Bj)("beaker-stop",60385),graphLine:(0,i.$Bj)("graph-line",60386),graphScatter:(0,i.$Bj)("graph-scatter",60387),pieChart:(0,i.$Bj)("pie-chart",60388),bracket:(0,i.$Bj)("bracket",60175),bracketDot:(0,i.$Bj)("bracket-dot",60389),bracketError:(0,i.$Bj)("bracket-error",60390),lockSmall:(0,i.$Bj)("lock-small",60391),azureDevops:(0,i.$Bj)("azure-devops",60392),verifiedFilled:(0,i.$Bj)("verified-filled",60393),newline:(0,i.$Bj)("newline",60394),layout:(0,i.$Bj)("layout",60395),layoutActivitybarLeft:(0,i.$Bj)("layout-activitybar-left",60396),layoutActivitybarRight:(0,i.$Bj)("layout-activitybar-right",60397),layoutPanelLeft:(0,i.$Bj)("layout-panel-left",60398),layoutPanelCenter:(0,i.$Bj)("layout-panel-center",60399),layoutPanelJustify:(0,i.$Bj)("layout-panel-justify",60400),layoutPanelRight:(0,i.$Bj)("layout-panel-right",60401),layoutPanel:(0,i.$Bj)("layout-panel",60402),layoutSidebarLeft:(0,i.$Bj)("layout-sidebar-left",60403),layoutSidebarRight:(0,i.$Bj)("layout-sidebar-right",60404),layoutStatusbar:(0,i.$Bj)("layout-statusbar",60405),layoutMenubar:(0,i.$Bj)("layout-menubar",60406),layoutCentered:(0,i.$Bj)("layout-centered",60407),target:(0,i.$Bj)("target",60408),indent:(0,i.$Bj)("indent",60409),recordSmall:(0,i.$Bj)("record-small",60410),errorSmall:(0,i.$Bj)("error-small",60411),terminalDecorationError:(0,i.$Bj)("terminal-decoration-error",60411),arrowCircleDown:(0,i.$Bj)("arrow-circle-down",60412),arrowCircleLeft:(0,i.$Bj)("arrow-circle-left",60413),arrowCircleRight:(0,i.$Bj)("arrow-circle-right",60414),arrowCircleUp:(0,i.$Bj)("arrow-circle-up",60415),layoutSidebarRightOff:(0,i.$Bj)("layout-sidebar-right-off",60416),layoutPanelOff:(0,i.$Bj)("layout-panel-off",60417),layoutSidebarLeftOff:(0,i.$Bj)("layout-sidebar-left-off",60418),blank:(0,i.$Bj)("blank",60419),heartFilled:(0,i.$Bj)("heart-filled",60420),map:(0,i.$Bj)("map",60421),mapFilled:(0,i.$Bj)("map-filled",60422),circleSmall:(0,i.$Bj)("circle-small",60423),bellSlash:(0,i.$Bj)("bell-slash",60424),bellSlashDot:(0,i.$Bj)("bell-slash-dot",60425),commentUnresolved:(0,i.$Bj)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,i.$Bj)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,i.$Bj)("git-pull-request-new-changes",60428),searchFuzzy:(0,i.$Bj)("search-fuzzy",60429),commentDraft:(0,i.$Bj)("comment-draft",60430),send:(0,i.$Bj)("send",60431),sparkle:(0,i.$Bj)("sparkle",60432),insert:(0,i.$Bj)("insert",60433),mic:(0,i.$Bj)("mic",60434),thumbsdownFilled:(0,i.$Bj)("thumbsdown-filled",60435),thumbsupFilled:(0,i.$Bj)("thumbsup-filled",60436),coffee:(0,i.$Bj)("coffee",60437),snake:(0,i.$Bj)("snake",60438),game:(0,i.$Bj)("game",60439),vr:(0,i.$Bj)("vr",60440),chip:(0,i.$Bj)("chip",60441),piano:(0,i.$Bj)("piano",60442),music:(0,i.$Bj)("music",60443),micFilled:(0,i.$Bj)("mic-filled",60444),repoFetch:(0,i.$Bj)("repo-fetch",60445),copilot:(0,i.$Bj)("copilot",60446),lightbulbSparkle:(0,i.$Bj)("lightbulb-sparkle",60447),robot:(0,i.$Bj)("robot",60448),sparkleFilled:(0,i.$Bj)("sparkle-filled",60449),diffSingle:(0,i.$Bj)("diff-single",60450),diffMultiple:(0,i.$Bj)("diff-multiple",60451),surroundWith:(0,i.$Bj)("surround-with",60452),share:(0,i.$Bj)("share",60453),gitStash:(0,i.$Bj)("git-stash",60454),gitStashApply:(0,i.$Bj)("git-stash-apply",60455),gitStashPop:(0,i.$Bj)("git-stash-pop",60456),vscode:(0,i.$Bj)("vscode",60457),vscodeInsiders:(0,i.$Bj)("vscode-insiders",60458),codeOss:(0,i.$Bj)("code-oss",60459),runCoverage:(0,i.$Bj)("run-coverage",60460),runAllCoverage:(0,i.$Bj)("run-all-coverage",60461),coverage:(0,i.$Bj)("coverage",60462),githubProject:(0,i.$Bj)("github-project",60463)}}),re(ie[43],se([0,1,27,42]),function(V,t,i,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Gj=t.$Fj=void 0,t.$Ej=y;function y(){return Object.values(t.$Gj)}t.$Fj={dialogError:(0,i.$Bj)("dialog-error","error"),dialogWarning:(0,i.$Bj)("dialog-warning","warning"),dialogInfo:(0,i.$Bj)("dialog-info","info"),dialogClose:(0,i.$Bj)("dialog-close","close"),treeItemExpanded:(0,i.$Bj)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,i.$Bj)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,i.$Bj)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,i.$Bj)("tree-filter-clear","close"),treeItemLoading:(0,i.$Bj)("tree-item-loading","loading"),menuSelection:(0,i.$Bj)("menu-selection","check"),menuSubmenu:(0,i.$Bj)("menu-submenu","chevron-right"),menuBarMore:(0,i.$Bj)("menubar-more","more"),scrollbarButtonLeft:(0,i.$Bj)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,i.$Bj)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,i.$Bj)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,i.$Bj)("scrollbar-button-down","triangle-down"),toolBarMore:(0,i.$Bj)("toolbar-more","more"),quickInputBack:(0,i.$Bj)("quick-input-back","arrow-left"),dropDownButton:(0,i.$Bj)("drop-down-button",60084),symbolCustomColor:(0,i.$Bj)("symbol-customcolor",60252),exportIcon:(0,i.$Bj)("export",60332),workspaceUnspecified:(0,i.$Bj)("workspace-unspecified",60355),newLine:(0,i.$Bj)("newline",60394),thumbsDownFilled:(0,i.$Bj)("thumbsdown-filled",60435),thumbsUpFilled:(0,i.$Bj)("thumbsup-filled",60436),gitFetch:(0,i.$Bj)("git-fetch",60445),lightbulbSparkleAutofix:(0,i.$Bj)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,i.$Bj)("debug-breakpoint-pending",60377)},t.$Gj={...P.$Dj,...t.$Fj}}),re(ie[14],se([0,1,26]),function(V,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Nn=P,t.$On=y,t.$Pn=p,t.$Qn=o,t.$Rn=a,t.$Sn=g,t.$Tn=B,t.$Un=d,t.$Vn=m,t.$Wn=e,t.$Xn=v,t.$Yn=j;function P(L){if(!L||typeof L!="object"||L instanceof RegExp)return L;const $=Array.isArray(L)?[]:{};return Object.entries(L).forEach(([b,u])=>{$[b]=u&&typeof u=="object"?P(u):u}),$}function y(L){if(!L||typeof L!="object")return L;const $=[L];for(;$.length>0;){const b=$.shift();Object.freeze(b);for(const u in b)if(f.call(b,u)){const l=b[u];typeof l=="object"&&!Object.isFrozen(l)&&!(0,i.$Xf)(l)&&$.push(l)}}return L}const f=Object.prototype.hasOwnProperty;function p(L,$){return h(L,$,new Set)}function h(L,$,b){if((0,i.$4f)(L))return L;const u=$(L);if(typeof u<"u")return u;if(Array.isArray(L)){const l=[];for(const n of L)l.push(h(n,$,b));return l}if((0,i.$Wf)(L)){if(b.has(L))throw new Error("Cannot clone recursive data-structure");b.add(L);const l={};for(const n in L)f.call(L,n)&&(l[n]=h(L[n],$,b));return b.delete(L),l}return L}function o(L,$,b=!0){return(0,i.$Wf)(L)?((0,i.$Wf)($)&&Object.keys($).forEach(u=>{u in L?b&&((0,i.$Wf)(L[u])&&(0,i.$Wf)($[u])?o(L[u],$[u],b):L[u]=$[u]):L[u]=$[u]}),L):$}function a(L,$){if(L===$)return!0;if(L==null||$===null||$===void 0||typeof L!=typeof $||typeof L!="object"||Array.isArray(L)!==Array.isArray($))return!1;let b,u;if(Array.isArray(L)){if(L.length!==$.length)return!1;for(b=0;b<L.length;b++)if(!a(L[b],$[b]))return!1}else{const l=[];for(u in L)l.push(u);l.sort();const n=[];for(u in $)n.push(u);if(n.sort(),!a(l,n))return!1;for(b=0;b<l.length;b++)if(!a(L[l[b]],$[l[b]]))return!1}return!0}function g(L){const $=new Set;return JSON.stringify(L,(b,u)=>{if((0,i.$Wf)(u)||Array.isArray(u)){if($.has(u))return"[Circular]";$.add(u)}return u})}function B(L,$){const b=Object.create(null);return!L||!$||Object.keys($).forEach(l=>{const n=L[l],s=$[l];a(n,s)||(b[l]=s)}),b}function d(L,$){const b=$.toLowerCase(),u=Object.keys(L).find(l=>l.toLowerCase()===b);return u?L[u]:L[$]}function m(L,$){const b=Object.create(null);for(const[u,l]of Object.entries(L))$(u,l)&&(b[u]=l);return b}function e(L){let $=[];for(;Object.prototype!==L;)$=$.concat(Object.getOwnPropertyNames(L)),L=Object.getPrototypeOf(L);return $}function v(L){const $=[];for(const b of e(L))typeof L[b]=="function"&&$.push(b);return $}function j(L,$){const b=l=>function(){const n=Array.prototype.slice.call(arguments,0);return $(l,n)},u={};for(const l of L)u[l]=b(l);return u}}),re(ie[28],se([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Constants=void 0,t.$Se=P,t.$Te=y;var i;(function(f){f[f.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",f[f.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",f[f.MAX_UINT_8=255]="MAX_UINT_8",f[f.MAX_UINT_16=65535]="MAX_UINT_16",f[f.MAX_UINT_32=4294967295]="MAX_UINT_32",f[f.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(i||(t.Constants=i={}));function P(f){return f<0?0:f>255?255:f|0}function y(f){return f<0?0:f>4294967295?4294967295:f|0}}),re(ie[29],se([0,1,28]),function(V,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$zt=t.$yt=void 0;class P{constructor(h){const o=(0,i.$Se)(h);this.c=o,this.a=P.d(o),this.b=new Map}static d(h){const o=new Uint8Array(256);return o.fill(h),o}set(h,o){const a=(0,i.$Se)(o);h>=0&&h<256?this.a[h]=a:this.b.set(h,a)}get(h){return h>=0&&h<256?this.a[h]:this.b.get(h)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}t.$yt=P;var y;(function(p){p[p.False=0]="False",p[p.True=1]="True"})(y||(y={}));class f{constructor(){this.a=new P(0)}add(h){this.a.set(h,1)}has(h){return this.a.get(h)===1}clear(){return this.a.clear()}}t.$zt=f}),re(ie[4],se([0,1,3]),function(V,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$jt=t.$it=void 0;class P{static addRange(p,h){let o=0;for(;o<h.length&&h[o].endExclusive<p.start;)o++;let a=o;for(;a<h.length&&h[a].start<=p.endExclusive;)a++;if(o===a)h.splice(o,0,p);else{const g=Math.min(p.start,h[o].start),B=Math.max(p.endExclusive,h[a-1].endExclusive);h.splice(o,a-o,new P(g,B))}}static tryCreate(p,h){if(!(p>h))return new P(p,h)}static ofLength(p){return new P(0,p)}static ofStartAndLength(p,h){return new P(p,p+h)}constructor(p,h){if(this.start=p,this.endExclusive=h,p>h)throw new i.$cb(`Invalid range: ${this.toString()}`)}get isEmpty(){return this.start===this.endExclusive}delta(p){return new P(this.start+p,this.endExclusive+p)}deltaStart(p){return new P(this.start+p,this.endExclusive)}deltaEnd(p){return new P(this.start,this.endExclusive+p)}get length(){return this.endExclusive-this.start}toString(){return`[${this.start}, ${this.endExclusive})`}equals(p){return this.start===p.start&&this.endExclusive===p.endExclusive}containsRange(p){return this.start<=p.start&&p.endExclusive<=this.endExclusive}contains(p){return this.start<=p&&p<this.endExclusive}join(p){return new P(Math.min(this.start,p.start),Math.max(this.endExclusive,p.endExclusive))}intersect(p){const h=Math.max(this.start,p.start),o=Math.min(this.endExclusive,p.endExclusive);if(h<=o)return new P(h,o)}intersects(p){const h=Math.max(this.start,p.start),o=Math.min(this.endExclusive,p.endExclusive);return h<o}intersectsOrTouches(p){const h=Math.max(this.start,p.start),o=Math.min(this.endExclusive,p.endExclusive);return h<=o}isBefore(p){return this.endExclusive<=p.start}isAfter(p){return this.start>=p.endExclusive}slice(p){return p.slice(this.start,this.endExclusive)}substring(p){return p.substring(this.start,this.endExclusive)}clip(p){if(this.isEmpty)throw new i.$cb(`Invalid clipping range: ${this.toString()}`);return Math.max(this.start,Math.min(this.endExclusive-1,p))}clipCyclic(p){if(this.isEmpty)throw new i.$cb(`Invalid clipping range: ${this.toString()}`);return p<this.start?this.endExclusive-(this.start-p)%this.length:p>=this.endExclusive?this.start+(p-this.start)%this.length:p}map(p){const h=[];for(let o=this.start;o<this.endExclusive;o++)h.push(p(o));return h}forEach(p){for(let h=this.start;h<this.endExclusive;h++)p(h)}}t.$it=P;class y{constructor(){this.a=[]}addRange(p){let h=0;for(;h<this.a.length&&this.a[h].endExclusive<p.start;)h++;let o=h;for(;o<this.a.length&&this.a[o].start<=p.endExclusive;)o++;if(h===o)this.a.splice(h,0,p);else{const a=Math.min(p.start,this.a[h].start),g=Math.max(p.endExclusive,this.a[o-1].endExclusive);this.a.splice(h,o-h,new P(a,g))}}toString(){return this.a.map(p=>p.toString()).join(", ")}intersectsStrict(p){let h=0;for(;h<this.a.length&&this.a[h].endExclusive<=p.start;)h++;return h<this.a.length&&this.a[h].start<p.endExclusive}intersectWithRange(p){const h=new y;for(const o of this.a){const a=o.intersect(p);a&&h.addRange(a)}return h}intersectWithRangeLength(p){return this.intersectWithRange(p).length}get length(){return this.a.reduce((p,h)=>p+h.length,0)}}t.$jt=y}),re(ie[5],se([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$at=void 0;class i{constructor(y,f){this.lineNumber=y,this.column=f}with(y=this.lineNumber,f=this.column){return y===this.lineNumber&&f===this.column?this:new i(y,f)}delta(y=0,f=0){return this.with(this.lineNumber+y,this.column+f)}equals(y){return i.equals(this,y)}static equals(y,f){return!y&&!f?!0:!!y&&!!f&&y.lineNumber===f.lineNumber&&y.column===f.column}isBefore(y){return i.isBefore(this,y)}static isBefore(y,f){return y.lineNumber<f.lineNumber?!0:f.lineNumber<y.lineNumber?!1:y.column<f.column}isBeforeOrEqual(y){return i.isBeforeOrEqual(this,y)}static isBeforeOrEqual(y,f){return y.lineNumber<f.lineNumber?!0:f.lineNumber<y.lineNumber?!1:y.column<=f.column}static compare(y,f){const p=y.lineNumber|0,h=f.lineNumber|0;if(p===h){const o=y.column|0,a=f.column|0;return o-a}return p-h}clone(){return new i(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(y){return new i(y.lineNumber,y.column)}static isIPosition(y){return y&&typeof y.lineNumber=="number"&&typeof y.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}t.$at=i}),re(ie[2],se([0,1,5]),function(V,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bt=void 0;class P{constructor(f,p,h,o){f>h||f===h&&p>o?(this.startLineNumber=h,this.startColumn=o,this.endLineNumber=f,this.endColumn=p):(this.startLineNumber=f,this.startColumn=p,this.endLineNumber=h,this.endColumn=o)}isEmpty(){return P.isEmpty(this)}static isEmpty(f){return f.startLineNumber===f.endLineNumber&&f.startColumn===f.endColumn}containsPosition(f){return P.containsPosition(this,f)}static containsPosition(f,p){return!(p.lineNumber<f.startLineNumber||p.lineNumber>f.endLineNumber||p.lineNumber===f.startLineNumber&&p.column<f.startColumn||p.lineNumber===f.endLineNumber&&p.column>f.endColumn)}static strictContainsPosition(f,p){return!(p.lineNumber<f.startLineNumber||p.lineNumber>f.endLineNumber||p.lineNumber===f.startLineNumber&&p.column<=f.startColumn||p.lineNumber===f.endLineNumber&&p.column>=f.endColumn)}containsRange(f){return P.containsRange(this,f)}static containsRange(f,p){return!(p.startLineNumber<f.startLineNumber||p.endLineNumber<f.startLineNumber||p.startLineNumber>f.endLineNumber||p.endLineNumber>f.endLineNumber||p.startLineNumber===f.startLineNumber&&p.startColumn<f.startColumn||p.endLineNumber===f.endLineNumber&&p.endColumn>f.endColumn)}strictContainsRange(f){return P.strictContainsRange(this,f)}static strictContainsRange(f,p){return!(p.startLineNumber<f.startLineNumber||p.endLineNumber<f.startLineNumber||p.startLineNumber>f.endLineNumber||p.endLineNumber>f.endLineNumber||p.startLineNumber===f.startLineNumber&&p.startColumn<=f.startColumn||p.endLineNumber===f.endLineNumber&&p.endColumn>=f.endColumn)}plusRange(f){return P.plusRange(this,f)}static plusRange(f,p){let h,o,a,g;return p.startLineNumber<f.startLineNumber?(h=p.startLineNumber,o=p.startColumn):p.startLineNumber===f.startLineNumber?(h=p.startLineNumber,o=Math.min(p.startColumn,f.startColumn)):(h=f.startLineNumber,o=f.startColumn),p.endLineNumber>f.endLineNumber?(a=p.endLineNumber,g=p.endColumn):p.endLineNumber===f.endLineNumber?(a=p.endLineNumber,g=Math.max(p.endColumn,f.endColumn)):(a=f.endLineNumber,g=f.endColumn),new P(h,o,a,g)}intersectRanges(f){return P.intersectRanges(this,f)}static intersectRanges(f,p){let h=f.startLineNumber,o=f.startColumn,a=f.endLineNumber,g=f.endColumn;const B=p.startLineNumber,d=p.startColumn,m=p.endLineNumber,e=p.endColumn;return h<B?(h=B,o=d):h===B&&(o=Math.max(o,d)),a>m?(a=m,g=e):a===m&&(g=Math.min(g,e)),h>a||h===a&&o>g?null:new P(h,o,a,g)}equalsRange(f){return P.equalsRange(this,f)}static equalsRange(f,p){return!f&&!p?!0:!!f&&!!p&&f.startLineNumber===p.startLineNumber&&f.startColumn===p.startColumn&&f.endLineNumber===p.endLineNumber&&f.endColumn===p.endColumn}getEndPosition(){return P.getEndPosition(this)}static getEndPosition(f){return new i.$at(f.endLineNumber,f.endColumn)}getStartPosition(){return P.getStartPosition(this)}static getStartPosition(f){return new i.$at(f.startLineNumber,f.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(f,p){return new P(this.startLineNumber,this.startColumn,f,p)}setStartPosition(f,p){return new P(f,p,this.endLineNumber,this.endColumn)}collapseToStart(){return P.collapseToStart(this)}static collapseToStart(f){return new P(f.startLineNumber,f.startColumn,f.startLineNumber,f.startColumn)}collapseToEnd(){return P.collapseToEnd(this)}static collapseToEnd(f){return new P(f.endLineNumber,f.endColumn,f.endLineNumber,f.endColumn)}delta(f){return new P(this.startLineNumber+f,this.startColumn,this.endLineNumber+f,this.endColumn)}static fromPositions(f,p=f){return new P(f.lineNumber,f.column,p.lineNumber,p.column)}static lift(f){return f?new P(f.startLineNumber,f.startColumn,f.endLineNumber,f.endColumn):null}static isIRange(f){return f&&typeof f.startLineNumber=="number"&&typeof f.startColumn=="number"&&typeof f.endLineNumber=="number"&&typeof f.endColumn=="number"}static areIntersectingOrTouching(f,p){return!(f.endLineNumber<p.startLineNumber||f.endLineNumber===p.startLineNumber&&f.endColumn<p.startColumn||p.endLineNumber<f.startLineNumber||p.endLineNumber===f.startLineNumber&&p.endColumn<f.startColumn)}static areIntersecting(f,p){return!(f.endLineNumber<p.startLineNumber||f.endLineNumber===p.startLineNumber&&f.endColumn<=p.startColumn||p.endLineNumber<f.startLineNumber||p.endLineNumber===f.startLineNumber&&p.endColumn<=f.startColumn)}static compareRangesUsingStarts(f,p){if(f&&p){const a=f.startLineNumber|0,g=p.startLineNumber|0;if(a===g){const B=f.startColumn|0,d=p.startColumn|0;if(B===d){const m=f.endLineNumber|0,e=p.endLineNumber|0;if(m===e){const v=f.endColumn|0,j=p.endColumn|0;return v-j}return m-e}return B-d}return a-g}return(f?1:0)-(p?1:0)}static compareRangesUsingEnds(f,p){return f.endLineNumber===p.endLineNumber?f.endColumn===p.endColumn?f.startLineNumber===p.startLineNumber?f.startColumn-p.startColumn:f.startLineNumber-p.startLineNumber:f.endColumn-p.endColumn:f.endLineNumber-p.endLineNumber}static spansMultipleLines(f){return f.endLineNumber>f.startLineNumber}toJSON(){return this}}t.$bt=P}),re(ie[44],se([0,1,2]),function(V,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ct=void 0;class P{static insert(f,p){return{range:new i.$bt(f.lineNumber,f.column,f.lineNumber,f.column),text:p,forceMoveMarkers:!0}}static delete(f){return{range:f,text:null}}static replace(f,p){return{range:f,text:p}}static replaceMove(f,p){return{range:f,text:p,forceMoveMarkers:!0}}}t.$ct=P}),re(ie[12],se([0,1,3,4,2,9]),function(V,t,i,P,y,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$lt=t.$kt=void 0;class p{static fromRange(a){return new p(a.startLineNumber,a.endLineNumber)}static fromRangeInclusive(a){return new p(a.startLineNumber,a.endLineNumber+1)}static subtract(a,g){return g?a.startLineNumber<g.startLineNumber&&g.endLineNumberExclusive<a.endLineNumberExclusive?[new p(a.startLineNumber,g.startLineNumber),new p(g.endLineNumberExclusive,a.endLineNumberExclusive)]:g.startLineNumber<=a.startLineNumber&&a.endLineNumberExclusive<=g.endLineNumberExclusive?[]:g.endLineNumberExclusive<a.endLineNumberExclusive?[new p(Math.max(g.endLineNumberExclusive,a.startLineNumber),a.endLineNumberExclusive)]:[new p(a.startLineNumber,Math.min(g.startLineNumber,a.endLineNumberExclusive))]:[a]}static joinMany(a){if(a.length===0)return[];let g=new h(a[0].slice());for(let B=1;B<a.length;B++)g=g.getUnion(new h(a[B].slice()));return g.ranges}static ofLength(a,g){return new p(a,a+g)}static deserialize(a){return new p(a[0],a[1])}constructor(a,g){if(a>g)throw new i.$cb(`startLineNumber ${a} cannot be after endLineNumberExclusive ${g}`);this.startLineNumber=a,this.endLineNumberExclusive=g}contains(a){return this.startLineNumber<=a&&a<this.endLineNumberExclusive}get isEmpty(){return this.startLineNumber===this.endLineNumberExclusive}delta(a){return new p(this.startLineNumber+a,this.endLineNumberExclusive+a)}deltaLength(a){return new p(this.startLineNumber,this.endLineNumberExclusive+a)}get length(){return this.endLineNumberExclusive-this.startLineNumber}join(a){return new p(Math.min(this.startLineNumber,a.startLineNumber),Math.max(this.endLineNumberExclusive,a.endLineNumberExclusive))}toString(){return`[${this.startLineNumber},${this.endLineNumberExclusive})`}intersect(a){const g=Math.max(this.startLineNumber,a.startLineNumber),B=Math.min(this.endLineNumberExclusive,a.endLineNumberExclusive);if(g<=B)return new p(g,B)}intersectsStrict(a){return this.startLineNumber<a.endLineNumberExclusive&&a.startLineNumber<this.endLineNumberExclusive}overlapOrTouch(a){return this.startLineNumber<=a.endLineNumberExclusive&&a.startLineNumber<=this.endLineNumberExclusive}equals(a){return this.startLineNumber===a.startLineNumber&&this.endLineNumberExclusive===a.endLineNumberExclusive}toInclusiveRange(){return this.isEmpty?null:new y.$bt(this.startLineNumber,1,this.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER)}toExclusiveRange(){return new y.$bt(this.startLineNumber,1,this.endLineNumberExclusive,1)}mapToLineArray(a){const g=[];for(let B=this.startLineNumber;B<this.endLineNumberExclusive;B++)g.push(a(B));return g}forEach(a){for(let g=this.startLineNumber;g<this.endLineNumberExclusive;g++)a(g)}serialize(){return[this.startLineNumber,this.endLineNumberExclusive]}includes(a){return this.startLineNumber<=a&&a<this.endLineNumberExclusive}toOffsetRange(){return new P.$it(this.startLineNumber-1,this.endLineNumberExclusive-1)}}t.$kt=p;class h{constructor(a=[]){this.c=a}get ranges(){return this.c}addRange(a){if(a.length===0)return;const g=(0,f.$kb)(this.c,d=>d.endLineNumberExclusive>=a.startLineNumber),B=(0,f.$ib)(this.c,d=>d.startLineNumber<=a.endLineNumberExclusive)+1;if(g===B)this.c.splice(g,0,a);else if(g===B-1){const d=this.c[g];this.c[g]=d.join(a)}else{const d=this.c[g].join(this.c[B-1]).join(a);this.c.splice(g,B-g,d)}}contains(a){const g=(0,f.$hb)(this.c,B=>B.startLineNumber<=a);return!!g&&g.endLineNumberExclusive>a}intersects(a){const g=(0,f.$hb)(this.c,B=>B.startLineNumber<a.endLineNumberExclusive);return!!g&&g.endLineNumberExclusive>a.startLineNumber}getUnion(a){if(this.c.length===0)return a;if(a.c.length===0)return this;const g=[];let B=0,d=0,m=null;for(;B<this.c.length||d<a.c.length;){let e=null;if(B<this.c.length&&d<a.c.length){const v=this.c[B],j=a.c[d];v.startLineNumber<j.startLineNumber?(e=v,B++):(e=j,d++)}else B<this.c.length?(e=this.c[B],B++):(e=a.c[d],d++);m===null?m=e:m.endLineNumberExclusive>=e.startLineNumber?m=new p(m.startLineNumber,Math.max(m.endLineNumberExclusive,e.endLineNumberExclusive)):(g.push(m),m=e)}return m!==null&&g.push(m),new h(g)}subtractFrom(a){const g=(0,f.$kb)(this.c,e=>e.endLineNumberExclusive>=a.startLineNumber),B=(0,f.$ib)(this.c,e=>e.startLineNumber<=a.endLineNumberExclusive)+1;if(g===B)return new h([a]);const d=[];let m=a.startLineNumber;for(let e=g;e<B;e++){const v=this.c[e];v.startLineNumber>m&&d.push(new p(m,v.startLineNumber)),m=v.endLineNumberExclusive}return m<a.endLineNumberExclusive&&d.push(new p(m,a.endLineNumberExclusive)),new h(d)}toString(){return this.c.map(a=>a.toString()).join(", ")}getIntersection(a){const g=[];let B=0,d=0;for(;B<this.c.length&&d<a.c.length;){const m=this.c[B],e=a.c[d],v=m.intersect(e);v&&!v.isEmpty&&g.push(v),m.endLineNumberExclusive<e.endLineNumberExclusive?B++:d++}return new h(g)}getWithDelta(a){return new h(this.c.map(g=>g.delta(a)))}}t.$lt=h}),re(ie[45],se([0,1,5,2]),function(V,t,i,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$dt=t.SelectionDirection=void 0;var y;(function(p){p[p.LTR=0]="LTR",p[p.RTL=1]="RTL"})(y||(t.SelectionDirection=y={}));class f extends P.$bt{constructor(h,o,a,g){super(h,o,a,g),this.selectionStartLineNumber=h,this.selectionStartColumn=o,this.positionLineNumber=a,this.positionColumn=g}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(h){return f.selectionsEqual(this,h)}static selectionsEqual(h,o){return h.selectionStartLineNumber===o.selectionStartLineNumber&&h.selectionStartColumn===o.selectionStartColumn&&h.positionLineNumber===o.positionLineNumber&&h.positionColumn===o.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(h,o){return this.getDirection()===0?new f(this.startLineNumber,this.startColumn,h,o):new f(h,o,this.startLineNumber,this.startColumn)}getPosition(){return new i.$at(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new i.$at(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(h,o){return this.getDirection()===0?new f(h,o,this.endLineNumber,this.endColumn):new f(this.endLineNumber,this.endColumn,h,o)}static fromPositions(h,o=h){return new f(h.lineNumber,h.column,o.lineNumber,o.column)}static fromRange(h,o){return o===0?new f(h.startLineNumber,h.startColumn,h.endLineNumber,h.endColumn):new f(h.endLineNumber,h.endColumn,h.startLineNumber,h.startColumn)}static liftSelection(h){return new f(h.selectionStartLineNumber,h.selectionStartColumn,h.positionLineNumber,h.positionColumn)}static selectionsArrEqual(h,o){if(h&&!o||!h&&o)return!1;if(!h&&!o)return!0;if(h.length!==o.length)return!1;for(let a=0,g=h.length;a<g;a++)if(!this.selectionsEqual(h[a],o[a]))return!1;return!0}static isISelection(h){return h&&typeof h.selectionStartLineNumber=="number"&&typeof h.selectionStartColumn=="number"&&typeof h.positionLineNumber=="number"&&typeof h.positionColumn=="number"}static createWithDirection(h,o,a,g,B){return B===0?new f(h,o,a,g):new f(a,g,h,o)}}t.$dt=f}),re(ie[46],se([0,1,29]),function(V,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Bt=t.$At=t.WordCharacterClass=void 0;var P;(function(p){p[p.Regular=0]="Regular",p[p.Whitespace=1]="Whitespace",p[p.WordSeparator=2]="WordSeparator"})(P||(t.WordCharacterClass=P={}));class y extends i.$yt{constructor(h){super(0);for(let o=0,a=h.length;o<a;o++)this.set(h.charCodeAt(o),2);this.set(32,1),this.set(9,1)}}t.$At=y;function f(p){const h={};return o=>(h.hasOwnProperty(o)||(h[o]=p(o)),h[o])}t.$Bt=f(p=>new y(p))}),re(ie[30],se([0,1,20,10,21]),function(V,t,i,P,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ns=t.$Ms=void 0,t.$Os=p,t.$Ps=o,t.$Qs=a,t.$Ms="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function f(B=""){let d="(-?\\d*\\.\\d\\w*)|([^";for(const m of t.$Ms)B.indexOf(m)>=0||(d+="\\"+m);return d+="\\s]+)",new RegExp(d,"g")}t.$Ns=f();function p(B){let d=t.$Ns;if(B&&B instanceof RegExp)if(B.global)d=B;else{let m="g";B.ignoreCase&&(m+="i"),B.multiline&&(m+="m"),B.unicode&&(m+="u"),d=new RegExp(B.source,m)}return d.lastIndex=0,d}const h=new y.$5c;h.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function o(B){const d=h.unshift(B);return(0,P.$Sc)(d)}function a(B,d,m,e,v){if(d=p(d),v||(v=i.Iterable.first(h)),m.length>v.maxLen){let u=B-v.maxLen/2;return u<0?u=0:e+=u,m=m.substring(u,B+v.maxLen/2),a(B,d,m,e,v)}const j=Date.now(),L=B-1-e;let $=-1,b=null;for(let u=1;!(Date.now()-j>=v.timeBudget);u++){const l=L-v.windowSize*u;d.lastIndex=Math.max(0,l);const n=g(d,m,L,$);if(!n&&b||(b=n,l<=0))break;$=l}if(b){const u={word:b[0],startColumn:e+1+b.index,endColumn:e+1+b.index+b[0].length};return d.lastIndex=0,u}return null}function g(B,d,m,e){let v;for(;v=B.exec(d);){const j=v.index||0;if(j<=m&&B.lastIndex>=m)return v;if(e>0&&j>e)return null}return null}}),re(ie[8],se([0,1,6,3,4]),function(V,t,i,P,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$w2=t.$v2=t.$u2=t.$t2=t.$s2=void 0;class f{static trivial(B,d){return new f([new p(y.$it.ofLength(B.length),y.$it.ofLength(d.length))],!1)}static trivialTimedOut(B,d){return new f([new p(y.$it.ofLength(B.length),y.$it.ofLength(d.length))],!0)}constructor(B,d){this.diffs=B,this.hitTimeout=d}}t.$s2=f;class p{static invert(B,d){const m=[];return(0,i.$Bb)(B,(e,v)=>{m.push(p.fromOffsetPairs(e?e.getEndExclusives():h.zero,v?v.getStarts():new h(d,(e?e.seq2Range.endExclusive-e.seq1Range.endExclusive:0)+d)))}),m}static fromOffsetPairs(B,d){return new p(new y.$it(B.offset1,d.offset1),new y.$it(B.offset2,d.offset2))}constructor(B,d){this.seq1Range=B,this.seq2Range=d}swap(){return new p(this.seq2Range,this.seq1Range)}toString(){return`${this.seq1Range} <-> ${this.seq2Range}`}join(B){return new p(this.seq1Range.join(B.seq1Range),this.seq2Range.join(B.seq2Range))}delta(B){return B===0?this:new p(this.seq1Range.delta(B),this.seq2Range.delta(B))}deltaStart(B){return B===0?this:new p(this.seq1Range.deltaStart(B),this.seq2Range.deltaStart(B))}deltaEnd(B){return B===0?this:new p(this.seq1Range.deltaEnd(B),this.seq2Range.deltaEnd(B))}intersectsOrTouches(B){return this.seq1Range.intersectsOrTouches(B.seq1Range)||this.seq2Range.intersectsOrTouches(B.seq2Range)}intersect(B){const d=this.seq1Range.intersect(B.seq1Range),m=this.seq2Range.intersect(B.seq2Range);if(!(!d||!m))return new p(d,m)}getStarts(){return new h(this.seq1Range.start,this.seq2Range.start)}getEndExclusives(){return new h(this.seq1Range.endExclusive,this.seq2Range.endExclusive)}}t.$t2=p;class h{static{this.zero=new h(0,0)}static{this.max=new h(Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER)}constructor(B,d){this.offset1=B,this.offset2=d}toString(){return`${this.offset1} <-> ${this.offset2}`}delta(B){return B===0?this:new h(this.offset1+B,this.offset2+B)}equals(B){return this.offset1===B.offset1&&this.offset2===B.offset2}}t.$u2=h;class o{static{this.instance=new o}isValid(){return!0}}t.$v2=o;class a{constructor(B){if(this.e=B,this.c=Date.now(),this.d=!0,B<=0)throw new P.$cb("timeout must be positive")}isValid(){if(!(Date.now()-this.c<this.e)&&this.d){this.d=!1;debugger}return this.d}disable(){this.e=Number.MAX_SAFE_INTEGER,this.isValid=()=>!0,this.d=!0}}t.$w2=a}),re(ie[31],se([0,1,4,8]),function(V,t,i,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$B2=void 0;class y{compute(a,g,B=P.$v2.instance){if(a.length===0||g.length===0)return P.$s2.trivial(a,g);const d=a,m=g;function e(s,N){for(;s<d.length&&N<m.length&&d.getElement(s)===m.getElement(N);)s++,N++;return s}let v=0;const j=new p;j.set(0,e(0,0));const L=new h;L.set(0,j.get(0)===0?null:new f(null,0,0,j.get(0)));let $=0;e:for(;;){if(v++,!B.isValid())return P.$s2.trivialTimedOut(d,m);const s=-Math.min(v,m.length+v%2),N=Math.min(v,d.length+v%2);for($=s;$<=N;$+=2){let c=0;const w=$===N?-1:j.get($+1),E=$===s?-1:j.get($-1)+1;c++;const A=Math.min(Math.max(w,E),d.length),M=A-$;if(c++,A>d.length||M>m.length)continue;const T=e(A,M);j.set($,T);const S=A===w?L.get($+1):L.get($-1);if(L.set($,T!==A?new f(S,A,M,T-A):S),j.get($)===d.length&&j.get($)-$===m.length)break e}}let b=L.get($);const u=[];let l=d.length,n=m.length;for(;;){const s=b?b.x+b.length:0,N=b?b.y+b.length:0;if((s!==l||N!==n)&&u.push(new P.$t2(new i.$it(s,l),new i.$it(N,n))),!b)break;l=b.x,n=b.y,b=b.prev}return u.reverse(),new P.$s2(u,!1)}}t.$B2=y;class f{constructor(a,g,B,d){this.prev=a,this.x=g,this.y=B,this.length=d}}class p{constructor(){this.a=new Int32Array(10),this.b=new Int32Array(10)}get(a){return a<0?(a=-a-1,this.b[a]):this.a[a]}set(a,g){if(a<0){if(a=-a-1,a>=this.b.length){const B=this.b;this.b=new Int32Array(B.length*2),this.b.set(B)}this.b[a]=g}else{if(a>=this.a.length){const B=this.a;this.a=new Int32Array(B.length*2),this.a.set(B)}this.a[a]=g}}}class h{constructor(){this.a=[],this.b=[]}get(a){return a<0?(a=-a-1,this.b[a]):this.a[a]}set(a,g){a<0?(a=-a-1,this.b[a]=g):this.a[a]=g}}}),re(ie[47],se([0,1,6,4,8]),function(V,t,i,P,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$F2=f,t.$G2=a,t.$H2=g,t.$I2=d,t.$J2=m;function f(e,v,j){let L=j;return L=p(e,v,L),L=p(e,v,L),L=h(e,v,L),L}function p(e,v,j){if(j.length===0)return j;const L=[];L.push(j[0]);for(let b=1;b<j.length;b++){const u=L[L.length-1];let l=j[b];if(l.seq1Range.isEmpty||l.seq2Range.isEmpty){const n=l.seq1Range.start-u.seq1Range.endExclusive;let s;for(s=1;s<=n&&!(e.getElement(l.seq1Range.start-s)!==e.getElement(l.seq1Range.endExclusive-s)||v.getElement(l.seq2Range.start-s)!==v.getElement(l.seq2Range.endExclusive-s));s++);if(s--,s===n){L[L.length-1]=new y.$t2(new P.$it(u.seq1Range.start,l.seq1Range.endExclusive-n),new P.$it(u.seq2Range.start,l.seq2Range.endExclusive-n));continue}l=l.delta(-s)}L.push(l)}const $=[];for(let b=0;b<L.length-1;b++){const u=L[b+1];let l=L[b];if(l.seq1Range.isEmpty||l.seq2Range.isEmpty){const n=u.seq1Range.start-l.seq1Range.endExclusive;let s;for(s=0;s<n&&!(!e.isStronglyEqual(l.seq1Range.start+s,l.seq1Range.endExclusive+s)||!v.isStronglyEqual(l.seq2Range.start+s,l.seq2Range.endExclusive+s));s++);if(s===n){L[b+1]=new y.$t2(new P.$it(l.seq1Range.start+n,u.seq1Range.endExclusive),new P.$it(l.seq2Range.start+n,u.seq2Range.endExclusive));continue}s>0&&(l=l.delta(s))}$.push(l)}return L.length>0&&$.push(L[L.length-1]),$}function h(e,v,j){if(!e.getBoundaryScore||!v.getBoundaryScore)return j;for(let L=0;L<j.length;L++){const $=L>0?j[L-1]:void 0,b=j[L],u=L+1<j.length?j[L+1]:void 0,l=new P.$it($?$.seq1Range.endExclusive+1:0,u?u.seq1Range.start-1:e.length),n=new P.$it($?$.seq2Range.endExclusive+1:0,u?u.seq2Range.start-1:v.length);b.seq1Range.isEmpty?j[L]=o(b,e,v,l,n):b.seq2Range.isEmpty&&(j[L]=o(b.swap(),v,e,n,l).swap())}return j}function o(e,v,j,L,$){let u=1;for(;e.seq1Range.start-u>=L.start&&e.seq2Range.start-u>=$.start&&j.isStronglyEqual(e.seq2Range.start-u,e.seq2Range.endExclusive-u)&&u<100;)u++;u--;let l=0;for(;e.seq1Range.start+l<L.endExclusive&&e.seq2Range.endExclusive+l<$.endExclusive&&j.isStronglyEqual(e.seq2Range.start+l,e.seq2Range.endExclusive+l)&&l<100;)l++;if(u===0&&l===0)return e;let n=0,s=-1;for(let N=-u;N<=l;N++){const c=e.seq2Range.start+N,w=e.seq2Range.endExclusive+N,E=e.seq1Range.start+N,A=v.getBoundaryScore(E)+j.getBoundaryScore(c)+j.getBoundaryScore(w);A>s&&(s=A,n=N)}return e.delta(n)}function a(e,v,j){const L=[];for(const $ of j){const b=L[L.length-1];if(!b){L.push($);continue}$.seq1Range.start-b.seq1Range.endExclusive<=2||$.seq2Range.start-b.seq2Range.endExclusive<=2?L[L.length-1]=new y.$t2(b.seq1Range.join($.seq1Range),b.seq2Range.join($.seq2Range)):L.push($)}return L}function g(e,v,j){const L=y.$t2.invert(j,e.length),$=[];let b=new y.$u2(0,0);function u(n,s){if(n.offset1<b.offset1||n.offset2<b.offset2)return;const N=e.findWordContaining(n.offset1),c=v.findWordContaining(n.offset2);if(!N||!c)return;let w=new y.$t2(N,c);const E=w.intersect(s);let A=E.seq1Range.length,M=E.seq2Range.length;for(;L.length>0;){const T=L[0];if(!(T.seq1Range.intersects(w.seq1Range)||T.seq2Range.intersects(w.seq2Range)))break;const F=e.findWordContaining(T.seq1Range.start),R=v.findWordContaining(T.seq2Range.start),x=new y.$t2(F,R),I=x.intersect(T);if(A+=I.seq1Range.length,M+=I.seq2Range.length,w=w.join(x),w.seq1Range.endExclusive>=T.seq1Range.endExclusive)L.shift();else break}A+M<(w.seq1Range.length+w.seq2Range.length)*2/3&&$.push(w),b=w.getEndExclusives()}for(;L.length>0;){const n=L.shift();n.seq1Range.isEmpty||(u(n.getStarts(),n),u(n.getEndExclusives().delta(-1),n))}return B(j,$)}function B(e,v){const j=[];for(;e.length>0||v.length>0;){const L=e[0],$=v[0];let b;L&&(!$||L.seq1Range.start<$.seq1Range.start)?b=e.shift():b=v.shift(),j.length>0&&j[j.length-1].seq1Range.endExclusive>=b.seq1Range.start?j[j.length-1]=j[j.length-1].join(b):j.push(b)}return j}function d(e,v,j){let L=j;if(L.length===0)return L;let $=0,b;do{b=!1;const u=[L[0]];for(let l=1;l<L.length;l++){let N=function(w,E){const A=new P.$it(s.seq1Range.endExclusive,n.seq1Range.start);return e.getText(A).replace(/\s/g,"").length<=4&&(w.seq1Range.length+w.seq2Range.length>5||E.seq1Range.length+E.seq2Range.length>5)};const n=L[l],s=u[u.length-1];N(s,n)?(b=!0,u[u.length-1]=u[u.length-1].join(n)):u.push(n)}L=u}while($++<10&&b);return L}function m(e,v,j){let L=j;if(L.length===0)return L;let $=0,b;do{b=!1;const l=[L[0]];for(let n=1;n<L.length;n++){let c=function(E,A){const M=new P.$it(N.seq1Range.endExclusive,s.seq1Range.start);if(e.countLinesIn(M)>5||M.length>500)return!1;const S=e.getText(M).trim();if(S.length>20||S.split(/\r\n|\r|\n/).length>1)return!1;const F=e.countLinesIn(E.seq1Range),R=E.seq1Range.length,x=v.countLinesIn(E.seq2Range),I=E.seq2Range.length,H=e.countLinesIn(A.seq1Range),K=A.seq1Range.length,_=v.countLinesIn(A.seq2Range),X=A.seq2Range.length,Z=2*40+50;function k(z){return Math.min(z,Z)}return Math.pow(Math.pow(k(F*40+R),1.5)+Math.pow(k(x*40+I),1.5),1.5)+Math.pow(Math.pow(k(H*40+K),1.5)+Math.pow(k(_*40+X),1.5),1.5)>(Z**1.5)**1.5*1.3};const s=L[n],N=l[l.length-1];c(N,s)?(b=!0,l[l.length-1]=l[l.length-1].join(s)):l.push(s)}L=l}while($++<10&&b);const u=[];return(0,i.$Cb)(L,(l,n,s)=>{let N=n;function c(S){return S.length>0&&S.trim().length<=3&&n.seq1Range.length+n.seq2Range.length>100}const w=e.extendToFullLines(n.seq1Range),E=e.getText(new P.$it(w.start,n.seq1Range.start));c(E)&&(N=N.deltaStart(-E.length));const A=e.getText(new P.$it(n.seq1Range.endExclusive,w.endExclusive));c(A)&&(N=N.deltaEnd(A.length));const M=y.$t2.fromOffsetPairs(l?l.getEndExclusives():y.$u2.zero,s?s.getStarts():y.$u2.max),T=N.intersect(M);u.length>0&&T.getStarts().equals(u[u.length-1].getEndExclusives())?u[u.length-1]=u[u.length-1].join(T):u.push(T)}),u}}),re(ie[48],se([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$E2=void 0;class i{constructor(f,p){this.a=f,this.b=p}getElement(f){return this.a[f]}get length(){return this.a.length}getBoundaryScore(f){const p=f===0?0:P(this.b[f-1]),h=f===this.b.length?0:P(this.b[f]);return 1e3-(p+h)}getText(f){return this.b.slice(f.start,f.endExclusive).join(`
`)}isStronglyEqual(f,p){return this.b[f]===this.b[p]}}t.$E2=i;function P(y){let f=0;for(;f<y.length&&(y.charCodeAt(f)===32||y.charCodeAt(f)===9);)f++;return f}}),re(ie[15],se([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$z2=t.$x2=void 0,t.$y2=P;class i{constructor(p,h){this.width=p,this.height=h,this.a=[],this.a=new Array(p*h)}get(p,h){return this.a[p+h*this.width]}set(p,h,o){this.a[p+h*this.width]=o}}t.$x2=i;function P(f){return f===32||f===9}class y{static{this.a=new Map}static b(p){let h=this.a.get(p);return h===void 0&&(h=this.a.size,this.a.set(p,h)),h}constructor(p,h,o){this.range=p,this.lines=h,this.source=o,this.d=[];let a=0;for(let g=p.startLineNumber-1;g<p.endLineNumberExclusive-1;g++){const B=h[g];for(let m=0;m<B.length;m++){a++;const e=B[m],v=y.b(e);this.d[v]=(this.d[v]||0)+1}a++;const d=y.b(`
`);this.d[d]=(this.d[d]||0)+1}this.c=a}computeSimilarity(p){let h=0;const o=Math.max(this.d.length,p.d.length);for(let a=0;a<o;a++)h+=Math.abs((this.d[a]??0)-(p.d[a]??0));return 1-h/(this.c+p.c)}}t.$z2=y}),re(ie[49],se([0,1,4,8,15]),function(V,t,i,P,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$A2=void 0;class f{compute(h,o,a=P.$v2.instance,g){if(h.length===0||o.length===0)return P.$s2.trivial(h,o);const B=new y.$x2(h.length,o.length),d=new y.$x2(h.length,o.length),m=new y.$x2(h.length,o.length);for(let u=0;u<h.length;u++)for(let l=0;l<o.length;l++){if(!a.isValid())return P.$s2.trivialTimedOut(h,o);const n=u===0?0:B.get(u-1,l),s=l===0?0:B.get(u,l-1);let N;h.getElement(u)===o.getElement(l)?(u===0||l===0?N=0:N=B.get(u-1,l-1),u>0&&l>0&&d.get(u-1,l-1)===3&&(N+=m.get(u-1,l-1)),N+=g?g(u,l):1):N=-1;const c=Math.max(n,s,N);if(c===N){const w=u>0&&l>0?m.get(u-1,l-1):0;m.set(u,l,w+1),d.set(u,l,3)}else c===n?(m.set(u,l,0),d.set(u,l,1)):c===s&&(m.set(u,l,0),d.set(u,l,2));B.set(u,l,c)}const e=[];let v=h.length,j=o.length;function L(u,l){(u+1!==v||l+1!==j)&&e.push(new P.$t2(new i.$it(u+1,v),new i.$it(l+1,j))),v=u,j=l}let $=h.length-1,b=o.length-1;for(;$>=0&&b>=0;)d.get($,b)===3?(L($,b),$--,b--):d.get($,b)===1?$--:b--;return L(-1,-1),e.reverse(),new P.$s2(e,!1)}}t.$A2=f}),re(ie[32],se([0,1,9,4,5,2,15]),function(V,t,i,P,y,f,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$C2=void 0;class h{constructor(e,v,j){this.lines=e,this.considerWhitespaceChanges=j,this.b=[],this.c=[],this.d=[];let L=!1;v.start>0&&v.endExclusive>=e.length&&(v=new P.$it(v.start-1,v.endExclusive),L=!0),this.lineRange=v,this.c[0]=0;for(let $=this.lineRange.start;$<this.lineRange.endExclusive;$++){let b=e[$],u=0;if(L)u=b.length,b="",L=!1;else if(!j){const l=b.trimStart();u=b.length-l.length,b=l.trimEnd()}this.d.push(u);for(let l=0;l<b.length;l++)this.b.push(b.charCodeAt(l));$<e.length-1&&(this.b.push(10),this.c[$-this.lineRange.start+1]=this.b.length)}this.d.push(0)}toString(){return`Slice: "${this.text}"`}get text(){return this.getText(new P.$it(0,this.length))}getText(e){return this.b.slice(e.start,e.endExclusive).map(v=>String.fromCharCode(v)).join("")}getElement(e){return this.b[e]}get length(){return this.b.length}getBoundaryScore(e){const v=d(e>0?this.b[e-1]:-1),j=d(e<this.b.length?this.b[e]:-1);if(v===7&&j===8)return 0;if(v===8)return 150;let L=0;return v!==j&&(L+=10,v===0&&j===1&&(L+=1)),L+=B(v),L+=B(j),L}translateOffset(e){if(this.lineRange.isEmpty)return new y.$at(this.lineRange.start+1,1);const v=(0,i.$ib)(this.c,j=>j<=e);return new y.$at(this.lineRange.start+v+1,e-this.c[v]+this.d[v]+1)}translateRange(e){return f.$bt.fromPositions(this.translateOffset(e.start),this.translateOffset(e.endExclusive))}findWordContaining(e){if(e<0||e>=this.b.length||!o(this.b[e]))return;let v=e;for(;v>0&&o(this.b[v-1]);)v--;let j=e;for(;j<this.b.length&&o(this.b[j]);)j++;return new P.$it(v,j)}countLinesIn(e){return this.translateOffset(e.endExclusive).lineNumber-this.translateOffset(e.start).lineNumber}isStronglyEqual(e,v){return this.b[e]===this.b[v]}extendToFullLines(e){const v=(0,i.$hb)(this.c,L=>L<=e.start)??0,j=(0,i.$jb)(this.c,L=>e.endExclusive<=L)??this.b.length;return new P.$it(v,j)}}t.$C2=h;function o(m){return m>=97&&m<=122||m>=65&&m<=90||m>=48&&m<=57}var a;(function(m){m[m.WordLower=0]="WordLower",m[m.WordUpper=1]="WordUpper",m[m.WordNumber=2]="WordNumber",m[m.End=3]="End",m[m.Other=4]="Other",m[m.Separator=5]="Separator",m[m.Space=6]="Space",m[m.LineBreakCR=7]="LineBreakCR",m[m.LineBreakLF=8]="LineBreakLF"})(a||(a={}));const g={0:0,1:0,2:0,3:10,4:2,5:30,6:3,7:10,8:10};function B(m){return g[m]}function d(m){return m===10?8:m===13?7:(0,p.$y2)(m)?6:m>=97&&m<=122?0:m>=65&&m<=90?1:m>=48&&m<=57?2:m===-1?3:m===44||m===59?5:4}}),re(ie[33],se([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$qt=t.$pt=void 0;class i{constructor(f,p,h){this.changes=f,this.moves=p,this.hitTimeout=h}}t.$pt=i;class P{constructor(f,p){this.lineRangeMapping=f,this.changes=p}flip(){return new P(this.lineRangeMapping.flip(),this.changes.map(f=>f.flip()))}}t.$qt=P}),re(ie[16],se([0,1,12]),function(V,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ot=t.$nt=t.$mt=void 0;class P{static inverse(h,o,a){const g=[];let B=1,d=1;for(const e of h){const v=new P(new i.$kt(B,e.original.startLineNumber),new i.$kt(d,e.modified.startLineNumber));v.modified.isEmpty||g.push(v),B=e.original.endLineNumberExclusive,d=e.modified.endLineNumberExclusive}const m=new P(new i.$kt(B,o+1),new i.$kt(d,a+1));return m.modified.isEmpty||g.push(m),g}static clip(h,o,a){const g=[];for(const B of h){const d=B.original.intersect(o),m=B.modified.intersect(a);d&&!d.isEmpty&&m&&!m.isEmpty&&g.push(new P(d,m))}return g}constructor(h,o){this.original=h,this.modified=o}toString(){return`{${this.original.toString()}->${this.modified.toString()}}`}flip(){return new P(this.modified,this.original)}join(h){return new P(this.original.join(h.original),this.modified.join(h.modified))}get changedLineCount(){return Math.max(this.original.length,this.modified.length)}}t.$mt=P;class y extends P{constructor(h,o,a){super(h,o),this.innerChanges=a}flip(){return new y(this.modified,this.original,this.innerChanges?.map(h=>h.flip()))}}t.$nt=y;class f{constructor(h,o){this.originalRange=h,this.modifiedRange=o}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}flip(){return new f(this.modifiedRange,this.originalRange)}}t.$ot=f}),re(ie[50],se([0,1,8,16,6,9,22,12,4,32,15,31]),function(V,t,i,P,y,f,p,h,o,a,g,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$D2=d;function d(b,u,l,n,s,N){let{moves:c,excludedChanges:w}=e(b,u,l,N);if(!N.isValid())return[];const E=b.filter(M=>!w.has(M)),A=v(E,n,s,u,l,N);return(0,y.$1b)(c,A),c=L(c),c=c.filter(M=>{const T=M.original.toOffsetRange().slice(u).map(F=>F.trim());return T.join(`
`).length>=15&&m(T,F=>F.length>=2)>=2}),c=$(b,c),c}function m(b,u){let l=0;for(const n of b)u(n)&&l++;return l}function e(b,u,l,n){const s=[],N=b.filter(E=>E.modified.isEmpty&&E.original.length>=3).map(E=>new g.$z2(E.original,u,E)),c=new Set(b.filter(E=>E.original.isEmpty&&E.modified.length>=3).map(E=>new g.$z2(E.modified,l,E))),w=new Set;for(const E of N){let A=-1,M;for(const T of c){const S=E.computeSimilarity(T);S>A&&(A=S,M=T)}if(A>.9&&M&&(c.delete(M),s.push(new P.$mt(E.range,M.range)),w.add(E.source),w.add(M.source)),!n.isValid())return{moves:s,excludedChanges:w}}return{moves:s,excludedChanges:w}}function v(b,u,l,n,s,N){const c=[],w=new p.$Hc;for(const S of b)for(let F=S.original.startLineNumber;F<S.original.endLineNumberExclusive-2;F++){const R=`${u[F-1]}:${u[F+1-1]}:${u[F+2-1]}`;w.add(R,{range:new h.$kt(F,F+3)})}const E=[];b.sort((0,y.$7b)(S=>S.modified.startLineNumber,y.$9b));for(const S of b){let F=[];for(let R=S.modified.startLineNumber;R<S.modified.endLineNumberExclusive-2;R++){const x=`${l[R-1]}:${l[R+1-1]}:${l[R+2-1]}`,I=new h.$kt(R,R+3),H=[];w.forEach(x,({range:K})=>{for(const X of F)if(X.originalLineRange.endLineNumberExclusive+1===K.endLineNumberExclusive&&X.modifiedLineRange.endLineNumberExclusive+1===I.endLineNumberExclusive){X.originalLineRange=new h.$kt(X.originalLineRange.startLineNumber,K.endLineNumberExclusive),X.modifiedLineRange=new h.$kt(X.modifiedLineRange.startLineNumber,I.endLineNumberExclusive),H.push(X);return}const _={modifiedLineRange:I,originalLineRange:K};E.push(_),H.push(_)}),F=H}if(!N.isValid())return[]}E.sort((0,y.$$b)((0,y.$7b)(S=>S.modifiedLineRange.length,y.$9b)));const A=new h.$lt,M=new h.$lt;for(const S of E){const F=S.modifiedLineRange.startLineNumber-S.originalLineRange.startLineNumber,R=A.subtractFrom(S.modifiedLineRange),x=M.subtractFrom(S.originalLineRange).getWithDelta(F),I=R.getIntersection(x);for(const H of I.ranges){if(H.length<3)continue;const K=H,_=H.delta(-F);c.push(new P.$mt(_,K)),A.addRange(K),M.addRange(_)}}c.sort((0,y.$7b)(S=>S.original.startLineNumber,y.$9b));const T=new f.$mb(b);for(let S=0;S<c.length;S++){const F=c[S],R=T.findLastMonotonous(k=>k.original.startLineNumber<=F.original.startLineNumber),x=(0,f.$hb)(b,k=>k.modified.startLineNumber<=F.modified.startLineNumber),I=Math.max(F.original.startLineNumber-R.original.startLineNumber,F.modified.startLineNumber-x.modified.startLineNumber),H=T.findLastMonotonous(k=>k.original.startLineNumber<F.original.endLineNumberExclusive),K=(0,f.$hb)(b,k=>k.modified.startLineNumber<F.modified.endLineNumberExclusive),_=Math.max(H.original.endLineNumberExclusive-F.original.endLineNumberExclusive,K.modified.endLineNumberExclusive-F.modified.endLineNumberExclusive);let X;for(X=0;X<I;X++){const k=F.original.startLineNumber-X-1,z=F.modified.startLineNumber-X-1;if(k>n.length||z>s.length||A.contains(z)||M.contains(k)||!j(n[k-1],s[z-1],N))break}X>0&&(M.addRange(new h.$kt(F.original.startLineNumber-X,F.original.startLineNumber)),A.addRange(new h.$kt(F.modified.startLineNumber-X,F.modified.startLineNumber)));let Z;for(Z=0;Z<_;Z++){const k=F.original.endLineNumberExclusive+Z,z=F.modified.endLineNumberExclusive+Z;if(k>n.length||z>s.length||A.contains(z)||M.contains(k)||!j(n[k-1],s[z-1],N))break}Z>0&&(M.addRange(new h.$kt(F.original.endLineNumberExclusive,F.original.endLineNumberExclusive+Z)),A.addRange(new h.$kt(F.modified.endLineNumberExclusive,F.modified.endLineNumberExclusive+Z))),(X>0||Z>0)&&(c[S]=new P.$mt(new h.$kt(F.original.startLineNumber-X,F.original.endLineNumberExclusive+Z),new h.$kt(F.modified.startLineNumber-X,F.modified.endLineNumberExclusive+Z)))}return c}function j(b,u,l){if(b.trim()===u.trim())return!0;if(b.length>300&&u.length>300)return!1;const s=new B.$B2().compute(new a.$C2([b],new o.$it(0,1),!1),new a.$C2([u],new o.$it(0,1),!1),l);let N=0;const c=i.$t2.invert(s.diffs,b.length);for(const M of c)M.seq1Range.forEach(T=>{(0,g.$y2)(b.charCodeAt(T))||N++});function w(M){let T=0;for(let S=0;S<b.length;S++)(0,g.$y2)(M.charCodeAt(S))||T++;return T}const E=w(b.length>u.length?b:u);return N/E>.6&&E>10}function L(b){if(b.length===0)return b;b.sort((0,y.$7b)(l=>l.original.startLineNumber,y.$9b));const u=[b[0]];for(let l=1;l<b.length;l++){const n=u[u.length-1],s=b[l],N=s.original.startLineNumber-n.original.endLineNumberExclusive,c=s.modified.startLineNumber-n.modified.endLineNumberExclusive;if(N>=0&&c>=0&&N+c<=2){u[u.length-1]=n.join(s);continue}u.push(s)}return u}function $(b,u){const l=new f.$mb(b);return u=u.filter(n=>{const s=l.findLastMonotonous(w=>w.original.startLineNumber<n.original.endLineNumberExclusive)||new P.$mt(new h.$kt(1,1),new h.$kt(1,1)),N=(0,f.$hb)(b,w=>w.modified.startLineNumber<n.modified.endLineNumberExclusive);return s!==N}),u}}),re(ie[51],se([0,1,6,13,12,4,2,8,49,31,50,47,48,32,33,16]),function(V,t,i,P,y,f,p,h,o,a,g,B,d,m,e,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$K2=void 0,t.$L2=L,t.$M2=$;class j{constructor(){this.e=new o.$A2,this.f=new a.$B2}computeDiff(u,l,n){if(u.length<=1&&(0,i.$ub)(u,l,(Z,k)=>Z===k))return new e.$pt([],[],!1);if(u.length===1&&u[0].length===0||l.length===1&&l[0].length===0)return new e.$pt([new v.$nt(new y.$kt(1,u.length+1),new y.$kt(1,l.length+1),[new v.$ot(new p.$bt(1,1,u.length,u[0].length+1),new p.$bt(1,1,l.length,l[0].length+1))])],[],!1);const s=n.maxComputationTimeMs===0?h.$v2.instance:new h.$w2(n.maxComputationTimeMs),N=!n.ignoreTrimWhitespace,c=new Map;function w(Z){let k=c.get(Z);return k===void 0&&(k=c.size,c.set(Z,k)),k}const E=u.map(Z=>w(Z.trim())),A=l.map(Z=>w(Z.trim())),M=new d.$E2(E,u),T=new d.$E2(A,l),S=M.length+T.length<1700?this.e.compute(M,T,s,(Z,k)=>u[Z]===l[k]?l[k].length===0?.1:1+Math.log(1+l[k].length):.99):this.f.compute(M,T);let F=S.diffs,R=S.hitTimeout;F=(0,B.$F2)(M,T,F),F=(0,B.$I2)(M,T,F);const x=[],I=Z=>{if(N)for(let k=0;k<Z;k++){const z=H+k,ue=K+k;if(u[z]!==l[ue]){const oe=this.j(u,l,new h.$t2(new f.$it(z,z+1),new f.$it(ue,ue+1)),s,N);for(const r of oe.mappings)x.push(r);oe.hitTimeout&&(R=!0)}}};let H=0,K=0;for(const Z of F){(0,P.$ad)(()=>Z.seq1Range.start-H===Z.seq2Range.start-K);const k=Z.seq1Range.start-H;I(k),H=Z.seq1Range.endExclusive,K=Z.seq2Range.endExclusive;const z=this.j(u,l,Z,s,N);z.hitTimeout&&(R=!0);for(const ue of z.mappings)x.push(ue)}I(u.length-H);const _=L(x,u,l);let X=[];return n.computeMoves&&(X=this.h(_,u,l,E,A,s,N)),(0,P.$ad)(()=>{function Z(z,ue){if(z.lineNumber<1||z.lineNumber>ue.length)return!1;const oe=ue[z.lineNumber-1];return!(z.column<1||z.column>oe.length+1)}function k(z,ue){return!(z.startLineNumber<1||z.startLineNumber>ue.length+1||z.endLineNumberExclusive<1||z.endLineNumberExclusive>ue.length+1)}for(const z of _){if(!z.innerChanges)return!1;for(const ue of z.innerChanges)if(!(Z(ue.modifiedRange.getStartPosition(),l)&&Z(ue.modifiedRange.getEndPosition(),l)&&Z(ue.originalRange.getStartPosition(),u)&&Z(ue.originalRange.getEndPosition(),u)))return!1;if(!k(z.modified,l)||!k(z.original,u))return!1}return!0}),new e.$pt(_,X,R)}h(u,l,n,s,N,c,w){return(0,g.$D2)(u,l,n,s,N,c).map(M=>{const T=this.j(l,n,new h.$t2(M.original.toOffsetRange(),M.modified.toOffsetRange()),c,w),S=L(T.mappings,l,n,!0);return new e.$qt(M,S)})}j(u,l,n,s,N){const c=new m.$C2(u,n.seq1Range,N),w=new m.$C2(l,n.seq2Range,N),E=c.length+w.length<500?this.e.compute(c,w,s):this.f.compute(c,w,s);let A=E.diffs;return A=(0,B.$F2)(c,w,A),A=(0,B.$H2)(c,w,A),A=(0,B.$G2)(c,w,A),A=(0,B.$J2)(c,w,A),{mappings:A.map(T=>new v.$ot(c.translateRange(T.seq1Range),w.translateRange(T.seq2Range))),hitTimeout:E.hitTimeout}}}t.$K2=j;function L(b,u,l,n=!1){const s=[];for(const N of(0,i.$Ab)(b.map(c=>$(c,u,l)),(c,w)=>c.original.overlapOrTouch(w.original)||c.modified.overlapOrTouch(w.modified))){const c=N[0],w=N[N.length-1];s.push(new v.$nt(c.original.join(w.original),c.modified.join(w.modified),N.map(E=>E.innerChanges[0])))}return(0,P.$ad)(()=>!n&&s.length>0&&(s[0].modified.startLineNumber!==s[0].original.startLineNumber||l.length-s[s.length-1].modified.endLineNumberExclusive!==u.length-s[s.length-1].original.endLineNumberExclusive)?!1:(0,P.$bd)(s,(N,c)=>c.original.startLineNumber-N.original.endLineNumberExclusive===c.modified.startLineNumber-N.modified.endLineNumberExclusive&&N.original.endLineNumberExclusive<c.original.startLineNumber&&N.modified.endLineNumberExclusive<c.modified.startLineNumber)),s}function $(b,u,l){let n=0,s=0;b.modifiedRange.endColumn===1&&b.originalRange.endColumn===1&&b.originalRange.startLineNumber+n<=b.originalRange.endLineNumber&&b.modifiedRange.startLineNumber+n<=b.modifiedRange.endLineNumber&&(s=-1),b.modifiedRange.startColumn-1>=l[b.modifiedRange.startLineNumber-1].length&&b.originalRange.startColumn-1>=u[b.originalRange.startLineNumber-1].length&&b.originalRange.startLineNumber<=b.originalRange.endLineNumber+s&&b.modifiedRange.startLineNumber<=b.modifiedRange.endLineNumber+s&&(n=1);const N=new y.$kt(b.originalRange.startLineNumber+n,b.originalRange.endLineNumber+1+s),c=new y.$kt(b.modifiedRange.startLineNumber+n,b.modifiedRange.endLineNumber+1+s);return new v.$nt(N,c,[b])}}),re(ie[34],se([0,1,25,33,16,7,2,13,12]),function(V,t,i,P,y,f,p,h,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$st=t.$rt=void 0;const a=3;class g{computeDiff(n,s,N){const w=new L(n,s,{maxComputationTime:N.maxComputationTimeMs,shouldIgnoreTrimWhitespace:N.ignoreTrimWhitespace,shouldComputeCharChanges:!0,shouldMakePrettyDiff:!0,shouldPostProcessCharChanges:!0}).computeDiff(),E=[];let A=null;for(const M of w.changes){let T;M.originalEndLineNumber===0?T=new o.$kt(M.originalStartLineNumber+1,M.originalStartLineNumber+1):T=new o.$kt(M.originalStartLineNumber,M.originalEndLineNumber+1);let S;M.modifiedEndLineNumber===0?S=new o.$kt(M.modifiedStartLineNumber+1,M.modifiedStartLineNumber+1):S=new o.$kt(M.modifiedStartLineNumber,M.modifiedEndLineNumber+1);let F=new y.$nt(T,S,M.charChanges?.map(R=>new y.$ot(new p.$bt(R.originalStartLineNumber,R.originalStartColumn,R.originalEndLineNumber,R.originalEndColumn),new p.$bt(R.modifiedStartLineNumber,R.modifiedStartColumn,R.modifiedEndLineNumber,R.modifiedEndColumn))));A&&(A.modified.endLineNumberExclusive===F.modified.startLineNumber||A.original.endLineNumberExclusive===F.original.startLineNumber)&&(F=new y.$nt(A.original.join(F.original),A.modified.join(F.modified),A.innerChanges&&F.innerChanges?A.innerChanges.concat(F.innerChanges):void 0),E.pop()),E.push(F),A=F}return(0,h.$ad)(()=>(0,h.$bd)(E,(M,T)=>T.original.startLineNumber-M.original.endLineNumberExclusive===T.modified.startLineNumber-M.modified.endLineNumberExclusive&&M.original.endLineNumberExclusive<T.original.startLineNumber&&M.modified.endLineNumberExclusive<T.modified.startLineNumber)),new P.$pt(E,[],w.quitEarly)}}t.$rt=g;function B(l,n,s,N){return new i.$ht(l,n,s).ComputeDiff(N)}class d{constructor(n){const s=[],N=[];for(let c=0,w=n.length;c<w;c++)s[c]=$(n[c],1),N[c]=b(n[c],1);this.lines=n,this.a=s,this.b=N}getElements(){const n=[];for(let s=0,N=this.lines.length;s<N;s++)n[s]=this.lines[s].substring(this.a[s]-1,this.b[s]-1);return n}getStrictElement(n){return this.lines[n]}getStartLineNumber(n){return n+1}getEndLineNumber(n){return n+1}createCharSequence(n,s,N){const c=[],w=[],E=[];let A=0;for(let M=s;M<=N;M++){const T=this.lines[M],S=n?this.a[M]:1,F=n?this.b[M]:T.length+1;for(let R=S;R<F;R++)c[A]=T.charCodeAt(R-1),w[A]=M+1,E[A]=R,A++;!n&&M<N&&(c[A]=10,w[A]=M+1,E[A]=T.length+1,A++)}return new m(c,w,E)}}class m{constructor(n,s,N){this.a=n,this.b=s,this.d=N}toString(){return"["+this.a.map((n,s)=>(n===10?"\\n":String.fromCharCode(n))+`-(${this.b[s]},${this.d[s]})`).join(", ")+"]"}e(n,s){if(n<0||n>=s.length)throw new Error("Illegal index")}getElements(){return this.a}getStartLineNumber(n){return n>0&&n===this.b.length?this.getEndLineNumber(n-1):(this.e(n,this.b),this.b[n])}getEndLineNumber(n){return n===-1?this.getStartLineNumber(n+1):(this.e(n,this.b),this.a[n]===10?this.b[n]+1:this.b[n])}getStartColumn(n){return n>0&&n===this.d.length?this.getEndColumn(n-1):(this.e(n,this.d),this.d[n])}getEndColumn(n){return n===-1?this.getStartColumn(n+1):(this.e(n,this.d),this.a[n]===10?1:this.d[n]+1)}}class e{constructor(n,s,N,c,w,E,A,M){this.originalStartLineNumber=n,this.originalStartColumn=s,this.originalEndLineNumber=N,this.originalEndColumn=c,this.modifiedStartLineNumber=w,this.modifiedStartColumn=E,this.modifiedEndLineNumber=A,this.modifiedEndColumn=M}static createFromDiffChange(n,s,N){const c=s.getStartLineNumber(n.originalStart),w=s.getStartColumn(n.originalStart),E=s.getEndLineNumber(n.originalStart+n.originalLength-1),A=s.getEndColumn(n.originalStart+n.originalLength-1),M=N.getStartLineNumber(n.modifiedStart),T=N.getStartColumn(n.modifiedStart),S=N.getEndLineNumber(n.modifiedStart+n.modifiedLength-1),F=N.getEndColumn(n.modifiedStart+n.modifiedLength-1);return new e(c,w,E,A,M,T,S,F)}}function v(l){if(l.length<=1)return l;const n=[l[0]];let s=n[0];for(let N=1,c=l.length;N<c;N++){const w=l[N],E=w.originalStart-(s.originalStart+s.originalLength),A=w.modifiedStart-(s.modifiedStart+s.modifiedLength);Math.min(E,A)<a?(s.originalLength=w.originalStart+w.originalLength-s.originalStart,s.modifiedLength=w.modifiedStart+w.modifiedLength-s.modifiedStart):(n.push(w),s=w)}return n}class j{constructor(n,s,N,c,w){this.originalStartLineNumber=n,this.originalEndLineNumber=s,this.modifiedStartLineNumber=N,this.modifiedEndLineNumber=c,this.charChanges=w}static createFromDiffResult(n,s,N,c,w,E,A){let M,T,S,F,R;if(s.originalLength===0?(M=N.getStartLineNumber(s.originalStart)-1,T=0):(M=N.getStartLineNumber(s.originalStart),T=N.getEndLineNumber(s.originalStart+s.originalLength-1)),s.modifiedLength===0?(S=c.getStartLineNumber(s.modifiedStart)-1,F=0):(S=c.getStartLineNumber(s.modifiedStart),F=c.getEndLineNumber(s.modifiedStart+s.modifiedLength-1)),E&&s.originalLength>0&&s.originalLength<20&&s.modifiedLength>0&&s.modifiedLength<20&&w()){const x=N.createCharSequence(n,s.originalStart,s.originalStart+s.originalLength-1),I=c.createCharSequence(n,s.modifiedStart,s.modifiedStart+s.modifiedLength-1);if(x.getElements().length>0&&I.getElements().length>0){let H=B(x,I,w,!0).changes;A&&(H=v(H)),R=[];for(let K=0,_=H.length;K<_;K++)R.push(e.createFromDiffChange(H[K],x,I))}}return new j(M,T,S,F,R)}}class L{constructor(n,s,N){this.a=N.shouldComputeCharChanges,this.b=N.shouldPostProcessCharChanges,this.d=N.shouldIgnoreTrimWhitespace,this.e=N.shouldMakePrettyDiff,this.f=n,this.g=s,this.h=new d(n),this.j=new d(s),this.k=u(N.maxComputationTime),this.l=u(N.maxComputationTime===0?0:Math.min(N.maxComputationTime,5e3))}computeDiff(){if(this.h.lines.length===1&&this.h.lines[0].length===0)return this.j.lines.length===1&&this.j.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.j.lines.length,charChanges:void 0}]};if(this.j.lines.length===1&&this.j.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.h.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:void 0}]};const n=B(this.h,this.j,this.k,this.e),s=n.changes,N=n.quitEarly;if(this.d){const A=[];for(let M=0,T=s.length;M<T;M++)A.push(j.createFromDiffResult(this.d,s[M],this.h,this.j,this.l,this.a,this.b));return{quitEarly:N,changes:A}}const c=[];let w=0,E=0;for(let A=-1,M=s.length;A<M;A++){const T=A+1<M?s[A+1]:null,S=T?T.originalStart:this.f.length,F=T?T.modifiedStart:this.g.length;for(;w<S&&E<F;){const R=this.f[w],x=this.g[E];if(R!==x){{let I=$(R,1),H=$(x,1);for(;I>1&&H>1;){const K=R.charCodeAt(I-2),_=x.charCodeAt(H-2);if(K!==_)break;I--,H--}(I>1||H>1)&&this.m(c,w+1,1,I,E+1,1,H)}{let I=b(R,1),H=b(x,1);const K=R.length+1,_=x.length+1;for(;I<K&&H<_;){const X=R.charCodeAt(I-1),Z=R.charCodeAt(H-1);if(X!==Z)break;I++,H++}(I<K||H<_)&&this.m(c,w+1,I,K,E+1,H,_)}}w++,E++}T&&(c.push(j.createFromDiffResult(this.d,T,this.h,this.j,this.l,this.a,this.b)),w+=T.originalLength,E+=T.modifiedLength)}return{quitEarly:N,changes:c}}m(n,s,N,c,w,E,A){if(this.n(n,s,N,c,w,E,A))return;let M;this.a&&(M=[new e(s,N,s,c,w,E,w,A)]),n.push(new j(s,s,w,w,M))}n(n,s,N,c,w,E,A){const M=n.length;if(M===0)return!1;const T=n[M-1];return T.originalEndLineNumber===0||T.modifiedEndLineNumber===0?!1:T.originalEndLineNumber===s&&T.modifiedEndLineNumber===w?(this.a&&T.charChanges&&T.charChanges.push(new e(s,N,s,c,w,E,w,A)),!0):T.originalEndLineNumber+1===s&&T.modifiedEndLineNumber+1===w?(T.originalEndLineNumber=s,T.modifiedEndLineNumber=w,this.a&&T.charChanges&&T.charChanges.push(new e(s,N,s,c,w,E,w,A)),!0):!1}}t.$st=L;function $(l,n){const s=f.$af(l);return s===-1?n:s+1}function b(l,n){const s=f.$cf(l);return s===-1?n:s+2}function u(l){if(l===0)return()=>!0;const n=Date.now();return()=>Date.now()-n<l}}),re(ie[52],se([0,1,34,51]),function(V,t,i,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$N2=void 0,t.$N2={getLegacy:()=>new i.$rt,getDefault:()=>new P.$K2}}),re(ie[53],se([0,1,36]),function(V,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$O2=B;function P(d){const m=[];for(const e of d){const v=Number(e);(v||v===0&&e.replace(/\s/g,"")!=="")&&m.push(v)}return m}function y(d,m,e,v){return{red:d/255,blue:e/255,green:m/255,alpha:v}}function f(d,m){const e=m.index,v=m[0].length;if(!e)return;const j=d.positionAt(e);return{startLineNumber:j.lineNumber,startColumn:j.column,endLineNumber:j.lineNumber,endColumn:j.column+v}}function p(d,m){if(!d)return;const e=i.$Ft.Format.CSS.parseHex(m);if(e)return{range:d,color:y(e.rgba.r,e.rgba.g,e.rgba.b,e.rgba.a)}}function h(d,m,e){if(!d||m.length!==1)return;const j=m[0].values(),L=P(j);return{range:d,color:y(L[0],L[1],L[2],e?L[3]:1)}}function o(d,m,e){if(!d||m.length!==1)return;const j=m[0].values(),L=P(j),$=new i.$Ft(new i.$Dt(L[0],L[1]/100,L[2]/100,e?L[3]:1));return{range:d,color:y($.rgba.r,$.rgba.g,$.rgba.b,$.rgba.a)}}function a(d,m){return typeof d=="string"?[...d.matchAll(m)]:d.findMatches(m)}function g(d){const m=[],v=a(d,/\b(rgb|rgba|hsl|hsla)(\([0-9\s,.\%]*\))|(#)([A-Fa-f0-9]{3})\b|(#)([A-Fa-f0-9]{4})\b|(#)([A-Fa-f0-9]{6})\b|(#)([A-Fa-f0-9]{8})\b/gm);if(v.length>0)for(const j of v){const L=j.filter(l=>l!==void 0),$=L[1],b=L[2];if(!b)continue;let u;if($==="rgb"){const l=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*\)$/gm;u=h(f(d,j),a(b,l),!1)}else if($==="rgba"){const l=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;u=h(f(d,j),a(b,l),!0)}else if($==="hsl"){const l=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*\)$/gm;u=o(f(d,j),a(b,l),!1)}else if($==="hsla"){const l=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;u=o(f(d,j),a(b,l),!0)}else $==="#"&&(u=p(f(d,j),$+b));u&&m.push(u)}return m}function B(d){return!d||typeof d.getValue!="function"||typeof d.positionAt!="function"?[]:g(d)}}),re(ie[54],se([0,1,29]),function(V,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$n2=t.$m2=t.State=void 0,t.$o2=d;var P;(function(m){m[m.Invalid=0]="Invalid",m[m.Start=1]="Start",m[m.H=2]="H",m[m.HT=3]="HT",m[m.HTT=4]="HTT",m[m.HTTP=5]="HTTP",m[m.F=6]="F",m[m.FI=7]="FI",m[m.FIL=8]="FIL",m[m.BeforeColon=9]="BeforeColon",m[m.AfterColon=10]="AfterColon",m[m.AlmostThere=11]="AlmostThere",m[m.End=12]="End",m[m.Accept=13]="Accept",m[m.LastKnownState=14]="LastKnownState"})(P||(t.State=P={}));class y{constructor(e,v,j){const L=new Uint8Array(e*v);for(let $=0,b=e*v;$<b;$++)L[$]=j;this.a=L,this.rows=e,this.cols=v}get(e,v){return this.a[e*this.cols+v]}set(e,v,j){this.a[e*this.cols+v]=j}}class f{constructor(e){let v=0,j=0;for(let $=0,b=e.length;$<b;$++){const[u,l,n]=e[$];l>v&&(v=l),u>j&&(j=u),n>j&&(j=n)}v++,j++;const L=new y(j,v,0);for(let $=0,b=e.length;$<b;$++){const[u,l,n]=e[$];L.set(u,l,n)}this.a=L,this.b=v}nextState(e,v){return v<0||v>=this.b?0:this.a.get(e,v)}}t.$m2=f;let p=null;function h(){return p===null&&(p=new f([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),p}var o;(function(m){m[m.None=0]="None",m[m.ForceTermination=1]="ForceTermination",m[m.CannotEndIn=2]="CannotEndIn"})(o||(o={}));let a=null;function g(){if(a===null){a=new i.$yt(0);const m=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let v=0;v<m.length;v++)a.set(m.charCodeAt(v),1);const e=".,;:";for(let v=0;v<e.length;v++)a.set(e.charCodeAt(v),2)}return a}class B{static a(e,v,j,L,$){let b=$-1;do{const u=v.charCodeAt(b);if(e.get(u)!==2)break;b--}while(b>L);if(L>0){const u=v.charCodeAt(L-1),l=v.charCodeAt(b);(u===40&&l===41||u===91&&l===93||u===123&&l===125)&&b--}return{range:{startLineNumber:j,startColumn:L+1,endLineNumber:j,endColumn:b+2},url:v.substring(L,b+1)}}static computeLinks(e,v=h()){const j=g(),L=[];for(let $=1,b=e.getLineCount();$<=b;$++){const u=e.getLineContent($),l=u.length;let n=0,s=0,N=0,c=1,w=!1,E=!1,A=!1,M=!1;for(;n<l;){let T=!1;const S=u.charCodeAt(n);if(c===13){let F;switch(S){case 40:w=!0,F=0;break;case 41:F=w?0:1;break;case 91:A=!0,E=!0,F=0;break;case 93:A=!1,F=E?0:1;break;case 123:M=!0,F=0;break;case 125:F=M?0:1;break;case 39:case 34:case 96:N===S?F=1:N===39||N===34||N===96?F=0:F=1;break;case 42:F=N===42?1:0;break;case 124:F=N===124?1:0;break;case 32:F=A?0:1;break;default:F=j.get(S)}F===1&&(L.push(B.a(j,u,$,s,n)),T=!0)}else if(c===12){let F;S===91?(E=!0,F=0):F=j.get(S),F===1?T=!0:c=13}else c=v.nextState(c,S),c===0&&(T=!0);T&&(c=1,w=!1,E=!1,M=!1,s=n+1,N=S),n++}c===13&&L.push(B.a(j,u,$,s,l))}return L}}t.$n2=B;function d(m){return!m||typeof m.getLineCount!="function"||typeof m.getLineContent!="function"?[]:B.computeLinks(m)}}),re(ie[55],se([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$p2=void 0;class i{constructor(){this.c=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}static{this.INSTANCE=new i}navigateValueSet(y,f,p,h,o){if(y&&f){const a=this.a(f,o);if(a)return{range:y,value:a}}if(p&&h){const a=this.a(h,o);if(a)return{range:p,value:a}}return null}a(y,f){const p=this.b(y,f);return p!==null?p:this.d(y,f)}b(y,f){const p=Math.pow(10,y.length-(y.lastIndexOf(".")+1));let h=Number(y);const o=parseFloat(y);return!isNaN(h)&&!isNaN(o)&&h===o?h===0&&!f?null:(h=Math.floor(h*p),h+=f?p:-p,String(h/p)):null}d(y,f){return this.e(this.c,y,f)}e(y,f,p){let h=null;for(let o=0,a=y.length;h===null&&o<a;o++)h=this.f(y[o],f,p);return h}f(y,f,p){let h=y.indexOf(f);return h>=0?(h+=p?1:-1,h<0?h=y.length-1:h%=y.length,y[h]):null}}t.$p2=i}),re(ie[56],se([0,1,14]),function(V,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$zv=t.$yv=t.$xv=t.ModelConstants=t.PositionAffinity=t.TrackedRangeStickiness=t.$vv=t.$uv=t.EndOfLineSequence=t.DefaultEndOfLine=t.EndOfLinePreference=t.InjectedTextCursorStops=t.MinimapPosition=t.GlyphMarginLane=t.OverviewRulerLane=void 0,t.$wv=m,t.$Av=b;var P;(function(u){u[u.Left=1]="Left",u[u.Center=2]="Center",u[u.Right=4]="Right",u[u.Full=7]="Full"})(P||(t.OverviewRulerLane=P={}));var y;(function(u){u[u.Left=1]="Left",u[u.Center=2]="Center",u[u.Right=3]="Right"})(y||(t.GlyphMarginLane=y={}));var f;(function(u){u[u.Inline=1]="Inline",u[u.Gutter=2]="Gutter"})(f||(t.MinimapPosition=f={}));var p;(function(u){u[u.Both=0]="Both",u[u.Right=1]="Right",u[u.Left=2]="Left",u[u.None=3]="None"})(p||(t.InjectedTextCursorStops=p={}));var h;(function(u){u[u.TextDefined=0]="TextDefined",u[u.LF=1]="LF",u[u.CRLF=2]="CRLF"})(h||(t.EndOfLinePreference=h={}));var o;(function(u){u[u.LF=1]="LF",u[u.CRLF=2]="CRLF"})(o||(t.DefaultEndOfLine=o={}));var a;(function(u){u[u.LF=0]="LF",u[u.CRLF=1]="CRLF"})(a||(t.EndOfLineSequence=a={}));class g{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(l){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,l.tabSize|0),l.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,l.indentSize|0),this.a=!1),this.insertSpaces=!!l.insertSpaces,this.defaultEOL=l.defaultEOL|0,this.trimAutoWhitespace=!!l.trimAutoWhitespace,this.bracketPairColorizationOptions=l.bracketPairColorizationOptions}equals(l){return this.tabSize===l.tabSize&&this.a===l.a&&this.indentSize===l.indentSize&&this.insertSpaces===l.insertSpaces&&this.defaultEOL===l.defaultEOL&&this.trimAutoWhitespace===l.trimAutoWhitespace&&(0,i.$Rn)(this.bracketPairColorizationOptions,l.bracketPairColorizationOptions)}createChangeEvent(l){return{tabSize:this.tabSize!==l.tabSize,indentSize:this.indentSize!==l.indentSize,insertSpaces:this.insertSpaces!==l.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==l.trimAutoWhitespace}}}t.$uv=g;class B{constructor(l,n){this._findMatchBrand=void 0,this.range=l,this.matches=n}}t.$vv=B;var d;(function(u){u[u.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",u[u.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",u[u.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",u[u.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(d||(t.TrackedRangeStickiness=d={}));function m(u){return u&&typeof u.read=="function"}var e;(function(u){u[u.Left=0]="Left",u[u.Right=1]="Right",u[u.None=2]="None",u[u.LeftOfInjectedText=3]="LeftOfInjectedText",u[u.RightOfInjectedText=4]="RightOfInjectedText"})(e||(t.PositionAffinity=e={}));var v;(function(u){u[u.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(v||(t.ModelConstants=v={}));class j{constructor(l,n,s,N,c,w){this.identifier=l,this.range=n,this.text=s,this.forceMoveMarkers=N,this.isAutoWhitespaceEdit=c,this._isTracked=w}}t.$xv=j;class L{constructor(l,n,s){this.regex=l,this.wordSeparators=n,this.simpleSearch=s}}t.$yv=L;class ${constructor(l,n,s){this.reverseEdits=l,this.changes=n,this.trimAutoWhitespaceLineNumbers=s}}t.$zv=$;function b(u){return!u.isTooLargeForSyncing()&&!u.isForSimpleWidget}}),re(ie[57],se([0,1,6,28]),function(V,t,i,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Fv=t.$Ev=t.$Dv=void 0;class y{constructor(o){this.a=o,this.b=new Uint32Array(o.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(o,a){o=(0,P.$Te)(o);const g=this.a,B=this.b,d=a.length;return d===0?!1:(this.a=new Uint32Array(g.length+d),this.a.set(g.subarray(0,o),0),this.a.set(g.subarray(o),o+d),this.a.set(a,o),o-1<this.c[0]&&(this.c[0]=o-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(B.subarray(0,this.c[0]+1)),!0)}setValue(o,a){return o=(0,P.$Te)(o),a=(0,P.$Te)(a),this.a[o]===a?!1:(this.a[o]=a,o-1<this.c[0]&&(this.c[0]=o-1),!0)}removeValues(o,a){o=(0,P.$Te)(o),a=(0,P.$Te)(a);const g=this.a,B=this.b;if(o>=g.length)return!1;const d=g.length-o;return a>=d&&(a=d),a===0?!1:(this.a=new Uint32Array(g.length-a),this.a.set(g.subarray(0,o),0),this.a.set(g.subarray(o+a),o),this.b=new Uint32Array(this.a.length),o-1<this.c[0]&&(this.c[0]=o-1),this.c[0]>=0&&this.b.set(B.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(o){return o<0?0:(o=(0,P.$Te)(o),this.d(o))}d(o){if(o<=this.c[0])return this.b[o];let a=this.c[0]+1;a===0&&(this.b[0]=this.a[0],a++),o>=this.a.length&&(o=this.a.length-1);for(let g=a;g<=o;g++)this.b[g]=this.b[g-1]+this.a[g];return this.c[0]=Math.max(this.c[0],o),this.b[o]}getIndexOf(o){o=Math.floor(o),this.getTotalSum();let a=0,g=this.a.length-1,B=0,d=0,m=0;for(;a<=g;)if(B=a+(g-a)/2|0,d=this.b[B],m=d-this.a[B],o<m)g=B-1;else if(o>=d)a=B+1;else break;return new p(B,o-m)}}t.$Dv=y;class f{constructor(o){this.a=o,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(o){return this.g(),o===0?0:this.d[o-1]}getIndexOf(o){this.g();const a=this.e[o],g=a>0?this.d[a-1]:0;return new p(a,o-g)}removeValues(o,a){this.a.splice(o,a),this.f(o)}insertValues(o,a){this.a=(0,i.$Wb)(this.a,o,a),this.f(o)}f(o){this.b=!1,this.c=Math.min(this.c,o-1)}g(){if(!this.b){for(let o=this.c+1,a=this.a.length;o<a;o++){const g=this.a[o],B=o>0?this.d[o-1]:0;this.d[o]=B+g;for(let d=0;d<g;d++)this.e[B+d]=o}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(o,a){this.a[o]!==a&&(this.a[o]=a,this.f(o))}}t.$Ev=f;class p{constructor(o,a){this.index=o,this.remainder=a,this._prefixSumIndexOfResultBrand=void 0,this.index=o,this.remainder=a}}t.$Fv=p}),re(ie[58],se([0,1,7,5,57]),function(V,t,i,P,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Gv=void 0;class f{constructor(h,o,a,g){this.d=h,this.f=o,this.g=a,this.h=g,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(h){h.eol&&h.eol!==this.g&&(this.g=h.eol,this.j=null);const o=h.changes;for(const a of o)this.o(a.range),this.p(new P.$at(a.range.startLineNumber,a.range.startColumn),a.text);this.h=h.versionId,this.k=null}l(){if(!this.j){const h=this.g.length,o=this.f.length,a=new Uint32Array(o);for(let g=0;g<o;g++)a[g]=this.f[g].length+h;this.j=new y.$Dv(a)}}n(h,o){this.f[h]=o,this.j&&this.j.setValue(h,this.f[h].length+this.g.length)}o(h){if(h.startLineNumber===h.endLineNumber){if(h.startColumn===h.endColumn)return;this.n(h.startLineNumber-1,this.f[h.startLineNumber-1].substring(0,h.startColumn-1)+this.f[h.startLineNumber-1].substring(h.endColumn-1));return}this.n(h.startLineNumber-1,this.f[h.startLineNumber-1].substring(0,h.startColumn-1)+this.f[h.endLineNumber-1].substring(h.endColumn-1)),this.f.splice(h.startLineNumber,h.endLineNumber-h.startLineNumber),this.j&&this.j.removeValues(h.startLineNumber,h.endLineNumber-h.startLineNumber)}p(h,o){if(o.length===0)return;const a=(0,i.$$e)(o);if(a.length===1){this.n(h.lineNumber-1,this.f[h.lineNumber-1].substring(0,h.column-1)+a[0]+this.f[h.lineNumber-1].substring(h.column-1));return}a[a.length-1]+=this.f[h.lineNumber-1].substring(h.column-1),this.n(h.lineNumber-1,this.f[h.lineNumber-1].substring(0,h.column-1)+a[0]);const g=new Uint32Array(a.length-1);for(let B=1;B<a.length;B++)this.f.splice(h.lineNumber+B-1,0,a[B]),g[B-1]=a[B].length+this.g.length;this.j&&this.j.insertValues(h.lineNumber,g)}}t.$Gv=f}),re(ie[59],se([0,1,7,46,5,2,56]),function(V,t,i,P,y,f,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$sC=t.$qC=t.$nC=void 0,t.$oC=a,t.$pC=g,t.$rC=v;const h=999;class o{constructor($,b,u,l){this.searchString=$,this.isRegex=b,this.matchCase=u,this.wordSeparators=l}parseSearchRequest(){if(this.searchString==="")return null;let $;this.isRegex?$=a(this.searchString):$=this.searchString.indexOf(`
`)>=0;let b=null;try{b=i.$9e(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:$,global:!0,unicode:!0})}catch{return null}if(!b)return null;let u=!this.isRegex&&!$;return u&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(u=this.matchCase),new p.$yv(b,this.wordSeparators?(0,P.$Bt)(this.wordSeparators):null,u?this.searchString:null)}}t.$nC=o;function a(L){if(!L||L.length===0)return!1;for(let $=0,b=L.length;$<b;$++){const u=L.charCodeAt($);if(u===10)return!0;if(u===92){if($++,$>=b)break;const l=L.charCodeAt($);if(l===110||l===114||l===87)return!0}}return!1}function g(L,$,b){if(!b)return new p.$vv(L,null);const u=[];for(let l=0,n=$.length;l<n;l++)u[l]=$[l];return new p.$vv(L,u)}class B{constructor($){const b=[];let u=0;for(let l=0,n=$.length;l<n;l++)$.charCodeAt(l)===10&&(b[u++]=l);this.a=b}findLineFeedCountBeforeOffset($){const b=this.a;let u=0,l=b.length-1;if(l===-1||$<=b[0])return 0;for(;u<l;){const n=u+((l-u)/2>>0);b[n]>=$?l=n-1:b[n+1]>=$?(u=n,l=n):u=n+1}return u+1}}class d{static findMatches($,b,u,l,n){const s=b.parseSearchRequest();return s?s.regex.multiline?this.b($,u,new j(s.wordSeparators,s.regex),l,n):this.c($,u,s,l,n):[]}static a($,b,u,l,n,s){let N,c=0;l?(c=l.findLineFeedCountBeforeOffset(n),N=b+n+c):N=b+n;let w;if(l){const T=l.findLineFeedCountBeforeOffset(n+s.length)-c;w=N+s.length+T}else w=N+s.length;const E=$.getPositionAt(N),A=$.getPositionAt(w);return new f.$bt(E.lineNumber,E.column,A.lineNumber,A.column)}static b($,b,u,l,n){const s=$.getOffsetAt(b.getStartPosition()),N=$.getValueInRange(b,1),c=$.getEOL()===`\r
`?new B(N):null,w=[];let E=0,A;for(u.reset(0);A=u.next(N);)if(w[E++]=g(this.a($,s,N,c,A.index,A[0]),A,l),E>=n)return w;return w}static c($,b,u,l,n){const s=[];let N=0;if(b.startLineNumber===b.endLineNumber){const w=$.getLineContent(b.startLineNumber).substring(b.startColumn-1,b.endColumn-1);return N=this.d(u,w,b.startLineNumber,b.startColumn-1,N,s,l,n),s}const c=$.getLineContent(b.startLineNumber).substring(b.startColumn-1);N=this.d(u,c,b.startLineNumber,b.startColumn-1,N,s,l,n);for(let w=b.startLineNumber+1;w<b.endLineNumber&&N<n;w++)N=this.d(u,$.getLineContent(w),w,0,N,s,l,n);if(N<n){const w=$.getLineContent(b.endLineNumber).substring(0,b.endColumn-1);N=this.d(u,w,b.endLineNumber,0,N,s,l,n)}return s}static d($,b,u,l,n,s,N,c){const w=$.wordSeparators;if(!N&&$.simpleSearch){const M=$.simpleSearch,T=M.length,S=b.length;let F=-T;for(;(F=b.indexOf(M,F+T))!==-1;)if((!w||v(w,b,S,F,T))&&(s[n++]=new p.$vv(new f.$bt(u,F+1+l,u,F+1+T+l),null),n>=c))return n;return n}const E=new j($.wordSeparators,$.regex);let A;E.reset(0);do if(A=E.next(b),A&&(s[n++]=g(new f.$bt(u,A.index+1+l,u,A.index+1+A[0].length+l),A,N),n>=c))return n;while(A);return n}static findNextMatch($,b,u,l){const n=b.parseSearchRequest();if(!n)return null;const s=new j(n.wordSeparators,n.regex);return n.regex.multiline?this.e($,u,s,l):this.f($,u,s,l)}static e($,b,u,l){const n=new y.$at(b.lineNumber,1),s=$.getOffsetAt(n),N=$.getLineCount(),c=$.getValueInRange(new f.$bt(n.lineNumber,n.column,N,$.getLineMaxColumn(N)),1),w=$.getEOL()===`\r
`?new B(c):null;u.reset(b.column-1);const E=u.next(c);return E?g(this.a($,s,c,w,E.index,E[0]),E,l):b.lineNumber!==1||b.column!==1?this.e($,new y.$at(1,1),u,l):null}static f($,b,u,l){const n=$.getLineCount(),s=b.lineNumber,N=$.getLineContent(s),c=this.g(u,N,s,b.column,l);if(c)return c;for(let w=1;w<=n;w++){const E=(s+w-1)%n,A=$.getLineContent(E+1),M=this.g(u,A,E+1,1,l);if(M)return M}return null}static g($,b,u,l,n){$.reset(l-1);const s=$.next(b);return s?g(new f.$bt(u,s.index+1,u,s.index+1+s[0].length),s,n):null}static findPreviousMatch($,b,u,l){const n=b.parseSearchRequest();if(!n)return null;const s=new j(n.wordSeparators,n.regex);return n.regex.multiline?this.h($,u,s,l):this.j($,u,s,l)}static h($,b,u,l){const n=this.b($,new f.$bt(1,1,b.lineNumber,b.column),u,l,10*h);if(n.length>0)return n[n.length-1];const s=$.getLineCount();return b.lineNumber!==s||b.column!==$.getLineMaxColumn(s)?this.h($,new y.$at(s,$.getLineMaxColumn(s)),u,l):null}static j($,b,u,l){const n=$.getLineCount(),s=b.lineNumber,N=$.getLineContent(s).substring(0,b.column-1),c=this.k(u,N,s,l);if(c)return c;for(let w=1;w<=n;w++){const E=(n+s-w-1)%n,A=$.getLineContent(E+1),M=this.k(u,A,E+1,l);if(M)return M}return null}static k($,b,u,l){let n=null,s;for($.reset(0);s=$.next(b);)n=g(new f.$bt(u,s.index+1,u,s.index+1+s[0].length),s,l);return n}}t.$qC=d;function m(L,$,b,u,l){if(u===0)return!0;const n=$.charCodeAt(u-1);if(L.get(n)!==0||n===13||n===10)return!0;if(l>0){const s=$.charCodeAt(u);if(L.get(s)!==0)return!0}return!1}function e(L,$,b,u,l){if(u+l===b)return!0;const n=$.charCodeAt(u+l);if(L.get(n)!==0||n===13||n===10)return!0;if(l>0){const s=$.charCodeAt(u+l-1);if(L.get(s)!==0)return!0}return!1}function v(L,$,b,u,l){return m(L,$,b,u,l)&&e(L,$,b,u,l)}class j{constructor($,b){this._wordSeparators=$,this.a=b,this.b=-1,this.c=0}reset($){this.a.lastIndex=$,this.b=-1,this.c=0}next($){const b=$.length;let u;do{if(this.b+this.c===b||(u=this.a.exec($),!u))return null;const l=u.index,n=u[0].length;if(l===this.b&&n===this.c){if(n===0){i.$sf($,b,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=l,this.c=n,!this._wordSeparators||v(this._wordSeparators,$,b,l,n))return u}while(u);return null}}t.$sC=j}),re(ie[60],se([0,1,2,59,7,13,30]),function(V,t,i,P,y,f,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UnicodeHighlighterReasonKind=t.$l2=void 0;class h{static computeUnicodeHighlights(e,v,j){const L=j?j.startLineNumber:1,$=j?j.endLineNumber:e.getLineCount(),b=new g(v),u=b.getCandidateCodePoints();let l;u==="allNonBasicAscii"?l=new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):l=new RegExp(`${o(Array.from(u))}`,"g");const n=new P.$sC(null,l),s=[];let N=!1,c,w=0,E=0,A=0;e:for(let M=L,T=$;M<=T;M++){const S=e.getLineContent(M),F=S.length;n.reset(0);do if(c=n.next(S),c){let R=c.index,x=c.index+c[0].length;if(R>0){const _=S.charCodeAt(R-1);y.$pf(_)&&R--}if(x+1<F){const _=S.charCodeAt(x-1);y.$pf(_)&&x++}const I=S.substring(R,x);let H=(0,p.$Qs)(R+1,p.$Ns,S,0);H&&H.endColumn<=R+1&&(H=null);const K=b.shouldHighlightNonBasicASCII(I,H?H.word:null);if(K!==0){if(K===3?w++:K===2?E++:K===1?A++:(0,f.$0c)(K),s.length>=1e3){N=!0;break e}s.push(new i.$bt(M,R+1,M,x+1))}}while(c)}return{ranges:s,hasMore:N,ambiguousCharacterCount:w,invisibleCharacterCount:E,nonBasicAsciiCharacterCount:A}}static computeUnicodeHighlightReason(e,v){const j=new g(v);switch(j.shouldHighlightNonBasicASCII(e,null)){case 0:return null;case 2:return{kind:1};case 3:{const $=e.codePointAt(0),b=j.ambiguousCharacters.getPrimaryConfusable($),u=y.$Sf.getLocales().filter(l=>!y.$Sf.getInstance(new Set([...v.allowedLocales,l])).isAmbiguous($));return{kind:0,confusableWith:String.fromCodePoint(b),notAmbiguousInLocales:u}}case 1:return{kind:2}}}}t.$l2=h;function o(m,e){return`[${y.$Ze(m.map(j=>String.fromCodePoint(j)).join(""))}]`}var a;(function(m){m[m.Ambiguous=0]="Ambiguous",m[m.Invisible=1]="Invisible",m[m.NonBasicAscii=2]="NonBasicAscii"})(a||(t.UnicodeHighlighterReasonKind=a={}));class g{constructor(e){this.b=e,this.a=new Set(e.allowedCodePoints),this.ambiguousCharacters=y.$Sf.getInstance(new Set(e.allowedLocales))}getCandidateCodePoints(){if(this.b.nonBasicASCII)return"allNonBasicAscii";const e=new Set;if(this.b.invisibleCharacters)for(const v of y.$Tf.codePoints)B(String.fromCodePoint(v))||e.add(v);if(this.b.ambiguousCharacters)for(const v of this.ambiguousCharacters.getConfusableCodePoints())e.add(v);for(const v of this.a)e.delete(v);return e}shouldHighlightNonBasicASCII(e,v){const j=e.codePointAt(0);if(this.a.has(j))return 0;if(this.b.nonBasicASCII)return 1;let L=!1,$=!1;if(v)for(const b of v){const u=b.codePointAt(0),l=y.$Af(b);L=L||l,!l&&!this.ambiguousCharacters.isAmbiguous(u)&&!y.$Tf.isInvisibleCharacter(u)&&($=!0)}return!L&&$?0:this.b.invisibleCharacters&&!B(e)&&y.$Tf.isInvisibleCharacter(j)?2:this.b.ambiguousCharacters&&this.ambiguousCharacters.isAmbiguous(j)?3:0}}function B(m){return m===" "||m===`
`||m==="	"}var d;(function(m){m[m.None=0]="None",m[m.NonBasicASCII=1]="NonBasicASCII",m[m.Invisible=2]="Invisible",m[m.Ambiguous=3]="Ambiguous"})(d||(d={}))}),re(ie[61],se([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WrappingIndent=t.TrackedRangeStickiness=t.TextEditorCursorStyle=t.TextEditorCursorBlinkingStyle=t.SymbolTag=t.SymbolKind=t.SignatureHelpTriggerKind=t.ShowLightbulbIconMode=t.SelectionDirection=t.ScrollbarVisibility=t.ScrollType=t.RenderMinimap=t.RenderLineNumbersType=t.PositionAffinity=t.PartialAcceptTriggerKind=t.OverviewRulerLane=t.OverlayWidgetPositionPreference=t.NewSymbolNameTag=t.MouseTargetType=t.MinimapPosition=t.MarkerTag=t.MarkerSeverity=t.KeyCode=t.InlineEditTriggerKind=t.InlineCompletionTriggerKind=t.InlayHintKind=t.InjectedTextCursorStops=t.IndentAction=t.GlyphMarginLane=t.EndOfLineSequence=t.EndOfLinePreference=t.EditorOption=t.EditorAutoIndentStrategy=t.DocumentHighlightKind=t.DefaultEndOfLine=t.CursorChangeReason=t.ContentWidgetPositionPreference=t.CompletionTriggerKind=t.CompletionItemTag=t.CompletionItemKind=t.CompletionItemInsertTextRule=t.CodeActionTriggerType=t.AccessibilitySupport=void 0;var i;(function(r){r[r.Unknown=0]="Unknown",r[r.Disabled=1]="Disabled",r[r.Enabled=2]="Enabled"})(i||(t.AccessibilitySupport=i={}));var P;(function(r){r[r.Invoke=1]="Invoke",r[r.Auto=2]="Auto"})(P||(t.CodeActionTriggerType=P={}));var y;(function(r){r[r.None=0]="None",r[r.KeepWhitespace=1]="KeepWhitespace",r[r.InsertAsSnippet=4]="InsertAsSnippet"})(y||(t.CompletionItemInsertTextRule=y={}));var f;(function(r){r[r.Method=0]="Method",r[r.Function=1]="Function",r[r.Constructor=2]="Constructor",r[r.Field=3]="Field",r[r.Variable=4]="Variable",r[r.Class=5]="Class",r[r.Struct=6]="Struct",r[r.Interface=7]="Interface",r[r.Module=8]="Module",r[r.Property=9]="Property",r[r.Event=10]="Event",r[r.Operator=11]="Operator",r[r.Unit=12]="Unit",r[r.Value=13]="Value",r[r.Constant=14]="Constant",r[r.Enum=15]="Enum",r[r.EnumMember=16]="EnumMember",r[r.Keyword=17]="Keyword",r[r.Text=18]="Text",r[r.Color=19]="Color",r[r.File=20]="File",r[r.Reference=21]="Reference",r[r.Customcolor=22]="Customcolor",r[r.Folder=23]="Folder",r[r.TypeParameter=24]="TypeParameter",r[r.User=25]="User",r[r.Issue=26]="Issue",r[r.Snippet=27]="Snippet"})(f||(t.CompletionItemKind=f={}));var p;(function(r){r[r.Deprecated=1]="Deprecated"})(p||(t.CompletionItemTag=p={}));var h;(function(r){r[r.Invoke=0]="Invoke",r[r.TriggerCharacter=1]="TriggerCharacter",r[r.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(h||(t.CompletionTriggerKind=h={}));var o;(function(r){r[r.EXACT=0]="EXACT",r[r.ABOVE=1]="ABOVE",r[r.BELOW=2]="BELOW"})(o||(t.ContentWidgetPositionPreference=o={}));var a;(function(r){r[r.NotSet=0]="NotSet",r[r.ContentFlush=1]="ContentFlush",r[r.RecoverFromMarkers=2]="RecoverFromMarkers",r[r.Explicit=3]="Explicit",r[r.Paste=4]="Paste",r[r.Undo=5]="Undo",r[r.Redo=6]="Redo"})(a||(t.CursorChangeReason=a={}));var g;(function(r){r[r.LF=1]="LF",r[r.CRLF=2]="CRLF"})(g||(t.DefaultEndOfLine=g={}));var B;(function(r){r[r.Text=0]="Text",r[r.Read=1]="Read",r[r.Write=2]="Write"})(B||(t.DocumentHighlightKind=B={}));var d;(function(r){r[r.None=0]="None",r[r.Keep=1]="Keep",r[r.Brackets=2]="Brackets",r[r.Advanced=3]="Advanced",r[r.Full=4]="Full"})(d||(t.EditorAutoIndentStrategy=d={}));var m;(function(r){r[r.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",r[r.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",r[r.accessibilitySupport=2]="accessibilitySupport",r[r.accessibilityPageSize=3]="accessibilityPageSize",r[r.ariaLabel=4]="ariaLabel",r[r.ariaRequired=5]="ariaRequired",r[r.autoClosingBrackets=6]="autoClosingBrackets",r[r.autoClosingComments=7]="autoClosingComments",r[r.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",r[r.autoClosingDelete=9]="autoClosingDelete",r[r.autoClosingOvertype=10]="autoClosingOvertype",r[r.autoClosingQuotes=11]="autoClosingQuotes",r[r.autoIndent=12]="autoIndent",r[r.automaticLayout=13]="automaticLayout",r[r.autoSurround=14]="autoSurround",r[r.bracketPairColorization=15]="bracketPairColorization",r[r.guides=16]="guides",r[r.codeLens=17]="codeLens",r[r.codeLensFontFamily=18]="codeLensFontFamily",r[r.codeLensFontSize=19]="codeLensFontSize",r[r.colorDecorators=20]="colorDecorators",r[r.colorDecoratorsLimit=21]="colorDecoratorsLimit",r[r.columnSelection=22]="columnSelection",r[r.comments=23]="comments",r[r.contextmenu=24]="contextmenu",r[r.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",r[r.cursorBlinking=26]="cursorBlinking",r[r.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",r[r.cursorStyle=28]="cursorStyle",r[r.cursorSurroundingLines=29]="cursorSurroundingLines",r[r.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",r[r.cursorWidth=31]="cursorWidth",r[r.disableLayerHinting=32]="disableLayerHinting",r[r.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",r[r.domReadOnly=34]="domReadOnly",r[r.dragAndDrop=35]="dragAndDrop",r[r.dropIntoEditor=36]="dropIntoEditor",r[r.emptySelectionClipboard=37]="emptySelectionClipboard",r[r.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",r[r.extraEditorClassName=39]="extraEditorClassName",r[r.fastScrollSensitivity=40]="fastScrollSensitivity",r[r.find=41]="find",r[r.fixedOverflowWidgets=42]="fixedOverflowWidgets",r[r.folding=43]="folding",r[r.foldingStrategy=44]="foldingStrategy",r[r.foldingHighlight=45]="foldingHighlight",r[r.foldingImportsByDefault=46]="foldingImportsByDefault",r[r.foldingMaximumRegions=47]="foldingMaximumRegions",r[r.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",r[r.fontFamily=49]="fontFamily",r[r.fontInfo=50]="fontInfo",r[r.fontLigatures=51]="fontLigatures",r[r.fontSize=52]="fontSize",r[r.fontWeight=53]="fontWeight",r[r.fontVariations=54]="fontVariations",r[r.formatOnPaste=55]="formatOnPaste",r[r.formatOnType=56]="formatOnType",r[r.glyphMargin=57]="glyphMargin",r[r.gotoLocation=58]="gotoLocation",r[r.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",r[r.hover=60]="hover",r[r.inDiffEditor=61]="inDiffEditor",r[r.inlineSuggest=62]="inlineSuggest",r[r.inlineEdit=63]="inlineEdit",r[r.letterSpacing=64]="letterSpacing",r[r.lightbulb=65]="lightbulb",r[r.lineDecorationsWidth=66]="lineDecorationsWidth",r[r.lineHeight=67]="lineHeight",r[r.lineNumbers=68]="lineNumbers",r[r.lineNumbersMinChars=69]="lineNumbersMinChars",r[r.linkedEditing=70]="linkedEditing",r[r.links=71]="links",r[r.matchBrackets=72]="matchBrackets",r[r.minimap=73]="minimap",r[r.mouseStyle=74]="mouseStyle",r[r.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",r[r.mouseWheelZoom=76]="mouseWheelZoom",r[r.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",r[r.multiCursorModifier=78]="multiCursorModifier",r[r.multiCursorPaste=79]="multiCursorPaste",r[r.multiCursorLimit=80]="multiCursorLimit",r[r.occurrencesHighlight=81]="occurrencesHighlight",r[r.overviewRulerBorder=82]="overviewRulerBorder",r[r.overviewRulerLanes=83]="overviewRulerLanes",r[r.padding=84]="padding",r[r.pasteAs=85]="pasteAs",r[r.parameterHints=86]="parameterHints",r[r.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",r[r.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",r[r.quickSuggestions=89]="quickSuggestions",r[r.quickSuggestionsDelay=90]="quickSuggestionsDelay",r[r.readOnly=91]="readOnly",r[r.readOnlyMessage=92]="readOnlyMessage",r[r.renameOnType=93]="renameOnType",r[r.renderControlCharacters=94]="renderControlCharacters",r[r.renderFinalNewline=95]="renderFinalNewline",r[r.renderLineHighlight=96]="renderLineHighlight",r[r.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",r[r.renderValidationDecorations=98]="renderValidationDecorations",r[r.renderWhitespace=99]="renderWhitespace",r[r.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",r[r.roundedSelection=101]="roundedSelection",r[r.rulers=102]="rulers",r[r.scrollbar=103]="scrollbar",r[r.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",r[r.scrollBeyondLastLine=105]="scrollBeyondLastLine",r[r.scrollPredominantAxis=106]="scrollPredominantAxis",r[r.selectionClipboard=107]="selectionClipboard",r[r.selectionHighlight=108]="selectionHighlight",r[r.selectOnLineNumbers=109]="selectOnLineNumbers",r[r.showFoldingControls=110]="showFoldingControls",r[r.showUnused=111]="showUnused",r[r.snippetSuggestions=112]="snippetSuggestions",r[r.smartSelect=113]="smartSelect",r[r.smoothScrolling=114]="smoothScrolling",r[r.stickyScroll=115]="stickyScroll",r[r.stickyTabStops=116]="stickyTabStops",r[r.stopRenderingLineAfter=117]="stopRenderingLineAfter",r[r.suggest=118]="suggest",r[r.suggestFontSize=119]="suggestFontSize",r[r.suggestLineHeight=120]="suggestLineHeight",r[r.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",r[r.suggestSelection=122]="suggestSelection",r[r.tabCompletion=123]="tabCompletion",r[r.tabIndex=124]="tabIndex",r[r.unicodeHighlighting=125]="unicodeHighlighting",r[r.unusualLineTerminators=126]="unusualLineTerminators",r[r.useShadowDOM=127]="useShadowDOM",r[r.useTabStops=128]="useTabStops",r[r.wordBreak=129]="wordBreak",r[r.wordSeparators=130]="wordSeparators",r[r.wordWrap=131]="wordWrap",r[r.wordWrapBreakAfterCharacters=132]="wordWrapBreakAfterCharacters",r[r.wordWrapBreakBeforeCharacters=133]="wordWrapBreakBeforeCharacters",r[r.wordWrapColumn=134]="wordWrapColumn",r[r.wordWrapOverride1=135]="wordWrapOverride1",r[r.wordWrapOverride2=136]="wordWrapOverride2",r[r.wrappingIndent=137]="wrappingIndent",r[r.wrappingStrategy=138]="wrappingStrategy",r[r.showDeprecated=139]="showDeprecated",r[r.inlayHints=140]="inlayHints",r[r.editorClassName=141]="editorClassName",r[r.pixelRatio=142]="pixelRatio",r[r.tabFocusMode=143]="tabFocusMode",r[r.layoutInfo=144]="layoutInfo",r[r.wrappingInfo=145]="wrappingInfo",r[r.defaultColorDecorators=146]="defaultColorDecorators",r[r.colorDecoratorsActivatedOn=147]="colorDecoratorsActivatedOn",r[r.inlineCompletionsAccessibilityVerbose=148]="inlineCompletionsAccessibilityVerbose"})(m||(t.EditorOption=m={}));var e;(function(r){r[r.TextDefined=0]="TextDefined",r[r.LF=1]="LF",r[r.CRLF=2]="CRLF"})(e||(t.EndOfLinePreference=e={}));var v;(function(r){r[r.LF=0]="LF",r[r.CRLF=1]="CRLF"})(v||(t.EndOfLineSequence=v={}));var j;(function(r){r[r.Left=1]="Left",r[r.Center=2]="Center",r[r.Right=3]="Right"})(j||(t.GlyphMarginLane=j={}));var L;(function(r){r[r.None=0]="None",r[r.Indent=1]="Indent",r[r.IndentOutdent=2]="IndentOutdent",r[r.Outdent=3]="Outdent"})(L||(t.IndentAction=L={}));var $;(function(r){r[r.Both=0]="Both",r[r.Right=1]="Right",r[r.Left=2]="Left",r[r.None=3]="None"})($||(t.InjectedTextCursorStops=$={}));var b;(function(r){r[r.Type=1]="Type",r[r.Parameter=2]="Parameter"})(b||(t.InlayHintKind=b={}));var u;(function(r){r[r.Automatic=0]="Automatic",r[r.Explicit=1]="Explicit"})(u||(t.InlineCompletionTriggerKind=u={}));var l;(function(r){r[r.Invoke=0]="Invoke",r[r.Automatic=1]="Automatic"})(l||(t.InlineEditTriggerKind=l={}));var n;(function(r){r[r.DependsOnKbLayout=-1]="DependsOnKbLayout",r[r.Unknown=0]="Unknown",r[r.Backspace=1]="Backspace",r[r.Tab=2]="Tab",r[r.Enter=3]="Enter",r[r.Shift=4]="Shift",r[r.Ctrl=5]="Ctrl",r[r.Alt=6]="Alt",r[r.PauseBreak=7]="PauseBreak",r[r.CapsLock=8]="CapsLock",r[r.Escape=9]="Escape",r[r.Space=10]="Space",r[r.PageUp=11]="PageUp",r[r.PageDown=12]="PageDown",r[r.End=13]="End",r[r.Home=14]="Home",r[r.LeftArrow=15]="LeftArrow",r[r.UpArrow=16]="UpArrow",r[r.RightArrow=17]="RightArrow",r[r.DownArrow=18]="DownArrow",r[r.Insert=19]="Insert",r[r.Delete=20]="Delete",r[r.Digit0=21]="Digit0",r[r.Digit1=22]="Digit1",r[r.Digit2=23]="Digit2",r[r.Digit3=24]="Digit3",r[r.Digit4=25]="Digit4",r[r.Digit5=26]="Digit5",r[r.Digit6=27]="Digit6",r[r.Digit7=28]="Digit7",r[r.Digit8=29]="Digit8",r[r.Digit9=30]="Digit9",r[r.KeyA=31]="KeyA",r[r.KeyB=32]="KeyB",r[r.KeyC=33]="KeyC",r[r.KeyD=34]="KeyD",r[r.KeyE=35]="KeyE",r[r.KeyF=36]="KeyF",r[r.KeyG=37]="KeyG",r[r.KeyH=38]="KeyH",r[r.KeyI=39]="KeyI",r[r.KeyJ=40]="KeyJ",r[r.KeyK=41]="KeyK",r[r.KeyL=42]="KeyL",r[r.KeyM=43]="KeyM",r[r.KeyN=44]="KeyN",r[r.KeyO=45]="KeyO",r[r.KeyP=46]="KeyP",r[r.KeyQ=47]="KeyQ",r[r.KeyR=48]="KeyR",r[r.KeyS=49]="KeyS",r[r.KeyT=50]="KeyT",r[r.KeyU=51]="KeyU",r[r.KeyV=52]="KeyV",r[r.KeyW=53]="KeyW",r[r.KeyX=54]="KeyX",r[r.KeyY=55]="KeyY",r[r.KeyZ=56]="KeyZ",r[r.Meta=57]="Meta",r[r.ContextMenu=58]="ContextMenu",r[r.F1=59]="F1",r[r.F2=60]="F2",r[r.F3=61]="F3",r[r.F4=62]="F4",r[r.F5=63]="F5",r[r.F6=64]="F6",r[r.F7=65]="F7",r[r.F8=66]="F8",r[r.F9=67]="F9",r[r.F10=68]="F10",r[r.F11=69]="F11",r[r.F12=70]="F12",r[r.F13=71]="F13",r[r.F14=72]="F14",r[r.F15=73]="F15",r[r.F16=74]="F16",r[r.F17=75]="F17",r[r.F18=76]="F18",r[r.F19=77]="F19",r[r.F20=78]="F20",r[r.F21=79]="F21",r[r.F22=80]="F22",r[r.F23=81]="F23",r[r.F24=82]="F24",r[r.NumLock=83]="NumLock",r[r.ScrollLock=84]="ScrollLock",r[r.Semicolon=85]="Semicolon",r[r.Equal=86]="Equal",r[r.Comma=87]="Comma",r[r.Minus=88]="Minus",r[r.Period=89]="Period",r[r.Slash=90]="Slash",r[r.Backquote=91]="Backquote",r[r.BracketLeft=92]="BracketLeft",r[r.Backslash=93]="Backslash",r[r.BracketRight=94]="BracketRight",r[r.Quote=95]="Quote",r[r.OEM_8=96]="OEM_8",r[r.IntlBackslash=97]="IntlBackslash",r[r.Numpad0=98]="Numpad0",r[r.Numpad1=99]="Numpad1",r[r.Numpad2=100]="Numpad2",r[r.Numpad3=101]="Numpad3",r[r.Numpad4=102]="Numpad4",r[r.Numpad5=103]="Numpad5",r[r.Numpad6=104]="Numpad6",r[r.Numpad7=105]="Numpad7",r[r.Numpad8=106]="Numpad8",r[r.Numpad9=107]="Numpad9",r[r.NumpadMultiply=108]="NumpadMultiply",r[r.NumpadAdd=109]="NumpadAdd",r[r.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",r[r.NumpadSubtract=111]="NumpadSubtract",r[r.NumpadDecimal=112]="NumpadDecimal",r[r.NumpadDivide=113]="NumpadDivide",r[r.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",r[r.ABNT_C1=115]="ABNT_C1",r[r.ABNT_C2=116]="ABNT_C2",r[r.AudioVolumeMute=117]="AudioVolumeMute",r[r.AudioVolumeUp=118]="AudioVolumeUp",r[r.AudioVolumeDown=119]="AudioVolumeDown",r[r.BrowserSearch=120]="BrowserSearch",r[r.BrowserHome=121]="BrowserHome",r[r.BrowserBack=122]="BrowserBack",r[r.BrowserForward=123]="BrowserForward",r[r.MediaTrackNext=124]="MediaTrackNext",r[r.MediaTrackPrevious=125]="MediaTrackPrevious",r[r.MediaStop=126]="MediaStop",r[r.MediaPlayPause=127]="MediaPlayPause",r[r.LaunchMediaPlayer=128]="LaunchMediaPlayer",r[r.LaunchMail=129]="LaunchMail",r[r.LaunchApp2=130]="LaunchApp2",r[r.Clear=131]="Clear",r[r.MAX_VALUE=132]="MAX_VALUE"})(n||(t.KeyCode=n={}));var s;(function(r){r[r.Hint=1]="Hint",r[r.Info=2]="Info",r[r.Warning=4]="Warning",r[r.Error=8]="Error"})(s||(t.MarkerSeverity=s={}));var N;(function(r){r[r.Unnecessary=1]="Unnecessary",r[r.Deprecated=2]="Deprecated"})(N||(t.MarkerTag=N={}));var c;(function(r){r[r.Inline=1]="Inline",r[r.Gutter=2]="Gutter"})(c||(t.MinimapPosition=c={}));var w;(function(r){r[r.UNKNOWN=0]="UNKNOWN",r[r.TEXTAREA=1]="TEXTAREA",r[r.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",r[r.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",r[r.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",r[r.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",r[r.CONTENT_TEXT=6]="CONTENT_TEXT",r[r.CONTENT_EMPTY=7]="CONTENT_EMPTY",r[r.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",r[r.CONTENT_WIDGET=9]="CONTENT_WIDGET",r[r.OVERVIEW_RULER=10]="OVERVIEW_RULER",r[r.SCROLLBAR=11]="SCROLLBAR",r[r.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",r[r.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(w||(t.MouseTargetType=w={}));var E;(function(r){r[r.AIGenerated=1]="AIGenerated"})(E||(t.NewSymbolNameTag=E={}));var A;(function(r){r[r.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",r[r.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",r[r.TOP_CENTER=2]="TOP_CENTER"})(A||(t.OverlayWidgetPositionPreference=A={}));var M;(function(r){r[r.Left=1]="Left",r[r.Center=2]="Center",r[r.Right=4]="Right",r[r.Full=7]="Full"})(M||(t.OverviewRulerLane=M={}));var T;(function(r){r[r.Word=0]="Word",r[r.Line=1]="Line",r[r.Suggest=2]="Suggest"})(T||(t.PartialAcceptTriggerKind=T={}));var S;(function(r){r[r.Left=0]="Left",r[r.Right=1]="Right",r[r.None=2]="None",r[r.LeftOfInjectedText=3]="LeftOfInjectedText",r[r.RightOfInjectedText=4]="RightOfInjectedText"})(S||(t.PositionAffinity=S={}));var F;(function(r){r[r.Off=0]="Off",r[r.On=1]="On",r[r.Relative=2]="Relative",r[r.Interval=3]="Interval",r[r.Custom=4]="Custom"})(F||(t.RenderLineNumbersType=F={}));var R;(function(r){r[r.None=0]="None",r[r.Text=1]="Text",r[r.Blocks=2]="Blocks"})(R||(t.RenderMinimap=R={}));var x;(function(r){r[r.Smooth=0]="Smooth",r[r.Immediate=1]="Immediate"})(x||(t.ScrollType=x={}));var I;(function(r){r[r.Auto=1]="Auto",r[r.Hidden=2]="Hidden",r[r.Visible=3]="Visible"})(I||(t.ScrollbarVisibility=I={}));var H;(function(r){r[r.LTR=0]="LTR",r[r.RTL=1]="RTL"})(H||(t.SelectionDirection=H={}));var K;(function(r){r.Off="off",r.OnCode="onCode",r.On="on"})(K||(t.ShowLightbulbIconMode=K={}));var _;(function(r){r[r.Invoke=1]="Invoke",r[r.TriggerCharacter=2]="TriggerCharacter",r[r.ContentChange=3]="ContentChange"})(_||(t.SignatureHelpTriggerKind=_={}));var X;(function(r){r[r.File=0]="File",r[r.Module=1]="Module",r[r.Namespace=2]="Namespace",r[r.Package=3]="Package",r[r.Class=4]="Class",r[r.Method=5]="Method",r[r.Property=6]="Property",r[r.Field=7]="Field",r[r.Constructor=8]="Constructor",r[r.Enum=9]="Enum",r[r.Interface=10]="Interface",r[r.Function=11]="Function",r[r.Variable=12]="Variable",r[r.Constant=13]="Constant",r[r.String=14]="String",r[r.Number=15]="Number",r[r.Boolean=16]="Boolean",r[r.Array=17]="Array",r[r.Object=18]="Object",r[r.Key=19]="Key",r[r.Null=20]="Null",r[r.EnumMember=21]="EnumMember",r[r.Struct=22]="Struct",r[r.Event=23]="Event",r[r.Operator=24]="Operator",r[r.TypeParameter=25]="TypeParameter"})(X||(t.SymbolKind=X={}));var Z;(function(r){r[r.Deprecated=1]="Deprecated"})(Z||(t.SymbolTag=Z={}));var k;(function(r){r[r.Hidden=0]="Hidden",r[r.Blink=1]="Blink",r[r.Smooth=2]="Smooth",r[r.Phase=3]="Phase",r[r.Expand=4]="Expand",r[r.Solid=5]="Solid"})(k||(t.TextEditorCursorBlinkingStyle=k={}));var z;(function(r){r[r.Line=1]="Line",r[r.Block=2]="Block",r[r.Underline=3]="Underline",r[r.LineThin=4]="LineThin",r[r.BlockOutline=5]="BlockOutline",r[r.UnderlineThin=6]="UnderlineThin"})(z||(t.TextEditorCursorStyle=z={}));var ue;(function(r){r[r.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",r[r.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",r[r.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",r[r.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(ue||(t.TrackedRangeStickiness=ue={}));var oe;(function(r){r[r.None=0]="None",r[r.Same=1]="Same",r[r.Indent=2]="Indent",r[r.DeepIndent=3]="DeepIndent"})(oe||(t.WrappingIndent=oe={}))}),re(ie[62],se([0,1,11,10]),function(V,t,i,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Mt=void 0;class y{constructor(){this.a=new Map,this.b=new Map,this.c=new i.$7d,this.onDidChange=this.c.event,this.d=null}handleChange(h){this.c.fire({changedLanguages:h,changedColorMap:!1})}register(h,o){return this.a.set(h,o),this.handleChange([h]),(0,P.$Sc)(()=>{this.a.get(h)===o&&(this.a.delete(h),this.handleChange([h]))})}get(h){return this.a.get(h)||null}registerFactory(h,o){this.b.get(h)?.dispose();const a=new f(this,h,o);return this.b.set(h,a),(0,P.$Sc)(()=>{const g=this.b.get(h);!g||g!==a||(this.b.delete(h),g.dispose())})}async getOrCreate(h){const o=this.get(h);if(o)return o;const a=this.b.get(h);return!a||a.isResolved?null:(await a.resolve(),this.get(h))}isResolved(h){if(this.get(h))return!0;const a=this.b.get(h);return!!(!a||a.isResolved)}setColorMap(h){this.d=h,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}t.$Mt=y;class f extends P.$Uc{get isResolved(){return this.c}constructor(h,o,a){super(),this.f=h,this.g=o,this.h=a,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const h=await this.h.tokenizationSupport;this.c=!0,h&&!this.a&&this.B(this.f.register(this.g,h))}}}),re(ie[63],se([64,65]),function(V,t){return V.create("vs/base/common/platform",t)}),re(ie[17],se([0,1,63]),function(V,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$I=t.$H=t.$G=t.$F=t.$E=t.OS=t.OperatingSystem=t.$B=t.$A=t.$z=t.$y=t.$x=t.Language=t.$w=t.$v=t.$u=t.$t=t.$s=t.$r=t.$q=t.$p=t.$o=t.$n=t.$m=t.$l=t.$k=t.$j=t.$i=t.Platform=t.$g=void 0,t.$h=s,t.$D=M,t.$J=T,t.$g="en";let P=!1,y=!1,f=!1,p=!1,h=!1,o=!1,a=!1,g=!1,B=!1,d=!1,m,e=t.$g,v=t.$g,j,L;const $=globalThis;let b;typeof $.vscode<"u"&&typeof $.vscode.process<"u"?b=$.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(b=process);const u=typeof b?.versions?.electron=="string",l=u&&b?.type==="renderer";if(typeof b=="object"){P=b.platform==="win32",y=b.platform==="darwin",f=b.platform==="linux",p=f&&!!b.env.SNAP&&!!b.env.SNAP_REVISION,a=u,B=!!b.env.CI||!!b.env.BUILD_ARTIFACTSTAGINGDIRECTORY,m=t.$g,e=t.$g;const S=b.env.VSCODE_NLS_CONFIG;if(S)try{const F=JSON.parse(S),R=F.availableLanguages["*"];m=F.locale,v=F.osLocale,e=R||t.$g,j=F._translationsConfigFile}catch{}h=!0}else typeof navigator=="object"&&!l?(L=navigator.userAgent,P=L.indexOf("Windows")>=0,y=L.indexOf("Macintosh")>=0,g=(L.indexOf("Macintosh")>=0||L.indexOf("iPad")>=0||L.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,f=L.indexOf("Linux")>=0,d=L?.indexOf("Mobi")>=0,o=!0,m=i.getConfiguredDefaultLocale(i.localize(0,null))||t.$g,e=m,v=navigator.language):console.error("Unable to resolve platform.");var n;(function(S){S[S.Web=0]="Web",S[S.Mac=1]="Mac",S[S.Linux=2]="Linux",S[S.Windows=3]="Windows"})(n||(t.Platform=n={}));function s(S){switch(S){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}let N=0;y?N=1:P?N=3:f&&(N=2),t.$i=P,t.$j=y,t.$k=f,t.$l=p,t.$m=h,t.$n=a,t.$o=o,t.$p=o&&typeof $.importScripts=="function",t.$q=t.$p?$.origin:void 0,t.$r=g,t.$s=d,t.$t=B,t.$u=N,t.$v=L,t.$w=e;var c;(function(S){function F(){return t.$w}S.value=F;function R(){return t.$w.length===2?t.$w==="en":t.$w.length>=3?t.$w[0]==="e"&&t.$w[1]==="n"&&t.$w[2]==="-":!1}S.isDefaultVariant=R;function x(){return t.$w==="en"}S.isDefault=x})(c||(t.Language=c={})),t.$x=m,t.$y=v,t.$z=j,t.$A=typeof $.postMessage=="function"&&!$.importScripts,t.$B=(()=>{if(t.$A){const S=[];$.addEventListener("message",R=>{if(R.data&&R.data.vscodeScheduleAsyncWork)for(let x=0,I=S.length;x<I;x++){const H=S[x];if(H.id===R.data.vscodeScheduleAsyncWork){S.splice(x,1),H.callback();return}}});let F=0;return R=>{const x=++F;S.push({id:x,callback:R}),$.postMessage({vscodeScheduleAsyncWork:x},"*")}}return S=>setTimeout(S)})();var w;(function(S){S[S.Windows=1]="Windows",S[S.Macintosh=2]="Macintosh",S[S.Linux=3]="Linux"})(w||(t.OperatingSystem=w={})),t.OS=y||g?2:P?1:3;let E=!0,A=!1;function M(){if(!A){A=!0;const S=new Uint8Array(2);S[0]=1,S[1]=2,E=new Uint16Array(S.buffer)[0]===513}return E}t.$E=!!(t.$v&&t.$v.indexOf("Chrome")>=0),t.$F=!!(t.$v&&t.$v.indexOf("Firefox")>=0),t.$G=!!(!t.$E&&t.$v&&t.$v.indexOf("Safari")>=0),t.$H=!!(t.$v&&t.$v.indexOf("Edg/")>=0),t.$I=!!(t.$v&&t.$v.indexOf("Android")>=0);function T(S){return parseFloat(S)>=20}}),re(ie[66],se([0,1,17]),function(V,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$fc=t.$ec=t.env=t.cwd=void 0;let P;const y=globalThis.vscode;if(typeof y<"u"&&typeof y.process<"u"){const f=y.process;P={get platform(){return f.platform},get arch(){return f.arch},get env(){return f.env},cwd(){return f.cwd()}}}else typeof process<"u"?P={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:P={get platform(){return i.$i?"win32":i.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=P.cwd,t.env=P.env,t.$ec=P.platform,t.$fc=P.arch}),re(ie[67],se([0,1,66]),function(V,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$uc=t.sep=t.$sc=t.$rc=t.$qc=t.$pc=t.$oc=t.$nc=t.$mc=t.$lc=t.$kc=t.$jc=t.$ic=t.$hc=t.$gc=void 0;const P=65,y=97,f=90,p=122,h=46,o=47,a=92,g=58,B=63;class d extends Error{constructor(s,N,c){let w;typeof N=="string"&&N.indexOf("not ")===0?(w="must not be",N=N.replace(/^not /,"")):w="must be";const E=s.indexOf(".")!==-1?"property":"argument";let A=`The "${s}" ${E} ${w} of type ${N}`;A+=`. Received type ${typeof c}`,super(A),this.code="ERR_INVALID_ARG_TYPE"}}function m(n,s){if(n===null||typeof n!="object")throw new d(s,"Object",n)}function e(n,s){if(typeof n!="string")throw new d(s,"string",n)}const v=i.$ec==="win32";function j(n){return n===o||n===a}function L(n){return n===o}function $(n){return n>=P&&n<=f||n>=y&&n<=p}function b(n,s,N,c){let w="",E=0,A=-1,M=0,T=0;for(let S=0;S<=n.length;++S){if(S<n.length)T=n.charCodeAt(S);else{if(c(T))break;T=o}if(c(T)){if(!(A===S-1||M===1))if(M===2){if(w.length<2||E!==2||w.charCodeAt(w.length-1)!==h||w.charCodeAt(w.length-2)!==h){if(w.length>2){const F=w.lastIndexOf(N);F===-1?(w="",E=0):(w=w.slice(0,F),E=w.length-1-w.lastIndexOf(N)),A=S,M=0;continue}else if(w.length!==0){w="",E=0,A=S,M=0;continue}}s&&(w+=w.length>0?`${N}..`:"..",E=2)}else w.length>0?w+=`${N}${n.slice(A+1,S)}`:w=n.slice(A+1,S),E=S-A-1;A=S,M=0}else T===h&&M!==-1?++M:M=-1}return w}function u(n,s){m(s,"pathObject");const N=s.dir||s.root,c=s.base||`${s.name||""}${s.ext||""}`;return N?N===s.root?`${N}${c}`:`${N}${n}${c}`:c}t.$gc={resolve(...n){let s="",N="",c=!1;for(let w=n.length-1;w>=-1;w--){let E;if(w>=0){if(E=n[w],e(E,"path"),E.length===0)continue}else s.length===0?E=i.cwd():(E=i.env[`=${s}`]||i.cwd(),(E===void 0||E.slice(0,2).toLowerCase()!==s.toLowerCase()&&E.charCodeAt(2)===a)&&(E=`${s}\\`));const A=E.length;let M=0,T="",S=!1;const F=E.charCodeAt(0);if(A===1)j(F)&&(M=1,S=!0);else if(j(F))if(S=!0,j(E.charCodeAt(1))){let R=2,x=R;for(;R<A&&!j(E.charCodeAt(R));)R++;if(R<A&&R!==x){const I=E.slice(x,R);for(x=R;R<A&&j(E.charCodeAt(R));)R++;if(R<A&&R!==x){for(x=R;R<A&&!j(E.charCodeAt(R));)R++;(R===A||R!==x)&&(T=`\\\\${I}\\${E.slice(x,R)}`,M=R)}}}else M=1;else $(F)&&E.charCodeAt(1)===g&&(T=E.slice(0,2),M=2,A>2&&j(E.charCodeAt(2))&&(S=!0,M=3));if(T.length>0)if(s.length>0){if(T.toLowerCase()!==s.toLowerCase())continue}else s=T;if(c){if(s.length>0)break}else if(N=`${E.slice(M)}\\${N}`,c=S,S&&s.length>0)break}return N=b(N,!c,"\\",j),c?`${s}\\${N}`:`${s}${N}`||"."},normalize(n){e(n,"path");const s=n.length;if(s===0)return".";let N=0,c,w=!1;const E=n.charCodeAt(0);if(s===1)return L(E)?"\\":n;if(j(E))if(w=!0,j(n.charCodeAt(1))){let M=2,T=M;for(;M<s&&!j(n.charCodeAt(M));)M++;if(M<s&&M!==T){const S=n.slice(T,M);for(T=M;M<s&&j(n.charCodeAt(M));)M++;if(M<s&&M!==T){for(T=M;M<s&&!j(n.charCodeAt(M));)M++;if(M===s)return`\\\\${S}\\${n.slice(T)}\\`;M!==T&&(c=`\\\\${S}\\${n.slice(T,M)}`,N=M)}}}else N=1;else $(E)&&n.charCodeAt(1)===g&&(c=n.slice(0,2),N=2,s>2&&j(n.charCodeAt(2))&&(w=!0,N=3));let A=N<s?b(n.slice(N),!w,"\\",j):"";return A.length===0&&!w&&(A="."),A.length>0&&j(n.charCodeAt(s-1))&&(A+="\\"),c===void 0?w?`\\${A}`:A:w?`${c}\\${A}`:`${c}${A}`},isAbsolute(n){e(n,"path");const s=n.length;if(s===0)return!1;const N=n.charCodeAt(0);return j(N)||s>2&&$(N)&&n.charCodeAt(1)===g&&j(n.charCodeAt(2))},join(...n){if(n.length===0)return".";let s,N;for(let E=0;E<n.length;++E){const A=n[E];e(A,"path"),A.length>0&&(s===void 0?s=N=A:s+=`\\${A}`)}if(s===void 0)return".";let c=!0,w=0;if(typeof N=="string"&&j(N.charCodeAt(0))){++w;const E=N.length;E>1&&j(N.charCodeAt(1))&&(++w,E>2&&(j(N.charCodeAt(2))?++w:c=!1))}if(c){for(;w<s.length&&j(s.charCodeAt(w));)w++;w>=2&&(s=`\\${s.slice(w)}`)}return t.$gc.normalize(s)},relative(n,s){if(e(n,"from"),e(s,"to"),n===s)return"";const N=t.$gc.resolve(n),c=t.$gc.resolve(s);if(N===c||(n=N.toLowerCase(),s=c.toLowerCase(),n===s))return"";let w=0;for(;w<n.length&&n.charCodeAt(w)===a;)w++;let E=n.length;for(;E-1>w&&n.charCodeAt(E-1)===a;)E--;const A=E-w;let M=0;for(;M<s.length&&s.charCodeAt(M)===a;)M++;let T=s.length;for(;T-1>M&&s.charCodeAt(T-1)===a;)T--;const S=T-M,F=A<S?A:S;let R=-1,x=0;for(;x<F;x++){const H=n.charCodeAt(w+x);if(H!==s.charCodeAt(M+x))break;H===a&&(R=x)}if(x!==F){if(R===-1)return c}else{if(S>F){if(s.charCodeAt(M+x)===a)return c.slice(M+x+1);if(x===2)return c.slice(M+x)}A>F&&(n.charCodeAt(w+x)===a?R=x:x===2&&(R=3)),R===-1&&(R=0)}let I="";for(x=w+R+1;x<=E;++x)(x===E||n.charCodeAt(x)===a)&&(I+=I.length===0?"..":"\\..");return M+=R,I.length>0?`${I}${c.slice(M,T)}`:(c.charCodeAt(M)===a&&++M,c.slice(M,T))},toNamespacedPath(n){if(typeof n!="string"||n.length===0)return n;const s=t.$gc.resolve(n);if(s.length<=2)return n;if(s.charCodeAt(0)===a){if(s.charCodeAt(1)===a){const N=s.charCodeAt(2);if(N!==B&&N!==h)return`\\\\?\\UNC\\${s.slice(2)}`}}else if($(s.charCodeAt(0))&&s.charCodeAt(1)===g&&s.charCodeAt(2)===a)return`\\\\?\\${s}`;return n},dirname(n){e(n,"path");const s=n.length;if(s===0)return".";let N=-1,c=0;const w=n.charCodeAt(0);if(s===1)return j(w)?n:".";if(j(w)){if(N=c=1,j(n.charCodeAt(1))){let M=2,T=M;for(;M<s&&!j(n.charCodeAt(M));)M++;if(M<s&&M!==T){for(T=M;M<s&&j(n.charCodeAt(M));)M++;if(M<s&&M!==T){for(T=M;M<s&&!j(n.charCodeAt(M));)M++;if(M===s)return n;M!==T&&(N=c=M+1)}}}}else $(w)&&n.charCodeAt(1)===g&&(N=s>2&&j(n.charCodeAt(2))?3:2,c=N);let E=-1,A=!0;for(let M=s-1;M>=c;--M)if(j(n.charCodeAt(M))){if(!A){E=M;break}}else A=!1;if(E===-1){if(N===-1)return".";E=N}return n.slice(0,E)},basename(n,s){s!==void 0&&e(s,"ext"),e(n,"path");let N=0,c=-1,w=!0,E;if(n.length>=2&&$(n.charCodeAt(0))&&n.charCodeAt(1)===g&&(N=2),s!==void 0&&s.length>0&&s.length<=n.length){if(s===n)return"";let A=s.length-1,M=-1;for(E=n.length-1;E>=N;--E){const T=n.charCodeAt(E);if(j(T)){if(!w){N=E+1;break}}else M===-1&&(w=!1,M=E+1),A>=0&&(T===s.charCodeAt(A)?--A===-1&&(c=E):(A=-1,c=M))}return N===c?c=M:c===-1&&(c=n.length),n.slice(N,c)}for(E=n.length-1;E>=N;--E)if(j(n.charCodeAt(E))){if(!w){N=E+1;break}}else c===-1&&(w=!1,c=E+1);return c===-1?"":n.slice(N,c)},extname(n){e(n,"path");let s=0,N=-1,c=0,w=-1,E=!0,A=0;n.length>=2&&n.charCodeAt(1)===g&&$(n.charCodeAt(0))&&(s=c=2);for(let M=n.length-1;M>=s;--M){const T=n.charCodeAt(M);if(j(T)){if(!E){c=M+1;break}continue}w===-1&&(E=!1,w=M+1),T===h?N===-1?N=M:A!==1&&(A=1):N!==-1&&(A=-1)}return N===-1||w===-1||A===0||A===1&&N===w-1&&N===c+1?"":n.slice(N,w)},format:u.bind(null,"\\"),parse(n){e(n,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return s;const N=n.length;let c=0,w=n.charCodeAt(0);if(N===1)return j(w)?(s.root=s.dir=n,s):(s.base=s.name=n,s);if(j(w)){if(c=1,j(n.charCodeAt(1))){let R=2,x=R;for(;R<N&&!j(n.charCodeAt(R));)R++;if(R<N&&R!==x){for(x=R;R<N&&j(n.charCodeAt(R));)R++;if(R<N&&R!==x){for(x=R;R<N&&!j(n.charCodeAt(R));)R++;R===N?c=R:R!==x&&(c=R+1)}}}}else if($(w)&&n.charCodeAt(1)===g){if(N<=2)return s.root=s.dir=n,s;if(c=2,j(n.charCodeAt(2))){if(N===3)return s.root=s.dir=n,s;c=3}}c>0&&(s.root=n.slice(0,c));let E=-1,A=c,M=-1,T=!0,S=n.length-1,F=0;for(;S>=c;--S){if(w=n.charCodeAt(S),j(w)){if(!T){A=S+1;break}continue}M===-1&&(T=!1,M=S+1),w===h?E===-1?E=S:F!==1&&(F=1):E!==-1&&(F=-1)}return M!==-1&&(E===-1||F===0||F===1&&E===M-1&&E===A+1?s.base=s.name=n.slice(A,M):(s.name=n.slice(A,E),s.base=n.slice(A,M),s.ext=n.slice(E,M))),A>0&&A!==c?s.dir=n.slice(0,A-1):s.dir=s.root,s},sep:"\\",delimiter:";",win32:null,posix:null};const l=(()=>{if(v){const n=/\\/g;return()=>{const s=i.cwd().replace(n,"/");return s.slice(s.indexOf("/"))}}return()=>i.cwd()})();t.$hc={resolve(...n){let s="",N=!1;for(let c=n.length-1;c>=-1&&!N;c--){const w=c>=0?n[c]:l();e(w,"path"),w.length!==0&&(s=`${w}/${s}`,N=w.charCodeAt(0)===o)}return s=b(s,!N,"/",L),N?`/${s}`:s.length>0?s:"."},normalize(n){if(e(n,"path"),n.length===0)return".";const s=n.charCodeAt(0)===o,N=n.charCodeAt(n.length-1)===o;return n=b(n,!s,"/",L),n.length===0?s?"/":N?"./":".":(N&&(n+="/"),s?`/${n}`:n)},isAbsolute(n){return e(n,"path"),n.length>0&&n.charCodeAt(0)===o},join(...n){if(n.length===0)return".";let s;for(let N=0;N<n.length;++N){const c=n[N];e(c,"path"),c.length>0&&(s===void 0?s=c:s+=`/${c}`)}return s===void 0?".":t.$hc.normalize(s)},relative(n,s){if(e(n,"from"),e(s,"to"),n===s||(n=t.$hc.resolve(n),s=t.$hc.resolve(s),n===s))return"";const N=1,c=n.length,w=c-N,E=1,A=s.length-E,M=w<A?w:A;let T=-1,S=0;for(;S<M;S++){const R=n.charCodeAt(N+S);if(R!==s.charCodeAt(E+S))break;R===o&&(T=S)}if(S===M)if(A>M){if(s.charCodeAt(E+S)===o)return s.slice(E+S+1);if(S===0)return s.slice(E+S)}else w>M&&(n.charCodeAt(N+S)===o?T=S:S===0&&(T=0));let F="";for(S=N+T+1;S<=c;++S)(S===c||n.charCodeAt(S)===o)&&(F+=F.length===0?"..":"/..");return`${F}${s.slice(E+T)}`},toNamespacedPath(n){return n},dirname(n){if(e(n,"path"),n.length===0)return".";const s=n.charCodeAt(0)===o;let N=-1,c=!0;for(let w=n.length-1;w>=1;--w)if(n.charCodeAt(w)===o){if(!c){N=w;break}}else c=!1;return N===-1?s?"/":".":s&&N===1?"//":n.slice(0,N)},basename(n,s){s!==void 0&&e(s,"ext"),e(n,"path");let N=0,c=-1,w=!0,E;if(s!==void 0&&s.length>0&&s.length<=n.length){if(s===n)return"";let A=s.length-1,M=-1;for(E=n.length-1;E>=0;--E){const T=n.charCodeAt(E);if(T===o){if(!w){N=E+1;break}}else M===-1&&(w=!1,M=E+1),A>=0&&(T===s.charCodeAt(A)?--A===-1&&(c=E):(A=-1,c=M))}return N===c?c=M:c===-1&&(c=n.length),n.slice(N,c)}for(E=n.length-1;E>=0;--E)if(n.charCodeAt(E)===o){if(!w){N=E+1;break}}else c===-1&&(w=!1,c=E+1);return c===-1?"":n.slice(N,c)},extname(n){e(n,"path");let s=-1,N=0,c=-1,w=!0,E=0;for(let A=n.length-1;A>=0;--A){const M=n.charCodeAt(A);if(M===o){if(!w){N=A+1;break}continue}c===-1&&(w=!1,c=A+1),M===h?s===-1?s=A:E!==1&&(E=1):s!==-1&&(E=-1)}return s===-1||c===-1||E===0||E===1&&s===c-1&&s===N+1?"":n.slice(s,c)},format:u.bind(null,"/"),parse(n){e(n,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return s;const N=n.charCodeAt(0)===o;let c;N?(s.root="/",c=1):c=0;let w=-1,E=0,A=-1,M=!0,T=n.length-1,S=0;for(;T>=c;--T){const F=n.charCodeAt(T);if(F===o){if(!M){E=T+1;break}continue}A===-1&&(M=!1,A=T+1),F===h?w===-1?w=T:S!==1&&(S=1):w!==-1&&(S=-1)}if(A!==-1){const F=E===0&&N?1:E;w===-1||S===0||S===1&&w===A-1&&w===E+1?s.base=s.name=n.slice(F,A):(s.name=n.slice(F,w),s.base=n.slice(F,A),s.ext=n.slice(w,A))}return E>0?s.dir=n.slice(0,E-1):N&&(s.dir="/"),s},sep:"/",delimiter:":",win32:null,posix:null},t.$hc.win32=t.$gc.win32=t.$gc,t.$hc.posix=t.$gc.posix=t.$hc,t.$ic=v?t.$gc.normalize:t.$hc.normalize,t.$jc=v?t.$gc.isAbsolute:t.$hc.isAbsolute,t.$kc=v?t.$gc.join:t.$hc.join,t.$lc=v?t.$gc.resolve:t.$hc.resolve,t.$mc=v?t.$gc.relative:t.$hc.relative,t.$nc=v?t.$gc.dirname:t.$hc.dirname,t.$oc=v?t.$gc.basename:t.$hc.basename,t.$pc=v?t.$gc.extname:t.$hc.extname,t.$qc=v?t.$gc.format:t.$hc.format,t.$rc=v?t.$gc.parse:t.$hc.parse,t.$sc=v?t.$gc.toNamespacedPath:t.$hc.toNamespacedPath,t.sep=v?t.$gc.sep:t.$hc.sep,t.$uc=v?t.$gc.delimiter:t.$hc.delimiter}),re(ie[18],se([0,1,67,17]),function(V,t,i,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.URI=void 0,t.$wc=e,t.$xc=u;const y=/^\w[\w\d+.-]*$/,f=/^\//,p=/^\/\//;function h(c,w){if(!c.scheme&&w)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${c.authority}", path: "${c.path}", query: "${c.query}", fragment: "${c.fragment}"}`);if(c.scheme&&!y.test(c.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(c.path){if(c.authority){if(!f.test(c.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(p.test(c.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function o(c,w){return!c&&!w?"file":c}function a(c,w){switch(c){case"https":case"http":case"file":w?w[0]!==B&&(w=B+w):w=B;break}return w}const g="",B="/",d=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class m{static isUri(w){return w instanceof m?!0:w?typeof w.authority=="string"&&typeof w.fragment=="string"&&typeof w.path=="string"&&typeof w.query=="string"&&typeof w.scheme=="string"&&typeof w.fsPath=="string"&&typeof w.with=="function"&&typeof w.toString=="function":!1}constructor(w,E,A,M,T,S=!1){typeof w=="object"?(this.scheme=w.scheme||g,this.authority=w.authority||g,this.path=w.path||g,this.query=w.query||g,this.fragment=w.fragment||g):(this.scheme=o(w,S),this.authority=E||g,this.path=a(this.scheme,A||g),this.query=M||g,this.fragment=T||g,h(this,S))}get fsPath(){return u(this,!1)}with(w){if(!w)return this;let{scheme:E,authority:A,path:M,query:T,fragment:S}=w;return E===void 0?E=this.scheme:E===null&&(E=g),A===void 0?A=this.authority:A===null&&(A=g),M===void 0?M=this.path:M===null&&(M=g),T===void 0?T=this.query:T===null&&(T=g),S===void 0?S=this.fragment:S===null&&(S=g),E===this.scheme&&A===this.authority&&M===this.path&&T===this.query&&S===this.fragment?this:new j(E,A,M,T,S)}static parse(w,E=!1){const A=d.exec(w);return A?new j(A[2]||g,N(A[4]||g),N(A[5]||g),N(A[7]||g),N(A[9]||g),E):new j(g,g,g,g,g)}static file(w){let E=g;if(P.$i&&(w=w.replace(/\\/g,B)),w[0]===B&&w[1]===B){const A=w.indexOf(B,2);A===-1?(E=w.substring(2),w=B):(E=w.substring(2,A),w=w.substring(A)||B)}return new j("file",E,w,g,g)}static from(w,E){return new j(w.scheme,w.authority,w.path,w.query,w.fragment,E)}static joinPath(w,...E){if(!w.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let A;return P.$i&&w.scheme==="file"?A=m.file(i.$gc.join(u(w,!0),...E)).path:A=i.$hc.join(w.path,...E),w.with({path:A})}toString(w=!1){return l(this,w)}toJSON(){return this}static revive(w){if(w){if(w instanceof m)return w;{const E=new j(w);return E._formatted=w.external??null,E._fsPath=w._sep===v?w.fsPath??null:null,E}}else return w}}t.URI=m;function e(c){return!c||typeof c!="object"?!1:typeof c.scheme=="string"&&(typeof c.authority=="string"||typeof c.authority>"u")&&(typeof c.path=="string"||typeof c.path>"u")&&(typeof c.query=="string"||typeof c.query>"u")&&(typeof c.fragment=="string"||typeof c.fragment>"u")}const v=P.$i?1:void 0;class j extends m{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=u(this,!1)),this._fsPath}toString(w=!1){return w?l(this,!0):(this._formatted||(this._formatted=l(this,!1)),this._formatted)}toJSON(){const w={$mid:1};return this._fsPath&&(w.fsPath=this._fsPath,w._sep=v),this._formatted&&(w.external=this._formatted),this.path&&(w.path=this.path),this.scheme&&(w.scheme=this.scheme),this.authority&&(w.authority=this.authority),this.query&&(w.query=this.query),this.fragment&&(w.fragment=this.fragment),w}}const L={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function $(c,w,E){let A,M=-1;for(let T=0;T<c.length;T++){const S=c.charCodeAt(T);if(S>=97&&S<=122||S>=65&&S<=90||S>=48&&S<=57||S===45||S===46||S===95||S===126||w&&S===47||E&&S===91||E&&S===93||E&&S===58)M!==-1&&(A+=encodeURIComponent(c.substring(M,T)),M=-1),A!==void 0&&(A+=c.charAt(T));else{A===void 0&&(A=c.substr(0,T));const F=L[S];F!==void 0?(M!==-1&&(A+=encodeURIComponent(c.substring(M,T)),M=-1),A+=F):M===-1&&(M=T)}}return M!==-1&&(A+=encodeURIComponent(c.substring(M))),A!==void 0?A:c}function b(c){let w;for(let E=0;E<c.length;E++){const A=c.charCodeAt(E);A===35||A===63?(w===void 0&&(w=c.substr(0,E)),w+=L[A]):w!==void 0&&(w+=c[E])}return w!==void 0?w:c}function u(c,w){let E;return c.authority&&c.path.length>1&&c.scheme==="file"?E=`//${c.authority}${c.path}`:c.path.charCodeAt(0)===47&&(c.path.charCodeAt(1)>=65&&c.path.charCodeAt(1)<=90||c.path.charCodeAt(1)>=97&&c.path.charCodeAt(1)<=122)&&c.path.charCodeAt(2)===58?w?E=c.path.substr(1):E=c.path[1].toLowerCase()+c.path.substr(2):E=c.path,P.$i&&(E=E.replace(/\//g,"\\")),E}function l(c,w){const E=w?b:$;let A="",{scheme:M,authority:T,path:S,query:F,fragment:R}=c;if(M&&(A+=M,A+=":"),(T||M==="file")&&(A+=B,A+=B),T){let x=T.indexOf("@");if(x!==-1){const I=T.substr(0,x);T=T.substr(x+1),x=I.lastIndexOf(":"),x===-1?A+=E(I,!1,!1):(A+=E(I.substr(0,x),!1,!1),A+=":",A+=E(I.substr(x+1),!1,!0)),A+="@"}T=T.toLowerCase(),x=T.lastIndexOf(":"),x===-1?A+=E(T,!1,!0):(A+=E(T.substr(0,x),!1,!0),A+=T.substr(x))}if(S){if(S.length>=3&&S.charCodeAt(0)===47&&S.charCodeAt(2)===58){const x=S.charCodeAt(1);x>=65&&x<=90&&(S=`/${String.fromCharCode(x+32)}:${S.substr(3)}`)}else if(S.length>=2&&S.charCodeAt(1)===58){const x=S.charCodeAt(0);x>=65&&x<=90&&(S=`${String.fromCharCode(x+32)}:${S.substr(2)}`)}A+=E(S,!0,!1)}return F&&(A+="?",A+=E(F,!1,!1)),R&&(A+="#",A+=w?R:$(R,!1,!1)),A}function n(c){try{return decodeURIComponent(c)}catch{return c.length>3?c.substr(0,3)+n(c.substr(3)):c}}const s=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function N(c){return c.match(s)?c.replace(s,w=>n(w)):c}}),re(ie[72],se([0,1,3,11,10,14,17,7]),function(V,t,i,P,y,f,p,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SimpleWorkerServer=t.SimpleWorkerClient=void 0,t.logOnceWebWorkerWarning=g,t.create=s;const o="$initialize";let a=!1;function g(N){p.$o&&(a||(a=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(N.message))}var B;(function(N){N[N.Request=0]="Request",N[N.Reply=1]="Reply",N[N.SubscribeEvent=2]="SubscribeEvent",N[N.Event=3]="Event",N[N.UnsubscribeEvent=4]="UnsubscribeEvent"})(B||(B={}));class d{constructor(c,w,E,A){this.vsWorker=c,this.req=w,this.method=E,this.args=A,this.type=0}}class m{constructor(c,w,E,A){this.vsWorker=c,this.seq=w,this.res=E,this.err=A,this.type=1}}class e{constructor(c,w,E,A){this.vsWorker=c,this.req=w,this.eventName=E,this.arg=A,this.type=2}}class v{constructor(c,w,E){this.vsWorker=c,this.req=w,this.event=E,this.type=3}}class j{constructor(c,w){this.vsWorker=c,this.req=w,this.type=4}}class L{constructor(c){this.a=-1,this.g=c,this.b=0,this.c=Object.create(null),this.d=new Map,this.f=new Map}setWorkerId(c){this.a=c}sendMessage(c,w){const E=String(++this.b);return new Promise((A,M)=>{this.c[E]={resolve:A,reject:M},this.o(new d(this.a,E,c,w))})}listen(c,w){let E=null;const A=new P.$7d({onWillAddFirstListener:()=>{E=String(++this.b),this.d.set(E,A),this.o(new e(this.a,E,c,w))},onDidRemoveLastListener:()=>{this.d.delete(E),this.o(new j(this.a,E)),E=null}});return A.event}handleMessage(c){!c||!c.vsWorker||this.a!==-1&&c.vsWorker!==this.a||this.h(c)}h(c){switch(c.type){case 1:return this.j(c);case 0:return this.k(c);case 2:return this.l(c);case 3:return this.m(c);case 4:return this.n(c)}}j(c){if(!this.c[c.seq]){console.warn("Got reply to unknown seq");return}const w=this.c[c.seq];if(delete this.c[c.seq],c.err){let E=c.err;c.err.$isError&&(E=new Error,E.name=c.err.name,E.message=c.err.message,E.stack=c.err.stack),w.reject(E);return}w.resolve(c.res)}k(c){const w=c.req;this.g.handleMessage(c.method,c.args).then(A=>{this.o(new m(this.a,w,A,void 0))},A=>{A.detail instanceof Error&&(A.detail=(0,i.$3)(A.detail)),this.o(new m(this.a,w,void 0,(0,i.$3)(A)))})}l(c){const w=c.req,E=this.g.handleEvent(c.eventName,c.arg)(A=>{this.o(new v(this.a,w,A))});this.f.set(w,E)}m(c){if(!this.d.has(c.req)){console.warn("Got event for unknown req");return}this.d.get(c.req).fire(c.event)}n(c){if(!this.f.has(c.req)){console.warn("Got unsubscribe for unknown req");return}this.f.get(c.req).dispose(),this.f.delete(c.req)}o(c){const w=[];if(c.type===0)for(let E=0;E<c.args.length;E++)c.args[E]instanceof ArrayBuffer&&w.push(c.args[E]);else c.type===1&&c.res instanceof ArrayBuffer&&w.push(c.res);this.g.sendMessage(c,w)}}class $ extends y.$Uc{constructor(c,w,E){super();let A=null;this.a=this.B(c.create("vs/base/common/worker/simpleWorker",x=>{this.c.handleMessage(x)},x=>{A?.(x)})),this.c=new L({sendMessage:(x,I)=>{this.a.postMessage(x,I)},handleMessage:(x,I)=>{if(typeof E[x]!="function")return Promise.reject(new Error("Missing method "+x+" on main thread host."));try{return Promise.resolve(E[x].apply(E,I))}catch(H){return Promise.reject(H)}},handleEvent:(x,I)=>{if(u(x)){const H=E[x].call(E,I);if(typeof H!="function")throw new Error(`Missing dynamic event ${x} on main thread host.`);return H}if(b(x)){const H=E[x];if(typeof H!="function")throw new Error(`Missing event ${x} on main thread host.`);return H}throw new Error(`Malformed event name ${x}`)}}),this.c.setWorkerId(this.a.getId());let M=null;const T=globalThis.require;typeof T<"u"&&typeof T.getConfig=="function"?M=T.getConfig():typeof globalThis.requirejs<"u"&&(M=globalThis.requirejs.s.contexts._.config);const S=(0,f.$Xn)(E);this.b=this.c.sendMessage(o,[this.a.getId(),JSON.parse(JSON.stringify(M)),w,S]);const F=(x,I)=>this.g(x,I),R=(x,I)=>this.c.listen(x,I);this.f=new Promise((x,I)=>{A=I,this.b.then(H=>{x(l(H,F,R))},H=>{I(H),this.h("Worker failed to load "+w,H)})})}getProxyObject(){return this.f}g(c,w){return new Promise((E,A)=>{this.b.then(()=>{this.c.sendMessage(c,w).then(E,A)},A)})}h(c,w){console.error(c),console.info(w)}}t.SimpleWorkerClient=$;function b(N){return N[0]==="o"&&N[1]==="n"&&h.$kf(N.charCodeAt(2))}function u(N){return/^onDynamic/.test(N)&&h.$kf(N.charCodeAt(9))}function l(N,c,w){const E=T=>function(){const S=Array.prototype.slice.call(arguments,0);return c(T,S)},A=T=>function(S){return w(T,S)},M={};for(const T of N){if(u(T)){M[T]=A(T);continue}if(b(T)){M[T]=w(T,void 0);continue}M[T]=E(T)}return M}class n{constructor(c,w){this.a=w,this.b=null,this.c=new L({sendMessage:(E,A)=>{c(E,A)},handleMessage:(E,A)=>this.d(E,A),handleEvent:(E,A)=>this.f(E,A)})}onmessage(c){this.c.handleMessage(c)}d(c,w){if(c===o)return this.g(w[0],w[1],w[2],w[3]);if(!this.b||typeof this.b[c]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+c));try{return Promise.resolve(this.b[c].apply(this.b,w))}catch(E){return Promise.reject(E)}}f(c,w){if(!this.b)throw new Error("Missing requestHandler");if(u(c)){const E=this.b[c].call(this.b,w);if(typeof E!="function")throw new Error(`Missing dynamic event ${c} on request handler.`);return E}if(b(c)){const E=this.b[c];if(typeof E!="function")throw new Error(`Missing event ${c} on request handler.`);return E}throw new Error(`Malformed event name ${c}`)}g(c,w,E,A){this.c.setWorkerId(c);const S=l(A,(F,R)=>this.c.sendMessage(F,R),(F,R)=>this.c.listen(F,R));return this.a?(this.b=this.a(S),Promise.resolve((0,f.$Xn)(this.b))):(w&&(typeof w.baseUrl<"u"&&delete w.baseUrl,typeof w.paths<"u"&&typeof w.paths.vs<"u"&&delete w.paths.vs,typeof w.trustedTypesPolicy<"u"&&delete w.trustedTypesPolicy,w.catchError=!0,globalThis.require.config(w)),new Promise((F,R)=>{(globalThis.require||V)([E],I=>{if(this.b=I.create(S),!this.b){R(new Error("No RequestHandler!"));return}F((0,f.$Xn)(this.b))},R)}))}}t.SimpleWorkerServer=n;function s(N){return new n(N,null)}}),re(ie[68],se([64,65]),function(V,t){return V.create("vs/editor/common/languages",t)}),re(ie[69],se([0,1,43,18,44,2,62,68]),function(V,t,i,P,y,f,p,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InlineEditTriggerKind=t.ExternalUriOpenerPriority=t.$8t=t.$7t=t.InlayHintKind=t.CommentState=t.CommentMode=t.CommentThreadApplicability=t.CommentThreadState=t.CommentThreadCollapsibleState=t.Command=t.NewSymbolNameTag=t.$6t=t.$5t=t.SymbolKinds=t.SymbolTag=t.$3t=t.SymbolKind=t.DocumentHighlightKind=t.SignatureHelpTriggerKind=t.DocumentPasteTriggerKind=t.CodeActionTriggerType=t.$1t=t.InlineCompletionTriggerKind=t.CompletionTriggerKind=t.PartialAcceptTriggerKind=t.CompletionItemInsertTextRule=t.CompletionItemTag=t.CompletionItemKinds=t.CompletionItemKind=t.$Zt=t.$Yt=t.$Xt=void 0,t.$2t=s,t.$4t=c;class o{constructor(z,ue,oe){this.offset=z,this.type=ue,this.language=oe,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}t.$Xt=o;class a{constructor(z,ue){this.tokens=z,this.endState=ue,this._tokenizationResultBrand=void 0}}t.$Yt=a;class g{constructor(z,ue){this.tokens=z,this.endState=ue,this._encodedTokenizationResultBrand=void 0}}t.$Zt=g;var B;(function(k){k[k.Method=0]="Method",k[k.Function=1]="Function",k[k.Constructor=2]="Constructor",k[k.Field=3]="Field",k[k.Variable=4]="Variable",k[k.Class=5]="Class",k[k.Struct=6]="Struct",k[k.Interface=7]="Interface",k[k.Module=8]="Module",k[k.Property=9]="Property",k[k.Event=10]="Event",k[k.Operator=11]="Operator",k[k.Unit=12]="Unit",k[k.Value=13]="Value",k[k.Constant=14]="Constant",k[k.Enum=15]="Enum",k[k.EnumMember=16]="EnumMember",k[k.Keyword=17]="Keyword",k[k.Text=18]="Text",k[k.Color=19]="Color",k[k.File=20]="File",k[k.Reference=21]="Reference",k[k.Customcolor=22]="Customcolor",k[k.Folder=23]="Folder",k[k.TypeParameter=24]="TypeParameter",k[k.User=25]="User",k[k.Issue=26]="Issue",k[k.Snippet=27]="Snippet"})(B||(t.CompletionItemKind=B={}));var d;(function(k){const z=new Map;z.set(0,i.$Gj.symbolMethod),z.set(1,i.$Gj.symbolFunction),z.set(2,i.$Gj.symbolConstructor),z.set(3,i.$Gj.symbolField),z.set(4,i.$Gj.symbolVariable),z.set(5,i.$Gj.symbolClass),z.set(6,i.$Gj.symbolStruct),z.set(7,i.$Gj.symbolInterface),z.set(8,i.$Gj.symbolModule),z.set(9,i.$Gj.symbolProperty),z.set(10,i.$Gj.symbolEvent),z.set(11,i.$Gj.symbolOperator),z.set(12,i.$Gj.symbolUnit),z.set(13,i.$Gj.symbolValue),z.set(15,i.$Gj.symbolEnum),z.set(14,i.$Gj.symbolConstant),z.set(15,i.$Gj.symbolEnum),z.set(16,i.$Gj.symbolEnumMember),z.set(17,i.$Gj.symbolKeyword),z.set(27,i.$Gj.symbolSnippet),z.set(18,i.$Gj.symbolText),z.set(19,i.$Gj.symbolColor),z.set(20,i.$Gj.symbolFile),z.set(21,i.$Gj.symbolReference),z.set(22,i.$Gj.symbolCustomColor),z.set(23,i.$Gj.symbolFolder),z.set(24,i.$Gj.symbolTypeParameter),z.set(25,i.$Gj.account),z.set(26,i.$Gj.issues);function ue($e){let ve=z.get($e);return ve||(console.info("No codicon found for CompletionItemKind "+$e),ve=i.$Gj.symbolProperty),ve}k.toIcon=ue;const oe=new Map;oe.set("method",0),oe.set("function",1),oe.set("constructor",2),oe.set("field",3),oe.set("variable",4),oe.set("class",5),oe.set("struct",6),oe.set("interface",7),oe.set("module",8),oe.set("property",9),oe.set("event",10),oe.set("operator",11),oe.set("unit",12),oe.set("value",13),oe.set("constant",14),oe.set("enum",15),oe.set("enum-member",16),oe.set("enumMember",16),oe.set("keyword",17),oe.set("snippet",27),oe.set("text",18),oe.set("color",19),oe.set("file",20),oe.set("reference",21),oe.set("customcolor",22),oe.set("folder",23),oe.set("type-parameter",24),oe.set("typeParameter",24),oe.set("account",25),oe.set("issue",26);function r($e,ve){let Le=oe.get($e);return typeof Le>"u"&&!ve&&(Le=9),Le}k.fromString=r})(d||(t.CompletionItemKinds=d={}));var m;(function(k){k[k.Deprecated=1]="Deprecated"})(m||(t.CompletionItemTag=m={}));var e;(function(k){k[k.None=0]="None",k[k.KeepWhitespace=1]="KeepWhitespace",k[k.InsertAsSnippet=4]="InsertAsSnippet"})(e||(t.CompletionItemInsertTextRule=e={}));var v;(function(k){k[k.Word=0]="Word",k[k.Line=1]="Line",k[k.Suggest=2]="Suggest"})(v||(t.PartialAcceptTriggerKind=v={}));var j;(function(k){k[k.Invoke=0]="Invoke",k[k.TriggerCharacter=1]="TriggerCharacter",k[k.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(j||(t.CompletionTriggerKind=j={}));var L;(function(k){k[k.Automatic=0]="Automatic",k[k.Explicit=1]="Explicit"})(L||(t.InlineCompletionTriggerKind=L={}));class ${constructor(z,ue,oe,r){this.range=z,this.text=ue,this.completionKind=oe,this.isSnippetText=r}equals(z){return f.$bt.lift(this.range).equalsRange(z.range)&&this.text===z.text&&this.completionKind===z.completionKind&&this.isSnippetText===z.isSnippetText}}t.$1t=$;var b;(function(k){k[k.Invoke=1]="Invoke",k[k.Auto=2]="Auto"})(b||(t.CodeActionTriggerType=b={}));var u;(function(k){k[k.Automatic=0]="Automatic",k[k.PasteAs=1]="PasteAs"})(u||(t.DocumentPasteTriggerKind=u={}));var l;(function(k){k[k.Invoke=1]="Invoke",k[k.TriggerCharacter=2]="TriggerCharacter",k[k.ContentChange=3]="ContentChange"})(l||(t.SignatureHelpTriggerKind=l={}));var n;(function(k){k[k.Text=0]="Text",k[k.Read=1]="Read",k[k.Write=2]="Write"})(n||(t.DocumentHighlightKind=n={}));function s(k){return k&&P.URI.isUri(k.uri)&&f.$bt.isIRange(k.range)&&(f.$bt.isIRange(k.originSelectionRange)||f.$bt.isIRange(k.targetSelectionRange))}var N;(function(k){k[k.File=0]="File",k[k.Module=1]="Module",k[k.Namespace=2]="Namespace",k[k.Package=3]="Package",k[k.Class=4]="Class",k[k.Method=5]="Method",k[k.Property=6]="Property",k[k.Field=7]="Field",k[k.Constructor=8]="Constructor",k[k.Enum=9]="Enum",k[k.Interface=10]="Interface",k[k.Function=11]="Function",k[k.Variable=12]="Variable",k[k.Constant=13]="Constant",k[k.String=14]="String",k[k.Number=15]="Number",k[k.Boolean=16]="Boolean",k[k.Array=17]="Array",k[k.Object=18]="Object",k[k.Key=19]="Key",k[k.Null=20]="Null",k[k.EnumMember=21]="EnumMember",k[k.Struct=22]="Struct",k[k.Event=23]="Event",k[k.Operator=24]="Operator",k[k.TypeParameter=25]="TypeParameter"})(N||(t.SymbolKind=N={})),t.$3t={17:(0,h.localize)(0,null),16:(0,h.localize)(1,null),4:(0,h.localize)(2,null),13:(0,h.localize)(3,null),8:(0,h.localize)(4,null),9:(0,h.localize)(5,null),21:(0,h.localize)(6,null),23:(0,h.localize)(7,null),7:(0,h.localize)(8,null),0:(0,h.localize)(9,null),11:(0,h.localize)(10,null),10:(0,h.localize)(11,null),19:(0,h.localize)(12,null),5:(0,h.localize)(13,null),1:(0,h.localize)(14,null),2:(0,h.localize)(15,null),20:(0,h.localize)(16,null),15:(0,h.localize)(17,null),18:(0,h.localize)(18,null),24:(0,h.localize)(19,null),3:(0,h.localize)(20,null),6:(0,h.localize)(21,null),14:(0,h.localize)(22,null),22:(0,h.localize)(23,null),25:(0,h.localize)(24,null),12:(0,h.localize)(25,null)};function c(k,z){return(0,h.localize)(26,null,k,t.$3t[z])}var w;(function(k){k[k.Deprecated=1]="Deprecated"})(w||(t.SymbolTag=w={}));var E;(function(k){const z=new Map;z.set(0,i.$Gj.symbolFile),z.set(1,i.$Gj.symbolModule),z.set(2,i.$Gj.symbolNamespace),z.set(3,i.$Gj.symbolPackage),z.set(4,i.$Gj.symbolClass),z.set(5,i.$Gj.symbolMethod),z.set(6,i.$Gj.symbolProperty),z.set(7,i.$Gj.symbolField),z.set(8,i.$Gj.symbolConstructor),z.set(9,i.$Gj.symbolEnum),z.set(10,i.$Gj.symbolInterface),z.set(11,i.$Gj.symbolFunction),z.set(12,i.$Gj.symbolVariable),z.set(13,i.$Gj.symbolConstant),z.set(14,i.$Gj.symbolString),z.set(15,i.$Gj.symbolNumber),z.set(16,i.$Gj.symbolBoolean),z.set(17,i.$Gj.symbolArray),z.set(18,i.$Gj.symbolObject),z.set(19,i.$Gj.symbolKey),z.set(20,i.$Gj.symbolNull),z.set(21,i.$Gj.symbolEnumMember),z.set(22,i.$Gj.symbolStruct),z.set(23,i.$Gj.symbolEvent),z.set(24,i.$Gj.symbolOperator),z.set(25,i.$Gj.symbolTypeParameter);function ue(oe){let r=z.get(oe);return r||(console.info("No codicon found for SymbolKind "+oe),r=i.$Gj.symbolProperty),r}k.toIcon=ue})(E||(t.SymbolKinds=E={}));class A{static asEditOperation(z){return y.$ct.replace(f.$bt.lift(z.range),z.text)}}t.$5t=A;class M{static{this.Comment=new M("comment")}static{this.Imports=new M("imports")}static{this.Region=new M("region")}static fromValue(z){switch(z){case"comment":return M.Comment;case"imports":return M.Imports;case"region":return M.Region}return new M(z)}constructor(z){this.value=z}}t.$6t=M;var T;(function(k){k[k.AIGenerated=1]="AIGenerated"})(T||(t.NewSymbolNameTag=T={}));var S;(function(k){function z(ue){return!ue||typeof ue!="object"?!1:typeof ue.id=="string"&&typeof ue.title=="string"}k.is=z})(S||(t.Command=S={}));var F;(function(k){k[k.Collapsed=0]="Collapsed",k[k.Expanded=1]="Expanded"})(F||(t.CommentThreadCollapsibleState=F={}));var R;(function(k){k[k.Unresolved=0]="Unresolved",k[k.Resolved=1]="Resolved"})(R||(t.CommentThreadState=R={}));var x;(function(k){k[k.Current=0]="Current",k[k.Outdated=1]="Outdated"})(x||(t.CommentThreadApplicability=x={}));var I;(function(k){k[k.Editing=0]="Editing",k[k.Preview=1]="Preview"})(I||(t.CommentMode=I={}));var H;(function(k){k[k.Published=0]="Published",k[k.Draft=1]="Draft"})(H||(t.CommentState=H={}));var K;(function(k){k[k.Type=1]="Type",k[k.Parameter=2]="Parameter"})(K||(t.InlayHintKind=K={}));class _{constructor(z){this.b=z,this.a=null}dispose(){this.a&&this.a.then(z=>{z&&z.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}t.$7t=_,t.$8t=new p.$Mt;var X;(function(k){k[k.None=0]="None",k[k.Option=1]="Option",k[k.Default=2]="Default",k[k.Preferred=3]="Preferred"})(X||(t.ExternalUriOpenerPriority=X={}));var Z;(function(k){k[k.Invoke=0]="Invoke",k[k.Automatic=1]="Automatic"})(Z||(t.InlineEditTriggerKind=Z={}))}),re(ie[70],se([0,1,24,11,38,18,5,2,45,69,61]),function(V,t,i,P,y,f,p,h,o,a,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$q2=void 0,t.$r2=d;class B{static{this.CtrlCmd=2048}static{this.Shift=1024}static{this.Alt=512}static{this.WinCtrl=256}static chord(e,v){return(0,y.$nr)(e,v)}}t.$q2=B;function d(){return{editor:void 0,languages:void 0,CancellationTokenSource:i.$ee,Emitter:P.$7d,KeyCode:g.KeyCode,KeyMod:B,Position:p.$at,Range:h.$bt,Selection:o.$dt,SelectionDirection:g.SelectionDirection,MarkerSeverity:g.MarkerSeverity,MarkerTag:g.MarkerTag,Uri:f.URI,Token:a.$Xt}}}),re(ie[73],se([0,1,25,18,5,2,58,30,54,55,70,23,60,34,52,14,3,53]),function(V,t,i,P,y,f,p,h,o,a,g,B,d,m,e,v,j,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.EditorSimpleWorker=void 0,t.create=u;class $ extends p.$Gv{get uri(){return this.d}get eol(){return this.g}getValue(){return this.getText()}findMatches(n){const s=[];for(let N=0;N<this.f.length;N++){const c=this.f[N],w=this.offsetAt(new y.$at(N+1,1)),E=c.matchAll(n);for(const A of E)(A.index||A.index===0)&&(A.index=A.index+w),s.push(A)}return s}getLinesContent(){return this.f.slice(0)}getLineCount(){return this.f.length}getLineContent(n){return this.f[n-1]}getWordAtPosition(n,s){const N=(0,h.$Qs)(n.column,(0,h.$Os)(s),this.f[n.lineNumber-1],0);return N?new f.$bt(n.lineNumber,N.startColumn,n.lineNumber,N.endColumn):null}getWordUntilPosition(n,s){const N=this.getWordAtPosition(n,s);return N?{word:this.f[n.lineNumber-1].substring(N.startColumn-1,n.column-1),startColumn:N.startColumn,endColumn:n.column}:{word:"",startColumn:n.column,endColumn:n.column}}words(n){const s=this.f,N=this.q.bind(this);let c=0,w="",E=0,A=[];return{*[Symbol.iterator](){for(;;)if(E<A.length){const M=w.substring(A[E].start,A[E].end);E+=1,yield M}else if(c<s.length)w=s[c],A=N(w,n),E=0,c+=1;else break}}}getLineWords(n,s){const N=this.f[n-1],c=this.q(N,s),w=[];for(const E of c)w.push({word:N.substring(E.start,E.end),startColumn:E.start+1,endColumn:E.end+1});return w}q(n,s){const N=[];let c;for(s.lastIndex=0;(c=s.exec(n))&&c[0].length!==0;)N.push({start:c.index,end:c.index+c[0].length});return N}getValueInRange(n){if(n=this.r(n),n.startLineNumber===n.endLineNumber)return this.f[n.startLineNumber-1].substring(n.startColumn-1,n.endColumn-1);const s=this.g,N=n.startLineNumber-1,c=n.endLineNumber-1,w=[];w.push(this.f[N].substring(n.startColumn-1));for(let E=N+1;E<c;E++)w.push(this.f[E]);return w.push(this.f[c].substring(0,n.endColumn-1)),w.join(s)}offsetAt(n){return n=this.s(n),this.l(),this.j.getPrefixSum(n.lineNumber-2)+(n.column-1)}positionAt(n){n=Math.floor(n),n=Math.max(0,n),this.l();const s=this.j.getIndexOf(n),N=this.f[s.index].length;return{lineNumber:1+s.index,column:1+Math.min(s.remainder,N)}}r(n){const s=this.s({lineNumber:n.startLineNumber,column:n.startColumn}),N=this.s({lineNumber:n.endLineNumber,column:n.endColumn});return s.lineNumber!==n.startLineNumber||s.column!==n.startColumn||N.lineNumber!==n.endLineNumber||N.column!==n.endColumn?{startLineNumber:s.lineNumber,startColumn:s.column,endLineNumber:N.lineNumber,endColumn:N.column}:n}s(n){if(!y.$at.isIPosition(n))throw new Error("bad position");let{lineNumber:s,column:N}=n,c=!1;if(s<1)s=1,N=1,c=!0;else if(s>this.f.length)s=this.f.length,N=this.f[s-1].length+1,c=!0;else{const w=this.f[s-1].length+1;N<1?(N=1,c=!0):N>w&&(N=w,c=!0)}return c?{lineNumber:s,column:N}:n}}class b{constructor(n,s){this.d=n,this.f=Object.create(null),this.g=s,this.h=null}dispose(){this.f=Object.create(null)}j(n){return this.f[n]}k(){const n=[];return Object.keys(this.f).forEach(s=>n.push(this.f[s])),n}acceptNewModel(n){this.f[n.url]=new $(P.URI.parse(n.url),n.lines,n.EOL,n.versionId)}acceptModelChanged(n,s){if(!this.f[n])return;this.f[n].onEvents(s)}acceptRemovedModel(n){this.f[n]&&delete this.f[n]}async computeUnicodeHighlights(n,s,N){const c=this.j(n);return c?d.$l2.computeUnicodeHighlights(c,s,N):{ranges:[],hasMore:!1,ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0}}async computeDiff(n,s,N,c){const w=this.j(n),E=this.j(s);return!w||!E?null:b.l(w,E,N,c)}static l(n,s,N,c){const w=c==="advanced"?e.$N2.getDefault():e.$N2.getLegacy(),E=n.getLinesContent(),A=s.getLinesContent(),M=w.computeDiff(E,A,N),T=M.changes.length>0?!1:this.n(n,s);function S(F){return F.map(R=>[R.original.startLineNumber,R.original.endLineNumberExclusive,R.modified.startLineNumber,R.modified.endLineNumberExclusive,R.innerChanges?.map(x=>[x.originalRange.startLineNumber,x.originalRange.startColumn,x.originalRange.endLineNumber,x.originalRange.endColumn,x.modifiedRange.startLineNumber,x.modifiedRange.startColumn,x.modifiedRange.endLineNumber,x.modifiedRange.endColumn])])}return{identical:T,quitEarly:M.hitTimeout,changes:S(M.changes),moves:M.moves.map(F=>[F.lineRangeMapping.original.startLineNumber,F.lineRangeMapping.original.endLineNumberExclusive,F.lineRangeMapping.modified.startLineNumber,F.lineRangeMapping.modified.endLineNumberExclusive,S(F.changes)])}}static n(n,s){const N=n.getLineCount(),c=s.getLineCount();if(N!==c)return!1;for(let w=1;w<=N;w++){const E=n.getLineContent(w),A=s.getLineContent(w);if(E!==A)return!1}return!0}async computeDirtyDiff(n,s,N){const c=this.j(n),w=this.j(s);if(!c||!w)return null;const E=c.getLinesContent(),A=w.getLinesContent();return new m.$st(E,A,{shouldComputeCharChanges:!1,shouldPostProcessCharChanges:!1,shouldIgnoreTrimWhitespace:N,shouldMakePrettyDiff:!0,maxComputationTime:1e3}).computeDiff().changes}static{this.o=1e5}async computeMoreMinimalEdits(n,s,N){const c=this.j(n);if(!c)return s;const w=[];let E;s=s.slice(0).sort((M,T)=>{if(M.range&&T.range)return f.$bt.compareRangesUsingStarts(M.range,T.range);const S=M.range?0:1,F=T.range?0:1;return S-F});let A=0;for(let M=1;M<s.length;M++)f.$bt.getEndPosition(s[A].range).equals(f.$bt.getStartPosition(s[M].range))?(s[A].range=f.$bt.fromPositions(f.$bt.getStartPosition(s[A].range),f.$bt.getEndPosition(s[M].range)),s[A].text+=s[M].text):(A++,s[A]=s[M]);s.length=A+1;for(let{range:M,text:T,eol:S}of s){if(typeof S=="number"&&(E=S),f.$bt.isEmpty(M)&&!T)continue;const F=c.getValueInRange(M);if(T=T.replace(/\r\n|\n|\r/g,c.eol),F===T)continue;if(Math.max(T.length,F.length)>b.o){w.push({range:M,text:T});continue}const R=(0,i.$gt)(F,T,N),x=c.offsetAt(f.$bt.lift(M).getStartPosition());for(const I of R){const H=c.positionAt(x+I.originalStart),K=c.positionAt(x+I.originalStart+I.originalLength),_={text:T.substr(I.modifiedStart,I.modifiedLength),range:{startLineNumber:H.lineNumber,startColumn:H.column,endLineNumber:K.lineNumber,endColumn:K.column}};c.getValueInRange(_.range)!==_.text&&w.push(_)}}return typeof E=="number"&&w.push({eol:E,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),w}computeHumanReadableDiff(n,s,N){const c=this.j(n);if(!c)return s;const w=[];let E;s=s.slice(0).sort((A,M)=>{if(A.range&&M.range)return f.$bt.compareRangesUsingStarts(A.range,M.range);const T=A.range?0:1,S=M.range?0:1;return T-S});for(let{range:A,text:M,eol:T}of s){let H=function(_,X){return new y.$at(_.lineNumber+X.lineNumber-1,X.lineNumber===1?_.column+X.column-1:X.column)},K=function(_,X){const Z=[];for(let k=X.startLineNumber;k<=X.endLineNumber;k++){const z=_[k-1];k===X.startLineNumber&&k===X.endLineNumber?Z.push(z.substring(X.startColumn-1,X.endColumn-1)):k===X.startLineNumber?Z.push(z.substring(X.startColumn-1)):k===X.endLineNumber?Z.push(z.substring(0,X.endColumn-1)):Z.push(z)}return Z};if(typeof T=="number"&&(E=T),f.$bt.isEmpty(A)&&!M)continue;const S=c.getValueInRange(A);if(M=M.replace(/\r\n|\n|\r/g,c.eol),S===M)continue;if(Math.max(M.length,S.length)>b.o){w.push({range:A,text:M});continue}const F=S.split(/\r\n|\n|\r/),R=M.split(/\r\n|\n|\r/),x=e.$N2.getDefault().computeDiff(F,R,N),I=f.$bt.lift(A).getStartPosition();for(const _ of x.changes)if(_.innerChanges)for(const X of _.innerChanges)w.push({range:f.$bt.fromPositions(H(I,X.originalRange.getStartPosition()),H(I,X.originalRange.getEndPosition())),text:K(R,X.modifiedRange).join(c.eol)});else throw new j.$cb("The experimental diff algorithm always produces inner changes")}return typeof E=="number"&&w.push({eol:E,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),w}async computeLinks(n){const s=this.j(n);return s?(0,o.$o2)(s):null}async computeDefaultDocumentColors(n){const s=this.j(n);return s?(0,L.$O2)(s):null}static{this.p=1e4}async textualSuggest(n,s,N,c){const w=new B.$3d,E=new RegExp(N,c),A=new Set;e:for(const M of n){const T=this.j(M);if(T){for(const S of T.words(E))if(!(S===s||!isNaN(Number(S)))&&(A.add(S),A.size>b.p))break e}}return{words:Array.from(A),duration:w.elapsed()}}async computeWordRanges(n,s,N,c){const w=this.j(n);if(!w)return Object.create(null);const E=new RegExp(N,c),A=Object.create(null);for(let M=s.startLineNumber;M<s.endLineNumber;M++){const T=w.getLineWords(M,E);for(const S of T){if(!isNaN(Number(S.word)))continue;let F=A[S.word];F||(F=[],A[S.word]=F),F.push({startLineNumber:M,startColumn:S.startColumn,endLineNumber:M,endColumn:S.endColumn})}}return A}async navigateValueSet(n,s,N,c,w){const E=this.j(n);if(!E)return null;const A=new RegExp(c,w);s.startColumn===s.endColumn&&(s={startLineNumber:s.startLineNumber,startColumn:s.startColumn,endLineNumber:s.endLineNumber,endColumn:s.endColumn+1});const M=E.getValueInRange(s),T=E.getWordAtPosition({lineNumber:s.startLineNumber,column:s.startColumn},A);if(!T)return null;const S=E.getValueInRange(T);return a.$p2.INSTANCE.navigateValueSet(s,M,T,S,N)}loadForeignModule(n,s,N){const c=(A,M)=>this.d.fhr(A,M),E={host:(0,v.$Yn)(N,c),getMirrorModels:()=>this.k()};return this.g?(this.h=this.g(E,s),Promise.resolve((0,v.$Xn)(this.h))):new Promise((A,M)=>{V([n],T=>{this.h=T.create(E,s),A((0,v.$Xn)(this.h))},M)})}fmr(n,s){if(!this.h||typeof this.h[n]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+n));try{return Promise.resolve(this.h[n].apply(this.h,s))}catch(N){return Promise.reject(N)}}}t.EditorSimpleWorker=b;function u(l){return new b(l,null)}typeof importScripts=="function"&&(globalThis.monaco=(0,g.$r2)())})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/be210b3a60c7d60030c1d3d92da00d008edf6ab9/core/vs/base/worker/workerMain.js.map
