/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var oe=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","vs/base/common/network","electron","vs/base/common/errors","vs/platform/files/common/files","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/base/common/resources","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/node/pfs","vs/base/common/arrays","vs/base/common/cancellation","vs/platform/environment/electron-main/environmentMainService","vs/base/common/strings","os","vs/platform/product/common/productService","vs/platform/telemetry/common/telemetry","vs/platform/windows/electron-main/windows","vs/platform/workspace/common/workspace","vs/base/common/extpath","vs/base/common/map","vs/base/common/uuid","vs/platform/state/node/state","vs/base/common/objects","vs/base/common/process","vs/base/parts/ipc/electron-main/ipcMain","vs/platform/environment/common/environment","vs/platform/policy/common/policy","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/json","fs","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/hash","vs/base/common/errorMessage","vs/base/common/labels","child_process","vs/platform/update/common/update","vs/base/common/decorators","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/platform/window/common/window","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/ternarySearchTree","vs/platform/files/common/watcher","vs/platform/utilityProcess/electron-main/utilityProcess","vs/base/common/lazy","vs/base/common/stream","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/base/common/performance","vs/platform/log/electron-main/loggerService","vs/platform/remote/common/remoteHosts","vs/platform/theme/electron-main/themeMainService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/iterator","vs/base/common/stopwatch","vs/base/common/severity","vs/base/common/codicons","vs/base/common/processes","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindows","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/window/electron-main/window","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/functional","vs/base/common/normalization","crypto","net","vs/base/node/id","vs/base/node/processes","vs/platform/environment/node/environmentService","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/shell/node/shellEnv","vs/platform/sign/common/sign","vs/platform/storage/common/storage","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/parts/ipc/node/ipc.net","vs/platform/update/electron-main/abstractUpdateService","vs/base/node/unc","vs/base/common/jsonEdit","vs/base/common/linkedList","vs/base/common/codiconsUtil","vs/base/common/themables","vs/base/node/ports","vs/base/common/glob","vs/base/node/extpath","vs/base/node/powershell","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","path","vs/platform/contextkey/common/contextkey","vs/platform/dialogs/common/dialogs","vs/platform/encryption/common/encryptionService","vs/platform/extensionManagement/common/extensionManagement","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/terminal","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/platform/windows/electron-main/windowImpl","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/common/codiconsLibrary","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/electron-main/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/issue/common/issue","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/electron-main/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/policy/node/nativePolicyService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/electronRemoteResources","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/telemetryUtils","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/userData/common/fileUserDataProvider","vs/platform/utilityProcess/common/utilityProcessWorkerService","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","zlib","vs/platform/backup/electron-main/backupMainService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/tunnel/node/tunnelService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/code/electron-main/auth","vs/platform/launch/electron-main/launchMainService","vs/platform/userDataProfile/electron-main/userDataProfilesHandler","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/terminal/electron-main/electronPtyHostStarter","vs/platform/utilityProcess/electron-main/utilityProcessWorkerMainService","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindow","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindowsMainService","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","minimist","assert","graceful-fs","string_decoder","vs/code/electron-main/main"],ae=function(J){for(var e=[],n=0,j=J.length;n<j;n++)e[n]=oe[J[n]];return e};define(oe[136],ae([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mb=void 0,e.$fb=n,e.$gb=j,e.$hb=P,e.$ib=B,e.$jb=S,e.$kb=E,e.$lb=h,e.$nb=p,e.$ob=y,e.$pb=k,e.$qb=g,e.$rb=m;function n(v,w,$){const f=j(v,w);if(f!==-1)return v[f]}function j(v,w,$=v.length-1){for(let f=$;f>=0;f--){const l=v[f];if(w(l))return f}return-1}function P(v,w){const $=B(v,w);return $===-1?void 0:v[$]}function B(v,w,$=0,f=v.length){let l=$,d=f;for(;l<d;){const a=Math.floor((l+d)/2);w(v[a])?l=a+1:d=a}return l-1}function S(v,w){const $=E(v,w);return $===v.length?void 0:v[$]}function E(v,w,$=0,f=v.length){let l=$,d=f;for(;l<d;){const a=Math.floor((l+d)/2);w(v[a])?d=a:l=a+1}return l}function h(v,w,$=0,f=v.length){const l=E(v,w,$,f);return l===v.length?-1:l}class c{static{this.assertInvariants=!1}constructor(w){this.e=w,this.c=0}findLastMonotonous(w){if(c.assertInvariants){if(this.d){for(const f of this.e)if(this.d(f)&&!w(f))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=w}const $=B(this.e,w,this.c);return this.c=$+1,$===-1?void 0:this.e[$]}}e.$mb=c;function p(v,w){if(v.length===0)return;let $=v[0];for(let f=1;f<v.length;f++){const l=v[f];w(l,$)>0&&($=l)}return $}function y(v,w){if(v.length===0)return;let $=v[0];for(let f=1;f<v.length;f++){const l=v[f];w(l,$)>=0&&($=l)}return $}function k(v,w){return p(v,($,f)=>-w($,f))}function g(v,w){if(v.length===0)return-1;let $=0;for(let f=1;f<v.length;f++){const l=v[f];w(l,v[$])>0&&($=f)}return $}function m(v,w){for(const $ of v){const f=w($);if(f!==void 0)return f}}}),define(oe[137],ae([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K=n,e.$L=j,e.$M=P,e.$N=B;function n(S,E){const h=Object.create(null);for(const c of S){const p=E(c);let y=h[p];y||(y=h[p]=[]),y.push(c)}return h}function j(S,E){const h=[],c=[];for(const p of S)E.has(p)||h.push(p);for(const p of E)S.has(p)||c.push(p);return{removed:h,added:c}}function P(S,E){const h=[],c=[];for(const[p,y]of S)E.has(p)||h.push(y);for(const[p,y]of E)S.has(p)||c.push(y);return{removed:h,added:c}}function B(S,E){const h=new Set;for(const c of E)S.has(c)&&h.add(c);return h}}),define(oe[138],ae([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ft=e.$Et=e.$Dt=e.$Ct=void 0;function n(E,h){const c=Math.pow(10,h);return Math.round(E*c)/c}class j{constructor(h,c,p,y=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,h))|0,this.g=Math.min(255,Math.max(0,c))|0,this.b=Math.min(255,Math.max(0,p))|0,this.a=n(Math.max(Math.min(1,y),0),3)}static equals(h,c){return h.r===c.r&&h.g===c.g&&h.b===c.b&&h.a===c.a}}e.$Ct=j;class P{constructor(h,c,p,y){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,h),0)|0,this.s=n(Math.max(Math.min(1,c),0),3),this.l=n(Math.max(Math.min(1,p),0),3),this.a=n(Math.max(Math.min(1,y),0),3)}static equals(h,c){return h.h===c.h&&h.s===c.s&&h.l===c.l&&h.a===c.a}static fromRGBA(h){const c=h.r/255,p=h.g/255,y=h.b/255,k=h.a,g=Math.max(c,p,y),m=Math.min(c,p,y);let v=0,w=0;const $=(m+g)/2,f=g-m;if(f>0){switch(w=Math.min($<=.5?f/(2*$):f/(2-2*$),1),g){case c:v=(p-y)/f+(p<y?6:0);break;case p:v=(y-c)/f+2;break;case y:v=(c-p)/f+4;break}v*=60,v=Math.round(v)}return new P(v,w,$,k)}static i(h,c,p){return p<0&&(p+=1),p>1&&(p-=1),p<1/6?h+(c-h)*6*p:p<1/2?c:p<2/3?h+(c-h)*(2/3-p)*6:h}static toRGBA(h){const c=h.h/360,{s:p,l:y,a:k}=h;let g,m,v;if(p===0)g=m=v=y;else{const w=y<.5?y*(1+p):y+p-y*p,$=2*y-w;g=P.i($,w,c+1/3),m=P.i($,w,c),v=P.i($,w,c-1/3)}return new j(Math.round(g*255),Math.round(m*255),Math.round(v*255),k)}}e.$Dt=P;class B{constructor(h,c,p,y){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,h),0)|0,this.s=n(Math.max(Math.min(1,c),0),3),this.v=n(Math.max(Math.min(1,p),0),3),this.a=n(Math.max(Math.min(1,y),0),3)}static equals(h,c){return h.h===c.h&&h.s===c.s&&h.v===c.v&&h.a===c.a}static fromRGBA(h){const c=h.r/255,p=h.g/255,y=h.b/255,k=Math.max(c,p,y),g=Math.min(c,p,y),m=k-g,v=k===0?0:m/k;let w;return m===0?w=0:k===c?w=((p-y)/m%6+6)%6:k===p?w=(y-c)/m+2:w=(c-p)/m+4,new B(Math.round(w*60),v,k,h.a)}static toRGBA(h){const{h:c,s:p,v:y,a:k}=h,g=y*p,m=g*(1-Math.abs(c/60%2-1)),v=y-g;let[w,$,f]=[0,0,0];return c<60?(w=g,$=m):c<120?(w=m,$=g):c<180?($=g,f=m):c<240?($=m,f=g):c<300?(w=m,f=g):c<=360&&(w=g,f=m),w=Math.round((w+v)*255),$=Math.round(($+v)*255),f=Math.round((f+v)*255),new j(w,$,f,k)}}e.$Et=B;class S{static fromHex(h){return S.Format.CSS.parseHex(h)||S.red}static equals(h,c){return!h&&!c?!0:!h||!c?!1:h.equals(c)}get hsla(){return this.i?this.i:P.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:B.fromRGBA(this.rgba)}constructor(h){if(h)if(h instanceof j)this.rgba=h;else if(h instanceof P)this.i=h,this.rgba=P.toRGBA(h);else if(h instanceof B)this.j=h,this.rgba=B.toRGBA(h);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(h){return!!h&&j.equals(this.rgba,h.rgba)&&P.equals(this.hsla,h.hsla)&&B.equals(this.hsva,h.hsva)}getRelativeLuminance(){const h=S.k(this.rgba.r),c=S.k(this.rgba.g),p=S.k(this.rgba.b),y=.2126*h+.7152*c+.0722*p;return n(y,4)}static k(h){const c=h/255;return c<=.03928?c/12.92:Math.pow((c+.055)/1.055,2.4)}getContrastRatio(h){const c=this.getRelativeLuminance(),p=h.getRelativeLuminance();return c>p?(c+.05)/(p+.05):(p+.05)/(c+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(h){const c=this.getRelativeLuminance(),p=h.getRelativeLuminance();return c>p}isDarkerThan(h){const c=this.getRelativeLuminance(),p=h.getRelativeLuminance();return c<p}lighten(h){return new S(new P(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*h,this.hsla.a))}darken(h){return new S(new P(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*h,this.hsla.a))}transparent(h){const{r:c,g:p,b:y,a:k}=this.rgba;return new S(new j(c,p,y,k*h))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new S(new j(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(h){const c=h.rgba,p=this.rgba.a,y=c.a,k=p+y*(1-p);if(k<1e-6)return S.transparent;const g=this.rgba.r*p/k+c.r*y*(1-p)/k,m=this.rgba.g*p/k+c.g*y*(1-p)/k,v=this.rgba.b*p/k+c.b*y*(1-p)/k;return new S(new j(g,m,v,k))}makeOpaque(h){if(this.isOpaque()||h.rgba.a!==1)return this;const{r:c,g:p,b:y,a:k}=this.rgba;return new S(new j(h.rgba.r-k*(h.rgba.r-c),h.rgba.g-k*(h.rgba.g-p),h.rgba.b-k*(h.rgba.b-y),1))}flatten(...h){const c=h.reduceRight((p,y)=>S.o(y,p));return S.o(this,c)}static o(h,c){const p=1-h.rgba.a;return new S(new j(p*c.rgba.r+h.rgba.a*h.rgba.r,p*c.rgba.g+h.rgba.a*h.rgba.g,p*c.rgba.b+h.rgba.a*h.rgba.b))}toString(){return this.u||(this.u=S.Format.CSS.format(this)),this.u}static getLighterColor(h,c,p){if(h.isLighterThan(c))return h;p=p||.5;const y=h.getRelativeLuminance(),k=c.getRelativeLuminance();return p=p*(k-y)/k,h.lighten(p)}static getDarkerColor(h,c,p){if(h.isDarkerThan(c))return h;p=p||.5;const y=h.getRelativeLuminance(),k=c.getRelativeLuminance();return p=p*(y-k)/y,h.darken(p)}static{this.white=new S(new j(255,255,255,1))}static{this.black=new S(new j(0,0,0,1))}static{this.red=new S(new j(255,0,0,1))}static{this.blue=new S(new j(0,0,255,1))}static{this.green=new S(new j(0,255,0,1))}static{this.cyan=new S(new j(0,255,255,1))}static{this.lightgrey=new S(new j(211,211,211,1))}static{this.transparent=new S(new j(0,0,0,0))}}e.$Ft=S,function(E){let h;(function(c){let p;(function(y){function k(t){return t.rgba.a===1?`rgb(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b})`:E.Format.CSS.formatRGBA(t)}y.formatRGB=k;function g(t){return`rgba(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b}, ${+t.rgba.a.toFixed(2)})`}y.formatRGBA=g;function m(t){return t.hsla.a===1?`hsl(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%)`:E.Format.CSS.formatHSLA(t)}y.formatHSL=m;function v(t){return`hsla(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%, ${t.hsla.a.toFixed(2)})`}y.formatHSLA=v;function w(t){const o=t.toString(16);return o.length!==2?"0"+o:o}function $(t){return`#${w(t.rgba.r)}${w(t.rgba.g)}${w(t.rgba.b)}`}y.formatHex=$;function f(t,o=!1){return o&&t.rgba.a===1?E.Format.CSS.formatHex(t):`#${w(t.rgba.r)}${w(t.rgba.g)}${w(t.rgba.b)}${w(Math.round(t.rgba.a*255))}`}y.formatHexA=f;function l(t){return t.isOpaque()?E.Format.CSS.formatHex(t):E.Format.CSS.formatRGBA(t)}y.format=l;function d(t){const o=t.length;if(o===0||t.charCodeAt(0)!==35)return null;if(o===7){const r=16*a(t.charCodeAt(1))+a(t.charCodeAt(2)),i=16*a(t.charCodeAt(3))+a(t.charCodeAt(4)),s=16*a(t.charCodeAt(5))+a(t.charCodeAt(6));return new E(new j(r,i,s,1))}if(o===9){const r=16*a(t.charCodeAt(1))+a(t.charCodeAt(2)),i=16*a(t.charCodeAt(3))+a(t.charCodeAt(4)),s=16*a(t.charCodeAt(5))+a(t.charCodeAt(6)),u=16*a(t.charCodeAt(7))+a(t.charCodeAt(8));return new E(new j(r,i,s,u/255))}if(o===4){const r=a(t.charCodeAt(1)),i=a(t.charCodeAt(2)),s=a(t.charCodeAt(3));return new E(new j(16*r+r,16*i+i,16*s+s))}if(o===5){const r=a(t.charCodeAt(1)),i=a(t.charCodeAt(2)),s=a(t.charCodeAt(3)),u=a(t.charCodeAt(4));return new E(new j(16*r+r,16*i+i,16*s+s,(16*u+u)/255))}return null}y.parseHex=d;function a(t){switch(t){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(p=c.CSS||(c.CSS={}))})(h=E.Format||(E.Format={}))}(S||(e.$Ft=S={}))}),define(oe[51],ae([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lh=j,e.$Mh=P,e.$Nh=B;function n(S){return(E,h,c)=>{let p=null,y=null;if(typeof c.value=="function"?(p="value",y=c.value):typeof c.get=="function"&&(p="get",y=c.get),!y)throw new Error("not supported");c[p]=S(y,h)}}function j(S,E,h){let c=null,p=null;if(typeof h.value=="function"?(c="value",p=h.value,p.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof h.get=="function"&&(c="get",p=h.get),!p)throw new Error("not supported");const y=`$memoize$${E}`;h[c]=function(...k){return this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!1,enumerable:!1,writable:!1,value:p.apply(this,k)}),this[y]}}function P(S,E,h){return n((c,p)=>{const y=`$debounce$${p}`,k=`$debounce$result$${p}`;return function(...g){this[k]||(this[k]=h?h():void 0),clearTimeout(this[y]),E&&(this[k]=E(this[k],...g),g=[this[k]]),this[y]=setTimeout(()=>{c.apply(this,g),this[k]=h?h():void 0},S)}})}function B(S,E,h){return n((c,p)=>{const y=`$throttle$timer$${p}`,k=`$throttle$result$${p}`,g=`$throttle$lastRun$${p}`,m=`$throttle$pending$${p}`;return function(...v){if(this[k]||(this[k]=h?h():void 0),(this[g]===null||this[g]===void 0)&&(this[g]=-Number.MAX_VALUE),E&&(this[k]=E(this[k],...v)),this[m])return;const w=this[g]+S;w<=Date.now()?(this[g]=Date.now(),c.apply(this,[this[k]]),this[k]=h?h():void 0):(this[m]=!0,this[y]=setTimeout(()=>{this[m]=!1,this[g]=Date.now(),c.apply(this,[this[k]]),this[k]=h?h():void 0},w-Date.now()))}})}}),define(oe[15],ae([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$9=e.$5=e.$X=e.$W=void 0,e.setUnexpectedErrorHandler=j,e.$Z=P,e.$1=B,e.$2=S,e.$3=E,e.$4=c,e.$6=y,e.$7=k,e.$8=g,e.$0=v;class n{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?l.isErrorNoTelemetry(t)?new l(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(o=>{o(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$W=n,e.$X=new n;function j(a){e.$X.setUnexpectedErrorHandler(a)}function P(a){if(!a||typeof a!="object")return!1;const t=a;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}function B(a){c(a)||e.$X.onUnexpectedError(a)}function S(a){c(a)||e.$X.onUnexpectedExternalError(a)}function E(a){if(a instanceof Error){const{name:t,message:o}=a,r=a.stacktrace||a.stack;return{$isError:!0,name:t,message:o,stack:r,noTelemetry:l.isErrorNoTelemetry(a)}}return a}const h="Canceled";function c(a){return a instanceof p?!0:a instanceof Error&&a.name===h&&a.message===h}class p extends Error{constructor(){super(h),this.name=this.message}}e.$5=p;function y(){const a=new Error(h);return a.name=a.message,a}function k(a){return a?new Error(`Illegal argument: ${a}`):new Error("Illegal argument")}function g(a){return a?new Error(`Illegal state: ${a}`):new Error("Illegal state")}class m extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=m;function v(a){return a?a.message?a.message:a.stack?a.stack.split(`
`)[0]:String(a):"Error"}class w extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$$=w;class $ extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$_=$;class f extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=f;class l extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof l)return t;const o=new l;return o.message=t.message,o.stack=t.stack,o}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$bb=l;class d extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,d.prototype)}}e.$cb=d}),define(oe[22],ae([0,1,15,136]),function(J,e,n,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bc=e.$ac=e.$_b=e.$0b=e.$9b=e.CompareResult=void 0,e.$sb=P,e.$tb=B,e.$ub=S,e.$vb=E,e.$wb=h,e.$xb=c,e.$yb=p,e.$zb=y,e.$Ab=k,e.$Bb=g,e.$Cb=m,e.$Db=v,e.$Eb=w,e.top=$,e.$Gb=f,e.$Hb=d,e.$Ib=a,e.$Jb=t,e.$Kb=o,e.$Lb=r,e.$Mb=i,e.$Nb=s,e.$Ob=u,e.$Pb=b,e.$Qb=I,e.$Rb=D,e.$Sb=R,e.$Tb=C,e.$Ub=A,e.$Vb=L,e.$Wb=W,e.$Xb=q,e.$Yb=H,e.$Zb=le,e.$1b=te,e.$2b=ue,e.$3b=X,e.$4b=Q,e.$5b=z,e.$6b=M,e.$7b=T,e.$8b=ce,e.$$b=O;function P(Z,V=0){return Z[Z.length-(1+V)]}function B(Z){if(Z.length===0)throw new Error("Invalid tail call");return[Z.slice(0,Z.length-1),Z[Z.length-1]]}function S(Z,V,x=(U,re)=>U===re){if(Z===V)return!0;if(!Z||!V||Z.length!==V.length)return!1;for(let U=0,re=Z.length;U<re;U++)if(!x(Z[U],V[U]))return!1;return!0}function E(Z,V){const x=Z.length-1;V<x&&(Z[V]=Z[x]),Z.pop()}function h(Z,V,x){return c(Z.length,U=>x(Z[U],V))}function c(Z,V){let x=0,U=Z-1;for(;x<=U;){const re=(x+U)/2|0,ee=V(re);if(ee<0)x=re+1;else if(ee>0)U=re-1;else return re}return-(x+1)}function p(Z,V,x){if(Z=Z|0,Z>=V.length)throw new TypeError("invalid index");const U=V[Math.floor(V.length*Math.random())],re=[],ee=[],fe=[];for(const me of V){const ve=x(me,U);ve<0?re.push(me):ve>0?ee.push(me):fe.push(me)}return Z<re.length?p(Z,re,x):Z<re.length+fe.length?fe[0]:p(Z-(re.length+fe.length),ee,x)}function y(Z,V){const x=[];let U;for(const re of Z.slice(0).sort(V))!U||V(U[0],re)!==0?(U=[re],x.push(U)):U.push(re);return x}function*k(Z,V){let x,U;for(const re of Z)U!==void 0&&V(U,re)?x.push(re):(x&&(yield x),x=[re]),U=re;x&&(yield x)}function g(Z,V){for(let x=0;x<=Z.length;x++)V(x===0?void 0:Z[x-1],x===Z.length?void 0:Z[x])}function m(Z,V){for(let x=0;x<Z.length;x++)V(x===0?void 0:Z[x-1],Z[x],x+1===Z.length?void 0:Z[x+1])}function v(Z,V,x){const U=[];function re(me,ve,ke){if(ve===0&&ke.length===0)return;const je=U[U.length-1];je&&je.start+je.deleteCount===me?(je.deleteCount+=ve,je.toInsert.push(...ke)):U.push({start:me,deleteCount:ve,toInsert:ke})}let ee=0,fe=0;for(;;){if(ee===Z.length){re(ee,0,V.slice(fe));break}if(fe===V.length){re(ee,Z.length-ee,[]);break}const me=Z[ee],ve=V[fe],ke=x(me,ve);ke===0?(ee+=1,fe+=1):ke<0?(re(ee,1,[]),ee+=1):ke>0&&(re(ee,0,[ve]),fe+=1)}return U}function w(Z,V,x){const U=v(Z,V,x),re=[],ee=[];for(const fe of U)re.push(...Z.slice(fe.start,fe.start+fe.deleteCount)),ee.push(...fe.toInsert);return{removed:re,added:ee}}function $(Z,V,x){if(x===0)return[];const U=Z.slice(0,x).sort(V);return l(Z,V,U,x,Z.length),U}function f(Z,V,x,U,re){return x===0?Promise.resolve([]):new Promise((ee,fe)=>{(async()=>{const me=Z.length,ve=Z.slice(0,x).sort(V);for(let ke=x,je=Math.min(x+U,me);ke<me;ke=je,je=Math.min(je+U,me)){if(ke>x&&await new Promise(We=>setTimeout(We)),re&&re.isCancellationRequested)throw new n.$5;l(Z,V,ve,ke,je)}return ve})().then(ee,fe)})}function l(Z,V,x,U,re){for(const ee=x.length;U<re;U++){const fe=Z[U];if(V(fe,x[ee-1])<0){x.pop();const me=(0,j.$kb)(x,ve=>V(fe,ve)<0);x.splice(me,0,fe)}}}function d(Z){return Z.filter(V=>!!V)}function a(Z){let V=0;for(let x=0;x<Z.length;x++)Z[x]&&(Z[V]=Z[x],V+=1);Z.length=V}function t(Z,V,x){Z.splice(x,0,Z.splice(V,1)[0])}function o(Z){return!Array.isArray(Z)||Z.length===0}function r(Z){return Array.isArray(Z)&&Z.length>0}function i(Z,V=x=>x){const x=new Set;return Z.filter(U=>{const re=V(U);return x.has(re)?!1:(x.add(re),!0)})}function s(Z){const V=new Set;return x=>{const U=Z(x);return V.has(U)?!1:(V.add(U),!0)}}function u(Z,V){return Z.length>0?Z[0]:V}function b(Z,V){return Z.length>0?Z[Z.length-1]:V}function I(Z,V,x=(U,re)=>U===re){let U=0;for(let re=0,ee=Math.min(Z.length,V.length);re<ee&&x(Z[re],V[re]);re++)U++;return U}function D(Z){return[].concat(...Z)}function R(Z,V){let x=typeof V=="number"?Z:0;typeof V=="number"?x=Z:(x=0,V=Z);const U=[];if(x<=V)for(let re=x;re<V;re++)U.push(re);else for(let re=x;re>V;re--)U.push(re);return U}function C(Z,V,x){return Z.reduce((U,re)=>(U[V(re)]=x?x(re):re,U),Object.create(null))}function A(Z,V){return Z.push(V),()=>L(Z,V)}function L(Z,V){const x=Z.indexOf(V);if(x>-1)return Z.splice(x,1),V}function W(Z,V,x){const U=Z.slice(0,V),re=Z.slice(V);return U.concat(x,re)}function q(Z,V){let x;if(typeof V=="number"){let U=V;x=()=>{const re=Math.sin(U++)*179426549;return re-Math.floor(re)}}else x=Math.random;for(let U=Z.length-1;U>0;U-=1){const re=Math.floor(x()*(U+1)),ee=Z[U];Z[U]=Z[re],Z[re]=ee}}function H(Z,V){const x=Z.indexOf(V);x>-1&&(Z.splice(x,1),Z.unshift(V))}function le(Z,V){const x=Z.indexOf(V);x>-1&&(Z.splice(x,1),Z.push(V))}function te(Z,V){for(const x of V)Z.push(x)}function ue(Z,V){return Array.isArray(Z)?Z.map(V):V(Z)}function X(Z){return Array.isArray(Z)?Z:[Z]}function Q(Z){return Z[Math.floor(Math.random()*Z.length)]}function z(Z,V,x){const U=F(Z,V),re=Z.length,ee=x.length;Z.length=re+ee;for(let fe=re-1;fe>=U;fe--)Z[fe+ee]=Z[fe];for(let fe=0;fe<ee;fe++)Z[fe+U]=x[fe]}function M(Z,V,x,U){const re=F(Z,V);let ee=Z.splice(re,x);return ee===void 0&&(ee=[]),z(Z,re,U),ee}function F(Z,V){return V<0?Math.max(V+Z.length,0):Math.min(V,Z.length)}var G;(function(Z){function V(ee){return ee<0}Z.isLessThan=V;function x(ee){return ee<=0}Z.isLessThanOrEqual=x;function U(ee){return ee>0}Z.isGreaterThan=U;function re(ee){return ee===0}Z.isNeitherLessOrGreaterThan=re,Z.greaterThan=1,Z.lessThan=-1,Z.neitherLessOrGreaterThan=0})(G||(e.CompareResult=G={}));function T(Z,V){return(x,U)=>V(Z(x),Z(U))}function ce(...Z){return(V,x)=>{for(const U of Z){const re=U(V,x);if(!G.isNeitherLessOrGreaterThan(re))return re}return G.neitherLessOrGreaterThan}}const he=(Z,V)=>Z-V;e.$9b=he;const K=(Z,V)=>(0,e.$9b)(Z?1:0,V?1:0);e.$0b=K;function O(Z){return(V,x)=>-Z(V,x)}class N{constructor(V){this.g=V,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(V){let x=this.c;for(;x<this.g.length&&V(this.g[x]);)x++;const U=x===this.c?null:this.g.slice(this.c,x);return this.c=x,U}takeFromEndWhile(V){let x=this.d;for(;x>=0&&V(this.g[x]);)x--;const U=x===this.d?null:this.g.slice(x+1,this.d+1);return this.d=x,U}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const V=this.g[this.c];return this.c++,V}removeLast(){const V=this.g[this.d];return this.d--,V}takeCount(V){const x=this.g.slice(this.c,this.c+V);return this.c+=V,x}}e.$_b=N;class _{static{this.empty=new _(V=>{})}constructor(V){this.iterate=V}forEach(V){this.iterate(x=>(V(x),!0))}toArray(){const V=[];return this.iterate(x=>(V.push(x),!0)),V}filter(V){return new _(x=>this.iterate(U=>V(U)?x(U):!0))}map(V){return new _(x=>this.iterate(U=>x(V(U))))}some(V){let x=!1;return this.iterate(U=>(x=V(U),!x)),x}findFirst(V){let x;return this.iterate(U=>V(U)?(x=U,!1):!0),x}findLast(V){let x;return this.iterate(U=>(V(U)&&(x=U),!0)),x}findLastMaxBy(V){let x,U=!0;return this.iterate(re=>((U||G.isGreaterThan(V(re,x)))&&(U=!1,x=re),!0)),x}}e.$ac=_;class se{constructor(V){this.c=V}static createSortPermutation(V,x){const U=Array.from(V.keys()).sort((re,ee)=>x(V[re],V[ee]));return new se(U)}apply(V){return V.map((x,U)=>V[this.c[U]])}inverse(){const V=this.c.slice();for(let x=0;x<this.c.length;x++)V[this.c[x]]=x;return new se(V)}}e.$bc=se}),define(oe[139],ae([0,1,15]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=j,e.$0c=P,e.$$c=B,e.$_c=S,e.$ad=E,e.$bd=h;function j(c,p){if(!c)throw new Error(p?`Assertion failed (${p})`:"Assertion Failed")}function P(c,p="Unreachable"){throw new Error(p)}function B(c){if(!c)throw new n.$cb("Assertion Failed")}function S(c){c||(0,n.$1)(new n.$cb("Soft Assertion Failed"))}function E(c){if(!c()){debugger;c(),(0,n.$1)(new n.$cb("Assertion Failed"))}}function h(c,p){let y=0;for(;y<c.length-1;){const k=c[y],g=c[y+1];if(!p(k,g))return!1;y++}return!0}}),define(oe[85],ae([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=n;function n(j,P){const B=this;let S=!1,E;return function(){if(S)return E;if(S=!0,P)try{E=j.apply(B,arguments)}finally{P()}else E=j.apply(B,arguments);return E}}}),define(oe[71],ae([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var n;(function(j){function P(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}j.is=P;const B=Object.freeze([]);function S(){return B}j.empty=S;function*E(t){yield t}j.single=E;function h(t){return P(t)?t:E(t)}j.wrap=h;function c(t){return t||B}j.from=c;function*p(t){for(let o=t.length-1;o>=0;o--)yield t[o]}j.reverse=p;function y(t){return!t||t[Symbol.iterator]().next().done===!0}j.isEmpty=y;function k(t){return t[Symbol.iterator]().next().value}j.first=k;function g(t,o){for(const r of t)if(o(r))return!0;return!1}j.some=g;function m(t,o){for(const r of t)if(o(r))return r}j.find=m;function*v(t,o){for(const r of t)o(r)&&(yield r)}j.filter=v;function*w(t,o){let r=0;for(const i of t)yield o(i,r++)}j.map=w;function*$(...t){for(const o of t)yield*o}j.concat=$;function f(t,o,r){let i=r;for(const s of t)i=o(i,s);return i}j.reduce=f;function*l(t,o,r=t.length){for(o<0&&(o+=t.length),r<0?r+=t.length:r>t.length&&(r=t.length);o<r;o++)yield t[o]}j.slice=l;function d(t,o=Number.POSITIVE_INFINITY){const r=[];if(o===0)return[r,t];const i=t[Symbol.iterator]();for(let s=0;s<o;s++){const u=i.next();if(u.done)return[r,j.empty()];r.push(u.value)}return[r,{[Symbol.iterator](){return i}}]}j.consume=d;async function a(t){const o=[];for await(const r of t)o.push(r);return Promise.resolve(o)}j.asyncToArray=a})(n||(e.Iterable=n={}))}),define(oe[42],ae([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$sn=S,e.$tn=y,e.$un=k,e.$vn=g,e.$wn=m,e.$xn=v,e.$yn=w,e.$zn=$,e.$An=f,e.$Bn=l,e.$Cn=d,e.$Dn=a;var n;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(n||(e.ScanError=n={}));var j;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(j||(e.SyntaxKind=j={}));var P;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(P||(e.ParseErrorCode=P={}));var B;(function(t){t.DEFAULT={allowTrailingComma:!0}})(B||(e.ParseOptions=B={}));function S(t,o=!1){let r=0;const i=t.length;let s="",u=0,b=16,I=0;function D(H){let le=0,te=0;for(;le<H;){const ue=t.charCodeAt(r);if(ue>=48&&ue<=57)te=te*16+ue-48;else if(ue>=65&&ue<=70)te=te*16+ue-65+10;else if(ue>=97&&ue<=102)te=te*16+ue-97+10;else break;r++,le++}return le<H&&(te=-1),te}function R(H){r=H,s="",u=0,b=16,I=0}function C(){const H=r;if(t.charCodeAt(r)===48)r++;else for(r++;r<t.length&&c(t.charCodeAt(r));)r++;if(r<t.length&&t.charCodeAt(r)===46)if(r++,r<t.length&&c(t.charCodeAt(r)))for(r++;r<t.length&&c(t.charCodeAt(r));)r++;else return I=3,t.substring(H,r);let le=r;if(r<t.length&&(t.charCodeAt(r)===69||t.charCodeAt(r)===101))if(r++,(r<t.length&&t.charCodeAt(r)===43||t.charCodeAt(r)===45)&&r++,r<t.length&&c(t.charCodeAt(r))){for(r++;r<t.length&&c(t.charCodeAt(r));)r++;le=r}else I=3;return t.substring(H,le)}function A(){let H="",le=r;for(;;){if(r>=i){H+=t.substring(le,r),I=2;break}const te=t.charCodeAt(r);if(te===34){H+=t.substring(le,r),r++;break}if(te===92){if(H+=t.substring(le,r),r++,r>=i){I=2;break}switch(t.charCodeAt(r++)){case 34:H+='"';break;case 92:H+="\\";break;case 47:H+="/";break;case 98:H+="\b";break;case 102:H+="\f";break;case 110:H+=`
`;break;case 114:H+="\r";break;case 116:H+="	";break;case 117:{const X=D(4);X>=0?H+=String.fromCharCode(X):I=4;break}default:I=5}le=r;continue}if(te>=0&&te<=31)if(h(te)){H+=t.substring(le,r),I=2;break}else I=6;r++}return H}function L(){if(s="",I=0,u=r,r>=i)return u=i,b=17;let H=t.charCodeAt(r);if(E(H)){do r++,s+=String.fromCharCode(H),H=t.charCodeAt(r);while(E(H));return b=15}if(h(H))return r++,s+=String.fromCharCode(H),H===13&&t.charCodeAt(r)===10&&(r++,s+=`
`),b=14;switch(H){case 123:return r++,b=1;case 125:return r++,b=2;case 91:return r++,b=3;case 93:return r++,b=4;case 58:return r++,b=6;case 44:return r++,b=5;case 34:return r++,s=A(),b=10;case 47:{const le=r-1;if(t.charCodeAt(r+1)===47){for(r+=2;r<i&&!h(t.charCodeAt(r));)r++;return s=t.substring(le,r),b=12}if(t.charCodeAt(r+1)===42){r+=2;const te=i-1;let ue=!1;for(;r<te;){if(t.charCodeAt(r)===42&&t.charCodeAt(r+1)===47){r+=2,ue=!0;break}r++}return ue||(r++,I=1),s=t.substring(le,r),b=13}return s+=String.fromCharCode(H),r++,b=16}case 45:if(s+=String.fromCharCode(H),r++,r===i||!c(t.charCodeAt(r)))return b=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=C(),b=11;default:for(;r<i&&W(H);)r++,H=t.charCodeAt(r);if(u!==r){switch(s=t.substring(u,r),s){case"true":return b=8;case"false":return b=9;case"null":return b=7}return b=16}return s+=String.fromCharCode(H),r++,b=16}}function W(H){if(E(H)||h(H))return!1;switch(H){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function q(){let H;do H=L();while(H>=12&&H<=15);return H}return{setPosition:R,getPosition:()=>r,scan:o?q:L,getToken:()=>b,getTokenValue:()=>s,getTokenOffset:()=>u,getTokenLength:()=>r-u,getTokenError:()=>I}}function E(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function h(t){return t===10||t===13||t===8232||t===8233}function c(t){return t>=48&&t<=57}var p;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(p||(p={}));function y(t,o){const r=[],i=new Object;let s;const u={value:{},offset:0,length:0,type:"object",parent:void 0};let b=!1;function I(D,R,C,A){u.value=D,u.offset=R,u.length=C,u.type=A,u.colonOffset=void 0,s=u}try{l(t,{onObjectBegin:(D,R)=>{if(o<=D)throw i;s=void 0,b=o>D,r.push("")},onObjectProperty:(D,R,C)=>{if(o<R||(I(D,R,C,"property"),r[r.length-1]=D,o<=R+C))throw i},onObjectEnd:(D,R)=>{if(o<=D)throw i;s=void 0,r.pop()},onArrayBegin:(D,R)=>{if(o<=D)throw i;s=void 0,r.push(0)},onArrayEnd:(D,R)=>{if(o<=D)throw i;s=void 0,r.pop()},onLiteralValue:(D,R,C)=>{if(o<R||(I(D,R,C,a(D)),o<=R+C))throw i},onSeparator:(D,R,C)=>{if(o<=R)throw i;if(D===":"&&s&&s.type==="property")s.colonOffset=R,b=!1,s=void 0;else if(D===","){const A=r[r.length-1];typeof A=="number"?r[r.length-1]=A+1:(b=!0,r[r.length-1]=""),s=void 0}}})}catch(D){if(D!==i)throw D}return{path:r,previousNode:s,isAtPropertyKey:b,matches:D=>{let R=0;for(let C=0;R<D.length&&C<r.length;C++)if(D[R]===r[C]||D[R]==="*")R++;else if(D[R]!=="**")return!1;return R===D.length}}}function k(t,o=[],r=B.DEFAULT){let i=null,s=[];const u=[];function b(D){Array.isArray(s)?s.push(D):i!==null&&(s[i]=D)}return l(t,{onObjectBegin:()=>{const D={};b(D),u.push(s),s=D,i=null},onObjectProperty:D=>{i=D},onObjectEnd:()=>{s=u.pop()},onArrayBegin:()=>{const D=[];b(D),u.push(s),s=D,i=null},onArrayEnd:()=>{s=u.pop()},onLiteralValue:b,onError:(D,R,C)=>{o.push({error:D,offset:R,length:C})}},r),s[0]}function g(t,o=[],r=B.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(D){i.type==="property"&&(i.length=D-i.offset,i=i.parent)}function u(D){return i.children.push(D),D}l(t,{onObjectBegin:D=>{i=u({type:"object",offset:D,length:-1,parent:i,children:[]})},onObjectProperty:(D,R,C)=>{i=u({type:"property",offset:R,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:D,offset:R,length:C,parent:i})},onObjectEnd:(D,R)=>{i.length=D+R-i.offset,i=i.parent,s(D+R)},onArrayBegin:(D,R)=>{i=u({type:"array",offset:D,length:-1,parent:i,children:[]})},onArrayEnd:(D,R)=>{i.length=D+R-i.offset,i=i.parent,s(D+R)},onLiteralValue:(D,R,C)=>{u({type:a(D),offset:R,length:C,parent:i,value:D}),s(R+C)},onSeparator:(D,R,C)=>{i.type==="property"&&(D===":"?i.colonOffset=R:D===","&&s(R))},onError:(D,R,C)=>{o.push({error:D,offset:R,length:C})}},r);const I=i.children[0];return I&&delete I.parent,I}function m(t,o){if(!t)return;let r=t;for(const i of o)if(typeof i=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let s=!1;for(const u of r.children)if(Array.isArray(u.children)&&u.children[0].value===i){r=u.children[1],s=!0;break}if(!s)return}else{const s=i;if(r.type!=="array"||s<0||!Array.isArray(r.children)||s>=r.children.length)return;r=r.children[s]}return r}function v(t){if(!t.parent||!t.parent.children)return[];const o=v(t.parent);if(t.parent.type==="property"){const r=t.parent.children[0].value;o.push(r)}else if(t.parent.type==="array"){const r=t.parent.children.indexOf(t);r!==-1&&o.push(r)}return o}function w(t){switch(t.type){case"array":return t.children.map(w);case"object":{const o=Object.create(null);for(const r of t.children){const i=r.children[1];i&&(o[r.children[0].value]=w(i))}return o}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function $(t,o,r=!1){return o>=t.offset&&o<t.offset+t.length||r&&o===t.offset+t.length}function f(t,o,r=!1){if($(t,o,r)){const i=t.children;if(Array.isArray(i))for(let s=0;s<i.length&&i[s].offset<=o;s++){const u=f(i[s],o,r);if(u)return u}return t}}function l(t,o,r=B.DEFAULT){const i=S(t,!1);function s(T){return T?()=>T(i.getTokenOffset(),i.getTokenLength()):()=>!0}function u(T){return T?ce=>T(ce,i.getTokenOffset(),i.getTokenLength()):()=>!0}const b=s(o.onObjectBegin),I=u(o.onObjectProperty),D=s(o.onObjectEnd),R=s(o.onArrayBegin),C=s(o.onArrayEnd),A=u(o.onLiteralValue),L=u(o.onSeparator),W=s(o.onComment),q=u(o.onError),H=r&&r.disallowComments,le=r&&r.allowTrailingComma;function te(){for(;;){const T=i.scan();switch(i.getTokenError()){case 4:ue(14);break;case 5:ue(15);break;case 3:ue(13);break;case 1:H||ue(11);break;case 2:ue(12);break;case 6:ue(16);break}switch(T){case 12:case 13:H?ue(10):W();break;case 16:ue(1);break;case 15:case 14:break;default:return T}}}function ue(T,ce=[],he=[]){if(q(T),ce.length+he.length>0){let K=i.getToken();for(;K!==17;){if(ce.indexOf(K)!==-1){te();break}else if(he.indexOf(K)!==-1)break;K=te()}}}function X(T){const ce=i.getTokenValue();return T?A(ce):I(ce),te(),!0}function Q(){switch(i.getToken()){case 11:{let T=0;try{T=JSON.parse(i.getTokenValue()),typeof T!="number"&&(ue(2),T=0)}catch{ue(2)}A(T);break}case 7:A(null);break;case 8:A(!0);break;case 9:A(!1);break;default:return!1}return te(),!0}function z(){return i.getToken()!==10?(ue(3,[],[2,5]),!1):(X(!1),i.getToken()===6?(L(":"),te(),G()||ue(4,[],[2,5])):ue(5,[],[2,5]),!0)}function M(){b(),te();let T=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(T||ue(4,[],[]),L(","),te(),i.getToken()===2&&le)break}else T&&ue(6,[],[]);z()||ue(4,[],[2,5]),T=!0}return D(),i.getToken()!==2?ue(7,[2],[]):te(),!0}function F(){R(),te();let T=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(T||ue(4,[],[]),L(","),te(),i.getToken()===4&&le)break}else T&&ue(6,[],[]);G()||ue(4,[],[4,5]),T=!0}return C(),i.getToken()!==4?ue(8,[4],[]):te(),!0}function G(){switch(i.getToken()){case 3:return F();case 1:return M();case 10:return X(!0);default:return Q()}}return te(),i.getToken()===17?r.allowEmptyContent?!0:(ue(4,[],[]),!1):G()?(i.getToken()!==17&&ue(9,[],[]),!0):(ue(4,[],[]),!1)}function d(t,o){const r=S(t),i=[];let s,u=0,b;do switch(b=r.getPosition(),s=r.scan(),s){case 12:case 13:case 17:u!==b&&i.push(t.substring(u,b)),o!==void 0&&i.push(r.getTokenValue().replace(/[^\r\n]/g,o)),u=r.getPosition();break}while(s!==17);return i.join("")}function a(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(oe[140],ae([0,1,42]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$En=j,e.$Fn=P,e.$Gn=E,e.$Hn=h;function j(c,p,y){let k,g,m,v,w;if(p){for(v=p.offset,w=v+p.length,m=v;m>0&&!h(c,m-1);)m--;let b=w;for(;b<c.length&&!h(c,b);)b++;g=c.substring(m,b),k=S(g,y)}else g=c,k=0,m=0,v=0,w=c.length;const $=E(y,c);let f=!1,l=0,d;y.insertSpaces?d=B(" ",y.tabSize||4):d="	";const a=(0,n.$sn)(g,!1);let t=!1;function o(){return $+B(d,k+l)}function r(){let b=a.scan();for(f=!1;b===15||b===14;)f=f||b===14,b=a.scan();return t=b===16||a.getTokenError()!==0,b}const i=[];function s(b,I,D){!t&&I<w&&D>v&&c.substring(I,D)!==b&&i.push({offset:I,length:D-I,content:b})}let u=r();if(u!==17){const b=a.getTokenOffset()+m,I=B(d,k);s(I,m,b)}for(;u!==17;){let b=a.getTokenOffset()+a.getTokenLength()+m,I=r(),D="";for(;!f&&(I===12||I===13);){const C=a.getTokenOffset()+m;s(" ",b,C),b=a.getTokenOffset()+a.getTokenLength()+m,D=I===12?o():"",I=r()}if(I===2)u!==1&&(l--,D=o());else if(I===4)u!==3&&(l--,D=o());else{switch(u){case 3:case 1:l++,D=o();break;case 5:case 12:D=o();break;case 13:f?D=o():D=" ";break;case 6:D=" ";break;case 10:if(I===6){D="";break}case 7:case 8:case 9:case 11:case 2:case 4:I===12||I===13?D=" ":I!==5&&I!==17&&(t=!0);break;case 16:t=!0;break}f&&(I===12||I===13)&&(D=o())}const R=a.getTokenOffset()+m;s(D,b,R),u=I}return i}function P(c,p){const y=JSON.stringify(c,void 0,p.insertSpaces?p.tabSize||4:"	");return p.eol!==void 0?y.replace(/\r\n|\r|\n/g,p.eol):y}function B(c,p){let y="";for(let k=0;k<p;k++)y+=c;return y}function S(c,p){let y=0,k=0;const g=p.tabSize||4;for(;y<c.length;){const m=c.charAt(y);if(m===" ")k++;else if(m==="	")k+=g;else break;y++}return Math.floor(k/g)}function E(c,p){for(let y=0;y<p.length;y++){const k=p.charAt(y);if(k==="\r")return y+1<p.length&&p.charAt(y+1)===`
`?`\r
`:"\r";if(k===`
`)return`
`}return c&&c.eol||`
`}function h(c,p){return`\r
`.indexOf(c.charAt(p))!==-1}}),define(oe[103],ae([0,1,42,140]),function(J,e,n,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$In=P,e.$Jn=B,e.$Kn=S,e.$Ln=E,e.$Mn=h;function P(c,p,y){return B(c,p,void 0,y)}function B(c,p,y,k,g){const m=p.slice(),v=[],w=(0,n.$vn)(c,v);let $,f;for(;m.length>0&&(f=m.pop(),$=(0,n.$wn)(w,m),$===void 0&&y!==void 0);)typeof f=="string"?y={[f]:y}:y=[y];if($)if($.type==="object"&&typeof f=="string"&&Array.isArray($.children)){const l=(0,n.$wn)($,[f]);if(l!==void 0)if(y===void 0){if(!l.parent)throw new Error("Malformed AST");const d=$.children.indexOf(l.parent);let a,t=l.parent.offset+l.parent.length;if(d>0){const o=$.children[d-1];a=o.offset+o.length}else a=$.offset+1,$.children.length>1&&(t=$.children[1].offset);return S(c,{offset:a,length:t-a,content:""},k)}else return S(c,{offset:l.offset,length:l.length,content:JSON.stringify(y)},k);else{if(y===void 0)return[];const d=`${JSON.stringify(f)}: ${JSON.stringify(y)}`,a=g?g($.children.map(o=>o.children[0].value)):$.children.length;let t;if(a>0){const o=$.children[a-1];t={offset:o.offset+o.length,length:0,content:","+d}}else $.children.length===0?t={offset:$.offset+1,length:0,content:d}:t={offset:$.offset+1,length:0,content:d+","};return S(c,t,k)}}else if($.type==="array"&&typeof f=="number"&&Array.isArray($.children))if(y!==void 0){const l=`${JSON.stringify(y)}`;let d;if($.children.length===0||f===0)d={offset:$.offset+1,length:0,content:$.children.length===0?l:l+","};else{const a=f===-1||f>$.children.length?$.children.length:f,t=$.children[a-1];d={offset:t.offset+t.length,length:0,content:","+l}}return S(c,d,k)}else{const l=f,d=$.children[l];let a;if($.children.length===1)a={offset:$.offset+1,length:$.length-2,content:""};else if($.children.length-1===l){const t=$.children[l-1],o=t.offset+t.length,r=$.offset+$.length;a={offset:o,length:r-2-o,content:""}}else a={offset:d.offset,length:$.children[l+1].offset-d.offset,content:""};return S(c,a,k)}else throw new Error(`Can not add ${typeof f!="number"?"index":"property"} to parent of type ${$.type}`);else{if(y===void 0)throw new Error("Can not delete in empty document");return S(c,{offset:w?w.offset:0,length:w?w.length:0,content:JSON.stringify(y)},k)}}function S(c,p,y){let k=E(c,p),g=p.offset,m=p.offset+p.content.length;if(p.length===0||p.content.length===0){for(;g>0&&!(0,j.$Hn)(k,g-1);)g--;for(;m<k.length&&!(0,j.$Hn)(k,m);)m++}const v=(0,j.$En)(k,{offset:g,length:m-g},y);for(let $=v.length-1;$>=0;$--){const f=v[$];k=E(k,f),g=Math.min(g,f.offset),m=Math.max(m,f.offset+f.length),m+=f.content.length-f.length}const w=c.length-(k.length-m)-g;return[{offset:g,length:w,content:k.substring(g,m)}]}function E(c,p){return c.substring(0,p.offset)+p.content+c.substring(p.offset+p.length)}function h(c,p){const y=p.slice(0).sort((g,m)=>{const v=g.offset-m.offset;return v===0?g.length-m.length:v});let k=c.length;for(let g=y.length-1;g>=0;g--){const m=y[g];if(m.offset+m.length<=k)c=E(c,m);else throw new Error("Overlapping edit");k=m.offset}return c}}),define(oe[62],ae([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class n{constructor(P){this.d=P,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(P){this.c=P}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=n}),define(oe[104],ae([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=void 0;class n{static{this.Undefined=new n(void 0)}constructor(B){this.element=B,this.next=n.Undefined,this.prev=n.Undefined}}class j{constructor(){this.a=n.Undefined,this.b=n.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===n.Undefined}clear(){let B=this.a;for(;B!==n.Undefined;){const S=B.next;B.prev=n.Undefined,B.next=n.Undefined,B=S}this.a=n.Undefined,this.b=n.Undefined,this.c=0}unshift(B){return this.d(B,!1)}push(B){return this.d(B,!0)}d(B,S){const E=new n(B);if(this.a===n.Undefined)this.a=E,this.b=E;else if(S){const c=this.b;this.b=E,E.prev=c,c.next=E}else{const c=this.a;this.a=E,E.next=c,c.prev=E}this.c+=1;let h=!1;return()=>{h||(h=!0,this.e(E))}}shift(){if(this.a!==n.Undefined){const B=this.a.element;return this.e(this.a),B}}pop(){if(this.b!==n.Undefined){const B=this.b.element;return this.e(this.b),B}}e(B){if(B.prev!==n.Undefined&&B.next!==n.Undefined){const S=B.prev;S.next=B.next,B.next.prev=S}else B.prev===n.Undefined&&B.next===n.Undefined?(this.a=n.Undefined,this.b=n.Undefined):B.next===n.Undefined?(this.b=this.b.prev,this.b.next=n.Undefined):B.prev===n.Undefined&&(this.a=this.a.next,this.a.prev=n.Undefined);this.c-=1}*[Symbol.iterator](){let B=this.a;for(;B!==n.Undefined;)yield B.element,B=B.next}}e.$5c=j}),define(oe[32],ae([0,1]),function(J,e){"use strict";var n,j,P;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.Touch=e.$Cc=e.$Bc=void 0,e.$yc=B,e.$zc=S,e.$Ac=E,e.$Ic=f;function B(l,d,a){let t=l.get(d);return t===void 0&&(t=a,l.set(d,t)),t}function S(l){const d=[];return l.forEach((a,t)=>{d.push(`${t} => ${a}`)}),`Map(${l.size}) {${d.join(", ")}}`}function E(l){const d=[];return l.forEach(a=>{d.push(a)}),`Set(${l.size}) {${d.join(", ")}}`}class h{constructor(d,a){this.uri=d,this.value=a}}function c(l){return Array.isArray(l)}class p{static{this.c=d=>d.toString()}constructor(d,a){if(this[n]="ResourceMap",d instanceof p)this.d=new Map(d.d),this.e=a??p.c;else if(c(d)){this.d=new Map,this.e=a??p.c;for(const[t,o]of d)this.set(t,o)}else this.d=new Map,this.e=d??p.c}set(d,a){return this.d.set(this.e(d),new h(d,a)),this}get(d){return this.d.get(this.e(d))?.value}has(d){return this.d.has(this.e(d))}get size(){return this.d.size}clear(){this.d.clear()}delete(d){return this.d.delete(this.e(d))}forEach(d,a){typeof a<"u"&&(d=d.bind(a));for(const[t,o]of this.d)d(o.value,o.uri,this)}*values(){for(const d of this.d.values())yield d.value}*keys(){for(const d of this.d.values())yield d.uri}*entries(){for(const d of this.d.values())yield[d.uri,d.value]}*[(n=Symbol.toStringTag,Symbol.iterator)](){for(const[,d]of this.d)yield[d.uri,d.value]}}e.$Bc=p;class y{constructor(d,a){this[j]="ResourceSet",!d||typeof d=="function"?this.c=new p(d):(this.c=new p(a),d.forEach(this.add,this))}get size(){return this.c.size}add(d){return this.c.set(d,d),this}clear(){this.c.clear()}delete(d){return this.c.delete(d)}forEach(d,a){this.c.forEach((t,o)=>d.call(a,o,o,this))}has(d){return this.c.has(d)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(j=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Cc=y;var k;(function(l){l[l.None=0]="None",l[l.AsOld=1]="AsOld",l[l.AsNew=2]="AsNew"})(k||(e.Touch=k={}));class g{constructor(){this[P]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(d){return this.c.has(d)}get(d,a=0){const t=this.c.get(d);if(t)return a!==0&&this.l(t,a),t.value}set(d,a,t=0){let o=this.c.get(d);if(o)o.value=a,t!==0&&this.l(o,t);else{switch(o={key:d,value:a,next:void 0,previous:void 0},t){case 0:this.j(o);break;case 1:this.i(o);break;case 2:this.j(o);break;default:this.j(o);break}this.c.set(d,o),this.f++}return this}delete(d){return!!this.remove(d)}remove(d){const a=this.c.get(d);if(a)return this.c.delete(d),this.k(a),this.f--,a.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const d=this.d;return this.c.delete(d.key),this.k(d),this.f--,d.value}forEach(d,a){const t=this.g;let o=this.d;for(;o;){if(a?d.bind(a)(o.value,o.key,this):d(o.value,o.key,this),this.g!==t)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const d=this,a=this.g;let t=this.d;const o={[Symbol.iterator](){return o},next(){if(d.g!==a)throw new Error("LinkedMap got modified during iteration.");if(t){const r={value:t.key,done:!1};return t=t.next,r}else return{value:void 0,done:!0}}};return o}values(){const d=this,a=this.g;let t=this.d;const o={[Symbol.iterator](){return o},next(){if(d.g!==a)throw new Error("LinkedMap got modified during iteration.");if(t){const r={value:t.value,done:!1};return t=t.next,r}else return{value:void 0,done:!0}}};return o}entries(){const d=this,a=this.g;let t=this.d;const o={[Symbol.iterator](){return o},next(){if(d.g!==a)throw new Error("LinkedMap got modified during iteration.");if(t){const r={value:[t.key,t.value],done:!1};return t=t.next,r}else return{value:void 0,done:!0}}};return o}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(d){if(d>=this.size)return;if(d===0){this.clear();return}let a=this.d,t=this.size;for(;a&&t>d;)this.c.delete(a.key),a=a.next,t--;this.d=a,this.f=t,a&&(a.previous=void 0),this.g++}i(d){if(!this.d&&!this.e)this.e=d;else if(this.d)d.next=this.d,this.d.previous=d;else throw new Error("Invalid list");this.d=d,this.g++}j(d){if(!this.d&&!this.e)this.d=d;else if(this.e)d.previous=this.e,this.e.next=d;else throw new Error("Invalid list");this.e=d,this.g++}k(d){if(d===this.d&&d===this.e)this.d=void 0,this.e=void 0;else if(d===this.d){if(!d.next)throw new Error("Invalid list");d.next.previous=void 0,this.d=d.next}else if(d===this.e){if(!d.previous)throw new Error("Invalid list");d.previous.next=void 0,this.e=d.previous}else{const a=d.next,t=d.previous;if(!a||!t)throw new Error("Invalid list");a.previous=t,t.next=a}d.next=void 0,d.previous=void 0,this.g++}l(d,a){if(!this.d||!this.e)throw new Error("Invalid list");if(!(a!==1&&a!==2)){if(a===1){if(d===this.d)return;const t=d.next,o=d.previous;d===this.e?(o.next=void 0,this.e=o):(t.previous=o,o.next=t),d.previous=void 0,d.next=this.d,this.d.previous=d,this.d=d,this.g++}else if(a===2){if(d===this.e)return;const t=d.next,o=d.previous;d===this.d?(t.previous=void 0,this.d=t):(t.previous=o,o.next=t),d.next=void 0,d.previous=this.e,this.e.next=d,this.e=d,this.g++}}}toJSON(){const d=[];return this.forEach((a,t)=>{d.push([t,a])}),d}fromJSON(d){this.clear();for(const[a,t]of d)this.set(a,t)}}e.$Dc=g;class m extends g{constructor(d,a=1){super(),this.m=d,this.n=Math.min(Math.max(0,a),1)}get limit(){return this.m}set limit(d){this.m=d,this.o()}get ratio(){return this.n}set ratio(d){this.n=Math.min(Math.max(0,d),1),this.o()}get(d,a=2){return super.get(d,a)}peek(d){return super.get(d,0)}set(d,a){return super.set(d,a,2),this.o(),this}o(){this.size>this.m&&this.h(Math.round(this.m*this.n))}}e.$Ec=m;class v{constructor(){this.c=new Map}add(d){return this.c.set(d,(this.c.get(d)||0)+1),this}delete(d){let a=this.c.get(d)||0;return a===0?!1:(a--,a===0?this.c.delete(d):this.c.set(d,a),!0)}has(d){return this.c.has(d)}}e.$Fc=v;class w{constructor(d){if(this.c=new Map,this.d=new Map,d)for(const[a,t]of d)this.set(a,t)}clear(){this.c.clear(),this.d.clear()}set(d,a){this.c.set(d,a),this.d.set(a,d)}get(d){return this.c.get(d)}getKey(d){return this.d.get(d)}delete(d){const a=this.c.get(d);return a===void 0?!1:(this.c.delete(d),this.d.delete(a),!0)}forEach(d,a){this.c.forEach((t,o)=>{d.call(a,t,o,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Gc=w;class ${constructor(){this.c=new Map}add(d,a){let t=this.c.get(d);t||(t=new Set,this.c.set(d,t)),t.add(a)}delete(d,a){const t=this.c.get(d);t&&(t.delete(a),t.size===0&&this.c.delete(d))}forEach(d,a){const t=this.c.get(d);t&&t.forEach(a)}get(d){const a=this.c.get(d);return a||new Set}}e.$Hc=$;function f(l,d){if(l===d)return!0;if(l.size!==d.size)return!1;for(const[a,t]of l)if(!d.has(a)||d.get(a)!==t)return!1;for(const[a]of d)if(!l.has(a))return!1;return!0}}),define(oe[2],ae([0,1,22,137,32,85,71]),function(J,e,n,j,P,B,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Jc=void 0,e.$Kc=p,e.$Lc=y,e.$Mc=k,e.$Nc=v,e.$Oc=w,e.$Pc=$,e.$Qc=f,e.$Rc=l,e.$Sc=d,e.$3c=D;const E=!1;let h=null;class c{constructor(){this.b=new Map}static{this.a=0}c(A){let L=this.b.get(A);return L||(L={parent:null,source:null,isSingleton:!1,value:A,idx:c.a++},this.b.set(A,L)),L}trackDisposable(A){const L=this.c(A);L.source||(L.source=new Error().stack)}setParent(A,L){const W=this.c(A);W.parent=L}markAsDisposed(A){this.b.delete(A)}markAsSingleton(A){this.c(A).isSingleton=!0}f(A,L){const W=L.get(A);if(W)return W;const q=A.parent?this.f(this.c(A.parent),L):A;return L.set(A,q),q}getTrackedDisposables(){const A=new Map;return[...this.b.entries()].filter(([,W])=>W.source!==null&&!this.f(W,A).isSingleton).flatMap(([W])=>W)}computeLeakingDisposables(A=10,L){let W;if(L)W=L;else{const ue=new Map,X=[...this.b.values()].filter(z=>z.source!==null&&!this.f(z,ue).isSingleton);if(X.length===0)return;const Q=new Set(X.map(z=>z.value));if(W=X.filter(z=>!(z.parent&&Q.has(z.parent))),W.length===0)throw new Error("There are cyclic diposable chains!")}if(!W)return;function q(ue){function X(z,M){for(;z.length>0&&M.some(F=>typeof F=="string"?F===z[0]:z[0].match(F));)z.shift()}const Q=ue.source.split(`
`).map(z=>z.trim().replace("at ","")).filter(z=>z!=="");return X(Q,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Q.reverse()}const H=new P.$Hc;for(const ue of W){const X=q(ue);for(let Q=0;Q<=X.length;Q++)H.add(X.slice(0,Q).join(`
`),ue)}W.sort((0,n.$7b)(ue=>ue.idx,n.$9b));let le="",te=0;for(const ue of W.slice(0,A)){te++;const X=q(ue),Q=[];for(let z=0;z<X.length;z++){let M=X[z];M=`(shared with ${H.get(X.slice(0,z+1).join(`
`)).size}/${W.length} leaks) at ${M}`;const G=H.get(X.slice(0,z).join(`
`)),T=(0,j.$K)([...G].map(ce=>q(ce)[z]),ce=>ce);delete T[X[z]];for(const[ce,he]of Object.entries(T))Q.unshift(`    - stacktraces of ${he.length} other leaks continue with ${ce}`);Q.unshift(M)}le+=`


==================== Leaking disposable ${te}/${W.length}: ${ue.value.constructor.name} ====================
${Q.join(`
`)}
============================================================

`}return W.length>A&&(le+=`


... and ${W.length-A} more leaking disposables

`),{leaks:W,details:le}}}e.$Jc=c;function p(C){h=C}if(E){const C="__is_disposable_tracked__";p(new class{trackDisposable(A){const L=new Error("Potentially leaked disposable").stack;setTimeout(()=>{A[C]||console.log(L)},3e3)}setParent(A,L){if(A&&A!==t.None)try{A[C]=!0}catch{}}markAsDisposed(A){if(A&&A!==t.None)try{A[C]=!0}catch{}}markAsSingleton(A){}})}function y(C){return h?.trackDisposable(C),C}function k(C){h?.markAsDisposed(C)}function g(C,A){h?.setParent(C,A)}function m(C,A){if(h)for(const L of C)h.setParent(L,A)}function v(C){return h?.markAsSingleton(C),C}function w(C){return typeof C.dispose=="function"&&C.dispose.length===0}function $(C){if(S.Iterable.is(C)){const A=[];for(const L of C)if(L)try{L.dispose()}catch(W){A.push(W)}if(A.length===1)throw A[0];if(A.length>1)throw new AggregateError(A,"Encountered errors while disposing of store");return Array.isArray(C)?[]:C}else if(C)return C.dispose(),C}function f(C){for(const A of C)w(A)&&A.dispose();return[]}function l(...C){const A=d(()=>$(C));return m(C,A),A}function d(C){const A=y({dispose:(0,B.$db)(()=>{k(A),C()})});return A}class a{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,y(this)}dispose(){this.g||(k(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{$(this.f)}finally{this.f.clear()}}add(A){if(!A)return A;if(A===this)throw new Error("Cannot register a disposable on itself!");return g(A,this),this.g?a.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(A),A}delete(A){if(A){if(A===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(A),A.dispose()}}deleteAndLeak(A){A&&this.f.has(A)&&(this.f.delete(A),g(A,null))}}e.$Tc=a;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new a,y(this),g(this.q,this)}dispose(){k(this),this.q.dispose()}B(A){if(A===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(A)}}e.$Uc=t;class o{constructor(){this.b=!1,y(this)}get value(){return this.b?void 0:this.a}set value(A){this.b||A===this.a||(this.a?.dispose(),A&&g(A,this),this.a=A)}clear(){this.value=void 0}dispose(){this.b=!0,k(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const A=this.a;return this.a=void 0,A&&g(A,null),A}}e.$Vc=o;class r{constructor(A){this.a=new o,this.b=!1,this.a.value=A}get value(){return this.a.value}set value(A){this.b||A===this.a.value||(this.a.value=A)}dispose(){this.b=!0,this.a.dispose()}}e.$Wc=r;class i{constructor(A){this.b=A,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Xc=i;class s{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,y(this)}set(A){let L=A;return this.unset=()=>L=void 0,this.isset=()=>L!==void 0,this.dispose=()=>{L&&(L(),L=void 0,k(this))},this}}e.$Yc=s;class u{constructor(){this.a=new Map}acquire(A,...L){let W=this.a.get(A);W||(W={counter:0,object:this.b(A,...L)},this.a.set(A,W));const{object:q}=W,H=(0,B.$db)(()=>{--W.counter===0&&(this.c(A,W.object),this.a.delete(A))});return W.counter++,{object:q,dispose:H}}}e.$Zc=u;class b{constructor(A){this.a=A}async acquire(A,...L){const W=this.a.acquire(A,...L);try{return{object:await W.object,dispose:()=>W.dispose()}}catch(q){throw W.dispose(),q}}}e.$1c=b;class I{constructor(A){this.object=A}dispose(){}}e.$2c=I;function D(C){const A=new a;try{C(A)}finally{A.dispose()}}class R{constructor(){this.a=new Map,this.b=!1,y(this)}dispose(){k(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{$(this.a.values())}finally{this.a.clear()}}has(A){return this.a.has(A)}get size(){return this.a.size}get(A){return this.a.get(A)}set(A,L,W=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),W||this.a.get(A)?.dispose(),this.a.set(A,L)}deleteAndDispose(A){this.a.get(A)?.dispose(),this.a.delete(A)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$4c=R}),define(oe[86],ae([0,1,32]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1l=void 0,e.$Yl=P,e.$Zl=S;const j=new n.$Ec(1e4);function P(c){return h(c,"NFC",j)}const B=new n.$Ec(1e4);function S(c){return h(c,"NFD",B)}const E=/[^\u0000-\u0080]/;function h(c,p,y){if(!c)return c;const k=y.get(c);if(k)return k;let g;return E.test(c)?g=c.normalize(p):g=c,y.set(c,g),g}e.$1l=function(){const c=/[\u0300-\u036f]/g;return function(p){return S(p).replace(c,"")}}()}),define(oe[141],ae([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qm=e.$pm=e.$om=void 0,e.$mm=n,e.rot=j;function n(E,h,c){return Math.min(Math.max(E,h),c)}function j(E,h){return(h+E%h)%h}class P{constructor(){this.a=0}getNext(){return this.a++}}e.$om=P;class B{constructor(){this.a=1,this.b=0}update(h){return this.b=this.b+(h-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$pm=B;class S{constructor(h){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(h),this.c.fill(0,0,h)}update(h){const c=this.c[this.d];return this.c[this.d]=h,this.d=(this.d+1)%this.c.length,this.e-=c,this.e+=h,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$qm=S}),function(){function J(P){const B=[];typeof P=="number"&&B.push("code/timeOrigin",P);function S(h){B.push(h,Date.now())}function E(){const h=[];for(let c=0;c<B.length;c+=2)h.push({name:B[c],startTime:B[c+1]});return h}return{mark:S,getMarks:E}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(P){performance.mark(P)},getMarks(){let P=performance.timeOrigin;typeof P!="number"&&(P=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const B=[{name:"code/timeOrigin",startTime:Math.round(P)}];for(const S of performance.getEntriesByType("mark"))B.push({name:S.name,startTime:Math.round(P+S.startTime)});return B}};if(typeof process=="object"){const P=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(P)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function n(P){return P.MonacoPerformanceMarks||(P.MonacoPerformanceMarks=e()),P.MonacoPerformanceMarks}var j;typeof global=="object"?j=global:typeof self=="object"?j=self:j={},typeof define=="function"?define("vs/base/common/performance",[],function(){return n(j)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=n(j):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),j.perf=n(j))}(),function(J,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var n=e();for(var j in n)(typeof exports=="object"?exports:J)[j]=n[j]}}(typeof self<"u"?self:this,function(){return function(J){var e={};function n(j){if(e[j])return e[j].exports;var P=e[j]={i:j,l:!1,exports:{}};return J[j].call(P.exports,P,P.exports,n),P.l=!0,P.exports}return n.m=J,n.c=e,n.d=function(j,P,B){n.o(j,P)||Object.defineProperty(j,P,{enumerable:!0,get:B})},n.r=function(j){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(j,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(j,"__esModule",{value:!0})},n.t=function(j,P){if(1&P&&(j=n(j)),8&P||4&P&&typeof j=="object"&&j&&j.__esModule)return j;var B=Object.create(null);if(n.r(B),Object.defineProperty(B,"default",{enumerable:!0,value:j}),2&P&&typeof j!="string")for(var S in j)n.d(B,S,function(E){return j[E]}.bind(null,S));return B},n.n=function(j){var P=j&&j.__esModule?function(){return j.default}:function(){return j};return n.d(P,"a",P),P},n.o=function(j,P){return Object.prototype.hasOwnProperty.call(j,P)},n.p="",n(n.s=0)}([function(J,e,n){(function(j){var P;e=J.exports=he,P=typeof j=="object"&&j.env&&j.env.NODE_DEBUG&&/\bsemver\b/i.test(j.env.NODE_DEBUG)?function(){var Y=Array.prototype.slice.call(arguments,0);Y.unshift("SEMVER"),console.log.apply(console,Y)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var B=256,S=Number.MAX_SAFE_INTEGER||9007199254740991,E=e.re=[],h=e.src=[],c=0,p=c++;h[p]="0|[1-9]\\d*";var y=c++;h[y]="[0-9]+";var k=c++;h[k]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var g=c++;h[g]="("+h[p]+")\\.("+h[p]+")\\.("+h[p]+")";var m=c++;h[m]="("+h[y]+")\\.("+h[y]+")\\.("+h[y]+")";var v=c++;h[v]="(?:"+h[p]+"|"+h[k]+")";var w=c++;h[w]="(?:"+h[y]+"|"+h[k]+")";var $=c++;h[$]="(?:-("+h[v]+"(?:\\."+h[v]+")*))";var f=c++;h[f]="(?:-?("+h[w]+"(?:\\."+h[w]+")*))";var l=c++;h[l]="[0-9A-Za-z-]+";var d=c++;h[d]="(?:\\+("+h[l]+"(?:\\."+h[l]+")*))";var a=c++,t="v?"+h[g]+h[$]+"?"+h[d]+"?";h[a]="^"+t+"$";var o="[v=\\s]*"+h[m]+h[f]+"?"+h[d]+"?",r=c++;h[r]="^"+o+"$";var i=c++;h[i]="((?:<|>)?=?)";var s=c++;h[s]=h[y]+"|x|X|\\*";var u=c++;h[u]=h[p]+"|x|X|\\*";var b=c++;h[b]="[v=\\s]*("+h[u]+")(?:\\.("+h[u]+")(?:\\.("+h[u]+")(?:"+h[$]+")?"+h[d]+"?)?)?";var I=c++;h[I]="[v=\\s]*("+h[s]+")(?:\\.("+h[s]+")(?:\\.("+h[s]+")(?:"+h[f]+")?"+h[d]+"?)?)?";var D=c++;h[D]="^"+h[i]+"\\s*"+h[b]+"$";var R=c++;h[R]="^"+h[i]+"\\s*"+h[I]+"$";var C=c++;h[C]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var A=c++;h[A]="(?:~>?)";var L=c++;h[L]="(\\s*)"+h[A]+"\\s+",E[L]=new RegExp(h[L],"g");var W=c++;h[W]="^"+h[A]+h[b]+"$";var q=c++;h[q]="^"+h[A]+h[I]+"$";var H=c++;h[H]="(?:\\^)";var le=c++;h[le]="(\\s*)"+h[H]+"\\s+",E[le]=new RegExp(h[le],"g");var te=c++;h[te]="^"+h[H]+h[b]+"$";var ue=c++;h[ue]="^"+h[H]+h[I]+"$";var X=c++;h[X]="^"+h[i]+"\\s*("+o+")$|^$";var Q=c++;h[Q]="^"+h[i]+"\\s*("+t+")$|^$";var z=c++;h[z]="(\\s*)"+h[i]+"\\s*("+o+"|"+h[b]+")",E[z]=new RegExp(h[z],"g");var M=c++;h[M]="^\\s*("+h[b]+")\\s+-\\s+("+h[b]+")\\s*$";var F=c++;h[F]="^\\s*("+h[I]+")\\s+-\\s+("+h[I]+")\\s*$";var G=c++;h[G]="(<|>)?=?\\s*\\*";for(var T=0;T<35;T++)P(T,h[T]),E[T]||(E[T]=new RegExp(h[T]));function ce(Y,de){if(Y instanceof he)return Y;if(typeof Y!="string"||Y.length>B||!(de?E[r]:E[a]).test(Y))return null;try{return new he(Y,de)}catch{return null}}function he(Y,de){if(Y instanceof he){if(Y.loose===de)return Y;Y=Y.version}else if(typeof Y!="string")throw new TypeError("Invalid Version: "+Y);if(Y.length>B)throw new TypeError("version is longer than "+B+" characters");if(!(this instanceof he))return new he(Y,de);P("SemVer",Y,de),this.loose=de;var $e=Y.trim().match(de?E[r]:E[a]);if(!$e)throw new TypeError("Invalid Version: "+Y);if(this.raw=Y,this.major=+$e[1],this.minor=+$e[2],this.patch=+$e[3],this.major>S||this.major<0)throw new TypeError("Invalid major version");if(this.minor>S||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>S||this.patch<0)throw new TypeError("Invalid patch version");$e[4]?this.prerelease=$e[4].split(".").map(function(Se){if(/^[0-9]+$/.test(Se)){var Ae=+Se;if(Ae>=0&&Ae<S)return Ae}return Se}):this.prerelease=[],this.build=$e[5]?$e[5].split("."):[],this.format()}e.parse=ce,e.valid=function(Y,de){var $e=ce(Y,de);return $e?$e.version:null},e.clean=function(Y,de){var $e=ce(Y.trim().replace(/^[=v]+/,""),de);return $e?$e.version:null},e.SemVer=he,he.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},he.prototype.toString=function(){return this.version},he.prototype.compare=function(Y){return P("SemVer.compare",this.version,this.loose,Y),Y instanceof he||(Y=new he(Y,this.loose)),this.compareMain(Y)||this.comparePre(Y)},he.prototype.compareMain=function(Y){return Y instanceof he||(Y=new he(Y,this.loose)),O(this.major,Y.major)||O(this.minor,Y.minor)||O(this.patch,Y.patch)},he.prototype.comparePre=function(Y){if(Y instanceof he||(Y=new he(Y,this.loose)),this.prerelease.length&&!Y.prerelease.length)return-1;if(!this.prerelease.length&&Y.prerelease.length)return 1;if(!this.prerelease.length&&!Y.prerelease.length)return 0;var de=0;do{var $e=this.prerelease[de],Se=Y.prerelease[de];if(P("prerelease compare",de,$e,Se),$e===void 0&&Se===void 0)return 0;if(Se===void 0)return 1;if($e===void 0)return-1;if($e!==Se)return O($e,Se)}while(++de)},he.prototype.inc=function(Y,de){switch(Y){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",de);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",de);break;case"prepatch":this.prerelease.length=0,this.inc("patch",de),this.inc("pre",de);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",de),this.inc("pre",de);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var $e=this.prerelease.length;--$e>=0;)typeof this.prerelease[$e]=="number"&&(this.prerelease[$e]++,$e=-2);$e===-1&&this.prerelease.push(0)}de&&(this.prerelease[0]===de?isNaN(this.prerelease[1])&&(this.prerelease=[de,0]):this.prerelease=[de,0]);break;default:throw new Error("invalid increment argument: "+Y)}return this.format(),this.raw=this.version,this},e.inc=function(Y,de,$e,Se){typeof $e=="string"&&(Se=$e,$e=void 0);try{return new he(Y,$e).inc(de,Se).version}catch{return null}},e.diff=function(Y,de){if(Z(Y,de))return null;var $e=ce(Y),Se=ce(de);if($e.prerelease.length||Se.prerelease.length){for(var Ae in $e)if((Ae==="major"||Ae==="minor"||Ae==="patch")&&$e[Ae]!==Se[Ae])return"pre"+Ae;return"prerelease"}for(var Ae in $e)if((Ae==="major"||Ae==="minor"||Ae==="patch")&&$e[Ae]!==Se[Ae])return Ae},e.compareIdentifiers=O;var K=/^[0-9]+$/;function O(Y,de){var $e=K.test(Y),Se=K.test(de);return $e&&Se&&(Y=+Y,de=+de),$e&&!Se?-1:Se&&!$e?1:Y<de?-1:Y>de?1:0}function N(Y,de,$e){return new he(Y,$e).compare(new he(de,$e))}function _(Y,de,$e){return N(Y,de,$e)>0}function se(Y,de,$e){return N(Y,de,$e)<0}function Z(Y,de,$e){return N(Y,de,$e)===0}function V(Y,de,$e){return N(Y,de,$e)!==0}function x(Y,de,$e){return N(Y,de,$e)>=0}function U(Y,de,$e){return N(Y,de,$e)<=0}function re(Y,de,$e,Se){var Ae;switch(de){case"===":typeof Y=="object"&&(Y=Y.version),typeof $e=="object"&&($e=$e.version),Ae=Y===$e;break;case"!==":typeof Y=="object"&&(Y=Y.version),typeof $e=="object"&&($e=$e.version),Ae=Y!==$e;break;case"":case"=":case"==":Ae=Z(Y,$e,Se);break;case"!=":Ae=V(Y,$e,Se);break;case">":Ae=_(Y,$e,Se);break;case">=":Ae=x(Y,$e,Se);break;case"<":Ae=se(Y,$e,Se);break;case"<=":Ae=U(Y,$e,Se);break;default:throw new TypeError("Invalid operator: "+de)}return Ae}function ee(Y,de){if(Y instanceof ee){if(Y.loose===de)return Y;Y=Y.value}if(!(this instanceof ee))return new ee(Y,de);P("comparator",Y,de),this.loose=de,this.parse(Y),this.semver===fe?this.value="":this.value=this.operator+this.semver.version,P("comp",this)}e.rcompareIdentifiers=function(Y,de){return O(de,Y)},e.major=function(Y,de){return new he(Y,de).major},e.minor=function(Y,de){return new he(Y,de).minor},e.patch=function(Y,de){return new he(Y,de).patch},e.compare=N,e.compareLoose=function(Y,de){return N(Y,de,!0)},e.rcompare=function(Y,de,$e){return N(de,Y,$e)},e.sort=function(Y,de){return Y.sort(function($e,Se){return e.compare($e,Se,de)})},e.rsort=function(Y,de){return Y.sort(function($e,Se){return e.rcompare($e,Se,de)})},e.gt=_,e.lt=se,e.eq=Z,e.neq=V,e.gte=x,e.lte=U,e.cmp=re,e.Comparator=ee;var fe={};function me(Y,de){if(Y instanceof me)return Y.loose===de?Y:new me(Y.raw,de);if(Y instanceof ee)return new me(Y.value,de);if(!(this instanceof me))return new me(Y,de);if(this.loose=de,this.raw=Y,this.set=Y.split(/\s*\|\|\s*/).map(function($e){return this.parseRange($e.trim())},this).filter(function($e){return $e.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+Y);this.format()}function ve(Y){return!Y||Y.toLowerCase()==="x"||Y==="*"}function ke(Y,de,$e,Se,Ae,qe,Be,Me,He,xe,Ze,Fe,ie){return((de=ve($e)?"":ve(Se)?">="+$e+".0.0":ve(Ae)?">="+$e+"."+Se+".0":">="+de)+" "+(Me=ve(He)?"":ve(xe)?"<"+(+He+1)+".0.0":ve(Ze)?"<"+He+"."+(+xe+1)+".0":Fe?"<="+He+"."+xe+"."+Ze+"-"+Fe:"<="+Me)).trim()}function je(Y,de){for(var $e=0;$e<Y.length;$e++)if(!Y[$e].test(de))return!1;if(de.prerelease.length){for($e=0;$e<Y.length;$e++)if(P(Y[$e].semver),Y[$e].semver!==fe&&Y[$e].semver.prerelease.length>0){var Se=Y[$e].semver;if(Se.major===de.major&&Se.minor===de.minor&&Se.patch===de.patch)return!0}return!1}return!0}function We(Y,de,$e){try{de=new me(de,$e)}catch{return!1}return de.test(Y)}function ye(Y,de,$e,Se){var Ae,qe,Be,Me,He;switch(Y=new he(Y,Se),de=new me(de,Se),$e){case">":Ae=_,qe=U,Be=se,Me=">",He=">=";break;case"<":Ae=se,qe=x,Be=_,Me="<",He="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(We(Y,de,Se))return!1;for(var xe=0;xe<de.set.length;++xe){var Ze=de.set[xe],Fe=null,ie=null;if(Ze.forEach(function(ge){ge.semver===fe&&(ge=new ee(">=0.0.0")),Fe=Fe||ge,ie=ie||ge,Ae(ge.semver,Fe.semver,Se)?Fe=ge:Be(ge.semver,ie.semver,Se)&&(ie=ge)}),Fe.operator===Me||Fe.operator===He||(!ie.operator||ie.operator===Me)&&qe(Y,ie.semver)||ie.operator===He&&Be(Y,ie.semver))return!1}return!0}ee.prototype.parse=function(Y){var de=this.loose?E[X]:E[Q],$e=Y.match(de);if(!$e)throw new TypeError("Invalid comparator: "+Y);this.operator=$e[1],this.operator==="="&&(this.operator=""),$e[2]?this.semver=new he($e[2],this.loose):this.semver=fe},ee.prototype.toString=function(){return this.value},ee.prototype.test=function(Y){return P("Comparator.test",Y,this.loose),this.semver===fe||(typeof Y=="string"&&(Y=new he(Y,this.loose)),re(Y,this.operator,this.semver,this.loose))},ee.prototype.intersects=function(Y,de){if(!(Y instanceof ee))throw new TypeError("a Comparator is required");var $e;if(this.operator==="")return $e=new me(Y.value,de),We(this.value,$e,de);if(Y.operator==="")return $e=new me(this.value,de),We(Y.semver,$e,de);var Se=!(this.operator!==">="&&this.operator!==">"||Y.operator!==">="&&Y.operator!==">"),Ae=!(this.operator!=="<="&&this.operator!=="<"||Y.operator!=="<="&&Y.operator!=="<"),qe=this.semver.version===Y.semver.version,Be=!(this.operator!==">="&&this.operator!=="<="||Y.operator!==">="&&Y.operator!=="<="),Me=re(this.semver,"<",Y.semver,de)&&(this.operator===">="||this.operator===">")&&(Y.operator==="<="||Y.operator==="<"),He=re(this.semver,">",Y.semver,de)&&(this.operator==="<="||this.operator==="<")&&(Y.operator===">="||Y.operator===">");return Se||Ae||qe&&Be||Me||He},e.Range=me,me.prototype.format=function(){return this.range=this.set.map(function(Y){return Y.join(" ").trim()}).join("||").trim(),this.range},me.prototype.toString=function(){return this.range},me.prototype.parseRange=function(Y){var de=this.loose;Y=Y.trim(),P("range",Y,de);var $e=de?E[F]:E[M];Y=Y.replace($e,ke),P("hyphen replace",Y),Y=Y.replace(E[z],"$1$2$3"),P("comparator trim",Y,E[z]),Y=(Y=(Y=Y.replace(E[L],"$1~")).replace(E[le],"$1^")).split(/\s+/).join(" ");var Se=de?E[X]:E[Q],Ae=Y.split(" ").map(function(qe){return function(Be,Me){return P("comp",Be),Be=function(He,xe){return He.trim().split(/\s+/).map(function(Ze){return function(Fe,ie){P("caret",Fe,ie);var ge=ie?E[ue]:E[te];return Fe.replace(ge,function(pe,be,Pe,Oe,Te){var Ke;return P("caret",Fe,pe,be,Pe,Oe,Te),ve(be)?Ke="":ve(Pe)?Ke=">="+be+".0.0 <"+(+be+1)+".0.0":ve(Oe)?Ke=be==="0"?">="+be+"."+Pe+".0 <"+be+"."+(+Pe+1)+".0":">="+be+"."+Pe+".0 <"+(+be+1)+".0.0":Te?(P("replaceCaret pr",Te),Te.charAt(0)!=="-"&&(Te="-"+Te),Ke=be==="0"?Pe==="0"?">="+be+"."+Pe+"."+Oe+Te+" <"+be+"."+Pe+"."+(+Oe+1):">="+be+"."+Pe+"."+Oe+Te+" <"+be+"."+(+Pe+1)+".0":">="+be+"."+Pe+"."+Oe+Te+" <"+(+be+1)+".0.0"):(P("no pr"),Ke=be==="0"?Pe==="0"?">="+be+"."+Pe+"."+Oe+" <"+be+"."+Pe+"."+(+Oe+1):">="+be+"."+Pe+"."+Oe+" <"+be+"."+(+Pe+1)+".0":">="+be+"."+Pe+"."+Oe+" <"+(+be+1)+".0.0"),P("caret return",Ke),Ke})}(Ze,xe)}).join(" ")}(Be,Me),P("caret",Be),Be=function(He,xe){return He.trim().split(/\s+/).map(function(Ze){return function(Fe,ie){var ge=ie?E[q]:E[W];return Fe.replace(ge,function(pe,be,Pe,Oe,Te){var Ke;return P("tilde",Fe,pe,be,Pe,Oe,Te),ve(be)?Ke="":ve(Pe)?Ke=">="+be+".0.0 <"+(+be+1)+".0.0":ve(Oe)?Ke=">="+be+"."+Pe+".0 <"+be+"."+(+Pe+1)+".0":Te?(P("replaceTilde pr",Te),Te.charAt(0)!=="-"&&(Te="-"+Te),Ke=">="+be+"."+Pe+"."+Oe+Te+" <"+be+"."+(+Pe+1)+".0"):Ke=">="+be+"."+Pe+"."+Oe+" <"+be+"."+(+Pe+1)+".0",P("tilde return",Ke),Ke})}(Ze,xe)}).join(" ")}(Be,Me),P("tildes",Be),Be=function(He,xe){return P("replaceXRanges",He,xe),He.split(/\s+/).map(function(Ze){return function(Fe,ie){Fe=Fe.trim();var ge=ie?E[R]:E[D];return Fe.replace(ge,function(pe,be,Pe,Oe,Te,Ke){P("xRange",Fe,pe,be,Pe,Oe,Te,Ke);var Ye=ve(Pe),Xe=Ye||ve(Oe),Qe=Xe||ve(Te);return be==="="&&Qe&&(be=""),Ye?pe=be===">"||be==="<"?"<0.0.0":"*":be&&Qe?(Xe&&(Oe=0),Qe&&(Te=0),be===">"?(be=">=",Xe?(Pe=+Pe+1,Oe=0,Te=0):Qe&&(Oe=+Oe+1,Te=0)):be==="<="&&(be="<",Xe?Pe=+Pe+1:Oe=+Oe+1),pe=be+Pe+"."+Oe+"."+Te):Xe?pe=">="+Pe+".0.0 <"+(+Pe+1)+".0.0":Qe&&(pe=">="+Pe+"."+Oe+".0 <"+Pe+"."+(+Oe+1)+".0"),P("xRange return",pe),pe})}(Ze,xe)}).join(" ")}(Be,Me),P("xrange",Be),Be=function(He,xe){return P("replaceStars",He,xe),He.trim().replace(E[G],"")}(Be,Me),P("stars",Be),Be}(qe,de)}).join(" ").split(/\s+/);return this.loose&&(Ae=Ae.filter(function(qe){return!!qe.match(Se)})),Ae=Ae.map(function(qe){return new ee(qe,de)})},me.prototype.intersects=function(Y,de){if(!(Y instanceof me))throw new TypeError("a Range is required");return this.set.some(function($e){return $e.every(function(Se){return Y.set.some(function(Ae){return Ae.every(function(qe){return Se.intersects(qe,de)})})})})},e.toComparators=function(Y,de){return new me(Y,de).set.map(function($e){return $e.map(function(Se){return Se.value}).join(" ").trim().split(" ")})},me.prototype.test=function(Y){if(!Y)return!1;typeof Y=="string"&&(Y=new he(Y,this.loose));for(var de=0;de<this.set.length;de++)if(je(this.set[de],Y))return!0;return!1},e.satisfies=We,e.maxSatisfying=function(Y,de,$e){var Se=null,Ae=null;try{var qe=new me(de,$e)}catch{return null}return Y.forEach(function(Be){qe.test(Be)&&(Se&&Ae.compare(Be)!==-1||(Ae=new he(Se=Be,$e)))}),Se},e.minSatisfying=function(Y,de,$e){var Se=null,Ae=null;try{var qe=new me(de,$e)}catch{return null}return Y.forEach(function(Be){qe.test(Be)&&(Se&&Ae.compare(Be)!==1||(Ae=new he(Se=Be,$e)))}),Se},e.validRange=function(Y,de){try{return new me(Y,de).range||"*"}catch{return null}},e.ltr=function(Y,de,$e){return ye(Y,de,"<",$e)},e.gtr=function(Y,de,$e){return ye(Y,de,">",$e)},e.outside=ye,e.prerelease=function(Y,de){var $e=ce(Y,de);return $e&&$e.prerelease.length?$e.prerelease:null},e.intersects=function(Y,de,$e){return Y=new me(Y,$e),de=new me(de,$e),Y.intersects(de)},e.coerce=function(Y){if(Y instanceof he)return Y;if(typeof Y!="string")return null;var de=Y.match(E[C]);return de==null?null:ce((de[1]||"0")+"."+(de[2]||"0")+"."+(de[3]||"0"))}}).call(this,n(1))},function(J,e){var n,j,P=J.exports={};function B(){throw new Error("setTimeout has not been defined")}function S(){throw new Error("clearTimeout has not been defined")}function E(w){if(n===setTimeout)return setTimeout(w,0);if((n===B||!n)&&setTimeout)return n=setTimeout,setTimeout(w,0);try{return n(w,0)}catch{try{return n.call(null,w,0)}catch{return n.call(this,w,0)}}}(function(){try{n=typeof setTimeout=="function"?setTimeout:B}catch{n=B}try{j=typeof clearTimeout=="function"?clearTimeout:S}catch{j=S}})();var h,c=[],p=!1,y=-1;function k(){p&&h&&(p=!1,h.length?c=h.concat(c):y=-1,c.length&&g())}function g(){if(!p){var w=E(k);p=!0;for(var $=c.length;$;){for(h=c,c=[];++y<$;)h&&h[y].run();y=-1,$=c.length}h=null,p=!1,function(f){if(j===clearTimeout)return clearTimeout(f);if((j===S||!j)&&clearTimeout)return j=clearTimeout,clearTimeout(f);try{j(f)}catch{try{return j.call(null,f)}catch{return j.call(this,f)}}}(w)}}function m(w,$){this.fun=w,this.array=$}function v(){}P.nextTick=function(w){var $=new Array(arguments.length-1);if(arguments.length>1)for(var f=1;f<arguments.length;f++)$[f-1]=arguments[f];c.push(new m(w,$)),c.length!==1||p||E(g)},m.prototype.run=function(){this.fun.apply(null,this.array)},P.title="browser",P.browser=!0,P.env={},P.argv=[],P.version="",P.versions={},P.on=v,P.addListener=v,P.once=v,P.off=v,P.removeListener=v,P.removeAllListeners=v,P.emit=v,P.prependListener=v,P.prependOnceListener=v,P.listeners=function(w){return[]},P.binding=function(w){throw new Error("process.binding is not supported")},P.cwd=function(){return"/"},P.chdir=function(w){throw new Error("process.chdir is not supported")},P.umask=function(){return 0}}])}),define(oe[142],ae([0,1]),function(J,e){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0}),e.$hs=void 0;class j{constructor(E,h,c){this.level=E,this.key=h,this.value=c,this.forward=[]}}const P=void 0;class B{constructor(E,h=2**16){this.comparator=E,this[n]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(h)|0),this.e=new j(this.c,P,P)}get size(){return this.f}clear(){this.e=new j(this.c,P,P),this.f=0}has(E){return!!B.g(this,E,this.comparator)}get(E){return B.g(this,E,this.comparator)?.value}set(E,h){return B.h(this,E,h,this.comparator)&&(this.f+=1),this}delete(E){const h=B.k(this,E,this.comparator);return h&&(this.f-=1),h}forEach(E,h){let c=this.e.forward[0];for(;c;)E.call(h,c.value,c.key,this),c=c.forward[0]}[(n=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let E=this.e.forward[0];for(;E;)yield[E.key,E.value],E=E.forward[0]}*keys(){let E=this.e.forward[0];for(;E;)yield E.key,E=E.forward[0]}*values(){let E=this.e.forward[0];for(;E;)yield E.value,E=E.forward[0]}toString(){let E="[SkipList]:",h=this.e.forward[0];for(;h;)E+=`node(${h.key}, ${h.value}, lvl:${h.level})`,h=h.forward[0];return E}static g(E,h,c){let p=E.e;for(let y=E.d-1;y>=0;y--)for(;p.forward[y]&&c(p.forward[y].key,h)<0;)p=p.forward[y];if(p=p.forward[0],p&&c(p.key,h)===0)return p}static h(E,h,c,p){const y=[];let k=E.e;for(let g=E.d-1;g>=0;g--){for(;k.forward[g]&&p(k.forward[g].key,h)<0;)k=k.forward[g];y[g]=k}if(k=k.forward[0],k&&p(k.key,h)===0)return k.value=c,!1;{const g=B.j(E);if(g>E.d){for(let m=E.d;m<g;m++)y[m]=E.e;E.d=g}k=new j(g,h,c);for(let m=0;m<g;m++)k.forward[m]=y[m].forward[m],y[m].forward[m]=k;return!0}}static j(E,h=.5){let c=1;for(;Math.random()<h&&c<E.c;)c+=1;return c}static k(E,h,c){const p=[];let y=E.e;for(let k=E.d-1;k>=0;k--){for(;y.forward[k]&&c(y.forward[k].key,h)<0;)y=y.forward[k];p[k]=y}if(y=y.forward[0],!y||c(y.key,h)!==0)return!1;for(let k=0;k<E.d&&p[k].forward[k]===y;k++)p[k].forward[k]=y.forward[k];for(;E.d>0&&E.e.forward[E.d-1]===P;)E.d-=1;return!0}}e.$hs=B}),define(oe[72],ae([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3d=void 0;const n=globalThis.performance&&typeof globalThis.performance.now=="function";class j{static create(B){return new j(B)}constructor(B){this.c=n&&B===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$3d=j}),define(oe[3],ae([0,1,15,85,2,104,72]),function(J,e,n,j,P,B,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$5d=e.Event=void 0,e.$6d=g;const E=!1,h=!1,c=!1;var p;(function(C){C.None=()=>P.$Uc.None;function A(ee){if(c){const{onDidAddListener:fe}=ee,me=v.create();let ve=0;ee.onDidAddListener=()=>{++ve===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),me.print()),fe?.()}}}function L(ee,fe){return M(ee,()=>{},0,void 0,!0,void 0,fe)}C.defer=L;function W(ee){return(fe,me=null,ve)=>{let ke=!1,je;return je=ee(We=>{if(!ke)return je?je.dispose():ke=!0,fe.call(me,We)},null,ve),ke&&je.dispose(),je}}C.once=W;function q(ee,fe,me){return Q((ve,ke=null,je)=>ee(We=>ve.call(ke,fe(We)),null,je),me)}C.map=q;function H(ee,fe,me){return Q((ve,ke=null,je)=>ee(We=>{fe(We),ve.call(ke,We)},null,je),me)}C.forEach=H;function le(ee,fe,me){return Q((ve,ke=null,je)=>ee(We=>fe(We)&&ve.call(ke,We),null,je),me)}C.filter=le;function te(ee){return ee}C.signal=te;function ue(...ee){return(fe,me=null,ve)=>{const ke=(0,P.$Rc)(...ee.map(je=>je(We=>fe.call(me,We))));return z(ke,ve)}}C.any=ue;function X(ee,fe,me,ve){let ke=me;return q(ee,je=>(ke=fe(ke,je),ke),ve)}C.reduce=X;function Q(ee,fe){let me;const ve={onWillAddFirstListener(){me=ee(ke.fire,ke)},onDidRemoveLastListener(){me?.dispose()}};fe||A(ve);const ke=new a(ve);return fe?.add(ke),ke.event}function z(ee,fe){return fe instanceof Array?fe.push(ee):fe&&fe.add(ee),ee}function M(ee,fe,me=100,ve=!1,ke=!1,je,We){let ye,Y,de,$e=0,Se;const Ae={leakWarningThreshold:je,onWillAddFirstListener(){ye=ee(Be=>{$e++,Y=fe(Y,Be),ve&&!de&&(qe.fire(Y),Y=void 0),Se=()=>{const Me=Y;Y=void 0,de=void 0,(!ve||$e>1)&&qe.fire(Me),$e=0},typeof me=="number"?(clearTimeout(de),de=setTimeout(Se,me)):de===void 0&&(de=0,queueMicrotask(Se))})},onWillRemoveListener(){ke&&$e>0&&Se?.()},onDidRemoveLastListener(){Se=void 0,ye.dispose()}};We||A(Ae);const qe=new a(Ae);return We?.add(qe),qe.event}C.debounce=M;function F(ee,fe=0,me){return C.debounce(ee,(ve,ke)=>ve?(ve.push(ke),ve):[ke],fe,void 0,!0,void 0,me)}C.accumulate=F;function G(ee,fe=(ve,ke)=>ve===ke,me){let ve=!0,ke;return le(ee,je=>{const We=ve||!fe(je,ke);return ve=!1,ke=je,We},me)}C.latch=G;function T(ee,fe,me){return[C.filter(ee,fe,me),C.filter(ee,ve=>!fe(ve),me)]}C.split=T;function ce(ee,fe=!1,me=[],ve){let ke=me.slice(),je=ee(Y=>{ke?ke.push(Y):ye.fire(Y)});ve&&ve.add(je);const We=()=>{ke?.forEach(Y=>ye.fire(Y)),ke=null},ye=new a({onWillAddFirstListener(){je||(je=ee(Y=>ye.fire(Y)),ve&&ve.add(je))},onDidAddFirstListener(){ke&&(fe?setTimeout(We):We())},onDidRemoveLastListener(){je&&je.dispose(),je=null}});return ve&&ve.add(ye),ye.event}C.buffer=ce;function he(ee,fe){return(ve,ke,je)=>{const We=fe(new O);return ee(function(ye){const Y=We.evaluate(ye);Y!==K&&ve.call(ke,Y)},void 0,je)}}C.chain=he;const K=Symbol("HaltChainable");class O{constructor(){this.f=[]}map(fe){return this.f.push(fe),this}forEach(fe){return this.f.push(me=>(fe(me),me)),this}filter(fe){return this.f.push(me=>fe(me)?me:K),this}reduce(fe,me){let ve=me;return this.f.push(ke=>(ve=fe(ve,ke),ve)),this}latch(fe=(me,ve)=>me===ve){let me=!0,ve;return this.f.push(ke=>{const je=me||!fe(ke,ve);return me=!1,ve=ke,je?ke:K}),this}evaluate(fe){for(const me of this.f)if(fe=me(fe),fe===K)break;return fe}}function N(ee,fe,me=ve=>ve){const ve=(...ye)=>We.fire(me(...ye)),ke=()=>ee.on(fe,ve),je=()=>ee.removeListener(fe,ve),We=new a({onWillAddFirstListener:ke,onDidRemoveLastListener:je});return We.event}C.fromNodeEventEmitter=N;function _(ee,fe,me=ve=>ve){const ve=(...ye)=>We.fire(me(...ye)),ke=()=>ee.addEventListener(fe,ve),je=()=>ee.removeEventListener(fe,ve),We=new a({onWillAddFirstListener:ke,onDidRemoveLastListener:je});return We.event}C.fromDOMEventEmitter=_;function se(ee){return new Promise(fe=>W(ee)(fe))}C.toPromise=se;function Z(ee){const fe=new a;return ee.then(me=>{fe.fire(me)},()=>{fe.fire(void 0)}).finally(()=>{fe.dispose()}),fe.event}C.fromPromise=Z;function V(ee,fe,me){return fe(me),ee(ve=>fe(ve))}C.runAndSubscribe=V;class x{constructor(fe,me){this._observable=fe,this.f=0,this.g=!1;const ve={onWillAddFirstListener:()=>{fe.addObserver(this)},onDidRemoveLastListener:()=>{fe.removeObserver(this)}};me||A(ve),this.emitter=new a(ve),me&&me.add(this.emitter)}beginUpdate(fe){this.f++}handlePossibleChange(fe){}handleChange(fe,me){this.g=!0}endUpdate(fe){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function U(ee,fe){return new x(ee,fe).emitter.event}C.fromObservable=U;function re(ee){return(fe,me,ve)=>{let ke=0,je=!1;const We={beginUpdate(){ke++},endUpdate(){ke--,ke===0&&(ee.reportChanges(),je&&(je=!1,fe.call(me)))},handlePossibleChange(){},handleChange(){je=!0}};ee.addObserver(We),ee.reportChanges();const ye={dispose(){ee.removeObserver(We)}};return ve instanceof P.$Tc?ve.add(ye):Array.isArray(ve)&&ve.push(ye),ye}}C.fromObservableLight=re})(p||(e.Event=p={}));class y{static{this.all=new Set}static{this.f=0}constructor(A){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${A}_${y.f++}`,y.all.add(this)}start(A){this.g=new S.$3d,this.listenerCount=A}stop(){if(this.g){const A=this.g.elapsed();this.durations.push(A),this.elapsedOverall+=A,this.invocationCount+=1,this.g=void 0}}}e.$5d=y;let k=-1;function g(C){const A=k;return k=C,{dispose(){k=A}}}class m{constructor(A,L=Math.random().toString(18).slice(2,5)){this.threshold=A,this.name=L,this.g=0}dispose(){this.f?.clear()}check(A,L){const W=this.threshold;if(W<=0||L<W)return;this.f||(this.f=new Map);const q=this.f.get(A.value)||0;if(this.f.set(A.value,q+1),this.g-=1,this.g<=0){this.g=W*.5;let H,le=0;for(const[te,ue]of this.f)(!H||le<ue)&&(H=te,le=ue);console.warn(`[${this.name}] potential listener LEAK detected, having ${L} listeners already. MOST frequent listener (${le}):`),console.warn(H)}return()=>{const H=this.f.get(A.value)||0;this.f.set(A.value,H-1)}}}class v{static create(){return new v(new Error().stack??"")}constructor(A){this.value=A}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let w=0;class ${constructor(A){this.value=A,this.id=w++}}const f=2,l=(C,A)=>{if(C instanceof $)A(C);else for(let L=0;L<C.length;L++){const W=C[L];W&&A(W)}},d=E?new FinalizationRegistry(C=>{typeof C=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(C))}):void 0;class a{constructor(A){this.w=0,this.f=A,this.g=k>0||this.f?.leakWarningThreshold?new m(this.f?.leakWarningThreshold??k):void 0,this.j=this.f?._profName?new y(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(h){const A=this.t;queueMicrotask(()=>{l(A,L=>L.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(A,L,W)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),P.$Uc.None;if(this.m)return P.$Uc.None;L&&(A=A.bind(L));const q=new $(A);let H,le;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(q.stack=v.create(),H=this.g.check(q.stack,this.w+1)),h&&(q.stack=le??v.create()),this.t?this.t instanceof $?(this.u??=new o,this.t=[this.t,q]):this.t.push(q):(this.f?.onWillAddFirstListener?.(this),this.t=q,this.f?.onDidAddFirstListener?.(this)),this.w++;const te=(0,P.$Sc)(()=>{d?.unregister(te),H?.(),this.x(q)});if(W instanceof P.$Tc?W.add(te):Array.isArray(W)&&W.push(te),d){const ue=new Error().stack.split(`
`).slice(2).join(`
`).trim();d.register(te,ue,te)}return te},this.q}x(A){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const L=this.t,W=L.indexOf(A);if(W===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,L[W]=void 0;const q=this.u.current===this;if(this.w*f<=L.length){let H=0;for(let le=0;le<L.length;le++)L[le]?L[H++]=L[le]:q&&(this.u.end--,H<this.u.i&&this.u.i--);L.length=H}}y(A,L){if(!A)return;const W=this.f?.onListenerError||n.$1;if(!W){A.value(L);return}try{A.value(L)}catch(q){W(q)}}z(A){const L=A.current.t;for(;A.i<A.end;)this.y(L[A.i++],A.value);A.reset()}fire(A){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof $)this.y(this.t,A);else{const L=this.u;L.enqueue(this,A,this.t.length),this.z(L)}this.j?.stop()}hasListeners(){return this.w>0}}e.$7d=a;const t=()=>new o;e.$8d=t;class o{constructor(){this.i=-1,this.end=0}enqueue(A,L,W){this.i=0,this.end=W,this.current=A,this.value=L}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class r extends a{async fireAsync(A,L,W){if(this.t)for(this.h||(this.h=new B.$5c),l(this.t,q=>this.h.push([q.value,A]));this.h.size>0&&!L.isCancellationRequested;){const[q,H]=this.h.shift(),le=[],te={...H,token:L,waitUntil:ue=>{if(Object.isFrozen(le))throw new Error("waitUntil can NOT be called asynchronous");W&&(ue=W(ue,q)),le.push(ue)}};try{q(te)}catch(ue){(0,n.$1)(ue);continue}Object.freeze(le),await Promise.allSettled(le).then(ue=>{for(const X of ue)X.status==="rejected"&&(0,n.$1)(X.reason)})}}}e.$9d=r;class i extends a{get isPaused(){return this.h!==0}constructor(A){super(A),this.h=0,this.s=new B.$5c,this.A=A?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const A=Array.from(this.s);this.s.clear(),super.fire(this.A(A))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(A){this.w&&(this.h!==0?this.s.push(A):super.fire(A))}}e.$0d=i;class s extends i{constructor(A){super(A),this.k=A.delay??100}fire(A){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(A)}}e.$$d=s;class u extends a{constructor(A){super(A),this.h=[],this.k=A?.merge}fire(A){this.hasListeners()&&(this.h.push(A),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(L=>super.fire(L)),this.h=[]}))}}e.$_d=u;class b{constructor(){this.g=!1,this.h=[],this.f=new a({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(A){const L={event:A,listener:null};this.h.push(L),this.g&&this.m(L);const W=()=>{this.g&&this.o(L);const q=this.h.indexOf(L);this.h.splice(q,1)};return(0,P.$Sc)((0,j.$db)(W))}j(){this.g=!0,this.h.forEach(A=>this.m(A))}k(){this.g=!1,this.h.forEach(A=>this.o(A))}m(A){A.listener=A.event(L=>this.f.fire(L))}o(A){A.listener?.dispose(),A.listener=null}dispose(){this.f.dispose();for(const A of this.h)A.listener?.dispose();this.h=[]}}e.$ae=b;class I{constructor(A,L,W,q){this.f=new P.$Tc;const H=this.f.add(new b),le=this.f.add(new P.$4c);function te(ue){le.set(ue,H.add(q(ue)))}for(const ue of A)te(ue);this.f.add(L(ue=>{te(ue)})),this.f.add(W(ue=>{le.deleteAndDispose(ue)})),this.event=H.event}dispose(){this.f.dispose()}}e.$be=I;class D{constructor(){this.f=[]}wrapEvent(A){return(L,W,q)=>A(H=>{const le=this.f[this.f.length-1];le?le.push(()=>L.call(W,H)):L.call(W,H)},void 0,q)}bufferEvents(A){const L=[];this.f.push(L);const W=A();return this.f.pop(),L.forEach(q=>q()),W}}e.$ce=D;class R{constructor(){this.f=!1,this.g=p.None,this.h=P.$Uc.None,this.j=new a({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(A){this.g=A,this.f&&(this.h.dispose(),this.h=A(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$de=R}),define(oe[23],ae([0,1,3]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ee=e.CancellationToken=void 0;const j=Object.freeze(function(E,h){const c=setTimeout(E.bind(h),0);return{dispose(){clearTimeout(c)}}});var P;(function(E){function h(c){return c===E.None||c===E.Cancelled||c instanceof B?!0:!c||typeof c!="object"?!1:typeof c.isCancellationRequested=="boolean"&&typeof c.onCancellationRequested=="function"}E.isCancellationToken=h,E.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:n.Event.None}),E.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:j})})(P||(e.CancellationToken=P={}));class B{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?j:(this.b||(this.b=new n.$7d),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class S{constructor(h){this.f=void 0,this.g=void 0,this.g=h&&h.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new B),this.f}cancel(){this.f?this.f instanceof B&&this.f.cancel():this.f=P.Cancelled}dispose(h=!1){h&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof B&&this.f.dispose():this.f=P.None}}e.$ee=S}),define(oe[143],ae([0,1,23]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Re=e.$Qe=e.$Pe=void 0;class j{constructor(E){this.b=E,this.a=null}get(){if(this.a)return this.a;const E=new n.$ee,h=this.b(E.token);return this.a={promise:h,dispose:()=>{this.a=null,E.cancel(),E.dispose()}},this.a}}e.$Pe=j;class P{constructor(E){this.c=E,this.a=void 0,this.b=void 0}get(E){const h=JSON.stringify(E);return this.b!==h&&(this.b=h,this.a=this.c(E)),this.a}}e.$Qe=P;class B{get cachedValues(){return this.a}constructor(E){this.b=E,this.a=new Map}get(E){if(this.a.has(E))return this.a.get(E);const h=this.b(E);return this.a.set(E,h),h}}e.$Re=B}),define(oe[63],ae([0,1,15,2]),function(J,e,n,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fe=P,e.$ge=B,e.$he=S,e.$ie=E,e.$je=c,e.$ke=p,e.$le=y,e.$me=k,e.$ne=g,e.$oe=m,e.$pe=v,e.$qe=w,e.$re=$,e.$se=f,e.$te=l;function P(d){const a=d;return a?typeof a.read=="function":!1}function B(d){const a=d;return a?[a.on,a.pause,a.resume,a.destroy].every(t=>typeof t=="function"):!1}function S(d){const a=d;return a?B(a.stream)&&Array.isArray(a.buffer)&&typeof a.ended=="boolean":!1}function E(d,a){return new h(d,a)}class h{constructor(a,t){this.e=a,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(a){if(!this.a.destroyed){if(this.a.flowing)this.g(a);else if(this.b.data.push(a),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(a){this.a.destroyed||(this.a.flowing?this.h(a):this.b.error.push(a))}end(a){this.a.destroyed||(typeof a<"u"&&this.write(a),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(a){this.c.data.slice(0).forEach(t=>t(a))}h(a){this.c.error.length===0?(0,n.$1)(a):this.c.error.slice(0).forEach(t=>t(a))}i(){this.c.end.slice(0).forEach(a=>a())}on(a,t){if(!this.a.destroyed)switch(a){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(a,t){if(this.a.destroyed)return;let o;switch(a){case"data":o=this.c.data;break;case"end":o=this.c.end;break;case"error":o=this.c.error;break}if(o){const r=o.indexOf(t);r>=0&&o.splice(r,1)}}j(){if(this.b.data.length>0){const a=this.e(this.b.data);this.g(a),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(o=>o())}}k(){if(this.c.error.length>0){for(const a of this.b.error)this.h(a);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function c(d,a){const t=[];let o;for(;(o=d.read())!==null;)t.push(o);return a(t)}function p(d,a,t){const o=[];let r;for(;(r=d.read())!==null&&o.length<t;)o.push(r);return r===null&&o.length>0?a(o):{read:()=>{if(o.length>0)return o.shift();if(typeof r<"u"){const i=r;return r=void 0,i}return d.read()}}}function y(d,a){return new Promise((t,o)=>{const r=[];k(d,{onData:i=>{a&&r.push(i)},onError:i=>{a?o(i):t(void 0)},onEnd:()=>{t(a?a(r):void 0)}})})}function k(d,a,t){d.on("error",o=>{t?.isCancellationRequested||a.onError(o)}),d.on("end",()=>{t?.isCancellationRequested||a.onEnd()}),d.on("data",o=>{t?.isCancellationRequested||a.onData(o)})}function g(d,a){return new Promise((t,o)=>{const r=new j.$Tc,i=[],s=I=>{if(i.push(I),i.length>a)return r.dispose(),d.pause(),t({stream:d,buffer:i,ended:!1})},u=I=>(r.dispose(),o(I)),b=()=>(r.dispose(),t({stream:d,buffer:i,ended:!0}));r.add((0,j.$Sc)(()=>d.removeListener("error",u))),d.on("error",u),r.add((0,j.$Sc)(()=>d.removeListener("end",b))),d.on("end",b),r.add((0,j.$Sc)(()=>d.removeListener("data",s))),d.on("data",s)})}function m(d,a){const t=E(a);return t.end(d),t}function v(){const d=E(()=>{throw new Error("not supported")});return d.end(),d}function w(d){let a=!1;return{read:()=>a?null:(a=!0,d)}}function $(d,a,t){const o=E(t);return k(d,{onData:r=>o.write(a.data(r)),onError:r=>o.error(a.error?a.error(r):r),onEnd:()=>o.end()}),o}function f(d,a,t){let o=!1;return{read:()=>{const r=a.read();return o?r:(o=!0,r!==null?t([d,r]):d)}}}function l(d,a,t){let o=!1;const r=E(t);return k(a,{onData:i=>o?r.write(i):(o=!0,r.write(t([d,i]))),onError:i=>r.error(i),onEnd:()=>{o||(o=!0,r.write(d)),r.end()}}),r}}),define(oe[17],ae([0,1,62,63]),function(J,e,n,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ue=void 0,e.$ve=c,e.$we=p,e.$xe=y,e.$ye=k,e.$ze=g,e.$Ae=m,e.$Be=v,e.$Ce=w,e.$De=$,e.$Ee=f,e.$Fe=l,e.$Ge=d,e.$He=a,e.$Ie=t,e.$Je=o,e.$Ke=r,e.$Le=i,e.$Me=s,e.$Ne=u,e.$Oe=D;const P=typeof Buffer<"u",B=new n.$V(()=>new Uint8Array(256));let S,E;class h{static alloc(C){return P?new h(Buffer.allocUnsafe(C)):new h(new Uint8Array(C))}static wrap(C){return P&&!Buffer.isBuffer(C)&&(C=Buffer.from(C.buffer,C.byteOffset,C.byteLength)),new h(C)}static fromString(C,A){return!(A?.dontUseNodeBuffer||!1)&&P?new h(Buffer.from(C)):(S||(S=new TextEncoder),new h(S.encode(C)))}static fromByteArray(C){const A=h.alloc(C.length);for(let L=0,W=C.length;L<W;L++)A.buffer[L]=C[L];return A}static concat(C,A){if(typeof A>"u"){A=0;for(let q=0,H=C.length;q<H;q++)A+=C[q].byteLength}const L=h.alloc(A);let W=0;for(let q=0,H=C.length;q<H;q++){const le=C[q];L.set(le,W),W+=le.byteLength}return L}constructor(C){this.buffer=C,this.byteLength=this.buffer.byteLength}clone(){const C=h.alloc(this.byteLength);return C.set(this),C}toString(){return P?this.buffer.toString():(E||(E=new TextDecoder),E.decode(this.buffer))}slice(C,A){return new h(this.buffer.subarray(C,A))}set(C,A){if(C instanceof h)this.buffer.set(C.buffer,A);else if(C instanceof Uint8Array)this.buffer.set(C,A);else if(C instanceof ArrayBuffer)this.buffer.set(new Uint8Array(C),A);else if(ArrayBuffer.isView(C))this.buffer.set(new Uint8Array(C.buffer,C.byteOffset,C.byteLength),A);else throw new Error("Unknown argument 'array'")}readUInt32BE(C){return k(this.buffer,C)}writeUInt32BE(C,A){g(this.buffer,C,A)}readUInt32LE(C){return m(this.buffer,C)}writeUInt32LE(C,A){v(this.buffer,C,A)}readUInt8(C){return w(this.buffer,C)}writeUInt8(C,A){$(this.buffer,C,A)}indexOf(C,A=0){return c(this.buffer,C instanceof h?C.buffer:C,A)}}e.$ue=h;function c(R,C,A=0){const L=C.byteLength,W=R.byteLength;if(L===0)return 0;if(L===1)return R.indexOf(C[0]);if(L>W-A)return-1;const q=B.value;q.fill(C.length);for(let ue=0;ue<C.length;ue++)q[C[ue]]=C.length-ue-1;let H=A+C.length-1,le=H,te=-1;for(;H<W;)if(R[H]===C[le]){if(le===0){te=H;break}H--,le--}else H+=Math.max(C.length-le,q[R[H]]),le=C.length-1;return te}function p(R,C){return R[C+0]<<0>>>0|R[C+1]<<8>>>0}function y(R,C,A){R[A+0]=C&255,C=C>>>8,R[A+1]=C&255}function k(R,C){return R[C]*2**24+R[C+1]*2**16+R[C+2]*2**8+R[C+3]}function g(R,C,A){R[A+3]=C,C=C>>>8,R[A+2]=C,C=C>>>8,R[A+1]=C,C=C>>>8,R[A]=C}function m(R,C){return R[C+0]<<0>>>0|R[C+1]<<8>>>0|R[C+2]<<16>>>0|R[C+3]<<24>>>0}function v(R,C,A){R[A+0]=C&255,C=C>>>8,R[A+1]=C&255,C=C>>>8,R[A+2]=C&255,C=C>>>8,R[A+3]=C&255}function w(R,C){return R[C]}function $(R,C,A){R[A]=C}function f(R){return j.$je(R,C=>h.concat(C))}function l(R){return j.$qe(R)}function d(R){return j.$le(R,C=>h.concat(C))}async function a(R){return R.ended?h.concat(R.buffer):h.concat([...R.buffer,await d(R.stream)])}function t(R){return j.$oe(R,C=>h.concat(C))}function o(R){return j.$re(R,{data:C=>typeof C=="string"?h.fromString(C):h.wrap(C)},C=>h.concat(C))}function r(R){return j.$ie(C=>h.concat(C),R)}function i(R,C){return j.$se(R,C,A=>h.concat(A))}function s(R,C){return j.$te(R,C,A=>h.concat(A))}function u(R){let C=0,A=0,L=0;const W=new Uint8Array(Math.floor(R.length/4*3)),q=le=>{switch(A){case 3:W[L++]=C|le,A=0;break;case 2:W[L++]=C|le>>>2,C=le<<6,A=3;break;case 1:W[L++]=C|le>>>4,C=le<<4,A=2;break;default:C=le<<2,A=1}};for(let le=0;le<R.length;le++){const te=R.charCodeAt(le);if(te>=65&&te<=90)q(te-65);else if(te>=97&&te<=122)q(te-97+26);else if(te>=48&&te<=57)q(te-48+52);else if(te===43||te===45)q(62);else if(te===47||te===95)q(63);else{if(te===61)break;throw new SyntaxError(`Unexpected base64 character ${R[le]}`)}}const H=L;for(;A>0;)q(0);return h.wrap(W).slice(0,H)}const b="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",I="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function D({buffer:R},C=!0,A=!1){const L=A?I:b;let W="";const q=R.byteLength%3;let H=0;for(;H<R.byteLength-q;H+=3){const le=R[H+0],te=R[H+1],ue=R[H+2];W+=L[le>>>2],W+=L[(le<<4|te>>>4)&63],W+=L[(te<<2|ue>>>6)&63],W+=L[ue&63]}if(q===1){const le=R[H+0];W+=L[le>>>2],W+=L[le<<4&63],C&&(W+="==")}else if(q===2){const le=R[H+0],te=R[H+1];W+=L[le>>>2],W+=L[(le<<4|te>>>4)&63],W+=L[te<<2&63],C&&(W+="=")}return W}}),define(oe[25],ae([0,1,143,62]),function(J,e,n,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tf=e.$Sf=e.$Rf=e.GraphemeBreakType=e.$Hf=e.$Bf=e.$uf=e.$tf=void 0,e.$Ue=P,e.$Ve=S,e.$We=h,e.$Xe=c,e.$Ye=p,e.$Ze=y,e.$1e=k,e.$2e=g,e.$3e=m,e.$4e=v,e.$5e=w,e.$6e=$,e.$7e=f,e.$8e=l,e.$9e=d,e.$0e=a,e.$$e=t,e.$_e=o,e.$af=r,e.$bf=i,e.$cf=s,e.$df=u,e.$ef=b,e.$ff=I,e.$gf=D,e.$hf=R,e.$if=C,e.$jf=A,e.$kf=L,e.$lf=W,e.$mf=q,e.$nf=H,e.$of=le,e.$pf=te,e.$qf=ue,e.$rf=X,e.$sf=Q,e.$vf=G,e.$wf=T,e.$xf=ce,e.$yf=he,e.$zf=N,e.$Af=se,e.$Cf=Z,e.$Df=V,e.$Ef=x,e.$Ff=U,e.$Gf=fe,e.$If=me,e.$Jf=ve,e.$Kf=ke,e.$Lf=je,e.$Mf=We,e.$Nf=ye,e.$Of=Y,e.$Pf=de,e.$Qf=Be;function P(ie){return!ie||typeof ie!="string"?!0:ie.trim().length===0}const B=/{(\d+)}/g;function S(ie,...ge){return ge.length===0?ie:ie.replace(B,function(pe,be){const Pe=parseInt(be,10);return isNaN(Pe)||Pe<0||Pe>=ge.length?pe:ge[Pe]})}const E=/{([^}]+)}/g;function h(ie,ge){return Object.keys(ge).length===0?ie:ie.replace(E,(pe,be)=>ge[be]??pe)}function c(ie){return ie.replace(/[<>"'&]/g,ge=>{switch(ge){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return ge})}function p(ie){return ie.replace(/[<>&]/g,function(ge){switch(ge){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ge}})}function y(ie){return ie.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function k(ie,ge){let pe=0;const be=ge.charCodeAt(0);for(let Pe=ie.length-1;Pe>=0;Pe--)ie.charCodeAt(Pe)===be&&pe++;return pe}function g(ie,ge,pe="\u2026"){return ie.length<=ge?ie:`${ie.substr(0,ge)}${pe}`}function m(ie,ge,pe="\u2026"){if(ie.length<=ge)return ie;const be=Math.ceil(ge/2)-pe.length/2,Pe=Math.floor(ge/2)-pe.length/2;return`${ie.substr(0,be)}${pe}${ie.substr(ie.length-Pe)}`}function v(ie,ge=" "){const pe=w(ie,ge);return $(pe,ge)}function w(ie,ge){if(!ie||!ge)return ie;const pe=ge.length;if(pe===0||ie.length===0)return ie;let be=0;for(;ie.indexOf(ge,be)===be;)be=be+pe;return ie.substring(be)}function $(ie,ge){if(!ie||!ge)return ie;const pe=ge.length,be=ie.length;if(pe===0||be===0)return ie;let Pe=be,Oe=-1;for(;Oe=ie.lastIndexOf(ge,Pe-1),!(Oe===-1||Oe+pe!==Pe);){if(Oe===0)return"";Pe=Oe}return ie.substring(0,Pe)}function f(ie){return ie.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function l(ie){return ie.replace(/\*/g,"")}function d(ie,ge,pe={}){if(!ie)throw new Error("Cannot create regex from empty string");ge||(ie=y(ie)),pe.wholeWord&&(/\B/.test(ie.charAt(0))||(ie="\\b"+ie),/\B/.test(ie.charAt(ie.length-1))||(ie=ie+"\\b"));let be="";return pe.global&&(be+="g"),pe.matchCase||(be+="i"),pe.multiline&&(be+="m"),pe.unicode&&(be+="u"),new RegExp(ie,be)}function a(ie){return ie.source==="^"||ie.source==="^$"||ie.source==="$"||ie.source==="^\\s*$"?!1:!!(ie.exec("")&&ie.lastIndex===0)}function t(ie){return ie.split(/\r\n|\r|\n/)}function o(ie){const ge=[],pe=ie.split(/(\r\n|\r|\n)/);for(let be=0;be<Math.ceil(pe.length/2);be++)ge.push(pe[2*be]+(pe[2*be+1]??""));return ge}function r(ie){for(let ge=0,pe=ie.length;ge<pe;ge++){const be=ie.charCodeAt(ge);if(be!==32&&be!==9)return ge}return-1}function i(ie,ge=0,pe=ie.length){for(let be=ge;be<pe;be++){const Pe=ie.charCodeAt(be);if(Pe!==32&&Pe!==9)return ie.substring(ge,be)}return ie.substring(ge,pe)}function s(ie,ge=ie.length-1){for(let pe=ge;pe>=0;pe--){const be=ie.charCodeAt(pe);if(be!==32&&be!==9)return pe}return-1}function u(ie,ge,pe){const be=[];let Pe=0;for(const Oe of ie.matchAll(ge)){if(be.push(ie.slice(Pe,Oe.index)),Oe.index===void 0)throw new Error("match.index should be defined");Pe=Oe.index+Oe[0].length,be.push(pe(Oe[0],...Oe.slice(1),Oe.index,ie,Oe.groups))}return be.push(ie.slice(Pe)),Promise.all(be).then(Oe=>Oe.join(""))}function b(ie,ge){return ie<ge?-1:ie>ge?1:0}function I(ie,ge,pe=0,be=ie.length,Pe=0,Oe=ge.length){for(;pe<be&&Pe<Oe;pe++,Pe++){const Ye=ie.charCodeAt(pe),Xe=ge.charCodeAt(Pe);if(Ye<Xe)return-1;if(Ye>Xe)return 1}const Te=be-pe,Ke=Oe-Pe;return Te<Ke?-1:Te>Ke?1:0}function D(ie,ge){return R(ie,ge,0,ie.length,0,ge.length)}function R(ie,ge,pe=0,be=ie.length,Pe=0,Oe=ge.length){for(;pe<be&&Pe<Oe;pe++,Pe++){let Ye=ie.charCodeAt(pe),Xe=ge.charCodeAt(Pe);if(Ye===Xe)continue;if(Ye>=128||Xe>=128)return I(ie.toLowerCase(),ge.toLowerCase(),pe,be,Pe,Oe);A(Ye)&&(Ye-=32),A(Xe)&&(Xe-=32);const Qe=Ye-Xe;if(Qe!==0)return Qe}const Te=be-pe,Ke=Oe-Pe;return Te<Ke?-1:Te>Ke?1:0}function C(ie){return ie>=48&&ie<=57}function A(ie){return ie>=97&&ie<=122}function L(ie){return ie>=65&&ie<=90}function W(ie,ge){return ie.length===ge.length&&R(ie,ge)===0}function q(ie,ge){const pe=ge.length;return ge.length>ie.length?!1:R(ie,ge,0,pe)===0}function H(ie,ge){const pe=Math.min(ie.length,ge.length);let be;for(be=0;be<pe;be++)if(ie.charCodeAt(be)!==ge.charCodeAt(be))return be;return pe}function le(ie,ge){const pe=Math.min(ie.length,ge.length);let be;const Pe=ie.length-1,Oe=ge.length-1;for(be=0;be<pe;be++)if(ie.charCodeAt(Pe-be)!==ge.charCodeAt(Oe-be))return be;return pe}function te(ie){return 55296<=ie&&ie<=56319}function ue(ie){return 56320<=ie&&ie<=57343}function X(ie,ge){return(ie-55296<<10)+(ge-56320)+65536}function Q(ie,ge,pe){const be=ie.charCodeAt(pe);if(te(be)&&pe+1<ge){const Pe=ie.charCodeAt(pe+1);if(ue(Pe))return X(be,Pe)}return be}function z(ie,ge){const pe=ie.charCodeAt(ge-1);if(ue(pe)&&ge>1){const be=ie.charCodeAt(ge-2);if(te(be))return X(be,pe)}return pe}class M{get offset(){return this.e}constructor(ge,pe=0){this.c=ge,this.d=ge.length,this.e=pe}setOffset(ge){this.e=ge}prevCodePoint(){const ge=z(this.c,this.e);return this.e-=ge>=65536?2:1,ge}nextCodePoint(){const ge=Q(this.c,this.d,this.e);return this.e+=ge>=65536?2:1,ge}eol(){return this.e>=this.d}}e.$tf=M;class F{get offset(){return this.c.offset}constructor(ge,pe=0){this.c=new M(ge,pe)}nextGraphemeLength(){const ge=Ae.getInstance(),pe=this.c,be=pe.offset;let Pe=ge.getGraphemeBreakType(pe.nextCodePoint());for(;!pe.eol();){const Oe=pe.offset,Te=ge.getGraphemeBreakType(pe.nextCodePoint());if($e(Pe,Te)){pe.setOffset(Oe);break}Pe=Te}return pe.offset-be}prevGraphemeLength(){const ge=Ae.getInstance(),pe=this.c,be=pe.offset;let Pe=ge.getGraphemeBreakType(pe.prevCodePoint());for(;pe.offset>0;){const Oe=pe.offset,Te=ge.getGraphemeBreakType(pe.prevCodePoint());if($e(Te,Pe)){pe.setOffset(Oe);break}Pe=Te}return be-pe.offset}eol(){return this.c.eol()}}e.$uf=F;function G(ie,ge){return new F(ie,ge).nextGraphemeLength()}function T(ie,ge){return new F(ie,ge).prevGraphemeLength()}function ce(ie,ge){ge>0&&ue(ie.charCodeAt(ge))&&ge--;const pe=ge+G(ie,ge);return[pe-T(ie,pe),pe]}function he(ie){const ge=new F(ie);let pe=0;for(;!ge.eol();)pe++,ge.nextGraphemeLength();return pe}let K;function O(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function N(ie){return K||(K=O()),K.test(ie)}const _=/^[\t\n\r\x20-\x7E]*$/;function se(ie){return _.test(ie)}e.$Bf=/[\u2028\u2029]/;function Z(ie){return e.$Bf.test(ie)}function V(ie){return ie>=11904&&ie<=55215||ie>=63744&&ie<=64255||ie>=65281&&ie<=65374}function x(ie){return ie>=127462&&ie<=127487||ie===8986||ie===8987||ie===9200||ie===9203||ie>=9728&&ie<=10175||ie===11088||ie===11093||ie>=127744&&ie<=128591||ie>=128640&&ie<=128764||ie>=128992&&ie<=129008||ie>=129280&&ie<=129535||ie>=129648&&ie<=129782}function U(ie,ge,pe=""){const be=ie.trimStart();if(be.length<ge)return be;const Pe=/\b/g;let Oe=0;for(;Pe.test(be)&&!(be.length-Pe.lastIndex<ge);)Oe=Pe.lastIndex,Pe.lastIndex+=1;return Oe===0?be:pe+be.substring(Oe).trimStart()}const re=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,ee=/\x1b\].*?\x07/g;function fe(ie){return ie&&(ie=ie.replace(re,"").replace(ee,"")),ie}e.$Hf="\uFEFF";function me(ie){return!!(ie&&ie.length>0&&ie.charCodeAt(0)===65279)}function ve(ie){return me(ie)?ie.substr(1):ie}function ke(ie,ge){if(!ie||!ge||ie.length<ge.length)return!1;const pe=ge.length,be=ie.toLowerCase();let Pe=0,Oe=-1;for(;Pe<pe;){const Te=be.indexOf(ge[Pe],Oe+1);if(Te<0)return!1;Oe=Te,Pe++}return!0}function je(ie,ge=!1){return ie?(ge&&(ie=ie.replace(/\\./g,"")),ie.toLowerCase()!==ie):!1}function We(ie){return ie.charAt(0).toUpperCase()+ie.slice(1)}function ye(ie,ge=1){if(ge===0)return"";let pe=-1;do pe=ie.indexOf(`
`,pe+1),ge--;while(ge>0&&pe>=0);return pe===-1?ie:(ie[pe-1]==="\r"&&pe--,ie.substr(0,pe))}function Y(ie){return ie=ie%(2*26),ie<26?String.fromCharCode(97+ie):String.fromCharCode(65+ie-26)}function de(ie){return Ae.getInstance().getGraphemeBreakType(ie)}function $e(ie,ge){return ie===0?ge!==5&&ge!==7:ie===2&&ge===3?!1:ie===4||ie===2||ie===3||ge===4||ge===2||ge===3?!0:!(ie===8&&(ge===8||ge===9||ge===11||ge===12)||(ie===11||ie===9)&&(ge===9||ge===10)||(ie===12||ie===10)&&ge===10||ge===5||ge===13||ge===7||ie===1||ie===13&&ge===14||ie===6&&ge===6)}var Se;(function(ie){ie[ie.Other=0]="Other",ie[ie.Prepend=1]="Prepend",ie[ie.CR=2]="CR",ie[ie.LF=3]="LF",ie[ie.Control=4]="Control",ie[ie.Extend=5]="Extend",ie[ie.Regional_Indicator=6]="Regional_Indicator",ie[ie.SpacingMark=7]="SpacingMark",ie[ie.L=8]="L",ie[ie.V=9]="V",ie[ie.T=10]="T",ie[ie.LV=11]="LV",ie[ie.LVT=12]="LVT",ie[ie.ZWJ=13]="ZWJ",ie[ie.Extended_Pictographic=14]="Extended_Pictographic"})(Se||(e.GraphemeBreakType=Se={}));class Ae{static{this.c=null}static getInstance(){return Ae.c||(Ae.c=new Ae),Ae.c}constructor(){this.d=qe()}getGraphemeBreakType(ge){if(ge<32)return ge===10?3:ge===13?2:4;if(ge<127)return 0;const pe=this.d,be=pe.length/3;let Pe=1;for(;Pe<=be;)if(ge<pe[3*Pe])Pe=2*Pe;else if(ge>pe[3*Pe+1])Pe=2*Pe+1;else return pe[3*Pe+2];return 0}}function qe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Be(ie,ge){if(ie===0)return 0;const pe=Me(ie,ge);if(pe!==void 0)return pe;const be=new M(ge,ie);return be.prevCodePoint(),be.offset}function Me(ie,ge){const pe=new M(ge,ie);let be=pe.prevCodePoint();for(;He(be)||be===65039||be===8419;){if(pe.offset===0)return;be=pe.prevCodePoint()}if(!x(be))return;let Pe=pe.offset;return Pe>0&&pe.prevCodePoint()===8205&&(Pe=pe.offset),Pe}function He(ie){return 127995<=ie&&ie<=127999}var xe;(function(ie){ie[ie.zwj=8205]="zwj",ie[ie.emojiVariantSelector=65039]="emojiVariantSelector",ie[ie.enclosingKeyCap=8419]="enclosingKeyCap"})(xe||(xe={})),e.$Rf="\xA0";class Ze{static{this.c=new j.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new n.$Qe(ge=>{function pe(Qe){const st=new Map;for(let tt=0;tt<Qe.length;tt+=2)st.set(Qe[tt],Qe[tt+1]);return st}function be(Qe,st){const tt=new Map(Qe);for(const[ot,at]of st)tt.set(ot,at);return tt}function Pe(Qe,st){if(!Qe)return st;const tt=new Map;for(const[ot,at]of Qe)st.has(ot)&&tt.set(ot,at);return tt}const Oe=this.c.value;let Te=ge.filter(Qe=>!Qe.startsWith("_")&&Qe in Oe);Te.length===0&&(Te=["_default"]);let Ke;for(const Qe of Te){const st=pe(Oe[Qe]);Ke=Pe(Ke,st)}const Ye=pe(Oe._common),Xe=be(Ye,Ke);return new Ze(Xe)})}static getInstance(ge){return Ze.d.get(Array.from(ge))}static{this.e=new j.$V(()=>Object.keys(Ze.c.value).filter(ge=>!ge.startsWith("_")))}static getLocales(){return Ze.e.value}constructor(ge){this.f=ge}isAmbiguous(ge){return this.f.has(ge)}getPrimaryConfusable(ge){return this.f.get(ge)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$Sf=Ze;class Fe{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Fe.c())),this.d}static isInvisibleCharacter(ge){return Fe.e().has(ge)}static get codePoints(){return Fe.e()}}e.$Tf=Fe}),define(oe[46],ae([0,1,25]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bj=e.$_i=void 0,e.$8i=j,e.$9i=P,e.$0i=B,e.$$i=E,e.$aj=v;function j($){return P($,0)}function P($,f){switch(typeof $){case"object":return $===null?B(349,f):Array.isArray($)?h($,f):c($,f);case"string":return E($,f);case"boolean":return S($,f);case"number":return B($,f);case"undefined":return B(937,f);default:return B(617,f)}}function B($,f){return(f<<5)-f+$|0}function S($,f){return B($?433:863,f)}function E($,f){f=B(149417,f);for(let l=0,d=$.length;l<d;l++)f=B($.charCodeAt(l),f);return f}function h($,f){return f=B(104579,f),$.reduce((l,d)=>P(d,l),f)}function c($,f){return f=B(181387,f),Object.keys($).sort().reduce((l,d)=>(l=E(d,l),P($[d],l)),f)}class p{constructor(){this.g=0}get value(){return this.g}hash(f){return this.g=P(f,this.g),this.g}}e.$_i=p;var y;(function($){$[$.BLOCK_SIZE=64]="BLOCK_SIZE",$[$.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(y||(y={}));function k($,f,l=32){const d=l-f,a=~((1<<d)-1);return($<<f|(a&$)>>>d)>>>0}function g($,f=0,l=$.byteLength,d=0){for(let a=0;a<l;a++)$[f+a]=d}function m($,f,l="0"){for(;$.length<f;)$=l+$;return $}function v($,f=32){return $ instanceof ArrayBuffer?Array.from(new Uint8Array($)).map(l=>l.toString(16).padStart(2,"0")).join(""):m(($>>>0).toString(16),f/4)}class w{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(f){const l=f.length;if(l===0)return;const d=this.p;let a=this.r,t=this.u,o,r;for(t!==0?(o=t,r=-1,t=0):(o=f.charCodeAt(0),r=0);;){let i=o;if(n.$pf(o))if(r+1<l){const s=f.charCodeAt(r+1);n.$qf(s)?(r++,i=n.$rf(o,s)):i=65533}else{t=o;break}else n.$qf(o)&&(i=65533);if(a=this.w(d,a,i),r++,r<l)o=f.charCodeAt(r);else break}this.r=a,this.u=t}w(f,l,d){return d<128?f[l++]=d:d<2048?(f[l++]=192|(d&1984)>>>6,f[l++]=128|(d&63)>>>0):d<65536?(f[l++]=224|(d&61440)>>>12,f[l++]=128|(d&4032)>>>6,f[l++]=128|(d&63)>>>0):(f[l++]=240|(d&1835008)>>>18,f[l++]=128|(d&258048)>>>12,f[l++]=128|(d&4032)>>>6,f[l++]=128|(d&63)>>>0),l>=64&&(this.y(),l-=64,this.t+=64,f[0]=f[64],f[1]=f[65],f[2]=f[66]),l}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),v(this.h)+v(this.l)+v(this.m)+v(this.n)+v(this.o)}x(){this.p[this.r++]=128,g(this.p,this.r),this.r>56&&(this.y(),g(this.p));const f=8*this.t;this.q.setUint32(56,Math.floor(f/4294967296),!1),this.q.setUint32(60,f%4294967296,!1),this.y()}y(){const f=w.g,l=this.q;for(let b=0;b<64;b+=4)f.setUint32(b,l.getUint32(b,!1),!1);for(let b=64;b<320;b+=4)f.setUint32(b,k(f.getUint32(b-12,!1)^f.getUint32(b-32,!1)^f.getUint32(b-56,!1)^f.getUint32(b-64,!1),1),!1);let d=this.h,a=this.l,t=this.m,o=this.n,r=this.o,i,s,u;for(let b=0;b<80;b++)b<20?(i=a&t|~a&o,s=1518500249):b<40?(i=a^t^o,s=1859775393):b<60?(i=a&t|a&o|t&o,s=2400959708):(i=a^t^o,s=3395469782),u=k(d,5)+i+r+s+f.getUint32(b*4,!1)&4294967295,r=o,o=t,t=k(a,30),a=d,d=u;this.h=this.h+d&4294967295,this.l=this.l+a&4294967295,this.m=this.m+t&4294967295,this.n=this.n+o&4294967295,this.o=this.o+r&4294967295}}e.$bj=w}),define(oe[73],ae([0,1,25]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var j;(function(P){P[P.Ignore=0]="Ignore",P[P.Info=1]="Info",P[P.Warning=2]="Warning",P[P.Error=3]="Error"})(j||(j={})),function(P){const B="error",S="warning",E="warn",h="info",c="ignore";function p(k){return k?n.$lf(B,k)?P.Error:n.$lf(S,k)||n.$lf(E,k)?P.Warning:n.$lf(h,k)?P.Info:P.Ignore:P.Ignore}P.fromValue=p;function y(k){switch(k){case P.Error:return B;case P.Warning:return S;case P.Info:return h;default:return c}}P.toString=y}(j||(j={})),e.default=j}),define(oe[144],ae([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4d=void 0,e.$4d=Symbol("MicrotaskDelay")}),define(oe[59],ae([0,1,22,25]),function(J,e,n,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ni=e.$mi=e.$li=e.$ki=e.$ji=void 0;class P{constructor(){this.b="",this.c=0}reset(g){return this.b=g,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(g){const m=g.charCodeAt(0),v=this.b.charCodeAt(this.c);return m-v}value(){return this.b[this.c]}}e.$ji=P;class B{constructor(g=!0){this.e=g}reset(g){return this.b=g,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let g=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(g)this.c++;else break;else g=!1;return this}cmp(g){return this.e?(0,j.$ff)(g,this.b,0,g.length,this.c,this.d):(0,j.$hf)(g,this.b,0,g.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$ki=B;class S{constructor(g=!0,m=!0){this.f=g,this.g=m}reset(g){this.d=0,this.e=0,this.b=g,this.c=g.length;for(let m=g.length-1;m>=0;m--,this.c--){const v=this.b.charCodeAt(m);if(!(v===47||this.f&&v===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let g=!0;for(;this.e<this.c;this.e++){const m=this.b.charCodeAt(this.e);if(m===47||this.f&&m===92)if(g)this.d++;else break;else g=!1}return this}cmp(g){return this.g?(0,j.$ff)(g,this.b,0,g.length,this.d,this.e):(0,j.$hf)(g,this.b,0,g.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$li=S;var E;(function(k){k[k.Scheme=1]="Scheme",k[k.Authority=2]="Authority",k[k.Path=3]="Path",k[k.Query=4]="Query",k[k.Fragment=5]="Fragment"})(E||(E={}));class h{constructor(g,m){this.f=g,this.g=m,this.d=[],this.e=0}reset(g){return this.c=g,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new S(!1,!this.f(g)),this.b.reset(g.path),this.b.value()&&this.d.push(3)),this.g(g)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(g){if(this.d[this.e]===1)return(0,j.$gf)(g,this.c.scheme);if(this.d[this.e]===2)return(0,j.$gf)(g,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(g);if(this.d[this.e]===4)return(0,j.$ef)(g,this.c.query);if(this.d[this.e]===5)return(0,j.$ef)(g,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$mi=h;class c{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const g=this.right;return this.right=g.left,g.left=this,this.updateHeight(),g.updateHeight(),g}rotateRight(){const g=this.left;return this.left=g.right,g.right=this,this.updateHeight(),g.updateHeight(),g}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var p;(function(k){k[k.Left=-1]="Left",k[k.Mid=0]="Mid",k[k.Right=1]="Right"})(p||(p={}));class y{static forUris(g=()=>!1,m=()=>!1){return new y(new h(g,m))}static forPaths(g=!1){return new y(new S(void 0,!g))}static forStrings(){return new y(new P)}static forConfigKeys(){return new y(new B)}constructor(g){this.b=g}clear(){this.c=void 0}fill(g,m){if(m){const v=m.slice(0);(0,n.$Xb)(v);for(const w of v)this.set(w,g)}else{const v=g.slice(0);(0,n.$Xb)(v);for(const w of v)this.set(w[0],w[1])}}set(g,m){const v=this.b.reset(g);let w;this.c||(this.c=new c,this.c.segment=v.value());const $=[];for(w=this.c;;){const l=v.cmp(w.segment);if(l>0)w.left||(w.left=new c,w.left.segment=v.value()),$.push([-1,w]),w=w.left;else if(l<0)w.right||(w.right=new c,w.right.segment=v.value()),$.push([1,w]),w=w.right;else if(v.hasNext())v.next(),w.mid||(w.mid=new c,w.mid.segment=v.value()),$.push([0,w]),w=w.mid;else break}const f=w.value;w.value=m,w.key=g;for(let l=$.length-1;l>=0;l--){const d=$[l][1];d.updateHeight();const a=d.balanceFactor();if(a<-1||a>1){const t=$[l][0],o=$[l+1][0];if(t===1&&o===1)$[l][1]=d.rotateLeft();else if(t===-1&&o===-1)$[l][1]=d.rotateRight();else if(t===1&&o===-1)d.right=$[l+1][1]=$[l+1][1].rotateRight(),$[l][1]=d.rotateLeft();else if(t===-1&&o===1)d.left=$[l+1][1]=$[l+1][1].rotateLeft(),$[l][1]=d.rotateRight();else throw new Error;if(l>0)switch($[l-1][0]){case-1:$[l-1][1].left=$[l][1];break;case 1:$[l-1][1].right=$[l][1];break;case 0:$[l-1][1].mid=$[l][1];break}else this.c=$[0][1]}}return f}get(g){return this.d(g)?.value}d(g){const m=this.b.reset(g);let v=this.c;for(;v;){const w=m.cmp(v.segment);if(w>0)v=v.left;else if(w<0)v=v.right;else if(m.hasNext())m.next(),v=v.mid;else break}return v}has(g){const m=this.d(g);return!(m?.value===void 0&&m?.mid===void 0)}delete(g){return this.e(g,!1)}deleteSuperstr(g){return this.e(g,!0)}e(g,m){const v=this.b.reset(g),w=[];let $=this.c;for(;$;){const f=v.cmp($.segment);if(f>0)w.push([-1,$]),$=$.left;else if(f<0)w.push([1,$]),$=$.right;else if(v.hasNext())v.next(),w.push([0,$]),$=$.mid;else break}if($){if(m?($.left=void 0,$.mid=void 0,$.right=void 0,$.height=1):($.key=void 0,$.value=void 0),!$.mid&&!$.value)if($.left&&$.right){const f=this.f($.right);if(f.key){const{key:l,value:d,segment:a}=f;this.e(f.key,!1),$.key=l,$.value=d,$.segment=a}}else{const f=$.left??$.right;if(w.length>0){const[l,d]=w[w.length-1];switch(l){case-1:d.left=f;break;case 0:d.mid=f;break;case 1:d.right=f;break}}else this.c=f}for(let f=w.length-1;f>=0;f--){const l=w[f][1];l.updateHeight();const d=l.balanceFactor();if(d>1?(l.right.balanceFactor()>=0||(l.right=l.right.rotateRight()),w[f][1]=l.rotateLeft()):d<-1&&(l.left.balanceFactor()<=0||(l.left=l.left.rotateLeft()),w[f][1]=l.rotateRight()),f>0)switch(w[f-1][0]){case-1:w[f-1][1].left=w[f][1];break;case 1:w[f-1][1].right=w[f][1];break;case 0:w[f-1][1].mid=w[f][1];break}else this.c=w[0][1]}}}f(g){for(;g.left;)g=g.left;return g}findSubstr(g){const m=this.b.reset(g);let v=this.c,w;for(;v;){const $=m.cmp(v.segment);if($>0)v=v.left;else if($<0)v=v.right;else if(m.hasNext())m.next(),w=v.value||w,v=v.mid;else break}return v&&v.value||w}findSuperstr(g){return this.g(g,!1)}g(g,m){const v=this.b.reset(g);let w=this.c;for(;w;){const $=v.cmp(w.segment);if($>0)w=w.left;else if($<0)w=w.right;else if(v.hasNext())v.next(),w=w.mid;else return w.mid?this.h(w.mid):m?w.value:void 0}}hasElementOrSubtree(g){return this.g(g,!0)!==void 0}forEach(g){for(const[m,v]of this)g(v,m)}*[Symbol.iterator](){yield*this.h(this.c)}h(g){const m=[];return this.j(g,m),m[Symbol.iterator]()}j(g,m){g&&(g.left&&this.j(g.left,m),g.value&&m.push([g.key,g.value]),g.mid&&this.j(g.mid,m),g.right&&this.j(g.right,m))}_isBalanced(){const g=m=>{if(!m)return!0;const v=m.balanceFactor();return v<-1||v>1?!1:g(m.left)&&g(m.right)};return g(this.c)}}e.$ni=y}),define(oe[12],ae([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uf=n,e.$Vf=j,e.$Wf=P,e.$Xf=B,e.$Yf=S,e.$Zf=E,e.$1f=h,e.$2f=c,e.$3f=p,e.$4f=y,e.$5f=k,e.$6f=g,e.$7f=m,e.$8f=w,e.$9f=$,e.$0f=f,e.$$f=l,e.$_f=d;function n(a){return typeof a=="string"}function j(a){return Array.isArray(a)&&a.every(t=>n(t))}function P(a){return typeof a=="object"&&a!==null&&!Array.isArray(a)&&!(a instanceof RegExp)&&!(a instanceof Date)}function B(a){const t=Object.getPrototypeOf(Uint8Array);return typeof a=="object"&&a instanceof t}function S(a){return typeof a=="number"&&!isNaN(a)}function E(a){return!!a&&typeof a[Symbol.iterator]=="function"}function h(a){return a===!0||a===!1}function c(a){return typeof a>"u"}function p(a){return!y(a)}function y(a){return c(a)||a===null}function k(a,t){if(!a)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}function g(a){if(y(a))throw new Error("Assertion Failed: argument is undefined or null");return a}function m(...a){const t=[];for(let o=0;o<a.length;o++){const r=a[o];if(y(r))throw new Error(`Assertion Failed: argument at index ${o} is undefined or null`);t.push(r)}return t}const v=Object.prototype.hasOwnProperty;function w(a){if(!P(a))return!1;for(const t in a)if(v.call(a,t))return!1;return!0}function $(a){return typeof a=="function"}function f(...a){return a.length>0&&a.every($)}function l(a,t){const o=Math.min(a.length,t.length);for(let r=0;r<o;r++)d(a[r],t[r])}function d(a,t){if(n(t)){if(typeof a!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if($(t)){try{if(a instanceof t)return}catch{}if(!y(a)&&a.constructor===t||t.length===1&&t.call(void 0,a)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(oe[105],ae([0,1,12]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bj=P,e.$Cj=B;const j=Object.create(null);function P(S,E){if((0,n.$Uf)(E)){const h=j[E];if(h===void 0)throw new Error(`${S} references an unknown codicon: ${E}`);E=h}return j[S]=E,{id:S}}function B(){return j}}),define(oe[145],ae([0,1,105]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dj=void 0,e.$Dj={add:(0,n.$Bj)("add",6e4),plus:(0,n.$Bj)("plus",6e4),gistNew:(0,n.$Bj)("gist-new",6e4),repoCreate:(0,n.$Bj)("repo-create",6e4),lightbulb:(0,n.$Bj)("lightbulb",60001),lightBulb:(0,n.$Bj)("light-bulb",60001),repo:(0,n.$Bj)("repo",60002),repoDelete:(0,n.$Bj)("repo-delete",60002),gistFork:(0,n.$Bj)("gist-fork",60003),repoForked:(0,n.$Bj)("repo-forked",60003),gitPullRequest:(0,n.$Bj)("git-pull-request",60004),gitPullRequestAbandoned:(0,n.$Bj)("git-pull-request-abandoned",60004),recordKeys:(0,n.$Bj)("record-keys",60005),keyboard:(0,n.$Bj)("keyboard",60005),tag:(0,n.$Bj)("tag",60006),gitPullRequestLabel:(0,n.$Bj)("git-pull-request-label",60006),tagAdd:(0,n.$Bj)("tag-add",60006),tagRemove:(0,n.$Bj)("tag-remove",60006),person:(0,n.$Bj)("person",60007),personFollow:(0,n.$Bj)("person-follow",60007),personOutline:(0,n.$Bj)("person-outline",60007),personFilled:(0,n.$Bj)("person-filled",60007),gitBranch:(0,n.$Bj)("git-branch",60008),gitBranchCreate:(0,n.$Bj)("git-branch-create",60008),gitBranchDelete:(0,n.$Bj)("git-branch-delete",60008),sourceControl:(0,n.$Bj)("source-control",60008),mirror:(0,n.$Bj)("mirror",60009),mirrorPublic:(0,n.$Bj)("mirror-public",60009),star:(0,n.$Bj)("star",60010),starAdd:(0,n.$Bj)("star-add",60010),starDelete:(0,n.$Bj)("star-delete",60010),starEmpty:(0,n.$Bj)("star-empty",60010),comment:(0,n.$Bj)("comment",60011),commentAdd:(0,n.$Bj)("comment-add",60011),alert:(0,n.$Bj)("alert",60012),warning:(0,n.$Bj)("warning",60012),search:(0,n.$Bj)("search",60013),searchSave:(0,n.$Bj)("search-save",60013),logOut:(0,n.$Bj)("log-out",60014),signOut:(0,n.$Bj)("sign-out",60014),logIn:(0,n.$Bj)("log-in",60015),signIn:(0,n.$Bj)("sign-in",60015),eye:(0,n.$Bj)("eye",60016),eyeUnwatch:(0,n.$Bj)("eye-unwatch",60016),eyeWatch:(0,n.$Bj)("eye-watch",60016),circleFilled:(0,n.$Bj)("circle-filled",60017),primitiveDot:(0,n.$Bj)("primitive-dot",60017),closeDirty:(0,n.$Bj)("close-dirty",60017),debugBreakpoint:(0,n.$Bj)("debug-breakpoint",60017),debugBreakpointDisabled:(0,n.$Bj)("debug-breakpoint-disabled",60017),debugHint:(0,n.$Bj)("debug-hint",60017),terminalDecorationSuccess:(0,n.$Bj)("terminal-decoration-success",60017),primitiveSquare:(0,n.$Bj)("primitive-square",60018),edit:(0,n.$Bj)("edit",60019),pencil:(0,n.$Bj)("pencil",60019),info:(0,n.$Bj)("info",60020),issueOpened:(0,n.$Bj)("issue-opened",60020),gistPrivate:(0,n.$Bj)("gist-private",60021),gitForkPrivate:(0,n.$Bj)("git-fork-private",60021),lock:(0,n.$Bj)("lock",60021),mirrorPrivate:(0,n.$Bj)("mirror-private",60021),close:(0,n.$Bj)("close",60022),removeClose:(0,n.$Bj)("remove-close",60022),x:(0,n.$Bj)("x",60022),repoSync:(0,n.$Bj)("repo-sync",60023),sync:(0,n.$Bj)("sync",60023),clone:(0,n.$Bj)("clone",60024),desktopDownload:(0,n.$Bj)("desktop-download",60024),beaker:(0,n.$Bj)("beaker",60025),microscope:(0,n.$Bj)("microscope",60025),vm:(0,n.$Bj)("vm",60026),deviceDesktop:(0,n.$Bj)("device-desktop",60026),file:(0,n.$Bj)("file",60027),fileText:(0,n.$Bj)("file-text",60027),more:(0,n.$Bj)("more",60028),ellipsis:(0,n.$Bj)("ellipsis",60028),kebabHorizontal:(0,n.$Bj)("kebab-horizontal",60028),mailReply:(0,n.$Bj)("mail-reply",60029),reply:(0,n.$Bj)("reply",60029),organization:(0,n.$Bj)("organization",60030),organizationFilled:(0,n.$Bj)("organization-filled",60030),organizationOutline:(0,n.$Bj)("organization-outline",60030),newFile:(0,n.$Bj)("new-file",60031),fileAdd:(0,n.$Bj)("file-add",60031),newFolder:(0,n.$Bj)("new-folder",60032),fileDirectoryCreate:(0,n.$Bj)("file-directory-create",60032),trash:(0,n.$Bj)("trash",60033),trashcan:(0,n.$Bj)("trashcan",60033),history:(0,n.$Bj)("history",60034),clock:(0,n.$Bj)("clock",60034),folder:(0,n.$Bj)("folder",60035),fileDirectory:(0,n.$Bj)("file-directory",60035),symbolFolder:(0,n.$Bj)("symbol-folder",60035),logoGithub:(0,n.$Bj)("logo-github",60036),markGithub:(0,n.$Bj)("mark-github",60036),github:(0,n.$Bj)("github",60036),terminal:(0,n.$Bj)("terminal",60037),console:(0,n.$Bj)("console",60037),repl:(0,n.$Bj)("repl",60037),zap:(0,n.$Bj)("zap",60038),symbolEvent:(0,n.$Bj)("symbol-event",60038),error:(0,n.$Bj)("error",60039),stop:(0,n.$Bj)("stop",60039),variable:(0,n.$Bj)("variable",60040),symbolVariable:(0,n.$Bj)("symbol-variable",60040),array:(0,n.$Bj)("array",60042),symbolArray:(0,n.$Bj)("symbol-array",60042),symbolModule:(0,n.$Bj)("symbol-module",60043),symbolPackage:(0,n.$Bj)("symbol-package",60043),symbolNamespace:(0,n.$Bj)("symbol-namespace",60043),symbolObject:(0,n.$Bj)("symbol-object",60043),symbolMethod:(0,n.$Bj)("symbol-method",60044),symbolFunction:(0,n.$Bj)("symbol-function",60044),symbolConstructor:(0,n.$Bj)("symbol-constructor",60044),symbolBoolean:(0,n.$Bj)("symbol-boolean",60047),symbolNull:(0,n.$Bj)("symbol-null",60047),symbolNumeric:(0,n.$Bj)("symbol-numeric",60048),symbolNumber:(0,n.$Bj)("symbol-number",60048),symbolStructure:(0,n.$Bj)("symbol-structure",60049),symbolStruct:(0,n.$Bj)("symbol-struct",60049),symbolParameter:(0,n.$Bj)("symbol-parameter",60050),symbolTypeParameter:(0,n.$Bj)("symbol-type-parameter",60050),symbolKey:(0,n.$Bj)("symbol-key",60051),symbolText:(0,n.$Bj)("symbol-text",60051),symbolReference:(0,n.$Bj)("symbol-reference",60052),goToFile:(0,n.$Bj)("go-to-file",60052),symbolEnum:(0,n.$Bj)("symbol-enum",60053),symbolValue:(0,n.$Bj)("symbol-value",60053),symbolRuler:(0,n.$Bj)("symbol-ruler",60054),symbolUnit:(0,n.$Bj)("symbol-unit",60054),activateBreakpoints:(0,n.$Bj)("activate-breakpoints",60055),archive:(0,n.$Bj)("archive",60056),arrowBoth:(0,n.$Bj)("arrow-both",60057),arrowDown:(0,n.$Bj)("arrow-down",60058),arrowLeft:(0,n.$Bj)("arrow-left",60059),arrowRight:(0,n.$Bj)("arrow-right",60060),arrowSmallDown:(0,n.$Bj)("arrow-small-down",60061),arrowSmallLeft:(0,n.$Bj)("arrow-small-left",60062),arrowSmallRight:(0,n.$Bj)("arrow-small-right",60063),arrowSmallUp:(0,n.$Bj)("arrow-small-up",60064),arrowUp:(0,n.$Bj)("arrow-up",60065),bell:(0,n.$Bj)("bell",60066),bold:(0,n.$Bj)("bold",60067),book:(0,n.$Bj)("book",60068),bookmark:(0,n.$Bj)("bookmark",60069),debugBreakpointConditionalUnverified:(0,n.$Bj)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,n.$Bj)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,n.$Bj)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,n.$Bj)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,n.$Bj)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,n.$Bj)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,n.$Bj)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,n.$Bj)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,n.$Bj)("debug-breakpoint-log-disabled",60075),briefcase:(0,n.$Bj)("briefcase",60076),broadcast:(0,n.$Bj)("broadcast",60077),browser:(0,n.$Bj)("browser",60078),bug:(0,n.$Bj)("bug",60079),calendar:(0,n.$Bj)("calendar",60080),caseSensitive:(0,n.$Bj)("case-sensitive",60081),check:(0,n.$Bj)("check",60082),checklist:(0,n.$Bj)("checklist",60083),chevronDown:(0,n.$Bj)("chevron-down",60084),chevronLeft:(0,n.$Bj)("chevron-left",60085),chevronRight:(0,n.$Bj)("chevron-right",60086),chevronUp:(0,n.$Bj)("chevron-up",60087),chromeClose:(0,n.$Bj)("chrome-close",60088),chromeMaximize:(0,n.$Bj)("chrome-maximize",60089),chromeMinimize:(0,n.$Bj)("chrome-minimize",60090),chromeRestore:(0,n.$Bj)("chrome-restore",60091),circleOutline:(0,n.$Bj)("circle-outline",60092),circle:(0,n.$Bj)("circle",60092),debugBreakpointUnverified:(0,n.$Bj)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,n.$Bj)("terminal-decoration-incomplete",60092),circleSlash:(0,n.$Bj)("circle-slash",60093),circuitBoard:(0,n.$Bj)("circuit-board",60094),clearAll:(0,n.$Bj)("clear-all",60095),clippy:(0,n.$Bj)("clippy",60096),closeAll:(0,n.$Bj)("close-all",60097),cloudDownload:(0,n.$Bj)("cloud-download",60098),cloudUpload:(0,n.$Bj)("cloud-upload",60099),code:(0,n.$Bj)("code",60100),collapseAll:(0,n.$Bj)("collapse-all",60101),colorMode:(0,n.$Bj)("color-mode",60102),commentDiscussion:(0,n.$Bj)("comment-discussion",60103),creditCard:(0,n.$Bj)("credit-card",60105),dash:(0,n.$Bj)("dash",60108),dashboard:(0,n.$Bj)("dashboard",60109),database:(0,n.$Bj)("database",60110),debugContinue:(0,n.$Bj)("debug-continue",60111),debugDisconnect:(0,n.$Bj)("debug-disconnect",60112),debugPause:(0,n.$Bj)("debug-pause",60113),debugRestart:(0,n.$Bj)("debug-restart",60114),debugStart:(0,n.$Bj)("debug-start",60115),debugStepInto:(0,n.$Bj)("debug-step-into",60116),debugStepOut:(0,n.$Bj)("debug-step-out",60117),debugStepOver:(0,n.$Bj)("debug-step-over",60118),debugStop:(0,n.$Bj)("debug-stop",60119),debug:(0,n.$Bj)("debug",60120),deviceCameraVideo:(0,n.$Bj)("device-camera-video",60121),deviceCamera:(0,n.$Bj)("device-camera",60122),deviceMobile:(0,n.$Bj)("device-mobile",60123),diffAdded:(0,n.$Bj)("diff-added",60124),diffIgnored:(0,n.$Bj)("diff-ignored",60125),diffModified:(0,n.$Bj)("diff-modified",60126),diffRemoved:(0,n.$Bj)("diff-removed",60127),diffRenamed:(0,n.$Bj)("diff-renamed",60128),diff:(0,n.$Bj)("diff",60129),diffSidebyside:(0,n.$Bj)("diff-sidebyside",60129),discard:(0,n.$Bj)("discard",60130),editorLayout:(0,n.$Bj)("editor-layout",60131),emptyWindow:(0,n.$Bj)("empty-window",60132),exclude:(0,n.$Bj)("exclude",60133),extensions:(0,n.$Bj)("extensions",60134),eyeClosed:(0,n.$Bj)("eye-closed",60135),fileBinary:(0,n.$Bj)("file-binary",60136),fileCode:(0,n.$Bj)("file-code",60137),fileMedia:(0,n.$Bj)("file-media",60138),filePdf:(0,n.$Bj)("file-pdf",60139),fileSubmodule:(0,n.$Bj)("file-submodule",60140),fileSymlinkDirectory:(0,n.$Bj)("file-symlink-directory",60141),fileSymlinkFile:(0,n.$Bj)("file-symlink-file",60142),fileZip:(0,n.$Bj)("file-zip",60143),files:(0,n.$Bj)("files",60144),filter:(0,n.$Bj)("filter",60145),flame:(0,n.$Bj)("flame",60146),foldDown:(0,n.$Bj)("fold-down",60147),foldUp:(0,n.$Bj)("fold-up",60148),fold:(0,n.$Bj)("fold",60149),folderActive:(0,n.$Bj)("folder-active",60150),folderOpened:(0,n.$Bj)("folder-opened",60151),gear:(0,n.$Bj)("gear",60152),gift:(0,n.$Bj)("gift",60153),gistSecret:(0,n.$Bj)("gist-secret",60154),gist:(0,n.$Bj)("gist",60155),gitCommit:(0,n.$Bj)("git-commit",60156),gitCompare:(0,n.$Bj)("git-compare",60157),compareChanges:(0,n.$Bj)("compare-changes",60157),gitMerge:(0,n.$Bj)("git-merge",60158),githubAction:(0,n.$Bj)("github-action",60159),githubAlt:(0,n.$Bj)("github-alt",60160),globe:(0,n.$Bj)("globe",60161),grabber:(0,n.$Bj)("grabber",60162),graph:(0,n.$Bj)("graph",60163),gripper:(0,n.$Bj)("gripper",60164),heart:(0,n.$Bj)("heart",60165),home:(0,n.$Bj)("home",60166),horizontalRule:(0,n.$Bj)("horizontal-rule",60167),hubot:(0,n.$Bj)("hubot",60168),inbox:(0,n.$Bj)("inbox",60169),issueReopened:(0,n.$Bj)("issue-reopened",60171),issues:(0,n.$Bj)("issues",60172),italic:(0,n.$Bj)("italic",60173),jersey:(0,n.$Bj)("jersey",60174),json:(0,n.$Bj)("json",60175),kebabVertical:(0,n.$Bj)("kebab-vertical",60176),key:(0,n.$Bj)("key",60177),law:(0,n.$Bj)("law",60178),lightbulbAutofix:(0,n.$Bj)("lightbulb-autofix",60179),linkExternal:(0,n.$Bj)("link-external",60180),link:(0,n.$Bj)("link",60181),listOrdered:(0,n.$Bj)("list-ordered",60182),listUnordered:(0,n.$Bj)("list-unordered",60183),liveShare:(0,n.$Bj)("live-share",60184),loading:(0,n.$Bj)("loading",60185),location:(0,n.$Bj)("location",60186),mailRead:(0,n.$Bj)("mail-read",60187),mail:(0,n.$Bj)("mail",60188),markdown:(0,n.$Bj)("markdown",60189),megaphone:(0,n.$Bj)("megaphone",60190),mention:(0,n.$Bj)("mention",60191),milestone:(0,n.$Bj)("milestone",60192),gitPullRequestMilestone:(0,n.$Bj)("git-pull-request-milestone",60192),mortarBoard:(0,n.$Bj)("mortar-board",60193),move:(0,n.$Bj)("move",60194),multipleWindows:(0,n.$Bj)("multiple-windows",60195),mute:(0,n.$Bj)("mute",60196),noNewline:(0,n.$Bj)("no-newline",60197),note:(0,n.$Bj)("note",60198),octoface:(0,n.$Bj)("octoface",60199),openPreview:(0,n.$Bj)("open-preview",60200),package:(0,n.$Bj)("package",60201),paintcan:(0,n.$Bj)("paintcan",60202),pin:(0,n.$Bj)("pin",60203),play:(0,n.$Bj)("play",60204),run:(0,n.$Bj)("run",60204),plug:(0,n.$Bj)("plug",60205),preserveCase:(0,n.$Bj)("preserve-case",60206),preview:(0,n.$Bj)("preview",60207),project:(0,n.$Bj)("project",60208),pulse:(0,n.$Bj)("pulse",60209),question:(0,n.$Bj)("question",60210),quote:(0,n.$Bj)("quote",60211),radioTower:(0,n.$Bj)("radio-tower",60212),reactions:(0,n.$Bj)("reactions",60213),references:(0,n.$Bj)("references",60214),refresh:(0,n.$Bj)("refresh",60215),regex:(0,n.$Bj)("regex",60216),remoteExplorer:(0,n.$Bj)("remote-explorer",60217),remote:(0,n.$Bj)("remote",60218),remove:(0,n.$Bj)("remove",60219),replaceAll:(0,n.$Bj)("replace-all",60220),replace:(0,n.$Bj)("replace",60221),repoClone:(0,n.$Bj)("repo-clone",60222),repoForcePush:(0,n.$Bj)("repo-force-push",60223),repoPull:(0,n.$Bj)("repo-pull",60224),repoPush:(0,n.$Bj)("repo-push",60225),report:(0,n.$Bj)("report",60226),requestChanges:(0,n.$Bj)("request-changes",60227),rocket:(0,n.$Bj)("rocket",60228),rootFolderOpened:(0,n.$Bj)("root-folder-opened",60229),rootFolder:(0,n.$Bj)("root-folder",60230),rss:(0,n.$Bj)("rss",60231),ruby:(0,n.$Bj)("ruby",60232),saveAll:(0,n.$Bj)("save-all",60233),saveAs:(0,n.$Bj)("save-as",60234),save:(0,n.$Bj)("save",60235),screenFull:(0,n.$Bj)("screen-full",60236),screenNormal:(0,n.$Bj)("screen-normal",60237),searchStop:(0,n.$Bj)("search-stop",60238),server:(0,n.$Bj)("server",60240),settingsGear:(0,n.$Bj)("settings-gear",60241),settings:(0,n.$Bj)("settings",60242),shield:(0,n.$Bj)("shield",60243),smiley:(0,n.$Bj)("smiley",60244),sortPrecedence:(0,n.$Bj)("sort-precedence",60245),splitHorizontal:(0,n.$Bj)("split-horizontal",60246),splitVertical:(0,n.$Bj)("split-vertical",60247),squirrel:(0,n.$Bj)("squirrel",60248),starFull:(0,n.$Bj)("star-full",60249),starHalf:(0,n.$Bj)("star-half",60250),symbolClass:(0,n.$Bj)("symbol-class",60251),symbolColor:(0,n.$Bj)("symbol-color",60252),symbolConstant:(0,n.$Bj)("symbol-constant",60253),symbolEnumMember:(0,n.$Bj)("symbol-enum-member",60254),symbolField:(0,n.$Bj)("symbol-field",60255),symbolFile:(0,n.$Bj)("symbol-file",60256),symbolInterface:(0,n.$Bj)("symbol-interface",60257),symbolKeyword:(0,n.$Bj)("symbol-keyword",60258),symbolMisc:(0,n.$Bj)("symbol-misc",60259),symbolOperator:(0,n.$Bj)("symbol-operator",60260),symbolProperty:(0,n.$Bj)("symbol-property",60261),wrench:(0,n.$Bj)("wrench",60261),wrenchSubaction:(0,n.$Bj)("wrench-subaction",60261),symbolSnippet:(0,n.$Bj)("symbol-snippet",60262),tasklist:(0,n.$Bj)("tasklist",60263),telescope:(0,n.$Bj)("telescope",60264),textSize:(0,n.$Bj)("text-size",60265),threeBars:(0,n.$Bj)("three-bars",60266),thumbsdown:(0,n.$Bj)("thumbsdown",60267),thumbsup:(0,n.$Bj)("thumbsup",60268),tools:(0,n.$Bj)("tools",60269),triangleDown:(0,n.$Bj)("triangle-down",60270),triangleLeft:(0,n.$Bj)("triangle-left",60271),triangleRight:(0,n.$Bj)("triangle-right",60272),triangleUp:(0,n.$Bj)("triangle-up",60273),twitter:(0,n.$Bj)("twitter",60274),unfold:(0,n.$Bj)("unfold",60275),unlock:(0,n.$Bj)("unlock",60276),unmute:(0,n.$Bj)("unmute",60277),unverified:(0,n.$Bj)("unverified",60278),verified:(0,n.$Bj)("verified",60279),versions:(0,n.$Bj)("versions",60280),vmActive:(0,n.$Bj)("vm-active",60281),vmOutline:(0,n.$Bj)("vm-outline",60282),vmRunning:(0,n.$Bj)("vm-running",60283),watch:(0,n.$Bj)("watch",60284),whitespace:(0,n.$Bj)("whitespace",60285),wholeWord:(0,n.$Bj)("whole-word",60286),window:(0,n.$Bj)("window",60287),wordWrap:(0,n.$Bj)("word-wrap",60288),zoomIn:(0,n.$Bj)("zoom-in",60289),zoomOut:(0,n.$Bj)("zoom-out",60290),listFilter:(0,n.$Bj)("list-filter",60291),listFlat:(0,n.$Bj)("list-flat",60292),listSelection:(0,n.$Bj)("list-selection",60293),selection:(0,n.$Bj)("selection",60293),listTree:(0,n.$Bj)("list-tree",60294),debugBreakpointFunctionUnverified:(0,n.$Bj)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,n.$Bj)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,n.$Bj)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,n.$Bj)("debug-stackframe-active",60297),circleSmallFilled:(0,n.$Bj)("circle-small-filled",60298),debugStackframeDot:(0,n.$Bj)("debug-stackframe-dot",60298),terminalDecorationMark:(0,n.$Bj)("terminal-decoration-mark",60298),debugStackframe:(0,n.$Bj)("debug-stackframe",60299),debugStackframeFocused:(0,n.$Bj)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,n.$Bj)("debug-breakpoint-unsupported",60300),symbolString:(0,n.$Bj)("symbol-string",60301),debugReverseContinue:(0,n.$Bj)("debug-reverse-continue",60302),debugStepBack:(0,n.$Bj)("debug-step-back",60303),debugRestartFrame:(0,n.$Bj)("debug-restart-frame",60304),debugAlt:(0,n.$Bj)("debug-alt",60305),callIncoming:(0,n.$Bj)("call-incoming",60306),callOutgoing:(0,n.$Bj)("call-outgoing",60307),menu:(0,n.$Bj)("menu",60308),expandAll:(0,n.$Bj)("expand-all",60309),feedback:(0,n.$Bj)("feedback",60310),gitPullRequestReviewer:(0,n.$Bj)("git-pull-request-reviewer",60310),groupByRefType:(0,n.$Bj)("group-by-ref-type",60311),ungroupByRefType:(0,n.$Bj)("ungroup-by-ref-type",60312),account:(0,n.$Bj)("account",60313),gitPullRequestAssignee:(0,n.$Bj)("git-pull-request-assignee",60313),bellDot:(0,n.$Bj)("bell-dot",60314),debugConsole:(0,n.$Bj)("debug-console",60315),library:(0,n.$Bj)("library",60316),output:(0,n.$Bj)("output",60317),runAll:(0,n.$Bj)("run-all",60318),syncIgnored:(0,n.$Bj)("sync-ignored",60319),pinned:(0,n.$Bj)("pinned",60320),githubInverted:(0,n.$Bj)("github-inverted",60321),serverProcess:(0,n.$Bj)("server-process",60322),serverEnvironment:(0,n.$Bj)("server-environment",60323),pass:(0,n.$Bj)("pass",60324),issueClosed:(0,n.$Bj)("issue-closed",60324),stopCircle:(0,n.$Bj)("stop-circle",60325),playCircle:(0,n.$Bj)("play-circle",60326),record:(0,n.$Bj)("record",60327),debugAltSmall:(0,n.$Bj)("debug-alt-small",60328),vmConnect:(0,n.$Bj)("vm-connect",60329),cloud:(0,n.$Bj)("cloud",60330),merge:(0,n.$Bj)("merge",60331),export:(0,n.$Bj)("export",60332),graphLeft:(0,n.$Bj)("graph-left",60333),magnet:(0,n.$Bj)("magnet",60334),notebook:(0,n.$Bj)("notebook",60335),redo:(0,n.$Bj)("redo",60336),checkAll:(0,n.$Bj)("check-all",60337),pinnedDirty:(0,n.$Bj)("pinned-dirty",60338),passFilled:(0,n.$Bj)("pass-filled",60339),circleLargeFilled:(0,n.$Bj)("circle-large-filled",60340),circleLarge:(0,n.$Bj)("circle-large",60341),circleLargeOutline:(0,n.$Bj)("circle-large-outline",60341),combine:(0,n.$Bj)("combine",60342),gather:(0,n.$Bj)("gather",60342),table:(0,n.$Bj)("table",60343),variableGroup:(0,n.$Bj)("variable-group",60344),typeHierarchy:(0,n.$Bj)("type-hierarchy",60345),typeHierarchySub:(0,n.$Bj)("type-hierarchy-sub",60346),typeHierarchySuper:(0,n.$Bj)("type-hierarchy-super",60347),gitPullRequestCreate:(0,n.$Bj)("git-pull-request-create",60348),runAbove:(0,n.$Bj)("run-above",60349),runBelow:(0,n.$Bj)("run-below",60350),notebookTemplate:(0,n.$Bj)("notebook-template",60351),debugRerun:(0,n.$Bj)("debug-rerun",60352),workspaceTrusted:(0,n.$Bj)("workspace-trusted",60353),workspaceUntrusted:(0,n.$Bj)("workspace-untrusted",60354),workspaceUnknown:(0,n.$Bj)("workspace-unknown",60355),terminalCmd:(0,n.$Bj)("terminal-cmd",60356),terminalDebian:(0,n.$Bj)("terminal-debian",60357),terminalLinux:(0,n.$Bj)("terminal-linux",60358),terminalPowershell:(0,n.$Bj)("terminal-powershell",60359),terminalTmux:(0,n.$Bj)("terminal-tmux",60360),terminalUbuntu:(0,n.$Bj)("terminal-ubuntu",60361),terminalBash:(0,n.$Bj)("terminal-bash",60362),arrowSwap:(0,n.$Bj)("arrow-swap",60363),copy:(0,n.$Bj)("copy",60364),personAdd:(0,n.$Bj)("person-add",60365),filterFilled:(0,n.$Bj)("filter-filled",60366),wand:(0,n.$Bj)("wand",60367),debugLineByLine:(0,n.$Bj)("debug-line-by-line",60368),inspect:(0,n.$Bj)("inspect",60369),layers:(0,n.$Bj)("layers",60370),layersDot:(0,n.$Bj)("layers-dot",60371),layersActive:(0,n.$Bj)("layers-active",60372),compass:(0,n.$Bj)("compass",60373),compassDot:(0,n.$Bj)("compass-dot",60374),compassActive:(0,n.$Bj)("compass-active",60375),azure:(0,n.$Bj)("azure",60376),issueDraft:(0,n.$Bj)("issue-draft",60377),gitPullRequestClosed:(0,n.$Bj)("git-pull-request-closed",60378),gitPullRequestDraft:(0,n.$Bj)("git-pull-request-draft",60379),debugAll:(0,n.$Bj)("debug-all",60380),debugCoverage:(0,n.$Bj)("debug-coverage",60381),runErrors:(0,n.$Bj)("run-errors",60382),folderLibrary:(0,n.$Bj)("folder-library",60383),debugContinueSmall:(0,n.$Bj)("debug-continue-small",60384),beakerStop:(0,n.$Bj)("beaker-stop",60385),graphLine:(0,n.$Bj)("graph-line",60386),graphScatter:(0,n.$Bj)("graph-scatter",60387),pieChart:(0,n.$Bj)("pie-chart",60388),bracket:(0,n.$Bj)("bracket",60175),bracketDot:(0,n.$Bj)("bracket-dot",60389),bracketError:(0,n.$Bj)("bracket-error",60390),lockSmall:(0,n.$Bj)("lock-small",60391),azureDevops:(0,n.$Bj)("azure-devops",60392),verifiedFilled:(0,n.$Bj)("verified-filled",60393),newline:(0,n.$Bj)("newline",60394),layout:(0,n.$Bj)("layout",60395),layoutActivitybarLeft:(0,n.$Bj)("layout-activitybar-left",60396),layoutActivitybarRight:(0,n.$Bj)("layout-activitybar-right",60397),layoutPanelLeft:(0,n.$Bj)("layout-panel-left",60398),layoutPanelCenter:(0,n.$Bj)("layout-panel-center",60399),layoutPanelJustify:(0,n.$Bj)("layout-panel-justify",60400),layoutPanelRight:(0,n.$Bj)("layout-panel-right",60401),layoutPanel:(0,n.$Bj)("layout-panel",60402),layoutSidebarLeft:(0,n.$Bj)("layout-sidebar-left",60403),layoutSidebarRight:(0,n.$Bj)("layout-sidebar-right",60404),layoutStatusbar:(0,n.$Bj)("layout-statusbar",60405),layoutMenubar:(0,n.$Bj)("layout-menubar",60406),layoutCentered:(0,n.$Bj)("layout-centered",60407),target:(0,n.$Bj)("target",60408),indent:(0,n.$Bj)("indent",60409),recordSmall:(0,n.$Bj)("record-small",60410),errorSmall:(0,n.$Bj)("error-small",60411),terminalDecorationError:(0,n.$Bj)("terminal-decoration-error",60411),arrowCircleDown:(0,n.$Bj)("arrow-circle-down",60412),arrowCircleLeft:(0,n.$Bj)("arrow-circle-left",60413),arrowCircleRight:(0,n.$Bj)("arrow-circle-right",60414),arrowCircleUp:(0,n.$Bj)("arrow-circle-up",60415),layoutSidebarRightOff:(0,n.$Bj)("layout-sidebar-right-off",60416),layoutPanelOff:(0,n.$Bj)("layout-panel-off",60417),layoutSidebarLeftOff:(0,n.$Bj)("layout-sidebar-left-off",60418),blank:(0,n.$Bj)("blank",60419),heartFilled:(0,n.$Bj)("heart-filled",60420),map:(0,n.$Bj)("map",60421),mapFilled:(0,n.$Bj)("map-filled",60422),circleSmall:(0,n.$Bj)("circle-small",60423),bellSlash:(0,n.$Bj)("bell-slash",60424),bellSlashDot:(0,n.$Bj)("bell-slash-dot",60425),commentUnresolved:(0,n.$Bj)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,n.$Bj)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,n.$Bj)("git-pull-request-new-changes",60428),searchFuzzy:(0,n.$Bj)("search-fuzzy",60429),commentDraft:(0,n.$Bj)("comment-draft",60430),send:(0,n.$Bj)("send",60431),sparkle:(0,n.$Bj)("sparkle",60432),insert:(0,n.$Bj)("insert",60433),mic:(0,n.$Bj)("mic",60434),thumbsdownFilled:(0,n.$Bj)("thumbsdown-filled",60435),thumbsupFilled:(0,n.$Bj)("thumbsup-filled",60436),coffee:(0,n.$Bj)("coffee",60437),snake:(0,n.$Bj)("snake",60438),game:(0,n.$Bj)("game",60439),vr:(0,n.$Bj)("vr",60440),chip:(0,n.$Bj)("chip",60441),piano:(0,n.$Bj)("piano",60442),music:(0,n.$Bj)("music",60443),micFilled:(0,n.$Bj)("mic-filled",60444),repoFetch:(0,n.$Bj)("repo-fetch",60445),copilot:(0,n.$Bj)("copilot",60446),lightbulbSparkle:(0,n.$Bj)("lightbulb-sparkle",60447),robot:(0,n.$Bj)("robot",60448),sparkleFilled:(0,n.$Bj)("sparkle-filled",60449),diffSingle:(0,n.$Bj)("diff-single",60450),diffMultiple:(0,n.$Bj)("diff-multiple",60451),surroundWith:(0,n.$Bj)("surround-with",60452),share:(0,n.$Bj)("share",60453),gitStash:(0,n.$Bj)("git-stash",60454),gitStashApply:(0,n.$Bj)("git-stash-apply",60455),gitStashPop:(0,n.$Bj)("git-stash-pop",60456),vscode:(0,n.$Bj)("vscode",60457),vscodeInsiders:(0,n.$Bj)("vscode-insiders",60458),codeOss:(0,n.$Bj)("code-oss",60459),runCoverage:(0,n.$Bj)("run-coverage",60460),runAllCoverage:(0,n.$Bj)("run-all-coverage",60461),coverage:(0,n.$Bj)("coverage",60462),githubProject:(0,n.$Bj)("github-project",60463)}}),define(oe[74],ae([0,1,105,145]),function(J,e,n,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gj=e.$Fj=void 0,e.$Ej=P;function P(){return Object.values(e.$Gj)}e.$Fj={dialogError:(0,n.$Bj)("dialog-error","error"),dialogWarning:(0,n.$Bj)("dialog-warning","warning"),dialogInfo:(0,n.$Bj)("dialog-info","info"),dialogClose:(0,n.$Bj)("dialog-close","close"),treeItemExpanded:(0,n.$Bj)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,n.$Bj)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,n.$Bj)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,n.$Bj)("tree-filter-clear","close"),treeItemLoading:(0,n.$Bj)("tree-item-loading","loading"),menuSelection:(0,n.$Bj)("menu-selection","check"),menuSubmenu:(0,n.$Bj)("menu-submenu","chevron-right"),menuBarMore:(0,n.$Bj)("menubar-more","more"),scrollbarButtonLeft:(0,n.$Bj)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,n.$Bj)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,n.$Bj)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,n.$Bj)("scrollbar-button-down","triangle-down"),toolBarMore:(0,n.$Bj)("toolbar-more","more"),quickInputBack:(0,n.$Bj)("quick-input-back","arrow-left"),dropDownButton:(0,n.$Bj)("drop-down-button",60084),symbolCustomColor:(0,n.$Bj)("symbol-customcolor",60252),exportIcon:(0,n.$Bj)("export",60332),workspaceUnspecified:(0,n.$Bj)("workspace-unspecified",60355),newLine:(0,n.$Bj)("newline",60394),thumbsDownFilled:(0,n.$Bj)("thumbsdown-filled",60435),thumbsUpFilled:(0,n.$Bj)("thumbsup-filled",60436),gitFetch:(0,n.$Bj)("git-fetch",60445),lightbulbSparkleAutofix:(0,n.$Bj)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,n.$Bj)("debug-breakpoint-pending",60377)},e.$Gj={...j.$Dj,...e.$Fj}}),define(oe[35],ae([0,1,12]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nn=j,e.$On=P,e.$Pn=S,e.$Qn=h,e.$Rn=c,e.$Sn=p,e.$Tn=y,e.$Un=k,e.$Vn=g,e.$Wn=m,e.$Xn=v,e.$Yn=w;function j($){if(!$||typeof $!="object"||$ instanceof RegExp)return $;const f=Array.isArray($)?[]:{};return Object.entries($).forEach(([l,d])=>{f[l]=d&&typeof d=="object"?j(d):d}),f}function P($){if(!$||typeof $!="object")return $;const f=[$];for(;f.length>0;){const l=f.shift();Object.freeze(l);for(const d in l)if(B.call(l,d)){const a=l[d];typeof a=="object"&&!Object.isFrozen(a)&&!(0,n.$Xf)(a)&&f.push(a)}}return $}const B=Object.prototype.hasOwnProperty;function S($,f){return E($,f,new Set)}function E($,f,l){if((0,n.$4f)($))return $;const d=f($);if(typeof d<"u")return d;if(Array.isArray($)){const a=[];for(const t of $)a.push(E(t,f,l));return a}if((0,n.$Wf)($)){if(l.has($))throw new Error("Cannot clone recursive data-structure");l.add($);const a={};for(const t in $)B.call($,t)&&(a[t]=E($[t],f,l));return l.delete($),a}return $}function h($,f,l=!0){return(0,n.$Wf)($)?((0,n.$Wf)(f)&&Object.keys(f).forEach(d=>{d in $?l&&((0,n.$Wf)($[d])&&(0,n.$Wf)(f[d])?h($[d],f[d],l):$[d]=f[d]):$[d]=f[d]}),$):f}function c($,f){if($===f)return!0;if($==null||f===null||f===void 0||typeof $!=typeof f||typeof $!="object"||Array.isArray($)!==Array.isArray(f))return!1;let l,d;if(Array.isArray($)){if($.length!==f.length)return!1;for(l=0;l<$.length;l++)if(!c($[l],f[l]))return!1}else{const a=[];for(d in $)a.push(d);a.sort();const t=[];for(d in f)t.push(d);if(t.sort(),!c(a,t))return!1;for(l=0;l<a.length;l++)if(!c($[a[l]],f[a[l]]))return!1}return!0}function p($){const f=new Set;return JSON.stringify($,(l,d)=>{if((0,n.$Wf)(d)||Array.isArray(d)){if(f.has(d))return"[Circular]";f.add(d)}return d})}function y($,f){const l=Object.create(null);return!$||!f||Object.keys(f).forEach(a=>{const t=$[a],o=f[a];c(t,o)||(l[a]=o)}),l}function k($,f){const l=f.toLowerCase(),d=Object.keys($).find(a=>a.toLowerCase()===l);return d?$[d]:$[f]}function g($,f){const l=Object.create(null);for(const[d,a]of Object.entries($))f(d,a)&&(l[d]=a);return l}function m($){let f=[];for(;Object.prototype!==$;)f=f.concat(Object.getOwnPropertyNames($)),$=Object.getPrototypeOf($);return f}function v($){const f=[];for(const l of m($))typeof $[l]=="function"&&f.push(l);return f}function w($,f){const l=a=>function(){const t=Array.prototype.slice.call(arguments,0);return f(a,t)},d={};for(const a of $)d[a]=l(a);return d}}),define(oe[106],ae([0,1,74]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$Hj=P;var j;(function(S){function E(h){return h&&typeof h=="object"&&typeof h.id=="string"}S.isThemeColor=E})(j||(e.ThemeColor=j={}));function P(S){return{id:S}}var B;(function(S){S.iconNameSegment="[A-Za-z0-9]+",S.iconNameExpression="[A-Za-z0-9-]+",S.iconModifierExpression="~[A-Za-z]+",S.iconNameCharacter="[A-Za-z0-9~-]";const E=new RegExp(`^(${S.iconNameExpression})(${S.iconModifierExpression})?$`);function h(f){const l=E.exec(f.id);if(!l)return h(n.$Gj.error);const[,d,a]=l,t=["codicon","codicon-"+d];return a&&t.push("codicon-modifier-"+a.substring(1)),t}S.asClassNameArray=h;function c(f){return h(f).join(" ")}S.asClassName=c;function p(f){return"."+h(f).join(".")}S.asCSSSelector=p;function y(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(typeof f.color>"u"||j.isThemeColor(f.color))}S.isThemeIcon=y;const k=new RegExp(`^\\$\\((${S.iconNameExpression}(?:${S.iconModifierExpression})?)\\)$`);function g(f){const l=k.exec(f);if(!l)return;const[,d]=l;return{id:d}}S.fromString=g;function m(f){return{id:f}}S.fromId=m;function v(f,l){let d=f.id;const a=d.lastIndexOf("~");return a!==-1&&(d=d.substring(0,a)),l&&(d=`${d}~${l}`),{id:d}}S.modify=v;function w(f){const l=f.id.lastIndexOf("~");if(l!==-1)return f.id.substring(l+1)}S.getModifier=w;function $(f,l){return f.id===l.id&&f.color?.id===l.color?.id}S.isEqual=$})(B||(e.ThemeIcon=B={}))}),define(oe[33],ae([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dg=void 0,e.$Cg=j;const n=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function j(P){return n.test(P)}e.$Dg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let P;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?P=crypto.getRandomValues.bind(crypto):P=function(E){for(let h=0;h<E.length;h++)E[h]=Math.floor(Math.random()*256);return E};const B=new Uint8Array(16),S=[];for(let E=0;E<256;E++)S.push(E.toString(16).padStart(2,"0"));return function(){P(B),B[6]=B[6]&15|64,B[8]=B[8]&63|128;let h=0,c="";return c+=S[B[h++]],c+=S[B[h++]],c+=S[B[h++]],c+=S[B[h++]],c+="-",c+=S[B[h++]],c+=S[B[h++]],c+="-",c+=S[B[h++]],c+=S[B[h++]],c+="-",c+=S[B[h++]],c+=S[B[h++]],c+="-",c+=S[B[h++]],c+=S[B[h++]],c+=S[B[h++]],c+=S[B[h++]],c+=S[B[h++]],c+=S[B[h++]],c}}()}),define(oe[146],ae([0,1,87,43,85]),function(J,e,n,j,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WV=B;async function B(S,E){if(await new Promise((p,y)=>{const k=j.createReadStream(S),g=n.createHash("sha256");k.pipe(g);const m=(0,P.$db)((v,w)=>{k.removeAllListeners(),g.removeAllListeners(),v?y(v):p(w)});k.once("error",m),k.once("end",m),g.once("error",m),g.once("data",v=>m(void 0,v.toString("hex")))})!==E)throw new Error("Hash mismatch")}}),define(oe[147],ae([0,1,26]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$on=B;const j=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function P(S){const E=S.replace(/\-/g,":").toLowerCase();return!j.has(E)}function B(){const S=(0,n.networkInterfaces)();for(const E in S){const h=S[E];if(h){for(const{mac:c}of h)if(P(c))return c}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(oe[107],ae([0,1,88]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gg=void 0,e.$Fg=j,e.$Hg=B;function j(E,h,c,p=1){let y=!1;return new Promise(k=>{const g=setTimeout(()=>{if(!y)return y=!0,k(0)},c);P(E,h,p,m=>{if(!y)return y=!0,clearTimeout(g),k(m)})})}function P(E,h,c,p){if(h===0)return p(0);const y=new n.Socket;y.once("connect",()=>(S(y),P(E+c,h-1,c,p))),y.once("data",()=>{}),y.once("error",k=>(S(y),k.code!=="ECONNREFUSED"?P(E+c,h-1,c,p):p(E))),y.connect(E,"127.0.0.1")}e.$Gg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function B(E,h,c,p="127.0.0.1"){let y=!1,k,g=1;const m=n.createServer({pauseOnConnect:!0});function v(w,$){y||(y=!0,m.removeAllListeners(),m.close(),k&&clearTimeout(k),$(w))}return new Promise(w=>{k=setTimeout(()=>{v(0,w)},c),m.on("listening",()=>{v(E,w)}),m.on("error",$=>{$&&($.code==="EADDRINUSE"||$.code==="EACCES")&&g<h?(E++,g++,m.listen(E,p)):v(0,w)}),m.on("close",()=>{v(0,w)}),m.listen(E,p)})}function S(E){try{E.removeAllListeners("connect"),E.removeAllListeners("error"),E.end(),E.destroy(),E.unref()}catch(h){console.error(h)}}}),function(){function J(){function e(){return process.uncHostAllowlist}function n(h){const c=new Set;if(Array.isArray(h))for(const p of h)typeof p=="string"&&c.add(p);return Array.from(c)}function j(){const h=e();return h?Array.from(h):[]}function P(h){if(process.platform!=="win32")return;const c=e();if(c)if(typeof h=="string")c.add(h.toLowerCase());else for(const p of n(h))P(p)}function B(h){if(typeof h!="string")return;const c=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let p;for(const y of c){if(h.indexOf(y)!==0)continue;const g=h.indexOf("\\",y.length);if(g===-1)continue;const m=h.substring(y.length,g);if(m){p=m;break}}return p}function S(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function E(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:j,addUNCHostToAllowlist:P,getUNCHost:B,disableUNCAccessRestrictions:S,isUNCAccessRestrictionsDisabled:E}}typeof define=="function"?define("vs/base/node/unc",[],function(){return J()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=J():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(oe[148],ae([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1V=e.$ZV=void 0,e.$ZV="vscode:contextmenu",e.$1V="vscode:onCloseContextMenu"}),define(oe[149],ae([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8V=void 0;class n{constructor(P,B){this.a=P,this.onMessage=B}send(P){try{this.a.send("vscode:message",P.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}e.$8V=n}),define(oe[150],ae([11,10]),function(J,e){return J.create("vs/base/common/date",e)}),define(oe[151],ae([0,1,150]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mm=c,e.$Nm=p,e.$Om=y;const j=60,P=j*60,B=P*24,S=B*7,E=B*30,h=B*365;function c(k,g,m,v){typeof k!="number"&&(k=k.getTime());const w=Math.round((new Date().getTime()-k)/1e3);if(w<-30)return(0,n.localize)(0,null,c(new Date().getTime()+w*1e3,!1));if(!v&&w<30)return(0,n.localize)(1,null);let $;return w<j?($=w,g?$===1?m?(0,n.localize)(2,null,$):(0,n.localize)(3,null,$):m?(0,n.localize)(4,null,$):(0,n.localize)(5,null,$):$===1?m?(0,n.localize)(6,null,$):(0,n.localize)(7,null,$):m?(0,n.localize)(8,null,$):(0,n.localize)(9,null,$)):w<P?($=Math.floor(w/j),g?$===1?m?(0,n.localize)(10,null,$):(0,n.localize)(11,null,$):m?(0,n.localize)(12,null,$):(0,n.localize)(13,null,$):$===1?m?(0,n.localize)(14,null,$):(0,n.localize)(15,null,$):m?(0,n.localize)(16,null,$):(0,n.localize)(17,null,$)):w<B?($=Math.floor(w/P),g?$===1?m?(0,n.localize)(18,null,$):(0,n.localize)(19,null,$):m?(0,n.localize)(20,null,$):(0,n.localize)(21,null,$):$===1?m?(0,n.localize)(22,null,$):(0,n.localize)(23,null,$):m?(0,n.localize)(24,null,$):(0,n.localize)(25,null,$)):w<S?($=Math.floor(w/B),g?$===1?(0,n.localize)(26,null,$):(0,n.localize)(27,null,$):$===1?(0,n.localize)(28,null,$):(0,n.localize)(29,null,$)):w<E?($=Math.floor(w/S),g?$===1?m?(0,n.localize)(30,null,$):(0,n.localize)(31,null,$):m?(0,n.localize)(32,null,$):(0,n.localize)(33,null,$):$===1?m?(0,n.localize)(34,null,$):(0,n.localize)(35,null,$):m?(0,n.localize)(36,null,$):(0,n.localize)(37,null,$)):w<h?($=Math.floor(w/E),g?$===1?m?(0,n.localize)(38,null,$):(0,n.localize)(39,null,$):m?(0,n.localize)(40,null,$):(0,n.localize)(41,null,$):$===1?m?(0,n.localize)(42,null,$):(0,n.localize)(43,null,$):m?(0,n.localize)(44,null,$):(0,n.localize)(45,null,$)):($=Math.floor(w/h),g?$===1?m?(0,n.localize)(46,null,$):(0,n.localize)(47,null,$):m?(0,n.localize)(48,null,$):(0,n.localize)(49,null,$):$===1?m?(0,n.localize)(50,null,$):(0,n.localize)(51,null,$):m?(0,n.localize)(52,null,$):(0,n.localize)(53,null,$))}function p(k,g){const m=Math.abs(k/1e3);return m<1?g?(0,n.localize)(54,null,k):(0,n.localize)(55,null,k):m<j?g?(0,n.localize)(56,null,Math.round(k)/1e3):(0,n.localize)(57,null,Math.round(k)/1e3):m<P?g?(0,n.localize)(58,null,Math.round(k/(1e3*j))):(0,n.localize)(59,null,Math.round(k/(1e3*j))):m<B?g?(0,n.localize)(60,null,Math.round(k/(1e3*P))):(0,n.localize)(61,null,Math.round(k/(1e3*P))):(0,n.localize)(62,null,Math.round(k/(1e3*B)))}function y(k){return k.getFullYear()+"-"+String(k.getMonth()+1).padStart(2,"0")+"-"+String(k.getDate()).padStart(2,"0")+"T"+String(k.getHours()).padStart(2,"0")+":"+String(k.getMinutes()).padStart(2,"0")+":"+String(k.getSeconds()).padStart(2,"0")+"."+(k.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(oe[152],ae([11,10]),function(J,e){return J.create("vs/base/common/errorMessage",e)}),define(oe[47],ae([0,1,22,12,152]),function(J,e,n,j,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5i=h,e.$6i=c,e.$7i=p;function B(y,k){return k&&(y.stack||y.stacktrace)?P.localize(0,null,E(y),S(y.stack)||S(y.stacktrace)):E(y)}function S(y){return Array.isArray(y)?y.join(`
`):y}function E(y){return y.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${y.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof y.code=="string"&&typeof y.errno=="number"&&typeof y.syscall=="string"?P.localize(1,null,y.message):y.message||P.localize(2,null)}function h(y=null,k=!1){if(!y)return P.localize(3,null);if(Array.isArray(y)){const g=n.$Hb(y),m=h(g[0],k);return g.length>1?P.localize(4,null,m,g.length):m}if(j.$Uf(y))return y;if(y.detail){const g=y.detail;if(g.error)return B(g.error,k);if(g.exception)return B(g.exception,k)}return y.stack?B(y,k):y.message?y.message:P.localize(5,null)}function c(y){const k=y;return k instanceof Error&&Array.isArray(k.actions)}function p(y,k){let g;return typeof y=="string"?g=new Error(y):g=y,g.actions=k,g}}),define(oe[153],ae([11,10]),function(J,e){return J.create("vs/base/common/jsonErrorMessages",e)}),define(oe[154],ae([0,1,153]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cq=j;function j(P){switch(P){case 1:return(0,n.localize)(0,null);case 2:return(0,n.localize)(1,null);case 3:return(0,n.localize)(2,null);case 4:return(0,n.localize)(3,null);case 5:return(0,n.localize)(4,null);case 6:return(0,n.localize)(5,null);case 7:return(0,n.localize)(6,null);case 8:return(0,n.localize)(7,null);case 9:return(0,n.localize)(8,null);default:return""}}}),define(oe[155],ae([11,10]),function(J,e){return J.create("vs/base/common/platform",e)}),define(oe[4],ae([0,1,155]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$g=void 0,e.$h=o,e.$D=I,e.$J=D,e.$g="en";let j=!1,P=!1,B=!1,S=!1,E=!1,h=!1,c=!1,p=!1,y=!1,k=!1,g,m=e.$g,v=e.$g,w,$;const f=globalThis;let l;typeof f.vscode<"u"&&typeof f.vscode.process<"u"?l=f.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(l=process);const d=typeof l?.versions?.electron=="string",a=d&&l?.type==="renderer";if(typeof l=="object"){j=l.platform==="win32",P=l.platform==="darwin",B=l.platform==="linux",S=B&&!!l.env.SNAP&&!!l.env.SNAP_REVISION,c=d,y=!!l.env.CI||!!l.env.BUILD_ARTIFACTSTAGINGDIRECTORY,g=e.$g,m=e.$g;const R=l.env.VSCODE_NLS_CONFIG;if(R)try{const C=JSON.parse(R),A=C.availableLanguages["*"];g=C.locale,v=C.osLocale,m=A||e.$g,w=C._translationsConfigFile}catch{}E=!0}else typeof navigator=="object"&&!a?($=navigator.userAgent,j=$.indexOf("Windows")>=0,P=$.indexOf("Macintosh")>=0,p=($.indexOf("Macintosh")>=0||$.indexOf("iPad")>=0||$.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,B=$.indexOf("Linux")>=0,k=$?.indexOf("Mobi")>=0,h=!0,g=n.getConfiguredDefaultLocale(n.localize(0,null))||e.$g,m=g,v=navigator.language):console.error("Unable to resolve platform.");var t;(function(R){R[R.Web=0]="Web",R[R.Mac=1]="Mac",R[R.Linux=2]="Linux",R[R.Windows=3]="Windows"})(t||(e.Platform=t={}));function o(R){switch(R){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}let r=0;P?r=1:j?r=3:B&&(r=2),e.$i=j,e.$j=P,e.$k=B,e.$l=S,e.$m=E,e.$n=c,e.$o=h,e.$p=h&&typeof f.importScripts=="function",e.$q=e.$p?f.origin:void 0,e.$r=p,e.$s=k,e.$t=y,e.$u=r,e.$v=$,e.$w=m;var i;(function(R){function C(){return e.$w}R.value=C;function A(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}R.isDefaultVariant=A;function L(){return e.$w==="en"}R.isDefault=L})(i||(e.Language=i={})),e.$x=g,e.$y=v,e.$z=w,e.$A=typeof f.postMessage=="function"&&!f.importScripts,e.$B=(()=>{if(e.$A){const R=[];f.addEventListener("message",A=>{if(A.data&&A.data.vscodeScheduleAsyncWork)for(let L=0,W=R.length;L<W;L++){const q=R[L];if(q.id===A.data.vscodeScheduleAsyncWork){R.splice(L,1),q.callback();return}}});let C=0;return A=>{const L=++C;R.push({id:L,callback:A}),f.postMessage({vscodeScheduleAsyncWork:L},"*")}}return R=>setTimeout(R)})();var s;(function(R){R[R.Windows=1]="Windows",R[R.Macintosh=2]="Macintosh",R[R.Linux=3]="Linux"})(s||(e.OperatingSystem=s={})),e.OS=P||p?2:j?1:3;let u=!0,b=!1;function I(){if(!b){b=!0;const R=new Uint8Array(2);R[0]=1,R[1]=2,u=new Uint16Array(R.buffer)[0]===513}return u}e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function D(R){return parseFloat(R)>=20}}),define(oe[36],ae([0,1,4]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fc=e.$ec=e.env=e.cwd=void 0;let j;const P=globalThis.vscode;if(typeof P<"u"&&typeof P.process<"u"){const B=P.process;j={get platform(){return B.platform},get arch(){return B.arch},get env(){return B.env},cwd(){return B.cwd()}}}else typeof process<"u"?j={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:j={get platform(){return n.$i?"win32":n.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=j.cwd,e.env=j.env,e.$ec=j.platform,e.$fc=j.arch}),define(oe[9],ae([0,1,36]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uc=e.sep=e.$sc=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=void 0;const j=65,P=97,B=90,S=122,E=46,h=47,c=92,p=58,y=63;class k extends Error{constructor(o,r,i){let s;typeof r=="string"&&r.indexOf("not ")===0?(s="must not be",r=r.replace(/^not /,"")):s="must be";const u=o.indexOf(".")!==-1?"property":"argument";let b=`The "${o}" ${u} ${s} of type ${r}`;b+=`. Received type ${typeof i}`,super(b),this.code="ERR_INVALID_ARG_TYPE"}}function g(t,o){if(t===null||typeof t!="object")throw new k(o,"Object",t)}function m(t,o){if(typeof t!="string")throw new k(o,"string",t)}const v=n.$ec==="win32";function w(t){return t===h||t===c}function $(t){return t===h}function f(t){return t>=j&&t<=B||t>=P&&t<=S}function l(t,o,r,i){let s="",u=0,b=-1,I=0,D=0;for(let R=0;R<=t.length;++R){if(R<t.length)D=t.charCodeAt(R);else{if(i(D))break;D=h}if(i(D)){if(!(b===R-1||I===1))if(I===2){if(s.length<2||u!==2||s.charCodeAt(s.length-1)!==E||s.charCodeAt(s.length-2)!==E){if(s.length>2){const C=s.lastIndexOf(r);C===-1?(s="",u=0):(s=s.slice(0,C),u=s.length-1-s.lastIndexOf(r)),b=R,I=0;continue}else if(s.length!==0){s="",u=0,b=R,I=0;continue}}o&&(s+=s.length>0?`${r}..`:"..",u=2)}else s.length>0?s+=`${r}${t.slice(b+1,R)}`:s=t.slice(b+1,R),u=R-b-1;b=R,I=0}else D===E&&I!==-1?++I:I=-1}return s}function d(t,o){g(o,"pathObject");const r=o.dir||o.root,i=o.base||`${o.name||""}${o.ext||""}`;return r?r===o.root?`${r}${i}`:`${r}${t}${i}`:i}e.$gc={resolve(...t){let o="",r="",i=!1;for(let s=t.length-1;s>=-1;s--){let u;if(s>=0){if(u=t[s],m(u,"path"),u.length===0)continue}else o.length===0?u=n.cwd():(u=n.env[`=${o}`]||n.cwd(),(u===void 0||u.slice(0,2).toLowerCase()!==o.toLowerCase()&&u.charCodeAt(2)===c)&&(u=`${o}\\`));const b=u.length;let I=0,D="",R=!1;const C=u.charCodeAt(0);if(b===1)w(C)&&(I=1,R=!0);else if(w(C))if(R=!0,w(u.charCodeAt(1))){let A=2,L=A;for(;A<b&&!w(u.charCodeAt(A));)A++;if(A<b&&A!==L){const W=u.slice(L,A);for(L=A;A<b&&w(u.charCodeAt(A));)A++;if(A<b&&A!==L){for(L=A;A<b&&!w(u.charCodeAt(A));)A++;(A===b||A!==L)&&(D=`\\\\${W}\\${u.slice(L,A)}`,I=A)}}}else I=1;else f(C)&&u.charCodeAt(1)===p&&(D=u.slice(0,2),I=2,b>2&&w(u.charCodeAt(2))&&(R=!0,I=3));if(D.length>0)if(o.length>0){if(D.toLowerCase()!==o.toLowerCase())continue}else o=D;if(i){if(o.length>0)break}else if(r=`${u.slice(I)}\\${r}`,i=R,R&&o.length>0)break}return r=l(r,!i,"\\",w),i?`${o}\\${r}`:`${o}${r}`||"."},normalize(t){m(t,"path");const o=t.length;if(o===0)return".";let r=0,i,s=!1;const u=t.charCodeAt(0);if(o===1)return $(u)?"\\":t;if(w(u))if(s=!0,w(t.charCodeAt(1))){let I=2,D=I;for(;I<o&&!w(t.charCodeAt(I));)I++;if(I<o&&I!==D){const R=t.slice(D,I);for(D=I;I<o&&w(t.charCodeAt(I));)I++;if(I<o&&I!==D){for(D=I;I<o&&!w(t.charCodeAt(I));)I++;if(I===o)return`\\\\${R}\\${t.slice(D)}\\`;I!==D&&(i=`\\\\${R}\\${t.slice(D,I)}`,r=I)}}}else r=1;else f(u)&&t.charCodeAt(1)===p&&(i=t.slice(0,2),r=2,o>2&&w(t.charCodeAt(2))&&(s=!0,r=3));let b=r<o?l(t.slice(r),!s,"\\",w):"";return b.length===0&&!s&&(b="."),b.length>0&&w(t.charCodeAt(o-1))&&(b+="\\"),i===void 0?s?`\\${b}`:b:s?`${i}\\${b}`:`${i}${b}`},isAbsolute(t){m(t,"path");const o=t.length;if(o===0)return!1;const r=t.charCodeAt(0);return w(r)||o>2&&f(r)&&t.charCodeAt(1)===p&&w(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let o,r;for(let u=0;u<t.length;++u){const b=t[u];m(b,"path"),b.length>0&&(o===void 0?o=r=b:o+=`\\${b}`)}if(o===void 0)return".";let i=!0,s=0;if(typeof r=="string"&&w(r.charCodeAt(0))){++s;const u=r.length;u>1&&w(r.charCodeAt(1))&&(++s,u>2&&(w(r.charCodeAt(2))?++s:i=!1))}if(i){for(;s<o.length&&w(o.charCodeAt(s));)s++;s>=2&&(o=`\\${o.slice(s)}`)}return e.$gc.normalize(o)},relative(t,o){if(m(t,"from"),m(o,"to"),t===o)return"";const r=e.$gc.resolve(t),i=e.$gc.resolve(o);if(r===i||(t=r.toLowerCase(),o=i.toLowerCase(),t===o))return"";let s=0;for(;s<t.length&&t.charCodeAt(s)===c;)s++;let u=t.length;for(;u-1>s&&t.charCodeAt(u-1)===c;)u--;const b=u-s;let I=0;for(;I<o.length&&o.charCodeAt(I)===c;)I++;let D=o.length;for(;D-1>I&&o.charCodeAt(D-1)===c;)D--;const R=D-I,C=b<R?b:R;let A=-1,L=0;for(;L<C;L++){const q=t.charCodeAt(s+L);if(q!==o.charCodeAt(I+L))break;q===c&&(A=L)}if(L!==C){if(A===-1)return i}else{if(R>C){if(o.charCodeAt(I+L)===c)return i.slice(I+L+1);if(L===2)return i.slice(I+L)}b>C&&(t.charCodeAt(s+L)===c?A=L:L===2&&(A=3)),A===-1&&(A=0)}let W="";for(L=s+A+1;L<=u;++L)(L===u||t.charCodeAt(L)===c)&&(W+=W.length===0?"..":"\\..");return I+=A,W.length>0?`${W}${i.slice(I,D)}`:(i.charCodeAt(I)===c&&++I,i.slice(I,D))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const o=e.$gc.resolve(t);if(o.length<=2)return t;if(o.charCodeAt(0)===c){if(o.charCodeAt(1)===c){const r=o.charCodeAt(2);if(r!==y&&r!==E)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(f(o.charCodeAt(0))&&o.charCodeAt(1)===p&&o.charCodeAt(2)===c)return`\\\\?\\${o}`;return t},dirname(t){m(t,"path");const o=t.length;if(o===0)return".";let r=-1,i=0;const s=t.charCodeAt(0);if(o===1)return w(s)?t:".";if(w(s)){if(r=i=1,w(t.charCodeAt(1))){let I=2,D=I;for(;I<o&&!w(t.charCodeAt(I));)I++;if(I<o&&I!==D){for(D=I;I<o&&w(t.charCodeAt(I));)I++;if(I<o&&I!==D){for(D=I;I<o&&!w(t.charCodeAt(I));)I++;if(I===o)return t;I!==D&&(r=i=I+1)}}}}else f(s)&&t.charCodeAt(1)===p&&(r=o>2&&w(t.charCodeAt(2))?3:2,i=r);let u=-1,b=!0;for(let I=o-1;I>=i;--I)if(w(t.charCodeAt(I))){if(!b){u=I;break}}else b=!1;if(u===-1){if(r===-1)return".";u=r}return t.slice(0,u)},basename(t,o){o!==void 0&&m(o,"ext"),m(t,"path");let r=0,i=-1,s=!0,u;if(t.length>=2&&f(t.charCodeAt(0))&&t.charCodeAt(1)===p&&(r=2),o!==void 0&&o.length>0&&o.length<=t.length){if(o===t)return"";let b=o.length-1,I=-1;for(u=t.length-1;u>=r;--u){const D=t.charCodeAt(u);if(w(D)){if(!s){r=u+1;break}}else I===-1&&(s=!1,I=u+1),b>=0&&(D===o.charCodeAt(b)?--b===-1&&(i=u):(b=-1,i=I))}return r===i?i=I:i===-1&&(i=t.length),t.slice(r,i)}for(u=t.length-1;u>=r;--u)if(w(t.charCodeAt(u))){if(!s){r=u+1;break}}else i===-1&&(s=!1,i=u+1);return i===-1?"":t.slice(r,i)},extname(t){m(t,"path");let o=0,r=-1,i=0,s=-1,u=!0,b=0;t.length>=2&&t.charCodeAt(1)===p&&f(t.charCodeAt(0))&&(o=i=2);for(let I=t.length-1;I>=o;--I){const D=t.charCodeAt(I);if(w(D)){if(!u){i=I+1;break}continue}s===-1&&(u=!1,s=I+1),D===E?r===-1?r=I:b!==1&&(b=1):r!==-1&&(b=-1)}return r===-1||s===-1||b===0||b===1&&r===s-1&&r===i+1?"":t.slice(r,s)},format:d.bind(null,"\\"),parse(t){m(t,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return o;const r=t.length;let i=0,s=t.charCodeAt(0);if(r===1)return w(s)?(o.root=o.dir=t,o):(o.base=o.name=t,o);if(w(s)){if(i=1,w(t.charCodeAt(1))){let A=2,L=A;for(;A<r&&!w(t.charCodeAt(A));)A++;if(A<r&&A!==L){for(L=A;A<r&&w(t.charCodeAt(A));)A++;if(A<r&&A!==L){for(L=A;A<r&&!w(t.charCodeAt(A));)A++;A===r?i=A:A!==L&&(i=A+1)}}}}else if(f(s)&&t.charCodeAt(1)===p){if(r<=2)return o.root=o.dir=t,o;if(i=2,w(t.charCodeAt(2))){if(r===3)return o.root=o.dir=t,o;i=3}}i>0&&(o.root=t.slice(0,i));let u=-1,b=i,I=-1,D=!0,R=t.length-1,C=0;for(;R>=i;--R){if(s=t.charCodeAt(R),w(s)){if(!D){b=R+1;break}continue}I===-1&&(D=!1,I=R+1),s===E?u===-1?u=R:C!==1&&(C=1):u!==-1&&(C=-1)}return I!==-1&&(u===-1||C===0||C===1&&u===I-1&&u===b+1?o.base=o.name=t.slice(b,I):(o.name=t.slice(b,u),o.base=t.slice(b,I),o.ext=t.slice(u,I))),b>0&&b!==i?o.dir=t.slice(0,b-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const a=(()=>{if(v){const t=/\\/g;return()=>{const o=n.cwd().replace(t,"/");return o.slice(o.indexOf("/"))}}return()=>n.cwd()})();e.$hc={resolve(...t){let o="",r=!1;for(let i=t.length-1;i>=-1&&!r;i--){const s=i>=0?t[i]:a();m(s,"path"),s.length!==0&&(o=`${s}/${o}`,r=s.charCodeAt(0)===h)}return o=l(o,!r,"/",$),r?`/${o}`:o.length>0?o:"."},normalize(t){if(m(t,"path"),t.length===0)return".";const o=t.charCodeAt(0)===h,r=t.charCodeAt(t.length-1)===h;return t=l(t,!o,"/",$),t.length===0?o?"/":r?"./":".":(r&&(t+="/"),o?`/${t}`:t)},isAbsolute(t){return m(t,"path"),t.length>0&&t.charCodeAt(0)===h},join(...t){if(t.length===0)return".";let o;for(let r=0;r<t.length;++r){const i=t[r];m(i,"path"),i.length>0&&(o===void 0?o=i:o+=`/${i}`)}return o===void 0?".":e.$hc.normalize(o)},relative(t,o){if(m(t,"from"),m(o,"to"),t===o||(t=e.$hc.resolve(t),o=e.$hc.resolve(o),t===o))return"";const r=1,i=t.length,s=i-r,u=1,b=o.length-u,I=s<b?s:b;let D=-1,R=0;for(;R<I;R++){const A=t.charCodeAt(r+R);if(A!==o.charCodeAt(u+R))break;A===h&&(D=R)}if(R===I)if(b>I){if(o.charCodeAt(u+R)===h)return o.slice(u+R+1);if(R===0)return o.slice(u+R)}else s>I&&(t.charCodeAt(r+R)===h?D=R:R===0&&(D=0));let C="";for(R=r+D+1;R<=i;++R)(R===i||t.charCodeAt(R)===h)&&(C+=C.length===0?"..":"/..");return`${C}${o.slice(u+D)}`},toNamespacedPath(t){return t},dirname(t){if(m(t,"path"),t.length===0)return".";const o=t.charCodeAt(0)===h;let r=-1,i=!0;for(let s=t.length-1;s>=1;--s)if(t.charCodeAt(s)===h){if(!i){r=s;break}}else i=!1;return r===-1?o?"/":".":o&&r===1?"//":t.slice(0,r)},basename(t,o){o!==void 0&&m(o,"ext"),m(t,"path");let r=0,i=-1,s=!0,u;if(o!==void 0&&o.length>0&&o.length<=t.length){if(o===t)return"";let b=o.length-1,I=-1;for(u=t.length-1;u>=0;--u){const D=t.charCodeAt(u);if(D===h){if(!s){r=u+1;break}}else I===-1&&(s=!1,I=u+1),b>=0&&(D===o.charCodeAt(b)?--b===-1&&(i=u):(b=-1,i=I))}return r===i?i=I:i===-1&&(i=t.length),t.slice(r,i)}for(u=t.length-1;u>=0;--u)if(t.charCodeAt(u)===h){if(!s){r=u+1;break}}else i===-1&&(s=!1,i=u+1);return i===-1?"":t.slice(r,i)},extname(t){m(t,"path");let o=-1,r=0,i=-1,s=!0,u=0;for(let b=t.length-1;b>=0;--b){const I=t.charCodeAt(b);if(I===h){if(!s){r=b+1;break}continue}i===-1&&(s=!1,i=b+1),I===E?o===-1?o=b:u!==1&&(u=1):o!==-1&&(u=-1)}return o===-1||i===-1||u===0||u===1&&o===i-1&&o===r+1?"":t.slice(o,i)},format:d.bind(null,"/"),parse(t){m(t,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return o;const r=t.charCodeAt(0)===h;let i;r?(o.root="/",i=1):i=0;let s=-1,u=0,b=-1,I=!0,D=t.length-1,R=0;for(;D>=i;--D){const C=t.charCodeAt(D);if(C===h){if(!I){u=D+1;break}continue}b===-1&&(I=!1,b=D+1),C===E?s===-1?s=D:R!==1&&(R=1):s!==-1&&(R=-1)}if(b!==-1){const C=u===0&&r?1:u;s===-1||R===0||R===1&&s===b-1&&s===u+1?o.base=o.name=t.slice(C,b):(o.name=t.slice(C,s),o.base=t.slice(C,b),o.ext=t.slice(s,b))}return u>0?o.dir=t.slice(0,u-1):r&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.$hc.win32=e.$gc.win32=e.$gc,e.$hc.posix=e.$gc.posix=e.$hc,e.$ic=v?e.$gc.normalize:e.$hc.normalize,e.$jc=v?e.$gc.isAbsolute:e.$hc.isAbsolute,e.$kc=v?e.$gc.join:e.$hc.join,e.$lc=v?e.$gc.resolve:e.$hc.resolve,e.$mc=v?e.$gc.relative:e.$hc.relative,e.$nc=v?e.$gc.dirname:e.$hc.dirname,e.$oc=v?e.$gc.basename:e.$hc.basename,e.$pc=v?e.$gc.extname:e.$hc.extname,e.$qc=v?e.$gc.format:e.$hc.format,e.$rc=v?e.$gc.parse:e.$hc.parse,e.$sc=v?e.$gc.toNamespacedPath:e.$hc.toNamespacedPath,e.sep=v?e.$gc.sep:e.$hc.sep,e.$uc=v?e.$gc.delimiter:e.$hc.delimiter}),define(oe[31],ae([0,1,9,4,25,12]),function(J,e,n,j,P,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ag=S,e.$bg=E,e.$cg=h,e.$dg=c,e.$eg=p,e.$fg=m,e.$gg=v,e.$hg=w,e.$ig=$,e.$jg=f,e.$kg=l,e.$lg=d,e.$mg=a,e.$ng=t,e.$og=o,e.$pg=s;function S(u){return u===47||u===92}function E(u){return u.replace(/[\\/]/g,n.$hc.sep)}function h(u){return u.indexOf("/")===-1&&(u=E(u)),/^[a-zA-Z]:(\/|$)/.test(u)&&(u="/"+u),u}function c(u,b=n.$hc.sep){if(!u)return"";const I=u.length,D=u.charCodeAt(0);if(S(D)){if(S(u.charCodeAt(1))&&!S(u.charCodeAt(2))){let C=3;const A=C;for(;C<I&&!S(u.charCodeAt(C));C++);if(A!==C&&!S(u.charCodeAt(C+1))){for(C+=1;C<I;C++)if(S(u.charCodeAt(C)))return u.slice(0,C+1).replace(/[\\/]/g,b)}}return b}else if($(D)&&u.charCodeAt(1)===58)return S(u.charCodeAt(2))?u.slice(0,2)+b:u.slice(0,2);let R=u.indexOf("://");if(R!==-1){for(R+=3;R<I;R++)if(S(u.charCodeAt(R)))return u.slice(0,R+1)}return""}function p(u){if(!j.$i||!u||u.length<5)return!1;let b=u.charCodeAt(0);if(b!==92||(b=u.charCodeAt(1),b!==92))return!1;let I=2;const D=I;for(;I<u.length&&(b=u.charCodeAt(I),b!==92);I++);return!(D===I||(b=u.charCodeAt(I+1),isNaN(b)||b===92))}const y=/[\\/:\*\?"<>\|]/g,k=/[\\/]/g,g=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function m(u,b=j.$i){const I=b?y:k;return!(!u||u.length===0||/^\s+$/.test(u)||(I.lastIndex=0,I.test(u))||b&&g.test(u)||u==="."||u===".."||b&&u[u.length-1]==="."||b&&u.length!==u.trim().length||u.length>255)}function v(u,b,I){const D=u===b;return!I||D?D:!u||!b?!1:(0,P.$lf)(u,b)}function w(u,b,I,D=n.sep){if(u===b)return!0;if(!u||!b||b.length>u.length)return!1;if(I){if(!(0,P.$mf)(u,b))return!1;if(b.length===u.length)return!0;let C=b.length;return b.charAt(b.length-1)===D&&C--,u.charAt(C)===D}return b.charAt(b.length-1)!==D&&(b+=D),u.indexOf(b)===0}function $(u){return u>=65&&u<=90||u>=97&&u<=122}function f(u,b){return j.$i&&u.endsWith(":")&&(u+=n.sep),(0,n.$jc)(u)||(u=(0,n.$kc)(b,u)),u=(0,n.$ic)(u),j.$i?(u=(0,P.$6e)(u,n.sep),u.endsWith(":")&&(u+=n.sep)):(u=(0,P.$6e)(u,n.sep),u||(u=n.sep)),u}function l(u){const b=(0,n.$ic)(u);return j.$i?u.length>3?!1:d(b)&&(u.length===2||b.charCodeAt(2)===92):b===n.$hc.sep}function d(u,b=j.$i){return b?$(u.charCodeAt(0))&&u.charCodeAt(1)===58:!1}function a(u,b=j.$i){return d(u,b)?u[0]:void 0}function t(u,b,I){return b.length>u.length?-1:u===b?0:(I&&(u=u.toLowerCase(),b=b.toLowerCase()),u.indexOf(b))}function o(u){const b=u.split(":");let I,D,R;for(const C of b){const A=Number(C);(0,B.$Yf)(A)?D===void 0?D=A:R===void 0&&(R=A):I=I?[I,C].join(":"):C}if(!I)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:I,line:D!==void 0?D:void 0,column:R!==void 0?R:D!==void 0?1:void 0}}const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",i="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function s(u,b,I=8){let D="";for(let C=0;C<I;C++){let A;C===0&&j.$i&&!b&&(I===3||I===4)?A=i:A=r,D+=A.charAt(Math.floor(Math.random()*A.length))}let R;return b?R=`${b}-${D}`:R=D,u?(0,n.$kc)(u,R):R}}),define(oe[75],ae([0,1,4]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$0l=B,e.$$l=S;var j;(function(E){E[E.stdout=0]="stdout",E[E.stderr=1]="stderr"})(j||(e.Source=j={}));var P;(function(E){E[E.Success=0]="Success",E[E.Unknown=1]="Unknown",E[E.AccessDenied=2]="AccessDenied",E[E.ProcessNotFound=3]="ProcessNotFound"})(P||(e.TerminateResponseCode=P={}));function B(E,...h){const c=h.reduce((k,g)=>(k[g]=!0,k),{}),p=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(E).filter(k=>!c[k]).forEach(k=>{for(let g=0;g<p.length;g++)if(k.search(p[g])!==-1){delete E[k];break}})}function S(E){E&&(delete E.DEBUG,n.$j&&delete E.DYLD_LIBRARY_PATH,n.$k&&delete E.LD_PRELOAD)}}),define(oe[7],ae([0,1,9,4]),function(J,e,n,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$wc=m,e.$xc=d;const P=/^\w[\w\d+.-]*$/,B=/^\//,S=/^\/\//;function E(i,s){if(!i.scheme&&s)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!P.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!B.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(S.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function h(i,s){return!i&&!s?"file":i}function c(i,s){switch(i){case"https":case"http":case"file":s?s[0]!==y&&(s=y+s):s=y;break}return s}const p="",y="/",k=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class g{static isUri(s){return s instanceof g?!0:s?typeof s.authority=="string"&&typeof s.fragment=="string"&&typeof s.path=="string"&&typeof s.query=="string"&&typeof s.scheme=="string"&&typeof s.fsPath=="string"&&typeof s.with=="function"&&typeof s.toString=="function":!1}constructor(s,u,b,I,D,R=!1){typeof s=="object"?(this.scheme=s.scheme||p,this.authority=s.authority||p,this.path=s.path||p,this.query=s.query||p,this.fragment=s.fragment||p):(this.scheme=h(s,R),this.authority=u||p,this.path=c(this.scheme,b||p),this.query=I||p,this.fragment=D||p,E(this,R))}get fsPath(){return d(this,!1)}with(s){if(!s)return this;let{scheme:u,authority:b,path:I,query:D,fragment:R}=s;return u===void 0?u=this.scheme:u===null&&(u=p),b===void 0?b=this.authority:b===null&&(b=p),I===void 0?I=this.path:I===null&&(I=p),D===void 0?D=this.query:D===null&&(D=p),R===void 0?R=this.fragment:R===null&&(R=p),u===this.scheme&&b===this.authority&&I===this.path&&D===this.query&&R===this.fragment?this:new w(u,b,I,D,R)}static parse(s,u=!1){const b=k.exec(s);return b?new w(b[2]||p,r(b[4]||p),r(b[5]||p),r(b[7]||p),r(b[9]||p),u):new w(p,p,p,p,p)}static file(s){let u=p;if(j.$i&&(s=s.replace(/\\/g,y)),s[0]===y&&s[1]===y){const b=s.indexOf(y,2);b===-1?(u=s.substring(2),s=y):(u=s.substring(2,b),s=s.substring(b)||y)}return new w("file",u,s,p,p)}static from(s,u){return new w(s.scheme,s.authority,s.path,s.query,s.fragment,u)}static joinPath(s,...u){if(!s.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let b;return j.$i&&s.scheme==="file"?b=g.file(n.$gc.join(d(s,!0),...u)).path:b=n.$hc.join(s.path,...u),s.with({path:b})}toString(s=!1){return a(this,s)}toJSON(){return this}static revive(s){if(s){if(s instanceof g)return s;{const u=new w(s);return u._formatted=s.external??null,u._fsPath=s._sep===v?s.fsPath??null:null,u}}else return s}}e.URI=g;function m(i){return!i||typeof i!="object"?!1:typeof i.scheme=="string"&&(typeof i.authority=="string"||typeof i.authority>"u")&&(typeof i.path=="string"||typeof i.path>"u")&&(typeof i.query=="string"||typeof i.query>"u")&&(typeof i.fragment=="string"||typeof i.fragment>"u")}const v=j.$i?1:void 0;class w extends g{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=d(this,!1)),this._fsPath}toString(s=!1){return s?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)}toJSON(){const s={$mid:1};return this._fsPath&&(s.fsPath=this._fsPath,s._sep=v),this._formatted&&(s.external=this._formatted),this.path&&(s.path=this.path),this.scheme&&(s.scheme=this.scheme),this.authority&&(s.authority=this.authority),this.query&&(s.query=this.query),this.fragment&&(s.fragment=this.fragment),s}}const $={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function f(i,s,u){let b,I=-1;for(let D=0;D<i.length;D++){const R=i.charCodeAt(D);if(R>=97&&R<=122||R>=65&&R<=90||R>=48&&R<=57||R===45||R===46||R===95||R===126||s&&R===47||u&&R===91||u&&R===93||u&&R===58)I!==-1&&(b+=encodeURIComponent(i.substring(I,D)),I=-1),b!==void 0&&(b+=i.charAt(D));else{b===void 0&&(b=i.substr(0,D));const C=$[R];C!==void 0?(I!==-1&&(b+=encodeURIComponent(i.substring(I,D)),I=-1),b+=C):I===-1&&(I=D)}}return I!==-1&&(b+=encodeURIComponent(i.substring(I))),b!==void 0?b:i}function l(i){let s;for(let u=0;u<i.length;u++){const b=i.charCodeAt(u);b===35||b===63?(s===void 0&&(s=i.substr(0,u)),s+=$[b]):s!==void 0&&(s+=i[u])}return s!==void 0?s:i}function d(i,s){let u;return i.authority&&i.path.length>1&&i.scheme==="file"?u=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?s?u=i.path.substr(1):u=i.path[1].toLowerCase()+i.path.substr(2):u=i.path,j.$i&&(u=u.replace(/\//g,"\\")),u}function a(i,s){const u=s?l:f;let b="",{scheme:I,authority:D,path:R,query:C,fragment:A}=i;if(I&&(b+=I,b+=":"),(D||I==="file")&&(b+=y,b+=y),D){let L=D.indexOf("@");if(L!==-1){const W=D.substr(0,L);D=D.substr(L+1),L=W.lastIndexOf(":"),L===-1?b+=u(W,!1,!1):(b+=u(W.substr(0,L),!1,!1),b+=":",b+=u(W.substr(L+1),!1,!0)),b+="@"}D=D.toLowerCase(),L=D.lastIndexOf(":"),L===-1?b+=u(D,!1,!0):(b+=u(D.substr(0,L),!1,!0),b+=D.substr(L))}if(R){if(R.length>=3&&R.charCodeAt(0)===47&&R.charCodeAt(2)===58){const L=R.charCodeAt(1);L>=65&&L<=90&&(R=`/${String.fromCharCode(L+32)}:${R.substr(3)}`)}else if(R.length>=2&&R.charCodeAt(1)===58){const L=R.charCodeAt(0);L>=65&&L<=90&&(R=`${String.fromCharCode(L+32)}:${R.substr(2)}`)}b+=u(R,!0,!1)}return C&&(b+="?",b+=u(C,!1,!1)),A&&(b+="#",b+=s?A:f(A,!1,!1)),b}function t(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+t(i.substr(3)):i}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(i){return i.match(o)?i.replace(o,s=>t(s)):i}}),define(oe[156],ae([0,1,7]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eq=j,e.$Fq=P,e.$Gq=B,e.log=E;function j(c){const p=c;return p&&typeof p.type=="string"&&typeof p.severity=="string"}function P(c){const p=[];let y;try{const k=JSON.parse(c.arguments),g=k[k.length-1];g&&g.__$stack&&(k.pop(),y=g.__$stack),p.push(...k)}catch{p.push("Unable to log remote console arguments",c.arguments)}return{args:p,stack:y}}function B(c){if(typeof c!="string")return B(P(c).stack);const p=c;if(p){const y=S(p),k=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(y||"");if(k&&k.length===4)return{uri:n.URI.file(k[1]),line:Number(k[2]),column:Number(k[3])}}}function S(c){if(!c)return c;const p=c.indexOf(`
`);return p===-1?c:c.substring(0,p)}function E(c,p){const{args:y,stack:k}=P(c),g=typeof y[0]=="string"&&y.length===1;let m=S(k);m&&(m=`(${m.trim()})`);let v=[];if(typeof y[0]=="string"?m&&g?v=[`%c[${p}] %c${y[0]} %c${m}`,h("blue"),h(""),h("grey")]:v=[`%c[${p}] %c${y[0]}`,h("blue"),h(""),...y.slice(1)]:v=[`%c[${p}]%`,h("blue"),...y],m&&!g&&v.push(m),typeof console[c.severity]!="function")throw new Error("Unknown console method");console[c.severity].apply(console,v)}function h(c){return`color: ${c}`}}),define(oe[76],ae([0,1,17,7]),function(J,e,n,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oh=P,e.$Ph=B,e.$Qh=E;function P(h){return JSON.stringify(h,S)}function B(h){let c=JSON.parse(h);return c=E(c),c}function S(h,c){return c instanceof RegExp?{$mid:2,source:c.source,flags:c.flags}:c}function E(h,c=0){if(!h||c>200)return h;if(typeof h=="object"){switch(h.$mid){case 1:return j.URI.revive(h);case 2:return new RegExp(h.source,h.flags);case 17:return new Date(h.source)}if(h instanceof n.$ue||h instanceof Uint8Array)return h;if(Array.isArray(h))for(let p=0;p<h.length;++p)h[p]=E(h[p],c+1);else for(const p in h)Object.hasOwnProperty.call(h,p)&&(h[p]=E(h[p],c+1))}return h}}),define(oe[13],ae([0,1,15,4,25,7,9]),function(J,e,n,j,P,B,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$ug=e.$tg=e.$sg=e.Schemas=void 0,e.$qg=h,e.$rg=c,e.$vg=y;var E;(function(m){m.inMemory="inmemory",m.vscode="vscode",m.internal="private",m.walkThrough="walkThrough",m.walkThroughSnippet="walkThroughSnippet",m.http="http",m.https="https",m.file="file",m.mailto="mailto",m.untitled="untitled",m.data="data",m.command="command",m.vscodeRemote="vscode-remote",m.vscodeRemoteResource="vscode-remote-resource",m.vscodeManagedRemoteResource="vscode-managed-remote-resource",m.vscodeUserData="vscode-userdata",m.vscodeCustomEditor="vscode-custom-editor",m.vscodeNotebookCell="vscode-notebook-cell",m.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",m.vscodeNotebookCellOutput="vscode-notebook-cell-output",m.vscodeInteractiveInput="vscode-interactive-input",m.vscodeSettings="vscode-settings",m.vscodeWorkspaceTrust="vscode-workspace-trust",m.vscodeTerminal="vscode-terminal",m.vscodeChatCodeBlock="vscode-chat-code-block",m.vscodeChatSesssion="vscode-chat-editor",m.webviewPanel="webview-panel",m.vscodeWebview="vscode-webview",m.extension="extension",m.vscodeFileResource="vscode-file",m.tmp="tmp",m.vsls="vsls",m.vscodeSourceControl="vscode-scm",m.codeSetting="code-setting"})(E||(e.Schemas=E={}));function h(m,v){return B.URI.isUri(m)?(0,P.$lf)(m.scheme,v):(0,P.$mf)(m,v+":")}function c(m,...v){return v.some(w=>h(m,w))}e.$sg="vscode-tkn",e.$tg="tkn";class p{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(v){this.d=v}setDelegate(v){this.e=v}setServerRootPath(v,w){this.f=y(v,w)}getServerRootPath(){return this.f}get g(){return S.$hc.join(this.f,E.vscodeRemoteResource)}set(v,w,$){this.a[v]=w,this.b[v]=$}setConnectionToken(v,w){this.c[v]=w}getPreferredWebSchema(){return this.d}rewrite(v){if(this.e)try{return this.e(v)}catch(a){return n.$1(a),v}const w=v.authority;let $=this.a[w];$&&$.indexOf(":")!==-1&&$.indexOf("[")===-1&&($=`[${$}]`);const f=this.b[w],l=this.c[w];let d=`path=${encodeURIComponent(v.path)}`;return typeof l=="string"&&(d+=`&${e.$tg}=${encodeURIComponent(l)}`),B.URI.from({scheme:j.$o?this.d:E.vscodeRemoteResource,authority:`${$}:${f}`,path:this.g,query:d})}}e.$ug=new p;function y(m,v){return S.$hc.join(v??"/",`${m.quality??"oss"}-${m.commit??"dev"}`)}e.$wg="vs/../../extensions",e.$xg="vs/../../node_modules",e.$yg="vs/../../node_modules.asar",e.$zg="vs/../../node_modules.asar.unpacked",e.$Ag="vscode-app";class k{static{this.a=e.$Ag}asBrowserUri(v){const w=this.b(v,J);return this.uriToBrowserUri(w)}uriToBrowserUri(v){return v.scheme===E.vscodeRemote?e.$ug.rewrite(v):v.scheme===E.file&&(j.$m||j.$q===`${E.vscodeFileResource}://${k.a}`)?v.with({scheme:E.vscodeFileResource,authority:v.authority||k.a,query:null,fragment:null}):v}asFileUri(v){const w=this.b(v,J);return this.uriToFileUri(w)}uriToFileUri(v){return v.scheme===E.vscodeFileResource?v.with({scheme:E.file,authority:v.authority!==k.a?v.authority:null,query:null,fragment:null}):v}b(v,w){return B.URI.isUri(v)?v:B.URI.parse(w.toUrl(v))}}e.$Bg=new k;var g;(function(m){const v=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);m.CoopAndCoep=Object.freeze(v.get("3"));const w="vscode-coi";function $(l){let d;typeof l=="string"?d=new URL(l).searchParams:l instanceof URL?d=l.searchParams:B.URI.isUri(l)&&(d=new URL(l.toString(!0)).searchParams);const a=d?.get(w);if(a)return v.get(a)}m.getHeadersFromQuery=$;function f(l,d,a){if(!globalThis.crossOriginIsolated)return;const t=d&&a?"3":a?"2":"1";l instanceof URLSearchParams?l.set(w,t):l[w]=t}m.addSearchParam=f})(g||(e.COI=g={}))}),define(oe[19],ae([0,1,31,13,9,4,25,7]),function(J,e,n,j,P,B,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=void 0,e.$Ig=h,e.$4g=p,e.$5g=k;function h(g){return(0,E.$xc)(g,!0)}class c{constructor(m){this.a=m}compare(m,v,w=!1){return m===v?0:(0,S.$ef)(this.getComparisonKey(m,w),this.getComparisonKey(v,w))}isEqual(m,v,w=!1){return m===v?!0:!m||!v?!1:this.getComparisonKey(m,w)===this.getComparisonKey(v,w)}getComparisonKey(m,v=!1){return m.with({path:this.a(m)?m.path.toLowerCase():void 0,fragment:v?null:void 0}).toString()}ignorePathCasing(m){return this.a(m)}isEqualOrParent(m,v,w=!1){if(m.scheme===v.scheme){if(m.scheme===j.Schemas.file)return n.$hg(h(m),h(v),this.a(m))&&m.query===v.query&&(w||m.fragment===v.fragment);if((0,e.$Zg)(m.authority,v.authority))return n.$hg(m.path,v.path,this.a(m),"/")&&m.query===v.query&&(w||m.fragment===v.fragment)}return!1}joinPath(m,...v){return E.URI.joinPath(m,...v)}basenameOrAuthority(m){return(0,e.$Rg)(m)||m.authority}basename(m){return P.$hc.basename(m.path)}extname(m){return P.$hc.extname(m.path)}dirname(m){if(m.path.length===0)return m;let v;return m.scheme===j.Schemas.file?v=E.URI.file(P.$nc(h(m))).path:(v=P.$hc.dirname(m.path),m.authority&&v.length&&v.charCodeAt(0)!==47&&(console.error(`dirname("${m.toString})) resulted in a relative path`),v="/")),m.with({path:v})}normalizePath(m){if(!m.path.length)return m;let v;return m.scheme===j.Schemas.file?v=E.URI.file(P.$ic(h(m))).path:v=P.$hc.normalize(m.path),m.with({path:v})}relativePath(m,v){if(m.scheme!==v.scheme||!(0,e.$Zg)(m.authority,v.authority))return;if(m.scheme===j.Schemas.file){const f=P.$mc(h(m),h(v));return B.$i?n.$bg(f):f}let w=m.path||"/";const $=v.path||"/";if(this.a(m)){let f=0;for(const l=Math.min(w.length,$.length);f<l&&!(w.charCodeAt(f)!==$.charCodeAt(f)&&w.charAt(f).toLowerCase()!==$.charAt(f).toLowerCase());f++);w=$.substr(0,f)+w.substr(f)}return P.$hc.relative(w,$)}resolvePath(m,v){if(m.scheme===j.Schemas.file){const w=E.URI.file(P.$lc(h(m),v));return m.with({authority:w.authority,path:w.path})}return v=n.$cg(v),m.with({path:P.$hc.resolve(m.path,v)})}isAbsolutePath(m){return!!m.path&&m.path[0]==="/"}isEqualAuthority(m,v){return m===v||m!==void 0&&v!==void 0&&(0,S.$lf)(m,v)}hasTrailingPathSeparator(m,v=P.sep){if(m.scheme===j.Schemas.file){const w=h(m);return w.length>n.$dg(w).length&&w[w.length-1]===v}else{const w=m.path;return w.length>1&&w.charCodeAt(w.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(m.fsPath)}}removeTrailingPathSeparator(m,v=P.sep){return(0,e.$1g)(m,v)?m.with({path:m.path.substr(0,m.path.length-1)}):m}addTrailingPathSeparator(m,v=P.sep){let w=!1;if(m.scheme===j.Schemas.file){const $=h(m);w=$!==void 0&&$.length===n.$dg($).length&&$[$.length-1]===v}else{v="/";const $=m.path;w=$.length===1&&$.charCodeAt($.length-1)===47}return!w&&!(0,e.$1g)(m,v)?m.with({path:m.path+"/"}):m}}e.$Jg=c,e.$Kg=new c(()=>!1),e.$Lg=new c(g=>g.scheme===j.Schemas.file?!B.$k:!0),e.$Mg=new c(g=>!0),e.$Ng=e.$Kg.isEqual.bind(e.$Kg),e.$Og=e.$Kg.isEqualOrParent.bind(e.$Kg),e.$Pg=e.$Kg.getComparisonKey.bind(e.$Kg),e.$Qg=e.$Kg.basenameOrAuthority.bind(e.$Kg),e.$Rg=e.$Kg.basename.bind(e.$Kg),e.$Sg=e.$Kg.extname.bind(e.$Kg),e.$Tg=e.$Kg.dirname.bind(e.$Kg),e.$Ug=e.$Kg.joinPath.bind(e.$Kg),e.$Vg=e.$Kg.normalizePath.bind(e.$Kg),e.$Wg=e.$Kg.relativePath.bind(e.$Kg),e.$Xg=e.$Kg.resolvePath.bind(e.$Kg),e.$Yg=e.$Kg.isAbsolutePath.bind(e.$Kg),e.$Zg=e.$Kg.isEqualAuthority.bind(e.$Kg),e.$1g=e.$Kg.hasTrailingPathSeparator.bind(e.$Kg),e.$2g=e.$Kg.removeTrailingPathSeparator.bind(e.$Kg),e.$3g=e.$Kg.addTrailingPathSeparator.bind(e.$Kg);function p(g,m){const v=[];for(let w=0;w<g.length;w++){const $=m(g[w]);g.some((f,l)=>l===w?!1:(0,e.$Og)($,m(f)))||v.push(g[w])}return v}var y;(function(g){g.META_DATA_LABEL="label",g.META_DATA_DESCRIPTION="description",g.META_DATA_SIZE="size",g.META_DATA_MIME="mime";function m(v){const w=new Map;v.path.substring(v.path.indexOf(";")+1,v.path.lastIndexOf(";")).split(";").forEach(l=>{const[d,a]=l.split(":");d&&a&&w.set(d,a)});const f=v.path.substring(0,v.path.indexOf(";"));return f&&w.set(g.META_DATA_MIME,f),w}g.parseMetaData=m})(y||(e.DataUri=y={}));function k(g,m,v){if(m){let w=g.path;return w&&w[0]!==P.$hc.sep&&(w=P.$hc.sep+w),g.with({scheme:v,authority:m,path:w})}return g.with({scheme:v})}}),define(oe[8],ae([0,1,23,15,3,2,19,4,144,62]),function(J,e,n,j,P,B,S,E,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.Promises=e.$Eh=e.$Dh=e.$Ch=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=void 0,e.$6g=p,e.$7g=y,e.$8g=k,e.$9g=g,e.$0g=m,e.$$g=v,e.$_g=w,e.$ah=$,e.$ih=u,e.$jh=b,e.$kh=I,e.$lh=D,e.$mh=R,e.$Bh=M,e.$Jh=Z;function p(x){return!!x&&typeof x.then=="function"}function y(x){const U=new n.$ee,re=x(U.token),ee=new Promise((fe,me)=>{const ve=U.token.onCancellationRequested(()=>{ve.dispose(),me(new j.$5)});Promise.resolve(re).then(ke=>{ve.dispose(),U.dispose(),fe(ke)},ke=>{ve.dispose(),U.dispose(),me(ke)})});return new class{cancel(){U.cancel(),U.dispose()}then(fe,me){return ee.then(fe,me)}catch(fe){return this.then(void 0,fe)}finally(fe){return ee.finally(fe)}}}function k(x,U,re){return new Promise((ee,fe)=>{const me=U.onCancellationRequested(()=>{me.dispose(),ee(re)});x.then(ee,fe).finally(()=>me.dispose())})}function g(x,U){return new Promise((re,ee)=>{const fe=U.onCancellationRequested(()=>{fe.dispose(),ee(new j.$5)});x.then(re,ee).finally(()=>fe.dispose())})}async function m(x){let U=-1;const re=x.map((ee,fe)=>ee.then(me=>(U=fe,me)));try{return await Promise.race(re)}finally{x.forEach((ee,fe)=>{fe!==U&&ee.cancel()})}}function v(x,U,re){let ee;const fe=setTimeout(()=>{ee?.(void 0),re?.()},U);return Promise.race([x.finally(()=>clearTimeout(fe)),new Promise(me=>ee=me)])}function w(x){return new Promise((U,re)=>{const ee=x();p(ee)?ee.then(U,re):U(ee)})}function $(){let x,U;return{promise:new Promise((ee,fe)=>{x=ee,U=fe}),resolve:x,reject:U}}class f{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(U){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=U,!this.b){const re=()=>{if(this.b=null,this.f)return;const ee=this.queue(this.d);return this.d=null,ee};this.b=new Promise(ee=>{this.a.then(re,re).then(ee)})}return new Promise((re,ee)=>{this.b.then(re,ee)})}return this.a=U(),new Promise((re,ee)=>{this.a.then(fe=>{this.a=null,re(fe)},fe=>{this.a=null,ee(fe)})})}dispose(){this.f=!0}}e.$bh=f;class l{constructor(){this.a=Promise.resolve(null)}queue(U){return this.a=this.a.then(()=>U(),()=>U())}}e.$ch=l;class d{constructor(){this.a=new Map}queue(U,re){const fe=(this.a.get(U)??Promise.resolve()).catch(()=>{}).then(re).finally(()=>{this.a.get(U)===fe&&this.a.delete(U)});return this.a.set(U,fe),fe}}e.$dh=d;const a=(x,U)=>{let re=!0;const ee=setTimeout(()=>{re=!1,U()},x);return{isTriggered:()=>re,dispose:()=>{clearTimeout(ee),re=!1}}},t=x=>{let U=!0;return queueMicrotask(()=>{U&&(U=!1,x())}),{isTriggered:()=>U,dispose:()=>{U=!1}}};class o{constructor(U){this.defaultDelay=U,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(U,re=this.defaultDelay){this.g=U,this.h(),this.b||(this.b=new Promise((fe,me)=>{this.d=fe,this.f=me}).then(()=>{if(this.b=null,this.d=null,this.g){const fe=this.g;return this.g=null,fe()}}));const ee=()=>{this.a=null,this.d?.(null)};return this.a=re===h.$4d?t(ee):a(re,ee),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new j.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$eh=o;class r{constructor(U){this.a=new o(U),this.b=new f}trigger(U,re){return this.a.trigger(()=>this.b.queue(U),re)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$fh=r;class i{constructor(){this.a=!1,this.b=new Promise((U,re)=>{this.d=U})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$gh=i;class s extends i{constructor(U){super(),this.f=setTimeout(()=>this.open(),U)}open(){clearTimeout(this.f),super.open()}}e.$hh=s;function u(x,U){return U?new Promise((re,ee)=>{const fe=setTimeout(()=>{me.dispose(),re()},x),me=U.onCancellationRequested(()=>{clearTimeout(fe),me.dispose(),ee(new j.$5)})}):y(re=>u(x,re))}function b(x,U=0,re){const ee=setTimeout(()=>{x(),re&&fe.dispose()},U),fe=(0,B.$Sc)(()=>{clearTimeout(ee),re?.deleteAndLeak(fe)});return re?.add(fe),fe}function I(x){const U=[];let re=0;const ee=x.length;function fe(){return re<ee?x[re++]():null}function me(ve){ve!=null&&U.push(ve);const ke=fe();return ke?ke.then(me):Promise.resolve(U)}return Promise.resolve(null).then(me)}function D(x,U=ee=>!!ee,re=null){let ee=0;const fe=x.length,me=()=>{if(ee>=fe)return Promise.resolve(re);const ve=x[ee++];return Promise.resolve(ve()).then(je=>U(je)?Promise.resolve(je):me())};return me()}function R(x,U=ee=>!!ee,re=null){if(x.length===0)return Promise.resolve(re);let ee=x.length;const fe=()=>{ee=-1;for(const me of x)me.cancel?.()};return new Promise((me,ve)=>{for(const ke of x)ke.then(je=>{--ee>=0&&U(je)?(fe(),me(je)):ee===0&&me(re)}).catch(je=>{--ee>=0&&(fe(),ve(je))})})}class C{constructor(U){this.a=0,this.b=!1,this.f=U,this.g=[],this.d=0,this.h=new P.$7d}whenIdle(){return this.size>0?P.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(U){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((re,ee)=>{this.g.push({factory:U,c:re,e:ee}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const U=this.g.shift();this.d++;const re=U.factory();re.then(U.c,U.e),re.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$nh=C;class A extends C{constructor(){super(1)}}e.$oh=A;class L{constructor(){this.a=new F,this.b=0}queue(U){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,U())):this.a.run(this.b++,U())}}e.$ph=L;class W{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const U=new ce;return this.b.add(U),U.p}g(){for(const[,U]of this.a)if(U.size>0)return!1;return!0}queueSize(U,re=S.$Kg){const ee=re.getComparisonKey(U);return this.a.get(ee)?.size??0}queueFor(U,re,ee=S.$Kg){const fe=ee.getComparisonKey(U);let me=this.a.get(fe);if(!me){me=new A;const ve=this.f++,ke=P.Event.once(me.onDrained)(()=>{me?.dispose(),this.a.delete(fe),this.h(),this.d?.deleteAndDispose(ve),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new B.$4c),this.d.set(ve,ke),this.a.set(fe,me)}return me.queue(re)}h(){this.g()&&this.j()}j(){for(const U of this.b)U.complete();this.b.clear()}dispose(){for(const[,U]of this.a)U.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$qh=W;class q{constructor(U,re){this.a=-1,typeof U=="function"&&typeof re=="number"&&this.setIfNotSet(U,re)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(U,re){this.cancel(),this.a=setTimeout(()=>{this.a=-1,U()},re)}setIfNotSet(U,re){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,U()},re))}}e.$rh=q;class H{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(U,re,ee=globalThis){this.cancel();const fe=ee.setInterval(()=>{U()},re);this.d=(0,B.$Sc)(()=>{ee.clearInterval(fe),this.d=void 0})}dispose(){this.cancel()}}e.$sh=H;class le{constructor(U,re){this.b=-1,this.a=U,this.d=re,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(U=this.d){this.cancel(),this.b=setTimeout(this.f,U)}get delay(){return this.d}set delay(U){this.d=U}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$th=le;class te{constructor(U,re){re%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${re}ms is not a multiple of 1000ms.`),this.a=U,this.b=re,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(U=this.b){U%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${U}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(U/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$uh=te;class ue extends le{constructor(U,re){super(U,re),this.j=[]}work(U){this.j.push(U),this.isScheduled()||this.schedule()}h(){const U=this.j;this.j=[],this.a?.(U)}dispose(){this.j=[],super.dispose()}}e.$vh=ue;class X extends B.$Uc{constructor(U,re){super(),this.g=U,this.h=re,this.a=[],this.b=this.B(new B.$Vc),this.f=!1}get pending(){return this.a.length}work(U){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+U.length>this.g.maxBufferedWork)return!1}else if(this.pending+U.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const re of U)this.a.push(re);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new le(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$wh=X,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$yh=(x,U)=>{(0,E.$B)(()=>{if(re)return;const ee=Date.now()+15;U(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ee-Date.now())}}))});let re=!1;return{dispose(){re||(re=!0)}}}:e.$yh=(x,U,re)=>{const ee=x.requestIdleCallback(U,typeof re=="number"?{timeout:re}:void 0);let fe=!1;return{dispose(){fe||(fe=!0,x.cancelIdleCallback(ee))}}},e.$xh=x=>(0,e.$yh)(globalThis,x)}();class Q{constructor(U,re){this.g=!1,this.d=()=>{try{this.j=re()}catch(ee){this.l=ee}finally{this.g=!0}},this.f=(0,e.$yh)(U,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$zh=Q;class z extends Q{constructor(U){super(globalThis,U)}}e.$Ah=z;async function M(x,U,re){let ee;for(let fe=0;fe<re;fe++)try{return await x()}catch(me){ee=me,await u(U)}throw ee}class F{isRunning(U){return typeof U=="number"?this.a?.taskId===U:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(U,re,ee){return this.a={taskId:U,cancel:()=>ee?.(),promise:re},re.then(()=>this.d(U),()=>this.d(U)),re}d(U){this.a&&U===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const U=this.b;this.b=void 0,U.run().then(U.promiseResolve,U.promiseReject)}}queue(U){if(this.b)this.b.run=U;else{const{promise:re,resolve:ee,reject:fe}=$();this.b={run:U,promise:re,promiseResolve:ee,promiseReject:fe}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Ch=F;class G{constructor(U,re=()=>Date.now()){this.d=U,this.f=re,this.a=0,this.b=0}increment(){const U=this.f();return U-this.a>this.d&&(this.a=U,this.b=0),this.b++,this.b}}e.$Dh=G;var T;(function(x){x[x.Resolved=0]="Resolved",x[x.Rejected=1]="Rejected"})(T||(T={}));class ce{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((U,re)=>{this.a=U,this.b=re})}complete(U){return new Promise(re=>{this.a(U),this.d={outcome:0,value:U},re()})}error(U){return new Promise(re=>{this.b(U),this.d={outcome:1,value:U},re()})}cancel(){return this.error(new j.$5)}}e.$Eh=ce;var he;(function(x){async function U(ee){let fe;const me=await Promise.all(ee.map(ve=>ve.then(ke=>ke,ke=>{fe||(fe=ke)})));if(typeof fe<"u")throw fe;return me}x.settled=U;function re(ee){return new Promise(async(fe,me)=>{try{await ee(fe,me)}catch(ve){me(ve)}})}x.withAsyncBody=re})(he||(e.Promises=he={}));class K{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(U){this.a=void 0,this.b=void 0,this.d=!1,this.promise=U.then(re=>(this.a=re,this.d=!0,re),re=>{throw this.b=re,this.d=!0,re})}requireValue(){if(!this.d)throw new j.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Fh=K;class O{constructor(U){this.b=U,this.a=new c.$V(()=>new K(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Gh=O;var N;(function(x){x[x.Initial=0]="Initial",x[x.DoneOK=1]="DoneOK",x[x.DoneError=2]="DoneError"})(N||(N={}));class _{static fromArray(U){return new _(re=>{re.emitMany(U)})}static fromPromise(U){return new _(async re=>{re.emitMany(await U)})}static fromPromises(U){return new _(async re=>{await Promise.all(U.map(async ee=>re.emitOne(await ee)))})}static merge(U){return new _(async re=>{await Promise.all(U.map(async ee=>{for await(const fe of ee)re.emitOne(fe)}))})}static{this.EMPTY=_.fromArray([])}constructor(U){this.a=0,this.b=[],this.d=null,this.f=new P.$7d,queueMicrotask(async()=>{const re={emitOne:ee=>this.g(ee),emitMany:ee=>this.h(ee),reject:ee=>this.k(ee)};try{await Promise.resolve(U(re)),this.j()}catch(ee){this.k(ee)}finally{re.emitOne=void 0,re.emitMany=void 0,re.reject=void 0}})}[Symbol.asyncIterator](){let U=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(U<this.b.length)return{done:!1,value:this.b[U++]};if(this.a===1)return{done:!0,value:void 0};await P.Event.toPromise(this.f.event)}while(!0)}}}static map(U,re){return new _(async ee=>{for await(const fe of U)ee.emitOne(re(fe))})}map(U){return _.map(this,U)}static filter(U,re){return new _(async ee=>{for await(const fe of U)re(fe)&&ee.emitOne(fe)})}filter(U){return _.filter(this,U)}static coalesce(U){return _.filter(U,re=>!!re)}coalesce(){return _.coalesce(this)}static async toPromise(U){const re=[];for await(const ee of U)re.push(ee);return re}toPromise(){return _.toPromise(this)}g(U){this.a===0&&(this.b.push(U),this.f.fire())}h(U){this.a===0&&(this.b=this.b.concat(U),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(U){this.a===0&&(this.a=2,this.d=U,this.f.fire())}}e.$Hh=_;class se extends _{constructor(U,re){super(re),this.l=U}cancel(){this.l.cancel()}}e.$Ih=se;function Z(x){const U=new n.$ee,re=x(U.token);return new se(U,async ee=>{const fe=U.token.onCancellationRequested(()=>{fe.dispose(),U.dispose(),ee.reject(new j.$5)});try{for await(const me of re){if(U.token.isCancellationRequested)return;ee.emitOne(me)}fe.dispose(),U.dispose()}catch(me){fe.dispose(),U.dispose(),ee.reject(me)}})}class V{constructor(){this.a=new ce,this.b=new _(ee=>{if(U){ee.reject(U);return}return re&&ee.emitMany(re),this.d=fe=>ee.reject(fe),this.f=fe=>ee.emitOne(fe),this.a.p});let U,re;this.f=ee=>{re||(re=[]),re.push(ee)},this.d=ee=>{U||(U=ee)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(U){this.d(U),this.a.complete()}emitOne(U){this.f(U)}}e.$Kh=V}),define(oe[108],ae([0,1,22,8,31,32,9,4,25]),function(J,e,n,j,P,B,S,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$j=e.$0j=void 0,e.$9j=c,e.$_j=m,e.$ak=A,e.$bk=L,e.$ck=W,e.$dk=q,e.$ek=H,e.$fk=X;function c(){return Object.create(null)}e.$0j="**",e.$$j="/";const p="[/\\\\]",y="[^/\\\\]",k=/\//g;function g(Q,z){switch(Q){case 0:return"";case 1:return`${y}*?`;default:return`(?:${p}|${y}+${p}${z?`|${p}${y}+`:""})*?`}}function m(Q,z){if(!Q)return[];const M=[];let F=!1,G=!1,T="";for(const ce of Q){switch(ce){case z:if(!F&&!G){M.push(T),T="";continue}break;case"{":F=!0;break;case"}":F=!1;break;case"[":G=!0;break;case"]":G=!1;break}T+=ce}return T&&M.push(T),M}function v(Q){if(!Q)return"";let z="";const M=m(Q,e.$$j);if(M.every(F=>F===e.$0j))z=".*";else{let F=!1;M.forEach((G,T)=>{if(G===e.$0j){if(F)return;z+=g(2,T===M.length-1)}else{let ce=!1,he="",K=!1,O="";for(const N of G){if(N!=="}"&&ce){he+=N;continue}if(K&&(N!=="]"||!O)){let _;N==="-"?_=N:(N==="^"||N==="!")&&!O?_="^":N===e.$$j?_="":_=(0,h.$Ze)(N),O+=_;continue}switch(N){case"{":ce=!0;continue;case"[":K=!0;continue;case"}":{const se=`(?:${m(he,",").map(Z=>v(Z)).join("|")})`;z+=se,ce=!1,he="";break}case"]":{z+="["+O+"]",K=!1,O="";break}case"?":z+=y;continue;case"*":z+=g(1);continue;default:z+=(0,h.$Ze)(N)}}T<M.length-1&&(M[T+1]!==e.$0j||T+2<M.length)&&(z+=p)}F=G===e.$0j})}return z}const w=/^\*\*\/\*\.[\w\.-]+$/,$=/^\*\*\/([\w\.-]+)\/?$/,f=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,l=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,d=/^\*\*((\/[\w\.-]+)+)\/?$/,a=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new B.$Ec(1e4),o=function(){return!1},r=function(){return null};function i(Q,z){if(!Q)return r;let M;typeof Q!="string"?M=Q.pattern:M=Q,M=M.trim();const F=`${M}_${!!z.trimForExclusions}`;let G=t.get(F);if(G)return s(G,Q);let T;return w.test(M)?G=b(M.substr(4),M):(T=$.exec(u(M,z)))?G=I(T[1],M):(z.trimForExclusions?l:f).test(M)?G=D(M,z):(T=d.exec(u(M,z)))?G=R(T[1].substr(1),M,!0):(T=a.exec(u(M,z)))?G=R(T[1],M,!1):G=C(M),t.set(F,G),s(G,Q)}function s(Q,z){if(typeof z=="string")return Q;const M=function(F,G){return(0,P.$hg)(F,z.base,!E.$k)?Q((0,h.$5e)(F.substr(z.base.length),S.sep),G):null};return M.allBasenames=Q.allBasenames,M.allPaths=Q.allPaths,M.basenames=Q.basenames,M.patterns=Q.patterns,M}function u(Q,z){return z.trimForExclusions&&Q.endsWith("/**")?Q.substr(0,Q.length-2):Q}function b(Q,z){return function(M,F){return typeof M=="string"&&M.endsWith(Q)?z:null}}function I(Q,z){const M=`/${Q}`,F=`\\${Q}`,G=function(ce,he){return typeof ce!="string"?null:he?he===Q?z:null:ce===Q||ce.endsWith(M)||ce.endsWith(F)?z:null},T=[Q];return G.basenames=T,G.patterns=[z],G.allBasenames=T,G}function D(Q,z){const M=ue(Q.slice(1,-1).split(",").map(he=>i(he,z)).filter(he=>he!==r),Q),F=M.length;if(!F)return r;if(F===1)return M[0];const G=function(he,K){for(let O=0,N=M.length;O<N;O++)if(M[O](he,K))return Q;return null},T=M.find(he=>!!he.allBasenames);T&&(G.allBasenames=T.allBasenames);const ce=M.reduce((he,K)=>K.allPaths?he.concat(K.allPaths):he,[]);return ce.length&&(G.allPaths=ce),G}function R(Q,z,M){const F=S.sep===S.$hc.sep,G=F?Q:Q.replace(k,S.sep),T=S.sep+G,ce=S.$hc.sep+Q;let he;return M?he=function(K,O){return typeof K=="string"&&(K===G||K.endsWith(T)||!F&&(K===Q||K.endsWith(ce)))?z:null}:he=function(K,O){return typeof K=="string"&&(K===G||!F&&K===Q)?z:null},he.allPaths=[(M?"*/":"./")+Q],he}function C(Q){try{const z=new RegExp(`^${v(Q)}$`);return function(M){return z.lastIndex=0,typeof M=="string"&&z.test(M)?Q:null}}catch{return r}}function A(Q,z,M){return!Q||typeof z!="string"?!1:L(Q)(z,void 0,M)}function L(Q,z={}){if(!Q)return o;if(typeof Q=="string"||W(Q)){const M=i(Q,z);if(M===r)return o;const F=function(G,T){return!!M(G,T)};return M.allBasenames&&(F.allBasenames=M.allBasenames),M.allPaths&&(F.allPaths=M.allPaths),F}return le(Q,z)}function W(Q){const z=Q;return z?typeof z.base=="string"&&typeof z.pattern=="string":!1}function q(Q){return Q.allBasenames||[]}function H(Q){return Q.allPaths||[]}function le(Q,z){const M=ue(Object.getOwnPropertyNames(Q).map(he=>te(he,Q[he],z)).filter(he=>he!==r)),F=M.length;if(!F)return r;if(!M.some(he=>!!he.requiresSiblings)){if(F===1)return M[0];const he=function(N,_){let se;for(let Z=0,V=M.length;Z<V;Z++){const x=M[Z](N,_);if(typeof x=="string")return x;(0,j.$6g)(x)&&(se||(se=[]),se.push(x))}return se?(async()=>{for(const Z of se){const V=await Z;if(typeof V=="string")return V}return null})():null},K=M.find(N=>!!N.allBasenames);K&&(he.allBasenames=K.allBasenames);const O=M.reduce((N,_)=>_.allPaths?N.concat(_.allPaths):N,[]);return O.length&&(he.allPaths=O),he}const G=function(he,K,O){let N,_;for(let se=0,Z=M.length;se<Z;se++){const V=M[se];V.requiresSiblings&&O&&(K||(K=(0,S.$oc)(he)),N||(N=K.substr(0,K.length-(0,S.$pc)(he).length)));const x=V(he,K,N,O);if(typeof x=="string")return x;(0,j.$6g)(x)&&(_||(_=[]),_.push(x))}return _?(async()=>{for(const se of _){const Z=await se;if(typeof Z=="string")return Z}return null})():null},T=M.find(he=>!!he.allBasenames);T&&(G.allBasenames=T.allBasenames);const ce=M.reduce((he,K)=>K.allPaths?he.concat(K.allPaths):he,[]);return ce.length&&(G.allPaths=ce),G}function te(Q,z,M){if(z===!1)return r;const F=i(Q,M);if(F===r)return r;if(typeof z=="boolean")return F;if(z){const G=z.when;if(typeof G=="string"){const T=(ce,he,K,O)=>{if(!O||!F(ce,he))return null;const N=G.replace("$(basename)",()=>K),_=O(N);return(0,j.$6g)(_)?_.then(se=>se?Q:null):_?Q:null};return T.requiresSiblings=!0,T}}return F}function ue(Q,z){const M=Q.filter(he=>!!he.basenames);if(M.length<2)return Q;const F=M.reduce((he,K)=>{const O=K.basenames;return O?he.concat(O):he},[]);let G;if(z){G=[];for(let he=0,K=F.length;he<K;he++)G.push(z)}else G=M.reduce((he,K)=>{const O=K.patterns;return O?he.concat(O):he},[]);const T=function(he,K){if(typeof he!="string")return null;if(!K){let N;for(N=he.length;N>0;N--){const _=he.charCodeAt(N-1);if(_===47||_===92)break}K=he.substr(N)}const O=F.indexOf(K);return O!==-1?G[O]:null};T.basenames=F,T.patterns=G,T.allBasenames=F;const ce=Q.filter(he=>!he.basenames);return ce.push(T),ce}function X(Q,z){return(0,n.$ub)(Q,z,(M,F)=>typeof M=="string"&&typeof F=="string"?M===F:typeof M!="string"&&typeof F!="string"?M.base===F.base&&M.pattern===F.pattern:!1)}}),define(oe[48],ae([0,1,22,31,9,4,19,25]),function(J,e,n,j,P,B,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fw=h,e.$gw=p,e.$hw=k,e.$iw=g,e.$jw=$,e.$kw=l,e.$lw=d,e.$mw=a,e.$nw=t,e.$ow=o;function h(i,s){const{os:u,tildify:b,relative:I}=s;if(I){const C=c(i,I,u);if(typeof C=="string")return C}let D=i.fsPath;if(u===1&&!B.$i?D=D.replace(/\//g,"\\"):u!==1&&B.$i&&(D=D.replace(/\\/g,"/")),u!==1&&b?.userHome){const C=b.userHome.fsPath;let A;i.scheme!==b.userHome.scheme&&i.path[0]===P.$hc.sep&&i.path[1]!==P.$hc.sep?A=b.userHome.with({path:i.path}).fsPath:A=D,D=k(A,C,u)}return(u===1?P.$gc:P.$hc).normalize(p(D,u===1))}function c(i,s,u){const b=u===1?P.$gc:P.$hc,I=u===3?S.$Kg:S.$Mg,D=s.getWorkspace(),R=(0,n.$Ob)(D.folders);if(!R)return;i.scheme!==R.uri.scheme&&i.path[0]===P.$hc.sep&&i.path[1]!==P.$hc.sep&&(i=R.uri.with({path:i.path}));const C=s.getWorkspaceFolder(i);if(!C)return;let A;if(I.isEqual(C.uri,i)?A="":A=I.relativePath(C.uri,i)??"",A&&(A=b.normalize(A)),D.folders.length>1&&!s.noPrefix){const L=C.name?C.name:I.basenameOrAuthority(C.uri);A=A?`${L} \u2022 ${A}`:L}return A}function p(i,s=B.$i){return(0,j.$lg)(i,s)?i.charAt(0).toUpperCase()+i.slice(1):i}let y=Object.create(null);function k(i,s,u=B.OS){if(u===1||!i||!s)return i;let b=y.original===s?y.normalized:void 0;b||(b=s,B.$i&&(b=(0,j.$bg)(b)),b=`${(0,E.$6e)(b,P.$hc.sep)}${P.$hc.sep}`,y={original:s,normalized:b});let I=i;return B.$i&&(I=(0,j.$bg)(I)),(u===3?I.startsWith(b):(0,E.$mf)(I,b))?`~/${I.substr(b.length)}`:i}function g(i,s){return i.replace(/^~($|\/|\\)/,`${s}$1`)}const m="\u2026",v="\\\\",w="~";function $(i,s=P.sep){const u=new Array(i.length);let b=!1;for(let I=0;I<i.length;I++){const D=i[I];if(D===""){u[I]=`.${s}`;continue}if(!D){u[I]=D;continue}b=!0;let R="",C=D;C.indexOf(v)===0?(R=C.substr(0,C.indexOf(v)+v.length),C=C.substr(C.indexOf(v)+v.length)):C.indexOf(s)===0?(R=C.substr(0,C.indexOf(s)+s.length),C=C.substr(C.indexOf(s)+s.length)):C.indexOf(w)===0&&(R=C.substr(0,C.indexOf(w)+w.length),C=C.substr(C.indexOf(w)+w.length));const A=C.split(s);for(let L=1;b&&L<=A.length;L++)for(let W=A.length-L;b&&W>=0;W--){b=!1;let q=A.slice(W,W+L).join(s);for(let H=0;!b&&H<i.length;H++)if(H!==I&&i[H]&&i[H].indexOf(q)>-1){const le=W+L===A.length,te=W>0&&i[H].indexOf(s)>-1?s+q:q,ue=i[H].endsWith(te);b=!le||ue}if(!b){let H="";(A[0].endsWith(":")||R!=="")&&(W===1&&(W=0,L++,q=A[0]+s+q),W>0&&(H=A[0]+s),H=R+H),W>0&&(H=H+m+s),H=H+q,W+L<A.length&&(H=H+s+m),u[I]=H}}b&&(u[I]=D)}return u}var f;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(f||(f={}));function l(i,s=Object.create(null)){const u=[];let b=!1,I="";for(const D of i)if(D==="$"||b&&D==="{")I&&u.push({value:I,type:f.TEXT}),I="",b=!0;else if(D==="}"&&b){const R=s[I];if(typeof R=="string")R.length&&u.push({value:R,type:f.VARIABLE});else if(R){const C=u[u.length-1];(!C||C.type!==f.SEPARATOR)&&u.push({value:R.label,type:f.SEPARATOR})}I="",b=!1}else I+=D;return I&&!b&&u.push({value:I,type:f.TEXT}),u.filter((D,R)=>{if(D.type===f.SEPARATOR){const C=u[R-1],A=u[R+1];return[C,A].every(L=>L&&(L.type===f.VARIABLE||L.type===f.TEXT)&&L.value.length>0)}return!0}).map(D=>D.value).join("")}function d(i,s){return B.$j||s?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,B.$j?"&":"&&"):i.replace(/&&|&/g,u=>u==="&"?"&&":"&")}function a(i,s){return B.$j||s?i.replace(/\(&&\w\)|&&/g,""):B.$i?i.replace(/&&|&/g,u=>u==="&"?"&&":"&"):i.replace(/&&/g,"_")}function t(i){return i.replace(/&/g,"&&")}function o(i){if(i.endsWith("]")){const s=i.lastIndexOf(" [",i.length-2);if(s!==-1){const u=r(i.substring(0,s)),b=i.substring(s);return{name:u.name+b,parentPath:u.parentPath}}}return r(i)}function r(i){const s=i.indexOf("/")!==-1?P.$hc:P.$gc,u=s.basename(i),b=s.dirname(i);return u.length?{name:u,parentPath:b}:{name:b,parentPath:""}}}),define(oe[157],ae([0,1,17,7]),function(J,e,n,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kn=e.$jn=void 0,e.$ln=E,e.$mn=c,e.$nn=p;function P(y){return y.toJSON()}class B{constructor(k){this.a=k}transformIncoming(k){const g=this.a.transformIncoming(k);return g===k?k:P(j.URI.from(g))}transformOutgoing(k){const g=this.a.transformOutgoing(k);return g===k?k:P(j.URI.from(g))}transformOutgoingURI(k){const g=this.a.transformOutgoing(k);return g===k?k:j.URI.from(g)}transformOutgoingScheme(k){return this.a.transformOutgoingScheme(k)}}e.$jn=B,e.$kn=new class{transformIncoming(y){return y}transformOutgoing(y){return y}transformOutgoingURI(y){return y}transformOutgoingScheme(y){return y}};function S(y,k,g){if(!y||g>200)return null;if(typeof y=="object"){if(y instanceof j.URI)return k.transformOutgoing(y);for(const m in y)if(Object.hasOwnProperty.call(y,m)){const v=S(y[m],k,g+1);v!==null&&(y[m]=v)}}return null}function E(y,k){const g=S(y,k,0);return g===null?y:g}function h(y,k,g,m){if(!y||m>200)return null;if(typeof y=="object"){if(y.$mid===1)return g?j.URI.revive(k.transformIncoming(y)):k.transformIncoming(y);if(y instanceof n.$ue)return null;for(const v in y)if(Object.hasOwnProperty.call(y,v)){const w=h(y[v],k,g,m+1);w!==null&&(y[v]=w)}}return null}function c(y,k){const g=h(y,k,!1,0);return g===null?y:g}function p(y,k){const g=h(y,k,!0,0);return g===null?y:g}}),define(oe[89],ae([0,1,26,59,33,147,4]),function(J,e,n,j,P,B,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pn=void 0,e.$qn=h,e.$rn=y,e.$pn=new class{c(k){return this.a||(this.a=j.$ni.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(k)}value(){if(this.b===void 0){let k=0,g=0;const m=(0,n.networkInterfaces)();for(const v in m){const w=m[v];if(w)for(const{mac:$,internal:f}of w)f||(g+=1,this.c($.toUpperCase())&&(k+=1))}this.b=g>0?k/g:0}return this.b}};let E;async function h(k){return E||(E=(async()=>await c(k)||P.$Dg())()),E}async function c(k){try{const g=await new Promise((v,w)=>{J(["crypto"],v,w)}),m=(0,B.$on)();return g.createHash("sha256").update(m,"utf8").digest("hex")}catch(g){k(g);return}}const p="Software\\Microsoft\\SQMClient";async function y(k){if(S.$i){const g=await new Promise((m,v)=>{J(["@vscode/windows-registry"],m,v)});try{return g.GetStringRegKey("HKEY_LOCAL_MACHINE",p,"MachineId")||""}catch(m){return k(m),""}}return""}}),define(oe[21],ae([0,1,43,26,158,8,31,86,9,4,19,7]),function(J,e,n,j,P,B,S,E,h,c,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=w,e.readdirSync=l,e.whenDeleted=t,e.configureFlushOnWrite=u,e.writeFileSync=I;var k;(function(te){te[te.UNLINK=0]="UNLINK",te[te.MOVE=1]="MOVE"})(k||(e.RimRafMode=k={}));async function g(te,ue=k.UNLINK,X){if((0,S.$kg)(te))throw new Error("rimraf - will refuse to recursively delete root");return ue===k.UNLINK?v(te):m(te,X)}async function m(te,ue=(0,S.$pg)((0,j.tmpdir)())){try{try{await n.promises.rename(te,ue)}catch(X){return X.code==="ENOENT"?void 0:v(te)}v(ue).catch(X=>{})}catch(X){if(X.code!=="ENOENT")throw X}}async function v(te){return(0,P.promisify)(n.rm)(te,{recursive:!0,force:!0,maxRetries:3})}function w(te){if((0,S.$kg)(te))throw new Error("rimraf - will refuse to recursively delete root");n.rmSync(te,{recursive:!0,force:!0,maxRetries:3})}async function $(te,ue){return d(await(ue?f(te):(0,P.promisify)(n.readdir)(te)))}async function f(te){try{return await(0,P.promisify)(n.readdir)(te,{withFileTypes:!0})}catch(Q){console.warn("[node.js fs] readdir with filetypes failed with error: ",Q)}const ue=[],X=await $(te);for(const Q of X){let z=!1,M=!1,F=!1;try{const G=await e.Promises.lstat((0,h.$kc)(te,Q));z=G.isFile(),M=G.isDirectory(),F=G.isSymbolicLink()}catch(G){console.warn("[node.js fs] unexpected error from lstat after readdir: ",G)}ue.push({name:Q,isFile:()=>z,isDirectory:()=>M,isSymbolicLink:()=>F})}return ue}function l(te){return d(n.readdirSync(te))}function d(te){return te.map(ue=>typeof ue=="string"?c.$j?(0,E.$Yl)(ue):ue:(ue.name=c.$j?(0,E.$Yl)(ue.name):ue.name,ue))}async function a(te){const ue=await $(te),X=[];for(const Q of ue)await o.existsDirectory((0,h.$kc)(te,Q))&&X.push(Q);return X}function t(te,ue=1e3){return new Promise(X=>{let Q=!1;const z=setInterval(()=>{Q||(Q=!0,n.access(te,M=>{Q=!1,M&&(clearInterval(z),X(void 0))}))},ue)})}var o;(function(te){async function ue(z){let M;try{if(M=await e.Promises.lstat(z),!M.isSymbolicLink())return{stat:M}}catch{}try{return{stat:await e.Promises.stat(z),symbolicLink:M?.isSymbolicLink()?{dangling:!1}:void 0}}catch(F){if(F.code==="ENOENT"&&M)return{stat:M,symbolicLink:{dangling:!0}};if(c.$i&&F.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(z)),symbolicLink:{dangling:!1}}}catch(G){if(G.code==="ENOENT"&&M)return{stat:M,symbolicLink:{dangling:!0}};throw G}throw F}}te.stat=ue;async function X(z){try{const{stat:M,symbolicLink:F}=await te.stat(z);return M.isFile()&&F?.dangling!==!0}catch{}return!1}te.existsFile=X;async function Q(z){try{const{stat:M,symbolicLink:F}=await te.stat(z);return M.isDirectory()&&F?.dangling!==!0}catch{}return!1}te.existsDirectory=Q})(o||(e.SymlinkSupport=o={}));const r=new B.$qh;function i(te,ue,X){return r.queueFor(y.URI.file(te),()=>{const Q=D(X);return new Promise((z,M)=>b(te,ue,Q,F=>F?M(F):z()))},p.$Lg)}let s=!0;function u(te){s=te}function b(te,ue,X,Q){if(!s)return n.writeFile(te,ue,{mode:X.mode,flag:X.flag},Q);n.open(te,X.flag,X.mode,(z,M)=>{if(z)return Q(z);n.writeFile(M,ue,F=>{if(F)return n.close(M,()=>Q(F));n.fdatasync(M,G=>(G&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",G),u(!1)),n.close(M,T=>Q(T))))})})}function I(te,ue,X){const Q=D(X);if(!s)return n.writeFileSync(te,ue,{mode:Q.mode,flag:Q.flag});const z=n.openSync(te,Q.flag,Q.mode);try{n.writeFileSync(z,ue);try{n.fdatasyncSync(z)}catch(M){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",M),u(!1)}}finally{n.closeSync(z)}}function D(te){return te?{mode:typeof te.mode=="number"?te.mode:438,flag:typeof te.flag=="string"?te.flag:"w"}:{mode:438,flag:"w"}}async function R(te,ue,X=6e4){if(te!==ue)try{c.$i&&typeof X=="number"?await C(te,ue,Date.now(),X):await(0,P.promisify)(n.rename)(te,ue)}catch(Q){if(te.toLowerCase()!==ue.toLowerCase()&&Q.code==="EXDEV"||te.endsWith("."))await A(te,ue,{preserveSymlinks:!1}),await g(te,k.MOVE);else throw Q}}async function C(te,ue,X,Q,z=0){try{return await(0,P.promisify)(n.rename)(te,ue)}catch(M){if(M.code!=="EACCES"&&M.code!=="EPERM"&&M.code!=="EBUSY")throw M;if(Date.now()-X>=Q)throw console.error(`[node.js fs] rename failed after ${z} retries with error: ${M}`),M;if(z===0){let F=!1;try{const{stat:G}=await o.stat(ue);G.isFile()||(F=!0)}catch{}if(F)throw M}return await(0,B.$ih)(Math.min(100,z*10)),C(te,ue,X,Q,z+1)}}async function A(te,ue,X){return W(te,ue,{root:{source:te,target:ue},options:X,handledSourcePaths:new Set})}const L=511;async function W(te,ue,X){if(X.handledSourcePaths.has(te))return;X.handledSourcePaths.add(te);const{stat:Q,symbolicLink:z}=await o.stat(te);if(z){if(X.options.preserveSymlinks)try{return await le(te,ue,X)}catch{}if(z.dangling)return}return Q.isDirectory()?q(te,ue,Q.mode&L,X):H(te,ue,Q.mode&L)}async function q(te,ue,X,Q){await e.Promises.mkdir(ue,{recursive:!0,mode:X});const z=await $(te);for(const M of z)await W((0,h.$kc)(te,M),(0,h.$kc)(ue,M),Q)}async function H(te,ue,X){await e.Promises.copyFile(te,ue),await e.Promises.chmod(ue,X)}async function le(te,ue,X){let Q=await e.Promises.readlink(te);(0,S.$hg)(Q,X.root.source,!c.$k)&&(Q=(0,h.$kc)(X.root.target,Q.substr(X.root.source.length+1))),await e.Promises.symlink(Q,ue)}e.Promises=new class{get access(){return(0,P.promisify)(n.access)}get stat(){return(0,P.promisify)(n.stat)}get lstat(){return(0,P.promisify)(n.lstat)}get utimes(){return(0,P.promisify)(n.utimes)}get read(){return(te,ue,X,Q,z)=>new Promise((M,F)=>{n.read(te,ue,X,Q,z,(G,T,ce)=>G?F(G):M({bytesRead:T,buffer:ce}))})}get readFile(){return(0,P.promisify)(n.readFile)}get write(){return(te,ue,X,Q,z)=>new Promise((M,F)=>{n.write(te,ue,X,Q,z,(G,T,ce)=>G?F(G):M({bytesWritten:T,buffer:ce}))})}get appendFile(){return(0,P.promisify)(n.appendFile)}get fdatasync(){return(0,P.promisify)(n.fdatasync)}get truncate(){return(0,P.promisify)(n.truncate)}get copyFile(){return(0,P.promisify)(n.copyFile)}get open(){return(0,P.promisify)(n.open)}get close(){return(0,P.promisify)(n.close)}get symlink(){return(0,P.promisify)(n.symlink)}get readlink(){return(0,P.promisify)(n.readlink)}get chmod(){return(0,P.promisify)(n.chmod)}get mkdir(){return(0,P.promisify)(n.mkdir)}get unlink(){return(0,P.promisify)(n.unlink)}get rmdir(){return(0,P.promisify)(n.rmdir)}get realpath(){return(0,P.promisify)(n.realpath)}async exists(te){try{return await e.Promises.access(te),!0}catch{return!1}}get readdir(){return $}get readDirsInDir(){return a}get writeFile(){return i}get rm(){return g}get rename(){return R}get copy(){return A}}}),define(oe[109],ae([0,1,43,9,4,25,21]),function(J,e,n,j,P,B,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mq=E,e.$Nq=h,e.$Oq=c,e.$Pq=p;function E(k){if(P.$k)return k;const g=(0,j.$nc)(k);if(k===g)return k;const m=((0,j.$oc)(k)||k).toLowerCase();try{const w=(0,S.readdirSync)(g).filter($=>$.toLowerCase()===m);if(w.length===1){const $=E(g);if($)return(0,j.$kc)($,w[0])}else if(w.length>1){const $=w.indexOf(m);if($>=0){const f=E(g);if(f)return(0,j.$kc)(f,w[$])}}}catch{}return null}async function h(k,g){if(P.$k)return k;const m=(0,j.$nc)(k);if(k===m)return k;const v=((0,j.$oc)(k)||k).toLowerCase();try{if(g?.isCancellationRequested)return null;const $=(await S.Promises.readdir(m)).filter(f=>f.toLowerCase()===v);if($.length===1){const f=await h(m,g);if(f)return(0,j.$kc)(f,$[0])}else if($.length>1){const f=$.indexOf(v);if(f>=0){const l=await h(m,g);if(l)return(0,j.$kc)(l,$[f])}}}catch{}return null}async function c(k){try{return await S.Promises.realpath(k)}catch{const m=y(k);return await S.Promises.access(m,n.constants.R_OK),m}}function p(k){try{return n.realpathSync(k)}catch{const m=y(k);return n.accessSync(m,n.constants.R_OK),m}}function y(k){return(0,B.$6e)((0,j.$ic)(k),j.sep)}}),define(oe[110],ae([0,1,26,9,21]),function(J,e,n,j,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8l=f,e.$9l=l;const B=/^\d+$/,S=/^Microsoft.PowerShell_.*/,E=/^Microsoft.PowerShellPreview_.*/;var h;(function(d){d[d.x64=0]="x64",d[d.x86=1]="x86",d[d.ARM=2]="ARM"})(h||(h={}));let c;switch(process.arch){case"ia32":c=1;break;case"arm":case"arm64":c=2;break;default:c=0;break}let p;process.env.PROCESSOR_ARCHITEW6432?p=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?p=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?p=1:p=0;class y{constructor(a,t,o){this.exePath=a,this.displayName=t,this.a=o}async exists(){return this.a===void 0&&(this.a=await P.SymlinkSupport.existsFile(this.exePath)),this.a}}function k({useAlternateBitness:d=!1}={}){return d?c===0?process.env["ProgramFiles(x86)"]||null:p===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function g({useAlternateBitness:d=!1,findPreview:a=!1}={}){const t=k({useAlternateBitness:d});if(!t)return null;const o=j.$kc(t,"PowerShell");if(!await P.SymlinkSupport.existsDirectory(o))return null;let r=-1,i=null;for(const b of await P.Promises.readdir(o)){let I=-1;if(a){const R=b.indexOf("-");if(R<0)continue;const C=b.substring(0,R);if(!B.test(C)||b.substring(R+1)!=="preview")continue;I=parseInt(C,10)}else{if(!B.test(b))continue;I=parseInt(b,10)}if(I<=r)continue;const D=j.$kc(o,b,"pwsh.exe");await P.SymlinkSupport.existsFile(D)&&(i=D,r=I)}if(!i)return null;const s=t.includes("x86")?" (x86)":"",u=a?" Preview":"";return new y(i,`PowerShell${u}${s}`,!0)}async function m({findPreview:d}={}){if(!process.env.LOCALAPPDATA)return null;const a=j.$kc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await P.SymlinkSupport.existsDirectory(a))return null;const{pwshMsixDirRegex:t,pwshMsixName:o}=d?{pwshMsixDirRegex:E,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:S,pwshMsixName:"PowerShell (Store)"};for(const r of await P.Promises.readdir(a))if(t.test(r)){const i=j.$kc(a,r,"pwsh.exe");return new y(i,o)}return null}function v(){const d=j.$kc(n.homedir(),".dotnet","tools","pwsh.exe");return new y(d,".NET Core PowerShell Global Tool")}function w(){const d=j.$kc(process.env.windir,c===1&&p!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new y(d,"Windows PowerShell",!0)}async function*$(){let d=await g();d&&(yield d),d=await g({useAlternateBitness:!0}),d&&(yield d),d=await m(),d&&(yield d),d=v(),d&&(yield d),d=await g({findPreview:!0}),d&&(yield d),d=await m({findPreview:!0}),d&&(yield d),d=await g({useAlternateBitness:!0,findPreview:!0}),d&&(yield d),d=w(),d&&(yield d)}async function*f(){for await(const d of $())await d.exists()&&(yield d)}async function l(){for await(const d of f())return d;return null}}),define(oe[90],ae([0,1,9,4,36,75,12,21]),function(J,e,n,j,P,B,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$_l=h,e.$am=c,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return B.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return B.TerminateResponseCode}});function h(y=P.env){return y.comspec||"cmd.exe"}function c(y){let k=[],g=!1;const m=function(v){if(g){k.push(v);return}(!y.send(v,$=>{if($&&console.error($),g=!1,k.length>0){const f=k.slice(0);k=[],f.forEach(l=>m(l))}})||j.$i)&&(g=!0)};return{send:m}}var p;(function(y){async function k(g,m,v){if(n.$jc(g))return g;if(m===void 0&&(m=P.cwd()),n.$nc(g)!=="."||(v===void 0&&S.$Uf(P.env.PATH)&&(v=P.env.PATH.split(n.$uc)),v===void 0||v.length===0))return n.$kc(m,g);async function $(f){if(await E.Promises.exists(f)){let l;try{l=await E.Promises.stat(f)}catch(d){d.message.startsWith("EACCES")&&(l=await E.Promises.lstat(f))}return l?!l.isDirectory():!1}return!1}for(const f of v){let l;if(n.$jc(f)?l=n.$kc(f,g):l=n.$kc(m,f,g),await $(l))return l;let d=l+".com";if(await $(d)||(d=l+".exe",await $(d)))return d}return n.$kc(m,g)}y.findExecutable=k})(p||(e.win32=p={}))}),define(oe[111],ae([0,1,49,13]),function(J,e,n,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ls=P;function P(S){return new Promise((E,h)=>{let c;const p=new Map;function y(g,m,v,w,$){const f=p.get(m);if(g===S||f){const l={name:k(v),cmd:v,pid:g,ppid:m,load:w,mem:$};p.set(g,l),g===S&&(c=l),f&&(f.children||(f.children=[]),f.children.push(l),f.children.length>1&&(f.children=f.children.sort((d,a)=>d.pid-a.pid)))}}function k(g){const m=/--utility-sub-type=network/i,v=/--crashes-directory/i,w=/\\pipe\\winpty-control/i,$=/conhost\.exe.+--headless/i,f=/--type=([a-zA-Z-]+)/;if(v.exec(g))return"electron-crash-reporter";if(w.exec(g))return"winpty-agent";if($.exec(g))return"conpty-agent";let l=f.exec(g);if(l&&l.length===2)return l[1]==="renderer"?"window":l[1]==="utility"?m.exec(g)?"utility-network-service":"utility-process":l[1]==="extensionHost"?"extension-host":l[1];const d=/[a-zA-Z-]+\.js/g;let a="";do l=d.exec(g),l&&(a+=l+" ");while(l);return a&&g.indexOf("node ")<0&&g.indexOf("node.exe")<0?`electron-nodejs (${a})`:g}if(process.platform==="win32"){const g=m=>m.indexOf("\\\\?\\")===0||m.indexOf("\\??\\")===0?m.substring(4):m.indexOf('"\\\\?\\')===0||m.indexOf('"\\??\\')===0?'"'+m.substring(5):m;new Promise((m,v)=>{J(["@vscode/windows-process-tree"],m,v)}).then(m=>{m.getProcessList(S,v=>{if(!v){h(new Error(`Root process ${S} not found`));return}m.getProcessCpuUsage(v,w=>{const $=new Map;w.forEach(f=>{const l=g(f.commandLine||"");$.set(f.pid,{name:k(l),cmd:l,pid:f.pid,ppid:f.ppid,load:f.cpu||0,mem:f.memory||0})}),c=$.get(S),c?($.forEach(f=>{const l=$.get(f.ppid);l&&(l.children||(l.children=[]),l.children.push(f))}),$.forEach(f=>{f.children&&(f.children=f.children.sort((l,d)=>l.pid-d.pid))}),E(c)):h(new Error(`Root process ${S} not found`))})},m.ProcessDataFlag.CommandLine|m.ProcessDataFlag.Memory)})}else{let g=function(){let m=[c];const v=[];for(;m.length;){const $=m.shift();$&&(v.push($.pid),$.children&&(m=m.concat($.children)))}let w=JSON.stringify(j.$Bg.asFileUri("vs/base/node/cpuUsage.sh").fsPath);w+=" "+v.join(" "),(0,n.exec)(w,{},($,f,l)=>{if($||l)h($||new Error(l.toString()));else{const d=f.toString().split(`
`);for(let a=0;a<v.length;a++){const t=p.get(v[a]);t.load=parseFloat(d[a])}if(!c){h(new Error(`Root process ${S} not found`));return}E(c)}})};(0,n.exec)("which ps",{},(m,v,w)=>{if(m||w)if(process.platform!=="linux")h(m||new Error(w.toString()));else{const $=JSON.stringify(j.$Bg.asFileUri("vs/base/node/ps.sh").fsPath);(0,n.exec)($,{},(f,l,d)=>{f||d?h(f||new Error(d.toString())):(B(l,y),g())})}else{const $=v.toString().trim();(0,n.exec)(`${$} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(l,d,a)=>{l||a&&!a.includes("screen size is bogus")?h(l||new Error(a.toString())):(B(d,y),process.platform==="linux"?g():c?E(c):h(new Error(`Root process ${S} not found`)))})}})}})}function B(S,E){const h=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,c=S.toString().split(`
`);for(const p of c){const y=h.exec(p.trim());y&&y.length===6&&E(parseInt(y[1]),parseInt(y[2]),y[5],parseFloat(y[3]),parseFloat(y[4]))}}}),define(oe[112],ae([0,1,26,4,110,90]),function(J,e,n,j,P,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bm=S;async function S(y,k){return y===1?j.$i?p():B.$_l(k):h(y,k)}let E=null;function h(y,k){if(j.$k&&y===2||j.$j&&y===3)return"/bin/bash";if(!E){let g;if(j.$i)g="/bin/bash";else{if(g=k.SHELL,!g)try{g=(0,n.userInfo)().shell}catch{}g||(g="sh"),g==="/bin/false"&&(g="/bin/bash")}E=g}return E}let c=null;async function p(){return c||(c=(await(0,P.$9l)()).exePath),c}});var Ee=this&&this.__decorate||function(J,e,n,j){var P=arguments.length,B=P<3?e:j===null?j=Object.getOwnPropertyDescriptor(e,n):j,S;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")B=Reflect.decorate(J,e,n,j);else for(var E=J.length-1;E>=0;E--)(S=J[E])&&(B=(P<3?S(B):P>3?S(e,n,B):S(e,n))||B);return P>3&&B&&Object.defineProperty(e,n,B),B};define(oe[44],ae([0,1,22,8,17,23,51,15,3,2,76,25,12]),function(J,e,n,j,P,B,S,E,h,c,p,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3h=e.ProxyChannel=e.$2h=e.$Yh=e.$Xh=e.$Wh=e.RequestInitiator=e.$Vh=e.$Sh=e.$Rh=void 0,e.$Th=u,e.$Uh=b,e.$Zh=L,e.$1h=W;var g;(function(z){z[z.Promise=100]="Promise",z[z.PromiseCancel=101]="PromiseCancel",z[z.EventListen=102]="EventListen",z[z.EventDispose=103]="EventDispose"})(g||(g={}));function m(z){switch(z){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var v;(function(z){z[z.Initialize=200]="Initialize",z[z.PromiseSuccess=201]="PromiseSuccess",z[z.PromiseError=202]="PromiseError",z[z.PromiseErrorObj=203]="PromiseErrorObj",z[z.EventFire=204]="EventFire"})(v||(v={}));function w(z){switch(z){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var $;(function(z){z[z.Uninitialized=0]="Uninitialized",z[z.Idle=1]="Idle"})($||($={}));function f(z){let M=0;for(let F=0;;F+=7){const G=z.read(1);if(M|=(G.buffer[0]&127)<<F,!(G.buffer[0]&128))return M}}const l=r(0);function d(z,M){if(M===0){z.write(l);return}let F=0;for(let T=M;T!==0;T=T>>>7)F++;const G=P.$ue.alloc(F);for(let T=0;M!==0;T++)G.buffer[T]=M&127,M=M>>>7,M>0&&(G.buffer[T]|=128);z.write(G)}class a{constructor(M){this.b=M,this.a=0}read(M){const F=this.b.slice(this.a,this.a+M);return this.a+=F.byteLength,F}}e.$Rh=a;class t{constructor(){this.a=[]}get buffer(){return P.$ue.concat(this.a)}write(M){this.a.push(M)}}e.$Sh=t;var o;(function(z){z[z.Undefined=0]="Undefined",z[z.String=1]="String",z[z.Buffer=2]="Buffer",z[z.VSBuffer=3]="VSBuffer",z[z.Array=4]="Array",z[z.Object=5]="Object",z[z.Int=6]="Int"})(o||(o={}));function r(z){const M=P.$ue.alloc(1);return M.writeUInt8(z,0),M}const i={Undefined:r(o.Undefined),String:r(o.String),Buffer:r(o.Buffer),VSBuffer:r(o.VSBuffer),Array:r(o.Array),Object:r(o.Object),Uint:r(o.Int)},s=typeof Buffer<"u";function u(z,M){if(typeof M>"u")z.write(i.Undefined);else if(typeof M=="string"){const F=P.$ue.fromString(M);z.write(i.String),d(z,F.byteLength),z.write(F)}else if(s&&Buffer.isBuffer(M)){const F=P.$ue.wrap(M);z.write(i.Buffer),d(z,F.byteLength),z.write(F)}else if(M instanceof P.$ue)z.write(i.VSBuffer),d(z,M.byteLength),z.write(M);else if(Array.isArray(M)){z.write(i.Array),d(z,M.length);for(const F of M)u(z,F)}else if(typeof M=="number"&&(M|0)===M)z.write(i.Uint),d(z,M);else{const F=P.$ue.fromString(JSON.stringify(M));z.write(i.Object),d(z,F.byteLength),z.write(F)}}function b(z){switch(z.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return z.read(f(z)).toString();case o.Buffer:return z.read(f(z)).buffer;case o.VSBuffer:return z.read(f(z));case o.Array:{const F=f(z),G=[];for(let T=0;T<F;T++)G.push(b(z));return G}case o.Object:return JSON.parse(z.read(f(z)).toString());case o.Int:return f(z)}}class I{constructor(M,F,G=null,T=1e3){this.h=M,this.j=F,this.k=G,this.l=T,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ce=>this.q(ce)),this.m({type:200})}registerChannel(M,F){this.b.set(M,F),setTimeout(()=>this.w(M),0)}m(M){switch(M.type){case 200:{const F=this.o([M.type]);this.k?.logOutgoing(F,0,1,w(M.type));return}case 201:case 202:case 204:case 203:{const F=this.o([M.type,M.id],M.data);this.k?.logOutgoing(F,M.id,1,w(M.type),M.data);return}}}o(M,F=void 0){const G=new t;return u(G,M),u(G,F),this.p(G.buffer)}p(M){try{return this.h.send(M),M.byteLength}catch{return 0}}q(M){const F=new a(M),G=b(F),T=b(F),ce=G[0];switch(ce){case 100:return this.k?.logIncoming(M.byteLength,G[1],1,`${m(ce)}: ${G[2]}.${G[3]}`,T),this.s({type:ce,id:G[1],channelName:G[2],name:G[3],arg:T});case 102:return this.k?.logIncoming(M.byteLength,G[1],1,`${m(ce)}: ${G[2]}.${G[3]}`,T),this.t({type:ce,id:G[1],channelName:G[2],name:G[3],arg:T});case 101:return this.k?.logIncoming(M.byteLength,G[1],1,`${m(ce)}`),this.u({type:ce,id:G[1]});case 103:return this.k?.logIncoming(M.byteLength,G[1],1,`${m(ce)}`),this.u({type:ce,id:G[1]})}}s(M){const F=this.b.get(M.channelName);if(!F){this.v(M);return}const G=new B.$ee;let T;try{T=F.call(this.j,M.name,M.arg,G.token)}catch(K){T=Promise.reject(K)}const ce=M.id;T.then(K=>{this.m({id:ce,data:K,type:201})},K=>{K instanceof Error?this.m({id:ce,data:{message:K.message,name:K.name,stack:K.stack?K.stack.split?K.stack.split(`
`):K.stack:void 0},type:202}):this.m({id:ce,data:K,type:203})}).finally(()=>{he.dispose(),this.d.delete(M.id)});const he=(0,c.$Sc)(()=>G.cancel());this.d.set(M.id,he)}t(M){const F=this.b.get(M.channelName);if(!F){this.v(M);return}const G=M.id,ce=F.listen(this.j,M.name,M.arg)(he=>this.m({id:G,data:he,type:204}));this.d.set(M.id,ce)}u(M){const F=this.d.get(M.id);F&&(F.dispose(),this.d.delete(M.id))}v(M){let F=this.g.get(M.channelName);F||(F=[],this.g.set(M.channelName,F));const G=setTimeout(()=>{console.error(`Unknown channel: ${M.channelName}`),M.type===100&&this.m({id:M.id,data:{name:"Unknown channel",message:`Channel name '${M.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);F.push({request:M,timeoutTimer:G})}w(M){const F=this.g.get(M);if(F){for(const G of F)switch(clearTimeout(G.timeoutTimer),G.request.type){case 100:this.s(G.request);break;case 102:this.t(G.request);break}this.g.delete(M)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,c.$Pc)(this.d.values()),this.d.clear()}}e.$Vh=I;var D;(function(z){z[z.LocalSide=0]="LocalSide",z[z.OtherSide=1]="OtherSide"})(D||(e.RequestInitiator=D={}));class R{constructor(M,F=null){this.l=M,this.a=!1,this.b=$.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new h.$7d,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(G=>this.s(G)),this.j=F}getChannel(M){const F=this;return{call(G,T,ce){return F.a?Promise.reject(new E.$5):F.m(M,G,T,ce)},listen(G,T){return F.a?h.Event.None:F.o(M,G,T)}}}m(M,F,G,T=B.CancellationToken.None){const ce=this.g++,K={id:ce,type:100,channelName:M,name:F,arg:G};if(T.isCancellationRequested)return Promise.reject(new E.$5);let O;return new Promise((_,se)=>{if(T.isCancellationRequested)return se(new E.$5);const Z=()=>{const re=ee=>{switch(ee.type){case 201:this.f.delete(ce),_(ee.data);break;case 202:{this.f.delete(ce);const fe=new Error(ee.data.message);fe.stack=Array.isArray(ee.data.stack)?ee.data.stack.join(`
`):ee.data.stack,fe.name=ee.data.name,se(fe);break}case 203:this.f.delete(ce),se(ee.data);break}};this.f.set(ce,re),this.p(K)};let V=null;this.b===$.Idle?Z():(V=(0,j.$7g)(re=>this.u()),V.then(()=>{V=null,Z()}));const x=()=>{V?(V.cancel(),V=null):this.p({id:ce,type:101}),se(new E.$5)},U=T.onCancellationRequested(x);O=(0,c.$Rc)((0,c.$Sc)(x),U),this.d.add(O)}).finally(()=>{O.dispose(),this.d.delete(O)})}o(M,F,G){const T=this.g++,he={id:T,type:102,channelName:M,name:F,arg:G};let K=null;const O=new h.$7d({onWillAddFirstListener:()=>{K=(0,j.$7g)(_=>this.u()),K.then(()=>{K=null,this.d.add(O),this.p(he)})},onDidRemoveLastListener:()=>{K?(K.cancel(),K=null):(this.d.delete(O),this.p({id:T,type:103}))}}),N=_=>O.fire(_.data);return this.f.set(T,N),O.event}p(M){switch(M.type){case 100:case 102:{const F=this.q([M.type,M.id,M.channelName,M.name],M.arg);this.j?.logOutgoing(F,M.id,0,`${m(M.type)}: ${M.channelName}.${M.name}`,M.arg);return}case 101:case 103:{const F=this.q([M.type,M.id]);this.j?.logOutgoing(F,M.id,0,m(M.type));return}}}q(M,F=void 0){const G=new t;return u(G,M),u(G,F),this.r(G.buffer)}r(M){try{return this.l.send(M),M.byteLength}catch{return 0}}s(M){const F=new a(M),G=b(F),T=b(F),ce=G[0];switch(ce){case 200:return this.j?.logIncoming(M.byteLength,0,0,w(ce)),this.t({type:G[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(M.byteLength,G[1],0,w(ce),T),this.t({type:G[0],id:G[1],data:T})}}t(M){if(M.type===200){this.b=$.Idle,this.k.fire();return}this.f.get(M.id)?.(M)}get onDidInitializePromise(){return h.Event.toPromise(this.onDidInitialize)}u(){return this.b===$.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,c.$Pc)(this.d.values()),this.d.clear()}}e.$Wh=R,Ee([S.$Lh],R.prototype,"onDidInitializePromise",null);class C{get connections(){const M=[];return this.f.forEach(F=>M.push(F)),M}constructor(M){this.a=new Map,this.f=new Set,this.g=new h.$7d,this.onDidAddConnection=this.g.event,this.h=new h.$7d,this.onDidRemoveConnection=this.h.event,this.j=new c.$Tc,this.j.add(M(({protocol:F,onDidClientDisconnect:G})=>{const T=h.Event.once(F.onMessage);this.j.add(T(ce=>{const he=new a(ce),K=b(he),O=new I(F,K),N=new R(F);this.a.forEach((se,Z)=>O.registerChannel(Z,se));const _={channelServer:O,channelClient:N,ctx:K};this.f.add(_),this.g.fire(_),this.j.add(G(()=>{O.dispose(),N.dispose(),this.f.delete(_),this.h.fire(_)}))}))}))}getChannel(M,F){const G=this;return{call(T,ce,he){let K;if((0,k.$9f)(F)){const N=(0,n.$4b)(G.connections.filter(F));K=N?Promise.resolve(N):h.Event.toPromise(h.Event.filter(G.onDidAddConnection,F))}else K=F.routeCall(G,T,ce);const O=K.then(N=>N.channelClient.getChannel(M));return L(O).call(T,ce,he)},listen(T,ce){if((0,k.$9f)(F))return G.k(M,F,T,ce);const he=F.routeEvent(G,T,ce).then(K=>K.channelClient.getChannel(M));return L(he).listen(T,ce)}}}k(M,F,G,T){const ce=this;let he;const K=new h.$7d({onWillAddFirstListener:()=>{he=new c.$Tc;const O=new h.$ae,N=new Map,_=Z=>{const x=Z.channelClient.getChannel(M).listen(G,T),U=O.add(x);N.set(Z,U)},se=Z=>{const V=N.get(Z);V&&(V.dispose(),N.delete(Z))};ce.connections.filter(F).forEach(_),h.Event.filter(ce.onDidAddConnection,F)(_,void 0,he),ce.onDidRemoveConnection(se,void 0,he),O.event(K.fire,K,he),he.add(O)},onDidRemoveLastListener:()=>{he?.dispose(),he=void 0}});return K.event}registerChannel(M,F){this.a.set(M,F);for(const G of this.f)G.channelServer.registerChannel(M,F)}dispose(){this.j.dispose();for(const M of this.f)M.channelClient.dispose(),M.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$Xh=C;class A{constructor(M,F,G=null){const T=new t;u(T,F),M.send(T.buffer),this.a=new R(M,G),this.d=new I(M,F,G)}getChannel(M){return this.a.getChannel(M)}registerChannel(M,F){this.d.registerChannel(M,F)}dispose(){this.a.dispose(),this.d.dispose()}}e.$Yh=A;function L(z){return{call(M,F,G){return z.then(T=>T.call(M,F,G))},listen(M,F){const G=new h.$de;return z.then(T=>G.input=T.listen(M,F)),G.event}}}function W(z){let M=!1;return{call(F,G,T){return M?z.call(F,G,T):(0,j.$ih)(0).then(()=>M=!0).then(()=>z.call(F,G,T))},listen(F,G){if(M)return z.listen(F,G);const T=new h.$de;return(0,j.$ih)(0).then(()=>M=!0).then(()=>T.input=z.listen(F,G)),T.event}}}class q{constructor(M){this.a=M}routeCall(M){return this.b(M)}routeEvent(M){return this.b(M)}async b(M){for(const F of M.connections)if(await Promise.resolve(this.a(F.ctx)))return Promise.resolve(F);return await h.Event.toPromise(M.onDidAddConnection),await this.b(M)}}e.$2h=q;var H;(function(z){function M(ce,he,K){const O=ce,N=K&&K.disableMarshalling,_=new Map;for(const se in O)G(se)&&_.set(se,h.Event.buffer(O[se],!0,void 0,he));return new class{listen(se,Z,V){const x=_.get(Z);if(x)return x;const U=O[Z];if(typeof U=="function"){if(T(Z))return U.call(O,V);if(G(Z))return _.set(Z,h.Event.buffer(O[Z],!0,void 0,he)),_.get(Z)}throw new E.$bb(`Event not found: ${Z}`)}call(se,Z,V){const x=O[Z];if(typeof x=="function"){if(!N&&Array.isArray(V))for(let re=0;re<V.length;re++)V[re]=(0,p.$Qh)(V[re]);let U=x.apply(O,V);return U instanceof Promise||(U=Promise.resolve(U)),U}throw new E.$bb(`Method not found: ${Z}`)}}}z.fromService=M;function F(ce,he){const K=he&&he.disableMarshalling;return new Proxy({},{get(O,N){if(typeof N=="string")return he?.properties?.has(N)?he.properties.get(N):T(N)?function(_){return ce.listen(N,_)}:G(N)?ce.listen(N):async function(..._){let se;he&&!(0,k.$4f)(he.context)?se=[he.context,..._]:se=_;const Z=await ce.call(N,se);return K?Z:(0,p.$Qh)(Z)};throw new E.$bb(`Property not found: ${String(N)}`)}})}z.toService=F;function G(ce){return ce[0]==="o"&&ce[1]==="n"&&y.$kf(ce.charCodeAt(2))}function T(ce){return/^onDynamic/.test(ce)&&y.$kf(ce.charCodeAt(9))}})(H||(e.ProxyChannel=H={}));const le=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function te(z){if(Array.isArray(z))return z;if(z&&typeof z=="object"&&typeof z.toString=="function"){const M=z.toString();if(M!=="[object Object]")return M}return z}function ue(z){return Array.isArray(z)?z.map(te):te(z)}function X(z,M,F,G,T,ce,he){he=ue(he);const K=le[T],O=K[G%K.length];let N=[`%c[${z}]%c[${String(M).padStart(7," ")}]%c[len: ${String(F).padStart(5," ")}]%c${String(G).padStart(5," ")} - ${ce}`,"color: darkgreen","color: grey","color: grey",`color: ${O}`];/\($/.test(ce)?(N=N.concat(he),N.push(")")):N.push(he),console.log.apply(console,N)}class Q{constructor(M,F){this.d=M,this.f=F,this.a=0,this.b=0}logOutgoing(M,F,G,T,ce){this.b+=M,X(this.d,this.b,M,F,G,T,ce)}logIncoming(M,F,G,T,ce){this.a+=M,X(this.f,this.a,M,F,G,T,ce)}}e.$3h=Q}),define(oe[159],ae([0,1,17,3,44]),function(J,e,n,j,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6V=e.$5V=void 0;class B{constructor(h){this.a=h,this.onMessage=j.Event.fromDOMEventEmitter(this.a,"message",c=>c.data?n.$ue.wrap(c.data):n.$ue.alloc(0)),h.start()}send(h){this.a.postMessage(h.buffer)}disconnect(){this.a.close()}}e.$5V=B;class S extends P.$Yh{constructor(h,c){const p=new B(h);super(p,c),this.b=p}dispose(){this.b.disconnect(),super.dispose()}}e.$6V=S}),define(oe[113],ae([0,1,17,3,2,44]),function(J,e,n,j,P,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8h=e.$7h=e.$6h=e.$5h=e.ProtocolConstants=e.$4h=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var S;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(S||(e.SocketDiagnosticsEventType=S={}));var E;(function(i){i.enableDiagnostics=!1,i.records=[];const s=new WeakMap;let u=0;function b(D,R){if(!s.has(D)){const C=String(++u);s.set(D,C)}return s.get(D)}function I(D,R,C,A){if(!i.enableDiagnostics)return;const L=b(D,R);if(A instanceof n.$ue||A instanceof Uint8Array||A instanceof ArrayBuffer||ArrayBuffer.isView(A)){const W=n.$ue.alloc(A.byteLength);W.set(A),i.records.push({timestamp:Date.now(),id:L,label:R,type:C,buff:W})}else i.records.push({timestamp:Date.now(),id:L,label:R,type:C,data:A})}i.traceSocketEvent=I})(E||(e.SocketDiagnostics=E={}));var h;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(h||(e.SocketCloseEventType=h={}));let c=null;function p(){return c||(c=n.$ue.alloc(0)),c}class y{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(s){this.a.push(s),this.b+=s.byteLength}read(s){return this.c(s,!0)}peek(s){return this.c(s,!1)}c(s,u){if(s===0)return p();if(s>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===s){const R=this.a[0];return u&&(this.a.shift(),this.b-=s),R}if(this.a[0].byteLength>s){const R=this.a[0].slice(0,s);return u&&(this.a[0]=this.a[0].slice(s),this.b-=s),R}const b=n.$ue.alloc(s);let I=0,D=0;for(;s>0;){const R=this.a[D];if(R.byteLength>s){const C=R.slice(0,s);b.set(C,I),I+=s,u&&(this.a[D]=R.slice(s),this.b-=s),s-=s}else b.set(R,I),I+=R.byteLength,u?(this.a.shift(),this.b-=R.byteLength):D++,s-=R.byteLength}return b}}e.$4h=y;var k;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume",i[i.KeepAlive=9]="KeepAlive"})(k||(k={}));function g(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var m;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",i[i.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(m||(e.ProtocolConstants=m={}));class v{constructor(s,u,b,I){this.type=s,this.id=u,this.ack=b,this.data=I,this.writtenTime=0}get size(){return this.data.byteLength}}class w extends P.$Uc{constructor(s){super(),this.f=this.B(new j.$7d),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=s,this.b=!1,this.c=new y,this.B(this.a.onData(u=>this.acceptChunk(u))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(s);this.c.byteLength>=this.g.readLen;){const u=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=u.readUInt32BE(9),this.g.messageType=u.readUInt8(0),this.g.id=u.readUInt32BE(1),this.g.ack=u.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:g(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const b=this.g.messageType,I=this.g.id,D=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",u),this.f.fire(new v(b,I,D,u)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class ${constructor(s){this.k=null,this.a=!1,this.b=!1,this.c=s,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(s){if(this.a)return;s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const u=n.$ue.alloc(13);u.writeUInt8(s.type,0),u.writeUInt32BE(s.id,1),u.writeUInt32BE(s.ack,5),u.writeUInt32BE(s.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:g(s.type),id:s.id,ack:s.ack,messageSize:s.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",s.data),this.j(u,s.data)}g(s,u){const b=this.f===0;return this.d.push(s,u),this.f+=s.byteLength+u.byteLength,b}h(){const s=n.$ue.concat(this.d,this.f);return this.d.length=0,this.f=0,s}j(s,u){this.g(s,u)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const s=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:s.byteLength}),this.c.write(s)}}class f extends P.$Uc{constructor(s){super(),this.f=new j.$7d,this.onMessage=this.f.event,this.g=new j.$7d,this.onDidDispose=this.g.event,this.a=s,this.b=this.B(new $(this.a)),this.c=this.B(new w(this.a)),this.B(this.c.onMessage(u=>{u.type===1&&this.f.fire(u.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(s){this.b.write(new v(1,0,0,s))}}e.$5h=f;class l extends B.$Yh{static fromSocket(s,u){return new l(new f(s),u)}get onDidDispose(){return this.b.onDidDispose}constructor(s,u,b=null){super(s,u,b),this.b=s}dispose(){super.dispose();const s=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),s.end()}}e.$6h=l;class d{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new j.$7d({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(s){this.b?this.d.length>0?this.d.push(s):this.a.fire(s):this.d.push(s)}flushBuffer(){this.d=[]}}e.$7h=d;class a{constructor(s){this.data=s,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let s=0,u=this.a;for(;u;)u=u.next,s++;return s}peek(){return this.a?this.a.data:null}toArray(){const s=[];let u=0,b=this.a;for(;b;)s[u++]=b.data,b=b.next;return s}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(s){const u=new a(s);if(!this.a){this.a=u,this.b=u;return}this.b.next=u,this.b=u}}class o{static{this.a=10}static{this.b=null}static getInstance(){return o.b||(o.b=new o),o.b}constructor(){this.c=[];const s=Date.now();for(let u=0;u<o.a;u++)this.c[u]=s-1e3*u;setInterval(()=>{for(let u=o.a;u>=1;u--)this.c[u]=this.c[u-1];this.c[0]=Date.now()},1e3)}d(){const s=Date.now(),u=(1+o.a)*1e3;let b=0;for(let I=0;I<o.a;I++)s-this.c[I]<=u&&b++;return 1-b/o.a}hasHighLoad(){return this.d()>=.5}}class r{get unacknowledgedCount(){return this.c-this.d}constructor(s){this.u=new d,this.onControlMessage=this.u.event,this.v=new d,this.onMessage=this.v.event,this.w=new d,this.onDidDispose=this.w.event,this.x=new d,this.onSocketClose=this.x.event,this.y=new d,this.onSocketTimeout=this.y.event,this.s=s.loadEstimator??o.getInstance(),this.t=s.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new P.$Tc,this.o=s.socket,this.p=this.r.add(new $(this.o)),this.q=this.r.add(new w(this.o)),this.r.add(this.q.onMessage(u=>this.z(u))),this.r.add(this.o.onClose(u=>this.x.fire(u))),s.initialChunk&&this.q.acceptChunk(s.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const s=new v(5,0,0,p());this.p.write(s),this.p.flush()}sendPause(){const s=new v(7,0,0,p());this.p.write(s)}sendResume(){const s=new v(8,0,0,p());this.p.write(s)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(s,u){this.a=!0,this.r.dispose(),this.r=new P.$Tc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=s,this.p=this.r.add(new $(this.o)),this.q=this.r.add(new w(this.o)),this.r.add(this.q.onMessage(b=>this.z(b))),this.r.add(this.o.onClose(b=>this.x.fire(b))),this.q.acceptChunk(u)}endAcceptReconnection(){this.a=!1,this.h=this.g;const s=new v(3,0,this.h,p());this.p.write(s);const u=this.b.toArray();for(let b=0,I=u.length;b<I;b++)this.p.write(u[b]);this.B()}acceptDisconnect(){this.w.fire()}z(s){if(s.ack>this.d){this.d=s.ack;do{const u=this.b.peek();if(u&&u.id<=s.ack)this.b.pop();else break}while(!0)}switch(s.type){case 0:break;case 1:{if(s.id>this.g)if(s.id!==this.g+1){const u=Date.now();u-this.m>1e4&&(this.m=u,this.p.write(new v(6,0,0,p())))}else this.g=s.id,this.j=Date.now(),this.A(),this.v.fire(s.data);break}case 2:{this.u.fire(s.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const u=this.b.toArray();for(let b=0,I=u.length;b<I;b++)this.p.write(u[b]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(s){const u=++this.c;this.h=this.g;const b=new v(1,u,this.h,s);this.b.push(b),this.a||(this.p.write(b),this.B())}sendControl(s){const u=new v(2,0,0,s);this.p.write(u)}A(){if(this.g<=this.h||this.k)return;const s=Date.now()-this.j;if(s>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-s+5)}B(){if(this.c<=this.d||this.f||this.a)return;const s=this.b.peek(),u=Date.now()-s.writtenTime,b=Date.now()-this.q.lastReadTime,I=Date.now()-this.n;if(u>=2e4&&b>=2e4&&I>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:u,timeSinceLastReceivedSomeData:b});return}const D=Math.max(2e4-u,2e4-b,2e4-I,500);this.f=setTimeout(()=>{this.f=null,this.B()},D)}C(){if(this.g<=this.h)return;this.h=this.g;const s=new v(3,0,this.h,p());this.p.write(s)}D(){this.h=this.g;const s=new v(9,0,this.h,p());this.p.write(s)}}e.$8h=r}),define(oe[37],ae([0,1,14,15,13]),function(J,e,n,j,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2V=void 0;class B{constructor(){this.a=new WeakMap}on(E,h){const c=(p,...y)=>{this.b(E,p)&&h(p,...y)};return this.a.set(h,c),n.ipcMain.on(E,c),this}once(E,h){return n.ipcMain.once(E,(c,...p)=>{this.b(E,c)&&h(c,...p)}),this}handle(E,h){return n.ipcMain.handle(E,(c,...p)=>this.b(E,c)?h(c,...p):Promise.reject(`Invalid channel '${E}' or sender for ipcMain.handle() usage.`)),this}removeHandler(E){return n.ipcMain.removeHandler(E),this}removeListener(E,h){const c=this.a.get(h);return c&&(n.ipcMain.removeListener(E,c),this.a.delete(h)),this}b(E,h){if(!E||!E.startsWith("vscode:"))return(0,j.$1)(`Refused to handle ipcMain event for channel '${E}' because the channel is unknown.`),!1;const c=h.senderFrame,p=c.url;if(!p||p==="about:blank")return!0;let y="unknown";try{y=new URL(p).host}catch{return(0,j.$1)(`Refused to handle ipcMain event for channel '${E}' because of a malformed URL '${p}'.`),!1}return y!==P.$Ag?((0,j.$1)(`Refused to handle ipcMain event for channel '${E}' because of a bad origin of '${y}'.`),!1):c.parent!==null?((0,j.$1)(`Refused to handle ipcMain event for channel '${E}' because sender of origin '${y}' is not a main frame.`),!1):!0}}e.$2V=new B}),define(oe[160],ae([0,1,14,37,148]),function(J,e,n,j,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3V=B;function B(){j.$2V.on(P.$ZV,(E,h,c,p,y)=>{const k=S(E,p,c);k.popup({x:y?y.x:void 0,y:y?y.y:void 0,positioningItem:y?y.positioningItem:void 0,callback:()=>{k&&E.sender.send(P.$1V,h)}})})}function S(E,h,c){const p=new n.Menu;return c.forEach(y=>{let k;y.type==="separator"?k=new n.MenuItem({type:y.type}):Array.isArray(y.submenu)?k=new n.MenuItem({submenu:S(E,h,y.submenu),label:y.label}):k=new n.MenuItem({label:y.label,type:y.type,accelerator:y.accelerator,checked:y.checked,enabled:y.enabled,visible:y.visible,click:(g,m,v)=>E.sender.send(h,y.id,v)}),p.append(k)}),p}}),define(oe[161],ae([0,1,37,17,3,2,44,149]),function(J,e,n,j,P,B,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9V=void 0;function h(p,y){const k=P.Event.fromNodeEventEmitter(n.$2V,y,(m,v)=>({event:m,message:v})),g=P.Event.filter(k,({event:m})=>m.sender.id===p);return P.Event.map(g,({message:m})=>m&&j.$ue.wrap(m))}class c extends S.$Xh{static{this.b=new Map}static d(){const y=P.Event.fromNodeEventEmitter(n.$2V,"vscode:hello",({sender:k})=>k);return P.Event.map(y,k=>{const g=k.id;c.b.get(g)?.dispose();const v=new P.$7d;c.b.set(g,(0,B.$Sc)(()=>v.fire()));const w=h(g,"vscode:message"),$=P.Event.any(P.Event.signal(h(g,"vscode:disconnect")),v.event);return{protocol:new E.$8V(k,w),onDidClientDisconnect:$}})}constructor(){super(c.d())}}e.$9V=c}),define(oe[114],ae([0,1,37,3,33,159]),function(J,e,n,j,P,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0V=void 0,e.$$V=E;class S extends B.$6V{constructor(c,p){super({addEventListener:(y,k)=>c.addListener(y,k),removeEventListener:(y,k)=>c.removeListener(y,k),postMessage:y=>c.postMessage(y),start:()=>c.start(),close:()=>c.close()},p)}}e.$0V=S;async function E(h){if(h.isDestroyed()||h.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const c=(0,P.$Dg)();h.webContents.send("vscode:createMessageChannel",c);const p=j.Event.fromNodeEventEmitter(n.$2V,"vscode:createMessageChannelResult",(k,g)=>({nonce:g,port:k.ports[0]})),{port:y}=await j.Event.toPromise(j.Event.once(j.Event.filter(p,k=>k.nonce===c)));return y}}),define(oe[162],ae([0,1,49,8,17,23,156,15,3,2,35,90,75,44]),function(J,e,n,j,P,B,S,E,h,c,p,y,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jq=e.$Iq=void 0;class m extends g.$Vh{constructor($){super({send:f=>{try{process.send?.(f.buffer.toString("base64"))}catch{}},onMessage:h.Event.fromNodeEventEmitter(process,"message",f=>P.$ue.wrap(Buffer.from(f,"base64")))},$),process.once("disconnect",()=>this.dispose())}}e.$Iq=m;class v{constructor($,f){this.i=$,this.j=f,this.c=new Set,this.g=new Map,this.h=new h.$7d,this.onDidProcessExit=this.h.event;const l=f&&f.timeout?f.timeout:6e4;this.b=new j.$eh(l),this.d=null,this.f=null}getChannel($){const f=this;return{call(l,d,a){return f.k($,l,d,a)},listen(l,d){return f.l($,l,d)}}}k($,f,l,d=B.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(d.isCancellationRequested)return Promise.reject(E.$6());this.b.cancel();const a=this.n($),t=(0,j.$7g)(i=>a.call(f,l,i)),o=d.onCancellationRequested(()=>t.cancel()),r=(0,c.$Sc)(()=>t.cancel());return this.c.add(r),t.finally(()=>{o.dispose(),this.c.delete(r),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l($,f,l){if(!this.b)return h.Event.None;this.b.cancel();let d;const a=new h.$7d({onWillAddFirstListener:()=>{d=this.n($).listen(f,l)(a.fire,a),this.c.add(d)},onDidRemoveLastListener:()=>{this.c.delete(d),d.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return a.event}get m(){if(!this.f){const $=this.j&&this.j.args?this.j.args:[],f=Object.create(null);f.env={...(0,p.$Nn)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(f.env={...f.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(f.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(f.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(f.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),f.execArgv===void 0&&(f.execArgv=process.execArgv.filter(s=>!/^--inspect(-brk)?=/.test(s)).filter(s=>!s.startsWith("--vscode-"))),(0,k.$$l)(f.env),this.d=(0,n.fork)(this.i,$,f);const l=new h.$7d;h.Event.fromNodeEventEmitter(this.d,"message",s=>s)(s=>{if((0,S.$Eq)(s)){(0,S.log)(s,`IPC Library: ${this.j.serverName}`);return}l.fire(P.$ue.wrap(Buffer.from(s,"base64")))});const a=this.j.useQueue?(0,y.$am)(this.d):this.d,t=s=>this.d&&this.d.connected&&a.send(s.buffer.toString("base64")),o=l.event,r={send:t,onMessage:o};this.f=new g.$Wh(r);const i=()=>this.o();process.once("exit",i),this.d.on("error",s=>console.warn('IPC "'+this.j.serverName+'" errored with '+s)),this.d.on("exit",(s,u)=>{process.removeListener("exit",i),this.c.forEach(b=>(0,c.$Pc)(b)),this.c.clear(),s!==0&&u!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+s+" and signal "+u),this.b?.cancel(),this.o(),this.h.fire({code:s,signal:u})})}return this.f}n($){let f=this.g.get($);return f||(f=this.m.getChannel($),this.g.set($,f)),f}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Jq=v}),define(oe[115],ae([0,1,8,3,2,76,12]),function(J,e,n,j,P,B,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ip=e.$Hp=e.StorageState=e.StorageHint=void 0,e.$Gp=h;var E;(function(k){k[k.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",k[k.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(E||(e.StorageHint=E={}));function h(k){const g=k;return g?.changed instanceof Map||g?.deleted instanceof Set}var c;(function(k){k[k.None=0]="None",k[k.Initialized=1]="Initialized",k[k.Closed=2]="Closed"})(c||(e.StorageState=c={}));class p extends P.$Uc{static{this.a=100}constructor(g,m=Object.create(null)){super(),this.r=g,this.s=m,this.b=this.B(new j.$0d),this.onDidChangeStorage=this.b.event,this.c=c.None,this.f=new Map,this.g=this.B(new n.$fh(p.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(g=>this.u(g)))}u(g){this.b.pause();try{g.changed?.forEach((m,v)=>this.w(v,m)),g.deleted?.forEach(m=>this.w(m,void 0))}finally{this.b.resume()}}w(g,m){if(this.c===c.Closed)return;let v=!1;(0,S.$4f)(m)?v=this.f.delete(g):this.f.get(g)!==m&&(this.f.set(g,m),v=!0),v&&this.b.fire({key:g,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===c.None&&(this.c=c.Initialized,this.s.hint!==E.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(g,m){const v=this.f.get(g);return(0,S.$4f)(v)?m:v}getBoolean(g,m){const v=this.get(g);return(0,S.$4f)(v)?m:v==="true"}getNumber(g,m){const v=this.get(g);return(0,S.$4f)(v)?m:parseInt(v,10)}getObject(g,m){const v=this.get(g);return(0,S.$4f)(v)?m:(0,B.$Ph)(v)}async set(g,m,v=!1){if(this.c===c.Closed)return;if((0,S.$4f)(m))return this.delete(g,v);const w=(0,S.$Wf)(m)||Array.isArray(m)?(0,B.$Oh)(m):String(m);if(this.f.get(g)!==w)return this.f.set(g,w),this.j.set(g,w),this.h.delete(g),this.b.fire({key:g,external:v}),this.D()}async delete(g,m=!1){if(!(this.c===c.Closed||!this.f.delete(g)))return this.h.has(g)||this.h.add(g),this.j.delete(g),this.b.fire({key:g,external:m}),this.D()}async optimize(){if(this.c!==c.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=c.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const g={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(g).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(g){if(this.z)return this.D(g)}async D(g){return this.s.hint===E.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),g)}async whenFlushed(){if(this.z)return new Promise(g=>this.n.push(g))}isInMemory(){return this.s.hint===E.STORAGE_IN_MEMORY}}e.$Hp=p;class y{constructor(){this.onDidChangeItemsExternal=j.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(g){g.insert?.forEach((m,v)=>this.a.set(v,m)),g.delete?.forEach(m=>this.a.delete(m))}async optimize(){}async close(){}}e.$Ip=y}),define(oe[163],ae([0,1,8,3,32,9,21]),function(J,e,n,j,P,B,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uW=void 0;class E{static{this.IN_MEMORY_PATH=":memory:"}get onDidChangeItemsExternal(){return j.Event.None}static{this.a=2e3}static{this.b=256}constructor(p,y=Object.create(null)){this.g=p,this.h=y,this.c=(0,B.$oc)(this.g),this.d=new h(this.h.logging),this.f=this.n(this.g)}async getItems(){const p=await this.f,y=new Map;return(await this.s(p,"SELECT * FROM ItemTable")).forEach(g=>y.set(g.key,g.value)),this.d.isTracing&&this.d.trace(`[storage ${this.c}] getItems(): ${y.size} rows`),y}async updateItems(p){const y=await this.f;return this.j(y,p)}j(p,y){return this.d.isTracing&&this.d.trace(`[storage ${this.c}] updateItems(): insert(${y.insert?(0,P.$zc)(y.insert):"0"}), delete(${y.delete?(0,P.$Ac)(y.delete):"0"})`),this.t(p,()=>{const k=y.insert,g=y.delete;if(k&&k.size>0){const m=[];m.push([]);let v=0;k.forEach((w,$)=>{let f=m[v];f.length>E.b&&(v++,f=[],m.push(f)),f.push($,w)}),m.forEach(w=>{this.u(p,`INSERT INTO ItemTable VALUES ${new Array(w.length/2).fill("(?,?)").join(",")}`,$=>$.run(w),()=>{const $=[];let f=0;return k.forEach((l,d)=>{$.push(d),f+=l.length}),`Keys: ${$.join(", ")} Length: ${f}`})})}if(g&&g.size){const m=[];m.push([]);let v=0;g.forEach(w=>{let $=m[v];$.length>E.b&&(v++,$=[],m.push($)),$.push(w)}),m.forEach(w=>{this.u(p,`DELETE FROM ItemTable WHERE key IN (${new Array(w.length).fill("?").join(",")})`,$=>$.run(w),()=>{const $=[];return g.forEach(f=>{$.push(f)}),`Keys: ${$.join(", ")}`})})}})}async optimize(){this.d.trace(`[storage ${this.c}] vacuum()`);const p=await this.f;return this.q(p,"VACUUM")}async close(p){this.d.trace(`[storage ${this.c}] close()`);const y=await this.f;return this.k(y,p)}k(p,y){return new Promise((k,g)=>{p.db.close(m=>(m&&this.o(p,`[storage ${this.c}] close(): ${m}`),this.g===E.IN_MEMORY_PATH?k():!p.isErroneous&&!p.isInMemory?this.l().then(k,v=>(this.d.error(`[storage ${this.c}] backup(): ${v}`),k())):typeof y=="function"?S.Promises.unlink(this.g).then(()=>this.p(this.g).then(v=>{const w=()=>this.k(v,void 0);return this.j(v,{insert:y()}).then(()=>w(),$=>(w(),Promise.reject($)))})).then(k,g):g(m||new Error("Database has errors or is in-memory without recovery option"))))})}l(){const p=this.m(this.g);return S.Promises.copy(this.g,p,{preserveSymlinks:!1})}m(p){return`${p}.backup`}async checkIntegrity(p){this.d.trace(`[storage ${this.c}] checkIntegrity(full: ${p})`);const y=await this.f,k=await this.r(y,p?"PRAGMA integrity_check":"PRAGMA quick_check"),g=p?k.integrity_check:k.quick_check;return y.isErroneous?`${g} (last error: ${y.lastError})`:y.isInMemory?`${g} (in-memory!)`:g}async n(p,y=!0){this.d.trace(`[storage ${this.c}] open(${p}, retryOnBusy: ${y})`);try{return await this.p(p)}catch(k){if(this.d.error(`[storage ${this.c}] open(): Unable to open DB due to ${k}`),k.code==="SQLITE_BUSY"&&y)return await(0,n.$ih)(E.a),this.n(p,!1);try{await S.Promises.unlink(p);try{await S.Promises.rename(this.m(p),p,!1)}catch{}return await this.p(p)}catch(g){return this.d.error(`[storage ${this.c}] open(): Unable to use backup due to ${g}`),this.p(E.IN_MEMORY_PATH)}}}o(p,y){p.isErroneous=!0,p.lastError=y,this.d.error(y)}p(p){return new Promise((y,k)=>{new Promise((g,m)=>{J(["@vscode/sqlite3"],g,m)}).then(g=>{const m={db:new(this.d.isTracing?g.verbose().Database:g.Database)(p,v=>v?m.db&&v.code!=="SQLITE_CANTOPEN"?m.db.close(()=>k(v)):k(v):this.q(m,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>y(m),w=>m.db.close(()=>k(w)))),isInMemory:p===E.IN_MEMORY_PATH};m.db.on("error",v=>this.o(m,`[storage ${this.c}] Error (event): ${v}`)),this.d.isTracing&&m.db.on("trace",v=>this.d.trace(`[storage ${this.c}] Trace (event): ${v}`))},k)})}q(p,y){return new Promise((k,g)=>{p.db.exec(y,m=>m?(this.o(p,`[storage ${this.c}] exec(): ${m}`),g(m)):k())})}r(p,y){return new Promise((k,g)=>{p.db.get(y,(m,v)=>m?(this.o(p,`[storage ${this.c}] get(): ${m}`),g(m)):k(v))})}s(p,y){return new Promise((k,g)=>{p.db.all(y,(m,v)=>m?(this.o(p,`[storage ${this.c}] all(): ${m}`),g(m)):k(v))})}t(p,y){return new Promise((k,g)=>{p.db.serialize(()=>{p.db.run("BEGIN TRANSACTION"),y(),p.db.run("END TRANSACTION",m=>m?(this.o(p,`[storage ${this.c}] transaction(): ${m}`),g(m)):k())})})}u(p,y,k,g){const m=p.db.prepare(y),v=w=>{this.o(p,`[storage ${this.c}] prepare(): ${w} (${y}). Details: ${g()}`)};m.on("error",v),k(m),m.finalize(w=>{w&&v(w),m.removeListener("error",v)})}}e.$uW=E;class h{static{this.a="VSCODE_TRACE_STORAGE"}constructor(p){p&&typeof p.logTrace=="function"&&process.env[h.a]&&(this.b=p.logTrace),p&&typeof p.logError=="function"&&(this.c=p.logError)}get isTracing(){return!!this.b}trace(p){this.b?.(p)}error(p){this.c?.(p)}}}),define(oe[164],ae([11,10]),function(J,e){return J.create("vs/code/electron-main/app",e)}),define(oe[165],ae([11,10]),function(J,e){return J.create("vs/platform/configuration/common/configurationRegistry",e)}),define(oe[166],ae([11,10]),function(J,e){return J.create("vs/platform/contextkey/common/contextkey",e)}),define(oe[167],ae([11,10]),function(J,e){return J.create("vs/platform/contextkey/common/scanner",e)}),define(oe[168],ae([11,10]),function(J,e){return J.create("vs/platform/dialogs/common/dialogs",e)}),define(oe[169],ae([11,10]),function(J,e){return J.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(oe[170],ae([11,10]),function(J,e){return J.create("vs/platform/environment/node/argv",e)}),define(oe[171],ae([11,10]),function(J,e){return J.create("vs/platform/environment/node/argvHelper",e)}),define(oe[172],ae([11,10]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(oe[173],ae([11,10]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(oe[174],ae([11,10]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(oe[175],ae([11,10]),function(J,e){return J.create("vs/platform/extensions/common/extensionValidator",e)}),define(oe[176],ae([11,10]),function(J,e){return J.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(oe[177],ae([11,10]),function(J,e){return J.create("vs/platform/files/common/fileService",e)}),define(oe[178],ae([11,10]),function(J,e){return J.create("vs/platform/files/common/files",e)}),define(oe[179],ae([11,10]),function(J,e){return J.create("vs/platform/files/common/io",e)}),define(oe[180],ae([11,10]),function(J,e){return J.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(oe[181],ae([11,10]),function(J,e){return J.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(oe[182],ae([11,10]),function(J,e){return J.create("vs/platform/issue/electron-main/issueMainService",e)}),define(oe[183],ae([11,10]),function(J,e){return J.create("vs/platform/log/common/log",e)}),define(oe[184],ae([11,10]),function(J,e){return J.create("vs/platform/menubar/electron-main/menubar",e)}),define(oe[185],ae([11,10]),function(J,e){return J.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(oe[186],ae([11,10]),function(J,e){return J.create("vs/platform/request/common/request",e)}),define(oe[187],ae([11,10]),function(J,e){return J.create("vs/platform/shell/node/shellEnv",e)}),define(oe[188],ae([11,10]),function(J,e){return J.create("vs/platform/telemetry/common/telemetryService",e)}),define(oe[189],ae([11,10]),function(J,e){return J.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(oe[190],ae([11,10]),function(J,e){return J.create("vs/platform/terminal/common/terminalProfiles",e)}),define(oe[191],ae([11,10]),function(J,e){return J.create("vs/platform/update/common/update.config.contribution",e)}),define(oe[192],ae([11,10]),function(J,e){return J.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(oe[193],ae([11,10]),function(J,e){return J.create("vs/platform/windows/electron-main/windowImpl",e)}),define(oe[194],ae([11,10]),function(J,e){return J.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(oe[195],ae([11,10]),function(J,e){return J.create("vs/platform/workspace/common/workspace",e)}),define(oe[196],ae([11,10]),function(J,e){return J.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(oe[197],ae([11,10]),function(J,e){return J.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(oe[198],ae([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zeb=n,e.$Aeb=j;function n(P){return P&&P.hasOwnProperty("folderUri")}function j(P){return P&&P.hasOwnProperty("workspace")}}),define(oe[199],ae([0,1,7]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E_b=j,e.$F_b=P,e.$G_b=B;function j(S){return typeof S?.backupFolder=="string"}function P(S){let E=[];try{Array.isArray(S.workspaces)&&(E=S.workspaces.map(h=>({workspace:{id:h.id,configPath:n.URI.parse(h.configURIPath)},remoteAuthority:h.remoteAuthority})))}catch{}return E}function B(S){let E=[];try{Array.isArray(S.folders)&&(E=S.folders.map(h=>({folderUri:n.URI.parse(h.folderUri),remoteAuthority:h.remoteAuthority})))}catch{}return E}}),define(oe[200],ae([0,1,15,167]),function(J,e,n,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cj=e.TokenType=void 0;var P;(function(c){c[c.LParen=0]="LParen",c[c.RParen=1]="RParen",c[c.Neg=2]="Neg",c[c.Eq=3]="Eq",c[c.NotEq=4]="NotEq",c[c.Lt=5]="Lt",c[c.LtEq=6]="LtEq",c[c.Gt=7]="Gt",c[c.GtEq=8]="GtEq",c[c.RegexOp=9]="RegexOp",c[c.RegexStr=10]="RegexStr",c[c.True=11]="True",c[c.False=12]="False",c[c.In=13]="In",c[c.Not=14]="Not",c[c.And=15]="And",c[c.Or=16]="Or",c[c.Str=17]="Str",c[c.QuotedStr=18]="QuotedStr",c[c.Error=19]="Error",c[c.EOF=20]="EOF"})(P||(e.TokenType=P={}));function B(...c){switch(c.length){case 1:return(0,j.localize)(0,null,c[0]);case 2:return(0,j.localize)(1,null,c[0],c[1]);case 3:return(0,j.localize)(2,null,c[0],c[1],c[2]);default:return}}const S=(0,j.localize)(3,null),E=(0,j.localize)(4,null);class h{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(p){switch(p.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return p.isTripleEq?"===":"==";case 4:return p.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return p.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return p.lexeme;case 18:return p.lexeme;case 19:return p.lexeme;case 20:return"EOF";default:throw(0,n.$8)(`unhandled token type: ${JSON.stringify(p)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(p=>p.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(p){return this.c=p,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const y=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:y})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const y=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:y})}else this.h(126)?this.k(9):this.l(B("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(B("&&"));break;case 124:this.h(124)?this.k(16):this.l(B("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(p){return this.r()||this.c.charCodeAt(this.e)!==p?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(p){this.f.push({type:p,offset:this.d})}l(p){const y=this.d,k=this.c.substring(this.d,this.e),g={type:19,offset:this.d,lexeme:k};this.g.push({offset:y,lexeme:k,additionalInfo:p}),this.f.push(g)}n(){this.m.lastIndex=this.d;const p=this.m.exec(this.c);if(p){this.e=this.d+p[0].length;const y=this.c.substring(this.d,this.e),k=h.b.get(y);k?this.k(k):this.f.push({type:17,lexeme:y,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(S);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let p=this.e,y=!1,k=!1;for(;;){if(p>=this.c.length){this.e=p,this.l(E);return}const m=this.c.charCodeAt(p);if(y)y=!1;else if(m===47&&!k){p++;break}else m===91?k=!0:m===92?y=!0:m===93&&(k=!1);p++}for(;p<this.c.length&&h.a.has(this.c.charCodeAt(p));)p++;this.e=p;const g=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:g,offset:this.d})}r(){return this.e>=this.c.length}}e.$cj=h}),define(oe[201],ae([0,1,3,2]),function(J,e,n,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uo=e.$to=void 0;class P{constructor(){this.a=new n.$7d,this.b=new n.$7d,this.c=new n.$7d,this.d=new n.$7d}static{this.ChannelName="extensionhostdebugservice"}call(E,h,c){switch(h){case"close":return Promise.resolve(this.a.fire({sessionId:c[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:c[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:c[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:c[0],port:c[1],subId:c[2]}))}throw new Error("Method not implemented.")}listen(E,h,c){switch(h){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.$to=P;class B extends j.$Uc{constructor(E){super(),this.b=E}reload(E){this.b.call("reload",[E])}get onReload(){return this.b.listen("reload")}close(E){this.b.call("close",[E])}get onClose(){return this.b.listen("close")}attachSession(E,h,c){this.b.call("attach",[E,h,c])}get onAttachSession(){return this.b.listen("attach")}terminateSession(E,h){this.b.call("terminate",[E,h])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(E,h){return this.b.call("openExtensionDevelopmentHostWindow",[E,h])}}e.$uo=B}),define(oe[202],ae([0,1,151,51,13,9,36,19,7]),function(J,e,n,j,P,B,S,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qm=e.$Pm=void 0,e.$Rm=p,e.$Sm=y,e.$Pm=/^([^.]+\..+)[:=](.+)$/;class c{get appRoot(){return(0,B.$nc)(P.$Bg.asFileUri("").fsPath)}get userHome(){return h.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return h.URI.file((0,B.$kc)(this.userDataPath,"User"))}get tmpDir(){return h.URI.file(this.b.tmpDir)}get cacheHome(){return h.URI.file(this.userDataPath)}get stateResource(){return(0,E.$Ug)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:P.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,E.$Ug)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const g=(0,n.$Om)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,B.$kc)(this.userDataPath,"logs",g)}return h.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,E.$Ug)(h.URI.file((0,B.$kc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,E.$Ug)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,E.$Ug)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,E.$Ug)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const g=S.env.VSCODE_PORTABLE;return g?h.URI.file((0,B.$kc)(g,"argv.json")):(0,E.$Ug)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return h.URI.file((0,B.$kc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const g=this.args["builtin-extensions-dir"];return g?(0,B.$lc)(g):(0,B.$ic)((0,B.$kc)(P.$Bg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const g=this.args["extensions-download-dir"];return g?h.URI.file((0,B.$lc)(g)):h.URI.file((0,B.$kc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const g=this.args["extensions-dir"];if(g)return(0,B.$lc)(g);const m=S.env.VSCODE_EXTENSIONS;if(m)return m;const v=S.env.VSCODE_PORTABLE;return v?(0,B.$kc)(v,"extensions"):(0,E.$Ug)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const g=this.args.extensionDevelopmentPath;if(Array.isArray(g))return g.map(m=>/^[^:/?#]+?:\/\//.test(m)?h.URI.parse(m):h.URI.file((0,B.$ic)(m)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(g=>g==="ui"||g==="workspace"||g==="web"?g:"workspace")}get extensionTestsLocationURI(){const g=this.args.extensionTestsPath;if(g)return/^[^:/?#]+?:\/\//.test(g)?h.URI.parse(g):h.URI.file((0,B.$ic)(g))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const g=this.args["disable-extension"];if(g){if(typeof g=="string")return[g];if(Array.isArray(g)&&g.length>0)return g}return!1}get debugExtensionHost(){return p(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!S.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(g=>!e.$Pm.test(g))}get extensionLogLevel(){const g=[];for(const m of this.args.log||[]){const v=e.$Pm.exec(m);v&&v[1]&&v[2]&&g.push([v[1],v[2]])}return g.length?g:void 0}get serviceMachineIdResource(){return(0,E.$Ug)(h.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const g=S.env.VSCODE_PORTABLE;return g?h.URI.file((0,B.$kc)(g,"policy.json")):(0,E.$Ug)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(g){this.args.continueOn=g}get args(){return this.a}constructor(g,m,v){this.a=g,this.b=m,this.c=v,this.editSessionId=this.args.editSessionId}}e.$Qm=c,Ee([j.$Lh],c.prototype,"appRoot",null),Ee([j.$Lh],c.prototype,"userHome",null),Ee([j.$Lh],c.prototype,"userDataPath",null),Ee([j.$Lh],c.prototype,"appSettingsHome",null),Ee([j.$Lh],c.prototype,"tmpDir",null),Ee([j.$Lh],c.prototype,"cacheHome",null),Ee([j.$Lh],c.prototype,"stateResource",null),Ee([j.$Lh],c.prototype,"userRoamingDataHome",null),Ee([j.$Lh],c.prototype,"userDataSyncHome",null),Ee([j.$Lh],c.prototype,"sync",null),Ee([j.$Lh],c.prototype,"machineSettingsResource",null),Ee([j.$Lh],c.prototype,"workspaceStorageHome",null),Ee([j.$Lh],c.prototype,"localHistoryHome",null),Ee([j.$Lh],c.prototype,"keyboardLayoutResource",null),Ee([j.$Lh],c.prototype,"argvResource",null),Ee([j.$Lh],c.prototype,"isExtensionDevelopment",null),Ee([j.$Lh],c.prototype,"untitledWorkspacesHome",null),Ee([j.$Lh],c.prototype,"builtinExtensionsPath",null),Ee([j.$Lh],c.prototype,"extensionsPath",null),Ee([j.$Lh],c.prototype,"extensionDevelopmentLocationURI",null),Ee([j.$Lh],c.prototype,"extensionDevelopmentKind",null),Ee([j.$Lh],c.prototype,"extensionTestsLocationURI",null),Ee([j.$Lh],c.prototype,"debugExtensionHost",null),Ee([j.$Lh],c.prototype,"logLevel",null),Ee([j.$Lh],c.prototype,"extensionLogLevel",null),Ee([j.$Lh],c.prototype,"serviceMachineIdResource",null),Ee([j.$Lh],c.prototype,"disableTelemetry",null),Ee([j.$Lh],c.prototype,"disableWorkspaceTrust",null),Ee([j.$Lh],c.prototype,"useInMemorySecretStorage",null),Ee([j.$Lh],c.prototype,"policyFile",null);function p(k,g){return y(k["inspect-extensions"],k["inspect-brk-extensions"],5870,g,k.debugId,k.extensionEnvironment)}function y(k,g,m,v,w,$){const l=Number(g||k)||(v?null:m),d=l?!!g:!1;let a;if($)try{a=JSON.parse($)}catch{}return{port:l,break:d,debugId:w,env:a}}}),define(oe[116],ae([0,1,313,4,170]),function(J,e,n,j,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dm=e.$cm=void 0,e.$em=E,e.$fm=c,e.$gm=g,e.$hm=m;const B={o:(0,P.localize)(0,null),e:(0,P.localize)(1,null),t:(0,P.localize)(2,null)};e.$cm=["tunnel","serve-web"],e.$dm={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,P.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Run a server that displays the editor UI in browsers.",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,P.localize)(4,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,P.localize)(5,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,P.localize)(6,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,P.localize)(7,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,P.localize)(8,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,P.localize)(9,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,P.localize)(10,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,P.localize)(11,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,P.localize)(12,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,P.localize)(13,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,P.localize)(14,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,P.localize)(15,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,P.localize)(16,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,P.localize)(17,null)},"show-versions":{type:"boolean",cat:"e",description:(0,P.localize)(18,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,P.localize)(19,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,P.localize)(20,null)},"pre-release":{type:"boolean",cat:"e",description:(0,P.localize)(21,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,P.localize)(22,null)},"update-extensions":{type:"boolean",cat:"e",description:(0,P.localize)(23,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,P.localize)(24,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,P.localize)(25,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,P.localize)(26,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,P.localize)(27,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,P.localize)(28,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,P.localize)(29,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,P.localize)(30,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,P.localize)(31,null)},sync:{type:"string",cat:"t",description:(0,P.localize)(32,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,P.localize)(33,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,P.localize)(34,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,P.localize)(35,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,P.localize)(36,null)},sandbox:{type:"boolean"},telemetry:{type:"boolean",cat:"t",description:(0,P.localize)(37,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"preserve-env":{type:"boolean"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const S={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function E(v,w,$=S){const f=v.find(u=>u.length>0&&u[0]!=="-"),l={},d=["_"],a=[],t={};let o;for(const u in w){const b=w[u];b.type==="subcommand"?u===f&&(o=b):(b.alias&&(l[u]=b.alias),b.type==="string"||b.type==="string[]"?(d.push(u),b.deprecates&&d.push(...b.deprecates)):b.type==="boolean"&&(a.push(u),b.deprecates&&a.push(...b.deprecates)),b.global&&(t[u]=b))}if(o&&f){const u=t;for(const R in o.options)u[R]=o.options[R];const b=v.filter(R=>R!==f),I=$.getSubcommandReporter?$.getSubcommandReporter(f):void 0,D=E(b,u,I);return{[f]:D,_:[]}}const r=n(v,{string:d,boolean:a,alias:l}),i={},s=r;i._=r._.map(u=>String(u)).filter(u=>u.length>0),delete s._;for(const u in w){const b=w[u];if(b.type==="subcommand")continue;b.alias&&delete s[b.alias];let I=s[u];if(b.deprecates)for(const D of b.deprecates)s.hasOwnProperty(D)&&(I||(I=s[D],I&&$.onDeprecatedOption(D,b.deprecationMessage||(0,P.localize)(38,null,u))),delete s[D]);if(typeof I<"u"){if(b.type==="string[]"){if(Array.isArray(I)||(I=[I]),!b.allowEmptyValue){const D=I.filter(R=>R.length>0);D.length!==I.length&&($.onEmptyValue(u),I=D.length>0?D:void 0)}}else b.type==="string"&&(Array.isArray(I)?(I=I.pop(),$.onMultipleValues(u,I)):!I&&!b.allowEmptyValue&&($.onEmptyValue(u),I=void 0));i[u]=I,b.deprecationMessage&&$.onDeprecatedOption(u,b.deprecationMessage)}delete s[u]}for(const u in s)$.onUnknownOption(u);return i}function h(v,w){let $="";return w.args&&(Array.isArray(w.args)?$=` <${w.args.join("> <")}>`:$=` <${w.args}>`),w.alias?`-${w.alias} --${v}${$}`:`--${v}${$}`}function c(v,w){const $=[];for(const f in v){const l=v[f],d=h(f,l);$.push([d,l.description])}return p($,w)}function p(v,w){const f=v.reduce((a,t)=>Math.max(a,t[0].length),12)+2+1;if(w-f<25)return v.reduce((a,t)=>a.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);const l=w-f-1,d=[];for(const a of v){const t=a[0],o=k(a[1],l),r=y(f-t.length-2);d.push("  "+t+r+o[0]);for(let i=1;i<o.length;i++)d.push(y(f)+o[i])}return d}function y(v){return" ".repeat(v)}function k(v,w){const $=[];for(;v.length;){const f=v.length<w?v.length:v.lastIndexOf(" ",w),l=v.slice(0,f).trim();v=v.slice(f),$.push(l)}return $}function g(v,w,$,f,l){const d=process.stdout.isTTY&&process.stdout.columns||80,a=l?.noInputFiles!==!0?`[${(0,P.localize)(39,null)}...]`:"",t=[`${v} ${$}`];t.push(""),t.push(`${(0,P.localize)(40,null)}: ${w} [${(0,P.localize)(41,null)}]${a}`),t.push(""),l?.noPipe!==!0&&(j.$i?t.push((0,P.localize)(42,null,w)):t.push((0,P.localize)(43,null,w)),t.push(""));const o={},r=[];for(const i in f){const s=f[i];if(s.type==="subcommand")s.description&&r.push({command:i,description:s.description});else if(s.description&&s.cat){let u=o[s.cat];u||(o[s.cat]=u={}),u[i]=s}}for(const i in o){const s=i,u=o[s];u&&(t.push(B[s]),t.push(...c(u,d)),t.push(""))}return r.length&&(t.push((0,P.localize)(44,null)),t.push(...p(r.map(i=>[i.command,i.description]),d)),t.push("")),t.join(`
`)}function m(v,w){return`${v||(0,P.localize)(45,null)}
${w||(0,P.localize)(46,null)}
${process.arch}`}}),define(oe[203],ae([0,1,88,201,116]),function(J,e,n,j,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gac=void 0;class B extends j.$to{constructor(E){super(),this.f=E}call(E,h,c){return h==="openExtensionDevelopmentHostWindow"?this.g(c[0],c[1]):super.call(E,h,c)}async g(E,h){const c=(0,P.$em)(E,P.$dm);c.debugRenderer=h;const p=c.extensionDevelopmentPath;if(!p)return{success:!1};const[y]=await this.f.openExtensionDevelopmentHostWindow(p,{context:5,cli:c,forceProfile:c.profile,forceTempProfile:c["profile-temp"]});if(!h)return{success:!0};const k=y.win;if(!k)return{success:!0};const g=k.webContents.debugger;let m=g.isAttached()?1/0:0;const v=(0,n.createServer)(w=>{m++===0&&g.attach();let $=!1;const f=a=>{$||w.write(JSON.stringify(a)+"\0")},l=(a,t,o,r)=>f({method:t,params:o,sessionId:r});k.on("close",()=>{g.removeListener("message",l),w.end(),$=!0}),g.addListener("message",l);let d=Buffer.alloc(0);w.on("data",a=>{d=Buffer.concat([d,a]);for(let t=d.indexOf(0);t!==-1;t=d.indexOf(0)){let o;try{const r=d.slice(0,t).toString("utf8");d=d.slice(t+1),o=JSON.parse(r)}catch(r){console.error("error reading cdp line",r)}g.sendCommand(o.method,o.params,o.sessionId).then(r=>f({id:o.id,sessionId:o.sessionId,result:r})).catch(r=>f({id:o.id,sessionId:o.sessionId,error:{code:0,message:r.message}}))}}),w.on("error",a=>{console.error("error on cdp pipe:",a)}),w.on("close",()=>{$=!0,--m===0&&g.detach()})});return await new Promise(w=>v.listen(0,w)),k.on("close",()=>v.close()),{rendererDebugPort:v.address().port,success:!0}}}e.$gac=B}),define(oe[64],ae([0,1,314,171,116]),function(J,e,n,j,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$im=E,e.$jm=h,e.$km=c,e.$lm=p;function B(y,k){const g=(l,d)=>{console.warn((0,j.localize)(0,null,l,d))},m=l=>{console.warn((0,j.localize)(1,null,l))},v=(l,d)=>{console.warn((0,j.localize)(2,null,l,d))},w=l=>({onUnknownOption:d=>{P.$cm.includes(l)||console.warn((0,j.localize)(3,null,d,l))},onMultipleValues:g,onEmptyValue:m,onDeprecatedOption:v,getSubcommandReporter:P.$cm.includes(l)?w:void 0}),$={onUnknownOption:l=>{console.warn((0,j.localize)(4,null,l))},onMultipleValues:g,onEmptyValue:m,onDeprecatedOption:v,getSubcommandReporter:w},f=(0,P.$em)(y,P.$dm,k?$:void 0);return f.goto&&f._.forEach(l=>n(/^(\w:)?[^:]+(:\d*){0,2}:?$/.test(l),(0,j.localize)(5,null))),f}function S(y){const k=y.findIndex(g=>!/^-/.test(g));if(k>-1)return[...y.slice(0,k),...y.slice(k+1)]}function E(y){let[,...k]=y;process.env.VSCODE_DEV&&(k=S(k)||[]);const g=!p(process.env);return B(k,g)}function h(y){let[,,...k]=y;return process.env.VSCODE_DEV&&(k=S(k)||[]),B(k,!0)}function c(y,...k){const g=y.indexOf("--");return g===-1?y.push(...k):y.splice(g,0,...k),y}function p(y){return y.VSCODE_CLI==="1"}}),function(){"use strict";function J(e,n,j){function P(S,E){const h=B(S,E),c=[h];return e.isAbsolute(h)||c.unshift(j),e.resolve(...c)}function B(S,E){process.env.VSCODE_DEV&&(E="code-oss-dev");const h=process.env.VSCODE_PORTABLE;if(h)return e.join(h,"user-data");let c=process.env.VSCODE_APPDATA;if(c)return e.join(c,E);const p=S["user-data-dir"];if(p)return p;switch(process.platform){case"win32":if(c=process.env.APPDATA,!c){const y=process.env.USERPROFILE;if(typeof y!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");c=e.join(y,"AppData","Roaming")}break;case"darwin":c=e.join(n.homedir(),"Library","Application Support");break;case"linux":c=process.env.XDG_CONFIG_HOME||e.join(n.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(c,E)}return{getUserDataPath:P}}if(typeof define=="function")define(oe[204],ae([117,26,36]),function(e,n,j){return J(e,n,j.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),n=require("os");module.exports=J(e,n,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(oe[91],ae([0,1,26,202,204]),function(J,e,n,j,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tm=void 0,e.$Um=S,e.$Vm=E;class B extends j.$Qm{constructor(c,p){super(c,{homeDir:(0,n.homedir)(),tmpDir:(0,n.tmpdir)(),userDataDir:(0,P.getUserDataPath)(c,p.nameShort)},p)}}e.$Tm=B;function S(h,c){return(0,j.$Sm)(h["inspect-ptyhost"],h["inspect-brk-ptyhost"],5877,c,h.extensionEnvironment)}function E(h,c){return(0,j.$Sm)(h["inspect-sharedprocess"],h["inspect-brk-sharedprocess"],5879,c,h.extensionEnvironment)}}),define(oe[205],ae([0,1,43,26,31]),function(J,e,n,j,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zbc=B;function B(S){const E=(0,P.$pg)((0,j.tmpdir)());try{return(0,n.writeFileSync)(E,""),S&&console.log(`Marker file for --wait created: ${E}`),E}catch(h){S&&console.error(`Failed to create marker file for --wait: ${h}`);return}}}),define(oe[206],ae([0,1,12,173]),function(J,e,n,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dq=P;function P(S,E,h,c){try{B(S,E,h,c)}catch(p){S.error(p?.message??p)}return E}function B(S,E,h,c){const p=(y,k,g)=>{const m=y[k];if((0,n.$Uf)(m)){const v=m,w=v.length;if(w>1&&v[0]==="%"&&v[w-1]==="%"){const $=v.substr(1,w-2);let f=h[$];f===void 0&&c&&(f=c[$]);const l=typeof f=="string"?f:f?.message,d=c?.[$],a=typeof d=="string"?d:d?.message;if(!l){a||S.warn(`[${E.name}]: ${(0,j.localize)(0,null,$)}`);return}if(g&&(k==="title"||k==="category")&&a&&a!==l){const t={value:l,original:a};y[k]=t}else y[k]=l}}else if((0,n.$Wf)(m))for(const v in m)m.hasOwnProperty(v)&&(v==="commands"?p(m,v,!0):p(m,v,g));else if(Array.isArray(m))for(let v=0;v<m.length;v++)p(m,v,g)};for(const y in E)E.hasOwnProperty(y)&&p(E,y)}}),define(oe[207],ae([0,1,19,73,175,208]),function(J,e,n,j,P,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rp=h,e.$sp=c,e.$tp=p,e.$up=y,e.$vp=k,e.$wp=g,e.$xp=m;const S=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,E=/^-(\d{4})(\d{2})(\d{2})$/;function h($){return $=$.trim(),$==="*"||S.test($)}function c($){if(!h($))return null;if($=$.trim(),$==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const f=$.match(S);return f?{hasCaret:f[1]==="^",hasGreaterEquals:f[1]===">=",majorBase:f[2]==="x"?0:parseInt(f[2],10),majorMustEqual:f[2]!=="x",minorBase:f[4]==="x"?0:parseInt(f[4],10),minorMustEqual:f[4]!=="x",patchBase:f[6]==="x"?0:parseInt(f[6],10),patchMustEqual:f[6]!=="x",preRelease:f[8]||null}:null}function p($){if(!$)return null;const f=$.majorBase,l=$.majorMustEqual,d=$.minorBase;let a=$.minorMustEqual;const t=$.patchBase;let o=$.patchMustEqual;$.hasCaret&&(f===0||(a=!1),o=!1);let r=0;if($.preRelease){const i=E.exec($.preRelease);if(i){const[,s,u,b]=i;r=Date.UTC(Number(s),Number(u)-1,Number(b))}}return{majorBase:f,majorMustEqual:l,minorBase:d,minorMustEqual:a,patchBase:t,patchMustEqual:o,isMinimum:$.hasGreaterEquals,notBefore:r}}function y($,f,l){let d;typeof $=="string"?d=p(c($)):d=$;let a;f instanceof Date?a=f.getTime():typeof f=="string"&&(a=new Date(f).getTime());let t;if(typeof l=="string"?t=p(c(l)):t=l,!d||!t)return!1;const o=d.majorBase,r=d.minorBase,i=d.patchBase;let s=t.majorBase,u=t.minorBase,b=t.patchBase;const I=t.notBefore;let D=t.majorMustEqual,R=t.minorMustEqual,C=t.patchMustEqual;return t.isMinimum?o>s?!0:o<s?!1:r>u?!0:r<u||a&&a<I?!1:i>=b:(o===1&&s===0&&(!D||!R||!C)&&(s=1,u=0,b=0,D=!0,R=!1,C=!1),o<s?!1:o>s?!D:r<u?!1:r>u?!R:i<b?!1:i>b?!C:!(a&&a<I))}function k($,f,l,d,a){const t=[];if(typeof d.publisher<"u"&&typeof d.publisher!="string")return t.push([j.default.Error,P.localize(0,null)]),t;if(typeof d.name!="string")return t.push([j.default.Error,P.localize(1,null,"name")]),t;if(typeof d.version!="string")return t.push([j.default.Error,P.localize(2,null,"version")]),t;if(!d.engines)return t.push([j.default.Error,P.localize(3,null,"engines")]),t;if(typeof d.engines.vscode!="string")return t.push([j.default.Error,P.localize(4,null,"engines.vscode")]),t;if(typeof d.extensionDependencies<"u"&&!w(d.extensionDependencies))return t.push([j.default.Error,P.localize(5,null,"extensionDependencies")]),t;if(typeof d.activationEvents<"u"){if(!w(d.activationEvents))return t.push([j.default.Error,P.localize(6,null,"activationEvents")]),t;if(typeof d.main>"u"&&typeof d.browser>"u")return t.push([j.default.Error,P.localize(7,null,"activationEvents","main","browser")]),t}if(typeof d.extensionKind<"u"&&typeof d.main>"u"&&t.push([j.default.Warning,P.localize(8,null,"extensionKind")]),typeof d.main<"u"){if(typeof d.main!="string")return t.push([j.default.Error,P.localize(9,null,"main")]),t;{const i=(0,n.$Ug)(l,d.main);(0,n.$Og)(i,l)||t.push([j.default.Warning,P.localize(10,null,i.path,l.path)])}}if(typeof d.browser<"u"){if(typeof d.browser!="string")return t.push([j.default.Error,P.localize(11,null,"browser")]),t;{const i=(0,n.$Ug)(l,d.browser);(0,n.$Og)(i,l)||t.push([j.default.Warning,P.localize(12,null,i.path,l.path)])}}if(!B.valid(d.version))return t.push([j.default.Error,P.localize(13,null)]),t;const o=[];if(!g($,f,d,a,o))for(const i of o)t.push([j.default.Error,i]);return t}function g($,f,l,d,a){return d||typeof l.main>"u"&&typeof l.browser>"u"?!0:v($,f,l.engines.vscode,a)}function m($,f,l){return $==="*"||v(f,l,$)}function v($,f,l,d=[]){const a=p(c(l));if(!a)return d.push(P.localize(14,null,l)),!1;if(a.majorBase===0){if(!a.majorMustEqual||!a.minorMustEqual)return d.push(P.localize(15,null,l)),!1}else if(!a.majorMustEqual)return d.push(P.localize(16,null,l)),!1;return y($,f,a)?!0:(d.push(P.localize(17,null,$,l)),!1)}function w($){if(!Array.isArray($))return!1;for(let f=0,l=$.length;f<l;f++)if(typeof $[f]!="string")return!1;return!0}}),define(oe[209],ae([0,1,17,33]),function(J,e,n,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rp=P;async function P(B,S,E){let h=E&&E.get("storage.serviceMachineId",-1)||null;if(h)return h;try{const p=(await S.readFile(B.serviceMachineIdResource)).value.toString();h=(0,j.$Cg)(p)?p:null}catch{h=null}if(!h){h=(0,j.$Dg)();try{await S.writeFile(B.serviceMachineIdResource,n.$ue.fromString(h))}catch{}}return E?.store("storage.serviceMachineId",h,-1,1),h}}),define(oe[77],ae([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ei=void 0;class n{constructor(P,B=[],S=!1){this.ctor=P,this.staticArguments=B,this.supportsDelayedInstantiation=S}}e.$ei=n}),define(oe[210],ae([0,1,77]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$fs=B,e.$gs=S;const j=[];var P;(function(E){E[E.Eager=0]="Eager",E[E.Delayed=1]="Delayed"})(P||(e.InstantiationType=P={}));function B(E,h,c){h instanceof n.$ei||(h=new n.$ei(h,[],!!c)),j.push([E,h])}function S(){return j}}),define(oe[211],ae([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wq=e.$Vq=void 0;class n{constructor(B,S){this.key=B,this.data=S,this.incoming=new Map,this.outgoing=new Map}}e.$Vq=n;class j{constructor(B){this.b=B,this.a=new Map}roots(){const B=[];for(const S of this.a.values())S.outgoing.size===0&&B.push(S);return B}insertEdge(B,S){const E=this.lookupOrInsertNode(B),h=this.lookupOrInsertNode(S);E.outgoing.set(h.key,h),h.incoming.set(E.key,E)}removeNode(B){const S=this.b(B);this.a.delete(S);for(const E of this.a.values())E.outgoing.delete(S),E.incoming.delete(S)}lookupOrInsertNode(B){const S=this.b(B);let E=this.a.get(S);return E||(E=new n(S,B),this.a.set(S,E)),E}lookup(B){return this.a.get(this.b(B))}isEmpty(){return this.a.size===0}toString(){const B=[];for(const[S,E]of this.a)B.push(`${S}
	(-> incoming)[${[...E.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...E.outgoing.keys()].join(",")}]
`);return B.join(`
`)}findCycleSlow(){for(const[B,S]of this.a){const E=new Set([B]),h=this.c(S,E);if(h)return h}}c(B,S){for(const[E,h]of B.outgoing){if(S.has(E))return[...S,E].join(" -> ");S.add(E);const c=this.c(h,S);if(c)return c;S.delete(E)}}}e.$Wq=j}),define(oe[6],ae([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gi=e._util=void 0,e.$hi=P,e.$ii=B;var n;(function(S){S.serviceIds=new Map,S.DI_TARGET="$di$target",S.DI_DEPENDENCIES="$di$dependencies";function E(h){return h[S.DI_DEPENDENCIES]||[]}S.getServiceDependencies=E})(n||(e._util=n={})),e.$gi=P("instantiationService");function j(S,E,h){E[n.DI_TARGET]===E?E[n.DI_DEPENDENCIES].push({id:S,index:h}):(E[n.DI_DEPENDENCIES]=[{id:S,index:h}],E[n.DI_TARGET]=E)}function P(S){if(n.serviceIds.has(S))return n.serviceIds.get(S);const E=function(h,c,p){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");j(E,h,p)};return E.toString=()=>S,n.serviceIds.set(S,E),E}function B(S){return S}}),define(oe[78],ae([0,1,6]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yac=void 0,e.$yac=(0,n.$hi)("auxiliaryWindowsMainService")}),define(oe[65],ae([0,1,6]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H_b=void 0,e.$H_b=(0,n.$hi)("backupMainService")}),define(oe[18],ae([0,1,12,7,6]),function(J,e,n,j,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$Ni=void 0,e.$Oi=B,e.$Pi=S,e.$Qi=h,e.$Ri=c,e.$Si=p,e.$Ti=y,e.$Ui=k,e.$Vi=m,e.$Wi=v,e.$Xi=w,e.$Ni=(0,P.$hi)("configurationService");function B($){return $&&typeof $=="object"&&(!$.overrideIdentifier||typeof $.overrideIdentifier=="string")&&(!$.resource||$.resource instanceof j.URI)}function S($){return $&&typeof $=="object"&&(!$.overrideIdentifiers||Array.isArray($.overrideIdentifiers))&&!$.overrideIdentifier&&(!$.resource||$.resource instanceof j.URI)}var E;(function($){$[$.APPLICATION=1]="APPLICATION",$[$.USER=2]="USER",$[$.USER_LOCAL=3]="USER_LOCAL",$[$.USER_REMOTE=4]="USER_REMOTE",$[$.WORKSPACE=5]="WORKSPACE",$[$.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",$[$.DEFAULT=7]="DEFAULT",$[$.MEMORY=8]="MEMORY"})(E||(e.ConfigurationTarget=E={}));function h($){switch($){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function c($){return $.applicationValue!==void 0||$.userValue!==void 0||$.userLocalValue!==void 0||$.userRemoteValue!==void 0||$.workspaceValue!==void 0||$.workspaceFolderValue!==void 0}function p($,f){const l=Object.create(null);for(const d in $)y(l,d,$[d],f);return l}function y($,f,l,d){const a=f.split("."),t=a.pop();let o=$;for(let r=0;r<a.length;r++){const i=a[r];let s=o[i];switch(typeof s){case"undefined":s=o[i]=Object.create(null);break;case"object":break;default:d(`Ignoring ${f} as ${a.slice(0,r+1).join(".")} is ${JSON.stringify(s)}`);return}o=s}if(typeof o=="object"&&o!==null)try{o[t]=l}catch{d(`Ignoring ${f} as ${a.join(".")} is ${JSON.stringify(o)}`)}else d(`Ignoring ${f} as ${a.join(".")} is ${JSON.stringify(o)}`)}function k($,f){const l=f.split(".");g($,l)}function g($,f){const l=f.shift();if(f.length===0){delete $[l];return}if(Object.keys($).indexOf(l)!==-1){const d=$[l];typeof d=="object"&&!Array.isArray(d)&&(g(d,f),Object.keys(d).length===0&&delete $[l])}}function m($,f,l){function d(o,r){let i=o;for(const s of r){if(typeof i!="object"||i===null)return;i=i[s]}return i}const a=f.split("."),t=d($,a);return typeof t>"u"?l:t}function v($,f,l){Object.keys(f).forEach(d=>{d!=="__proto__"&&(d in $?n.$Wf($[d])&&n.$Wf(f[d])?v($[d],f[d],l):l&&($[d]=f[d]):$[d]=f[d])})}function w($){return $.replace(/[\[\]]/g,"")}}),define(oe[118],ae([0,1,4,25,200,6,166,15]),function(J,e,n,j,P,B,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$fj=e.$ej=e.ContextKeyExprType=void 0,e.$dj=c,e.$gj=o,e.$hj=r,e.$Aj=T;const h=new Map;h.set("false",!1),h.set("true",!0),h.set("isMac",n.$j),h.set("isLinux",n.$k),h.set("isWindows",n.$i),h.set("isWeb",n.$o),h.set("isMacNative",n.$j&&!n.$o),h.set("isEdge",n.$H),h.set("isFirefox",n.$F),h.set("isChrome",n.$E),h.set("isSafari",n.$G);function c(K,O){if(h.get(K)!==void 0)throw(0,E.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");h.set(K,O)}const p=Object.prototype.hasOwnProperty;var y;(function(K){K[K.False=0]="False",K[K.True=1]="True",K[K.Defined=2]="Defined",K[K.Not=3]="Not",K[K.Equals=4]="Equals",K[K.NotEquals=5]="NotEquals",K[K.And=6]="And",K[K.Regex=7]="Regex",K[K.NotRegex=8]="NotRegex",K[K.Or=9]="Or",K[K.In=10]="In",K[K.NotIn=11]="NotIn",K[K.Greater=12]="Greater",K[K.GreaterEquals=13]="GreaterEquals",K[K.Smaller=14]="Smaller",K[K.SmallerEquals=15]="SmallerEquals"})(y||(e.ContextKeyExprType=y={}));const k={regexParsingWithErrorRecovery:!0},g=(0,S.localize)(0,null),m=(0,S.localize)(1,null),v=(0,S.localize)(2,null),w=(0,S.localize)(3,null),$=(0,S.localize)(4,null),f=(0,S.localize)(5,null),l=(0,S.localize)(6,null),d=(0,S.localize)(7,null);class a{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(O=k){this.k=O,this.d=new P.$cj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(O){if(O===""){this.h.push({message:g,offset:0,lexeme:"",additionalInfo:m});return}this.f=this.d.reset(O).scan(),this.g=0,this.h=[];try{const N=this.l();if(!this.E()){const _=this.D(),se=_.type===17?f:void 0;throw this.h.push({message:$,offset:_.offset,lexeme:P.$cj.getLexeme(_),additionalInfo:se}),a.c}return N}catch(N){if(N!==a.c)throw N;return}}l(){return this.m()}m(){const O=[this.o()];for(;this.y(16);){const N=this.o();O.push(N)}return O.length===1?O[0]:t.or(...O)}o(){const O=[this.s()];for(;this.y(15);){const N=this.s();O.push(N)}return O.length===1?O[0]:t.and(...O)}s(){if(this.y(2)){const O=this.D();switch(O.type){case 11:return this.z(),s.INSTANCE;case 12:return this.z(),u.INSTANCE;case 0:{this.z();const N=this.l();return this.A(1,w),N?.negate()}case 17:return this.z(),A.create(O.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",O)}}return this.t()}t(){const O=this.D();switch(O.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const N=this.l();return this.A(1,w),N}case 17:{const N=O.lexeme;if(this.z(),this.y(9)){const se=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),se.type!==10)throw this.B("REGEX",se);const Z=se.lexeme,V=Z.lastIndexOf("/"),x=V===Z.length-1?void 0:this.w(Z.substring(V+1));let U;try{U=new RegExp(Z.substring(1,V),x)}catch{throw this.B("REGEX",se)}return te.create(N,U)}switch(se.type){case 10:case 19:{const Z=[se.lexeme];this.z();let V=this.D(),x=0;for(let me=0;me<se.lexeme.length;me++)se.lexeme.charCodeAt(me)===40?x++:se.lexeme.charCodeAt(me)===41&&x--;for(;!this.E()&&V.type!==15&&V.type!==16;){switch(V.type){case 0:x++;break;case 1:x--;break;case 10:case 18:for(let me=0;me<V.lexeme.length;me++)V.lexeme.charCodeAt(me)===40?x++:se.lexeme.charCodeAt(me)===41&&x--}if(x<0)break;Z.push(P.$cj.getLexeme(V)),this.z(),V=this.D()}const U=Z.join(""),re=U.lastIndexOf("/"),ee=re===U.length-1?void 0:this.w(U.substring(re+1));let fe;try{fe=new RegExp(U.substring(1,re),ee)}catch{throw this.B("REGEX",se)}return t.regex(N,fe)}case 18:{const Z=se.lexeme;this.z();let V=null;if(!(0,j.$Ue)(Z)){const x=Z.indexOf("/"),U=Z.lastIndexOf("/");if(x!==U&&x>=0){const re=Z.slice(x+1,U),ee=Z[U+1]==="i"?"i":"";try{V=new RegExp(re,ee)}catch{throw this.B("REGEX",se)}}}if(V===null)throw this.B("REGEX",se);return te.create(N,V)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,v);const se=this.u();return t.notIn(N,se)}switch(this.D().type){case 3:{this.z();const se=this.u();if(this.x().type===18)return t.equals(N,se);switch(se){case"true":return t.has(N);case"false":return t.not(N);default:return t.equals(N,se)}}case 4:{this.z();const se=this.u();if(this.x().type===18)return t.notEquals(N,se);switch(se){case"true":return t.not(N);case"false":return t.has(N);default:return t.notEquals(N,se)}}case 5:return this.z(),H.create(N,this.u());case 6:return this.z(),le.create(N,this.u());case 7:return this.z(),W.create(N,this.u());case 8:return this.z(),q.create(N,this.u());case 13:return this.z(),t.in(N,this.u());default:return t.has(N)}}case 20:throw this.h.push({message:l,offset:O.offset,lexeme:"",additionalInfo:d}),a.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const O=this.D();switch(O.type){case 17:case 18:return this.z(),O.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(O){return O.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(O){return this.C(O)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(O,N){if(this.C(O))return this.z();throw this.B(N,this.D())}B(O,N,_){const se=(0,S.localize)(8,null,O,P.$cj.getLexeme(N)),Z=N.offset,V=P.$cj.getLexeme(N);return this.h.push({message:se,offset:Z,lexeme:V,additionalInfo:_}),a.c}C(O){return this.D().type===O}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$ej=a;class t{static false(){return s.INSTANCE}static true(){return u.INSTANCE}static has(O){return b.create(O)}static equals(O,N){return I.create(O,N)}static notEquals(O,N){return C.create(O,N)}static regex(O,N){return te.create(O,N)}static in(O,N){return D.create(O,N)}static notIn(O,N){return R.create(O,N)}static not(O){return A.create(O)}static and(...O){return Q.create(O,null,!0)}static or(...O){return z.create(O,null,!0)}static greater(O,N){return W.create(O,N)}static greaterEquals(O,N){return q.create(O,N)}static smaller(O,N){return H.create(O,N)}static smallerEquals(O,N){return le.create(O,N)}static{this.c=new a({regexParsingWithErrorRecovery:!1})}static deserialize(O){return O==null?void 0:this.c.parse(O)}}e.$fj=t;function o(K){const O=new a({regexParsingWithErrorRecovery:!1});return K.map(N=>(O.parse(N),O.lexingErrors.length>0?O.lexingErrors.map(_=>({errorMessage:_.additionalInfo?(0,S.localize)(9,null,_.additionalInfo):(0,S.localize)(10,null),offset:_.offset,length:_.lexeme.length})):O.parsingErrors.length>0?O.parsingErrors.map(_=>({errorMessage:_.additionalInfo?`${_.message}. ${_.additionalInfo}`:_.message,offset:_.offset,length:_.lexeme.length})):[]))}function r(K,O){const N=K?K.substituteConstants():void 0,_=O?O.substituteConstants():void 0;return!N&&!_?!0:!N||!_?!1:N.equals(_)}function i(K,O){return K.cmp(O)}class s{static{this.INSTANCE=new s}constructor(){this.type=0}cmp(O){return this.type-O.type}equals(O){return O.type===this.type}substituteConstants(){return this}evaluate(O){return!1}serialize(){return"false"}keys(){return[]}map(O){return this}negate(){return u.INSTANCE}}e.$ij=s;class u{static{this.INSTANCE=new u}constructor(){this.type=1}cmp(O){return this.type-O.type}equals(O){return O.type===this.type}substituteConstants(){return this}evaluate(O){return!0}serialize(){return"true"}keys(){return[]}map(O){return this}negate(){return s.INSTANCE}}e.$jj=u;class b{static create(O,N=null){const _=h.get(O);return typeof _=="boolean"?_?u.INSTANCE:s.INSTANCE:new b(O,N)}constructor(O,N){this.key=O,this.c=N,this.type=2}cmp(O){return O.type!==this.type?this.type-O.type:F(this.key,O.key)}equals(O){return O.type===this.type?this.key===O.key:!1}substituteConstants(){const O=h.get(this.key);return typeof O=="boolean"?O?u.INSTANCE:s.INSTANCE:this}evaluate(O){return!!O.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(O){return O.mapDefined(this.key)}negate(){return this.c||(this.c=A.create(this.key,this)),this.c}}e.$kj=b;class I{static create(O,N,_=null){if(typeof N=="boolean")return N?b.create(O,_):A.create(O,_);const se=h.get(O);return typeof se=="boolean"?N===(se?"true":"false")?u.INSTANCE:s.INSTANCE:new I(O,N,_)}constructor(O,N,_){this.c=O,this.d=N,this.f=_,this.type=4}cmp(O){return O.type!==this.type?this.type-O.type:G(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){const O=h.get(this.c);if(typeof O=="boolean"){const N=O?"true":"false";return this.d===N?u.INSTANCE:s.INSTANCE}return this}evaluate(O){return O.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(O){return O.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=C.create(this.c,this.d,this)),this.f}}e.$lj=I;class D{static create(O,N){return new D(O,N)}constructor(O,N){this.d=O,this.f=N,this.type=10,this.c=null}cmp(O){return O.type!==this.type?this.type-O.type:G(this.d,this.f,O.d,O.f)}equals(O){return O.type===this.type?this.d===O.d&&this.f===O.f:!1}substituteConstants(){return this}evaluate(O){const N=O.getValue(this.f),_=O.getValue(this.d);return Array.isArray(N)?N.includes(_):typeof _=="string"&&typeof N=="object"&&N!==null?p.call(N,_):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(O){return O.mapIn(this.d,this.f)}negate(){return this.c||(this.c=R.create(this.d,this.f)),this.c}}e.$mj=D;class R{static create(O,N){return new R(O,N)}constructor(O,N){this.d=O,this.f=N,this.type=11,this.c=D.create(O,N)}cmp(O){return O.type!==this.type?this.type-O.type:this.c.cmp(O.c)}equals(O){return O.type===this.type?this.c.equals(O.c):!1}substituteConstants(){return this}evaluate(O){return!this.c.evaluate(O)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(O){return O.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$nj=R;class C{static create(O,N,_=null){if(typeof N=="boolean")return N?A.create(O,_):b.create(O,_);const se=h.get(O);return typeof se=="boolean"?N===(se?"true":"false")?s.INSTANCE:u.INSTANCE:new C(O,N,_)}constructor(O,N,_){this.c=O,this.d=N,this.f=_,this.type=5}cmp(O){return O.type!==this.type?this.type-O.type:G(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){const O=h.get(this.c);if(typeof O=="boolean"){const N=O?"true":"false";return this.d===N?s.INSTANCE:u.INSTANCE}return this}evaluate(O){return O.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(O){return O.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=I.create(this.c,this.d,this)),this.f}}e.$oj=C;class A{static create(O,N=null){const _=h.get(O);return typeof _=="boolean"?_?s.INSTANCE:u.INSTANCE:new A(O,N)}constructor(O,N){this.c=O,this.d=N,this.type=3}cmp(O){return O.type!==this.type?this.type-O.type:F(this.c,O.c)}equals(O){return O.type===this.type?this.c===O.c:!1}substituteConstants(){const O=h.get(this.c);return typeof O=="boolean"?O?s.INSTANCE:u.INSTANCE:this}evaluate(O){return!O.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(O){return O.mapNot(this.c)}negate(){return this.d||(this.d=b.create(this.c,this)),this.d}}e.$pj=A;function L(K,O){if(typeof K=="string"){const N=parseFloat(K);isNaN(N)||(K=N)}return typeof K=="string"||typeof K=="number"?O(K):s.INSTANCE}class W{static create(O,N,_=null){return L(N,se=>new W(O,se,_))}constructor(O,N,_){this.c=O,this.d=N,this.f=_,this.type=12}cmp(O){return O.type!==this.type?this.type-O.type:G(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(O){return O.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=le.create(this.c,this.d,this)),this.f}}e.$qj=W;class q{static create(O,N,_=null){return L(N,se=>new q(O,se,_))}constructor(O,N,_){this.c=O,this.d=N,this.f=_,this.type=13}cmp(O){return O.type!==this.type?this.type-O.type:G(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(O){return O.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=H.create(this.c,this.d,this)),this.f}}e.$rj=q;class H{static create(O,N,_=null){return L(N,se=>new H(O,se,_))}constructor(O,N,_){this.c=O,this.d=N,this.f=_,this.type=14}cmp(O){return O.type!==this.type?this.type-O.type:G(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(O){return O.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=q.create(this.c,this.d,this)),this.f}}e.$sj=H;class le{static create(O,N,_=null){return L(N,se=>new le(O,se,_))}constructor(O,N,_){this.c=O,this.d=N,this.f=_,this.type=15}cmp(O){return O.type!==this.type?this.type-O.type:G(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(O){return O.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=W.create(this.c,this.d,this)),this.f}}e.$tj=le;class te{static create(O,N){return new te(O,N)}constructor(O,N){this.d=O,this.f=N,this.type=7,this.c=null}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.d<O.d)return-1;if(this.d>O.d)return 1;const N=this.f?this.f.source:"",_=O.f?O.f.source:"";return N<_?-1:N>_?1:0}equals(O){if(O.type===this.type){const N=this.f?this.f.source:"",_=O.f?O.f.source:"";return this.d===O.d&&N===_}return!1}substituteConstants(){return this}evaluate(O){const N=O.getValue(this.d);return this.f?this.f.test(N):!1}serialize(){const O=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${O}`}keys(){return[this.d]}map(O){return O.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ue.create(this)),this.c}}e.$uj=te;class ue{static create(O){return new ue(O)}constructor(O){this.c=O,this.type=8}cmp(O){return O.type!==this.type?this.type-O.type:this.c.cmp(O.c)}equals(O){return O.type===this.type?this.c.equals(O.c):!1}substituteConstants(){return this}evaluate(O){return!this.c.evaluate(O)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(O){return new ue(this.c.map(O))}negate(){return this.c}}e.$vj=ue;function X(K){let O=null;for(let N=0,_=K.length;N<_;N++){const se=K[N].substituteConstants();if(K[N]!==se&&O===null){O=[];for(let Z=0;Z<N;Z++)O[Z]=K[Z]}O!==null&&(O[N]=se)}return O===null?K:O}class Q{static create(O,N,_){return Q.d(O,N,_)}constructor(O,N){this.expr=O,this.c=N,this.type=6}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.expr.length<O.expr.length)return-1;if(this.expr.length>O.expr.length)return 1;for(let N=0,_=this.expr.length;N<_;N++){const se=i(this.expr[N],O.expr[N]);if(se!==0)return se}return 0}equals(O){if(O.type===this.type){if(this.expr.length!==O.expr.length)return!1;for(let N=0,_=this.expr.length;N<_;N++)if(!this.expr[N].equals(O.expr[N]))return!1;return!0}return!1}substituteConstants(){const O=X(this.expr);return O===this.expr?this:Q.create(O,this.c,!1)}evaluate(O){for(let N=0,_=this.expr.length;N<_;N++)if(!this.expr[N].evaluate(O))return!1;return!0}static d(O,N,_){const se=[];let Z=!1;for(const V of O)if(V){if(V.type===1){Z=!0;continue}if(V.type===0)return s.INSTANCE;if(V.type===6){se.push(...V.expr);continue}se.push(V)}if(se.length===0&&Z)return u.INSTANCE;if(se.length!==0){if(se.length===1)return se[0];se.sort(i);for(let V=1;V<se.length;V++)se[V-1].equals(se[V])&&(se.splice(V,1),V--);if(se.length===1)return se[0];for(;se.length>1;){const V=se[se.length-1];if(V.type!==9)break;se.pop();const x=se.pop(),U=se.length===0,re=z.create(V.expr.map(ee=>Q.create([ee,x],null,_)),null,U);re&&(se.push(re),se.sort(i))}if(se.length===1)return se[0];if(_){for(let V=0;V<se.length;V++)for(let x=V+1;x<se.length;x++)if(se[V].negate().equals(se[x]))return s.INSTANCE;if(se.length===1)return se[0]}return new Q(se,N)}}serialize(){return this.expr.map(O=>O.serialize()).join(" && ")}keys(){const O=[];for(const N of this.expr)O.push(...N.keys());return O}map(O){return new Q(this.expr.map(N=>N.map(O)),null)}negate(){if(!this.c){const O=[];for(const N of this.expr)O.push(N.negate());this.c=z.create(O,this,!0)}return this.c}}e.$wj=Q;class z{static create(O,N,_){return z.d(O,N,_)}constructor(O,N){this.expr=O,this.c=N,this.type=9}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.expr.length<O.expr.length)return-1;if(this.expr.length>O.expr.length)return 1;for(let N=0,_=this.expr.length;N<_;N++){const se=i(this.expr[N],O.expr[N]);if(se!==0)return se}return 0}equals(O){if(O.type===this.type){if(this.expr.length!==O.expr.length)return!1;for(let N=0,_=this.expr.length;N<_;N++)if(!this.expr[N].equals(O.expr[N]))return!1;return!0}return!1}substituteConstants(){const O=X(this.expr);return O===this.expr?this:z.create(O,this.c,!1)}evaluate(O){for(let N=0,_=this.expr.length;N<_;N++)if(this.expr[N].evaluate(O))return!0;return!1}static d(O,N,_){let se=[],Z=!1;if(O){for(let V=0,x=O.length;V<x;V++){const U=O[V];if(U){if(U.type===0){Z=!0;continue}if(U.type===1)return u.INSTANCE;if(U.type===9){se=se.concat(U.expr);continue}se.push(U)}}if(se.length===0&&Z)return s.INSTANCE;se.sort(i)}if(se.length!==0){if(se.length===1)return se[0];for(let V=1;V<se.length;V++)se[V-1].equals(se[V])&&(se.splice(V,1),V--);if(se.length===1)return se[0];if(_){for(let V=0;V<se.length;V++)for(let x=V+1;x<se.length;x++)if(se[V].negate().equals(se[x]))return u.INSTANCE;if(se.length===1)return se[0]}return new z(se,N)}}serialize(){return this.expr.map(O=>O.serialize()).join(" || ")}keys(){const O=[];for(const N of this.expr)O.push(...N.keys());return O}map(O){return new z(this.expr.map(N=>N.map(O)),null)}negate(){if(!this.c){const O=[];for(const N of this.expr)O.push(N.negate());for(;O.length>1;){const N=O.shift(),_=O.shift(),se=[];for(const Z of he(N))for(const V of he(_))se.push(Q.create([Z,V],null,!1));O.unshift(z.create(se,null,!1))}this.c=z.create(O,this,!0)}return this.c}}e.$xj=z;class M extends b{static{this.d=[]}static all(){return M.d.values()}constructor(O,N,_){super(O,null),this.f=N,typeof _=="object"?M.d.push({..._,key:O}):_!==!0&&M.d.push({key:O,description:_,type:N!=null?typeof N:void 0})}bindTo(O){return O.createKey(this.key,this.f)}getValue(O){return O.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(O){return I.create(this.key,O)}notEqualsTo(O){return C.create(this.key,O)}}e.$yj=M,e.$zj=(0,B.$hi)("contextKeyService");function F(K,O){return K<O?-1:K>O?1:0}function G(K,O,N,_){return K<N?-1:K>N?1:O<_?-1:O>_?1:0}function T(K,O){if(K.type===0||O.type===1)return!0;if(K.type===9)return O.type===9?ce(K.expr,O.expr):!1;if(O.type===9){for(const N of O.expr)if(T(K,N))return!0;return!1}if(K.type===6){if(O.type===6)return ce(O.expr,K.expr);for(const N of K.expr)if(T(N,O))return!0;return!1}return K.equals(O)}function ce(K,O){let N=0,_=0;for(;N<K.length&&_<O.length;){const se=K[N].cmp(O[_]);if(se<0)return!1;se===0&&N++,_++}return N===K.length}function he(K){return K.type===9?K.expr:[K]}}),define(oe[92],ae([0,1,6]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3m=e.$1m=e.ID=void 0,e.$2m=j,e.ID="diagnosticsService",e.$1m=(0,n.$hi)(e.ID);function j(B){return!!B.hostName&&!!B.errorMessage}class P{async getPerformanceInfo(S,E){return{}}async getSystemInfo(S,E){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(S,E){return""}async getWorkspaceFileExtensions(S){return{extensions:[]}}async reportWorkspaceStats(S){}}e.$3m=P}),define(oe[119],ae([0,1,19,73,168,6,48,4,35]),function(J,e,n,j,P,B,S,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfirmResult=e.$rw=e.$qw=e.$pw=void 0,e.$sw=g,e.$tw=m,e.$pw=(0,B.$hi)("dialogService");var c;(function(v){v[v.Confirmation=1]="Confirmation",v[v.Prompt=2]="Prompt",v[v.Input=3]="Input"})(c||(c={}));class p{a(w){return this.d(w,c.Confirmation)}b(w){return this.d(w,c.Prompt)}c(w){return this.d(w,c.Input)}d(w,$){const f=[];switch($){case c.Confirmation:{const l=w;l.primaryButton?f.push(l.primaryButton):f.push((0,P.localize)(0,null)),l.cancelButton?f.push(l.cancelButton):f.push((0,P.localize)(1,null));break}case c.Prompt:{const l=w;Array.isArray(l.buttons)&&l.buttons.length>0&&f.push(...l.buttons.map(d=>d.label)),l.cancelButton&&(l.cancelButton===!0?f.push((0,P.localize)(2,null)):typeof l.cancelButton=="string"?f.push(l.cancelButton):l.cancelButton.label?f.push(l.cancelButton.label):f.push((0,P.localize)(3,null))),f.length===0&&f.push((0,P.localize)(4,null));break}case c.Input:{const l=w;l.primaryButton?f.push(l.primaryButton):f.push((0,P.localize)(5,null)),l.cancelButton?f.push(l.cancelButton):f.push((0,P.localize)(6,null));break}}return f}e(w){if(typeof w=="string")return w;if(typeof w=="number")return w===j.default.Info?"info":w===j.default.Error?"error":w===j.default.Warning?"warning":"none"}f(w,$,f){const l=[...w.buttons??[]];w.cancelButton&&typeof w.cancelButton!="string"&&typeof w.cancelButton!="boolean"&&l.push(w.cancelButton);let d=l[$]?.run({checkboxChecked:f});return d instanceof Promise||(d=Promise.resolve(d)),{result:d,checkboxChecked:f}}}e.$qw=p,e.$rw=(0,B.$hi)("fileDialogService");var y;(function(v){v[v.SAVE=0]="SAVE",v[v.DONT_SAVE=1]="DONT_SAVE",v[v.CANCEL=2]="CANCEL"})(y||(e.ConfirmResult=y={}));const k=10;function g(v){const w=[];return w.push(...v.slice(0,k).map($=>typeof $=="string"?$:(0,n.$Rg)($))),v.length>k&&(v.length-k===1?w.push((0,P.localize)(7,null)):w.push((0,P.localize)(8,null,v.length-k))),w.push(""),w.join(`
`)}function m(v,w){const $=(0,h.$Nn)(v);let f=($.buttons??[]).map(t=>(0,S.$mw)(t)),l=(v.buttons||[]).map((t,o)=>o),d=0,a=$.cancelId??f.length-1;if(f.length>1){const t=typeof a=="number"?f[a]:void 0;if(E.$k||E.$j){if(typeof t=="string"&&f.length>1&&a!==1){f.splice(a,1),f.splice(1,0,t);const o=l[a];l.splice(a,1),l.splice(1,0,o),a=1}E.$k&&f.length>1&&(f=f.reverse(),l=l.reverse(),d=f.length-1,typeof t=="string"&&(a=d-1))}else if(E.$i&&typeof t=="string"&&f.length>1&&a!==f.length-1){f.splice(a,1),f.push(t);const o=l[a];l.splice(a,1),l.push(o),a=f.length-1}}return $.buttons=f,$.defaultId=d,$.cancelId=a,$.noLink=!0,$.title=$.title||w.nameLong,{options:$,buttonIndeces:l}}}),define(oe[120],ae([0,1,6]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KnownStorageProvider=e.PasswordStoreCLIOption=e.$KW=e.$JW=void 0,e.$LW=B,e.$MW=S,e.$JW=(0,n.$hi)("encryptionService"),e.$KW=(0,n.$hi)("encryptionMainService");var j;(function(E){E.kwallet="kwallet",E.kwallet5="kwallet5",E.gnomeLibsecret="gnome-libsecret",E.basic="basic"})(j||(e.PasswordStoreCLIOption=j={}));var P;(function(E){E.unknown="unknown",E.basicText="basic_text",E.gnomeAny="gnome_any",E.gnomeLibsecret="gnome_libsecret",E.gnomeKeyring="gnome_keyring",E.kwallet="kwallet",E.kwallet5="kwallet5",E.kwallet6="kwallet6",E.dplib="dpapi",E.keychainAccess="keychain_access"})(P||(e.KnownStorageProvider=P={}));function B(E){return E==="kwallet"||E==="kwallet5"||E==="kwallet6"}function S(E){return E==="gnome_any"||E==="gnome_libsecret"||E==="gnome_keyring"}}),define(oe[38],ae([0,1,6]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pi=e.$oi=void 0,e.$oi=(0,n.$hi)("environmentService"),e.$pi=(0,n.$ii)(e.$oi)}),define(oe[121],ae([0,1,172,6]),function(J,e,n,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zo=e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.ExtensionGalleryErrorCode=e.$Ro=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Qo=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=void 0,e.$Ko=P,e.$Lo=B,e.$Mo=S,e.$No=E,e.$Oo=h,e.$Po=c,e.$Eo="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Fo=new RegExp(e.$Eo),e.$Go="__web_extension",e.$Ho="skipWalkthrough",e.$Io="extensionsSync",e.$Jo="dependecyOrPackExtensionInstall";function P(l){switch(l){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function B(l){switch(l){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function S(l,d){switch(l){case 3:return d==="x64"?"win32-x64":d==="arm64"?"win32-arm64":"unknown";case 2:return d==="x64"?"linux-x64":d==="arm64"?"linux-arm64":d==="arm"?"linux-armhf":"unknown";case"alpine":return d==="x64"?"alpine-x64":d==="arm64"?"alpine-arm64":"unknown";case 1:return d==="x64"?"darwin-x64":d==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function E(l,d){return d==="web"&&!l.includes("web")}function h(l,d,a){return E(d,a)?!1:l==="undefined"||l==="universal"?!0:l==="unknown"?!1:l===a}function c(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(!l.uuid||typeof l.uuid=="string")}var p;(function(l){l[l.NoneOrRelevance=0]="NoneOrRelevance",l[l.LastUpdatedDate=1]="LastUpdatedDate",l[l.Title=2]="Title",l[l.PublisherName=3]="PublisherName",l[l.InstallCount=4]="InstallCount",l[l.PublishedDate=10]="PublishedDate",l[l.AverageRating=6]="AverageRating",l[l.WeightedRating=12]="WeightedRating"})(p||(e.SortBy=p={}));var y;(function(l){l[l.Default=0]="Default",l[l.Ascending=1]="Ascending",l[l.Descending=2]="Descending"})(y||(e.SortOrder=y={}));var k;(function(l){l.Install="install",l.Uninstall="uninstall"})(k||(e.StatisticType=k={}));var g;(function(l){l[l.None=1]="None",l[l.Install=2]="Install",l[l.Update=3]="Update",l[l.Migrate=4]="Migrate"})(g||(e.InstallOperation=g={})),e.$Qo=(0,j.$hi)("extensionGalleryService");var m;(function(l){l.Unsupported="Unsupported",l.Deprecated="Deprecated",l.Malicious="Malicious",l.Incompatible="Incompatible",l.IncompatibleTargetPlatform="IncompatibleTargetPlatform",l.ReleaseVersionNotFound="ReleaseVersionNotFound",l.Invalid="Invalid",l.Download="Download",l.DownloadSignature="DownloadSignature",l.UpdateMetadata="UpdateMetadata",l.Extract="Extract",l.Scanning="Scanning",l.Delete="Delete",l.Rename="Rename",l.CorruptZip="CorruptZip",l.IncompleteZip="IncompleteZip",l.Signature="Signature",l.NotAllowed="NotAllowed",l.Gallery="Gallery",l.Unknown="Unknown",l.Internal="Internal"})(m||(e.ExtensionManagementErrorCode=m={}));var v;(function(l){l.UnknownError="UnknownError",l.PackageIsInvalidZip="PackageIsInvalidZip",l.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(v||(e.ExtensionSignaturetErrorCode=v={}));class w extends Error{constructor(d,a){super(d),this.code=a,this.name=a}}e.$Ro=w;var $;(function(l){l.Timeout="Timeout",l.Cancelled="Cancelled",l.Failed="Failed"})($||(e.ExtensionGalleryErrorCode=$={}));class f extends Error{constructor(d,a){super(d),this.code=a,this.name=a}}e.$So=f,e.$To=(0,j.$hi)("extensionManagementService"),e.$Uo="extensionsIdentifiers/disabled",e.$Vo="extensionsIdentifiers/enabled",e.$Wo=(0,j.$hi)("IGlobalExtensionEnablementService"),e.$Xo=(0,j.$hi)("IExtensionTipsService"),e.$Yo=(0,n.localize2)(0,"Extensions"),e.$Zo=(0,n.localize2)(1,"Preferences")}),define(oe[212],ae([0,1,6]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oac=e.$nac=void 0,e.$nac=(0,n.$hi)("extensionHostStarter"),e.$oac="extensionHostStarter"}),define(oe[213],ae([0,1,6]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$o5b=e.$n5b=void 0,e.$n5b=(0,n.$hi)("externalTerminal"),e.$o5b="Terminal.app"}),define(oe[214],ae([0,1,6]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qac=void 0,e.$qac=(0,n.$hi)("externalTerminal")}),define(oe[215],ae([0,1,49,51,13,9,4,75,21,90,176,213]),function(J,e,n,j,P,B,S,E,h,c,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tac=e.$sac=e.$rac=void 0;const k=p.localize(0,null);class g{async getDefaultTerminalForPlatforms(){return{windows:m.getDefaultTerminalWindows(),linux:await w.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class m extends g{static{this.b="cmd.exe"}openTerminal(a,t){return this.spawnTerminal(n,a,c.$_l(),t)}spawnTerminal(a,t,o,r){const i=t.windowsExec||m.getDefaultTerminalWindows();r&&r[1]===":"&&(r=r[0].toUpperCase()+r.substr(1));const s=B.$oc(i,".exe").toLowerCase();if(s==="cmder")return a.spawn(i,r?[r]:void 0),Promise.resolve(void 0);const u=["/c","start","/wait"];return i.indexOf(" ")>=0&&u.push('""'),u.push(i),s==="wt"&&u.push("-d ."),new Promise((b,I)=>{const D=$(process),R=a.spawn(o,u,{cwd:r,env:D,detached:!0});R.on("error",I),R.on("exit",()=>b())})}async runInTerminal(a,t,o,r,i){const s="windowsExec"in i&&i.windowsExec?i.windowsExec:m.getDefaultTerminalWindows(),u=await m.f();return new Promise((b,I)=>{const D=`"${t} - ${k}"`,R=`"${o.join('" "')}" & pause`,C=Object.assign({},$(process),r);Object.keys(C).filter(H=>C[H]===null).forEach(H=>delete C[H]);const A={cwd:t,env:C,windowsVerbatimArguments:!0};let L,W;B.$oc(s,".exe")==="wt"?(L=s,W=["-d",".",m.b,"/c",R]):u?(L=u,W=["-d",".",s,"/c",R]):(L=m.b,W=["/c","start",D,"/wait",s,"/c",`"${R}"`]),n.spawn(L,W,A).on("error",H=>{I(f(H))}),b(void 0)})}static getDefaultTerminalWindows(){if(!m.d){const a=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");m.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${a?"Sysnative":"System32"}\\cmd.exe`}return m.d}static async f(){try{const a=await c.win32.findExecutable("wt");return await h.Promises.exists(a)?a:void 0}catch{return}}}e.$rac=m,Ee([j.$Lh],m,"f",null);class v extends g{static{this.b="/usr/bin/osascript"}openTerminal(a,t){return this.spawnTerminal(n,a,t)}runInTerminal(a,t,o,r,i){const s=i.osxExec||y.$o5b;return new Promise((u,b)=>{if(s===y.$o5b||s==="iTerm.app"){const I=s===y.$o5b?"TerminalHelper":"iTermHelper",R=[P.$Bg.asFileUri(`vs/workbench/contrib/externalTerminal/node/${I}.scpt`).fsPath,"-t",a||k,"-w",t];for(const L of o)R.push("-a"),R.push(L);if(r){const L=Object.assign({},$(process),r);for(const W in L){const q=L[W];q===null?(R.push("-u"),R.push(W)):(R.push("-e"),R.push(`${W}=${q}`))}}let C="";const A=n.spawn(v.b,R);A.on("error",L=>{b(f(L))}),A.stderr.on("data",L=>{C+=L.toString()}),A.on("exit",L=>{if(L===0)u(void 0);else if(C){const W=C.split(`
`,1);b(new Error(W[0]))}else b(new Error(p.localize(1,null,I,L)))})}else b(new Error(p.localize(2,null,s)))})}spawnTerminal(a,t,o){const r=t.osxExec||y.$o5b;return new Promise((i,s)=>{const u=["-a",r];o&&u.push(o);const b=$(process),I=a.spawn("/usr/bin/open",u,{cwd:o,env:b});I.on("error",s),I.on("exit",()=>i())})}}e.$sac=v;class w extends g{static{this.b=p.localize(3,null)}openTerminal(a,t){return this.spawnTerminal(n,a,t)}runInTerminal(a,t,o,r,i){const s=i.linuxExec?Promise.resolve(i.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((u,b)=>{const I=[];s.then(D=>{D.indexOf("gnome-terminal")>=0?I.push("-x"):I.push("-e"),I.push("bash"),I.push("-c");const R=`${l(o)}; echo; read -p "${w.b}" -n1;`;I.push(`''${R}''`);const C=Object.assign({},$(process),r);Object.keys(C).filter(q=>C[q]===null).forEach(q=>delete C[q]);const A={cwd:t,env:C};let L="";const W=n.spawn(D,I,A);W.on("error",q=>{b(f(q))}),W.stderr.on("data",q=>{L+=q.toString()}),W.on("exit",q=>{if(q===0)u(void 0);else if(L){const H=L.split(`
`,1);b(new Error(H[0]))}else b(new Error(p.localize(4,null,D,q)))})})})}static async getDefaultTerminalLinuxReady(){if(!w.d)if(!S.$k)w.d=Promise.resolve("xterm");else{const a=await h.Promises.exists("/etc/debian_version");w.d=new Promise(t=>{a?t("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?t("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?t("konsole"):process.env.COLORTERM?t(process.env.COLORTERM):process.env.TERM?t(process.env.TERM):t("xterm")})}return w.d}spawnTerminal(a,t,o){const r=t.linuxExec?Promise.resolve(t.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((i,s)=>{r.then(u=>{const b=$(process),I=a.spawn(u,[],{cwd:o,env:b});I.on("error",s),I.on("exit",()=>i())})})}}e.$tac=w;function $(d){const a={...d.env};return(0,E.$0l)(a),a}function f(d){return"errno"in d&&d.errno==="ENOENT"&&"path"in d&&typeof d.path=="string"?new Error(p.localize(5,null,d.path)):d}function l(d){let a="";for(const t of d)t.indexOf(" ")>=0?a+='"'+t+'"':a+=t,a+=" ";return a}}),define(oe[16],ae([0,1,59,9,25,12,7,178,6,4,13,62]),function(J,e,n,j,P,B,S,E,h,c,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jl=e.$gl=e.FileKind=e.$fl=e.$el=e.$dl=e.$cl=e.$bl=e.$al=e.$_k=e.FileOperationResult=e.$$k=e.$0k=e.$9k=e.$7k=e.FileChangeType=e.$6k=e.FileOperation=e.$Zk=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.$Nk=void 0,e.$Ok=k,e.$Pk=v,e.$Qk=$,e.$Rk=f,e.$Sk=l,e.$Tk=d,e.$Uk=a,e.$Vk=t,e.$Wk=o,e.$Xk=r,e.$Yk=i,e.$1k=b,e.$2k=I,e.$3k=D,e.$4k=R,e.$5k=C,e.$8k=H,e.$hl=z,e.$il=M,e.$kl=G,e.$Nk=(0,h.$hi)("fileService");function k(T){return T.create===!0}var g;(function(T){T[T.Unknown=0]="Unknown",T[T.File=1]="File",T[T.Directory=2]="Directory",T[T.SymbolicLink=64]="SymbolicLink"})(g||(e.FileType=g={}));var m;(function(T){T[T.Readonly=1]="Readonly",T[T.Locked=2]="Locked"})(m||(e.FilePermission=m={}));function v(T){const ce=T;return!!ce&&typeof ce.onDidChange=="function"}var w;(function(T){T[T.None=0]="None",T[T.FileReadWrite=2]="FileReadWrite",T[T.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",T[T.FileReadStream=16]="FileReadStream",T[T.FileFolderCopy=8]="FileFolderCopy",T[T.PathCaseSensitive=1024]="PathCaseSensitive",T[T.Readonly=2048]="Readonly",T[T.Trash=4096]="Trash",T[T.FileWriteUnlock=8192]="FileWriteUnlock",T[T.FileAtomicRead=16384]="FileAtomicRead",T[T.FileAtomicWrite=32768]="FileAtomicWrite",T[T.FileAtomicDelete=65536]="FileAtomicDelete",T[T.FileClone=131072]="FileClone"})(w||(e.FileSystemProviderCapabilities=w={}));function $(T){return!!(T.capabilities&2)}function f(T){return!!(T.capabilities&8)}function l(T){return!!(T.capabilities&131072)}function d(T){return!!(T.capabilities&4)}function a(T){return!!(T.capabilities&16)}function t(T){return $(T)?!!(T.capabilities&16384):!1}function o(T){return $(T)?!!(T.capabilities&32768):!1}function r(T){return!!(T.capabilities&65536)}function i(T){return!!(T.capabilities&2048)}var s;(function(T){T.FileExists="EntryExists",T.FileNotFound="EntryNotFound",T.FileNotADirectory="EntryNotADirectory",T.FileIsADirectory="EntryIsADirectory",T.FileExceedsStorageQuota="EntryExceedsStorageQuota",T.FileTooLarge="EntryTooLarge",T.FileWriteLocked="EntryWriteLocked",T.NoPermissions="NoPermissions",T.Unavailable="Unavailable",T.Unknown="Unknown"})(s||(e.FileSystemProviderErrorCode=s={}));class u extends Error{static create(ce,he){const K=new u(ce.toString(),he);return D(K,he),K}constructor(ce,he){super(ce),this.code=he}}e.$Zk=u;function b(T,ce){return u.create(T,ce)}function I(T){return T||b((0,E.localize)(0,null),s.Unknown)}function D(T,ce){return T.name=ce?`${ce} (FileSystemError)`:"FileSystemError",T}function R(T){if(!T)return s.Unknown;if(T instanceof u)return T.code;const ce=/^(.+) \(FileSystemError\)$/.exec(T.name);if(!ce)return s.Unknown;switch(ce[1]){case s.FileExists:return s.FileExists;case s.FileIsADirectory:return s.FileIsADirectory;case s.FileNotADirectory:return s.FileNotADirectory;case s.FileNotFound:return s.FileNotFound;case s.FileTooLarge:return s.FileTooLarge;case s.FileWriteLocked:return s.FileWriteLocked;case s.NoPermissions:return s.NoPermissions;case s.Unavailable:return s.Unavailable}return s.Unknown}function C(T){if(T instanceof le)return T.fileOperationResult;switch(R(T)){case s.FileNotFound:return 1;case s.FileIsADirectory:return 0;case s.FileNotADirectory:return 9;case s.FileWriteLocked:return 5;case s.NoPermissions:return 6;case s.FileExists:return 4;case s.FileTooLarge:return 7;default:return 10}}var A;(function(T){T[T.CREATE=0]="CREATE",T[T.DELETE=1]="DELETE",T[T.MOVE=2]="MOVE",T[T.COPY=3]="COPY",T[T.WRITE=4]="WRITE"})(A||(e.FileOperation=A={}));class L{constructor(ce,he,K){this.resource=ce,this.operation=he,this.target=K}isOperation(ce){return this.operation===ce}}e.$6k=L;var W;(function(T){T[T.UPDATED=0]="UPDATED",T[T.ADDED=1]="ADDED",T[T.DELETED=2]="DELETED"})(W||(e.FileChangeType=W={}));class q{static{this.a=null}constructor(ce,he){this.c=he,this.b=void 0,this.d=new y.$V(()=>{const K=n.$ni.forUris(()=>this.c);return K.fill(this.rawAdded.map(O=>[O,!0])),K}),this.f=new y.$V(()=>{const K=n.$ni.forUris(()=>this.c);return K.fill(this.rawUpdated.map(O=>[O,!0])),K}),this.g=new y.$V(()=>{const K=n.$ni.forUris(()=>this.c);return K.fill(this.rawDeleted.map(O=>[O,!0])),K}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const K of ce){switch(K.type){case 1:this.rawAdded.push(K.resource);break;case 0:this.rawUpdated.push(K.resource);break;case 2:this.rawDeleted.push(K.resource);break}this.b!==q.a&&(typeof K.cId=="number"?this.b===void 0?this.b=K.cId:this.b!==K.cId&&(this.b=q.a):this.b!==void 0&&(this.b=q.a))}}contains(ce,...he){return this.h(ce,{includeChildren:!1},...he)}affects(ce,...he){return this.h(ce,{includeChildren:!0},...he)}h(ce,he,...K){if(!ce)return!1;const O=K.length>0;return!!((!O||K.includes(1))&&(this.d.value.get(ce)||he.includeChildren&&this.d.value.findSuperstr(ce))||(!O||K.includes(0))&&(this.f.value.get(ce)||he.includeChildren&&this.f.value.findSuperstr(ce))||(!O||K.includes(2))&&(this.g.value.findSubstr(ce)||he.includeChildren&&this.g.value.findSuperstr(ce)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ce){return this.b===ce}hasCorrelation(){return typeof this.b=="number"}}e.$7k=q;function H(T,ce,he){return!T||!ce||T===ce||ce.length>T.length?!1:(ce.charAt(ce.length-1)!==j.sep&&(ce+=j.sep),he?(0,P.$mf)(T,ce):T.indexOf(ce)===0)}class le extends Error{constructor(ce,he,K){super(ce),this.fileOperationResult=he,this.options=K}}e.$9k=le;class te extends le{constructor(ce,he,K,O){super(ce,he,O),this.fileOperationResult=he,this.size=K}}e.$0k=te;class ue extends le{constructor(ce,he,K){super(ce,2,K),this.stat=he}}e.$$k=ue;var X;(function(T){T[T.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",T[T.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",T[T.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",T[T.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",T[T.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",T[T.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",T[T.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",T[T.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",T[T.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",T[T.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",T[T.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(X||(e.FileOperationResult=X={})),e.$_k={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$al={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$bl="files.associations",e.$cl="files.exclude",e.$dl="files.readonlyInclude",e.$el="files.readonlyExclude",e.$fl="files.readonlyFromPermissions";var Q;(function(T){T[T.FILE=0]="FILE",T[T.FOLDER=1]="FOLDER",T[T.ROOT_FOLDER=2]="ROOT_FOLDER"})(Q||(e.FileKind=Q={})),e.$gl="";function z(T){if(!(typeof T.size!="number"||typeof T.mtime!="number"))return T.mtime.toString(29)+T.size.toString(31)}async function M(T,ce){if(!ce.hasProvider(S.URI.from({scheme:T.scheme})))return new Promise(he=>{const K=ce.onDidChangeFileSystemProviderRegistrations(O=>{O.scheme===T.scheme&&O.added&&(K.dispose(),he())})})}class F{static{this.KB=1024}static{this.MB=F.KB*F.KB}static{this.GB=F.MB*F.KB}static{this.TB=F.GB*F.KB}static formatSize(ce){return(0,B.$Yf)(ce)||(ce=0),ce<F.KB?(0,E.localize)(1,null,ce.toFixed(0)):ce<F.MB?(0,E.localize)(2,null,(ce/F.KB).toFixed(2)):ce<F.GB?(0,E.localize)(3,null,(ce/F.MB).toFixed(2)):ce<F.TB?(0,E.localize)(4,null,(ce/F.GB).toFixed(2)):(0,E.localize)(5,null,(ce/F.TB).toFixed(2))}}e.$jl=F;function G(T){const ce=typeof T=="string"||T?.scheme===p.Schemas.vscodeRemote;return typeof T!="string"&&T?.scheme===p.Schemas.file?1024*F.MB:ce?10*F.MB:c.$o?50*F.MB:1024*F.MB}}),define(oe[122],ae([0,1,17,15,179,16]),function(J,e,n,j,P,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sq=S;async function S(p,y,k,g,m,v){let w;try{await E(p,y,k,g,m,v)}catch($){w=$}finally{w&&m.errorTransformer&&(w=m.errorTransformer(w)),typeof w<"u"&&k.error(w),k.end()}}async function E(p,y,k,g,m,v){h(v);const w=await p.open(y,{create:!1});try{h(v);let $=0,f=0,l=m&&typeof m.length=="number"?m.length:void 0,d=n.$ue.alloc(Math.min(m.bufferSize,typeof l=="number"?l:m.bufferSize)),a=m&&typeof m.position=="number"?m.position:0,t=0;do f=await p.read(w,a,d.buffer,t,d.byteLength-t),a+=f,t+=f,$+=f,typeof l=="number"&&(l-=f),t===d.byteLength&&(await k.write(g(d)),d=n.$ue.alloc(Math.min(m.bufferSize,typeof l=="number"?l:m.bufferSize)),t=0);while(f>0&&(typeof l!="number"||l>0)&&h(v)&&c($,m));if(t>0){let o=t;typeof l=="number"&&(o=Math.min(t,l)),k.write(g(d.slice(0,o)))}}catch($){throw(0,B.$2k)($)}finally{await p.close(w)}}function h(p){if(p.isCancellationRequested)throw(0,j.$6)();return!0}function c(p,y){if(typeof y?.limits?.size=="number"&&p>y.limits.size)throw(0,B.$1k)((0,P.localize)(0,null),B.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(oe[60],ae([0,1,108,2,9,4,7,16]),function(J,e,n,j,P,B,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yq=e.$xq=e.$wq=void 0,e.$uq=h,e.$vq=c,e.$zq=g,e.$Aq=m,e.$Bq=v,e.$Cq=w;function h(f){return typeof f.correlationId=="number"}function c(f){return f.recursive===!0}class p extends j.$Uc{static{this.a=5}constructor(l,d,a,t){super(),this.h=l,this.j=d,this.m=a,this.n=t,this.c=this.B(new j.$Vc),this.f=void 0,this.g=0}s(){const l=new j.$Tc;this.c.value=l,this.b=this.r(l),this.b.setVerboseLogging(this.m),l.add(this.b.onDidChangeFile(d=>this.h(d))),l.add(this.b.onDidLogMessage(d=>this.j(d))),l.add(this.b.onDidError(d=>this.t(d)))}t(l){this.n.restartOnError?this.g<p.a&&this.f?(this.w(`restarting watcher after error: ${l}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${l}`):this.w(l)}u(l){this.g++,this.s(),this.watch(l)}async watch(l){this.f=l,await this.b?.watch(l)}async setVerboseLogging(l){this.m=l,await this.b?.setVerboseLogging(l)}w(l){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${l}`})}y(l){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${l}`})}dispose(){return this.b=void 0,super.dispose()}}e.$wq=p;class y extends p{constructor(l,d,a){super(l,d,a,{type:"node.js",restartOnError:!1})}}e.$xq=y;class k extends p{constructor(l,d,a){super(l,d,a,{type:"universal",restartOnError:!0})}}e.$yq=k;function g(f){return f.map(l=>({type:l.type,resource:S.URI.revive(l.resource),cId:l.cId}))}function m(f){const l=new $;for(const d of f)l.processEvent(d);return l.coalesce()}function v(f,l){return typeof l=="string"&&!l.startsWith(n.$0j)&&!(0,P.$jc)(l)?{base:f,pattern:l}:l}function w(f,l){const d=[];for(const a of l)d.push((0,n.$bk)(v(f,a)));return d}class ${constructor(){this.a=new Set,this.b=new Map}c(l){return B.$k?l.resource.fsPath:l.resource.fsPath.toLowerCase()}processEvent(l){const d=this.b.get(this.c(l));let a=!1;if(d){const t=d.type,o=l.type;d.resource.fsPath!==l.resource.fsPath&&(l.type===2||l.type===1)?a=!0:t===1&&o===2?(this.b.delete(this.c(l)),this.a.delete(d)):t===2&&o===1?d.type=0:t===1&&o===0||(d.type=o)}else a=!0;a&&(this.a.add(l),this.b.set(this.c(l),l))}coalesce(){const l=[],d=[];return Array.from(this.a).filter(a=>a.type!==2?(l.push(a),!1):!0).sort((a,t)=>a.resource.fsPath.length-t.resource.fsPath.length).filter(a=>d.some(t=>(0,E.$8k)(a.resource.fsPath,t,!B.$k))?!1:(d.push(a.resource.fsPath),!0)).concat(l)}}}),define(oe[216],ae([0,1,17,47,15,3,2,63,33,16,60]),function(J,e,n,j,P,B,S,E,h,c,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LP=e.$KP=void 0,e.$KP="localFilesystem";class y extends S.$Uc{constructor(g,m){super(),this.a=g,this.b=m,this.onDidChangeCapabilities=B.Event.None,this.f=this.B(new B.$7d),this.onDidChangeFile=this.f.event,this.g=this.B(new B.$7d),this.onDidWatchError=this.g.event,this.h=(0,h.$Dg)(),this.j()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(g){return this.a.call("stat",[g])}readdir(g){return this.a.call("readdir",[g])}async readFile(g,m){const{buffer:v}=await this.a.call("readFile",[g,m]);return v}readFileStream(g,m,v){const w=(0,E.$ie)(f=>n.$ue.concat(f.map(l=>n.$ue.wrap(l))).buffer),$=new S.$Tc;return $.add(this.a.listen("readFileStream",[g,m])(f=>{if(f instanceof n.$ue)w.write(f.buffer);else{if(f==="end")w.end();else{let l;if(f instanceof Error)l=f;else{const d=f;l=(0,c.$1k)(d.message??(0,j.$5i)(d),d.code??c.FileSystemProviderErrorCode.Unknown)}w.error(l),w.end()}$.dispose()}})),$.add(v.onCancellationRequested(()=>{w.error((0,P.$6)()),w.end(),$.dispose()})),w}writeFile(g,m,v){return this.a.call("writeFile",[g,n.$ue.wrap(m),v])}open(g,m){return this.a.call("open",[g,m])}close(g){return this.a.call("close",[g])}async read(g,m,v,w,$){const[f,l]=await this.a.call("read",[g,m,$]);return v.set(f.buffer.slice(0,l),w),l}write(g,m,v,w,$){return this.a.call("write",[g,m,n.$ue.wrap(v),w,$])}mkdir(g){return this.a.call("mkdir",[g])}delete(g,m){return this.a.call("delete",[g,m])}rename(g,m,v){return this.a.call("rename",[g,m,v])}copy(g,m,v){return this.a.call("copy",[g,m,v])}cloneFile(g,m){return this.a.call("cloneFile",[g,m])}j(){this.B(this.a.listen("fileChange",[this.h])(g=>{if(Array.isArray(g)){const m=g;this.f.fire((0,p.$zq)(m))}else{const m=g;this.g.fire(m)}}))}watch(g,m){const v=(0,h.$Dg)();return this.a.call("watch",[this.h,v,g,m]),(0,S.$Sc)(()=>this.a.call("unwatch",[this.h,v]))}}e.$LP=y}),define(oe[217],ae([0,1,43,2,60,3,7]),function(J,e,n,j,P,B,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lq=void 0;class E extends j.$Uc{constructor(){super(),this.a=this.B(new B.$7d),this.onDidChangeFile=this.a.event,this.b=this.B(new B.$7d),this.onDidLogMessage=this.b.event,this.c=this.B(new B.$7d),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new j.$4c),this.m=5007,this.B(this.f(c=>this.n(c)))}n(c){this.r(c)&&this.t(c)}r(c){return(0,P.$uq)(c)}async watch(c){this.h.clear(),this.g.clear();for(const p of c)this.r(p)?this.h.set(p.correlationId,p):this.g.add(p);for(const[p]of this.j)this.h.has(p)||this.j.deleteAndDispose(p);return this.s()}s(){return this.D([...this.g,...Array.from(this.h.values()).filter(c=>!this.j.has(c.correlationId))])}t(c){if(this.j.has(c.correlationId))return;const p=new j.$Tc;this.j.set(c.correlationId,p),this.w(c,p),this.s()}u(c){this.j.deleteAndDispose(c.correlationId),this.s()}w(c,p){const y=S.URI.file(c.path),k=this;let g=!1;const m=(v,w)=>{if(p.isDisposed)return;const $=this.y(v),f=this.y(w),l=g;if(g=$,f&&!$||l&&!$&&!f){this.F(`fs.watchFile() detected ${c.path} exists again, resuming watcher (correlationId: ${c.correlationId})`);const d={resource:y,type:1,cId:c.correlationId};k.a.fire([d]),this.z(d,c),this.u(c)}};this.F(`starting fs.watchFile() on ${c.path} (correlationId: ${c.correlationId})`);try{(0,n.watchFile)(c.path,{persistent:!1,interval:this.m},m)}catch(v){this.G(`fs.watchFile() failed with error ${v} on path ${c.path} (correlationId: ${c.correlationId})`)}p.add((0,j.$Sc)(()=>{this.F(`stopping fs.watchFile() on ${c.path} (correlationId: ${c.correlationId})`);try{(0,n.unwatchFile)(c.path,m)}catch(v){this.G(`fs.unwatchFile() failed with error ${v} on path ${c.path} (correlationId: ${c.correlationId})`)}}))}y(c){return c.ctimeMs===0&&c.ino===0}async stop(){this.j.clearAndDisposeAll()}z(c,p){const y=` >> normalized ${c.type===1?"[ADDED]":c.type===2?"[DELETED]":"[CHANGED]"} ${c.resource.fsPath}`;this.F(typeof p.correlationId=="number"?`${y} (correlationId: ${p.correlationId})`:y)}C(c){return`${c.path} (excludes: ${c.excludes.length>0?c.excludes:"<none>"}, includes: ${c.includes&&c.includes.length>0?JSON.stringify(c.includes):"<all>"}, correlationId: ${typeof c.correlationId=="number"?c.correlationId:"<none>"})`}}e.$Lq=E}),define(oe[218],ae([0,1,43,8,23,31,2,86,9,4,19,7,109,21,60]),function(J,e,n,j,P,B,S,E,h,c,p,y,k,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qq=void 0,e.$Rq=w;class v extends S.$Uc{static{this.a=100}static{this.b=75}constructor(f,l,d,a,t){super(),this.m=f,this.n=l,this.r=d,this.s=a,this.t=t,this.c=this.B(new j.$wh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},o=>this.n(o))),this.f=this.B(new j.$vh(o=>this.D(o),v.b)),this.g=(0,m.$Cq)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,m.$Cq)(this.m.path,this.m.includes):void 0,this.j=new P.$ee,this.ready=this.u()}async u(){try{const f=await this.w(this.m);if(this.j.token.isCancellationRequested)return;const l=await g.Promises.stat(f);if(this.j.token.isCancellationRequested)return;this.B(await this.y(f,l.isDirectory()))}catch(f){f.code!=="ENOENT"?this.G(f):this.I(`ignoring a path for watching who's stat info failed to resolve: ${this.m.path} (error: ${f})`),this.r?.()}}async w(f){let l=f.path;try{l=await g.Promises.realpath(f.path),f.path===l&&(l=await(0,k.$Nq)(f.path,this.j.token)??f.path),f.path!==l&&this.I(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${f.path}, real: ${l})`)}catch{}return l}async y(f,l){if(c.$j&&(0,B.$hg)(f,"/Volumes/",!0))return this.G(`Refusing to watch ${f} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),S.$Uc.None;const d=new P.$ee(this.j.token),a=new S.$Tc;try{const t=y.URI.file(this.m.path),o=(0,h.$oc)(f),r=(0,n.watch)(f);a.add((0,S.$Sc)(()=>{r.removeAllListeners(),r.close()})),this.I(`Started watching: '${f}'`);const i=new Set;if(l)try{for(const u of await g.Promises.readdir(f))i.add(u)}catch(u){this.G(u)}const s=new Map;a.add((0,S.$Sc)(()=>{for(const[,u]of s)u.dispose();s.clear()})),r.on("error",(u,b)=>{this.G(`Failed to watch ${f} for changes using fs.watch() (${u}, ${b})`),this.r?.()}),r.on("change",(u,b)=>{if(d.token.isCancellationRequested)return;this.I(`[raw] ["${u}"] ${b}`);let I="";if(b&&(I=b.toString(),c.$j&&(I=(0,E.$Yl)(I))),!(!I||u!=="change"&&u!=="rename"))if(l)if(u==="rename"){s.get(I)?.dispose();const D=setTimeout(async()=>{if(s.delete(I),I===o&&!await g.Promises.exists(f)){this.z(t);return}const R=await this.F((0,h.$kc)(f,I));if(d.token.isCancellationRequested)return;let C;R?i.has(I)?C=0:(C=1,i.add(I)):(i.delete(I),C=2),this.C({resource:(0,p.$Ug)(t,I),type:C,cId:this.m.correlationId})},v.a);s.set(I,(0,S.$Sc)(()=>clearTimeout(D)))}else{let D;i.has(I)?D=0:(D=1,i.add(I)),this.C({resource:(0,p.$Ug)(t,I),type:D,cId:this.m.correlationId})}else if(u==="rename"||I!==o){const D=setTimeout(async()=>{const R=await g.Promises.exists(f);d.token.isCancellationRequested||(R?(this.C({resource:t,type:0,cId:this.m.correlationId},!0),a.add(await this.y(f,!1))):this.z(t))},v.a);a.clear(),a.add((0,S.$Sc)(()=>clearTimeout(D)))}else this.C({resource:t,type:0,cId:this.m.correlationId},!0)})}catch(t){d.token.isCancellationRequested||this.G(`Failed to watch ${f} for changes using fs.watch() (${t.toString()})`),this.r?.()}return(0,S.$Sc)(()=>{d.dispose(!0),a.dispose()})}z(f){this.H("Watcher shutdown because watched path got deleted"),this.C({resource:f,type:2,cId:this.m.correlationId},!0),this.f.flush(),this.r?.()}C(f,l=!1){this.j.token.isCancellationRequested||(this.t&&this.I(`${f.type===1?"[ADDED]":f.type===2?"[DELETED]":"[CHANGED]"} ${f.resource.fsPath}`),!l&&this.g.some(d=>d(f.resource.fsPath))?this.t&&this.I(` >> ignored (excluded) ${f.resource.fsPath}`):!l&&this.h&&this.h.length>0&&!this.h.some(d=>d(f.resource.fsPath))?this.t&&this.I(` >> ignored (not included) ${f.resource.fsPath}`):this.f.work(f))}D(f){const l=(0,m.$Aq)(f);if(l.length>0){if(this.t)for(const a of l)this.I(` >> normalized ${a.type===1?"[ADDED]":a.type===2?"[DELETED]":"[CHANGED]"} ${a.resource.fsPath}`);this.c.work(l)?this.c.pending>0&&this.I(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${l[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.H(`started ignoring events due to too many file change events at once (incoming: ${l.length}, most recent change: ${l[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async F(f){if(c.$k)return g.Promises.exists(f);try{const l=(0,h.$oc)(f);return(await g.Promises.readdir((0,h.$nc)(f))).some(a=>a===l)}catch(l){return this.I(l),!1}}setVerboseLogging(f){this.t=f}G(f){this.j.token.isCancellationRequested||this.s?.({type:"error",message:`[File Watcher (node.js)] ${f}`})}H(f){this.j.token.isCancellationRequested||this.s?.({type:"warn",message:`[File Watcher (node.js)] ${f}`})}I(f){!this.j.token.isCancellationRequested&&this.t&&this.s?.({type:"trace",message:`[File Watcher (node.js)] ${f}`})}dispose(){this.j.dispose(!0),super.dispose()}}e.$Qq=v;async function w($,f,l,d,a=512){const t=await g.Promises.open($,"r"),o=Buffer.allocUnsafe(a),r=new P.$ee(d);let i,s=!1;const u={path:$,excludes:[],recursive:!1},b=new v(u,I=>{(async()=>{for(const{type:D}of I)if(D===0){if(s)return;s=!0;try{for(;!r.token.isCancellationRequested;){const{bytesRead:R}=await g.Promises.read(t,o,0,a,null);if(!R||r.token.isCancellationRequested)break;f(o.slice(0,R))}}catch(R){i=new Error(R),r.dispose(!0)}finally{s=!1}}})()});return await b.ready,l(),new Promise((I,D)=>{r.token.onCancellationRequested(async()=>{b.dispose();try{await g.Promises.close(t)}catch(R){i=new Error(R)}i?D(i):I()})})}}),define(oe[219],ae([0,1,3,108,217,4,218,31]),function(J,e,n,j,P,B,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sq=void 0;class h extends P.$Lq{constructor(){super(...arguments),this.onDidError=n.Event.None,this.H=new Set,this.I=!1}async D(p){p=this.O(p);const y=[],k=new Set(Array.from(this.H));for(const g of p){const m=this.L(g);m&&(0,j.$fk)(m.request.excludes,g.excludes)&&(0,j.$fk)(m.request.includes,g.includes)?k.delete(m):y.push(g)}y.length&&this.F(`Request to start watching: ${y.map(g=>this.C(g)).join(",")}`),k.size&&this.F(`Request to stop watching: ${Array.from(k).map(g=>this.C(g.request)).join(",")}`);for(const g of k)this.N(g);for(const g of y)this.M(g)}L(p){for(const y of this.H)if(typeof p.correlationId=="number"||typeof y.request.correlationId=="number"){if(y.request.correlationId===p.correlationId)return y}else if((0,E.$gg)(y.request.path,p.path,!B.$k))return y}M(p){const y=new S.$Qq(p,g=>this.a.fire(g),()=>this.c.fire(p),g=>this.b.fire(g),this.I),k={request:p,instance:y};this.H.add(k)}async stop(){await super.stop();for(const p of this.H)this.N(p)}N(p){this.F("stopping file watcher",p),this.H.delete(p),p.instance.dispose()}O(p){const y=new Map;for(const k of p){const g=B.$k?k.path:k.path.toLowerCase();let m=y.get(k.correlationId);m||(m=new Map,y.set(k.correlationId,m)),m.has(g)&&this.F(`ignoring a request for watching who's path is already watched: ${this.C(k)}`),m.set(g,k)}return Array.from(y.values()).map(k=>Array.from(k.values())).flat()}async setVerboseLogging(p){this.I=p;for(const y of this.H)y.instance.setVerboseLogging(p)}F(p,y){this.I&&this.b.fire({type:"trace",message:this.R(p,y)})}G(p){this.b.fire({type:"warn",message:this.R(p)})}R(p,y){return y?`[File Watcher (node.js)] ${p} (${this.C(y.request)})`:`[File Watcher (node.js)] ${p}`}}e.$Sq=h}),define(oe[220],ae([0,1,60,219]),function(J,e,n,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tq=void 0;class P extends n.$xq{constructor(S,E,h){super(S,E,h),this.s()}r(S){return S.add(new j.$Sq)}}e.$Tq=P}),define(oe[221],ae([0,1,13,44,162,60]),function(J,e,n,j,P,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kq=void 0;class S extends B.$yq{constructor(h,c,p){super(h,c,p),this.s()}r(h){const c=h.add(new P.$Jq(n.$Bg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return h.add(c.onDidProcessExit(({code:p,signal:y})=>this.t(`terminated by itself with code ${p}, signal: ${y}`))),j.ProxyChannel.toService((0,j.$1h)(c.getChannel("watcher")))}}e.$Kq=S}),define(oe[93],ae([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fi=void 0;class n{constructor(...P){this.a=new Map;for(const[B,S]of P)this.set(B,S)}set(P,B){const S=this.a.get(P);return this.a.set(P,B),S}has(P){return this.a.has(P)}get(P){return this.a.get(P)}}e.$fi=n}),define(oe[222],ae([0,1,8,15,2,77,211,6,93,104]),function(J,e,n,j,P,B,S,E,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yq=e.$Xq=void 0;const p=!1;class y extends Error{constructor(w){super("cyclic dependency between services"),this.message=w.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${w.toString()}`}}class k{constructor(w=new h.$fi,$=!1,f,l=p){this.f=w,this.g=$,this.h=f,this.i=l,this.o=new Set,this.f.set(E.$gi,this),this._globalGraph=l?f?._globalGraph??new S.$Wq(d=>d):void 0}createChild(w){return new k(w,this.g,this,this.i)}invokeFunction(w,...$){const f=m.traceInvocation(this.i,w);let l=!1;try{return w({get:a=>{if(l)throw(0,j.$8)("service accessor is only valid during the invocation of its target method");const t=this.m(a,f);if(!t)throw new Error(`[invokeFunction] unknown service '${a}'`);return t}},...$)}finally{l=!0,f.stop()}}createInstance(w,...$){let f,l;return w instanceof B.$ei?(f=m.traceCreation(this.i,w.ctor),l=this.j(w.ctor,w.staticArguments.concat($),f)):(f=m.traceCreation(this.i,w),l=this.j(w,$,f)),f.stop(),l}j(w,$=[],f){const l=E._util.getServiceDependencies(w).sort((t,o)=>t.index-o.index),d=[];for(const t of l){const o=this.m(t.id,f);o||this.u(`[createInstance] ${w.name} depends on UNKNOWN service ${t.id}.`,!1),d.push(o)}const a=l.length>0?l[0].index:$.length;if($.length!==a){console.trace(`[createInstance] First service dependency of ${w.name} at position ${a+1} conflicts with ${$.length} static arguments`);const t=a-$.length;t>0?$=$.concat(new Array(t)):$=$.slice(0,a)}return Reflect.construct(w,$.concat(d))}k(w,$){if(this.f.get(w)instanceof B.$ei)this.f.set(w,$);else if(this.h)this.h.k(w,$);else throw new Error("illegalState - setting UNKNOWN service instance")}l(w){const $=this.f.get(w);return!$&&this.h?this.h.l(w):$}m(w,$){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(w));const f=this.l(w);return f instanceof B.$ei?this.q(w,f,$.branch(w,!0)):($.branch(w,!1),f)}q(w,$,f){if(this.o.has(w))throw new Error(`illegal state - RECURSIVELY instantiating service '${w}'`);this.o.add(w);try{return this.r(w,$,f)}finally{this.o.delete(w)}}r(w,$,f){const l=new S.$Wq(t=>t.id.toString());let d=0;const a=[{id:w,desc:$,_trace:f}];for(;a.length;){const t=a.pop();if(l.lookupOrInsertNode(t),d++>1e3)throw new y(l);for(const o of E._util.getServiceDependencies(t.desc.ctor)){const r=this.l(o.id);if(r||this.u(`[createInstance] ${w} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(o.id)),r instanceof B.$ei){const i={id:o.id,desc:r,_trace:t._trace.branch(o.id,!0)};l.insertEdge(t,i),a.push(i)}}}for(;;){const t=l.roots();if(t.length===0){if(!l.isEmpty())throw new y(l);break}for(const{data:o}of t){if(this.l(o.id)instanceof B.$ei){const i=this.s(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this.k(o.id,i)}l.removeNode(o)}}return this.l(w)}s(w,$,f=[],l,d){if(this.f.get(w)instanceof B.$ei)return this.t(w,$,f,l,d);if(this.h)return this.h.s(w,$,f,l,d);throw new Error(`illegalState - creating UNKNOWN service instance ${$.name}`)}t(w,$,f=[],l,d){if(l){const a=new k(void 0,this.g,this,this.i);a.c=String(w);const t=new Map,o=new n.$Ah(()=>{const r=a.j($,f,d);for(const[i,s]of t){const u=r[i];if(typeof u=="function")for(const b of s)b.disposable=u.apply(r,b.listener)}return t.clear(),r});return new Proxy(Object.create(null),{get(r,i){if(!o.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let b=t.get(i);return b||(b=new c.$5c,t.set(i,b)),(D,R,C)=>{if(o.isInitialized)return o.value[i](D,R,C);{const A={listener:[D,R,C],disposable:void 0},L=b.push(A);return(0,P.$Sc)(()=>{L(),A.disposable?.dispose()})}}}if(i in r)return r[i];const s=o.value;let u=s[i];return typeof u!="function"||(u=u.bind(s),r[i]=u),u},set(r,i,s){return o.value[i]=s,!0},getPrototypeOf(r){return $.prototype}})}else return this.j($,f,d)}u(w,$){if($&&console.warn(w),this.g)throw new Error(w)}}e.$Xq=k;var g;(function(v){v[v.None=0]="None",v[v.Creation=1]="Creation",v[v.Invocation=2]="Invocation",v[v.Branch=3]="Branch"})(g||(g={}));class m{static{this.all=new Set}static{this.c=new class extends m{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(w,$){return w?new m(2,$.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):m.c}static traceCreation(w,$){return w?new m(1,$.name):m.c}static{this.f=0}constructor(w,$){this.type=w,this.name=$,this.g=Date.now(),this.h=[]}branch(w,$){const f=new m(3,w.toString());return this.h.push([w,$,f]),f}stop(){const w=Date.now()-this.g;m.f+=w;let $=!1;function f(d,a){const t=[],o=new Array(d+1).join("	");for(const[r,i,s]of a.h)if(i&&s){$=!0,t.push(`${o}CREATES -> ${r}`);const u=f(d+1,s);u&&t.push(u)}else t.push(`${o}uses -> ${r}`);return t.join(`
`)}const l=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${f(1,this)}`,`DONE, took ${w.toFixed(2)}ms (grand total ${m.f.toFixed(2)}ms)`];(w>2||$)&&m.all.add(l.join(`
`))}}e.$Yq=m}),define(oe[223],ae([0,1,6]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ECb=e.IssueSource=e.IssueType=void 0;var j;(function(B){B[B.Bug=0]="Bug",B[B.PerformanceIssue=1]="PerformanceIssue",B[B.FeatureRequest=2]="FeatureRequest"})(j||(e.IssueType=j={}));var P;(function(B){B.VSCode="vscode",B.Extension="extension",B.Marketplace="marketplace"})(P||(e.IssueSource=P={})),e.$ECb=(0,n.$hi)("issueService")}),define(oe[5],ae([0,1,183,47,3,46,2,32,4,19,12,7,118,6]),function(J,e,n,j,P,B,S,E,h,c,p,y,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Qj=e.LogLevel=e.$Oj=e.$Nj=void 0,e.$Pj=v,e.log=$,e.$2j=b,e.$3j=I,e.$4j=D,e.$5j=R,e.$Nj=(0,g.$hi)("logService"),e.$Oj=(0,g.$hi)("loggerService");function m(){return new Date().toISOString()}function v(C){return(0,p.$Yf)(C)}var w;(function(C){C[C.Off=0]="Off",C[C.Trace=1]="Trace",C[C.Debug=2]="Debug",C[C.Info=3]="Info",C[C.Warning=4]="Warning",C[C.Error=5]="Error"})(w||(e.LogLevel=w={})),e.$Qj=w.Info;function $(C,A,L){switch(A){case w.Trace:C.trace(L);break;case w.Debug:C.debug(L);break;case w.Info:C.info(L);break;case w.Warning:C.warn(L);break;case w.Error:C.error(L);break;case w.Off:break;default:throw new Error(`Invalid log level ${A}`)}}function f(C,A=!1){let L="";for(let W=0;W<C.length;W++){let q=C[W];if(q instanceof Error&&(q=(0,j.$5i)(q,A)),typeof q=="object")try{q=JSON.stringify(q)}catch{}L+=(W>0?" ":"")+q}return L}class l extends S.$Uc{constructor(){super(...arguments),this.b=e.$Qj,this.c=this.B(new P.$7d),this.onDidChangeLogLevel=this.c.event}setLevel(A){this.b!==A&&(this.b=A,this.c.fire(this.b))}getLevel(){return this.b}f(A){return this.b!==w.Off&&this.b<=A}}e.$Sj=l;class d extends l{constructor(A){super(),this.h=A}f(A){return this.h||super.f(A)}trace(A,...L){this.f(w.Trace)&&this.g(w.Trace,f([A,...L],!0))}debug(A,...L){this.f(w.Debug)&&this.g(w.Debug,f([A,...L]))}info(A,...L){this.f(w.Info)&&this.g(w.Info,f([A,...L]))}warn(A,...L){this.f(w.Warning)&&this.g(w.Warning,f([A,...L]))}error(A,...L){if(this.f(w.Error))if(A instanceof Error){const W=Array.prototype.slice.call(arguments);W[0]=A.stack,this.g(w.Error,f(W))}else this.g(w.Error,f([A,...L]))}flush(){}}e.$Tj=d;class a extends l{constructor(A=e.$Qj){super(),this.setLevel(A),this.g=!h.$i}trace(A,...L){this.f(w.Trace)&&(this.g?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,A,...L):console.log(`[main ${m()}]`,A,...L))}debug(A,...L){this.f(w.Debug)&&(this.g?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,A,...L):console.log(`[main ${m()}]`,A,...L))}info(A,...L){this.f(w.Info)&&(this.g?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,A,...L):console.log(`[main ${m()}]`,A,...L))}warn(A,...L){this.f(w.Warning)&&(this.g?console.warn(`\x1B[93m[main ${m()}]\x1B[0m`,A,...L):console.warn(`[main ${m()}]`,A,...L))}error(A,...L){this.f(w.Error)&&(this.g?console.error(`\x1B[91m[main ${m()}]\x1B[0m`,A,...L):console.error(`[main ${m()}]`,A,...L))}flush(){}}e.$Uj=a;class t extends l{constructor(A=e.$Qj,L=!0){super(),this.g=L,this.setLevel(A)}trace(A,...L){this.f(w.Trace)&&(this.g?console.log("%cTRACE","color: #888",A,...L):console.log(A,...L))}debug(A,...L){this.f(w.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",A,...L):console.log(A,...L))}info(A,...L){this.f(w.Info)&&(this.g?console.log("%c INFO","color: #33f",A,...L):console.log(A,...L))}warn(A,...L){this.f(w.Warning)&&(this.g?console.log("%c WARN","color: #993",A,...L):console.log(A,...L))}error(A,...L){this.f(w.Error)&&(this.g?console.log("%c  ERR","color: #f33",A,...L):console.error(A,...L))}flush(){}}e.$Vj=t;class o extends l{constructor(A,L=e.$Qj){super(),this.g=A,this.setLevel(L)}trace(A,...L){this.f(w.Trace)&&this.g.log(w.Trace,[this.h(A),...L])}debug(A,...L){this.f(w.Debug)&&this.g.log(w.Debug,[this.h(A),...L])}info(A,...L){this.f(w.Info)&&this.g.log(w.Info,[this.h(A),...L])}warn(A,...L){this.f(w.Warning)&&this.g.log(w.Warning,[this.h(A),...L])}error(A,...L){this.f(w.Error)&&this.g.log(w.Error,[this.h(A),...L])}h(A){return typeof A=="string"?A:(0,j.$5i)(A,this.f(w.Trace))}flush(){}}e.$Wj=o;class r extends l{constructor(A){super(),this.g=A,A.length&&this.setLevel(A[0].getLevel())}setLevel(A){for(const L of this.g)L.setLevel(A);super.setLevel(A)}trace(A,...L){for(const W of this.g)W.trace(A,...L)}debug(A,...L){for(const W of this.g)W.debug(A,...L)}info(A,...L){for(const W of this.g)W.info(A,...L)}warn(A,...L){for(const W of this.g)W.warn(A,...L)}error(A,...L){for(const W of this.g)W.error(A,...L)}flush(){for(const A of this.g)A.flush()}dispose(){for(const A of this.g)A.dispose();super.dispose()}}e.$Xj=r;class i extends S.$Uc{constructor(A,L,W){if(super(),this.h=A,this.j=L,this.b=new E.$Bc,this.c=this.B(new P.$7d),this.onDidChangeLoggers=this.c.event,this.f=this.B(new P.$7d),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new P.$7d),this.onDidChangeVisibility=this.g.event,W)for(const q of W)this.b.set(q.resource,{logger:void 0,info:q})}m(A){return(0,p.$Uf)(A)?[...this.b.values()].find(L=>L.info.id===A):this.b.get(A)}getLogger(A){return this.m(A)?.logger}createLogger(A,L){const W=this.n(A),q=(0,p.$Uf)(A)?A:L?.id??(0,B.$8i)(W.toString()).toString(16);let H=this.b.get(W)?.logger;const le=L?.logLevel==="always"?w.Trace:L?.logLevel;H||(H=this.s(W,le??this.getLogLevel(W)??this.h,{...L,id:q}));const te={logger:H,info:{resource:W,id:q,logLevel:le,name:L?.name,hidden:L?.hidden,extensionId:L?.extensionId,when:L?.when}};return this.registerLogger(te.info),this.b.set(W,te),H}n(A){return(0,p.$Uf)(A)?(0,c.$Ug)(this.j,`${A}.log`):A}setLogLevel(A,L){if(y.URI.isUri(A)){const W=A,q=L,H=this.b.get(W);H&&q!==H.info.logLevel&&(H.info.logLevel=q===this.h?void 0:q,H.logger?.setLevel(q),this.b.set(H.info.resource,H),this.f.fire([W,q]))}else{this.h=A;for(const[W,q]of this.b.entries())this.b.get(W)?.info.logLevel===void 0&&q.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(A,L){const W=this.m(A);W&&L!==!W.info.hidden&&(W.info.hidden=!L,this.b.set(W.info.resource,W),this.g.fire([W.info.resource,L]))}getLogLevel(A){let L;return A&&(L=this.b.get(A)?.info.logLevel),L??this.h}registerLogger(A){const L=this.b.get(A.resource);L?L.info.hidden!==A.hidden&&this.setVisibility(A.resource,!A.hidden):(this.b.set(A.resource,{info:A,logger:void 0}),this.c.fire({added:[A],removed:[]}))}deregisterLogger(A){const L=this.b.get(A);L&&(L.logger&&L.logger.dispose(),this.b.delete(A),this.c.fire({added:[],removed:[L.info]}))}*getRegisteredLoggers(){for(const A of this.b.values())yield A.info}getRegisteredLogger(A){return this.b.get(A)?.info}dispose(){this.b.forEach(A=>A.logger?.dispose()),this.b.clear(),super.dispose()}}e.$Yj=i;class s{constructor(){this.onDidChangeLogLevel=new P.$7d().event}setLevel(A){}getLevel(){return w.Info}trace(A,...L){}debug(A,...L){}info(A,...L){}warn(A,...L){}error(A,...L){}critical(A,...L){}dispose(){}flush(){}}e.$Zj=s;class u extends s{}e.$1j=u;function b(C){if(C.verbose)return w.Trace;if(typeof C.logLevel=="string"){const A=R(C.logLevel.toLowerCase());if(A!==void 0)return A}return e.$Qj}function I(C){switch(C){case w.Trace:return"trace";case w.Debug:return"debug";case w.Info:return"info";case w.Warning:return"warn";case w.Error:return"error";case w.Off:return"off"}}function D(C){switch(C){case w.Trace:return{original:"Trace",value:n.localize(0,null)};case w.Debug:return{original:"Debug",value:n.localize(1,null)};case w.Info:return{original:"Info",value:n.localize(2,null)};case w.Warning:return{original:"Warning",value:n.localize(3,null)};case w.Error:return{original:"Error",value:n.localize(4,null)};case w.Off:return{original:"Off",value:n.localize(5,null)}}}function R(C){switch(C){case"trace":return w.Trace;case"debug":return w.Debug;case"info":return w.Info;case"warn":return w.Warning;case"error":return w.Error;case"critical":return w.Error;case"off":return w.Off}}e.$6j=new k.$yj("logLevel",I(w.Info))});var ne=this&&this.__param||function(J,e){return function(n,j){e(n,j,J)}};define(oe[224],ae([0,1,14,4,5]),function(J,e,n,j,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mac=void 0;const B=n.safeStorage;let S=class{constructor(h){this.a=h,n.app.commandLine.getSwitchValue("password-store")==="basic"&&B.setUsePlainTextEncryption?.(!0)}async encrypt(h){this.a.trace("[EncryptionMainService] Encrypting value.");try{const c=JSON.stringify(B.encryptString(h));return this.a.trace("[EncryptionMainService] Encrypted value."),c}catch(c){throw this.a.error(c),c}}async decrypt(h){let c;try{if(c=JSON.parse(h),!c.data)throw new Error(`[EncryptionMainService] Invalid encrypted value: ${h}`);const p=Buffer.from(c.data);this.a.trace("[EncryptionMainService] Decrypting value.");const y=B.decryptString(p);return this.a.trace("[EncryptionMainService] Decrypted value."),y}catch(p){throw this.a.error(p),p}}isEncryptionAvailable(){return Promise.resolve(B.isEncryptionAvailable())}getKeyStorageProvider(){if(j.$i)return Promise.resolve("dpapi");if(j.$j)return Promise.resolve("keychain_access");if(B.getSelectedStorageBackend)try{const h=B.getSelectedStorageBackend();return Promise.resolve(h)}catch(h){this.a.error(h)}return Promise.resolve("unknown")}async setUsePlainTextEncryption(){if(j.$i)throw new Error("Setting plain text encryption is not supported on Windows.");if(j.$j)throw new Error("Setting plain text encryption is not supported on macOS.");if(!B.setUsePlainTextEncryption)throw new Error("Setting plain text encryption is not supported.");B.setUsePlainTextEncryption(!0)}};e.$mac=S,e.$mac=S=Ee([ne(0,P.$Nj)],S)}),define(oe[225],ae([0,1,22,8,15,3,2,9,60,5]),function(J,e,n,j,P,B,S,E,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dq=void 0;class p extends S.$Uc{constructor(k,g){super(),this.a=k,this.b=g,this.c=this.B(new B.$7d),this.onDidChangeFile=this.c.event,this.g=this.B(new B.$7d),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new j.$fh(0)),this.w=[],this.y=this.B(new j.$fh(0))}watch(k,g){return g.recursive||this.b?.watcher?.forceUniversal?this.n(k,g):this.z(k,g)}n(k,g){const m={path:this.H(k),excludes:g.excludes,includes:g.includes,recursive:g.recursive,correlationId:g.correlationId},v=(0,n.$Ub)(this.j,m);return this.r(),(0,S.$Sc)(()=>{v(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(k=>(0,P.$1)(k))}s(){this.h||(this.h=this.B(this.t(g=>this.c.fire((0,h.$zq)(g)),g=>this.G(g),this.a.getLevel()===c.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===c.LogLevel.Trace)})));const k=this.b?.watcher?.recursive?.usePolling;if(k===!0)for(const g of this.j)(0,h.$vq)(g)&&(g.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(k))for(const g of this.j)(0,h.$vq)(g)&&k.includes(g.path)&&(g.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(k,g){const m={path:this.H(k),excludes:g.excludes,includes:g.includes,recursive:!1,correlationId:g.correlationId},v=(0,n.$Ub)(this.w,m);return this.C(),(0,S.$Sc)(()=>{v(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(k=>(0,P.$1)(k))}D(){return this.u||(this.u=this.B(this.F(k=>this.c.fire((0,h.$zq)(k)),k=>this.G(k),this.a.getLevel()===c.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===c.LogLevel.Trace)}))),this.u.watch(this.w)}G(k){k.type==="error"&&this.g.fire(k.message),this.a[k.type](k.message)}H(k){return(0,E.$ic)(k.fsPath)}}e.$Dq=p}),define(oe[226],ae([0,1,22,8,17,23,3,46,71,2,59,13,66,19,63,177,16,122,5,15]),function(J,e,n,j,P,B,S,E,h,c,p,y,k,g,m,v,w,$,f,l){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.$tq=void 0;let a=class extends c.$Uc{static{d=this}constructor(o){super(),this.b=o,this.a=256*1024,this.c=this.B(new S.$7d),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new S.$7d),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new S.$7d),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new S.$7d),this.onDidRunOperation=this.r.event,this.X=this.B(new S.$7d),this.Y=this.B(new S.$7d),this.onDidFilesChange=this.Y.event,this.Z=this.B(new S.$7d),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new j.$qh)}registerProvider(o,r){if(this.h.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,k.mark)(`code/registerFilesystem/${o}`);const i=new c.$Tc;return this.h.set(o,r),this.c.fire({added:!0,scheme:o,provider:r}),i.add(r.onDidChangeFile(s=>{const u=new w.$7k(s,!this.S(r));this.X.fire(u),u.hasCorrelation()||this.Y.fire(u)})),typeof r.onDidWatchError=="function"&&i.add(r.onDidWatchError(s=>this.Z.fire(new Error(s)))),i.add(r.onDidChangeCapabilities(()=>this.g.fire({provider:r,scheme:o}))),(0,c.$Sc)(()=>{this.c.fire({added:!1,scheme:o,provider:r}),this.h.delete(o),(0,c.$Pc)(i)})}getProvider(o){return this.h.get(o)}async activateProvider(o){const r=[];this.f.fire({scheme:o,join(i){r.push(i)}}),!this.h.has(o)&&await j.Promises.settled(r)}async canHandleResource(o){return await this.activateProvider(o.scheme),this.hasProvider(o)}hasProvider(o){return this.h.has(o.scheme)}hasCapability(o,r){const i=this.h.get(o.scheme);return!!(i&&i.capabilities&r)}listCapabilities(){return h.Iterable.map(this.h,([o,r])=>({scheme:o,capabilities:r.capabilities}))}async j(o){if(!(0,g.$Yg)(o))throw new w.$9k((0,v.localize)(0,null,this.sb(o)),8);await this.activateProvider(o.scheme);const r=this.h.get(o.scheme);if(!r){const i=new l.$bb;throw i.message=(0,v.localize)(1,null,o.toString()),i}return r}async m(o){const r=await this.j(o);if((0,w.$Tk)(r)||(0,w.$Qk)(r)||(0,w.$Uk)(r))return r;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(o){const r=await this.j(o);if((0,w.$Tk)(r)||(0,w.$Qk)(r))return r;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,r){try{return await this.s(o,r)}catch(i){throw(0,w.$4k)(i)===w.FileSystemProviderErrorCode.FileNotFound?new w.$9k((0,v.localize)(2,null,this.sb(o)),1):(0,w.$2k)(i)}}async s(o,r){const i=await this.j(o),s=this.S(i),u=r?.resolveTo,b=r?.resolveSingleChildDescendants,I=r?.resolveMetadata,D=await i.stat(o);let R;return this.t(i,o,D,void 0,!!I,(C,A)=>(R||(R=p.$ni.forUris(()=>!s),R.set(o,!0),u&&R.fill(!0,u)),R.get(C.resource)||R.findSuperstr(C.resource.with({query:null,fragment:null}))?!0:C.isDirectory&&b?A===1:!1))}async t(o,r,i,s,u,b){const{providerExtUri:I}=this.R(o),D={resource:r,name:I.basename(r),isFile:(i.type&w.FileType.File)!==0,isDirectory:(i.type&w.FileType.Directory)!==0,isSymbolicLink:(i.type&w.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:!!((i.permissions??0)&w.FilePermission.Readonly)||!!(o.capabilities&2048),locked:!!((i.permissions??0)&w.FilePermission.Locked),etag:(0,w.$hl)({mtime:i.mtime,size:i.size}),children:void 0};if(D.isDirectory&&b(D,s)){try{const R=await o.readdir(r),C=await j.Promises.settled(R.map(async([A,L])=>{try{const W=I.joinPath(r,A),q=u?await o.stat(W):{type:L};return await this.t(o,W,q,R.length,u,b)}catch(W){return this.b.trace(W),null}}));D.children=(0,n.$Hb)(C)}catch(R){this.b.trace(R),D.children=[]}return D}return D}async resolveAll(o){return j.Promises.settled(o.map(async r=>{try{return{stat:await this.s(r.resource,r.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(o){const r=await this.j(o),i=await r.stat(o);return this.t(r,o,i,void 0,!0,()=>!1)}async exists(o){const r=await this.j(o);try{return!!await r.stat(o)}catch{return!1}}async canCreateFile(o,r){try{await this.u(o,r)}catch(i){return i}return!0}async u(o,r){if(!r?.overwrite&&await this.exists(o))throw new w.$9k((0,v.localize)(3,null,this.sb(o)),3,r)}async createFile(o,r=P.$ue.fromString(""),i){await this.u(o,i);const s=await this.writeFile(o,r);return this.r.fire(new w.$6k(o,0,s)),s}async writeFile(o,r,i){const s=this.qb(await this.n(o),o),{providerExtUri:u}=this.R(s);let b=i;if((0,w.$Wk)(s)&&!b?.atomic){const I=s.enforceAtomicWriteFile?.(o);I&&(b={...i,atomic:I})}try{await this.w(s,o,b)||await this.U(s,u.dirname(o));let D;if((0,w.$Qk)(s)&&!(r instanceof P.$ue))if((0,m.$ge)(r)){const R=await(0,m.$ne)(r,3);R.ended?D=P.$ue.concat(R.buffer):D=R}else D=(0,m.$ke)(r,R=>P.$ue.concat(R),3);else D=r;!(0,w.$Tk)(s)||(0,w.$Qk)(s)&&D instanceof P.$ue||(0,w.$Qk)(s)&&(0,w.$Wk)(s)&&b?.atomic?await this.hb(s,o,b,D):await this.db(s,o,b,D instanceof P.$ue?(0,P.$Fe)(D):D),this.r.fire(new w.$6k(o,4))}catch(I){throw new w.$9k((0,v.localize)(4,null,this.sb(o),(0,w.$2k)(I).toString()),(0,w.$5k)(I),b)}return this.resolve(o,{resolveMetadata:!0})}async w(o,r,i){const s=!!i?.unlock;if(s&&!(o.capabilities&8192))throw new Error((0,v.localize)(5,null,this.sb(r)));if(!!i?.atomic){if(!(o.capabilities&32768))throw new Error((0,v.localize)(6,null,this.sb(r)));if(!(o.capabilities&2))throw new Error((0,v.localize)(7,null,this.sb(r)));if(s)throw new Error((0,v.localize)(8,null,this.sb(r)))}let b;try{b=await o.stat(r)}catch{return}if(b.type&w.FileType.Directory)throw new w.$9k((0,v.localize)(9,null,this.sb(r)),0,i);if(this.rb(r,b),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==w.$gl&&typeof b.mtime=="number"&&typeof b.size=="number"&&i.mtime<b.mtime&&i.etag!==(0,w.$hl)({mtime:i.mtime,size:b.size}))throw new w.$9k((0,v.localize)(10,null),3,i);return b}async readFile(o,r,i){const s=await this.m(o);return r?.atomic?this.z(s,o,r,i):this.C(s,o,r,i)}async z(o,r,i,s){return new Promise((u,b)=>{this.cb.queueFor(r,async()=>{try{const I=await this.C(o,r,i,s);u(I)}catch(I){b(I)}},this.R(o).providerExtUri)})}async C(o,r,i,s){const u=await this.D(o,r,{...i,preferUnbuffered:!0},s);return{...u,value:await(0,P.$Ge)(u.value)}}async readFileStream(o,r,i){const s=await this.m(o);return this.D(s,o,r,i)}async D(o,r,i,s){const u=new B.$ee(s);let b=i;(0,w.$Vk)(o)&&o.enforceAtomicReadFile?.(r)&&(b={...i,atomic:!0});const I=this.J(r,b).then(R=>R,R=>{throw u.dispose(!0),R});let D;try{return typeof b?.etag=="string"&&b.etag!==w.$gl&&await I,b?.atomic&&(0,w.$Vk)(o)||!((0,w.$Tk)(o)||(0,w.$Uk)(o))||(0,w.$Qk)(o)&&b?.preferUnbuffered?D=this.I(o,r,b):(0,w.$Uk)(o)?D=this.G(o,r,u.token,b):D=this.H(o,r,u.token,b),D.on("end",()=>u.dispose()),D.on("error",()=>u.dispose()),{...await I,value:D}}catch(R){throw D&&await(0,m.$le)(D),this.F(R,r,b)}}F(o,r,i){const s=(0,v.localize)(11,null,this.sb(r),(0,w.$2k)(o).toString());return o instanceof w.$$k?new w.$$k(s,o.stat,i):o instanceof w.$0k?new w.$0k(s,o.fileOperationResult,o.size,o.options):new w.$9k(s,(0,w.$5k)(o),i)}G(o,r,i,s=Object.create(null)){const u=o.readFileStream(r,s,i);return(0,m.$re)(u,{data:b=>b instanceof P.$ue?b:P.$ue.wrap(b),error:b=>this.F(b,r,s)},b=>P.$ue.concat(b))}H(o,r,i,s=Object.create(null)){const u=(0,P.$Ke)();return(0,$.$sq)(o,r,u,b=>b,{...s,bufferSize:this.a,errorTransformer:b=>this.F(b,r,s)},i),u}I(o,r,i){const s=(0,m.$ie)(u=>P.$ue.concat(u));return(async()=>{try{let u;i?.atomic&&(0,w.$Vk)(o)?u=await o.readFile(r,{atomic:!0}):u=await o.readFile(r),typeof i?.position=="number"&&(u=u.slice(i.position)),typeof i?.length=="number"&&(u=u.slice(0,i.length)),this.L(r,u.byteLength,i),s.end(P.$ue.wrap(u))}catch(u){s.error(u),s.end()}})(),s}async J(o,r){const i=await this.resolve(o,{resolveMetadata:!0});if(i.isDirectory)throw new w.$9k((0,v.localize)(12,null,this.sb(o)),0,r);if(typeof r?.etag=="string"&&r.etag!==w.$gl&&r.etag===i.etag)throw new w.$$k((0,v.localize)(13,null),i,r);return this.L(o,i.size,r),i}L(o,r,i){if(typeof i?.limits?.size=="number"&&r>i.limits.size)throw new w.$0k((0,v.localize)(14,null,this.sb(o)),7,r,i)}async canMove(o,r,i){return this.M(o,r,"move",i)}async canCopy(o,r,i){return this.M(o,r,"copy",i)}async M(o,r,i,s){if(o.toString()!==r.toString())try{const u=i==="move"?this.qb(await this.n(o),o):await this.m(o),b=this.qb(await this.n(r),r);await this.Q(u,o,b,r,i,s)}catch(u){return u}return!0}async move(o,r,i){const s=this.qb(await this.n(o),o),u=this.qb(await this.n(r),r),b=await this.N(s,o,u,r,"move",!!i),I=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new w.$6k(o,b==="move"?2:3,I)),I}async copy(o,r,i){const s=await this.m(o),u=this.qb(await this.n(r),r),b=await this.N(s,o,u,r,"copy",!!i),I=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new w.$6k(o,b==="copy"?3:2,I)),I}async N(o,r,i,s,u,b){if(r.toString()===s.toString())return u;const{exists:I,isSameResourceWithDifferentPathCase:D}=await this.Q(o,r,i,s,u,b);if(I&&!D&&b&&await this.del(s,{recursive:!0}),await this.U(i,this.R(i).providerExtUri.dirname(s)),u==="copy"){if(o===i&&(0,w.$Rk)(o))await o.copy(r,s,{overwrite:b});else{const R=await this.resolve(r);R.isDirectory?await this.P(o,R,i,s):await this.O(o,r,i,s)}return u}else return o===i?(await o.rename(r,s,{overwrite:b}),u):(await this.N(o,r,i,s,"copy",b),await this.del(r,{recursive:!0}),"copy")}async O(o,r,i,s){if((0,w.$Tk)(o)&&(0,w.$Tk)(i))return this.jb(o,r,i,s);if((0,w.$Tk)(o)&&(0,w.$Qk)(i))return this.pb(o,r,i,s);if((0,w.$Qk)(o)&&(0,w.$Tk)(i))return this.nb(o,r,i,s);if((0,w.$Qk)(o)&&(0,w.$Qk)(i))return this.lb(o,r,i,s)}async P(o,r,i,s){await i.mkdir(s),Array.isArray(r.children)&&await j.Promises.settled(r.children.map(async u=>{const b=this.R(i).providerExtUri.joinPath(s,u.name);return u.isDirectory?this.P(o,await this.resolve(u.resource),i,b):this.O(o,u.resource,i,b)}))}async Q(o,r,i,s,u,b){let I=!1;if(o===i){const{providerExtUri:R,isPathCaseSensitive:C}=this.R(o);if(C||(I=R.isEqual(r,s)),I&&u==="copy")throw new Error((0,v.localize)(15,null,this.sb(r),this.sb(s)));if(!I&&R.isEqualOrParent(s,r))throw new Error((0,v.localize)(16,null,this.sb(r),this.sb(s)))}const D=await this.exists(s);if(D&&!I){if(!b)throw new w.$9k((0,v.localize)(17,null,this.sb(r),this.sb(s)),4);if(o===i){const{providerExtUri:R}=this.R(o);if(R.isEqualOrParent(r,s))throw new Error((0,v.localize)(18,null,this.sb(r),this.sb(s)))}}return{exists:D,isSameResourceWithDifferentPathCase:I}}R(o){const r=this.S(o);return{providerExtUri:r?g.$Kg:g.$Mg,isPathCaseSensitive:r}}S(o){return!!(o.capabilities&1024)}async createFolder(o){const r=this.qb(await this.j(o),o);await this.U(r,o);const i=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new w.$6k(o,0,i)),i}async U(o,r){const i=[],{providerExtUri:s}=this.R(o);for(;!s.isEqual(r,s.dirname(r));)try{if(!((await o.stat(r)).type&w.FileType.Directory))throw new Error((0,v.localize)(19,null,this.sb(r)));break}catch(u){if((0,w.$4k)(u)!==w.FileSystemProviderErrorCode.FileNotFound)throw u;i.push(s.basename(r)),r=s.dirname(r)}for(let u=i.length-1;u>=0;u--){r=s.joinPath(r,i[u]);try{await o.mkdir(r)}catch(b){if((0,w.$4k)(b)!==w.FileSystemProviderErrorCode.FileExists)throw b}}}async canDelete(o,r){try{await this.W(o,r)}catch(i){return i}return!0}async W(o,r){const i=this.qb(await this.j(o),o),s=!!r?.useTrash;if(s&&!(i.capabilities&4096))throw new Error((0,v.localize)(20,null,this.sb(o)));const u=r?.atomic;if(u&&!(i.capabilities&65536))throw new Error((0,v.localize)(21,null,this.sb(o)));if(s&&u)throw new Error((0,v.localize)(22,null,this.sb(o)));let b;try{b=await i.stat(o)}catch{}if(b)this.rb(o,b);else throw new w.$9k((0,v.localize)(23,null,this.sb(o)),1);if(!!!r?.recursive){const D=await this.resolve(o);if(D.isDirectory&&Array.isArray(D.children)&&D.children.length>0)throw new Error((0,v.localize)(24,null,this.sb(o)))}return i}async del(o,r){const i=await this.W(o,r);let s=r;if((0,w.$Xk)(i)&&!s?.atomic){const D=i.enforceAtomicDelete?.(o);D&&(s={...r,atomic:D})}const u=!!s?.useTrash,b=!!s?.recursive,I=s?.atomic??!1;await i.delete(o,{recursive:b,useTrash:u,atomic:I}),this.r.fire(new w.$6k(o,1))}async cloneFile(o,r){const i=await this.j(o),s=this.qb(await this.n(r),r);if(!(i===s&&this.R(i).providerExtUri.isEqual(o,r)))return i===s&&(0,w.$Sk)(i)?i.cloneFile(o,r):(await this.U(s,this.R(s).providerExtUri.dirname(r)),i===s&&(0,w.$Rk)(i)?this.cb.queueFor(o,()=>i.copy(o,r,{overwrite:!0}),this.R(i).providerExtUri):this.cb.queueFor(o,()=>this.O(i,o,s,r),this.R(i).providerExtUri))}static{this.ab=0}createWatcher(o,r){return this.watch(o,{...r,correlationId:d.ab++})}watch(o,r={recursive:!1,excludes:[]}){const i=new c.$Tc;let s=!1,u=()=>{s=!0};i.add((0,c.$Sc)(()=>u())),(async()=>{try{const I=await this.bb(o,r);s?(0,c.$Pc)(I):u=()=>(0,c.$Pc)(I)}catch(I){this.b.error(I)}})();const b=r.correlationId;if(typeof b=="number"){const I=i.add(new S.$7d);return i.add(this.X.event(R=>{R.correlates(b)&&I.fire(R)})),{onDidChange:I.event,dispose:()=>i.dispose()}}return i}async bb(o,r){const i=await this.j(o),s=(0,E.$8i)([this.R(i).providerExtUri.getComparisonKey(o),r]);let u=this.$.get(s);return u||(u={count:0,disposable:i.watch(o,r)},this.$.set(s,u)),u.count+=1,(0,c.$Sc)(()=>{u&&(u.count--,u.count===0&&((0,c.$Pc)(u.disposable),this.$.delete(s)))})}dispose(){super.dispose();for(const[,o]of this.$)(0,c.$Pc)(o.disposable);this.$.clear()}async db(o,r,i,s){return this.cb.queueFor(r,async()=>{const u=await o.open(r,{create:!0,unlock:i?.unlock??!1});try{(0,m.$ge)(s)||(0,m.$he)(s)?await this.eb(o,u,s):await this.fb(o,u,s)}catch(b){throw(0,w.$2k)(b)}finally{await o.close(u)}},this.R(o).providerExtUri)}async eb(o,r,i){let s=0,u;if((0,m.$he)(i)){if(i.buffer.length>0){const b=P.$ue.concat(i.buffer);await this.gb(o,r,b,b.byteLength,s,0),s+=b.byteLength}if(i.ended)return;u=i.stream}else u=i;return new Promise((b,I)=>{(0,m.$me)(u,{onData:async D=>{u.pause();try{await this.gb(o,r,D,D.byteLength,s,0)}catch(R){return I(R)}s+=D.byteLength,setTimeout(()=>u.resume())},onError:D=>I(D),onEnd:()=>b()})})}async fb(o,r,i){let s=0,u;for(;(u=i.read())!==null;)await this.gb(o,r,u,u.byteLength,s,0),s+=u.byteLength}async gb(o,r,i,s,u,b){let I=0;for(;I<s;){const D=await o.write(r,u+I,i.buffer,b+I,s-I);I+=D}}async hb(o,r,i,s){return this.cb.queueFor(r,()=>this.ib(o,r,i,s),this.R(o).providerExtUri)}async ib(o,r,i,s){let u;s instanceof P.$ue?u=s:(0,m.$ge)(s)?u=await(0,P.$Ge)(s):(0,m.$he)(s)?u=await(0,P.$He)(s):u=(0,P.$Ee)(s),await o.writeFile(r,u.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1,atomic:i?.atomic??!1})}async jb(o,r,i,s){return this.cb.queueFor(s,()=>this.kb(o,r,i,s),this.R(i).providerExtUri)}async kb(o,r,i,s){let u,b;try{u=await o.open(r,{create:!1}),b=await i.open(s,{create:!0,unlock:!1});const I=P.$ue.alloc(this.a);let D=0,R=0,C=0;do C=await o.read(u,D,I.buffer,R,I.byteLength-R),await this.gb(i,b,I,C,D,R),D+=C,R+=C,R===I.byteLength&&(R=0);while(C>0)}catch(I){throw(0,w.$2k)(I)}finally{await j.Promises.settled([typeof u=="number"?o.close(u):Promise.resolve(),typeof b=="number"?i.close(b):Promise.resolve()])}}async lb(o,r,i,s){return this.cb.queueFor(s,()=>this.mb(o,r,i,s),this.R(i).providerExtUri)}async mb(o,r,i,s){return i.writeFile(s,await o.readFile(r),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(o,r,i,s){return this.cb.queueFor(s,()=>this.ob(o,r,i,s),this.R(i).providerExtUri)}async ob(o,r,i,s){const u=await i.open(s,{create:!0,unlock:!1});try{const b=await o.readFile(r);await this.gb(i,u,P.$ue.wrap(b),b.byteLength,0,0)}catch(b){throw(0,w.$2k)(b)}finally{await i.close(u)}}async pb(o,r,i,s){const u=await(0,P.$Ge)(this.H(o,r,B.CancellationToken.None));await this.hb(i,s,void 0,u)}qb(o,r){if(o.capabilities&2048)throw new w.$9k((0,v.localize)(25,null,this.sb(r)),6);return o}rb(o,r){if((r.permissions??0)&w.FilePermission.Readonly)throw new w.$9k((0,v.localize)(26,null,this.sb(o)),6)}sb(o){return o.scheme===y.Schemas.file?o.fsPath:o.toString(!0)}};e.$tq=a,e.$tq=a=d=Ee([ne(0,f.$Nj)],a)}),define(oe[94],ae([0,1,43,315,8,32,17,3,31,2,9,4,19,63,21,181,16,122,225,47,221,220]),function(J,e,n,j,P,B,S,E,h,c,p,y,k,g,m,v,w,$,f,l,d,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uq=void 0,(()=>{try{(0,j.gracefulify)(n)}catch(o){console.error(`Error enabling graceful-fs: ${(0,l.$5i)(o)}`)}})();class t extends f.$Dq{static{this.I=!1}constructor(r,i){super(r,i),this.onDidChangeCapabilities=E.Event.None,this.N=new B.$Bc(s=>k.$Lg.getComparisonKey(s)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,y.$k&&(this.J|=1024)),this.J}async stat(r){try{const{stat:i,symbolicLink:s}=await m.SymlinkSupport.stat(this.H(r));return{type:this.M(i,s),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:w.FilePermission.Locked}}catch(i){throw this.fb(i)}}async L(r){try{return await this.stat(r)}catch{return}}async readdir(r){try{const i=await m.Promises.readdir(this.H(r),{withFileTypes:!0}),s=[];return await Promise.all(i.map(async u=>{try{let b;u.isSymbolicLink()?b=(await this.stat((0,k.$Ug)(r,u.name))).type:b=this.M(u),s.push([u.name,b])}catch(b){this.a.trace(b)}})),s}catch(i){throw this.fb(i)}}M(r,i){let s;return i?.dangling?s=w.FileType.Unknown:r.isFile()?s=w.FileType.File:r.isDirectory()?s=w.FileType.Directory:s=w.FileType.Unknown,i&&(s|=w.FileType.SymbolicLink),s}async O(r){const i=this.H(r);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let s;for(;s=this.N.get(r);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await s.wait();const u=new P.$gh;return this.N.set(r,u),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,c.$Sc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.N.get(r)===u&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.N.delete(r)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),u.open()})}async readFile(r,i){let s;try{i?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(r)})`),s=await this.O(r));const u=this.H(r);return await m.Promises.readFile(u)}catch(u){throw this.fb(u)}finally{s?.dispose()}}P(r){t.I&&this.a.trace(r)}readFileStream(r,i,s){const u=(0,g.$ie)(b=>S.$ue.concat(b.map(I=>S.$ue.wrap(I))).buffer);return(0,$.$sq)(this,r,u,b=>b.buffer,{...i,bufferSize:256*1024},s),u}async writeFile(r,i,s){return s?.atomic!==!1&&s?.atomic?.postfix&&await this.Q(r)?this.R(r,(0,k.$Ug)((0,k.$Tg)(r),`${(0,k.$Rg)(r)}${s.atomic.postfix}`),i,s):this.S(r,i,s)}async Q(r){try{const i=this.H(r),{symbolicLink:s}=await m.SymlinkSupport.stat(i);if(s)return!1}catch{}return!0}async R(r,i,s,u){const b=new c.$Tc;try{b.add(await this.O(r)),b.add(await this.O(i)),await this.S(i,s,u,!0);try{await this.rename(i,r,{overwrite:!0})}catch(I){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw I}}finally{b.dispose()}}async S(r,i,s,u){let b;try{const I=this.H(r);if(!s.create||!s.overwrite){if(await m.Promises.exists(I)){if(!s.overwrite)throw(0,w.$1k)((0,v.localize)(0,null),w.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,w.$1k)((0,v.localize)(1,null),w.FileSystemProviderErrorCode.FileNotFound)}b=await this.open(r,{create:!0,unlock:s.unlock},u),await this.write(b,0,i,0,i.byteLength)}catch(I){throw await this.gb(r,I)}finally{typeof b=="number"&&await this.close(b)}}static{this.Y=!0}static configureFlushOnWrite(r){t.Y=r}async open(r,i,s){const u=this.H(r);let b;(0,w.$Ok)(i)&&!s&&(b=await this.O(r));let I;try{if((0,w.$Ok)(i)&&i.unlock)try{const{stat:R}=await m.SymlinkSupport.stat(u);R.mode&128||await m.Promises.chmod(u,R.mode|128)}catch(R){R.code!=="ENOENT"&&this.a.trace(R)}let D;if((0,w.$Ok)(i)){if(y.$i)try{await m.Promises.truncate(u,0),D="r+"}catch(R){R.code!=="ENOENT"&&this.a.trace(R)}D||(D="w")}else D="r";I=await m.Promises.open(u,D)}catch(D){throw b?.dispose(),(0,w.$Ok)(i)?await this.gb(r,D):this.fb(D)}if(this.U.set(I,0),(0,w.$Ok)(i)&&this.X.set(I,r),b){const D=this.W.get(I);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${I} (${u})`),this.W.set(I,b),D&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${I} (${u})`),D.dispose())}return I}async close(r){const i=this.W.get(r);try{if(this.U.delete(r),this.X.delete(r)&&t.Y)try{await m.Promises.fdatasync(r)}catch(s){t.configureFlushOnWrite(!1),this.a.error(s)}return await m.Promises.close(r)}catch(s){throw this.fb(s)}finally{i&&(this.W.get(r)===i&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${r}`),this.W.delete(r)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${r}`),i.dispose())}}async read(r,i,s,u,b){const I=this.Z(r,i);let D=null;try{D=(await m.Promises.read(r,s,u,b,I)).bytesRead}catch(R){throw this.fb(R)}finally{this.$(r,I,D)}return D}Z(r,i){return i===this.U.get(r)?null:i}$(r,i,s){const u=this.U.get(r);typeof u=="number"&&(typeof i=="number"||(typeof s=="number"?this.U.set(r,u+s):this.U.delete(r)))}async write(r,i,s,u,b){return(0,P.$Bh)(()=>this.ab(r,i,s,u,b),100,3)}async ab(r,i,s,u,b){const I=this.Z(r,i);let D=null;try{D=(await m.Promises.write(r,s,u,b,I)).bytesWritten}catch(R){throw await this.gb(this.X.get(r),R)}finally{this.$(r,I,D)}return D}async mkdir(r){try{await m.Promises.mkdir(this.H(r))}catch(i){throw this.fb(i)}}async delete(r,i){try{const s=this.H(r);if(i.recursive){let u;i?.atomic!==!1&&i.atomic.postfix&&(u=(0,p.$kc)((0,p.$nc)(s),`${(0,p.$oc)(s)}${i.atomic.postfix}`)),await m.Promises.rm(s,m.RimRafMode.MOVE,u)}else try{await m.Promises.unlink(s)}catch(u){if(u.code==="EPERM"||u.code==="EISDIR"){let b=!1;try{const{stat:I,symbolicLink:D}=await m.SymlinkSupport.stat(s);b=I.isDirectory()&&!D}catch{}if(b)await m.Promises.rmdir(s);else throw u}else throw u}}catch(s){throw this.fb(s)}}async rename(r,i,s){const u=this.H(r),b=this.H(i);if(u!==b)try{await this.bb(r,i,"move",s.overwrite),await m.Promises.rename(u,b)}catch(I){throw(I.code==="EINVAL"||I.code==="EBUSY"||I.code==="ENAMETOOLONG")&&(I=new Error((0,v.localize)(2,null,(0,p.$oc)(u),(0,p.$oc)((0,p.$nc)(b)),I.toString()))),this.fb(I)}}async copy(r,i,s){const u=this.H(r),b=this.H(i);if(u!==b)try{await this.bb(r,i,"copy",s.overwrite),await m.Promises.copy(u,b,{preserveSymlinks:!0})}catch(I){throw(I.code==="EINVAL"||I.code==="EBUSY"||I.code==="ENAMETOOLONG")&&(I=new Error((0,v.localize)(3,null,(0,p.$oc)(u),(0,p.$oc)((0,p.$nc)(b)),I.toString()))),this.fb(I)}}async bb(r,i,s,u){const b=this.H(r),I=this.H(i);let D=!1;if(!!(this.capabilities&1024)||(D=(0,h.$gg)(b,I,!0)),D){if(s==="copy")throw(0,w.$1k)((0,v.localize)(4,null),w.FileSystemProviderErrorCode.FileExists);if(s==="move")return}const C=await this.L(r);if(!C)throw(0,w.$1k)((0,v.localize)(5,null),w.FileSystemProviderErrorCode.FileNotFound);const A=await this.L(i);if(A){if(!u)throw(0,w.$1k)((0,v.localize)(6,null),w.FileSystemProviderErrorCode.FileExists);C.type&w.FileType.File&&A.type&w.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(r,i){return this.cb(r,i,!1)}async cb(r,i,s){const u=this.H(r),b=this.H(i),I=!!(this.capabilities&1024);if((0,h.$gg)(u,b,!I))return;const D=new c.$Tc;try{D.add(await this.O(r)),D.add(await this.O(i)),s&&await m.Promises.mkdir((0,p.$nc)(b),{recursive:!0}),await m.Promises.copyFile(u,b)}catch(R){if(R.code==="ENOENT"&&!s)return this.cb(r,i,!0);throw this.fb(R)}finally{D.dispose()}}t(r,i,s){return new d.$Kq(u=>r(u),u=>i(u),s)}F(r,i,s){return new a.$Tq(u=>r(u),u=>i(u),s)}fb(r){if(r instanceof w.$Zk)return r;let i=r,s;switch(r.code){case"ENOENT":s=w.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":s=w.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":s=w.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":s=w.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":s=w.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${r.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,s=w.FileSystemProviderErrorCode.Unknown;break;default:s=w.FileSystemProviderErrorCode.Unknown}return(0,w.$1k)(i,s)}async gb(r,i){let s=this.fb(i);if(r&&s.code===w.FileSystemProviderErrorCode.NoPermissions)try{const{stat:u}=await m.SymlinkSupport.stat(this.H(r));u.mode&128||(s=(0,w.$1k)(i,w.FileSystemProviderErrorCode.FileWriteLocked))}catch(u){this.a.trace(u)}return s}}e.$Uq=t}),define(oe[227],ae([0,1,3,94,2,17,63,23]),function(J,e,n,j,P,B,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ss=e.$rs=void 0;class h extends P.$Uc{constructor(y,k){super(),this.a=y,this.b=k,this.F=new Map,this.G=new Map}call(y,k,g){const m=this.c(y);switch(k){case"stat":return this.g(m,g[0]);case"readdir":return this.h(m,g[0]);case"open":return this.r(m,g[0],g[1]);case"close":return this.s(g[0]);case"read":return this.t(g[0],g[1],g[2]);case"readFile":return this.j(m,g[0],g[1]);case"write":return this.u(g[0],g[1],g[2],g[3],g[4]);case"writeFile":return this.n(m,g[0],g[1],g[2]);case"rename":return this.z(m,g[0],g[1],g[2]);case"copy":return this.C(m,g[0],g[1],g[2]);case"cloneFile":return this.D(m,g[0],g[1]);case"mkdir":return this.w(m,g[0]);case"delete":return this.y(m,g[0],g[1]);case"watch":return this.I(m,g[0],g[1],g[2],g[3]);case"unwatch":return this.J(g[0],g[1])}throw new Error(`IPC Command ${k} not found`)}listen(y,k,g){const m=this.c(y);switch(k){case"fileChange":return this.H(m,g[0]);case"readFileStream":return this.m(m,g[0],g[1])}throw new Error(`Unknown event ${k}`)}g(y,k){const g=this.f(y,k,!0);return this.a.stat(g)}h(y,k){const g=this.f(y,k);return this.a.readdir(g)}async j(y,k,g){const m=this.f(y,k,!0),v=await this.a.readFile(m,g);return B.$ue.wrap(v)}m(y,k,g){const m=this.f(y,k,!0),v=new E.$ee,w=new n.$7d({onDidRemoveLastListener:()=>{v.cancel()}}),$=this.a.readFileStream(m,g,v.token);return(0,S.$me)($,{onData:f=>w.fire(B.$ue.wrap(f)),onError:f=>w.fire(f),onEnd:()=>{w.fire("end"),w.dispose(),v.dispose()}}),w.event}n(y,k,g,m){const v=this.f(y,k);return this.a.writeFile(v,g.buffer,m)}r(y,k,g){const m=this.f(y,k,!0);return this.a.open(m,g)}s(y){return this.a.close(y)}async t(y,k,g){const m=B.$ue.alloc(g),w=await this.a.read(y,k,m.buffer,0,g);return[m,w]}u(y,k,g,m,v){return this.a.write(y,k,g.buffer,m,v)}w(y,k){const g=this.f(y,k);return this.a.mkdir(g)}y(y,k,g){const m=this.f(y,k);return this.a.delete(m,g)}z(y,k,g,m){const v=this.f(y,k),w=this.f(y,g);return this.a.rename(v,w,m)}C(y,k,g,m){const v=this.f(y,k),w=this.f(y,g);return this.a.copy(v,w,m)}D(y,k,g){const m=this.f(y,k),v=this.f(y,g);return this.a.cloneFile(m,v)}H(y,k){const g=new n.$7d({onWillAddFirstListener:()=>{this.F.set(k,this.L(y,g))},onDidRemoveLastListener:()=>{(0,P.$Pc)(this.F.get(k)),this.F.delete(k)}});return g.event}async I(y,k,g,m,v){const w=this.F.get(k);if(w){const $=this.f(y,m),f=w.watch(g,$,v);this.G.set(k+g,f)}}async J(y,k){const g=y+k,m=this.G.get(g);m&&((0,P.$Pc)(m),this.G.delete(g))}dispose(){super.dispose();for(const[,y]of this.G)y.dispose();this.G.clear();for(const[,y]of this.F)y.dispose();this.F.clear()}}e.$rs=h;class c extends P.$Uc{constructor(y,k,g,m){super(),this.c=y,this.f=g,this.g=m,this.a=new Map,this.b=this.B(new j.$Uq(this.f,{watcher:{recursive:this.j(this.g)}})),this.h(k)}h(y){const k=this.B(new n.$7d);this.B(k.event(g=>{y.fire(g.map(m=>({resource:this.c.transformOutgoingURI(m.resource),type:m.type,cId:m.cId})))})),this.B(this.b.onDidChangeFile(g=>k.fire(g))),this.B(this.b.onDidWatchError(g=>y.fire(g)))}j(y){}m(y){}watch(y,k,g){const m=this.m(this.g);return Array.isArray(m)&&(g.excludes=[...g.excludes,...m]),this.a.set(y,this.b.watch(k,g)),(0,P.$Sc)(()=>{(0,P.$Pc)(this.a.get(y)),this.a.delete(y)})}dispose(){for(const[,y]of this.a)y.dispose();this.a.clear(),super.dispose()}}e.$ss=c}),define(oe[228],ae([0,1,14,180,4,7,16,9,227,157,47]),function(J,e,n,j,P,B,S,E,h,c,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uac=void 0;class y extends h.$rs{constructor(m,v,w){super(m,v),this.M=w}c(m){return c.$kn}f(m,v){return B.URI.revive(v)}async y(m,v,w){if(!w.useTrash)return super.y(m,v,w);const $=this.f(m,v),f=(0,E.$ic)($.fsPath);try{await n.shell.trashItem(f)}catch(l){throw(0,S.$1k)(P.$i?(0,j.localize)(0,null,(0,E.$oc)(f),(0,p.$5i)(l)):(0,j.localize)(1,null,(0,E.$oc)(f),(0,p.$5i)(l)),S.FileSystemProviderErrorCode.Unknown)}}L(m,v){return new k(m,v,this.b,this.M)}}e.$uac=y;class k extends h.$ss{watch(m,v,w){if(w.recursive)throw(0,S.$1k)("Recursive file watching is not supported from main process for performance reasons.",S.FileSystemProviderErrorCode.Unavailable);return super.watch(m,v,w)}}}),define(oe[229],ae([0,1,5]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$i0b=void 0;class j extends n.$Tj{constructor(B=n.$Qj){super(),this.m=[],this.n=void 0,this.setLevel(B),this.B(this.onDidChangeLogLevel(S=>{this.n?.setLevel(S)}))}set logger(B){this.n=B;for(const{level:S,message:E}of this.m)(0,n.log)(B,S,E);this.m=[]}g(B,S){this.n?(0,n.log)(this.n,B,S):this.getLevel()<=B&&this.m.push({level:B,message:S})}dispose(){this.n?.dispose(),super.dispose()}flush(){this.n?.flush()}}e.$i0b=j}),define(oe[230],ae([0,1,7,3,5,2]),function(J,e,n,j,P,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vr=e.$Ur=e.$Tr=void 0;class S extends P.$Yj{constructor(y,k,g,m,v){super(k,g,m),this.r=y,this.t=v,this.B(v.listen("onDidChangeLogLevel",y)(w=>{(0,P.$Pj)(w)?super.setLogLevel(w):super.setLogLevel(n.URI.revive(w[0]),w[1])})),this.B(v.listen("onDidChangeVisibility",y)(([w,$])=>super.setVisibility(n.URI.revive(w),$))),this.B(v.listen("onDidChangeLoggers",y)(({added:w,removed:$})=>{for(const f of w)super.registerLogger({...f,resource:n.URI.revive(f.resource)});for(const f of $)super.deregisterLogger(f.resource)}))}createConsoleMainLogger(){return new P.$Wj({log:(y,k)=>{this.t.call("consoleLog",[y,k])}})}registerLogger(y){super.registerLogger(y),this.t.call("registerLogger",[y,this.r])}deregisterLogger(y){super.deregisterLogger(y),this.t.call("deregisterLogger",[y,this.r])}setLogLevel(y,k){super.setLogLevel(y,k),this.t.call("setLogLevel",[y,k])}setVisibility(y,k){super.setVisibility(y,k),this.t.call("setVisibility",[this.n(y),k])}s(y,k,g){return new E(this.t,y,k,g,this.r)}static setLogLevel(y,k,g){return y.call("setLogLevel",[k,g])}}e.$Tr=S;class E extends P.$Tj{constructor(y,k,g,m,v){super(m?.logLevel==="always"),this.r=y,this.s=k,this.m=!1,this.n=[],this.setLevel(g),this.r.call("createLogger",[k,m,v]).then(()=>{this.u(this.n),this.m=!0})}g(y,k){const g=[[y,k]];this.m?this.u(g):this.n.push(...g)}u(y){this.r.call("log",[this.s,y])}}class h{constructor(y,k){this.a=y,this.b=k}listen(y,k){const g=this.b(y);switch(k){case"onDidChangeLoggers":return j.Event.map(this.a.onDidChangeLoggers,m=>({added:[...m.added].map(v=>this.c(v,g)),removed:[...m.removed].map(v=>this.c(v,g))}));case"onDidChangeVisibility":return j.Event.map(this.a.onDidChangeVisibility,m=>[g.transformOutgoingURI(m[0]),m[1]]);case"onDidChangeLogLevel":return j.Event.map(this.a.onDidChangeLogLevel,m=>(0,P.$Pj)(m)?m:[g.transformOutgoingURI(m[0]),m[1]])}throw new Error(`Event not found: ${k}`)}async call(y,k,g){const m=this.b(y);switch(k){case"setLogLevel":return(0,P.$Pj)(g[0])?this.a.setLogLevel(g[0]):this.a.setLogLevel(n.URI.revive(m.transformIncoming(g[0][0])),g[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(v=>this.c(v,m)))}throw new Error(`Call not found: ${k}`)}c(y,k){return{...y,resource:k.transformOutgoingURI(y.resource)}}}e.$Ur=h;class c extends B.$Uc{constructor(y,k){super(),k.call("setLogLevel",[y.getLogLevel()]),this.B(y.onDidChangeLogLevel(g=>k.call("setLogLevel",[g]))),k.call("getRegisteredLoggers").then(g=>{for(const m of g)y.registerLogger({...m,resource:n.URI.revive(m.resource)})}),this.B(k.listen("onDidChangeVisibility")(([g,m])=>y.setVisibility(n.URI.revive(g),m))),this.B(k.listen("onDidChangeLoggers")(({added:g,removed:m})=>{for(const v of g)y.registerLogger({...v,resource:n.URI.revive(v.resource)});for(const v of m)y.deregisterLogger(v.resource)}))}}e.$Vr=c}),define(oe[231],ae([0,1,2,5]),function(J,e,n,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3P=void 0;class P extends n.$Uc{constructor(S,E=[]){super(),this.a=new j.$Xj([S,...E]),this.B(S.onDidChangeLogLevel(h=>this.setLevel(h)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(S){this.a.setLevel(S)}getLevel(){return this.a.getLevel()}trace(S,...E){this.a.trace(S,...E)}debug(S,...E){this.a.debug(S,...E)}info(S,...E){this.a.info(S,...E)}warn(S,...E){this.a.warn(S,...E)}error(S,...E){this.a.error(S,...E)}flush(){this.a.flush()}}e.$3P=P}),define(oe[232],ae([0,1,32,7,5]),function(J,e,n,j,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pbc=void 0;class B{constructor(E){this.b=E,this.a=new n.$Bc}listen(E,h,c){switch(h){case"onDidChangeLoggers":return c?this.b.getOnDidChangeLoggersEvent(c):this.b.onDidChangeLoggers;case"onDidChangeLogLevel":return c?this.b.getOnDidChangeLogLevelEvent(c):this.b.onDidChangeLogLevel;case"onDidChangeVisibility":return c?this.b.getOnDidChangeVisibilityEvent(c):this.b.onDidChangeVisibility}throw new Error(`Event not found: ${h}`)}async call(E,h,c){switch(h){case"createLogger":this.c(j.URI.revive(c[0]),c[1],c[2]);return;case"log":return this.e(j.URI.revive(c[0]),c[1]);case"consoleLog":return this.d(c[0],c[1]);case"setLogLevel":return(0,P.$Pj)(c[0])?this.b.setLogLevel(c[0]):this.b.setLogLevel(j.URI.revive(c[0]),c[1]);case"setVisibility":return this.b.setVisibility(j.URI.revive(c[0]),c[1]);case"registerLogger":return this.b.registerLogger({...c[0],resource:j.URI.revive(c[0].resource)},c[1]);case"deregisterLogger":return this.b.deregisterLogger(j.URI.revive(c[0]))}throw new Error(`Call not found: ${h}`)}c(E,h,c){this.a.set(E,this.b.createLogger(E,h,c))}d(E,h){let c=console.log;switch(E){case P.LogLevel.Error:c=console.error;break;case P.LogLevel.Warning:c=console.warn;break;case P.LogLevel.Info:c=console.info;break}c.call(console,...h)}e(E,h){const c=this.a.get(E);if(!c)throw new Error("Create the logger before logging");for(const[p,y]of h)(0,P.log)(c,p,y)}}e.$pbc=B}),define(oe[233],ae([0,1,16,5]),function(J,e,n,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RP=void 0;var P;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(P||(P={}));async function B(c,p,y,k,g){try{const m=await new Promise((w,$)=>{J(["@vscode/spdlog"],w,$)});m.setFlushOn(P.Trace);const v=await m.createAsyncRotatingLogger(c,p,y,k);return g?v.clearFormatters():v.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),v}catch(m){console.error(m)}return null}function S(c,p,y){switch(p){case j.LogLevel.Trace:c.trace(y);break;case j.LogLevel.Debug:c.debug(y);break;case j.LogLevel.Info:c.info(y);break;case j.LogLevel.Warning:c.warn(y);break;case j.LogLevel.Error:c.error(y);break;case j.LogLevel.Off:break;default:throw new Error(`Invalid log level ${p}`)}}function E(c,p){switch(p){case j.LogLevel.Trace:c.setLevel(P.Trace);break;case j.LogLevel.Debug:c.setLevel(P.Debug);break;case j.LogLevel.Info:c.setLevel(P.Info);break;case j.LogLevel.Warning:c.setLevel(P.Warning);break;case j.LogLevel.Error:c.setLevel(P.Error);break;case j.LogLevel.Off:c.setLevel(P.Off);break;default:throw new Error(`Invalid log level ${p}`)}}class h extends j.$Tj{constructor(p,y,k,g,m){super(),this.m=[],this.setLevel(m),this.n=this.s(p,y,k,g),this.B(this.onDidChangeLogLevel(v=>{this.r&&E(this.r,v)}))}async s(p,y,k,g){const m=k?6:1,v=30/m*n.$jl.MB,w=await B(p,y,v,m,g);if(w){this.r=w,E(this.r,this.getLevel());for(const{level:$,message:f}of this.m)S(this.r,$,f);this.m=[]}}g(p,y){this.r?S(this.r,p,y):this.getLevel()<=p&&this.m.push({level:p,message:y})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$RP=h}),define(oe[234],ae([0,1,33,5,233]),function(J,e,n,j,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SP=void 0;class B extends j.$Yj{s(E,h,c){return new P.$RP((0,n.$Dg)(),E.fsPath,!c?.donotRotate,!!c?.donotUseFormatters,h)}}e.$SP=B}),define(oe[67],ae([0,1,32,3,6,5,234]),function(J,e,n,j,P,B,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3_b=e.$2_b=void 0,e.$2_b=(0,P.$ii)(B.$Oj);class E extends S.$SP{constructor(){super(...arguments),this.u=new n.$Bc}createLogger(c,p,y){y!==void 0&&this.u.set(this.n(c),y);try{return super.createLogger(c,p)}catch(k){throw this.u.delete(this.n(c)),k}}registerLogger(c,p){p!==void 0&&this.u.set(c.resource,p),super.registerLogger(c)}deregisterLogger(c){this.u.delete(c),super.deregisterLogger(c)}getRegisteredLoggers(c){const p=[];for(const y of super.getRegisteredLoggers())c===this.u.get(y.resource)&&p.push(y);return p}getOnDidChangeLogLevelEvent(c){return j.Event.filter(this.onDidChangeLogLevel,p=>(0,B.$Pj)(p)||this.w(p[0],c))}getOnDidChangeVisibilityEvent(c){return j.Event.filter(this.onDidChangeVisibility,([p])=>this.w(p,c))}getOnDidChangeLoggersEvent(c){return j.Event.filter(j.Event.map(this.onDidChangeLoggers,p=>({added:[...p.added].filter(k=>this.w(k.resource,c)),removed:[...p.removed].filter(k=>this.w(k.resource,c))})),p=>p.added.length>0||p.removed.length>0)}deregisterLoggers(c){for(const[p,y]of this.u)y===c&&this.deregisterLogger(p)}w(c,p){const y=this.u.get(c);return y===void 0||y===p}dispose(){super.dispose(),this.u.clear()}}e.$3_b=E}),define(oe[235],ae([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hac=n,e.$Iac=j,e.$Jac=P,e.$Kac=B;function n(S){return S.submenu!==void 0}function j(S){return S.id==="vscode.menubar.separator"}function P(S){return S.uri!==void 0}function B(S){return!n(S)&&!j(S)&&!P(S)}}),define(oe[39],ae([0,1,3,71,2,6]),function(J,e,n,j,P,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4n=e.$3n=e.$2n=void 0,e.$2n=(0,B.$hi)("policy");class S extends P.$Uc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new n.$7d),this.onDidChange=this.h.event}async updatePolicyDefinitions(c){const p=Object.keys(this.f).length;return this.f={...c,...this.f},p!==Object.keys(this.f).length&&await this.j(c),j.Iterable.reduce(this.g.entries(),(y,[k,g])=>({...y,[k]:g}),{})}getPolicyValue(c){return this.g.get(c)}serialize(){return j.Iterable.reduce(Object.entries(this.f),(c,[p,y])=>({...c,[p]:{definition:y,value:this.g.get(p)}}),{})}}e.$3n=S;class E{constructor(){this.onDidChange=n.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$4n=E}),define(oe[236],ae([0,1,8,3,71,12,16,5,39]),function(J,e,n,j,P,B,S,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ibc=void 0;function c(y,k){const g=[];for(const m of new Set(P.Iterable.concat(y.keys(),k.keys())))y.get(m)!==k.get(m)&&g.push(m);return g}let p=class extends h.$3n{constructor(k,g,m){super(),this.m=k,this.n=g,this.s=m,this.c=this.B(new n.$fh(500));const v=j.Event.filter(g.onDidFilesChange,w=>w.affects(k));this.B(g.watch(k)),this.B(v(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const k=new Map;try{const g=await this.n.readFile(this.m),m=JSON.parse(g.value.toString());if(!(0,B.$Wf)(m))throw new Error("Policy file isn't a JSON object");for(const v of Object.keys(m))this.f[v]&&k.set(v,m[v])}catch(g){g.fileOperationResult!==1&&this.s.error("[FilePolicyService] Failed to read policies",g)}return k}async w(){const k=await this.u(),g=c(this.g,k);this.g=k,g.length>0&&this.h.fire(g)}};e.$Ibc=p,e.$Ibc=p=Ee([ne(1,S.$Nk),ne(2,E.$Nj)],p)}),define(oe[237],ae([0,1,3,2,39]),function(J,e,n,j,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hbc=e.$gbc=void 0;class B{constructor(h){this.b=h,this.a=new j.$Tc}listen(h,c){switch(c){case"onDidChange":return n.Event.map(this.b.onDidChange,p=>p.reduce((y,k)=>({...y,[k]:this.b.getPolicyValue(k)??null}),{}),this.a)}throw new Error(`Event not found: ${c}`)}call(h,c,p){switch(c){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(p)}throw new Error(`Call not found: ${c}`)}dispose(){this.a.dispose()}}e.$gbc=B;class S extends P.$3n{constructor(h,c){super(),this.a=c;for(const p in h){const{definition:y,value:k}=h[p];this.f[p]=y,k!==void 0&&this.g.set(p,k)}this.a.listen("onDidChange")(p=>{for(const y in p){const k=p[y];k===null?this.g.delete(y):this.g.set(y,k)}this.h.fire(Object.keys(p))})}async j(h){const c=await this.a.call("updatePolicyDefinitions",h);for(const p in c)this.g.set(p,c[p])}}e.$hbc=S}),define(oe[238],ae([0,1,39,8,2,5]),function(J,e,n,j,P,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hbc=void 0;let S=class extends n.$3n{constructor(h,c){super(),this.m=h,this.n=c,this.a=new j.$bh,this.b=this.B(new P.$Vc)}async j(h){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(h).length} policy definitions`);const{createWatcher:c}=await new Promise((p,y)=>{J(["@vscode/policy-watcher"],p,y)});await this.a.queue(()=>new Promise((p,y)=>{try{this.b.value=c(this.n,h,k=>{this.t(k),p()})}catch(k){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",k),y(k)}}))}t(h){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(h)}`);for(const c in h){const p=h[c];p===void 0?this.g.delete(c):this.g.set(c,p)}this.h.fire(Object.keys(h))}};e.$Hbc=S,e.$Hbc=S=Ee([ne(0,B.$Nj)],S)}),define(oe[79],ae([0,1,36]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let j;const P=globalThis.vscode;if(typeof P<"u"&&typeof P.context<"u"){const B=P.context.configuration();if(B)j=B.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(j=globalThis._VSCODE_PRODUCT_JSON,n.env.VSCODE_DEV&&Object.assign(j,{nameShort:`${j.nameShort} Dev`,nameLong:`${j.nameLong} Dev`,dataFolderName:`${j.dataFolderName}-dev`,serverDataFolderName:j.serverDataFolderName?`${j.serverDataFolderName}-dev`:void 0}),!j.version){const B=globalThis._VSCODE_PACKAGE_JSON;Object.assign(j,{version:B.version})}}else j={},Object.keys(j).length===0&&Object.assign(j,{version:"1.87.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=j}),define(oe[27],ae([0,1,6]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8j=e.$7j=void 0,e.$7j=(0,n.$hi)("productService"),e.$8j="vscode://schemas/vscode-product"}),define(oe[239],ae([0,1,8,5]),function(J,e,n,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xac=void 0;let P=class{constructor(S,E,h){this.a=S,this.b=E,this.c=h}async inspect(S){await this.d();const E=this.a.webContents.debugger;await E.sendCommand("Profiler.start"),this.c.warn("[perf] profiling STARTED",this.b),await(0,n.$ih)(S);const h=await E.sendCommand("Profiler.stop");return this.c.warn("[perf] profiling DONE",this.b),await this.e(),h.profile}async d(){const S=this.a.webContents.debugger;S.attach(),await S.sendCommand("Profiler.enable")}async e(){const S=this.a.webContents.debugger;await S.sendCommand("Profiler.disable"),S.detach()}};e.$xac=P,e.$xac=P=Ee([ne(2,j.$Nj)],P)}),define(oe[80],ae([0,1,6]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K_b=void 0,e.$K_b=(0,n.$hi)("protocolMainService")}),define(oe[45],ae([0,1,139,12]),function(J,e,n,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zn=void 0;class P{constructor(){this.a=new Map}add(S,E){n.ok(j.$Uf(S)),n.ok(j.$Wf(E)),n.ok(!this.a.has(S),"There is already an extension with this id"),this.a.set(S,E)}knows(S){return this.a.has(S)}as(S){return this.a.get(S)||null}}e.$Zn=new P}),define(oe[240],ae([0,1,3,45]),function(J,e,n,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1n=void 0,e.$1n={JSONContribution:"base.contributions.json"};function P(E){return E.length>0&&E.charAt(E.length-1)==="#"?E.substring(0,E.length-1):E}class B{constructor(){this.b=new n.$7d,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(h,c){this.a[P(h)]=c,this.b.fire(h)}notifySchemaChanged(h){this.b.fire(h)}getSchemaContributions(){return{schemas:this.a}}}const S=new B;j.$Zn.add(e.$1n.JSONContribution,S)}),define(oe[52],ae([0,1,22,3,12,165,18,240,45]),function(J,e,n,j,P,B,S,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.ConfigurationScope=e.$5n=e.EditPresentationTypes=void 0,e.$do=v,e.$eo=w,e.$fo=$,e.$go=l,e.$ho=d;var c;(function(a){a.Multiline="multilineText",a.Singleline="singlelineText"})(c||(e.EditPresentationTypes=c={})),e.$5n={Configuration:"base.contributions.configuration"};var p;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.MACHINE=2]="MACHINE",a[a.WINDOW=3]="WINDOW",a[a.RESOURCE=4]="RESOURCE",a[a.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",a[a.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(p||(e.ConfigurationScope=p={})),e.$6n={properties:{},patternProperties:{}},e.$7n={properties:{},patternProperties:{}},e.$8n={properties:{},patternProperties:{}},e.$9n={properties:{},patternProperties:{}},e.$0n={properties:{},patternProperties:{}},e.$$n={properties:{},patternProperties:{}},e.$_n="vscode://schemas/settings/resourceLanguage",e.$ao="vscode://schemas/settings/configurationDefaults";const y=h.$Zn.as(E.$1n.JSONContribution);class k{constructor(){this.h=new Set,this.i=new j.$7d,this.onDidSchemaChange=this.i.event,this.j=new j.$7d,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:B.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},y.registerSchema(e.$_n,this.g),this.v()}registerConfiguration(t,o=!0){this.registerConfigurations([t],o)}registerConfigurations(t,o=!0){const r=new Set;this.n(t,o,r),y.registerSchema(e.$_n,this.g),this.i.fire(),this.j.fire({properties:r})}deregisterConfigurations(t){const o=new Set;this.o(t,o),y.registerSchema(e.$_n,this.g),this.i.fire(),this.j.fire({properties:o})}updateConfigurations({add:t,remove:o}){const r=new Set;this.o(o,r),this.n(t,!1,r),y.registerSchema(e.$_n,this.g),this.i.fire(),this.j.fire({properties:r})}registerDefaultConfigurations(t){const o=new Set;this.k(t,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}k(t,o){const r=[];for(const{overrides:i,source:s}of t)for(const u in i)if(o.add(u),e.$co.test(u)){const b=this.a.get(u),I=b?.valuesSources??new Map;if(s)for(const A of Object.keys(i[u]))I.set(A,s);const D={...b?.value||{},...i[u]};this.a.set(u,{source:s,value:D,valuesSources:I});const R=(0,S.$Xi)(u),C={type:"object",default:D,description:B.localize(1,null,R),$ref:e.$_n,defaultDefaultValue:D,source:P.$Uf(s)?void 0:s,defaultValueSource:s};r.push(...v(u)),this.d[u]=C,this.b.properties[u]=C}else{this.a.set(u,{value:i[u],source:s});const b=this.d[u];b&&(this.w(u,b),this.r(u,b))}this.m(r)}deregisterDefaultConfigurations(t){const o=new Set;this.l(t,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}l(t,o){for(const{overrides:r,source:i}of t)for(const s in r){const u=this.a.get(s),b=P.$Uf(i)?i:i?.id,I=P.$Uf(u?.source)?u?.source:u?.source?.id;if(b===I)if(o.add(s),this.a.delete(s),e.$co.test(s))delete this.d[s],delete this.b.properties[s];else{const D=this.d[s];D&&(this.w(s,D),this.r(s,D))}}this.u()}deltaConfiguration(t){let o=!1;const r=new Set;t.removedDefaults&&(this.l(t.removedDefaults,r),o=!0),t.addedDefaults&&(this.k(t.addedDefaults,r),o=!0),t.removedConfigurations&&this.o(t.removedConfigurations,r),t.addedConfigurations&&this.n(t.addedConfigurations,!1,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const o of t)this.h.add(o);this.u()}n(t,o,r){t.forEach(i=>{this.p(i,o,i.extensionInfo,i.restrictedProperties,void 0,r),this.c.push(i),this.q(i)})}o(t,o){const r=i=>{if(i.properties)for(const s in i.properties){o.add(s);const u=this.d[s];u?.policy?.name&&this.e.delete(u.policy.name),delete this.d[s],this.s(s,i.properties[s])}i.allOf?.forEach(s=>r(s))};for(const i of t){r(i);const s=this.c.indexOf(i);s!==-1&&this.c.splice(s,1)}}p(t,o=!0,r,i,s=3,u){s=P.$4f(t.scope)?s:t.scope;const b=t.properties;if(b)for(const D in b){const R=b[D];if(o&&l(D,R)){delete b[D];continue}if(R.source=r,R.defaultDefaultValue=b[D].default,this.w(D,R),e.$co.test(D)?R.scope=void 0:(R.scope=P.$4f(R.scope)?s:R.scope,R.restricted=P.$4f(R.restricted)?!!i?.includes(D):R.restricted),b[D].hasOwnProperty("included")&&!b[D].included){this.f[D]=b[D],delete b[D];continue}else this.d[D]=b[D],b[D].policy?.name&&this.e.set(b[D].policy.name,D);!b[D].deprecationMessage&&b[D].markdownDeprecationMessage&&(b[D].deprecationMessage=b[D].markdownDeprecationMessage),u.add(D)}const I=t.allOf;if(I)for(const D of I)this.p(D,o,r,i,s,u)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const o=r=>{const i=r.properties;if(i)for(const u in i)this.r(u,i[u]);r.allOf?.forEach(o)};o(t)}r(t,o){switch(e.$6n.properties[t]=o,o.scope){case 1:e.$7n.properties[t]=o;break;case 2:e.$8n.properties[t]=o;break;case 6:e.$9n.properties[t]=o;break;case 3:e.$0n.properties[t]=o;break;case 4:e.$$n.properties[t]=o;break;case 5:e.$$n.properties[t]=o,this.g.properties[t]=o;break}}s(t,o){switch(delete e.$6n.properties[t],o.scope){case 1:delete e.$7n.properties[t];break;case 2:delete e.$8n.properties[t];break;case 6:delete e.$9n.properties[t];break;case 3:delete e.$0n.properties[t];break;case 4:case 5:delete e.$$n.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const o=`[${t}]`,r={type:"object",description:B.localize(2,null),errorMessage:B.localize(3,null),$ref:e.$_n};this.w(o,r),e.$6n.properties[o]=r,e.$7n.properties[o]=r,e.$8n.properties[o]=r,e.$9n.properties[o]=r,e.$0n.properties[o]=r,e.$$n.properties[o]=r}}v(){const t={type:"object",description:B.localize(4,null),errorMessage:B.localize(5,null),$ref:e.$_n};e.$6n.patternProperties[e.$bo]=t,e.$7n.patternProperties[e.$bo]=t,e.$8n.patternProperties[e.$bo]=t,e.$9n.patternProperties[e.$bo]=t,e.$0n.patternProperties[e.$bo]=t,e.$$n.patternProperties[e.$bo]=t,this.i.fire()}w(t,o){const r=this.a.get(t);let i=r?.value,s=r?.source;P.$2f(i)&&(i=o.defaultDefaultValue,s=void 0),P.$2f(i)&&(i=$(o.type)),o.default=i,o.defaultValueSource=s}}const g="\\[([^\\]]+)\\]",m=new RegExp(g,"g");e.$bo=`^(${g})+$`,e.$co=new RegExp(e.$bo);function v(a){const t=[];if(e.$co.test(a)){let o=m.exec(a);for(;o?.length;){const r=o[1].trim();r&&t.push(r),o=m.exec(a)}}return(0,n.$Mb)(t)}function w(a){return a.reduce((t,o)=>`${t}[${o}]`,"")}function $(a){switch(Array.isArray(a)?a[0]:a){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const f=new k;h.$Zn.add(e.$5n.Configuration,f);function l(a,t){return a.trim()?e.$co.test(a)?B.localize(7,null,a):f.getConfigurationProperties()[a]!==void 0?B.localize(8,null,a):t.policy?.name&&f.getPolicyConfigurations().get(t.policy?.name)!==void 0?B.localize(9,null,a,t.policy?.name,f.getPolicyConfigurations().get(t.policy?.name)):null:B.localize(6,null)}function d(){const a=[],t=f.getConfigurationProperties();for(const o of Object.keys(t))a.push([o,t[o].scope]);return a.push(["launch",4]),a.push(["task",4]),a}}),define(oe[123],ae([0,1,22,3,42,2,32,35,12,7,18,52,45]),function(J,e,n,j,P,B,S,E,h,c,p,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$no=e.$lo=e.$ko=e.$jo=e.$io=void 0,e.$mo=l;function g(o){return Object.isFrozen(o)?o:E.$On(o)}class m{constructor(r={},i=[],s=[],u){this.b=r,this.c=i,this.d=s,this.raw=u,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const r=this.raw.map(i=>{if(i instanceof m)return i;const s=new v("");return s.parseRaw(i),s.configurationModel});this.f=r.reduce((i,s)=>s===i?s:i.merge(s),r[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(r){return r?(0,p.$Vi)(this.contents,r):this.contents}inspect(r,i){const s=this;return{get value(){return g(s.rawConfiguration.getValue(r))},get override(){return i?g(s.rawConfiguration.getOverrideValue(r,i)):void 0},get merged(){return g(i?s.rawConfiguration.override(i).getValue(r):s.rawConfiguration.getValue(r))},get overrides(){const u=[];for(const{contents:b,identifiers:I,keys:D}of s.rawConfiguration.overrides){const R=new m(b,D).getValue(r);R!==void 0&&u.push({identifiers:I,value:R})}return u.length?g(u):void 0}}}getOverrideValue(r,i){const s=this.i(i);return s?r?(0,p.$Vi)(s,r):s:void 0}getKeysForOverrideIdentifier(r){const i=[];for(const s of this.overrides)s.identifiers.includes(r)&&i.push(...s.keys);return n.$Mb(i)}getAllOverrideIdentifiers(){const r=[];for(const i of this.overrides)r.push(...i.identifiers);return n.$Mb(r)}override(r){let i=this.a.get(r);return i||(i=this.g(r),this.a.set(r,i)),i}merge(...r){const i=E.$Nn(this.contents),s=E.$Nn(this.overrides),u=[...this.keys],b=this.raw?.length?[...this.raw]:[this];for(const I of r)if(b.push(...I.raw?.length?I.raw:[I]),!I.isEmpty()){this.h(i,I.contents);for(const D of I.overrides){const[R]=s.filter(C=>n.$ub(C.identifiers,D.identifiers));R?(this.h(R.contents,D.contents),R.keys.push(...D.keys),R.keys=n.$Mb(R.keys)):s.push(E.$Nn(D))}for(const D of I.keys)u.indexOf(D)===-1&&u.push(D)}return new m(i,u,s,b.every(I=>I instanceof m)?void 0:b)}g(r){const i=this.i(r);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const s={};for(const u of n.$Mb([...Object.keys(this.contents),...Object.keys(i)])){let b=this.contents[u];const I=i[u];I&&(typeof b=="object"&&typeof I=="object"?(b=E.$Nn(b),this.h(b,I)):b=I),s[u]=b}return new m(s,this.keys,this.overrides)}h(r,i){for(const s of Object.keys(i)){if(s in r&&h.$Wf(r[s])&&h.$Wf(i[s])){this.h(r[s],i[s]);continue}r[s]=E.$Nn(i[s])}}i(r){let i=null,s=null;const u=b=>{b&&(s?this.h(s,b):s=E.$Nn(b))};for(const b of this.overrides)b.identifiers.length===1&&b.identifiers[0]===r?i=b.contents:b.identifiers.includes(r)&&u(b.contents);return u(i),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(r,i){this.j(r,i,!0)}setValue(r,i){this.j(r,i,!1)}removeValue(r){const i=this.keys.indexOf(r);i!==-1&&(this.keys.splice(i,1),(0,p.$Ui)(this.contents,r),y.$co.test(r)&&this.overrides.splice(this.overrides.findIndex(s=>n.$ub(s.identifiers,(0,y.$do)(r))),1))}j(r,i,s){(0,p.$Ti)(this.contents,r,i,u=>console.error(u)),s=s||this.keys.indexOf(r)===-1,s&&this.keys.push(r),y.$co.test(r)&&this.overrides.push({identifiers:(0,y.$do)(r),keys:Object.keys(this.contents[r]),contents:(0,p.$Si)(this.contents[r],u=>console.error(u))})}}e.$io=m;class v{constructor(r){this.f=r,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new m}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(r,i){if(!h.$4f(r)){const s=this.g(r);this.parseRaw(s,i)}}reparse(r){this.a&&this.parseRaw(this.a,r)}parseRaw(r,i){this.a=r;const{contents:s,keys:u,overrides:b,restricted:I,hasExcludedProperties:D}=this.h(r,i);this.b=new m(s,u,b,D?[r]:void 0),this.c=I||[]}g(r){let i={},s=null,u=[];const b=[],I=[];function D(C){Array.isArray(u)?u.push(C):s!==null&&(u[s]=C)}const R={onObjectBegin:()=>{const C={};D(C),b.push(u),u=C,s=null},onObjectProperty:C=>{s=C},onObjectEnd:()=>{u=b.pop()},onArrayBegin:()=>{const C=[];D(C),b.push(u),u=C,s=null},onArrayEnd:()=>{u=b.pop()},onLiteralValue:D,onError:(C,A,L)=>{I.push({error:C,offset:A,length:L})}};if(r)try{P.$Bn(r,R),i=u[0]||{}}catch(C){console.error(`Error while parsing settings file ${this.f}: ${C}`),this.d=[C]}return i}h(r,i){const s=k.$Zn.as(y.$5n.Configuration).getConfigurationProperties(),u=this.i(r,s,!0,i);r=u.raw;const b=(0,p.$Si)(r,R=>console.error(`Conflict in settings file ${this.f}: ${R}`)),I=Object.keys(r),D=this.j(r,R=>console.error(`Conflict in settings file ${this.f}: ${R}`));return{contents:b,keys:I,overrides:D,restricted:u.restricted,hasExcludedProperties:u.hasExcludedProperties}}i(r,i,s,u){let b=!1;if(!u?.scopes&&!u?.skipRestricted&&!u?.exclude?.length)return{raw:r,restricted:[],hasExcludedProperties:b};const I={},D=[];for(const R in r)if(y.$co.test(R)&&s){const C=this.i(r[R],i,!1,u);I[R]=C.raw,b=b||C.hasExcludedProperties,D.push(...C.restricted)}else{const C=i[R],A=C?typeof C.scope<"u"?C.scope:3:void 0;C?.restricted&&D.push(R),!u.exclude?.includes(R)&&(u.include?.includes(R)||(A===void 0||u.scopes===void 0||u.scopes.includes(A))&&!(u.skipRestricted&&C?.restricted))?I[R]=r[R]:b=!0}return{raw:I,restricted:D,hasExcludedProperties:b}}j(r,i){const s=[];for(const u of Object.keys(r))if(y.$co.test(u)){const b={};for(const I in r[u])b[I]=r[u][I];s.push({identifiers:(0,y.$do)(u),keys:Object.keys(b),contents:(0,p.$Si)(b,i)})}return s}}e.$jo=v;class w extends B.$Uc{constructor(r,i,s,u){super(),this.c=r,this.f=i,this.g=u,this.b=this.B(new j.$7d),this.onDidChange=this.b.event,this.a=new v(this.c.toString()),this.B(this.g.watch(s.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(j.Event.any(j.Event.filter(this.g.onDidFilesChange,b=>b.contains(this.c)),j.Event.filter(this.g.onDidRunOperation,b=>(b.isOperation(0)||b.isOperation(3)||b.isOperation(1)||b.isOperation(4))&&s.isEqual(b.resource,r)))(()=>this.b.fire()))}async loadConfiguration(){try{const r=await this.g.readFile(this.c);return this.a.parse(r.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new m}}reparse(r){return r&&(this.f=r),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$ko=w;class ${constructor(r,i,s,u,b,I,D,R,C,A,L,W,q){this.a=r,this.b=i,this.c=s,this.overrideIdentifiers=u,this.d=b,this.f=I,this.g=D,this.h=R,this.i=C,this.j=A,this.k=L,this.l=W,this.m=q}get value(){return g(this.c)}n(r){return r?.value!==void 0||r?.override!==void 0||r?.overrides!==void 0?r:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class f{constructor(r,i,s,u,b=new m,I=new m,D=new S.$Bc,R=new m,C=new S.$Bc){this.c=r,this.d=i,this.f=s,this.g=u,this.h=b,this.i=I,this.j=D,this.l=R,this.m=C,this.a=null,this.b=new S.$Bc,this.n=null}getValue(r,i,s){return this.p(r,i,s).getValue(r)}updateValue(r,i,s={}){let u;s.resource?(u=this.m.get(s.resource),u||(u=new m,this.m.set(s.resource,u))):u=this.l,i===void 0?u.removeValue(r):u.setValue(r,i),s.resource||(this.a=null)}inspect(r,i,s){const u=this.p(r,i,s),b=this.t(i.resource,s),I=i.resource?this.m.get(i.resource)||this.l:this.l,D=new Set;for(const R of u.overrides)for(const C of R.identifiers)u.getOverrideValue(r,C)!==void 0&&D.add(C);return new $(r,i,u.getValue(r),D.size?[...D]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,s?this.i:void 0,b||void 0,I)}keys(r){const i=this.t(void 0,r);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(r){this.c=r,this.a=null,this.b.clear()}updatePolicyConfiguration(r){this.d=r}updateApplicationConfiguration(r){this.f=r,this.a=null,this.b.clear()}updateLocalUserConfiguration(r){this.g=r,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(r){this.h=r,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(r){this.i=r,this.a=null,this.b.clear()}updateFolderConfiguration(r,i){this.j.set(r,i),this.b.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this.b.delete(r)}compareAndUpdateDefaultConfiguration(r,i){const s=[];if(!i){const{added:u,updated:b,removed:I}=a(this.c,r);i=[...u,...b,...I]}for(const u of i)for(const b of(0,y.$do)(u)){const I=this.c.getKeysForOverrideIdentifier(b),D=r.getKeysForOverrideIdentifier(b),R=[...D.filter(C=>I.indexOf(C)===-1),...I.filter(C=>D.indexOf(C)===-1),...I.filter(C=>!E.$Rn(this.c.override(b).getValue(C),r.override(b).getValue(C)))];s.push([b,R])}return this.updateDefaultConfiguration(r),{keys:i,overrides:s}}compareAndUpdatePolicyConfiguration(r){const{added:i,updated:s,removed:u}=a(this.d,r),b=[...i,...s,...u];return b.length&&this.updatePolicyConfiguration(r),{keys:b,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:i,updated:s,removed:u,overrides:b}=a(this.applicationConfiguration,r),I=[...i,...s,...u];return I.length&&this.updateApplicationConfiguration(r),{keys:I,overrides:b}}compareAndUpdateLocalUserConfiguration(r){const{added:i,updated:s,removed:u,overrides:b}=a(this.localUserConfiguration,r),I=[...i,...s,...u];return I.length&&this.updateLocalUserConfiguration(r),{keys:I,overrides:b}}compareAndUpdateRemoteUserConfiguration(r){const{added:i,updated:s,removed:u,overrides:b}=a(this.remoteUserConfiguration,r),I=[...i,...s,...u];return I.length&&this.updateRemoteUserConfiguration(r),{keys:I,overrides:b}}compareAndUpdateWorkspaceConfiguration(r){const{added:i,updated:s,removed:u,overrides:b}=a(this.workspaceConfiguration,r),I=[...i,...s,...u];return I.length&&this.updateWorkspaceConfiguration(r),{keys:I,overrides:b}}compareAndUpdateFolderConfiguration(r,i){const s=this.folderConfigurations.get(r),{added:u,updated:b,removed:I,overrides:D}=a(s,i),R=[...u,...b,...I];return(R.length||!s)&&this.updateFolderConfiguration(r,i),{keys:R,overrides:D}}compareAndDeleteFolderConfiguration(r){const i=this.folderConfigurations.get(r);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:s,updated:u,removed:b,overrides:I}=a(i,void 0);return{keys:[...s,...u,...b],overrides:I}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(r,i,s){let u=this.q(i,s);return i.overrideIdentifier&&(u=u.override(i.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(r)!==void 0&&(u=u.merge(this.d)),u}q({resource:r},i){let s=this.r();if(i&&r){const u=i.getFolder(r);u&&(s=this.s(u.uri)||s);const b=this.m.get(r);b&&(s=s.merge(b))}return s}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(r){let i=this.b.get(r);if(!i){const s=this.r(),u=this.j.get(r);u?(i=s.merge(u),this.b.set(r,i)):i=s}return i}t(r,i){if(i&&r){const s=i.getFolder(r);if(s)return this.j.get(s.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((r,i)=>{const{contents:s,overrides:u,keys:b}=this.j.get(i);return r.push([i,{contents:s,overrides:u,keys:b}]),r},[])}}allKeys(){const r=new Set;return this.c.keys.forEach(i=>r.add(i)),this.userConfiguration.keys.forEach(i=>r.add(i)),this.i.keys.forEach(i=>r.add(i)),this.j.forEach(i=>i.keys.forEach(s=>r.add(s))),[...r.values()]}u(){const r=new Set;return this.c.getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.i.getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.j.forEach(i=>i.getAllOverrideIdentifiers().forEach(s=>r.add(s))),[...r.values()]}v(r){const i=new Set;return this.c.getKeysForOverrideIdentifier(r).forEach(s=>i.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(s=>i.add(s)),this.i.getKeysForOverrideIdentifier(r).forEach(s=>i.add(s)),this.j.forEach(s=>s.getKeysForOverrideIdentifier(r).forEach(u=>i.add(u))),[...i.values()]}static parse(r){const i=this.w(r.defaults),s=this.w(r.policy),u=this.w(r.application),b=this.w(r.user),I=this.w(r.workspace),D=r.folders.reduce((R,C)=>(R.set(c.URI.revive(C[0]),this.w(C[1])),R),new S.$Bc);return new f(i,s,u,b,new m,I,D,new m,new S.$Bc)}static w(r){return new m(r.contents,r.keys,r.overrides)}}e.$lo=f;function l(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const r=new Set,i=new Map;for(const u of o)u.keys.forEach(b=>r.add(b)),u.overrides.forEach(([b,I])=>{const D=(0,S.$yc)(i,b,new Set);I.forEach(R=>D.add(R))});const s=[];return i.forEach((u,b)=>s.push([b,[...u.values()]])),{keys:[...r.values()],overrides:s}}class d{constructor(r,i,s,u){this.change=r,this.f=i,this.g=s,this.h=u,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.i=void 0;for(const b of r.keys)this.affectedKeys.add(b);for(const[,b]of r.overrides)for(const I of b)this.affectedKeys.add(I);this.d=this.a;for(const b of this.affectedKeys)this.d+=b+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=f.parse(this.f.data)),this.i}affectsConfiguration(r,i){const s=this.a+r,u=this.d.indexOf(s);if(u<0)return!1;const b=u+s.length;if(b>=this.d.length)return!1;const I=this.d.charCodeAt(b);if(I!==this.b&&I!==this.c)return!1;if(i){const D=this.previousConfiguration?this.previousConfiguration.getValue(r,i,this.f?.workspace):void 0,R=this.g.getValue(r,i,this.h);return!E.$Rn(D,R)}return!0}}e.$no=d;function a(o,r){const{added:i,removed:s,updated:u}=t(r?.rawConfiguration,o?.rawConfiguration),b=[],I=o?.getAllOverrideIdentifiers()||[],D=r?.getAllOverrideIdentifiers()||[];if(r){const R=D.filter(C=>!I.includes(C));for(const C of R)b.push([C,r.getKeysForOverrideIdentifier(C)])}if(o){const R=I.filter(C=>!D.includes(C));for(const C of R)b.push([C,o.getKeysForOverrideIdentifier(C)])}if(r&&o){for(const R of I)if(D.includes(R)){const C=t({contents:o.getOverrideValue(void 0,R)||{},keys:o.getKeysForOverrideIdentifier(R)},{contents:r.getOverrideValue(void 0,R)||{},keys:r.getKeysForOverrideIdentifier(R)});b.push([R,[...C.added,...C.removed,...C.updated]])}}return{added:i,removed:s,updated:u,overrides:b}}function t(o,r){const i=o?r?o.keys.filter(b=>r.keys.indexOf(b)===-1):[...o.keys]:[],s=r?o?r.keys.filter(b=>o.keys.indexOf(b)===-1):[...r.keys]:[],u=[];if(o&&r){for(const b of r.keys)if(o.keys.indexOf(b)!==-1){const I=(0,p.$Vi)(r.contents,b),D=(0,p.$Vi)(o.contents,b);E.$Rn(I,D)||u.push(b)}}return{added:i,removed:s,updated:u}}}),define(oe[241],ae([0,1,22,3,2,35,12,123,52,5,39,45]),function(J,e,n,j,P,B,S,E,h,c,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qo=e.$po=e.$oo=void 0;class k extends P.$Uc{constructor(){super(...arguments),this.a=this.B(new j.$7d),this.onDidChangeConfiguration=this.a.event,this.b=new E.$io}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(y.$Zn.as(h.$5n.Configuration).onDidUpdateConfiguration(({properties:w,defaultsOverrides:$})=>this.c(Array.from(w),$))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(w,$){this.h(w,y.$Zn.as(h.$5n.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:w})}f(){return{}}g(){this.b=new E.$io;const w=y.$Zn.as(h.$5n.Configuration).getConfigurationProperties();this.h(Object.keys(w),w)}h(w,$){const f=this.f();for(const l of w){const d=f[l],a=$[l];d!==void 0?this.b.addValue(l,d):a?this.b.addValue(l,a.default):this.b.removeValue(l)}}}e.$oo=k;class g{constructor(){this.onDidChangeConfiguration=j.Event.None,this.configurationModel=new E.$io}async initialize(){return this.configurationModel}}e.$po=g;let m=class extends P.$Uc{get configurationModel(){return this.b}constructor(w,$,f){super(),this.c=w,this.f=$,this.g=f,this.a=this.B(new j.$7d),this.onDidChangeConfiguration=this.a.event,this.b=new E.$io}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(w=>this.j(w))),this.B(this.c.onDidChangeConfiguration(async({properties:w})=>this.m(await this.h(w),!0))),this.b}async h(w){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",w);const $={},f=[],l=y.$Zn.as(h.$5n.Configuration).getConfigurationProperties();for(const d of w){const a=l[d];if(!a){f.push(d);continue}if(a.policy){if(a.type!=="string"&&a.type!=="number"){this.g.warn(`Policy ${a.policy.name} has unsupported type ${a.type}`);continue}f.push(d),$[a.policy.name]={type:a.type}}}return(0,S.$8f)($)||await this.f.updatePolicyDefinitions($),f}j(w){this.g.trace("PolicyConfiguration#onDidChangePolicies",w);const $=y.$Zn.as(h.$5n.Configuration).getPolicyConfigurations(),f=(0,n.$Hb)(w.map(l=>$.get(l)));this.m(f,!0)}m(w,$){this.g.trace("PolicyConfiguration#update",w);const f=y.$Zn.as(h.$5n.Configuration).getConfigurationProperties(),l=[],d=this.b.isEmpty();for(const a of w){const t=f[a]?.policy?.name;if(t){const o=this.f.getPolicyValue(t);(d?o!==void 0:!(0,B.$Rn)(this.b.getValue(a),o))&&l.push([a,o])}else this.b.getValue(a)!==void 0&&l.push([a,void 0])}if(l.length){this.g.trace("PolicyConfiguration#changed",l);const a=this.b;this.b=new E.$io;for(const t of a.keys)this.b.setValue(t,a.getValue(t));for(const[t,o]of l)o===void 0?this.b.removeValue(t):this.b.setValue(t,o);$&&this.a.fire(this.b)}}};e.$qo=m,e.$qo=m=Ee([ne(1,p.$2n),ne(2,c.$Nj)],m)}),define(oe[242],ae([0,1,22,8,17,3,42,103,2,35,4,19,18,123,52,241,39]),function(J,e,n,j,P,B,S,E,h,c,p,y,k,g,m,v,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ro=void 0;class $ extends h.$Uc{constructor(d,a,t,o){super(),this.m=d,this.h=this.B(new B.$7d),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new v.$oo),this.c=t instanceof w.$4n?new v.$po:this.B(new v.$qo(this.b,t,o)),this.f=this.B(new g.$ko(this.m,{},y.$Lg,a)),this.a=new g.$lo(this.b.configurationModel,this.c.configurationModel,new g.$io,new g.$io),this.j=new f(d,a,this),this.g=this.B(new j.$th(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:r,properties:i})=>this.r(r,i))),this.B(this.c.onDidChangeConfiguration(r=>this.s(r))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[d,a,t]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new g.$lo(d,a,new g.$io,t)}getConfigurationData(){return this.a.toData()}getValue(d,a){const t=typeof d=="string"?d:void 0,o=(0,k.$Oi)(d)?d:(0,k.$Oi)(a)?a:{};return this.a.getValue(t,o,void 0)}async updateValue(d,a,t,o,r){const i=(0,k.$Pi)(t)?t:(0,k.$Oi)(t)?{resource:t.resource,overrideIdentifiers:t.overrideIdentifier?[t.overrideIdentifier]:void 0}:void 0,s=i?o:t;if(s!==void 0&&s!==3&&s!==2)throw new Error(`Unable to write ${d} to target ${s}.`);i?.overrideIdentifiers&&(i.overrideIdentifiers=(0,n.$Mb)(i.overrideIdentifiers),i.overrideIdentifiers=i.overrideIdentifiers.length?i.overrideIdentifiers:void 0);const u=this.inspect(d,{resource:i?.resource,overrideIdentifier:i?.overrideIdentifiers?i.overrideIdentifiers[0]:void 0});if(u.policyValue!==void 0)throw new Error(`Unable to write ${d} because it is configured in system policy.`);if((0,c.$Rn)(a,u.defaultValue)&&(a=void 0),i?.overrideIdentifiers?.length&&i.overrideIdentifiers.length>1){const I=i.overrideIdentifiers.sort(),D=this.a.localUserConfiguration.overrides.find(R=>(0,n.$ub)([...R.identifiers].sort(),I));D&&(i.overrideIdentifiers=D.identifiers)}const b=i?.overrideIdentifiers?.length?[(0,m.$eo)(i.overrideIdentifiers),d]:[d];await this.j.write(b,a),await this.reloadConfiguration()}inspect(d,a={}){return this.a.inspect(d,a,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const d=await this.f.loadConfiguration();this.n(d)}n(d){const a=this.a.toData(),t=this.a.compareAndUpdateLocalUserConfiguration(d);this.t(t,a,2)}r(d,a){const t=this.a.toData(),o=this.a.compareAndUpdateDefaultConfiguration(d,a);this.t(o,t,7)}s(d){const a=this.a.toData(),t=this.a.compareAndUpdatePolicyConfiguration(d);this.t(t,a,7)}t(d,a,t){const o=new g.$no(d,{data:a},this.a);o.source=t,this.h.fire(o)}}e.$ro=$;class f{constructor(d,a,t){this.b=d,this.c=a,this.d=t,this.a=new j.$oh}write(d,a){return this.a.queue(()=>this.e(d,a))}async e(d,a){let t;try{t=(await this.c.readFile(this.b)).value.toString()}catch(i){if(i.fileOperationResult===1)t="{}";else throw i}const o=[];if((0,S.$un)(t,o,{allowTrailingComma:!0,allowEmptyContent:!0}),o.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const r=this.f(t,d,a);t=(0,E.$Mn)(t,r),await this.c.writeFile(this.b,P.$ue.fromString(t))}f(d,a,t){const{tabSize:o,insertSpaces:r,eol:i}=this.h;if(!a.length){const s=JSON.stringify(t,null,r?" ".repeat(o):"	");return[{content:s,length:s.length,offset:0}]}return(0,E.$Jn)(d,a,t,{tabSize:o,insertSpaces:r,eol:i})}get h(){if(!this.g){let d=p.OS===3||p.OS===2?`
`:`\r
`;const a=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});a&&typeof a=="string"&&a!=="auto"&&(d=a),this.g={eol:d,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(oe[243],ae([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wbc=e.$vbc=e.$ubc=void 0,e.$ubc="request",e.$vbc="remoteResourceHandler";class n{async routeCall(P,B,S){if(B!==e.$ubc)throw new Error(`Call not found: ${B}`);const E=S[0];if(E?.authority){const h=P.connections.find(c=>c.ctx===E.authority);if(h)return h}throw new Error("Caller not found")}routeEvent(P,B){throw new Error(`Event not found: ${B}`)}}e.$wbc=n}),define(oe[244],ae([0,1,15,6]),function(J,e,n,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vl=e.RemoteAuthorityResolverErrorCode=e.$ul=e.$tl=e.RemoteConnectionType=e.$sl=void 0,e.$wl=c,e.$sl=(0,j.$hi)("remoteAuthorityResolverService");var P;(function(p){p[p.WebSocket=0]="WebSocket",p[p.Managed=1]="Managed"})(P||(e.RemoteConnectionType=P={}));class B{constructor(y){this.id=y,this.type=1}toString(){return`Managed(${this.id})`}}e.$tl=B;class S{constructor(y,k){this.host=y,this.port=k,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$ul=S;var E;(function(p){p.Unknown="Unknown",p.NotAvailable="NotAvailable",p.TemporarilyNotAvailable="TemporarilyNotAvailable",p.NoResolverFound="NoResolverFound",p.InvalidAuthority="InvalidAuthority"})(E||(e.RemoteAuthorityResolverErrorCode=E={}));class h extends n.$bb{static isNotAvailable(y){return y instanceof h&&y._code===E.NotAvailable}static isTemporarilyNotAvailable(y){return y instanceof h&&y._code===E.TemporarilyNotAvailable}static isNoResolverFound(y){return y instanceof h&&y._code===E.NoResolverFound}static isInvalidAuthority(y){return y instanceof h&&y._code===E.InvalidAuthority}static isHandled(y){return y instanceof h&&y.isHandled}constructor(y,k=E.Unknown,g){super(y),this._message=y,this._code=k,this._detail=g,this.isHandled=k===E.NotAvailable&&g===!0,Object.setPrototypeOf(this,h.prototype)}}e.$vl=h;function c(p){const y=p.indexOf("+");return y===-1?p:p.substring(0,y)}}),define(oe[245],ae([0,1,8,17,23,15,3,2,13,66,72,33,113,244]),function(J,e,n,j,P,B,S,E,h,c,p,y,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ll=e.$Kl=e.$Jl=e.$Il=e.$Hl=e.$Gl=e.$Fl=e.$El=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$Bl=I,e.$Cl=D,e.$Dl=C;const m=30*1e3;var v;(function(K){K[K.Management=1]="Management",K[K.ExtensionHost=2]="ExtensionHost",K[K.Tunnel=3]="Tunnel"})(v||(e.ConnectionType=v={}));function w(K){switch(K){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function $(K){const O=new P.$ee;return setTimeout(()=>O.cancel(),K),O.token}function f(K,O){if(K.isCancellationRequested||O.isCancellationRequested)return P.CancellationToken.Cancelled;const N=new P.$ee;return K.onCancellationRequested(()=>N.cancel()),O.onCancellationRequested(()=>N.cancel()),N.token}class l{get didTimeout(){return this.c==="timedout"}constructor(O){this.c="pending",this.d=new E.$Tc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,n.$ah)(),O.isCancellationRequested?this.h():this.d.add(O.onCancellationRequested(()=>this.h()))}registerDisposable(O){this.c==="pending"?this.d.add(O):O.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const O=new Error("Time limit reached");return O.code="ETIMEDOUT",O.syscall="connect",O}resolve(O){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(O))}reject(O){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(O))}}function d(K,O){const N=new l(O);return N.registerDisposable(K.onControlMessage(_=>{const se=JSON.parse(_.toString()),Z=M(se);Z?N.reject(Z):N.resolve(se)})),N.promise}function a(K,O,N,_,se,Z,V,x){const U=new l(x),re=p.$3d.create(!1);return K.info(`Creating a socket (${V})...`),c.mark(`code/willCreateSocket/${Z}`),O.connect(N,_,se,V).then(ee=>{U.didTimeout?(c.mark(`code/didCreateSocketError/${Z}`),K.info(`Creating a socket (${V}) finished after ${re.elapsed()} ms, but this is too late and has timed out already.`),ee?.dispose()):(c.mark(`code/didCreateSocketOK/${Z}`),K.info(`Creating a socket (${V}) was successful after ${re.elapsed()} ms.`),U.resolve(ee))},ee=>{c.mark(`code/didCreateSocketError/${Z}`),K.info(`Creating a socket (${V}) returned an error after ${re.elapsed()} ms.`),K.error(ee),U.reject(ee)}),U.promise}function t(K,O){const N=new l(O);return K.then(_=>{N.didTimeout||N.resolve(_)},_=>{N.didTimeout||N.reject(_)}),N.promise}async function o(K,O,N,_){const se=ce(K,O);K.logService.trace(`${se} 1/6. invoking socketFactory.connect().`);let Z;try{Z=await a(K.logService,K.remoteSocketFactoryService,K.connectTo,h.$ug.getServerRootPath(),`reconnectionToken=${K.reconnectionToken}&reconnection=${K.reconnectionProtocol?"true":"false"}`,w(O),`renderer-${w(O)}-${K.reconnectionToken}`,_)}catch(ee){throw K.logService.error(`${se} socketFactory.connect() failed or timed out. Error:`),K.logService.error(ee),ee}K.logService.trace(`${se} 2/6. socketFactory.connect() was successful.`);let V,x;K.reconnectionProtocol?(K.reconnectionProtocol.beginAcceptReconnection(Z,null),V=K.reconnectionProtocol,x=!1):(V=new k.$8h({socket:Z}),x=!0),K.logService.trace(`${se} 3/6. sending AuthRequest control message.`);const U=await t(K.signService.createNewMessage((0,y.$Dg)()),_),re={type:"auth",auth:K.connectionToken||"00000000000000000000",data:U.data};V.sendControl(j.$ue.fromString(JSON.stringify(re)));try{const ee=await d(V,f(_,$(1e4)));if(ee.type!=="sign"||typeof ee.data!="string"){const ke=new Error("Unexpected handshake message");throw ke.code="VSCODE_CONNECTION_ERROR",ke}if(K.logService.trace(`${se} 4/6. received SignRequest control message.`),!await t(K.signService.validate(U,ee.signedData),_)){const ke=new Error("Refused to connect to unsupported server");throw ke.code="VSCODE_CONNECTION_ERROR",ke}const me=await t(K.signService.sign(ee.data),_),ve={type:"connectionType",commit:K.commit,signedData:me,desiredConnectionType:O};return N&&(ve.args=N),K.logService.trace(`${se} 5/6. sending ConnectionTypeRequest control message.`),V.sendControl(j.$ue.fromString(JSON.stringify(ve))),{protocol:V,ownsProtocol:x}}catch(ee){throw ee&&ee.code==="ETIMEDOUT"&&(K.logService.error(`${se} the handshake timed out. Error:`),K.logService.error(ee)),ee&&ee.code==="VSCODE_CONNECTION_ERROR"&&(K.logService.error(`${se} received error control message when negotiating connection. Error:`),K.logService.error(ee)),x&&z(V),ee}}async function r(K,O,N,_){const se=Date.now(),Z=ce(K,O),{protocol:V,ownsProtocol:x}=await o(K,O,N,_),U=new l(_);return U.registerDisposable(V.onControlMessage(re=>{const ee=JSON.parse(re.toString()),fe=M(ee);fe?(K.logService.error(`${Z} received error control message when negotiating connection. Error:`),K.logService.error(fe),x&&z(V),U.reject(fe)):(K.reconnectionProtocol?.endAcceptReconnection(),K.logService.trace(`${Z} 6/6. handshake finished, connection is up and running after ${he(se)}!`),U.resolve({protocol:V,firstMessage:ee}))})),U.promise}async function i(K,O){const{protocol:N}=await r(K,1,void 0,O);return{protocol:N}}async function s(K,O,N){const{protocol:_,firstMessage:se}=await r(K,2,O,N),Z=se&&se.debugPort;return{protocol:_,debugPort:Z}}async function u(K,O,N){const _=Date.now(),se=ce(K,3),{protocol:Z}=await o(K,3,O,N);return K.logService.trace(`${se} 6/6. handshake finished, connection is up and running after ${he(_)}!`),Z}async function b(K,O,N){const{connectTo:_,connectionToken:se}=await K.addressProvider.getAddress();return{commit:K.commit,quality:K.quality,connectTo:_,connectionToken:se,reconnectionToken:O,reconnectionProtocol:N,remoteSocketFactoryService:K.remoteSocketFactoryService,signService:K.signService,logService:K.logService}}async function I(K,O,N){return R(K,async _=>{const{protocol:se}=await i(_,P.CancellationToken.None);return new X(K,O,N,_.reconnectionToken,se)})}async function D(K,O){return R(K,async N=>{const{protocol:_,debugPort:se}=await s(N,O,P.CancellationToken.None);return new Q(K,O,N.reconnectionToken,_,se)})}async function R(K,O){for(let _=1;;_++)try{const se=(0,y.$Dg)(),Z=await b(K,se,null);return await O(Z)}catch(se){if(_<5)K.logService.error(`[remote-connection][attempt ${_}] An error occurred in initial connection! Will retry... Error:`),K.logService.error(se);else throw K.logService.error(`[remote-connection][attempt ${_}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),K.logService.error(se),ue.triggerPermanentFailure(0,0,g.$vl.isHandled(se)),se}}async function C(K,O,N){const _=await b(K,(0,y.$Dg)(),null);return await u(_,{host:O,port:N},P.CancellationToken.None)}function A(K){return(0,n.$7g)(O=>new Promise((N,_)=>{const se=setTimeout(N,K*1e3);O.onCancellationRequested(()=>{clearTimeout(se),N()})}))}var L;(function(K){K[K.ConnectionLost=0]="ConnectionLost",K[K.ReconnectionWait=1]="ReconnectionWait",K[K.ReconnectionRunning=2]="ReconnectionRunning",K[K.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",K[K.ConnectionGain=4]="ConnectionGain"})(L||(e.PersistentConnectionEventType=L={}));class W{constructor(O,N){this.reconnectionToken=O,this.millisSinceLastIncomingData=N,this.type=0}}e.$El=W;class q{constructor(O,N,_,se){this.reconnectionToken=O,this.millisSinceLastIncomingData=N,this.durationSeconds=_,this.c=se,this.type=1}skipWait(){this.c.cancel()}}e.$Fl=q;class H{constructor(O,N,_){this.reconnectionToken=O,this.millisSinceLastIncomingData=N,this.attempt=_,this.type=2}}e.$Gl=H;class le{constructor(O,N,_){this.reconnectionToken=O,this.millisSinceLastIncomingData=N,this.attempt=_,this.type=4}}e.$Hl=le;class te{constructor(O,N,_,se){this.reconnectionToken=O,this.millisSinceLastIncomingData=N,this.attempt=_,this.handled=se,this.type=3}}e.$Il=te;class ue extends E.$Uc{static triggerPermanentFailure(O,N,_){this._permanentFailure=!0,this.f=O,this.g=N,this.h=_,this.j.forEach(se=>se.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(O=>O.y())}static debugPauseSocketWriting(){this.j.forEach(O=>O.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||ue._permanentFailure}constructor(O,N,_,se,Z){super(),this.t=O,this.u=N,this.reconnectionToken=_,this.protocol=se,this.w=Z,this.m=this.B(new S.$7d),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new le(this.reconnectionToken,0,0)),this.B(se.onSocketClose(V=>{const x=T(this.t,this.reconnectionToken,!0);V?V.type===0?(this.u.logService.info(`${x} received socket close event (hadError: ${V.hadError}).`),V.error&&this.u.logService.error(V.error)):(this.u.logService.info(`${x} received socket close event (wasClean: ${V.wasClean}, code: ${V.code}, reason: ${V.reason}).`),V.event&&this.u.logService.error(V.event)):this.u.logService.info(`${x} received socket close event.`),this.y()})),this.B(se.onSocketTimeout(V=>{const x=T(this.t,this.reconnectionToken,!0);this.u.logService.info(`${x} received socket timeout event (unacknowledgedMsgCount: ${V.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${V.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${V.timeSinceLastReceivedSomeData}).`),this.y()})),ue.j.push(this),this.B((0,E.$Sc)(()=>{const V=ue.j.indexOf(this);V>=0&&ue.j.splice(V,1)})),this.n&&this.D(ue.f,ue.g,ue.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const O=T(this.t,this.reconnectionToken,!0);this.u.logService.info(`${O} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new W(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const N=[0,5,5,10,10,10,10,10,30];let _=-1;do{_++;const se=_<N.length?N[_]:N[N.length-1];try{if(se>0){const V=A(se);this.m.fire(new q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),se,V)),this.u.logService.info(`${O} waiting for ${se} seconds before reconnecting...`);try{await V}catch{}}if(this.n){this.u.logService.error(`${O} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new H(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),_+1)),this.u.logService.info(`${O} resolving connection...`);const Z=await b(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${O} connecting to ${Z.connectTo}...`),await this.G(Z,$(m)),this.u.logService.info(`${O} reconnected!`),this.m.fire(new le(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),_+1));break}catch(Z){if(Z.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${O} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(Z),this.C(this.protocol.getMillisSinceLastIncomingData(),_+1,!1);break}if(_>360){this.u.logService.error(`${O} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(Z),this.C(this.protocol.getMillisSinceLastIncomingData(),_+1,!1);break}if(g.$vl.isTemporarilyNotAvailable(Z)){this.u.logService.info(`${O} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(Z);continue}if((Z.code==="ETIMEDOUT"||Z.code==="ENETUNREACH"||Z.code==="ECONNREFUSED"||Z.code==="ECONNRESET")&&Z.syscall==="connect"){this.u.logService.info(`${O} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(Z);continue}if((0,B.$4)(Z)){this.u.logService.info(`${O} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(Z);continue}if(Z instanceof g.$vl){this.u.logService.error(`${O} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(Z),this.C(this.protocol.getMillisSinceLastIncomingData(),_+1,g.$vl.isHandled(Z));break}this.u.logService.error(`${O} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(Z),this.C(this.protocol.getMillisSinceLastIncomingData(),_+1,!1);break}}while(!this.n&&!this.s)}C(O,N,_){this.w?ue.triggerPermanentFailure(O,N,_):this.D(O,N,_)}D(O,N,_){this.m.fire(new te(this.reconnectionToken,O,N,_)),z(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$Jl=ue;class X extends ue{constructor(O,N,_,se,Z){super(1,O,se,Z,!0),this.client=this.B(new k.$6h(Z,{remoteAuthority:N,clientId:_},O.ipcLogger))}async G(O,N){await i(O,N)}}e.$Kl=X;class Q extends ue{constructor(O,N,_,se,Z){super(2,O,_,se,!1),this.H=N,this.debugPort=Z}async G(O,N){await s(O,this.H,N)}}e.$Ll=Q;function z(K){try{K.acceptDisconnect();const O=K.getSocket();K.dispose(),O.dispose()}catch(O){(0,B.$1)(O)}}function M(K){if(K&&K.type==="error"){const O=new Error(`Connection error: ${K.reason}`);return O.code="VSCODE_CONNECTION_ERROR",O}return null}function F(K,O){for(;K.length<O;)K+=" ";return K}function G(K,O){return`[remote-connection][${F(w(K),13)}][${O.substr(0,5)}\u2026]`}function T(K,O,N){return`${G(K,O)}[${N?"reconnect":"initial"}]`}function ce(K,O){return`${T(O,K.reconnectionToken,!!K.reconnectionProtocol)}[${K.connectTo}]`}function he(K){return`${Date.now()-K} ms`}}),define(oe[68],ae([0,1,13]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sm=j,e.$tm=P,e.$um=B,e.$vm=S;function j(h){return h.scheme===n.Schemas.vscodeRemote?h.authority:void 0}function P(h){if(!h)return;const c=h.indexOf("+");return c<0?h:h.substr(0,c)}function B(h){const{host:c,port:p}=E(h);if(typeof p>"u")throw new Error(`Invalid remote authority: ${h}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:c,port:p}}function S(h,c){let{host:p,port:y}=E(h);return typeof y>"u"&&(y=c),{host:p,port:y}}function E(h){const c=h.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(c)return{host:c[1],port:parseInt(c[2],10)};const p=h.match(/^(\[[0-9a-z:]+\])$/);if(p)return{host:p[1],port:void 0};const y=h.match(/(.*):(\d+)$/);return y?{host:y[1],port:parseInt(y[2],10)}:{host:h,port:void 0}}}),define(oe[124],ae([0,1,25,6,68]),function(J,e,n,j,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jm=e.$Em=e.$Dm=e.$Cm=e.TargetPlatform=e.ExtensionType=e.$Bm=e.$zm=e.$ym=e.$xm=e.$wm=void 0,e.$Am=B,e.$Fm=y,e.$Gm=k,e.$Hm=g,e.$Im=m,e.$wm="extensions.user.cache",e.$xm="extensions.builtin.cache",e.$ym="undefined_publisher",e.$zm=["ui","workspace","web"];function B(v){if(typeof v=="object"&&v!==null&&v.supported!==!0)return v.description}e.$Bm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var S;(function(v){v[v.System=0]="System",v[v.User=1]="User"})(S||(e.ExtensionType=S={}));var E;(function(v){v.WIN32_X64="win32-x64",v.WIN32_ARM64="win32-arm64",v.LINUX_X64="linux-x64",v.LINUX_ARM64="linux-arm64",v.LINUX_ARMHF="linux-armhf",v.ALPINE_X64="alpine-x64",v.ALPINE_ARM64="alpine-arm64",v.DARWIN_X64="darwin-x64",v.DARWIN_ARM64="darwin-arm64",v.WEB="web",v.UNIVERSAL="universal",v.UNKNOWN="unknown",v.UNDEFINED="undefined"})(E||(e.TargetPlatform=E={}));class h{constructor(w){this.value=w,this._lower=w.toLowerCase()}static equals(w,$){if(typeof w>"u"||w===null)return typeof $>"u"||$===null;if(typeof $>"u"||$===null)return!1;if(typeof w=="string"||typeof $=="string"){const f=typeof w=="string"?w:w.value,l=typeof $=="string"?$:$.value;return n.$lf(f,l)}return w._lower===$._lower}static toKey(w){return typeof w=="string"?w.toLowerCase():w._lower}}e.$Cm=h;class c{get size(){return this.c.size}constructor(w){if(this.c=new Set,w)for(const $ of w)this.add($)}add(w){this.c.add(h.toKey(w))}delete(w){return this.c.delete(h.toKey(w))}has(w){return this.c.has(h.toKey(w))}}e.$Dm=c;class p{constructor(){this.c=new Map}clear(){this.c.clear()}delete(w){this.c.delete(h.toKey(w))}get(w){return this.c.get(h.toKey(w))}has(w){return this.c.has(h.toKey(w))}set(w,$){this.c.set(h.toKey(w),$)}values(){return this.c.values()}forEach(w){this.c.forEach(w)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Em=p;function y(v){return k(v)}function k(v){return v.contributes&&v.contributes.localizations?v.contributes.localizations.length>0:!1}function g(v){return v.contributes&&v.contributes.authentication?v.contributes.authentication.length>0:!1}function m(v,w){if(w){const $=`onResolveRemoteAuthority:${(0,P.$tm)(w)}`;return!!v.activationEvents?.includes($)}return!1}e.$Jm=(0,j.$hi)("IBuiltinExtensionsScannerService")}),define(oe[246],ae([0,1,2,6]),function(J,e,n,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yl=e.$xl=void 0,e.$xl=(0,j.$hi)("remoteSocketFactoryService");class P{constructor(){this.a={}}register(S,E){return this.a[S]??=[],this.a[S].push(E),(0,n.$Sc)(()=>{const h=this.a[S]?.indexOf(E);typeof h=="number"&&h>=0&&this.a[S]?.splice(h,1)})}b(S){return(this.a[S.type]||[]).find(h=>h.supports(S))}connect(S,E,h,c){const p=this.b(S);if(!p)throw new Error(`No socket factory found for ${S}`);return p.connect(S,E,h,c)}}e.$yl=P}),define(oe[247],ae([0,1,26,49,21,117]),function(J,e,n,j,P,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wac=E;let S;async function E(g=!1){return(S===void 0||g)&&(S=h()),S}async function h(){const g=c();if(g===void 0)return!1;if(g>=22e3){const m=y();if(m)return new Promise(v=>{j.execFile(m,["--status"],w=>v(!w))})}else{const m=k();if(m)try{if((await P.Promises.stat(m)).isFile())return!0}catch{}}return!1}function c(){const g=/(\d+)\.(\d+)\.(\d+)/g.exec(n.release());if(g)return parseInt(g[3])}function p(g){const m=process.env.SystemRoot;if(m){const v=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return B.join(m,v?"Sysnative":"System32",g)}}function y(){return p("wsl.exe")}function k(){return p("lxss\\LxssManager.dll")}}),define(oe[53],ae([0,1,17,15,2,186,52,6,5,45]),function(J,e,n,j,P,B,S,E,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zp=e.$yp=void 0,e.$Ap=k,e.$Bp=g,e.$Cp=m,e.$Dp=v,e.$Ep=w,e.$Fp=$,e.$yp=(0,E.$hi)("requestService");class p{constructor(a){this.b=a}toJSON(){if(!this.a){const a=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?a[t]="*****":a[t]=this.b[t];this.a=a}return this.a}}class y extends P.$Uc{constructor(a){super(),this.b=0,this.a=a.createLogger("network",{name:(0,B.localize)(0,null),when:h.$6j.isEqualTo((0,h.$3j)(h.LogLevel.Trace)).serialize()})}async c(a,t,o){const r=`${a} #${++this.b}: ${t.url}`;this.a.trace(`${r} - begin`,t.type,new p(t.headers??{}));try{const i=await o();return this.a.trace(`${r} - end`,t.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.a.error(`${r} - error`,t.type,(0,j.$0)(i)),i}}}e.$zp=y;function k(d){return d.res.statusCode&&d.res.statusCode>=200&&d.res.statusCode<300||d.res.statusCode===1223}function g(d){return d.res.statusCode===204}async function m(d){return g(d)?null:(await(0,n.$Ge)(d.stream)).toString()}async function v(d){if(!k(d))throw new Error("Server returned "+d.res.statusCode);return m(d)}async function w(d){if(!k(d))throw new Error("Server returned "+d.res.statusCode);if(g(d))return null;const t=(await(0,n.$Ge)(d.stream)).toString();try{return JSON.parse(t)}catch(o){throw o.message+=`:
`+t,o}}function $(d){l(d)}let f;function l(d){const a=c.$Zn.as(S.$5n.Configuration),t=f;f={id:"http",order:15,title:(0,B.localize)(1,null),type:"object",scope:d,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,B.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,B.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,B.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,B.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,B.localize)(6,null),(0,B.localize)(7,null),(0,B.localize)(8,null),(0,B.localize)(9,null)],default:"override",description:(0,B.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,B.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,B.localize)(12,null),restricted:!0}}},a.updateConfigurations({add:[f],remove:t?[t]:[]})}l(1)}),define(oe[248],ae([0,1,17,23]),function(J,e,n,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Er=e.$Dr=void 0;class P{constructor(E){this.a=E}listen(E,h){throw new Error("Invalid listen")}call(E,h,c,p=j.CancellationToken.None){switch(h){case"request":return this.a.request(c[0],p).then(async({res:y,stream:k})=>{const g=await(0,n.$Ge)(k);return[{statusCode:y.statusCode,headers:y.headers},g]});case"resolveProxy":return this.a.resolveProxy(c[0]);case"loadCertificates":return this.a.loadCertificates()}throw new Error("Invalid call")}}e.$Dr=P;class B{constructor(E){this.a=E}async request(E,h){const[c,p]=await this.a.call("request",[E],h);return{res:c,stream:(0,n.$Ie)(p)}}async resolveProxy(E){return this.a.call("resolveProxy",[E])}async loadCertificates(){return this.a.call("loadCertificates")}}e.$Er=B}),define(oe[249],ae([0,1,250,12]),function(J,e,n,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fr=B;function P(S,E){return S.protocol==="http:"?E.HTTP_PROXY||E.http_proxy||null:S.protocol==="https:"&&(E.HTTPS_PROXY||E.https_proxy||E.HTTP_PROXY||E.http_proxy)||null}async function B(S,E,h={}){const c=(0,n.parse)(S),p=h.proxyUrl||P(c,E);if(!p)return null;const y=(0,n.parse)(p);if(!/^https?:$/.test(y.protocol||""))return null;const k={host:y.hostname||"",port:(y.port?+y.port:0)||(y.protocol==="https"?443:80),auth:y.auth,rejectUnauthorized:(0,j.$1f)(h.strictSSL)?h.strictSSL:!0};return c.protocol==="http:"?new(await new Promise((g,m)=>{J(["http-proxy-agent"],g,m)})).HttpProxyAgent(p,k):new(await new Promise((g,m)=>{J(["https-proxy-agent"],g,m)})).HttpsProxyAgent(p,k)}}),define(oe[251],ae([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sac=e.$Rac=e.$Qac=void 0,e.$Qac={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$Rac={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$Sac={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(oe[95],ae([0,1,49,9,187,23,47,15,4,33,112,64,8,141]),function(J,e,n,j,P,B,S,E,h,c,p,y,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rm=v;let m;async function v($,f,l,d){return l["force-disable-user-env"]?(f.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):h.$i?(f.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,y.$lm)(d)&&!l["force-user-env"]?(f.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,y.$lm)(d)?f.trace("resolveShellEnv(): running (--force-user-env)"):f.trace("resolveShellEnv(): running (macOS/Linux)"),m||(m=k.Promises.withAsyncBody(async(a,t)=>{const o=new B.$ee;let r=1e4;const i=$.getValue("application.shellEnvironmentResolutionTimeout");typeof i=="number"&&(r=(0,g.$mm)(i,1,120)*1e3);const s=setTimeout(()=>{o.dispose(!0),t(new Error((0,P.localize)(0,null)))},r);try{a(await w(f,o.token))}catch(u){!(0,E.$4)(u)&&!o.token.isCancellationRequested?t(new Error((0,P.localize)(1,null,(0,S.$5i)(u)))):a({})}finally{clearTimeout(s),o.dispose()}})),m)}async function w($,f){const l=process.env.ELECTRON_RUN_AS_NODE;$.trace("getUnixShellEnvironment#runAsNode",l);const d=process.env.ELECTRON_NO_ATTACH_CONSOLE;$.trace("getUnixShellEnvironment#noAttach",d);const a=(0,c.$Dg)().replace(/-/g,"").substr(0,12),t=new RegExp(a+"({.*})"+a),o={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};$.trace("getUnixShellEnvironment#env",o);const r=await(0,p.$bm)(h.OS,o);return $.trace("getUnixShellEnvironment#shell",r),new Promise((i,s)=>{if(f.isCancellationRequested)return s(new E.$5);const u=(0,j.$oc)(r);let b,I;const D="";/^pwsh(-preview)?$/.test(u)?(b=`& '${process.execPath}' ${D} -p '''${a}'' + JSON.stringify(process.env) + ''${a}'''`,I=["-Login","-Command"]):u==="nu"?(b=`^'${process.execPath}' ${D} -p '"${a}" + JSON.stringify(process.env) + "${a}"'`,I=["-i","-l","-c"]):u==="xonsh"?(b=`import os, json; print("${a}", json.dumps(dict(os.environ)), "${a}")`,I=["-i","-l","-c"]):(b=`'${process.execPath}' ${D} -p '"${a}" + JSON.stringify(process.env) + "${a}"'`,u==="tcsh"||u==="csh"?I=["-ic"]:I=["-i","-l","-c"]),$.trace("getUnixShellEnvironment#spawn",JSON.stringify(I),b);const R=(0,n.spawn)(r,[...I,b],{detached:!0,stdio:["ignore","pipe","pipe"],env:o});f.onCancellationRequested(()=>(R.kill(),s(new E.$5))),R.on("error",L=>{$.error("getUnixShellEnvironment#errorChildProcess",(0,S.$5i)(L)),s(L)});const C=[];R.stdout.on("data",L=>C.push(L));const A=[];R.stderr.on("data",L=>A.push(L)),R.on("close",(L,W)=>{const q=Buffer.concat(C).toString("utf8");$.trace("getUnixShellEnvironment#raw",q);const H=Buffer.concat(A).toString("utf8");if(H.trim()&&$.trace("getUnixShellEnvironment#stderr",H),L||W)return s(new Error((0,P.localize)(2,null,L,W)));const le=t.exec(q),te=le?le[1]:"{}";try{const ue=JSON.parse(te);l?ue.ELECTRON_RUN_AS_NODE=l:delete ue.ELECTRON_RUN_AS_NODE,d?ue.ELECTRON_NO_ATTACH_CONSOLE=d:delete ue.ELECTRON_NO_ATTACH_CONSOLE,delete ue.VSCODE_RESOLVING_ENVIRONMENT,delete ue.XDG_RUNTIME_DIR,$.trace("getUnixShellEnvironment#result",ue),i(ue)}catch(ue){$.error("getUnixShellEnvironment#errorCaught",(0,S.$5i)(ue)),s(ue)}})})}}),define(oe[252],ae([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K9b=void 0;class n{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(P){try{const B=await this.c();if(B){const S=String(n.a++);return this.b.set(S,B),{id:S,data:B.createNewMessage(P)}}}catch{}return{id:"",data:P}}async validate(P,B){if(!P.id)return!0;const S=this.b.get(P.id);if(!S)return!1;this.b.delete(P.id);try{return S.validate(B)==="ok"}catch{return!1}finally{S.dispose?.()}}async sign(P){try{return await this.d(P)}catch{}return P}}e.$K9b=n}),define(oe[96],ae([0,1,6]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Al=e.$zl=void 0,e.$zl="signService",e.$Al=(0,n.$hi)(e.$zl)}),define(oe[253],ae([0,1,252]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gbc=void 0;class j extends n.$K9b{c(){return this.h().then(B=>new B.validator)}d(B){return this.h().then(S=>new S.signer().sign(B))}h(){return new Promise((B,S)=>J(["vsda"],B,S))}}e.$Gbc=j}),define(oe[34],ae([0,1,6]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UP=e.$TP=void 0,e.$TP=(0,n.$hi)("stateReadService"),e.$UP=(0,n.$hi)("stateService")}),define(oe[125],ae([0,1,8,17,2,12,38,16,5]),function(J,e,n,j,P,B,S,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XP=e.$WP=e.$VP=e.SaveStrategy=void 0;var c;(function(g){g[g.IMMEDIATE=0]="IMMEDIATE",g[g.DELAYED=1]="DELAYED"})(c||(e.SaveStrategy=c={}));class p extends P.$Uc{constructor(m,v,w,$){super(),this.h=m,this.j=v,this.m=w,this.n=$,this.a=Object.create(null),this.b="",this.c=this.B(new n.$fh(this.j===0?0:100)),this.f=void 0,this.g=void 0}init(){return this.f||(this.f=this.r()),this.f}async r(){try{this.b=(await this.n.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(m){m.fileOperationResult!==1&&this.m.error(m)}}getItem(m,v){const w=this.a[m];return(0,B.$4f)(w)?v:w}setItem(m,v){this.setItems([{key:m,data:v}])}setItems(m){let v=!1;for(const{key:w,data:$}of m)this.a[w]!==$&&((0,B.$4f)($)?(0,B.$2f)(this.a[w])||(this.a[w]=void 0,v=!0):(this.a[w]=$,v=!0));v&&this.s()}removeItem(m){(0,B.$2f)(this.a[m])||(this.a[m]=void 0,this.s())}async s(){if(!this.g)return this.c.trigger(()=>this.t())}async t(){if(!this.f)return;await this.f;const m=JSON.stringify(this.a,null,4);if(m!==this.b)try{await this.n.writeFile(this.h,j.$ue.fromString(m),{atomic:{postfix:".vsctmp"}}),this.b=m}catch(v){this.m.error(v)}}async close(){return this.g||(this.g=this.c.trigger(()=>this.t(),0)),this.g}}e.$VP=p;let y=class extends P.$Uc{constructor(m,v,w,$){super(),this.a=this.B(new p(v.stateResource,m,w,$))}async init(){await this.a.init()}getItem(m,v){return this.a.getItem(m,v)}};e.$WP=y,e.$WP=y=Ee([ne(1,S.$oi),ne(2,h.$Nj),ne(3,E.$Nk)],y);class k extends y{setItem(m,v){this.a.setItem(m,v)}setItems(m){this.a.setItems(m)}removeItem(m){this.a.removeItem(m)}close(){return this.a.close()}}e.$XP=k}),define(oe[126],ae([0,1,4,36,33]),function(J,e,n,j,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1o=S,e.$2o=E;function B(h){if(n.$u===2&&/^penguin(\.|$)/i.test(h))return"chromebook"}function S(h,c,p,y,k,g,m,v,w){const $=Object.create(null);$["common.machineId"]=g,$["common.sqmId"]=m,$.sessionID=(0,P.$Dg)()+Date.now(),$.commitHash=y,$.version=k,$["common.platformVersion"]=(h||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),$["common.platform"]=(0,n.$h)(n.$u),$["common.nodePlatform"]=j.$ec,$["common.nodeArch"]=p,$["common.product"]=w||"desktop",v&&($["common.msftInternal"]=v);let f=0;const l=Date.now();Object.defineProperties($,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-l,enumerable:!0},"common.sequence":{get:()=>f++,enumerable:!0}}),n.$l&&($["common.snap"]="true");const d=B(c);return d&&($["common.platformDetail"]=d),$}function E(h){const c=j.env.USERDNSDOMAIN;if(!c)return!1;const p=c.toLowerCase();return h.some(y=>p===y)}}),define(oe[28],ae([0,1,6]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$Wl=e.$Vl=e.$Ul=e.$Tl=e.$Sl=e.$Rl=e.$Ql=e.$Pl=e.$Ol=e.$Nl=e.$Ml=void 0,e.$Ml=(0,n.$hi)("telemetryService"),e.$Nl=(0,n.$hi)("customEndpointTelemetryService"),e.$Ol="telemetry.currentSessionDate",e.$Pl="telemetry.firstSessionDate",e.$Ql="telemetry.lastSessionDate",e.$Rl="telemetry.machineId",e.$Sl="telemetry.sqmId",e.$Tl="telemetry",e.$Ul="telemetry.telemetryLevel",e.$Vl="telemetry.enableCrashReporter",e.$Wl="telemetry.enableTelemetry";var j;(function(B){B[B.NONE=0]="NONE",B[B.CRASH=1]="CRASH",B[B.ERROR=2]="ERROR",B[B.USAGE=3]="USAGE"})(j||(e.TelemetryLevel=j={}));var P;(function(B){B.OFF="off",B.CRASH="crash",B.ERROR="error",B.ON="all"})(P||(e.TelemetryConfiguration=P={}))}),define(oe[254],ae([0,1,26,8,42,13,9,4,7,89,21,111,92,16,27,28]),function(J,e,n,j,P,B,S,E,h,c,p,y,k,g,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ps=void 0,e.$ms=$,e.$ns=l,e.$os=d;const w=new Map;async function $(t,o){const r=`${t}::${o.join(":")}`,i=w.get(r);if(i)return i;const s=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],u=new Map,b=new Map,I=2e4;function D(C,A,L,W){const q=A.substring(C.length+1);return j.Promises.withAsyncBody(async H=>{let le;try{le=await p.Promises.readdir(A,{withFileTypes:!0})}catch{H();return}if(W.count>=I){W.count+=le.length,W.maxReached=!0,H();return}let te=le.length;if(te===0){H();return}let ue=le;W.count+le.length>I&&(W.maxReached=!0,te=I-W.count,ue=le.slice(0,te)),W.count+=le.length;for(const X of ue)if(X.isDirectory()){if(L.includes(X.name)||await D(C,(0,S.$kc)(A,X.name),L,W),--te===0){H();return}}else{const Q=X.name.lastIndexOf(".");if(Q>=0){const z=X.name.substring(Q+1);z&&u.set(z,(u.get(z)??0)+1)}for(const z of s)z.relativePathPattern?.test(q)!==!1&&z.filePattern.test(X.name)&&b.set(z.tag,(b.get(z.tag)??0)+1);if(--te===0){H();return}}})}const R=j.Promises.withAsyncBody(async C=>{const A={count:0,maxReached:!1};await D(t,t,o,A);const L=await d(t);C({configFiles:f(b),fileTypes:f(u),fileCount:A.count,maxFilesReached:A.maxReached,launchConfigFiles:L})});return w.set(r,R),R}function f(t){return Array.from(t.entries(),([o,r])=>({name:o,count:r})).sort((o,r)=>r.count-o.count)}function l(){const t={os:`${n.type()} ${n.arch()} ${n.release()}`,memory:`${(n.totalmem()/g.$jl.GB).toFixed(2)}GB (${(n.freemem()/g.$jl.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(c.$pn.value()*100)}%`},o=n.cpus();return o&&o.length>0&&(t.cpus=`${o[0].model} (${o.length} x ${o[0].speed})`),t}async function d(t){try{const o=new Map,r=(0,S.$kc)(t,".vscode","launch.json"),i=await p.Promises.readFile(r),s=[],u=(0,P.$un)(i.toString(),s);if(s.length)return console.log(`Unable to parse ${r}`),[];if((0,P.$Dn)(u)==="object"&&u.configurations)for(const b of u.configurations){const I=b.type;I&&(o.has(I)?o.set(I,o.get(I)+1):o.set(I,1))}return f(o)}catch{return[]}}let a=class{constructor(o,r){this.c=o,this.d=r}f(o){const r=[];return r.push(`OS Version:       ${o.os}`),r.push(`CPUs:             ${o.cpus}`),r.push(`Memory (System):  ${o.memory}`),r.push(`VM:               ${o.vmHint}`),r.join(`
`)}g(o){const r=[];r.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),r.push(`OS Version:       ${n.type()} ${n.arch()} ${n.release()}`);const i=n.cpus();return i&&i.length>0&&r.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),r.push(`Memory (System):  ${(n.totalmem()/g.$jl.GB).toFixed(2)}GB (${(n.freemem()/g.$jl.GB).toFixed(2)}GB free)`),E.$i||r.push(`Load (avg):       ${n.loadavg().map(s=>Math.round(s)).join(", ")}`),r.push(`VM:               ${Math.round(c.$pn.value()*100)}%`),r.push(`Screen Reader:    ${o.screenReader?"yes":"no"}`),r.push(`Process Argv:     ${o.mainArguments.join(" ")}`),r.push(`GPU Status:       ${this.j(o.gpuFeatureStatus)}`),r.join(`
`)}async getPerformanceInfo(o,r){return Promise.all([(0,y.$ls)(o.mainPID),this.k(o)]).then(async i=>{let[s,u]=i,b=this.m(o,s);return r.forEach(I=>{if((0,k.$2m)(I))b+=`
${I.errorMessage}`,u+=`
${I.errorMessage}`;else if(b+=`

Remote: ${I.hostName}`,I.processes&&(b+=`
${this.m(o,I.processes)}`),I.workspaceMetadata){u+=`
|  Remote: ${I.hostName}`;for(const D of Object.keys(I.workspaceMetadata)){const R=I.workspaceMetadata[D];let C=`${R.fileCount} files`;R.maxFilesReached&&(C=`more than ${C}`),u+=`|    Folder (${D}): ${C}`,u+=this.h(R)}}}),{processInfo:b,workspaceInfo:u}})}async getSystemInfo(o,r){const{memory:i,vmHint:s,os:u,cpus:b}=l(),I={os:u,memory:i,cpus:b,vmHint:s,processArgs:`${o.mainArguments.join(" ")}`,gpuStatus:o.gpuFeatureStatus,screenReader:`${o.screenReader?"yes":"no"}`,remoteData:r};return E.$i||(I.load=`${n.loadavg().map(D=>Math.round(D)).join(", ")}`),E.$k&&(I.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(I)}async getDiagnostics(o,r){const i=[];return(0,y.$ls)(o.mainPID).then(async s=>(i.push(""),i.push(this.g(o)),i.push(""),i.push(this.m(o,s)),o.windows.some(u=>u.folderURIs&&u.folderURIs.length>0&&!u.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.k(o))),r.forEach(u=>{if((0,k.$2m)(u))i.push(`
${u.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${u.hostName}`),i.push(this.f(u.machineInfo)),u.processes&&i.push(this.m(o,u.processes)),u.workspaceMetadata)for(const b of Object.keys(u.workspaceMetadata)){const I=u.workspaceMetadata[b];let D=`${I.fileCount} files`;I.maxFilesReached&&(D=`more than ${D}`),i.push(`Folder (${b}): ${D}`),i.push(this.h(I))}}),i.push(""),i.push(""),i.join(`
`)))}h(o){const r=[];let s=0;const u=(R,C)=>{const A=` ${R}(${C})`;s+A.length>60?(r.push(b),b="|                 ",s=b.length):s+=A.length,b+=A};let b="|      File types:";const I=10,D=o.fileTypes.length>I?I:o.fileTypes.length;for(let R=0;R<D;R++){const C=o.fileTypes[R];u(C.name,C.count)}if(r.push(b),o.configFiles.length>=0&&(b="|      Conf files:",s=0,o.configFiles.forEach(R=>{u(R.name,R.count)}),r.push(b)),o.launchConfigFiles.length>0){let R="|      Launch Configs:";o.launchConfigFiles.forEach(C=>{const A=C.count>1?` ${C.name}(${C.count})`:` ${C.name}`;R+=A}),r.push(R)}return r.join(`
`)}j(o){const r=Math.max(...Object.keys(o).map(i=>i.length));return Object.keys(o).map(i=>`${i}:  ${" ".repeat(r-i.length)}  ${o[i]}`).join(`
                  `)}k(o){const r=[],i=[];return o.windows.forEach(s=>{s.folderURIs.length===0||s.remoteAuthority||(r.push(`|  Window (${s.title})`),s.folderURIs.forEach(u=>{const b=h.URI.revive(u);if(b.scheme===B.Schemas.file){const I=b.fsPath;i.push($(I,["node_modules",".git"]).then(D=>{let R=`${D.fileCount} files`;D.maxFilesReached&&(R=`more than ${R}`),r.push(`|    Folder (${(0,S.$oc)(I)}): ${R}`),r.push(this.h(D))}).catch(D=>{r.push(`|      Error: Unable to collect workspace stats for folder ${I} (${D.toString()})`)}))}else r.push(`|    Folder (${b.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(s=>r.join(`
`)).catch(s=>`Unable to collect workspace stats: ${s}`)}m(o,r){const i=new Map;o.windows.forEach(u=>i.set(u.pid,`window [${u.id}] (${u.title})`)),o.pidToNames.forEach(({pid:u,name:b})=>i.set(u,b));const s=[];return s.push("CPU %	Mem MB	   PID	Process"),r&&this.n(o.mainPID,i,s,r,0),s.join(`
`)}n(o,r,i,s,u){const b=u===0;let I;b?I=s.pid===o?`${this.d.applicationName} main`:"remote agent":r.has(s.pid)?I=r.get(s.pid):I=`${"  ".repeat(u)} ${s.name}`;const D=process.platform==="win32"?s.mem:n.totalmem()*(s.mem/100);i.push(`${s.load.toFixed(0).padStart(5," ")}	${(D/g.$jl.MB).toFixed(0).padStart(6," ")}	${s.pid.toFixed(0).padStart(6," ")}	${I}`),Array.isArray(s.children)&&s.children.forEach(R=>this.n(o,r,i,R,u+1))}async getWorkspaceFileExtensions(o){const r=new Set;for(const{uri:i}of o.folders){const s=h.URI.revive(i);if(s.scheme!==B.Schemas.file)continue;const u=s.fsPath;try{(await $(u,["node_modules",".git"])).fileTypes.forEach(I=>r.add(I.name))}catch{}}return{extensions:[...r]}}async reportWorkspaceStats(o){for(const{uri:r}of o.folders){const i=h.URI.revive(r);if(i.scheme!==B.Schemas.file)continue;const s=i.fsPath;try{const u=await $(s,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":o.telemetryId,rendererSessionId:o.rendererSessionId}),u.fileTypes.forEach(b=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:o.rendererSessionId,type:b.name,count:b.count})}),u.launchConfigFiles.forEach(b=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:o.rendererSessionId,type:b.name,count:b.count})}),u.configFiles.forEach(b=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:o.rendererSessionId,type:b.name,count:b.count})})}catch{}}}};e.$ps=a,e.$ps=a=Ee([ne(0,v.$Ml),ne(1,m.$7j)],a)}),define(oe[255],ae([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wac=e.$Vac=void 0;class n{constructor(B){this.b=B}listen(B,S){throw new Error(`Event not found: ${S}`)}call(B,S,{eventName:E,data:h}){return this.b.forEach(c=>c.log(E,h)),Promise.resolve(null)}}e.$Vac=n;class j{constructor(B){this.b=B}log(B,S){return this.b.call("log",{eventName:B,data:S}).then(void 0,E=>`Failed to log telemetry: ${console.warn(E)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$Wac=j}),define(oe[54],ae([0,1,35,12,68,126,28]),function(J,e,n,j,P,B,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=void 0,e.$0o=p,e.$$o=y,e.$_o=k,e.$ap=g,e.$bp=v,e.$cp=$,e.$dp=f,e.$ep=a;class E{constructor(o){this.value=o,this.isTrustedTelemetryValue=!0}}e.$3o=E;class h{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$4o=h,e.$5o=new h;class c{async publicLog(o,r,i){}async publicLogError(o,r,i){}}e.$6o=c,e.$7o="telemetry",e.$8o="extensionTelemetryLog",e.$9o={log:()=>null,flush:()=>Promise.resolve(null)};function p(t,o){return!o.isBuilt&&!o.disableTelemetry?!0:!(o.disableTelemetry||!t.enableTelemetry)}function y(t,o){return o.extensionTestsLocationURI?!0:!(o.isBuilt||o.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}function k(t){const o=t.getValue(S.$Ul),r=t.getValue(S.$Vl);if(t.getValue(S.$Wl)===!1||r===!1)return 0;switch(o??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function g(t){const o={},r={},i={};w(t,i);for(let s in i){s=s.length>150?s.substr(s.length-149):s;const u=i[s];typeof u=="number"?r[s]=u:typeof u=="boolean"?r[s]=u?1:0:typeof u=="string"?(u.length>8192&&console.warn(`Telemetry property: ${s} has been trimmed to 8192, the original length is ${u.length}`),o[s]=u.substring(0,8191)):typeof u<"u"&&u!==null&&(o[s]=u)}return{properties:o,measurements:r}}const m=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function v(t){if(!t)return"none";const o=(0,P.$tm)(t);return m.has(o)?o:"other"}function w(t,o,r=0,i){if(t)for(const s of Object.getOwnPropertyNames(t)){const u=t[s],b=i?i+s:s;Array.isArray(u)?o[b]=(0,n.$Sn)(u):u instanceof Date?o[b]=u.toISOString():(0,j.$Wf)(u)?r<2?w(u,o,r+1,b+"."):o[b]=(0,n.$Sn)(u):o[b]=u}}function $(t,o){const r=t.msftInternalDomains||[],i=o.getValue("telemetry.internalTesting");return(0,B.$2o)(r)||i}function f(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}function l(t,o){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let r=t;const i=[];for(const I of o)for(;;){const D=I.exec(t);if(!D)break;i.push([D.index,I.lastIndex])}const s=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,u=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let b=0;for(r="";;){const I=u.exec(t);if(!I)break;const D=i.some(([R,C])=>I.index<C&&R<u.lastIndex);!s.test(I[0])&&!D&&(r+=t.substring(b,I.index)+"<REDACTED: user-file-path>",b=u.lastIndex)}return b<t.length&&(r+=t.substr(b)),r}function d(t){if(!t)return t;const o=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of o)if(r.regex.test(t))return`<REDACTED: ${r.label}>`;return t}function a(t,o){return(0,n.$Pn)(t,r=>{if(r instanceof E||Object.hasOwnProperty.call(r,"isTrustedTelemetryValue"))return r.value;if(typeof r=="string"){let i=r.replaceAll("%20"," ");i=l(i,o);for(const s of o)i=i.replace(s,"");return i=d(i),i}})}}),define(oe[127],ae([0,1,25,121,124,4,7,15,36,54]),function(J,e,n,j,P,B,S,E,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$op=e.$gp=void 0,e.$fp=p,e.$hp=m,e.$ip=v,e.$jp=w,e.$kp=$,e.$lp=f,e.$mp=l,e.$np=d,e.$pp=a,e.$qp=o;function p(r,i){return r.uuid&&i.uuid?r.uuid===i.uuid:r.id===i.id?!0:(0,n.$gf)(r.id,i.id)===0}const y=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class k{static create(i){const s=i.manifest?i.manifest.version:i.version,u=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new k(i.identifier,s,u)}static parse(i){const s=y.exec(i);return s&&s[1]&&s[2]?new k({id:s[1]},s[2],s[4]||void 0):null}constructor(i,s,u="undefined"){this.version=s,this.targetPlatform=u,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof k?p(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.$gp=k;const g=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function m(r){const i=g.exec(r);return i&&i[1]?[w(i[1]),i[2]]:[w(r),void 0]}function v(r,i){return`${r}.${i}`}function w(r){return r.toLowerCase()}function $(r,i){return w(v(r??P.$ym,i))}function f(r,i){const s=[],u=b=>{for(const I of s)if(I.some(D=>p(i(D),i(b))))return I;return null};for(const b of r){const I=u(b);I?I.push(b):s.push([b])}return s}function l(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}function d(r){return{id:new c.$3o(r.identifier.id),name:new c.$3o(r.name),galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.$op=new P.$Cm("pprice.better-merge");function a(r,i){const s=[],u=i.manifest.extensionDependencies?.slice(0)??[];for(;u.length;){const b=u.shift();if(b&&s.every(I=>!p(I.identifier,{id:b}))){const I=r.filter(D=>p(D.identifier,{id:b}));I.length===1&&(s.push(I[0]),u.push(...I[0].manifest.extensionDependencies?.slice(0)??[]))}}return s}async function t(r,i){if(!B.$k)return!1;let s;try{s=(await r.readFile(S.URI.file("/etc/os-release"))).value.toString()}catch{try{s=(await r.readFile(S.URI.file("/usr/lib/os-release"))).value.toString()}catch(b){i.debug("Error while getting the os-release file.",(0,E.$0)(b))}}return!!s&&(s.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function o(r,i){const s=await t(r,i),u=(0,j.$Mo)(s?"alpine":B.$u,h.$fc);return i.debug("ComputeTargetPlatform:",u),u}}),define(oe[256],ae([0,1,209,54]),function(J,e,n,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sp=P;async function P(B,S,E,h,c,p,y){const k={"X-Market-Client-Id":`VSCode ${B}`,"User-Agent":`VSCode ${B} (${S.nameShort})`};if((0,j.$0o)(S,E)&&(0,j.$_o)(h)===3){const g=await(0,n.$Rp)(E,c,p);k["X-Market-User-Id"]=g,k["VSCode-SessionId"]=y.machineId||g}return k}}),define(oe[257],ae([0,1,2,35,4,25,188,18,52,79,27,45,28,54]),function(J,e,n,j,P,B,S,E,h,c,p,y,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ir=void 0;let m=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor($,f,l){this.k=f,this.l=l,this.d={},this.i=new n.$Tc,this.j=[],this.b=$.appenders,this.c=$.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=$.piiPaths||[],this.g=3,this.h=!!$.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const d of this.f)this.j.push(new RegExp((0,B.$Ze)(d),"gi")),d.indexOf("\\")>=0&&this.j.push(new RegExp((0,B.$Ze)(d.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(d=>{(d.affectsConfiguration(k.$Ul)||d.affectsConfiguration(k.$Wl)||d.affectsConfiguration(k.$Vl))&&this.m()}))}setExperimentProperty($,f){this.d[$]=f}m(){let $=(0,g.$_o)(this.k);const f=this.l.enabledTelemetryLevels;if(f){this.h=this.sendErrorTelemetry?f.error:!1;const l=f.usage?3:f.error?2:0;$=Math.min($,l)}this.g=$}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n($,f,l){this.g<f||(l=(0,j.$Qn)(l,this.d),l=(0,g.$ep)(l,this.j),l=(0,j.$Qn)(l,this.c),this.b.forEach(d=>d.log($,l)))}publicLog($,f){this.n($,3,f)}publicLog2($,f){this.publicLog($,f)}publicLogError($,f){this.h&&this.n($,2,f)}publicLogError2($,f){this.publicLogError($,f)}};e.$Ir=m,e.$Ir=m=Ee([ne(1,E.$Ni),ne(2,p.$7j)],m);function v(){const w=(0,S.localize)(0,null,c.default.nameLong),$=c.default.privacyStatementUrl?(0,S.localize)(2,null,"https://aka.ms/vscode-telemetry",c.default.privacyStatementUrl):(0,S.localize)(1,null,"https://aka.ms/vscode-telemetry"),f=P.$o?"":(0,S.localize)(3,null),l=(0,S.localize)(4,null),d=(0,S.localize)(5,null),a=(0,S.localize)(6,null),t=(0,S.localize)(7,null),o=`
|       | ${l} | ${d} | ${a} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,r=(0,S.localize)(8,null);return`
${w} ${$} ${f}

&nbsp;

${t}
${o}

&nbsp;

${r}
`}y.$Zn.as(h.$5n.Configuration).registerConfiguration({id:k.$Tl,order:1,type:"object",title:(0,S.localize)(9,null),properties:{[k.$Ul]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,S.localize)(10,null),(0,S.localize)(11,null),(0,S.localize)(12,null),(0,S.localize)(13,null)],markdownDescription:v(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),y.$Zn.as(h.$5n.Configuration).registerConfiguration({id:k.$Tl,order:110,type:"object",title:(0,S.localize)(14,null),properties:{[k.$Wl]:{type:"boolean",markdownDescription:c.default.privacyStatementUrl?(0,S.localize)(16,null,c.default.nameLong,c.default.privacyStatementUrl):(0,S.localize)(15,null,c.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,S.localize)(17,null,`\`#${k.$Ul}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(oe[258],ae([0,1,4,89,28]),function(J,e,n,j,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lbc=B,e.$mbc=S;async function B(E,h){let c=E.getItem(P.$Rl);return(typeof c!="string"||n.$j&&c==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(c=await(0,j.$qn)(h.error.bind(h))),c}async function S(E,h){let c=E.getItem(P.$Sl);return typeof c!="string"&&(c=await(0,j.$rn)(h.error.bind(h))),c}}),define(oe[259],ae([0,1,28,258]),function(J,e,n,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nbc=P,e.$obc=B;async function P(S,E){const h=await(0,j.$lbc)(S,E);return S.setItem(n.$Rl,h),h}async function B(S,E){const h=await(0,j.$mbc)(S,E);return S.setItem(n.$Sl,h),h}}),define(oe[128],ae([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var n;(function(j){j[j.Replace=1]="Replace",j[j.Append=2]="Append",j[j.Prepend=3]="Prepend"})(n||(e.EnvironmentVariableMutatorType=n={}))}),define(oe[260],ae([0,1,4,128]),function(J,e,n,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_r=void 0;const P=new Map([[j.EnvironmentVariableMutatorType.Append,"APPEND"],[j.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[j.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class B{constructor(p){this.collections=p,this.a=new Map,this.b=new Map,p.forEach((y,k)=>{this.d(y,k);const g=y.map.entries();let m=g.next();for(;!m.done;){const v=m.value[1],w=m.value[0];let $=this.a.get(w);if($||($=[],this.a.set(w,$)),$.length>0&&$[0].type===j.EnvironmentVariableMutatorType.Replace){m=g.next();continue}const f={extensionIdentifier:k,value:v.value,type:v.type,scope:v.scope,variable:v.variable,options:v.options};f.scope||delete f.scope,$.unshift(f),m=g.next()}})}async applyToProcessEnvironment(p,y,k){let g;n.$i&&(g={},Object.keys(p).forEach(m=>g[m.toLowerCase()]=m));for(const[m,v]of this.getVariableMap(y)){const w=n.$i&&g[m.toLowerCase()]||m;for(const $ of v){const f=k?await k($.value):$.value;if($.options?.applyAtProcessCreation??!0)switch($.type){case j.EnvironmentVariableMutatorType.Append:p[w]=(p[w]||"")+f;break;case j.EnvironmentVariableMutatorType.Prepend:p[w]=f+(p[w]||"");break;case j.EnvironmentVariableMutatorType.Replace:p[w]=f;break}if($.options?.applyAtShellIntegration??!1){const l=`VSCODE_ENV_${P.get($.type)}`;p[l]=(p[l]?p[l]+":":"")+m+"="+this.c(f)}}}}c(p){return p.replaceAll(":","\\x3a")}diff(p,y){const k=new Map,g=new Map,m=new Map;if(p.getVariableMap(y).forEach((v,w)=>{const $=this.getVariableMap(y).get(w),f=E(v,$);f&&k.set(w,f)}),this.getVariableMap(y).forEach((v,w)=>{const $=p.getVariableMap(y).get(w),f=E(v,$);f&&m.set(w,f)}),this.getVariableMap(y).forEach((v,w)=>{const $=p.getVariableMap(y).get(w),f=h(v,$);f&&g.set(w,f)}),!(k.size===0&&g.size===0&&m.size===0))return{added:k,changed:g,removed:m}}getVariableMap(p){const y=new Map;for(const k of this.a.values()){const g=k.filter(m=>S(m,p));g.length>0&&y.set(g[0].variable,g)}return y}getDescriptionMap(p){const y=new Map;for(const k of this.b.values()){const g=k.filter(m=>S(m,p,!0));for(const m of g)y.set(m.extensionIdentifier,m.description)}return y}d(p,y){if(!p.descriptionMap)return;const k=p.descriptionMap.entries();let g=k.next();for(;!g.done;){const m=g.value[1],v=g.value[0];let w=this.b.get(v);w||(w=[],this.b.set(v,w));const $={extensionIdentifier:y,scope:m.scope,description:m.description};$.scope||delete $.scope,w.push($),g=k.next()}}}e.$_r=B;function S(c,p,y=!1){return c.scope?!!(c.scope.workspaceFolder&&p?.workspaceFolder&&c.scope.workspaceFolder.index===p.workspaceFolder.index):y?p===c.scope:!0}function E(c,p){if(!p)return c;const y=new Set;p.forEach(g=>y.add(g.extensionIdentifier));const k=[];return c.forEach(g=>{y.has(g.extensionIdentifier)||k.push(g)}),k.length===0?void 0:k}function h(c,p){if(!p)return;const y=new Map;p.forEach(g=>y.set(g.extensionIdentifier,g));const k=[];return c.forEach(g=>{const m=y.get(g.extensionIdentifier);m&&(g.type!==m.type||g.value!==m.value||g.scope?.workspaceFolder?.index!==m.scope?.workspaceFolder?.index)&&k.push(m)}),k.length===0?void 0:k}}),define(oe[261],ae([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6r=n,e.$7r=j,e.$8r=P,e.$9r=B,e.$0r=S,e.$$r=E;function n(h){return[...h.entries()]}function j(h){return h?[...h.entries()]:[]}function P(h){return new Map(h)}function B(h){return new Map(h??[])}function S(h){return Array.from(h.entries()).map(c=>[c[0],n(c[1].map),j(c[1].descriptionMap)])}function E(h){return new Map(h.map(c=>[c[0],{map:P(c[1]),descriptionMap:B(c[2])}]))}}),define(oe[262],ae([0,1,8,23,3,2,5]),function(J,e,n,j,P,B,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wr=void 0;let E=class extends B.$Uc{constructor(c,p){super(),this.h=p,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new P.$7d),this.onCreateRequest=this.g.event,this.b=c===void 0?15e3:c,this.B((0,B.$Sc)(()=>{for(const y of this.f.values())(0,B.$Pc)(y)}))}createRequest(c){return new Promise((p,y)=>{const k=++this.a;this.c.set(k,p),this.g.fire({requestId:k,...c});const g=new j.$ee;(0,n.$ih)(this.b,g.token).then(()=>y(`Request ${k} timed out (${this.b}ms)`)),this.f.set(k,[(0,B.$Sc)(()=>g.cancel())])})}acceptReply(c,p){const y=this.c.get(c);y?(this.c.delete(c),(0,B.$Pc)(this.f.get(c)||[]),this.f.delete(c),y(p)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${c}`)}};e.$Wr=E,e.$Wr=E=Ee([ne(1,S.$Nj)],E)}),define(oe[129],ae([0,1,6,118,45]),function(J,e,n,j,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sr=e.$Rr=e.$Qr=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$Pr=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$Or=void 0,e.$Or=new j.$yj("terminalTabFocusMode",!1,!0);var B;(function(a){a.AutomationProfile="terminal.integrated.automationProfile.",a.DefaultProfile="terminal.integrated.defaultProfile.",a.Profiles="terminal.integrated.profiles."})(B||(e.TerminalSettingPrefix=B={}));var S;(function(a){a.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",a.AutomationProfileLinux="terminal.integrated.automationProfile.linux",a.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",a.AutomationProfileWindows="terminal.integrated.automationProfile.windows",a.ProfilesWindows="terminal.integrated.profiles.windows",a.ProfilesMacOs="terminal.integrated.profiles.osx",a.ProfilesLinux="terminal.integrated.profiles.linux",a.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",a.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",a.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",a.UseWslProfiles="terminal.integrated.useWslProfiles",a.TabsDefaultColor="terminal.integrated.tabs.defaultColor",a.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",a.TabsEnabled="terminal.integrated.tabs.enabled",a.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",a.TabsHideCondition="terminal.integrated.tabs.hideCondition",a.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",a.TabsShowActions="terminal.integrated.tabs.showActions",a.TabsLocation="terminal.integrated.tabs.location",a.TabsFocusMode="terminal.integrated.tabs.focusMode",a.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",a.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",a.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",a.CopyOnSelection="terminal.integrated.copyOnSelection",a.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",a.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",a.FontFamily="terminal.integrated.fontFamily",a.FontSize="terminal.integrated.fontSize",a.LetterSpacing="terminal.integrated.letterSpacing",a.LineHeight="terminal.integrated.lineHeight",a.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",a.TabStopWidth="terminal.integrated.tabStopWidth",a.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",a.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",a.BellDuration="terminal.integrated.bellDuration",a.FontWeight="terminal.integrated.fontWeight",a.FontWeightBold="terminal.integrated.fontWeightBold",a.CursorBlinking="terminal.integrated.cursorBlinking",a.CursorStyle="terminal.integrated.cursorStyle",a.CursorStyleInactive="terminal.integrated.cursorStyleInactive",a.CursorWidth="terminal.integrated.cursorWidth",a.Scrollback="terminal.integrated.scrollback",a.DetectLocale="terminal.integrated.detectLocale",a.DefaultLocation="terminal.integrated.defaultLocation",a.GpuAcceleration="terminal.integrated.gpuAcceleration",a.TerminalTitleSeparator="terminal.integrated.tabs.separator",a.TerminalTitle="terminal.integrated.tabs.title",a.TerminalDescription="terminal.integrated.tabs.description",a.RightClickBehavior="terminal.integrated.rightClickBehavior",a.Cwd="terminal.integrated.cwd",a.ConfirmOnExit="terminal.integrated.confirmOnExit",a.ConfirmOnKill="terminal.integrated.confirmOnKill",a.EnableBell="terminal.integrated.enableBell",a.EnableVisualBell="terminal.integrated.enableVisualBell",a.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",a.AllowChords="terminal.integrated.allowChords",a.AllowMnemonics="terminal.integrated.allowMnemonics",a.TabFocusMode="terminal.integrated.tabFocusMode",a.EnvMacOs="terminal.integrated.env.osx",a.EnvLinux="terminal.integrated.env.linux",a.EnvWindows="terminal.integrated.env.windows",a.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",a.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",a.ShowExitAlert="terminal.integrated.showExitAlert",a.SplitCwd="terminal.integrated.splitCwd",a.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",a.WordSeparators="terminal.integrated.wordSeparators",a.EnableFileLinks="terminal.integrated.enableFileLinks",a.UnicodeVersion="terminal.integrated.unicodeVersion",a.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",a.LocalEchoEnabled="terminal.integrated.localEchoEnabled",a.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",a.LocalEchoStyle="terminal.integrated.localEchoStyle",a.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",a.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",a.HideOnStartup="terminal.integrated.hideOnStartup",a.CustomGlyphs="terminal.integrated.customGlyphs",a.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",a.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",a.InheritEnv="terminal.integrated.inheritEnv",a.ShowLinkHover="terminal.integrated.showLinkHover",a.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",a.AutoReplies="terminal.integrated.autoReplies",a.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",a.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",a.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",a.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",a.ShellIntegrationSuggestEnabled="terminal.integrated.shellIntegration.suggestEnabled",a.EnableImages="terminal.integrated.enableImages",a.SmoothScrolling="terminal.integrated.smoothScrolling",a.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",a.FocusAfterRun="terminal.integrated.focusAfterRun",a.AccessibleViewPreserveCursorPosition="terminal.integrated.accessibleViewPreserveCursorPosition",a.AccessibleViewFocusOnCommandExecution="terminal.integrated.accessibleViewFocusOnCommandExecution",a.StickyScrollEnabled="terminal.integrated.stickyScroll.enabled",a.StickyScrollMaxLineCount="terminal.integrated.stickyScroll.maxLineCount",a.MouseWheelZoom="terminal.integrated.mouseWheelZoom",a.ExperimentalInlineChat="terminal.integrated.experimentalInlineChat",a.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",a.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",a.DevMode="terminal.integrated.developer.devMode"})(S||(e.TerminalSettingId=S={}));var E;(function(a){a.PowerShell="pwsh",a.Bash="bash",a.Fish="fish",a.Sh="sh",a.Csh="csh",a.Ksh="ksh",a.Zsh="zsh",a.Python="python"})(E||(e.PosixShellType=E={}));var h;(function(a){a.CommandPrompt="cmd",a.PowerShell="pwsh",a.Wsl="wsl",a.GitBash="gitbash",a.Python="python"})(h||(e.WindowsShellType=h={}));var c;(function(a){a[a.Api=0]="Api",a[a.Process=1]="Process",a[a.Sequence=2]="Sequence",a[a.Config=3]="Config"})(c||(e.TitleEventSource=c={}));var p;(function(a){a.LocalPty="localPty",a.PtyHost="ptyHost",a.PtyHostWindow="ptyHostWindow",a.Logger="logger",a.Heartbeat="heartbeat"})(p||(e.TerminalIpcChannels=p={}));var y;(function(a){a.Cwd="cwd",a.InitialCwd="initialCwd",a.FixedDimensions="fixedDimensions",a.Title="title",a.ShellType="shellType",a.HasChildProcesses="hasChildProcesses",a.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",a.OverrideDimensions="overrideDimensions",a.FailedShellIntegrationActivation="failedShellIntegrationActivation",a.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(y||(e.ProcessPropertyType=y={})),e.$Pr=(0,n.$hi)("ptyService");var k;(function(a){a[a.BeatInterval=5e3]="BeatInterval",a[a.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",a[a.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",a[a.SecondWaitMultiplier=1]="SecondWaitMultiplier",a[a.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(k||(e.HeartbeatConstants=k={}));var g;(function(a){a[a.Panel=1]="Panel",a[a.Editor=2]="Editor"})(g||(e.TerminalLocation=g={}));var m;(function(a){a.TerminalView="view",a.Editor="editor"})(m||(e.TerminalLocationString=m={}));var v;(function(a){a[a.GraceTime=6e4]="GraceTime",a[a.ShortGraceTime=6e3]="ShortGraceTime"})(v||(e.LocalReconnectConstants=v={}));var w;(function(a){a[a.HighWatermarkChars=1e5]="HighWatermarkChars",a[a.LowWatermarkChars=5e3]="LowWatermarkChars",a[a.CharCountAckSize=5e3]="CharCountAckSize"})(w||(e.FlowControlConstants=w={}));var $;(function(a){a.GitBash="Git Bash",a.Pwsh="PowerShell"})($||(e.ProfileSource=$={}));var f;(function(a){a[a.Off=0]="Off",a[a.FinalTerm=1]="FinalTerm",a[a.VSCode=2]="VSCode"})(f||(e.ShellIntegrationStatus=f={}));var l;(function(a){a[a.Unknown=0]="Unknown",a[a.Shutdown=1]="Shutdown",a[a.Process=2]="Process",a[a.User=3]="User",a[a.Extension=4]="Extension"})(l||(e.TerminalExitReason=l={})),e.$Qr={Backend:"workbench.contributions.terminal.processBackend"};class d{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(t){const o=this.b(t.remoteAuthority);if(this.a.has(o))throw new Error(`A terminal backend with remote authority '${o}' was already registered.`);this.a.set(o,t)}getTerminalBackend(t){return this.a.get(this.b(t))}b(t){return t?.toLowerCase()??""}}P.$Zn.add(e.$Qr.Backend,new d),e.$Rr=(0,n.$hi)("localPtyService"),e.$Sr=(0,n.$hi)("terminalLogService")}),define(oe[263],ae([0,1,74,7,190,106]),function(J,e,n,j,P,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xr=S,e.$Yr=c,e.$Zr=p,e.$1r=y;function S(k,g){const m=[{name:null,description:(0,P.localize)(0,null)}];return m.push(...k.map(v=>({name:v.profileName,description:E(v)}))),g&&m.push(...g.map(v=>({name:v.title,description:h(v)}))),{values:m.map(v=>v.name),markdownDescriptions:m.map(v=>v.description)}}function E(k){let g=`$(${B.ThemeIcon.isThemeIcon(k.icon)?k.icon.id:k.icon?k.icon:n.$Gj.terminal.id}) ${k.profileName}
- path: ${k.path}`;return k.args&&(typeof k.args=="string"?g+=`
- args: "${k.args}"`:g+=`
- args: [${k.args.length===0?"":`'${k.args.join("','")}'`}]`),k.overrideName!==void 0&&(g+=`
- overrideName: ${k.overrideName}`),k.color&&(g+=`
- color: ${k.color}`),k.env&&(g+=`
- env: ${JSON.stringify(k.env)}`),g}function h(k){return`$(${B.ThemeIcon.isThemeIcon(k.icon)?k.icon.id:k.icon?k.icon:n.$Gj.terminal.id}) ${k.title}
- extensionIdentifier: ${k.extensionIdentifier}`}function c(k,g){if(!k&&!g)return!0;if(typeof k=="string"&&typeof g=="string")return k===g;if(Array.isArray(k)&&Array.isArray(g)){if(k.length!==g.length)return!1;for(let m=0;m<k.length;m++)if(k[m]!==g[m])return!1;return!0}return!1}function p(k,g){if(!k&&!g)return!0;if(!k||!g)return!1;if(B.ThemeIcon.isThemeIcon(k)&&B.ThemeIcon.isThemeIcon(g))return k.id===g.id&&k.color===g.color;if(typeof k=="object"&&"light"in k&&"dark"in k&&typeof g=="object"&&"light"in g&&"dark"in g){const m=k,v=g;if((j.URI.isUri(m.light)||y(m.light))&&(j.URI.isUri(m.dark)||y(m.dark))&&(j.URI.isUri(v.light)||y(v.light))&&(j.URI.isUri(v.dark)||y(v.dark)))return m.light.path===v.light.path&&m.dark.path===v.dark.path}if(j.URI.isUri(k)&&j.URI.isUri(g)||y(k)||y(g)){const m=k,v=g;return m.path===v.path&&m.scheme===v.scheme}return!1}function y(k){return k?typeof k.path=="string"&&typeof k.scheme=="string":!1}}),define(oe[264],ae([0,1,74,4,189,52,45,263]),function(J,e,n,j,P,B,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3r=e.$2r=void 0,e.$4r=g,e.$5r=v,e.$2r={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.$3r={type:"string",enum:Array.from((0,n.$Ej)(),w=>w.id),markdownEnumDescriptions:Array.from((0,n.$Ej)(),w=>`$(${w.id})`)};const h={args:{description:(0,P.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,P.localize)(1,null),type:"boolean"},icon:{description:(0,P.localize)(2,null),...e.$3r},color:{description:(0,P.localize)(3,null),...e.$2r},env:{markdownDescription:(0,P.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},c={type:"object",required:["path"],properties:{path:{description:(0,P.localize)(5,null),type:["string","array"],items:{type:"string"}},...h}},p={type:"object",required:["path"],properties:{path:{description:(0,P.localize)(6,null),type:["string"],items:{type:"string"}},...h}};function y(w){const $=w===2?"linux":w===1?"osx":"windows";return(0,P.localize)(7,null,(0,j.$h)(w),'```json\n"terminal.integrated.profile.'+$+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const k={id:"terminal",order:100,title:(0,P.localize)(8,null),type:"object",properties:{"terminal.integrated.automationProfile.linux":{restricted:!0,markdownDescription:(0,P.localize)(9,null),type:["object","null"],default:null,anyOf:[{type:"null"},p],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},"terminal.integrated.automationProfile.osx":{restricted:!0,markdownDescription:(0,P.localize)(10,null),type:["object","null"],default:null,anyOf:[{type:"null"},p],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},"terminal.integrated.automationProfile.windows":{restricted:!0,markdownDescription:(0,P.localize)(11,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},p],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},"terminal.integrated.profiles.windows":{restricted:!0,markdownDescription:y(3),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,P.localize)(12,null),enum:["PowerShell","Git Bash"]},...h}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,P.localize)(13,null),type:"string"},id:{description:(0,P.localize)(14,null),type:"string"},title:{description:(0,P.localize)(15,null),type:"string"},...h}},{type:"null"},c]}},"terminal.integrated.profiles.osx":{restricted:!0,markdownDescription:y(1),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,P.localize)(16,null),type:"string"},id:{description:(0,P.localize)(17,null),type:"string"},title:{description:(0,P.localize)(18,null),type:"string"},...h}},{type:"null"},c]}},"terminal.integrated.profiles.linux":{restricted:!0,markdownDescription:y(2),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,P.localize)(19,null),type:"string"},id:{description:(0,P.localize)(20,null),type:"string"},title:{description:(0,P.localize)(21,null),type:"string"},...h}},{type:"null"},c]}},"terminal.integrated.useWslProfiles":{description:(0,P.localize)(22,null),type:"boolean",default:!0},"terminal.integrated.inheritEnv":{scope:1,description:(0,P.localize)(23,null),type:"boolean",default:!0},"terminal.integrated.persistentSessionScrollback":{scope:1,markdownDescription:(0,P.localize)(24,null),type:"number",default:100},"terminal.integrated.showLinkHover":{scope:1,description:(0,P.localize)(25,null),type:"boolean",default:!0},"terminal.integrated.ignoreProcessNames":{markdownDescription:(0,P.localize)(26,null,"`#terminal.integrated.confirmOnKill#`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function g(){S.$Zn.as(B.$5n.Configuration).registerConfiguration(k),v()}let m;function v(w,$){const f=S.$Zn.as(B.$5n.Configuration);let l;w&&(l=(0,E.$Xr)(w?.profiles,$));const d=m;m={id:"terminal",order:100,title:(0,P.localize)(27,null),type:"object",properties:{"terminal.integrated.defaultProfile.linux":{restricted:!0,markdownDescription:(0,P.localize)(28,null),type:["string","null"],default:null,enum:w?.os===3?l?.values:void 0,markdownEnumDescriptions:w?.os===3?l?.markdownDescriptions:void 0},"terminal.integrated.defaultProfile.osx":{restricted:!0,markdownDescription:(0,P.localize)(29,null),type:["string","null"],default:null,enum:w?.os===2?l?.values:void 0,markdownEnumDescriptions:w?.os===2?l?.markdownDescriptions:void 0},"terminal.integrated.defaultProfile.windows":{restricted:!0,markdownDescription:(0,P.localize)(30,null),type:["string","null"],default:null,enum:w?.os===1?l?.values:void 0,markdownEnumDescriptions:w?.os===1?l?.markdownDescriptions:void 0}}},f.updateConfigurations({add:[m],remove:d?[d]:[]})}}),define(oe[265],ae([0,1,26,13,35,9,4,36,25,12,21,128,261,260]),function(J,e,n,j,P,B,S,E,h,c,p,y,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$as=m,e.$bs=v,e.$cs=w;function m(){const i=/(\d+)\.(\d+)\.(\d+)/g.exec(n.release());let s=0;return i&&i.length===4&&(s=parseInt(i[3])),s}async function v(i,s,u,b=E.env,I=p.Promises.exists){if(B.$jc(i))return await I(i)?i:void 0;if(s===void 0&&(s=E.cwd()),B.$nc(i)!=="."){const A=B.$kc(s,i);return await I(A)?A:void 0}const R=(0,P.$Un)(b,"PATH");if(u===void 0&&(0,c.$Uf)(R)&&(u=R.split(B.$uc)),u===void 0||u.length===0){const A=B.$kc(s,i);return await I(A)?A:void 0}for(const A of u){let L;if(B.$jc(A)?L=B.$kc(A,i):L=B.$kc(s,A,i),await I(L))return L;if(S.$i){let W=L+".com";if(await I(W)||(W=L+".exe",await I(W)))return W}}const C=B.$kc(s,i);return await I(C)?C:void 0}function w(i,s,u,b,I){const D=S.$i&&(!s.windowsEnableConpty||m()<18309);if(!s.shellIntegration.enabled||!i.executable||i.isFeatureTerminal&&!i.forceShellIntegration||i.hideFromUser||i.ignoreShellIntegration||D)return;const R=i.args,C=E.$ec==="win32"?B.$oc(i.executable).toLowerCase():B.$oc(i.executable),A=B.$nc(j.$Bg.asFileUri("").fsPath);let L;const W={VSCODE_INJECTION:"1"};if(s.shellIntegration.nonce&&(W.VSCODE_NONCE=s.shellIntegration.nonce),S.$i){if(C==="pwsh.exe"||C==="powershell.exe")return!R||o(R)?L=l.get(f.WindowsPwsh):t(R)&&(L=l.get(f.WindowsPwshLogin)),L?(L=[...L],L[L.length-1]=(0,h.$Ve)(L[L.length-1],A,""),s.shellIntegration.suggestEnabled&&(W.VSCODE_SUGGEST="1"),{newArgs:L,envMixin:W}):void 0;b.warn(`Shell integration cannot be enabled for executable "${i.executable}" and args`,i.args);return}switch(C){case"bash":return!R||R.length===0?L=l.get(f.Bash):r(R)&&(W.VSCODE_SHELL_LOGIN="1",$(s,W),L=l.get(f.Bash)),L?(L=[...L],L[L.length-1]=(0,h.$Ve)(L[L.length-1],A),{newArgs:L,envMixin:W}):void 0;case"fish":{const q=u?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",H=B.$kc(A,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return W.XDG_DATA_DIRS=`${q}:${H}`,$(s,W),{newArgs:void 0,envMixin:W}}case"pwsh":return!R||o(R)?L=l.get(f.Pwsh):t(R)&&(L=l.get(f.PwshLogin)),L?(s.shellIntegration.suggestEnabled&&(W.VSCODE_SUGGEST="1"),L=[...L],L[L.length-1]=(0,h.$Ve)(L[L.length-1],A,""),{newArgs:L,envMixin:W}):void 0;case"zsh":{if(!R||R.length===0?L=l.get(f.Zsh):r(R)?(L=l.get(f.ZshLogin),$(s,W)):(R===l.get(f.Zsh)||R===l.get(f.ZshLogin))&&(L=R),!L)return;L=[...L],L[L.length-1]=(0,h.$Ve)(L[L.length-1],A);let q;try{q=n.userInfo().username}catch{q="unknown"}const H=B.$kc(n.tmpdir(),`${q}-${I.applicationName}-zsh`);W.ZDOTDIR=H;const le=u?.ZDOTDIR??n.homedir()??"~";W.USER_ZDOTDIR=le;const te=[];return te.push({source:B.$kc(A,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:B.$kc(H,".zshrc")}),te.push({source:B.$kc(A,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:B.$kc(H,".zprofile")}),te.push({source:B.$kc(A,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:B.$kc(H,".zshenv")}),te.push({source:B.$kc(A,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:B.$kc(H,".zlogin")}),{newArgs:L,envMixin:W,filesToCopy:te}}}b.warn(`Shell integration cannot be enabled for executable "${i.executable}" and args`,i.args)}function $(i,s){if(S.$j&&i.environmentVariableCollections){const u=(0,k.$$r)(i.environmentVariableCollections),I=new g.$_r(u).getVariableMap({workspaceFolder:i.workspaceFolder}).get("PATH"),D=[];if(I)for(const R of I)R.type===y.EnvironmentVariableMutatorType.Prepend&&D.push(R.value);D.length>0&&(s.VSCODE_PATH_PREFIX=D.join(""))}}var f;(function(i){i.WindowsPwsh="windows-pwsh",i.WindowsPwshLogin="windows-pwsh-login",i.Pwsh="pwsh",i.PwshLogin="pwsh-login",i.Zsh="zsh",i.ZshLogin="zsh-login",i.Bash="bash"})(f||(f={}));const l=new Map;l.set(f.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),l.set(f.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),l.set(f.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),l.set(f.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),l.set(f.Zsh,["-i"]),l.set(f.ZshLogin,["-il"]),l.set(f.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const d=["-login","-l"],a=["-nol","-nologo"];function t(i){return typeof i=="string"?d.includes(i.toLowerCase()):i.length===1&&d.includes(i[0].toLowerCase())||i.length===2&&(d.includes(i[0].toLowerCase())||d.includes(i[1].toLowerCase()))&&(a.includes(i[0].toLowerCase())||a.includes(i[1].toLowerCase()))}function o(i){return typeof i=="string"?a.includes(i.toLowerCase()):i.length===0||i?.length===1&&a.includes(i[0].toLowerCase())}function r(i){return i==="string"&&d.includes(i.toLowerCase())||typeof i!="string"&&i.length===1&&d.includes(i[0].toLowerCase())}}),define(oe[266],ae([0,1,49,74,9,4,12,21,110,265,117]),function(J,e,n,j,P,B,S,E,h,c,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ds=m;var y;(function(u){u.UnixShellsPath="/etc/shells"})(y||(y={}));let k,g=!0;function m(u,b,I,D,R=process.env,C,A,L,W){return C=C||{existsFile:E.SymlinkSupport.existsFile,readFile:E.Promises.readFile},B.$i?v(I,C,R,A,D.getValue("terminal.integrated.useWslProfiles")!==!1,u&&typeof u=="object"?{...u}:D.getValue("terminal.integrated.profiles.windows"),typeof b=="string"?b:D.getValue("terminal.integrated.defaultProfile.windows"),W,L):r(C,A,I,u&&typeof u=="object"?{...u}:D.getValue(B.$k?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof b=="string"?b:D.getValue(B.$k?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),W,L,R)}async function v(u,b,I,D,R,C,A,L,W){const q=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),H=`${process.env.windir}\\${q?"Sysnative":"System32"}`;let le=!1;(0,c.$as)()>=16299&&(le=!0),await l(L);const te=new Map;if(u){te.set("PowerShell",{source:"PowerShell",icon:j.$Gj.terminalPowershell,isAutoDetected:!0}),te.set("Windows PowerShell",{path:`${H}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:j.$Gj.terminalPowershell,isAutoDetected:!0}),te.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),te.set("Command Prompt",{path:`${H}\\cmd.exe`,icon:j.$Gj.terminalCmd,isAutoDetected:!0}),te.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),te.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],env:{CHERE_INVOKING:"1"},icon:j.$Gj.terminalBash,isAutoDetected:!0});const X=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;te.set("Cmder",{path:`${H}\\cmd.exe`,args:["/K",X],requiresPath:process.env.CMDER_ROOT?X:{path:X,isUnsafe:!0},isAutoDetected:!0})}i(C,te);const ue=await w(te.entries(),A,b,I,D,W);if(u&&R)try{const X=await t(`${H}\\${le?"wsl":"bash"}.exe`,A);for(const Q of X)(!C||!(Q.profileName in C))&&ue.push(Q)}catch{g&&(D?.trace("WSL is not installed, so could not detect WSL profiles"),g=!1)}return ue}async function w(u,b,I,D=process.env,R,C){const A=[];for(const[L,W]of u)A.push($(L,W,b,I,D,R,C));return(await Promise.all(A)).filter(L=>!!L)}async function $(u,b,I,D,R=process.env,C,A){if(b===null)return;let L,W,q;if("source"in b&&!("path"in b)){const ue=k?.get(b.source);if(!ue)return;L=ue.paths,W=b.args||ue.args,b.icon?q=f(b.icon):ue.icon&&(q=ue.icon)}else L=Array.isArray(b.path)?b.path:[b.path],W=B.$i||Array.isArray(b.args)?b.args:void 0,q=f(b.icon);let H;if(A){const ue=L.map(Q=>typeof Q=="string"?Q:Q.path),X=await A(ue);H=new Array(L.length);for(let Q=0;Q<L.length;Q++)typeof L[Q]=="string"?H[Q]=X[Q]:H[Q]={path:X[Q],isUnsafe:!0}}else H=L.slice();let le;if(b.requiresPath){let ue;if((0,S.$Uf)(b.requiresPath)?ue=b.requiresPath:(ue=b.requiresPath.path,b.requiresPath.isUnsafe&&(le=ue)),!await D.existsFile(ue))return}const te=await s(u,I,H,D,R,W,b.env,b.overrideName,b.isAutoDetected,le);if(!te){C?.debug("Terminal profile not validated",u,L);return}return te.isAutoDetected=b.isAutoDetected,te.icon=q,te.color=b.color,te}function f(u){return typeof u=="string"?{id:u}:u}async function l(u){if(k&&!u)return;const[b,I]=await Promise.all([d(),u||a()]);k=new Map,k.set("Git Bash",{profileName:"Git Bash",paths:b,args:["--login","-i"]}),k.set("PowerShell",{profileName:"PowerShell",paths:I,icon:j.$Gj.terminalPowershell})}async function d(){const u=new Set,b=await(0,c.$bs)("git.exe");if(b){const R=(0,p.dirname)(b);u.add((0,p.resolve)(R,"../.."))}function I(R,C){C&&R.add(C)}I(u,process.env.ProgramW6432),I(u,process.env.ProgramFiles),I(u,process.env["ProgramFiles(X86)"]),I(u,`${process.env.LocalAppData}\\Program`);const D=[];for(const R of u)D.push(`${R}\\Git\\bin\\bash.exe`,`${R}\\Git\\usr\\bin\\bash.exe`,`${R}\\usr\\bin\\bash.exe`);return D.push(`${process.env.UserProfile}\\scoop\\apps\\git\\current\\bin\\bash.exe`),D.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),D}async function a(){const u=[];for await(const b of(0,h.$8l)())u.push(b.exePath);return u}async function t(u,b){const I=[],D=await new Promise((A,L)=>{n.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(W,q)=>{if(W)return L("Problem occurred when getting wsl distros");A(q)})});if(!D)return[];const R=new RegExp(/[\r?\n]/),C=D.split(R).filter(A=>A.trim().length>0&&A!=="");for(const A of C){if(A===""||A.startsWith("docker-desktop"))continue;const L=`${A} (WSL)`,W={profileName:L,path:u,args:["-d",`${A}`],isDefault:L===b,icon:o(A),isAutoDetected:!1};I.push(W)}return I}function o(u){return u.includes("Ubuntu")?j.$Gj.terminalUbuntu:u.includes("Debian")?j.$Gj.terminalDebian:j.$Gj.terminalLinux}async function r(u,b,I,D,R,C,A,L){const W=new Map;if(I&&await u.existsFile("/etc/shells")){const q=(await u.readFile("/etc/shells")).toString(),H=(C||q.split(`
`)).map(te=>{const ue=te.indexOf("#");return ue===-1?te:te.substring(0,ue)}).filter(te=>te.trim().length>0),le=new Map;for(const te of H){let ue=(0,P.$oc)(te),X=le.get(ue)||0;X++,X>1&&(ue=`${ue} (${X})`),le.set(ue,X),W.set(ue,{path:te,isAutoDetected:!0})}}return i(D,W),await w(W.entries(),R,u,L,b,A)}function i(u,b){if(u)for(const[I,D]of Object.entries(u))D===null||typeof D!="object"||!("path"in D)&&!("source"in D)?b.delete(I):(D.icon=D.icon||b.get(I)?.icon,b.set(I,D))}async function s(u,b,I,D,R,C,A,L,W,q){if(I.length===0)return Promise.resolve(void 0);const H=I.shift();if(H==="")return s(u,b,I,D,R,C,A,L,W);const le=typeof H!="string"&&H.isUnsafe,te=typeof H=="string"?H:H.path,ue={profileName:u,path:te,args:C,env:A,overrideName:L,isAutoDetected:W,isDefault:u===b,isUnsafePath:le,requiresUnsafePath:q};if((0,P.$oc)(te)===te){const Q=R.PATH?R.PATH.split(P.$uc):void 0,z=await(0,c.$bs)(te,void 0,Q,void 0,D.existsFile);return z?(ue.path=z,ue.isFromPath=!0,ue):s(u,b,I,D,R,C)}return await D.existsFile((0,P.$ic)(te))?ue:s(u,b,I,D,R,C,A,L,W)}}),define(oe[267],ae([0,1,3,2,4,44,18,5,230,95,262,129,264,266,112,72]),function(J,e,n,j,P,B,S,E,h,c,p,y,k,g,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$es=void 0;var w;(function(f){f[f.MaxRestarts=5]="MaxRestarts"})(w||(w={}));let $=class extends j.$Uc{get c(){return this.h(),this.a}get f(){return this.h(),this.b}get g(){return this.b}h(){this.a||this.U()}constructor(l,d,a,t){super(),this.M=l,this.N=d,this.O=a,this.P=t,this.m=!1,this.n=0,this.r=!0,this.u=this.B(new n.$7d),this.onPtyHostExit=this.u.event,this.w=this.B(new n.$7d),this.onPtyHostStart=this.w.event,this.y=this.B(new n.$7d),this.onPtyHostUnresponsive=this.y.event,this.z=this.B(new n.$7d),this.onPtyHostResponsive=this.z.event,this.C=this.B(new n.$7d),this.onPtyHostRequestResolveVariables=this.C.event,this.D=this.B(new n.$7d),this.onProcessData=this.D.event,this.F=this.B(new n.$7d),this.onProcessReady=this.F.event,this.G=this.B(new n.$7d),this.onProcessReplay=this.G.event,this.H=this.B(new n.$7d),this.onProcessOrphanQuestion=this.H.event,this.I=this.B(new n.$7d),this.onDidRequestDetach=this.I.event,this.J=this.B(new n.$7d),this.onDidChangeProperty=this.J.event,this.L=this.B(new n.$7d),this.onProcessExit=this.L.event,(0,k.$4r)(),this.B(this.M),this.B((0,j.$Sc)(()=>this.W())),this.j=this.B(new p.$Wr(void 0,this.O)),this.j.onCreateRequest(this.C.fire,this.C),this.M.onRequestConnection&&n.Event.once(this.M.onRequestConnection)(()=>this.h()),this.M.onWillShutdown?.(()=>this.m=!0)}get Q(){return this.N.getValue("terminal.integrated.ignoreProcessNames")}async R(){return this.g?.refreshIgnoreProcessNames?.(this.Q)}async S(){if(P.$i)return process.env;try{return await(0,c.$rm)(this.N,this.O,{_:[]},process.env)}catch(l){return this.O.error("ptyHost was unable to resolve shell environment",l),{}}}U(){const l=this.M.start(),d=l.client;this.O.getLevel()===E.LogLevel.Trace&&this.O.trace("PtyHostService#_startPtyHost",new Error().stack?.replace(/^Error/,"")),B.ProxyChannel.toService(d.getChannel(y.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.X()),this.X(!0),this.B(l.onDidProcessExit(o=>{this.u.fire(o.code),!this.m&&!this.q.isDisposed&&(this.n<=w.MaxRestarts?(this.O.error(`ptyHost terminated unexpectedly with code ${o.code}`),this.n++,this.restartPtyHost()):this.O.error(`ptyHost terminated unexpectedly with code ${o.code}, giving up`))}));const t=B.ProxyChannel.toService(d.getChannel(y.TerminalIpcChannels.PtyHost));return this.B(t.onProcessData(o=>this.D.fire(o))),this.B(t.onProcessReady(o=>this.F.fire(o))),this.B(t.onProcessExit(o=>this.L.fire(o))),this.B(t.onDidChangeProperty(o=>this.J.fire(o))),this.B(t.onProcessReplay(o=>this.G.fire(o))),this.B(t.onProcessOrphanQuestion(o=>this.H.fire(o))),this.B(t.onDidRequestDetach(o=>this.I.fire(o))),this.B(new h.$Vr(this.P,d.getChannel(y.TerminalIpcChannels.Logger))),this.a=l,this.b=t,this.w.fire(),this.B(this.N.onDidChangeConfiguration(async o=>{o.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this.R()})),this.R(),[l,t]}async createProcess(l,d,a,t,o,r,i,s,u,b,I){const D=setTimeout(()=>this.$(),y.HeartbeatConstants.CreateProcessTimeout),R=await this.f.createProcess(l,d,a,t,o,r,i,s,u,b,I);return clearTimeout(D),R}updateTitle(l,d,a){return this.f.updateTitle(l,d,a)}updateIcon(l,d,a,t){return this.f.updateIcon(l,d,a,t)}attachToProcess(l){return this.f.attachToProcess(l)}detachFromProcess(l,d){return this.f.detachFromProcess(l,d)}shutdownAll(){return this.f.shutdownAll()}listProcesses(){return this.f.listProcesses()}async getPerformanceMarks(){return this.g?.getPerformanceMarks()??[]}async reduceConnectionGraceTime(){return this.g?.reduceConnectionGraceTime()}start(l){return this.f.start(l)}shutdown(l,d){return this.f.shutdown(l,d)}input(l,d){return this.f.input(l,d)}processBinary(l,d){return this.f.processBinary(l,d)}resize(l,d,a){return this.f.resize(l,d,a)}clearBuffer(l){return this.f.clearBuffer(l)}acknowledgeDataEvent(l,d){return this.f.acknowledgeDataEvent(l,d)}setUnicodeVersion(l,d){return this.f.setUnicodeVersion(l,d)}getInitialCwd(l){return this.f.getInitialCwd(l)}getCwd(l){return this.f.getCwd(l)}async getLatency(){const l=new v.$3d,d=await this.f.getLatency();return l.stop(),[{label:"ptyhostservice<->ptyhost",latency:l.elapsed()},...d]}orphanQuestionReply(l){return this.f.orphanQuestionReply(l)}installAutoReply(l,d){return this.f.installAutoReply(l,d)}uninstallAllAutoReplies(){return this.f.uninstallAllAutoReplies()}uninstallAutoReply(l){return this.f.uninstallAutoReply(l)}getDefaultSystemShell(l){return this.g?.getDefaultSystemShell(l)??(0,m.$bm)(l??P.OS,process.env)}async getProfiles(l,d,a,t=!1){const o=await this.S();return(0,g.$ds)(d,a,t,this.N,o,void 0,this.O,this.bb.bind(this,l))}async getEnvironment(){return this.b?this.f.getEnvironment():{...process.env}}getWslPath(l,d){return this.f.getWslPath(l,d)}getRevivedPtyNewId(l,d){return this.f.getRevivedPtyNewId(l,d)}setTerminalLayoutInfo(l){return this.f.setTerminalLayoutInfo(l)}async getTerminalLayoutInfo(l){return this.g?.getTerminalLayoutInfo(l)}async requestDetachInstance(l,d){return this.f.requestDetachInstance(l,d)}async acceptDetachInstanceReply(l,d){return this.f.acceptDetachInstanceReply(l,d)}async freePortKillProcess(l){if(!this.f.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.f.freePortKillProcess(l)}async serializeTerminalState(l){return this.f.serializeTerminalState(l)}async reviveTerminalProcesses(l,d,a){return this.f.reviveTerminalProcesses(l,d,a)}async refreshProperty(l,d){return this.f.refreshProperty(l,d)}async updateProperty(l,d,a){return this.f.updateProperty(l,d,a)}async restartPtyHost(){this.W(),this.r=!0,this.U()}W(){this.f.shutdownAll(),this.c.store.dispose()}X(l){this.ab(),this.s=setTimeout(()=>this.Y(),l?y.HeartbeatConstants.ConnectingBeatInterval:y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier),this.r||(this.r=!0,this.z.fire())}Y(){this.O.warn(`No ptyHost heartbeat after ${y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.s=void 0,this.t=setTimeout(()=>this.Z(),y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.SecondWaitMultiplier)}Z(){this.O.error(`No ptyHost heartbeat after ${(y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier+y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.t=void 0,this.r&&(this.r=!1,this.y.fire())}$(){this.ab(),this.O.error(`No ptyHost response to createProcess after ${y.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.r&&(this.r=!1,this.y.fire())}ab(){this.s&&(clearTimeout(this.s),this.s=void 0),this.t&&(clearTimeout(this.t),this.t=void 0)}bb(l,d){return this.j.createRequest({workspaceId:l,originalText:d})}async acceptPtyHostResolvedVariables(l,d){this.j.acceptReply(l,d)}};e.$es=$,e.$es=$=Ee([ne(1,S.$Ni),ne(2,E.$Nj),ne(3,E.$Oj)],$)}),define(oe[69],ae([0,1,14,3,2,4,18,6,34]),function(J,e,n,j,P,B,S,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M_b=e.$L_b=void 0;const c="#FFFFFF",p="#1E1E1E",y="#000000",k="#FFFFFF",g="theme",m="themeBackground",v="windowSplash";e.$L_b=(0,E.$hi)("themeMainService");let w=class extends P.$Uc{constructor(f,l){super(),this.b=f,this.c=l,this.a=this.B(new j.$7d),this.onDidChangeColorScheme=this.a.event,this.B(this.c.onDidChangeConfiguration(d=>{d.affectsConfiguration("window.systemColorTheme")&&this.f()})),this.f(),this.B(j.Event.fromNodeEventEmitter(n.nativeTheme,"updated")(()=>this.a.fire(this.getColorScheme())))}f(){switch(this.c.getValue("window.systemColorTheme")){case"dark":n.nativeTheme.themeSource="dark";break;case"light":n.nativeTheme.themeSource="light";break;case"auto":switch(this.g()){case"vs":n.nativeTheme.themeSource="light";break;case"vs-dark":n.nativeTheme.themeSource="dark";break;default:n.nativeTheme.themeSource="system"}break;default:n.nativeTheme.themeSource="system";break}}getColorScheme(){if(B.$i){if(n.nativeTheme.shouldUseHighContrastColors)return{dark:n.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(B.$j){if(n.nativeTheme.shouldUseInvertedColorScheme||n.nativeTheme.shouldUseHighContrastColors)return{dark:n.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(B.$k&&n.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:n.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const f=this.getColorScheme();if(f.highContrast&&this.c.getValue("window.autoDetectHighContrast"))return f.dark?y:k;let l=this.b.getItem(m,null);if(!l)switch(this.g()){case"vs":l=c;break;case"hc-black":l=y;break;case"hc-light":l=k;break;default:l=p}return B.$j&&l.toUpperCase()===p&&(l="#171717"),l}g(){switch(this.b.getItem(g,"vs-dark").split(" ")[0]){case"vs":return"vs";case"hc-black":return"hc-black";case"hc-light":return"hc-light";default:return"vs-dark"}}saveWindowSplash(f,l){this.b.setItems([{key:g,data:l.baseTheme},{key:m,data:l.colorInfo.background},{key:v,data:l}]),typeof f=="number"&&this.h(f,l),this.f()}h(f,l){for(const d of n.BrowserWindow.getAllWindows())if(d.id===f){d.setBackgroundColor(l.colorInfo.background);break}}getWindowSplash(){return this.b.getItem(v)}};e.$M_b=w,e.$M_b=w=Ee([ne(0,h.$UP),ne(1,S.$Ni)],w)}),define(oe[130],ae([0,1,3,7,18,6,5]),function(J,e,n,j,P,B,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7v=e.$6v=e.$3v=e.$1v=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$Wv=e.$Vv=void 0,e.$Xv=c,e.$Yv=y,e.$Zv=k,e.$2v=g,e.$4v=m,e.$5v=v,e.$Vv=(0,B.$hi)("tunnelService"),e.$Wv=(0,B.$hi)("sharedTunnelsService");var E;(function(f){f.Http="http",f.Https="https"})(E||(e.TunnelProtocol=E={}));var h;(function(f){f.ConstantPrivate="constantPrivate",f.Private="private",f.Public="public"})(h||(e.TunnelPrivacyId=h={}));function c(f){return!!f.forwardPort}var p;(function(f){f[f.Notify=1]="Notify",f[f.OpenBrowser=2]="OpenBrowser",f[f.OpenPreview=3]="OpenPreview",f[f.Silent=4]="Silent",f[f.Ignore=5]="Ignore",f[f.OpenBrowserOnce=6]="OpenBrowserOnce"})(p||(e.ProvidedOnAutoForward=p={}));function y(f){if(f.scheme!=="http"&&f.scheme!=="https")return;const l=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(f.authority);if(l)return{address:l[1],port:+l[2]}}function k(f){if(f.scheme!=="http"&&f.scheme!=="https"||!f.query)return;const l=f.query.split("&");for(const d of l){const a=d.split("=")[1];if(/^https?:/.exec(a)){const t=y(j.URI.parse(a));if(t)return t}}}e.$1v=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function g(f){return e.$1v.indexOf(f)>=0}e.$3v=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function m(f){return e.$3v.indexOf(f)>=0}function v(f,l,d,a){if(d===1)return!1;if(d===2&&m(l)){const t=/(\d+)\.(\d+)\.(\d+)/g.exec(a);if(t?.length===4&&parseInt(t[1])>=18)return!1}return f<1024}class w{constructor(l,d,a){this.remoteAddress=l,this.localAddress=d,this.b=a,this.a=new n.$7d,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$6v=w;let $=class{constructor(l,d){this.k=l,this.l=d,this.a=new n.$7d,this.onTunnelOpened=this.a.event,this.b=new n.$7d,this.onTunnelClosed=this.b.event,this.c=new n.$7d,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const l=this.l.getValue("remote.localPortHost");return!l||l==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(l){return this.f=l,l?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(l){this.g=l.elevation,this.i=l.privacyOptions,this.h=l.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const l=[],d=Array.from(this.e.values());for(const a of d){const t=Array.from(a.values());for(const o of t){const r=await o.value;r&&typeof r!="string"&&l.push(r)}}return l}async dispose(){for(const l of this.e.values()){for(const{value:d}of l.values())await d.then(a=>typeof a!="string"?a?.dispose():void 0);l.clear()}this.e.clear()}setEnvironmentTunnel(l,d,a,t,o){this.q(l,d,Promise.resolve({tunnelRemoteHost:l,tunnelRemotePort:d,localAddress:a,privacy:t,protocol:o,dispose:()=>Promise.resolve()}))}async getExistingTunnel(l,d){(m(l)||g(l))&&(l=e.$1v[0]);const a=this.s(l,d);if(a)return++a.refcount,a.value}openTunnel(l,d,a,t,o,r=!1,i,s){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${d}:${a} on local port ${o}.`);const u=this.f??l;if(!u)return;if(d||(d="localhost"),t||(t=this.m),this.f&&this.j.has(a)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const b=this.t(u,d,a,t,o,r,i,s);return b?b.then(I=>{if(I){if(typeof I=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(d,a),I}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(d,a);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const D=this.o(I);return(I.tunnelRemoteHost!==d||I.tunnelRemotePort!==a)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),i&&I.privacy!==i&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(D),D}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),b)}o(l){return{tunnelRemotePort:l.tunnelRemotePort,tunnelRemoteHost:l.tunnelRemoteHost,tunnelLocalPort:l.tunnelLocalPort,localAddress:l.localAddress,privacy:l.privacy,protocol:l.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${l.tunnelRemoteHost}:${l.tunnelRemotePort} `);const d=this.e.get(l.tunnelRemoteHost);if(d){const a=d.get(l.tunnelRemotePort);a&&(a.refcount--,await this.p(l.tunnelRemoteHost,l.tunnelRemotePort,a))}}}}async p(l,d,a){if(a.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${l}:${d}.`);const t=a.value.then(async o=>{o&&typeof o!="string"&&(await o.dispose(!0),this.b.fire({host:o.tunnelRemoteHost,port:o.tunnelRemotePort}))});return this.e.has(l)&&this.e.get(l).delete(d),t}}async closeTunnel(l,d){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${l}:${d} `);const a=this.e.get(l);if(a&&a.has(d)){const t=a.get(d);t.refcount=0,await this.p(l,d,t)}}q(l,d,a){this.e.has(l)||this.e.set(l,new Map),this.e.get(l).set(d,{refcount:1,value:a})}async r(l,d){const a=this.e.get(l);if(a){const t=a.get(d),o=t?await t.value:void 0;(!o||typeof o=="string")&&a.delete(d),a.size===0&&this.e.delete(l)}}s(l,d){const a=[l];g(l)?(a.push(...e.$1v),a.push(...e.$3v)):m(l)&&a.push(...e.$3v);const t=a.map(o=>this.e.get(o));for(const o of t){const r=o?.get(d);if(r)return r}}canTunnel(l){return!!y(l)}u(l,d,a,t,o,r,i){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${d}:${a} on local port ${t}.`);const s=a;this.j.add(s);const u=t===void 0?a:t,b={elevationRequired:o?this.isPortPrivileged(u):!1},I={remoteAddress:{host:d,port:a},localAddressPort:t,privacy:r,public:r?r!==h.Private:void 0,protocol:i},D=l.forwardPort(I,b);return D?(this.q(d,a,D),D.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(s)})):this.j.delete(s),D}};e.$7v=$,e.$7v=$=Ee([ne(0,S.$Nj),ne(1,P.$Ni)],$)}),define(oe[50],ae([0,1,6]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1W=e.$ZW=e.DisablementReason=e.UpdateType=e.StateType=void 0;var j;(function(S){S.Uninitialized="uninitialized",S.Idle="idle",S.Disabled="disabled",S.CheckingForUpdates="checking for updates",S.AvailableForDownload="available for download",S.Downloading="downloading",S.Downloaded="downloaded",S.Updating="updating",S.Ready="ready"})(j||(e.StateType=j={}));var P;(function(S){S[S.Setup=0]="Setup",S[S.Archive=1]="Archive",S[S.Snap=2]="Snap"})(P||(e.UpdateType=P={}));var B;(function(S){S[S.NotBuilt=0]="NotBuilt",S[S.DisabledByEnvironment=1]="DisabledByEnvironment",S[S.ManuallyDisabled=2]="ManuallyDisabled",S[S.MissingConfiguration=3]="MissingConfiguration",S[S.InvalidConfiguration=4]="InvalidConfiguration",S[S.RunningAsAdmin=5]="RunningAsAdmin"})(B||(e.DisablementReason=B={})),e.$ZW={Uninitialized:{type:"uninitialized"},Disabled:S=>({type:"disabled",reason:S}),Idle:(S,E)=>({type:"idle",updateType:S,error:E}),CheckingForUpdates:S=>({type:"checking for updates",explicit:S}),AvailableForDownload:S=>({type:"available for download",update:S}),Downloading:{type:"downloading"},Downloaded:S=>({type:"downloaded",update:S}),Updating:S=>({type:"updating",update:S}),Ready:S=>({type:"ready",update:S})},e.$1W=(0,n.$hi)("updateService")}),define(oe[268],ae([0,1,4,191,52,45]),function(J,e,n,j,P,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),B.$Zn.as(P.$5n.Configuration).registerConfiguration({id:"update",order:15,title:(0,j.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,j.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,j.localize)(2,null),(0,j.localize)(3,null),(0,j.localize)(4,null),(0,j.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,j.localize)(6,null),deprecationMessage:(0,j.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,j.localize)(8,null),description:(0,j.localize)(9,null),included:n.$i&&!n.$o},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,j.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(oe[269],ae([0,1,3,50]),function(J,e,n,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yac=e.$Xac=void 0;class P{constructor(E){this.a=E}listen(E,h){switch(h){case"onStateChange":return this.a.onStateChange}throw new Error(`Event not found: ${h}`)}call(E,h,c){switch(h){case"checkForUpdates":return this.a.checkForUpdates(c);case"downloadUpdate":return this.a.downloadUpdate();case"applyUpdate":return this.a.applyUpdate();case"quitAndInstall":return this.a.quitAndInstall();case"_getInitialState":return Promise.resolve(this.a.state);case"isLatestVersion":return this.a.isLatestVersion();case"_applySpecificUpdate":return this.a._applySpecificUpdate(c)}throw new Error(`Call not found: ${h}`)}}e.$Xac=P;class B{get state(){return this.b}set state(E){this.b=E,this.a.fire(E)}constructor(E){this.c=E,this.a=new n.$7d,this.onStateChange=this.a.event,this.b=j.$ZW.Uninitialized,this.c.listen("onStateChange")(h=>this.state=h),this.c.call("_getInitialState").then(h=>this.state=h)}checkForUpdates(E){return this.c.call("checkForUpdates",E)}downloadUpdate(){return this.c.call("downloadUpdate")}applyUpdate(){return this.c.call("applyUpdate")}quitAndInstall(){return this.c.call("quitAndInstall")}isLatestVersion(){return this.c.call("isLatestVersion")}_applySpecificUpdate(E){return this.c.call("_applySpecificUpdate",E)}}e.$Yac=B}),define(oe[40],ae([0,1,6]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ll=void 0,e.$ll=(0,n.$hi)("IUriIdentityService")}),define(oe[270],ae([0,1,40,210,16,19,142,3,2]),function(J,e,n,j,P,B,S,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$is=void 0;class c{static{this._clock=0}constructor(k){this.uri=k,this.time=c._clock++}touch(){return this.time=c._clock++,this}}let p=class{constructor(k){this.g=k,this.c=new h.$Tc,this.f=2**16;const g=new Map,m=v=>{let w=g.get(v.scheme);return w===void 0&&(w=k.hasProvider(v)&&!this.g.hasCapability(v,1024),g.set(v.scheme,w)),w};this.c.add(E.Event.any(k.onDidChangeFileSystemProviderRegistrations,k.onDidChangeFileSystemProviderCapabilities)(v=>{g.delete(v.scheme)})),this.extUri=new B.$Jg(m),this.d=new S.$hs((v,w)=>this.extUri.compare(v,w,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(k){this.g.hasProvider(k)&&(k=(0,B.$Vg)(k));const g=this.d.get(k);return g?g.touch().uri.with({fragment:k.fragment}):(this.d.set(k,new c(k)),this.h(),k)}h(){if(this.d.size<this.f)return;const k=[...this.d.entries()].sort((m,v)=>m[1].time<v[1].time?1:m[1].time>v[1].time?-1:0);c._clock=0,this.d.clear();const g=this.f*.5;for(let m=0;m<g;m++)this.d.set(k[m][0],k[m][1].touch())}};e.$is=p,e.$is=p=Ee([ne(0,P.$Nk)],p),(0,j.$fs)(n.$ll,p,1)}),define(oe[131],ae([0,1,6]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QW=void 0,e.$QW=(0,n.$hi)("urlService")}),define(oe[271],ae([0,1,7]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8ac=e.$7ac=e.$6ac=void 0;class j{constructor(E){this.a=E}listen(E,h){throw new Error(`Event not found: ${h}`)}call(E,h,c){switch(h){case"handleURL":return this.a.handleURL(n.URI.revive(c[0]),c[1])}throw new Error(`Call not found: ${h}`)}}e.$6ac=j;class P{constructor(E){this.a=E}handleURL(E,h){return this.a.call("handleURL",[E.toJSON(),h])}}e.$7ac=P;class B{constructor(E,h){this.a=E,this.b=h}async routeCall(E,h,c,p){if(h!=="handleURL")throw new Error(`Call not found: ${h}`);if(Array.isArray(c)&&c.length>0){const y=n.URI.revive(c[0]);if(this.b.trace("URLHandlerRouter#routeCall() with URI argument",y.toString(!0)),y.query){const k=/\bwindowId=(\d+)/.exec(y.query);if(k){const g=k[1];this.b.trace(`URLHandlerRouter#routeCall(): found windowId query parameter with value "${g}"`,y.toString(!0));const m=new RegExp(`window:${g}`),v=E.connections.find(w=>(this.b.trace("URLHandlerRouter#routeCall(): testing connection",w.ctx),m.test(w.ctx)));if(v)return this.b.trace("URLHandlerRouter#routeCall(): found a connection to route",y.toString(!0)),v;this.b.trace("URLHandlerRouter#routeCall(): did not find a connection to route",y.toString(!0))}else this.b.trace("URLHandlerRouter#routeCall(): did not find windowId query parameter",y.toString(!0))}}else this.b.trace("URLHandlerRouter#routeCall() without URI argument");return this.a.routeCall(E,h,c,p)}routeEvent(E,h){throw new Error(`Event not found: ${h}`)}}e.$8ac=B}),define(oe[272],ae([0,1,8,2,7,27]),function(J,e,n,j,P,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SW=e.$RW=void 0;class S extends j.$Uc{constructor(){super(...arguments),this.a=new Set}open(c,p){const y=[...this.a.values()];return(0,n.$lh)(y.map(k=>()=>k.handleURL(c,p)),void 0,!1).then(k=>k||!1)}registerHandler(c){return this.a.add(c),(0,j.$Sc)(()=>this.a.delete(c))}}e.$RW=S;let E=class extends S{constructor(c){super(),this.b=c}create(c){let{authority:p,path:y,query:k,fragment:g}=c||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return p&&y&&y.indexOf("/")!==0&&(y=`/${y}`),P.URI.from({scheme:this.b.urlProtocol,authority:p,path:y,query:k,fragment:g})}};e.$SW=E,e.$SW=E=Ee([ne(0,B.$7j)],E)}),define(oe[273],ae([0,1,14,8,3,2,4,7]),function(J,e,n,j,P,B,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9ac=void 0;class h extends B.$Uc{constructor(p,y,k,g,m,v){if(super(),this.c=y,this.f=v,this.a=[],this.b=0,p&&(v.trace("ElectronURLListener initialUrisToHandle:",p.map(f=>f.originalUrl)),this.a=p),S.$i){const f=g.isBuilt?[]:[`"${g.appRoot}"`];f.push("--open-url","--"),n.app.setAsDefaultProtocolClient(m.urlProtocol,process.execPath,f)}const w=P.Event.map(P.Event.fromNodeEventEmitter(n.app,"open-url",(f,l)=>({event:f,url:l})),({event:f,url:l})=>(f.preventDefault(),l));this.B(w(f=>{const l=this.g(f);l&&this.c.open(l,{originalUrl:f})})),k.getWindows().filter(f=>f.isReady).length>0?(v.trace("ElectronURLListener: window is ready to handle URLs"),this.h()):(v.trace("ElectronURLListener: waiting for window to be ready to handle URLs..."),this.B(P.Event.once(k.onDidSignalReadyWindow)(()=>this.h())))}g(p){try{return E.URI.parse(p)}catch{return}}async h(){if(this.b++>10){this.f.trace("ElectronURLListener#flush(): giving up after 10 retries");return}this.f.trace("ElectronURLListener#flush(): flushing URLs");const p=[];for(const y of this.a)await this.c.open(y.uri,{originalUrl:y.originalUrl})?this.f.trace("ElectronURLListener#flush(): URL was handled",y.originalUrl):(this.f.trace("ElectronURLListener#flush(): URL was not yet handled",y.originalUrl),p.push(y));p.length!==0&&(this.a=p,(0,j.$jh)(()=>this.h(),500,this.q))}}e.$9ac=h}),define(oe[274],ae([0,1,3,2,16,59,32]),function(J,e,n,j,P,B,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jbc=void 0;class E extends j.$Uc{constructor(c,p,y,k,g,m){super(),this.f=c,this.g=p,this.h=y,this.j=k,this.m=g,this.n=m,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new n.$7d),this.onDidChangeFile=this.a.event,this.b=B.$ni.forUris(()=>!(this.capabilities&1024)),this.c=new S.$Cc(v=>this.m.extUri.getComparisonKey(this.t(v))),this.r(),this.B(k.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(v=>this.s(v)))}r(){this.c.clear();for(const c of this.j.profiles)this.c.add(c.settingsResource),this.c.add(c.keybindingsResource),this.c.add(c.tasksResource),this.c.add(c.extensionsResource)}open(c,p){return this.g.open(this.t(c),p)}close(c){return this.g.close(c)}read(c,p,y,k,g){return this.g.read(c,p,y,k,g)}write(c,p,y,k,g){return this.g.write(c,p,y,k,g)}watch(c,p){this.b.set(c,c);const y=this.g.watch(this.t(c),p);return(0,j.$Sc)(()=>{this.b.delete(c),y.dispose()})}stat(c){return this.g.stat(this.t(c))}mkdir(c){return this.g.mkdir(this.t(c))}rename(c,p,y){return this.g.rename(this.t(c),this.t(p),y)}readFile(c,p){return this.g.readFile(this.t(c),p)}readFileStream(c,p,y){return this.g.readFileStream(this.t(c),p,y)}readdir(c){return this.g.readdir(this.t(c))}enforceAtomicReadFile(c){return this.c.has(c)}writeFile(c,p,y){return this.g.writeFile(this.t(c),p,y)}enforceAtomicWriteFile(c){return this.c.has(c)?{postfix:".vsctmp"}:!1}delete(c,p){return this.g.delete(this.t(c),p)}copy(c,p,y){if((0,P.$Rk)(this.g))return this.g.copy(this.t(c),this.t(p),y);throw new Error("copy not supported")}cloneFile(c,p){if((0,P.$Sk)(this.g))return this.g.cloneFile(this.t(c),this.t(p));throw new Error("clone not supported")}s(c){const p=[];for(const y of c){if(y.resource.scheme!==this.f)continue;const k=this.u(y.resource);this.b.findSubstr(k)&&p.push({resource:k,type:y.type,cId:y.cId})}p.length&&(this.n.debug("User data changed"),this.a.fire(p))}t(c){return c.with({scheme:this.f})}u(c){return c.with({scheme:this.h})}}e.$Jbc=E}),define(oe[275],ae([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qbc=void 0,e.$qbc="utilityProcessWorker"}),define(oe[276],ae([0,1,6]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0ac=void 0,e.$0ac=(0,n.$hi)("webviewManagerService")}),define(oe[277],ae([0,1,14,2,13,7]),function(J,e,n,j,P,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$ac=void 0;class S extends j.$Uc{static{this.a=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}constructor(){super();const h=this.b.bind(this);n.protocol.registerFileProtocol(P.Schemas.vscodeWebview,h)}b(h,c){try{const p=B.URI.parse(h.url),y=S.a.get(p.path);if(typeof y=="string"){const k=`vs/workbench/contrib/webview/browser/pre/${y}`,g=P.$Bg.asFileUri(k);return c({path:g.fsPath,headers:{...P.COI.getHeadersFromQuery(h.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return c({error:-10})}catch{}return c({error:-2})}}e.$$ac=S}),define(oe[55],ae([0,1,4]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomTitleBarVisibility=e.TitlebarStyle=e.TitleBarSetting=e.$$C=void 0,e.$_C=j,e.$aD=P,e.$bD=B,e.$cD=S,e.$dD=E,e.$eD=y,e.$fD=k,e.$gD=g,e.$hD=m,e.$iD=v,e.$jD=w,e.$$C={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function j($){return typeof $.parentId=="number"}function P($){return!!$.workspaceUri}function B($){return!!$.folderUri}function S($){return!!$.fileUri}function E($){const f=k($),l=$.getValue("window.menuBarVisibility");return l==="default"||f&&l==="compact"||n.$j&&n.$m?"classic":l}var h;(function($){$.TITLE_BAR_STYLE="window.titleBarStyle",$.CUSTOM_TITLE_BAR_VISIBILITY="window.customTitleBarVisibility"})(h||(e.TitleBarSetting=h={}));var c;(function($){$.NATIVE="native",$.CUSTOM="custom"})(c||(e.TitlebarStyle=c={}));var p;(function($){$.AUTO="auto",$.WINDOWED="windowed",$.NEVER="never"})(p||(e.CustomTitleBarVisibility=p={}));function y($,f){return!0}function k($,f){return f||(f=g($)),f==="native"}function g($){if(n.$o)return"custom";const f=$.getValue("window");if(f){if(n.$j&&f.nativeTabs===!0||n.$j&&f.nativeFullScreen===!1)return"native";const a=f.titleBarStyle;if(a==="native"||a==="custom")return a}return n.$k?"native":"custom"}function m($){return!(!n.$i||n.$o||k($))}function v($){const f=$.getValue("window");return!f||typeof f.nativeFullScreen!="boolean"||f.nativeTabs?!0:f.nativeFullScreen!==!1}function w($=0){return Math.pow(1.2,$)}}),define(oe[81],ae([0,1,14]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.$B_b=e.$A_b=e.UnloadReason=e.LoadReason=void 0;var j;(function(c){c[c.INITIAL=1]="INITIAL",c[c.LOAD=2]="LOAD",c[c.RELOAD=3]="RELOAD"})(j||(e.LoadReason=j={}));var P;(function(c){c[c.CLOSE=1]="CLOSE",c[c.QUIT=2]="QUIT",c[c.RELOAD=3]="RELOAD",c[c.LOAD=4]="LOAD"})(P||(e.UnloadReason=P={}));const B=function(c=1){return{width:1024,height:768,mode:c}};e.$A_b=B;const S=function(){const y=n.screen.getPrimaryDisplay().workArea,k=Math.max(y.x+y.width/2-800/2,0),g=Math.max(y.y+y.height/2-600/2,0);return{x:k,y:g,width:800,height:600,mode:1}};e.$B_b=S;var E;(function(c){c[c.Maximized=0]="Maximized",c[c.Normal=1]="Normal",c[c.Minimized=2]="Minimized",c[c.Fullscreen=3]="Fullscreen"})(E||(e.WindowMode=E={}));var h;(function(c){c[c.UNRESPONSIVE=1]="UNRESPONSIVE",c[c.PROCESS_GONE=2]="PROCESS_GONE",c[c.LOAD=3]="LOAD"})(h||(e.WindowError=h={}))}),define(oe[278],ae([0,1,8,3,2]),function(J,e,n,j,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ebc=void 0;class B extends P.$Uc{constructor({onDidOpenMainWindow:E,onDidFocusMainWindow:h,getActiveWindowId:c}){super(),this.a=this.B(new P.$Tc),j.Event.latch(j.Event.any(E,h))(this.f,this,this.a),this.b=(0,n.$7g)(()=>c()),(async()=>{try{const y=await this.b;this.c=typeof this.c=="number"?this.c:y}catch{}finally{this.b=void 0}})()}f(E){this.b&&(this.b.cancel(),this.b=void 0),this.c=E}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$ebc=B}),define(oe[30],ae([0,1,195,9,59,19,7,6,13]),function(J,e,n,j,P,B,S,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ji=e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Bi=e.$Ai=e.WorkbenchState=e.$ui=e.$ti=e.$qi=void 0,e.$ri=c,e.$si=p,e.$vi=y,e.$wi=k,e.$xi=g,e.$yi=v,e.$zi=w,e.$Ci=l,e.$Hi=d,e.$Ii=a,e.$Ki=t,e.$Li=o,e.$Mi=r,e.$qi=(0,E.$hi)("contextService");function c(i){const s=i;return typeof s?.id=="string"&&S.URI.isUri(s.uri)}function p(i){return typeof i?.id=="string"&&!c(i)&&!k(i)}e.$ti={id:"ext-dev"},e.$ui={id:"empty-window"};function y(i,s){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,j.$oc)(i)}:s?e.$ti:e.$ui;const u=i;return u.configuration?{id:u.id,configPath:u.configuration}:u.folders.length===1?{id:u.id,uri:u.folders[0].uri}:{id:u.id}}function k(i){const s=i;return typeof s?.id=="string"&&S.URI.isUri(s.configPath)}function g(i){const s=i;if(s?.uri)return{id:s.id,uri:S.URI.revive(s.uri)};const u=i;if(u?.configPath)return{id:u.id,configPath:S.URI.revive(u.configPath)};if(i?.id)return{id:i.id}}var m;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(m||(e.WorkbenchState=m={}));function v(i){const s=i;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}function w(i){const s=i;return!!(s&&typeof s=="object"&&S.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}class ${constructor(s,u,b,I,D){this.h=s,this.j=b,this.k=I,this.l=D,this.c=P.$ni.forUris(this.l,()=>!0),this.folders=u}update(s){this.h=s.id,this.k=s.configuration,this.j=s.transient,this.l=s.l,this.folders=s.folders}get folders(){return this.g}set folders(s){this.g=s,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(s){this.k=s}getFolder(s){return s&&this.c.findSubstr(s)||null}n(){this.c=P.$ni.forUris(this.l,()=>!0);for(const s of this.folders)this.c.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Ai=$;class f{constructor(s,u){this.raw=u,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,B.$Ug)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Bi=f;function l(i){return new f({uri:i,index:0,name:(0,B.$Qg)(i)},{uri:i.toString()})}e.$Di="code-workspace",e.$Ei=`.${e.$Di}`,e.$Fi=[{name:(0,n.localize)(0,null),extensions:[e.$Di]}],e.$Gi="workspace.json";function d(i,s){return B.$Lg.isEqualOrParent(i,s.untitledWorkspacesHome)}function a(i){let s;return S.URI.isUri(i)?s=i:s=i.configuration,s?.scheme===h.Schemas.tmp}e.$Ji="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(i){return i.id===e.$Ji}function o(i,s){return!d(i,s)&&!a(i)}function r(i){return(typeof i=="string"?(0,j.$pc)(i):(0,B.$Sg)(i))===e.$Ei}}),define(oe[56],ae([0,1,14,8,46,48,2,86,4,21,169,119,6,5,27,30]),function(J,e,n,j,P,B,S,E,h,c,p,y,k,g,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J_b=e.$I_b=void 0,e.$I_b=(0,k.$hi)("dialogMainService");let w=class{constructor(f,l){this.d=f,this.e=l,this.a=new Map,this.b=new Map,this.c=new j.$oh}pickFileFolder(f,l){return this.f({...f,pickFolders:!0,pickFiles:!0,title:(0,p.localize)(0,null)},l)}pickFolder(f,l){return this.f({...f,pickFolders:!0,title:(0,p.localize)(1,null)},l)}pickFile(f,l){return this.f({...f,pickFiles:!0,title:(0,p.localize)(2,null)},l)}pickWorkspace(f,l){const d=(0,p.localize)(3,null),a=(0,B.$mw)((0,p.localize)(4,null)),t=v.$Fi;return this.f({...f,pickFiles:!0,title:d,filters:t,buttonLabel:a},l)}async f(f,l){const d={title:f.title,buttonLabel:f.buttonLabel,filters:f.filters,defaultPath:f.defaultPath};(typeof f.pickFiles=="boolean"||typeof f.pickFolders=="boolean")&&(d.properties=void 0,f.pickFiles&&f.pickFolders&&(d.properties=["multiSelections","openDirectory","openFile","createDirectory"])),d.properties||(d.properties=["multiSelections",f.pickFolders?"openDirectory":"openFile","createDirectory"]),h.$j&&d.properties.push("treatPackageAsDirectory");const a=await this.showOpenDialog(d,(l||n.BrowserWindow.getFocusedWindow())??void 0);if(a&&a.filePaths&&a.filePaths.length>0)return a.filePaths}g(f){if(f){let l=this.b.get(f.id);return l||(l=new j.$oh,this.b.set(f.id,l)),l}else return this.c}showMessageBox(f,l){return this.g(l).queue(async()=>{const{options:d,buttonIndeces:a}=(0,y.$tw)(f,this.e);let t;return l?t=await n.dialog.showMessageBox(l,d):t=await n.dialog.showMessageBox(d),{response:a[t.response],checkboxChecked:t.checkboxChecked}})}async showSaveDialog(f,l){const d=this.j(f,l);if(!d)return this.d.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.g(l).queue(async()=>{let a;return l?a=await n.dialog.showSaveDialog(l,f):a=await n.dialog.showSaveDialog(f),a.filePath=this.h(a.filePath),a})}finally{(0,S.$Pc)(d)}}h(f){return f&&h.$j&&(f=(0,E.$Yl)(f)),f}i(f){return f.map(l=>this.h(l))}async showOpenDialog(f,l){f.defaultPath&&(await c.Promises.exists(f.defaultPath)||(f.defaultPath=void 0));const d=this.j(f,l);if(!d)return this.d.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.g(l).queue(async()=>{let a;return l?a=await n.dialog.showOpenDialog(l,f):a=await n.dialog.showOpenDialog(f),a.filePaths=this.i(a.filePaths),a})}finally{(0,S.$Pc)(d)}}j(f,l){if(!l)return S.$Uc.None;this.d.trace("[DialogMainService]: request to acquire file dialog lock",f);let d=this.a.get(l.id);d||(d=new Set,this.a.set(l.id,d));const a=(0,P.$8i)(f);if(!d.has(a))return this.d.trace("[DialogMainService]: new file dialog lock created",f),d.add(a),(0,S.$Sc)(()=>{this.d.trace("[DialogMainService]: file dialog lock disposed",f),d?.delete(a),d?.size===0&&this.a.delete(l.id)})}};e.$J_b=w,e.$J_b=w=Ee([ne(0,g.$Nj),ne(1,m.$7j)],w)}),define(oe[279],ae([0,1,3,2,76,30]),function(J,e,n,j,P,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uac=void 0;class S extends j.$Uc{static{this.a=100}constructor(h,c){super(),this.f=h,this.g=c,this.b=this.B(new n.$7d),this.c=new Map,this.h(c.applicationStorage,this.b)}h(h,c){this.B(n.Event.debounce(h.onDidChangeStorage,(p,y)=>(p?p.push(y):p=[y],p),S.a)(p=>{p.length&&c.fire(this.j(p,h))}))}j(h,c){const p=new Map,y=new Set;return h.forEach(k=>{const g=c.get(k.key);typeof g=="string"?p.set(k.key,g):y.add(k.key)}),{changed:Array.from(p.entries()),deleted:Array.from(y.values())}}listen(h,c,p){switch(c){case"onDidChangeStorage":{const y=p.profile?(0,P.$Qh)(p.profile):void 0;if(!y)return this.b.event;let k=this.c.get(y.id);return k||(k=this.B(new n.$7d),this.h(this.g.profileStorage(y),k),this.c.set(y.id,k)),k.event}}throw new Error(`Event not found: ${c}`)}async call(h,c,p){const y=p.profile?(0,P.$Qh)(p.profile):void 0,k=(0,B.$xi)(p.workspace),g=await this.m(y,k);switch(c){case"getItems":return Array.from(g.items.entries());case"updateItems":{const m=p;if(m.insert)for(const[v,w]of m.insert)g.set(v,w);m.delete?.forEach(v=>g.delete(v));break}case"optimize":return g.optimize();case"isUsed":{const m=p.payload;if(typeof m=="string")return this.g.isUsed(m)}default:throw new Error(`Call not found: ${c}`)}}async m(h,c){let p;c?p=this.g.workspaceStorage(c):h?p=this.g.profileStorage(h):p=this.g.applicationStorage;try{await p.init()}catch(y){this.f.error(`StorageIPC#init: Unable to init ${c?"workspace":h?"profile":"application"} storage due to ${y}`)}return p}}e.$Uac=S}),define(oe[41],ae([0,1,46,3,2,19,7,192,38,16,6,5,30,32,40,8,33,25,12]),function(J,e,n,j,P,B,S,E,h,c,p,y,k,g,m,v,w,$,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rl=e.$ql=e.$nl=e.ProfileResourceType=void 0,e.$ml=d,e.$ol=a,e.$pl=t;var l;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})(l||(e.ProfileResourceType=l={}));function d(i){const s=i;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&typeof s.isDefault=="boolean"&&typeof s.name=="string"&&S.URI.isUri(s.location)&&S.URI.isUri(s.globalStorageHome)&&S.URI.isUri(s.settingsResource)&&S.URI.isUri(s.keybindingsResource)&&S.URI.isUri(s.tasksResource)&&S.URI.isUri(s.snippetsHome)&&S.URI.isUri(s.extensionsResource))}e.$nl=(0,p.$hi)("IUserDataProfilesService");function a(i,s){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,icon:i.icon,location:S.URI.revive(i.location).with({scheme:s}),globalStorageHome:S.URI.revive(i.globalStorageHome).with({scheme:s}),settingsResource:S.URI.revive(i.settingsResource).with({scheme:s}),keybindingsResource:S.URI.revive(i.keybindingsResource).with({scheme:s}),tasksResource:S.URI.revive(i.tasksResource).with({scheme:s}),snippetsHome:S.URI.revive(i.snippetsHome).with({scheme:s}),extensionsResource:S.URI.revive(i.extensionsResource).with({scheme:s}),cacheHome:S.URI.revive(i.cacheHome).with({scheme:s}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}function t(i,s,u,b,I,D){return{id:i,name:s,location:u,isDefault:!1,shortName:I?.shortName,icon:I?.icon,globalStorageHome:D&&I?.useDefaultFlags?.globalState?D.globalStorageHome:(0,B.$Ug)(u,"globalStorage"),settingsResource:D&&I?.useDefaultFlags?.settings?D.settingsResource:(0,B.$Ug)(u,"settings.json"),keybindingsResource:D&&I?.useDefaultFlags?.keybindings?D.keybindingsResource:(0,B.$Ug)(u,"keybindings.json"),tasksResource:D&&I?.useDefaultFlags?.tasks?D.tasksResource:(0,B.$Ug)(u,"tasks.json"),snippetsHome:D&&I?.useDefaultFlags?.snippets?D.snippetsHome:(0,B.$Ug)(u,"snippets"),extensionsResource:D&&I?.useDefaultFlags?.extensions?D.extensionsResource:(0,B.$Ug)(u,"extensions.json"),cacheHome:(0,B.$Ug)(b,i),useDefaultFlags:I?.useDefaultFlags,isTransient:I?.transient}}let o=class extends P.$Uc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(s,u,b,I){super(),this.t=s,this.u=u,this.w=b,this.y=I,this.f=!0,this.h=this.B(new j.$7d),this.onDidChangeProfiles=this.h.event,this.j=this.B(new j.$7d),this.onWillCreateProfile=this.j.event,this.m=this.B(new j.$7d),this.onWillRemoveProfile=this.m.event,this.n=this.B(new j.$7d),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new g.$Bc,emptyWindows:new Map},this.profilesHome=(0,B.$Ug)(this.t.userRoamingDataHome,"profiles"),this.g=(0,B.$Ug)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(s){this.f!==s&&(this.z=void 0,this.f=s)}isEnabled(){return this.f}get C(){if(!this.z){const s=this.D(),u=[s];if(this.f)try{for(const D of this.O()){if(!D.name||!(0,f.$Uf)(D.name)||!D.location){this.y.warn("Skipping the invalid stored profile",D.location||D.name);continue}u.push(t((0,B.$Rg)(D.location),D.name,D.location,this.g,{shortName:D.shortName,icon:D.icon,useDefaultFlags:D.useDefaultFlags},s))}}catch(D){this.y.error(D)}const b=new g.$Bc,I=new Map;if(u.length)try{const D=this.Q();if(D.workspaces)for(const[R,C]of Object.entries(D.workspaces)){const A=S.URI.parse(R),L=u.find(W=>W.id===C);L&&b.set(A,L)}if(D.emptyWindows)for(const[R,C]of Object.entries(D.emptyWindows)){const A=u.find(L=>L.id===C);A&&I.set(R,A)}}catch(D){this.y.error(D)}this.z={profiles:u,workspaces:b,emptyWindows:I}}return this.z}D(){const s=t("__default__profile__",(0,E.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...s,extensionsResource:this.S()??s.extensionsResource,isDefault:!0}}async createTransientProfile(s){const u="Temp",b=new RegExp(`${(0,$.$Ze)(u)}\\s(\\d+)`);let I=0;for(const R of this.profiles){const C=b.exec(R.name),A=C?parseInt(C[1]):0;I=A>I?A:I}const D=`${u} ${I+1}`;return this.createProfile((0,n.$8i)((0,w.$Dg)()).toString(16),D,{transient:!0},s)}async createNamedProfile(s,u,b){return this.createProfile((0,n.$8i)((0,w.$Dg)()).toString(16),s,u,b)}async createProfile(s,u,b,I){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const D=await this.F(s,u,b);return I&&await this.setProfileForWorkspace(I,D),D}async F(s,u,b){if(!(0,f.$Uf)(u)||!u)throw new Error("Name of the profile is mandatory and must be of type `string`");let I=this.r.get(u);return I||(I=(async()=>{try{const D=this.profiles.find(A=>A.name===u||A.id===s);if(D)return D;const R=t(s,u,(0,B.$Ug)(this.profilesHome,s),this.g,b,this.defaultProfile);await this.u.createFolder(R.location);const C=[];return this.j.fire({profile:R,join(A){C.push(A)}}),await v.Promises.settled(C),this.I([R],[],[]),R}finally{this.r.delete(u)}})(),this.r.set(u,I)),I}async updateProfile(s,u){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let b=this.profiles.find(I=>I.id===s.id);if(!b)throw new Error(`Profile '${s.name}' does not exist`);return b=t(b.id,u.name??b.name,b.location,this.g,{shortName:u.shortName??b.shortName,icon:u.icon===null?void 0:u.icon??b.icon,transient:u.transient??b.isTransient,useDefaultFlags:u.useDefaultFlags??b.useDefaultFlags},this.defaultProfile),this.I([],[],[b]),b}async removeProfile(s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(s.isDefault)throw new Error("Cannot remove default profile");const u=this.profiles.find(I=>I.id===s.id);if(!u)throw new Error(`Profile '${s.name}' does not exist`);const b=[];this.m.fire({profile:u,join(I){b.push(I)}});try{await Promise.allSettled(b)}catch(I){this.y.error(I)}for(const I of[...this.C.emptyWindows.keys()])u.id===this.C.emptyWindows.get(I)?.id&&this.C.emptyWindows.delete(I);for(const I of[...this.C.workspaces.keys()])u.id===this.C.workspaces.get(I)?.id&&this.C.workspaces.delete(I);this.M(),this.I([],[u],[]);try{await this.u.del(u.cacheHome,{recursive:!0})}catch(I){(0,c.$5k)(I)!==1&&this.y.error(I)}}async setProfileForWorkspace(s,u){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const b=this.profiles.find(I=>I.id===u.id);if(!b)throw new Error(`Profile '${u.name}' does not exist`);this.L(s,b)}unsetWorkspace(s,u){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(s,void 0,u)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const s=await this.u.resolve(this.profilesHome);await Promise.all((s.children||[]).filter(u=>u.isDirectory&&this.profiles.every(b=>!this.w.extUri.isEqual(b.location,u.resource))).map(u=>this.u.del(u.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const s=this.s.profiles.filter(u=>!this.H(u));await Promise.allSettled(s.map(u=>this.removeProfile(u)))}getProfileForWorkspace(s){const u=this.G(s);return S.URI.isUri(u)?this.s.workspaces.get(u)??this.C.workspaces.get(u):this.s.emptyWindows.get(u)??this.C.emptyWindows.get(u)}G(s){return(0,k.$ri)(s)?s.uri:(0,k.$wi)(s)?s.configPath:s.id}H(s){return!!([...this.s.emptyWindows.values()].some(u=>this.w.extUri.isEqual(u.location,s.location))||[...this.s.workspaces.values()].some(u=>this.w.extUri.isEqual(u.location,s.location))||[...this.C.emptyWindows.values()].some(u=>this.w.extUri.isEqual(u.location,s.location))||[...this.C.workspaces.values()].some(u=>this.w.extUri.isEqual(u.location,s.location)))}I(s,u,b){const I=[...this.profiles,...s],D=[];this.s.profiles=[];for(let R of I)R.isDefault||u.some(C=>R.id===C.id)||(R=b.find(C=>R.id===C.id)??R,R.isTransient?this.s.profiles.push(R):D.push({location:R.location,name:R.name,shortName:R.shortName,icon:R.icon,useDefaultFlags:R.useDefaultFlags}));this.P(D),this.z=void 0,this.J(s,u,b)}J(s,u,b){this.h.fire({added:s,removed:u,updated:b,all:this.profiles})}L(s,u,b){b=u?.isTransient?!0:b,b||this.L(s,void 0,!0);const I=this.G(s),D=b?this.s:this.C;S.URI.isUri(I)?(D.workspaces.delete(I),u&&D.workspaces.set(I,u)):(D.emptyWindows.delete(I),u&&D.emptyWindows.set(I,u)),b||this.M()}M(){const s={};for(const[b,I]of this.C.workspaces.entries())s[b.toString()]=I.id;const u={};for(const[b,I]of this.C.emptyWindows.entries())u[b.toString()]=I.id;this.R({workspaces:s,emptyWindows:u}),this.z=void 0}N(s){const u={},b=this.D();if(s.workspaces)for(const[D,R]of Object.entries(s.workspaces)){const C=S.URI.parse(R);u[D]=this.w.extUri.isEqual(C,b.location)?b.id:this.w.extUri.basename(C)}const I={};if(s.emptyWindows)for(const[D,R]of Object.entries(s.emptyWindows)){const C=S.URI.parse(R);I[D]=this.w.extUri.isEqual(C,b.location)?b.id:this.w.extUri.basename(C)}return{workspaces:u,emptyWindows:I}}O(){return[]}P(s){throw new Error("not implemented")}Q(){return{}}R(s){throw new Error("not implemented")}S(){}};e.$ql=o,e.$ql=o=Ee([ne(0,h.$oi),ne(1,c.$Nk),ne(2,m.$ll),ne(3,y.$Nj)],o);class r extends o{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(s){this.a=s}Q(){return this.X}R(s){this.X=s}}e.$rl=r}),define(oe[82],ae([0,1,8,17,2,3,32,7,121,127,16,6,5,41,40,12,15,28]),function(J,e,n,j,P,B,S,E,h,c,p,y,k,g,m,v,w,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bq=e.$aq=e.$_p=e.ExtensionsProfileScanningErrorCode=void 0;var f;(function(o){o.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",o.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(f||(e.ExtensionsProfileScanningErrorCode=f={}));class l extends Error{constructor(r,i){super(r),this.code=i}}e.$_p=l,e.$aq=(0,y.$hi)("IExtensionsProfileScannerService");let d=class extends P.$Uc{constructor(r,i,s,u,b,I){super(),this.j=r,this.m=i,this.n=s,this.r=u,this.s=b,this.t=I,this.b=this.B(new B.$7d),this.onAddExtensions=this.b.event,this.c=this.B(new B.$7d),this.onDidAddExtensions=this.c.event,this.f=this.B(new B.$7d),this.onRemoveExtensions=this.f.event,this.g=this.B(new B.$7d),this.onDidRemoveExtensions=this.g.event,this.h=new S.$Bc}scanProfileExtensions(r,i){return this.u(r,void 0,i)}async addExtensionsToProfile(r,i,s){const u=[],b=[];try{return await this.u(i,I=>{const D=[];if(s)D.push(...I);else for(const R of I)r.some(([C])=>(0,c.$fp)(C.identifier,R.identifier)&&C.manifest.version!==R.version)?u.push(R):D.push(R);for(const[R,C]of r){const A=D.findIndex(W=>(0,c.$fp)(W.identifier,R.identifier)&&W.version===R.manifest.version),L={identifier:R.identifier,version:R.manifest.version,location:R.location,metadata:C};A===-1?(b.push(L),D.push(L)):D.splice(A,1,L)}return b.length&&this.b.fire({extensions:b,profileLocation:i}),u.length&&this.f.fire({extensions:u,profileLocation:i}),D}),b.length&&this.c.fire({extensions:b,profileLocation:i}),u.length&&this.g.fire({extensions:u,profileLocation:i}),b}catch(I){throw b.length&&this.c.fire({extensions:b,error:I,profileLocation:i}),u.length&&this.g.fire({extensions:u,error:I,profileLocation:i}),I}}async updateMetadata(r,i){const s=[];return await this.u(i,u=>{const b=[];for(const I of u){const D=r.find(([R])=>(0,c.$fp)(R.identifier,I.identifier)&&R.manifest.version===I.version);D&&(I.metadata={...I.metadata,...D[1]},s.push(I)),b.push(I)}return b}),s}async removeExtensionFromProfile(r,i){const s=[];try{await this.u(i,u=>{const b=[];for(const I of u)(0,c.$fp)(I.identifier,r.identifier)?s.push(I):b.push(I);return s.length&&this.f.fire({extensions:s,profileLocation:i}),b}),s.length&&this.g.fire({extensions:s,profileLocation:i})}catch(u){throw s.length&&this.g.fire({extensions:s,error:u,profileLocation:i}),u}}async u(r,i,s){return this.F(r).queue(async()=>{let u=[],b;try{const I=await this.m.readFile(r);b=JSON.parse(I.value.toString().trim()||"[]")}catch(I){if((0,p.$5k)(I)!==1)throw I;if(this.r.extUri.isEqual(r,this.n.defaultProfile.extensionsResource)&&(b=await this.D()),!b&&s?.bailOutWhenFileNotFound)throw new l((0,w.$0)(I),"ERROR_PROFILE_NOT_FOUND")}if(b){Array.isArray(b)||this.w(r);let I=!1;for(const D of b){a(D)||this.w(r);let R;if((0,v.$Uf)(D.relativeLocation)&&D.relativeLocation)R=this.z(D.relativeLocation);else if((0,v.$Uf)(D.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${D.location}`);continue}else{R=E.URI.revive(D.location);const C=this.y(R);C&&(I=!0,D.relativeLocation=C)}(0,v.$2f)(D.metadata?.hasPreReleaseVersion)&&D.metadata?.preRelease&&(I=!0,D.metadata.hasPreReleaseVersion=!0),u.push({identifier:D.identifier,location:R,version:D.version,metadata:D.metadata})}I&&await this.m.writeFile(r,j.$ue.fromString(JSON.stringify(b)))}if(i){u=i(u);const I=u.map(D=>({identifier:D.identifier,version:D.version,location:D.location.toJSON(),relativeLocation:this.y(D.location),metadata:D.metadata}));await this.m.writeFile(r,j.$ue.fromString(JSON.stringify(I)))}return u})}w(r){const i=new l(`Invalid extensions content in ${r.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}y(r){return this.r.extUri.isEqual(this.r.extUri.dirname(r),this.j)?this.r.extUri.basename(r):void 0}z(r){return this.r.extUri.joinPath(this.j,r)}async D(){return this.C||(this.C=(async()=>{const r=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),i=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let s;try{s=(await this.m.readFile(r)).value.toString()}catch(b){if((0,p.$5k)(b)===1)return;throw b}this.t.info("Migrating extensions from old default profile location",r.toString());let u;try{const b=JSON.parse(s);Array.isArray(b)&&b.every(I=>a(I))?u=b:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",b)}catch(b){this.t.error(b)}if(u)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,j.$ue.fromString(JSON.stringify(u)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",r.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(b){if((0,p.$5k)(b)===3)this.t.info("Migration from old default profile location to new location is done by another window",r.toString(),this.n.defaultProfile.extensionsResource.toString());else throw b}try{await this.m.del(r)}catch(b){(0,p.$5k)(b)!==1&&this.t.error(b)}try{await this.m.del(i)}catch(b){(0,p.$5k)(b)!==1&&this.t.error(b)}return u})()),this.C}F(r){let i=this.h.get(r);return i||(i=new n.$oh,this.h.set(r,i)),i}};e.$bq=d,e.$bq=d=Ee([ne(1,p.$Nk),ne(2,g.$nl),ne(3,m.$ll),ne(4,$.$Ml),ne(5,k.$Nj)],d);function a(o){return(0,v.$Wf)(o)&&(0,h.$Po)(o.identifier)&&(t(o.location)||(0,v.$Uf)(o.location)&&o.location)&&((0,v.$2f)(o.relativeLocation)||(0,v.$Uf)(o.relativeLocation))&&o.version&&(0,v.$Uf)(o.version)}function t(o){return o?(0,v.$Uf)(o.path)&&(0,v.$Uf)(o.scheme):!1}}),define(oe[132],ae([0,1,22,8,35,17,15,42,154,2,13,9,4,19,208,73,12,7,174,38,127,124,207,16,6,5,27,3,76,82,41,40,206]),function(J,e,n,j,P,B,S,E,h,c,p,y,k,g,m,v,w,$,f,l,d,a,t,o,r,i,s,u,b,I,D,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iq=e.$gq=e.$fq=e.$eq=e.Translations=void 0,e.$hq=le;var A;(function(ue){function X(Q,z){if(Q===z)return!0;const M=Object.keys(Q),F=new Set;for(const G of Object.keys(z))F.add(G);if(M.length!==F.size)return!1;for(const G of M){if(Q[G]!==z[G])return!1;F.delete(G)}return F.size===0}ue.equals=X})(A||(e.Translations=A={})),e.$eq=(0,r.$hi)("IExtensionsScannerService");let L=class extends c.$Uc{constructor(X,Q,z,M,F,G,T,ce,he,K,O,N){super(),this.systemExtensionsLocation=X,this.userExtensionsLocation=Q,this.r=z,this.s=M,this.t=F,this.u=G,this.w=T,this.y=ce,this.z=he,this.C=K,this.D=O,this.F=N,this.g=this.B(new u.$7d),this.onDidChangeCache=this.g.event,this.h=(0,g.$Ug)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(H,this.s,this.h)),this.m=this.B(this.F.createInstance(H,this.s,this.h)),this.n=this.B(this.F.createInstance(q,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,d.$qp)(this.w,this.y)),this.G}async scanAllExtensions(X,Q,z){const[M,F]=await Promise.all([this.scanSystemExtensions(X),this.scanUserExtensions(Q)]),G=z?await this.scanExtensionsUnderDevelopment(X,[...M,...F]):[];return this.L(M,F,G,await this.getTargetPlatform(),!0)}async scanSystemExtensions(X){const Q=[];Q.push(this.M(!!X.useCache,X.language)),Q.push(this.N(X.language,!!X.checkControlFile));const[z,M]=await Promise.all(Q);return this.J([...z,...M],0,X,!1)}async scanUserExtensions(X){const Q=X.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",Q);const z=this.D.extUri.isEqual(X.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,M=await this.P(Q,!!X.profileLocation,1,!X.includeUninstalled,X.language,!0,z,X.productVersion??this.R()),F=X.useCache&&!M.devMode&&M.excludeObsolete?this.m:this.n;let G;try{G=await F.scanExtensions(M)}catch(T){if(T instanceof I.$_p&&T.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),G=await F.scanExtensions(M);else throw T}return G=await this.J(G,1,X,!0),this.y.trace("Scanned user extensions:",G.length),G}async scanExtensionsUnderDevelopment(X,Q){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const z=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(M=>M.scheme===p.Schemas.file).map(async M=>{const F=await this.P(M,!1,1,!0,X.language,!1,void 0,X.productVersion??this.R());return(await this.n.scanOneOrMultipleExtensions(F)).map(T=>(T.type=Q.find(ce=>(0,d.$fp)(ce.identifier,T.identifier))?.type??T.type,this.n.validate(T,F)))}))).flat();return this.J(z,"development",X,!0)}return[]}async scanExistingExtension(X,Q,z){const M=await this.P(X,!1,Q,!0,z.language,!0,void 0,z.productVersion??this.R()),F=await this.n.scanExtension(M);return!F||!z.includeInvalid&&!F.isValid?null:F}async scanOneOrMultipleExtensions(X,Q,z){const M=await this.P(X,!1,Q,!0,z.language,!0,void 0,z.productVersion??this.R()),F=await this.n.scanOneOrMultipleExtensions(M);return this.J(F,Q,z,!0)}async scanMetadata(X){const Q=(0,g.$Ug)(X,"package.json"),z=(await this.w.readFile(Q)).value.toString();return JSON.parse(z).__metadata}async updateMetadata(X,Q){const z=(0,g.$Ug)(X,"package.json"),M=(await this.w.readFile(z)).value.toString(),F=JSON.parse(M);Q.isMachineScoped===!1&&delete Q.isMachineScoped,Q.isBuiltin===!1&&delete Q.isBuiltin,F.__metadata={...F.__metadata,...Q},await this.w.writeFile((0,g.$Ug)(X,"package.json"),B.$ue.fromString(JSON.stringify(F,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(X){if(X instanceof I.$_p&&X.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw X}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const X=await this.scanUserExtensions({includeInvalid:!0});if(X.length)await this.u.addExtensionsToProfile(X.map(Q=>[Q,Q.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,B.$ue.fromString(JSON.stringify([])))}catch(Q){(0,o.$5k)(Q)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,S.$0)(Q))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(X){this.y.error(X)}finally{this.H=void 0}})()),this.H}async J(X,Q,z,M){return z.includeAllVersions||(X=this.L(Q===0?X:void 0,Q===1?X:void 0,Q==="development"?X:void 0,await this.getTargetPlatform(),M)),z.includeInvalid||(X=X.filter(F=>F.isValid)),X.sort((F,G)=>{const T=y.$oc(F.location.fsPath),ce=y.$oc(G.location.fsPath);return T<ce?-1:T>ce?1:0})}L(X,Q,z,M,F){const G=(ce,he,K)=>{if(ce.isValid&&!he.isValid)return!1;if(ce.isValid===he.isValid){if(F&&m.gt(ce.manifest.version,he.manifest.version))return this.y.debug(`Skipping extension ${he.location.path} with lower version ${he.manifest.version} in favour of ${ce.location.path} with version ${ce.manifest.version}`),!1;if(m.eq(ce.manifest.version,he.manifest.version)){if(ce.type===0)return this.y.debug(`Skipping extension ${he.location.path} in favour of system extension ${ce.location.path} with same version`),!1;if(ce.targetPlatform===M)return this.y.debug(`Skipping extension ${he.location.path} from different target platform ${he.targetPlatform}`),!1}}return K?this.y.warn(`Overwriting user extension ${ce.location.path} with ${he.location.path}.`):this.y.debug(`Overwriting user extension ${ce.location.path} with ${he.location.path}.`),!0},T=new a.$Em;return X?.forEach(ce=>{const he=T.get(ce.identifier.id);(!he||G(he,ce,!1))&&T.set(ce.identifier.id,ce)}),Q?.forEach(ce=>{const he=T.get(ce.identifier.id);if(!he&&X&&ce.type===0){this.y.debug(`Skipping obsolete system extension ${ce.location.path}.`);return}(!he||G(he,ce,!1))&&T.set(ce.identifier.id,ce)}),z?.forEach(ce=>{const he=T.get(ce.identifier.id);(!he||G(he,ce,!0))&&T.set(ce.identifier.id,ce),T.set(ce.identifier.id,ce)}),[...T.values()]}async M(X,Q){this.y.trace("Started scanning system extensions");const z=await this.P(this.systemExtensionsLocation,!1,0,!0,Q,!0,void 0,this.R()),F=await(X&&!z.devMode?this.j:this.n).scanExtensions(z);return this.y.trace("Scanned system extensions:",F.length),F}async N(X,Q){const z=this.z.isBuilt?[]:this.C.builtInExtensions;if(!z?.length)return[];this.y.trace("Started scanning dev system extensions");const M=Q?await this.O():{},F=[],G=$.URI.file(y.$ic(y.$kc(p.$Bg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const ce of z){const he=M[ce.name]||"marketplace";switch(he){case"disabled":break;case"marketplace":F.push((0,g.$Ug)(G,ce.name));break;default:F.push($.URI.file(he));break}}const T=await Promise.all(F.map(async ce=>this.n.scanExtension(await this.P(ce,!1,0,!0,X,!0,void 0,this.R()))));return this.y.trace("Scanned dev system extensions:",T.length),(0,n.$Hb)(T)}async O(){try{const X=await this.w.readFile(this.r);return JSON.parse(X.value.toString())}catch{return{}}}async P(X,Q,z,M,F,G,T,ce){const he=await this.f(F??k.$w),K=await this.Q(X),O=Q&&!this.D.extUri.isEqual(X,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,N=O?await this.Q(O):void 0;return new W(X,K,O,N,Q,T,z,M,G,ce.version,ce.date,this.C.commit,!this.z.isBuilt,F,he)}async Q(X){try{const Q=await this.w.stat(X);if(typeof Q.mtime=="number")return Q.mtime}catch{}}R(){return{version:this.C.version,date:this.C.date}}};e.$fq=L,e.$fq=L=Ee([ne(4,D.$nl),ne(5,I.$aq),ne(6,o.$Nk),ne(7,i.$Nj),ne(8,l.$oi),ne(9,s.$7j),ne(10,R.$ll),ne(11,r.$gi)],L);class W{constructor(X,Q,z,M,F,G,T,ce,he,K,O,N,_,se,Z){this.location=X,this.mtime=Q,this.applicationExtensionslocation=z,this.applicationExtensionslocationMtime=M,this.profile=F,this.profileScanOptions=G,this.type=T,this.excludeObsolete=ce,this.validate=he,this.productVersion=K,this.productDate=O,this.productCommit=N,this.devMode=_,this.language=se,this.translations=Z}static createNlsConfiguration(X){return{language:X.language,pseudo:X.language==="pseudo",devMode:X.devMode,translations:X.translations}}static equals(X,Q){return(0,g.$Ng)(X.location,Q.location)&&X.mtime===Q.mtime&&(0,g.$Ng)(X.applicationExtensionslocation,Q.applicationExtensionslocation)&&X.applicationExtensionslocationMtime===Q.applicationExtensionslocationMtime&&X.profile===Q.profile&&P.$Rn(X.profileScanOptions,Q.profileScanOptions)&&X.type===Q.type&&X.excludeObsolete===Q.excludeObsolete&&X.validate===Q.validate&&X.productVersion===Q.productVersion&&X.productDate===Q.productDate&&X.productCommit===Q.productCommit&&X.devMode===Q.devMode&&X.language===Q.language&&A.equals(X.translations,Q.translations)}}e.$gq=W;let q=class extends c.$Uc{constructor(X,Q,z,M,F){super(),this.f=X,this.g=Q,this.h=z,this.j=M,this.m=F}async scanExtensions(X){const Q=X.profile?await this.r(X):await this.n(X);let z={};if(X.excludeObsolete&&X.type===1)try{const M=(await this.j.readFile(this.f)).value.toString();z=JSON.parse(M)}catch{}return(0,w.$8f)(z)?Q:Q.filter(M=>!z[d.$gp.create(M).toString()])}async n(X){const Q=await this.j.resolve(X.location);if(!Q.children?.length)return[];const z=await Promise.all(Q.children.map(async M=>{if(!M.isDirectory||X.type===1&&(0,g.$Rg)(M.resource).indexOf(".")===0)return null;const F=new W(M.resource,X.mtime,X.applicationExtensionslocation,X.applicationExtensionslocationMtime,X.profile,X.profileScanOptions,X.type,X.excludeObsolete,X.validate,X.productVersion,X.productDate,X.productCommit,X.devMode,X.language,X.translations);return this.scanExtension(F)}));return(0,n.$Hb)(z).sort((M,F)=>M.location.path<F.location.path?-1:1)}async r(X){let Q=await this.s(X.location,()=>!0,X);if(X.applicationExtensionslocation&&!this.h.extUri.isEqual(X.location,X.applicationExtensionslocation)){Q=Q.filter(M=>!M.metadata?.isApplicationScoped);const z=await this.s(X.applicationExtensionslocation,M=>!!M.metadata?.isBuiltin||!!M.metadata?.isApplicationScoped,X);Q.push(...z)}return Q}async s(X,Q,z){const M=await this.g.scanProfileExtensions(X,z.profileScanOptions);if(!M.length)return[];const F=await Promise.all(M.map(async G=>{if(Q(G)){const T=new W(G.location,z.mtime,z.applicationExtensionslocation,z.applicationExtensionslocationMtime,z.profile,z.profileScanOptions,z.type,z.excludeObsolete,z.validate,z.productVersion,z.productDate,z.productCommit,z.devMode,z.language,z.translations);return this.scanExtension(T,G.metadata)}return null}));return(0,n.$Hb)(F)}async scanOneOrMultipleExtensions(X){try{if(await this.j.exists((0,g.$Ug)(X.location,"package.json"))){const Q=await this.scanExtension(X);return Q?[Q]:[]}else return await this.scanExtensions(X)}catch(Q){return this.m.error(`Error scanning extensions at ${X.location.path}:`,(0,S.$0)(Q)),[]}}async scanExtension(X,Q){try{let z=await this.scanExtensionManifest(X.location);if(z){z.publisher||(z.publisher=a.$ym),Q=Q??z.__metadata,delete z.__metadata;const M=(0,d.$kp)(z.publisher,z.name),F=Q?.id?{id:M,uuid:Q.id}:{id:M},G=Q?.isSystem?0:X.type,T=G===0||!!Q?.isBuiltin;z=await this.t(X.location,z,W.createNlsConfiguration(X));const ce={type:G,identifier:F,manifest:z,location:X.location,isBuiltin:T,targetPlatform:Q?.targetPlatform??"undefined",metadata:Q,isValid:!0,validations:[]};return X.validate?this.validate(ce,X):ce}}catch(z){X.type!==0&&this.m.error(z)}return null}validate(X,Q){let z=!0;const M=(0,t.$vp)(Q.productVersion,Q.productDate,Q.location,X.manifest,X.isBuiltin);for(const[F,G]of M)F===v.default.Error&&(z=!1,this.m.error(this.z(Q.location,G)));return X.isValid=z,X.validations=M,X}async scanExtensionManifest(X){const Q=(0,g.$Ug)(X,"package.json");let z;try{z=(await this.j.readFile(Q)).value.toString()}catch(F){return(0,o.$5k)(F)!==1&&this.m.error(this.z(X,(0,f.localize)(0,null,Q.path,F.message))),null}let M;try{M=JSON.parse(z)}catch{const G=[];(0,E.$un)(z,G);for(const T of G)this.m.error(this.z(X,(0,f.localize)(1,null,Q.path,T.offset,T.length,(0,h.$cq)(T.error))));return null}return(0,E.$Dn)(M)!=="object"?(this.m.error(this.z(X,(0,f.localize)(2,null,Q.path))),null):M}async t(X,Q,z){const M=await this.u(X,Q,z);if(M)try{const F=[],G=await this.w(M.default,F);if(F.length>0)return F.forEach(ce=>{this.m.error(this.z(X,(0,f.localize)(3,null,M.default?.path,(0,h.$cq)(ce.error))))}),Q;if((0,E.$Dn)(M)!=="object")return this.m.error(this.z(X,(0,f.localize)(4,null,M.default?.path))),Q;const T=M.values||Object.create(null);return(0,C.$dq)(this.m,Q,T,G)}catch{}return Q}async u(X,Q,z){const M=(0,g.$Ug)(X,"package.nls.json"),F=(he,K)=>{K.forEach(O=>{this.m.error(this.z(X,(0,f.localize)(5,null,he?.path,(0,h.$cq)(O.error))))})},G=he=>{this.m.error(this.z(X,(0,f.localize)(6,null,he?.path)))},T=`${Q.publisher}.${Q.name}`,ce=z.translations[T];if(ce)try{const he=$.URI.file(ce),K=(await this.j.readFile(he)).value.toString(),O=[],N=(0,E.$un)(K,O);return O.length>0?(F(he,O),{values:void 0,default:M}):(0,E.$Dn)(N)!=="object"?(G(he),{values:void 0,default:M}):{values:N.contents?N.contents.package:void 0,default:M}}catch{return{values:void 0,default:M}}else{if(!await this.j.exists(M))return;let K;try{K=await this.y(X,z)}catch{return}if(!K.localized)return{values:void 0,default:K.original};try{const O=(await this.j.readFile(K.localized)).value.toString(),N=[],_=(0,E.$un)(O,N);return N.length>0?(F(K.localized,N),{values:void 0,default:K.original}):(0,E.$Dn)(_)!=="object"?(G(K.localized),{values:void 0,default:K.original}):{values:_,default:K.original}}catch{return{values:void 0,default:K.original}}}}async w(X,Q){if(X)try{const z=(await this.j.readFile(X)).value.toString();return(0,E.$un)(z,Q)}catch{}}y(X,Q){return new Promise((z,M)=>{const F=G=>{const T=(0,g.$Ug)(X,`package.nls.${G}.json`);this.j.exists(T).then(ce=>{ce&&z({localized:T,original:(0,g.$Ug)(X,"package.nls.json")});const he=G.lastIndexOf("-");he===-1?z({localized:(0,g.$Ug)(X,"package.nls.json"),original:null}):(G=G.substring(0,he),F(G))})};if(Q.devMode||Q.pseudo||!Q.language)return z({localized:(0,g.$Ug)(X,"package.nls.json"),original:null});F(Q.language)})}z(X,Q){return`[${X.path}]: ${Q}`}};q=Ee([ne(1,I.$aq),ne(2,R.$ll),ne(3,o.$Nk),ne(4,i.$Nj)],q);let H=class extends q{constructor(X,Q,z,M,F,G,T){super(Q,M,F,G,T),this.G=X,this.H=z,this.D=this.B(new j.$fh(3e3)),this.F=this.B(new u.$7d),this.onDidChangeCache=this.F.event}async scanExtensions(X){const Q=this.M(X),z=await this.I(Q);if(this.C=X,z&&z.input&&W.equals(z.input,this.C))return this.m.debug("Using cached extensions scan result",X.location.toString()),this.D.trigger(()=>this.L()),z.result.map(F=>(F.location=$.URI.revive(F.location),F));const M=await super.scanExtensions(X);return await this.J(Q,{input:X,result:M}),M}async I(X){try{const Q=await this.j.readFile(X),z=JSON.parse(Q.value.toString());return{result:z.result,input:(0,b.$Qh)(z.input)}}catch(Q){this.m.debug("Error while reading the extension cache file:",X.path,(0,S.$0)(Q))}return null}async J(X,Q){try{await this.j.writeFile(X,B.$ue.fromString(JSON.stringify(Q)))}catch(z){this.m.debug("Error while writing the extension cache file:",X.path,(0,S.$0)(z))}}async L(){if(!this.C)return;const X=this.M(this.C),Q=await this.I(X);if(!Q)return;const z=Q.result,M=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!P.$Rn(M,z))try{this.m.info("Invalidating Cache",z,M),await this.j.del(X),this.F.fire()}catch(F){this.m.error(F)}}M(X){const Q=this.N(X);return this.h.extUri.joinPath(Q.cacheHome,X.type===0?a.$xm:a.$wm)}N(X){return X.type===0?this.H.defaultProfile:X.profile?this.h.extUri.isEqual(X.location,this.G.extensionsResource)?this.G:this.H.profiles.find(Q=>this.h.extUri.isEqual(X.location,Q.extensionsResource))??this.G:this.H.defaultProfile}};H=Ee([ne(2,D.$nl),ne(3,I.$aq),ne(4,R.$ll),ne(5,o.$Nk),ne(6,i.$Nj)],H);function le(ue,X){const Q=(0,d.$ip)(ue.manifest.publisher,ue.manifest.name);return{id:Q,identifier:new a.$Cm(Q),isBuiltin:ue.type===0,isUserBuiltin:ue.type===1&&ue.isBuiltin,isUnderDevelopment:X,extensionLocation:ue.location,uuid:ue.identifier.uuid,targetPlatform:ue.targetPlatform,...ue.manifest}}class te extends L{constructor(X,Q,z,M,F,G,T,ce,he,K,O,N){super(X,Q,(0,g.$Ug)(z,".vscode-oss-dev","extensions","control.json"),M,F,G,T,ce,he,K,O,N),this.S=(async()=>{if(k.$z)try{const _=await this.w.readFile($.URI.file(k.$z));return JSON.parse(_.value.toString())}catch{}return Object.create(null)})()}f(X){return this.S}}e.$iq=te}),define(oe[280],ae([0,1,5,41,40,28,82,16,38,7]),function(J,e,n,j,P,B,S,E,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2P=void 0;let p=class extends S.$bq{constructor(k,g,m,v,w,$){super(c.URI.file(k.extensionsPath),g,m,v,w,$)}};e.$2P=p,e.$2P=p=Ee([ne(0,h.$pi),ne(1,E.$Nk),ne(2,j.$nl),ne(3,P.$ll),ne(4,B.$Ml),ne(5,n.$Nj)],p)}),define(oe[281],ae([0,1,7,38,82,132,16,6,5,27,40,41]),function(J,e,n,j,P,B,S,E,h,c,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ibc=void 0;let k=class extends B.$iq{constructor(m,v,w,$,f,l,d,a){super(n.URI.file(f.builtinExtensionsPath),n.URI.file(f.extensionsPath),f.userHome,m.defaultProfile,m,v,w,$,f,l,d,a)}};e.$ibc=k,e.$ibc=k=Ee([ne(0,y.$nl),ne(1,P.$aq),ne(2,S.$Nk),ne(3,h.$Nj),ne(4,j.$pi),ne(5,c.$7j),ne(6,p.$ll),ne(7,E.$gi)],k)}),define(oe[282],ae([0,1,14,2,13,9,4,59,7,33,37,38,5,41]),function(J,e,n,j,P,B,S,E,h,c,p,y,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Abc=void 0;let m=class extends j.$Uc{constructor(w,$,f){super(),this.c=w,this.f=f,this.a=E.$ni.forPaths(!S.$k),this.b=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot(w.appRoot),this.addValidFileRoot(w.extensionsPath),this.addValidFileRoot($.defaultProfile.globalStorageHome.with({scheme:P.Schemas.file}).fsPath),this.addValidFileRoot(w.workspaceStorageHome.with({scheme:P.Schemas.file}).fsPath),this.g()}g(){const{defaultSession:w}=n.session;w.protocol.registerFileProtocol(P.Schemas.vscodeFileResource,($,f)=>this.j($,f)),w.protocol.interceptFileProtocol(P.Schemas.file,($,f)=>this.h($,f)),this.B((0,j.$Sc)(()=>{w.protocol.unregisterProtocol(P.Schemas.vscodeFileResource),w.protocol.uninterceptProtocol(P.Schemas.file)}))}addValidFileRoot(w){const $=(0,B.$ic)(w);return this.a.get($)?j.$Uc.None:(this.a.set($,!0),(0,j.$Sc)(()=>this.a.delete($)))}h(w,$){const f=h.URI.parse(w.url);return this.f.error(`Refused to load resource ${f.fsPath} from ${P.Schemas.file}: protocol (original URL: ${w.url})`),$({error:-3})}j(w,$){const f=this.m(w);let l;return this.c.crossOriginIsolated&&((0,B.$oc)(f)==="workbench.html"||(0,B.$oc)(f)==="workbench-dev.html"?l=P.COI.CoopAndCoep:l=P.COI.getHeadersFromQuery(w.url)),this.a.findSubstr(f)?$({path:f,headers:l}):this.b.has((0,B.$pc)(f).toLowerCase())?$({path:f}):(this.f.error(`${P.Schemas.vscodeFileResource}: Refused to load resource ${f} from ${P.Schemas.vscodeFileResource}: protocol (original URL: ${w.url})`),$({error:-3}))}m(w){const $=h.URI.parse(w.url),f=P.$Bg.uriToFileUri($);return(0,B.$ic)(f.fsPath)}createIPCObjectUrl(){let w;const $=h.URI.from({scheme:"vscode",path:(0,c.$Dg)()}),f=$.toString(),l=async()=>w;return p.$2V.handle(f,l),this.f.trace(`IPC Object URL: Registered new channel ${f}.`),{resource:$,update:d=>w=d,dispose:()=>{this.f.trace(`IPC Object URL: Removed channel ${f}.`),p.$2V.removeHandler(f)}}}};e.$Abc=m,e.$Abc=m=Ee([ne(0,y.$pi),ne(1,g.$nl),ne(2,k.$Nj)],m)}),define(oe[97],ae([0,1,8,3,2,66,12,115,6,41]),function(J,e,n,j,P,B,S,E,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pp=e.$Np=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$Lp=e.$Kp=e.$Jp=void 0,e.$Mp=g,e.$Op=v,e.$Qp=$,e.$Jp="__$__isNewStorageMarker",e.$Kp="__$__targetStorageMarker",e.$Lp=(0,h.$hi)("storageService");var p;(function(f){f[f.NONE=0]="NONE",f[f.SHUTDOWN=1]="SHUTDOWN"})(p||(e.WillSaveStateReason=p={}));var y;(function(f){f[f.APPLICATION=-1]="APPLICATION",f[f.PROFILE=0]="PROFILE",f[f.WORKSPACE=1]="WORKSPACE"})(y||(e.StorageScope=y={}));var k;(function(f){f[f.USER=0]="USER",f[f.MACHINE=1]="MACHINE"})(k||(e.StorageTarget=k={}));function g(f){const l=f.get(e.$Kp);if(l)try{return JSON.parse(l)}catch{}return Object.create(null)}class m extends P.$Uc{static{this.a=60*1e3}constructor(l={flushInterval:m.a}){super(),this.m=l,this.b=this.B(new j.$0d),this.c=this.B(new j.$0d),this.onDidChangeTarget=this.c.event,this.f=this.B(new j.$7d),this.onWillSaveState=this.f.event,this.h=this.B(new n.$th(()=>this.n(),this.m.flushInterval)),this.j=this.B(new P.$Vc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(l,d,a){return j.Event.filter(this.b.event,t=>t.scope===l&&(d===void 0||t.key===d),a)}n(){this.j.value=(0,n.$xh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,P.$Pc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,B.mark)("code/willInitStorage");try{await this.O()}finally{(0,B.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(l,d){const{key:a,external:t}=d;if(a===e.$Kp){switch(l){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:l})}else this.b.fire({scope:l,key:a,target:this.J(l)[a],external:t})}w(l){this.f.fire({reason:l})}get(l,d,a){return this.P(d)?.get(l,a)}getBoolean(l,d,a){return this.P(d)?.getBoolean(l,a)}getNumber(l,d,a){return this.P(d)?.getNumber(l,a)}getObject(l,d,a){return this.P(d)?.getObject(l,a)}storeAll(l,d){this.y(()=>{for(const a of l)this.store(a.key,a.value,a.scope,a.target,d)})}store(l,d,a,t,o=!1){if((0,S.$4f)(d)){this.remove(l,a,o);return}this.y(()=>{this.z(l,a,t),this.P(a)?.set(l,d,o)})}remove(l,d,a=!1){this.y(()=>{this.z(l,d,void 0),this.P(d)?.delete(l,a)})}y(l){this.b.pause(),this.c.pause();try{l()}finally{this.b.resume(),this.c.resume()}}keys(l,d){const a=[],t=this.J(l);for(const o of Object.keys(t))t[o]===d&&a.push(o);return a}z(l,d,a,t=!1){const o=this.J(d);typeof a=="number"?o[l]!==a&&(o[l]=a,this.P(d)?.set(e.$Kp,JSON.stringify(o),t)):typeof o[l]=="number"&&(delete o[l],this.P(d)?.set(e.$Kp,JSON.stringify(o),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(l){switch(l){case-1:return this.I;case 0:return this.G;default:return this.D}}L(l){const d=this.P(l);return d?g(d):Object.create(null)}isNew(l){return this.getBoolean(e.$Jp,l)===!0}async flush(l=p.NONE){this.f.fire({reason:l});const d=this.P(-1),a=this.P(0),t=this.P(1);switch(l){case p.NONE:await n.Promises.settled([d?.whenFlushed()??Promise.resolve(),a?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case p.SHUTDOWN:await n.Promises.settled([d?.flush(0)??Promise.resolve(),a?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const l=this.P(-1)?.items??new Map,d=this.P(0)?.items??new Map,a=this.P(1)?.items??new Map;return $(l,d,a,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(l){return await this.flush(),this.P(l)?.optimize()}async switch(l,d){return this.w(p.NONE),(0,c.$ml)(l)?this.R(l,d):this.S(l,d)}M(l,d){return!(l.id===d.id||v(d)&&v(l))}N(l,d,a){this.y(()=>{const t=new Set;for(const[o,r]of l)t.add(o),d.get(o)!==r&&this.u(a,{key:o,external:!0});for(const[o]of d.items)t.has(o)||this.u(a,{key:o,external:!0})})}}e.$Np=m;function v(f){return f.isDefault||!!f.useDefaultFlags?.globalState}class w extends m{constructor(){super(),this.U=this.B(new E.$Hp(new E.$Ip,{hint:E.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new E.$Hp(new E.$Ip,{hint:E.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new E.$Hp(new E.$Ip,{hint:E.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(l=>this.u(1,l))),this.B(this.W.onDidChangeStorage(l=>this.u(0,l))),this.B(this.U.onDidChangeStorage(l=>this.u(-1,l)))}P(l){switch(l){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(l){switch(l){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(l){return!1}}e.$Pp=w;async function $(f,l,d,a,t,o){const r=A=>{try{return JSON.parse(A)}catch{return A}},i=new Map,s=new Map;f.forEach((A,L)=>{i.set(L,A),s.set(L,r(A))});const u=new Map,b=new Map;l.forEach((A,L)=>{u.set(L,A),b.set(L,r(A))});const I=new Map,D=new Map;d.forEach((A,L)=>{I.set(L,A),D.set(L,r(A))}),console.group(a!==t?`Storage: Application (path: ${a})`:`Storage: Application & Profile (path: ${a}, default profile)`);const R=[];if(i.forEach((A,L)=>{R.push({key:L,value:A})}),console.table(R),console.groupEnd(),console.log(s),a!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const A=[];u.forEach((L,W)=>{A.push({key:W,value:L})}),console.table(A),console.groupEnd(),console.log(b)}console.group(`Storage: Workspace (path: ${o})`);const C=[];I.forEach((A,L)=>{C.push({key:L,value:A})}),console.table(C),console.groupEnd(),console.log(D)}}),define(oe[283],ae([0,1,22,8,3,2,9,72,7,21,115,163,5,97,28,30,13]),function(J,e,n,j,P,B,S,E,h,c,p,y,k,g,m,v,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$__b=e.$$_b=e.$0_b=e.$9_b=void 0;class $ extends B.$Uc{static{this.a=2e3}get storage(){return this.f}constructor(r,i){super(),this.m=r,this.n=i,this.b=this.B(new P.$7d),this.onDidChangeStorage=this.b.event,this.c=this.B(new P.$7d),this.onDidCloseStorage=this.c.event,this.f=this.B(new p.$Hp(new p.$Ip,{hint:p.StorageHint.STORAGE_IN_MEMORY})),this.g=void 0,this.h=new j.$Eh,this.whenInit=this.h.p,this.j=p.StorageState.None}isInMemory(){return this.f.isInMemory()}init(){return this.g||(this.g=(async()=>{if(this.j===p.StorageState.None)try{const r=this.B(await this.t());this.f.dispose(),this.f=r,this.B(r.onDidChangeStorage(s=>this.b.fire(s))),await this.s(r);const i=r.getBoolean(g.$Jp);i===void 0?r.set(g.$Jp,!0):i&&r.set(g.$Jp,!1)}catch(r){this.m.error(`[storage main] initialize(): Unable to init storage due to ${r}`)}finally{this.j=p.StorageState.Initialized,this.h.complete()}})()),this.g}r(){return{logTrace:this.m.getLevel()===k.LogLevel.Trace?r=>this.m.trace(r):void 0,logError:r=>this.m.error(r)}}s(r){return r.init()}get items(){return this.f.items}get(r,i){return this.f.get(r,i)}set(r,i){return this.f.set(r,i)}delete(r){return this.f.delete(r)}optimize(){return this.f.optimize()}async close(){const r=new E.$3d(!1);await this.w(),r.stop(),r.elapsed()>$.a&&await this.u(r),this.c.fire()}async u(r){if(this.path)try{const i=(0,n.top)(Array.from(this.f.items.entries()).map(([u,b])=>({key:u,length:b.length})),(u,b)=>b.length-u.length,5).map(u=>`${u.key}:${u.length}`).join(", "),s=(await this.n.stat(h.URI.file(this.path))).size;this.m.warn(`[storage main] detected slow close() operation: Time: ${r.elapsed()}ms, DB size: ${s}b, Large Keys: ${i}`)}catch(i){this.m.error("[storage main] figuring out stats for slow DB on close() resulted in an error",i)}}async w(){this.g&&await this.g,this.j=p.StorageState.Closed,await this.f.close()}}class f extends ${static{this.y="state.vscdb"}get path(){if(!this.C.useInMemoryStorage)return(0,S.$kc)(this.z.globalStorageHome.with({scheme:w.Schemas.file}).fsPath,f.y)}constructor(r,i,s,u){super(s,u),this.z=r,this.C=i}async t(){return new p.$Hp(new y.$uW(this.path??y.$uW.IN_MEMORY_PATH,{logging:this.r()}),this.path?void 0:{hint:p.StorageHint.STORAGE_IN_MEMORY})}}class l extends f{constructor(r,i,s,u){super(r,i,s,u)}}e.$9_b=l;class d extends f{constructor(r,i,s,u){super(i.defaultProfile,r,s,u)}async s(r){await super.s(r),this.G(r)}G(r){r.get(m.$Pl,void 0)===void 0&&r.set(m.$Pl,new Date().toUTCString());const s=r.get(m.$Ol,void 0),u=new Date().toUTCString();r.set(m.$Ql,typeof s>"u"?null:s),r.set(m.$Ol,u)}}e.$0_b=d;class a extends ${static{this.y="state.vscdb"}static{this.z="workspace.json"}get path(){if(!this.D.useInMemoryStorage)return(0,S.$kc)(this.F.workspaceStorageHome.with({scheme:w.Schemas.file}).fsPath,this.C.id,a.y)}constructor(r,i,s,u,b){super(s,b),this.C=r,this.D=i,this.F=u}async t(){const{storageFilePath:r,wasCreated:i}=await this.H();return new p.$Hp(new y.$uW(r,{logging:this.r()}),{hint:this.D.useInMemoryStorage?p.StorageHint.STORAGE_IN_MEMORY:i?p.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async H(){if(this.D.useInMemoryStorage)return{storageFilePath:y.$uW.IN_MEMORY_PATH,wasCreated:!0};const r=(0,S.$kc)(this.F.workspaceStorageHome.with({scheme:w.Schemas.file}).fsPath,this.C.id),i=(0,S.$kc)(r,a.y);return await c.Promises.exists(r)?{storageFilePath:i,wasCreated:!1}:(await c.Promises.mkdir(r,{recursive:!0}),this.I(r),{storageFilePath:i,wasCreated:!0})}async I(r){let i;if((0,v.$ri)(this.C)?i={folder:this.C.uri.toString()}:(0,v.$wi)(this.C)&&(i={workspace:this.C.configPath.toString()}),i)try{const s=(0,S.$kc)(r,a.z);await c.Promises.exists(s)||await c.Promises.writeFile(s,JSON.stringify(i,void 0,2))}catch(s){this.m.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${s}`)}}}e.$$_b=a;class t extends ${get path(){}async t(){return new p.$Hp(new p.$Ip,{hint:p.StorageHint.STORAGE_IN_MEMORY})}}e.$__b=t}),define(oe[284],ae([0,1,3,2,97]),function(J,e,n,j,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kbc=void 0;class B extends j.$Uc{constructor(E,h,c){super(),this.b=E,this.c=h,this.f=c;const p=this.B(new j.$Vc);this.a=this.B(new n.$7d({onWillAddFirstListener:()=>p.value=this.g(),onDidRemoveLastListener:()=>p.value=void 0}))}g(){this.f.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const E=new j.$Tc;return E.add(n.Event.debounce(this.b.applicationStorage.onDidChangeStorage,(h,c)=>(h?h.push(c.key):h=[c.key],h),100)(h=>this.h(h))),E.add(n.Event.debounce(this.b.onDidChangeProfileStorage,(h,c)=>{h||(h=new Map);let p=h.get(c.profile.id);return p||h.set(c.profile.id,p={profile:c.profile,keys:[],storage:c.storage}),p.keys.push(c.key),h},100)(h=>this.j(h))),E}h(E){const h=E.includes(P.$Kp)?[this.c.defaultProfile]:[],c=[];if(E=E.filter(p=>p!==P.$Kp),E.length){const p=(0,P.$Mp)(this.b.applicationStorage.storage);c.push({profile:this.c.defaultProfile,changes:E.map(y=>({key:y,scope:0,target:p[y]}))})}this.m(h,c)}j(E){const h=[],c=new Map;for(const[p,y]of E.entries()){y.keys.includes(P.$Kp)&&h.push(y.profile);const k=y.keys.filter(g=>g!==P.$Kp);if(k.length){const g=(0,P.$Mp)(y.storage.storage);c.set(p,{profile:y.profile,changes:k.map(m=>({key:m,scope:0,target:g[m]}))})}}this.m(h,[...c.values()])}m(E,h){(E.length||h.length)&&this.a.fire({valueChanges:h,targetChanges:E})}listen(E,h,c){switch(h){case"onDidChange":return this.a.event}throw new Error(`[ProfileStorageChangesListenerChannel] Event not found: ${h}`)}async call(E,h){throw new Error(`Call not found: ${h}`)}}e.$kbc=B}),define(oe[285],ae([0,1,7,38,16,5,34,40,41,12,125]),function(J,e,n,j,P,B,S,E,h,c,p){"use strict";var y,k;Object.defineProperty(e,"__esModule",{value:!0}),e.$1P=e.$ZP=e.$YP=void 0;let g=class extends h.$ql{static{y=this}static{this.a="profileAssociationsMigration"}constructor($,f,l,d,a){super(l,d,f,a),this.U=$,this.W=l}O(){return this.U.getItem(y.b,[]).map(f=>({...f,location:(0,c.$Uf)(f.location)?this.w.extUri.joinPath(this.profilesHome,f.location):n.URI.revive(f.location)}))}Q(){const $=this.U.getItem(y.c,{});return this.U.getItem(y.a,!1)?$:this.N($)}S(){return this.w.extUri.joinPath(n.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$YP=g,e.$YP=g=y=Ee([ne(0,S.$TP),ne(1,E.$ll),ne(2,j.$pi),ne(3,P.$Nk),ne(4,B.$Nj)],g);let m=k=class extends g{constructor($,f,l,d,a){super($,f,l,d,a),this.$=$}P($){$.length?this.$.setItem(k.b,$.map(f=>({...f,location:this.w.extUri.basename(f.location)}))):this.$.removeItem(k.b)}O(){const $=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P($),this.$.setItem("userDataProfilesMigration",!0)),$}R($){$.emptyWindows||$.workspaces?this.$.setItem(k.c,$):this.$.removeItem(k.c)}Q(){const $="workspaceAndProfileInfo",f=this.$.getItem($,void 0);if(f){this.$.removeItem($);const d=f.reduce((a,{workspace:t,profile:o})=>(a[n.URI.revive(t).toString()]=n.URI.revive(o).toString(),a),{});this.$.setItem(k.c,{workspaces:d})}const l=super.Q();return this.$.getItem(k.a,!1)||(this.R(l),this.$.setItem(k.a,!0)),l}};e.$ZP=m,e.$ZP=m=k=Ee([ne(0,S.$UP),ne(1,E.$ll),ne(2,j.$pi),ne(3,P.$Nk),ne(4,B.$Nj)],m);let v=class extends m{constructor($,f,l,d){super(new p.$XP(0,f,d,l),$,f,l,d)}async init(){return await this.$.init(),super.init()}};e.$1P=v,e.$1P=v=Ee([ne(0,E.$ll),ne(1,j.$pi),ne(2,P.$Nk),ne(3,B.$Nj)],v)}),define(oe[57],ae([0,1,38,16,6,5,40,41,285,34]),function(J,e,n,j,P,B,S,E,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$R_b=e.$Q_b=void 0,e.$Q_b=(0,P.$ii)(E.$nl);let p=class extends h.$ZP{constructor(k,g,m,v,w){super(k,g,m,v,w)}getAssociatedEmptyWindows(){const k=[];for(const g of this.C.emptyWindows.keys())k.push({id:g});return k}};e.$R_b=p,e.$R_b=p=Ee([ne(0,c.$UP),ne(1,S.$ll),ne(2,n.$pi),ne(3,j.$Nk),ne(4,B.$Nj)],p)}),define(oe[133],ae([0,1,19,7,30]),function(J,e,n,j,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S_b=B,e.$T_b=S,e.$U_b=E;async function B(h,c,p){for(const k of h){const g=k.openedWorkspace;if((0,P.$wi)(g)){const m=await p(g);if(m){if(m.folders.some(v=>n.$Lg.isEqualOrParent(c,v.uri)))return k}else if(n.$Lg.isEqualOrParent(c,g.configPath))return k}}const y=h.filter(k=>(0,P.$ri)(k.openedWorkspace)&&n.$Lg.isEqualOrParent(c,k.openedWorkspace.uri));if(y.length)return y.sort((k,g)=>-(k.openedWorkspace.uri.path.length-g.openedWorkspace.uri.path.length))[0]}function S(h,c){for(const p of h)if((0,P.$wi)(p.openedWorkspace)&&n.$Lg.isEqual(p.openedWorkspace.configPath,c)||(0,P.$ri)(p.openedWorkspace)&&n.$Lg.isEqual(p.openedWorkspace.uri,c))return p}function E(h,c){const p=y=>c.some(k=>n.$Lg.isEqual(j.URI.file(k),j.URI.file(y)));for(const y of h)if(y.config?.extensionDevelopmentPath?.some(k=>p(k)))return y}}),define(oe[98],ae([0,1,31,42,103,48,13,9,4,19,7,6,68,30]),function(J,e,n,j,P,B,S,E,h,c,p,y,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Beb=void 0,e.$Ceb=m,e.$Deb=v,e.$Eeb=w,e.$Feb=$,e.$Geb=d,e.$Heb=t,e.$Ieb=o,e.$Jeb=b,e.$Keb=I,e.$Beb=(0,y.$hi)("workspacesService");function m(D){return D.hasOwnProperty("workspace")}function v(D){return D.hasOwnProperty("folderUri")}function w(D){return D.hasOwnProperty("fileUri")}function $(D){return f(D)||l(D)}function f(D){const R=D;return typeof R?.path=="string"&&(!R.name||typeof R.name=="string")}function l(D){const R=D;return typeof R?.uri=="string"&&(!R.name||typeof R.name=="string")}function d(D,R,C,A,L){if(D.scheme!==A.scheme)return{name:C,uri:D.toString(!0)};let W=R?void 0:L.relativePath(A,D);if(W!==void 0)W.length===0?W=".":h.$i&&(W=a(W));else if(D.scheme===S.Schemas.file)W=D.fsPath,h.$i&&(W=a(W));else if(L.isEqualAuthority(D.authority,A.authority))W=D.path;else return{name:C,uri:D.toString(!0)};return{name:C,path:W}}function a(D){return D=(0,B.$gw)(D),(0,n.$eg)(D)||(D=(0,n.$bg)(D)),D}function t(D,R,C){const A=[],L=new Set,W=C.dirname(R);for(const q of D){let H;if(f(q))q.path&&(H=C.resolvePath(W,q.path));else if(l(q))try{H=p.URI.parse(q.uri),H.path[0]!==E.$hc.sep&&(H=H.with({path:E.$hc.sep+H.path}))}catch(le){console.warn(le)}if(H){const le=C.getComparisonKey(H);if(!L.has(le)){L.add(le);const te=q.name||C.basenameOrAuthority(H);A.push(new g.$Bi({uri:H,name:te,index:A.length},q))}}}return A}function o(D,R,C,A,L){const W=r(R,D),q=L.dirname(R),H=L.dirname(A),le=[];for(const Q of W.folders){const z=f(Q)?L.resolvePath(q,Q.path):p.URI.parse(Q.uri);let M;C?M=!1:M=!f(Q)||(0,E.$jc)(Q.path),le.push(d(z,M,Q.name,H,L))}const te={insertSpaces:!1,tabSize:4,eol:h.$k||h.$j?`
`:`\r
`},ue=P.$Jn(D,["folders"],le,te);let X=P.$Mn(D,ue);return(0,c.$Zg)(W.remoteAuthority,(0,k.$sm)(A))&&(X=P.$Mn(X,P.$In(X,["remoteAuthority"],te))),X}function r(D,R){const C=j.$un(R);if(C&&Array.isArray(C.folders))C.folders=C.folders.filter(A=>$(A));else throw new Error(`${D} looks like an invalid workspace file.`);return C}function i(D){return D.workspace&&typeof D.workspace=="object"&&typeof D.workspace.id=="string"&&typeof D.workspace.configPath=="string"}function s(D){return typeof D.folderUri=="string"}function u(D){return typeof D.fileUri=="string"}function b(D,R){const C={workspaces:[],files:[]};if(D){const A=function(W,q){for(let H=0;H<W.length;H++)try{q(W[H],H)}catch(le){R.warn(`Error restoring recent entry ${JSON.stringify(W[H])}: ${le.toString()}. Skip entry.`)}},L=D;Array.isArray(L.entries)&&A(L.entries,W=>{const q=W.label,H=W.remoteAuthority;i(W)?C.workspaces.push({label:q,remoteAuthority:H,workspace:{id:W.workspace.id,configPath:p.URI.parse(W.workspace.configPath)}}):s(W)?C.workspaces.push({label:q,remoteAuthority:H,folderUri:p.URI.parse(W.folderUri)}):u(W)&&C.files.push({label:q,remoteAuthority:H,fileUri:p.URI.parse(W.fileUri)})})}return C}function I(D){const R={entries:[]};for(const C of D.workspaces)v(C)?R.entries.push({folderUri:C.folderUri.toString(),label:C.label,remoteAuthority:C.remoteAuthority}):R.entries.push({workspace:{id:C.workspace.id,configPath:C.workspace.configPath.toString()},label:C.label,remoteAuthority:C.remoteAuthority});for(const C of D.files)R.entries.push({fileUri:C.fileUri.toString(),label:C.label,remoteAuthority:C.remoteAuthority});return R}}),define(oe[99],ae([0,1,87,13,4,19]),function(J,e,n,j,P,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V_b=void 0,e.$W_b=S,e.$X_b=E,e.$Y_b=h,e.$V_b=128/4;function S(c){function p(){let y=c.scheme===j.Schemas.file?(0,B.$Ig)(c):c.toString();return P.$k||(y=y.toLowerCase()),(0,n.createHash)("md5").update(y).digest("hex")}return{id:p(),configPath:c}}function E(c,p){function y(){if(c.scheme!==j.Schemas.file)return(0,n.createHash)("md5").update(c.toString()).digest("hex");if(!p)return;let g;return P.$k?g=p.ino:P.$j?g=p.birthtime.getTime():P.$i&&(typeof p.birthtimeMs=="number"?g=Math.floor(p.birthtimeMs):g=p.birthtime.getTime()),(0,n.createHash)("md5").update(c.fsPath).update(g?String(g):"").digest("hex")}const k=y();if(typeof k=="string")return{id:k,uri:c}}function h(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}}),define(oe[100],ae([0,1,87,88,26,286,17,15,3,2,9,4,33,44,113]),function(J,e,n,j,P,B,S,E,h,c,p,y,k,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bi=e.$$h=e.$0h=e.$9h=void 0,e.$_h=r,e.$ai=i,e.$ci=b,e.$di=I;class v{traceSocketEvent(R,C){m.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,R,C)}constructor(R,C=""){this.f=!0,this.debugLabel=C,this.socket=R,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=A=>{if(this.traceSocketEvent("error",{code:A?.code,message:A?.message}),A){if(A.code==="EPIPE")return;(0,E.$1)(A)}},this.socket.on("error",this.a),this.b=A=>{this.traceSocketEvent("close",{hadError:A}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(R){const C=A=>{this.traceSocketEvent("read",A),R(S.$ue.wrap(A))};return this.socket.on("data",C),{dispose:()=>this.socket.off("data",C)}}onClose(R){const C=A=>{R({type:0,hadError:A,error:void 0})};return this.socket.on("close",C),{dispose:()=>this.socket.off("close",C)}}onEnd(R){const C=()=>{R()};return this.socket.on("end",C),{dispose:()=>this.socket.off("end",C)}}write(R){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",R),this.socket.write(R.buffer,C=>{if(C){if(C.code==="EPIPE")return;(0,E.$1)(C)}})}catch(C){if(C.code==="EPIPE")return;(0,E.$1)(C)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((R,C)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),R();return}const A=()=>{this.socket.off("close",A),this.socket.off("end",A),this.socket.off("error",A),this.socket.off("timeout",A),this.socket.off("drain",A),this.traceSocketEvent("nodeDrainEnd"),R()};this.socket.on("close",A),this.socket.on("end",A),this.socket.on("error",A),this.socket.on("timeout",A),this.socket.on("drain",A)})}}e.$9h=v;var w;(function(D){D[D.MinHeaderByteSize=2]="MinHeaderByteSize",D[D.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(w||(w={}));var $;(function(D){D[D.PeekHeader=1]="PeekHeader",D[D.ReadHeader=2]="ReadHeader",D[D.ReadBody=3]="ReadBody",D[D.Fin=4]="Fin"})($||($={}));class f extends c.$Uc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(R,C){this.socket.traceSocketEvent(R,C)}constructor(R,C,A,L){super(),this.f=this.B(new h.$7d),this.g=this.B(new h.$7d),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=R,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:C,inflateBytesLength:A?.byteLength||0,recordInflateBytes:L}),this.a=this.B(new l(this,C,A,L,this.f,(W,q)=>this.m(W,q))),this.B(this.a.onError(W=>{console.error(W),(0,E.$1)(W),this.g.fire({type:0,hadError:!0,error:W})})),this.b=new m.$4h,this.B(this.socket.onData(W=>this.n(W))),this.B(this.socket.onClose(async W=>{this.a.isProcessingReadQueue()&&await h.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(W)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(R){return this.f.event(R)}onClose(R){return this.g.event(R)}onEnd(R){return this.socket.onEnd(R)}write(R){let C=0;for(;C<R.byteLength;)this.a.writeMessage(R.slice(C,Math.min(C+262144,R.byteLength)),{compressed:!0,opcode:2}),C+=262144}m(R,{compressed:C,opcode:A}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",R);let L=2;R.byteLength<126?L+=0:R.byteLength<2**16?L+=2:L+=8;const W=S.$ue.alloc(L),q=C?64:0,H=A&15;if(W.writeUInt8(128|q|H,0),R.byteLength<126)W.writeUInt8(R.byteLength,1);else if(R.byteLength<2**16){W.writeUInt8(126,1);let le=1;W.writeUInt8(R.byteLength>>>8&255,++le),W.writeUInt8(R.byteLength>>>0&255,++le)}else{W.writeUInt8(127,1);let le=1;W.writeUInt8(0,++le),W.writeUInt8(0,++le),W.writeUInt8(0,++le),W.writeUInt8(0,++le),W.writeUInt8(R.byteLength>>>24&255,++le),W.writeUInt8(R.byteLength>>>16&255,++le),W.writeUInt8(R.byteLength>>>8&255,++le),W.writeUInt8(R.byteLength>>>0&255,++le)}this.socket.write(S.$ue.concat([W,R]))}end(){this.h=!0,this.socket.end()}n(R){if(R.byteLength!==0){for(this.b.acceptChunk(R);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const C=this.b.peek(this.j.readLen),A=C.readUInt8(0),L=(A&128)>>>7,W=(A&64)>>>6,q=A&15,H=C.readUInt8(1),le=(H&128)>>>7,te=H&127;this.j.state=2,this.j.readLen=2+(le?4:0)+(te===126?2:0)+(te===127?8:0),this.j.fin=L,this.j.firstFrameOfMessage&&(this.j.compressed=!!W),this.j.firstFrameOfMessage=!!L,this.j.mask=0,this.j.opcode=q,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const C=this.b.read(this.j.readLen),A=C.readUInt8(1),L=(A&128)>>>7;let W=A&127,q=1;W===126?W=C.readUInt8(++q)*2**8+C.readUInt8(++q):W===127&&(W=C.readUInt8(++q)*0+C.readUInt8(++q)*0+C.readUInt8(++q)*0+C.readUInt8(++q)*0+C.readUInt8(++q)*2**24+C.readUInt8(++q)*2**16+C.readUInt8(++q)*2**8+C.readUInt8(++q));let H=0;L&&(H=C.readUInt8(++q)*2**24+C.readUInt8(++q)*2**16+C.readUInt8(++q)*2**8+C.readUInt8(++q)),this.j.state=3,this.j.readLen=W,this.j.mask=H,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const C=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",C),t(C,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",C),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(C,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(C,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await h.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$0h=f;class l extends c.$Uc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:S.$ue.alloc(0)}constructor(R,C,A,L,W,q){super(),this.n=R,this.r=W,this.s=q,this.a=this.B(new h.$7d),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new h.$7d),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new h.$7d),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,C?(this.b=this.B(new d(this.n,L,A,{windowBits:15})),this.f=this.B(new a(this.n,{windowBits:15})),this.B(this.b.onError(H=>this.a.fire(H))),this.B(this.f.onError(H=>this.a.fire(H)))):(this.b=null,this.f=null)}writeMessage(R,C){this.g.push({data:R,options:C}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:R,options:C}=this.g.shift();if(this.f&&C.compressed){const A=await this.w(this.f,R);this.s(A,C)}else this.s(R,{...C,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(R,C){return new Promise((A,L)=>{R.write(C),R.flush(W=>A(W))})}acceptFrame(R,C,A){this.h.push({data:R,isCompressed:C,isLastFrameOfMessage:A}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const R=this.h.shift();if(this.b&&R.isCompressed){const C=await this.C(this.b,R.data,R.isLastFrameOfMessage);this.r.fire(C)}else this.r.fire(R.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(R,C,A){return new Promise((L,W)=>{R.write(C),A&&R.write(S.$ue.fromByteArray([0,0,255,255])),R.flush(q=>L(q))})}}class d extends c.$Uc{get recordedInflateBytes(){return this.j?S.$ue.concat(this.f):S.$ue.alloc(0)}constructor(R,C,A,L){super(),this.h=R,this.j=C,this.a=this.B(new h.$7d),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,B.createInflateRaw)(L),this.b.on("error",W=>{this.h.traceSocketEvent("zlibInflateError",{message:W?.message,code:W?.code}),this.a.fire(W)}),this.b.on("data",W=>{this.h.traceSocketEvent("zlibInflateData",W),this.g.push(S.$ue.wrap(W))}),A&&(this.h.traceSocketEvent("zlibInflateInitialWrite",A.buffer),this.b.write(A.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(R){this.j&&this.f.push(R.clone()),this.h.traceSocketEvent("zlibInflateWrite",R),this.b.write(R.buffer)}flush(R){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const C=S.$ue.concat(this.g);this.g.length=0,R(C)})}}class a extends c.$Uc{constructor(R,C){super(),this.g=R,this.a=this.B(new h.$7d),this.onError=this.a.event,this.f=[],this.b=(0,B.createDeflateRaw)({windowBits:15}),this.b.on("error",A=>{this.g.traceSocketEvent("zlibDeflateError",{message:A?.message,code:A?.code}),this.a.fire(A)}),this.b.on("data",A=>{this.g.traceSocketEvent("zlibDeflateData",A),this.f.push(S.$ue.wrap(A))})}write(R){this.g.traceSocketEvent("zlibDeflateWrite",R.buffer),this.b.write(R.buffer)}flush(R){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let C=S.$ue.concat(this.f);this.f.length=0,C=C.slice(0,C.byteLength-4),R(C)})}}function t(D,R){if(R===0)return;const C=D.byteLength>>>2;for(let le=0;le<C;le++){const te=D.readUInt32BE(le*4);D.writeUInt32BE(te^R,le*4)}const A=C*4,L=D.byteLength-A,W=R>>>24&255,q=R>>>16&255,H=R>>>8&255;L>=1&&D.writeUInt8(D.readUInt8(A)^W,A),L>=2&&D.writeUInt8(D.readUInt8(A+1)^q,A+1),L>=3&&D.writeUInt8(D.readUInt8(A+2)^H,A+2)}e.$$h=process.env.XDG_RUNTIME_DIR;const o={2:107,1:103};function r(){const D=(0,k.$Dg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${D}-sock`;const R=process.platform!=="darwin"&&e.$$h?e.$$h:(0,P.tmpdir)(),C=(0,p.$kc)(R,`vscode-ipc-${D}.sock`);return s(C),C}function i(D,R,C){const L=(0,n.createHash)("sha256").update(D).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${L}-${C}-${R}-sock`;const W=C.substr(0,4),q=R.substr(0,6);let H;return process.platform!=="darwin"&&e.$$h&&!process.env.VSCODE_PORTABLE?H=(0,p.$kc)(e.$$h,`vscode-${L}-${W}-${q}.sock`):H=(0,p.$kc)(D,`${W}-${q}.sock`),s(H),H}function s(D){const R=o[y.$u];typeof R=="number"&&D.length>=R&&console.warn(`WARNING: IPC handle "${D}" is longer than ${R} chars, try a shorter --user-data-dir`)}class u extends g.$Xh{static b(R){const C=h.Event.fromNodeEventEmitter(R,"connection");return h.Event.map(C,A=>({protocol:new m.$5h(new v(A,"ipc-server-connection")),onDidClientDisconnect:h.Event.once(h.Event.fromNodeEventEmitter(A,"close"))}))}constructor(R){super(u.b(R)),this.d=R}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$bi=u;function b(D){return new Promise((R,C)=>{const A=(0,j.createServer)();A.on("error",C),A.listen(D,()=>{A.removeListener("error",C),R(new u(A))})})}function I(D,R){return new Promise((C,A)=>{const L=(0,j.createConnection)(D,()=>{L.removeListener("error",A),C(m.$6h.fromSocket(new v(L,`ipc-client${R}`),R))});L.once("error",A)})}}),define(oe[24],ae([0,1,51,9,4,100,38,91,6]),function(J,e,n,j,P,B,S,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$D_b=e.$C_b=void 0,e.$C_b=(0,h.$ii)(S.$oi);class c extends E.$Tm{constructor(){super(...arguments),this.d={}}get cachedLanguagesPath(){return(0,j.$kc)(this.userDataPath,"clp")}get backupHome(){return(0,j.$kc)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,B.$ai)(this.userDataPath,"main",this.c.version)}get mainLockfile(){return(0,j.$kc)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}unsetSnapExportedVariables(){if(P.$k){for(const y in process.env)if(y.endsWith("_VSCODE_SNAP_ORIG")){const k=y.slice(0,-17);if(this.d[k])continue;process.env[k]&&(this.d[k]=process.env[k]),process.env[y]?process.env[k]=process.env[y]:delete process.env[k]}}}restoreSnapExportedVariables(){if(P.$k)for(const y in this.d)process.env[y]=this.d[y],delete this.d[y]}}e.$D_b=c,Ee([n.$Lh],c.prototype,"cachedLanguagesPath",null),Ee([n.$Lh],c.prototype,"backupHome",null),Ee([n.$Lh],c.prototype,"mainIPCHandle",null),Ee([n.$Lh],c.prototype,"mainLockfile",null),Ee([n.$Lh],c.prototype,"disableUpdates",null),Ee([n.$Lh],c.prototype,"crossOriginIsolated",null),Ee([n.$Lh],c.prototype,"codeCachePath",null),Ee([n.$Lh],c.prototype,"useCodeCache",null)}),define(oe[287],ae([0,1,87,31,13,9,4,19,21,199,18,24,34,16,5,198,30,99]),function(J,e,n,j,P,B,S,E,h,c,p,y,k,g,m,v,w,$){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.$fac=void 0;let l=class{static{f=this}static{this.a="backupWorkspaces"}constructor(a,t,o,r){this.j=a,this.k=t,this.l=o,this.m=r,this.c=this.j.backupHome,this.d=[],this.e=[],this.g=[],this.h=E.$Lg,this.i={isEqual:(i,s)=>(0,j.$gg)(i,s,!S.$k)}}async initialize(){const a=this.m.getItem(f.a)??{workspaces:[],folders:[],emptyWindows:[]};this.g=await this.w(a.emptyWindows),this.d=await this.u((0,c.$F_b)(a)),this.e=await this.v((0,c.$G_b)(a)),this.C()}n(){return this.q()?[]:this.d.slice(0)}o(){return this.q()?[]:this.e.slice(0)}isHotExitEnabled(){return this.s()!==g.$al.OFF}q(){return this.s()===g.$al.ON_EXIT_AND_WINDOW_CLOSE}s(){return this.k.getValue()?.files?.hotExit||g.$al.ON_EXIT}getEmptyWindowBackups(){return this.g.slice(0)}registerWorkspaceBackup(a,t){this.d.some(r=>a.workspace.id===r.workspace.id)||(this.d.push(a),this.C());const o=(0,B.$kc)(this.c,a.workspace.id);return t?this.t(o,t).then(()=>o):o}async t(a,t){if(await h.Promises.exists(a)&&await this.z(a),await h.Promises.exists(t))try{await h.Promises.rename(t,a,!1)}catch(o){this.l.error(`Backup: Could not move backup folder to new location: ${o.toString()}`)}}registerFolderBackup(a){return this.e.some(t=>this.h.isEqual(a.folderUri,t.folderUri))||(this.e.push(a),this.C()),(0,B.$kc)(this.c,this.D(a))}registerEmptyWindowBackup(a){return this.g.some(t=>!!t.backupFolder&&this.i.isEqual(t.backupFolder,a.backupFolder))||(this.g.push(a),this.C()),(0,B.$kc)(this.c,a.backupFolder)}async u(a){if(!Array.isArray(a))return[];const t=new Set,o=[];for(const r of a){const i=r.workspace;if(!(0,w.$wi)(i))return[];if(!t.has(i.id)){t.add(i.id);const s=(0,B.$kc)(this.c,i.id);await this.B(s)?i.configPath.scheme!==P.Schemas.file||await h.Promises.exists(i.configPath.fsPath)?o.push(r):await this.z(s):await this.x(s)}}return o}async v(a){if(!Array.isArray(a))return[];const t=[],o=new Set;for(const r of a){const i=r.folderUri,s=this.h.getComparisonKey(i);if(!o.has(s)){o.add(s);const u=(0,B.$kc)(this.c,this.D(r));await this.B(u)?i.scheme!==P.Schemas.file||await h.Promises.exists(i.fsPath)?t.push(r):await this.z(u):await this.x(u)}}return t}async w(a){if(!Array.isArray(a))return[];const t=[],o=new Set;for(const r of a){const i=r.backupFolder;if(typeof i!="string")return[];if(!o.has(i)){o.add(i);const s=(0,B.$kc)(this.c,i);await this.B(s)?t.push(r):await this.x(s)}}return t}async x(a){try{await h.Promises.rm(a,h.RimRafMode.MOVE)}catch(t){this.l.error(`Backup: Could not delete stale backup: ${t.toString()}`)}}y(){let a=(0,$.$Y_b)();for(;this.g.some(t=>!!t.backupFolder&&this.i.isEqual(t.backupFolder,a.id));)a=(0,$.$Y_b)();return{backupFolder:a.id}}async z(a){const t=this.y(),o=(0,B.$kc)(this.c,t.backupFolder);try{await h.Promises.rename(a,o,!1)}catch(r){return this.l.error(`Backup: Could not rename backup folder: ${r.toString()}`),!1}return this.g.push(t),!0}async getDirtyWorkspaces(){const a=[];for(const t of this.d)await this.A(t)&&a.push(t);for(const t of this.e)await this.A(t)&&a.push(t);return a}A(a){let t;return(0,c.$E_b)(a)?t=(0,B.$kc)(this.c,a.backupFolder):(0,v.$zeb)(a)?t=(0,B.$kc)(this.c,this.D(a)):t=(0,B.$kc)(this.c,a.workspace.id),this.B(t)}async B(a){try{const t=await h.Promises.readdir(a);for(const o of t)try{if((await h.Promises.readdir((0,B.$kc)(a,o))).length>0)return!0}catch{}}catch{}return!1}C(){const a={workspaces:this.d.map(({workspace:t,remoteAuthority:o})=>{const r={id:t.id,configURIPath:t.configPath.toString()};return o&&(r.remoteAuthority=o),r}),folders:this.e.map(({folderUri:t,remoteAuthority:o})=>{const r={folderUri:t.toString()};return o&&(r.remoteAuthority=o),r}),emptyWindows:this.g.map(({backupFolder:t,remoteAuthority:o})=>{const r={backupFolder:t};return o&&(r.remoteAuthority=o),r})};this.m.setItem(f.a,a)}D(a){const t=a.folderUri;let o;return t.scheme===P.Schemas.file?o=S.$k?t.fsPath:t.fsPath.toLowerCase():o=t.toString().toLowerCase(),(0,n.createHash)("md5").update(o).digest("hex")}};e.$fac=l,e.$fac=l=f=Ee([ne(0,y.$C_b),ne(1,p.$Ni),ne(2,m.$Nj),ne(3,k.$UP)],l)}),define(oe[20],ae([0,1,14,37,8,3,2,4,36,12,6,5,34,24]),function(J,e,n,j,P,B,S,E,h,c,p,y,k,g){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$8_b=e.LifecycleMainPhase=e.ShutdownReason=e.$7_b=void 0,e.$7_b=(0,p.$hi)("lifecycleMainService");var v;(function(f){f[f.QUIT=1]="QUIT",f[f.KILL=2]="KILL"})(v||(e.ShutdownReason=v={}));var w;(function(f){f[f.Starting=1]="Starting",f[f.Ready=2]="Ready",f[f.AfterWindowOpen=3]="AfterWindowOpen",f[f.Eventually=4]="Eventually"})(w||(e.LifecycleMainPhase=w={}));let $=class extends S.$Uc{static{m=this}static{this.b="lifecycle.quitAndRestart"}get quitRequested(){return this.j}get wasRestarted(){return this.m}get phase(){return this.n}constructor(l,d,a){super(),this.F=l,this.G=d,this.H=a,this.c=this.B(new B.$7d),this.onBeforeShutdown=this.c.event,this.f=this.B(new B.$7d),this.onWillShutdown=this.f.event,this.g=this.B(new B.$7d),this.onWillLoadWindow=this.g.event,this.h=this.B(new B.$7d),this.onBeforeCloseWindow=this.h.event,this.j=!1,this.m=!1,this.n=1,this.r=new Set,this.s=0,this.t=0,this.u=void 0,this.w=void 0,this.y=void 0,this.z=new Map,this.C=new Map,this.D=void 0,this.I(),this.when(2).then(()=>this.J())}I(){this.m=!!this.G.getItem(m.b),this.m&&this.G.removeItem(m.b)}J(){const l=()=>{this.j||(this.S("Lifecycle#app.on(before-quit)"),this.j=!0,this.S("Lifecycle#onBeforeShutdown.fire()"),this.c.fire(),E.$j&&this.t===0&&this.L(1))};n.app.addListener("before-quit",l);const d=()=>{this.S("Lifecycle#app.on(window-all-closed)"),(this.j||!E.$j)&&n.app.quit()};n.app.addListener("window-all-closed",d),n.app.once("will-quit",a=>{this.S("Lifecycle#app.on(will-quit) - begin"),a.preventDefault(),this.L(1).finally(()=>{this.S("Lifecycle#app.on(will-quit) - after fireOnWillShutdown"),this.O(!1),n.app.removeListener("before-quit",l),n.app.removeListener("window-all-closed",d),this.S("Lifecycle#app.on(will-quit) - calling app.quit()"),n.app.quit()})})}L(l){if(this.y)return this.y;const d=this.F;this.S("Lifecycle#onWillShutdown.fire()");const a=[];return this.f.fire({reason:l,join(t,o){d.trace(`Lifecycle#onWillShutdown - begin '${t}'`),a.push(o.finally(()=>{d.trace(`Lifecycle#onWillShutdown - end '${t}'`)}))}}),this.y=(async()=>{try{await P.Promises.settled(a)}catch(t){this.F.error(t)}try{await this.G.close()}catch(t){this.F.error(t)}})(),this.y}set phase(l){if(l<this.phase)throw new Error("Lifecycle cannot go backwards");if(this.n===l)return;this.S(`lifecycle (main): phase changed (value: ${l})`),this.n=l;const d=this.C.get(this.n);d&&(d.open(),this.C.delete(this.n))}async when(l){if(l<=this.n)return;let d=this.C.get(l);d||(d=new P.$gh,this.C.set(l,d)),await d.wait()}registerWindow(l){const d=new S.$Tc;this.t++,d.add(l.onWillLoad(t=>this.g.fire({window:l,workspace:t.workspace,reason:t.reason})));const a=(0,c.$6f)(l.win);a.on("close",t=>{const o=l.id;if(this.r.has(o)){this.r.delete(o);return}this.S(`Lifecycle#window.on('close') - window ID ${l.id}`),t.preventDefault(),this.unload(l,1).then(r=>{if(r){this.r.delete(o);return}this.r.add(o),this.S(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${o}`),this.h.fire(l),l.close()})}),a.on("closed",()=>{this.S(`Lifecycle#window.on('closed') - window ID ${l.id}`),this.t--,d.dispose(),this.t===0&&(!E.$j||this.j)&&this.L(1)})}registerAuxWindow(l){const d=(0,c.$6f)(l.win);d.on("close",a=>{this.S(`Lifecycle#auxWindow.on('close') - window ID ${l.id}`),this.j&&(this.S("Lifecycle#auxWindow.on('close') - preventDefault() because quit requested"),a.preventDefault())}),d.on("closed",()=>{this.S(`Lifecycle#auxWindow.on('closed') - window ID ${l.id}`)})}async reload(l,d){await this.unload(l,3)||l.reload(d)}unload(l,d){const a=this.z.get(l.id);if(a)return a;const t=this.M(l,d).finally(()=>{this.z.delete(l.id)});return this.z.set(l.id,t),t}async M(l,d){if(!l.isReady)return!1;this.S(`Lifecycle#unload() - window ID ${l.id}`);const a=this.j?2:d,t=await this.P(l,a);return t?(this.S(`Lifecycle#unload() - veto in renderer (window ID ${l.id})`),this.N(t)):(await this.Q(l,a),!1)}N(l){return l?(this.O(!0),this.j=!1,!0):!1}O(l){this.w&&(this.w(l),this.w=void 0,this.u=void 0)}P(l,d){return new Promise(a=>{const t=this.s++,o=`vscode:ok${t}`,r=`vscode:cancel${t}`;j.$2V.once(o,()=>{a(!1)}),j.$2V.once(r,()=>{a(!0)}),l.send("vscode:onBeforeUnload",{okChannel:o,cancelChannel:r,reason:d})})}Q(l,d){return new Promise(a=>{const o=`vscode:reply${this.s++}`;j.$2V.once(o,()=>a()),l.send("vscode:onWillUnload",{replyChannel:o,reason:d})})}quit(l){return this.R(l).then(d=>{if(!d&&l)try{if(E.$i){const a=(0,h.cwd)();a!==process.cwd()&&process.chdir(a)}}catch(a){this.F.error(a)}return d})}R(l){return this.S(`Lifecycle#quit() - begin (willRestart: ${l})`),this.u?(this.S("Lifecycle#quit() - returning pending quit promise"),this.u):(l&&this.G.setItem(m.b,!0),this.u=new Promise(d=>{this.w=d,this.S("Lifecycle#quit() - calling app.quit()"),n.app.quit()}),this.u)}S(l){this.H.args["enable-smoke-test-driver"]?this.F.info(l):this.F.trace(l)}setRelaunchHandler(l){this.D=l}async relaunch(l){this.S("Lifecycle#relaunch()");const d=process.argv.slice(1);if(l?.addArgs&&d.push(...l.addArgs),l?.removeArgs)for(const o of l.removeArgs){const r=d.indexOf(o);r>=0&&d.splice(r,1)}const a=()=>{this.D?.handleRelaunch(l)||(this.S("Lifecycle#relaunch() - calling app.relaunch()"),n.app.relaunch({args:d}))};n.app.once("quit",a),await this.quit(!0)&&n.app.removeListener("quit",a)}async kill(l){this.S("Lifecycle#kill()"),await this.L(2),await Promise.race([(0,P.$ih)(1e3),(async()=>{for(const d of n.BrowserWindow.getAllWindows())if(d&&!d.isDestroyed()){let a;d.webContents&&!d.webContents.isDestroyed()?a=new Promise(t=>d.once("closed",t)):a=Promise.resolve(),d.destroy(),await a}})()]),n.app.exit(l)}};e.$8_b=$,e.$8_b=$=m=Ee([ne(0,y.$Nj),ne(1,k.$UP),ne(2,g.$C_b)],$)}),define(oe[288],ae([0,1,4,3,2,6,20]),function(J,e,n,j,P,B,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dac=e.$Cac=void 0,e.$Cac=(0,B.$hi)("keyboardLayoutMainService");let E=class extends P.$Uc{constructor(p){super(),this.a=this.B(new j.$7d),this.onDidChangeKeyboardLayout=this.a.event,this.b=null,this.c=null,p.when(3).then(()=>this.f())}f(){return this.b||(this.b=this.g()),this.b}async g(){const p=await new Promise((y,k)=>{J(["native-keymap"],y,k)});this.c=h(p),n.$t||p.onDidChangeKeyboardLayout(()=>{this.c=h(p),this.a.fire(this.c)})}async getKeyboardLayoutData(){return await this.f(),this.c}};e.$Dac=E,e.$Dac=E=Ee([ne(0,S.$7_b)],E);function h(c){const p=c.getKeyMap(),y=c.getCurrentKeyboardLayout();return{keyboardMapping:p,keyboardLayoutInfo:y}}}),define(oe[289],ae([0,1,250,8,17,15,12,18,38,95,5,53,249,286]),function(J,e,n,j,P,B,S,E,h,c,p,y,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gr=void 0,e.$Hr=w;let m=class extends y.$zp{constructor(f,l,d,a){super(a),this.m=f,this.n=l,this.r=d,this.s(),this.B(f.onDidChangeConfiguration(t=>{t.affectsConfiguration("http")&&this.s()}))}s(){const f=this.m.getValue("http");this.f=f?.proxy,this.g=!!f?.proxyStrictSSL,this.h=f?.proxyAuthorization}async request(f,l){const{f:d,g:a}=this;let t;try{t=await(0,c.$rm)(this.m,this.r,this.n.args,process.env)}catch(i){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,B.$0)(i)))}const o={...process.env,...t},r=f.agent?f.agent:await(0,k.$Fr)(f.url||"",o,{proxyUrl:d,strictSSL:a});return f.agent=r,f.strictSSL=a,this.h&&(f.headers={...f.headers||{},"Proxy-Authorization":this.h}),this.c(f.isChromiumNetwork?"electron":"node",f,()=>w(f,l))}async resolveProxy(f){}async loadCertificates(){return(await new Promise((l,d)=>{J(["@vscode/proxy-agent"],l,d)})).loadSystemCertificates({log:this.r})}};e.$Gr=m,e.$Gr=m=Ee([ne(0,E.$Ni),ne(1,h.$pi),ne(2,p.$Nj),ne(3,p.$Oj)],m);async function v($){return((0,n.parse)($.url).protocol==="https:"?await new Promise((d,a)=>{J(["https"],d,a)}):await new Promise((d,a)=>{J(["http"],d,a)})).request}async function w($,f){return j.Promises.withAsyncBody(async(l,d)=>{const a=(0,n.parse)($.url),t=$.getRawRequest?$.getRawRequest($):await v($),o={hostname:a.hostname,port:a.port?parseInt(a.port):a.protocol==="https:"?443:80,protocol:a.protocol,path:a.path,method:$.type||"GET",headers:$.headers,agent:$.agent,rejectUnauthorized:(0,S.$1f)($.strictSSL)?$.strictSSL:!0};$.user&&$.password&&(o.auth=$.user+":"+$.password);const r=t(o,i=>{const s=(0,S.$Yf)($.followRedirects)?$.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&s>0&&i.headers.location)w({...$,url:i.headers.location,followRedirects:s-1},f).then(l,d);else{let u=i;!$.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(u=i.pipe((0,g.createGunzip)())),l({res:i,stream:(0,P.$Je)(u)})}});r.on("error",d),$.timeout&&r.setTimeout($.timeout),$.isChromiumNetwork&&r.removeHeader("Content-Length"),$.data&&typeof $.data=="string"&&r.write($.data),r.end(),f.onCancellationRequested(()=>{r.abort(),d(new B.$5)})})}}),define(oe[290],ae([0,1,14,289]),function(J,e,n,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fbc=void 0;function P(S){return n.net.request}class B extends j.$Gr{request(E,h){return super.request({...E||{},getRawRequest:P,isChromiumNetwork:!0},h)}}e.$Fbc=B}),define(oe[83],ae([0,1,7,3,2,38,16,6,20,5,97,283,41,57,40,13]),function(J,e,n,j,P,B,S,E,h,c,p,y,k,g,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dac=e.$cac=e.$bac=e.$aac=void 0,e.$aac=(0,E.$hi)("storageMainService");let w=class extends P.$Uc{constructor(l,d,a,t,o,r){super(),this.c=l,this.f=d,this.g=a,this.h=t,this.j=o,this.m=r,this.a=void 0,this.b=this.B(new j.$7d),this.onDidChangeProfileStorage=this.b.event,this.applicationStorage=this.B(this.s()),this.t=new Map,this.w=new Map,this.r()}n(){return{useInMemoryStorage:!!this.f.extensionTestsLocationURI}}r(){(async()=>(await this.h.when(3),this.applicationStorage.init()))(),this.B(this.h.onWillLoadWindow(l=>{l.window.profile&&this.profileStorage(l.window.profile).init(),l.workspace&&this.workspaceStorage(l.workspace).init()})),this.B(this.h.onWillShutdown(l=>{this.c.trace("storageMainService#onWillShutdown()"),this.a=l.reason,l.join("applicationStorage",this.applicationStorage.close());for(const[,d]of this.t)l.join("profileStorage",d.close());for(const[,d]of this.w)l.join("workspaceStorage",d.close())})),this.B(this.g.onWillCreateProfile(l=>{l.join((async()=>{await this.j.exists(l.profile.globalStorageHome)||await this.j.createFolder(l.profile.globalStorageHome)})())})),this.B(this.g.onWillRemoveProfile(l=>{const d=this.t.get(l.profile.id);d&&l.join(d.close())}))}s(){this.c.trace("StorageMainService: creating application storage");const l=new y.$0_b(this.n(),this.g,this.c,this.j);return this.B(j.Event.once(l.onDidCloseStorage)(()=>{this.c.trace("StorageMainService: closed application storage")})),l}profileStorage(l){if((0,p.$Op)(l))return this.applicationStorage;let d=this.t.get(l.id);if(!d){this.c.trace(`StorageMainService: creating profile storage (${l.name})`),d=this.B(this.u(l)),this.t.set(l.id,d);const a=this.B(d.onDidChangeStorage(t=>this.b.fire({...t,storage:d,profile:l})));this.B(j.Event.once(d.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed profile storage (${l.name})`),this.t.delete(l.id),a.dispose()}))}return d}u(l){return this.a===2?new y.$__b(this.c,this.j):new y.$9_b(l,this.n(),this.c,this.j)}workspaceStorage(l){let d=this.w.get(l.id);return d||(this.c.trace(`StorageMainService: creating workspace storage (${l.id})`),d=this.B(this.y(l)),this.w.set(l.id,d),this.B(j.Event.once(d.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed workspace storage (${l.id})`),this.w.delete(l.id)}))),d}y(l){return this.a===2?new y.$__b(this.c,this.j):new y.$$_b(l,this.n(),this.c,this.f,this.j)}isUsed(l){const d=n.URI.file(l);for(const a of[this.applicationStorage,...this.t.values(),...this.w.values()])if(a.path&&this.m.extUri.isEqualOrParent(n.URI.file(a.path),d))return!0;return!1}};e.$bac=w,e.$bac=w=Ee([ne(0,c.$Nj),ne(1,B.$oi),ne(2,g.$Q_b),ne(3,h.$7_b),ne(4,S.$Nk),ne(5,m.$ll)],w),e.$cac=(0,E.$hi)("applicationStorageMainService");let $=class extends p.$Np{constructor(l,d){super(),this.s=l,this.U=d,this.whenReady=this.U.applicationStorage.whenInit}O(){return this.U.applicationStorage.whenInit}P(l){if(l===-1)return this.U.applicationStorage.storage}Q(l){if(l===-1)return this.s.defaultProfile.globalStorageHome.with({scheme:v.Schemas.file}).fsPath}r(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}R(){throw new Error("Switching storage profile is unsupported from main process")}S(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};e.$dac=$,e.$dac=$=Ee([ne(0,k.$nl),ne(1,e.$aac)],$)}),define(oe[291],ae([0,1,88,26,107,100,8,2,4,18,5,27,245,246,96,130,17]),function(J,e,n,j,P,B,S,E,h,c,p,y,k,g,m,v,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ebc=e.$Dbc=e.$Cbc=e.$Bbc=void 0;async function $(t,o,r,i,s){let u;for(let b=3;b&&(u?.dispose(),u=await new f(t,o,r,i,s).waitForReady(),!(s&&P.$Gg[s]||!P.$Gg[u.tunnelLocalPort]));b--);return u}class f extends E.$Uc{constructor(o,r,i,s,u){super(),this.m=r,this.n=u,this.privacy=v.TunnelPrivacyId.Private,this.j=new Map,this.a=o,this.b=n.createServer(),this.c=new S.$gh,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=b=>this.r(b),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=s,this.tunnelRemoteHost=i}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(r=>{r()})}async waitForReady(){const o=this.n??this.tunnelRemotePort,r=(0,v.$4v)(this.m)?"0.0.0.0":"127.0.0.1";let i=await(0,P.$Hg)(o,2,1e3,r),s=null;return this.b.listen(i,this.m),await this.c.wait(),s=this.b.address(),s||(i=0,this.b.listen(i,this.m),await this.c.wait(),s=this.b.address()),this.tunnelLocalPort=s.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${s.port}`,this}async r(o){o.pause();const r=(0,v.$2v)(this.tunnelRemoteHost)||(0,v.$4v)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,i=await(0,k.$Dl)(this.a,r,this.tunnelRemotePort),s=i.getSocket(),u=i.readEntireBuffer();i.dispose(),u.byteLength>0&&o.write(u.buffer),o.on("end",()=>{o.localAddress&&this.j.delete(o.localAddress),s.end()}),o.on("close",()=>s.end()),o.on("error",()=>{o.localAddress&&this.j.delete(o.localAddress),s instanceof B.$9h?s.socket.destroy():s.end()}),s instanceof B.$9h?this.t(o,s):this.s(o,s),o.localAddress&&this.j.set(o.localAddress,()=>{o.end(),s.end()})}s(o,r){r.onClose(()=>o.destroy()),r.onEnd(()=>o.end()),r.onData(i=>o.write(i.buffer)),o.on("data",i=>r.write(w.$ue.wrap(i))),o.resume()}t(o,r){const i=r.socket;i.on("end",()=>o.end()),i.on("close",()=>o.end()),i.on("error",()=>{o.destroy()}),i.pipe(o),o.pipe(i)}}e.$Bbc=f;let l=class extends v.$7v{constructor(o,r,i,s,u){super(r,u),this.v=o,this.w=i,this.y=s}isPortPrivileged(o){return(0,v.$5v)(o,this.m,h.OS,j.release())}t(o,r,i,s,u,b,I,D){const R=this.s(r,i);if(R)return++R.refcount,R.value;if((0,v.$Xv)(o))return this.u(o,r,i,u,b,I,D);{this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${r}:${i} on local port ${u}.`);const C={commit:this.y.commit,quality:this.y.quality,addressProvider:o,remoteSocketFactoryService:this.v,signService:this.w,logService:this.k,ipcLogger:null},A=$(C,s,r,i,u);return this.k.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.q(r,i,A),A}}};e.$Cbc=l,e.$Cbc=l=Ee([ne(0,g.$xl),ne(1,p.$Nj),ne(2,m.$Al),ne(3,y.$7j),ne(4,c.$Ni)],l);let d=class extends l{constructor(o,r,i,s,u){super(o,r,i,s,u)}};e.$Dbc=d,e.$Dbc=d=Ee([ne(0,g.$xl),ne(1,p.$Nj),ne(2,m.$Al),ne(3,y.$7j),ne(4,c.$Ni)],d);let a=class extends E.$Uc{constructor(o,r,i,s,u){super(),this.b=o,this.c=r,this.f=i,this.g=s,this.h=u,this.a=new Map}async openTunnel(o,r,i,s,u,b,I,D,R){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${i}:${s} on local port ${b}.`),!this.a.has(o)){const C=new d(this.b,this.c,this.g,this.f,this.h);this.B(C),this.a.set(o,C),C.onTunnelClosed(async()=>{(await C.tunnels).length===0&&(C.dispose(),this.a.delete(o))})}return this.a.get(o).openTunnel(r,i,s,u,b,I,D,R)}};e.$Ebc=a,e.$Ebc=a=Ee([ne(0,g.$xl),ne(1,p.$Nj),ne(2,y.$7j),ne(3,m.$Al),ne(4,c.$Ni)],a)}),define(oe[101],ae([0,1,8,23,3,18,24,20,5,27,53,50]),function(J,e,n,j,P,B,S,E,h,c,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1ac=void 0,e.$Zac=k;function k(m,v,w){return`${w.updateUrl}/api/update/${m}/${v}/${w.commit}`}let g=class{get state(){return this.b}d(v){this.j.info("update#setState",v.type),this.b=v,this.c.fire(v)}constructor(v,w,$,f,l,d){this.f=v,this.g=w,this.h=$,this.i=f,this.j=l,this.k=d,this.b=y.$ZW.Uninitialized,this.c=new P.$7d,this.onStateChange=this.c.event,v.when(3).finally(()=>this.l())}async l(){if(!this.h.isBuilt){this.d(y.$ZW.Disabled(0));return}if(this.h.disableUpdates){this.d(y.$ZW.Disabled(1)),this.j.info("update#ctor - updates are disabled by the environment");return}if(!this.k.updateUrl||!this.k.commit){this.d(y.$ZW.Disabled(3)),this.j.info("update#ctor - updates are disabled as there is no update URL");return}const v=this.g.getValue("update.mode"),w=this.m(v);if(!w){this.d(y.$ZW.Disabled(2)),this.j.info("update#ctor - updates are disabled by user preference");return}if(this.a=this.s(w),!this.a){this.d(y.$ZW.Disabled(4)),this.j.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.g.getValue("_update.prss")){const $=new URL(this.a);$.searchParams.set("prss","true"),this.a=$.toString()}if(this.d(y.$ZW.Idle(this.q())),v==="manual"){this.j.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}v==="start"?(this.j.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.n(30*1e3).then(void 0,$=>this.j.error($))}m(v){return v==="none"?void 0:this.k.quality}n(v=60*60*1e3){return(0,n.$ih)(v).then(()=>this.checkForUpdates(!1)).then(()=>this.n(60*60*1e3))}async checkForUpdates(v){this.j.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.t(v)}async downloadUpdate(){this.j.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.o(this.state)}async o(v){}async applyUpdate(){this.j.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.p()}async p(){}quitAndInstall(){return this.j.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.j.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(v=>{this.j.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${v}`),!v&&(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.r())})),Promise.resolve(void 0)}async isLatestVersion(){if(!this.a)return;if(this.g.getValue("update.mode")==="none")return!1;try{return(await this.i.request({url:this.a},j.CancellationToken.None)).res.statusCode===204}catch(w){this.j.error("update#isLatestVersion(): failed to check for updates"),this.j.error(w);return}}async _applySpecificUpdate(v){}q(){return 1}r(){}};e.$1ac=g,e.$1ac=g=Ee([ne(0,E.$7_b),ne(1,B.$Ni),ne(2,S.$C_b),ne(3,p.$yp),ne(4,h.$Nj),ne(5,c.$7j)],g)}),define(oe[292],ae([0,1,14,51,3,46,2,18,24,20,5,27,53,28,50,101]),function(J,e,n,j,P,B,S,E,h,c,p,y,k,g,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2ac=void 0;let w=class extends v.$1ac{get v(){return P.Event.fromNodeEventEmitter(n.autoUpdater,"error",(f,l)=>l)}get w(){return P.Event.fromNodeEventEmitter(n.autoUpdater,"update-not-available")}get x(){return P.Event.fromNodeEventEmitter(n.autoUpdater,"update-available")}get y(){return P.Event.fromNodeEventEmitter(n.autoUpdater,"update-downloaded",(f,l,d,a)=>({version:d,productVersion:d,timestamp:a}))}constructor(f,l,d,a,t,o,r){super(f,l,a,t,o,r),this.z=d,this.u=new S.$Tc,f.setRelaunchHandler(this)}handleRelaunch(f){return f?.addArgs||f?.removeArgs||this.state.type!=="ready"?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){await super.l(),this.v(this.B,this,this.u),this.x(this.E,this,this.u),this.y(this.F,this,this.u),this.w(this.G,this,this.u)}B(f){this.z.publicLog2("update:error",{messageHash:String((0,B.$8i)(String(f)))}),this.j.error("UpdateService error:",f);const l=this.state.type==="checking for updates"&&this.state.explicit?f:void 0;this.d(m.$ZW.Idle(1,l))}s(f){let l;this.k.darwinUniversalAssetId?l=this.k.darwinUniversalAssetId:l=process.arch==="x64"?"darwin":"darwin-arm64";const d=(0,v.$Zac)(l,f,this.k);try{n.autoUpdater.setFeedURL({url:d})}catch(a){this.j.error("Failed to set update feed URL",a);return}return d}t(f){this.d(m.$ZW.CheckingForUpdates(f)),n.autoUpdater.checkForUpdates()}E(){this.state.type==="checking for updates"&&this.d(m.$ZW.Downloading)}F(f){this.state.type==="downloading"&&(this.d(m.$ZW.Downloaded(f)),this.z.publicLog2("update:downloaded",{version:f.version}),this.d(m.$ZW.Ready(f)))}G(){this.state.type==="checking for updates"&&(this.z.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.d(m.$ZW.Idle(1)))}r(){this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),n.autoUpdater.quitAndInstall()}dispose(){this.u.dispose()}};e.$2ac=w,Ee([j.$Lh],w.prototype,"v",null),Ee([j.$Lh],w.prototype,"w",null),Ee([j.$Lh],w.prototype,"x",null),Ee([j.$Lh],w.prototype,"y",null),e.$2ac=w=Ee([ne(0,c.$7_b),ne(1,E.$Ni),ne(2,g.$Ml),ne(3,h.$C_b),ne(4,k.$yp),ne(5,p.$Nj),ne(6,y.$7j)],w)}),define(oe[293],ae([0,1,49,43,8,3,9,24,20,5,28,50]),function(J,e,n,j,P,B,S,E,h,c,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4ac=void 0;let k=class{get state(){return this.a}d(v){this.g.info("update#setState",v.type),this.a=v,this.b.fire(v)}constructor(v,w,$){if(this.f=v,this.g=$,this.a=y.$ZW.Uninitialized,this.b=new B.$7d,this.onStateChange=this.b.event,w.disableUpdates){this.g.info("update#ctor - updates are disabled");return}this.d(y.$ZW.Idle(this.k())),this.h(30*1e3).then(void 0,f=>this.g.error(f))}h(v=60*60*1e3){return(0,P.$ih)(v).then(()=>this.checkForUpdates(!1)).then(()=>this.h(60*60*1e3))}async checkForUpdates(v){this.g.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.m(v)}async downloadUpdate(){this.g.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.i(this.state)}i(v){return Promise.resolve(void 0)}async applyUpdate(){this.g.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.j()}j(){return Promise.resolve(void 0)}quitAndInstall(){return this.g.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.g.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(v=>{this.g.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${v}`),!v&&(this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.l())})),Promise.resolve(void 0)}k(){return 2}l(){}async _applySpecificUpdate(v){}};k=Ee([ne(0,h.$7_b),ne(1,E.$C_b),ne(2,c.$Nj)],k);let g=class extends k{constructor(v,w,$,f,l,d){super($,f,l),this.o=v,this.p=w,this.q=d;const a=(0,j.watch)(S.$nc(this.o)),t=B.Event.fromNodeEventEmitter(a,"change",(s,u)=>u),o=B.Event.filter(t,s=>s==="current"),i=B.Event.debounce(o,(s,u)=>u,2e3)(()=>this.checkForUpdates(!1));$.onWillShutdown(()=>{i.dispose(),a.close()})}m(){this.d(y.$ZW.CheckingForUpdates(!1)),this.u().then(v=>{v?this.d(y.$ZW.Ready({version:"something"})):(this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(y.$ZW.Idle(2)))},v=>{this.g.error(v),this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(y.$ZW.Idle(2,v.message||v))})}l(){this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,n.spawn)("sleep 3 && "+S.$oc(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async u(){const v=await new Promise(($,f)=>(0,j.realpath)(`${S.$nc(this.o)}/current`,(l,d)=>l?f(l):$(d))),w=S.$oc(v);return this.p!==w}isLatestVersion(){return this.u().then(void 0,v=>{this.g.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};e.$4ac=g,e.$4ac=g=Ee([ne(2,h.$7_b),ne(3,E.$C_b),ne(4,c.$Nj),ne(5,p.$Ml)],g)}),define(oe[29],ae([0,1,14,4,6,81,55,69,27,18,24,9,138]),function(J,e,n,j,P,B,S,E,h,c,p,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowStateValidator=e.OpenContext=e.$N_b=void 0,e.$O_b=m,e.$P_b=v,e.$N_b=(0,P.$hi)("windowsMainService");var g;(function($){$[$.CLI=0]="CLI",$[$.DOCK=1]="DOCK",$[$.MENU=2]="MENU",$[$.DIALOG=3]="DIALOG",$[$.DESKTOP=4]="DESKTOP",$[$.API=5]="API"})(g||(e.OpenContext=g={}));function m($,f,l){const d=$.get(E.$L_b),a=$.get(h.$7j),t=$.get(c.$Ni),o=$.get(p.$C_b),r=t.getValue("window"),i={backgroundColor:d.getBackgroundColor(),minWidth:S.$$C.WIDTH,minHeight:S.$$C.HEIGHT,title:a.nameLong,...l,x:f.x,y:f.y,width:f.width,height:f.height,webPreferences:{enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,S.$jD)(f.zoomLevel??r?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",...l?.webPreferences,sandbox:!0},experimentalDarkMode:!0};if(j.$k?i.icon=(0,y.$kc)(o.appRoot,"resources/linux/code.png"):j.$i&&!o.isBuilt&&(i.icon=(0,y.$kc)(o.appRoot,"resources/win32/code_150x150.png")),j.$j&&(i.acceptFirstMouse=!0,r?.clickThroughInactive===!1&&(i.acceptFirstMouse=!1)),j.$j&&!(0,S.$iD)(t)&&(i.fullscreenable=!1),j.$j&&r?.nativeTabs===!0&&(i.tabbingIdentifier=a.nameShort),!(0,S.$fD)(t)&&(i.titleBarStyle="hidden",j.$j||(i.frame=!1),(0,S.$hD)(t))){const b=d.getWindowSplash()?.colorInfo.titleBarBackground??d.getBackgroundColor(),I=k.$Ft.fromHex(b).isDarker()?"#FFFFFF":"#000000";i.titleBarOverlay={height:29,color:b,symbolColor:I}}return i}function v($){let f,l=Number.MIN_VALUE;for(const d of $)d.lastFocusTime>l&&(l=d.lastFocusTime,f=d);return f}var w;(function($){function f(d,a,t=n.screen.getAllDisplays()){if(d.trace(`window#validateWindowState: validating window state on ${t.length} display(s)`,a),typeof a.x!="number"||typeof a.y!="number"||typeof a.width!="number"||typeof a.height!="number"){d.trace("window#validateWindowState: unexpected type of state values");return}if(a.width<=0||a.height<=0){d.trace("window#validateWindowState: unexpected negative values");return}if(t.length===1){const i=l(t[0]);if(d.trace("window#validateWindowState: single monitor working area",i),i){let s=function(){!a||typeof a.x!="number"||typeof a.y!="number"||!i||(a.x<i.x&&(a.x=i.x),a.y<i.y&&(a.y=i.y))};s(),a.width>i.width&&(a.width=i.width),a.height>i.height&&(a.height=i.height),a.x>i.x+i.width-128&&(a.x=i.x+i.width-a.width),a.y>i.y+i.height-128&&(a.y=i.y+i.height-a.height),s()}return a}if(a.display&&a.mode===3){const i=t.find(s=>s.id===a.display);if(i&&typeof i.bounds?.x=="number"&&typeof i.bounds?.y=="number"){d.trace("window#validateWindowState: restoring fullscreen to previous display");const s=(0,B.$A_b)(3);return s.x=i.bounds.x,s.y=i.bounds.y,s}}let o,r;try{o=n.screen.getDisplayMatching({x:a.x,y:a.y,width:a.width,height:a.height}),r=l(o),d.trace("window#validateWindowState: multi-monitor working area",r)}catch(i){d.error("window#validateWindowState: error finding display for window state",i)}if(o&&r&&a.x+a.width>r.x&&a.y+a.height>r.y&&a.x<r.x+r.width&&a.y<r.y+r.height)return a;d.trace("window#validateWindowState: state is outside of the multi-monitor working area")}$.validateWindowState=f;function l(d){if(d.workArea.width>0&&d.workArea.height>0)return d.workArea;if(d.bounds.width>0&&d.bounds.height>0)return d.bounds}})(w||(e.WindowStateValidator=w={}))}),define(oe[294],ae([0,1,14,23,3,46,2,33,120,5,83,29]),function(J,e,n,j,P,B,S,E,h,c,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eac=void 0;var k;(function(m){m[m.Initial=1]="Initial",m[m.StoredCredentialsUsed=2]="StoredCredentialsUsed",m[m.LoginDialogShown=3]="LoginDialogShown"})(k||(k={}));let g=class extends S.$Uc{constructor(v,w,$,f){super(),this.g=v,this.h=w,this.j=$,this.m=f,this.a="proxy-credentials://",this.b=void 0,this.c=k.Initial,this.f=void 0,this.n()}n(){const v=P.Event.fromNodeEventEmitter(n.app,"login",(w,$,f,l,d)=>({event:w,webContents:$,req:f,authInfo:l,callback:d}));this.B(v(this.r,this))}async r({event:v,authInfo:w,req:$,callback:f}){if(!w.isProxy)return;if(!this.b&&this.c===k.LoginDialogShown&&$.firstAuthAttempt){this.g.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}v.preventDefault();let l;if(this.b)this.g.trace("auth#onLogin (proxy) - pending proxy handling found"),l=await this.b;else{this.g.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.b=this.s(w);try{l=await this.b}finally{this.b=void 0}}f(l?.username,l?.password)}async s(v){this.g.trace("auth#resolveProxyCredentials (proxy) - enter");try{const w=await this.t(v);if(w)return this.g.trace("auth#resolveProxyCredentials (proxy) - got credentials"),w;this.g.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.g.trace("auth#resolveProxyCredentials (proxy) - exit")}}async t(v){this.g.trace("auth#doResolveProxyCredentials - enter",v);const w=String((0,B.$8i)({scheme:v.scheme,host:v.host,port:v.port}));let $,f;try{const t=this.m.get(this.a+w,-1);if(t){const o=JSON.parse(await this.j.decrypt(t));$=o.username,f=o.password}}catch(t){this.g.error(t)}if(this.c!==k.StoredCredentialsUsed&&typeof $=="string"&&typeof f=="string")return this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.c=k.StoredCredentialsUsed,{username:$,password:f};const l=this.h.getFocusedWindow()||this.h.getLastActiveWindow();if(!l){this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.g.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${l.id} to handle proxy login`);const d={authInfo:v,username:this.f?.username??$,password:this.f?.password??f,replyChannel:`vscode:proxyAuthResponse:${(0,E.$Dg)()}`};l.sendWhenReady("vscode:openProxyAuthenticationDialog",j.CancellationToken.None,d),this.c=k.LoginDialogShown;const a=await new Promise(t=>{const o=async(r,i,s)=>{if(i===d.replyChannel)if(this.g.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${l.id}`),l.win?.webContents.off("ipc-message",o),s){const u={username:s.username,password:s.password};try{if(s.remember){const b=await this.j.encrypt(JSON.stringify(u));this.m.store(this.a+w,b,-1,1)}else this.m.remove(this.a+w,-1)}catch(b){this.g.error(b)}t({username:u.username,password:u.password})}else t(void 0)};l.win?.webContents.on("ipc-message",o)});return this.f=a,a}};e.$eac=g,e.$eac=g=Ee([ne(0,c.$Nj),ne(1,y.$N_b),ne(2,h.$KW),ne(3,p.$cac)],g)}),define(oe[295],ae([0,1,14,22,4,7,21,18,64,6,5,131,29]),function(J,e,n,j,P,B,S,E,h,c,p,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gac=e.$Fac=e.ID=void 0,e.ID="launchMainService",e.$Fac=(0,c.$hi)(e.ID);let g=class{constructor(v,w,$,f){this.a=v,this.b=w,this.c=$,this.d=f}async start(v,w){this.a.trace("Received data from other instance: ",v,w),P.$j&&n.app.focus({steal:!0});const $=this.e(v);if($.length){let f=Promise.resolve();if(this.b.getWindowCount()===0){const l=(0,j.$Ob)(await this.b.openEmptyWindow({context:4}));l&&(f=l.ready())}f.then(()=>{for(const{uri:l,originalUrl:d}of $)this.c.open(l,{originalUrl:d})})}else return this.f(v,w)}e(v){return v["open-url"]&&v._urls&&v._urls.length>0?(0,j.$Hb)(v._urls.map(w=>{try{return{uri:B.URI.parse(w),originalUrl:w}}catch{return null}})):[]}async f(v,w){const $=(0,h.$lm)(w)?0:4;let f=[];const l=v.wait&&v.waitMarkerFilePath?B.URI.file(v.waitMarkerFilePath):void 0,d=v.remote||void 0,a={context:$,cli:v,userEnv:v["preserve-env"]||$===0?w:void 0,waitMarkerFileURI:l,remoteAuthority:d,forceProfile:v.profile,forceTempProfile:v["profile-temp"]};if(v.extensionDevelopmentPath)await this.b.openExtensionDevelopmentHostWindow(v.extensionDevelopmentPath,a);else if(!v._.length&&!v["folder-uri"]&&!v["file-uri"]){let t=!1;if(v["new-window"]||v["unity-launch"]||a.forceProfile||a.forceTempProfile)t=!0;else if(v["reuse-window"])t=!1;else switch(this.d.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":t=!0;break;case"off":t=!1;break;default:t=!P.$j}if(t)f=await this.b.open({...a,forceNewWindow:!0,forceEmpty:!0});else{const o=this.b.getLastActiveWindow();o?(this.b.openExistingWindow(o,a),f=[o]):f=await this.b.open({...a,forceEmpty:!0})}}else f=await this.b.open({...a,forceNewWindow:v["new-window"],preferNewWindow:!v["reuse-window"]&&!v.wait,forceReuseWindow:v["reuse-window"],diffMode:v.diff,mergeMode:v.merge,addMode:v.add,noRecentEntry:!!v["skip-add-to-recently-opened"],gotoLineMode:v.goto});if(l&&f.length===1&&f[0])return Promise.race([f[0].whenClosedOrLoaded,(0,S.whenDeleted)(l.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.a.trace("Received request for process ID from other instance."),process.pid}};e.$Gac=g,e.$Gac=g=Ee([ne(0,p.$Nj),ne(1,k.$N_b),ne(2,y.$QW),ne(3,E.$Ni)],g)}),define(oe[296],ae([0,1,2,20,57,30,8,29]),function(J,e,n,j,P,B,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jbc=void 0;let h=class extends n.$Uc{constructor(p,y,k){super(),this.a=y,this.b=k,this.B(p.onWillLoadWindow(g=>{g.reason===2&&this.c(g.window)})),this.B(p.onBeforeCloseWindow(g=>this.c(g))),this.B(new S.$th(()=>this.g(),30*1e3)).schedule()}async c(p){const y=this.f(p),k=this.a.getProfileForWorkspace(y);k?.isTransient&&(this.a.unsetWorkspace(y,k.isTransient),k.isTransient&&await this.a.cleanUpTransientProfiles())}f(p){return p.openedWorkspace??(0,B.$vi)(p.backupPath,p.isExtensionDevelopmentHost)}g(){const p=this.a.getAssociatedEmptyWindows();if(p.length===0)return;const y=this.b.getWindows().map(k=>this.f(k));for(const k of p)y.some(g=>g.id===k.id)||this.a.unsetWorkspace(k,!1)}};e.$jbc=h,e.$jbc=h=Ee([ne(0,j.$7_b),ne(1,P.$Q_b),ne(2,E.$N_b)],h)}),define(oe[61],ae([0,1,14,2,3,5,316,8,13,29,73,28,20,75,35,4,102]),function(J,e,n,j,P,B,S,E,h,c,p,y,k,g,m,v,w){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$iac=e.$hac=void 0;function f(a){return typeof a.responseWindowId=="number"}let l=class extends j.$Uc{static{$=this}static{this.a=0}static{this.b=new Map}static getAll(){return Array.from($.b.values())}constructor(t,o,r){super(),this.u=t,this.w=o,this.y=r,this.c=String(++$.a),this.f=this.B(new P.$7d),this.onStdout=this.f.event,this.g=this.B(new P.$7d),this.onStderr=this.g.event,this.h=this.B(new P.$7d),this.onMessage=this.h.event,this.j=this.B(new P.$7d),this.onSpawn=this.j.event,this.m=this.B(new P.$7d),this.onExit=this.m.event,this.n=this.B(new P.$7d),this.onCrash=this.n.event,this.r=void 0,this.s=void 0,this.t=void 0}z(t,o){let r;switch(this.t?.correlationId?r=`[UtilityProcess id: ${this.t?.correlationId}, type: ${this.t?.type}, pid: ${this.s??"<none>"}]: ${t}`:r=`[UtilityProcess type: ${this.t?.type}, pid: ${this.s??"<none>"}]: ${t}`,o){case p.default.Error:this.u.error(r);break;case p.default.Warning:this.u.warn(r);break;case p.default.Info:this.u.trace(r);break}}C(){return this.r?(this.z("Cannot start utility process because it is already running...",p.default.Error),!1):!0}start(t){const o=this.D(t);return o&&t.payload&&this.postMessage(t.payload)&&this.z("payload sent via postMessage()",p.default.Info),o}D(t){if(!this.C())return!1;this.t=t;const o=`${this.t.type}-${this.c}`,r=h.$Bg.asFileUri("bootstrap-fork.js").fsPath,i=this.t.args??[],s=this.t.execArgv??[],u=this.t.allowLoadingUnsignedLibraries,b=this.t.forceAllocationsToV8Sandbox,I="pipe",D=this.F(t);return this.z("creating new...",p.default.Info),this.r=n.utilityProcess.fork(r,i,{serviceName:o,env:D,execArgv:s,allowLoadingUnsignedLibraries:u,forceAllocationsToV8Sandbox:b,stdio:I}),this.G(this.r,this.t,o),!0}F(t){const o=t.env?{...t.env}:{...(0,m.$Nn)(process.env)};o.VSCODE_AMD_ENTRYPOINT=t.entryPoint,typeof t.parentLifecycleBound=="number"&&(o.VSCODE_PARENT_PID=String(t.parentLifecycleBound)),o.VSCODE_CRASH_REPORTER_PROCESS_TYPE=t.type,v.$i&&((0,w.isUNCAccessRestrictionsDisabled)()?o.NODE_DISABLE_UNC_ACCESS_CHECKS="1":o.NODE_UNC_HOST_ALLOWLIST=(0,w.getUNCHostAllowlist)().join("\\")),(0,g.$$l)(o);for(const r of Object.keys(o))o[r]=String(o[r]);return o}G(t,o,r){if(t.stdout){const i=new S.StringDecoder("utf-8");this.B(P.Event.fromNodeEventEmitter(t.stdout,"data")(s=>this.f.fire(typeof s=="string"?s:i.write(s))))}if(t.stderr){const i=new S.StringDecoder("utf-8");this.B(P.Event.fromNodeEventEmitter(t.stderr,"data")(s=>this.g.fire(typeof s=="string"?s:i.write(s))))}this.B(P.Event.fromNodeEventEmitter(t,"message")(i=>this.h.fire(i))),this.B(P.Event.fromNodeEventEmitter(t,"spawn")(()=>{this.s=t.pid,typeof t.pid=="number"&&$.b.set(t.pid,{pid:t.pid,name:f(o)?`${o.type} [${o.responseWindowId}]`:o.type}),this.z("successfully created",p.default.Info),this.j.fire(t.pid)})),this.B(P.Event.fromNodeEventEmitter(t,"exit")(i=>{this.z(`received exit event with code ${i}`,p.default.Info),this.m.fire({pid:this.s,code:i,signal:"unknown"}),this.H()})),this.B(P.Event.fromNodeEventEmitter(n.app,"child-process-gone",(i,s)=>({event:i,details:s}))(({details:i})=>{i.type==="Utility"&&i.name===r&&(this.z(`crashed with code ${i.exitCode} and reason '${i.reason}'`,p.default.Error),this.w.publicLog2("utilityprocesscrash",{type:o.type,reason:i.reason,code:i.exitCode}),this.n.fire({pid:this.s,code:i.exitCode,reason:i.reason}),this.H())}))}once(t,o){const r=this.B(this.h.event(i=>{i===t&&(r.dispose(),o())}))}postMessage(t,o){return this.r?(this.r.postMessage(t,o),!0):!1}connect(t){const{port1:o,port2:r}=new n.MessageChannelMain;return this.postMessage(t,[r]),o}enableInspectPort(){if(!this.r||typeof this.s!="number")return!1;this.z("enabling inspect port",p.default.Info);const t=process;return typeof t._debugProcess=="function"?(t._debugProcess(this.s),!0):!1}kill(){if(!this.r)return;this.z("attempting to kill the process...",p.default.Info),this.r.kill()?(this.z("successfully killed the process",p.default.Info),this.H()):this.z("unable to kill the process",p.default.Warning)}H(){typeof this.s=="number"&&$.b.delete(this.s),this.r=void 0}async waitForExit(t){this.r&&(this.z("waiting to exit...",p.default.Info),await Promise.race([P.Event.toPromise(this.onExit),(0,E.$ih)(t)]),this.r&&(this.z(`did not exit within ${t}ms, will kill it now...`,p.default.Info),this.kill()))}};e.$hac=l,e.$hac=l=$=Ee([ne(0,B.$Nj),ne(1,y.$Ml),ne(2,k.$7_b)],l);let d=class extends l{constructor(t,o,r,i){super(t,r,i),this.I=o}start(t){const o=this.I.getWindowById(t.responseWindowId);if(!o?.win||o.win.isDestroyed()||o.win.webContents.isDestroyed())return this.z("Refusing to start utility process because requesting window cannot be found or is destroyed...",p.default.Error),!0;if(!super.D(t))return!1;this.J(o.win,t);const i=this.connect(t.payload);return o.win.webContents.postMessage(t.responseChannel,t.responseNonce,[i]),!0}J(t,o){o.windowLifecycleBound&&(this.B(P.Event.filter(this.y.onWillLoadWindow,r=>r.window.win===t)(()=>this.kill())),this.B(P.Event.fromNodeEventEmitter(t,"closed")(()=>this.kill())))}};e.$iac=d,e.$iac=d=Ee([ne(0,B.$Nj),ne(1,c.$N_b),ne(2,y.$Ml),ne(3,k.$7_b)],d)}),define(oe[297],ae([0,1,15,3,5,20,8,61,29,28]),function(J,e,n,j,P,B,S,E,h,c){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$pac=void 0;let y=class{static{p=this}static{this.a=0}constructor(g,m,v,w){this.d=g,this.f=m,this.g=v,this.h=w,this.b=new Map,this.c=!1,this.f.onWillShutdown($=>{this.c=!0,$.join("extHostStarter",this._waitForAllExit(6e3))})}dispose(){}i(g){const m=this.b.get(g);if(!m)throw new Error("Unknown extension host!");return m}onDynamicStdout(g){return this.i(g).onStdout}onDynamicStderr(g){return this.i(g).onStderr}onDynamicMessage(g){return this.i(g).onMessage}onDynamicExit(g){return this.i(g).onExit}async createExtensionHost(){if(this.c)throw(0,n.$6)();const g=String(++p.a),m=new E.$iac(this.d,this.g,this.h,this.f);return this.b.set(g,m),m.onExit(({pid:v,code:w,signal:$})=>{this.d.info(`Extension host with pid ${v} exited with code: ${w}, signal: ${$}.`),setTimeout(()=>{m.dispose(),this.b.delete(g)}),setTimeout(()=>{try{process.kill(v,0),this.d.error(`Extension host with pid ${v} still exists, forcefully killing it...`),process.kill(v)}catch{}},1e3)}),{id:g}}async start(g,m){if(this.c)throw(0,n.$6)();const v=this.i(g);return v.start({...m,type:"extensionHost",entryPoint:"vs/workbench/api/node/extensionHostProcess",args:["--skipWorkspaceStorageLock"],execArgv:m.execArgv,allowLoadingUnsignedLibraries:!0,forceAllocationsToV8Sandbox:!0,correlationId:g}),{pid:await j.Event.toPromise(v.onSpawn)}}async enableInspectPort(g){if(this.c)throw(0,n.$6)();const m=this.b.get(g);return m?m.enableInspectPort():!1}async kill(g){if(this.c)throw(0,n.$6)();const m=this.b.get(g);m&&m.kill()}async _killAllNow(){for(const[,g]of this.b)g.kill()}async _waitForAllExit(g){const m=[];for(const[,v]of this.b)m.push(v.waitForExit(g));return S.Promises.settled(m).then(()=>{})}};e.$pac=y,e.$pac=y=p=Ee([ne(0,P.$Nj),ne(1,B.$7_b),ne(2,h.$N_b),ne(3,c.$Ml)],y)}),define(oe[298],ae([0,1,37,8,2,24,20,5,41,39,67,61,54,91,12,251]),function(J,e,n,j,P,B,S,E,h,c,p,y,k,g,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tac=void 0;let w=class extends P.$Uc{constructor(f,l,d,a,t,o,r,i){super(),this.f=f,this.g=l,this.h=d,this.j=a,this.m=t,this.n=o,this.r=r,this.s=i,this.a=new j.$gh,this.b=void 0,this.c=void 0,this.y=void 0,this.z=void 0,this.t()}t(){n.$2V.on(v.$Rac.request,(f,l)=>this.u(f,l,v.$Rac.response)),n.$2V.on(v.$Sac.request,(f,l)=>this.u(f,l,v.$Sac.response)),this.B(this.m.onWillShutdown(()=>this.w()))}async u(f,l,d){this.n.trace(`[SharedProcess] onWindowConnection for: ${d}`),this.a.isOpen()||this.a.open(),await this.whenReady();const a=await this.connect(d);if(f.sender.isDestroyed())return a.close();f.sender.postMessage(d,l,[a])}w(){this.n.trace("[SharedProcess] onWillShutdown"),this.b?.postMessage(v.$Qac.exit),this.b=void 0}whenReady(){return this.y||(this.y=(async()=>{await this.C;const f=new j.$Eh;this.b?.once(v.$Qac.initDone,()=>f.complete()),await f.p,this.c?.dispose(),this.n.trace("[SharedProcess] Overall ready")})()),this.y}get C(){return this.z||(this.z=(async()=>{await this.a.wait(),this.D();const f=new j.$Eh;this.b?.once(v.$Qac.ipcReady,()=>f.complete()),await f.p,this.n.trace("[SharedProcess] IPC ready")})()),this.z}D(){this.b=this.B(new y.$hac(this.n,k.$5o,this.m)),this.c=this.b.onMessage(d=>{typeof d.warning=="string"?this.n.warn(d.warning):typeof d.error=="string"&&this.n.error(d.error)});const f=(0,g.$Vm)(this.h.args,this.h.isBuilt);let l;f.port&&(l=["--nolazy"],f.break?l.push(`--inspect-brk=${f.port}`):l.push(`--inspect=${f.port}`)),this.b.start({type:"shared-process",entryPoint:"vs/code/node/sharedProcess/sharedProcessMain",payload:this.F(),execArgv:l})}F(){return{machineId:this.f,sqmId:this.g,codeCachePath:this.h.codeCachePath,profiles:{home:this.j.profilesHome,all:this.j.profiles},args:this.h.args,logLevel:this.r.getLogLevel(),loggers:this.r.getRegisteredLoggers(),policiesData:this.s.serialize()}}async connect(f){return await this.C,(0,m.$6f)(this.b).connect(f)}};e.$Tac=w,e.$Tac=w=Ee([ne(2,B.$C_b),ne(3,h.$nl),ne(4,S.$7_b),ne(5,E.$Nj),ne(6,p.$2_b),ne(7,c.$2n)],w)}),define(oe[299],ae([0,1,24,91,20,5,54,61,114,37,2,3,35,18,13]),function(J,e,n,j,P,B,S,E,h,c,p,y,k,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tbc=void 0;let v=class extends p.$Uc{constructor($,f,l,d,a){super(),this.f=$,this.g=f,this.h=l,this.j=d,this.m=a,this.a=void 0,this.b=new y.$7d,this.onRequestConnection=this.b.event,this.c=new y.$7d,this.onWillShutdown=this.c.event,this.j.onWillShutdown(()=>this.c.fire()),c.$2V.on("vscode:createPtyHostMessageChannel",(t,o)=>this.r(t,o)),this.B((0,p.$Sc)(()=>{c.$2V.removeHandler("vscode:createPtyHostMessageChannel")}))}start(){this.a=new E.$hac(this.m,S.$5o,this.j);const $=(0,j.$Um)(this.h.args,this.h.isBuilt),f=$.port?["--nolazy",`--inspect${$.break?"-brk":""}=${$.port}`]:void 0;this.a.start({type:"ptyHost",entryPoint:"vs/platform/terminal/node/ptyHostMain",execArgv:f,args:["--logsPath",this.h.logsHome.with({scheme:m.Schemas.file}).fsPath],env:this.n()});const l=this.a.connect(),d=new h.$0V(l,"ptyHost"),a=new p.$Tc;return a.add(d),a.add((0,p.$Sc)(()=>{this.a?.kill(),this.a?.dispose(),this.a=void 0})),{client:d,store:a,onDidProcessExit:this.a.onExit}}n(){this.h.unsetSnapExportedVariables();const $={...(0,k.$Nn)(process.env),VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:String(this.f.graceTime),VSCODE_RECONNECT_SHORT_GRACE_TIME:String(this.f.shortGraceTime),VSCODE_RECONNECT_SCROLLBACK:String(this.f.scrollback)},f=this.g.getValue("terminal.integrated.developer.ptyHost.latency");f&&typeof f=="number"&&($.VSCODE_LATENCY=String(f));const l=this.g.getValue("terminal.integrated.developer.ptyHost.startupDelay");return l&&typeof l=="number"&&($.VSCODE_STARTUP_DELAY=String(l)),this.h.restoreSnapExportedVariables(),$}r($,f){this.b.fire();const l=this.a.connect();if($.sender.isDestroyed()){l.close();return}$.sender.postMessage("vscode:createPtyHostMessageChannelResult",f,[l])}};e.$tbc=v,e.$tbc=v=Ee([ne(1,g.$Ni),ne(2,n.$C_b),ne(3,P.$7_b),ne(4,B.$Nj)],v)}),define(oe[300],ae([0,1,2,6,5,29,61,28,46,3,8,20]),function(J,e,n,j,P,B,S,E,h,c,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sbc=e.$rbc=void 0,e.$rbc=(0,j.$hi)("utilityProcessWorker");let k=class extends n.$Uc{constructor(v,w,$,f){super(),this.b=v,this.c=w,this.f=$,this.g=f,this.a=new Map}async createWorker(v){const w=`window: ${v.reply.windowId}, moduleId: ${v.process.moduleId}`;this.b.trace(`[UtilityProcessWorker]: createWorker(${w})`);const $=this.h(v);this.a.has($)&&(this.b.warn(`[UtilityProcessWorker]: createWorker() found an existing worker that will be terminated (${w})`),this.disposeWorker(v));const f=new g(this.b,this.c,this.f,this.g,v);if(!f.spawn())return{reason:{code:1,signal:"EINVALID"}};this.a.set($,f);const l=new p.$Eh;return c.Event.once(f.onDidTerminate)(d=>{d.code===0?this.b.trace(`[UtilityProcessWorker]: terminated normally with code ${d.code}, signal: ${d.signal}`):this.b.error(`[UtilityProcessWorker]: terminated unexpectedly with code ${d.code}, signal: ${d.signal}`),this.a.delete($),l.complete({reason:d})}),l.p}h(v){return(0,h.$8i)({moduleId:v.process.moduleId,windowId:v.reply.windowId})}async disposeWorker(v){const w=this.h(v),$=this.a.get(w);$&&(this.b.trace(`[UtilityProcessWorker]: disposeWorker(window: ${v.reply.windowId}, moduleId: ${v.process.moduleId})`),$.kill(),this.a.delete(w))}};e.$sbc=k,e.$sbc=k=Ee([ne(0,P.$Nj),ne(1,B.$N_b),ne(2,E.$Ml),ne(3,y.$7_b)],k);let g=class extends n.$Uc{constructor(v,w,$,f,l){super(),this.c=v,this.f=w,this.g=$,this.h=f,this.j=l,this.a=this.B(new c.$7d),this.onDidTerminate=this.a.event,this.b=new S.$iac(this.c,this.f,this.g,this.h),this.m()}m(){this.B(this.b.onExit(v=>this.a.fire({code:v.code,signal:v.signal}))),this.B(this.b.onCrash(v=>this.a.fire({code:v.code,signal:"ECRASH"})))}spawn(){const w=this.f.getWindowById(this.j.reply.windowId)?.win?.webContents.getOSProcessId();return this.b.start({type:this.j.process.type,entryPoint:this.j.process.moduleId,parentLifecycleBound:w,windowLifecycleBound:!0,correlationId:`${this.j.reply.windowId}`,responseWindowId:this.j.reply.windowId,responseChannel:this.j.reply.channel,responseNonce:this.j.reply.nonce})}kill(){this.b.kill()}};g=Ee([ne(0,P.$Nj),ne(1,B.$N_b),ne(2,E.$Ml),ne(3,y.$7_b)],g)}),define(oe[301],ae([0,1,14,3,2,277,29]),function(J,e,n,j,P,B,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_ac=void 0;let E=class extends P.$Uc{constructor(c){super(),this.b=c,this.a=this.B(new j.$7d),this.onFoundInFrame=this.a.event,this.B(new B.$$ac)}async setIgnoreMenuShortcuts(c,p){let y;if(typeof c.windowId=="number"){const{windowId:k}=c,g=this.b.getWindowById(k);if(!g?.win)throw new Error(`Invalid windowId: ${k}`);y=g.win.webContents}else{const{webContentsId:k}=c;if(y=n.webContents.fromId(k),!y)throw new Error(`Invalid webContentsId: ${k}`)}y.isDestroyed()||y.setIgnoreMenuShortcuts(p)}async findInFrame(c,p,y,k){const m=this.c(c,p);if(typeof m.findInFrame=="function"){m.findInFrame(y,{findNext:k.findNext,forward:k.forward});const v=(w,$)=>{$.finalUpdate&&(this.a.fire($),m.removeListener("found-in-frame",v))};m.on("found-in-frame",v)}}async stopFindInFrame(c,p,y){const g=this.c(c,p);typeof g.stopFindInFrame=="function"&&g.stopFindInFrame(y.keepSelection?"keepSelection":"clearSelection")}c(c,p){const y=this.b.getWindowById(c.windowId);if(!y?.win)throw new Error(`Invalid windowId: ${c}`);const k=y.win.webContents.mainFrame.framesInSubtree.find(g=>g.name===p);if(!k)throw new Error(`Unknown frame: ${p}`);return k}};e.$_ac=E,e.$_ac=E=Ee([ne(0,S.$N_b)],E)}),define(oe[302],ae([0,1,14,2,4,19,7,18,20,5,34,29,81,30]),function(J,e,n,j,P,B,S,E,h,c,p,y,k,g){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$abc=void 0,e.$bbc=w,e.$cbc=f;let v=class extends j.$Uc{static{m=this}static{this.a="windowsState"}get state(){return this.b}constructor(a,t,o,r,i){super(),this.g=a,this.h=t,this.j=o,this.m=r,this.n=i,this.b=w(this.h.getItem(m.a)),this.c=void 0,this.f=!1,this.r()}r(){n.app.on("browser-window-blur",()=>{this.f||this.t()}),this.j.onBeforeCloseWindow(a=>this.u(a)),this.j.onBeforeShutdown(()=>this.s()),this.g.onDidChangeWindowsCount(a=>{a.newCount-a.oldCount>0&&(this.c=void 0)}),this.g.onDidDestroyWindow(a=>this.u(a))}s(){this.f=!0,this.t()}t(){const a=new Set,t={openedWindows:[],lastPluginDevelopmentHostWindow:this.b.lastPluginDevelopmentHostWindow,lastActiveWindow:this.c};if(!t.lastActiveWindow){let i=this.g.getLastActiveWindow();(!i||i.isExtensionDevelopmentHost)&&(i=this.g.getWindows().find(s=>!s.isExtensionDevelopmentHost)),i&&(t.lastActiveWindow=this.w(i),t.lastActiveWindow.uiState.mode===3&&a.add(t.lastActiveWindow.uiState.display))}const o=this.g.getWindows().find(i=>i.isExtensionDevelopmentHost&&!i.isExtensionTestHost);o&&(t.lastPluginDevelopmentHostWindow=this.w(o),t.lastPluginDevelopmentHostWindow.uiState.mode===3&&(a.has(t.lastPluginDevelopmentHostWindow.uiState.display)?P.$j&&!o.win?.isSimpleFullScreen()&&(t.lastPluginDevelopmentHostWindow.uiState.mode=1):a.add(t.lastPluginDevelopmentHostWindow.uiState.display))),this.g.getWindowCount()>1&&(t.openedWindows=this.g.getWindows().filter(i=>!i.isExtensionDevelopmentHost).map(i=>{const s=this.w(i);return s.uiState.mode===3&&(a.has(s.uiState.display)?P.$j&&s.windowId!==t.lastActiveWindow?.windowId&&!i.win?.isSimpleFullScreen()&&(s.uiState.mode=1):a.add(s.uiState.display)),s}));const r=f(t);this.h.setItem(m.a,r),this.f&&this.m.trace("[WindowsStateHandler] onBeforeShutdown",r)}u(a){if(this.j.quitRequested)return;const t=this.w(a);a.isExtensionDevelopmentHost&&!a.isExtensionTestHost?this.b.lastPluginDevelopmentHostWindow=t:!a.isExtensionDevelopmentHost&&a.openedWorkspace&&this.b.openedWindows.forEach(o=>{const r=(0,g.$wi)(a.openedWorkspace)&&o.workspace?.id===a.openedWorkspace.id,i=(0,g.$ri)(a.openedWorkspace)&&o.folderUri&&B.$Lg.isEqual(o.folderUri,a.openedWorkspace.uri);(r||i)&&(o.uiState=t.uiState)}),this.g.getWindowCount()===1&&(this.c=t)}w(a){return{windowId:a.id,workspace:(0,g.$wi)(a.openedWorkspace)?a.openedWorkspace:void 0,folderUri:(0,g.$ri)(a.openedWorkspace)?a.openedWorkspace.uri:void 0,backupPath:a.backupPath,remoteAuthority:a.remoteAuthority,uiState:a.serializeWindowState()}}getNewWindowState(a){const t=this.z(a),o=this.n.getValue("window");if(t.mode===3){let r;t.hasDefaultState?r=!!(o?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(o.newWindowDimensions)>=0):r=!!(this.j.wasRestarted||o?.restoreFullscreen),r||(t.mode=1)}return t}z(a){const t=this.g.getLastActiveWindow();if(!a.extensionTestsPath){if(a.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const b=a.workspace;if((0,g.$wi)(b)){const D=this.state.openedWindows.filter(R=>R.workspace&&R.workspace.id===b.id).map(R=>R.uiState);if(D.length)return D[0]}if((0,g.$ri)(b)){const D=this.state.openedWindows.filter(R=>R.folderUri&&B.$Lg.isEqual(R.folderUri,b.uri)).map(R=>R.uiState);if(D.length)return D[0]}else if(a.backupPath){const D=this.state.openedWindows.filter(R=>R.backupPath===a.backupPath).map(R=>R.uiState);if(D.length)return D[0]}const I=this.c||this.state.lastActiveWindow;if(!t&&I)return I.uiState}let o;const r=n.screen.getAllDisplays();if(r.length===1)o=r[0];else{if(P.$j){const b=n.screen.getCursorScreenPoint();o=n.screen.getDisplayNearestPoint(b)}!o&&t&&(o=n.screen.getDisplayMatching(t.getBounds())),o||(o=n.screen.getPrimaryDisplay()||r[0])}let i=(0,k.$A_b)();i.x=Math.round(o.bounds.x+o.bounds.width/2-i.width/2),i.y=Math.round(o.bounds.y+o.bounds.height/2-i.height/2);const s=this.n.getValue("window");let u=!0;if(s?.newWindowDimensions){if(s.newWindowDimensions==="maximized")i.mode=0,u=!1;else if(s.newWindowDimensions==="fullscreen")i.mode=3,u=!1;else if((s.newWindowDimensions==="inherit"||s.newWindowDimensions==="offset")&&t){const b=t.serializeWindowState();b.mode===3?i.mode=3:i={...b,zoomLevel:void 0},u=i.mode!==3&&s.newWindowDimensions==="offset"}}return u&&(i=this.C(i)),i.hasDefaultState=!0,i}C(a){if(this.g.getWindows().length===0)return a;a.x=typeof a.x=="number"?a.x:0,a.y=typeof a.y=="number"?a.y:0;const t=this.g.getWindows().map(o=>o.getBounds());for(;t.some(o=>o.x===a.x||o.y===a.y);)a.x+=30,a.y+=30;return a}};e.$abc=v,e.$abc=v=m=Ee([ne(0,y.$N_b),ne(1,p.$UP),ne(2,h.$7_b),ne(3,c.$Nj),ne(4,E.$Ni)],v);function w(d){const a={openedWindows:[]},t=d||{openedWindows:[]};return t.lastActiveWindow&&(a.lastActiveWindow=$(t.lastActiveWindow)),t.lastPluginDevelopmentHostWindow&&(a.lastPluginDevelopmentHostWindow=$(t.lastPluginDevelopmentHostWindow)),Array.isArray(t.openedWindows)&&(a.openedWindows=t.openedWindows.map(o=>$(o))),a}function $(d){const a={uiState:d.uiState};return d.backupPath&&(a.backupPath=d.backupPath),d.remoteAuthority&&(a.remoteAuthority=d.remoteAuthority),d.folder&&(a.folderUri=S.URI.parse(d.folder)),d.workspaceIdentifier&&(a.workspace={id:d.workspaceIdentifier.id,configPath:S.URI.parse(d.workspaceIdentifier.configURIPath)}),a}function f(d){return{lastActiveWindow:d.lastActiveWindow&&l(d.lastActiveWindow),lastPluginDevelopmentHostWindow:d.lastPluginDevelopmentHostWindow&&l(d.lastPluginDevelopmentHostWindow),openedWindows:d.openedWindows.map(a=>l(a))}}function l(d){return{workspaceIdentifier:d.workspace&&{id:d.workspace.id,configURIPath:d.workspace.configPath.toString()},folder:d.folderUri&&d.folderUri.toString(),backupPath:d.backupPath,remoteAuthority:d.remoteAuthority,uiState:d.uiState}}}),define(oe[58],ae([0,1,14,3,42,2,13,9,19,21,197,65,56,24,6,5,57,133,30,98,99]),function(J,e,n,j,P,B,S,E,h,c,p,y,k,g,m,v,w,$,f,l,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1_b=e.$Z_b=void 0,e.$Z_b=(0,m.$hi)("workspacesManagementMainService");let a=class extends B.$Uc{constructor(o,r,i,s,u){super(),this.g=o,this.h=r,this.j=i,this.m=s,this.n=u,this.a=this.B(new j.$7d),this.onDidDeleteUntitledWorkspace=this.a.event,this.b=this.B(new j.$7d),this.onDidEnterWorkspace=this.b.event,this.c=this.g.untitledWorkspacesHome,this.f=[]}async initialize(){this.f=[];try{const o=(await c.Promises.readdir(this.c.with({scheme:S.Schemas.file}).fsPath)).map(r=>(0,h.$Ug)(this.c,r,f.$Gi));for(const r of o){const i=(0,d.$W_b)(r),s=await this.resolveLocalWorkspace(r);s?this.f.push({workspace:i,remoteAuthority:s.remoteAuthority}):await this.deleteUntitledWorkspace(i)}}catch(o){o.code!=="ENOENT"&&this.h.warn(`Unable to read folders in ${this.c} (${o}).`)}}resolveLocalWorkspace(o){return this.r(o,r=>c.Promises.readFile(r,"utf8"))}r(o,r){if(this.s(o)&&o.scheme===S.Schemas.file)try{const i=r(o.fsPath);return i instanceof Promise?i.then(s=>this.t(o,s),s=>{}):this.t(o,i)}catch{return}}s(o){return(0,f.$Hi)(o,this.g)||(0,f.$Mi)(o)}t(o,r){try{const i=this.u(o,r),s=(0,d.$W_b)(o);return{id:s.id,configPath:s.configPath,folders:(0,l.$Heb)(i.folders,s.configPath,h.$Lg),remoteAuthority:i.remoteAuthority,transient:i.transient}}catch(i){this.h.warn(i.toString())}}u(o,r){const i=(0,P.$un)(r);if(i&&Array.isArray(i.folders))i.folders=i.folders.filter(s=>(0,l.$Feb)(s));else throw new Error(`${o.toString(!0)} looks like an invalid workspace file.`);return i}async createUntitledWorkspace(o,r){const{workspace:i,storedWorkspace:s}=this.w(o,r),u=i.configPath.fsPath;return await c.Promises.mkdir((0,E.$nc)(u),{recursive:!0}),await c.Promises.writeFile(u,JSON.stringify(s,null,"	")),this.f.push({workspace:i,remoteAuthority:r}),i}w(o=[],r){const i=(Date.now()+Math.round(Math.random()*1e3)).toString(),s=(0,h.$Ug)(this.c,i),u=(0,h.$Ug)(s,f.$Gi),b=[];for(const I of o)b.push((0,l.$Geb)(I.uri,!0,I.name,s,h.$Lg));return{workspace:(0,d.$W_b)(u),storedWorkspace:{folders:b,remoteAuthority:r}}}async getWorkspaceIdentifier(o){return(0,d.$W_b)(o)}isUntitledWorkspace(o){return(0,f.$Hi)(o.configPath,this.g)}async deleteUntitledWorkspace(o){this.isUntitledWorkspace(o)&&(await this.y(o),this.j.isEnabled()&&this.j.unsetWorkspace(o),this.a.fire(o))}async y(o){const r=(0,h.$Ig)(o.configPath);try{await c.Promises.rm((0,E.$nc)(r));const i=(0,E.$kc)(this.g.workspaceStorageHome.with({scheme:S.Schemas.file}).fsPath,o.id);await c.Promises.exists(i)&&await c.Promises.writeFile((0,E.$kc)(i,"obsolete"),""),this.f=this.f.filter(s=>s.workspace.id!==o.id)}catch(i){this.h.warn(`Unable to delete untitled workspace ${r} (${i}).`)}}getUntitledWorkspaces(){return this.f}async enterWorkspace(o,r,i){if(!o||!o.win||!o.isReady||!await this.z(o,r,i))return;const u=await this.C(o,(0,d.$W_b)(i));if(u)return this.b.fire({window:o,workspace:u.workspace}),u}async z(o,r,i){return i?(0,f.$wi)(o.openedWorkspace)&&h.$Lg.isEqual(o.openedWorkspace.configPath,i)?!1:(0,$.$T_b)(r,i)?(await this.n.showMessageBox({type:"info",buttons:[(0,p.localize)(0,null)],message:(0,p.localize)(1,null,(0,h.$Rg)(i)),detail:(0,p.localize)(2,null)},n.BrowserWindow.getFocusedWindow()??void 0),!1):!0:!0}async C(o,r){if(!o.config)return;o.focus();let i;return o.config.extensionDevelopmentPath||(o.config.backupPath?i=await this.m.registerWorkspaceBackup({workspace:r,remoteAuthority:o.remoteAuthority},o.config.backupPath):i=this.m.registerWorkspaceBackup({workspace:r,remoteAuthority:o.remoteAuthority})),(0,f.$wi)(o.openedWorkspace)&&this.isUntitledWorkspace(o.openedWorkspace)&&await this.deleteUntitledWorkspace(o.openedWorkspace),o.config.workspace=r,o.config.backupPath=i,{workspace:r,backupPath:i}}};e.$1_b=a,e.$1_b=a=Ee([ne(0,g.$C_b),ne(1,v.$Nj),ne(2,w.$Q_b),ne(3,y.$H_b),ne(4,k.$I_b)],a)}),define(oe[134],ae([0,1,14,37,23,6,29,30,58,12,5,61]),function(J,e,n,j,P,B,S,E,h,c,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lac=e.$kac=e.ID=void 0,e.ID="diagnosticsMainService",e.$kac=(0,B.$hi)(e.ID);let k=class{constructor(m,v,w){this.a=m,this.b=v,this.c=w}async getRemoteDiagnostics(m){const v=this.a.getWindows();return(await Promise.all(v.map(async $=>{const f=$.remoteAuthority;if(!f)return;const l=`vscode:getDiagnosticInfoResponse${$.id}`,d={includeProcesses:m.includeProcesses,folders:m.includeWorkspaceMetadata?await this.f($):void 0};return new Promise(a=>{$.sendWhenReady("vscode:getDiagnosticInfo",P.CancellationToken.None,{replyChannel:l,args:d}),j.$2V.once(l,(t,o)=>{o||a({hostName:f,errorMessage:`Unable to resolve connection to '${f}'.`}),a(o)}),setTimeout(()=>{a({hostName:f,errorMessage:`Connection to '${f}' could not be established`})},5e3)})}))).filter($=>!!$)}async getMainDiagnostics(){this.c.trace("Received request for main process info from other instance.");const m=[];for(const w of n.BrowserWindow.getAllWindows()){const $=this.a.getWindowById(w.id);$?m.push(await this.d($)):m.push(this.e(w))}const v=[];for(const{pid:w,name:$}of y.$hac.getAll())v.push({pid:w,name:$});return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:m,pidToNames:v,screenReader:!!n.app.accessibilitySupportEnabled,gpuFeatureStatus:n.app.getGPUFeatureStatus()}}async d(m){const v=await this.f(m),w=(0,c.$6f)(m.win);return this.e(w,v,m.remoteAuthority)}e(m,v=[],w){return{id:m.id,pid:m.webContents.getOSProcessId(),title:m.getTitle(),folderURIs:v,remoteAuthority:w}}async f(m){const v=[],w=m.openedWorkspace;if((0,E.$ri)(w))v.push(w.uri);else if((0,E.$wi)(w)){const $=await this.b.resolveLocalWorkspace(w.configPath);$&&$.folders.forEach(l=>{v.push(l.uri)})}return v}};e.$lac=k,e.$lac=k=Ee([ne(0,S.$N_b),ne(1,h.$Z_b),ne(2,p.$Nj)],k)}),define(oe[70],ae([0,1,49,14,26,158,51,3,2,13,9,4,7,109,89,21,107,185,56,24,6,20,5,27,69,29,30,58,17,247,239,78,15]),function(J,e,n,j,P,B,S,E,h,c,p,y,k,g,m,v,w,$,f,l,d,a,t,o,r,i,s,u,b,I,D,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aac=e.$zac=void 0,e.$zac=(0,d.$hi)("nativeHostMainService");let A=class extends h.$Uc{constructor(W,q,H,le,te,ue,X,Q,z){super(),this.a=W,this.b=q,this.c=H,this.f=le,this.g=te,this.h=ue,this.j=X,this.m=Q,this.n=z,this.onDidOpenMainWindow=E.Event.map(this.a.onDidOpenWindow,M=>M.id),this.onDidTriggerWindowSystemContextMenu=E.Event.any(E.Event.filter(E.Event.map(this.a.onDidTriggerSystemContextMenu,({window:M,x:F,y:G})=>({windowId:M.id,x:F,y:G})),({windowId:M})=>!!this.a.getWindowById(M)),E.Event.filter(E.Event.map(this.b.onDidTriggerSystemContextMenu,({window:M,x:F,y:G})=>({windowId:M.id,x:F,y:G})),({windowId:M})=>!!this.b.getWindowById(M))),this.onDidMaximizeWindow=E.Event.any(E.Event.filter(E.Event.map(this.a.onDidMaximizeWindow,M=>M.id),M=>!!this.a.getWindowById(M)),E.Event.filter(E.Event.map(this.b.onDidMaximizeWindow,M=>M.id),M=>!!this.b.getWindowById(M))),this.onDidUnmaximizeWindow=E.Event.any(E.Event.filter(E.Event.map(this.a.onDidUnmaximizeWindow,M=>M.id),M=>!!this.a.getWindowById(M)),E.Event.filter(E.Event.map(this.b.onDidUnmaximizeWindow,M=>M.id),M=>!!this.b.getWindowById(M))),this.onDidChangeWindowFullScreen=E.Event.any(E.Event.map(this.a.onDidChangeFullScreen,M=>({windowId:M.window.id,fullscreen:M.fullscreen})),E.Event.map(this.b.onDidChangeFullScreen,M=>({windowId:M.window.id,fullscreen:M.fullscreen}))),this.onDidBlurMainWindow=E.Event.filter(E.Event.fromNodeEventEmitter(j.app,"browser-window-blur",(M,F)=>F.id),M=>!!this.a.getWindowById(M)),this.onDidFocusMainWindow=E.Event.any(E.Event.map(E.Event.filter(E.Event.map(this.a.onDidChangeWindowsCount,()=>this.a.getLastActiveWindow()),M=>!!M),M=>M.id),E.Event.filter(E.Event.fromNodeEventEmitter(j.app,"browser-window-focus",(M,F)=>F.id),M=>!!this.a.getWindowById(M))),this.onDidBlurMainOrAuxiliaryWindow=E.Event.any(this.onDidBlurMainWindow,E.Event.filter(E.Event.fromNodeEventEmitter(j.app,"browser-window-blur",(M,F)=>F.id),M=>!!this.b.getWindowById(M))),this.onDidFocusMainOrAuxiliaryWindow=E.Event.any(this.onDidFocusMainWindow,E.Event.filter(E.Event.fromNodeEventEmitter(j.app,"browser-window-focus",(M,F)=>F.id),M=>!!this.b.getWindowById(M))),this.onDidResumeOS=E.Event.fromNodeEventEmitter(j.powerMonitor,"resume"),this.onDidChangeColorScheme=this.m.onDidChangeColorScheme,this.r=this.B(new E.$7d),this.onDidChangePassword=this.r.event,this.onDidChangeDisplay=E.Event.debounce(E.Event.any(E.Event.filter(E.Event.fromNodeEventEmitter(j.screen,"display-metrics-changed",(M,F,G)=>G),M=>!(Array.isArray(M)&&M.length===1&&M[0]==="workArea")),E.Event.fromNodeEventEmitter(j.screen,"display-added"),E.Event.fromNodeEventEmitter(j.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(W,q){const H=this.a.getWindows().map(te=>({id:te.id,workspace:te.openedWorkspace??(0,s.$vi)(te.backupPath,te.isExtensionDevelopmentHost),title:te.win?.getTitle()??"",filename:te.getRepresentedFilename(),dirty:te.isDocumentEdited()})),le=[];return q.includeAuxiliaryWindows&&le.push(...this.b.getWindows().map(te=>({id:te.id,parentId:te.parentId,title:te.win?.getTitle()??"",filename:te.getRepresentedFilename()}))),[...H,...le]}async getWindowCount(W){return this.a.getWindowCount()}async getActiveWindowId(W){const q=this.a.getFocusedWindow()||this.a.getLastActiveWindow();if(q)return q.id}openWindow(W,q,H){return Array.isArray(q)?this.s(W,q,H):this.t(W,q)}async s(W,q,H=Object.create(null)){q.length>0&&await this.a.open({context:5,contextWindowId:W,urisToOpen:q,cli:this.g.args,forceNewWindow:H.forceNewWindow,forceReuseWindow:H.forceReuseWindow,preferNewWindow:H.preferNewWindow,diffMode:H.diffMode,mergeMode:H.mergeMode,addMode:H.addMode,gotoLineMode:H.gotoLineMode,noRecentEntry:H.noRecentEntry,waitMarkerFileURI:H.waitMarkerFileURI,remoteAuthority:H.remoteAuthority||void 0,forceProfile:H.forceProfile,forceTempProfile:H.forceTempProfile})}async t(W,q){await this.a.openEmptyWindow({context:5,contextWindowId:W},q)}async toggleFullScreen(W,q){this.C(q?.targetWindowId,W)?.toggleFullScreen()}async handleTitleDoubleClick(W,q){this.C(q?.targetWindowId,W)?.handleTitleDoubleClick()}async getCursorScreenPoint(W){const q=j.screen.getCursorScreenPoint(),H=j.screen.getDisplayNearestPoint(q);return{point:q,display:H.bounds}}async isMaximized(W,q){return this.C(q?.targetWindowId,W)?.win?.isMaximized()??!1}async maximizeWindow(W,q){this.C(q?.targetWindowId,W)?.win?.maximize()}async unmaximizeWindow(W,q){this.C(q?.targetWindowId,W)?.win?.unmaximize()}async minimizeWindow(W,q){this.C(q?.targetWindowId,W)?.win?.minimize()}async moveWindowTop(W,q){this.C(q?.targetWindowId,W)?.win?.moveTop()}async positionWindow(W,q,H){const le=this.C(H?.targetWindowId,W);if(le?.win){if(le.win.isFullScreen()){const te=E.Event.toPromise(E.Event.once(E.Event.fromNodeEventEmitter(le.win,"leave-full-screen")));le.win.setFullScreen(!1),await te}le.win.setBounds(q)}}async updateWindowControls(W,q){this.C(q?.targetWindowId,W)?.updateWindowControls(q)}async focusWindow(W,q){this.C(q?.targetWindowId,W)?.focus({force:q?.force??!1})}async setMinimumSize(W,q,H){const le=this.D(W);if(le?.win){const[te,ue]=le.win.getSize(),[X,Q]=le.win.getMinimumSize(),[z,M]=[q??X,H??Q],[F,G]=[Math.max(te,z),Math.max(ue,M)];(X!==z||Q!==M)&&le.win.setMinimumSize(z,M),(te!==F||ue!==G)&&le.win.setSize(F,G)}}async saveWindowSplash(W,q){this.m.saveWindowSplash(W,q)}async installShellCommand(W){const{source:q,target:H}=await this.u();try{const{symbolicLink:le}=await v.SymlinkSupport.stat(q);if(le&&!le.dangling){const te=await(0,g.$Oq)(q);if(H===te)return}await v.Promises.unlink(q)}catch(le){if(le.code!=="ENOENT")throw le}try{await v.Promises.symlink(H,q)}catch(le){if(le.code!=="EACCES"&&le.code!=="ENOENT")throw le;const{response:te}=await this.showMessageBox(W,{type:"info",message:(0,$.localize)(0,null,this.j.nameShort),buttons:[(0,$.localize)(1,null),(0,$.localize)(2,null)]});if(te===1)throw new C.$5;try{const ue=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${H}' '${q}'\\" with administrator privileges"`;await(0,B.promisify)(n.exec)(ue)}catch{throw new Error((0,$.localize)(3,null,q))}}}async uninstallShellCommand(W){const{source:q}=await this.u();try{await v.Promises.unlink(q)}catch(H){switch(H.code){case"EACCES":{const{response:le}=await this.showMessageBox(W,{type:"info",message:(0,$.localize)(4,null,this.j.nameShort),buttons:[(0,$.localize)(5,null),(0,$.localize)(6,null)]});if(le===1)throw new C.$5;try{const te=`osascript -e "do shell script \\"rm '${q}'\\" with administrator privileges"`;await(0,B.promisify)(n.exec)(te)}catch{throw new Error((0,$.localize)(7,null,q))}break}case"ENOENT":break;default:throw H}}}async u(){const W=(0,p.$lc)(this.g.appRoot,"bin","code"),q=`/usr/local/bin/${this.j.applicationName}`;if(!await v.Promises.exists(W))throw new Error((0,$.localize)(8,null,W));return{source:q,target:W}}async showMessageBox(W,q){const H=this.C(q?.targetWindowId,W);return this.c.showMessageBox(q,H?.win??void 0)}async showSaveDialog(W,q){const H=this.C(q?.targetWindowId,W);return this.c.showSaveDialog(q,H?.win??void 0)}async showOpenDialog(W,q){const H=this.C(q?.targetWindowId,W);return this.c.showOpenDialog(q,H?.win??void 0)}async pickFileFolderAndOpen(W,q){const H=await this.c.pickFileFolder(q);H&&await this.w(await Promise.all(H.map(async le=>await v.SymlinkSupport.existsDirectory(le)?{folderUri:k.URI.file(le)}:{fileUri:k.URI.file(le)})),q,W)}async pickFolderAndOpen(W,q){const H=await this.c.pickFolder(q);H&&await this.w(H.map(le=>({folderUri:k.URI.file(le)})),q,W)}async pickFileAndOpen(W,q){const H=await this.c.pickFile(q);H&&await this.w(H.map(le=>({fileUri:k.URI.file(le)})),q,W)}async pickWorkspaceAndOpen(W,q){const H=await this.c.pickWorkspace(q);H&&await this.w(H.map(le=>({workspaceUri:k.URI.file(le)})),q,W)}async w(W,q,H){await this.a.open({context:3,contextWindowId:H,cli:this.g.args,urisToOpen:W,forceNewWindow:q.forceNewWindow})}async showItemInFolder(W,q){j.shell.showItemInFolder(q)}async setRepresentedFilename(W,q,H){this.C(H?.targetWindowId,W)?.setRepresentedFilename(q)}async setDocumentEdited(W,q,H){this.C(H?.targetWindowId,W)?.setDocumentEdited(q)}async openExternal(W,q){return this.g.unsetSnapExportedVariables(),j.shell.openExternal(q),this.g.restoreSnapExportedVariables(),!0}moveItemToTrash(W,q){return j.shell.trashItem(q)}async isAdmin(){let W;return y.$i?W=(await new Promise((q,H)=>{J(["native-is-elevated"],q,H)}))():W=process.getuid?.()===0,W}async writeElevated(W,q,H,le){const te=await new Promise((ue,X)=>{J(["@vscode/sudo-prompt"],ue,X)});return new Promise((ue,X)=>{const Q=[`"${this.z}"`];le?.unlock&&Q.push("--file-chmod"),Q.push("--file-write",`"${q.fsPath}"`,`"${H.fsPath}"`);const z={name:this.j.nameLong.replace("-",""),icns:y.$j&&this.g.isBuilt?(0,p.$kc)((0,p.$nc)(this.g.appRoot),`${this.j.nameShort}.icns`):void 0};te.exec(Q.join(" "),z,(M,F,G)=>{F&&this.h.trace(`[sudo-prompt] received stdout: ${F}`),G&&this.h.trace(`[sudo-prompt] received stderr: ${G}`),M?X(M):ue(void 0)})})}async isRunningUnderARM64Translation(){return y.$k||y.$i?!1:j.app.runningUnderARM64Translation}get z(){return y.$i?this.g.isBuilt?(0,p.$kc)((0,p.$nc)(process.execPath),"bin",`${this.j.applicationName}.cmd`):(0,p.$kc)(this.g.appRoot,"scripts","code-cli.bat"):y.$k?this.g.isBuilt?(0,p.$kc)((0,p.$nc)(process.execPath),"bin",`${this.j.applicationName}`):(0,p.$kc)(this.g.appRoot,"scripts","code-cli.sh"):this.g.isBuilt?(0,p.$kc)(this.g.appRoot,"bin","code"):(0,p.$kc)(this.g.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,P.totalmem)(),freemem:(0,P.freemem)(),loadavg:(0,P.loadavg)()}}async getOSProperties(){return{arch:(0,P.arch)(),platform:(0,P.platform)(),release:(0,P.release)(),type:(0,P.type)(),cpus:(0,P.cpus)()}}async getOSVirtualMachineHint(){return m.$pn.value()}async getOSColorScheme(){return this.m.getColorScheme()}async hasWSLFeatureInstalled(){return y.$i&&(0,I.$wac)()}async killProcess(W,q,H){process.kill(q,H)}async readClipboardText(W,q){return j.clipboard.readText(q)}async writeClipboardText(W,q,H){return j.clipboard.writeText(q,H)}async readClipboardFindText(W){return j.clipboard.readFindText()}async writeClipboardFindText(W,q){return j.clipboard.writeFindText(q)}async writeClipboardBuffer(W,q,H,le){return j.clipboard.writeBuffer(q,Buffer.from(H.buffer),le)}async readClipboardBuffer(W,q){return b.$ue.wrap(j.clipboard.readBuffer(q))}async hasClipboard(W,q,H){return j.clipboard.has(q,H)}async newWindowTab(){await this.a.open({context:5,cli:this.g.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.g.args.remote||void 0})}async showPreviousWindowTab(){j.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){j.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){j.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){j.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){j.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(W,q){this.D(W)?.updateTouchBar(q)}async notifyReady(W){this.D(W)?.setReady()}async relaunch(W,q){return this.f.relaunch(q)}async reload(W,q){const H=this.D(W);if(H){if((0,s.$wi)(H.openedWorkspace)){const le=H.openedWorkspace.configPath;if(le.scheme===c.Schemas.file&&(await this.n.resolveLocalWorkspace(le))?.transient)return this.openWindow(H.id,{forceReuseWindow:!0})}return this.f.reload(H,q?.disableExtensions!==void 0?{_:[],"disable-extensions":q.disableExtensions}:void 0)}}async closeWindow(W,q){return this.C(q?.targetWindowId,W)?.win?.close()}async quit(W){const q=this.a.getLastActiveWindow();q?.isExtensionDevelopmentHost&&this.a.getWindowCount()>1&&q.win?q.win.close():this.f.quit()}async exit(W,q){await this.f.kill(q)}async resolveProxy(W,q){return this.D(W)?.win?.webContents?.session?.resolveProxy(q)}async loadCertificates(W){return(await new Promise((H,le)=>{J(["@vscode/proxy-agent"],H,le)})).loadSystemCertificates({log:this.h})}findFreePort(W,q,H,le,te=1){return(0,w.$Fg)(q,H,le,te)}async openDevTools(W,q){this.C(q?.targetWindowId,W)?.win?.webContents.openDevTools(q?.mode?{mode:q.mode,activate:q.activate}:void 0)}async toggleDevTools(W,q){this.C(q?.targetWindowId,W)?.win?.webContents.toggleDevTools()}async profileRenderer(W,q,H){const le=this.D(W);if(!le||!le.win)throw new Error;return await new D.$xac(le.win,q,this.h).inspect(H)}async windowsGetStringRegKey(W,q,H,le){if(!y.$i)return;const te=await new Promise((ue,X)=>{J(["@vscode/windows-registry"],ue,X)});try{return te.GetStringRegKey(q,H,le)}catch{return}}C(W,q){return this.D(W)??this.F(W)??this.D(q)}D(W){if(typeof W=="number")return this.a.getWindowById(W)}F(W){if(typeof W=="number")return this.b.getWindowById(W)}};e.$Aac=A,Ee([S.$Lh],A.prototype,"z",null),e.$Aac=A=Ee([ne(0,i.$N_b),ne(1,R.$yac),ne(2,f.$I_b),ne(3,a.$7_b),ne(4,l.$C_b),ne(5,t.$Nj),ne(6,o.$7j),ne(7,r.$L_b),ne(8,u.$Z_b)],A)}),define(oe[303],ae([0,1,14,26,8,23,31,2,13,4,7,111,37,182,92,134,56,24,5,70,79,27,80,34,61,55,29]),function(J,e,n,j,P,B,S,E,h,c,p,y,k,g,m,v,w,$,f,l,d,a,t,o,r,i,s){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$Bac=void 0;const b="issue.processExplorerWindowState";let I=class{static{u=this}static{this.a="#1E1E1E"}constructor(C,A,L,W,q,H,le,te,ue,X,Q){this.g=C,this.h=A,this.i=L,this.j=W,this.k=q,this.l=H,this.m=le,this.n=te,this.o=ue,this.p=X,this.q=Q,this.b=null,this.c=null,this.d=null,this.f=null,this.r()}r(){k.$2V.on("vscode:listProcesses",async C=>{const A=[];try{A.push({name:(0,g.localize)(0,null),rootProcess:await(0,y.$ls)(process.pid)}),(await this.k.getRemoteDiagnostics({includeProcesses:!0})).forEach(W=>{(0,m.$2m)(W)?A.push({name:W.hostName,rootProcess:W}):W.processes&&A.push({name:W.hostName,rootProcess:W.processes})})}catch(L){this.i.error(`Listing processes failed: ${L}`)}this.t(C,"vscode:listProcessesResponse",A)}),k.$2V.on("vscode:workbenchCommand",(C,A)=>{const{id:L,from:W,args:q}=A;let H;switch(W){case"processExplorer":H=this.f;break;default:throw new Error(`Unexpected command source: ${W}`)}H?.webContents.send("vscode:runAction",{id:L,from:W,args:q})}),k.$2V.on("vscode:closeProcessExplorer",C=>{this.d?.close()}),k.$2V.on("vscode:pidToNameRequest",async C=>{const A=await this.k.getMainDiagnostics(),L=[];for(const W of A.windows)L.push([W.pid,`window [${W.id}] (${W.title})`]);for(const{pid:W,name:q}of r.$hac.getAll())L.push([W,q]);this.t(C,"vscode:pidToNameResponse",L)})}async openReporter(C){if(this.b)this.b&&this.s(this.b);else if(this.c=n.BrowserWindow.getFocusedWindow(),this.c){const A=new E.$Tc,L=A.add(this.n.createIPCObjectUrl()),W=this.v(this.c,700,800);this.b=this.u(W,L,{backgroundColor:C.styles.backgroundColor,title:(0,g.localize)(1,null),zoomLevel:C.zoomLevel,alwaysOnTop:!1},"issue-reporter"),L.update({appRoot:this.h.appRoot,windowId:this.b.id,userEnv:this.g,data:C,disableExtensions:!!this.h.disableExtensions,os:{type:(0,j.type)(),arch:(0,j.arch)(),release:(0,j.release)()},product:d.default}),this.b.loadURL(h.$Bg.asBrowserUri(`vs/code/electron-sandbox/issue/issueReporter${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.b.on("close",()=>{this.b=null,A.dispose()}),this.c.on("closed",()=>{this.b&&(this.b.close(),this.b=null,A.dispose())})}}async openProcessExplorer(C){if(!this.d&&(this.f=n.BrowserWindow.getFocusedWindow(),this.f)){const A=new E.$Tc,L=A.add(this.n.createIPCObjectUrl()),W=this.p.getItem(b,void 0),q=D(W)?W:this.v(this.f,800,500);this.d=this.u(q,L,{backgroundColor:C.styles.backgroundColor,title:(0,g.localize)(2,null),zoomLevel:C.zoomLevel,alwaysOnTop:!0},"process-explorer"),L.update({appRoot:this.h.appRoot,windowId:this.d.id,userEnv:this.g,data:C,product:d.default}),this.d.loadURL(h.$Bg.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.d.on("close",()=>{this.d=null,A.dispose()}),this.f.on("close",()=>{this.d&&(this.d.close(),this.d=null,A.dispose())});const H=()=>{if(!this.d)return;const le=this.d.getSize(),te=this.d.getPosition();if(!le||!te)return;const ue={width:le[0],height:le[1],x:te[0],y:te[1]};this.p.setItem(b,ue)};this.d.on("moved",H),this.d.on("resized",H)}this.d&&this.s(this.d)}async stopTracing(){if(!this.h.args.trace)return;const C=await n.contentTracing.stopRecording(`${(0,S.$pg)(this.h.userHome.fsPath,this.o.applicationName)}.trace.txt`);await this.l.showMessageBox({type:"info",message:(0,g.localize)(3,null),detail:(0,g.localize)(4,null,C),buttons:[(0,g.localize)(5,null)]},n.BrowserWindow.getFocusedWindow()??void 0),this.m.showItemInFolder(void 0,C)}async getSystemStatus(){const[C,A]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.j.getDiagnostics(C,A)}async $getSystemInfo(){const[C,A]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return await this.j.getSystemInfo(C,A)}async $getPerformanceInfo(){try{const[C,A]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.j.getPerformanceInfo(C,A)}catch(C){throw this.i.warn("issueService#getPerformanceInfo ",C.message),C}}async $reloadWithExtensionsDisabled(){if(this.c)try{await this.m.reload(this.c.id,{disableExtensions:!0})}catch(C){this.i.error(C)}}async $showConfirmCloseDialog(){if(this.b){const{response:C}=await this.l.showMessageBox({type:"warning",message:(0,g.localize)(6,null),buttons:[(0,g.localize)(7,null),(0,g.localize)(8,null)]},this.b);C===0&&this.b&&(this.b.destroy(),this.b=null)}}async $showClipboardDialog(){if(this.b){const{response:C}=await this.l.showMessageBox({type:"warning",message:(0,g.localize)(9,null),buttons:[(0,g.localize)(10,null),(0,g.localize)(11,null)]},this.b);return C===0}return!1}issueReporterWindowCheck(){if(!this.c)throw new Error("Issue reporter window not available");const C=this.q.getWindowById(this.c.id);if(!C)throw new Error("Window not found");return C}async $getIssueReporterUri(C){const A=this.issueReporterWindowCheck(),L=`vscode:triggerIssueUriRequestHandlerResponse${A.id}`;return P.Promises.withAsyncBody(async(W,q)=>{const H=new B.$ee;A.sendWhenReady("vscode:triggerIssueUriRequestHandler",H.token,{replyChannel:L,extensionId:C}),k.$2V.once(L,(le,te)=>{W(p.URI.parse(te))});try{await(0,P.$ih)(5e3),H.cancel(),q(new Error("Timed out waiting for issue reporter URI"))}finally{k.$2V.removeHandler(L)}})}async $getIssueReporterData(C){const A=this.issueReporterWindowCheck(),L=`vscode:triggerIssueDataProviderResponse${A.id}`;return P.Promises.withAsyncBody(async W=>{const q=new B.$ee;A.sendWhenReady("vscode:triggerIssueDataProvider",q.token,{replyChannel:L,extensionId:C}),k.$2V.once(L,(H,le)=>{W(le)});try{await(0,P.$ih)(5e3),q.cancel(),W("Error: Extension timed out waiting for issue reporter data")}finally{k.$2V.removeHandler(L)}})}async $getIssueReporterTemplate(C){const A=this.issueReporterWindowCheck(),L=`vscode:triggerIssueDataTemplateResponse${A.id}`;return P.Promises.withAsyncBody(async W=>{const q=new B.$ee;A.sendWhenReady("vscode:triggerIssueDataTemplate",q.token,{replyChannel:L,extensionId:C}),k.$2V.once(L,(H,le)=>{W(le)});try{await(0,P.$ih)(5e3),q.cancel(),W("Error: Extension timed out waiting for issue reporter template")}finally{k.$2V.removeHandler(L)}})}async $getReporterStatus(C,A){const L=[!1,!1],W=this.issueReporterWindowCheck(),q="vscode:triggerReporterStatus",H=new B.$ee;return W.sendWhenReady(q,H.token,{replyChannel:q,extensionId:C,extensionName:A}),await(0,P.$$g)(new Promise(te=>k.$2V.once("vscode:triggerReporterStatusResponse",(ue,X)=>te(X))),2e3,()=>{this.i.error("Error: Extension timed out waiting for reporter status"),H.cancel()})??L}async $sendReporterMenu(C,A){const L=this.issueReporterWindowCheck(),W="vscode:triggerReporterMenu",q=new B.$ee;return L.sendWhenReady(W,q.token,{replyChannel:W,extensionId:C,extensionName:A}),await(0,P.$$g)(new Promise(le=>k.$2V.once(`vscode:triggerReporterMenuResponse:${C}`,(te,ue)=>le(ue))),5e3,()=>{this.i.error(`Error: Extension ${C} timed out waiting for menu response`),q.cancel()})}async $closeReporter(){this.b?.close()}async closeProcessExplorer(){this.d?.close()}s(C){C.isMinimized()&&C.restore(),C.focus()}t(C,A,...L){C.sender.isDestroyed()||C.sender.send(A,...L)}u(C,A,L,W){const q=new n.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:C.width,height:C.height,minWidth:300,minHeight:200,x:C.x,y:C.y,title:L.title,backgroundColor:L.backgroundColor||u.a,webPreferences:{preload:h.$Bg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${A.resource.toString()}`],v8CacheOptions:this.h.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,i.$jD)(L.zoomLevel),sandbox:!0},alwaysOnTop:L.alwaysOnTop,experimentalDarkMode:!0});return q.setMenuBarVisibility(!1),q}v(C,A,L){let W;const q=n.screen.getAllDisplays();if(q.length===1)W=q[0];else{if(c.$j){const te=n.screen.getCursorScreenPoint();W=n.screen.getDisplayNearestPoint(te)}!W&&C&&(W=n.screen.getDisplayMatching(C.getBounds())),W||(W=n.screen.getPrimaryDisplay()||q[0])}const H=W.bounds,le={width:A,height:L,x:H.x+H.width/2-A/2,y:H.y+H.height/2-L/2};return H.width>0&&H.height>0&&(le.x<H.x&&(le.x=H.x),le.y<H.y&&(le.y=H.y),le.x>H.x+H.width&&(le.x=H.x),le.y>H.y+H.height&&(le.y=H.y),le.width>H.width&&(le.width=H.width),le.height>H.height&&(le.height=H.height)),le}};e.$Bac=I,e.$Bac=I=u=Ee([ne(1,$.$C_b),ne(2,f.$Nj),ne(3,m.$1m),ne(4,v.$kac),ne(5,w.$I_b),ne(6,l.$zac),ne(7,t.$K_b),ne(8,a.$7j),ne(9,o.$UP),ne(10,s.$N_b)],I);function D(R){return typeof R!="object"||R===null?!1:"x"in R&&"y"in R&&"width"in R&&"height"in R}}),define(oe[304],ae([0,1,23,18,24,20,5,70,27,53,28,50,101]),function(J,e,n,j,P,B,S,E,h,c,p,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3ac=void 0;let g=class extends k.$1ac{constructor(v,w,$,f,l,d,a,t){super(v,w,f,l,d,t),this.e=$,this.u=a}s(v){return(0,k.$Zac)(`linux-${process.arch}`,v,this.k)}t(v){this.a&&(this.d(y.$ZW.CheckingForUpdates(v)),this.i.request({url:this.a},n.CancellationToken.None).then(c.$Ep).then(w=>{!w||!w.url||!w.version||!w.productVersion?(this.e.publicLog2("update:notAvailable",{explicit:!!v}),this.d(y.$ZW.Idle(1))):this.d(y.$ZW.AvailableForDownload(w))}).then(void 0,w=>{this.j.error(w);const $=v?w.message||w:void 0;this.d(y.$ZW.Idle(1,$))}))}async o(v){this.k.downloadUrl&&this.k.downloadUrl.length>0?this.u.openExternal(void 0,this.k.downloadUrl):v.update.url&&this.u.openExternal(void 0,v.update.url),this.d(y.$ZW.Idle(1))}};e.$3ac=g,e.$3ac=g=Ee([ne(0,B.$7_b),ne(1,j.$Ni),ne(2,p.$Ml),ne(3,P.$C_b),ne(4,c.$yp),ne(5,S.$Nj),ne(6,E.$zac),ne(7,h.$7j)],g)}),define(oe[305],ae([0,1,49,43,26,8,23,51,46,9,7,146,21,18,24,16,20,5,70,27,53,28,50,101]),function(J,e,n,j,P,B,S,E,h,c,p,y,k,g,m,v,w,$,f,l,d,a,t,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5ac=void 0;async function r(b,I=1e3){for(;!b();)await(0,B.$ih)(I)}let i;function s(){return typeof i>"u"&&(i=j.existsSync(c.$kc(c.$nc(process.execPath),"unins000.exe"))?0:1),i}let u=class extends o.$1ac{get cachePath(){const I=c.$kc((0,P.tmpdir)(),`vscode-${this.k.quality}-${this.k.target}-${process.arch}`);return k.Promises.mkdir(I,{recursive:!0}).then(()=>I)}constructor(I,D,R,C,A,L,W,q,H){super(I,D,C,A,L,H),this.u=R,this.v=W,this.w=q,I.setRelaunchHandler(this)}handleRelaunch(I){return I?.addArgs||I?.removeArgs||this.state.type!=="ready"||!this.e?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){if(this.k.target==="user"&&await this.w.isAdmin(void 0)){this.d(t.$ZW.Disabled(5)),this.j.info("update#ctor - updates are disabled due to running as Admin in user setup");return}await super.l()}s(I){let D=`win32-${process.arch}`;return s()===1?D+="-archive":this.k.target==="user"&&(D+="-user"),(0,o.$Zac)(D,I,this.k)}t(I){this.a&&(this.d(t.$ZW.CheckingForUpdates(I)),this.i.request({url:this.a},S.CancellationToken.None).then(d.$Ep).then(D=>{const R=s();return!D||!D.url||!D.version||!D.productVersion?(this.u.publicLog2("update:notAvailable",{explicit:!!I}),this.d(t.$ZW.Idle(R)),Promise.resolve(null)):R===1?(this.d(t.$ZW.AvailableForDownload(D)),Promise.resolve(null)):(this.d(t.$ZW.Downloading),this.C(D.version).then(()=>this.B(D.version).then(C=>k.Promises.exists(C).then(A=>{if(A)return Promise.resolve(C);const L=`${C}.tmp`;return this.i.request({url:D.url},S.CancellationToken.None).then(W=>this.v.writeFile(p.URI.file(L),W.stream)).then(D.sha256hash?()=>(0,y.$WV)(L,D.sha256hash):()=>{}).then(()=>k.Promises.rename(L,C,!1)).then(()=>C)})).then(C=>{this.e={packagePath:C},this.d(t.$ZW.Downloaded(D)),this.g.getValue("update.enableWindowsBackgroundUpdates")?this.k.target==="user"&&this.p():this.d(t.$ZW.Ready(D))})))}).then(void 0,D=>{this.u.publicLog2("update:error",{messageHash:String((0,h.$8i)(String(D)))}),this.j.error(D);const R=I?D.message||D:void 0;this.d(t.$ZW.Idle(s(),R))}))}async o(I){I.update.url&&this.w.openExternal(void 0,I.update.url),this.d(t.$ZW.Idle(s()))}async B(I){const D=await this.cachePath;return c.$kc(D,`CodeSetup-${this.k.quality}-${I}.exe`)}async C(I=null){const D=I?L=>!new RegExp(`${this.k.quality}-${I}\\.exe$`).test(L):()=>!0,R=await this.cachePath,A=(await k.Promises.readdir(R)).filter(D).map(async L=>{try{await k.Promises.unlink(c.$kc(R,L))}catch{}});await Promise.all(A)}async p(){if(this.state.type!=="downloaded"||!this.e)return Promise.resolve(void 0);const I=this.state.update;this.d(t.$ZW.Updating(I));const D=await this.cachePath;this.e.updateFilePath=c.$kc(D,`CodeSetup-${this.k.quality}-${I.version}.flag`),await k.Promises.writeFile(this.e.updateFilePath,"flag"),(0,n.spawn)(this.e.packagePath,["/verysilent","/log",`/update="${this.e.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.e=void 0,this.d(t.$ZW.Idle(s()))});const C=`${this.k.win32MutexName}-ready`,A=await new Promise((L,W)=>{J(["@vscode/windows-mutex"],L,W)});r(()=>A.isActive(C)).then(()=>this.d(t.$ZW.Ready(I)))}r(){this.state.type!=="ready"||!this.e||(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.e.updateFilePath?j.unlinkSync(this.e.updateFilePath):(0,n.spawn)(this.e.packagePath,["/silent","/log","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}q(){return s()}async _applySpecificUpdate(I){if(this.state.type!=="idle")return;const D=this.g.getValue("update.enableWindowsBackgroundUpdates"),R={version:"unknown",productVersion:"unknown"};this.d(t.$ZW.Downloading),this.e={packagePath:I},this.d(t.$ZW.Downloaded(R)),D?this.k.target==="user"&&this.p():this.d(t.$ZW.Ready(R))}};e.$5ac=u,Ee([E.$Lh],u.prototype,"cachePath",null),e.$5ac=u=Ee([ne(0,w.$7_b),ne(1,g.$Ni),ne(2,a.$Ml),ne(3,m.$C_b),ne(4,d.$yp),ne(5,$.$Nj),ne(6,v.$Nk),ne(7,f.$zac),ne(8,l.$7j)],u)}),define(oe[135],ae([0,1,14,8,23,47,3,2,13,66,4,7,193,26,65,18,56,24,64,16,20,5,27,80,256,83,28,106,69,55,29,30,58,81,39,34,57,67,22,6]),function(J,e,n,j,P,B,S,E,h,c,p,y,k,g,m,v,w,$,f,l,d,a,t,o,r,i,s,u,b,I,D,R,C,A,L,W,q,H,le,te){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5_b=e.$4_b=void 0;var ue;(function(z){z[z.NONE=0]="NONE",z[z.NAVIGATING=1]="NAVIGATING",z[z.READY=2]="READY"})(ue||(ue={}));class X extends E.$Uc{get lastFocusTime(){return this.j}get win(){return this.m}n(M){this.m=M,this.B(S.Event.fromNodeEventEmitter(M,"maximize")(()=>this.b.fire())),this.B(S.Event.fromNodeEventEmitter(M,"unmaximize")(()=>this.c.fire())),this.B(S.Event.fromNodeEventEmitter(M,"closed")(()=>{this.a.fire(),this.dispose()})),this.B(S.Event.fromNodeEventEmitter(M,"focus")(()=>{this.j=Date.now()})),this.B(S.Event.fromNodeEventEmitter(this.m,"enter-full-screen")(()=>this.g.fire())),this.B(S.Event.fromNodeEventEmitter(this.m,"leave-full-screen")(()=>this.h.fire()));const F=!(0,I.$fD)(this.r);if(p.$j&&F&&M.setSheetOffset((0,p.$J)((0,g.release)())?28:22),F&&(p.$i&&(0,I.$hD)(this.r)||p.$j)){const G=this.s.getItem(X.C);G&&this.updateWindowControls({height:G})}p.$i&&F&&M.hookWindowMessage(278,()=>{const[T,ce]=M.getPosition(),he=n.screen.getCursorScreenPoint(),K=he.x-T,O=he.y-ce;return!(K>30&&O>=0&&O<=Math.max(M.getBounds().height*.15,35))||(M.setEnabled(!1),M.setEnabled(!0),this.f.fire({x:K,y:O})),0}),this.t.args["open-devtools"]===!0&&M.webContents.openDevTools(),p.$j&&(this.B(this.onDidEnterFullScreen(()=>{this.G?.complete(!0)})),this.B(this.onDidLeaveFullScreen(()=>{this.G?.complete(!0)})))}constructor(M,F,G,T){super(),this.r=M,this.s=F,this.t=G,this.u=T,this.a=this.B(new S.$7d),this.onDidClose=this.a.event,this.b=this.B(new S.$7d),this.onDidMaximize=this.b.event,this.c=this.B(new S.$7d),this.onDidUnmaximize=this.c.event,this.f=this.B(new S.$7d),this.onDidTriggerSystemContextMenu=this.f.event,this.g=this.B(new S.$7d),this.onDidEnterFullScreen=this.g.event,this.h=this.B(new S.$7d),this.onDidLeaveFullScreen=this.h.event,this.j=Date.now(),this.m=null,this.D=(0,I.$hD)(this.r),this.F=void 0,this.G=void 0}setRepresentedFilename(M){p.$j?this.win?.setRepresentedFilename(M):this.w=M}getRepresentedFilename(){return p.$j?this.win?.getRepresentedFilename():this.w}setDocumentEdited(M){p.$j&&this.win?.setDocumentEdited(M),this.z=M}isDocumentEdited(){return p.$j?!!this.win?.isDocumentEdited():!!this.z}focus(M){p.$j&&M?.force&&n.app.focus({steal:!0});const F=this.win;F&&(F.isMinimized()&&F.restore(),F.focus())}handleTitleDoubleClick(){const M=this.win;if(M)if(p.$j)switch(n.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":M.minimize();break;case"None":break;case"Maximize":default:M.isMaximized()?M.unmaximize():M.maximize()}else M.isMaximized()?M.unmaximize():M.maximize()}static{this.C="windowControlHeight"}updateWindowControls(M){const F=this.win;if(F){if(M.height&&this.s.setItem(Q.C,M.height),p.$i&&this.D)F.setTitleBarOverlay({color:M.backgroundColor?.trim()===""?void 0:M.backgroundColor,symbolColor:M.foregroundColor?.trim()===""?void 0:M.foregroundColor,height:M.height?M.height-1:void 0});else if(p.$j&&M.height!==void 0){const G=(M.height-15)/2;G?F.setWindowButtonPosition({x:G,y:G}):F.setWindowButtonPosition(null)}}}toggleFullScreen(){this.H(!this.isFullScreen,!1)}H(M,F){(0,I.$iD)(this.r)?this.I(M,F):this.L(M)}get isFullScreen(){if(p.$j&&typeof this.F=="boolean")return this.F;const M=this.win,F=M?.isFullScreen(),G=M?.isSimpleFullScreen();return!!(F||G)}I(M,F){const G=this.win;G?.isSimpleFullScreen()&&G?.setSimpleFullScreen(!1),this.J(M,F)}J(M,F){if(p.$j){this.F=M;const T=this.G=new j.$Eh;(async()=>{const ce=await Promise.race([T.p,(0,j.$ih)(1e4).then(()=>!1)]);this.G===T&&(this.F=void 0,this.G=void 0,!ce&&M&&F&&this.win&&!this.win.isFullScreen()&&(this.u.warn("window: native macOS fullscreen transition did not happen within 10s from restoring"),this.h.fire()))})()}this.win?.setFullScreen(M)}L(M){const F=this.win;F?.isFullScreen()&&this.J(!1,!1),F?.setSimpleFullScreen(M),F?.webContents.focus()}dispose(){super.dispose(),this.m=null}}e.$4_b=X;let Q=class extends X{get id(){return this.P}get backupPath(){return this.R?.backupPath}get openedWorkspace(){return this.R?.workspace}get profile(){if(!this.config)return;const M=this.gb.profiles.find(F=>F.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&M?M:this.gb.getProfileForWorkspace(this.config.workspace??(0,R.$vi)(this.backupPath,this.isExtensionDevelopmentHost))??this.gb.defaultProfile}get remoteAuthority(){return this.R?.remoteAuthority}get config(){return this.R}get isExtensionDevelopmentHost(){return!!this.R?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.R?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.R?.debugId}constructor(M,F,G,T,ce,he,K,O,N,_,se,Z,V,x,U,re,ee,fe,me,ve,ke){super(_,ve,T,F),this.eb=G,this.fb=ce,this.gb=he,this.hb=K,this.ib=O,this.jb=N,this.kb=se,this.lb=Z,this.mb=V,this.nb=x,this.ob=U,this.pb=re,this.qb=ee,this.rb=fe,this.sb=me,this.M=this.B(new S.$7d),this.onWillLoad=this.M.event,this.N=this.B(new S.$7d),this.onDidSignalReady=this.N.event,this.O=this.B(new S.$7d),this.onDidDestroy=this.O.event,this.W=[],this.X=[],this.Y=void 0,this.Z=void 0,this.$=void 0,this.ab=this.B(this.rb.createIPCObjectUrl()),this.db=!1,this.tb=0;{const[je,We]=this.Db(M.state);this.S=je,this.u.trace("window#ctor: using window state",je);const ye=this.S.mode===0||this.S.mode===3,Y=ke.invokeFunction(D.$O_b,this.S,{show:!ye,webPreferences:{preload:h.$Bg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.ab.resource.toString()}`],v8CacheOptions:this.t.useCodeCache?"bypassHeatCheck":"none"}});(0,c.mark)("code/willCreateCodeBrowserWindow"),this.m=new n.BrowserWindow(Y),(0,c.mark)("code/didCreateCodeBrowserWindow"),this.P=this.m.id,this.n(this.m);const de=this.r.getValue("window"),$e=p.$j&&de?.nativeTabs===!0;(p.$j||p.$i)&&We&&(!$e||n.BrowserWindow.getAllWindows().length===1)&&[this.S.width,this.S.height,this.S.x,this.S.y].every(Se=>typeof Se=="number")&&this.m.setBounds({width:this.S.width,height:this.S.height,x:this.S.x,y:this.S.y}),ye&&((0,c.mark)("code/willMaximizeCodeWindow"),this.m.maximize(),this.S.mode===3&&this.H(!0,!0),this.m.show(),(0,c.mark)("code/didMaximizeCodeWindow")),this.j=Date.now()}this.Ab(),this.Jb(),this.ub()}setReady(){for(this.u.trace(`window#load: window reported ready (id: ${this.P})`),this.tb=2;this.W.length;)this.W.pop()(this);this.N.fire()}ready(){return new Promise(M=>{if(this.isReady)return M(this);this.W.push(M)})}get isReady(){return this.tb===2}get whenClosedOrLoaded(){return new Promise(M=>{function F(){G.dispose(),T.dispose(),M()}const G=this.onDidClose(()=>F()),T=this.onWillLoad(()=>F())})}ub(){this.m.on("unresponsive",()=>this.xb(1)),this.m.webContents.on("render-process-gone",(F,G)=>this.xb(2,{...G})),this.m.webContents.on("did-fail-load",(F,G,T)=>this.xb(3,{reason:T,exitCode:G})),this.m.webContents.on("will-prevent-unload",F=>{F.preventDefault()}),this.m.webContents.on("did-finish-load",()=>{this.bb&&(this.R=this.bb,this.bb=void 0)}),this.B(this.onDidMaximize(()=>{this.R&&(this.R.maximized=!0)})),this.B(this.onDidUnmaximize(()=>{this.R&&(this.R.maximized=!1)})),this.B(this.onDidEnterFullScreen(()=>{this.sendWhenReady("vscode:enterFullScreen",P.CancellationToken.None)})),this.B(this.onDidLeaveFullScreen(()=>{this.sendWhenReady("vscode:leaveFullScreen",P.CancellationToken.None)})),this.B(this.r.onDidChangeConfiguration(F=>this.Ab(F))),this.B(this.lb.onDidDeleteUntitledWorkspace(F=>this.zb(F)));const M=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this.m.webContents.session.webRequest.onBeforeSendHeaders({urls:M},async(F,G)=>{const T=await this.wb();G({cancel:!1,requestHeaders:Object.assign(F.requestHeaders,T)})})}wb(){return this.vb||(this.vb=(0,r.$Sp)(this.qb.version,this.qb,this.t,this.r,this.hb,this.ib,this.nb)),this.vb}async xb(M,F){switch(M){case 2:this.u.error(`CodeWindow: renderer process gone (reason: ${F?.reason||"<unknown>"}, code: ${F?.exitCode||"<unknown>"})`);break;case 1:this.u.error("CodeWindow: detected unresponsive");break;case 3:this.u.error(`CodeWindow: failed to load (reason: ${F?.reason||"<unknown>"}, code: ${F?.exitCode||"<unknown>"})`);break}switch(this.nb.publicLog2("windowerror",{type:M,reason:F?.reason,code:F?.exitCode}),M){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.pb.kill(1);return}if(this.t.args["enable-smoke-test-driver"]){await this.yb(!1,!1),this.pb.quit();return}if(M===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this.m&&this.m.webContents&&this.m.webContents.isDevToolsOpened())return;const{response:G,checkboxChecked:T}=await this.ob.showMessageBox({type:"warning",buttons:[(0,k.localize)(0,null),(0,k.localize)(1,null),(0,k.localize)(2,null)],message:(0,k.localize)(3,null),detail:(0,k.localize)(4,null),checkboxLabel:this.R?.workspace?(0,k.localize)(5,null):void 0},this.m);if(G!==2){const ce=G===0;await this.yb(ce,T)}}else if(M===2){let G;F?G=(0,k.localize)(7,null,F.reason,F.exitCode??"<unknown>"):G=(0,k.localize)(6,null);const{response:T,checkboxChecked:ce}=await this.ob.showMessageBox({type:"warning",buttons:[this.R?.workspace?(0,k.localize)(8,null):(0,k.localize)(9,null),(0,k.localize)(10,null)],message:G,detail:this.R?.workspace?(0,k.localize)(11,null):(0,k.localize)(12,null),checkboxLabel:this.R?.workspace?(0,k.localize)(13,null):void 0},this.m),he=T===0;await this.yb(he,ce)}break}}async yb(M,F){const G=this.R?.workspace;if(F&&G)try{const T=this.jb.workspaceStorage(G);await T.init(),T.delete("memento/workbench.parts.editor"),await T.close()}catch(T){this.u.error(T)}this.O.fire();try{if(M&&this.R){let T,ce;(0,R.$ri)(G)?T={folderUri:G.uri}:(0,R.$wi)(G)?T={workspaceUri:G.configPath}:ce=!0,(0,le.$Ob)(await this.sb.open({context:5,userEnv:this.R.userEnv,cli:{...this.t.args,_:[]},urisToOpen:T?[T]:void 0,forceEmpty:ce,forceNewWindow:!0,remoteAuthority:this.remoteAuthority}))?.focus()}}finally{this.m?.destroy()}}zb(M){this.R?.workspace?.id===M.id&&(this.R.workspace=void 0)}Ab(M){if(!M||M.affectsConfiguration("window.menuBarVisibility")){const F=this.Fb();F!==this.U&&(this.U=F,this.Gb(F))}if(!M||M.affectsConfiguration("http.proxy")){let F=(this.r.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;F?.endsWith("/")&&(F=F.substr(0,F.length-1));const G=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((F||"").indexOf("@")===-1&&(F!==this.Y||G!==this.Z)){this.Y=F,this.Z=G;const T=F||"",ce=G?`${G},<local>`:"<local>";this.u.trace(`Setting proxy to '${T}', bypassing '${ce}'`),this.m.webContents.session.setProxy({proxyRules:T,proxyBypassRules:ce,pacScript:""}),typeof n.app.setProxy=="function"&&n.app.setProxy({proxyRules:T,proxyBypassRules:ce,pacScript:""})}}}addTabbedWindow(M){p.$j&&M.win&&this.m.addTabbedWindow(M.win)}load(M,F=Object.create(null)){this.u.trace(`window#load: attempt to load window (id: ${this.P})`),this.isDocumentEdited()&&(!F.isReload||!this.mb.isHotExitEnabled())&&this.setDocumentEdited(!1),F.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this.m.setTitle(this.qb.nameLong)),this.Bb(M,F),this.tb===0?this.R=M:this.bb=M,this.tb=1,this.m.loadURL(h.$Bg.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.t.isBuilt?"":"-dev"}.html`).toString(!0));const G=this.db;this.db=!0,!this.t.isBuilt&&!this.t.extensionTestsLocationURI&&this.B(new j.$th(()=>{this.m&&!this.m.isVisible()&&!this.m.isMinimized()&&(this.m.show(),this.focus({force:!0}),this.m.webContents.openDevTools())},1e4)).schedule(),this.M.fire({workspace:M.workspace,reason:F.isReload?3:G?2:1})}Bb(M,F){const G=(this.R??this.bb)?.userEnv;if(G){const T=(0,f.$lm)(G)&&!(0,f.$lm)(M.userEnv),ce=this.isExtensionDevelopmentHost;(T||ce)&&(M.userEnv={...G,...M.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(M.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),F.disableExtensions!==void 0&&(M["disable-extensions"]=F.disableExtensions),M.fullscreen=this.isFullScreen,M.maximized=this.m.isMaximized(),M.partsSplash=this.kb.getWindowSplash(),M.zoomLevel=this.Ib(),M.isCustomZoomLevel=typeof this.$=="number",M.isCustomZoomLevel&&M.partsSplash&&(M.partsSplash.zoomLevel=M.zoomLevel),(0,c.mark)("code/willOpenNewWindow"),M.perfMarks=(0,c.getMarks)(),this.ab.update(M)}async reload(M){const F=Object.assign({},this.R);F.workspace=await this.Cb(F),delete F.filesToOpenOrCreate,delete F.filesToDiff,delete F.filesToMerge,delete F.filesToWait,this.isExtensionDevelopmentHost&&M&&(F.verbose=M.verbose,F.debugId=M.debugId,F.extensionEnvironment=M.extensionEnvironment,F["inspect-extensions"]=M["inspect-extensions"],F["inspect-brk-extensions"]=M["inspect-brk-extensions"],F["extensions-dir"]=M["extensions-dir"]),F.accessibilitySupport=n.app.isAccessibilitySupportEnabled(),F.isInitialStartup=!1,F.policiesData=this.fb.serialize(),F.continueOn=this.t.continueOn,F.profiles={all:this.gb.profiles,profile:this.profile||this.gb.defaultProfile,home:this.gb.profilesHome},F.logLevel=this.eb.getLogLevel(),F.loggers={window:this.eb.getRegisteredLoggers(this.id),global:this.eb.getRegisteredLoggers()},this.load(F,{isReload:!0,disableExtensions:M?.["disable-extensions"]})}async Cb(M){if((0,R.$wi)(M.workspace)){const F=M.workspace.configPath;if(F.scheme===h.Schemas.file&&!await this.hb.exists(F))return}else if((0,R.$ri)(M.workspace)){const F=M.workspace.uri;if(F.scheme===h.Schemas.file&&!await this.hb.exists(F))return}return M.workspace}serializeWindowState(){if(!this.m)return(0,A.$A_b)();if(this.isFullScreen){let G;try{G=n.screen.getDisplayMatching(this.getBounds())}catch{}const T=(0,A.$A_b)();return{mode:3,display:G?G.id:void 0,width:this.S.width||T.width,height:this.S.height||T.height,x:this.S.x||0,y:this.S.y||0,zoomLevel:this.$}}const M=Object.create(null);let F;if(!p.$j&&this.m.isMaximized()?F=0:F=1,F===0?M.mode=0:M.mode=1,F===1||F===0){let G;F===1?G=this.getBounds():G=this.m.getNormalBounds(),M.x=G.x,M.y=G.y,M.width=G.width,M.height=G.height}return M.zoomLevel=this.$,M}Db(M){(0,c.mark)("code/willRestoreCodeWindowState");let F=!1;if(M){this.$=M.zoomLevel;try{const G=n.screen.getAllDisplays();F=G.length>1,M=D.WindowStateValidator.validateWindowState(this.u,M,G)}catch(G){this.u.warn(`Unexpected error validating window state: ${G}
${G.stack}`)}}return(0,c.mark)("code/didRestoreCodeWindowState"),[M||(0,A.$A_b)(),F]}getBounds(){const[M,F]=this.m.getPosition(),[G,T]=this.m.getSize();return{x:M,y:F,width:G,height:T}}H(M,F){super.H(M,F),this.sendWhenReady(M?"vscode:enterFullScreen":"vscode:leaveFullScreen",P.CancellationToken.None),this.U&&this.Gb(this.U,!1)}Fb(){let M=(0,I.$dD)(this.r);return["visible","toggle","hidden"].indexOf(M)<0&&(M="classic"),M}Gb(M,F=!0){p.$j||(M==="toggle"&&F&&this.send("vscode:showInfoMessage",(0,k.localize)(14,null)),M==="hidden"?setTimeout(()=>{this.Hb(M)}):this.Hb(M))}Hb(M){const F=this.isFullScreen;switch(M){case"classic":this.m.setMenuBarVisibility(!F),this.m.autoHideMenuBar=F;break;case"visible":this.m.setMenuBarVisibility(!0),this.m.autoHideMenuBar=!1;break;case"toggle":this.m.setMenuBarVisibility(!1),this.m.autoHideMenuBar=!0;break;case"hidden":this.m.setMenuBarVisibility(!1),this.m.autoHideMenuBar=!1;break}}notifyZoomLevel(M){this.$=M}Ib(){return typeof this.$=="number"?this.$:this.r.getValue("window")?.zoomLevel}close(){this.m?.close()}sendWhenReady(M,F,...G){this.isReady?this.send(M,...G):this.ready().then(()=>{F.isCancellationRequested||this.send(M,...G)})}send(M,...F){if(this.m){if(this.m.isDestroyed()||this.m.webContents.isDestroyed()){this.u.warn(`Sending IPC message to channel '${M}' for window that is destroyed`);return}try{this.m.webContents.send(M,...F)}catch(G){this.u.warn(`Error sending IPC message to channel '${M}' of window ${this.P}: ${(0,B.$5i)(G)}`)}}}updateTouchBar(M){p.$j&&this.X.forEach((F,G)=>{const T=M[G];F.segments=this.Lb(T)})}Jb(){if(p.$j){for(let M=0;M<10;M++){const F=this.Kb();this.X.push(F)}this.m.setTouchBar(new n.TouchBar({items:this.X}))}}Kb(M=[]){const F=this.Lb(M),G=new n.TouchBar.TouchBarSegmentedControl({segments:F,mode:"buttons",segmentStyle:"automatic",change:T=>{this.sendWhenReady("vscode:runAction",P.CancellationToken.None,{id:G.segments[T].id,from:"touchbar"})}});return G}Lb(M=[]){return M.map(G=>{let T;G.icon&&!u.ThemeIcon.isThemeIcon(G.icon)&&G.icon?.dark?.scheme===h.Schemas.file&&(T=n.nativeImage.createFromPath(y.URI.revive(G.icon.dark).fsPath),T.isEmpty()&&(T=void 0));let ce;return typeof G.title=="string"?ce=G.title:ce=G.title.value,{id:G.id,label:T?void 0:ce,icon:T}})}dispose(){super.dispose(),this.eb.deregisterLoggers(this.id)}};e.$5_b=Q,e.$5_b=Q=Ee([ne(1,a.$Nj),ne(2,H.$2_b),ne(3,$.$C_b),ne(4,L.$2n),ne(5,q.$Q_b),ne(6,l.$Nk),ne(7,i.$cac),ne(8,i.$aac),ne(9,v.$Ni),ne(10,b.$L_b),ne(11,C.$Z_b),ne(12,m.$H_b),ne(13,s.$Ml),ne(14,w.$I_b),ne(15,d.$7_b),ne(16,t.$7j),ne(17,o.$K_b),ne(18,D.$N_b),ne(19,W.$UP),ne(20,te.$gi)],Q)}),define(oe[306],ae([0,1,14,4,18,24,20,5,34,55,135]),function(J,e,n,j,P,B,S,E,h,c,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6_b=void 0;let y=class extends p.$4_b{get win(){return super.win||this.tryClaimWindow(),super.win}constructor(g,m,v,w,$,f){super(w,$,m,v),this.M=g,this.N=f,this.id=this.M.id,this.parentId=-1,this.tryClaimWindow()}tryClaimWindow(){if(this.m||this.q.isDisposed||this.M.isDestroyed())return;const g=n.BrowserWindow.fromWebContents(this.M);g&&(this.u.trace("[aux window] Claimed browser window instance"),this.n(g),g.setMenu(null),(j.$i||j.$k)&&(0,c.$fD)(this.r)&&g.setAutoHideMenuBar(!0),this.N.registerAuxWindow(this))}};e.$6_b=y,e.$6_b=y=Ee([ne(1,B.$C_b),ne(2,E.$Nj),ne(3,P.$Ni),ne(4,h.$UP),ne(5,S.$7_b)],y)}),define(oe[307],ae([0,1,14,3,2,13,37,306,6,5,81,29]),function(J,e,n,j,P,B,S,E,h,c,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xbc=void 0;let k=class extends P.$Uc{constructor(m,v){super(),this.h=m,this.j=v,this.a=this.B(new j.$7d),this.onDidMaximizeWindow=this.a.event,this.b=this.B(new j.$7d),this.onDidUnmaximizeWindow=this.b.event,this.c=this.B(new j.$7d),this.onDidChangeFullScreen=this.c.event,this.f=this.B(new j.$7d),this.onDidTriggerSystemContextMenu=this.f.event,this.g=new Map,this.m()}m(){n.app.on("browser-window-created",(m,v)=>{const w=this.getWindowById(v.id);w&&(this.j.trace('[aux window] app.on("browser-window-created"): Trying to claim auxiliary window'),w.tryClaimWindow())}),S.$2V.handle("vscode:registerAuxiliaryWindow",async(m,v)=>{const w=this.getWindowById(m.sender.id);return w&&(this.j.trace("[aux window] vscode:registerAuxiliaryWindow: Registering auxiliary window to main window"),w.parentId=v),m.sender.id})}createWindow(m){return this.h.invokeFunction(y.$O_b,this.n(m),{webPreferences:{preload:B.$Bg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload-aux.js").fsPath}})}n(m){const v={},w=m.features.split(",");for(const f of w){const[l,d]=f.split("=");switch(l){case"width":v.width=parseInt(d,10);break;case"height":v.height=parseInt(d,10);break;case"left":v.x=parseInt(d,10);break;case"top":v.y=parseInt(d,10);break}}const $=y.WindowStateValidator.validateWindowState(this.j,v)??(0,p.$B_b)();return this.j.trace("[aux window] using window state",$),$}registerWindow(m){const v=new P.$Tc,w=this.h.createInstance(E.$6_b,m);this.g.set(w.id,w),v.add((0,P.$Sc)(()=>this.g.delete(w.id))),v.add(w.onDidMaximize(()=>this.a.fire(w))),v.add(w.onDidUnmaximize(()=>this.b.fire(w))),v.add(w.onDidEnterFullScreen(()=>this.c.fire({window:w,fullscreen:!0}))),v.add(w.onDidLeaveFullScreen(()=>this.c.fire({window:w,fullscreen:!1}))),v.add(w.onDidTriggerSystemContextMenu(({x:$,y:f})=>this.f.fire({window:w,x:$,y:f}))),j.Event.once(w.onDidClose)(()=>v.dispose())}getWindowById(m){return this.g.get(m)}getFocusedWindow(){const m=n.BrowserWindow.getFocusedWindow();if(m)return this.getWindowById(m.id)}getLastActiveWindow(){return(0,y.$P_b)(Array.from(this.g.values()))}getWindows(){return Array.from(this.g.values())}};e.$xbc=k,e.$xbc=k=Ee([ne(0,h.$gi),ne(1,c.$Nj)],k)}),define(oe[84],ae([0,1,14,22,8,3,48,2,13,4,19,7,21,196,6,20,5,83,98,30,58,32,56]),function(J,e,n,j,P,B,S,E,h,c,p,y,k,g,m,v,w,$,f,l,d,a,t){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$Mac=e.$Lac=void 0,e.$Lac=(0,m.$hi)("workspacesHistoryMainService");let r=class extends E.$Uc{static{o=this}static{this.a=500}static{this.b="history.recentlyOpenedPathsList"}constructor(s,u,b,I,D){super(),this.f=s,this.g=u,this.h=b,this.j=I,this.m=D,this.c=this.B(new B.$7d),this.onDidChangeRecentlyOpened=this.c.event,this.H=this.B(new P.$fh(800)),this.n()}n(){this.h.when(4).then(()=>this.I()),this.B(this.g.onDidEnterWorkspace(s=>this.addRecentlyOpened([{workspace:s.workspace,remoteAuthority:s.window.remoteAuthority}])))}async addRecentlyOpened(s){let u=[],b=[];for(const D of s)if((0,f.$Ceb)(D))!this.g.isUntitledWorkspace(D.workspace)&&!this.w(u,D.workspace)&&u.push(D);else if((0,f.$Deb)(D))this.y(u,D.folderUri)||u.push(D);else{const R=this.z(b,D.fileUri),C=D.fileUri.scheme===h.Schemas.file&&o.G.indexOf((0,p.$Rg)(D.fileUri))>=0;!R&&!C&&(b.push(D),c.$i&&D.fileUri.scheme===h.Schemas.file&&n.app.addRecentDocument(D.fileUri.fsPath))}const I=await this.r({workspaces:u,files:b});u=I.workspaces,b=I.files,u.length>o.a&&(u.length=o.a),b.length>o.a&&(b.length=o.a),await this.t({workspaces:u,files:b}),this.c.fire(),c.$j&&this.H.trigger(()=>this.N())}async removeRecentlyOpened(s){const u=R=>{const C=this.u(R);for(const A of s)if(p.$Lg.isEqual(A,C))return!1;return!0},b=await this.getRecentlyOpened(),I=b.workspaces.filter(u),D=b.files.filter(u);(I.length!==b.workspaces.length||D.length!==b.files.length)&&(await this.t({files:D,workspaces:I}),this.c.fire(),c.$j&&this.H.trigger(()=>this.N()))}async clearRecentlyOpened(s){if(s?.confirm){const{response:u}=await this.m.showMessageBox({type:"warning",buttons:[(0,g.localize)(0,null),(0,g.localize)(1,null)],message:(0,g.localize)(2,null),detail:(0,g.localize)(3,null),cancelId:1});if(u!==0)return}await this.t({workspaces:[],files:[]}),n.app.clearRecentDocuments(),this.c.fire()}async getRecentlyOpened(){return this.r()}async r(s){const u=new a.$Bc(D=>p.$Lg.getComparisonKey(D));if(s?.workspaces)for(const D of s.workspaces)u.set(this.u(D),D);const b=new a.$Bc(D=>p.$Lg.getComparisonKey(D));if(s?.files)for(const D of s.files)b.set(this.u(D),D);const I=await this.s();for(const D of I.workspaces){const R=u.get(this.u(D));R?R.label=R.label??D.label:u.set(this.u(D),D)}for(const D of I.files){const R=b.get(this.u(D));R?R.label=R.label??D.label:b.set(this.u(D),D)}return{workspaces:[...u.values()],files:[...b.values()]}}async s(){await this.j.whenReady;let s;const u=this.j.get(o.b,-1);if(typeof u=="string")try{s=JSON.parse(u)}catch(b){this.f.error("Unexpected error parsing opened paths list",b)}return(0,f.$Jeb)(s,this.f)}async t(s){await this.j.whenReady,this.j.store(o.b,JSON.stringify((0,f.$Keb)(s)),-1,1)}u(s){return(0,f.$Deb)(s)?s.folderUri:(0,f.$Eeb)(s)?s.fileUri:s.workspace.configPath}w(s,u){return!!s.find(b=>(0,f.$Ceb)(b)&&b.workspace.id===u.id)}y(s,u){return!!s.find(b=>(0,f.$Deb)(b)&&p.$Lg.isEqual(b.folderUri,u))}z(s,u){return!!s.find(b=>p.$Lg.isEqual(b.fileUri,u))}static{this.C=7}static{this.D=10}static{this.F=7}static{this.G=["COMMIT_EDITMSG","MERGE_MSG"]}async I(){c.$i&&(await this.J(),this.B(this.onDidChangeRecentlyOpened(()=>this.J())))}async J(){if(!c.$i)return;const s=[];if(s.push({type:"tasks",items:[{type:"task",title:(0,g.localize)(4,null),description:(0,g.localize)(5,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const u=[];for(const D of n.app.getJumpListSettings().removedItems){const R=D.args;if(R){const C=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(R);C&&u.push(y.URI.parse(C[2]))}}await this.removeRecentlyOpened(u);let b=!1;const I=(0,j.$Hb)((await this.getRecentlyOpened()).workspaces.slice(0,o.F).map(D=>{const R=(0,f.$Ceb)(D)?D.workspace:D.folderUri,{title:C,description:A}=this.L(R,D.label);let L;return y.URI.isUri(R)?L=`--folder-uri "${R.toString()}"`:(b=!0,L=`--file-uri "${R.configPath.toString()}"`),{type:"task",title:C.substr(0,255),description:A.substr(0,255),program:process.execPath,args:L,iconPath:"explorer.exe",iconIndex:0}}));I.length>0&&s.push({type:"custom",name:b?(0,g.localize)(6,null):(0,g.localize)(7,null),items:I})}s.push({type:"recent"});try{const u=n.app.setJumpList(s);u&&u!=="ok"&&this.f.warn(`updateWindowsJumpList#setJumpList unexpected result: ${u}`)}catch(u){this.f.warn("updateWindowsJumpList#setJumpList",u)}}L(s,u){if(u)return{title:(0,S.$ow)(u).name,description:u};if(y.URI.isUri(s))return{title:(0,p.$Rg)(s),description:this.M(s)};if(this.g.isUntitledWorkspace(s))return{title:(0,g.localize)(8,null),description:""};let b=(0,p.$Rg)(s.configPath);return b.endsWith(l.$Di)&&(b=b.substr(0,b.length-l.$Di.length-1)),{title:(0,g.localize)(9,null,b),description:this.M(s.configPath)}}M(s){return s.scheme==="file"?(0,S.$gw)(s.fsPath):s.toString()}async N(){if(!c.$j)return;n.app.clearRecentDocuments();const s=await this.getRecentlyOpened(),u=[];let b=0;for(let D=0;D<s.workspaces.length&&b<o.C;D++){const R=this.u(s.workspaces[D]);if(R.scheme===h.Schemas.file){const C=(0,p.$Ig)(R);await k.Promises.exists(C)&&(u.push(C),b++)}}const I=[];for(let D=0;D<s.files.length&&b<o.D;D++){const R=this.u(s.files[D]);if(R.scheme===h.Schemas.file){const C=(0,p.$Ig)(R);if(o.G.includes((0,p.$Rg)(R))||u.includes(C))continue;await k.Promises.exists(C)&&(I.push(C),b++)}}I.reverse().forEach(D=>n.app.addRecentDocument(D)),u.reverse().forEach(D=>n.app.addRecentDocument(D))}};e.$Mac=r,e.$Mac=r=o=Ee([ne(0,w.$Nj),ne(1,d.$Z_b),ne(2,v.$7_b),ne(3,$.$cac),ne(4,t.$I_b)],r)}),define(oe[308],ae([0,1,14,8,23,48,4,7,184,78,18,24,20,5,235,70,27,34,28,50,55,29,84]),function(J,e,n,j,P,B,S,E,h,c,p,y,k,g,m,v,w,$,f,l,d,a,t){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$Nac=void 0;const r="menu";let i=class{static{o=this}static{this.a="lastKnownMenubarData"}constructor(b,I,D,R,C,A,L,W,q,H,le,te){this.n=b,this.o=I,this.p=D,this.q=R,this.r=C,this.s=A,this.t=L,this.u=W,this.v=q,this.w=H,this.x=le,this.y=te,this.m=Object.create(null),this.g=new j.$th(()=>this.F(),0),this.h=new j.$th(()=>{this.j=[]},1e4),this.k=Object.create(null),this.l=Object.create(null),(S.$j||(0,d.$fD)(I))&&this.z(),this.A(),this.d=!1,this.f=!1,this.j=[],this.I(),this.B()}z(){const b=this.t.getItem(o.a);b&&(b.menus&&(this.k=b.menus),b.keybindings&&(this.l=b.keybindings))}A(){this.m["workbench.action.files.newUntitledFile"]=(A,L,W)=>{this.Y({type:"commandId",commandId:"workbench.action.files.newUntitledFile"})||this.p.openEmptyWindow({context:2,contextWindowId:L?.id})},this.m["workbench.action.newWindow"]=(A,L,W)=>this.p.openEmptyWindow({context:2,contextWindowId:L?.id}),this.m["workbench.action.files.openFileFolder"]=(A,L,W)=>this.w.pickFileFolderAndOpen(void 0,{forceNewWindow:this.R(W),telemetryExtraData:{from:r}}),this.m["workbench.action.files.openFolder"]=(A,L,W)=>this.w.pickFolderAndOpen(void 0,{forceNewWindow:this.R(W),telemetryExtraData:{from:r}}),this.m["workbench.action.openWorkspace"]=(A,L,W)=>this.w.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.R(W),telemetryExtraData:{from:r}}),this.m["workbench.action.clearRecentFiles"]=()=>this.s.clearRecentlyOpened({confirm:!0});const b=this.x.youTubeUrl;b&&(this.m["workbench.action.openYouTubeUrl"]=()=>this.ab(b,"openYouTubeUrl"));const I=this.x.requestFeatureUrl;I&&(this.m["workbench.action.openRequestFeatureUrl"]=()=>this.ab(I,"openUserVoiceUrl"));const D=this.x.reportIssueUrl;D&&(this.m["workbench.action.openIssueReporter"]=()=>this.ab(D,"openReportIssues"));const R=this.x.licenseUrl;R&&(this.m["workbench.action.openLicenseUrl"]=()=>{if(S.$w){const A=R.indexOf("?")>0?"&":"?";this.ab(`${R}${A}lang=${S.$w}`,"openLicenseUrl")}else this.ab(R,"openLicenseUrl")});const C=this.x.privacyStatementUrl;C&&R&&(this.m["workbench.action.openPrivacyStatementUrl"]=()=>{this.ab(C,"openPrivacyStatement")})}B(){this.u.onWillShutdown(()=>this.b=!0),this.p.onDidChangeWindowsCount(b=>this.G(b)),this.w.onDidBlurMainWindow(()=>this.H()),this.w.onDidFocusMainWindow(()=>this.H())}get C(){const b=this.o.getValue("window.enableMenuBarMnemonics");return typeof b!="boolean"?!0:b}get D(){if(!S.$j)return!1;const b=this.o.getValue("window.nativeTabs");return typeof b!="boolean"?!1:b}updateMenu(b,I){this.k=b.menus,this.l=b.keybindings,this.t.setItem(o.a,b),this.E()}E(){this.g.schedule()}F(){this.b||setTimeout(()=>{this.b||this.I()},10)}G(b){S.$j&&(b.oldCount===0&&b.newCount>0||b.oldCount>0&&b.newCount===0)&&(this.d=b.newCount===0,this.E())}H(){if(!S.$j)return;const b=n.BrowserWindow.getFocusedWindow();this.f=!b||!!this.y.getWindowById(b.id),this.E()}I(){const b=n.Menu.getApplicationMenu();if(b&&this.j.push(b),Object.keys(this.k).length===0){this.J(S.$j?new n.Menu:null);return}const I=new n.Menu;let D;if(S.$j){const C=new n.Menu;D=new n.MenuItem({label:this.x.nameShort,submenu:C}),this.K(C),I.append(D)}if(S.$j&&!this.c){this.c=!0;const C=new n.Menu;C.append(new n.MenuItem({label:this.cb(h.localize(0,null)),click:()=>this.p.openEmptyWindow({context:1})})),n.app.dock.setMenu(C)}if(this.M("File")){const C=new n.Menu,A=new n.MenuItem({label:this.cb(h.localize(1,null)),submenu:C});this.O(C,"File"),I.append(A)}if(this.M("Edit")){const C=new n.Menu,A=new n.MenuItem({label:this.cb(h.localize(2,null)),submenu:C});this.O(C,"Edit"),I.append(A)}if(this.M("Selection")){const C=new n.Menu,A=new n.MenuItem({label:this.cb(h.localize(3,null)),submenu:C});this.O(C,"Selection"),I.append(A)}if(this.M("View")){const C=new n.Menu,A=new n.MenuItem({label:this.cb(h.localize(4,null)),submenu:C});this.O(C,"View"),I.append(A)}if(this.M("Go")){const C=new n.Menu,A=new n.MenuItem({label:this.cb(h.localize(5,null)),submenu:C});this.O(C,"Go"),I.append(A)}if(this.M("Run")){const C=new n.Menu,A=new n.MenuItem({label:this.cb(h.localize(6,null)),submenu:C});this.O(C,"Run"),I.append(A)}if(this.M("Terminal")){const C=new n.Menu,A=new n.MenuItem({label:this.cb(h.localize(7,null)),submenu:C});this.O(C,"Terminal"),I.append(A)}let R;if(this.M("Window")){const C=new n.Menu;R=new n.MenuItem({label:this.cb(h.localize(8,null)),submenu:C,role:"window"}),this.U(C)}if(R&&I.append(R),this.M("Help")){const C=new n.Menu,A=new n.MenuItem({label:this.cb(h.localize(9,null)),submenu:C,role:"help"});this.O(C,"Help"),I.append(A)}I.items&&I.items.length>0?this.J(I):this.J(null),this.h.schedule()}J(b){if(n.Menu.setApplicationMenu(b),b)for(const I of this.y.getWindows())I.win?.setMenu(null)}K(b){const I=this.W(h.localize(10,null,this.x.nameLong),"workbench.action.showAboutDialog"),D=this.V();let R;if(this.M("Preferences")){const te=new n.Menu;this.O(te,"Preferences"),R=new n.MenuItem({label:this.cb(h.localize(11,null)),submenu:te})}const C=new n.Menu,A=new n.MenuItem({label:h.localize(12,null),role:"services",submenu:C}),L=new n.MenuItem({label:h.localize(13,null,this.x.nameLong),role:"hide",accelerator:"Command+H"}),W=new n.MenuItem({label:h.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),q=new n.MenuItem({label:h.localize(15,null),role:"unhide"}),H=new n.MenuItem(this.$("workbench.action.quit",{label:h.localize(16,null,this.x.nameLong),click:async(te,ue,X)=>{const Q=this.p.getLastActiveWindow();(this.p.getWindowCount()===0||n.BrowserWindow.getFocusedWindow()||Q?.win?.isMinimized())&&await this.L(X)&&this.w.quit(void 0)}})),le=[I];le.push(...D),R&&le.push(s(),R),le.push(s(),A,s(),L,W,q,s(),H),le.forEach(te=>b.append(te))}async L(b){if(this.p.getWindowCount()===0)return!0;const I=this.o.getValue("window.confirmBeforeClose");if(I==="always"||I==="keyboardOnly"&&this.S(b)){const{response:D}=await this.w.showMessageBox(this.p.getFocusedWindow()?.id,{type:"question",buttons:[h.localize(17,null),h.localize(18,null)],message:h.localize(19,null)});return D===0}return!0}M(b){if(!S.$j&&!(0,d.$fD)(this.o))return!1;switch(b){case"File":case"Help":if(S.$j)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k&&!!this.k[b];case"Window":if(S.$j)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k;default:return this.p.getWindowCount()>0&&!!this.k&&!!this.k[b]}}N(b,I){I.forEach(D=>{if((0,m.$Iac)(D))b.append(s());else if((0,m.$Hac)(D)){const R=new n.Menu,C=new n.MenuItem({label:this.cb(D.label),submenu:R});this.N(R,D.submenu.items),b.append(C)}else(0,m.$Jac)(D)?b.append(this.Q(D)):(0,m.$Kac)(D)&&(D.id==="workbench.action.showAboutDialog"&&this.P(b),S.$j?this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f?this.m[D.id]?b.append(new n.MenuItem(this.$(D.id,{label:this.cb(D.label),click:this.m[D.id]}))):b.append(this.W(D.label,D.id,!1,D.checked)):b.append(this.W(D.label,D.id,D.enabled!==!1,!!D.checked)):b.append(this.W(D.label,D.id,D.enabled!==!1,!!D.checked)))})}O(b,I){this.k&&this.k[I]&&this.N(b,this.k[I].items)}P(b){const I=this.V();I.length&&(I.forEach(D=>b.append(D)),b.append(s()))}Q(b){const I=E.URI.revive(b.uri),D=b.id,R=D==="openRecentFile"?{fileUri:I}:D==="openRecentWorkspace"?{workspaceUri:I}:{folderUri:I};return new n.MenuItem(this.$(D,{label:b.label,click:async(C,A,L)=>{const W=this.R(L);(await this.p.open({context:2,cli:this.q.args,urisToOpen:[R],forceNewWindow:W,gotoLineMode:!1,remoteAuthority:b.remoteAuthority})).length>0||await this.s.removeRecentlyOpened([I])}},!1))}R(b){return!!(b&&(!S.$j&&(b.ctrlKey||b.shiftKey)||S.$j&&(b.metaKey||b.altKey)))}S(b){return!!(b.triggeredByAccelerator||b.altKey||b.ctrlKey||b.metaKey||b.shiftKey)}T(b,I,D){const R={label:this.cb(b),role:D,enabled:!0};return new n.MenuItem(this.Z(I,R))}U(b){const I=new n.MenuItem({label:h.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.p.getWindowCount()>0}),D=new n.MenuItem({label:h.localize(21,null),role:"zoom",enabled:this.p.getWindowCount()>0}),R=new n.MenuItem({label:h.localize(22,null),role:"front",enabled:this.p.getWindowCount()>0}),C=this.W(h.localize(23,null),"workbench.action.switchWindow"),A=[];this.D&&(A.push(s()),A.push(this.W(h.localize(24,null),"workbench.action.newWindowTab")),A.push(this.T(h.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),A.push(this.T(h.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),A.push(this.T(h.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),A.push(this.T(h.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[I,D,s(),C,...A,s(),R].forEach(L=>b.append(L))}V(){switch(this.n.state.type){case"idle":return[new n.MenuItem({label:this.cb(h.localize(29,null)),click:()=>setTimeout(()=>{this.bb("CheckForUpdate"),this.n.checkForUpdates(!0)},0)})];case"checking for updates":return[new n.MenuItem({label:h.localize(30,null),enabled:!1})];case"available for download":return[new n.MenuItem({label:this.cb(h.localize(31,null)),click:()=>{this.n.downloadUpdate()}})];case"downloading":return[new n.MenuItem({label:h.localize(32,null),enabled:!1})];case"downloaded":return S.$j?[]:[new n.MenuItem({label:this.cb(h.localize(33,null)),click:()=>{this.bb("InstallUpdate"),this.n.applyUpdate()}})];case"updating":return[new n.MenuItem({label:h.localize(34,null),enabled:!1})];case"ready":return[new n.MenuItem({label:this.cb(h.localize(35,null)),click:()=>{this.bb("RestartToUpdate"),this.n.quitAndInstall()}})];default:return[]}}W(b,I,D,R){const C=this.cb(b),A=typeof I=="function"?I:(le,te,ue)=>{const X=le?le.userSettingsLabel:null;let Q=I;Array.isArray(I)&&(Q=this.R(ue)?I[1]:I[0]),X&&ue.triggeredByAccelerator?this.Y({type:"keybinding",userSettingsLabel:X}):this.Y({type:"commandId",commandId:Q})},L=typeof D=="boolean"?D:this.p.getWindowCount()>0,W=typeof R=="boolean"?R:!1,q={label:C,click:A,enabled:L};W&&(q.type="checkbox",q.checked=W);let H;return typeof I=="string"?H=I:Array.isArray(I)&&(H=I[0]),S.$j&&(H==="editor.action.clipboardCutAction"?q.role="cut":H==="editor.action.clipboardCopyAction"?q.role="copy":H==="editor.action.clipboardPasteAction"&&(q.role="paste"),H==="undo"?q.click=this.X(A,{inDevTools:le=>le.undo(),inNoWindow:()=>n.Menu.sendActionToFirstResponder("undo:")}):H==="redo"?q.click=this.X(A,{inDevTools:le=>le.redo(),inNoWindow:()=>n.Menu.sendActionToFirstResponder("redo:")}):H==="editor.action.selectAll"&&(q.click=this.X(A,{inDevTools:le=>le.selectAll(),inNoWindow:()=>n.Menu.sendActionToFirstResponder("selectAll:")}))),new n.MenuItem(this.Z(H,q))}X(b,I){return(D,R,C)=>{const A=n.BrowserWindow.getFocusedWindow();if(!A)return I.inNoWindow();if(A.webContents.isDevToolsFocused()&&A.webContents.devToolsWebContents)return I.inDevTools(A.webContents.devToolsWebContents);b(D,R||A,C)}}Y(b){let I=n.BrowserWindow.getFocusedWindow();if(I){const R=this.y.getWindowById(I.id);R&&(I=this.p.getWindowById(R.parentId)?.win??null)}if(!I){const R=this.p.getLastActiveWindow();R?.win?.isMinimized()&&(I=R.win)}const D=I?this.p.getWindowById(I.id):void 0;if(D){if(this.v.trace("menubar#runActionInRenderer",b),S.$j&&!this.q.isBuilt&&!D.isReady&&(b.type==="commandId"&&b.commandId==="workbench.action.toggleDevTools"||b.type!=="commandId"&&b.userSettingsLabel==="alt+cmd+i"))return!1;if(b.type==="commandId"){const R={id:b.commandId,from:"menu"};D.sendWhenReady("vscode:runAction",P.CancellationToken.None,R)}else{const R={userSettingsLabel:b.userSettingsLabel};D.sendWhenReady("vscode:runKeybinding",P.CancellationToken.None,R)}return!0}else return this.v.trace("menubar#runActionInRenderer: no active window found",b),!1}Z(b,I){const D=typeof b=="string"?this.l[b]:void 0;if(D?.label){if(D.isNative!==!1)I.accelerator=D.label,I.userSettingsLabel=D.userSettingsLabel;else if(typeof I.label=="string"){const R=I.label.indexOf("[");R>=0?I.label=`${I.label.substr(0,R)} [${D.label}]`:I.label=`${I.label} [${D.label}]`}}else I.accelerator=void 0;return I}$(b,I,D=!I.accelerator){D&&(I=this.Z(b,I));const R=I.click;return I.click=(C,A,L)=>{this.bb(b),R?.(C,A,L)},I}ab(b,I){this.w.openExternal(void 0,b),this.bb(I)}bb(b){this.r.publicLog2("workbenchActionExecuted",{id:b,from:r})}cb(b){return(0,B.$lw)(b,!this.C)}};e.$Nac=i,e.$Nac=i=o=Ee([ne(0,l.$1W),ne(1,p.$Ni),ne(2,a.$N_b),ne(3,y.$C_b),ne(4,f.$Ml),ne(5,t.$Lac),ne(6,$.$UP),ne(7,k.$7_b),ne(8,g.$Nj),ne(9,v.$zac),ne(10,w.$7j),ne(11,c.$yac)],i);function s(){return new n.MenuItem({type:"separator"})}}),define(oe[309],ae([0,1,6,20,5,308]),function(J,e,n,j,P,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pac=e.$Oac=void 0,e.$Oac=(0,n.$hi)("menubarMainService");let S=class{constructor(h,c,p){this.b=h,this.c=c,this.d=p,this.a=this.e()}async e(){return await this.c.when(3),this.b.createInstance(B.$Nac)}async updateMenubar(h,c){this.d.trace("menubarService#updateMenubar",h),(await this.a).updateMenu(c,h)}};e.$Pac=S,e.$Pac=S=Ee([ne(0,n.$gi),ne(1,j.$7_b),ne(2,P.$Nj)],S)}),define(oe[310],ae([0,1,14,21,102,26,22,23,3,31,48,2,13,9,66,4,36,19,12,7,194,65,18,56,24,16,6,20,5,79,80,68,34,55,135,29,133,302,30,99,84,58,69,39,57,67,78]),function(J,e,n,j,P,B,S,E,h,c,p,y,k,g,m,v,w,$,f,l,d,a,t,o,r,i,s,u,b,I,D,R,C,A,L,W,q,H,le,te,ue,X,Q,z,M,F,G){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dbc=void 0;function T(K){return(0,le.$wi)(K?.workspace)}function ce(K){return(0,le.$ri)(K?.workspace)}let he=class extends y.$Uc{constructor(O,N,_,se,Z,V,x,U,re,ee,fe,me,ve,ke,je,We,ye,Y,de,$e){super(),this.s=O,this.t=N,this.u=_,this.w=se,this.z=Z,this.C=V,this.D=x,this.F=U,this.G=re,this.H=ee,this.I=fe,this.J=me,this.L=ve,this.M=ke,this.N=je,this.O=We,this.P=ye,this.Q=Y,this.R=de,this.S=$e,this.a=this.B(new h.$7d),this.onDidOpenWindow=this.a.event,this.b=this.B(new h.$7d),this.onDidSignalReadyWindow=this.b.event,this.c=this.B(new h.$7d),this.onDidDestroyWindow=this.c.event,this.f=this.B(new h.$7d),this.onDidChangeWindowsCount=this.f.event,this.g=this.B(new h.$7d),this.onDidMaximizeWindow=this.g.event,this.h=this.B(new h.$7d),this.onDidUnmaximizeWindow=this.h.event,this.j=this.B(new h.$7d),this.onDidChangeFullScreen=this.j.event,this.m=this.B(new h.$7d),this.onDidTriggerSystemContextMenu=this.m.event,this.n=new Map,this.r=this.B(new H.$abc(this,this.C,this.H,this.w,this.J)),this.U()}U(){this.B(this.M.onDidEnterWorkspace(O=>this.b.fire(O.window))),this.B(this.onDidSignalReadyWindow(O=>{if(O.config?.extensionDevelopmentPath||O.config?.extensionTestsPath){const N=new y.$Tc;if(N.add(h.Event.any(O.onDidClose,O.onDidDestroy)(()=>N.dispose())),O.config.extensionDevelopmentPath)for(const _ of O.config.extensionDevelopmentPath)N.add(this.Q.addValidFileRoot(_));O.config.extensionTestsPath&&N.add(this.Q.addValidFileRoot(O.config.extensionTestsPath))}}))}openEmptyWindow(O,N){const _=this.F.args,se=N?.remoteAuthority||void 0,Z=!0,V=N?.forceReuseWindow,x=!V;return this.open({...O,cli:_,forceEmpty:Z,forceNewWindow:x,forceReuseWindow:V,remoteAuthority:se})}openExistingWindow(O,N){O.focus(),this.W(N,[O])}async open(O){this.w.trace("windowsManager#open"),O.addMode&&(O.initialStartup||!this.getLastActiveWindow())&&(O.addMode=!1);const N=[],_=[],se=[],Z=[],V=[];let x,U=0;const re=await this.cb(O);this.w.trace("windowsManager#open pathsToOpen",re);for(const ke of re)ce(ke)?O.addMode?N.push(ke):_.push(ke):T(ke)?se.push(ke):ke.fileUri?(x||(x={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:ke.remoteAuthority}),x.filesToOpenOrCreate.push(ke)):ke.backupPath?V.push({backupFolder:(0,g.$oc)(ke.backupPath),remoteAuthority:ke.remoteAuthority}):U++;O.diffMode&&x&&x.filesToOpenOrCreate.length>=2&&(x.filesToDiff=x.filesToOpenOrCreate.slice(0,2),x.filesToOpenOrCreate=[]),O.mergeMode&&x&&x.filesToOpenOrCreate.length===4&&(x.filesToMerge=x.filesToOpenOrCreate.slice(0,4),x.filesToOpenOrCreate=[],x.filesToDiff=[]),x&&O.waitMarkerFileURI&&(x.filesToWait={paths:(0,S.$Hb)([...x.filesToDiff,x.filesToMerge[3],...x.filesToOpenOrCreate]),waitMarkerFileUri:O.waitMarkerFileURI}),O.initialStartup?(Z.push(...this.M.getUntitledWorkspaces()),se.push(...Z),V.push(...this.I.getEmptyWindowBackups())):V.length=0;const{windows:ee,filesOpenedInWindow:fe}=await this.X(O,se,_,V,U,x,N);if(this.w.trace(`windowsManager#open used window count ${ee.length} (workspacesToOpen: ${se.length}, foldersToOpen: ${_.length}, emptyToRestore: ${V.length}, emptyToOpen: ${U})`),ee.length>1)if(fe)fe.focus();else{const ke=this.r.state.lastActiveWindow&&!O.forceEmpty&&!O.cli._.length&&!O.cli["file-uri"]&&!O.cli["folder-uri"]&&!(O.urisToOpen&&O.urisToOpen.length);let je=!0,We=!0;if(ke){const ye=ee.filter(Y=>this.r.state.lastActiveWindow&&Y.backupPath===this.r.state.lastActiveWindow.backupPath);ye.length&&(ye[0].focus(),je=!1,We=!1)}if(je)for(let ye=ee.length-1;ye>=0;ye--){const Y=ee[ye];if(!(Y.openedWorkspace&&Z.some(de=>Y.openedWorkspace&&de.workspace.id===Y.openedWorkspace.id)||Y.backupPath&&V.some(de=>Y.backupPath&&de.backupFolder===(0,g.$oc)(Y.backupPath)))){Y.focus(),We=!1;break}}We&&ee[ee.length-1].focus()}const me=x&&x.filesToDiff.length>0,ve=x&&x.filesToMerge.length>0;if(!ee.some(ke=>ke.isExtensionDevelopmentHost)&&!me&&!ve&&!O.noRecentEntry){const ke=[];for(const je of re)T(je)&&!je.transient?ke.push({label:je.label,workspace:je.workspace,remoteAuthority:je.remoteAuthority}):ce(je)?ke.push({label:je.label,folderUri:je.workspace.uri,remoteAuthority:je.remoteAuthority}):je.fileUri&&ke.push({label:je.label,fileUri:je.fileUri,remoteAuthority:je.remoteAuthority});this.L.addRecentlyOpened(ke)}return this.W(O,ee),ee}W(O,N){const _=O.waitMarkerFileURI;O.context===0&&_&&N.length===1&&N[0]&&(async()=>{await N[0].whenClosedOrLoaded;try{await this.P.del(_)}catch{}})()}async X(O,N,_,se,Z,V,x){const U=[];let re;function ee(ye,Y){U.push(ye),Y&&(re=ye,V=void 0)}let{openFolderInNewWindow:fe,openFilesInNewWindow:me}=this.ob(O);if(!O.initialStartup&&x.length>0){const ye=x[0].remoteAuthority,Y=this.ub(ye);Y&&ee(this.$(Y,x.map(de=>de.workspace.uri)))}const ve=_.length+N.length+se.length;if(V&&ve===0){const ye=V.filesToOpenOrCreate[0]||V.filesToDiff[0]||V.filesToMerge[3],Y=this.getWindows().filter($e=>V&&(0,$.$Zg)($e.remoteAuthority,V.remoteAuthority));let de;ye?.fileUri&&!me&&((O.context===4||O.context===0||O.context===1)&&(de=await(0,q.$S_b)(Y,ye.fileUri,async $e=>$e.configPath.scheme===k.Schemas.file?this.M.resolveLocalWorkspace($e.configPath):void 0)),de||(de=this.vb(Y))),de?(0,le.$wi)(de.openedWorkspace)?N.push({workspace:de.openedWorkspace,remoteAuthority:de.remoteAuthority}):(0,le.$ri)(de.openedWorkspace)?_.push({workspace:de.openedWorkspace,remoteAuthority:de.remoteAuthority}):ee(this.Y(O,de,V),!0):ee(await this.pb({userEnv:O.userEnv,cli:O.cli,initialStartup:O.initialStartup,filesToOpen:V,forceNewWindow:!0,remoteAuthority:V.remoteAuthority,forceNewTabbedWindow:O.forceNewTabbedWindow,forceProfile:O.forceProfile,forceTempProfile:O.forceTempProfile}),!0)}const ke=(0,S.$Mb)(N,ye=>ye.workspace.id);if(ke.length>0){const ye=(0,S.$Hb)(ke.map(Y=>(0,q.$T_b)(this.getWindows(),Y.workspace.configPath)));if(ye.length>0){const Y=ye[0],de=(0,$.$Zg)(V?.remoteAuthority,Y.remoteAuthority)?V:void 0;ee(this.Y(O,Y,de),!!de),fe=!0}for(const Y of ke){if(ye.some(Se=>Se.openedWorkspace&&Se.openedWorkspace.id===Y.workspace.id))continue;const de=Y.remoteAuthority,$e=(0,$.$Zg)(V?.remoteAuthority,de)?V:void 0;ee(await this.bb(O,Y,fe,$e),!!$e),fe=!0}}const je=(0,S.$Mb)(_,ye=>$.$Lg.getComparisonKey(ye.workspace.uri));if(je.length>0){const ye=(0,S.$Hb)(je.map(Y=>(0,q.$T_b)(this.getWindows(),Y.workspace.uri)));if(ye.length>0){const Y=ye[0],de=(0,$.$Zg)(V?.remoteAuthority,Y.remoteAuthority)?V:void 0;ee(this.Y(O,Y,de),!!de),fe=!0}for(const Y of je){if(ye.some(Se=>(0,le.$ri)(Se.openedWorkspace)&&$.$Lg.isEqual(Se.openedWorkspace.uri,Y.workspace.uri)))continue;const de=Y.remoteAuthority,$e=(0,$.$Zg)(V?.remoteAuthority,de)?V:void 0;ee(await this.bb(O,Y,fe,$e),!!$e),fe=!0}}const We=(0,S.$Mb)(se,ye=>ye.backupFolder);if(We.length>0)for(const ye of We){const Y=ye.remoteAuthority,de=(0,$.$Zg)(V?.remoteAuthority,Y)?V:void 0;ee(await this.ab(O,!0,Y,de,ye),!!de),fe=!0}if(U.length===0||V){V&&!Z&&Z++;const ye=V?V.remoteAuthority:O.remoteAuthority;for(let Y=0;Y<Z;Y++)ee(await this.ab(O,fe,ye,V),!!V),fe=!0}return{windows:(0,S.$Mb)(U),filesOpenedInWindow:re}}Y(O,N,_){this.w.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:_}),this.Z(N);const se={filesToOpenOrCreate:_?.filesToOpenOrCreate,filesToDiff:_?.filesToDiff,filesToMerge:_?.filesToMerge,filesToWait:_?.filesToWait,termProgram:O?.userEnv?.TERM_PROGRAM};return N.sendWhenReady("vscode:openFiles",E.CancellationToken.None,se),N}Z(O){let N=O;const _=n.BrowserWindow.getFocusedWindow();if(_&&_.id!==O.id){const se=this.S.getWindowById(_.id);se&&se.parentId===O.id&&(N=se)}N.focus()}$(O,N){this.w.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:N}),O.focus();const _={foldersToAdd:N};return O.sendWhenReady("vscode:addFolders",E.CancellationToken.None,_),O}ab(O,N,_,se,Z){this.w.trace("windowsManager#doOpenEmpty",{restore:!!Z,remoteAuthority:_,filesToOpen:se,forceNewWindow:N});let V;return!N&&typeof O.contextWindowId=="number"&&(V=this.getWindowById(O.contextWindowId)),this.pb({userEnv:O.userEnv,cli:O.cli,initialStartup:O.initialStartup,remoteAuthority:_,forceNewWindow:N,forceNewTabbedWindow:O.forceNewTabbedWindow,filesToOpen:se,windowToUse:V,emptyWindowBackupInfo:Z,forceProfile:O.forceProfile,forceTempProfile:O.forceTempProfile})}bb(O,N,_,se,Z){return this.w.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:N,filesToOpen:se}),!_&&!Z&&typeof O.contextWindowId=="number"&&(Z=this.getWindowById(O.contextWindowId)),this.pb({workspace:N.workspace,userEnv:O.userEnv,cli:O.cli,initialStartup:O.initialStartup,remoteAuthority:N.remoteAuthority,forceNewWindow:_,forceNewTabbedWindow:O.forceNewTabbedWindow,filesToOpen:se,windowToUse:Z,forceProfile:O.forceProfile,forceTempProfile:O.forceTempProfile})}async cb(O){let N,_=!1,se=!1;if(O.urisToOpen&&O.urisToOpen.length>0?(N=await this.db(O),_=!0):O.forceEmpty?N=[Object.create(null)]:O.cli._.length||O.cli["folder-uri"]||O.cli["file-uri"]?(N=await this.eb(O.cli),N.length===0&&N.push(Object.create(null)),_=!0):(N=await this.gb(),N.length===0&&N.push(Object.create(null)),se=!0),!O.addMode&&_){const Z=N.filter(V=>ce(V));if(Z.length>1){const V=Z[0].remoteAuthority;if(Z.every(x=>(0,$.$Zg)(x.remoteAuthority,V))){const x=await this.M.createUntitledWorkspace(Z.map(U=>({uri:U.workspace.uri})));N.push({workspace:x,remoteAuthority:V}),N=N.filter(U=>!ce(U))}}}if(O.initialStartup&&!se&&this.J.getValue("window")?.restoreWindows==="preserve"){const Z=await this.gb();N.unshift(...Z.filter(V=>T(V)||ce(V)||V.backupPath))}return N}async db(O){const N={gotoLineMode:O.gotoLineMode,remoteAuthority:O.remoteAuthority},_=await Promise.all((0,S.$Hb)(O.urisToOpen||[]).map(async se=>{const Z=await this.ib(se,N);if(Z)return Z.label=se.label,Z;const V=this.kb(se);this.O.showMessageBox({type:"info",buttons:[(0,d.localize)(0,null)],message:V.scheme===k.Schemas.file?(0,d.localize)(1,null):(0,d.localize)(2,null),detail:V.scheme===k.Schemas.file?(0,d.localize)(3,null,(0,p.$fw)(V,{os:v.OS,tildify:this.F})):(0,d.localize)(4,null,V.toString(!0))},n.BrowserWindow.getFocusedWindow()??void 0)}));return(0,S.$Hb)(_)}async eb(O){const N=[],_={ignoreFileNotFound:!0,gotoLineMode:O.goto,remoteAuthority:O.remote||void 0,forceOpenWorkspaceAsFile:O.diff&&O._.length===2||O.merge&&O._.length===4},se=O["folder-uri"];if(se){const x=await Promise.all(se.map(U=>{const re=this.fb(U);if(re)return this.ib({folderUri:re},_)}));N.push(...(0,S.$Hb)(x))}const Z=O["file-uri"];if(Z){const x=await Promise.all(Z.map(U=>{const re=this.fb(U);if(re)return this.ib((0,le.$Mi)(U)?{workspaceUri:re}:{fileUri:re},_)}));N.push(...(0,S.$Hb)(x))}const V=await Promise.all(O._.map(x=>_.remoteAuthority?this.nb(x,_):this.lb(x,_)));return N.push(...(0,S.$Hb)(V)),N}fb(O){try{const N=l.URI.parse(O);if(!N.scheme){this.w.error(`Invalid URI input string, scheme missing: ${O}`);return}return N.path?N:N.with({path:"/"})}catch(N){this.w.error(`Invalid URI input string: ${O}, ${N.message}`)}}async gb(){const O=this.hb();switch(O){case"none":return[];case"one":case"all":case"preserve":case"folders":{const N=[];O!=="one"&&N.push(...this.r.state.openedWindows),this.r.state.lastActiveWindow&&N.push(this.r.state.lastActiveWindow);const _=await Promise.all(N.map(async se=>{if(se.workspace){const Z=await this.ib({workspaceUri:se.workspace.configPath},{remoteAuthority:se.remoteAuthority,rejectTransientWorkspaces:!0});if(T(Z))return Z}else if(se.folderUri){const Z=await this.ib({folderUri:se.folderUri},{remoteAuthority:se.remoteAuthority});if(ce(Z))return Z}else if(O!=="folders"&&se.backupPath)return{backupPath:se.backupPath,remoteAuthority:se.remoteAuthority}}));return(0,S.$Hb)(_)}}}hb(){let O;return this.H.wasRestarted?O="all":(O=this.J.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(O)||(O="all")),O}async ib(O,N=Object.create(null)){const _=this.kb(O);return _.scheme===k.Schemas.file?((0,A.$cD)(O)&&(N={...N,forceOpenWorkspaceAsFile:!0}),this.lb(_.fsPath,N)):this.jb(O,N)}jb(O,N){let _=this.kb(O);const se=(0,R.$sm)(_)||N.remoteAuthority;if(_=(0,$.$2g)((0,$.$Vg)(_)),(0,A.$cD)(O)){if(N.gotoLineMode){const{path:Z,line:V,column:x}=(0,c.$og)(_.path);return{fileUri:_.with({path:Z}),options:{selection:V?{startLineNumber:V,startColumn:x||1}:void 0},remoteAuthority:se}}return{fileUri:_,remoteAuthority:se}}else if((0,A.$aD)(O))return{workspace:(0,te.$W_b)(_),remoteAuthority:se};return{workspace:(0,te.$X_b)(_),remoteAuthority:se}}kb(O){return(0,A.$aD)(O)?O.workspaceUri:(0,A.$bD)(O)?O.folderUri:O.fileUri}async lb(O,N,_){let se,Z;N.gotoLineMode&&({path:O,line:se,column:Z}=(0,c.$og)(O)),O=(0,c.$jg)((0,g.$ic)(O),(0,w.cwd)());try{const V=await j.Promises.stat(O);if(V.isFile()){if(!N.forceOpenWorkspaceAsFile){const x=await this.M.resolveLocalWorkspace(l.URI.file(O));if(x)return x.transient&&N.rejectTransientWorkspaces?void 0:{workspace:{id:x.id,configPath:x.configPath},type:i.FileType.File,exists:!0,remoteAuthority:x.remoteAuthority,transient:x.transient}}return{fileUri:l.URI.file(O),type:i.FileType.File,exists:!0,options:{selection:se?{startLineNumber:se,startColumn:Z||1}:void 0}}}else{if(V.isDirectory())return{workspace:(0,te.$X_b)(l.URI.file(O),V),type:i.FileType.Directory,exists:!0};if(!v.$i&&O==="/dev/null")return{fileUri:l.URI.file(O),type:i.FileType.File,exists:!0}}}catch(V){if(V.code==="ERR_UNC_HOST_NOT_ALLOWED"&&!_)return this.mb(O,N);const x=l.URI.file(O);if(this.L.removeRecentlyOpened([x]),N.ignoreFileNotFound)return{fileUri:x,type:i.FileType.File,exists:!1}}}async mb(O,N){const _=l.URI.file(O),{response:se,checkboxChecked:Z}=await this.O.showMessageBox({type:"warning",buttons:[(0,d.localize)(5,null),(0,d.localize)(6,null),(0,d.localize)(7,null)],message:(0,d.localize)(8,null,_.authority),detail:(0,d.localize)(9,null,(0,p.$fw)(_,{os:v.OS,tildify:this.F})),checkboxLabel:(0,d.localize)(10,null,_.authority),cancelId:1});if(se===0){if((0,P.addUNCHostToAllowlist)(_.authority),Z){const V={channel:"vscode:configureAllowedUNCHost",args:_.authority};this.sendToFocused(V.channel,V.args),this.sendToOpeningWindow(V.channel,V.args)}return this.lb(O,N,!0)}if(se===2)return n.shell.openExternal("https://aka.ms/vscode-windows-unc"),this.mb(O,N)}nb(O,N){const _=O.charCodeAt(0),se=N.remoteAuthority;let Z,V;N.gotoLineMode&&({path:O,line:Z,column:V}=(0,c.$og)(O)),_!==47&&((0,c.$ig)(_)&&O.charCodeAt(O.charCodeAt(1))===58&&(O=(0,c.$bg)(O)),O=`/${O}`);const x=l.URI.from({scheme:k.Schemas.vscodeRemote,authority:se,path:O});if(O.charCodeAt(O.length-1)!==47){if((0,le.$Mi)(O))return N.forceOpenWorkspaceAsFile?{fileUri:x,options:{selection:Z?{startLineNumber:Z,startColumn:V||1}:void 0},remoteAuthority:N.remoteAuthority}:{workspace:(0,te.$W_b)(x),remoteAuthority:se};if(N.gotoLineMode||g.$hc.basename(O).indexOf(".")!==-1)return{fileUri:x,options:{selection:Z?{startLineNumber:Z,startColumn:V||1}:void 0},remoteAuthority:se}}return{workspace:(0,te.$X_b)(x),remoteAuthority:se}}ob(O){const N=this.J.getValue("window"),_=N?.openFoldersInNewWindow||"default",se=N?.openFilesInNewWindow||"off";let Z=(O.preferNewWindow||O.forceNewWindow)&&!O.forceReuseWindow;!O.forceNewWindow&&!O.forceReuseWindow&&(_==="on"||_==="off")&&(Z=_==="on");let V=!1;return O.forceNewWindow||O.forceReuseWindow?V=!!O.forceNewWindow&&!O.forceReuseWindow:(v.$j?O.context===1&&(V=!0):O.context!==3&&O.context!==2&&!(O.userEnv&&O.userEnv.TERM_PROGRAM==="vscode")&&(V=!0),!O.cli.extensionDevelopmentPath&&(se==="on"||se==="off")&&(V=se==="on")),{openFolderInNewWindow:!!Z,openFilesInNewWindow:V}}async openExtensionDevelopmentHostWindow(O,N){const _=(0,q.$U_b)(this.getWindows(),O);if(_)return this.H.reload(_,N.cli),_.focus(),[_];let se=N.cli["folder-uri"]||[],Z=N.cli["file-uri"]||[],V=N.cli._;if(!V.length&&!se.length&&!Z.length&&!N.cli.extensionTestsPath){const re=this.r.state.lastPluginDevelopmentHostWindow,ee=re?.workspace??re?.folderUri;ee&&(l.URI.isUri(ee)?ee.scheme===k.Schemas.file?V=[ee.fsPath]:se=[ee.toString()]:ee.configPath.scheme===k.Schemas.file?V=[(0,$.$Ig)(ee.configPath)]:Z=[ee.configPath.toString()])}let x=N.remoteAuthority;for(const re of O)if(re.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const ee=l.URI.parse(re),fe=(0,R.$sm)(ee);fe&&(x?(0,$.$Zg)(fe,x)||this.w.error("more than one extension development path authority"):x=fe)}V=V.filter(re=>{const ee=l.URI.file(re);return(0,q.$T_b)(this.getWindows(),ee)?!1:(0,$.$Zg)((0,R.$sm)(ee),x)}),se=se.filter(re=>{const ee=this.fb(re);return ee&&(0,q.$T_b)(this.getWindows(),ee)?!1:ee?(0,$.$Zg)((0,R.$sm)(ee),x):!1}),Z=Z.filter(re=>{const ee=this.fb(re);return ee&&(0,q.$T_b)(this.getWindows(),ee)?!1:ee?(0,$.$Zg)((0,R.$sm)(ee),x):!1}),N.cli._=V,N.cli["folder-uri"]=se,N.cli["file-uri"]=Z;const U={context:N.context,cli:N.cli,forceNewWindow:!0,forceEmpty:!V.length&&!se.length&&!Z.length,userEnv:N.userEnv,noRecentEntry:!0,waitMarkerFileURI:N.waitMarkerFileURI,remoteAuthority:x,forceProfile:N.forceProfile,forceTempProfile:N.forceTempProfile};return this.open(U)}async pb(O){const N=this.J.getValue("window"),_=this.getLastActiveWindow(),se=_?.profile??this.G.defaultProfile;let Z;!O.forceNewWindow&&!O.forceNewTabbedWindow&&(Z=O.windowToUse||_,Z&&Z.focus());const V={...this.F.args,...O.cli,machineId:this.s,sqmId:this.t,windowId:-1,mainPid:process.pid,appRoot:this.F.appRoot,execPath:process.execPath,codeCachePath:this.F.codeCachePath,backupPath:O.emptyWindowBackupInfo?(0,g.$kc)(this.F.backupHome,O.emptyWindowBackupInfo.backupFolder):void 0,profiles:{home:this.G.profilesHome,all:this.G.profiles,profile:se},homeDir:this.F.userHome.with({scheme:k.Schemas.file}).fsPath,tmpDir:this.F.tmpDir.with({scheme:k.Schemas.file}).fsPath,userDataDir:this.F.userDataPath,remoteAuthority:O.remoteAuthority,workspace:O.workspace,userEnv:{...this.u,...O.userEnv},filesToOpenOrCreate:O.filesToOpen?.filesToOpenOrCreate,filesToDiff:O.filesToOpen?.filesToDiff,filesToMerge:O.filesToOpen?.filesToMerge,filesToWait:O.filesToOpen?.filesToWait,logLevel:this.z.getLogLevel(),loggers:{window:[],global:this.z.getRegisteredLoggers()},logsPath:this.F.logsHome.with({scheme:k.Schemas.file}).fsPath,product:I.default,isInitialStartup:O.initialStartup,perfMarks:(0,m.getMarks)(),os:{release:(0,B.release)(),hostname:(0,B.hostname)(),arch:(0,B.arch)()},autoDetectHighContrast:N?.autoDetectHighContrast??!0,autoDetectColorScheme:N?.autoDetectColorScheme??!1,accessibilitySupport:n.app.accessibilitySupportEnabled,colorScheme:this.R.getColorScheme(),policiesData:this.D.serialize(),continueOn:this.F.continueOn};if(Z){const x=Z.config;!V.extensionDevelopmentPath&&x?.extensionDevelopmentPath&&(V.extensionDevelopmentPath=x.extensionDevelopmentPath,V.extensionDevelopmentKind=x.extensionDevelopmentKind,V["enable-proposed-api"]=x["enable-proposed-api"],V.verbose=x.verbose,V["inspect-extensions"]=x["inspect-extensions"],V["inspect-brk-extensions"]=x["inspect-brk-extensions"],V.debugId=x.debugId,V.extensionEnvironment=x.extensionEnvironment,V["extensions-dir"]=x["extensions-dir"],V["disable-extensions"]=x["disable-extensions"]),V.loggers={global:V.loggers.global,window:x?.loggers.window??V.loggers.window}}else{const x=this.r.getNewWindowState(V);(0,m.mark)("code/willCreateCodeWindow");const U=Z=this.N.createInstance(L.$5_b,{state:x,extensionDevelopmentPath:V.extensionDevelopmentPath,isExtensionTestHost:!!V.extensionTestsPath});(0,m.mark)("code/didCreateCodeWindow"),O.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(U),this.n.set(U.id,U),this.a.fire(U),this.f.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()});const re=new y.$Tc;re.add(U.onDidSignalReady(()=>this.b.fire(U))),re.add(h.Event.once(U.onDidClose)(()=>this.sb(U,re))),re.add(h.Event.once(U.onDidDestroy)(()=>this.tb(U))),re.add(U.onDidMaximize(()=>this.g.fire(U))),re.add(U.onDidUnmaximize(()=>this.h.fire(U))),re.add(U.onDidEnterFullScreen(()=>this.j.fire({window:U,fullscreen:!0}))),re.add(U.onDidLeaveFullScreen(()=>this.j.fire({window:U,fullscreen:!1}))),re.add(U.onDidTriggerSystemContextMenu(({x:fe,y:me})=>this.m.fire({window:U,x:fe,y:me})));const ee=(0,f.$6f)(U.win?.webContents);ee.removeAllListeners("devtools-reload-page"),ee.on("devtools-reload-page",()=>this.H.reload(U)),this.H.registerWindow(U)}return V.windowId=Z.id,Z.isReady?this.H.unload(Z,4).then(async x=>{x||await this.qb(Z,V,O,se)}):await this.qb(Z,V,O,se),Z}async qb(O,N,_,se){if(N.extensionDevelopmentPath||((0,le.$wi)(N.workspace)?N.backupPath=this.I.registerWorkspaceBackup({workspace:N.workspace,remoteAuthority:N.remoteAuthority}):(0,le.$ri)(N.workspace)?N.backupPath=this.I.registerFolderBackup({folderUri:N.workspace.uri,remoteAuthority:N.remoteAuthority}):N.backupPath=this.I.registerEmptyWindowBackup({backupFolder:_.emptyWindowBackupInfo?.backupFolder??(0,te.$Y_b)().id,remoteAuthority:N.remoteAuthority})),this.G.isEnabled()){const Z=N.workspace??(0,le.$vi)(N.backupPath,!1),V=this.rb(_,Z,se),x=V instanceof Promise?await V:V;N.profiles.profile=x,N.extensionDevelopmentPath||await this.G.setProfileForWorkspace(Z,x)}O.load(N)}rb(O,N,_){return O.forceProfile?this.G.profiles.find(se=>se.name===O.forceProfile)??this.G.createNamedProfile(O.forceProfile):O.forceTempProfile?this.G.createTransientProfile():this.G.getProfileForWorkspace(N)??_}sb(O,N){this.n.delete(O.id),this.f.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()}),N.dispose()}tb(O){this.n.delete(O.id),this.c.fire(O)}getFocusedWindow(){const O=n.BrowserWindow.getFocusedWindow();if(O)return this.getWindowById(O.id)}getLastActiveWindow(){return this.vb(this.getWindows())}ub(O){return this.vb(this.getWindows().filter(N=>(0,$.$Zg)(N.remoteAuthority,O)))}vb(O){return(0,W.$P_b)(O)}sendToFocused(O,...N){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(O,E.CancellationToken.None,...N)}sendToOpeningWindow(O,...N){this.B(h.Event.once(this.onDidSignalReadyWindow)(_=>{_.sendWhenReady(O,E.CancellationToken.None,...N)}))}sendToAll(O,N,_){for(const se of this.getWindows())_&&_.indexOf(se.id)>=0||se.sendWhenReady(O,E.CancellationToken.None,N)}getWindows(){return Array.from(this.n.values())}getWindowCount(){return this.n.size}getWindowById(O){return this.n.get(O)}getWindowByWebContents(O){const N=n.BrowserWindow.fromWebContents(O);if(N)return this.getWindowById(N.id)}};e.$dbc=he,e.$dbc=he=Ee([ne(3,b.$Nj),ne(4,F.$2_b),ne(5,C.$UP),ne(6,z.$2n),ne(7,r.$C_b),ne(8,M.$Q_b),ne(9,u.$7_b),ne(10,a.$H_b),ne(11,t.$Ni),ne(12,ue.$Lac),ne(13,X.$Z_b),ne(14,s.$gi),ne(15,o.$I_b),ne(16,i.$Nk),ne(17,D.$K_b),ne(18,Q.$L_b),ne(19,G.$yac)],he)}),define(oe[311],ae([0,1,65,29,84,58]),function(J,e,n,j,P,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fbc=void 0;let S=class{constructor(h,c,p,y){this.a=h,this.b=c,this.c=p,this.d=y,this.onDidChangeRecentlyOpened=this.c.onDidChangeRecentlyOpened}async enterWorkspace(h,c){const p=this.b.getWindowById(h);if(p)return this.a.enterWorkspace(p,this.b.getWindows(),c)}createUntitledWorkspace(h,c,p){return this.a.createUntitledWorkspace(c,p)}deleteUntitledWorkspace(h,c){return this.a.deleteUntitledWorkspace(c)}getWorkspaceIdentifier(h,c){return this.a.getWorkspaceIdentifier(c)}getRecentlyOpened(h){return this.c.getRecentlyOpened()}addRecentlyOpened(h,c){return this.c.addRecentlyOpened(c)}removeRecentlyOpened(h,c){return this.c.removeRecentlyOpened(c)}clearRecentlyOpened(h){return this.c.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.d.getDirtyWorkspaces()}};e.$fbc=S,e.$fbc=S=Ee([ne(0,B.$Z_b),ne(1,j.$N_b),ne(2,P.$Lac),ne(3,n.$H_b)],S)}),define(oe[312],ae([0,1,14,102,37,26,17,47,15,31,3,42,48,2,13,9,4,12,7,33,160,44,161,114,294,164,65,287,18,203,92,134,56,120,224,24,64,95,212,297,214,215,216,16,228,94,77,6,93,223,303,288,295,20,5,309,70,27,68,298,96,34,279,83,126,28,255,257,54,50,269,292,304,293,305,131,271,272,273,276,301,55,29,310,278,30,98,84,311,58,39,237,57,248,53,82,132,281,296,284,8,259,280,232,67,300,275,22,129,299,267,243,62,78,307]),function(J,e,n,j,P,B,S,E,h,c,p,y,k,g,m,v,w,$,f,l,d,a,t,o,r,i,s,u,b,I,D,R,C,A,L,W,q,H,le,te,ue,X,Q,z,M,F,G,T,ce,he,K,O,N,_,se,Z,V,x,U,re,ee,fe,me,ve,ke,je,We,ye,Y,de,$e,Se,Ae,qe,Be,Me,He,xe,Ze,Fe,ie,ge,pe,be,Pe,Oe,Te,Ke,Ye,Xe,Qe,st,tt,ot,at,yt,vt,kt,Et,Pt,ct,gt,St,It,jt,lt,Dt,$t,ut,Ct,Rt,ht,At,mt,Ot){"use strict";var ft;Object.defineProperty(e,"__esModule",{value:!0}),e.$ybc=void 0;let dt=class extends g.$Uc{static{ft=this}static{this.a={[m.Schemas.file]:"security.promptForLocalFileProtocolHandling",[m.Schemas.vscodeRemote]:"security.promptForRemoteFileProtocolHandling"}}constructor(Ie,De,Re,we,Ce,ze,Ue,Ge,Le,Ne,Ve,Je){super(),this.g=Ie,this.h=De,this.j=Re,this.m=we,this.n=Ce,this.s=ze,this.t=Ue,this.u=Ge,this.w=Le,this.y=Ne,this.z=Ve,this.C=Je,this.D(),this.F()}D(){const Ie=Le=>Le?.startsWith(`${m.Schemas.vscodeWebview}://`),De=new Set(["clipboard-read","clipboard-sanitized-write"]);n.session.defaultSession.setPermissionRequestHandler((Le,Ne,Ve,Je)=>Ie(Je.requestingUrl)?Ve(De.has(Ne)):Ve(!1)),n.session.defaultSession.setPermissionCheckHandler((Le,Ne,Ve,Je)=>Ie(Je.requestingUrl)?De.has(Ne):!1);const Re=new Set([m.Schemas.file,m.Schemas.vscodeFileResource,m.Schemas.vscodeRemoteResource,m.Schemas.vscodeManagedRemoteResource,"devtools"]),we=Le=>{for(let Ne=Le;Ne;Ne=Ne.parent)if(Ne.url.startsWith(`${m.Schemas.vscodeWebview}://`))return!0;return!1},Ce=Le=>Le.resourceType==="xhr"||we(Le.frame),ze=Le=>{const Ne=Le.frame;if(!Ne||!this.b)return!1;const Ve=n.BrowserWindow.getAllWindows();for(const Je of Ve)if(Ne.processId===Je.webContents.mainFrame.processId)return!0;return!1},Ue=(Le,Ne)=>{if(Le.path!=="/index.html")return!0;const Ve=Ne.frame;if(!Ve||!this.b)return!1;for(const Je of this.b.getWindows())if(Je.win&&Ve.processId===Je.win.webContents.mainFrame.processId)return!0;return!1};n.session.defaultSession.webRequest.onBeforeRequest((Le,Ne)=>{const Ve=f.URI.parse(Le.url);return Ve.scheme===m.Schemas.vscodeWebview&&!Ue(Ve,Le)?(this.m.error("Blocked vscode-webview request",Le.url),Ne({cancel:!0})):Ve.scheme===m.Schemas.vscodeFileResource&&!ze(Le)?(this.m.error("Blocked vscode-file request",Le.url),Ne({cancel:!0})):Ve.path.endsWith(".svg")&&!Re.has(Ve.scheme)?Ne({cancel:!Ce(Le)}):Ne({cancel:!1})}),n.session.defaultSession.webRequest.onHeadersReceived((Le,Ne)=>{const Ve=Le.responseHeaders,Je=Ve["content-type"]||Ve["Content-Type"];if(Je&&Array.isArray(Je)){const _e=f.URI.parse(Le.url);if(_e.path.endsWith(".svg")&&Re.has(_e.scheme))return Ve["Content-Type"]=["image/svg+xml"],Ne({cancel:!1,responseHeaders:Ve});if(!_e.path.endsWith(m.Schemas.vscodeRemoteResource)&&Je.some(it=>it.toLowerCase().includes("image/svg")))return Ne({cancel:!Ce(Le)})}return Ne({cancel:!1})}),n.session.defaultSession.webRequest.onHeadersReceived((Le,Ne)=>{if(Le.url.startsWith("https://vscode.download.prss.microsoft.com/")){const Ve=Le.responseHeaders??Object.create(null);if(Ve["Access-Control-Allow-Origin"]===void 0)return Ve["Access-Control-Allow-Origin"]=["*"],Ne({cancel:!1,responseHeaders:Ve})}return Ne({cancel:!1})});const Ge=n.session.defaultSession;typeof Ge.setCodeCachePath=="function"&&this.s.codeCachePath&&Ge.setCodeCachePath((0,v.$kc)(this.s.codeCachePath,"chrome")),w.$i&&(this.u.getValue("security.restrictUNCAccess")===!1?(0,j.disableUNCAccessRestrictions)():(0,j.addUNCHostToAllowlist)(this.u.getValue("security.allowedUNCHosts")))}F(){(0,h.setUnexpectedErrorHandler)(Re=>this.H(Re)),process.on("uncaughtException",Re=>{(0,h.$Z)(Re)||(0,h.$1)(Re)}),process.on("unhandledRejection",Re=>(0,h.$1)(Re)),this.t.onWillShutdown(()=>this.dispose()),(0,d.$3V)(),n.app.on("accessibility-support-changed",(Re,we)=>{this.b?.sendToAll("vscode:accessibilitySupportChanged",we)}),n.app.on("activate",async(Re,we)=>{this.m.trace("app#activate"),we||await this.b?.openEmptyWindow({context:1})}),n.app.on("web-contents-created",(Re,we)=>{we?.opener?.url.startsWith(`${m.Schemas.vscodeFileResource}://${m.$Ag}/`)&&(this.m.trace('[aux window]  app.on("web-contents-created"): Registering auxiliary window'),this.c?.registerWindow(we)),we.on("will-navigate",Ce=>{this.m.error("webContents#will-navigate: Prevented webcontent navigation"),Ce.preventDefault()}),we.setWindowOpenHandler(Ce=>Ce.url==="about:blank"?(this.m.trace("[aux window] webContents#setWindowOpenHandler: Allowing auxiliary window to open on about:blank"),{action:"allow",overrideBrowserWindowOptions:this.c?.createWindow(Ce)}):(this.m.trace(`webContents#setWindowOpenHandler: Prevented opening window with URL ${Ce.url}}`),this.f?.openExternal(void 0,Ce.url),{action:"deny"}))});let Ie=[],De;n.app.on("open-file",(Re,we)=>{this.m.trace("app#open-file: ",we),Re.preventDefault(),Ie.push((0,Oe.$Mi)(we)?{workspaceUri:f.URI.file(we)}:{fileUri:f.URI.file(we)}),De!==void 0&&(clearTimeout(De),De=void 0),De=setTimeout(async()=>{await this.b?.open({context:1,cli:this.s.args,urisToOpen:Ie,gotoLineMode:!1,preferNewWindow:!0}),Ie=[],De=void 0},100)}),n.app.on("new-window-for-tab",async()=>{await this.b?.openEmptyWindow({context:4})}),P.$2V.handle("vscode:fetchShellEnv",Re=>{const we=this.b?.getWindowByWebContents(Re.sender);let Ce,ze;return we?.config?(Ce=we.config,ze={...process.env,...we.config.userEnv}):(Ce=this.s.args,ze=process.env),this.X(Ce,ze,!1)}),P.$2V.handle("vscode:writeNlsFile",(Re,we,Ce)=>{const ze=this.G([we]);if(!ze||typeof Ce!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.y.writeFile(ze,S.$ue.fromString(Ce))}),P.$2V.handle("vscode:readNlsFile",async(Re,...we)=>{const Ce=this.G(we);if(!Ce)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.y.readFile(Ce)).value.toString()}),P.$2V.on("vscode:toggleDevTools",Re=>Re.sender.toggleDevTools()),P.$2V.on("vscode:openDevTools",Re=>Re.sender.openDevTools()),P.$2V.on("vscode:reloadWindow",Re=>Re.sender.reload()),P.$2V.handle("vscode:notifyZoomLevel",async(Re,we)=>{const Ce=this.b?.getWindowById(Re.sender.id);Ce&&Ce.notifyZoomLevel(we)})}G(Ie){let De;for(const Re of Ie)typeof Re=="string"&&(typeof De!="string"?De=Re:De=(0,v.$kc)(De,Re));if(!(typeof De!="string"||!(0,v.$jc)(De)||!(0,c.$hg)(De,this.s.cachedLanguagesPath,!w.$k)))return f.URI.file(De)}H(Ie){if(Ie){const De={message:`[uncaught exception in main]: ${Ie.message}`,stack:Ie.stack};this.b?.sendToFocused("vscode:reportError",JSON.stringify(De))}this.m.error(`[uncaught exception in main]: ${Ie}`),Ie.stack&&this.m.error(Ie.stack)}async startup(){this.m.debug("Starting VS Code"),this.m.debug(`from: ${this.s.appRoot}`),this.m.debug("args:",this.s.args);const Ie=this.z.win32AppUserModelId;w.$i&&Ie&&n.app.setAppUserModelId(Ie);try{w.$j&&this.u.getValue("window.nativeTabs")===!0&&!n.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&n.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Ne){this.m.error(Ne)}const De=new t.$9V;this.t.onWillShutdown(Ne=>{Ne.reason===2&&De.dispose()}),this.m.trace("Resolving machine identifier...");const[Re,we]=await Promise.all([(0,gt.$nbc)(this.w,this.m),(0,gt.$obc)(this.w,this.m)]);this.m.trace(`Resolved machine identifier: ${Re}`);const{sharedProcessReady:Ce,sharedProcessClient:ze}=this.P(Re,we),Ue=await this.Q(Re,we,Ce);this.B(Ue.createInstance(r.$eac)),this.B(Ue.createInstance(Et.$jbc)),Ue.invokeFunction(Ne=>this.R(Ne,De,ze));const Ge=await Ue.invokeFunction(Ne=>this.I(Ne,De));this.J(De),this.t.phase=2,await Ue.invokeFunction(Ne=>this.S(Ne,Ge)),this.t.phase=3,this.U(),this.B(new ct.$th(()=>{this.B((0,ct.$xh)(()=>this.t.phase=4,2500))},2500)).schedule()}async I(Ie,De){const Re=this.b=Ie.get(pe.$N_b),we=Ie.get(Me.$QW),Ce=this.f=Ie.get(V.$zac),ze=Ie.get(C.$I_b),Ue=this;we.registerHandler({async handleURL(_e,it){return Ue.O(Re,ze,we,_e,it)}});const Ge=this.B(new Pe.$ebc({onDidOpenMainWindow:Ce.onDidOpenMainWindow,onDidFocusMainWindow:Ce.onDidFocusMainWindow,getActiveWindowId:()=>Ce.getActiveWindowId(-1)})),Le=new a.$2h(_e=>Ge.getActiveClientId().then(it=>_e===it)),Ne=new He.$8ac(Le,this.m),Ve=De.getChannel("urlHandler",Ne);we.registerHandler(new He.$7ac(Ve));const Je=await this.L(Re,ze);return this.B(new Ze.$9ac(Je?.urls,we,Re,this.s,this.z,this.m)),Je}J(Ie){const De=()=>({statusCode:404,data:"Not found"}),Re=new At.$V(()=>Ie.getChannel(ht.$vbc,new ht.$wbc));n.protocol.registerBufferProtocol(m.Schemas.vscodeManagedRemoteResource,(we,Ce)=>{const ze=f.URI.parse(we.url);if(!ze.authority.startsWith("window:"))return Ce(De());Re.value.call(ht.$ubc,[ze]).then(Ue=>Ce({...Ue,data:Buffer.from(Ue.body,"base64")}),Ue=>{this.m.warn("error dispatching remote resource call",Ue),Ce({statusCode:500,data:String(Ue)})})})}async L(Ie,De){const Re=this.s.args["open-url"]?this.s.args._urls||[]:[];Re.length>0&&this.m.trace("app#resolveInitialProtocolUrls() protocol urls from command line:",Re);const we=global.getOpenUrls()||[];if(we.length>0&&this.m.trace("app#resolveInitialProtocolUrls() protocol urls from macOS 'open-url' event:",we),Re.length+we.length===0)return;const Ce=[...Re,...we].map(Ge=>{try{return{uri:f.URI.parse(Ge),originalUrl:Ge}}catch{this.m.trace("app#resolveInitialProtocolUrls() protocol url failed to parse:",Ge);return}}),ze=[],Ue=[];for(const Ge of Ce){if(!Ge)continue;const Le=this.N(Ge.uri);if(Le)if(await this.M(Le,Ie,De)){this.m.trace("app#resolveInitialProtocolUrls() protocol url was blocked:",Ge.uri.toString(!0));continue}else this.m.trace("app#resolveInitialProtocolUrls() protocol url will be handled as window to open:",Ge.uri.toString(!0),Le),ze.push(Le);else this.m.trace("app#resolveInitialProtocolUrls() protocol url will be passed to active window for handling:",Ge.uri.toString(!0)),Ue.push(Ge)}return{urls:Ue,openables:ze}}async M(Ie,De,Re){let we,Ce;if((0,ge.$aD)(Ie)?(we=Ie.workspaceUri,Ce=(0,i.localize)(0,null,we.scheme===m.Schemas.file?(0,k.$fw)(we,{os:w.OS,tildify:this.s}):we.toString(!0),this.z.nameShort)):(0,ge.$bD)(Ie)?(we=Ie.folderUri,Ce=(0,i.localize)(1,null,we.scheme===m.Schemas.file?(0,k.$fw)(we,{os:w.OS,tildify:this.s}):we.toString(!0),this.z.nameShort)):(we=Ie.fileUri,Ce=(0,i.localize)(2,null,we.scheme===m.Schemas.file?(0,k.$fw)(we,{os:w.OS,tildify:this.s}):we.toString(!0),this.z.nameShort)),we.scheme!==m.Schemas.file&&we.scheme!==m.Schemas.vscodeRemote||this.u.getValue(ft.a[we.scheme])===!1)return!1;const{response:Ue,checkboxChecked:Ge}=await Re.showMessageBox({type:"warning",buttons:[(0,i.localize)(3,null),(0,i.localize)(4,null)],message:Ce,detail:(0,i.localize)(5,null),checkboxLabel:we.scheme===m.Schemas.file?(0,i.localize)(6,null):(0,i.localize)(7,null),cancelId:1});if(Ue!==0)return!0;if(Ge){const Le={channel:"vscode:disablePromptForProtocolHandling",args:we.scheme===m.Schemas.file?"local":"remote"};De.sendToFocused(Le.channel,Le.args),De.sendToOpeningWindow(Le.channel,Le.args)}return!1}N(Ie){if(Ie.path){if(Ie.authority===m.Schemas.file){const De=f.URI.file(Ie.fsPath);return(0,Oe.$Mi)(De)?{workspaceUri:De}:{fileUri:De}}else if(Ie.authority===m.Schemas.vscodeRemote){const De=Ie.path.indexOf(v.$hc.sep,1);if(De!==-1){const Re=Ie.path.substring(1,De),we=Ie.path.substring(De);let Ce=Ie.query;const ze=new URLSearchParams(Ie.query);ze.get("windowId")==="_blank"&&(ze.delete("windowId"),Ce=ze.toString());const Ue=f.URI.from({scheme:m.Schemas.vscodeRemote,authority:Re,path:we,query:Ce,fragment:Ie.fragment});return(0,Oe.$Mi)(we)?{workspaceUri:Ue}:/:[\d]+$/.test(we)?{fileUri:Ue}:{folderUri:Ue}}}}}async O(Ie,De,Re,we,Ce){this.m.trace("app#handleProtocolUrl():",we.toString(!0),Ce),we.scheme===this.z.urlProtocol&&we.path==="workspace"&&(we=we.with({authority:"file",path:f.URI.parse(we.query).path,query:""}));let ze=!1;const Ue=new URLSearchParams(we.query);Ue.get("windowId")==="_blank"?(this.m.trace("app#handleProtocolUrl() found 'windowId=_blank' as parameter, setting shouldOpenInNewWindow=true:",we.toString(!0)),Ue.delete("windowId"),we=we.with({query:Ue.toString()}),ze=!0):w.$j&&Ie.getWindowCount()===0&&(this.m.trace("app#handleProtocolUrl() running on macOS with no window open, setting shouldOpenInNewWindow=true:",we.toString(!0)),ze=!0);const Ge=Ue.get("continueOn");Ge!==null&&(this.m.trace("app#handleProtocolUrl() found 'continueOn' as parameter:",we.toString(!0)),Ue.delete("continueOn"),we=we.with({query:Ue.toString()}),this.s.continueOn=Ge??void 0);const Le=this.N(we);return Le?await this.M(Le,Ie,De)?(this.m.trace("app#handleProtocolUrl() protocol url was blocked:",we.toString(!0)),!0):(this.m.trace("app#handleProtocolUrl() opening protocol url as window:",Le,we.toString(!0)),(0,$t.$Ob)(await Ie.open({context:5,cli:{...this.s.args},urisToOpen:[Le],forceNewWindow:ze,gotoLineMode:!0}))?.focus(),!0):ze?(this.m.trace("app#handleProtocolUrl() opening empty window and passing in protocol url:",we.toString(!0)),await(0,$t.$Ob)(await Ie.open({context:5,cli:{...this.s.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,U.$sm)(we)}))?.ready(),Re.open(we,Ce)):(this.m.trace("app#handleProtocolUrl(): not handled",we.toString(!0),Ce),!1)}P(Ie,De){const Re=this.B(this.j.createInstance(re.$Tac,Ie,De)),we=(async()=>{this.m.trace("Main->SharedProcess#connect");const ze=await Re.connect();return this.m.trace("Main->SharedProcess#connect: connection established"),new o.$0V(ze,"main")})();return{sharedProcessReady:(async()=>(await Re.whenReady(),we))(),sharedProcessClient:we}}async Q(Ie,De,Re){const we=new ce.$fi;switch(process.platform){case"win32":we.set(de.$1W,new G.$ei(Be.$5ac));break;case"linux":w.$l?we.set(de.$1W,new G.$ei(qe.$4ac,[process.env.SNAP,process.env.SNAP_REVISION])):we.set(de.$1W,new G.$ei(Ae.$3ac));break;case"darwin":we.set(de.$1W,new G.$ei(Se.$2ac));break}we.set(pe.$N_b,new G.$ei(be.$dbc,[Ie,De,this.h],!1)),we.set(mt.$yac,new G.$ei(Ot.$xbc,void 0,!1));const Ce=new C.$J_b(this.m,this.z);we.set(C.$I_b,Ce),we.set(N.$Fac,new G.$ei(N.$Gac,void 0,!1)),we.set(R.$kac,new G.$ei(R.$lac,void 0,!1)),we.set(D.$1m,a.ProxyChannel.toService((0,a.$Zh)(Re.then(Ne=>Ne.getChannel("diagnostics"))))),we.set(he.$ECb,new G.$ei(K.$Bac,[this.h])),we.set(A.$KW,new G.$ei(L.$mac)),we.set(O.$Cac,new G.$ei(O.$Dac)),we.set(V.$zac,new G.$ei(V.$Aac,void 0,!1)),we.set(Fe.$0ac,new G.$ei(ie.$_ac)),we.set(Z.$Oac,new G.$ei(Z.$Pac)),we.set(le.$nac,new G.$ei(te.$pac)),we.set(ve.$aac,new G.$ei(ve.$bac)),we.set(ve.$cac,new G.$ei(ve.$dac));const ze=new Ct.$tbc({graceTime:6e4,shortGraceTime:6e3,scrollback:this.u.getValue("terminal.integrated.persistentSessionScrollback")??100},this.u,this.s,this.t,this.m),Ue=new Rt.$es(ze,this.u,this.m,this.n);we.set(ut.$Rr,Ue),w.$i?we.set(ue.$qac,new G.$ei(X.$rac)):w.$j?we.set(ue.$qac,new G.$ei(X.$sac)):w.$k&&we.set(ue.$qac,new G.$ei(X.$tac));const Ge=new u.$fac(this.s,this.u,this.m,this.w);we.set(s.$H_b,Ge);const Le=new Xe.$1_b(this.s,this.m,this.C,Ge,Ce);if(we.set(Xe.$Z_b,Le),we.set(Te.$Beb,new G.$ei(Ye.$fbc,void 0,!1)),we.set(Ke.$Lac,new G.$ei(Ke.$Mac,void 0,!1)),we.set(Me.$QW,new G.$ei(xe.$SW,void 0,!1)),(0,Y.$0o)(this.z,this.s)){const Ne=(0,Y.$cp)(this.z,this.u),Ve=(0,a.$Zh)(Re.then(rt=>rt.getChannel("telemetryAppender"))),Je=new We.$Wac(Ve),_e=(0,ke.$1o)((0,B.release)(),(0,B.hostname)(),process.arch,this.z.commit,this.z.version,Ie,De,Ne),it=(0,Y.$dp)(this.s),nt={appenders:[Je],commonProperties:_e,piiPaths:it,sendErrorTelemetry:!0};we.set(je.$Ml,new G.$ei(ye.$Ir,[nt],!1))}else we.set(je.$Ml,Y.$5o);return we.set(yt.$aq,new G.$ei(St.$2P,void 0,!0)),we.set(vt.$eq,new G.$ei(kt.$ibc,void 0,!0)),we.set(lt.$rbc,new G.$ei(lt.$sbc,void 0,!0)),await ct.Promises.settled([Ge.initialize(),Le.initialize()]),this.j.createChild(we)}R(Ie,De,Re){const we=this.B(new g.$Tc),Ce=a.ProxyChannel.fromService(Ie.get(N.$Fac),we,{disableMarshalling:!0});this.g.registerChannel("launch",Ce);const ze=a.ProxyChannel.fromService(Ie.get(R.$kac),we,{disableMarshalling:!0});this.g.registerChannel("diagnostics",ze);const Ue=new st.$gbc(Ie.get(Qe.$2n));De.registerChannel("policy",Ue),Re.then(et=>et.registerChannel("policy",Ue));const Ge=this.y.getProvider(m.Schemas.file);(0,$.$5f)(Ge instanceof F.$Uq);const Le=new M.$uac(Ge,this.m,this.s);De.registerChannel(Q.$KP,Le),Re.then(et=>et.registerChannel(Q.$KP,Le));const Ne=a.ProxyChannel.fromService(Ie.get(tt.$Q_b),we);De.registerChannel("userDataProfiles",Ne),Re.then(et=>et.registerChannel("userDataProfiles",Ne));const Ve=new ot.$Dr(Ie.get(at.$yp));Re.then(et=>et.registerChannel("request",Ve));const Je=new $e.$Xac(Ie.get(de.$1W));De.registerChannel("update",Je);const _e=a.ProxyChannel.fromService(Ie.get(he.$ECb),we);De.registerChannel("issue",_e);const it=a.ProxyChannel.fromService(Ie.get(A.$KW),we);De.registerChannel("encryption",it);const nt=a.ProxyChannel.fromService(Ie.get(ee.$Al),we);De.registerChannel("sign",nt);const rt=a.ProxyChannel.fromService(Ie.get(O.$Cac),we);De.registerChannel("keyboardLayout",rt),this.f=Ie.get(V.$zac);const wt=a.ProxyChannel.fromService(this.f,we);De.registerChannel("nativeHost",wt),Re.then(et=>et.registerChannel("nativeHost",wt));const Bt=a.ProxyChannel.fromService(Ie.get(Te.$Beb),we);De.registerChannel("workspaces",Bt);const Mt=a.ProxyChannel.fromService(Ie.get(Z.$Oac),we);De.registerChannel("menubar",Mt);const Lt=a.ProxyChannel.fromService(Ie.get(Me.$QW),we);De.registerChannel("url",Lt);const Wt=a.ProxyChannel.fromService(Ie.get(Fe.$0ac),we);De.registerChannel("webview",Wt);const pt=this.B(new me.$Uac(this.m,Ie.get(ve.$aac)));De.registerChannel("storage",pt),Re.then(et=>et.registerChannel("storage",pt));const Nt=this.B(new Pt.$kbc(Ie.get(ve.$aac),Ie.get(tt.$Q_b),this.m));Re.then(et=>et.registerChannel("profileStorageListener",Nt));const Ft=a.ProxyChannel.fromService(Ie.get(ut.$Rr),we);De.registerChannel(ut.TerminalIpcChannels.LocalPty,Ft);const Tt=a.ProxyChannel.fromService(Ie.get(ue.$qac),we);De.registerChannel("externalTerminal",Tt);const bt=new It.$pbc(Ie.get(jt.$2_b));De.registerChannel("logger",bt),Re.then(et=>et.registerChannel("logger",bt));const zt=new I.$gac(Ie.get(pe.$N_b));De.registerChannel("extensionhostdebugservice",zt);const qt=a.ProxyChannel.fromService(Ie.get(le.$nac),we);De.registerChannel(le.$oac,qt);const Ut=a.ProxyChannel.fromService(Ie.get(lt.$rbc),we);De.registerChannel(Dt.$qbc,Ut)}async S(Ie,De){const Re=this.b=Ie.get(pe.$N_b);this.c=Ie.get(mt.$yac);const we=(0,q.$lm)(process.env)?0:4,Ce=this.s.args;if(De){if(De.openables.length>0)return Re.open({context:we,cli:Ce,urisToOpen:De.openables,gotoLineMode:!0,initialStartup:!0});if(De.urls.length>0)for(const nt of De.urls){const rt=new URLSearchParams(nt.uri.query);if(rt.get("windowId")==="_blank")return rt.delete("windowId"),nt.originalUrl=nt.uri.toString(!0),nt.uri=nt.uri.with({query:rt.toString()}),Re.open({context:we,cli:Ce,forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,initialStartup:!0})}}const ze=global.macOpenFiles,Ue=Ce._.length,Ge=!!Ce["folder-uri"],Le=!!Ce["file-uri"],Ne=Ce["skip-add-to-recently-opened"]===!0,Ve=Ce.wait&&Ce.waitMarkerFilePath?f.URI.file(Ce.waitMarkerFilePath):void 0,Je=Ce.remote||void 0,_e=Ce.profile,it=Ce["profile-temp"];if(!Ue&&!Ge&&!Le){if(Ce["new-window"]||_e||it)return Re.open({context:we,cli:Ce,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:Ne,waitMarkerFileURI:Ve,initialStartup:!0,remoteAuthority:Je,forceProfile:_e,forceTempProfile:it});if(ze.length)return Re.open({context:1,cli:Ce,urisToOpen:ze.map(nt=>(0,Oe.$Mi)(nt)?{workspaceUri:f.URI.file(nt)}:{fileUri:f.URI.file(nt)}),noRecentEntry:Ne,waitMarkerFileURI:Ve,initialStartup:!0})}return Re.open({context:we,cli:Ce,forceNewWindow:Ce["new-window"]||!Ue&&Ce["unity-launch"],diffMode:Ce.diff,mergeMode:Ce.merge,noRecentEntry:Ne,waitMarkerFileURI:Ve,gotoLineMode:Ce.goto,initialStartup:!0,remoteAuthority:Je,forceProfile:_e,forceTempProfile:it})}U(){this.W(),n.protocol.registerHttpProtocol(m.Schemas.vscodeRemoteResource,(Ie,De)=>{De({url:Ie.url.replace(/^vscode-remote-resource:/,"http:"),method:Ie.method})}),this.X(this.s.args,process.env,!0),this.Y(),w.$j&&n.app.runningUnderARM64Translation&&this.b?.sendToFocused("vscode:showTranslatedBuildWarning")}async W(){const Ie=this.z.win32MutexName;if(w.$i&&Ie)try{const De=await new Promise((we,Ce)=>{J(["@vscode/windows-mutex"],we,Ce)}),Re=new De.Mutex(Ie);p.Event.once(this.t.onWillShutdown)(()=>Re.release())}catch(De){this.m.error(De)}}async X(Ie,De,Re){try{return await(0,H.$rm)(this.u,this.m,Ie,De)}catch(we){const Ce=(0,E.$5i)(we);Re?this.b?.sendToFocused("vscode:showResolveShellEnvError",Ce):this.m.error(Ce)}return{}}async Y(){try{const De=(await this.y.readFile(this.s.argvResource)).value.toString(),Re=JSON.parse((0,y.$Cn)(De)),Ce=(0,Y.$_o)(this.u)>=1;if(Re["enable-crash-reporter"]===void 0){const ze=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Ce},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,l.$Dg)()}"`,"}"],Ue=De.substring(0,De.length-2).concat(`,
`,ze.join(`
`));await this.y.writeFile(this.s.argvResource,S.$ue.fromString(Ue))}else{const ze=De.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${Ce},`);ze!==De&&await this.y.writeFile(this.s.argvResource,S.$ue.fromString(ze))}}catch(Ie){this.m.error(Ie)}}};e.$ybc=dt,e.$ybc=dt=ft=Ee([ne(2,T.$gi),ne(3,se.$Nj),ne(4,se.$Oj),ne(5,W.$C_b),ne(6,_.$7_b),ne(7,b.$Ni),ne(8,fe.$UP),ne(9,z.$Nk),ne(10,x.$7j),ne(11,tt.$Q_b)],dt)}),define(oe[317],ae([0,1,14,43,7,22,8,47,15,31,3,48,13,9,66,4,36,25,21,44,100,312,10,18,242,254,24,64,205,16,226,94,77,222,93,20,229,5,79,27,80,282,130,291,53,290,96,253,34,54,69,57,39,238,236,2,40,270,67,231,119,125,274,102,268]),function(J,e,n,j,P,B,S,E,h,c,p,y,k,g,m,v,w,$,f,l,d,a,t,o,r,i,s,u,b,I,D,R,C,A,L,W,q,H,le,te,ue,X,Q,z,M,F,G,T,ce,he,K,O,N,_,se,Z,V,x,U,re,ee,fe,me,ve){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class ke{main(){try{this.a()}catch(ye){console.error(ye.message),n.app.exit(1)}}async a(){(0,h.setUnexpectedErrorHandler)(Me=>console.error(Me));const[ye,Y,de,$e,Se,Ae,qe,Be]=this.b();try{try{await this.d(de,Be,$e,Se,qe)}catch(Me){throw this.g(de,qe,Me),Me}await ye.invokeFunction(async Me=>{const He=Me.get(H.$Nj),xe=Me.get(W.$7_b),Ze=Me.get(I.$Nk),Fe=Me.get(H.$Oj),ie=await this.f(He,de,xe,ye,qe,!0);return f.Promises.writeFile(de.mainLockfile,String(process.pid)).catch(ge=>{He.warn(`app#startup(): Error writing main lockfile: ${ge.stack}`)}),Ae.logger=Fe.createLogger("main",{name:(0,t.localize)(0,null)}),p.Event.once(xe.onWillShutdown)(ge=>{Ze.dispose(),$e.dispose(),ge.join("instanceLockfile",f.Promises.unlink(de.mainLockfile).catch(()=>{}))}),ye.createInstance(a.$ybc,ie,Y).startup()})}catch(Me){ye.invokeFunction(this.j,Me)}}b(){const ye=new L.$fi,Y=new Z.$Tc;process.once("exit",()=>Y.dispose());const de={_serviceBrand:void 0,...le.default};ye.set(te.$7j,de);const $e=new s.$D_b(this.k(),de),Se=this.c($e);ye.set(s.$C_b,$e);const Ae=new U.$3_b((0,H.$2j)($e),$e.logsHome);ye.set(U.$2_b,Ae);const qe=new q.$i0b(Ae.getLogLevel()),Be=Y.add(new re.$3P(qe,[new H.$Uj(Ae.getLogLevel())]));ye.set(H.$Nj,Be);const Me=new D.$tq(Be);ye.set(I.$Nk,Me);const He=new R.$Uq(Be);Me.registerProvider(k.Schemas.file,He);const xe=new x.$is(Me);ye.set(V.$ll,xe);const Ze=new fe.$XP(1,$e,Be,Me);ye.set(ce.$TP,Ze),ye.set(ce.$UP,Ze);const Fe=new O.$R_b(Ze,xe,$e,Me,Be);ye.set(O.$Q_b,Fe),Me.registerProvider(k.Schemas.vscodeUserData,new me.$Jbc(k.Schemas.file,He,k.Schemas.vscodeUserData,Fe,xe,Be));const ie=v.$i&&de.win32RegValueName?Y.add(new _.$Hbc(Be,de.win32RegValueName)):$e.policyFile?Y.add(new se.$Ibc($e.policyFile,Me,Be)):new N.$4n;ye.set(N.$2n,ie);const ge=new r.$ro(Fe.defaultProfile.settingsResource,Me,ie,Be);return ye.set(o.$Ni,ge),ye.set(W.$7_b,new C.$ei(W.$8_b,void 0,!1)),ye.set(M.$yp,new C.$ei(F.$Fbc,void 0,!0)),ye.set(K.$L_b,new C.$ei(K.$M_b)),ye.set(G.$Al,new C.$ei(T.$Gbc,void 0,!1)),ye.set(Q.$Vv,new C.$ei(z.$Dbc)),ye.set(ue.$K_b,new X.$Abc($e,Fe,Be)),[new A.$Xq(ye,!0),Se,$e,ge,Ze,qe,de,Fe]}c(ye){const Y={VSCODE_IPC_HOOK:ye.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(de=>{const $e=process.env[de];typeof $e=="string"&&(Y[de]=$e)}),Object.assign(process.env,Y),Y}async d(ye,Y,de,$e,Se){await S.Promises.settled([Promise.all([this.e(ye.extensionsPath),ye.codeCachePath,ye.logsHome.with({scheme:k.Schemas.file}).fsPath,Y.defaultProfile.globalStorageHome.with({scheme:k.Schemas.file}).fsPath,ye.workspaceStorageHome.with({scheme:k.Schemas.file}).fsPath,ye.localHistoryHome.with({scheme:k.Schemas.file}).fsPath,ye.backupHome].map(Ae=>Ae?f.Promises.mkdir(Ae,{recursive:!0}):void 0)),$e.init(),de.initialize()]),Y.init()}e(ye){if(v.$i){const Y=(0,ve.getUNCHost)(ye);Y&&(0,ve.addUNCHostToAllowlist)(Y)}return ye}async f(ye,Y,de,$e,Se,Ae){let qe;try{(0,m.mark)("code/willStartMainServer"),qe=await(0,d.$ci)(Y.mainIPCHandle),(0,m.mark)("code/didStartMainServer"),p.Event.once(de.onWillShutdown)(()=>qe.dispose())}catch(Be){if(Be.code!=="EADDRINUSE")throw this.g(Y,Se,Be),Be;let Me;try{Me=await(0,d.$di)(Y.mainIPCHandle,"main")}catch(Fe){if(!Ae||v.$i||Fe.code!=="ECONNREFUSED")throw Fe.code==="EPERM"&&this.h((0,t.localize)(1,null,Se.nameShort),(0,t.localize)(2,null),Se),Fe;try{(0,j.unlinkSync)(Y.mainIPCHandle)}catch(ie){throw ye.warn("Could not delete obsolete instance handle",ie),ie}return this.f(ye,Y,de,$e,Se,!1)}if(Y.extensionTestsLocationURI&&!Y.debugExtensionHost.break){const Fe=`Running extension tests from the command line is currently only supported if no other instance of ${Se.nameShort} is running.`;throw ye.error(Fe),Me.dispose(),new Error(Fe)}let He;!Y.args.wait&&!Y.args.status&&(He=setTimeout(()=>{this.h((0,t.localize)(3,null,Se.nameShort),(0,t.localize)(4,null),Se)},1e4));const xe=l.ProxyChannel.toService(Me.getChannel("launch"),{disableMarshalling:!0}),Ze=l.ProxyChannel.toService(Me.getChannel("diagnostics"),{disableMarshalling:!0});if(Y.args.status)return $e.invokeFunction(async()=>{const Fe=new i.$ps(he.$5o,Se),ie=await Ze.getMainDiagnostics(),ge=await Ze.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),pe=await Fe.getDiagnostics(ie,ge);throw console.log(pe),new h.$ab});throw v.$i&&await this.i(xe,ye),ye.trace("Sending env to running instance..."),await xe.start(Y.args,process.env),Me.dispose(),He&&clearTimeout(He),new h.$ab("Sent env to running instance. Terminating...")}if(Y.args.status)throw console.log((0,t.localize)(5,null,Se.nameShort)),new h.$ab("Terminating...");return process.env.VSCODE_PID=String(process.pid),qe}g(ye,Y,de){if(de.code==="EACCES"||de.code==="EPERM"){const $e=(0,B.$Hb)([ye.userDataPath,ye.extensionsPath,d.$$h]).map(Se=>(0,y.$fw)(P.URI.file(Se),{os:v.OS,tildify:ye}));this.h((0,t.localize)(6,null),(0,t.localize)(7,null,(0,E.$5i)(de),$e.join(`
`)),Y)}}h(ye,Y,de){n.dialog.showMessageBoxSync((0,ee.$tw)({type:"warning",buttons:[(0,t.localize)(8,null)],message:ye,detail:Y},de).options)}async i(ye,Y){if(v.$i){const de=await ye.getMainProcessId();Y.trace("Sending some foreground love to the running instance:",de);try{(await new Promise(($e,Se)=>{J(["windows-foreground-love"],$e,Se)})).allowSetForegroundWindow(de)}catch($e){Y.error($e)}}}j(ye,Y){const de=ye.get(H.$Nj),$e=ye.get(W.$7_b);let Se=0;Y&&(Y.isExpected?Y.message&&de.trace(Y.message):(Se=1,Y.stack?de.error(Y.stack):de.error(`Startup error: ${Y.toString()}`))),$e.kill(Se)}k(){const ye=this.l((0,u.$im)(process.argv));if(ye.wait&&!ye.waitMarkerFilePath){const Y=(0,b.$zbc)(ye.verbose);Y&&((0,u.$km)(process.argv,"--waitMarkerFilePath",Y),ye.waitMarkerFilePath=Y)}return ye}l(ye){if(ye["open-url"]&&(ye._urls=ye._,ye._=[]),!ye.remote){const Y=this.m(ye._,ye.goto);ye._=Y}return ye}m(ye,Y){const de=(0,w.cwd)(),$e=ye.map(qe=>{let Be=String(qe),Me;Y&&(Me=(0,c.$og)(Be),Be=Me.path),Be&&(Be=this.n(de,Be));const He=(0,c.$jg)(Be,de),xe=(0,g.$oc)(He);return xe&&!(0,c.$fg)(xe)?null:Y&&Me?(Me.path=He,this.o(Me)):He}),Se=v.$i||v.$j,Ae=(0,B.$Mb)($e,qe=>qe&&Se?qe.toLowerCase():qe||"");return(0,B.$Hb)(Ae)}n(ye,Y){return v.$i&&(Y=(0,$.$6e)(Y,'"')),Y=(0,$.$4e)((0,$.$4e)(Y," "),"	"),v.$i&&(Y=(0,g.$lc)(ye,Y),Y=(0,$.$6e)(Y,".")),Y}o(ye){const Y=[ye.path];return typeof ye.line=="number"&&Y.push(String(ye.line)),typeof ye.column=="number"&&Y.push(String(ye.column)),Y.join(":")}}new ke().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/be210b3a60c7d60030c1d3d92da00d008edf6ab9/core/vs/code/electron-main/main.js.map
