/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var be=["exports","require","vs/base/browser/dom","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/base/common/errors","vs/base/common/types","vs/css!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/async","vs/base/common/strings","vs/nls!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/arrays","vs/nls","vs/base/browser/ui/hover/hoverDelegateFactory","vs/base/browser/keyboardEvent","vs/base/common/uri","vs/base/browser/browser","vs/base/common/codicons","vs/base/common/themables","vs/base/browser/mouseEvent","vs/base/browser/ui/widget","vs/base/browser/window","vs/base/common/lazy","vs/base/browser/event","vs/base/common/path","vs/base/browser/touch","vs/base/browser/ui/tree/tree","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/cancellation","vs/base/parts/sandbox/electron-sandbox/globals","vs/base/common/network","vs/base/browser/ui/hover/updatableHoverWidget","vs/base/common/map","vs/base/common/numbers","vs/base/common/buffer","vs/base/common/filters","vs/base/common/codiconsUtil","vs/base/common/iconLabels","vs/base/common/actions","vs/base/common/resources","vs/base/browser/ui/scrollbar/scrollbarArrow","vs/base/browser/ui/list/listWidget","vs/platform/instantiation/common/instantiation","vs/base/browser/fastDomNode","vs/base/browser/ui/scrollbar/scrollbarState","vs/base/common/functional","vs/base/common/keyCodes","vs/base/common/linkedList","vs/base/common/range","vs/base/common/scrollable","vs/base/common/hash","vs/base/common/symbols","vs/base/common/objects","vs/css!vs/base/browser/ui/actionbar/actionbar","vs/base/common/marshalling","vs/base/browser/dnd","vs/base/browser/formattedTextRenderer","vs/base/browser/globalPointerMoveMonitor","vs/base/browser/ui/aria/aria","vs/base/browser/ui/tree/indexTreeModel","vs/base/browser/ui/scrollbar/abstractScrollbar","vs/base/browser/ui/scrollbar/scrollableElement","vs/base/browser/ui/list/listView","vs/base/common/htmlContent","vs/base/browser/ui/actionbar/actionViewItems","vs/base/browser/ui/actionbar/actionbar","vs/base/browser/ui/inputbox/inputBox","vs/base/browser/ui/toggle/toggle","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/browser/iframe","vs/base/browser/ui/list/list","vs/base/browser/ui/list/splice","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/assert","vs/base/common/idGenerator","vs/base/common/keybindings","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/navigator","vs/base/common/history","vs/base/browser/ui/list/rangeMap","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/stream","vs/base/common/diff/diff","vs/base/common/ternarySearchTree","vs/base/common/codiconsLibrary","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-sandbox/contextmenu","vs/css!vs/base/browser/ui/aria/aria","vs/css!vs/base/browser/ui/codicons/codicon/codicon","vs/css!vs/base/browser/ui/codicons/codicon/codicon-modifiers","vs/base/browser/ui/codicons/codiconStyles","vs/css!vs/base/browser/ui/findinput/findInput","vs/css!vs/base/browser/ui/inputbox/inputBox","vs/css!vs/base/browser/ui/list/list","vs/css!vs/base/browser/ui/scrollbar/media/scrollbars","vs/css!vs/base/browser/ui/selectBox/selectBox","vs/css!vs/base/browser/ui/selectBox/selectBoxCustom","vs/css!vs/base/browser/ui/toggle/toggle","vs/css!vs/base/browser/ui/tree/media/tree","vs/css!vs/code/electron-sandbox/processExplorer/media/processExplorer","vs/nls!vs/base/browser/ui/actionbar/actionViewItems","vs/nls!vs/base/browser/ui/findinput/findInput","vs/nls!vs/base/browser/ui/findinput/findInputToggles","vs/nls!vs/base/browser/ui/hover/updatableHoverWidget","vs/nls!vs/base/browser/ui/inputbox/inputBox","vs/nls!vs/base/browser/ui/selectBox/selectBoxCustom","vs/nls!vs/base/browser/ui/tree/abstractTree","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/platform","vs/base/browser/canIUse","vs/base/common/process","vs/base/common/extpath","vs/base/common/mime","vs/base/browser/dompurify/dompurify","vs/base/browser/ui/iconLabel/iconLabels","vs/base/browser/ui/list/rowCache","vs/base/browser/ui/scrollbar/scrollbarVisibilityController","vs/base/browser/ui/selectBox/selectBoxNative","vs/base/browser/ui/tree/objectTreeModel","vs/base/browser/ui/scrollbar/horizontalScrollbar","vs/base/browser/ui/scrollbar/verticalScrollbar","vs/base/browser/markdownRenderer","vs/base/browser/ui/selectBox/selectBoxCustom","vs/base/browser/ui/selectBox/selectBox","vs/base/browser/ui/findinput/findInputToggles","vs/base/browser/ui/findinput/findInput","vs/base/browser/ui/tree/abstractTree","vs/base/browser/ui/tree/dataTree","vs/base/parts/ipc/electron-sandbox/ipc.electron","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/theme/common/iconRegistry","vs/platform/diagnostics/common/diagnostics","vs/platform/files/common/files","vs/platform/ipc/common/mainProcessService","vs/platform/ipc/electron-sandbox/mainProcessService","vs/platform/native/common/nativeHostService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/theme/common/iconRegistry","vs/platform/theme/browser/iconsStyleSheet","vs/platform/window/common/window","vs/platform/window/electron-sandbox/window","vs/code/electron-sandbox/processExplorer/processExplorerMain"],$e=function(ne){for(var t=[],i=0,N=ne.length;i<N;i++)t[i]=be[ne[i]];return t};/*! @license DOMPurify 3.0.5 | (c) Cure53 and other contributors | Released under the Apache license 2.0 and Mozilla Public License 2.0 | github.com/cure53/DOMPurify/blob/3.0.5/LICENSE */const{entries:Ot,setPrototypeOf:xt,isFrozen:ii,getPrototypeOf:si,getOwnPropertyDescriptor:ni}=Object;let{freeze:ot,seal:ft,create:ri}=Object,{apply:Nt,construct:Ct}=typeof Reflect<"u"&&Reflect;Nt||(Nt=function(t,i,N){return t.apply(i,N)}),ot||(ot=function(t){return t}),ft||(ft=function(t){return t}),Ct||(Ct=function(t,i){return new t(...i)});const oi=ct(Array.prototype.forEach),zt=ct(Array.prototype.pop),wt=ct(Array.prototype.push),yt=ct(String.prototype.toLowerCase),Rt=ct(String.prototype.toString),li=ct(String.prototype.match),dt=ct(String.prototype.replace),ai=ct(String.prototype.indexOf),hi=ct(String.prototype.trim),ht=ct(RegExp.prototype.test),vt=ui(TypeError);function ct(ne){return function(t){for(var i=arguments.length,N=new Array(i>1?i-1:0),z=1;z<i;z++)N[z-1]=arguments[z];return Nt(ne,t,N)}}function ui(ne){return function(){for(var t=arguments.length,i=new Array(t),N=0;N<t;N++)i[N]=arguments[N];return Ct(ne,i)}}function He(ne,t,i){var N;i=(N=i)!==null&&N!==void 0?N:yt,xt&&xt(ne,null);let z=t.length;for(;z--;){let H=t[z];if(typeof H=="string"){const E=i(H);E!==H&&(ii(t)||(t[z]=E),H=E)}ne[H]=!0}return ne}function bt(ne){const t=ri(null);for(const[i,N]of Ot(ne))t[i]=N;return t}function Et(ne,t){for(;ne!==null;){const N=ni(ne,t);if(N){if(N.get)return ct(N.get);if(typeof N.value=="function")return ct(N.value)}ne=si(ne)}function i(N){return console.warn("fallback value for",N),null}return i}const Ht=ot(["a","abbr","acronym","address","area","article","aside","audio","b","bdi","bdo","big","blink","blockquote","body","br","button","canvas","caption","center","cite","code","col","colgroup","content","data","datalist","dd","decorator","del","details","dfn","dialog","dir","div","dl","dt","element","em","fieldset","figcaption","figure","font","footer","form","h1","h2","h3","h4","h5","h6","head","header","hgroup","hr","html","i","img","input","ins","kbd","label","legend","li","main","map","mark","marquee","menu","menuitem","meter","nav","nobr","ol","optgroup","option","output","p","picture","pre","progress","q","rp","rt","ruby","s","samp","section","select","shadow","small","source","spacer","span","strike","strong","style","sub","summary","sup","table","tbody","td","template","textarea","tfoot","th","thead","time","tr","track","tt","u","ul","var","video","wbr"]),Lt=ot(["svg","a","altglyph","altglyphdef","altglyphitem","animatecolor","animatemotion","animatetransform","circle","clippath","defs","desc","ellipse","filter","font","g","glyph","glyphref","hkern","image","line","lineargradient","marker","mask","metadata","mpath","path","pattern","polygon","polyline","radialgradient","rect","stop","style","switch","symbol","text","textpath","title","tref","tspan","view","vkern"]),It=ot(["feBlend","feColorMatrix","feComponentTransfer","feComposite","feConvolveMatrix","feDiffuseLighting","feDisplacementMap","feDistantLight","feDropShadow","feFlood","feFuncA","feFuncB","feFuncG","feFuncR","feGaussianBlur","feImage","feMerge","feMergeNode","feMorphology","feOffset","fePointLight","feSpecularLighting","feSpotLight","feTile","feTurbulence"]),ci=ot(["animate","color-profile","cursor","discard","font-face","font-face-format","font-face-name","font-face-src","font-face-uri","foreignobject","hatch","hatchpath","mesh","meshgradient","meshpatch","meshrow","missing-glyph","script","set","solidcolor","unknown","use"]),Mt=ot(["math","menclose","merror","mfenced","mfrac","mglyph","mi","mlabeledtr","mmultiscripts","mn","mo","mover","mpadded","mphantom","mroot","mrow","ms","mspace","msqrt","mstyle","msub","msup","msubsup","mtable","mtd","mtext","mtr","munder","munderover","mprescripts"]),fi=ot(["maction","maligngroup","malignmark","mlongdiv","mscarries","mscarry","msgroup","mstack","msline","msrow","semantics","annotation","annotation-xml","mprescripts","none"]),Wt=ot(["#text"]),Vt=ot(["accept","action","align","alt","autocapitalize","autocomplete","autopictureinpicture","autoplay","background","bgcolor","border","capture","cellpadding","cellspacing","checked","cite","class","clear","color","cols","colspan","controls","controlslist","coords","crossorigin","datetime","decoding","default","dir","disabled","disablepictureinpicture","disableremoteplayback","download","draggable","enctype","enterkeyhint","face","for","headers","height","hidden","high","href","hreflang","id","inputmode","integrity","ismap","kind","label","lang","list","loading","loop","low","max","maxlength","media","method","min","minlength","multiple","muted","name","nonce","noshade","novalidate","nowrap","open","optimum","pattern","placeholder","playsinline","poster","preload","pubdate","radiogroup","readonly","rel","required","rev","reversed","role","rows","rowspan","spellcheck","scope","selected","shape","size","sizes","span","srclang","start","src","srcset","step","style","summary","tabindex","title","translate","type","usemap","valign","value","width","xmlns","slot"]),jt=ot(["accent-height","accumulate","additive","alignment-baseline","ascent","attributename","attributetype","azimuth","basefrequency","baseline-shift","begin","bias","by","class","clip","clippathunits","clip-path","clip-rule","color","color-interpolation","color-interpolation-filters","color-profile","color-rendering","cx","cy","d","dx","dy","diffuseconstant","direction","display","divisor","dur","edgemode","elevation","end","fill","fill-opacity","fill-rule","filter","filterunits","flood-color","flood-opacity","font-family","font-size","font-size-adjust","font-stretch","font-style","font-variant","font-weight","fx","fy","g1","g2","glyph-name","glyphref","gradientunits","gradienttransform","height","href","id","image-rendering","in","in2","k","k1","k2","k3","k4","kerning","keypoints","keysplines","keytimes","lang","lengthadjust","letter-spacing","kernelmatrix","kernelunitlength","lighting-color","local","marker-end","marker-mid","marker-start","markerheight","markerunits","markerwidth","maskcontentunits","maskunits","max","mask","media","method","mode","min","name","numoctaves","offset","operator","opacity","order","orient","orientation","origin","overflow","paint-order","path","pathlength","patterncontentunits","patterntransform","patternunits","points","preservealpha","preserveaspectratio","primitiveunits","r","rx","ry","radius","refx","refy","repeatcount","repeatdur","restart","result","rotate","scale","seed","shape-rendering","specularconstant","specularexponent","spreadmethod","startoffset","stddeviation","stitchtiles","stop-color","stop-opacity","stroke-dasharray","stroke-dashoffset","stroke-linecap","stroke-linejoin","stroke-miterlimit","stroke-opacity","stroke","stroke-width","style","surfacescale","systemlanguage","tabindex","targetx","targety","transform","transform-origin","text-anchor","text-decoration","text-rendering","textlength","type","u1","u2","unicode","values","viewbox","visibility","version","vert-adv-y","vert-origin-x","vert-origin-y","width","word-spacing","wrap","writing-mode","xchannelselector","ychannelselector","x","x1","x2","xmlns","y","y1","y2","z","zoomandpan"]),qt=ot(["accent","accentunder","align","bevelled","close","columnsalign","columnlines","columnspan","denomalign","depth","dir","display","displaystyle","encoding","fence","frame","height","href","id","largeop","length","linethickness","lspace","lquote","mathbackground","mathcolor","mathsize","mathvariant","maxsize","minsize","movablelimits","notation","numalign","open","rowalign","rowlines","rowspacing","rowspan","rspace","rquote","scriptlevel","scriptminsize","scriptsizemultiplier","selection","separator","separators","stretchy","subscriptshift","supscriptshift","symmetric","voffset","width","xmlns"]),At=ot(["xlink:href","xml:id","xlink:title","xml:space","xmlns:xlink"]),di=ft(/\{\{[\w\W]*|[\w\W]*\}\}/gm),gi=ft(/<%[\w\W]*|[\w\W]*%>/gm),mi=ft(/\${[\w\W]*}/gm),bi=ft(/^data-[\-\w.\u00B7-\uFFFF]/),$i=ft(/^aria-[\-\w]+$/),Kt=ft(/^(?:(?:(?:f|ht)tps?|mailto|tel|callto|sms|cid|xmpp):|[^a-z]|[a-z+.\-]+(?:[^a-z+.\-:]|$))/i),pi=ft(/^(?:\w+script|data):/i),wi=ft(/[\u0000-\u0020\u00A0\u1680\u180E\u2000-\u2029\u205F\u3000]/g),Qt=ft(/^html$/i);var Gt=Object.freeze({__proto__:null,MUSTACHE_EXPR:di,ERB_EXPR:gi,TMPLIT_EXPR:mi,DATA_ATTR:bi,ARIA_ATTR:$i,IS_ALLOWED_URI:Kt,IS_SCRIPT_OR_DATA:pi,ATTR_WHITESPACE:wi,DOCTYPE_NAME:Qt});const vi=()=>typeof window>"u"?null:window,Di=function(t,i){if(typeof t!="object"||typeof t.createPolicy!="function")return null;let N=null;const z="data-tt-policy-suffix";i&&i.hasAttribute(z)&&(N=i.getAttribute(z));const H="dompurify"+(N?"#"+N:"");try{return t.createPolicy(H,{createHTML(E){return E},createScriptURL(E){return E}})}catch{return console.warn("TrustedTypes policy "+H+" could not be created."),null}};function Yt(){let ne=arguments.length>0&&arguments[0]!==void 0?arguments[0]:vi();const t=Oe=>Yt(Oe);if(t.version="3.0.5",t.removed=[],!ne||!ne.document||ne.document.nodeType!==9)return t.isSupported=!1,t;const i=ne.document,N=i.currentScript;let{document:z}=ne;const{DocumentFragment:H,HTMLTemplateElement:E,Node:k,Element:b,NodeFilter:$,NamedNodeMap:w=ne.NamedNodeMap||ne.MozNamedAttrMap,HTMLFormElement:P,DOMParser:c,trustedTypes:f}=ne,e=b.prototype,n=Et(e,"cloneNode"),h=Et(e,"nextSibling"),m=Et(e,"childNodes"),p=Et(e,"parentNode");if(typeof E=="function"){const Oe=z.createElement("template");Oe.content&&Oe.content.ownerDocument&&(z=Oe.content.ownerDocument)}let v,o="";const{implementation:g,createNodeIterator:r,createDocumentFragment:B,getElementsByTagName:C}=z,{importNode:L}=i;let M={};t.isSupported=typeof Ot=="function"&&typeof p=="function"&&g&&g.createHTMLDocument!==void 0;const{MUSTACHE_EXPR:O,ERB_EXPR:y,TMPLIT_EXPR:x,DATA_ATTR:q,ARIA_ATTR:I,IS_SCRIPT_OR_DATA:j,ATTR_WHITESPACE:T}=Gt;let{IS_ALLOWED_URI:Q}=Gt,Z=null;const ce=He({},[...Ht,...Lt,...It,...Mt,...Wt]);let oe=null;const te=He({},[...Vt,...jt,...qt,...At]);let de=Object.seal(Object.create(null,{tagNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},attributeNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},allowCustomizedBuiltInElements:{writable:!0,configurable:!1,enumerable:!0,value:!1}})),Be=null,Fe=null,Pe=!0,le=!0,_=!1,ae=!0,re=!1,J=!1,G=!1,ie=!1,ue=!1,ye=!1,Ne=!1,Ae=!0,ge=!1;const u="user-content-";let S=!0,D=!1,a={},d=null;const s=He({},["annotation-xml","audio","colgroup","desc","foreignobject","head","iframe","math","mi","mn","mo","ms","mtext","noembed","noframes","noscript","plaintext","script","style","svg","template","thead","title","video","xmp"]);let l=null;const F=He({},["audio","video","img","source","image","track"]);let A=null;const R=He({},["alt","class","for","id","label","name","pattern","placeholder","role","summary","title","value","style","xmlns"]),W="http://www.w3.org/1998/Math/MathML",X="http://www.w3.org/2000/svg",U="http://www.w3.org/1999/xhtml";let me=U,ve=!1,we=null;const Me=He({},[W,X,U],Rt);let ke;const Ee=["application/xhtml+xml","text/html"],Ce="text/html";let Re,Ye=null;const st=z.createElement("form"),Ge=function(he){return he instanceof RegExp||he instanceof Function},Ue=function(he){if(!(Ye&&Ye===he)){if((!he||typeof he!="object")&&(he={}),he=bt(he),ke=Ee.indexOf(he.PARSER_MEDIA_TYPE)===-1?ke=Ce:ke=he.PARSER_MEDIA_TYPE,Re=ke==="application/xhtml+xml"?Rt:yt,Z="ALLOWED_TAGS"in he?He({},he.ALLOWED_TAGS,Re):ce,oe="ALLOWED_ATTR"in he?He({},he.ALLOWED_ATTR,Re):te,we="ALLOWED_NAMESPACES"in he?He({},he.ALLOWED_NAMESPACES,Rt):Me,A="ADD_URI_SAFE_ATTR"in he?He(bt(R),he.ADD_URI_SAFE_ATTR,Re):R,l="ADD_DATA_URI_TAGS"in he?He(bt(F),he.ADD_DATA_URI_TAGS,Re):F,d="FORBID_CONTENTS"in he?He({},he.FORBID_CONTENTS,Re):s,Be="FORBID_TAGS"in he?He({},he.FORBID_TAGS,Re):{},Fe="FORBID_ATTR"in he?He({},he.FORBID_ATTR,Re):{},a="USE_PROFILES"in he?he.USE_PROFILES:!1,Pe=he.ALLOW_ARIA_ATTR!==!1,le=he.ALLOW_DATA_ATTR!==!1,_=he.ALLOW_UNKNOWN_PROTOCOLS||!1,ae=he.ALLOW_SELF_CLOSE_IN_ATTR!==!1,re=he.SAFE_FOR_TEMPLATES||!1,J=he.WHOLE_DOCUMENT||!1,ue=he.RETURN_DOM||!1,ye=he.RETURN_DOM_FRAGMENT||!1,Ne=he.RETURN_TRUSTED_TYPE||!1,ie=he.FORCE_BODY||!1,Ae=he.SANITIZE_DOM!==!1,ge=he.SANITIZE_NAMED_PROPS||!1,S=he.KEEP_CONTENT!==!1,D=he.IN_PLACE||!1,Q=he.ALLOWED_URI_REGEXP||Kt,me=he.NAMESPACE||U,de=he.CUSTOM_ELEMENT_HANDLING||{},he.CUSTOM_ELEMENT_HANDLING&&Ge(he.CUSTOM_ELEMENT_HANDLING.tagNameCheck)&&(de.tagNameCheck=he.CUSTOM_ELEMENT_HANDLING.tagNameCheck),he.CUSTOM_ELEMENT_HANDLING&&Ge(he.CUSTOM_ELEMENT_HANDLING.attributeNameCheck)&&(de.attributeNameCheck=he.CUSTOM_ELEMENT_HANDLING.attributeNameCheck),he.CUSTOM_ELEMENT_HANDLING&&typeof he.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements=="boolean"&&(de.allowCustomizedBuiltInElements=he.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements),re&&(le=!1),ye&&(ue=!0),a&&(Z=He({},[...Wt]),oe=[],a.html===!0&&(He(Z,Ht),He(oe,Vt)),a.svg===!0&&(He(Z,Lt),He(oe,jt),He(oe,At)),a.svgFilters===!0&&(He(Z,It),He(oe,jt),He(oe,At)),a.mathMl===!0&&(He(Z,Mt),He(oe,qt),He(oe,At))),he.ADD_TAGS&&(Z===ce&&(Z=bt(Z)),He(Z,he.ADD_TAGS,Re)),he.ADD_ATTR&&(oe===te&&(oe=bt(oe)),He(oe,he.ADD_ATTR,Re)),he.ADD_URI_SAFE_ATTR&&He(A,he.ADD_URI_SAFE_ATTR,Re),he.FORBID_CONTENTS&&(d===s&&(d=bt(d)),He(d,he.FORBID_CONTENTS,Re)),S&&(Z["#text"]=!0),J&&He(Z,["html","head","body"]),Z.table&&(He(Z,["tbody"]),delete Be.tbody),he.TRUSTED_TYPES_POLICY){if(typeof he.TRUSTED_TYPES_POLICY.createHTML!="function")throw vt('TRUSTED_TYPES_POLICY configuration option must provide a "createHTML" hook.');if(typeof he.TRUSTED_TYPES_POLICY.createScriptURL!="function")throw vt('TRUSTED_TYPES_POLICY configuration option must provide a "createScriptURL" hook.');v=he.TRUSTED_TYPES_POLICY,o=v.createHTML("")}else v===void 0&&(v=Di(f,N)),v!==null&&typeof o=="string"&&(o=v.createHTML(""));ot&&ot(he),Ye=he}},Y=He({},["mi","mo","mn","ms","mtext"]),se=He({},["foreignobject","desc","title","annotation-xml"]),pe=He({},["title","style","font","a","script"]),De=He({},Lt);He(De,It),He(De,ci);const Le=He({},Mt);He(Le,fi);const ze=function(he){let Te=p(he);(!Te||!Te.tagName)&&(Te={namespaceURI:me,tagName:"template"});const Ie=yt(he.tagName),Ke=yt(Te.tagName);return we[he.namespaceURI]?he.namespaceURI===X?Te.namespaceURI===U?Ie==="svg":Te.namespaceURI===W?Ie==="svg"&&(Ke==="annotation-xml"||Y[Ke]):!!De[Ie]:he.namespaceURI===W?Te.namespaceURI===U?Ie==="math":Te.namespaceURI===X?Ie==="math"&&se[Ke]:!!Le[Ie]:he.namespaceURI===U?Te.namespaceURI===X&&!se[Ke]||Te.namespaceURI===W&&!Y[Ke]?!1:!Le[Ie]&&(pe[Ie]||!De[Ie]):!!(ke==="application/xhtml+xml"&&we[he.namespaceURI]):!1},Ve=function(he){wt(t.removed,{element:he});try{he.parentNode.removeChild(he)}catch{he.remove()}},_e=function(he,Te){try{wt(t.removed,{attribute:Te.getAttributeNode(he),from:Te})}catch{wt(t.removed,{attribute:null,from:Te})}if(Te.removeAttribute(he),he==="is"&&!oe[he])if(ue||ye)try{Ve(Te)}catch{}else try{Te.setAttribute(he,"")}catch{}},tt=function(he){let Te,Ie;if(ie)he="<remove></remove>"+he;else{const at=li(he,/^[\r\n\t ]+/);Ie=at&&at[0]}ke==="application/xhtml+xml"&&me===U&&(he='<html xmlns="http://www.w3.org/1999/xhtml"><head></head><body>'+he+"</body></html>");const Ke=v?v.createHTML(he):he;if(me===U)try{Te=new c().parseFromString(Ke,ke)}catch{}if(!Te||!Te.documentElement){Te=g.createDocument(me,"template",null);try{Te.documentElement.innerHTML=ve?o:Ke}catch{}}const it=Te.body||Te.documentElement;return he&&Ie&&it.insertBefore(z.createTextNode(Ie),it.childNodes[0]||null),me===U?C.call(Te,J?"html":"body")[0]:J?Te.documentElement:it},nt=function(he){return r.call(he.ownerDocument||he,he,$.SHOW_ELEMENT|$.SHOW_COMMENT|$.SHOW_TEXT,null,!1)},Je=function(he){return he instanceof P&&(typeof he.nodeName!="string"||typeof he.textContent!="string"||typeof he.removeChild!="function"||!(he.attributes instanceof w)||typeof he.removeAttribute!="function"||typeof he.setAttribute!="function"||typeof he.namespaceURI!="string"||typeof he.insertBefore!="function"||typeof he.hasChildNodes!="function")},rt=function(he){return typeof k=="object"?he instanceof k:he&&typeof he=="object"&&typeof he.nodeType=="number"&&typeof he.nodeName=="string"},et=function(he,Te,Ie){M[he]&&oi(M[he],Ke=>{Ke.call(t,Te,Ie,Ye)})},mt=function(he){let Te;if(et("beforeSanitizeElements",he,null),Je(he))return Ve(he),!0;const Ie=Re(he.nodeName);if(et("uponSanitizeElement",he,{tagName:Ie,allowedTags:Z}),he.hasChildNodes()&&!rt(he.firstElementChild)&&(!rt(he.content)||!rt(he.content.firstElementChild))&&ht(/<[/\w]/g,he.innerHTML)&&ht(/<[/\w]/g,he.textContent))return Ve(he),!0;if(!Z[Ie]||Be[Ie]){if(!Be[Ie]&&kt(Ie)&&(de.tagNameCheck instanceof RegExp&&ht(de.tagNameCheck,Ie)||de.tagNameCheck instanceof Function&&de.tagNameCheck(Ie)))return!1;if(S&&!d[Ie]){const Ke=p(he)||he.parentNode,it=m(he)||he.childNodes;if(it&&Ke){const at=it.length;for(let Xe=at-1;Xe>=0;--Xe)Ke.insertBefore(n(it[Xe],!0),h(he))}}return Ve(he),!0}return he instanceof b&&!ze(he)||(Ie==="noscript"||Ie==="noembed"||Ie==="noframes")&&ht(/<\/no(script|embed|frames)/i,he.innerHTML)?(Ve(he),!0):(re&&he.nodeType===3&&(Te=he.textContent,Te=dt(Te,O," "),Te=dt(Te,y," "),Te=dt(Te,x," "),he.textContent!==Te&&(wt(t.removed,{element:he.cloneNode()}),he.textContent=Te)),et("afterSanitizeElements",he,null),!1)},gt=function(he,Te,Ie){if(Ae&&(Te==="id"||Te==="name")&&(Ie in z||Ie in st))return!1;if(!(le&&!Fe[Te]&&ht(q,Te))){if(!(Pe&&ht(I,Te))){if(!oe[Te]||Fe[Te]){if(!(kt(he)&&(de.tagNameCheck instanceof RegExp&&ht(de.tagNameCheck,he)||de.tagNameCheck instanceof Function&&de.tagNameCheck(he))&&(de.attributeNameCheck instanceof RegExp&&ht(de.attributeNameCheck,Te)||de.attributeNameCheck instanceof Function&&de.attributeNameCheck(Te))||Te==="is"&&de.allowCustomizedBuiltInElements&&(de.tagNameCheck instanceof RegExp&&ht(de.tagNameCheck,Ie)||de.tagNameCheck instanceof Function&&de.tagNameCheck(Ie))))return!1}else if(!A[Te]){if(!ht(Q,dt(Ie,T,""))){if(!((Te==="src"||Te==="xlink:href"||Te==="href")&&he!=="script"&&ai(Ie,"data:")===0&&l[he])){if(!(_&&!ht(j,dt(Ie,T,"")))){if(Ie)return!1}}}}}}return!0},kt=function(he){return he.indexOf("-")>0},St=function(he){let Te,Ie,Ke,it;et("beforeSanitizeAttributes",he,null);const{attributes:at}=he;if(!at)return;const Xe={attrName:"",attrValue:"",keepAttr:!0,allowedAttributes:oe};for(it=at.length;it--;){Te=at[it];const{name:ut,namespaceURI:$t}=Te;if(Ie=ut==="value"?Te.value:hi(Te.value),Ke=Re(ut),Xe.attrName=Ke,Xe.attrValue=Ie,Xe.keepAttr=!0,Xe.forceKeepAttr=void 0,et("uponSanitizeAttribute",he,Xe),Ie=Xe.attrValue,Xe.forceKeepAttr||(_e(ut,he),!Xe.keepAttr))continue;if(!ae&&ht(/\/>/i,Ie)){_e(ut,he);continue}re&&(Ie=dt(Ie,O," "),Ie=dt(Ie,y," "),Ie=dt(Ie,x," "));const Tt=Re(he.nodeName);if(gt(Tt,Ke,Ie)){if(ge&&(Ke==="id"||Ke==="name")&&(_e(ut,he),Ie=u+Ie),v&&typeof f=="object"&&typeof f.getAttributeType=="function"&&!$t)switch(f.getAttributeType(Tt,Ke)){case"TrustedHTML":{Ie=v.createHTML(Ie);break}case"TrustedScriptURL":{Ie=v.createScriptURL(Ie);break}}try{$t?he.setAttributeNS($t,ut,Ie):he.setAttribute(ut,Ie),zt(t.removed)}catch{}}}et("afterSanitizeAttributes",he,null)},Bt=function Oe(he){let Te;const Ie=nt(he);for(et("beforeSanitizeShadowDOM",he,null);Te=Ie.nextNode();)et("uponSanitizeShadowNode",Te,null),!mt(Te)&&(Te.content instanceof H&&Oe(Te.content),St(Te));et("afterSanitizeShadowDOM",he,null)};return t.sanitize=function(Oe){let he=arguments.length>1&&arguments[1]!==void 0?arguments[1]:{},Te,Ie,Ke,it;if(ve=!Oe,ve&&(Oe="<!-->"),typeof Oe!="string"&&!rt(Oe))if(typeof Oe.toString=="function"){if(Oe=Oe.toString(),typeof Oe!="string")throw vt("dirty is not a string, aborting")}else throw vt("toString is not a function");if(!t.isSupported)return Oe;if(G||Ue(he),t.removed=[],typeof Oe=="string"&&(D=!1),D){if(Oe.nodeName){const ut=Re(Oe.nodeName);if(!Z[ut]||Be[ut])throw vt("root node is forbidden and cannot be sanitized in-place")}}else if(Oe instanceof k)Te=tt("<!---->"),Ie=Te.ownerDocument.importNode(Oe,!0),Ie.nodeType===1&&Ie.nodeName==="BODY"||Ie.nodeName==="HTML"?Te=Ie:Te.appendChild(Ie);else{if(!ue&&!re&&!J&&Oe.indexOf("<")===-1)return v&&Ne?v.createHTML(Oe):Oe;if(Te=tt(Oe),!Te)return ue?null:Ne?o:""}Te&&ie&&Ve(Te.firstChild);const at=nt(D?Oe:Te);for(;Ke=at.nextNode();)mt(Ke)||(Ke.content instanceof H&&Bt(Ke.content),St(Ke));if(D)return Oe;if(ue){if(ye)for(it=B.call(Te.ownerDocument);Te.firstChild;)it.appendChild(Te.firstChild);else it=Te;return(oe.shadowroot||oe.shadowrootmode)&&(it=L.call(i,it,!0)),it}let Xe=J?Te.outerHTML:Te.innerHTML;return J&&Z["!doctype"]&&Te.ownerDocument&&Te.ownerDocument.doctype&&Te.ownerDocument.doctype.name&&ht(Qt,Te.ownerDocument.doctype.name)&&(Xe="<!DOCTYPE "+Te.ownerDocument.doctype.name+`>
`+Xe),re&&(Xe=dt(Xe,O," "),Xe=dt(Xe,y," "),Xe=dt(Xe,x," ")),v&&Ne?v.createHTML(Xe):Xe},t.setConfig=function(Oe){Ue(Oe),G=!0},t.clearConfig=function(){Ye=null,G=!1},t.isValidAttribute=function(Oe,he,Te){Ye||Ue({});const Ie=Re(Oe),Ke=Re(he);return gt(Ie,Ke,Te)},t.addHook=function(Oe,he){typeof he=="function"&&(M[Oe]=M[Oe]||[],wt(M[Oe],he))},t.removeHook=function(Oe){if(M[Oe])return zt(M[Oe])},t.removeHooks=function(Oe){M[Oe]&&(M[Oe]=[])},t.removeAllHooks=function(){M={}},t}var yi=Yt();define("vs/base/browser/dompurify/dompurify",function(){return yi}),define(be[45],$e([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$FS=void 0,t.$GS=z;class i{constructor(E){this.domNode=E,this.a="",this.b="",this.c="",this.d="",this.e="",this.f="",this.g="",this.h="",this.i="",this.j="",this.k="",this.l="",this.m="",this.n="",this.o="",this.p="",this.q="",this.r="",this.s="",this.t="",this.u="",this.v="",this.w="",this.x="",this.y="",this.z="",this.A=!1,this.B="none",this.C=""}setMaxWidth(E){const k=N(E);this.a!==k&&(this.a=k,this.domNode.style.maxWidth=this.a)}setWidth(E){const k=N(E);this.b!==k&&(this.b=k,this.domNode.style.width=this.b)}setHeight(E){const k=N(E);this.c!==k&&(this.c=k,this.domNode.style.height=this.c)}setTop(E){const k=N(E);this.d!==k&&(this.d=k,this.domNode.style.top=this.d)}setLeft(E){const k=N(E);this.e!==k&&(this.e=k,this.domNode.style.left=this.e)}setBottom(E){const k=N(E);this.f!==k&&(this.f=k,this.domNode.style.bottom=this.f)}setRight(E){const k=N(E);this.g!==k&&(this.g=k,this.domNode.style.right=this.g)}setPaddingTop(E){const k=N(E);this.h!==k&&(this.h=k,this.domNode.style.paddingTop=this.h)}setPaddingLeft(E){const k=N(E);this.i!==k&&(this.i=k,this.domNode.style.paddingLeft=this.i)}setPaddingBottom(E){const k=N(E);this.j!==k&&(this.j=k,this.domNode.style.paddingBottom=this.j)}setPaddingRight(E){const k=N(E);this.k!==k&&(this.k=k,this.domNode.style.paddingRight=this.k)}setFontFamily(E){this.l!==E&&(this.l=E,this.domNode.style.fontFamily=this.l)}setFontWeight(E){this.m!==E&&(this.m=E,this.domNode.style.fontWeight=this.m)}setFontSize(E){const k=N(E);this.n!==k&&(this.n=k,this.domNode.style.fontSize=this.n)}setFontStyle(E){this.o!==E&&(this.o=E,this.domNode.style.fontStyle=this.o)}setFontFeatureSettings(E){this.p!==E&&(this.p=E,this.domNode.style.fontFeatureSettings=this.p)}setFontVariationSettings(E){this.q!==E&&(this.q=E,this.domNode.style.fontVariationSettings=this.q)}setTextDecoration(E){this.r!==E&&(this.r=E,this.domNode.style.textDecoration=this.r)}setLineHeight(E){const k=N(E);this.s!==k&&(this.s=k,this.domNode.style.lineHeight=this.s)}setLetterSpacing(E){const k=N(E);this.t!==k&&(this.t=k,this.domNode.style.letterSpacing=this.t)}setClassName(E){this.u!==E&&(this.u=E,this.domNode.className=this.u)}toggleClassName(E,k){this.domNode.classList.toggle(E,k),this.u=this.domNode.className}setDisplay(E){this.v!==E&&(this.v=E,this.domNode.style.display=this.v)}setPosition(E){this.w!==E&&(this.w=E,this.domNode.style.position=this.w)}setVisibility(E){this.x!==E&&(this.x=E,this.domNode.style.visibility=this.x)}setColor(E){this.y!==E&&(this.y=E,this.domNode.style.color=this.y)}setBackgroundColor(E){this.z!==E&&(this.z=E,this.domNode.style.backgroundColor=this.z)}setLayerHinting(E){this.A!==E&&(this.A=E,this.domNode.style.transform=this.A?"translate3d(0px, 0px, 0px)":"")}setBoxShadow(E){this.C!==E&&(this.C=E,this.domNode.style.boxShadow=E)}setContain(E){this.B!==E&&(this.B=E,this.domNode.style.contain=this.B)}setAttribute(E,k){this.domNode.setAttribute(E,k)}removeAttribute(E){this.domNode.removeAttribute(E)}appendChild(E){this.domNode.appendChild(E.domNode)}removeChild(E){this.domNode.removeChild(E.domNode)}}t.$FS=i;function N(H){return typeof H=="number"?`${H}px`:H}function z(H){return new i(H)}}),define(be[72],$e([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$XQ=void 0,t.$YQ=H;const i=new WeakMap;function N(k){if(!k.parent||k.parent===k)return null;try{const b=k.location,$=k.parent.location;if(b.origin!=="null"&&$.origin!=="null"&&b.origin!==$.origin)return null}catch{return null}return k.parent}class z{static a(b){let $=i.get(b);if(!$){$=[],i.set(b,$);let w=b,P;do P=N(w),P?$.push({window:new WeakRef(w),iframeElement:w.frameElement||null}):$.push({window:new WeakRef(w),iframeElement:null}),w=P;while(w)}return $.slice(0)}static getPositionOfChildWindowRelativeToAncestorWindow(b,$){if(!$||b===$)return{top:0,left:0};let w=0,P=0;const c=this.a(b);for(const f of c){const e=f.window.deref();if(w+=e?.scrollY??0,P+=e?.scrollX??0,e===$||!f.iframeElement)break;const n=f.iframeElement.getBoundingClientRect();w+=n.top,P+=n.left}return{top:w,left:P}}}t.$XQ=z;async function H(k,b){if(!crypto.subtle)throw new Error("'crypto.subtle' is not available so webviews will not work. This is likely because the editor is not running in a secure context (https://developer.mozilla.org/en-US/docs/Web/Security/Secure_Contexts).");const $=JSON.stringify({parentOrigin:k,salt:b}),P=new TextEncoder().encode($),c=await crypto.subtle.digest("sha-256",P);return E(c)}function E(k){const $=Array.from(new Uint8Array(k)).map(w=>w.toString(16).padStart(2,"0")).join("");return BigInt(`0x${$}`).toString(32).padStart(52,"0")}}),define(be[73],$e([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$pT=t.$oT=t.$nT=t.ListDragOverEffectPosition=t.ListDragOverEffectType=void 0;var i;(function(E){E[E.Copy=0]="Copy",E[E.Move=1]="Move"})(i||(t.ListDragOverEffectType=i={}));var N;(function(E){E.Over="drop-target",E.Before="drop-target-before",E.After="drop-target-after"})(N||(t.ListDragOverEffectPosition=N={})),t.$nT={reject(){return{accept:!1}},accept(){return{accept:!0}}};class z extends Error{constructor(k,b){super(`ListError [${k}] ${b}`)}}t.$oT=z;class H{constructor(){this.c=new WeakMap}getHeight(k){return this.c.get(k)??this.d(k)}setDynamicHeight(k,b){b>0&&this.c.set(k,b)}}t.$pT=H}),define(be[74],$e([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$dT=void 0;class i{constructor(z){this.a=z}splice(z,H,E){this.a.forEach(k=>k.splice(z,H,E))}}t.$dT=i}),define(be[46],$e([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$LS=void 0;const i=20;class N{constructor(H,E,k,b,$,w){this.a=Math.round(E),this.b=Math.round(k),this.c=Math.round(H),this.d=b,this.e=$,this.f=w,this.g=0,this.h=!1,this.i=0,this.j=0,this.k=0,this.m()}clone(){return new N(this.c,this.a,this.b,this.d,this.e,this.f)}setVisibleSize(H){const E=Math.round(H);return this.d!==E?(this.d=E,this.m(),!0):!1}setScrollSize(H){const E=Math.round(H);return this.e!==E?(this.e=E,this.m(),!0):!1}setScrollPosition(H){const E=Math.round(H);return this.f!==E?(this.f=E,this.m(),!0):!1}setScrollbarSize(H){this.a=Math.round(H)}setOppositeScrollbarSize(H){this.b=Math.round(H)}static l(H,E,k,b,$){const w=Math.max(0,k-H),P=Math.max(0,w-2*E),c=b>0&&b>k;if(!c)return{computedAvailableSize:Math.round(w),computedIsNeeded:c,computedSliderSize:Math.round(P),computedSliderRatio:0,computedSliderPosition:0};const f=Math.round(Math.max(i,Math.floor(k*P/b))),e=(P-f)/(b-k),n=$*e;return{computedAvailableSize:Math.round(w),computedIsNeeded:c,computedSliderSize:Math.round(f),computedSliderRatio:e,computedSliderPosition:Math.round(n)}}m(){const H=N.l(this.b,this.c,this.d,this.e,this.f);this.g=H.computedAvailableSize,this.h=H.computedIsNeeded,this.i=H.computedSliderSize,this.j=H.computedSliderRatio,this.k=H.computedSliderPosition}getArrowSize(){return this.c}getScrollPosition(){return this.f}getRectangleLargeSize(){return this.g}getRectangleSmallSize(){return this.a}isNeeded(){return this.h}getSliderSize(){return this.i}getSliderPosition(){return this.k}getDesiredScrollPositionFromOffset(H){if(!this.h)return 0;const E=H-this.c-this.i/2;return Math.round(E/this.j)}getDesiredScrollPositionFromOffsetPaged(H){if(!this.h)return 0;const E=H-this.c;let k=this.f;return E<this.k?k-=this.d:k+=this.d,k}getDesiredScrollPositionFromDelta(H){if(!this.h)return 0;const E=this.k+H;return Math.round(E/this.j)}}t.$LS=N}),define(be[27],$e([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$hV=t.$gV=t.$fV=t.TreeDragOverBubble=t.TreeMouseEventTarget=t.ObjectTreeElementCollapseState=t.TreeVisibility=void 0;var i;(function(b){b[b.Hidden=0]="Hidden",b[b.Visible=1]="Visible",b[b.Recurse=2]="Recurse"})(i||(t.TreeVisibility=i={}));var N;(function(b){b[b.Expanded=0]="Expanded",b[b.Collapsed=1]="Collapsed",b[b.PreserveOrExpanded=2]="PreserveOrExpanded",b[b.PreserveOrCollapsed=3]="PreserveOrCollapsed"})(N||(t.ObjectTreeElementCollapseState=N={}));var z;(function(b){b[b.Unknown=0]="Unknown",b[b.Twistie=1]="Twistie",b[b.Element=2]="Element",b[b.Filter=3]="Filter"})(z||(t.TreeMouseEventTarget=z={}));var H;(function(b){b[b.Down=0]="Down",b[b.Up=1]="Up"})(H||(t.TreeDragOverBubble=H={})),t.$fV={acceptBubbleUp(){return{accept:!0,bubble:1}},acceptBubbleDown(b=!1){return{accept:!0,bubble:0,autoExpand:b}},acceptCopyBubbleUp(){return{accept:!0,bubble:1,effect:{type:0,position:"drop-target"}}},acceptCopyBubbleDown(b=!1){return{accept:!0,bubble:0,effect:{type:0,position:"drop-target"},autoExpand:b}}};class E extends Error{constructor($,w){super(`TreeError [${$}] ${w}`)}}t.$gV=E;class k{constructor($){this.a=$,this.b=new WeakMap}map($){let w=this.b.get($);return w||(w=this.a($),this.b.set($,w)),w}}t.$hV=k}),define(be[22],$e([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$BQ=void 0,t.$AQ=i,t.$CQ=N;function i(z,H){const E=z;typeof E.vscodeWindowId!="number"&&Object.defineProperty(E,"vscodeWindowId",{get:()=>H})}t.$BQ=window;function N(z){return z===t.$BQ?!1:typeof z?.vscodeWindowId=="number"}}),define(be[75],$e([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$mb=void 0,t.$fb=i,t.$gb=N,t.$hb=z,t.$ib=H,t.$jb=E,t.$kb=k,t.$lb=b,t.$nb=w,t.$ob=P,t.$pb=c,t.$qb=f,t.$rb=e;function i(n,h,m){const p=N(n,h);if(p!==-1)return n[p]}function N(n,h,m=n.length-1){for(let p=m;p>=0;p--){const v=n[p];if(h(v))return p}return-1}function z(n,h){const m=H(n,h);return m===-1?void 0:n[m]}function H(n,h,m=0,p=n.length){let v=m,o=p;for(;v<o;){const g=Math.floor((v+o)/2);h(n[g])?v=g+1:o=g}return v-1}function E(n,h){const m=k(n,h);return m===n.length?void 0:n[m]}function k(n,h,m=0,p=n.length){let v=m,o=p;for(;v<o;){const g=Math.floor((v+o)/2);h(n[g])?o=g:v=g+1}return v}function b(n,h,m=0,p=n.length){const v=k(n,h,m,p);return v===n.length?-1:v}class ${static{this.assertInvariants=!1}constructor(h){this.e=h,this.c=0}findLastMonotonous(h){if($.assertInvariants){if(this.d){for(const p of this.e)if(this.d(p)&&!h(p))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=h}const m=H(this.e,h,this.c);return this.c=m+1,m===-1?void 0:this.e[m]}}t.$mb=$;function w(n,h){if(n.length===0)return;let m=n[0];for(let p=1;p<n.length;p++){const v=n[p];h(v,m)>0&&(m=v)}return m}function P(n,h){if(n.length===0)return;let m=n[0];for(let p=1;p<n.length;p++){const v=n[p];h(v,m)>=0&&(m=v)}return m}function c(n,h){return w(n,(m,p)=>-h(m,p))}function f(n,h){if(n.length===0)return-1;let m=0;for(let p=1;p<n.length;p++){const v=n[p];h(v,n[m])>0&&(m=p)}return m}function e(n,h){for(const m of n){const p=h(m);if(p!==void 0)return p}}}),define(be[76],$e([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$K=i,t.$L=N,t.$M=z,t.$N=H;function i(E,k){const b=Object.create(null);for(const $ of E){const w=k($);let P=b[w];P||(P=b[w]=[]),P.push($)}return b}function N(E,k){const b=[],$=[];for(const w of E)k.has(w)||b.push(w);for(const w of k)E.has(w)||$.push(w);return{removed:b,added:$}}function z(E,k){const b=[],$=[];for(const[w,P]of E)k.has(w)||b.push(P);for(const[w,P]of k)E.has(w)||$.push(P);return{removed:b,added:$}}function H(E,k){const b=new Set;for(const $ of k)E.has($)&&b.add($);return b}}),define(be[77],$e([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ft=t.$Et=t.$Dt=t.$Ct=void 0;function i(k,b){const $=Math.pow(10,b);return Math.round(k*$)/$}class N{constructor(b,$,w,P=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,b))|0,this.g=Math.min(255,Math.max(0,$))|0,this.b=Math.min(255,Math.max(0,w))|0,this.a=i(Math.max(Math.min(1,P),0),3)}static equals(b,$){return b.r===$.r&&b.g===$.g&&b.b===$.b&&b.a===$.a}}t.$Ct=N;class z{constructor(b,$,w,P){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,b),0)|0,this.s=i(Math.max(Math.min(1,$),0),3),this.l=i(Math.max(Math.min(1,w),0),3),this.a=i(Math.max(Math.min(1,P),0),3)}static equals(b,$){return b.h===$.h&&b.s===$.s&&b.l===$.l&&b.a===$.a}static fromRGBA(b){const $=b.r/255,w=b.g/255,P=b.b/255,c=b.a,f=Math.max($,w,P),e=Math.min($,w,P);let n=0,h=0;const m=(e+f)/2,p=f-e;if(p>0){switch(h=Math.min(m<=.5?p/(2*m):p/(2-2*m),1),f){case $:n=(w-P)/p+(w<P?6:0);break;case w:n=(P-$)/p+2;break;case P:n=($-w)/p+4;break}n*=60,n=Math.round(n)}return new z(n,h,m,c)}static i(b,$,w){return w<0&&(w+=1),w>1&&(w-=1),w<1/6?b+($-b)*6*w:w<1/2?$:w<2/3?b+($-b)*(2/3-w)*6:b}static toRGBA(b){const $=b.h/360,{s:w,l:P,a:c}=b;let f,e,n;if(w===0)f=e=n=P;else{const h=P<.5?P*(1+w):P+w-P*w,m=2*P-h;f=z.i(m,h,$+1/3),e=z.i(m,h,$),n=z.i(m,h,$-1/3)}return new N(Math.round(f*255),Math.round(e*255),Math.round(n*255),c)}}t.$Dt=z;class H{constructor(b,$,w,P){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,b),0)|0,this.s=i(Math.max(Math.min(1,$),0),3),this.v=i(Math.max(Math.min(1,w),0),3),this.a=i(Math.max(Math.min(1,P),0),3)}static equals(b,$){return b.h===$.h&&b.s===$.s&&b.v===$.v&&b.a===$.a}static fromRGBA(b){const $=b.r/255,w=b.g/255,P=b.b/255,c=Math.max($,w,P),f=Math.min($,w,P),e=c-f,n=c===0?0:e/c;let h;return e===0?h=0:c===$?h=((w-P)/e%6+6)%6:c===w?h=(P-$)/e+2:h=($-w)/e+4,new H(Math.round(h*60),n,c,b.a)}static toRGBA(b){const{h:$,s:w,v:P,a:c}=b,f=P*w,e=f*(1-Math.abs($/60%2-1)),n=P-f;let[h,m,p]=[0,0,0];return $<60?(h=f,m=e):$<120?(h=e,m=f):$<180?(m=f,p=e):$<240?(m=e,p=f):$<300?(h=e,p=f):$<=360&&(h=f,p=e),h=Math.round((h+n)*255),m=Math.round((m+n)*255),p=Math.round((p+n)*255),new N(h,m,p,c)}}t.$Et=H;class E{static fromHex(b){return E.Format.CSS.parseHex(b)||E.red}static equals(b,$){return!b&&!$?!0:!b||!$?!1:b.equals($)}get hsla(){return this.i?this.i:z.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:H.fromRGBA(this.rgba)}constructor(b){if(b)if(b instanceof N)this.rgba=b;else if(b instanceof z)this.i=b,this.rgba=z.toRGBA(b);else if(b instanceof H)this.j=b,this.rgba=H.toRGBA(b);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(b){return!!b&&N.equals(this.rgba,b.rgba)&&z.equals(this.hsla,b.hsla)&&H.equals(this.hsva,b.hsva)}getRelativeLuminance(){const b=E.k(this.rgba.r),$=E.k(this.rgba.g),w=E.k(this.rgba.b),P=.2126*b+.7152*$+.0722*w;return i(P,4)}static k(b){const $=b/255;return $<=.03928?$/12.92:Math.pow(($+.055)/1.055,2.4)}getContrastRatio(b){const $=this.getRelativeLuminance(),w=b.getRelativeLuminance();return $>w?($+.05)/(w+.05):(w+.05)/($+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(b){const $=this.getRelativeLuminance(),w=b.getRelativeLuminance();return $>w}isDarkerThan(b){const $=this.getRelativeLuminance(),w=b.getRelativeLuminance();return $<w}lighten(b){return new E(new z(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*b,this.hsla.a))}darken(b){return new E(new z(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*b,this.hsla.a))}transparent(b){const{r:$,g:w,b:P,a:c}=this.rgba;return new E(new N($,w,P,c*b))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new E(new N(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(b){const $=b.rgba,w=this.rgba.a,P=$.a,c=w+P*(1-w);if(c<1e-6)return E.transparent;const f=this.rgba.r*w/c+$.r*P*(1-w)/c,e=this.rgba.g*w/c+$.g*P*(1-w)/c,n=this.rgba.b*w/c+$.b*P*(1-w)/c;return new E(new N(f,e,n,c))}makeOpaque(b){if(this.isOpaque()||b.rgba.a!==1)return this;const{r:$,g:w,b:P,a:c}=this.rgba;return new E(new N(b.rgba.r-c*(b.rgba.r-$),b.rgba.g-c*(b.rgba.g-w),b.rgba.b-c*(b.rgba.b-P),1))}flatten(...b){const $=b.reduceRight((w,P)=>E.o(P,w));return E.o(this,$)}static o(b,$){const w=1-b.rgba.a;return new E(new N(w*$.rgba.r+b.rgba.a*b.rgba.r,w*$.rgba.g+b.rgba.a*b.rgba.g,w*$.rgba.b+b.rgba.a*b.rgba.b))}toString(){return this.u||(this.u=E.Format.CSS.format(this)),this.u}static getLighterColor(b,$,w){if(b.isLighterThan($))return b;w=w||.5;const P=b.getRelativeLuminance(),c=$.getRelativeLuminance();return w=w*(c-P)/c,b.lighten(w)}static getDarkerColor(b,$,w){if(b.isDarkerThan($))return b;w=w||.5;const P=b.getRelativeLuminance(),c=$.getRelativeLuminance();return w=w*(P-c)/P,b.darken(w)}static{this.white=new E(new N(255,255,255,1))}static{this.black=new E(new N(0,0,0,1))}static{this.red=new E(new N(255,0,0,1))}static{this.blue=new E(new N(0,0,255,1))}static{this.green=new E(new N(0,255,0,1))}static{this.cyan=new E(new N(0,255,255,1))}static{this.lightgrey=new E(new N(211,211,211,1))}static{this.transparent=new E(new N(0,0,0,0))}}t.$Ft=E,function(k){let b;(function($){let w;(function(P){function c(r){return r.rgba.a===1?`rgb(${r.rgba.r}, ${r.rgba.g}, ${r.rgba.b})`:k.Format.CSS.formatRGBA(r)}P.formatRGB=c;function f(r){return`rgba(${r.rgba.r}, ${r.rgba.g}, ${r.rgba.b}, ${+r.rgba.a.toFixed(2)})`}P.formatRGBA=f;function e(r){return r.hsla.a===1?`hsl(${r.hsla.h}, ${(r.hsla.s*100).toFixed(2)}%, ${(r.hsla.l*100).toFixed(2)}%)`:k.Format.CSS.formatHSLA(r)}P.formatHSL=e;function n(r){return`hsla(${r.hsla.h}, ${(r.hsla.s*100).toFixed(2)}%, ${(r.hsla.l*100).toFixed(2)}%, ${r.hsla.a.toFixed(2)})`}P.formatHSLA=n;function h(r){const B=r.toString(16);return B.length!==2?"0"+B:B}function m(r){return`#${h(r.rgba.r)}${h(r.rgba.g)}${h(r.rgba.b)}`}P.formatHex=m;function p(r,B=!1){return B&&r.rgba.a===1?k.Format.CSS.formatHex(r):`#${h(r.rgba.r)}${h(r.rgba.g)}${h(r.rgba.b)}${h(Math.round(r.rgba.a*255))}`}P.formatHexA=p;function v(r){return r.isOpaque()?k.Format.CSS.formatHex(r):k.Format.CSS.formatRGBA(r)}P.format=v;function o(r){const B=r.length;if(B===0||r.charCodeAt(0)!==35)return null;if(B===7){const C=16*g(r.charCodeAt(1))+g(r.charCodeAt(2)),L=16*g(r.charCodeAt(3))+g(r.charCodeAt(4)),M=16*g(r.charCodeAt(5))+g(r.charCodeAt(6));return new k(new N(C,L,M,1))}if(B===9){const C=16*g(r.charCodeAt(1))+g(r.charCodeAt(2)),L=16*g(r.charCodeAt(3))+g(r.charCodeAt(4)),M=16*g(r.charCodeAt(5))+g(r.charCodeAt(6)),O=16*g(r.charCodeAt(7))+g(r.charCodeAt(8));return new k(new N(C,L,M,O/255))}if(B===4){const C=g(r.charCodeAt(1)),L=g(r.charCodeAt(2)),M=g(r.charCodeAt(3));return new k(new N(16*C+C,16*L+L,16*M+M))}if(B===5){const C=g(r.charCodeAt(1)),L=g(r.charCodeAt(2)),M=g(r.charCodeAt(3)),O=g(r.charCodeAt(4));return new k(new N(16*C+C,16*L+L,16*M+M,(16*O+O)/255))}return null}P.parseHex=o;function g(r){switch(r){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(w=$.CSS||($.CSS={}))})(b=k.Format||(k.Format={}))}(E||(t.$Ft=E={}))}),define(be[28],$e([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Lh=N,t.$Mh=z,t.$Nh=H;function i(E){return(k,b,$)=>{let w=null,P=null;if(typeof $.value=="function"?(w="value",P=$.value):typeof $.get=="function"&&(w="get",P=$.get),!P)throw new Error("not supported");$[w]=E(P,b)}}function N(E,k,b){let $=null,w=null;if(typeof b.value=="function"?($="value",w=b.value,w.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof b.get=="function"&&($="get",w=b.get),!w)throw new Error("not supported");const P=`$memoize$${k}`;b[$]=function(...c){return this.hasOwnProperty(P)||Object.defineProperty(this,P,{configurable:!1,enumerable:!1,writable:!1,value:w.apply(this,c)}),this[P]}}function z(E,k,b){return i(($,w)=>{const P=`$debounce$${w}`,c=`$debounce$result$${w}`;return function(...f){this[c]||(this[c]=b?b():void 0),clearTimeout(this[P]),k&&(this[c]=k(this[c],...f),f=[this[c]]),this[P]=setTimeout(()=>{$.apply(this,f),this[c]=b?b():void 0},E)}})}function H(E,k,b){return i(($,w)=>{const P=`$throttle$timer$${w}`,c=`$throttle$result$${w}`,f=`$throttle$lastRun$${w}`,e=`$throttle$pending$${w}`;return function(...n){if(this[c]||(this[c]=b?b():void 0),(this[f]===null||this[f]===void 0)&&(this[f]=-Number.MAX_VALUE),k&&(this[c]=k(this[c],...n)),this[e])return;const h=this[f]+E;h<=Date.now()?(this[f]=Date.now(),$.apply(this,[this[c]]),this[c]=b?b():void 0):(this[e]=!0,this[P]=setTimeout(()=>{this[e]=!1,this[f]=Date.now(),$.apply(this,[this[c]]),this[c]=b?b():void 0},h-Date.now()))}})}}),define(be[78],$e([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$et=void 0;class i{constructor(z,H,E,k){this.originalStart=z,this.originalLength=H,this.modifiedStart=E,this.modifiedLength=k}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.$et=i}),define(be[6],$e([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cb=t.$bb=t.$ab=t.$_=t.$$=t.$9=t.$5=t.$X=t.$W=void 0,t.setUnexpectedErrorHandler=N,t.$Z=z,t.$1=H,t.$2=E,t.$3=k,t.$4=$,t.$6=P,t.$7=c,t.$8=f,t.$0=n;class i{constructor(){this.b=[],this.a=function(r){setTimeout(()=>{throw r.stack?v.isErrorNoTelemetry(r)?new v(r.message+`

`+r.stack):new Error(r.message+`

`+r.stack):r},0)}}addListener(r){return this.b.push(r),()=>{this.d(r)}}c(r){this.b.forEach(B=>{B(r)})}d(r){this.b.splice(this.b.indexOf(r),1)}setUnexpectedErrorHandler(r){this.a=r}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(r){this.a(r),this.c(r)}onUnexpectedExternalError(r){this.a(r)}}t.$W=i,t.$X=new i;function N(g){t.$X.setUnexpectedErrorHandler(g)}function z(g){if(!g||typeof g!="object")return!1;const r=g;return r.code==="EPIPE"&&r.syscall?.toUpperCase()==="WRITE"}function H(g){$(g)||t.$X.onUnexpectedError(g)}function E(g){$(g)||t.$X.onUnexpectedExternalError(g)}function k(g){if(g instanceof Error){const{name:r,message:B}=g,C=g.stacktrace||g.stack;return{$isError:!0,name:r,message:B,stack:C,noTelemetry:v.isErrorNoTelemetry(g)}}return g}const b="Canceled";function $(g){return g instanceof w?!0:g instanceof Error&&g.name===b&&g.message===b}class w extends Error{constructor(){super(b),this.name=this.message}}t.$5=w;function P(){const g=new Error(b);return g.name=g.message,g}function c(g){return g?new Error(`Illegal argument: ${g}`):new Error("Illegal argument")}function f(g){return g?new Error(`Illegal state: ${g}`):new Error("Illegal state")}class e extends TypeError{constructor(r){super(r?`${r} is read-only and cannot be changed`:"Cannot change read-only property")}}t.$9=e;function n(g){return g?g.message?g.message:g.stack?g.stack.split(`
`)[0]:String(g):"Error"}class h extends Error{constructor(r){super("NotImplemented"),r&&(this.message=r)}}t.$$=h;class m extends Error{constructor(r){super("NotSupported"),r&&(this.message=r)}}t.$_=m;class p extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.$ab=p;class v extends Error{constructor(r){super(r),this.name="CodeExpectedError"}static fromError(r){if(r instanceof v)return r;const B=new v;return B.message=r.message,B.stack=r.stack,B}static isErrorNoTelemetry(r){return r.name==="CodeExpectedError"}}t.$bb=v;class o extends Error{constructor(r){super(r||"An unexpected bug occurred."),Object.setPrototypeOf(this,o.prototype)}}t.$cb=o}),define(be[12],$e([1,0,6,75]),function(ne,t,i,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bc=t.$ac=t.$_b=t.$0b=t.$9b=t.CompareResult=void 0,t.$sb=z,t.$tb=H,t.$ub=E,t.$vb=k,t.$wb=b,t.$xb=$,t.$yb=w,t.$zb=P,t.$Ab=c,t.$Bb=f,t.$Cb=e,t.$Db=n,t.$Eb=h,t.top=m,t.$Gb=p,t.$Hb=o,t.$Ib=g,t.$Jb=r,t.$Kb=B,t.$Lb=C,t.$Mb=L,t.$Nb=M,t.$Ob=O,t.$Pb=y,t.$Qb=x,t.$Rb=q,t.$Sb=I,t.$Tb=j,t.$Ub=T,t.$Vb=Q,t.$Wb=Z,t.$Xb=ce,t.$Yb=oe,t.$Zb=te,t.$1b=de,t.$2b=Be,t.$3b=Fe,t.$4b=Pe,t.$5b=le,t.$6b=_,t.$7b=J,t.$8b=G,t.$$b=ye;function z(u,S=0){return u[u.length-(1+S)]}function H(u){if(u.length===0)throw new Error("Invalid tail call");return[u.slice(0,u.length-1),u[u.length-1]]}function E(u,S,D=(a,d)=>a===d){if(u===S)return!0;if(!u||!S||u.length!==S.length)return!1;for(let a=0,d=u.length;a<d;a++)if(!D(u[a],S[a]))return!1;return!0}function k(u,S){const D=u.length-1;S<D&&(u[S]=u[D]),u.pop()}function b(u,S,D){return $(u.length,a=>D(u[a],S))}function $(u,S){let D=0,a=u-1;for(;D<=a;){const d=(D+a)/2|0,s=S(d);if(s<0)D=d+1;else if(s>0)a=d-1;else return d}return-(D+1)}function w(u,S,D){if(u=u|0,u>=S.length)throw new TypeError("invalid index");const a=S[Math.floor(S.length*Math.random())],d=[],s=[],l=[];for(const F of S){const A=D(F,a);A<0?d.push(F):A>0?s.push(F):l.push(F)}return u<d.length?w(u,d,D):u<d.length+l.length?l[0]:w(u-(d.length+l.length),s,D)}function P(u,S){const D=[];let a;for(const d of u.slice(0).sort(S))!a||S(a[0],d)!==0?(a=[d],D.push(a)):a.push(d);return D}function*c(u,S){let D,a;for(const d of u)a!==void 0&&S(a,d)?D.push(d):(D&&(yield D),D=[d]),a=d;D&&(yield D)}function f(u,S){for(let D=0;D<=u.length;D++)S(D===0?void 0:u[D-1],D===u.length?void 0:u[D])}function e(u,S){for(let D=0;D<u.length;D++)S(D===0?void 0:u[D-1],u[D],D+1===u.length?void 0:u[D+1])}function n(u,S,D){const a=[];function d(F,A,R){if(A===0&&R.length===0)return;const W=a[a.length-1];W&&W.start+W.deleteCount===F?(W.deleteCount+=A,W.toInsert.push(...R)):a.push({start:F,deleteCount:A,toInsert:R})}let s=0,l=0;for(;;){if(s===u.length){d(s,0,S.slice(l));break}if(l===S.length){d(s,u.length-s,[]);break}const F=u[s],A=S[l],R=D(F,A);R===0?(s+=1,l+=1):R<0?(d(s,1,[]),s+=1):R>0&&(d(s,0,[A]),l+=1)}return a}function h(u,S,D){const a=n(u,S,D),d=[],s=[];for(const l of a)d.push(...u.slice(l.start,l.start+l.deleteCount)),s.push(...l.toInsert);return{removed:d,added:s}}function m(u,S,D){if(D===0)return[];const a=u.slice(0,D).sort(S);return v(u,S,a,D,u.length),a}function p(u,S,D,a,d){return D===0?Promise.resolve([]):new Promise((s,l)=>{(async()=>{const F=u.length,A=u.slice(0,D).sort(S);for(let R=D,W=Math.min(D+a,F);R<F;R=W,W=Math.min(W+a,F)){if(R>D&&await new Promise(X=>setTimeout(X)),d&&d.isCancellationRequested)throw new i.$5;v(u,S,A,R,W)}return A})().then(s,l)})}function v(u,S,D,a,d){for(const s=D.length;a<d;a++){const l=u[a];if(S(l,D[s-1])<0){D.pop();const F=(0,N.$kb)(D,A=>S(l,A)<0);D.splice(F,0,l)}}}function o(u){return u.filter(S=>!!S)}function g(u){let S=0;for(let D=0;D<u.length;D++)u[D]&&(u[S]=u[D],S+=1);u.length=S}function r(u,S,D){u.splice(D,0,u.splice(S,1)[0])}function B(u){return!Array.isArray(u)||u.length===0}function C(u){return Array.isArray(u)&&u.length>0}function L(u,S=D=>D){const D=new Set;return u.filter(a=>{const d=S(a);return D.has(d)?!1:(D.add(d),!0)})}function M(u){const S=new Set;return D=>{const a=u(D);return S.has(a)?!1:(S.add(a),!0)}}function O(u,S){return u.length>0?u[0]:S}function y(u,S){return u.length>0?u[u.length-1]:S}function x(u,S,D=(a,d)=>a===d){let a=0;for(let d=0,s=Math.min(u.length,S.length);d<s&&D(u[d],S[d]);d++)a++;return a}function q(u){return[].concat(...u)}function I(u,S){let D=typeof S=="number"?u:0;typeof S=="number"?D=u:(D=0,S=u);const a=[];if(D<=S)for(let d=D;d<S;d++)a.push(d);else for(let d=D;d>S;d--)a.push(d);return a}function j(u,S,D){return u.reduce((a,d)=>(a[S(d)]=D?D(d):d,a),Object.create(null))}function T(u,S){return u.push(S),()=>Q(u,S)}function Q(u,S){const D=u.indexOf(S);if(D>-1)return u.splice(D,1),S}function Z(u,S,D){const a=u.slice(0,S),d=u.slice(S);return a.concat(D,d)}function ce(u,S){let D;if(typeof S=="number"){let a=S;D=()=>{const d=Math.sin(a++)*179426549;return d-Math.floor(d)}}else D=Math.random;for(let a=u.length-1;a>0;a-=1){const d=Math.floor(D()*(a+1)),s=u[a];u[a]=u[d],u[d]=s}}function oe(u,S){const D=u.indexOf(S);D>-1&&(u.splice(D,1),u.unshift(S))}function te(u,S){const D=u.indexOf(S);D>-1&&(u.splice(D,1),u.push(S))}function de(u,S){for(const D of S)u.push(D)}function Be(u,S){return Array.isArray(u)?u.map(S):S(u)}function Fe(u){return Array.isArray(u)?u:[u]}function Pe(u){return u[Math.floor(Math.random()*u.length)]}function le(u,S,D){const a=ae(u,S),d=u.length,s=D.length;u.length=d+s;for(let l=d-1;l>=a;l--)u[l+s]=u[l];for(let l=0;l<s;l++)u[l+a]=D[l]}function _(u,S,D,a){const d=ae(u,S);let s=u.splice(d,D);return s===void 0&&(s=[]),le(u,d,a),s}function ae(u,S){return S<0?Math.max(S+u.length,0):Math.min(S,u.length)}var re;(function(u){function S(s){return s<0}u.isLessThan=S;function D(s){return s<=0}u.isLessThanOrEqual=D;function a(s){return s>0}u.isGreaterThan=a;function d(s){return s===0}u.isNeitherLessOrGreaterThan=d,u.greaterThan=1,u.lessThan=-1,u.neitherLessOrGreaterThan=0})(re||(t.CompareResult=re={}));function J(u,S){return(D,a)=>S(u(D),u(a))}function G(...u){return(S,D)=>{for(const a of u){const d=a(S,D);if(!re.isNeitherLessOrGreaterThan(d))return d}return re.neitherLessOrGreaterThan}}const ie=(u,S)=>u-S;t.$9b=ie;const ue=(u,S)=>(0,t.$9b)(u?1:0,S?1:0);t.$0b=ue;function ye(u){return(S,D)=>-u(S,D)}class Ne{constructor(S){this.g=S,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(S){let D=this.c;for(;D<this.g.length&&S(this.g[D]);)D++;const a=D===this.c?null:this.g.slice(this.c,D);return this.c=D,a}takeFromEndWhile(S){let D=this.d;for(;D>=0&&S(this.g[D]);)D--;const a=D===this.d?null:this.g.slice(D+1,this.d+1);return this.d=D,a}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const S=this.g[this.c];return this.c++,S}removeLast(){const S=this.g[this.d];return this.d--,S}takeCount(S){const D=this.g.slice(this.c,this.c+S);return this.c+=S,D}}t.$_b=Ne;class Ae{static{this.empty=new Ae(S=>{})}constructor(S){this.iterate=S}forEach(S){this.iterate(D=>(S(D),!0))}toArray(){const S=[];return this.iterate(D=>(S.push(D),!0)),S}filter(S){return new Ae(D=>this.iterate(a=>S(a)?D(a):!0))}map(S){return new Ae(D=>this.iterate(a=>D(S(a))))}some(S){let D=!1;return this.iterate(a=>(D=S(a),!D)),D}findFirst(S){let D;return this.iterate(a=>S(a)?(D=a,!1):!0),D}findLast(S){let D;return this.iterate(a=>(S(a)&&(D=a),!0)),D}findLastMaxBy(S){let D,a=!0;return this.iterate(d=>((a||re.isGreaterThan(S(d,D)))&&(a=!1,D=d),!0)),D}}t.$ac=Ae;class ge{constructor(S){this.c=S}static createSortPermutation(S,D){const a=Array.from(S.keys()).sort((d,s)=>D(S[d],S[s]));return new ge(a)}apply(S){return S.map((D,a)=>S[this.c[a]])}inverse(){const S=this.c.slice();for(let D=0;D<this.c.length;D++)S[this.c[D]]=D;return new ge(S)}}t.$bc=ge}),define(be[79],$e([1,0,6]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=N,t.$0c=z,t.$$c=H,t.$_c=E,t.$ad=k,t.$bd=b;function N($,w){if(!$)throw new Error(w?`Assertion failed (${w})`:"Assertion Failed")}function z($,w="Unreachable"){throw new Error(w)}function H($){if(!$)throw new i.$cb("Assertion Failed")}function E($){$||(0,i.$1)(new i.$cb("Soft Assertion Failed"))}function k($){if(!$()){debugger;$(),(0,i.$1)(new i.$cb("Assertion Failed"))}}function b($,w){let P=0;for(;P<$.length-1;){const c=$[P],f=$[P+1];if(!w(c,f))return!1;P++}return!0}}),define(be[47],$e([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$db=i;function i(N,z){const H=this;let E=!1,k;return function(){if(E)return k;if(E=!0,z)try{k=N.apply(H,arguments)}finally{z()}else k=N.apply(H,arguments);return k}}}),define(be[80],$e([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$KO=t.$JO=void 0;class i{constructor(z){this.a=z,this.b=0}nextId(){return this.a+ ++this.b}}t.$JO=i,t.$KO=new i("id#")}),define(be[29],$e([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var i;(function(N){function z(r){return r&&typeof r=="object"&&typeof r[Symbol.iterator]=="function"}N.is=z;const H=Object.freeze([]);function E(){return H}N.empty=E;function*k(r){yield r}N.single=k;function b(r){return z(r)?r:k(r)}N.wrap=b;function $(r){return r||H}N.from=$;function*w(r){for(let B=r.length-1;B>=0;B--)yield r[B]}N.reverse=w;function P(r){return!r||r[Symbol.iterator]().next().done===!0}N.isEmpty=P;function c(r){return r[Symbol.iterator]().next().value}N.first=c;function f(r,B){for(const C of r)if(B(C))return!0;return!1}N.some=f;function e(r,B){for(const C of r)if(B(C))return C}N.find=e;function*n(r,B){for(const C of r)B(C)&&(yield C)}N.filter=n;function*h(r,B){let C=0;for(const L of r)yield B(L,C++)}N.map=h;function*m(...r){for(const B of r)yield*B}N.concat=m;function p(r,B,C){let L=C;for(const M of r)L=B(L,M);return L}N.reduce=p;function*v(r,B,C=r.length){for(B<0&&(B+=r.length),C<0?C+=r.length:C>r.length&&(C=r.length);B<C;B++)yield r[B]}N.slice=v;function o(r,B=Number.POSITIVE_INFINITY){const C=[];if(B===0)return[C,r];const L=r[Symbol.iterator]();for(let M=0;M<B;M++){const O=L.next();if(O.done)return[C,N.empty()];C.push(O.value)}return[C,{[Symbol.iterator](){return L}}]}N.consume=o;async function g(r){const B=[];for await(const C of r)B.push(C);return Promise.resolve(B)}N.asyncToArray=g})(i||(t.Iterable=i={}))}),define(be[48],$e([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.KeyMod=t.KeyCodeUtils=t.$mr=t.$lr=t.$kr=t.$jr=t.$ir=t.ScanCode=t.KeyCode=void 0,t.$nr=f;var i;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(i||(t.KeyCode=i={}));var N;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(N||(t.ScanCode=N={}));class z{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(n,h){this._keyCodeToStr[n]=h,this._strToKeyCode[h.toLowerCase()]=n}keyCodeToStr(n){return this._keyCodeToStr[n]}strToKeyCode(n){return this._strToKeyCode[n.toLowerCase()]||0}}const H=new z,E=new z,k=new z;t.$ir=new Array(230),t.$jr={};const b=[],$=Object.create(null),w=Object.create(null);t.$kr={lowerCaseToEnum:e=>w[e]||0,toEnum:e=>$[e]||0,toString:e=>b[e]||"None"},t.$lr=[],t.$mr=[];for(let e=0;e<=193;e++)t.$lr[e]=-1;for(let e=0;e<=132;e++)t.$mr[e]=-1;(function(){const e="",n=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[1,1,"Hyper",0,e,0,e,e,e],[1,2,"Super",0,e,0,e,e,e],[1,3,"Fn",0,e,0,e,e,e],[1,4,"FnLock",0,e,0,e,e,e],[1,5,"Suspend",0,e,0,e,e,e],[1,6,"Resume",0,e,0,e,e,e],[1,7,"Turbo",0,e,0,e,e,e],[1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[1,9,"WakeUp",0,e,0,e,e,e],[0,10,"KeyA",31,"A",65,"VK_A",e,e],[0,11,"KeyB",32,"B",66,"VK_B",e,e],[0,12,"KeyC",33,"C",67,"VK_C",e,e],[0,13,"KeyD",34,"D",68,"VK_D",e,e],[0,14,"KeyE",35,"E",69,"VK_E",e,e],[0,15,"KeyF",36,"F",70,"VK_F",e,e],[0,16,"KeyG",37,"G",71,"VK_G",e,e],[0,17,"KeyH",38,"H",72,"VK_H",e,e],[0,18,"KeyI",39,"I",73,"VK_I",e,e],[0,19,"KeyJ",40,"J",74,"VK_J",e,e],[0,20,"KeyK",41,"K",75,"VK_K",e,e],[0,21,"KeyL",42,"L",76,"VK_L",e,e],[0,22,"KeyM",43,"M",77,"VK_M",e,e],[0,23,"KeyN",44,"N",78,"VK_N",e,e],[0,24,"KeyO",45,"O",79,"VK_O",e,e],[0,25,"KeyP",46,"P",80,"VK_P",e,e],[0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[0,27,"KeyR",48,"R",82,"VK_R",e,e],[0,28,"KeyS",49,"S",83,"VK_S",e,e],[0,29,"KeyT",50,"T",84,"VK_T",e,e],[0,30,"KeyU",51,"U",85,"VK_U",e,e],[0,31,"KeyV",52,"V",86,"VK_V",e,e],[0,32,"KeyW",53,"W",87,"VK_W",e,e],[0,33,"KeyX",54,"X",88,"VK_X",e,e],[0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[0,36,"Digit1",22,"1",49,"VK_1",e,e],[0,37,"Digit2",23,"2",50,"VK_2",e,e],[0,38,"Digit3",24,"3",51,"VK_3",e,e],[0,39,"Digit4",25,"4",52,"VK_4",e,e],[0,40,"Digit5",26,"5",53,"VK_5",e,e],[0,41,"Digit6",27,"6",54,"VK_6",e,e],[0,42,"Digit7",28,"7",55,"VK_7",e,e],[0,43,"Digit8",29,"8",56,"VK_8",e,e],[0,44,"Digit9",30,"9",57,"VK_9",e,e],[0,45,"Digit0",21,"0",48,"VK_0",e,e],[1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,e,0,e,e,e],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[1,64,"F1",59,"F1",112,"VK_F1",e,e],[1,65,"F2",60,"F2",113,"VK_F2",e,e],[1,66,"F3",61,"F3",114,"VK_F3",e,e],[1,67,"F4",62,"F4",115,"VK_F4",e,e],[1,68,"F5",63,"F5",116,"VK_F5",e,e],[1,69,"F6",64,"F6",117,"VK_F6",e,e],[1,70,"F7",65,"F7",118,"VK_F7",e,e],[1,71,"F8",66,"F8",119,"VK_F8",e,e],[1,72,"F9",67,"F9",120,"VK_F9",e,e],[1,73,"F10",68,"F10",121,"VK_F10",e,e],[1,74,"F11",69,"F11",122,"VK_F11",e,e],[1,75,"F12",70,"F12",123,"VK_F12",e,e],[1,76,"PrintScreen",0,e,0,e,e,e],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",e,e],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[1,80,"Home",14,"Home",36,"VK_HOME",e,e],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[1,83,"End",13,"End",35,"VK_END",e,e],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",e,e],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",e,e],[1,94,"NumpadEnter",3,e,0,e,e,e],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",e,e],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",e,e],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",e,e],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",e,e],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",e,e],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",e,e],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",e,e],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",e,e],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",e,e],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",e,e],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",e,e],[1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[1,108,"Power",0,e,0,e,e,e],[1,109,"NumpadEqual",0,e,0,e,e,e],[1,110,"F13",71,"F13",124,"VK_F13",e,e],[1,111,"F14",72,"F14",125,"VK_F14",e,e],[1,112,"F15",73,"F15",126,"VK_F15",e,e],[1,113,"F16",74,"F16",127,"VK_F16",e,e],[1,114,"F17",75,"F17",128,"VK_F17",e,e],[1,115,"F18",76,"F18",129,"VK_F18",e,e],[1,116,"F19",77,"F19",130,"VK_F19",e,e],[1,117,"F20",78,"F20",131,"VK_F20",e,e],[1,118,"F21",79,"F21",132,"VK_F21",e,e],[1,119,"F22",80,"F22",133,"VK_F22",e,e],[1,120,"F23",81,"F23",134,"VK_F23",e,e],[1,121,"F24",82,"F24",135,"VK_F24",e,e],[1,122,"Open",0,e,0,e,e,e],[1,123,"Help",0,e,0,e,e,e],[1,124,"Select",0,e,0,e,e,e],[1,125,"Again",0,e,0,e,e,e],[1,126,"Undo",0,e,0,e,e,e],[1,127,"Cut",0,e,0,e,e,e],[1,128,"Copy",0,e,0,e,e,e],[1,129,"Paste",0,e,0,e,e,e],[1,130,"Find",0,e,0,e,e,e],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,136,"KanaMode",0,e,0,e,e,e],[0,137,"IntlYen",0,e,0,e,e,e],[1,138,"Convert",0,e,0,e,e,e],[1,139,"NonConvert",0,e,0,e,e,e],[1,140,"Lang1",0,e,0,e,e,e],[1,141,"Lang2",0,e,0,e,e,e],[1,142,"Lang3",0,e,0,e,e,e],[1,143,"Lang4",0,e,0,e,e,e],[1,144,"Lang5",0,e,0,e,e,e],[1,145,"Abort",0,e,0,e,e,e],[1,146,"Props",0,e,0,e,e,e],[1,147,"NumpadParenLeft",0,e,0,e,e,e],[1,148,"NumpadParenRight",0,e,0,e,e,e],[1,149,"NumpadBackspace",0,e,0,e,e,e],[1,150,"NumpadMemoryStore",0,e,0,e,e,e],[1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[1,152,"NumpadMemoryClear",0,e,0,e,e,e],[1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",e,e],[1,156,"NumpadClearEntry",0,e,0,e,e,e],[1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[1,0,e,6,"Alt",18,"VK_MENU",e,e],[1,0,e,57,"Meta",91,"VK_COMMAND",e,e],[1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[1,165,"BrightnessUp",0,e,0,e,e,e],[1,166,"BrightnessDown",0,e,0,e,e,e],[1,167,"MediaPlay",0,e,0,e,e,e],[1,168,"MediaRecord",0,e,0,e,e,e],[1,169,"MediaFastForward",0,e,0,e,e,e],[1,170,"MediaRewind",0,e,0,e,e,e],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,174,"Eject",0,e,0,e,e,e],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,180,"SelectTask",0,e,0,e,e,e],[1,181,"LaunchScreenSaver",0,e,0,e,e,e],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[1,189,"ZoomToggle",0,e,0,e,e,e],[1,190,"MailReply",0,e,0,e,e,e],[1,191,"MailForward",0,e,0,e,e,e],[1,192,"MailSend",0,e,0,e,e,e],[1,0,e,114,"KeyInComposition",229,e,e,e],[1,0,e,116,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,0,e,96,"OEM_8",223,"VK_OEM_8",e,e],[1,0,e,0,e,0,"VK_KANA",e,e],[1,0,e,0,e,0,"VK_HANGUL",e,e],[1,0,e,0,e,0,"VK_JUNJA",e,e],[1,0,e,0,e,0,"VK_FINAL",e,e],[1,0,e,0,e,0,"VK_HANJA",e,e],[1,0,e,0,e,0,"VK_KANJI",e,e],[1,0,e,0,e,0,"VK_CONVERT",e,e],[1,0,e,0,e,0,"VK_NONCONVERT",e,e],[1,0,e,0,e,0,"VK_ACCEPT",e,e],[1,0,e,0,e,0,"VK_MODECHANGE",e,e],[1,0,e,0,e,0,"VK_SELECT",e,e],[1,0,e,0,e,0,"VK_PRINT",e,e],[1,0,e,0,e,0,"VK_EXECUTE",e,e],[1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[1,0,e,0,e,0,"VK_HELP",e,e],[1,0,e,0,e,0,"VK_APPS",e,e],[1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[1,0,e,0,e,0,"VK_PACKET",e,e],[1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[1,0,e,0,e,0,"VK_ATTN",e,e],[1,0,e,0,e,0,"VK_CRSEL",e,e],[1,0,e,0,e,0,"VK_EXSEL",e,e],[1,0,e,0,e,0,"VK_EREOF",e,e],[1,0,e,0,e,0,"VK_PLAY",e,e],[1,0,e,0,e,0,"VK_ZOOM",e,e],[1,0,e,0,e,0,"VK_NONAME",e,e],[1,0,e,0,e,0,"VK_PA1",e,e],[1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],h=[],m=[];for(const p of n){const[v,o,g,r,B,C,L,M,O]=p;if(m[o]||(m[o]=!0,b[o]=g,$[g]=o,w[g.toLowerCase()]=o,v&&(t.$lr[o]=r,r!==0&&r!==3&&r!==5&&r!==4&&r!==6&&r!==57&&(t.$mr[r]=o))),!h[r]){if(h[r]=!0,!B)throw new Error(`String representation missing for key code ${r} around scan code ${g}`);H.define(r,B),E.define(r,M||B),k.define(r,O||M||B)}C&&(t.$ir[C]=r),L&&(t.$jr[L]=r)}t.$mr[3]=46})();var P;(function(e){function n(g){return H.keyCodeToStr(g)}e.toString=n;function h(g){return H.strToKeyCode(g)}e.fromString=h;function m(g){return E.keyCodeToStr(g)}e.toUserSettingsUS=m;function p(g){return k.keyCodeToStr(g)}e.toUserSettingsGeneral=p;function v(g){return E.strToKeyCode(g)||k.strToKeyCode(g)}e.fromUserSettings=v;function o(g){if(g>=98&&g<=113)return null;switch(g){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return H.keyCodeToStr(g)}e.toElectronAccelerator=o})(P||(t.KeyCodeUtils=P={}));var c;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(c||(t.KeyMod=c={}));function f(e,n){const h=(n&65535)<<16>>>0;return(e|h)>>>0}}),define(be[81],$e([1,0,6]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ur=t.$tr=t.$sr=t.$rr=t.$qr=void 0,t.$or=z,t.$pr=H;var N;(function(P){P[P.CtrlCmd=2048]="CtrlCmd",P[P.Shift=1024]="Shift",P[P.Alt=512]="Alt",P[P.WinCtrl=256]="WinCtrl",P[P.KeyCode=255]="KeyCode"})(N||(N={}));function z(P,c){if(typeof P=="number"){if(P===0)return null;const f=(P&65535)>>>0,e=(P&4294901760)>>>16;return e!==0?new b([H(f,c),H(e,c)]):new b([H(f,c)])}else{const f=[];for(let e=0;e<P.length;e++)f.push(H(P[e],c));return new b(f)}}function H(P,c){const f=!!(P&2048),e=!!(P&256),n=c===2?e:f,h=!!(P&1024),m=!!(P&512),p=c===2?f:e,v=P&255;return new E(n,h,m,p,v)}class E{constructor(c,f,e,n,h){this.ctrlKey=c,this.shiftKey=f,this.altKey=e,this.metaKey=n,this.keyCode=h}equals(c){return c instanceof E&&this.ctrlKey===c.ctrlKey&&this.shiftKey===c.shiftKey&&this.altKey===c.altKey&&this.metaKey===c.metaKey&&this.keyCode===c.keyCode}getHashCode(){const c=this.ctrlKey?"1":"0",f=this.shiftKey?"1":"0",e=this.altKey?"1":"0",n=this.metaKey?"1":"0";return`K${c}${f}${e}${n}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toKeybinding(){return new b([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}t.$qr=E;class k{constructor(c,f,e,n,h){this.ctrlKey=c,this.shiftKey=f,this.altKey=e,this.metaKey=n,this.scanCode=h}equals(c){return c instanceof k&&this.ctrlKey===c.ctrlKey&&this.shiftKey===c.shiftKey&&this.altKey===c.altKey&&this.metaKey===c.metaKey&&this.scanCode===c.scanCode}getHashCode(){const c=this.ctrlKey?"1":"0",f=this.shiftKey?"1":"0",e=this.altKey?"1":"0",n=this.metaKey?"1":"0";return`S${c}${f}${e}${n}${this.scanCode}`}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}t.$rr=k;class b{constructor(c){if(c.length===0)throw(0,i.$7)("chords");this.chords=c}getHashCode(){let c="";for(let f=0,e=this.chords.length;f<e;f++)f!==0&&(c+=";"),c+=this.chords[f].getHashCode();return c}equals(c){if(c===null||this.chords.length!==c.chords.length)return!1;for(let f=0;f<this.chords.length;f++)if(!this.chords[f].equals(c.chords[f]))return!1;return!0}}t.$sr=b;class ${constructor(c,f,e,n,h,m){this.ctrlKey=c,this.shiftKey=f,this.altKey=e,this.metaKey=n,this.keyLabel=h,this.keyAriaLabel=m}}t.$tr=$;class w{}t.$ur=w}),define(be[23],$e([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$V=void 0;class i{constructor(z){this.d=z,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(z){this.c=z}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}t.$V=i}),define(be[14],$e([1,0,23]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1S=k,t.$2S=b,t.$3S=$;let z=()=>({get delay(){return-1},dispose:()=>{},showHover:()=>{}});const H=new i.$V(()=>z("mouse",!1)),E=new i.$V(()=>z("element",!1));function k(w){z=w}function b(w){return w==="element"?E.value:H.value}function $(){return z("element",!0)}}),define(be[49],$e([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5c=void 0;class i{static{this.Undefined=new i(void 0)}constructor(H){this.element=H,this.next=i.Undefined,this.prev=i.Undefined}}class N{constructor(){this.a=i.Undefined,this.b=i.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===i.Undefined}clear(){let H=this.a;for(;H!==i.Undefined;){const E=H.next;H.prev=i.Undefined,H.next=i.Undefined,H=E}this.a=i.Undefined,this.b=i.Undefined,this.c=0}unshift(H){return this.d(H,!1)}push(H){return this.d(H,!0)}d(H,E){const k=new i(H);if(this.a===i.Undefined)this.a=k,this.b=k;else if(E){const $=this.b;this.b=k,k.prev=$,$.next=k}else{const $=this.a;this.a=k,k.next=$,$.prev=k}this.c+=1;let b=!1;return()=>{b||(b=!0,this.e(k))}}shift(){if(this.a!==i.Undefined){const H=this.a.element;return this.e(this.a),H}}pop(){if(this.b!==i.Undefined){const H=this.b.element;return this.e(this.b),H}}e(H){if(H.prev!==i.Undefined&&H.next!==i.Undefined){const E=H.prev;E.next=H.next,H.next.prev=E}else H.prev===i.Undefined&&H.next===i.Undefined?(this.a=i.Undefined,this.b=i.Undefined):H.next===i.Undefined?(this.b=this.b.prev,this.b.next=i.Undefined):H.prev===i.Undefined&&(this.a=this.a.next,this.a.prev=i.Undefined);this.c-=1}*[Symbol.iterator](){let H=this.a;for(;H!==i.Undefined;)yield H.element,H=H.next}}t.$5c=N}),define(be[34],$e([1,0]),function(ne,t){"use strict";var i,N,z;Object.defineProperty(t,"__esModule",{value:!0}),t.$Hc=t.$Gc=t.$Fc=t.$Ec=t.$Dc=t.Touch=t.$Cc=t.$Bc=void 0,t.$yc=H,t.$zc=E,t.$Ac=k,t.$Ic=p;function H(v,o,g){let r=v.get(o);return r===void 0&&(r=g,v.set(o,r)),r}function E(v){const o=[];return v.forEach((g,r)=>{o.push(`${r} => ${g}`)}),`Map(${v.size}) {${o.join(", ")}}`}function k(v){const o=[];return v.forEach(g=>{o.push(g)}),`Set(${v.size}) {${o.join(", ")}}`}class b{constructor(o,g){this.uri=o,this.value=g}}function $(v){return Array.isArray(v)}class w{static{this.c=o=>o.toString()}constructor(o,g){if(this[i]="ResourceMap",o instanceof w)this.d=new Map(o.d),this.e=g??w.c;else if($(o)){this.d=new Map,this.e=g??w.c;for(const[r,B]of o)this.set(r,B)}else this.d=new Map,this.e=o??w.c}set(o,g){return this.d.set(this.e(o),new b(o,g)),this}get(o){return this.d.get(this.e(o))?.value}has(o){return this.d.has(this.e(o))}get size(){return this.d.size}clear(){this.d.clear()}delete(o){return this.d.delete(this.e(o))}forEach(o,g){typeof g<"u"&&(o=o.bind(g));for(const[r,B]of this.d)o(B.value,B.uri,this)}*values(){for(const o of this.d.values())yield o.value}*keys(){for(const o of this.d.values())yield o.uri}*entries(){for(const o of this.d.values())yield[o.uri,o.value]}*[(i=Symbol.toStringTag,Symbol.iterator)](){for(const[,o]of this.d)yield[o.uri,o.value]}}t.$Bc=w;class P{constructor(o,g){this[N]="ResourceSet",!o||typeof o=="function"?this.c=new w(o):(this.c=new w(g),o.forEach(this.add,this))}get size(){return this.c.size}add(o){return this.c.set(o,o),this}clear(){this.c.clear()}delete(o){return this.c.delete(o)}forEach(o,g){this.c.forEach((r,B)=>o.call(g,B,B,this))}has(o){return this.c.has(o)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(N=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.$Cc=P;var c;(function(v){v[v.None=0]="None",v[v.AsOld=1]="AsOld",v[v.AsNew=2]="AsNew"})(c||(t.Touch=c={}));class f{constructor(){this[z]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(o){return this.c.has(o)}get(o,g=0){const r=this.c.get(o);if(r)return g!==0&&this.l(r,g),r.value}set(o,g,r=0){let B=this.c.get(o);if(B)B.value=g,r!==0&&this.l(B,r);else{switch(B={key:o,value:g,next:void 0,previous:void 0},r){case 0:this.j(B);break;case 1:this.i(B);break;case 2:this.j(B);break;default:this.j(B);break}this.c.set(o,B),this.f++}return this}delete(o){return!!this.remove(o)}remove(o){const g=this.c.get(o);if(g)return this.c.delete(o),this.k(g),this.f--,g.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const o=this.d;return this.c.delete(o.key),this.k(o),this.f--,o.value}forEach(o,g){const r=this.g;let B=this.d;for(;B;){if(g?o.bind(g)(B.value,B.key,this):o(B.value,B.key,this),this.g!==r)throw new Error("LinkedMap got modified during iteration.");B=B.next}}keys(){const o=this,g=this.g;let r=this.d;const B={[Symbol.iterator](){return B},next(){if(o.g!==g)throw new Error("LinkedMap got modified during iteration.");if(r){const C={value:r.key,done:!1};return r=r.next,C}else return{value:void 0,done:!0}}};return B}values(){const o=this,g=this.g;let r=this.d;const B={[Symbol.iterator](){return B},next(){if(o.g!==g)throw new Error("LinkedMap got modified during iteration.");if(r){const C={value:r.value,done:!1};return r=r.next,C}else return{value:void 0,done:!0}}};return B}entries(){const o=this,g=this.g;let r=this.d;const B={[Symbol.iterator](){return B},next(){if(o.g!==g)throw new Error("LinkedMap got modified during iteration.");if(r){const C={value:[r.key,r.value],done:!1};return r=r.next,C}else return{value:void 0,done:!0}}};return B}[(z=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(o){if(o>=this.size)return;if(o===0){this.clear();return}let g=this.d,r=this.size;for(;g&&r>o;)this.c.delete(g.key),g=g.next,r--;this.d=g,this.f=r,g&&(g.previous=void 0),this.g++}i(o){if(!this.d&&!this.e)this.e=o;else if(this.d)o.next=this.d,this.d.previous=o;else throw new Error("Invalid list");this.d=o,this.g++}j(o){if(!this.d&&!this.e)this.d=o;else if(this.e)o.previous=this.e,this.e.next=o;else throw new Error("Invalid list");this.e=o,this.g++}k(o){if(o===this.d&&o===this.e)this.d=void 0,this.e=void 0;else if(o===this.d){if(!o.next)throw new Error("Invalid list");o.next.previous=void 0,this.d=o.next}else if(o===this.e){if(!o.previous)throw new Error("Invalid list");o.previous.next=void 0,this.e=o.previous}else{const g=o.next,r=o.previous;if(!g||!r)throw new Error("Invalid list");g.previous=r,r.next=g}o.next=void 0,o.previous=void 0,this.g++}l(o,g){if(!this.d||!this.e)throw new Error("Invalid list");if(!(g!==1&&g!==2)){if(g===1){if(o===this.d)return;const r=o.next,B=o.previous;o===this.e?(B.next=void 0,this.e=B):(r.previous=B,B.next=r),o.previous=void 0,o.next=this.d,this.d.previous=o,this.d=o,this.g++}else if(g===2){if(o===this.e)return;const r=o.next,B=o.previous;o===this.d?(r.previous=void 0,this.d=r):(r.previous=B,B.next=r),o.next=void 0,o.previous=this.e,this.e.next=o,this.e=o,this.g++}}}toJSON(){const o=[];return this.forEach((g,r)=>{o.push([r,g])}),o}fromJSON(o){this.clear();for(const[g,r]of o)this.set(g,r)}}t.$Dc=f;class e extends f{constructor(o,g=1){super(),this.m=o,this.n=Math.min(Math.max(0,g),1)}get limit(){return this.m}set limit(o){this.m=o,this.o()}get ratio(){return this.n}set ratio(o){this.n=Math.min(Math.max(0,o),1),this.o()}get(o,g=2){return super.get(o,g)}peek(o){return super.get(o,0)}set(o,g){return super.set(o,g,2),this.o(),this}o(){this.size>this.m&&this.h(Math.round(this.m*this.n))}}t.$Ec=e;class n{constructor(){this.c=new Map}add(o){return this.c.set(o,(this.c.get(o)||0)+1),this}delete(o){let g=this.c.get(o)||0;return g===0?!1:(g--,g===0?this.c.delete(o):this.c.set(o,g),!0)}has(o){return this.c.has(o)}}t.$Fc=n;class h{constructor(o){if(this.c=new Map,this.d=new Map,o)for(const[g,r]of o)this.set(g,r)}clear(){this.c.clear(),this.d.clear()}set(o,g){this.c.set(o,g),this.d.set(g,o)}get(o){return this.c.get(o)}getKey(o){return this.d.get(o)}delete(o){const g=this.c.get(o);return g===void 0?!1:(this.c.delete(o),this.d.delete(g),!0)}forEach(o,g){this.c.forEach((r,B)=>{o.call(g,r,B,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}t.$Gc=h;class m{constructor(){this.c=new Map}add(o,g){let r=this.c.get(o);r||(r=new Set,this.c.set(o,r)),r.add(g)}delete(o,g){const r=this.c.get(o);r&&(r.delete(g),r.size===0&&this.c.delete(o))}forEach(o,g){const r=this.c.get(o);r&&r.forEach(g)}get(o){const g=this.c.get(o);return g||new Set}}t.$Hc=m;function p(v,o){if(v===o)return!0;if(v.size!==o.size)return!1;for(const[g,r]of v)if(!o.has(g)||o.get(g)!==r)return!1;for(const[g]of o)if(!v.has(g))return!1;return!0}}),define(be[3],$e([1,0,12,76,34,47,29]),function(ne,t,i,N,z,H,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4c=t.$2c=t.$1c=t.$Zc=t.$Yc=t.$Xc=t.$Wc=t.$Vc=t.$Uc=t.$Tc=t.$Jc=void 0,t.$Kc=w,t.$Lc=P,t.$Mc=c,t.$Nc=n,t.$Oc=h,t.$Pc=m,t.$Qc=p,t.$Rc=v,t.$Sc=o,t.$3c=q;const k=!1;let b=null;class ${constructor(){this.b=new Map}static{this.a=0}c(T){let Q=this.b.get(T);return Q||(Q={parent:null,source:null,isSingleton:!1,value:T,idx:$.a++},this.b.set(T,Q)),Q}trackDisposable(T){const Q=this.c(T);Q.source||(Q.source=new Error().stack)}setParent(T,Q){const Z=this.c(T);Z.parent=Q}markAsDisposed(T){this.b.delete(T)}markAsSingleton(T){this.c(T).isSingleton=!0}f(T,Q){const Z=Q.get(T);if(Z)return Z;const ce=T.parent?this.f(this.c(T.parent),Q):T;return Q.set(T,ce),ce}getTrackedDisposables(){const T=new Map;return[...this.b.entries()].filter(([,Z])=>Z.source!==null&&!this.f(Z,T).isSingleton).flatMap(([Z])=>Z)}computeLeakingDisposables(T=10,Q){let Z;if(Q)Z=Q;else{const Be=new Map,Fe=[...this.b.values()].filter(le=>le.source!==null&&!this.f(le,Be).isSingleton);if(Fe.length===0)return;const Pe=new Set(Fe.map(le=>le.value));if(Z=Fe.filter(le=>!(le.parent&&Pe.has(le.parent))),Z.length===0)throw new Error("There are cyclic diposable chains!")}if(!Z)return;function ce(Be){function Fe(le,_){for(;le.length>0&&_.some(ae=>typeof ae=="string"?ae===le[0]:le[0].match(ae));)le.shift()}const Pe=Be.source.split(`
`).map(le=>le.trim().replace("at ","")).filter(le=>le!=="");return Fe(Pe,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Pe.reverse()}const oe=new z.$Hc;for(const Be of Z){const Fe=ce(Be);for(let Pe=0;Pe<=Fe.length;Pe++)oe.add(Fe.slice(0,Pe).join(`
`),Be)}Z.sort((0,i.$7b)(Be=>Be.idx,i.$9b));let te="",de=0;for(const Be of Z.slice(0,T)){de++;const Fe=ce(Be),Pe=[];for(let le=0;le<Fe.length;le++){let _=Fe[le];_=`(shared with ${oe.get(Fe.slice(0,le+1).join(`
`)).size}/${Z.length} leaks) at ${_}`;const re=oe.get(Fe.slice(0,le).join(`
`)),J=(0,N.$K)([...re].map(G=>ce(G)[le]),G=>G);delete J[Fe[le]];for(const[G,ie]of Object.entries(J))Pe.unshift(`    - stacktraces of ${ie.length} other leaks continue with ${G}`);Pe.unshift(_)}te+=`


==================== Leaking disposable ${de}/${Z.length}: ${Be.value.constructor.name} ====================
${Pe.join(`
`)}
============================================================

`}return Z.length>T&&(te+=`


... and ${Z.length-T} more leaking disposables

`),{leaks:Z,details:te}}}t.$Jc=$;function w(j){b=j}if(k){const j="__is_disposable_tracked__";w(new class{trackDisposable(T){const Q=new Error("Potentially leaked disposable").stack;setTimeout(()=>{T[j]||console.log(Q)},3e3)}setParent(T,Q){if(T&&T!==r.None)try{T[j]=!0}catch{}}markAsDisposed(T){if(T&&T!==r.None)try{T[j]=!0}catch{}}markAsSingleton(T){}})}function P(j){return b?.trackDisposable(j),j}function c(j){b?.markAsDisposed(j)}function f(j,T){b?.setParent(j,T)}function e(j,T){if(b)for(const Q of j)b.setParent(Q,T)}function n(j){return b?.markAsSingleton(j),j}function h(j){return typeof j.dispose=="function"&&j.dispose.length===0}function m(j){if(E.Iterable.is(j)){const T=[];for(const Q of j)if(Q)try{Q.dispose()}catch(Z){T.push(Z)}if(T.length===1)throw T[0];if(T.length>1)throw new AggregateError(T,"Encountered errors while disposing of store");return Array.isArray(j)?[]:j}else if(j)return j.dispose(),j}function p(j){for(const T of j)h(T)&&T.dispose();return[]}function v(...j){const T=o(()=>m(j));return e(j,T),T}function o(j){const T=P({dispose:(0,H.$db)(()=>{c(T),j()})});return T}class g{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,P(this)}dispose(){this.g||(c(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{m(this.f)}finally{this.f.clear()}}add(T){if(!T)return T;if(T===this)throw new Error("Cannot register a disposable on itself!");return f(T,this),this.g?g.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(T),T}delete(T){if(T){if(T===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(T),T.dispose()}}deleteAndLeak(T){T&&this.f.has(T)&&(this.f.delete(T),f(T,null))}}t.$Tc=g;class r{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new g,P(this),f(this.q,this)}dispose(){c(this),this.q.dispose()}B(T){if(T===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(T)}}t.$Uc=r;class B{constructor(){this.b=!1,P(this)}get value(){return this.b?void 0:this.a}set value(T){this.b||T===this.a||(this.a?.dispose(),T&&f(T,this),this.a=T)}clear(){this.value=void 0}dispose(){this.b=!0,c(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const T=this.a;return this.a=void 0,T&&f(T,null),T}}t.$Vc=B;class C{constructor(T){this.a=new B,this.b=!1,this.a.value=T}get value(){return this.a.value}set value(T){this.b||T===this.a.value||(this.a.value=T)}dispose(){this.b=!0,this.a.dispose()}}t.$Wc=C;class L{constructor(T){this.b=T,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}t.$Xc=L;class M{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,P(this)}set(T){let Q=T;return this.unset=()=>Q=void 0,this.isset=()=>Q!==void 0,this.dispose=()=>{Q&&(Q(),Q=void 0,c(this))},this}}t.$Yc=M;class O{constructor(){this.a=new Map}acquire(T,...Q){let Z=this.a.get(T);Z||(Z={counter:0,object:this.b(T,...Q)},this.a.set(T,Z));const{object:ce}=Z,oe=(0,H.$db)(()=>{--Z.counter===0&&(this.c(T,Z.object),this.a.delete(T))});return Z.counter++,{object:ce,dispose:oe}}}t.$Zc=O;class y{constructor(T){this.a=T}async acquire(T,...Q){const Z=this.a.acquire(T,...Q);try{return{object:await Z.object,dispose:()=>Z.dispose()}}catch(ce){throw Z.dispose(),ce}}}t.$1c=y;class x{constructor(T){this.object=T}dispose(){}}t.$2c=x;function q(j){const T=new g;try{j(T)}finally{T.dispose()}}class I{constructor(){this.a=new Map,this.b=!1,P(this)}dispose(){c(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{m(this.a.values())}finally{this.a.clear()}}has(T){return this.a.has(T)}get size(){return this.a.size}get(T){return this.a.get(T)}set(T,Q,Z=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),Z||this.a.get(T)?.dispose(),this.a.set(T,Q)}deleteAndDispose(T){this.a.get(T)?.dispose(),this.a.delete(T)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}t.$4c=I}),function(ne,t){typeof define=="function"&&define.amd?define(be[82],$e([0]),t):typeof exports=="object"&&typeof module<"u"?t(exports):(ne=typeof globalThis<"u"?globalThis:ne||self,t(ne.marked={}))}(this,function(ne){"use strict";function t(u,S){for(var D=0;D<S.length;D++){var a=S[D];a.enumerable=a.enumerable||!1,a.configurable=!0,"value"in a&&(a.writable=!0),Object.defineProperty(u,a.key,a)}}function i(u,S,D){return S&&t(u.prototype,S),D&&t(u,D),Object.defineProperty(u,"prototype",{writable:!1}),u}function N(u,S){if(u){if(typeof u=="string")return z(u,S);var D=Object.prototype.toString.call(u).slice(8,-1);if(D==="Object"&&u.constructor&&(D=u.constructor.name),D==="Map"||D==="Set")return Array.from(u);if(D==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(D))return z(u,S)}}function z(u,S){(S==null||S>u.length)&&(S=u.length);for(var D=0,a=new Array(S);D<S;D++)a[D]=u[D];return a}function H(u,S){var D=typeof Symbol<"u"&&u[Symbol.iterator]||u["@@iterator"];if(D)return(D=D.call(u)).next.bind(D);if(Array.isArray(u)||(D=N(u))||S&&u&&typeof u.length=="number"){D&&(u=D);var a=0;return function(){return a>=u.length?{done:!0}:{done:!1,value:u[a++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function E(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ne.defaults=E();function k(u){ne.defaults=u}var b=/[&<>"']/,$=/[&<>"']/g,w=/[<>"']|&(?!#?\w+;)/,P=/[<>"']|&(?!#?\w+;)/g,c={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},f=function(S){return c[S]};function e(u,S){if(S){if(b.test(u))return u.replace($,f)}else if(w.test(u))return u.replace(P,f);return u}var n=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function h(u){return u.replace(n,function(S,D){return D=D.toLowerCase(),D==="colon"?":":D.charAt(0)==="#"?D.charAt(1)==="x"?String.fromCharCode(parseInt(D.substring(2),16)):String.fromCharCode(+D.substring(1)):""})}var m=/(^|[^\[])\^/g;function p(u,S){u=typeof u=="string"?u:u.source,S=S||"";var D={replace:function(d,s){return s=s.source||s,s=s.replace(m,"$1"),u=u.replace(d,s),D},getRegex:function(){return new RegExp(u,S)}};return D}var v=/[^\w:]/g,o=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function g(u,S,D){if(u){var a;try{a=decodeURIComponent(h(D)).replace(v,"").toLowerCase()}catch{return null}if(a.indexOf("javascript:")===0||a.indexOf("vbscript:")===0||a.indexOf("data:")===0)return null}S&&!o.test(D)&&(D=M(S,D));try{D=encodeURI(D).replace(/%25/g,"%")}catch{return null}return D}var r={},B=/^[^:]+:\/*[^/]*$/,C=/^([^:]+:)[\s\S]*$/,L=/^([^:]+:\/*[^/]*)[\s\S]*$/;function M(u,S){r[" "+u]||(B.test(u)?r[" "+u]=u+"/":r[" "+u]=q(u,"/",!0)),u=r[" "+u];var D=u.indexOf(":")===-1;return S.substring(0,2)==="//"?D?S:u.replace(C,"$1")+S:S.charAt(0)==="/"?D?S:u.replace(L,"$1")+S:u+S}var O={exec:function(){}};function y(u){for(var S=1,D,a;S<arguments.length;S++){D=arguments[S];for(a in D)Object.prototype.hasOwnProperty.call(D,a)&&(u[a]=D[a])}return u}function x(u,S){var D=u.replace(/\|/g,function(s,l,F){for(var A=!1,R=l;--R>=0&&F[R]==="\\";)A=!A;return A?"|":" |"}),a=D.split(/ \|/),d=0;if(a[0].trim()||a.shift(),a.length>0&&!a[a.length-1].trim()&&a.pop(),a.length>S)a.splice(S);else for(;a.length<S;)a.push("");for(;d<a.length;d++)a[d]=a[d].trim().replace(/\\\|/g,"|");return a}function q(u,S,D){var a=u.length;if(a===0)return"";for(var d=0;d<a;){var s=u.charAt(a-d-1);if(s===S&&!D)d++;else if(s!==S&&D)d++;else break}return u.slice(0,a-d)}function I(u,S){if(u.indexOf(S[1])===-1)return-1;for(var D=u.length,a=0,d=0;d<D;d++)if(u[d]==="\\")d++;else if(u[d]===S[0])a++;else if(u[d]===S[1]&&(a--,a<0))return d;return-1}function j(u){u&&u.sanitize&&!u.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function T(u,S){if(S<1)return"";for(var D="";S>1;)S&1&&(D+=u),S>>=1,u+=u;return D+u}function Q(u,S,D,a){var d=S.href,s=S.title?e(S.title):null,l=u[1].replace(/\\([\[\]])/g,"$1");if(u[0].charAt(0)!=="!"){a.state.inLink=!0;var F={type:"link",raw:D,href:d,title:s,text:l,tokens:a.inlineTokens(l)};return a.state.inLink=!1,F}return{type:"image",raw:D,href:d,title:s,text:e(l)}}function Z(u,S){var D=u.match(/^(\s+)(?:```)/);if(D===null)return S;var a=D[1];return S.split(`
`).map(function(d){var s=d.match(/^\s+/);if(s===null)return d;var l=s[0];return l.length>=a.length?d.slice(a.length):d}).join(`
`)}var ce=function(){function u(D){this.options=D||ne.defaults}var S=u.prototype;return S.space=function(a){var d=this.rules.block.newline.exec(a);if(d&&d[0].length>0)return{type:"space",raw:d[0]}},S.code=function(a){var d=this.rules.block.code.exec(a);if(d){var s=d[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:d[0],codeBlockStyle:"indented",text:this.options.pedantic?s:q(s,`
`)}}},S.fences=function(a){var d=this.rules.block.fences.exec(a);if(d){var s=d[0],l=Z(s,d[3]||"");return{type:"code",raw:s,lang:d[2]?d[2].trim():d[2],text:l}}},S.heading=function(a){var d=this.rules.block.heading.exec(a);if(d){var s=d[2].trim();if(/#$/.test(s)){var l=q(s,"#");(this.options.pedantic||!l||/ $/.test(l))&&(s=l.trim())}return{type:"heading",raw:d[0],depth:d[1].length,text:s,tokens:this.lexer.inline(s)}}},S.hr=function(a){var d=this.rules.block.hr.exec(a);if(d)return{type:"hr",raw:d[0]}},S.blockquote=function(a){var d=this.rules.block.blockquote.exec(a);if(d){var s=d[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:d[0],tokens:this.lexer.blockTokens(s,[]),text:s}}},S.list=function(a){var d=this.rules.block.list.exec(a);if(d){var s,l,F,A,R,W,X,U,me,ve,we,Me,ke=d[1].trim(),Ee=ke.length>1,Ce={type:"list",raw:"",ordered:Ee,start:Ee?+ke.slice(0,-1):"",loose:!1,items:[]};ke=Ee?"\\d{1,9}\\"+ke.slice(-1):"\\"+ke,this.options.pedantic&&(ke=Ee?ke:"[*+-]");for(var Re=new RegExp("^( {0,3}"+ke+")((?:[	 ][^\\n]*)?(?:\\n|$))");a&&(Me=!1,!(!(d=Re.exec(a))||this.rules.block.hr.test(a)));){if(s=d[0],a=a.substring(s.length),U=d[2].split(`
`,1)[0],me=a.split(`
`,1)[0],this.options.pedantic?(A=2,we=U.trimLeft()):(A=d[2].search(/[^ ]/),A=A>4?1:A,we=U.slice(A),A+=d[1].length),W=!1,!U&&/^ *$/.test(me)&&(s+=me+`
`,a=a.substring(me.length+1),Me=!0),!Me)for(var Ye=new RegExp("^ {0,"+Math.min(3,A-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),st=new RegExp("^ {0,"+Math.min(3,A-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Ge=new RegExp("^ {0,"+Math.min(3,A-1)+"}(?:```|~~~)"),Ue=new RegExp("^ {0,"+Math.min(3,A-1)+"}#");a&&(ve=a.split(`
`,1)[0],U=ve,this.options.pedantic&&(U=U.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Ge.test(U)||Ue.test(U)||Ye.test(U)||st.test(a)));){if(U.search(/[^ ]/)>=A||!U.trim())we+=`
`+U.slice(A);else if(!W)we+=`
`+U;else break;!W&&!U.trim()&&(W=!0),s+=ve+`
`,a=a.substring(ve.length+1)}Ce.loose||(X?Ce.loose=!0:/\n *\n *$/.test(s)&&(X=!0)),this.options.gfm&&(l=/^\[[ xX]\] /.exec(we),l&&(F=l[0]!=="[ ] ",we=we.replace(/^\[[ xX]\] +/,""))),Ce.items.push({type:"list_item",raw:s,task:!!l,checked:F,loose:!1,text:we}),Ce.raw+=s}Ce.items[Ce.items.length-1].raw=s.trimRight(),Ce.items[Ce.items.length-1].text=we.trimRight(),Ce.raw=Ce.raw.trimRight();var Y=Ce.items.length;for(R=0;R<Y;R++){this.lexer.state.top=!1,Ce.items[R].tokens=this.lexer.blockTokens(Ce.items[R].text,[]);var se=Ce.items[R].tokens.filter(function(De){return De.type==="space"}),pe=se.every(function(De){for(var Le=De.raw.split(""),ze=0,Ve=H(Le),_e;!(_e=Ve()).done;){var tt=_e.value;if(tt===`
`&&(ze+=1),ze>1)return!0}return!1});!Ce.loose&&se.length&&pe&&(Ce.loose=!0,Ce.items[R].loose=!0)}return Ce}},S.html=function(a){var d=this.rules.block.html.exec(a);if(d){var s={type:"html",raw:d[0],pre:!this.options.sanitizer&&(d[1]==="pre"||d[1]==="script"||d[1]==="style"),text:d[0]};if(this.options.sanitize){var l=this.options.sanitizer?this.options.sanitizer(d[0]):e(d[0]);s.type="paragraph",s.text=l,s.tokens=this.lexer.inline(l)}return s}},S.def=function(a){var d=this.rules.block.def.exec(a);if(d){d[3]&&(d[3]=d[3].substring(1,d[3].length-1));var s=d[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:s,raw:d[0],href:d[2],title:d[3]}}},S.table=function(a){var d=this.rules.block.table.exec(a);if(d){var s={type:"table",header:x(d[1]).map(function(X){return{text:X}}),align:d[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:d[3]&&d[3].trim()?d[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(s.header.length===s.align.length){s.raw=d[0];var l=s.align.length,F,A,R,W;for(F=0;F<l;F++)/^ *-+: *$/.test(s.align[F])?s.align[F]="right":/^ *:-+: *$/.test(s.align[F])?s.align[F]="center":/^ *:-+ *$/.test(s.align[F])?s.align[F]="left":s.align[F]=null;for(l=s.rows.length,F=0;F<l;F++)s.rows[F]=x(s.rows[F],s.header.length).map(function(X){return{text:X}});for(l=s.header.length,A=0;A<l;A++)s.header[A].tokens=this.lexer.inline(s.header[A].text);for(l=s.rows.length,A=0;A<l;A++)for(W=s.rows[A],R=0;R<W.length;R++)W[R].tokens=this.lexer.inline(W[R].text);return s}}},S.lheading=function(a){var d=this.rules.block.lheading.exec(a);if(d)return{type:"heading",raw:d[0],depth:d[2].charAt(0)==="="?1:2,text:d[1],tokens:this.lexer.inline(d[1])}},S.paragraph=function(a){var d=this.rules.block.paragraph.exec(a);if(d){var s=d[1].charAt(d[1].length-1)===`
`?d[1].slice(0,-1):d[1];return{type:"paragraph",raw:d[0],text:s,tokens:this.lexer.inline(s)}}},S.text=function(a){var d=this.rules.block.text.exec(a);if(d)return{type:"text",raw:d[0],text:d[0],tokens:this.lexer.inline(d[0])}},S.escape=function(a){var d=this.rules.inline.escape.exec(a);if(d)return{type:"escape",raw:d[0],text:e(d[1])}},S.tag=function(a){var d=this.rules.inline.tag.exec(a);if(d)return!this.lexer.state.inLink&&/^<a /i.test(d[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(d[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(d[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(d[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:d[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(d[0]):e(d[0]):d[0]}},S.link=function(a){var d=this.rules.inline.link.exec(a);if(d){var s=d[2].trim();if(!this.options.pedantic&&/^</.test(s)){if(!/>$/.test(s))return;var l=q(s.slice(0,-1),"\\");if((s.length-l.length)%2===0)return}else{var F=I(d[2],"()");if(F>-1){var A=d[0].indexOf("!")===0?5:4,R=A+d[1].length+F;d[2]=d[2].substring(0,F),d[0]=d[0].substring(0,R).trim(),d[3]=""}}var W=d[2],X="";if(this.options.pedantic){var U=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(W);U&&(W=U[1],X=U[3])}else X=d[3]?d[3].slice(1,-1):"";return W=W.trim(),/^</.test(W)&&(this.options.pedantic&&!/>$/.test(s)?W=W.slice(1):W=W.slice(1,-1)),Q(d,{href:W&&W.replace(this.rules.inline._escapes,"$1"),title:X&&X.replace(this.rules.inline._escapes,"$1")},d[0],this.lexer)}},S.reflink=function(a,d){var s;if((s=this.rules.inline.reflink.exec(a))||(s=this.rules.inline.nolink.exec(a))){var l=(s[2]||s[1]).replace(/\s+/g," ");if(l=d[l.toLowerCase()],!l||!l.href){var F=s[0].charAt(0);return{type:"text",raw:F,text:F}}return Q(s,l,s[0],this.lexer)}},S.emStrong=function(a,d,s){s===void 0&&(s="");var l=this.rules.inline.emStrong.lDelim.exec(a);if(l&&!(l[3]&&s.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var F=l[1]||l[2]||"";if(!F||F&&(s===""||this.rules.inline.punctuation.exec(s))){var A=l[0].length-1,R,W,X=A,U=0,me=l[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(me.lastIndex=0,d=d.slice(-1*a.length+A);(l=me.exec(d))!=null;)if(R=l[1]||l[2]||l[3]||l[4]||l[5]||l[6],!!R){if(W=R.length,l[3]||l[4]){X+=W;continue}else if((l[5]||l[6])&&A%3&&!((A+W)%3)){U+=W;continue}if(X-=W,!(X>0)){if(W=Math.min(W,W+X+U),Math.min(A,W)%2){var ve=a.slice(1,A+l.index+W);return{type:"em",raw:a.slice(0,A+l.index+W+1),text:ve,tokens:this.lexer.inlineTokens(ve)}}var we=a.slice(2,A+l.index+W-1);return{type:"strong",raw:a.slice(0,A+l.index+W+1),text:we,tokens:this.lexer.inlineTokens(we)}}}}}},S.codespan=function(a){var d=this.rules.inline.code.exec(a);if(d){var s=d[2].replace(/\n/g," "),l=/[^ ]/.test(s),F=/^ /.test(s)&&/ $/.test(s);return l&&F&&(s=s.substring(1,s.length-1)),s=e(s,!0),{type:"codespan",raw:d[0],text:s}}},S.br=function(a){var d=this.rules.inline.br.exec(a);if(d)return{type:"br",raw:d[0]}},S.del=function(a){var d=this.rules.inline.del.exec(a);if(d)return{type:"del",raw:d[0],text:d[2],tokens:this.lexer.inlineTokens(d[2])}},S.autolink=function(a,d){var s=this.rules.inline.autolink.exec(a);if(s){var l,F;return s[2]==="@"?(l=e(this.options.mangle?d(s[1]):s[1]),F="mailto:"+l):(l=e(s[1]),F=l),{type:"link",raw:s[0],text:l,href:F,tokens:[{type:"text",raw:l,text:l}]}}},S.url=function(a,d){var s;if(s=this.rules.inline.url.exec(a)){var l,F;if(s[2]==="@")l=e(this.options.mangle?d(s[0]):s[0]),F="mailto:"+l;else{var A;do A=s[0],s[0]=this.rules.inline._backpedal.exec(s[0])[0];while(A!==s[0]);l=e(s[0]),s[1]==="www."?F="http://"+l:F=l}return{type:"link",raw:s[0],text:l,href:F,tokens:[{type:"text",raw:l,text:l}]}}},S.inlineText=function(a,d){var s=this.rules.inline.text.exec(a);if(s){var l;return this.lexer.state.inRawBlock?l=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(s[0]):e(s[0]):s[0]:l=e(this.options.smartypants?d(s[0]):s[0]),{type:"text",raw:s[0],text:l}}},u}(),oe={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:O,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};oe._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,oe._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,oe.def=p(oe.def).replace("label",oe._label).replace("title",oe._title).getRegex(),oe.bullet=/(?:[*+-]|\d{1,9}[.)])/,oe.listItemStart=p(/^( *)(bull) */).replace("bull",oe.bullet).getRegex(),oe.list=p(oe.list).replace(/bull/g,oe.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+oe.def.source+")").getRegex(),oe._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",oe._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,oe.html=p(oe.html,"i").replace("comment",oe._comment).replace("tag",oe._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),oe.paragraph=p(oe._paragraph).replace("hr",oe.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",oe._tag).getRegex(),oe.blockquote=p(oe.blockquote).replace("paragraph",oe.paragraph).getRegex(),oe.normal=y({},oe),oe.gfm=y({},oe.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),oe.gfm.table=p(oe.gfm.table).replace("hr",oe.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",oe._tag).getRegex(),oe.gfm.paragraph=p(oe._paragraph).replace("hr",oe.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",oe.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",oe._tag).getRegex(),oe.pedantic=y({},oe.normal,{html:p(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",oe._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:O,paragraph:p(oe.normal._paragraph).replace("hr",oe.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",oe.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var te={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:O,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:O,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};te._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",te.punctuation=p(te.punctuation).replace(/punctuation/g,te._punctuation).getRegex(),te.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,te.escapedEmSt=/\\\*|\\_/g,te._comment=p(oe._comment).replace("(?:-->|$)","-->").getRegex(),te.emStrong.lDelim=p(te.emStrong.lDelim).replace(/punct/g,te._punctuation).getRegex(),te.emStrong.rDelimAst=p(te.emStrong.rDelimAst,"g").replace(/punct/g,te._punctuation).getRegex(),te.emStrong.rDelimUnd=p(te.emStrong.rDelimUnd,"g").replace(/punct/g,te._punctuation).getRegex(),te._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,te._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,te._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,te.autolink=p(te.autolink).replace("scheme",te._scheme).replace("email",te._email).getRegex(),te._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,te.tag=p(te.tag).replace("comment",te._comment).replace("attribute",te._attribute).getRegex(),te._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,te._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,te._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,te.link=p(te.link).replace("label",te._label).replace("href",te._href).replace("title",te._title).getRegex(),te.reflink=p(te.reflink).replace("label",te._label).replace("ref",oe._label).getRegex(),te.nolink=p(te.nolink).replace("ref",oe._label).getRegex(),te.reflinkSearch=p(te.reflinkSearch,"g").replace("reflink",te.reflink).replace("nolink",te.nolink).getRegex(),te.normal=y({},te),te.pedantic=y({},te.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:p(/^!?\[(label)\]\((.*?)\)/).replace("label",te._label).getRegex(),reflink:p(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",te._label).getRegex()}),te.gfm=y({},te.normal,{escape:p(te.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),te.gfm.url=p(te.gfm.url,"i").replace("email",te.gfm._extended_email).getRegex(),te.breaks=y({},te.gfm,{br:p(te.br).replace("{2,}","*").getRegex(),text:p(te.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function de(u){return u.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function Be(u){var S="",D,a,d=u.length;for(D=0;D<d;D++)a=u.charCodeAt(D),Math.random()>.5&&(a="x"+a.toString(16)),S+="&#"+a+";";return S}var Fe=function(){function u(D){this.tokens=[],this.tokens.links=Object.create(null),this.options=D||ne.defaults,this.options.tokenizer=this.options.tokenizer||new ce,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var a={block:oe.normal,inline:te.normal};this.options.pedantic?(a.block=oe.pedantic,a.inline=te.pedantic):this.options.gfm&&(a.block=oe.gfm,this.options.breaks?a.inline=te.breaks:a.inline=te.gfm),this.tokenizer.rules=a}u.lex=function(a,d){var s=new u(d);return s.lex(a)},u.lexInline=function(a,d){var s=new u(d);return s.inlineTokens(a)};var S=u.prototype;return S.lex=function(a){a=a.replace(/\r\n|\r/g,`
`),this.blockTokens(a,this.tokens);for(var d;d=this.inlineQueue.shift();)this.inlineTokens(d.src,d.tokens);return this.tokens},S.blockTokens=function(a,d){var s=this;d===void 0&&(d=[]),this.options.pedantic?a=a.replace(/\t/g,"    ").replace(/^ +$/gm,""):a=a.replace(/^( *)(\t+)/gm,function(X,U,me){return U+"    ".repeat(me.length)});for(var l,F,A,R;a;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(X){return(l=X.call({lexer:s},a,d))?(a=a.substring(l.raw.length),d.push(l),!0):!1}))){if(l=this.tokenizer.space(a)){a=a.substring(l.raw.length),l.raw.length===1&&d.length>0?d[d.length-1].raw+=`
`:d.push(l);continue}if(l=this.tokenizer.code(a)){a=a.substring(l.raw.length),F=d[d.length-1],F&&(F.type==="paragraph"||F.type==="text")?(F.raw+=`
`+l.raw,F.text+=`
`+l.text,this.inlineQueue[this.inlineQueue.length-1].src=F.text):d.push(l);continue}if(l=this.tokenizer.fences(a)){a=a.substring(l.raw.length),d.push(l);continue}if(l=this.tokenizer.heading(a)){a=a.substring(l.raw.length),d.push(l);continue}if(l=this.tokenizer.hr(a)){a=a.substring(l.raw.length),d.push(l);continue}if(l=this.tokenizer.blockquote(a)){a=a.substring(l.raw.length),d.push(l);continue}if(l=this.tokenizer.list(a)){a=a.substring(l.raw.length),d.push(l);continue}if(l=this.tokenizer.html(a)){a=a.substring(l.raw.length),d.push(l);continue}if(l=this.tokenizer.def(a)){a=a.substring(l.raw.length),F=d[d.length-1],F&&(F.type==="paragraph"||F.type==="text")?(F.raw+=`
`+l.raw,F.text+=`
`+l.raw,this.inlineQueue[this.inlineQueue.length-1].src=F.text):this.tokens.links[l.tag]||(this.tokens.links[l.tag]={href:l.href,title:l.title});continue}if(l=this.tokenizer.table(a)){a=a.substring(l.raw.length),d.push(l);continue}if(l=this.tokenizer.lheading(a)){a=a.substring(l.raw.length),d.push(l);continue}if(A=a,this.options.extensions&&this.options.extensions.startBlock&&function(){var X=1/0,U=a.slice(1),me=void 0;s.options.extensions.startBlock.forEach(function(ve){me=ve.call({lexer:this},U),typeof me=="number"&&me>=0&&(X=Math.min(X,me))}),X<1/0&&X>=0&&(A=a.substring(0,X+1))}(),this.state.top&&(l=this.tokenizer.paragraph(A))){F=d[d.length-1],R&&F.type==="paragraph"?(F.raw+=`
`+l.raw,F.text+=`
`+l.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=F.text):d.push(l),R=A.length!==a.length,a=a.substring(l.raw.length);continue}if(l=this.tokenizer.text(a)){a=a.substring(l.raw.length),F=d[d.length-1],F&&F.type==="text"?(F.raw+=`
`+l.raw,F.text+=`
`+l.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=F.text):d.push(l);continue}if(a){var W="Infinite loop on byte: "+a.charCodeAt(0);if(this.options.silent){console.error(W);break}else throw new Error(W)}}return this.state.top=!0,d},S.inline=function(a,d){return d===void 0&&(d=[]),this.inlineQueue.push({src:a,tokens:d}),d},S.inlineTokens=function(a,d){var s=this;d===void 0&&(d=[]);var l,F,A,R=a,W,X,U;if(this.tokens.links){var me=Object.keys(this.tokens.links);if(me.length>0)for(;(W=this.tokenizer.rules.inline.reflinkSearch.exec(R))!=null;)me.includes(W[0].slice(W[0].lastIndexOf("[")+1,-1))&&(R=R.slice(0,W.index)+"["+T("a",W[0].length-2)+"]"+R.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(W=this.tokenizer.rules.inline.blockSkip.exec(R))!=null;)R=R.slice(0,W.index)+"["+T("a",W[0].length-2)+"]"+R.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(W=this.tokenizer.rules.inline.escapedEmSt.exec(R))!=null;)R=R.slice(0,W.index)+"++"+R.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;a;)if(X||(U=""),X=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(we){return(l=we.call({lexer:s},a,d))?(a=a.substring(l.raw.length),d.push(l),!0):!1}))){if(l=this.tokenizer.escape(a)){a=a.substring(l.raw.length),d.push(l);continue}if(l=this.tokenizer.tag(a)){a=a.substring(l.raw.length),F=d[d.length-1],F&&l.type==="text"&&F.type==="text"?(F.raw+=l.raw,F.text+=l.text):d.push(l);continue}if(l=this.tokenizer.link(a)){a=a.substring(l.raw.length),d.push(l);continue}if(l=this.tokenizer.reflink(a,this.tokens.links)){a=a.substring(l.raw.length),F=d[d.length-1],F&&l.type==="text"&&F.type==="text"?(F.raw+=l.raw,F.text+=l.text):d.push(l);continue}if(l=this.tokenizer.emStrong(a,R,U)){a=a.substring(l.raw.length),d.push(l);continue}if(l=this.tokenizer.codespan(a)){a=a.substring(l.raw.length),d.push(l);continue}if(l=this.tokenizer.br(a)){a=a.substring(l.raw.length),d.push(l);continue}if(l=this.tokenizer.del(a)){a=a.substring(l.raw.length),d.push(l);continue}if(l=this.tokenizer.autolink(a,Be)){a=a.substring(l.raw.length),d.push(l);continue}if(!this.state.inLink&&(l=this.tokenizer.url(a,Be))){a=a.substring(l.raw.length),d.push(l);continue}if(A=a,this.options.extensions&&this.options.extensions.startInline&&function(){var we=1/0,Me=a.slice(1),ke=void 0;s.options.extensions.startInline.forEach(function(Ee){ke=Ee.call({lexer:this},Me),typeof ke=="number"&&ke>=0&&(we=Math.min(we,ke))}),we<1/0&&we>=0&&(A=a.substring(0,we+1))}(),l=this.tokenizer.inlineText(A,de)){a=a.substring(l.raw.length),l.raw.slice(-1)!=="_"&&(U=l.raw.slice(-1)),X=!0,F=d[d.length-1],F&&F.type==="text"?(F.raw+=l.raw,F.text+=l.text):d.push(l);continue}if(a){var ve="Infinite loop on byte: "+a.charCodeAt(0);if(this.options.silent){console.error(ve);break}else throw new Error(ve)}}return d},i(u,null,[{key:"rules",get:function(){return{block:oe,inline:te}}}]),u}(),Pe=function(){function u(D){this.options=D||ne.defaults}var S=u.prototype;return S.code=function(a,d,s){var l=(d||"").match(/\S*/)[0];if(this.options.highlight){var F=this.options.highlight(a,l);F!=null&&F!==a&&(s=!0,a=F)}return a=a.replace(/\n$/,"")+`
`,l?'<pre><code class="'+this.options.langPrefix+e(l,!0)+'">'+(s?a:e(a,!0))+`</code></pre>
`:"<pre><code>"+(s?a:e(a,!0))+`</code></pre>
`},S.blockquote=function(a){return`<blockquote>
`+a+`</blockquote>
`},S.html=function(a){return a},S.heading=function(a,d,s,l){if(this.options.headerIds){var F=this.options.headerPrefix+l.slug(s);return"<h"+d+' id="'+F+'">'+a+"</h"+d+`>
`}return"<h"+d+">"+a+"</h"+d+`>
`},S.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},S.list=function(a,d,s){var l=d?"ol":"ul",F=d&&s!==1?' start="'+s+'"':"";return"<"+l+F+`>
`+a+"</"+l+`>
`},S.listitem=function(a){return"<li>"+a+`</li>
`},S.checkbox=function(a){return"<input "+(a?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},S.paragraph=function(a){return"<p>"+a+`</p>
`},S.table=function(a,d){return d&&(d="<tbody>"+d+"</tbody>"),`<table>
<thead>
`+a+`</thead>
`+d+`</table>
`},S.tablerow=function(a){return`<tr>
`+a+`</tr>
`},S.tablecell=function(a,d){var s=d.header?"th":"td",l=d.align?"<"+s+' align="'+d.align+'">':"<"+s+">";return l+a+("</"+s+`>
`)},S.strong=function(a){return"<strong>"+a+"</strong>"},S.em=function(a){return"<em>"+a+"</em>"},S.codespan=function(a){return"<code>"+a+"</code>"},S.br=function(){return this.options.xhtml?"<br/>":"<br>"},S.del=function(a){return"<del>"+a+"</del>"},S.link=function(a,d,s){if(a=g(this.options.sanitize,this.options.baseUrl,a),a===null)return s;var l='<a href="'+e(a)+'"';return d&&(l+=' title="'+d+'"'),l+=">"+s+"</a>",l},S.image=function(a,d,s){if(a=g(this.options.sanitize,this.options.baseUrl,a),a===null)return s;var l='<img src="'+a+'" alt="'+s+'"';return d&&(l+=' title="'+d+'"'),l+=this.options.xhtml?"/>":">",l},S.text=function(a){return a},u}(),le=function(){function u(){}var S=u.prototype;return S.strong=function(a){return a},S.em=function(a){return a},S.codespan=function(a){return a},S.del=function(a){return a},S.html=function(a){return a},S.text=function(a){return a},S.link=function(a,d,s){return""+s},S.image=function(a,d,s){return""+s},S.br=function(){return""},u}(),_=function(){function u(){this.seen={}}var S=u.prototype;return S.serialize=function(a){return a.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},S.getNextSafeSlug=function(a,d){var s=a,l=0;if(this.seen.hasOwnProperty(s)){l=this.seen[a];do l++,s=a+"-"+l;while(this.seen.hasOwnProperty(s))}return d||(this.seen[a]=l,this.seen[s]=0),s},S.slug=function(a,d){d===void 0&&(d={});var s=this.serialize(a);return this.getNextSafeSlug(s,d.dryrun)},u}(),ae=function(){function u(D){this.options=D||ne.defaults,this.options.renderer=this.options.renderer||new Pe,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new le,this.slugger=new _}u.parse=function(a,d){var s=new u(d);return s.parse(a)},u.parseInline=function(a,d){var s=new u(d);return s.parseInline(a)};var S=u.prototype;return S.parse=function(a,d){d===void 0&&(d=!0);var s="",l,F,A,R,W,X,U,me,ve,we,Me,ke,Ee,Ce,Re,Ye,st,Ge,Ue,Y=a.length;for(l=0;l<Y;l++){if(we=a[l],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[we.type]&&(Ue=this.options.extensions.renderers[we.type].call({parser:this},we),Ue!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(we.type))){s+=Ue||"";continue}switch(we.type){case"space":continue;case"hr":{s+=this.renderer.hr();continue}case"heading":{s+=this.renderer.heading(this.parseInline(we.tokens),we.depth,h(this.parseInline(we.tokens,this.textRenderer)),this.slugger);continue}case"code":{s+=this.renderer.code(we.text,we.lang,we.escaped);continue}case"table":{for(me="",U="",R=we.header.length,F=0;F<R;F++)U+=this.renderer.tablecell(this.parseInline(we.header[F].tokens),{header:!0,align:we.align[F]});for(me+=this.renderer.tablerow(U),ve="",R=we.rows.length,F=0;F<R;F++){for(X=we.rows[F],U="",W=X.length,A=0;A<W;A++)U+=this.renderer.tablecell(this.parseInline(X[A].tokens),{header:!1,align:we.align[A]});ve+=this.renderer.tablerow(U)}s+=this.renderer.table(me,ve);continue}case"blockquote":{ve=this.parse(we.tokens),s+=this.renderer.blockquote(ve);continue}case"list":{for(Me=we.ordered,ke=we.start,Ee=we.loose,R=we.items.length,ve="",F=0;F<R;F++)Re=we.items[F],Ye=Re.checked,st=Re.task,Ce="",Re.task&&(Ge=this.renderer.checkbox(Ye),Ee?Re.tokens.length>0&&Re.tokens[0].type==="paragraph"?(Re.tokens[0].text=Ge+" "+Re.tokens[0].text,Re.tokens[0].tokens&&Re.tokens[0].tokens.length>0&&Re.tokens[0].tokens[0].type==="text"&&(Re.tokens[0].tokens[0].text=Ge+" "+Re.tokens[0].tokens[0].text)):Re.tokens.unshift({type:"text",text:Ge}):Ce+=Ge),Ce+=this.parse(Re.tokens,Ee),ve+=this.renderer.listitem(Ce,st,Ye);s+=this.renderer.list(ve,Me,ke);continue}case"html":{s+=this.renderer.html(we.text);continue}case"paragraph":{s+=this.renderer.paragraph(this.parseInline(we.tokens));continue}case"text":{for(ve=we.tokens?this.parseInline(we.tokens):we.text;l+1<Y&&a[l+1].type==="text";)we=a[++l],ve+=`
`+(we.tokens?this.parseInline(we.tokens):we.text);s+=d?this.renderer.paragraph(ve):ve;continue}default:{var se='Token with "'+we.type+'" type was not found.';if(this.options.silent){console.error(se);return}else throw new Error(se)}}}return s},S.parseInline=function(a,d){d=d||this.renderer;var s="",l,F,A,R=a.length;for(l=0;l<R;l++){if(F=a[l],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[F.type]&&(A=this.options.extensions.renderers[F.type].call({parser:this},F),A!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(F.type))){s+=A||"";continue}switch(F.type){case"escape":{s+=d.text(F.text);break}case"html":{s+=d.html(F.text);break}case"link":{s+=d.link(F.href,F.title,this.parseInline(F.tokens,d));break}case"image":{s+=d.image(F.href,F.title,F.text);break}case"strong":{s+=d.strong(this.parseInline(F.tokens,d));break}case"em":{s+=d.em(this.parseInline(F.tokens,d));break}case"codespan":{s+=d.codespan(F.text);break}case"br":{s+=d.br();break}case"del":{s+=d.del(this.parseInline(F.tokens,d));break}case"text":{s+=d.text(F.text);break}default:{var W='Token with "'+F.type+'" type was not found.';if(this.options.silent){console.error(W);return}else throw new Error(W)}}}return s},u}();function re(u,S,D){if(typeof u>"u"||u===null)throw new Error("marked(): input parameter is undefined or null");if(typeof u!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(u)+", string expected");if(typeof S=="function"&&(D=S,S=null),S=y({},re.defaults,S||{}),j(S),D){var a=S.highlight,d;try{d=Fe.lex(u,S)}catch(R){return D(R)}var s=function(W){var X;if(!W)try{S.walkTokens&&re.walkTokens(d,S.walkTokens),X=ae.parse(d,S)}catch(U){W=U}return S.highlight=a,W?D(W):D(null,X)};if(!a||a.length<3||(delete S.highlight,!d.length))return s();var l=0;re.walkTokens(d,function(R){R.type==="code"&&(l++,setTimeout(function(){a(R.text,R.lang,function(W,X){if(W)return s(W);X!=null&&X!==R.text&&(R.text=X,R.escaped=!0),l--,l===0&&s()})},0))}),l===0&&s();return}function F(R){if(R.message+=`
Please report this to https://github.com/markedjs/marked.`,S.silent)return"<p>An error occurred:</p><pre>"+e(R.message+"",!0)+"</pre>";throw R}try{var A=Fe.lex(u,S);if(S.walkTokens){if(S.async)return Promise.all(re.walkTokens(A,S.walkTokens)).then(function(){return ae.parse(A,S)}).catch(F);re.walkTokens(A,S.walkTokens)}return ae.parse(A,S)}catch(R){F(R)}}re.options=re.setOptions=function(u){return y(re.defaults,u),k(re.defaults),re},re.getDefaults=E,re.defaults=ne.defaults,re.use=function(){for(var u=arguments.length,S=new Array(u),D=0;D<u;D++)S[D]=arguments[D];var a=y.apply(void 0,[{}].concat(S)),d=re.defaults.extensions||{renderers:{},childTokens:{}},s;S.forEach(function(l){if(l.extensions&&(s=!0,l.extensions.forEach(function(A){if(!A.name)throw new Error("extension name required");if(A.renderer){var R=d.renderers?d.renderers[A.name]:null;R?d.renderers[A.name]=function(){for(var W=arguments.length,X=new Array(W),U=0;U<W;U++)X[U]=arguments[U];var me=A.renderer.apply(this,X);return me===!1&&(me=R.apply(this,X)),me}:d.renderers[A.name]=A.renderer}if(A.tokenizer){if(!A.level||A.level!=="block"&&A.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");d[A.level]?d[A.level].unshift(A.tokenizer):d[A.level]=[A.tokenizer],A.start&&(A.level==="block"?d.startBlock?d.startBlock.push(A.start):d.startBlock=[A.start]:A.level==="inline"&&(d.startInline?d.startInline.push(A.start):d.startInline=[A.start]))}A.childTokens&&(d.childTokens[A.name]=A.childTokens)})),l.renderer&&function(){var A=re.defaults.renderer||new Pe,R=function(U){var me=A[U];A[U]=function(){for(var ve=arguments.length,we=new Array(ve),Me=0;Me<ve;Me++)we[Me]=arguments[Me];var ke=l.renderer[U].apply(A,we);return ke===!1&&(ke=me.apply(A,we)),ke}};for(var W in l.renderer)R(W);a.renderer=A}(),l.tokenizer&&function(){var A=re.defaults.tokenizer||new ce,R=function(U){var me=A[U];A[U]=function(){for(var ve=arguments.length,we=new Array(ve),Me=0;Me<ve;Me++)we[Me]=arguments[Me];var ke=l.tokenizer[U].apply(A,we);return ke===!1&&(ke=me.apply(A,we)),ke}};for(var W in l.tokenizer)R(W);a.tokenizer=A}(),l.walkTokens){var F=re.defaults.walkTokens;a.walkTokens=function(A){var R=[];return R.push(l.walkTokens.call(this,A)),F&&(R=R.concat(F.call(this,A))),R}}s&&(a.extensions=d),re.setOptions(a)})},re.walkTokens=function(u,S){for(var D=[],a=function(){var F=s.value;switch(D=D.concat(S.call(re,F)),F.type){case"table":{for(var A=H(F.header),R;!(R=A()).done;){var W=R.value;D=D.concat(re.walkTokens(W.tokens,S))}for(var X=H(F.rows),U;!(U=X()).done;)for(var me=U.value,ve=H(me),we;!(we=ve()).done;){var Me=we.value;D=D.concat(re.walkTokens(Me.tokens,S))}break}case"list":{D=D.concat(re.walkTokens(F.items,S));break}default:re.defaults.extensions&&re.defaults.extensions.childTokens&&re.defaults.extensions.childTokens[F.type]?re.defaults.extensions.childTokens[F.type].forEach(function(ke){D=D.concat(re.walkTokens(F[ke],S))}):F.tokens&&(D=D.concat(re.walkTokens(F.tokens,S)))}},d=H(u),s;!(s=d()).done;)a();return D},re.parseInline=function(u,S){if(typeof u>"u"||u===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof u!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(u)+", string expected");S=y({},re.defaults,S||{}),j(S);try{var D=Fe.lexInline(u,S);return S.walkTokens&&re.walkTokens(D,S.walkTokens),ae.parseInline(D,S)}catch(a){if(a.message+=`
Please report this to https://github.com/markedjs/marked.`,S.silent)return"<p>An error occurred:</p><pre>"+e(a.message+"",!0)+"</pre>";throw a}},re.Parser=ae,re.parser=ae.parse,re.Renderer=Pe,re.TextRenderer=le,re.Lexer=Fe,re.lexer=Fe.lex,re.Tokenizer=ce,re.Slugger=_,re.parse=re;var J=re.options,G=re.setOptions,ie=re.use,ue=re.walkTokens,ye=re.parseInline,Ne=re,Ae=ae.parse,ge=Fe.lex;ne.Lexer=Fe,ne.Parser=ae,ne.Renderer=Pe,ne.Slugger=_,ne.TextRenderer=le,ne.Tokenizer=ce,ne.getDefaults=E,ne.lexer=ge,ne.marked=re,ne.options=J,ne.parse=Ne,ne.parseInline=ye,ne.parser=Ae,ne.setOptions=G,ne.use=ie,ne.walkTokens=ue,Object.defineProperty(ne,"__esModule",{value:!0})}),define(be[83],$e([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$gk=i;function i(n){const h=H(n);if(h&&h.length>0)return new Uint32Array(h)}let N=0;const z=new Uint32Array(10);function H(n){if(N=0,E(n,P,4352),N>0||(E(n,c,4449),N>0)||(E(n,f,4520),N>0)||(E(n,e,12593),N))return z.subarray(0,N);if(n>=44032&&n<=55203){const h=n-44032,m=h%588,p=Math.floor(h/588),v=Math.floor(m/28),o=m%28-1;if(p<P.length?E(p,P,0):4352+p-12593<e.length&&E(4352+p,e,12593),v<c.length?E(v,c,0):4449+v-12593<e.length&&E(4449+v-12593,e,12593),o>=0&&(o<f.length?E(o,f,0):4520+o-12593<e.length&&E(4520+o-12593,e,12593)),N>0)return z.subarray(0,N)}}function E(n,h,m){n>=m&&n<m+h.length&&k(h[n-m])}function k(n){n!==0&&(z[N++]=n&255,n>>8&&(z[N++]=n>>8&255),n>>16&&(z[N++]=n>>16&255))}var b;(function(n){n[n.InitialConsonant=4352]="InitialConsonant",n[n.Vowel=4449]="Vowel",n[n.FinalConsonant=4520]="FinalConsonant",n[n.CompatibilityJamo=12593]="CompatibilityJamo"})(b||(b={}));var $;(function(n){n[n.NUL=0]="NUL",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z"})($||($={}));var w;(function(n){n[n.fa=24934]="fa",n[n.fg=26470]="fg",n[n.fq=29030]="fq",n[n.fr=29286]="fr",n[n.ft=29798]="ft",n[n.fv=30310]="fv",n[n.fx=30822]="fx",n[n.hk=27496]="hk",n[n.hl=27752]="hl",n[n.ho=28520]="ho",n[n.ml=27757]="ml",n[n.nj=27246]="nj",n[n.nl=27758]="nl",n[n.np=28782]="np",n[n.qt=29809]="qt",n[n.rt=29810]="rt",n[n.sg=26483]="sg",n[n.sw=30579]="sw"})(w||(w={}));const P=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),c=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),f=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),e=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(be[84],$e([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$yU=void 0;class i{constructor(z,H=0,E=z.length,k=H-1){this.a=z,this.b=H,this.c=E,this.d=k}current(){return this.d===this.b-1||this.d===this.c?null:this.a[this.d]}next(){return this.d=Math.min(this.d+1,this.c),this.current()}previous(){return this.d=Math.max(this.d-1,this.b-1),this.current()}first(){return this.d=this.b,this.current()}last(){return this.d=this.c-1,this.current()}}t.$yU=i}),define(be[85],$e([1,0,84]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$AU=t.$zU=void 0;class N{constructor(E=[],k=10){this.h(E),this.b=k,this.d()}getHistory(){return this.j}add(E){this.a.delete(E),this.a.add(E),this.d()}next(){return this.c.next()}previous(){return this.g()!==0?this.c.previous():null}current(){return this.c.current()}first(){return this.c.first()}last(){return this.c.last()}isFirst(){return this.g()===0}isLast(){return this.g()>=this.j.length-1}isNowhere(){return this.c.current()===null}has(E){return this.a.has(E)}clear(){this.h([]),this.d()}d(){this.f();const E=this.j;this.c=new i.$yU(E,0,E.length,E.length)}f(){const E=this.j;E.length>this.b&&this.h(E.slice(E.length-this.b))}g(){const E=this.c.current();return E?this.j.indexOf(E):-1}h(E){this.a=new Set;for(const k of E)this.a.add(k)}get j(){const E=[];return this.a.forEach(k=>E.push(k)),E}}t.$zU=N;class z{get size(){return this.f}constructor(E,k=10){if(this.g=k,E.length<1)throw new Error("not supported");this.f=1,this.b=this.c=this.d={value:E[0],previous:void 0,next:void 0},this.a=new Set([E[0]]);for(let b=1;b<E.length;b++)this.add(E[b])}add(E){const k={value:E,previous:this.c,next:void 0};for(this.c.next=k,this.c=k,this.d=this.c,this.f++,this.a.has(E)?this.h(E):this.a.add(E);this.f>this.g;)this.a.delete(this.b.value),this.b=this.b.next,this.b.previous=void 0,this.f--}replaceLast(E){if(this.c.value===E)return E;const k=this.c.value;return this.a.delete(k),this.c.value=E,this.a.has(E)?this.h(E):this.a.add(E),k}prepend(E){if(this.f===this.g||this.a.has(E))return;const k={value:E,previous:void 0,next:this.b};this.b.previous=k,this.b=k,this.f++,this.a.add(E)}isAtEnd(){return this.d===this.c}current(){return this.d.value}previous(){return this.d.previous&&(this.d=this.d.previous),this.d.value}next(){return this.d.next&&(this.d=this.d.next),this.d.value}has(E){return this.a.has(E)}resetCursor(){return this.d=this.c,this.d.value}*[Symbol.iterator](){let E=this.b;for(;E;)yield E.value,E=E.next}h(E){let k=this.b;for(;k!==this.c;)k.value===E&&(k===this.b?(this.b=this.b.next,this.b.previous=void 0):(k.previous.next=k.next,k.next.previous=k.previous),this.f--),k=k.next}}t.$AU=z}),define(be[35],$e([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$qm=t.$pm=t.$om=void 0,t.$mm=i,t.rot=N;function i(k,b,$){return Math.min(Math.max(k,b),$)}function N(k,b){return(b+k%b)%b}class z{constructor(){this.a=0}getNext(){return this.a++}}t.$om=z;class H{constructor(){this.a=1,this.b=0}update(b){return this.b=this.b+(b-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}t.$pm=H;class E{constructor(b){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(b),this.c.fill(0,0,b)}update(b){const $=this.c[this.d];return this.c[this.d]=b,this.d=(this.d+1)%this.c.length,this.e-=$,this.e+=b,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}t.$qm=E}),define(be[50],$e([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;var i;(function(N){function z(b,$){if(b.start>=$.end||$.start>=b.end)return{start:0,end:0};const w=Math.max(b.start,$.start),P=Math.min(b.end,$.end);return P-w<=0?{start:0,end:0}:{start:w,end:P}}N.intersect=z;function H(b){return b.end-b.start<=0}N.isEmpty=H;function E(b,$){return!H(z(b,$))}N.intersects=E;function k(b,$){const w=[],P={start:b.start,end:Math.min($.start,b.end)},c={start:Math.max($.end,b.start),end:b.end};return H(P)||w.push(P),H(c)||w.push(c),w}N.relativeComplement=k})(i||(t.Range=i={}))}),define(be[86],$e([1,0,50]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$hT=void 0,t.$eT=N,t.$fT=z,t.$gT=H;function N(b,$){const w=[];for(const P of $){if(b.start>=P.range.end)continue;if(b.end<P.range.start)break;const c=i.Range.intersect(b,P.range);i.Range.isEmpty(c)||w.push({range:c,size:P.size})}return w}function z({start:b,end:$},w){return{start:b+w,end:$+w}}function H(b){const $=[];let w=null;for(const P of b){const c=P.range.start,f=P.range.end,e=P.size;if(w&&e===w.size){w.range.end=f;continue}w={range:{start:c,end:f},size:e},$.push(w)}return $}function E(...b){return H(b.reduce(($,w)=>$.concat(w),[]))}class k{get paddingTop(){return this.c}set paddingTop($){this.b=this.b+$-this.c,this.c=$}constructor($){this.a=[],this.b=0,this.c=0,this.c=$??0,this.b=this.c}splice($,w,P=[]){const c=P.length-w,f=N({start:0,end:$},this.a),e=N({start:$+w,end:Number.POSITIVE_INFINITY},this.a).map(h=>({range:z(h.range,c),size:h.size})),n=P.map((h,m)=>({range:{start:$+m,end:$+m+1},size:h.size}));this.a=E(f,n,e),this.b=this.c+this.a.reduce((h,m)=>h+m.size*(m.range.end-m.range.start),0)}get count(){const $=this.a.length;return $?this.a[$-1].range.end:0}get size(){return this.b}indexAt($){if($<0)return-1;if($<this.c)return 0;let w=0,P=this.c;for(const c of this.a){const f=c.range.end-c.range.start,e=P+f*c.size;if($<e)return w+Math.floor(($-P)/c.size);w+=f,P=e}return w}indexAfter($){return Math.min(this.indexAt($)+1,this.count)}positionAt($){if($<0)return-1;let w=0,P=0;for(const c of this.a){const f=c.range.end-c.range.start,e=P+f;if($<e)return this.c+w+($-P)*c.size;w+=f*c.size,P=e}return-1}}t.$hT=k}),define(be[87],$e([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3d=void 0;const i=globalThis.performance&&typeof globalThis.performance.now=="function";class N{static create(H){return new N(H)}constructor(H){this.c=i&&H===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}t.$3d=N}),define(be[4],$e([1,0,6,47,3,49,87]),function(ne,t,i,N,z,H,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$de=t.$ce=t.$be=t.$ae=t.$_d=t.$$d=t.$0d=t.$9d=t.$8d=t.$7d=t.$5d=t.Event=void 0,t.$6d=f;const k=!1,b=!1,$=!1;var w;(function(j){j.None=()=>z.$Uc.None;function T(s){if($){const{onDidAddListener:l}=s,F=n.create();let A=0;s.onDidAddListener=()=>{++A===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),F.print()),l?.()}}}function Q(s,l){return _(s,()=>{},0,void 0,!0,void 0,l)}j.defer=Q;function Z(s){return(l,F=null,A)=>{let R=!1,W;return W=s(X=>{if(!R)return W?W.dispose():R=!0,l.call(F,X)},null,A),R&&W.dispose(),W}}j.once=Z;function ce(s,l,F){return Pe((A,R=null,W)=>s(X=>A.call(R,l(X)),null,W),F)}j.map=ce;function oe(s,l,F){return Pe((A,R=null,W)=>s(X=>{l(X),A.call(R,X)},null,W),F)}j.forEach=oe;function te(s,l,F){return Pe((A,R=null,W)=>s(X=>l(X)&&A.call(R,X),null,W),F)}j.filter=te;function de(s){return s}j.signal=de;function Be(...s){return(l,F=null,A)=>{const R=(0,z.$Rc)(...s.map(W=>W(X=>l.call(F,X))));return le(R,A)}}j.any=Be;function Fe(s,l,F,A){let R=F;return ce(s,W=>(R=l(R,W),R),A)}j.reduce=Fe;function Pe(s,l){let F;const A={onWillAddFirstListener(){F=s(R.fire,R)},onDidRemoveLastListener(){F?.dispose()}};l||T(A);const R=new g(A);return l?.add(R),R.event}function le(s,l){return l instanceof Array?l.push(s):l&&l.add(s),s}function _(s,l,F=100,A=!1,R=!1,W,X){let U,me,ve,we=0,Me;const ke={leakWarningThreshold:W,onWillAddFirstListener(){U=s(Ce=>{we++,me=l(me,Ce),A&&!ve&&(Ee.fire(me),me=void 0),Me=()=>{const Re=me;me=void 0,ve=void 0,(!A||we>1)&&Ee.fire(Re),we=0},typeof F=="number"?(clearTimeout(ve),ve=setTimeout(Me,F)):ve===void 0&&(ve=0,queueMicrotask(Me))})},onWillRemoveListener(){R&&we>0&&Me?.()},onDidRemoveLastListener(){Me=void 0,U.dispose()}};X||T(ke);const Ee=new g(ke);return X?.add(Ee),Ee.event}j.debounce=_;function ae(s,l=0,F){return j.debounce(s,(A,R)=>A?(A.push(R),A):[R],l,void 0,!0,void 0,F)}j.accumulate=ae;function re(s,l=(A,R)=>A===R,F){let A=!0,R;return te(s,W=>{const X=A||!l(W,R);return A=!1,R=W,X},F)}j.latch=re;function J(s,l,F){return[j.filter(s,l,F),j.filter(s,A=>!l(A),F)]}j.split=J;function G(s,l=!1,F=[],A){let R=F.slice(),W=s(me=>{R?R.push(me):U.fire(me)});A&&A.add(W);const X=()=>{R?.forEach(me=>U.fire(me)),R=null},U=new g({onWillAddFirstListener(){W||(W=s(me=>U.fire(me)),A&&A.add(W))},onDidAddFirstListener(){R&&(l?setTimeout(X):X())},onDidRemoveLastListener(){W&&W.dispose(),W=null}});return A&&A.add(U),U.event}j.buffer=G;function ie(s,l){return(A,R,W)=>{const X=l(new ye);return s(function(U){const me=X.evaluate(U);me!==ue&&A.call(R,me)},void 0,W)}}j.chain=ie;const ue=Symbol("HaltChainable");class ye{constructor(){this.f=[]}map(l){return this.f.push(l),this}forEach(l){return this.f.push(F=>(l(F),F)),this}filter(l){return this.f.push(F=>l(F)?F:ue),this}reduce(l,F){let A=F;return this.f.push(R=>(A=l(A,R),A)),this}latch(l=(F,A)=>F===A){let F=!0,A;return this.f.push(R=>{const W=F||!l(R,A);return F=!1,A=R,W?R:ue}),this}evaluate(l){for(const F of this.f)if(l=F(l),l===ue)break;return l}}function Ne(s,l,F=A=>A){const A=(...U)=>X.fire(F(...U)),R=()=>s.on(l,A),W=()=>s.removeListener(l,A),X=new g({onWillAddFirstListener:R,onDidRemoveLastListener:W});return X.event}j.fromNodeEventEmitter=Ne;function Ae(s,l,F=A=>A){const A=(...U)=>X.fire(F(...U)),R=()=>s.addEventListener(l,A),W=()=>s.removeEventListener(l,A),X=new g({onWillAddFirstListener:R,onDidRemoveLastListener:W});return X.event}j.fromDOMEventEmitter=Ae;function ge(s){return new Promise(l=>Z(s)(l))}j.toPromise=ge;function u(s){const l=new g;return s.then(F=>{l.fire(F)},()=>{l.fire(void 0)}).finally(()=>{l.dispose()}),l.event}j.fromPromise=u;function S(s,l,F){return l(F),s(A=>l(A))}j.runAndSubscribe=S;class D{constructor(l,F){this._observable=l,this.f=0,this.g=!1;const A={onWillAddFirstListener:()=>{l.addObserver(this)},onDidRemoveLastListener:()=>{l.removeObserver(this)}};F||T(A),this.emitter=new g(A),F&&F.add(this.emitter)}beginUpdate(l){this.f++}handlePossibleChange(l){}handleChange(l,F){this.g=!0}endUpdate(l){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function a(s,l){return new D(s,l).emitter.event}j.fromObservable=a;function d(s){return(l,F,A)=>{let R=0,W=!1;const X={beginUpdate(){R++},endUpdate(){R--,R===0&&(s.reportChanges(),W&&(W=!1,l.call(F)))},handlePossibleChange(){},handleChange(){W=!0}};s.addObserver(X),s.reportChanges();const U={dispose(){s.removeObserver(X)}};return A instanceof z.$Tc?A.add(U):Array.isArray(A)&&A.push(U),U}}j.fromObservableLight=d})(w||(t.Event=w={}));class P{static{this.all=new Set}static{this.f=0}constructor(T){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${T}_${P.f++}`,P.all.add(this)}start(T){this.g=new E.$3d,this.listenerCount=T}stop(){if(this.g){const T=this.g.elapsed();this.durations.push(T),this.elapsedOverall+=T,this.invocationCount+=1,this.g=void 0}}}t.$5d=P;let c=-1;function f(j){const T=c;return c=j,{dispose(){c=T}}}class e{constructor(T,Q=Math.random().toString(18).slice(2,5)){this.threshold=T,this.name=Q,this.g=0}dispose(){this.f?.clear()}check(T,Q){const Z=this.threshold;if(Z<=0||Q<Z)return;this.f||(this.f=new Map);const ce=this.f.get(T.value)||0;if(this.f.set(T.value,ce+1),this.g-=1,this.g<=0){this.g=Z*.5;let oe,te=0;for(const[de,Be]of this.f)(!oe||te<Be)&&(oe=de,te=Be);console.warn(`[${this.name}] potential listener LEAK detected, having ${Q} listeners already. MOST frequent listener (${te}):`),console.warn(oe)}return()=>{const oe=this.f.get(T.value)||0;this.f.set(T.value,oe-1)}}}class n{static create(){return new n(new Error().stack??"")}constructor(T){this.value=T}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let h=0;class m{constructor(T){this.value=T,this.id=h++}}const p=2,v=(j,T)=>{if(j instanceof m)T(j);else for(let Q=0;Q<j.length;Q++){const Z=j[Q];Z&&T(Z)}},o=k?new FinalizationRegistry(j=>{typeof j=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(j))}):void 0;class g{constructor(T){this.w=0,this.f=T,this.g=c>0||this.f?.leakWarningThreshold?new e(this.f?.leakWarningThreshold??c):void 0,this.j=this.f?._profName?new P(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(b){const T=this.t;queueMicrotask(()=>{v(T,Q=>Q.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(T,Q,Z)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),z.$Uc.None;if(this.m)return z.$Uc.None;Q&&(T=T.bind(Q));const ce=new m(T);let oe,te;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(ce.stack=n.create(),oe=this.g.check(ce.stack,this.w+1)),b&&(ce.stack=te??n.create()),this.t?this.t instanceof m?(this.u??=new B,this.t=[this.t,ce]):this.t.push(ce):(this.f?.onWillAddFirstListener?.(this),this.t=ce,this.f?.onDidAddFirstListener?.(this)),this.w++;const de=(0,z.$Sc)(()=>{o?.unregister(de),oe?.(),this.x(ce)});if(Z instanceof z.$Tc?Z.add(de):Array.isArray(Z)&&Z.push(de),o){const Be=new Error().stack.split(`
`).slice(2).join(`
`).trim();o.register(de,Be,de)}return de},this.q}x(T){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const Q=this.t,Z=Q.indexOf(T);if(Z===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,Q[Z]=void 0;const ce=this.u.current===this;if(this.w*p<=Q.length){let oe=0;for(let te=0;te<Q.length;te++)Q[te]?Q[oe++]=Q[te]:ce&&(this.u.end--,oe<this.u.i&&this.u.i--);Q.length=oe}}y(T,Q){if(!T)return;const Z=this.f?.onListenerError||i.$1;if(!Z){T.value(Q);return}try{T.value(Q)}catch(ce){Z(ce)}}z(T){const Q=T.current.t;for(;T.i<T.end;)this.y(Q[T.i++],T.value);T.reset()}fire(T){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof m)this.y(this.t,T);else{const Q=this.u;Q.enqueue(this,T,this.t.length),this.z(Q)}this.j?.stop()}hasListeners(){return this.w>0}}t.$7d=g;const r=()=>new B;t.$8d=r;class B{constructor(){this.i=-1,this.end=0}enqueue(T,Q,Z){this.i=0,this.end=Z,this.current=T,this.value=Q}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class C extends g{async fireAsync(T,Q,Z){if(this.t)for(this.h||(this.h=new H.$5c),v(this.t,ce=>this.h.push([ce.value,T]));this.h.size>0&&!Q.isCancellationRequested;){const[ce,oe]=this.h.shift(),te=[],de={...oe,token:Q,waitUntil:Be=>{if(Object.isFrozen(te))throw new Error("waitUntil can NOT be called asynchronous");Z&&(Be=Z(Be,ce)),te.push(Be)}};try{ce(de)}catch(Be){(0,i.$1)(Be);continue}Object.freeze(te),await Promise.allSettled(te).then(Be=>{for(const Fe of Be)Fe.status==="rejected"&&(0,i.$1)(Fe.reason)})}}}t.$9d=C;class L extends g{get isPaused(){return this.h!==0}constructor(T){super(T),this.h=0,this.s=new H.$5c,this.A=T?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const T=Array.from(this.s);this.s.clear(),super.fire(this.A(T))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(T){this.w&&(this.h!==0?this.s.push(T):super.fire(T))}}t.$0d=L;class M extends L{constructor(T){super(T),this.k=T.delay??100}fire(T){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(T)}}t.$$d=M;class O extends g{constructor(T){super(T),this.h=[],this.k=T?.merge}fire(T){this.hasListeners()&&(this.h.push(T),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(Q=>super.fire(Q)),this.h=[]}))}}t.$_d=O;class y{constructor(){this.g=!1,this.h=[],this.f=new g({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(T){const Q={event:T,listener:null};this.h.push(Q),this.g&&this.m(Q);const Z=()=>{this.g&&this.o(Q);const ce=this.h.indexOf(Q);this.h.splice(ce,1)};return(0,z.$Sc)((0,N.$db)(Z))}j(){this.g=!0,this.h.forEach(T=>this.m(T))}k(){this.g=!1,this.h.forEach(T=>this.o(T))}m(T){T.listener=T.event(Q=>this.f.fire(Q))}o(T){T.listener?.dispose(),T.listener=null}dispose(){this.f.dispose();for(const T of this.h)T.listener?.dispose();this.h=[]}}t.$ae=y;class x{constructor(T,Q,Z,ce){this.f=new z.$Tc;const oe=this.f.add(new y),te=this.f.add(new z.$4c);function de(Be){te.set(Be,oe.add(ce(Be)))}for(const Be of T)de(Be);this.f.add(Q(Be=>{de(Be)})),this.f.add(Z(Be=>{te.deleteAndDispose(Be)})),this.event=oe.event}dispose(){this.f.dispose()}}t.$be=x;class q{constructor(){this.f=[]}wrapEvent(T){return(Q,Z,ce)=>T(oe=>{const te=this.f[this.f.length-1];te?te.push(()=>Q.call(Z,oe)):Q.call(Z,oe)},void 0,ce)}bufferEvents(T){const Q=[];this.f.push(Q);const Z=T();return this.f.pop(),Q.forEach(ce=>ce()),Z}}t.$ce=q;class I{constructor(){this.f=!1,this.g=w.None,this.h=z.$Uc.None,this.j=new g({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(T){this.g=T,this.f&&(this.h.dispose(),this.h=T(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}t.$de=I}),define(be[17],$e([1,0,22,4]),function(ne,t,i,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$TQ=t.$SQ=t.$RQ=t.$QQ=t.$PQ=t.$OQ=t.$NQ=t.$MQ=t.$HQ=void 0,t.$EQ=H,t.$FQ=E,t.$GQ=k,t.$IQ=b,t.$JQ=$,t.$KQ=w,t.$LQ=P,t.$UQ=e,t.$VQ=n;class z{constructor(){this.a=new Map,this.b=new N.$7d,this.onDidChangeZoomLevel=this.b.event,this.c=new Map,this.d=new N.$7d,this.onDidChangeFullscreen=this.d.event,this.e=new Map}static{this.INSTANCE=new z}getZoomLevel(m){return this.a.get(this.f(m))??0}setZoomLevel(m,p){if(this.getZoomLevel(p)===m)return;const v=this.f(p);this.a.set(v,m),this.b.fire(v)}getZoomFactor(m){return this.c.get(this.f(m))??1}setZoomFactor(m,p){this.c.set(this.f(p),m)}setFullscreen(m,p){if(this.isFullscreen(p)===m)return;const v=this.f(p);this.e.set(v,m),this.d.fire(v)}isFullscreen(m){return!!this.e.get(this.f(m))}f(m){return m.vscodeWindowId}}function H(h,m,p){typeof m=="string"&&(m=h.matchMedia(m)),m.addEventListener("change",p)}function E(h,m){z.INSTANCE.setZoomLevel(h,m)}function k(h){return z.INSTANCE.getZoomLevel(h)}t.$HQ=z.INSTANCE.onDidChangeZoomLevel;function b(h){return z.INSTANCE.getZoomFactor(h)}function $(h,m){z.INSTANCE.setZoomFactor(h,m)}function w(h,m){z.INSTANCE.setFullscreen(h,m)}function P(h){return z.INSTANCE.isFullscreen(h)}t.$MQ=z.INSTANCE.onDidChangeFullscreen;const c=navigator.userAgent;t.$NQ=c.indexOf("Firefox")>=0,t.$OQ=c.indexOf("AppleWebKit")>=0,t.$PQ=c.indexOf("Chrome")>=0,t.$QQ=!t.$PQ&&c.indexOf("Safari")>=0,t.$RQ=!t.$PQ&&!t.$QQ&&t.$OQ,t.$SQ=c.indexOf("Electron/")>=0,t.$TQ=c.indexOf("Android")>=0;let f=!1;if(typeof i.$BQ.matchMedia=="function"){const h=i.$BQ.matchMedia("(display-mode: standalone) or (display-mode: window-controls-overlay)"),m=i.$BQ.matchMedia("(display-mode: fullscreen)");f=h.matches,H(i.$BQ,h,({matches:p})=>{f&&m.matches||(f=p)})}function e(){return f}function n(){return navigator?.windowControlsOverlay?.visible}}),define(be[24],$e([1,0,4]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$_S=void 0;class N{get event(){return this.a.event}constructor(H,E,k){const b=$=>this.a.fire($);this.a=new i.$7d({onWillAddFirstListener:()=>H.addEventListener(E,b,k),onDidRemoveLastListener:()=>H.removeEventListener(E,b,k)})}dispose(){this.a.dispose()}}t.$_S=N}),define(be[30],$e([1,0,4]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ee=t.CancellationToken=void 0;const N=Object.freeze(function(k,b){const $=setTimeout(k.bind(b),0);return{dispose(){clearTimeout($)}}});var z;(function(k){function b($){return $===k.None||$===k.Cancelled||$ instanceof H?!0:!$||typeof $!="object"?!1:typeof $.isCancellationRequested=="boolean"&&typeof $.onCancellationRequested=="function"}k.isCancellationToken=b,k.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:i.Event.None}),k.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:N})})(z||(t.CancellationToken=z={}));class H{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?N:(this.b||(this.b=new i.$7d),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class E{constructor(b){this.f=void 0,this.g=void 0,this.g=b&&b.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new H),this.f}cancel(){this.f?this.f instanceof H&&this.f.cancel():this.f=z.Cancelled}dispose(b=!1){b&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof H&&this.f.dispose():this.f=z.None}}t.$ee=E}),define(be[88],$e([1,0,30]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Re=t.$Qe=t.$Pe=void 0;class N{constructor(k){this.b=k,this.a=null}get(){if(this.a)return this.a;const k=new i.$ee,b=this.b(k.token);return this.a={promise:b,dispose:()=>{this.a=null,k.cancel(),k.dispose()}},this.a}}t.$Pe=N;class z{constructor(k){this.c=k,this.a=void 0,this.b=void 0}get(k){const b=JSON.stringify(k);return this.b!==b&&(this.b=b,this.a=this.c(k)),this.a}}t.$Qe=z;class H{get cachedValues(){return this.a}constructor(k){this.b=k,this.a=new Map}get(k){if(this.a.has(k))return this.a.get(k);const b=this.b(k);return this.a.set(k,b),b}}t.$Re=H}),define(be[51],$e([1,0,4,3]),function(ne,t,i,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Gs=t.$Fs=t.$Es=t.$Ds=t.ScrollbarVisibility=void 0;var z;(function(f){f[f.Auto=1]="Auto",f[f.Hidden=2]="Hidden",f[f.Visible=3]="Visible"})(z||(t.ScrollbarVisibility=z={}));class H{constructor(e,n,h,m,p,v,o){this.c=e,this._scrollStateBrand=void 0,this.c&&(n=n|0,h=h|0,m=m|0,p=p|0,v=v|0,o=o|0),this.rawScrollLeft=m,this.rawScrollTop=o,n<0&&(n=0),m+n>h&&(m=h-n),m<0&&(m=0),p<0&&(p=0),o+p>v&&(o=v-p),o<0&&(o=0),this.width=n,this.scrollWidth=h,this.scrollLeft=m,this.height=p,this.scrollHeight=v,this.scrollTop=o}equals(e){return this.rawScrollLeft===e.rawScrollLeft&&this.rawScrollTop===e.rawScrollTop&&this.width===e.width&&this.scrollWidth===e.scrollWidth&&this.scrollLeft===e.scrollLeft&&this.height===e.height&&this.scrollHeight===e.scrollHeight&&this.scrollTop===e.scrollTop}withScrollDimensions(e,n){return new H(this.c,typeof e.width<"u"?e.width:this.width,typeof e.scrollWidth<"u"?e.scrollWidth:this.scrollWidth,n?this.rawScrollLeft:this.scrollLeft,typeof e.height<"u"?e.height:this.height,typeof e.scrollHeight<"u"?e.scrollHeight:this.scrollHeight,n?this.rawScrollTop:this.scrollTop)}withScrollPosition(e){return new H(this.c,this.width,this.scrollWidth,typeof e.scrollLeft<"u"?e.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof e.scrollTop<"u"?e.scrollTop:this.rawScrollTop)}createScrollEvent(e,n){const h=this.width!==e.width,m=this.scrollWidth!==e.scrollWidth,p=this.scrollLeft!==e.scrollLeft,v=this.height!==e.height,o=this.scrollHeight!==e.scrollHeight,g=this.scrollTop!==e.scrollTop;return{inSmoothScrolling:n,oldWidth:e.width,oldScrollWidth:e.scrollWidth,oldScrollLeft:e.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:e.height,oldScrollHeight:e.scrollHeight,oldScrollTop:e.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:h,scrollWidthChanged:m,scrollLeftChanged:p,heightChanged:v,scrollHeightChanged:o,scrollTopChanged:g}}}t.$Ds=H;class E extends N.$Uc{constructor(e){super(),this._scrollableBrand=void 0,this.j=this.B(new i.$7d),this.onScroll=this.j.event,this.c=e.smoothScrollDuration,this.f=e.scheduleAtNextAnimationFrame,this.g=new H(e.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(e){this.c=e}validateScrollPosition(e){return this.g.withScrollPosition(e)}getScrollDimensions(){return this.g}setScrollDimensions(e,n){const h=this.g.withScrollDimensions(e,n);this.n(h,!!this.h),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(e){const n=this.g.withScrollPosition(e);this.h&&(this.h.dispose(),this.h=null),this.n(n,!1)}setScrollPositionSmooth(e,n){if(this.c===0)return this.setScrollPositionNow(e);if(this.h){e={scrollLeft:typeof e.scrollLeft>"u"?this.h.to.scrollLeft:e.scrollLeft,scrollTop:typeof e.scrollTop>"u"?this.h.to.scrollTop:e.scrollTop};const h=this.g.withScrollPosition(e);if(this.h.to.scrollLeft===h.scrollLeft&&this.h.to.scrollTop===h.scrollTop)return;let m;n?m=new w(this.h.from,h,this.h.startTime,this.h.duration):m=this.h.combine(this.g,h,this.c),this.h.dispose(),this.h=m}else{const h=this.g.withScrollPosition(e);this.h=w.start(this.g,h,this.c)}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}hasPendingScrollAnimation(){return!!this.h}m(){if(!this.h)return;const e=this.h.tick(),n=this.g.withScrollPosition(e);if(this.n(n,!0),!!this.h){if(e.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}}n(e,n){const h=this.g;h.equals(e)||(this.g=e,this.j.fire(this.g.createScrollEvent(h,n)))}}t.$Es=E;class k{constructor(e,n,h){this.scrollLeft=e,this.scrollTop=n,this.isDone=h}}t.$Fs=k;function b(f,e){const n=e-f;return function(h){return f+n*c(h)}}function $(f,e,n){return function(h){return h<n?f(h/n):e((h-n)/(1-n))}}class w{constructor(e,n,h,m){this.from=e,this.to=n,this.duration=m,this.startTime=h,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(e,n,h){if(Math.abs(e-n)>2.5*h){let p,v;return e<n?(p=e+.75*h,v=n-.75*h):(p=e-.75*h,v=n+.75*h),$(b(e,p),b(v,n),.33)}return b(e,n)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(e){this.to=e.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(e){const n=(e-this.startTime)/this.duration;if(n<1){const h=this.c(n),m=this.d(n);return new k(h,m,!1)}return new k(this.to.scrollLeft,this.to.scrollTop,!0)}combine(e,n,h){return w.start(e,n,h)}static start(e,n,h){h=h+10;const m=Date.now()-10;return new w(e,n,m,h)}}t.$Gs=w;function P(f){return Math.pow(f,3)}function c(f){return 1-P(1-f)}}),define(be[89],$e([1,0,6,3]),function(ne,t,i,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$fe=z,t.$ge=H,t.$he=E,t.$ie=k,t.$je=$,t.$ke=w,t.$le=P,t.$me=c,t.$ne=f,t.$oe=e,t.$pe=n,t.$qe=h,t.$re=m,t.$se=p,t.$te=v;function z(o){const g=o;return g?typeof g.read=="function":!1}function H(o){const g=o;return g?[g.on,g.pause,g.resume,g.destroy].every(r=>typeof r=="function"):!1}function E(o){const g=o;return g?H(g.stream)&&Array.isArray(g.buffer)&&typeof g.ended=="boolean":!1}function k(o,g){return new b(o,g)}class b{constructor(g,r){this.e=g,this.f=r,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(g){if(!this.a.destroyed){if(this.a.flowing)this.g(g);else if(this.b.data.push(g),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(r=>this.d.push(r))}}error(g){this.a.destroyed||(this.a.flowing?this.h(g):this.b.error.push(g))}end(g){this.a.destroyed||(typeof g<"u"&&this.write(g),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(g){this.c.data.slice(0).forEach(r=>r(g))}h(g){this.c.error.length===0?(0,i.$1)(g):this.c.error.slice(0).forEach(r=>r(g))}i(){this.c.end.slice(0).forEach(g=>g())}on(g,r){if(!this.a.destroyed)switch(g){case"data":this.c.data.push(r),this.resume();break;case"end":this.c.end.push(r),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(r),this.a.flowing&&this.k();break}}removeListener(g,r){if(this.a.destroyed)return;let B;switch(g){case"data":B=this.c.data;break;case"end":B=this.c.end;break;case"error":B=this.c.error;break}if(B){const C=B.indexOf(r);C>=0&&B.splice(C,1)}}j(){if(this.b.data.length>0){const g=this.e(this.b.data);this.g(g),this.b.data.length=0;const r=[...this.d];this.d.length=0,r.forEach(B=>B())}}k(){if(this.c.error.length>0){for(const g of this.b.error)this.h(g);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function $(o,g){const r=[];let B;for(;(B=o.read())!==null;)r.push(B);return g(r)}function w(o,g,r){const B=[];let C;for(;(C=o.read())!==null&&B.length<r;)B.push(C);return C===null&&B.length>0?g(B):{read:()=>{if(B.length>0)return B.shift();if(typeof C<"u"){const L=C;return C=void 0,L}return o.read()}}}function P(o,g){return new Promise((r,B)=>{const C=[];c(o,{onData:L=>{g&&C.push(L)},onError:L=>{g?B(L):r(void 0)},onEnd:()=>{r(g?g(C):void 0)}})})}function c(o,g,r){o.on("error",B=>{r?.isCancellationRequested||g.onError(B)}),o.on("end",()=>{r?.isCancellationRequested||g.onEnd()}),o.on("data",B=>{r?.isCancellationRequested||g.onData(B)})}function f(o,g){return new Promise((r,B)=>{const C=new N.$Tc,L=[],M=x=>{if(L.push(x),L.length>g)return C.dispose(),o.pause(),r({stream:o,buffer:L,ended:!1})},O=x=>(C.dispose(),B(x)),y=()=>(C.dispose(),r({stream:o,buffer:L,ended:!0}));C.add((0,N.$Sc)(()=>o.removeListener("error",O))),o.on("error",O),C.add((0,N.$Sc)(()=>o.removeListener("end",y))),o.on("end",y),C.add((0,N.$Sc)(()=>o.removeListener("data",M))),o.on("data",M)})}function e(o,g){const r=k(g);return r.end(o),r}function n(){const o=k(()=>{throw new Error("not supported")});return o.end(),o}function h(o){let g=!1;return{read:()=>g?null:(g=!0,o)}}function m(o,g,r){const B=k(r);return c(o,{onData:C=>B.write(g.data(C)),onError:C=>B.error(g.error?g.error(C):C),onEnd:()=>B.end()}),B}function p(o,g,r){let B=!1;return{read:()=>{const C=g.read();return B?C:(B=!0,C!==null?r([o,C]):o)}}}function v(o,g,r){let B=!1;const C=k(r);return c(g,{onData:L=>B?C.write(L):(B=!0,C.write(r([o,L]))),onError:L=>C.error(L),onEnd:()=>{B||(B=!0,C.write(o)),C.end()}}),C}}),define(be[36],$e([1,0,23,89]),function(ne,t,i,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ue=void 0,t.$ve=$,t.$we=w,t.$xe=P,t.$ye=c,t.$ze=f,t.$Ae=e,t.$Be=n,t.$Ce=h,t.$De=m,t.$Ee=p,t.$Fe=v,t.$Ge=o,t.$He=g,t.$Ie=r,t.$Je=B,t.$Ke=C,t.$Le=L,t.$Me=M,t.$Ne=O,t.$Oe=q;const z=typeof Buffer<"u",H=new i.$V(()=>new Uint8Array(256));let E,k;class b{static alloc(j){return z?new b(Buffer.allocUnsafe(j)):new b(new Uint8Array(j))}static wrap(j){return z&&!Buffer.isBuffer(j)&&(j=Buffer.from(j.buffer,j.byteOffset,j.byteLength)),new b(j)}static fromString(j,T){return!(T?.dontUseNodeBuffer||!1)&&z?new b(Buffer.from(j)):(E||(E=new TextEncoder),new b(E.encode(j)))}static fromByteArray(j){const T=b.alloc(j.length);for(let Q=0,Z=j.length;Q<Z;Q++)T.buffer[Q]=j[Q];return T}static concat(j,T){if(typeof T>"u"){T=0;for(let ce=0,oe=j.length;ce<oe;ce++)T+=j[ce].byteLength}const Q=b.alloc(T);let Z=0;for(let ce=0,oe=j.length;ce<oe;ce++){const te=j[ce];Q.set(te,Z),Z+=te.byteLength}return Q}constructor(j){this.buffer=j,this.byteLength=this.buffer.byteLength}clone(){const j=b.alloc(this.byteLength);return j.set(this),j}toString(){return z?this.buffer.toString():(k||(k=new TextDecoder),k.decode(this.buffer))}slice(j,T){return new b(this.buffer.subarray(j,T))}set(j,T){if(j instanceof b)this.buffer.set(j.buffer,T);else if(j instanceof Uint8Array)this.buffer.set(j,T);else if(j instanceof ArrayBuffer)this.buffer.set(new Uint8Array(j),T);else if(ArrayBuffer.isView(j))this.buffer.set(new Uint8Array(j.buffer,j.byteOffset,j.byteLength),T);else throw new Error("Unknown argument 'array'")}readUInt32BE(j){return c(this.buffer,j)}writeUInt32BE(j,T){f(this.buffer,j,T)}readUInt32LE(j){return e(this.buffer,j)}writeUInt32LE(j,T){n(this.buffer,j,T)}readUInt8(j){return h(this.buffer,j)}writeUInt8(j,T){m(this.buffer,j,T)}indexOf(j,T=0){return $(this.buffer,j instanceof b?j.buffer:j,T)}}t.$ue=b;function $(I,j,T=0){const Q=j.byteLength,Z=I.byteLength;if(Q===0)return 0;if(Q===1)return I.indexOf(j[0]);if(Q>Z-T)return-1;const ce=H.value;ce.fill(j.length);for(let Be=0;Be<j.length;Be++)ce[j[Be]]=j.length-Be-1;let oe=T+j.length-1,te=oe,de=-1;for(;oe<Z;)if(I[oe]===j[te]){if(te===0){de=oe;break}oe--,te--}else oe+=Math.max(j.length-te,ce[I[oe]]),te=j.length-1;return de}function w(I,j){return I[j+0]<<0>>>0|I[j+1]<<8>>>0}function P(I,j,T){I[T+0]=j&255,j=j>>>8,I[T+1]=j&255}function c(I,j){return I[j]*2**24+I[j+1]*2**16+I[j+2]*2**8+I[j+3]}function f(I,j,T){I[T+3]=j,j=j>>>8,I[T+2]=j,j=j>>>8,I[T+1]=j,j=j>>>8,I[T]=j}function e(I,j){return I[j+0]<<0>>>0|I[j+1]<<8>>>0|I[j+2]<<16>>>0|I[j+3]<<24>>>0}function n(I,j,T){I[T+0]=j&255,j=j>>>8,I[T+1]=j&255,j=j>>>8,I[T+2]=j&255,j=j>>>8,I[T+3]=j&255}function h(I,j){return I[j]}function m(I,j,T){I[T]=j}function p(I){return N.$je(I,j=>b.concat(j))}function v(I){return N.$qe(I)}function o(I){return N.$le(I,j=>b.concat(j))}async function g(I){return I.ended?b.concat(I.buffer):b.concat([...I.buffer,await o(I.stream)])}function r(I){return N.$oe(I,j=>b.concat(j))}function B(I){return N.$re(I,{data:j=>typeof j=="string"?b.fromString(j):b.wrap(j)},j=>b.concat(j))}function C(I){return N.$ie(j=>b.concat(j),I)}function L(I,j){return N.$se(I,j,T=>b.concat(T))}function M(I,j){return N.$te(I,j,T=>b.concat(T))}function O(I){let j=0,T=0,Q=0;const Z=new Uint8Array(Math.floor(I.length/4*3)),ce=te=>{switch(T){case 3:Z[Q++]=j|te,T=0;break;case 2:Z[Q++]=j|te>>>2,j=te<<6,T=3;break;case 1:Z[Q++]=j|te>>>4,j=te<<4,T=2;break;default:j=te<<2,T=1}};for(let te=0;te<I.length;te++){const de=I.charCodeAt(te);if(de>=65&&de<=90)ce(de-65);else if(de>=97&&de<=122)ce(de-97+26);else if(de>=48&&de<=57)ce(de-48+52);else if(de===43||de===45)ce(62);else if(de===47||de===95)ce(63);else{if(de===61)break;throw new SyntaxError(`Unexpected base64 character ${I[te]}`)}}const oe=Q;for(;T>0;)ce(0);return b.wrap(Z).slice(0,oe)}const y="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",x="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function q({buffer:I},j=!0,T=!1){const Q=T?x:y;let Z="";const ce=I.byteLength%3;let oe=0;for(;oe<I.byteLength-ce;oe+=3){const te=I[oe+0],de=I[oe+1],Be=I[oe+2];Z+=Q[te>>>2],Z+=Q[(te<<4|de>>>4)&63],Z+=Q[(de<<2|Be>>>6)&63],Z+=Q[Be&63]}if(ce===1){const te=I[oe+0];Z+=Q[te>>>2],Z+=Q[te<<4&63],j&&(Z+="==")}else if(ce===2){const te=I[oe+0],de=I[oe+1];Z+=Q[te>>>2],Z+=Q[(te<<4|de>>>4)&63],Z+=Q[de<<2&63],j&&(Z+="=")}return Z}}),define(be[10],$e([1,0,88,23]),function(ne,t,i,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Tf=t.$Sf=t.$Rf=t.GraphemeBreakType=t.$Hf=t.$Bf=t.$uf=t.$tf=void 0,t.$Ue=z,t.$Ve=E,t.$We=b,t.$Xe=$,t.$Ye=w,t.$Ze=P,t.$1e=c,t.$2e=f,t.$3e=e,t.$4e=n,t.$5e=h,t.$6e=m,t.$7e=p,t.$8e=v,t.$9e=o,t.$0e=g,t.$$e=r,t.$_e=B,t.$af=C,t.$bf=L,t.$cf=M,t.$df=O,t.$ef=y,t.$ff=x,t.$gf=q,t.$hf=I,t.$if=j,t.$jf=T,t.$kf=Q,t.$lf=Z,t.$mf=ce,t.$nf=oe,t.$of=te,t.$pf=de,t.$qf=Be,t.$rf=Fe,t.$sf=Pe,t.$vf=re,t.$wf=J,t.$xf=G,t.$yf=ie,t.$zf=Ne,t.$Af=ge,t.$Cf=u,t.$Df=S,t.$Ef=D,t.$Ff=a,t.$Gf=l,t.$If=F,t.$Jf=A,t.$Kf=R,t.$Lf=W,t.$Mf=X,t.$Nf=U,t.$Of=me,t.$Pf=ve,t.$Qf=Ce;function z(Y){return!Y||typeof Y!="string"?!0:Y.trim().length===0}const H=/{(\d+)}/g;function E(Y,...se){return se.length===0?Y:Y.replace(H,function(pe,De){const Le=parseInt(De,10);return isNaN(Le)||Le<0||Le>=se.length?pe:se[Le]})}const k=/{([^}]+)}/g;function b(Y,se){return Object.keys(se).length===0?Y:Y.replace(k,(pe,De)=>se[De]??pe)}function $(Y){return Y.replace(/[<>"'&]/g,se=>{switch(se){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return se})}function w(Y){return Y.replace(/[<>&]/g,function(se){switch(se){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return se}})}function P(Y){return Y.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function c(Y,se){let pe=0;const De=se.charCodeAt(0);for(let Le=Y.length-1;Le>=0;Le--)Y.charCodeAt(Le)===De&&pe++;return pe}function f(Y,se,pe="\u2026"){return Y.length<=se?Y:`${Y.substr(0,se)}${pe}`}function e(Y,se,pe="\u2026"){if(Y.length<=se)return Y;const De=Math.ceil(se/2)-pe.length/2,Le=Math.floor(se/2)-pe.length/2;return`${Y.substr(0,De)}${pe}${Y.substr(Y.length-Le)}`}function n(Y,se=" "){const pe=h(Y,se);return m(pe,se)}function h(Y,se){if(!Y||!se)return Y;const pe=se.length;if(pe===0||Y.length===0)return Y;let De=0;for(;Y.indexOf(se,De)===De;)De=De+pe;return Y.substring(De)}function m(Y,se){if(!Y||!se)return Y;const pe=se.length,De=Y.length;if(pe===0||De===0)return Y;let Le=De,ze=-1;for(;ze=Y.lastIndexOf(se,Le-1),!(ze===-1||ze+pe!==Le);){if(ze===0)return"";Le=ze}return Y.substring(0,Le)}function p(Y){return Y.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function v(Y){return Y.replace(/\*/g,"")}function o(Y,se,pe={}){if(!Y)throw new Error("Cannot create regex from empty string");se||(Y=P(Y)),pe.wholeWord&&(/\B/.test(Y.charAt(0))||(Y="\\b"+Y),/\B/.test(Y.charAt(Y.length-1))||(Y=Y+"\\b"));let De="";return pe.global&&(De+="g"),pe.matchCase||(De+="i"),pe.multiline&&(De+="m"),pe.unicode&&(De+="u"),new RegExp(Y,De)}function g(Y){return Y.source==="^"||Y.source==="^$"||Y.source==="$"||Y.source==="^\\s*$"?!1:!!(Y.exec("")&&Y.lastIndex===0)}function r(Y){return Y.split(/\r\n|\r|\n/)}function B(Y){const se=[],pe=Y.split(/(\r\n|\r|\n)/);for(let De=0;De<Math.ceil(pe.length/2);De++)se.push(pe[2*De]+(pe[2*De+1]??""));return se}function C(Y){for(let se=0,pe=Y.length;se<pe;se++){const De=Y.charCodeAt(se);if(De!==32&&De!==9)return se}return-1}function L(Y,se=0,pe=Y.length){for(let De=se;De<pe;De++){const Le=Y.charCodeAt(De);if(Le!==32&&Le!==9)return Y.substring(se,De)}return Y.substring(se,pe)}function M(Y,se=Y.length-1){for(let pe=se;pe>=0;pe--){const De=Y.charCodeAt(pe);if(De!==32&&De!==9)return pe}return-1}function O(Y,se,pe){const De=[];let Le=0;for(const ze of Y.matchAll(se)){if(De.push(Y.slice(Le,ze.index)),ze.index===void 0)throw new Error("match.index should be defined");Le=ze.index+ze[0].length,De.push(pe(ze[0],...ze.slice(1),ze.index,Y,ze.groups))}return De.push(Y.slice(Le)),Promise.all(De).then(ze=>ze.join(""))}function y(Y,se){return Y<se?-1:Y>se?1:0}function x(Y,se,pe=0,De=Y.length,Le=0,ze=se.length){for(;pe<De&&Le<ze;pe++,Le++){const tt=Y.charCodeAt(pe),nt=se.charCodeAt(Le);if(tt<nt)return-1;if(tt>nt)return 1}const Ve=De-pe,_e=ze-Le;return Ve<_e?-1:Ve>_e?1:0}function q(Y,se){return I(Y,se,0,Y.length,0,se.length)}function I(Y,se,pe=0,De=Y.length,Le=0,ze=se.length){for(;pe<De&&Le<ze;pe++,Le++){let tt=Y.charCodeAt(pe),nt=se.charCodeAt(Le);if(tt===nt)continue;if(tt>=128||nt>=128)return x(Y.toLowerCase(),se.toLowerCase(),pe,De,Le,ze);T(tt)&&(tt-=32),T(nt)&&(nt-=32);const Je=tt-nt;if(Je!==0)return Je}const Ve=De-pe,_e=ze-Le;return Ve<_e?-1:Ve>_e?1:0}function j(Y){return Y>=48&&Y<=57}function T(Y){return Y>=97&&Y<=122}function Q(Y){return Y>=65&&Y<=90}function Z(Y,se){return Y.length===se.length&&I(Y,se)===0}function ce(Y,se){const pe=se.length;return se.length>Y.length?!1:I(Y,se,0,pe)===0}function oe(Y,se){const pe=Math.min(Y.length,se.length);let De;for(De=0;De<pe;De++)if(Y.charCodeAt(De)!==se.charCodeAt(De))return De;return pe}function te(Y,se){const pe=Math.min(Y.length,se.length);let De;const Le=Y.length-1,ze=se.length-1;for(De=0;De<pe;De++)if(Y.charCodeAt(Le-De)!==se.charCodeAt(ze-De))return De;return pe}function de(Y){return 55296<=Y&&Y<=56319}function Be(Y){return 56320<=Y&&Y<=57343}function Fe(Y,se){return(Y-55296<<10)+(se-56320)+65536}function Pe(Y,se,pe){const De=Y.charCodeAt(pe);if(de(De)&&pe+1<se){const Le=Y.charCodeAt(pe+1);if(Be(Le))return Fe(De,Le)}return De}function le(Y,se){const pe=Y.charCodeAt(se-1);if(Be(pe)&&se>1){const De=Y.charCodeAt(se-2);if(de(De))return Fe(De,pe)}return pe}class _{get offset(){return this.e}constructor(se,pe=0){this.c=se,this.d=se.length,this.e=pe}setOffset(se){this.e=se}prevCodePoint(){const se=le(this.c,this.e);return this.e-=se>=65536?2:1,se}nextCodePoint(){const se=Pe(this.c,this.d,this.e);return this.e+=se>=65536?2:1,se}eol(){return this.e>=this.d}}t.$tf=_;class ae{get offset(){return this.c.offset}constructor(se,pe=0){this.c=new _(se,pe)}nextGraphemeLength(){const se=ke.getInstance(),pe=this.c,De=pe.offset;let Le=se.getGraphemeBreakType(pe.nextCodePoint());for(;!pe.eol();){const ze=pe.offset,Ve=se.getGraphemeBreakType(pe.nextCodePoint());if(we(Le,Ve)){pe.setOffset(ze);break}Le=Ve}return pe.offset-De}prevGraphemeLength(){const se=ke.getInstance(),pe=this.c,De=pe.offset;let Le=se.getGraphemeBreakType(pe.prevCodePoint());for(;pe.offset>0;){const ze=pe.offset,Ve=se.getGraphemeBreakType(pe.prevCodePoint());if(we(Ve,Le)){pe.setOffset(ze);break}Le=Ve}return De-pe.offset}eol(){return this.c.eol()}}t.$uf=ae;function re(Y,se){return new ae(Y,se).nextGraphemeLength()}function J(Y,se){return new ae(Y,se).prevGraphemeLength()}function G(Y,se){se>0&&Be(Y.charCodeAt(se))&&se--;const pe=se+re(Y,se);return[pe-J(Y,pe),pe]}function ie(Y){const se=new ae(Y);let pe=0;for(;!se.eol();)pe++,se.nextGraphemeLength();return pe}let ue;function ye(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function Ne(Y){return ue||(ue=ye()),ue.test(Y)}const Ae=/^[\t\n\r\x20-\x7E]*$/;function ge(Y){return Ae.test(Y)}t.$Bf=/[\u2028\u2029]/;function u(Y){return t.$Bf.test(Y)}function S(Y){return Y>=11904&&Y<=55215||Y>=63744&&Y<=64255||Y>=65281&&Y<=65374}function D(Y){return Y>=127462&&Y<=127487||Y===8986||Y===8987||Y===9200||Y===9203||Y>=9728&&Y<=10175||Y===11088||Y===11093||Y>=127744&&Y<=128591||Y>=128640&&Y<=128764||Y>=128992&&Y<=129008||Y>=129280&&Y<=129535||Y>=129648&&Y<=129782}function a(Y,se,pe=""){const De=Y.trimStart();if(De.length<se)return De;const Le=/\b/g;let ze=0;for(;Le.test(De)&&!(De.length-Le.lastIndex<se);)ze=Le.lastIndex,Le.lastIndex+=1;return ze===0?De:pe+De.substring(ze).trimStart()}const d=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,s=/\x1b\].*?\x07/g;function l(Y){return Y&&(Y=Y.replace(d,"").replace(s,"")),Y}t.$Hf="\uFEFF";function F(Y){return!!(Y&&Y.length>0&&Y.charCodeAt(0)===65279)}function A(Y){return F(Y)?Y.substr(1):Y}function R(Y,se){if(!Y||!se||Y.length<se.length)return!1;const pe=se.length,De=Y.toLowerCase();let Le=0,ze=-1;for(;Le<pe;){const Ve=De.indexOf(se[Le],ze+1);if(Ve<0)return!1;ze=Ve,Le++}return!0}function W(Y,se=!1){return Y?(se&&(Y=Y.replace(/\\./g,"")),Y.toLowerCase()!==Y):!1}function X(Y){return Y.charAt(0).toUpperCase()+Y.slice(1)}function U(Y,se=1){if(se===0)return"";let pe=-1;do pe=Y.indexOf(`
`,pe+1),se--;while(se>0&&pe>=0);return pe===-1?Y:(Y[pe-1]==="\r"&&pe--,Y.substr(0,pe))}function me(Y){return Y=Y%(2*26),Y<26?String.fromCharCode(97+Y):String.fromCharCode(65+Y-26)}function ve(Y){return ke.getInstance().getGraphemeBreakType(Y)}function we(Y,se){return Y===0?se!==5&&se!==7:Y===2&&se===3?!1:Y===4||Y===2||Y===3||se===4||se===2||se===3?!0:!(Y===8&&(se===8||se===9||se===11||se===12)||(Y===11||Y===9)&&(se===9||se===10)||(Y===12||Y===10)&&se===10||se===5||se===13||se===7||Y===1||Y===13&&se===14||Y===6&&se===6)}var Me;(function(Y){Y[Y.Other=0]="Other",Y[Y.Prepend=1]="Prepend",Y[Y.CR=2]="CR",Y[Y.LF=3]="LF",Y[Y.Control=4]="Control",Y[Y.Extend=5]="Extend",Y[Y.Regional_Indicator=6]="Regional_Indicator",Y[Y.SpacingMark=7]="SpacingMark",Y[Y.L=8]="L",Y[Y.V=9]="V",Y[Y.T=10]="T",Y[Y.LV=11]="LV",Y[Y.LVT=12]="LVT",Y[Y.ZWJ=13]="ZWJ",Y[Y.Extended_Pictographic=14]="Extended_Pictographic"})(Me||(t.GraphemeBreakType=Me={}));class ke{static{this.c=null}static getInstance(){return ke.c||(ke.c=new ke),ke.c}constructor(){this.d=Ee()}getGraphemeBreakType(se){if(se<32)return se===10?3:se===13?2:4;if(se<127)return 0;const pe=this.d,De=pe.length/3;let Le=1;for(;Le<=De;)if(se<pe[3*Le])Le=2*Le;else if(se>pe[3*Le+1])Le=2*Le+1;else return pe[3*Le+2];return 0}}function Ee(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ce(Y,se){if(Y===0)return 0;const pe=Re(Y,se);if(pe!==void 0)return pe;const De=new _(se,Y);return De.prevCodePoint(),De.offset}function Re(Y,se){const pe=new _(se,Y);let De=pe.prevCodePoint();for(;Ye(De)||De===65039||De===8419;){if(pe.offset===0)return;De=pe.prevCodePoint()}if(!D(De))return;let Le=pe.offset;return Le>0&&pe.prevCodePoint()===8205&&(Le=pe.offset),Le}function Ye(Y){return 127995<=Y&&Y<=127999}var st;(function(Y){Y[Y.zwj=8205]="zwj",Y[Y.emojiVariantSelector=65039]="emojiVariantSelector",Y[Y.enclosingKeyCap=8419]="enclosingKeyCap"})(st||(st={})),t.$Rf="\xA0";class Ge{static{this.c=new N.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new i.$Qe(se=>{function pe(Je){const rt=new Map;for(let et=0;et<Je.length;et+=2)rt.set(Je[et],Je[et+1]);return rt}function De(Je,rt){const et=new Map(Je);for(const[mt,gt]of rt)et.set(mt,gt);return et}function Le(Je,rt){if(!Je)return rt;const et=new Map;for(const[mt,gt]of Je)rt.has(mt)&&et.set(mt,gt);return et}const ze=this.c.value;let Ve=se.filter(Je=>!Je.startsWith("_")&&Je in ze);Ve.length===0&&(Ve=["_default"]);let _e;for(const Je of Ve){const rt=pe(ze[Je]);_e=Le(_e,rt)}const tt=pe(ze._common),nt=De(tt,_e);return new Ge(nt)})}static getInstance(se){return Ge.d.get(Array.from(se))}static{this.e=new N.$V(()=>Object.keys(Ge.c.value).filter(se=>!se.startsWith("_")))}static getLocales(){return Ge.e.value}constructor(se){this.f=se}isAmbiguous(se){return this.f.has(se)}getPrimaryConfusable(se){return this.f.get(se)}getConfusableCodePoints(){return new Set(this.f.keys())}}t.$Sf=Ge;class Ue{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Ue.c())),this.d}static isInvisibleCharacter(se){return Ue.e().has(se)}static get codePoints(){return Ue.e()}}t.$Tf=Ue}),define(be[37],$e([1,0,34,83,10]),function(ne,t,i,N,z){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$uk=t.FuzzyScore=t.$jk=t.$ik=void 0,t.or=H,t.$kk=k,t.$lk=b,t.$mk=P,t.$nk=O,t.$ok=y,t.$pk=Q,t.$qk=Z,t.$rk=ce,t.$sk=oe,t.$tk=Ne,t.$vk=S,t.$wk=d,t.$xk=s;function H(...A){return function(R,W){for(let X=0,U=A.length;X<U;X++){const me=A[X](R,W);if(me)return me}return null}}t.$ik=E.bind(void 0,!1),t.$jk=E.bind(void 0,!0);function E(A,R,W){if(!W||W.length<R.length)return null;let X;return A?X=z.$mf(W,R):X=W.indexOf(R)===0,X?R.length>0?[{start:0,end:R.length}]:[]:null}function k(A,R){const W=R.toLowerCase().indexOf(A.toLowerCase());return W===-1?null:[{start:W,end:W+A.length}]}function b(A,R){return $(A.toLowerCase(),R.toLowerCase(),0,0)}function $(A,R,W,X){if(W===A.length)return[];if(X===R.length)return null;if(A[W]===R[X]){let U=null;return(U=$(A,R,W+1,X+1))?o({start:X,end:X+1},U):null}return $(A,R,W,X+1)}function w(A){return 97<=A&&A<=122}function P(A){return 65<=A&&A<=90}function c(A){return 48<=A&&A<=57}function f(A){return A===32||A===9||A===10||A===13}const e=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(A=>e.add(A.charCodeAt(0)));function n(A){return f(A)||e.has(A)}function h(A,R){return A===R||n(A)&&n(R)}const m=new Map;function p(A){if(m.has(A))return m.get(A);let R;const W=(0,N.$gk)(A);return W&&(R=W),m.set(A,R),R}function v(A){return w(A)||P(A)||c(A)}function o(A,R){return R.length===0?R=[A]:A.end===R[0].start?R[0].start=A.start:R.unshift(A),R}function g(A,R){for(let W=R;W<A.length;W++){const X=A.charCodeAt(W);if(P(X)||c(X)||W>0&&!v(A.charCodeAt(W-1)))return W}return A.length}function r(A,R,W,X){if(W===A.length)return[];if(X===R.length)return null;if(A[W]!==R[X].toLowerCase())return null;{let U=null,me=X+1;for(U=r(A,R,W+1,X+1);!U&&(me=g(R,me))<R.length;)U=r(A,R,W+1,me),me++;return U===null?null:o({start:X,end:X+1},U)}}function B(A){let R=0,W=0,X=0,U=0,me=0;for(let Ee=0;Ee<A.length;Ee++)me=A.charCodeAt(Ee),P(me)&&R++,w(me)&&W++,v(me)&&X++,c(me)&&U++;const ve=R/A.length,we=W/A.length,Me=X/A.length,ke=U/A.length;return{upperPercent:ve,lowerPercent:we,alphaPercent:Me,numericPercent:ke}}function C(A){const{upperPercent:R,lowerPercent:W}=A;return W===0&&R>.6}function L(A){const{upperPercent:R,lowerPercent:W,alphaPercent:X,numericPercent:U}=A;return W>.2&&R<.8&&X>.6&&U<.2}function M(A){let R=0,W=0,X=0,U=0;for(let me=0;me<A.length;me++)X=A.charCodeAt(me),P(X)&&R++,w(X)&&W++,f(X)&&U++;return(R===0||W===0)&&U===0?A.length<=30:R<=5}function O(A,R){if(!R||(R=R.trim(),R.length===0)||!M(A))return null;R.length>60&&(R=R.substring(0,60));const W=B(R);if(!L(W)){if(!C(W))return null;R=R.toLowerCase()}let X=null,U=0;for(A=A.toLowerCase();U<R.length&&(X=r(A,R,0,U))===null;)U=g(R,U+1);return X}function y(A,R,W=!1){if(!R||R.length===0)return null;let X=null,U=0;for(A=A.toLowerCase(),R=R.toLowerCase();U<R.length&&(X=x(A,R,0,U,W),X===null);)U=q(R,U+1);return X}function x(A,R,W,X,U){let me=0;if(W===A.length)return[];if(X===R.length)return null;if(!h(A.charCodeAt(W),R.charCodeAt(X))){const Me=p(A.charCodeAt(W));if(!Me)return null;for(let ke=0;ke<Me.length;ke++)if(!h(Me[ke],R.charCodeAt(X+ke)))return null;me+=Me.length-1}let ve=null,we=X+me+1;if(ve=x(A,R,W+1,we,U),!U)for(;!ve&&(we=q(R,we))<R.length;)ve=x(A,R,W+1,we,U),we++;if(!ve)return null;if(A.charCodeAt(W)!==R.charCodeAt(X)){const Me=p(A.charCodeAt(W));if(!Me)return ve;for(let ke=0;ke<Me.length;ke++)if(Me[ke]!==R.charCodeAt(X+ke))return ve}return o({start:X,end:X+me+1},ve)}function q(A,R){for(let W=R;W<A.length;W++)if(n(A.charCodeAt(W))||W>0&&n(A.charCodeAt(W-1)))return W;return A.length}const I=H(t.$jk,O,k),j=H(t.$jk,O,b),T=new i.$Ec(1e4);function Q(A,R,W=!1){if(typeof A!="string"||typeof R!="string")return null;let X=T.get(A);X||(X=new RegExp(z.$7e(A),"i"),T.set(A,X));const U=X.exec(R);return U?[{start:U.index,end:U.index+U[0].length}]:W?j(A,R):I(A,R)}function Z(A,R){const W=S(A,A.toLowerCase(),0,R,R.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return W?oe(W):null}function ce(A,R,W,X,U,me){const ve=Math.min(13,A.length);for(;W<ve;W++){const we=S(A,R,W,X,U,me,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(we)return we}return[0,me]}function oe(A){if(typeof A>"u")return[];const R=[],W=A[1];for(let X=A.length-1;X>1;X--){const U=A[X]+W,me=R[R.length-1];me&&me.end===U?me.end=U+1:R.push({start:U,end:U+1})}return R}const te=128;function de(){const A=[],R=[];for(let W=0;W<=te;W++)R[W]=0;for(let W=0;W<=te;W++)A.push(R.slice(0));return A}function Be(A){const R=[];for(let W=0;W<=A;W++)R[W]=0;return R}const Fe=Be(2*te),Pe=Be(2*te),le=de(),_=de(),ae=de(),re=!1;function J(A,R,W,X,U){function me(we,Me,ke=" "){for(;we.length<Me;)we=ke+we;return we}let ve=` |   |${X.split("").map(we=>me(we,3)).join("|")}
`;for(let we=0;we<=W;we++)we===0?ve+=" |":ve+=`${R[we-1]}|`,ve+=A[we].slice(0,U+1).map(Me=>me(Me.toString(),3)).join("|")+`
`;return ve}function G(A,R,W,X){A=A.substr(R),W=W.substr(X),console.log(J(_,A,A.length,W,W.length)),console.log(J(ae,A,A.length,W,W.length)),console.log(J(le,A,A.length,W,W.length))}function ie(A,R){if(R<0||R>=A.length)return!1;const W=A.codePointAt(R);switch(W){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!z.$Ef(W)}}function ue(A,R){if(R<0||R>=A.length)return!1;switch(A.charCodeAt(R)){case 32:case 9:return!0;default:return!1}}function ye(A,R,W){return R[A]!==W[A]}function Ne(A,R,W,X,U,me,ve=!1){for(;R<W&&U<me;)A[R]===X[U]&&(ve&&(Fe[R]=U),R+=1),U+=1;return R===W}var Ae;(function(A){A[A.Diag=1]="Diag",A[A.Left=2]="Left",A[A.LeftLeft=3]="LeftLeft"})(Ae||(Ae={}));var ge;(function(A){A.Default=[-100,0];function R(W){return!W||W.length===2&&W[0]===-100&&W[1]===0}A.isDefault=R})(ge||(t.FuzzyScore=ge={}));class u{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(R,W){this.firstMatchCanBeWeak=R,this.boostFullMatch=W}}t.$uk=u;function S(A,R,W,X,U,me,ve=u.default){const we=A.length>te?te:A.length,Me=X.length>te?te:X.length;if(W>=we||me>=Me||we-W>Me-me||!Ne(R,W,we,U,me,Me,!0))return;D(we,Me,W,me,R,U);let ke=1,Ee=1,Ce=W,Re=me;const Ye=[!1];for(ke=1,Ce=W;Ce<we;ke++,Ce++){const se=Fe[Ce],pe=Pe[Ce],De=Ce+1<we?Pe[Ce+1]:Me;for(Ee=se-me+1,Re=se;Re<De;Ee++,Re++){let Le=Number.MIN_SAFE_INTEGER,ze=!1;Re<=pe&&(Le=a(A,R,Ce,W,X,U,Re,Me,me,le[ke-1][Ee-1]===0,Ye));let Ve=0;Le!==Number.MAX_SAFE_INTEGER&&(ze=!0,Ve=Le+_[ke-1][Ee-1]);const _e=Re>se,tt=_e?_[ke][Ee-1]+(le[ke][Ee-1]>0?-5:0):0,nt=Re>se+1&&le[ke][Ee-1]>0,Je=nt?_[ke][Ee-2]+(le[ke][Ee-2]>0?-5:0):0;if(nt&&(!_e||Je>=tt)&&(!ze||Je>=Ve))_[ke][Ee]=Je,ae[ke][Ee]=3,le[ke][Ee]=0;else if(_e&&(!ze||tt>=Ve))_[ke][Ee]=tt,ae[ke][Ee]=2,le[ke][Ee]=0;else if(ze)_[ke][Ee]=Ve,ae[ke][Ee]=1,le[ke][Ee]=le[ke-1][Ee-1]+1;else throw new Error("not possible")}}if(re&&G(A,W,X,me),!Ye[0]&&!ve.firstMatchCanBeWeak)return;ke--,Ee--;const st=[_[ke][Ee],me];let Ge=0,Ue=0;for(;ke>=1;){let se=Ee;do{const pe=ae[ke][se];if(pe===3)se=se-2;else if(pe===2)se=se-1;else break}while(se>=1);Ge>1&&R[W+ke-1]===U[me+Ee-1]&&!ye(se+me-1,X,U)&&Ge+1>le[ke][se]&&(se=Ee),se===Ee?Ge++:Ge=1,Ue||(Ue=se),ke--,Ee=se-1,st.push(Ee)}Me===we&&ve.boostFullMatch&&(st[0]+=2);const Y=Ue-we;return st[0]-=Y,st}function D(A,R,W,X,U,me){let ve=A-1,we=R-1;for(;ve>=W&&we>=X;)U[ve]===me[we]&&(Pe[ve]=we,ve--),we--}function a(A,R,W,X,U,me,ve,we,Me,ke,Ee){if(R[W]!==me[ve])return Number.MIN_SAFE_INTEGER;let Ce=1,Re=!1;return ve===W-X?Ce=A[W]===U[ve]?7:5:ye(ve,U,me)&&(ve===0||!ye(ve-1,U,me))?(Ce=A[W]===U[ve]?7:5,Re=!0):ie(me,ve)&&(ve===0||!ie(me,ve-1))?Ce=5:(ie(me,ve-1)||ue(me,ve-1))&&(Ce=5,Re=!0),Ce>1&&W===X&&(Ee[0]=!0),Re||(Re=ye(ve,U,me)||ie(me,ve-1)||ue(me,ve-1)),W===X?ve>Me&&(Ce-=Re?3:5):ke?Ce+=Re?2:0:Ce+=Re?0:1,ve+1===we&&(Ce-=Re?3:5),Ce}function d(A,R,W,X,U,me,ve){return l(A,R,W,X,U,me,!0,ve)}function s(A,R,W,X,U,me,ve){return l(A,R,W,X,U,me,!1,ve)}function l(A,R,W,X,U,me,ve,we){let Me=S(A,R,W,X,U,me,we);if(Me&&!ve)return Me;if(A.length>=3){const ke=Math.min(7,A.length-1);for(let Ee=W+1;Ee<ke;Ee++){const Ce=F(A,Ee);if(Ce){const Re=S(Ce,Ce.toLowerCase(),W,X,U,me,we);Re&&(Re[0]-=3,(!Me||Re[0]>Me[0])&&(Me=Re))}}}return Me}function F(A,R){if(R+1>=A.length)return;const W=A[R],X=A[R+1];if(W!==X)return A.slice(0,R)+X+W+A.slice(R+2)}}),define(be[52],$e([1,0,10]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bj=t.$_i=void 0,t.$8i=N,t.$9i=z,t.$0i=H,t.$$i=k,t.$aj=n;function N(m){return z(m,0)}function z(m,p){switch(typeof m){case"object":return m===null?H(349,p):Array.isArray(m)?b(m,p):$(m,p);case"string":return k(m,p);case"boolean":return E(m,p);case"number":return H(m,p);case"undefined":return H(937,p);default:return H(617,p)}}function H(m,p){return(p<<5)-p+m|0}function E(m,p){return H(m?433:863,p)}function k(m,p){p=H(149417,p);for(let v=0,o=m.length;v<o;v++)p=H(m.charCodeAt(v),p);return p}function b(m,p){return p=H(104579,p),m.reduce((v,o)=>z(o,v),p)}function $(m,p){return p=H(181387,p),Object.keys(m).sort().reduce((v,o)=>(v=k(o,v),z(m[o],v)),p)}class w{constructor(){this.g=0}get value(){return this.g}hash(p){return this.g=z(p,this.g),this.g}}t.$_i=w;var P;(function(m){m[m.BLOCK_SIZE=64]="BLOCK_SIZE",m[m.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(P||(P={}));function c(m,p,v=32){const o=v-p,g=~((1<<o)-1);return(m<<p|(g&m)>>>o)>>>0}function f(m,p=0,v=m.byteLength,o=0){for(let g=0;g<v;g++)m[p+g]=o}function e(m,p,v="0"){for(;m.length<p;)m=v+m;return m}function n(m,p=32){return m instanceof ArrayBuffer?Array.from(new Uint8Array(m)).map(v=>v.toString(16).padStart(2,"0")).join(""):e((m>>>0).toString(16),p/4)}class h{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(p){const v=p.length;if(v===0)return;const o=this.p;let g=this.r,r=this.u,B,C;for(r!==0?(B=r,C=-1,r=0):(B=p.charCodeAt(0),C=0);;){let L=B;if(i.$pf(B))if(C+1<v){const M=p.charCodeAt(C+1);i.$qf(M)?(C++,L=i.$rf(B,M)):L=65533}else{r=B;break}else i.$qf(B)&&(L=65533);if(g=this.w(o,g,L),C++,C<v)B=p.charCodeAt(C);else break}this.r=g,this.u=r}w(p,v,o){return o<128?p[v++]=o:o<2048?(p[v++]=192|(o&1984)>>>6,p[v++]=128|(o&63)>>>0):o<65536?(p[v++]=224|(o&61440)>>>12,p[v++]=128|(o&4032)>>>6,p[v++]=128|(o&63)>>>0):(p[v++]=240|(o&1835008)>>>18,p[v++]=128|(o&258048)>>>12,p[v++]=128|(o&4032)>>>6,p[v++]=128|(o&63)>>>0),v>=64&&(this.y(),v-=64,this.t+=64,p[0]=p[64],p[1]=p[65],p[2]=p[66]),v}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),n(this.h)+n(this.l)+n(this.m)+n(this.n)+n(this.o)}x(){this.p[this.r++]=128,f(this.p,this.r),this.r>56&&(this.y(),f(this.p));const p=8*this.t;this.q.setUint32(56,Math.floor(p/4294967296),!1),this.q.setUint32(60,p%4294967296,!1),this.y()}y(){const p=h.g,v=this.q;for(let y=0;y<64;y+=4)p.setUint32(y,v.getUint32(y,!1),!1);for(let y=64;y<320;y+=4)p.setUint32(y,c(p.getUint32(y-12,!1)^p.getUint32(y-32,!1)^p.getUint32(y-56,!1)^p.getUint32(y-64,!1),1),!1);let o=this.h,g=this.l,r=this.m,B=this.n,C=this.o,L,M,O;for(let y=0;y<80;y++)y<20?(L=g&r|~g&B,M=1518500249):y<40?(L=g^r^B,M=1859775393):y<60?(L=g&r|g&B|r&B,M=2400959708):(L=g^r^B,M=3395469782),O=c(o,5)+L+C+M+p.getUint32(y*4,!1)&4294967295,C=B,B=r,r=c(g,30),g=o,o=O;this.h=this.h+o&4294967295,this.l=this.l+g&4294967295,this.m=this.m+r&4294967295,this.n=this.n+B&4294967295,this.o=this.o+C&4294967295}}t.$bj=h}),define(be[90],$e([1,0,78,52]),function(ne,t,i,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ht=t.$ft=void 0,t.$gt=H;class z{constructor(c){this.a=c}getElements(){const c=this.a,f=new Int32Array(c.length);for(let e=0,n=c.length;e<n;e++)f[e]=c.charCodeAt(e);return f}}t.$ft=z;function H(P,c,f){return new w(new z(P),new z(c)).ComputeDiff(f).changes}class E{static Assert(c,f){if(!c)throw new Error(f)}}class k{static Copy(c,f,e,n,h){for(let m=0;m<h;m++)e[n+m]=c[f+m]}static Copy2(c,f,e,n,h){for(let m=0;m<h;m++)e[n+m]=c[f+m]}}var b;(function(P){P[P.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(b||(b={}));class ${constructor(){this.a=[],this.b=1073741824,this.c=1073741824,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new i.$et(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=1073741824,this.c=1073741824}AddOriginalElement(c,f){this.b=Math.min(this.b,c),this.c=Math.min(this.c,f),this.d++}AddModifiedElement(c,f){this.b=Math.min(this.b,c),this.c=Math.min(this.c,f),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class w{constructor(c,f,e=null){this.a=e,this.b=c,this.c=f;const[n,h,m]=w.o(c),[p,v,o]=w.o(f);this.d=m&&o,this.e=n,this.f=h,this.g=p,this.h=v,this.k=[],this.m=[]}static n(c){return c.length>0&&typeof c[0]=="string"}static o(c){const f=c.getElements();if(w.n(f)){const e=new Int32Array(f.length);for(let n=0,h=f.length;n<h;n++)e[n]=(0,N.$$i)(f[n],0);return[f,e,!0]}return f instanceof Int32Array?[[],f,!1]:[[],new Int32Array(f),!1]}p(c,f){return this.f[c]!==this.h[f]?!1:this.d?this.e[c]===this.g[f]:!0}q(c,f){if(!this.p(c,f))return!1;const e=w.r(this.b,c),n=w.r(this.c,f);return e===n}static r(c,f){return typeof c.getStrictElement=="function"?c.getStrictElement(f):null}s(c,f){return this.f[c]!==this.f[f]?!1:this.d?this.e[c]===this.e[f]:!0}u(c,f){return this.h[c]!==this.h[f]?!1:this.d?this.g[c]===this.g[f]:!0}ComputeDiff(c){return this.v(0,this.f.length-1,0,this.h.length-1,c)}v(c,f,e,n,h){const m=[!1];let p=this.w(c,f,e,n,m);return h&&(p=this.z(p)),{quitEarly:m[0],changes:p}}w(c,f,e,n,h){for(h[0]=!1;c<=f&&e<=n&&this.p(c,e);)c++,e++;for(;f>=c&&n>=e&&this.p(f,n);)f--,n--;if(c>f||e>n){let r;return e<=n?(E.Assert(c===f+1,"originalStart should only be one more than originalEnd"),r=[new i.$et(c,0,e,n-e+1)]):c<=f?(E.Assert(e===n+1,"modifiedStart should only be one more than modifiedEnd"),r=[new i.$et(c,f-c+1,e,0)]):(E.Assert(c===f+1,"originalStart should only be one more than originalEnd"),E.Assert(e===n+1,"modifiedStart should only be one more than modifiedEnd"),r=[]),r}const m=[0],p=[0],v=this.y(c,f,e,n,m,p,h),o=m[0],g=p[0];if(v!==null)return v;if(!h[0]){const r=this.w(c,o,e,g,h);let B=[];return h[0]?B=[new i.$et(o+1,f-(o+1)+1,g+1,n-(g+1)+1)]:B=this.w(o+1,f,g+1,n,h),this.H(r,B)}return[new i.$et(c,f-c+1,e,n-e+1)]}x(c,f,e,n,h,m,p,v,o,g,r,B,C,L,M,O,y,x){let q=null,I=null,j=new $,T=f,Q=e,Z=C[0]-O[0]-n,ce=-1073741824,oe=this.k.length-1;do{const te=Z+c;te===T||te<Q&&o[te-1]<o[te+1]?(r=o[te+1],L=r-Z-n,r<ce&&j.MarkNextChange(),ce=r,j.AddModifiedElement(r+1,L),Z=te+1-c):(r=o[te-1]+1,L=r-Z-n,r<ce&&j.MarkNextChange(),ce=r-1,j.AddOriginalElement(r,L+1),Z=te-1-c),oe>=0&&(o=this.k[oe],c=o[0],T=1,Q=o.length-1)}while(--oe>=-1);if(q=j.getReverseChanges(),x[0]){let te=C[0]+1,de=O[0]+1;if(q!==null&&q.length>0){const Be=q[q.length-1];te=Math.max(te,Be.getOriginalEnd()),de=Math.max(de,Be.getModifiedEnd())}I=[new i.$et(te,B-te+1,de,M-de+1)]}else{j=new $,T=m,Q=p,Z=C[0]-O[0]-v,ce=1073741824,oe=y?this.m.length-1:this.m.length-2;do{const te=Z+h;te===T||te<Q&&g[te-1]>=g[te+1]?(r=g[te+1]-1,L=r-Z-v,r>ce&&j.MarkNextChange(),ce=r+1,j.AddOriginalElement(r+1,L+1),Z=te+1-h):(r=g[te-1],L=r-Z-v,r>ce&&j.MarkNextChange(),ce=r,j.AddModifiedElement(r+1,L+1),Z=te-1-h),oe>=0&&(g=this.m[oe],h=g[0],T=1,Q=g.length-1)}while(--oe>=-1);I=j.getChanges()}return this.H(q,I)}y(c,f,e,n,h,m,p){let v=0,o=0,g=0,r=0,B=0,C=0;c--,e--,h[0]=0,m[0]=0,this.k=[],this.m=[];const L=f-c+(n-e),M=L+1,O=new Int32Array(M),y=new Int32Array(M),x=n-e,q=f-c,I=c-e,j=f-n,Q=(q-x)%2===0;O[x]=c,y[q]=f,p[0]=!1;for(let Z=1;Z<=L/2+1;Z++){let ce=0,oe=0;g=this.J(x-Z,Z,x,M),r=this.J(x+Z,Z,x,M);for(let de=g;de<=r;de+=2){de===g||de<r&&O[de-1]<O[de+1]?v=O[de+1]:v=O[de-1]+1,o=v-(de-x)-I;const Be=v;for(;v<f&&o<n&&this.p(v+1,o+1);)v++,o++;if(O[de]=v,v+o>ce+oe&&(ce=v,oe=o),!Q&&Math.abs(de-q)<=Z-1&&v>=y[de])return h[0]=v,m[0]=o,Be<=y[de]&&1447>0&&Z<=1448?this.x(x,g,r,I,q,B,C,j,O,y,v,f,h,o,n,m,Q,p):null}const te=(ce-c+(oe-e)-Z)/2;if(this.a!==null&&!this.a(ce,te))return p[0]=!0,h[0]=ce,m[0]=oe,te>0&&1447>0&&Z<=1448?this.x(x,g,r,I,q,B,C,j,O,y,v,f,h,o,n,m,Q,p):(c++,e++,[new i.$et(c,f-c+1,e,n-e+1)]);B=this.J(q-Z,Z,q,M),C=this.J(q+Z,Z,q,M);for(let de=B;de<=C;de+=2){de===B||de<C&&y[de-1]>=y[de+1]?v=y[de+1]-1:v=y[de-1],o=v-(de-q)-j;const Be=v;for(;v>c&&o>e&&this.p(v,o);)v--,o--;if(y[de]=v,Q&&Math.abs(de-x)<=Z&&v<=O[de])return h[0]=v,m[0]=o,Be>=O[de]&&1447>0&&Z<=1448?this.x(x,g,r,I,q,B,C,j,O,y,v,f,h,o,n,m,Q,p):null}if(Z<=1447){let de=new Int32Array(r-g+2);de[0]=x-g+1,k.Copy2(O,g,de,1,r-g+1),this.k.push(de),de=new Int32Array(C-B+2),de[0]=q-B+1,k.Copy2(y,B,de,1,C-B+1),this.m.push(de)}}return this.x(x,g,r,I,q,B,C,j,O,y,v,f,h,o,n,m,Q,p)}z(c){for(let f=0;f<c.length;f++){const e=c[f],n=f<c.length-1?c[f+1].originalStart:this.f.length,h=f<c.length-1?c[f+1].modifiedStart:this.h.length,m=e.originalLength>0,p=e.modifiedLength>0;for(;e.originalStart+e.originalLength<n&&e.modifiedStart+e.modifiedLength<h&&(!m||this.s(e.originalStart,e.originalStart+e.originalLength))&&(!p||this.u(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const o=this.q(e.originalStart,e.modifiedStart);if(this.q(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!o)break;e.originalStart++,e.modifiedStart++}const v=[null];if(f<c.length-1&&this.I(c[f],c[f+1],v)){c[f]=v[0],c.splice(f+1,1),f--;continue}}for(let f=c.length-1;f>=0;f--){const e=c[f];let n=0,h=0;if(f>0){const r=c[f-1];n=r.originalStart+r.originalLength,h=r.modifiedStart+r.modifiedLength}const m=e.originalLength>0,p=e.modifiedLength>0;let v=0,o=this.G(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let r=1;;r++){const B=e.originalStart-r,C=e.modifiedStart-r;if(B<n||C<h||m&&!this.s(B,B+e.originalLength)||p&&!this.u(C,C+e.modifiedLength))break;const M=(B===n&&C===h?5:0)+this.G(B,e.originalLength,C,e.modifiedLength);M>o&&(o=M,v=r)}e.originalStart-=v,e.modifiedStart-=v;const g=[null];if(f>0&&this.I(c[f-1],c[f],g)){c[f-1]=g[0],c.splice(f,1),f++;continue}}if(this.d)for(let f=1,e=c.length;f<e;f++){const n=c[f-1],h=c[f],m=h.originalStart-n.originalStart-n.originalLength,p=n.originalStart,v=h.originalStart+h.originalLength,o=v-p,g=n.modifiedStart,r=h.modifiedStart+h.modifiedLength,B=r-g;if(m<5&&o<20&&B<20){const C=this.A(p,o,g,B,m);if(C){const[L,M]=C;(L!==n.originalStart+n.originalLength||M!==n.modifiedStart+n.modifiedLength)&&(n.originalLength=L-n.originalStart,n.modifiedLength=M-n.modifiedStart,h.originalStart=L+m,h.modifiedStart=M+m,h.originalLength=v-h.originalStart,h.modifiedLength=r-h.modifiedStart)}}}return c}A(c,f,e,n,h){if(f<h||n<h)return null;const m=c+f-h+1,p=e+n-h+1;let v=0,o=0,g=0;for(let r=c;r<m;r++)for(let B=e;B<p;B++){const C=this.B(r,B,h);C>0&&C>v&&(v=C,o=r,g=B)}return v>0?[o,g]:null}B(c,f,e){let n=0;for(let h=0;h<e;h++){if(!this.p(c+h,f+h))return 0;n+=this.e[c+h].length}return n}C(c){return c<=0||c>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[c])}D(c,f){if(this.C(c)||this.C(c-1))return!0;if(f>0){const e=c+f;if(this.C(e-1)||this.C(e))return!0}return!1}E(c){return c<=0||c>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[c])}F(c,f){if(this.E(c)||this.E(c-1))return!0;if(f>0){const e=c+f;if(this.E(e-1)||this.E(e))return!0}return!1}G(c,f,e,n){const h=this.D(c,f)?1:0,m=this.F(e,n)?1:0;return h+m}H(c,f){const e=[];if(c.length===0||f.length===0)return f.length>0?f:c;if(this.I(c[c.length-1],f[0],e)){const n=new Array(c.length+f.length-1);return k.Copy(c,0,n,0,c.length-1),n[c.length-1]=e[0],k.Copy(f,1,n,c.length,f.length-1),n}else{const n=new Array(c.length+f.length);return k.Copy(c,0,n,0,c.length),k.Copy(f,0,n,c.length,f.length),n}}I(c,f,e){if(E.Assert(c.originalStart<=f.originalStart,"Left change is not less than or equal to right change"),E.Assert(c.modifiedStart<=f.modifiedStart,"Left change is not less than or equal to right change"),c.originalStart+c.originalLength>=f.originalStart||c.modifiedStart+c.modifiedLength>=f.modifiedStart){const n=c.originalStart;let h=c.originalLength;const m=c.modifiedStart;let p=c.modifiedLength;return c.originalStart+c.originalLength>=f.originalStart&&(h=f.originalStart+f.originalLength-c.originalStart),c.modifiedStart+c.modifiedLength>=f.modifiedStart&&(p=f.modifiedStart+f.modifiedLength-c.modifiedStart),e[0]=new i.$et(n,h,m,p),!0}else return e[0]=null,!1}J(c,f,e,n){if(c>=0&&c<n)return c;const h=e,m=n-e-1,p=f%2===0;if(c<0){const v=h%2===0;return p===v?0:1}else{const v=m%2===0;return p===v?n-1:n-2}}}t.$ht=w}),define(be[53],$e([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4d=void 0,t.$4d=Symbol("MicrotaskDelay")}),define(be[91],$e([1,0,12,10]),function(ne,t,i,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ni=t.$mi=t.$li=t.$ki=t.$ji=void 0;class z{constructor(){this.b="",this.c=0}reset(f){return this.b=f,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(f){const e=f.charCodeAt(0),n=this.b.charCodeAt(this.c);return e-n}value(){return this.b[this.c]}}t.$ji=z;class H{constructor(f=!0){this.e=f}reset(f){return this.b=f,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let f=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(f)this.c++;else break;else f=!1;return this}cmp(f){return this.e?(0,N.$ff)(f,this.b,0,f.length,this.c,this.d):(0,N.$hf)(f,this.b,0,f.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}t.$ki=H;class E{constructor(f=!0,e=!0){this.f=f,this.g=e}reset(f){this.d=0,this.e=0,this.b=f,this.c=f.length;for(let e=f.length-1;e>=0;e--,this.c--){const n=this.b.charCodeAt(e);if(!(n===47||this.f&&n===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let f=!0;for(;this.e<this.c;this.e++){const e=this.b.charCodeAt(this.e);if(e===47||this.f&&e===92)if(f)this.d++;else break;else f=!1}return this}cmp(f){return this.g?(0,N.$ff)(f,this.b,0,f.length,this.d,this.e):(0,N.$hf)(f,this.b,0,f.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}t.$li=E;var k;(function(c){c[c.Scheme=1]="Scheme",c[c.Authority=2]="Authority",c[c.Path=3]="Path",c[c.Query=4]="Query",c[c.Fragment=5]="Fragment"})(k||(k={}));class b{constructor(f,e){this.f=f,this.g=e,this.d=[],this.e=0}reset(f){return this.c=f,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new E(!1,!this.f(f)),this.b.reset(f.path),this.b.value()&&this.d.push(3)),this.g(f)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(f){if(this.d[this.e]===1)return(0,N.$gf)(f,this.c.scheme);if(this.d[this.e]===2)return(0,N.$gf)(f,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(f);if(this.d[this.e]===4)return(0,N.$ef)(f,this.c.query);if(this.d[this.e]===5)return(0,N.$ef)(f,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}t.$mi=b;class ${constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const f=this.right;return this.right=f.left,f.left=this,this.updateHeight(),f.updateHeight(),f}rotateRight(){const f=this.left;return this.left=f.right,f.right=this,this.updateHeight(),f.updateHeight(),f}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var w;(function(c){c[c.Left=-1]="Left",c[c.Mid=0]="Mid",c[c.Right=1]="Right"})(w||(w={}));class P{static forUris(f=()=>!1,e=()=>!1){return new P(new b(f,e))}static forPaths(f=!1){return new P(new E(void 0,!f))}static forStrings(){return new P(new z)}static forConfigKeys(){return new P(new H)}constructor(f){this.b=f}clear(){this.c=void 0}fill(f,e){if(e){const n=e.slice(0);(0,i.$Xb)(n);for(const h of n)this.set(h,f)}else{const n=f.slice(0);(0,i.$Xb)(n);for(const h of n)this.set(h[0],h[1])}}set(f,e){const n=this.b.reset(f);let h;this.c||(this.c=new $,this.c.segment=n.value());const m=[];for(h=this.c;;){const v=n.cmp(h.segment);if(v>0)h.left||(h.left=new $,h.left.segment=n.value()),m.push([-1,h]),h=h.left;else if(v<0)h.right||(h.right=new $,h.right.segment=n.value()),m.push([1,h]),h=h.right;else if(n.hasNext())n.next(),h.mid||(h.mid=new $,h.mid.segment=n.value()),m.push([0,h]),h=h.mid;else break}const p=h.value;h.value=e,h.key=f;for(let v=m.length-1;v>=0;v--){const o=m[v][1];o.updateHeight();const g=o.balanceFactor();if(g<-1||g>1){const r=m[v][0],B=m[v+1][0];if(r===1&&B===1)m[v][1]=o.rotateLeft();else if(r===-1&&B===-1)m[v][1]=o.rotateRight();else if(r===1&&B===-1)o.right=m[v+1][1]=m[v+1][1].rotateRight(),m[v][1]=o.rotateLeft();else if(r===-1&&B===1)o.left=m[v+1][1]=m[v+1][1].rotateLeft(),m[v][1]=o.rotateRight();else throw new Error;if(v>0)switch(m[v-1][0]){case-1:m[v-1][1].left=m[v][1];break;case 1:m[v-1][1].right=m[v][1];break;case 0:m[v-1][1].mid=m[v][1];break}else this.c=m[0][1]}}return p}get(f){return this.d(f)?.value}d(f){const e=this.b.reset(f);let n=this.c;for(;n;){const h=e.cmp(n.segment);if(h>0)n=n.left;else if(h<0)n=n.right;else if(e.hasNext())e.next(),n=n.mid;else break}return n}has(f){const e=this.d(f);return!(e?.value===void 0&&e?.mid===void 0)}delete(f){return this.e(f,!1)}deleteSuperstr(f){return this.e(f,!0)}e(f,e){const n=this.b.reset(f),h=[];let m=this.c;for(;m;){const p=n.cmp(m.segment);if(p>0)h.push([-1,m]),m=m.left;else if(p<0)h.push([1,m]),m=m.right;else if(n.hasNext())n.next(),h.push([0,m]),m=m.mid;else break}if(m){if(e?(m.left=void 0,m.mid=void 0,m.right=void 0,m.height=1):(m.key=void 0,m.value=void 0),!m.mid&&!m.value)if(m.left&&m.right){const p=this.f(m.right);if(p.key){const{key:v,value:o,segment:g}=p;this.e(p.key,!1),m.key=v,m.value=o,m.segment=g}}else{const p=m.left??m.right;if(h.length>0){const[v,o]=h[h.length-1];switch(v){case-1:o.left=p;break;case 0:o.mid=p;break;case 1:o.right=p;break}}else this.c=p}for(let p=h.length-1;p>=0;p--){const v=h[p][1];v.updateHeight();const o=v.balanceFactor();if(o>1?(v.right.balanceFactor()>=0||(v.right=v.right.rotateRight()),h[p][1]=v.rotateLeft()):o<-1&&(v.left.balanceFactor()<=0||(v.left=v.left.rotateLeft()),h[p][1]=v.rotateRight()),p>0)switch(h[p-1][0]){case-1:h[p-1][1].left=h[p][1];break;case 1:h[p-1][1].right=h[p][1];break;case 0:h[p-1][1].mid=h[p][1];break}else this.c=h[0][1]}}}f(f){for(;f.left;)f=f.left;return f}findSubstr(f){const e=this.b.reset(f);let n=this.c,h;for(;n;){const m=e.cmp(n.segment);if(m>0)n=n.left;else if(m<0)n=n.right;else if(e.hasNext())e.next(),h=n.value||h,n=n.mid;else break}return n&&n.value||h}findSuperstr(f){return this.g(f,!1)}g(f,e){const n=this.b.reset(f);let h=this.c;for(;h;){const m=n.cmp(h.segment);if(m>0)h=h.left;else if(m<0)h=h.right;else if(n.hasNext())n.next(),h=h.mid;else return h.mid?this.h(h.mid):e?h.value:void 0}}hasElementOrSubtree(f){return this.g(f,!0)!==void 0}forEach(f){for(const[e,n]of this)f(n,e)}*[Symbol.iterator](){yield*this.h(this.c)}h(f){const e=[];return this.j(f,e),e[Symbol.iterator]()}j(f,e){f&&(f.left&&this.j(f.left,e),f.value&&e.push([f.key,f.value]),f.mid&&this.j(f.mid,e),f.right&&this.j(f.right,e))}_isBalanced(){const f=e=>{if(!e)return!0;const n=e.balanceFactor();return n<-1||n>1?!1:f(e.left)&&f(e.right)};return f(this.c)}}t.$ni=P}),define(be[7],$e([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Uf=i,t.$Vf=N,t.$Wf=z,t.$Xf=H,t.$Yf=E,t.$Zf=k,t.$1f=b,t.$2f=$,t.$3f=w,t.$4f=P,t.$5f=c,t.$6f=f,t.$7f=e,t.$8f=h,t.$9f=m,t.$0f=p,t.$$f=v,t.$_f=o;function i(g){return typeof g=="string"}function N(g){return Array.isArray(g)&&g.every(r=>i(r))}function z(g){return typeof g=="object"&&g!==null&&!Array.isArray(g)&&!(g instanceof RegExp)&&!(g instanceof Date)}function H(g){const r=Object.getPrototypeOf(Uint8Array);return typeof g=="object"&&g instanceof r}function E(g){return typeof g=="number"&&!isNaN(g)}function k(g){return!!g&&typeof g[Symbol.iterator]=="function"}function b(g){return g===!0||g===!1}function $(g){return typeof g>"u"}function w(g){return!P(g)}function P(g){return $(g)||g===null}function c(g,r){if(!g)throw new Error(r?`Unexpected type, expected '${r}'`:"Unexpected type")}function f(g){if(P(g))throw new Error("Assertion Failed: argument is undefined or null");return g}function e(...g){const r=[];for(let B=0;B<g.length;B++){const C=g[B];if(P(C))throw new Error(`Assertion Failed: argument at index ${B} is undefined or null`);r.push(C)}return r}const n=Object.prototype.hasOwnProperty;function h(g){if(!z(g))return!1;for(const r in g)if(n.call(g,r))return!1;return!0}function m(g){return typeof g=="function"}function p(...g){return g.length>0&&g.every(m)}function v(g,r){const B=Math.min(g.length,r.length);for(let C=0;C<B;C++)o(g[C],r[C])}function o(g,r){if(i(r)){if(typeof g!==r)throw new Error(`argument does not match constraint: typeof ${r}`)}else if(m(r)){try{if(g instanceof r)return}catch{}if(!P(g)&&g.constructor===r||r.length===1&&r.call(void 0,g)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(be[38],$e([1,0,7]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Bj=z,t.$Cj=H;const N=Object.create(null);function z(E,k){if((0,i.$Uf)(k)){const b=N[k];if(b===void 0)throw new Error(`${E} references an unknown codicon: ${k}`);k=b}return N[E]=k,{id:E}}function H(){return N}}),define(be[92],$e([1,0,38]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Dj=void 0,t.$Dj={add:(0,i.$Bj)("add",6e4),plus:(0,i.$Bj)("plus",6e4),gistNew:(0,i.$Bj)("gist-new",6e4),repoCreate:(0,i.$Bj)("repo-create",6e4),lightbulb:(0,i.$Bj)("lightbulb",60001),lightBulb:(0,i.$Bj)("light-bulb",60001),repo:(0,i.$Bj)("repo",60002),repoDelete:(0,i.$Bj)("repo-delete",60002),gistFork:(0,i.$Bj)("gist-fork",60003),repoForked:(0,i.$Bj)("repo-forked",60003),gitPullRequest:(0,i.$Bj)("git-pull-request",60004),gitPullRequestAbandoned:(0,i.$Bj)("git-pull-request-abandoned",60004),recordKeys:(0,i.$Bj)("record-keys",60005),keyboard:(0,i.$Bj)("keyboard",60005),tag:(0,i.$Bj)("tag",60006),gitPullRequestLabel:(0,i.$Bj)("git-pull-request-label",60006),tagAdd:(0,i.$Bj)("tag-add",60006),tagRemove:(0,i.$Bj)("tag-remove",60006),person:(0,i.$Bj)("person",60007),personFollow:(0,i.$Bj)("person-follow",60007),personOutline:(0,i.$Bj)("person-outline",60007),personFilled:(0,i.$Bj)("person-filled",60007),gitBranch:(0,i.$Bj)("git-branch",60008),gitBranchCreate:(0,i.$Bj)("git-branch-create",60008),gitBranchDelete:(0,i.$Bj)("git-branch-delete",60008),sourceControl:(0,i.$Bj)("source-control",60008),mirror:(0,i.$Bj)("mirror",60009),mirrorPublic:(0,i.$Bj)("mirror-public",60009),star:(0,i.$Bj)("star",60010),starAdd:(0,i.$Bj)("star-add",60010),starDelete:(0,i.$Bj)("star-delete",60010),starEmpty:(0,i.$Bj)("star-empty",60010),comment:(0,i.$Bj)("comment",60011),commentAdd:(0,i.$Bj)("comment-add",60011),alert:(0,i.$Bj)("alert",60012),warning:(0,i.$Bj)("warning",60012),search:(0,i.$Bj)("search",60013),searchSave:(0,i.$Bj)("search-save",60013),logOut:(0,i.$Bj)("log-out",60014),signOut:(0,i.$Bj)("sign-out",60014),logIn:(0,i.$Bj)("log-in",60015),signIn:(0,i.$Bj)("sign-in",60015),eye:(0,i.$Bj)("eye",60016),eyeUnwatch:(0,i.$Bj)("eye-unwatch",60016),eyeWatch:(0,i.$Bj)("eye-watch",60016),circleFilled:(0,i.$Bj)("circle-filled",60017),primitiveDot:(0,i.$Bj)("primitive-dot",60017),closeDirty:(0,i.$Bj)("close-dirty",60017),debugBreakpoint:(0,i.$Bj)("debug-breakpoint",60017),debugBreakpointDisabled:(0,i.$Bj)("debug-breakpoint-disabled",60017),debugHint:(0,i.$Bj)("debug-hint",60017),terminalDecorationSuccess:(0,i.$Bj)("terminal-decoration-success",60017),primitiveSquare:(0,i.$Bj)("primitive-square",60018),edit:(0,i.$Bj)("edit",60019),pencil:(0,i.$Bj)("pencil",60019),info:(0,i.$Bj)("info",60020),issueOpened:(0,i.$Bj)("issue-opened",60020),gistPrivate:(0,i.$Bj)("gist-private",60021),gitForkPrivate:(0,i.$Bj)("git-fork-private",60021),lock:(0,i.$Bj)("lock",60021),mirrorPrivate:(0,i.$Bj)("mirror-private",60021),close:(0,i.$Bj)("close",60022),removeClose:(0,i.$Bj)("remove-close",60022),x:(0,i.$Bj)("x",60022),repoSync:(0,i.$Bj)("repo-sync",60023),sync:(0,i.$Bj)("sync",60023),clone:(0,i.$Bj)("clone",60024),desktopDownload:(0,i.$Bj)("desktop-download",60024),beaker:(0,i.$Bj)("beaker",60025),microscope:(0,i.$Bj)("microscope",60025),vm:(0,i.$Bj)("vm",60026),deviceDesktop:(0,i.$Bj)("device-desktop",60026),file:(0,i.$Bj)("file",60027),fileText:(0,i.$Bj)("file-text",60027),more:(0,i.$Bj)("more",60028),ellipsis:(0,i.$Bj)("ellipsis",60028),kebabHorizontal:(0,i.$Bj)("kebab-horizontal",60028),mailReply:(0,i.$Bj)("mail-reply",60029),reply:(0,i.$Bj)("reply",60029),organization:(0,i.$Bj)("organization",60030),organizationFilled:(0,i.$Bj)("organization-filled",60030),organizationOutline:(0,i.$Bj)("organization-outline",60030),newFile:(0,i.$Bj)("new-file",60031),fileAdd:(0,i.$Bj)("file-add",60031),newFolder:(0,i.$Bj)("new-folder",60032),fileDirectoryCreate:(0,i.$Bj)("file-directory-create",60032),trash:(0,i.$Bj)("trash",60033),trashcan:(0,i.$Bj)("trashcan",60033),history:(0,i.$Bj)("history",60034),clock:(0,i.$Bj)("clock",60034),folder:(0,i.$Bj)("folder",60035),fileDirectory:(0,i.$Bj)("file-directory",60035),symbolFolder:(0,i.$Bj)("symbol-folder",60035),logoGithub:(0,i.$Bj)("logo-github",60036),markGithub:(0,i.$Bj)("mark-github",60036),github:(0,i.$Bj)("github",60036),terminal:(0,i.$Bj)("terminal",60037),console:(0,i.$Bj)("console",60037),repl:(0,i.$Bj)("repl",60037),zap:(0,i.$Bj)("zap",60038),symbolEvent:(0,i.$Bj)("symbol-event",60038),error:(0,i.$Bj)("error",60039),stop:(0,i.$Bj)("stop",60039),variable:(0,i.$Bj)("variable",60040),symbolVariable:(0,i.$Bj)("symbol-variable",60040),array:(0,i.$Bj)("array",60042),symbolArray:(0,i.$Bj)("symbol-array",60042),symbolModule:(0,i.$Bj)("symbol-module",60043),symbolPackage:(0,i.$Bj)("symbol-package",60043),symbolNamespace:(0,i.$Bj)("symbol-namespace",60043),symbolObject:(0,i.$Bj)("symbol-object",60043),symbolMethod:(0,i.$Bj)("symbol-method",60044),symbolFunction:(0,i.$Bj)("symbol-function",60044),symbolConstructor:(0,i.$Bj)("symbol-constructor",60044),symbolBoolean:(0,i.$Bj)("symbol-boolean",60047),symbolNull:(0,i.$Bj)("symbol-null",60047),symbolNumeric:(0,i.$Bj)("symbol-numeric",60048),symbolNumber:(0,i.$Bj)("symbol-number",60048),symbolStructure:(0,i.$Bj)("symbol-structure",60049),symbolStruct:(0,i.$Bj)("symbol-struct",60049),symbolParameter:(0,i.$Bj)("symbol-parameter",60050),symbolTypeParameter:(0,i.$Bj)("symbol-type-parameter",60050),symbolKey:(0,i.$Bj)("symbol-key",60051),symbolText:(0,i.$Bj)("symbol-text",60051),symbolReference:(0,i.$Bj)("symbol-reference",60052),goToFile:(0,i.$Bj)("go-to-file",60052),symbolEnum:(0,i.$Bj)("symbol-enum",60053),symbolValue:(0,i.$Bj)("symbol-value",60053),symbolRuler:(0,i.$Bj)("symbol-ruler",60054),symbolUnit:(0,i.$Bj)("symbol-unit",60054),activateBreakpoints:(0,i.$Bj)("activate-breakpoints",60055),archive:(0,i.$Bj)("archive",60056),arrowBoth:(0,i.$Bj)("arrow-both",60057),arrowDown:(0,i.$Bj)("arrow-down",60058),arrowLeft:(0,i.$Bj)("arrow-left",60059),arrowRight:(0,i.$Bj)("arrow-right",60060),arrowSmallDown:(0,i.$Bj)("arrow-small-down",60061),arrowSmallLeft:(0,i.$Bj)("arrow-small-left",60062),arrowSmallRight:(0,i.$Bj)("arrow-small-right",60063),arrowSmallUp:(0,i.$Bj)("arrow-small-up",60064),arrowUp:(0,i.$Bj)("arrow-up",60065),bell:(0,i.$Bj)("bell",60066),bold:(0,i.$Bj)("bold",60067),book:(0,i.$Bj)("book",60068),bookmark:(0,i.$Bj)("bookmark",60069),debugBreakpointConditionalUnverified:(0,i.$Bj)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,i.$Bj)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,i.$Bj)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,i.$Bj)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,i.$Bj)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,i.$Bj)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,i.$Bj)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,i.$Bj)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,i.$Bj)("debug-breakpoint-log-disabled",60075),briefcase:(0,i.$Bj)("briefcase",60076),broadcast:(0,i.$Bj)("broadcast",60077),browser:(0,i.$Bj)("browser",60078),bug:(0,i.$Bj)("bug",60079),calendar:(0,i.$Bj)("calendar",60080),caseSensitive:(0,i.$Bj)("case-sensitive",60081),check:(0,i.$Bj)("check",60082),checklist:(0,i.$Bj)("checklist",60083),chevronDown:(0,i.$Bj)("chevron-down",60084),chevronLeft:(0,i.$Bj)("chevron-left",60085),chevronRight:(0,i.$Bj)("chevron-right",60086),chevronUp:(0,i.$Bj)("chevron-up",60087),chromeClose:(0,i.$Bj)("chrome-close",60088),chromeMaximize:(0,i.$Bj)("chrome-maximize",60089),chromeMinimize:(0,i.$Bj)("chrome-minimize",60090),chromeRestore:(0,i.$Bj)("chrome-restore",60091),circleOutline:(0,i.$Bj)("circle-outline",60092),circle:(0,i.$Bj)("circle",60092),debugBreakpointUnverified:(0,i.$Bj)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,i.$Bj)("terminal-decoration-incomplete",60092),circleSlash:(0,i.$Bj)("circle-slash",60093),circuitBoard:(0,i.$Bj)("circuit-board",60094),clearAll:(0,i.$Bj)("clear-all",60095),clippy:(0,i.$Bj)("clippy",60096),closeAll:(0,i.$Bj)("close-all",60097),cloudDownload:(0,i.$Bj)("cloud-download",60098),cloudUpload:(0,i.$Bj)("cloud-upload",60099),code:(0,i.$Bj)("code",60100),collapseAll:(0,i.$Bj)("collapse-all",60101),colorMode:(0,i.$Bj)("color-mode",60102),commentDiscussion:(0,i.$Bj)("comment-discussion",60103),creditCard:(0,i.$Bj)("credit-card",60105),dash:(0,i.$Bj)("dash",60108),dashboard:(0,i.$Bj)("dashboard",60109),database:(0,i.$Bj)("database",60110),debugContinue:(0,i.$Bj)("debug-continue",60111),debugDisconnect:(0,i.$Bj)("debug-disconnect",60112),debugPause:(0,i.$Bj)("debug-pause",60113),debugRestart:(0,i.$Bj)("debug-restart",60114),debugStart:(0,i.$Bj)("debug-start",60115),debugStepInto:(0,i.$Bj)("debug-step-into",60116),debugStepOut:(0,i.$Bj)("debug-step-out",60117),debugStepOver:(0,i.$Bj)("debug-step-over",60118),debugStop:(0,i.$Bj)("debug-stop",60119),debug:(0,i.$Bj)("debug",60120),deviceCameraVideo:(0,i.$Bj)("device-camera-video",60121),deviceCamera:(0,i.$Bj)("device-camera",60122),deviceMobile:(0,i.$Bj)("device-mobile",60123),diffAdded:(0,i.$Bj)("diff-added",60124),diffIgnored:(0,i.$Bj)("diff-ignored",60125),diffModified:(0,i.$Bj)("diff-modified",60126),diffRemoved:(0,i.$Bj)("diff-removed",60127),diffRenamed:(0,i.$Bj)("diff-renamed",60128),diff:(0,i.$Bj)("diff",60129),diffSidebyside:(0,i.$Bj)("diff-sidebyside",60129),discard:(0,i.$Bj)("discard",60130),editorLayout:(0,i.$Bj)("editor-layout",60131),emptyWindow:(0,i.$Bj)("empty-window",60132),exclude:(0,i.$Bj)("exclude",60133),extensions:(0,i.$Bj)("extensions",60134),eyeClosed:(0,i.$Bj)("eye-closed",60135),fileBinary:(0,i.$Bj)("file-binary",60136),fileCode:(0,i.$Bj)("file-code",60137),fileMedia:(0,i.$Bj)("file-media",60138),filePdf:(0,i.$Bj)("file-pdf",60139),fileSubmodule:(0,i.$Bj)("file-submodule",60140),fileSymlinkDirectory:(0,i.$Bj)("file-symlink-directory",60141),fileSymlinkFile:(0,i.$Bj)("file-symlink-file",60142),fileZip:(0,i.$Bj)("file-zip",60143),files:(0,i.$Bj)("files",60144),filter:(0,i.$Bj)("filter",60145),flame:(0,i.$Bj)("flame",60146),foldDown:(0,i.$Bj)("fold-down",60147),foldUp:(0,i.$Bj)("fold-up",60148),fold:(0,i.$Bj)("fold",60149),folderActive:(0,i.$Bj)("folder-active",60150),folderOpened:(0,i.$Bj)("folder-opened",60151),gear:(0,i.$Bj)("gear",60152),gift:(0,i.$Bj)("gift",60153),gistSecret:(0,i.$Bj)("gist-secret",60154),gist:(0,i.$Bj)("gist",60155),gitCommit:(0,i.$Bj)("git-commit",60156),gitCompare:(0,i.$Bj)("git-compare",60157),compareChanges:(0,i.$Bj)("compare-changes",60157),gitMerge:(0,i.$Bj)("git-merge",60158),githubAction:(0,i.$Bj)("github-action",60159),githubAlt:(0,i.$Bj)("github-alt",60160),globe:(0,i.$Bj)("globe",60161),grabber:(0,i.$Bj)("grabber",60162),graph:(0,i.$Bj)("graph",60163),gripper:(0,i.$Bj)("gripper",60164),heart:(0,i.$Bj)("heart",60165),home:(0,i.$Bj)("home",60166),horizontalRule:(0,i.$Bj)("horizontal-rule",60167),hubot:(0,i.$Bj)("hubot",60168),inbox:(0,i.$Bj)("inbox",60169),issueReopened:(0,i.$Bj)("issue-reopened",60171),issues:(0,i.$Bj)("issues",60172),italic:(0,i.$Bj)("italic",60173),jersey:(0,i.$Bj)("jersey",60174),json:(0,i.$Bj)("json",60175),kebabVertical:(0,i.$Bj)("kebab-vertical",60176),key:(0,i.$Bj)("key",60177),law:(0,i.$Bj)("law",60178),lightbulbAutofix:(0,i.$Bj)("lightbulb-autofix",60179),linkExternal:(0,i.$Bj)("link-external",60180),link:(0,i.$Bj)("link",60181),listOrdered:(0,i.$Bj)("list-ordered",60182),listUnordered:(0,i.$Bj)("list-unordered",60183),liveShare:(0,i.$Bj)("live-share",60184),loading:(0,i.$Bj)("loading",60185),location:(0,i.$Bj)("location",60186),mailRead:(0,i.$Bj)("mail-read",60187),mail:(0,i.$Bj)("mail",60188),markdown:(0,i.$Bj)("markdown",60189),megaphone:(0,i.$Bj)("megaphone",60190),mention:(0,i.$Bj)("mention",60191),milestone:(0,i.$Bj)("milestone",60192),gitPullRequestMilestone:(0,i.$Bj)("git-pull-request-milestone",60192),mortarBoard:(0,i.$Bj)("mortar-board",60193),move:(0,i.$Bj)("move",60194),multipleWindows:(0,i.$Bj)("multiple-windows",60195),mute:(0,i.$Bj)("mute",60196),noNewline:(0,i.$Bj)("no-newline",60197),note:(0,i.$Bj)("note",60198),octoface:(0,i.$Bj)("octoface",60199),openPreview:(0,i.$Bj)("open-preview",60200),package:(0,i.$Bj)("package",60201),paintcan:(0,i.$Bj)("paintcan",60202),pin:(0,i.$Bj)("pin",60203),play:(0,i.$Bj)("play",60204),run:(0,i.$Bj)("run",60204),plug:(0,i.$Bj)("plug",60205),preserveCase:(0,i.$Bj)("preserve-case",60206),preview:(0,i.$Bj)("preview",60207),project:(0,i.$Bj)("project",60208),pulse:(0,i.$Bj)("pulse",60209),question:(0,i.$Bj)("question",60210),quote:(0,i.$Bj)("quote",60211),radioTower:(0,i.$Bj)("radio-tower",60212),reactions:(0,i.$Bj)("reactions",60213),references:(0,i.$Bj)("references",60214),refresh:(0,i.$Bj)("refresh",60215),regex:(0,i.$Bj)("regex",60216),remoteExplorer:(0,i.$Bj)("remote-explorer",60217),remote:(0,i.$Bj)("remote",60218),remove:(0,i.$Bj)("remove",60219),replaceAll:(0,i.$Bj)("replace-all",60220),replace:(0,i.$Bj)("replace",60221),repoClone:(0,i.$Bj)("repo-clone",60222),repoForcePush:(0,i.$Bj)("repo-force-push",60223),repoPull:(0,i.$Bj)("repo-pull",60224),repoPush:(0,i.$Bj)("repo-push",60225),report:(0,i.$Bj)("report",60226),requestChanges:(0,i.$Bj)("request-changes",60227),rocket:(0,i.$Bj)("rocket",60228),rootFolderOpened:(0,i.$Bj)("root-folder-opened",60229),rootFolder:(0,i.$Bj)("root-folder",60230),rss:(0,i.$Bj)("rss",60231),ruby:(0,i.$Bj)("ruby",60232),saveAll:(0,i.$Bj)("save-all",60233),saveAs:(0,i.$Bj)("save-as",60234),save:(0,i.$Bj)("save",60235),screenFull:(0,i.$Bj)("screen-full",60236),screenNormal:(0,i.$Bj)("screen-normal",60237),searchStop:(0,i.$Bj)("search-stop",60238),server:(0,i.$Bj)("server",60240),settingsGear:(0,i.$Bj)("settings-gear",60241),settings:(0,i.$Bj)("settings",60242),shield:(0,i.$Bj)("shield",60243),smiley:(0,i.$Bj)("smiley",60244),sortPrecedence:(0,i.$Bj)("sort-precedence",60245),splitHorizontal:(0,i.$Bj)("split-horizontal",60246),splitVertical:(0,i.$Bj)("split-vertical",60247),squirrel:(0,i.$Bj)("squirrel",60248),starFull:(0,i.$Bj)("star-full",60249),starHalf:(0,i.$Bj)("star-half",60250),symbolClass:(0,i.$Bj)("symbol-class",60251),symbolColor:(0,i.$Bj)("symbol-color",60252),symbolConstant:(0,i.$Bj)("symbol-constant",60253),symbolEnumMember:(0,i.$Bj)("symbol-enum-member",60254),symbolField:(0,i.$Bj)("symbol-field",60255),symbolFile:(0,i.$Bj)("symbol-file",60256),symbolInterface:(0,i.$Bj)("symbol-interface",60257),symbolKeyword:(0,i.$Bj)("symbol-keyword",60258),symbolMisc:(0,i.$Bj)("symbol-misc",60259),symbolOperator:(0,i.$Bj)("symbol-operator",60260),symbolProperty:(0,i.$Bj)("symbol-property",60261),wrench:(0,i.$Bj)("wrench",60261),wrenchSubaction:(0,i.$Bj)("wrench-subaction",60261),symbolSnippet:(0,i.$Bj)("symbol-snippet",60262),tasklist:(0,i.$Bj)("tasklist",60263),telescope:(0,i.$Bj)("telescope",60264),textSize:(0,i.$Bj)("text-size",60265),threeBars:(0,i.$Bj)("three-bars",60266),thumbsdown:(0,i.$Bj)("thumbsdown",60267),thumbsup:(0,i.$Bj)("thumbsup",60268),tools:(0,i.$Bj)("tools",60269),triangleDown:(0,i.$Bj)("triangle-down",60270),triangleLeft:(0,i.$Bj)("triangle-left",60271),triangleRight:(0,i.$Bj)("triangle-right",60272),triangleUp:(0,i.$Bj)("triangle-up",60273),twitter:(0,i.$Bj)("twitter",60274),unfold:(0,i.$Bj)("unfold",60275),unlock:(0,i.$Bj)("unlock",60276),unmute:(0,i.$Bj)("unmute",60277),unverified:(0,i.$Bj)("unverified",60278),verified:(0,i.$Bj)("verified",60279),versions:(0,i.$Bj)("versions",60280),vmActive:(0,i.$Bj)("vm-active",60281),vmOutline:(0,i.$Bj)("vm-outline",60282),vmRunning:(0,i.$Bj)("vm-running",60283),watch:(0,i.$Bj)("watch",60284),whitespace:(0,i.$Bj)("whitespace",60285),wholeWord:(0,i.$Bj)("whole-word",60286),window:(0,i.$Bj)("window",60287),wordWrap:(0,i.$Bj)("word-wrap",60288),zoomIn:(0,i.$Bj)("zoom-in",60289),zoomOut:(0,i.$Bj)("zoom-out",60290),listFilter:(0,i.$Bj)("list-filter",60291),listFlat:(0,i.$Bj)("list-flat",60292),listSelection:(0,i.$Bj)("list-selection",60293),selection:(0,i.$Bj)("selection",60293),listTree:(0,i.$Bj)("list-tree",60294),debugBreakpointFunctionUnverified:(0,i.$Bj)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,i.$Bj)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,i.$Bj)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,i.$Bj)("debug-stackframe-active",60297),circleSmallFilled:(0,i.$Bj)("circle-small-filled",60298),debugStackframeDot:(0,i.$Bj)("debug-stackframe-dot",60298),terminalDecorationMark:(0,i.$Bj)("terminal-decoration-mark",60298),debugStackframe:(0,i.$Bj)("debug-stackframe",60299),debugStackframeFocused:(0,i.$Bj)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,i.$Bj)("debug-breakpoint-unsupported",60300),symbolString:(0,i.$Bj)("symbol-string",60301),debugReverseContinue:(0,i.$Bj)("debug-reverse-continue",60302),debugStepBack:(0,i.$Bj)("debug-step-back",60303),debugRestartFrame:(0,i.$Bj)("debug-restart-frame",60304),debugAlt:(0,i.$Bj)("debug-alt",60305),callIncoming:(0,i.$Bj)("call-incoming",60306),callOutgoing:(0,i.$Bj)("call-outgoing",60307),menu:(0,i.$Bj)("menu",60308),expandAll:(0,i.$Bj)("expand-all",60309),feedback:(0,i.$Bj)("feedback",60310),gitPullRequestReviewer:(0,i.$Bj)("git-pull-request-reviewer",60310),groupByRefType:(0,i.$Bj)("group-by-ref-type",60311),ungroupByRefType:(0,i.$Bj)("ungroup-by-ref-type",60312),account:(0,i.$Bj)("account",60313),gitPullRequestAssignee:(0,i.$Bj)("git-pull-request-assignee",60313),bellDot:(0,i.$Bj)("bell-dot",60314),debugConsole:(0,i.$Bj)("debug-console",60315),library:(0,i.$Bj)("library",60316),output:(0,i.$Bj)("output",60317),runAll:(0,i.$Bj)("run-all",60318),syncIgnored:(0,i.$Bj)("sync-ignored",60319),pinned:(0,i.$Bj)("pinned",60320),githubInverted:(0,i.$Bj)("github-inverted",60321),serverProcess:(0,i.$Bj)("server-process",60322),serverEnvironment:(0,i.$Bj)("server-environment",60323),pass:(0,i.$Bj)("pass",60324),issueClosed:(0,i.$Bj)("issue-closed",60324),stopCircle:(0,i.$Bj)("stop-circle",60325),playCircle:(0,i.$Bj)("play-circle",60326),record:(0,i.$Bj)("record",60327),debugAltSmall:(0,i.$Bj)("debug-alt-small",60328),vmConnect:(0,i.$Bj)("vm-connect",60329),cloud:(0,i.$Bj)("cloud",60330),merge:(0,i.$Bj)("merge",60331),export:(0,i.$Bj)("export",60332),graphLeft:(0,i.$Bj)("graph-left",60333),magnet:(0,i.$Bj)("magnet",60334),notebook:(0,i.$Bj)("notebook",60335),redo:(0,i.$Bj)("redo",60336),checkAll:(0,i.$Bj)("check-all",60337),pinnedDirty:(0,i.$Bj)("pinned-dirty",60338),passFilled:(0,i.$Bj)("pass-filled",60339),circleLargeFilled:(0,i.$Bj)("circle-large-filled",60340),circleLarge:(0,i.$Bj)("circle-large",60341),circleLargeOutline:(0,i.$Bj)("circle-large-outline",60341),combine:(0,i.$Bj)("combine",60342),gather:(0,i.$Bj)("gather",60342),table:(0,i.$Bj)("table",60343),variableGroup:(0,i.$Bj)("variable-group",60344),typeHierarchy:(0,i.$Bj)("type-hierarchy",60345),typeHierarchySub:(0,i.$Bj)("type-hierarchy-sub",60346),typeHierarchySuper:(0,i.$Bj)("type-hierarchy-super",60347),gitPullRequestCreate:(0,i.$Bj)("git-pull-request-create",60348),runAbove:(0,i.$Bj)("run-above",60349),runBelow:(0,i.$Bj)("run-below",60350),notebookTemplate:(0,i.$Bj)("notebook-template",60351),debugRerun:(0,i.$Bj)("debug-rerun",60352),workspaceTrusted:(0,i.$Bj)("workspace-trusted",60353),workspaceUntrusted:(0,i.$Bj)("workspace-untrusted",60354),workspaceUnknown:(0,i.$Bj)("workspace-unknown",60355),terminalCmd:(0,i.$Bj)("terminal-cmd",60356),terminalDebian:(0,i.$Bj)("terminal-debian",60357),terminalLinux:(0,i.$Bj)("terminal-linux",60358),terminalPowershell:(0,i.$Bj)("terminal-powershell",60359),terminalTmux:(0,i.$Bj)("terminal-tmux",60360),terminalUbuntu:(0,i.$Bj)("terminal-ubuntu",60361),terminalBash:(0,i.$Bj)("terminal-bash",60362),arrowSwap:(0,i.$Bj)("arrow-swap",60363),copy:(0,i.$Bj)("copy",60364),personAdd:(0,i.$Bj)("person-add",60365),filterFilled:(0,i.$Bj)("filter-filled",60366),wand:(0,i.$Bj)("wand",60367),debugLineByLine:(0,i.$Bj)("debug-line-by-line",60368),inspect:(0,i.$Bj)("inspect",60369),layers:(0,i.$Bj)("layers",60370),layersDot:(0,i.$Bj)("layers-dot",60371),layersActive:(0,i.$Bj)("layers-active",60372),compass:(0,i.$Bj)("compass",60373),compassDot:(0,i.$Bj)("compass-dot",60374),compassActive:(0,i.$Bj)("compass-active",60375),azure:(0,i.$Bj)("azure",60376),issueDraft:(0,i.$Bj)("issue-draft",60377),gitPullRequestClosed:(0,i.$Bj)("git-pull-request-closed",60378),gitPullRequestDraft:(0,i.$Bj)("git-pull-request-draft",60379),debugAll:(0,i.$Bj)("debug-all",60380),debugCoverage:(0,i.$Bj)("debug-coverage",60381),runErrors:(0,i.$Bj)("run-errors",60382),folderLibrary:(0,i.$Bj)("folder-library",60383),debugContinueSmall:(0,i.$Bj)("debug-continue-small",60384),beakerStop:(0,i.$Bj)("beaker-stop",60385),graphLine:(0,i.$Bj)("graph-line",60386),graphScatter:(0,i.$Bj)("graph-scatter",60387),pieChart:(0,i.$Bj)("pie-chart",60388),bracket:(0,i.$Bj)("bracket",60175),bracketDot:(0,i.$Bj)("bracket-dot",60389),bracketError:(0,i.$Bj)("bracket-error",60390),lockSmall:(0,i.$Bj)("lock-small",60391),azureDevops:(0,i.$Bj)("azure-devops",60392),verifiedFilled:(0,i.$Bj)("verified-filled",60393),newline:(0,i.$Bj)("newline",60394),layout:(0,i.$Bj)("layout",60395),layoutActivitybarLeft:(0,i.$Bj)("layout-activitybar-left",60396),layoutActivitybarRight:(0,i.$Bj)("layout-activitybar-right",60397),layoutPanelLeft:(0,i.$Bj)("layout-panel-left",60398),layoutPanelCenter:(0,i.$Bj)("layout-panel-center",60399),layoutPanelJustify:(0,i.$Bj)("layout-panel-justify",60400),layoutPanelRight:(0,i.$Bj)("layout-panel-right",60401),layoutPanel:(0,i.$Bj)("layout-panel",60402),layoutSidebarLeft:(0,i.$Bj)("layout-sidebar-left",60403),layoutSidebarRight:(0,i.$Bj)("layout-sidebar-right",60404),layoutStatusbar:(0,i.$Bj)("layout-statusbar",60405),layoutMenubar:(0,i.$Bj)("layout-menubar",60406),layoutCentered:(0,i.$Bj)("layout-centered",60407),target:(0,i.$Bj)("target",60408),indent:(0,i.$Bj)("indent",60409),recordSmall:(0,i.$Bj)("record-small",60410),errorSmall:(0,i.$Bj)("error-small",60411),terminalDecorationError:(0,i.$Bj)("terminal-decoration-error",60411),arrowCircleDown:(0,i.$Bj)("arrow-circle-down",60412),arrowCircleLeft:(0,i.$Bj)("arrow-circle-left",60413),arrowCircleRight:(0,i.$Bj)("arrow-circle-right",60414),arrowCircleUp:(0,i.$Bj)("arrow-circle-up",60415),layoutSidebarRightOff:(0,i.$Bj)("layout-sidebar-right-off",60416),layoutPanelOff:(0,i.$Bj)("layout-panel-off",60417),layoutSidebarLeftOff:(0,i.$Bj)("layout-sidebar-left-off",60418),blank:(0,i.$Bj)("blank",60419),heartFilled:(0,i.$Bj)("heart-filled",60420),map:(0,i.$Bj)("map",60421),mapFilled:(0,i.$Bj)("map-filled",60422),circleSmall:(0,i.$Bj)("circle-small",60423),bellSlash:(0,i.$Bj)("bell-slash",60424),bellSlashDot:(0,i.$Bj)("bell-slash-dot",60425),commentUnresolved:(0,i.$Bj)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,i.$Bj)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,i.$Bj)("git-pull-request-new-changes",60428),searchFuzzy:(0,i.$Bj)("search-fuzzy",60429),commentDraft:(0,i.$Bj)("comment-draft",60430),send:(0,i.$Bj)("send",60431),sparkle:(0,i.$Bj)("sparkle",60432),insert:(0,i.$Bj)("insert",60433),mic:(0,i.$Bj)("mic",60434),thumbsdownFilled:(0,i.$Bj)("thumbsdown-filled",60435),thumbsupFilled:(0,i.$Bj)("thumbsup-filled",60436),coffee:(0,i.$Bj)("coffee",60437),snake:(0,i.$Bj)("snake",60438),game:(0,i.$Bj)("game",60439),vr:(0,i.$Bj)("vr",60440),chip:(0,i.$Bj)("chip",60441),piano:(0,i.$Bj)("piano",60442),music:(0,i.$Bj)("music",60443),micFilled:(0,i.$Bj)("mic-filled",60444),repoFetch:(0,i.$Bj)("repo-fetch",60445),copilot:(0,i.$Bj)("copilot",60446),lightbulbSparkle:(0,i.$Bj)("lightbulb-sparkle",60447),robot:(0,i.$Bj)("robot",60448),sparkleFilled:(0,i.$Bj)("sparkle-filled",60449),diffSingle:(0,i.$Bj)("diff-single",60450),diffMultiple:(0,i.$Bj)("diff-multiple",60451),surroundWith:(0,i.$Bj)("surround-with",60452),share:(0,i.$Bj)("share",60453),gitStash:(0,i.$Bj)("git-stash",60454),gitStashApply:(0,i.$Bj)("git-stash-apply",60455),gitStashPop:(0,i.$Bj)("git-stash-pop",60456),vscode:(0,i.$Bj)("vscode",60457),vscodeInsiders:(0,i.$Bj)("vscode-insiders",60458),codeOss:(0,i.$Bj)("code-oss",60459),runCoverage:(0,i.$Bj)("run-coverage",60460),runAllCoverage:(0,i.$Bj)("run-all-coverage",60461),coverage:(0,i.$Bj)("coverage",60462),githubProject:(0,i.$Bj)("github-project",60463)}}),define(be[18],$e([1,0,38,92]),function(ne,t,i,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Gj=t.$Fj=void 0,t.$Ej=z;function z(){return Object.values(t.$Gj)}t.$Fj={dialogError:(0,i.$Bj)("dialog-error","error"),dialogWarning:(0,i.$Bj)("dialog-warning","warning"),dialogInfo:(0,i.$Bj)("dialog-info","info"),dialogClose:(0,i.$Bj)("dialog-close","close"),treeItemExpanded:(0,i.$Bj)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,i.$Bj)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,i.$Bj)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,i.$Bj)("tree-filter-clear","close"),treeItemLoading:(0,i.$Bj)("tree-item-loading","loading"),menuSelection:(0,i.$Bj)("menu-selection","check"),menuSubmenu:(0,i.$Bj)("menu-submenu","chevron-right"),menuBarMore:(0,i.$Bj)("menubar-more","more"),scrollbarButtonLeft:(0,i.$Bj)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,i.$Bj)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,i.$Bj)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,i.$Bj)("scrollbar-button-down","triangle-down"),toolBarMore:(0,i.$Bj)("toolbar-more","more"),quickInputBack:(0,i.$Bj)("quick-input-back","arrow-left"),dropDownButton:(0,i.$Bj)("drop-down-button",60084),symbolCustomColor:(0,i.$Bj)("symbol-customcolor",60252),exportIcon:(0,i.$Bj)("export",60332),workspaceUnspecified:(0,i.$Bj)("workspace-unspecified",60355),newLine:(0,i.$Bj)("newline",60394),thumbsDownFilled:(0,i.$Bj)("thumbsdown-filled",60435),thumbsUpFilled:(0,i.$Bj)("thumbsup-filled",60436),gitFetch:(0,i.$Bj)("git-fetch",60445),lightbulbSparkleAutofix:(0,i.$Bj)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,i.$Bj)("debug-breakpoint-pending",60377)},t.$Gj={...N.$Dj,...t.$Fj}}),define(be[54],$e([1,0,7]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Nn=N,t.$On=z,t.$Pn=E,t.$Qn=b,t.$Rn=$,t.$Sn=w,t.$Tn=P,t.$Un=c,t.$Vn=f,t.$Wn=e,t.$Xn=n,t.$Yn=h;function N(m){if(!m||typeof m!="object"||m instanceof RegExp)return m;const p=Array.isArray(m)?[]:{};return Object.entries(m).forEach(([v,o])=>{p[v]=o&&typeof o=="object"?N(o):o}),p}function z(m){if(!m||typeof m!="object")return m;const p=[m];for(;p.length>0;){const v=p.shift();Object.freeze(v);for(const o in v)if(H.call(v,o)){const g=v[o];typeof g=="object"&&!Object.isFrozen(g)&&!(0,i.$Xf)(g)&&p.push(g)}}return m}const H=Object.prototype.hasOwnProperty;function E(m,p){return k(m,p,new Set)}function k(m,p,v){if((0,i.$4f)(m))return m;const o=p(m);if(typeof o<"u")return o;if(Array.isArray(m)){const g=[];for(const r of m)g.push(k(r,p,v));return g}if((0,i.$Wf)(m)){if(v.has(m))throw new Error("Cannot clone recursive data-structure");v.add(m);const g={};for(const r in m)H.call(m,r)&&(g[r]=k(m[r],p,v));return v.delete(m),g}return m}function b(m,p,v=!0){return(0,i.$Wf)(m)?((0,i.$Wf)(p)&&Object.keys(p).forEach(o=>{o in m?v&&((0,i.$Wf)(m[o])&&(0,i.$Wf)(p[o])?b(m[o],p[o],v):m[o]=p[o]):m[o]=p[o]}),m):p}function $(m,p){if(m===p)return!0;if(m==null||p===null||p===void 0||typeof m!=typeof p||typeof m!="object"||Array.isArray(m)!==Array.isArray(p))return!1;let v,o;if(Array.isArray(m)){if(m.length!==p.length)return!1;for(v=0;v<m.length;v++)if(!$(m[v],p[v]))return!1}else{const g=[];for(o in m)g.push(o);g.sort();const r=[];for(o in p)r.push(o);if(r.sort(),!$(g,r))return!1;for(v=0;v<g.length;v++)if(!$(m[g[v]],p[g[v]]))return!1}return!0}function w(m){const p=new Set;return JSON.stringify(m,(v,o)=>{if((0,i.$Wf)(o)||Array.isArray(o)){if(p.has(o))return"[Circular]";p.add(o)}return o})}function P(m,p){const v=Object.create(null);return!m||!p||Object.keys(p).forEach(g=>{const r=m[g],B=p[g];$(r,B)||(v[g]=B)}),v}function c(m,p){const v=p.toLowerCase(),o=Object.keys(m).find(g=>g.toLowerCase()===v);return o?m[o]:m[p]}function f(m,p){const v=Object.create(null);for(const[o,g]of Object.entries(m))p(o,g)&&(v[o]=g);return v}function e(m){let p=[];for(;Object.prototype!==m;)p=p.concat(Object.getOwnPropertyNames(m)),m=Object.getPrototypeOf(m);return p}function n(m){const p=[];for(const v of e(m))typeof m[v]=="function"&&p.push(v);return p}function h(m,p){const v=g=>function(){const r=Array.prototype.slice.call(arguments,0);return p(g,r)},o={};for(const g of m)o[g]=v(g);return o}}),define(be[19],$e([1,0,18]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ThemeIcon=t.ThemeColor=void 0,t.$Hj=z;var N;(function(E){function k(b){return b&&typeof b=="object"&&typeof b.id=="string"}E.isThemeColor=k})(N||(t.ThemeColor=N={}));function z(E){return{id:E}}var H;(function(E){E.iconNameSegment="[A-Za-z0-9]+",E.iconNameExpression="[A-Za-z0-9-]+",E.iconModifierExpression="~[A-Za-z]+",E.iconNameCharacter="[A-Za-z0-9~-]";const k=new RegExp(`^(${E.iconNameExpression})(${E.iconModifierExpression})?$`);function b(p){const v=k.exec(p.id);if(!v)return b(i.$Gj.error);const[,o,g]=v,r=["codicon","codicon-"+o];return g&&r.push("codicon-modifier-"+g.substring(1)),r}E.asClassNameArray=b;function $(p){return b(p).join(" ")}E.asClassName=$;function w(p){return"."+b(p).join(".")}E.asCSSSelector=w;function P(p){return p&&typeof p=="object"&&typeof p.id=="string"&&(typeof p.color>"u"||N.isThemeColor(p.color))}E.isThemeIcon=P;const c=new RegExp(`^\\$\\((${E.iconNameExpression}(?:${E.iconModifierExpression})?)\\)$`);function f(p){const v=c.exec(p);if(!v)return;const[,o]=v;return{id:o}}E.fromString=f;function e(p){return{id:p}}E.fromId=e;function n(p,v){let o=p.id;const g=o.lastIndexOf("~");return g!==-1&&(o=o.substring(0,g)),v&&(o=`${o}~${v}`),{id:o}}E.modify=n;function h(p){const v=p.id.lastIndexOf("~");if(v!==-1)return p.id.substring(v+1)}E.getModifier=h;function m(p,v){return p.id===v.id&&p.color?.id===v.color?.id}E.isEqual=m})(H||(t.ThemeIcon=H={}))}),define(be[39],$e([1,0,37,10,19]),function(ne,t,i,N,z){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$yk=b,t.$zk=w,t.$Ak=c,t.$Bk=f,t.$Ck=n,t.$Dk=h;const H="$(",E=new RegExp(`\\$\\(${z.ThemeIcon.iconNameExpression}(?:${z.ThemeIcon.iconModifierExpression})?\\)`,"g"),k=new RegExp(`(\\\\)?${E.source}`,"g");function b(m){return m.replace(k,(p,v)=>v?p:`\\${p}`)}const $=new RegExp(`\\\\${E.source}`,"g");function w(m){return m.replace($,p=>`\\${p}`)}const P=new RegExp(`(\\s)?(\\\\)?${E.source}(\\s)?`,"g");function c(m){return m.indexOf(H)===-1?m:m.replace(P,(p,v,o,g)=>o?p:v||g||"")}function f(m){return m?m.replace(/\$\((.*?)\)/g,(p,v)=>` ${v} `).trim():""}const e=new RegExp(`\\$\\(${z.ThemeIcon.iconNameCharacter}+\\)`,"g");function n(m){e.lastIndex=0;let p="";const v=[];let o=0;for(;;){const g=e.lastIndex,r=e.exec(m),B=m.substring(g,r?.index);if(B.length>0){p+=B;for(let C=0;C<B.length;C++)v.push(o)}if(!r)break;o+=r[0].length}return{text:p,iconOffsets:v}}function h(m,p,v=!1){const{text:o,iconOffsets:g}=p;if(!g||g.length===0)return(0,i.$pk)(m,o,v);const r=(0,N.$5e)(o," "),B=o.length-r.length,C=(0,i.$pk)(m,r,v);if(C)for(const L of C){const M=g[L.start+B]+B;L.start+=M,L.end+=M}return C}}),define(be[93],$e([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1V=t.$ZV=void 0,t.$ZV="vscode:contextmenu",t.$1V="vscode:onCloseContextMenu"}),define(be[94],$e([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$8V=void 0;class i{constructor(z,H){this.a=z,this.onMessage=H}send(z){try{this.a.send("vscode:message",z.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}t.$8V=i}),define(be[31],$e([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$S=t.$R=t.$Q=t.$P=t.$O=void 0;const i=globalThis.vscode;t.$O=i.ipcRenderer,t.$P=i.ipcMessagePort,t.$Q=i.webFrame,t.$R=i.process,t.$S=i.context}),define(be[95],$e([1,0,93,31]),function(ne,t,i,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4V=H;let z=0;function H(k,b,$){const w=[],P=z++,c=`vscode:onContextMenu${P}`,f=(e,n,h)=>{w[n].click?.(h)};N.$O.once(c,f),N.$O.once(i.$1V,(e,n)=>{n===P&&(N.$O.removeListener(c,f),$?.())}),N.$O.send(i.$ZV,P,k.map(e=>E(e,w)),c,b)}function E(k,b){const $={id:b.length,label:k.label,type:k.type,accelerator:k.accelerator,checked:k.checked,enabled:typeof k.enabled=="boolean"?k.enabled:!0,visible:typeof k.visible=="boolean"?k.visible:!0};return b.push(k),Array.isArray(k.submenu)&&($.submenu=k.submenu.map(w=>E(w,b))),$}}),define(be[55],$e([8]),{}),define(be[96],$e([8]),{}),define(be[97],$e([8]),{}),define(be[98],$e([8]),{}),define(be[99],$e([1,0,97,98]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0})}),define(be[100],$e([8]),{}),define(be[101],$e([8]),{}),define(be[102],$e([8]),{}),define(be[103],$e([8]),{}),define(be[104],$e([8]),{}),define(be[105],$e([8]),{}),define(be[106],$e([8]),{}),define(be[107],$e([8]),{}),define(be[108],$e([8]),{}),define(be[109],$e([13,11]),function(ne,t){return ne.create("vs/base/browser/ui/actionbar/actionViewItems",t)}),define(be[110],$e([13,11]),function(ne,t){return ne.create("vs/base/browser/ui/findinput/findInput",t)}),define(be[111],$e([13,11]),function(ne,t){return ne.create("vs/base/browser/ui/findinput/findInputToggles",t)}),define(be[112],$e([13,11]),function(ne,t){return ne.create("vs/base/browser/ui/hover/updatableHoverWidget",t)}),define(be[113],$e([13,11]),function(ne,t){return ne.create("vs/base/browser/ui/inputbox/inputBox",t)}),define(be[114],$e([13,11]),function(ne,t){return ne.create("vs/base/browser/ui/selectBox/selectBoxCustom",t)}),define(be[115],$e([13,11]),function(ne,t){return ne.create("vs/base/browser/ui/tree/abstractTree",t)}),define(be[116],$e([13,11]),function(ne,t){return ne.create("vs/base/common/actions",t)}),define(be[40],$e([1,0,4,3,116]),function(ne,t,i,N,z){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3i=t.$2i=t.$1i=t.$Zi=t.$Yi=void 0,t.$4i=w;class H extends N.$Uc{constructor(c,f="",e="",n=!0,h){super(),this.h=this.B(new i.$7d),this.onDidChange=this.h.event,this.w=!0,this.j=c,this.m=f,this.u=e,this.w=n,this.C=h}get id(){return this.j}get label(){return this.m}set label(c){this.D(c)}D(c){this.m!==c&&(this.m=c,this.h.fire({label:c}))}get tooltip(){return this.n||""}set tooltip(c){this.F(c)}F(c){this.n!==c&&(this.n=c,this.h.fire({tooltip:c}))}get class(){return this.u}set class(c){this.G(c)}G(c){this.u!==c&&(this.u=c,this.h.fire({class:c}))}get enabled(){return this.w}set enabled(c){this.H(c)}H(c){this.w!==c&&(this.w=c,this.h.fire({enabled:c}))}get checked(){return this.z}set checked(c){this.I(c)}I(c){this.z!==c&&(this.z=c,this.h.fire({checked:c}))}async run(c,f){this.C&&await this.C(c)}}t.$Yi=H;class E extends N.$Uc{constructor(){super(...arguments),this.f=this.B(new i.$7d),this.onWillRun=this.f.event,this.m=this.B(new i.$7d),this.onDidRun=this.m.event}async run(c,f){if(!c.enabled)return;this.f.fire({action:c});let e;try{await this.u(c,f)}catch(n){e=n}this.m.fire({action:c,error:e})}async u(c,f){await c.run(f)}}t.$Zi=E;class k{constructor(){this.id=k.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...c){let f=[];for(const e of c)e.length&&(f.length?f=[...f,new k,...e]:f=e);return f}static{this.ID="vs.actions.separator"}async run(){}}t.$1i=k;class b{get actions(){return this.a}constructor(c,f,e,n){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=c,this.label=f,this.class=n,this.a=e}async run(){}}t.$2i=b;class $ extends H{static{this.ID="vs.actions.empty"}constructor(){super($.ID,z.localize(0,null),void 0,!1)}}t.$3i=$;function w(P){return{id:P.id,label:P.label,class:P.class,enabled:P.enabled??!0,checked:P.checked,run:async(...c)=>P.run(...c),tooltip:P.label}}}),define(be[117],$e([13,11]),function(ne,t){return ne.create("vs/base/common/platform",t)}),define(be[5],$e([1,0,117]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$I=t.$H=t.$G=t.$F=t.$E=t.OS=t.OperatingSystem=t.$B=t.$A=t.$z=t.$y=t.$x=t.Language=t.$w=t.$v=t.$u=t.$t=t.$s=t.$r=t.$q=t.$p=t.$o=t.$n=t.$m=t.$l=t.$k=t.$j=t.$i=t.Platform=t.$g=void 0,t.$h=B,t.$D=x,t.$J=q,t.$g="en";let N=!1,z=!1,H=!1,E=!1,k=!1,b=!1,$=!1,w=!1,P=!1,c=!1,f,e=t.$g,n=t.$g,h,m;const p=globalThis;let v;typeof p.vscode<"u"&&typeof p.vscode.process<"u"?v=p.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(v=process);const o=typeof v?.versions?.electron=="string",g=o&&v?.type==="renderer";if(typeof v=="object"){N=v.platform==="win32",z=v.platform==="darwin",H=v.platform==="linux",E=H&&!!v.env.SNAP&&!!v.env.SNAP_REVISION,$=o,P=!!v.env.CI||!!v.env.BUILD_ARTIFACTSTAGINGDIRECTORY,f=t.$g,e=t.$g;const I=v.env.VSCODE_NLS_CONFIG;if(I)try{const j=JSON.parse(I),T=j.availableLanguages["*"];f=j.locale,n=j.osLocale,e=T||t.$g,h=j._translationsConfigFile}catch{}k=!0}else typeof navigator=="object"&&!g?(m=navigator.userAgent,N=m.indexOf("Windows")>=0,z=m.indexOf("Macintosh")>=0,w=(m.indexOf("Macintosh")>=0||m.indexOf("iPad")>=0||m.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,H=m.indexOf("Linux")>=0,c=m?.indexOf("Mobi")>=0,b=!0,f=i.getConfiguredDefaultLocale(i.localize(0,null))||t.$g,e=f,n=navigator.language):console.error("Unable to resolve platform.");var r;(function(I){I[I.Web=0]="Web",I[I.Mac=1]="Mac",I[I.Linux=2]="Linux",I[I.Windows=3]="Windows"})(r||(t.Platform=r={}));function B(I){switch(I){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}let C=0;z?C=1:N?C=3:H&&(C=2),t.$i=N,t.$j=z,t.$k=H,t.$l=E,t.$m=k,t.$n=$,t.$o=b,t.$p=b&&typeof p.importScripts=="function",t.$q=t.$p?p.origin:void 0,t.$r=w,t.$s=c,t.$t=P,t.$u=C,t.$v=m,t.$w=e;var L;(function(I){function j(){return t.$w}I.value=j;function T(){return t.$w.length===2?t.$w==="en":t.$w.length>=3?t.$w[0]==="e"&&t.$w[1]==="n"&&t.$w[2]==="-":!1}I.isDefaultVariant=T;function Q(){return t.$w==="en"}I.isDefault=Q})(L||(t.Language=L={})),t.$x=f,t.$y=n,t.$z=h,t.$A=typeof p.postMessage=="function"&&!p.importScripts,t.$B=(()=>{if(t.$A){const I=[];p.addEventListener("message",T=>{if(T.data&&T.data.vscodeScheduleAsyncWork)for(let Q=0,Z=I.length;Q<Z;Q++){const ce=I[Q];if(ce.id===T.data.vscodeScheduleAsyncWork){I.splice(Q,1),ce.callback();return}}});let j=0;return T=>{const Q=++j;I.push({id:Q,callback:T}),p.postMessage({vscodeScheduleAsyncWork:Q},"*")}}return I=>setTimeout(I)})();var M;(function(I){I[I.Windows=1]="Windows",I[I.Macintosh=2]="Macintosh",I[I.Linux=3]="Linux"})(M||(t.OperatingSystem=M={})),t.OS=z||w?2:N?1:3;let O=!0,y=!1;function x(){if(!y){y=!0;const I=new Uint8Array(2);I[0]=1,I[1]=2,O=new Uint16Array(I.buffer)[0]===513}return O}t.$E=!!(t.$v&&t.$v.indexOf("Chrome")>=0),t.$F=!!(t.$v&&t.$v.indexOf("Firefox")>=0),t.$G=!!(!t.$E&&t.$v&&t.$v.indexOf("Safari")>=0),t.$H=!!(t.$v&&t.$v.indexOf("Edg/")>=0),t.$I=!!(t.$v&&t.$v.indexOf("Android")>=0);function q(I){return parseFloat(I)>=20}}),define(be[118],$e([1,0,17,22,5]),function(ne,t,i,N,z){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$WQ=t.KeyboardSupport=void 0;var H;(function(E){E[E.Always=0]="Always",E[E.FullScreen=1]="FullScreen",E[E.None=2]="None"})(H||(t.KeyboardSupport=H={})),t.$WQ={clipboard:{writeText:z.$m||document.queryCommandSupported&&document.queryCommandSupported("copy")||!!(navigator&&navigator.clipboard&&navigator.clipboard.writeText),readText:z.$m||!!(navigator&&navigator.clipboard&&navigator.clipboard.readText)},keyboard:z.$m||i.$UQ()?0:navigator.keyboard||i.$QQ?1:2,touch:"ontouchstart"in N.$BQ||navigator.maxTouchPoints>0,pointerEvents:N.$BQ.PointerEvent&&("ontouchstart"in N.$BQ||navigator.maxTouchPoints>0)}}),define(be[15],$e([1,0,17,48,81,5]),function(ne,t,i,N,z,H){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5Q=void 0,t.$3Q=P,t.$4Q=c;function E(e){if(e.charCode){const h=String.fromCharCode(e.charCode).toUpperCase();return N.KeyCodeUtils.fromString(h)}const n=e.keyCode;if(n===3)return 7;if(i.$NQ)switch(n){case 59:return 85;case 60:if(H.$k)return 97;break;case 61:return 86;case 107:return 109;case 109:return 111;case 173:return 88;case 224:if(H.$j)return 57;break}else if(i.$OQ){if(H.$j&&n===93)return 57;if(!H.$j&&n===92)return 57}return N.$ir[n]||0}const k=H.$j?256:2048,b=512,$=1024,w=H.$j?2048:256;function P(e){const n=[];return e.ctrlKey&&n.push("ctrl"),e.shiftKey&&n.push("shift"),e.altKey&&n.push("alt"),e.metaKey&&n.push("meta"),`modifiers: [${n.join(",")}], code: ${e.code}, keyCode: ${e.keyCode}, key: ${e.key}`}function c(e){const n=[];return e.ctrlKey&&n.push("ctrl"),e.shiftKey&&n.push("shift"),e.altKey&&n.push("alt"),e.metaKey&&n.push("meta"),`modifiers: [${n.join(",")}], code: ${e.code}, keyCode: ${e.keyCode} ('${N.KeyCodeUtils.toString(e.keyCode)}')`}class f{constructor(n){this._standardKeyboardEventBrand=!0;const h=n;this.browserEvent=h,this.target=h.target,this.ctrlKey=h.ctrlKey,this.shiftKey=h.shiftKey,this.altKey=h.altKey,this.metaKey=h.metaKey,this.altGraphKey=h.getModifierState?.("AltGraph"),this.keyCode=E(h),this.code=h.code,this.ctrlKey=this.ctrlKey||this.keyCode===5,this.altKey=this.altKey||this.keyCode===6,this.shiftKey=this.shiftKey||this.keyCode===4,this.metaKey=this.metaKey||this.keyCode===57,this.a=this.c(),this.b=this.d()}preventDefault(){this.browserEvent&&this.browserEvent.preventDefault&&this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent&&this.browserEvent.stopPropagation&&this.browserEvent.stopPropagation()}toKeyCodeChord(){return this.b}equals(n){return this.a===n}c(){let n=0;this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(n=this.keyCode);let h=0;return this.ctrlKey&&(h|=k),this.altKey&&(h|=b),this.shiftKey&&(h|=$),this.metaKey&&(h|=w),h|=n,h}d(){let n=0;return this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(n=this.keyCode),new z.$qr(this.ctrlKey,this.shiftKey,this.altKey,this.metaKey,n)}}t.$5Q=f}),define(be[20],$e([1,0,17,72,5]),function(ne,t,i,N,z){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$2Q=t.$1Q=t.$ZQ=void 0;class H{constructor($,w){this.timestamp=Date.now(),this.browserEvent=w,this.leftButton=w.button===0,this.middleButton=w.button===1,this.rightButton=w.button===2,this.buttons=w.buttons,this.target=w.target,this.detail=w.detail||1,w.type==="dblclick"&&(this.detail=2),this.ctrlKey=w.ctrlKey,this.shiftKey=w.shiftKey,this.altKey=w.altKey,this.metaKey=w.metaKey,typeof w.pageX=="number"?(this.posx=w.pageX,this.posy=w.pageY):(this.posx=w.clientX+this.target.ownerDocument.body.scrollLeft+this.target.ownerDocument.documentElement.scrollLeft,this.posy=w.clientY+this.target.ownerDocument.body.scrollTop+this.target.ownerDocument.documentElement.scrollTop);const P=N.$XQ.getPositionOfChildWindowRelativeToAncestorWindow($,w.view);this.posx-=P.left,this.posy-=P.top}preventDefault(){this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent.stopPropagation()}}t.$ZQ=H;class E extends H{constructor($,w){super($,w),this.dataTransfer=w.dataTransfer}}t.$1Q=E;class k{constructor($,w=0,P=0){this.browserEvent=$||null,this.target=$?$.target||$.targetNode||$.srcElement:null,this.deltaY=P,this.deltaX=w;let c=!1;if(i.$PQ){const f=navigator.userAgent.match(/Chrome\/(\d+)/);c=(f?parseInt(f[1]):123)<=122}if($){const f=$,e=$,n=$.view?.devicePixelRatio||1;if(typeof f.wheelDeltaY<"u")c?this.deltaY=f.wheelDeltaY/(120*n):this.deltaY=f.wheelDeltaY/120;else if(typeof e.VERTICAL_AXIS<"u"&&e.axis===e.VERTICAL_AXIS)this.deltaY=-e.detail/3;else if($.type==="wheel"){const h=$;h.deltaMode===h.DOM_DELTA_LINE?i.$NQ&&!z.$j?this.deltaY=-$.deltaY/3:this.deltaY=-$.deltaY:this.deltaY=-$.deltaY/40}if(typeof f.wheelDeltaX<"u")i.$QQ&&z.$i?this.deltaX=-(f.wheelDeltaX/120):c?this.deltaX=f.wheelDeltaX/(120*n):this.deltaX=f.wheelDeltaX/120;else if(typeof e.HORIZONTAL_AXIS<"u"&&e.axis===e.HORIZONTAL_AXIS)this.deltaX=-$.detail/3;else if($.type==="wheel"){const h=$;h.deltaMode===h.DOM_DELTA_LINE?i.$NQ&&!z.$j?this.deltaX=-$.deltaX/3:this.deltaX=-$.deltaX:this.deltaX=-$.deltaX/40}this.deltaY===0&&this.deltaX===0&&$.wheelDelta&&(c?this.deltaY=$.wheelDelta/(120*n):this.deltaY=$.wheelDelta/120)}}preventDefault(){this.browserEvent?.preventDefault()}stopPropagation(){this.browserEvent?.stopPropagation()}}t.$2Q=k}),define(be[119],$e([1,0,5]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$fc=t.$ec=t.env=t.cwd=void 0;let N;const z=globalThis.vscode;if(typeof z<"u"&&typeof z.process<"u"){const H=z.process;N={get platform(){return H.platform},get arch(){return H.arch},get env(){return H.env},cwd(){return H.cwd()}}}else typeof process<"u"?N={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:N={get platform(){return i.$i?"win32":i.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=N.cwd,t.env=N.env,t.$ec=N.platform,t.$fc=N.arch}),define(be[25],$e([1,0,119]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$uc=t.sep=t.$sc=t.$rc=t.$qc=t.$pc=t.$oc=t.$nc=t.$mc=t.$lc=t.$kc=t.$jc=t.$ic=t.$hc=t.$gc=void 0;const N=65,z=97,H=90,E=122,k=46,b=47,$=92,w=58,P=63;class c extends Error{constructor(B,C,L){let M;typeof C=="string"&&C.indexOf("not ")===0?(M="must not be",C=C.replace(/^not /,"")):M="must be";const O=B.indexOf(".")!==-1?"property":"argument";let y=`The "${B}" ${O} ${M} of type ${C}`;y+=`. Received type ${typeof L}`,super(y),this.code="ERR_INVALID_ARG_TYPE"}}function f(r,B){if(r===null||typeof r!="object")throw new c(B,"Object",r)}function e(r,B){if(typeof r!="string")throw new c(B,"string",r)}const n=i.$ec==="win32";function h(r){return r===b||r===$}function m(r){return r===b}function p(r){return r>=N&&r<=H||r>=z&&r<=E}function v(r,B,C,L){let M="",O=0,y=-1,x=0,q=0;for(let I=0;I<=r.length;++I){if(I<r.length)q=r.charCodeAt(I);else{if(L(q))break;q=b}if(L(q)){if(!(y===I-1||x===1))if(x===2){if(M.length<2||O!==2||M.charCodeAt(M.length-1)!==k||M.charCodeAt(M.length-2)!==k){if(M.length>2){const j=M.lastIndexOf(C);j===-1?(M="",O=0):(M=M.slice(0,j),O=M.length-1-M.lastIndexOf(C)),y=I,x=0;continue}else if(M.length!==0){M="",O=0,y=I,x=0;continue}}B&&(M+=M.length>0?`${C}..`:"..",O=2)}else M.length>0?M+=`${C}${r.slice(y+1,I)}`:M=r.slice(y+1,I),O=I-y-1;y=I,x=0}else q===k&&x!==-1?++x:x=-1}return M}function o(r,B){f(B,"pathObject");const C=B.dir||B.root,L=B.base||`${B.name||""}${B.ext||""}`;return C?C===B.root?`${C}${L}`:`${C}${r}${L}`:L}t.$gc={resolve(...r){let B="",C="",L=!1;for(let M=r.length-1;M>=-1;M--){let O;if(M>=0){if(O=r[M],e(O,"path"),O.length===0)continue}else B.length===0?O=i.cwd():(O=i.env[`=${B}`]||i.cwd(),(O===void 0||O.slice(0,2).toLowerCase()!==B.toLowerCase()&&O.charCodeAt(2)===$)&&(O=`${B}\\`));const y=O.length;let x=0,q="",I=!1;const j=O.charCodeAt(0);if(y===1)h(j)&&(x=1,I=!0);else if(h(j))if(I=!0,h(O.charCodeAt(1))){let T=2,Q=T;for(;T<y&&!h(O.charCodeAt(T));)T++;if(T<y&&T!==Q){const Z=O.slice(Q,T);for(Q=T;T<y&&h(O.charCodeAt(T));)T++;if(T<y&&T!==Q){for(Q=T;T<y&&!h(O.charCodeAt(T));)T++;(T===y||T!==Q)&&(q=`\\\\${Z}\\${O.slice(Q,T)}`,x=T)}}}else x=1;else p(j)&&O.charCodeAt(1)===w&&(q=O.slice(0,2),x=2,y>2&&h(O.charCodeAt(2))&&(I=!0,x=3));if(q.length>0)if(B.length>0){if(q.toLowerCase()!==B.toLowerCase())continue}else B=q;if(L){if(B.length>0)break}else if(C=`${O.slice(x)}\\${C}`,L=I,I&&B.length>0)break}return C=v(C,!L,"\\",h),L?`${B}\\${C}`:`${B}${C}`||"."},normalize(r){e(r,"path");const B=r.length;if(B===0)return".";let C=0,L,M=!1;const O=r.charCodeAt(0);if(B===1)return m(O)?"\\":r;if(h(O))if(M=!0,h(r.charCodeAt(1))){let x=2,q=x;for(;x<B&&!h(r.charCodeAt(x));)x++;if(x<B&&x!==q){const I=r.slice(q,x);for(q=x;x<B&&h(r.charCodeAt(x));)x++;if(x<B&&x!==q){for(q=x;x<B&&!h(r.charCodeAt(x));)x++;if(x===B)return`\\\\${I}\\${r.slice(q)}\\`;x!==q&&(L=`\\\\${I}\\${r.slice(q,x)}`,C=x)}}}else C=1;else p(O)&&r.charCodeAt(1)===w&&(L=r.slice(0,2),C=2,B>2&&h(r.charCodeAt(2))&&(M=!0,C=3));let y=C<B?v(r.slice(C),!M,"\\",h):"";return y.length===0&&!M&&(y="."),y.length>0&&h(r.charCodeAt(B-1))&&(y+="\\"),L===void 0?M?`\\${y}`:y:M?`${L}\\${y}`:`${L}${y}`},isAbsolute(r){e(r,"path");const B=r.length;if(B===0)return!1;const C=r.charCodeAt(0);return h(C)||B>2&&p(C)&&r.charCodeAt(1)===w&&h(r.charCodeAt(2))},join(...r){if(r.length===0)return".";let B,C;for(let O=0;O<r.length;++O){const y=r[O];e(y,"path"),y.length>0&&(B===void 0?B=C=y:B+=`\\${y}`)}if(B===void 0)return".";let L=!0,M=0;if(typeof C=="string"&&h(C.charCodeAt(0))){++M;const O=C.length;O>1&&h(C.charCodeAt(1))&&(++M,O>2&&(h(C.charCodeAt(2))?++M:L=!1))}if(L){for(;M<B.length&&h(B.charCodeAt(M));)M++;M>=2&&(B=`\\${B.slice(M)}`)}return t.$gc.normalize(B)},relative(r,B){if(e(r,"from"),e(B,"to"),r===B)return"";const C=t.$gc.resolve(r),L=t.$gc.resolve(B);if(C===L||(r=C.toLowerCase(),B=L.toLowerCase(),r===B))return"";let M=0;for(;M<r.length&&r.charCodeAt(M)===$;)M++;let O=r.length;for(;O-1>M&&r.charCodeAt(O-1)===$;)O--;const y=O-M;let x=0;for(;x<B.length&&B.charCodeAt(x)===$;)x++;let q=B.length;for(;q-1>x&&B.charCodeAt(q-1)===$;)q--;const I=q-x,j=y<I?y:I;let T=-1,Q=0;for(;Q<j;Q++){const ce=r.charCodeAt(M+Q);if(ce!==B.charCodeAt(x+Q))break;ce===$&&(T=Q)}if(Q!==j){if(T===-1)return L}else{if(I>j){if(B.charCodeAt(x+Q)===$)return L.slice(x+Q+1);if(Q===2)return L.slice(x+Q)}y>j&&(r.charCodeAt(M+Q)===$?T=Q:Q===2&&(T=3)),T===-1&&(T=0)}let Z="";for(Q=M+T+1;Q<=O;++Q)(Q===O||r.charCodeAt(Q)===$)&&(Z+=Z.length===0?"..":"\\..");return x+=T,Z.length>0?`${Z}${L.slice(x,q)}`:(L.charCodeAt(x)===$&&++x,L.slice(x,q))},toNamespacedPath(r){if(typeof r!="string"||r.length===0)return r;const B=t.$gc.resolve(r);if(B.length<=2)return r;if(B.charCodeAt(0)===$){if(B.charCodeAt(1)===$){const C=B.charCodeAt(2);if(C!==P&&C!==k)return`\\\\?\\UNC\\${B.slice(2)}`}}else if(p(B.charCodeAt(0))&&B.charCodeAt(1)===w&&B.charCodeAt(2)===$)return`\\\\?\\${B}`;return r},dirname(r){e(r,"path");const B=r.length;if(B===0)return".";let C=-1,L=0;const M=r.charCodeAt(0);if(B===1)return h(M)?r:".";if(h(M)){if(C=L=1,h(r.charCodeAt(1))){let x=2,q=x;for(;x<B&&!h(r.charCodeAt(x));)x++;if(x<B&&x!==q){for(q=x;x<B&&h(r.charCodeAt(x));)x++;if(x<B&&x!==q){for(q=x;x<B&&!h(r.charCodeAt(x));)x++;if(x===B)return r;x!==q&&(C=L=x+1)}}}}else p(M)&&r.charCodeAt(1)===w&&(C=B>2&&h(r.charCodeAt(2))?3:2,L=C);let O=-1,y=!0;for(let x=B-1;x>=L;--x)if(h(r.charCodeAt(x))){if(!y){O=x;break}}else y=!1;if(O===-1){if(C===-1)return".";O=C}return r.slice(0,O)},basename(r,B){B!==void 0&&e(B,"ext"),e(r,"path");let C=0,L=-1,M=!0,O;if(r.length>=2&&p(r.charCodeAt(0))&&r.charCodeAt(1)===w&&(C=2),B!==void 0&&B.length>0&&B.length<=r.length){if(B===r)return"";let y=B.length-1,x=-1;for(O=r.length-1;O>=C;--O){const q=r.charCodeAt(O);if(h(q)){if(!M){C=O+1;break}}else x===-1&&(M=!1,x=O+1),y>=0&&(q===B.charCodeAt(y)?--y===-1&&(L=O):(y=-1,L=x))}return C===L?L=x:L===-1&&(L=r.length),r.slice(C,L)}for(O=r.length-1;O>=C;--O)if(h(r.charCodeAt(O))){if(!M){C=O+1;break}}else L===-1&&(M=!1,L=O+1);return L===-1?"":r.slice(C,L)},extname(r){e(r,"path");let B=0,C=-1,L=0,M=-1,O=!0,y=0;r.length>=2&&r.charCodeAt(1)===w&&p(r.charCodeAt(0))&&(B=L=2);for(let x=r.length-1;x>=B;--x){const q=r.charCodeAt(x);if(h(q)){if(!O){L=x+1;break}continue}M===-1&&(O=!1,M=x+1),q===k?C===-1?C=x:y!==1&&(y=1):C!==-1&&(y=-1)}return C===-1||M===-1||y===0||y===1&&C===M-1&&C===L+1?"":r.slice(C,M)},format:o.bind(null,"\\"),parse(r){e(r,"path");const B={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return B;const C=r.length;let L=0,M=r.charCodeAt(0);if(C===1)return h(M)?(B.root=B.dir=r,B):(B.base=B.name=r,B);if(h(M)){if(L=1,h(r.charCodeAt(1))){let T=2,Q=T;for(;T<C&&!h(r.charCodeAt(T));)T++;if(T<C&&T!==Q){for(Q=T;T<C&&h(r.charCodeAt(T));)T++;if(T<C&&T!==Q){for(Q=T;T<C&&!h(r.charCodeAt(T));)T++;T===C?L=T:T!==Q&&(L=T+1)}}}}else if(p(M)&&r.charCodeAt(1)===w){if(C<=2)return B.root=B.dir=r,B;if(L=2,h(r.charCodeAt(2))){if(C===3)return B.root=B.dir=r,B;L=3}}L>0&&(B.root=r.slice(0,L));let O=-1,y=L,x=-1,q=!0,I=r.length-1,j=0;for(;I>=L;--I){if(M=r.charCodeAt(I),h(M)){if(!q){y=I+1;break}continue}x===-1&&(q=!1,x=I+1),M===k?O===-1?O=I:j!==1&&(j=1):O!==-1&&(j=-1)}return x!==-1&&(O===-1||j===0||j===1&&O===x-1&&O===y+1?B.base=B.name=r.slice(y,x):(B.name=r.slice(y,O),B.base=r.slice(y,x),B.ext=r.slice(O,x))),y>0&&y!==L?B.dir=r.slice(0,y-1):B.dir=B.root,B},sep:"\\",delimiter:";",win32:null,posix:null};const g=(()=>{if(n){const r=/\\/g;return()=>{const B=i.cwd().replace(r,"/");return B.slice(B.indexOf("/"))}}return()=>i.cwd()})();t.$hc={resolve(...r){let B="",C=!1;for(let L=r.length-1;L>=-1&&!C;L--){const M=L>=0?r[L]:g();e(M,"path"),M.length!==0&&(B=`${M}/${B}`,C=M.charCodeAt(0)===b)}return B=v(B,!C,"/",m),C?`/${B}`:B.length>0?B:"."},normalize(r){if(e(r,"path"),r.length===0)return".";const B=r.charCodeAt(0)===b,C=r.charCodeAt(r.length-1)===b;return r=v(r,!B,"/",m),r.length===0?B?"/":C?"./":".":(C&&(r+="/"),B?`/${r}`:r)},isAbsolute(r){return e(r,"path"),r.length>0&&r.charCodeAt(0)===b},join(...r){if(r.length===0)return".";let B;for(let C=0;C<r.length;++C){const L=r[C];e(L,"path"),L.length>0&&(B===void 0?B=L:B+=`/${L}`)}return B===void 0?".":t.$hc.normalize(B)},relative(r,B){if(e(r,"from"),e(B,"to"),r===B||(r=t.$hc.resolve(r),B=t.$hc.resolve(B),r===B))return"";const C=1,L=r.length,M=L-C,O=1,y=B.length-O,x=M<y?M:y;let q=-1,I=0;for(;I<x;I++){const T=r.charCodeAt(C+I);if(T!==B.charCodeAt(O+I))break;T===b&&(q=I)}if(I===x)if(y>x){if(B.charCodeAt(O+I)===b)return B.slice(O+I+1);if(I===0)return B.slice(O+I)}else M>x&&(r.charCodeAt(C+I)===b?q=I:I===0&&(q=0));let j="";for(I=C+q+1;I<=L;++I)(I===L||r.charCodeAt(I)===b)&&(j+=j.length===0?"..":"/..");return`${j}${B.slice(O+q)}`},toNamespacedPath(r){return r},dirname(r){if(e(r,"path"),r.length===0)return".";const B=r.charCodeAt(0)===b;let C=-1,L=!0;for(let M=r.length-1;M>=1;--M)if(r.charCodeAt(M)===b){if(!L){C=M;break}}else L=!1;return C===-1?B?"/":".":B&&C===1?"//":r.slice(0,C)},basename(r,B){B!==void 0&&e(B,"ext"),e(r,"path");let C=0,L=-1,M=!0,O;if(B!==void 0&&B.length>0&&B.length<=r.length){if(B===r)return"";let y=B.length-1,x=-1;for(O=r.length-1;O>=0;--O){const q=r.charCodeAt(O);if(q===b){if(!M){C=O+1;break}}else x===-1&&(M=!1,x=O+1),y>=0&&(q===B.charCodeAt(y)?--y===-1&&(L=O):(y=-1,L=x))}return C===L?L=x:L===-1&&(L=r.length),r.slice(C,L)}for(O=r.length-1;O>=0;--O)if(r.charCodeAt(O)===b){if(!M){C=O+1;break}}else L===-1&&(M=!1,L=O+1);return L===-1?"":r.slice(C,L)},extname(r){e(r,"path");let B=-1,C=0,L=-1,M=!0,O=0;for(let y=r.length-1;y>=0;--y){const x=r.charCodeAt(y);if(x===b){if(!M){C=y+1;break}continue}L===-1&&(M=!1,L=y+1),x===k?B===-1?B=y:O!==1&&(O=1):B!==-1&&(O=-1)}return B===-1||L===-1||O===0||O===1&&B===L-1&&B===C+1?"":r.slice(B,L)},format:o.bind(null,"/"),parse(r){e(r,"path");const B={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return B;const C=r.charCodeAt(0)===b;let L;C?(B.root="/",L=1):L=0;let M=-1,O=0,y=-1,x=!0,q=r.length-1,I=0;for(;q>=L;--q){const j=r.charCodeAt(q);if(j===b){if(!x){O=q+1;break}continue}y===-1&&(x=!1,y=q+1),j===k?M===-1?M=q:I!==1&&(I=1):M!==-1&&(I=-1)}if(y!==-1){const j=O===0&&C?1:O;M===-1||I===0||I===1&&M===y-1&&M===O+1?B.base=B.name=r.slice(j,y):(B.name=r.slice(j,M),B.base=r.slice(j,y),B.ext=r.slice(M,y))}return O>0?B.dir=r.slice(0,O-1):C&&(B.dir="/"),B},sep:"/",delimiter:":",win32:null,posix:null},t.$hc.win32=t.$gc.win32=t.$gc,t.$hc.posix=t.$gc.posix=t.$hc,t.$ic=n?t.$gc.normalize:t.$hc.normalize,t.$jc=n?t.$gc.isAbsolute:t.$hc.isAbsolute,t.$kc=n?t.$gc.join:t.$hc.join,t.$lc=n?t.$gc.resolve:t.$hc.resolve,t.$mc=n?t.$gc.relative:t.$hc.relative,t.$nc=n?t.$gc.dirname:t.$hc.dirname,t.$oc=n?t.$gc.basename:t.$hc.basename,t.$pc=n?t.$gc.extname:t.$hc.extname,t.$qc=n?t.$gc.format:t.$hc.format,t.$rc=n?t.$gc.parse:t.$hc.parse,t.$sc=n?t.$gc.toNamespacedPath:t.$hc.toNamespacedPath,t.sep=n?t.$gc.sep:t.$hc.sep,t.$uc=n?t.$gc.delimiter:t.$hc.delimiter}),define(be[120],$e([1,0,25,5,10,7]),function(ne,t,i,N,z,H){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ag=E,t.$bg=k,t.$cg=b,t.$dg=$,t.$eg=w,t.$fg=e,t.$gg=n,t.$hg=h,t.$ig=m,t.$jg=p,t.$kg=v,t.$lg=o,t.$mg=g,t.$ng=r,t.$og=B,t.$pg=M;function E(O){return O===47||O===92}function k(O){return O.replace(/[\\/]/g,i.$hc.sep)}function b(O){return O.indexOf("/")===-1&&(O=k(O)),/^[a-zA-Z]:(\/|$)/.test(O)&&(O="/"+O),O}function $(O,y=i.$hc.sep){if(!O)return"";const x=O.length,q=O.charCodeAt(0);if(E(q)){if(E(O.charCodeAt(1))&&!E(O.charCodeAt(2))){let j=3;const T=j;for(;j<x&&!E(O.charCodeAt(j));j++);if(T!==j&&!E(O.charCodeAt(j+1))){for(j+=1;j<x;j++)if(E(O.charCodeAt(j)))return O.slice(0,j+1).replace(/[\\/]/g,y)}}return y}else if(m(q)&&O.charCodeAt(1)===58)return E(O.charCodeAt(2))?O.slice(0,2)+y:O.slice(0,2);let I=O.indexOf("://");if(I!==-1){for(I+=3;I<x;I++)if(E(O.charCodeAt(I)))return O.slice(0,I+1)}return""}function w(O){if(!N.$i||!O||O.length<5)return!1;let y=O.charCodeAt(0);if(y!==92||(y=O.charCodeAt(1),y!==92))return!1;let x=2;const q=x;for(;x<O.length&&(y=O.charCodeAt(x),y!==92);x++);return!(q===x||(y=O.charCodeAt(x+1),isNaN(y)||y===92))}const P=/[\\/:\*\?"<>\|]/g,c=/[\\/]/g,f=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function e(O,y=N.$i){const x=y?P:c;return!(!O||O.length===0||/^\s+$/.test(O)||(x.lastIndex=0,x.test(O))||y&&f.test(O)||O==="."||O===".."||y&&O[O.length-1]==="."||y&&O.length!==O.trim().length||O.length>255)}function n(O,y,x){const q=O===y;return!x||q?q:!O||!y?!1:(0,z.$lf)(O,y)}function h(O,y,x,q=i.sep){if(O===y)return!0;if(!O||!y||y.length>O.length)return!1;if(x){if(!(0,z.$mf)(O,y))return!1;if(y.length===O.length)return!0;let j=y.length;return y.charAt(y.length-1)===q&&j--,O.charAt(j)===q}return y.charAt(y.length-1)!==q&&(y+=q),O.indexOf(y)===0}function m(O){return O>=65&&O<=90||O>=97&&O<=122}function p(O,y){return N.$i&&O.endsWith(":")&&(O+=i.sep),(0,i.$jc)(O)||(O=(0,i.$kc)(y,O)),O=(0,i.$ic)(O),N.$i?(O=(0,z.$6e)(O,i.sep),O.endsWith(":")&&(O+=i.sep)):(O=(0,z.$6e)(O,i.sep),O||(O=i.sep)),O}function v(O){const y=(0,i.$ic)(O);return N.$i?O.length>3?!1:o(y)&&(O.length===2||y.charCodeAt(2)===92):y===i.$hc.sep}function o(O,y=N.$i){return y?m(O.charCodeAt(0))&&O.charCodeAt(1)===58:!1}function g(O,y=N.$i){return o(O,y)?O[0]:void 0}function r(O,y,x){return y.length>O.length?-1:O===y?0:(x&&(O=O.toLowerCase(),y=y.toLowerCase()),O.indexOf(y))}function B(O){const y=O.split(":");let x,q,I;for(const j of y){const T=Number(j);(0,H.$Yf)(T)?q===void 0?q=T:I===void 0&&(I=T):x=x?[x,j].join(":"):j}if(!x)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:x,line:q!==void 0?q:void 0,column:I!==void 0?I:q!==void 0?1:void 0}}const C="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",L="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function M(O,y,x=8){let q="";for(let j=0;j<x;j++){let T;j===0&&N.$i&&!y&&(x===3||x===4)?T=L:T=C,q+=T.charAt(Math.floor(Math.random()*T.length))}let I;return y?I=`${y}-${q}`:I=q,O?(0,i.$kc)(O,I):I}}),define(be[121],$e([1,0,25]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ys=void 0,t.$zs=H,t.$As=E,t.$Bs=k,t.$Cs=$,t.$ys=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const N={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},z={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function H(w){const P=(0,i.$pc)(w),c=N[P.toLowerCase()];return c!==void 0?c:E(w)}function E(w){const P=(0,i.$pc)(w);return z[P.toLowerCase()]}function k(w){for(const P in z)if(z[P]===w)return P}const b=/^(.+)\/(.+?)(;.+)?$/;function $(w,P){const c=b.exec(w);return c?`${c[1].toLowerCase()}/${c[2].toLowerCase()}${c[3]??""}`:P?void 0:w}}),define(be[16],$e([1,0,25,5]),function(ne,t,i,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.URI=void 0,t.$wc=e,t.$xc=o;const z=/^\w[\w\d+.-]*$/,H=/^\//,E=/^\/\//;function k(L,M){if(!L.scheme&&M)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${L.authority}", path: "${L.path}", query: "${L.query}", fragment: "${L.fragment}"}`);if(L.scheme&&!z.test(L.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(L.path){if(L.authority){if(!H.test(L.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(E.test(L.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function b(L,M){return!L&&!M?"file":L}function $(L,M){switch(L){case"https":case"http":case"file":M?M[0]!==P&&(M=P+M):M=P;break}return M}const w="",P="/",c=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class f{static isUri(M){return M instanceof f?!0:M?typeof M.authority=="string"&&typeof M.fragment=="string"&&typeof M.path=="string"&&typeof M.query=="string"&&typeof M.scheme=="string"&&typeof M.fsPath=="string"&&typeof M.with=="function"&&typeof M.toString=="function":!1}constructor(M,O,y,x,q,I=!1){typeof M=="object"?(this.scheme=M.scheme||w,this.authority=M.authority||w,this.path=M.path||w,this.query=M.query||w,this.fragment=M.fragment||w):(this.scheme=b(M,I),this.authority=O||w,this.path=$(this.scheme,y||w),this.query=x||w,this.fragment=q||w,k(this,I))}get fsPath(){return o(this,!1)}with(M){if(!M)return this;let{scheme:O,authority:y,path:x,query:q,fragment:I}=M;return O===void 0?O=this.scheme:O===null&&(O=w),y===void 0?y=this.authority:y===null&&(y=w),x===void 0?x=this.path:x===null&&(x=w),q===void 0?q=this.query:q===null&&(q=w),I===void 0?I=this.fragment:I===null&&(I=w),O===this.scheme&&y===this.authority&&x===this.path&&q===this.query&&I===this.fragment?this:new h(O,y,x,q,I)}static parse(M,O=!1){const y=c.exec(M);return y?new h(y[2]||w,C(y[4]||w),C(y[5]||w),C(y[7]||w),C(y[9]||w),O):new h(w,w,w,w,w)}static file(M){let O=w;if(N.$i&&(M=M.replace(/\\/g,P)),M[0]===P&&M[1]===P){const y=M.indexOf(P,2);y===-1?(O=M.substring(2),M=P):(O=M.substring(2,y),M=M.substring(y)||P)}return new h("file",O,M,w,w)}static from(M,O){return new h(M.scheme,M.authority,M.path,M.query,M.fragment,O)}static joinPath(M,...O){if(!M.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let y;return N.$i&&M.scheme==="file"?y=f.file(i.$gc.join(o(M,!0),...O)).path:y=i.$hc.join(M.path,...O),M.with({path:y})}toString(M=!1){return g(this,M)}toJSON(){return this}static revive(M){if(M){if(M instanceof f)return M;{const O=new h(M);return O._formatted=M.external??null,O._fsPath=M._sep===n?M.fsPath??null:null,O}}else return M}}t.URI=f;function e(L){return!L||typeof L!="object"?!1:typeof L.scheme=="string"&&(typeof L.authority=="string"||typeof L.authority>"u")&&(typeof L.path=="string"||typeof L.path>"u")&&(typeof L.query=="string"||typeof L.query>"u")&&(typeof L.fragment=="string"||typeof L.fragment>"u")}const n=N.$i?1:void 0;class h extends f{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=o(this,!1)),this._fsPath}toString(M=!1){return M?g(this,!0):(this._formatted||(this._formatted=g(this,!1)),this._formatted)}toJSON(){const M={$mid:1};return this._fsPath&&(M.fsPath=this._fsPath,M._sep=n),this._formatted&&(M.external=this._formatted),this.path&&(M.path=this.path),this.scheme&&(M.scheme=this.scheme),this.authority&&(M.authority=this.authority),this.query&&(M.query=this.query),this.fragment&&(M.fragment=this.fragment),M}}const m={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function p(L,M,O){let y,x=-1;for(let q=0;q<L.length;q++){const I=L.charCodeAt(q);if(I>=97&&I<=122||I>=65&&I<=90||I>=48&&I<=57||I===45||I===46||I===95||I===126||M&&I===47||O&&I===91||O&&I===93||O&&I===58)x!==-1&&(y+=encodeURIComponent(L.substring(x,q)),x=-1),y!==void 0&&(y+=L.charAt(q));else{y===void 0&&(y=L.substr(0,q));const j=m[I];j!==void 0?(x!==-1&&(y+=encodeURIComponent(L.substring(x,q)),x=-1),y+=j):x===-1&&(x=q)}}return x!==-1&&(y+=encodeURIComponent(L.substring(x))),y!==void 0?y:L}function v(L){let M;for(let O=0;O<L.length;O++){const y=L.charCodeAt(O);y===35||y===63?(M===void 0&&(M=L.substr(0,O)),M+=m[y]):M!==void 0&&(M+=L[O])}return M!==void 0?M:L}function o(L,M){let O;return L.authority&&L.path.length>1&&L.scheme==="file"?O=`//${L.authority}${L.path}`:L.path.charCodeAt(0)===47&&(L.path.charCodeAt(1)>=65&&L.path.charCodeAt(1)<=90||L.path.charCodeAt(1)>=97&&L.path.charCodeAt(1)<=122)&&L.path.charCodeAt(2)===58?M?O=L.path.substr(1):O=L.path[1].toLowerCase()+L.path.substr(2):O=L.path,N.$i&&(O=O.replace(/\//g,"\\")),O}function g(L,M){const O=M?v:p;let y="",{scheme:x,authority:q,path:I,query:j,fragment:T}=L;if(x&&(y+=x,y+=":"),(q||x==="file")&&(y+=P,y+=P),q){let Q=q.indexOf("@");if(Q!==-1){const Z=q.substr(0,Q);q=q.substr(Q+1),Q=Z.lastIndexOf(":"),Q===-1?y+=O(Z,!1,!1):(y+=O(Z.substr(0,Q),!1,!1),y+=":",y+=O(Z.substr(Q+1),!1,!0)),y+="@"}q=q.toLowerCase(),Q=q.lastIndexOf(":"),Q===-1?y+=O(q,!1,!0):(y+=O(q.substr(0,Q),!1,!0),y+=q.substr(Q))}if(I){if(I.length>=3&&I.charCodeAt(0)===47&&I.charCodeAt(2)===58){const Q=I.charCodeAt(1);Q>=65&&Q<=90&&(I=`/${String.fromCharCode(Q+32)}:${I.substr(3)}`)}else if(I.length>=2&&I.charCodeAt(1)===58){const Q=I.charCodeAt(0);Q>=65&&Q<=90&&(I=`${String.fromCharCode(Q+32)}:${I.substr(2)}`)}y+=O(I,!0,!1)}return j&&(y+="?",y+=O(j,!1,!1)),T&&(y+="#",y+=M?T:p(T,!1,!1)),y}function r(L){try{return decodeURIComponent(L)}catch{return L.length>3?L.substr(0,3)+r(L.substr(3)):L}}const B=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function C(L){return L.match(B)?L.replace(B,M=>r(M)):L}}),define(be[56],$e([1,0,36,16]),function(ne,t,i,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Oh=z,t.$Ph=H,t.$Qh=k;function z(b){return JSON.stringify(b,E)}function H(b){let $=JSON.parse(b);return $=k($),$}function E(b,$){return $ instanceof RegExp?{$mid:2,source:$.source,flags:$.flags}:$}function k(b,$=0){if(!b||$>200)return b;if(typeof b=="object"){switch(b.$mid){case 1:return N.URI.revive(b);case 2:return new RegExp(b.source,b.flags);case 17:return new Date(b.source)}if(b instanceof i.$ue||b instanceof Uint8Array)return b;if(Array.isArray(b))for(let w=0;w<b.length;++w)b[w]=k(b[w],$+1);else for(const w in b)Object.hasOwnProperty.call(b,w)&&(b[w]=k(b[w],$+1))}return b}}),define(be[32],$e([1,0,6,5,10,16,25]),function(ne,t,i,N,z,H,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.COI=t.$Bg=t.$Ag=t.$zg=t.$yg=t.$xg=t.$wg=t.$ug=t.$tg=t.$sg=t.Schemas=void 0,t.$qg=b,t.$rg=$,t.$vg=P;var k;(function(e){e.inMemory="inmemory",e.vscode="vscode",e.internal="private",e.walkThrough="walkThrough",e.walkThroughSnippet="walkThroughSnippet",e.http="http",e.https="https",e.file="file",e.mailto="mailto",e.untitled="untitled",e.data="data",e.command="command",e.vscodeRemote="vscode-remote",e.vscodeRemoteResource="vscode-remote-resource",e.vscodeManagedRemoteResource="vscode-managed-remote-resource",e.vscodeUserData="vscode-userdata",e.vscodeCustomEditor="vscode-custom-editor",e.vscodeNotebookCell="vscode-notebook-cell",e.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",e.vscodeNotebookCellOutput="vscode-notebook-cell-output",e.vscodeInteractiveInput="vscode-interactive-input",e.vscodeSettings="vscode-settings",e.vscodeWorkspaceTrust="vscode-workspace-trust",e.vscodeTerminal="vscode-terminal",e.vscodeChatCodeBlock="vscode-chat-code-block",e.vscodeChatSesssion="vscode-chat-editor",e.webviewPanel="webview-panel",e.vscodeWebview="vscode-webview",e.extension="extension",e.vscodeFileResource="vscode-file",e.tmp="tmp",e.vsls="vsls",e.vscodeSourceControl="vscode-scm",e.codeSetting="code-setting"})(k||(t.Schemas=k={}));function b(e,n){return H.URI.isUri(e)?(0,z.$lf)(e.scheme,n):(0,z.$mf)(e,n+":")}function $(e,...n){return n.some(h=>b(e,h))}t.$sg="vscode-tkn",t.$tg="tkn";class w{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(n){this.d=n}setDelegate(n){this.e=n}setServerRootPath(n,h){this.f=P(n,h)}getServerRootPath(){return this.f}get g(){return E.$hc.join(this.f,k.vscodeRemoteResource)}set(n,h,m){this.a[n]=h,this.b[n]=m}setConnectionToken(n,h){this.c[n]=h}getPreferredWebSchema(){return this.d}rewrite(n){if(this.e)try{return this.e(n)}catch(g){return i.$1(g),n}const h=n.authority;let m=this.a[h];m&&m.indexOf(":")!==-1&&m.indexOf("[")===-1&&(m=`[${m}]`);const p=this.b[h],v=this.c[h];let o=`path=${encodeURIComponent(n.path)}`;return typeof v=="string"&&(o+=`&${t.$tg}=${encodeURIComponent(v)}`),H.URI.from({scheme:N.$o?this.d:k.vscodeRemoteResource,authority:`${m}:${p}`,path:this.g,query:o})}}t.$ug=new w;function P(e,n){return E.$hc.join(n??"/",`${e.quality??"oss"}-${e.commit??"dev"}`)}t.$wg="vs/../../extensions",t.$xg="vs/../../node_modules",t.$yg="vs/../../node_modules.asar",t.$zg="vs/../../node_modules.asar.unpacked",t.$Ag="vscode-app";class c{static{this.a=t.$Ag}asBrowserUri(n){const h=this.b(n,ne);return this.uriToBrowserUri(h)}uriToBrowserUri(n){return n.scheme===k.vscodeRemote?t.$ug.rewrite(n):n.scheme===k.file&&(N.$m||N.$q===`${k.vscodeFileResource}://${c.a}`)?n.with({scheme:k.vscodeFileResource,authority:n.authority||c.a,query:null,fragment:null}):n}asFileUri(n){const h=this.b(n,ne);return this.uriToFileUri(h)}uriToFileUri(n){return n.scheme===k.vscodeFileResource?n.with({scheme:k.file,authority:n.authority!==c.a?n.authority:null,query:null,fragment:null}):n}b(n,h){return H.URI.isUri(n)?n:H.URI.parse(h.toUrl(n))}}t.$Bg=new c;var f;(function(e){const n=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);e.CoopAndCoep=Object.freeze(n.get("3"));const h="vscode-coi";function m(v){let o;typeof v=="string"?o=new URL(v).searchParams:v instanceof URL?o=v.searchParams:H.URI.isUri(v)&&(o=new URL(v.toString(!0)).searchParams);const g=o?.get(h);if(g)return n.get(g)}e.getHeadersFromQuery=m;function p(v,o,g){if(!globalThis.crossOriginIsolated)return;const r=o&&g?"3":g?"2":"1";v instanceof URLSearchParams?v.set(h,r):v[h]=r}e.addSearchParam=p})(f||(t.COI=f={}))}),define(be[41],$e([1,0,120,32,25,5,10,16]),function(ne,t,i,N,z,H,E,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DataUri=t.$3g=t.$2g=t.$1g=t.$Zg=t.$Yg=t.$Xg=t.$Wg=t.$Vg=t.$Ug=t.$Tg=t.$Sg=t.$Rg=t.$Qg=t.$Pg=t.$Og=t.$Ng=t.$Mg=t.$Lg=t.$Kg=t.$Jg=void 0,t.$Ig=b,t.$4g=w,t.$5g=c;function b(f){return(0,k.$xc)(f,!0)}class ${constructor(e){this.a=e}compare(e,n,h=!1){return e===n?0:(0,E.$ef)(this.getComparisonKey(e,h),this.getComparisonKey(n,h))}isEqual(e,n,h=!1){return e===n?!0:!e||!n?!1:this.getComparisonKey(e,h)===this.getComparisonKey(n,h)}getComparisonKey(e,n=!1){return e.with({path:this.a(e)?e.path.toLowerCase():void 0,fragment:n?null:void 0}).toString()}ignorePathCasing(e){return this.a(e)}isEqualOrParent(e,n,h=!1){if(e.scheme===n.scheme){if(e.scheme===N.Schemas.file)return i.$hg(b(e),b(n),this.a(e))&&e.query===n.query&&(h||e.fragment===n.fragment);if((0,t.$Zg)(e.authority,n.authority))return i.$hg(e.path,n.path,this.a(e),"/")&&e.query===n.query&&(h||e.fragment===n.fragment)}return!1}joinPath(e,...n){return k.URI.joinPath(e,...n)}basenameOrAuthority(e){return(0,t.$Rg)(e)||e.authority}basename(e){return z.$hc.basename(e.path)}extname(e){return z.$hc.extname(e.path)}dirname(e){if(e.path.length===0)return e;let n;return e.scheme===N.Schemas.file?n=k.URI.file(z.$nc(b(e))).path:(n=z.$hc.dirname(e.path),e.authority&&n.length&&n.charCodeAt(0)!==47&&(console.error(`dirname("${e.toString})) resulted in a relative path`),n="/")),e.with({path:n})}normalizePath(e){if(!e.path.length)return e;let n;return e.scheme===N.Schemas.file?n=k.URI.file(z.$ic(b(e))).path:n=z.$hc.normalize(e.path),e.with({path:n})}relativePath(e,n){if(e.scheme!==n.scheme||!(0,t.$Zg)(e.authority,n.authority))return;if(e.scheme===N.Schemas.file){const p=z.$mc(b(e),b(n));return H.$i?i.$bg(p):p}let h=e.path||"/";const m=n.path||"/";if(this.a(e)){let p=0;for(const v=Math.min(h.length,m.length);p<v&&!(h.charCodeAt(p)!==m.charCodeAt(p)&&h.charAt(p).toLowerCase()!==m.charAt(p).toLowerCase());p++);h=m.substr(0,p)+h.substr(p)}return z.$hc.relative(h,m)}resolvePath(e,n){if(e.scheme===N.Schemas.file){const h=k.URI.file(z.$lc(b(e),n));return e.with({authority:h.authority,path:h.path})}return n=i.$cg(n),e.with({path:z.$hc.resolve(e.path,n)})}isAbsolutePath(e){return!!e.path&&e.path[0]==="/"}isEqualAuthority(e,n){return e===n||e!==void 0&&n!==void 0&&(0,E.$lf)(e,n)}hasTrailingPathSeparator(e,n=z.sep){if(e.scheme===N.Schemas.file){const h=b(e);return h.length>i.$dg(h).length&&h[h.length-1]===n}else{const h=e.path;return h.length>1&&h.charCodeAt(h.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(e.fsPath)}}removeTrailingPathSeparator(e,n=z.sep){return(0,t.$1g)(e,n)?e.with({path:e.path.substr(0,e.path.length-1)}):e}addTrailingPathSeparator(e,n=z.sep){let h=!1;if(e.scheme===N.Schemas.file){const m=b(e);h=m!==void 0&&m.length===i.$dg(m).length&&m[m.length-1]===n}else{n="/";const m=e.path;h=m.length===1&&m.charCodeAt(m.length-1)===47}return!h&&!(0,t.$1g)(e,n)?e.with({path:e.path+"/"}):e}}t.$Jg=$,t.$Kg=new $(()=>!1),t.$Lg=new $(f=>f.scheme===N.Schemas.file?!H.$k:!0),t.$Mg=new $(f=>!0),t.$Ng=t.$Kg.isEqual.bind(t.$Kg),t.$Og=t.$Kg.isEqualOrParent.bind(t.$Kg),t.$Pg=t.$Kg.getComparisonKey.bind(t.$Kg),t.$Qg=t.$Kg.basenameOrAuthority.bind(t.$Kg),t.$Rg=t.$Kg.basename.bind(t.$Kg),t.$Sg=t.$Kg.extname.bind(t.$Kg),t.$Tg=t.$Kg.dirname.bind(t.$Kg),t.$Ug=t.$Kg.joinPath.bind(t.$Kg),t.$Vg=t.$Kg.normalizePath.bind(t.$Kg),t.$Wg=t.$Kg.relativePath.bind(t.$Kg),t.$Xg=t.$Kg.resolvePath.bind(t.$Kg),t.$Yg=t.$Kg.isAbsolutePath.bind(t.$Kg),t.$Zg=t.$Kg.isEqualAuthority.bind(t.$Kg),t.$1g=t.$Kg.hasTrailingPathSeparator.bind(t.$Kg),t.$2g=t.$Kg.removeTrailingPathSeparator.bind(t.$Kg),t.$3g=t.$Kg.addTrailingPathSeparator.bind(t.$Kg);function w(f,e){const n=[];for(let h=0;h<f.length;h++){const m=e(f[h]);f.some((p,v)=>v===h?!1:(0,t.$Og)(m,e(p)))||n.push(f[h])}return n}var P;(function(f){f.META_DATA_LABEL="label",f.META_DATA_DESCRIPTION="description",f.META_DATA_SIZE="size",f.META_DATA_MIME="mime";function e(n){const h=new Map;n.path.substring(n.path.indexOf(";")+1,n.path.lastIndexOf(";")).split(";").forEach(v=>{const[o,g]=v.split(":");o&&g&&h.set(o,g)});const p=n.path.substring(0,n.path.indexOf(";"));return p&&h.set(f.META_DATA_MIME,p),h}f.parseMetaData=e})(P||(t.DataUri=P={}));function c(f,e,n){if(e){let h=f.path;return h&&h[0]!==z.$hc.sep&&(h=z.$hc.sep+h),f.with({scheme:n,authority:e,path:h})}return f.with({scheme:n})}}),define(be[9],$e([1,0,30,6,4,3,41,5,53,23]),function(ne,t,i,N,z,H,E,k,b,$){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Kh=t.$Ih=t.$Hh=t.$Gh=t.$Fh=t.Promises=t.$Eh=t.$Dh=t.$Ch=t.$Ah=t.$zh=t.$yh=t.$xh=t.$wh=t.$vh=t.$uh=t.$th=t.$sh=t.$rh=t.$qh=t.$ph=t.$oh=t.$nh=t.$hh=t.$gh=t.$fh=t.$eh=t.$dh=t.$ch=t.$bh=void 0,t.$6g=w,t.$7g=P,t.$8g=c,t.$9g=f,t.$0g=e,t.$$g=n,t.$_g=h,t.$ah=m,t.$ih=O,t.$jh=y,t.$kh=x,t.$lh=q,t.$mh=I,t.$Bh=_,t.$Jh=u;function w(D){return!!D&&typeof D.then=="function"}function P(D){const a=new i.$ee,d=D(a.token),s=new Promise((l,F)=>{const A=a.token.onCancellationRequested(()=>{A.dispose(),F(new N.$5)});Promise.resolve(d).then(R=>{A.dispose(),a.dispose(),l(R)},R=>{A.dispose(),a.dispose(),F(R)})});return new class{cancel(){a.cancel(),a.dispose()}then(l,F){return s.then(l,F)}catch(l){return this.then(void 0,l)}finally(l){return s.finally(l)}}}function c(D,a,d){return new Promise((s,l)=>{const F=a.onCancellationRequested(()=>{F.dispose(),s(d)});D.then(s,l).finally(()=>F.dispose())})}function f(D,a){return new Promise((d,s)=>{const l=a.onCancellationRequested(()=>{l.dispose(),s(new N.$5)});D.then(d,s).finally(()=>l.dispose())})}async function e(D){let a=-1;const d=D.map((s,l)=>s.then(F=>(a=l,F)));try{return await Promise.race(d)}finally{D.forEach((s,l)=>{l!==a&&s.cancel()})}}function n(D,a,d){let s;const l=setTimeout(()=>{s?.(void 0),d?.()},a);return Promise.race([D.finally(()=>clearTimeout(l)),new Promise(F=>s=F)])}function h(D){return new Promise((a,d)=>{const s=D();w(s)?s.then(a,d):a(s)})}function m(){let D,a;return{promise:new Promise((s,l)=>{D=s,a=l}),resolve:D,reject:a}}class p{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(a){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=a,!this.b){const d=()=>{if(this.b=null,this.f)return;const s=this.queue(this.d);return this.d=null,s};this.b=new Promise(s=>{this.a.then(d,d).then(s)})}return new Promise((d,s)=>{this.b.then(d,s)})}return this.a=a(),new Promise((d,s)=>{this.a.then(l=>{this.a=null,d(l)},l=>{this.a=null,s(l)})})}dispose(){this.f=!0}}t.$bh=p;class v{constructor(){this.a=Promise.resolve(null)}queue(a){return this.a=this.a.then(()=>a(),()=>a())}}t.$ch=v;class o{constructor(){this.a=new Map}queue(a,d){const l=(this.a.get(a)??Promise.resolve()).catch(()=>{}).then(d).finally(()=>{this.a.get(a)===l&&this.a.delete(a)});return this.a.set(a,l),l}}t.$dh=o;const g=(D,a)=>{let d=!0;const s=setTimeout(()=>{d=!1,a()},D);return{isTriggered:()=>d,dispose:()=>{clearTimeout(s),d=!1}}},r=D=>{let a=!0;return queueMicrotask(()=>{a&&(a=!1,D())}),{isTriggered:()=>a,dispose:()=>{a=!1}}};class B{constructor(a){this.defaultDelay=a,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(a,d=this.defaultDelay){this.g=a,this.h(),this.b||(this.b=new Promise((l,F)=>{this.d=l,this.f=F}).then(()=>{if(this.b=null,this.d=null,this.g){const l=this.g;return this.g=null,l()}}));const s=()=>{this.a=null,this.d?.(null)};return this.a=d===b.$4d?r(s):g(d,s),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new N.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}t.$eh=B;class C{constructor(a){this.a=new B(a),this.b=new p}trigger(a,d){return this.a.trigger(()=>this.b.queue(a),d)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}t.$fh=C;class L{constructor(){this.a=!1,this.b=new Promise((a,d)=>{this.d=a})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}t.$gh=L;class M extends L{constructor(a){super(),this.f=setTimeout(()=>this.open(),a)}open(){clearTimeout(this.f),super.open()}}t.$hh=M;function O(D,a){return a?new Promise((d,s)=>{const l=setTimeout(()=>{F.dispose(),d()},D),F=a.onCancellationRequested(()=>{clearTimeout(l),F.dispose(),s(new N.$5)})}):P(d=>O(D,d))}function y(D,a=0,d){const s=setTimeout(()=>{D(),d&&l.dispose()},a),l=(0,H.$Sc)(()=>{clearTimeout(s),d?.deleteAndLeak(l)});return d?.add(l),l}function x(D){const a=[];let d=0;const s=D.length;function l(){return d<s?D[d++]():null}function F(A){A!=null&&a.push(A);const R=l();return R?R.then(F):Promise.resolve(a)}return Promise.resolve(null).then(F)}function q(D,a=s=>!!s,d=null){let s=0;const l=D.length,F=()=>{if(s>=l)return Promise.resolve(d);const A=D[s++];return Promise.resolve(A()).then(W=>a(W)?Promise.resolve(W):F())};return F()}function I(D,a=s=>!!s,d=null){if(D.length===0)return Promise.resolve(d);let s=D.length;const l=()=>{s=-1;for(const F of D)F.cancel?.()};return new Promise((F,A)=>{for(const R of D)R.then(W=>{--s>=0&&a(W)?(l(),F(W)):s===0&&F(d)}).catch(W=>{--s>=0&&(l(),A(W))})})}class j{constructor(a){this.a=0,this.b=!1,this.f=a,this.g=[],this.d=0,this.h=new z.$7d}whenIdle(){return this.size>0?z.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(a){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((d,s)=>{this.g.push({factory:a,c:d,e:s}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const a=this.g.shift();this.d++;const d=a.factory();d.then(a.c,a.e),d.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}t.$nh=j;class T extends j{constructor(){super(1)}}t.$oh=T;class Q{constructor(){this.a=new ae,this.b=0}queue(a){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,a())):this.a.run(this.b++,a())}}t.$ph=Q;class Z{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const a=new G;return this.b.add(a),a.p}g(){for(const[,a]of this.a)if(a.size>0)return!1;return!0}queueSize(a,d=E.$Kg){const s=d.getComparisonKey(a);return this.a.get(s)?.size??0}queueFor(a,d,s=E.$Kg){const l=s.getComparisonKey(a);let F=this.a.get(l);if(!F){F=new T;const A=this.f++,R=z.Event.once(F.onDrained)(()=>{F?.dispose(),this.a.delete(l),this.h(),this.d?.deleteAndDispose(A),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new H.$4c),this.d.set(A,R),this.a.set(l,F)}return F.queue(d)}h(){this.g()&&this.j()}j(){for(const a of this.b)a.complete();this.b.clear()}dispose(){for(const[,a]of this.a)a.dispose();this.a.clear(),this.j(),this.d?.dispose()}}t.$qh=Z;class ce{constructor(a,d){this.a=-1,typeof a=="function"&&typeof d=="number"&&this.setIfNotSet(a,d)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(a,d){this.cancel(),this.a=setTimeout(()=>{this.a=-1,a()},d)}setIfNotSet(a,d){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,a()},d))}}t.$rh=ce;class oe{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(a,d,s=globalThis){this.cancel();const l=s.setInterval(()=>{a()},d);this.d=(0,H.$Sc)(()=>{s.clearInterval(l),this.d=void 0})}dispose(){this.cancel()}}t.$sh=oe;class te{constructor(a,d){this.b=-1,this.a=a,this.d=d,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(a=this.d){this.cancel(),this.b=setTimeout(this.f,a)}get delay(){return this.d}set delay(a){this.d=a}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}t.$th=te;class de{constructor(a,d){d%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${d}ms is not a multiple of 1000ms.`),this.a=a,this.b=d,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(a=this.b){a%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${a}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(a/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}t.$uh=de;class Be extends te{constructor(a,d){super(a,d),this.j=[]}work(a){this.j.push(a),this.isScheduled()||this.schedule()}h(){const a=this.j;this.j=[],this.a?.(a)}dispose(){this.j=[],super.dispose()}}t.$vh=Be;class Fe extends H.$Uc{constructor(a,d){super(),this.g=a,this.h=d,this.a=[],this.b=this.B(new H.$Vc),this.f=!1}get pending(){return this.a.length}work(a){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+a.length>this.g.maxBufferedWork)return!1}else if(this.pending+a.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const d of a)this.a.push(d);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new te(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}t.$wh=Fe,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?t.$yh=(D,a)=>{(0,k.$B)(()=>{if(d)return;const s=Date.now()+15;a(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,s-Date.now())}}))});let d=!1;return{dispose(){d||(d=!0)}}}:t.$yh=(D,a,d)=>{const s=D.requestIdleCallback(a,typeof d=="number"?{timeout:d}:void 0);let l=!1;return{dispose(){l||(l=!0,D.cancelIdleCallback(s))}}},t.$xh=D=>(0,t.$yh)(globalThis,D)}();class Pe{constructor(a,d){this.g=!1,this.d=()=>{try{this.j=d()}catch(s){this.l=s}finally{this.g=!0}},this.f=(0,t.$yh)(a,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}t.$zh=Pe;class le extends Pe{constructor(a){super(globalThis,a)}}t.$Ah=le;async function _(D,a,d){let s;for(let l=0;l<d;l++)try{return await D()}catch(F){s=F,await O(a)}throw s}class ae{isRunning(a){return typeof a=="number"?this.a?.taskId===a:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(a,d,s){return this.a={taskId:a,cancel:()=>s?.(),promise:d},d.then(()=>this.d(a),()=>this.d(a)),d}d(a){this.a&&a===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const a=this.b;this.b=void 0,a.run().then(a.promiseResolve,a.promiseReject)}}queue(a){if(this.b)this.b.run=a;else{const{promise:d,resolve:s,reject:l}=m();this.b={run:a,promise:d,promiseResolve:s,promiseReject:l}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}t.$Ch=ae;class re{constructor(a,d=()=>Date.now()){this.d=a,this.f=d,this.a=0,this.b=0}increment(){const a=this.f();return a-this.a>this.d&&(this.a=a,this.b=0),this.b++,this.b}}t.$Dh=re;var J;(function(D){D[D.Resolved=0]="Resolved",D[D.Rejected=1]="Rejected"})(J||(J={}));class G{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((a,d)=>{this.a=a,this.b=d})}complete(a){return new Promise(d=>{this.a(a),this.d={outcome:0,value:a},d()})}error(a){return new Promise(d=>{this.b(a),this.d={outcome:1,value:a},d()})}cancel(){return this.error(new N.$5)}}t.$Eh=G;var ie;(function(D){async function a(s){let l;const F=await Promise.all(s.map(A=>A.then(R=>R,R=>{l||(l=R)})));if(typeof l<"u")throw l;return F}D.settled=a;function d(s){return new Promise(async(l,F)=>{try{await s(l,F)}catch(A){F(A)}})}D.withAsyncBody=d})(ie||(t.Promises=ie={}));class ue{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(a){this.a=void 0,this.b=void 0,this.d=!1,this.promise=a.then(d=>(this.a=d,this.d=!0,d),d=>{throw this.b=d,this.d=!0,d})}requireValue(){if(!this.d)throw new N.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}t.$Fh=ue;class ye{constructor(a){this.b=a,this.a=new $.$V(()=>new ue(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}t.$Gh=ye;var Ne;(function(D){D[D.Initial=0]="Initial",D[D.DoneOK=1]="DoneOK",D[D.DoneError=2]="DoneError"})(Ne||(Ne={}));class Ae{static fromArray(a){return new Ae(d=>{d.emitMany(a)})}static fromPromise(a){return new Ae(async d=>{d.emitMany(await a)})}static fromPromises(a){return new Ae(async d=>{await Promise.all(a.map(async s=>d.emitOne(await s)))})}static merge(a){return new Ae(async d=>{await Promise.all(a.map(async s=>{for await(const l of s)d.emitOne(l)}))})}static{this.EMPTY=Ae.fromArray([])}constructor(a){this.a=0,this.b=[],this.d=null,this.f=new z.$7d,queueMicrotask(async()=>{const d={emitOne:s=>this.g(s),emitMany:s=>this.h(s),reject:s=>this.k(s)};try{await Promise.resolve(a(d)),this.j()}catch(s){this.k(s)}finally{d.emitOne=void 0,d.emitMany=void 0,d.reject=void 0}})}[Symbol.asyncIterator](){let a=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(a<this.b.length)return{done:!1,value:this.b[a++]};if(this.a===1)return{done:!0,value:void 0};await z.Event.toPromise(this.f.event)}while(!0)}}}static map(a,d){return new Ae(async s=>{for await(const l of a)s.emitOne(d(l))})}map(a){return Ae.map(this,a)}static filter(a,d){return new Ae(async s=>{for await(const l of a)d(l)&&s.emitOne(l)})}filter(a){return Ae.filter(this,a)}static coalesce(a){return Ae.filter(a,d=>!!d)}coalesce(){return Ae.coalesce(this)}static async toPromise(a){const d=[];for await(const s of a)d.push(s);return d}toPromise(){return Ae.toPromise(this)}g(a){this.a===0&&(this.b.push(a),this.f.fire())}h(a){this.a===0&&(this.b=this.b.concat(a),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(a){this.a===0&&(this.a=2,this.d=a,this.f.fire())}}t.$Hh=Ae;class ge extends Ae{constructor(a,d){super(d),this.l=a}cancel(){this.l.cancel()}}t.$Ih=ge;function u(D){const a=new i.$ee,d=D(a.token);return new ge(a,async s=>{const l=a.token.onCancellationRequested(()=>{l.dispose(),a.dispose(),s.reject(new N.$5)});try{for await(const F of d){if(a.token.isCancellationRequested)return;s.emitOne(F)}l.dispose(),a.dispose()}catch(F){l.dispose(),a.dispose(),s.reject(F)}})}class S{constructor(){this.a=new G,this.b=new Ae(s=>{if(a){s.reject(a);return}return d&&s.emitMany(d),this.d=l=>s.reject(l),this.f=l=>s.emitOne(l),this.a.p});let a,d;this.f=s=>{d||(d=[]),d.push(s)},this.d=s=>{a||(a=s)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(a){this.d(a),this.a.complete()}emitOne(a){this.f(a)}}t.$Kh=S}),define(be[2],$e([1,0,17,118,15,20,9,6,4,122,3,32,5,16,52,22]),function(ne,t,i,N,z,H,E,k,b,$,w,P,c,f,e,n){"use strict";var h;Object.defineProperty(t,"__esModule",{value:!0}),t.$xS=t.$vS=t.$sS=t.DetectedFullscreenMode=t.Namespace=t.$3R=t.$1R=t.$RR=t.$nR=t.$hR=t.$fR=t.$eR=t.$dR=t.$$Q=t.$0Q=t.$9Q=t.onDidUnregisterWindow=t.onWillUnregisterWindow=t.onDidRegisterWindow=t.hasWindow=t.getWindowById=t.getWindowId=t.getWindowsCount=t.getWindows=t.getDocument=t.getWindow=t.registerWindow=void 0,t.$7Q=m,t.$8Q=v,t.$_Q=L,t.$aR=M,t.$bR=O,t.$cR=y,t.$gR=q,t.$iR=T,t.$jR=Q,t.$kR=te,t.$lR=de,t.$mR=Be,t.$oR=le,t.$pR=_,t.$qR=ae,t.$rR=re,t.$sR=J,t.$tR=G,t.$uR=ie,t.$vR=ue,t.$wR=ye,t.$xR=Ne,t.$yR=ge,t.$zR=u,t.$AR=D,t.$BR=d,t.$CR=s,t.$DR=l,t.$ER=F,t.$FR=A,t.$GR=R,t.$HR=W,t.$IR=X,t.$JR=U,t.$KR=me,t.$LR=ve,t.$MR=we,t.$NR=ke,t.$OR=Ee,t.$PR=Re,t.$QR=Ye,t.$SR=Ge,t.$TR=Ue,t.$UR=Le,t.$VR=ze,t.$WR=_e,t.$XR=tt,t.$YR=nt,t.$ZR=Je,t.$2R=rt,t.$4R=et,t.$5R=mt,t.$6R=kt,t.$7R=St,t.$8R=Bt,t.$9R=Oe,t.$0R=he,t.$=it,t.$_R=at,t.$aS=Xe,t.$bS=ut,t.$cS=$t,t.$dS=Xt,t.$eS=Ai,t.$fS=ki,t.$gS=Si,t.$hS=Bi,t.$iS=Ti,t.$jS=Fi,t.$kS=Ni,t.$lS=Ci,t.$mS=Ri,t.$nS=Ut,t.$oS=Li,t.$pS=Ii,t.$qS=Mi,t.$rS=_t,t.$tS=Oi,t.$uS=zi,t.$wS=Hi,t.h=qi,t.$zS=ti,t.$AS=Qi,h=function(){const V=new Map;(0,n.$AQ)(n.$BQ,1);const K={window:n.$BQ,disposables:new w.$Tc};V.set(n.$BQ.vscodeWindowId,K);const ee=new b.$7d,fe=new b.$7d,Se=new b.$7d;function xe(je,We){return(typeof je=="number"?V.get(je):void 0)??(We?K:void 0)}return{onDidRegisterWindow:ee.event,onWillUnregisterWindow:Se.event,onDidUnregisterWindow:fe.event,registerWindow(je){if(V.has(je.vscodeWindowId))return w.$Uc.None;const We=new w.$Tc,qe={window:je,disposables:We.add(new w.$Tc)};return V.set(je.vscodeWindowId,qe),We.add((0,w.$Sc)(()=>{V.delete(je.vscodeWindowId),fe.fire(je)})),We.add(v(je,t.$1R.BEFORE_UNLOAD,()=>{Se.fire(je)})),ee.fire(qe),We},getWindows(){return V.values()},getWindowsCount(){return V.size},getWindowId(je){return je.vscodeWindowId},hasWindow(je){return V.has(je)},getWindowById:xe,getWindow(je){const We=je;if(We?.ownerDocument?.defaultView)return We.ownerDocument.defaultView.window;const qe=je;return qe?.view?qe.view.window:n.$BQ},getDocument(je){const We=je;return(0,t.getWindow)(We).document}}}(),t.registerWindow=h.registerWindow,t.getWindow=h.getWindow,t.getDocument=h.getDocument,t.getWindows=h.getWindows,t.getWindowsCount=h.getWindowsCount,t.getWindowId=h.getWindowId,t.getWindowById=h.getWindowById,t.hasWindow=h.hasWindow,t.onDidRegisterWindow=h.onDidRegisterWindow,t.onWillUnregisterWindow=h.onWillUnregisterWindow,t.onDidUnregisterWindow=h.onDidUnregisterWindow;function m(V){for(;V.firstChild;)V.firstChild.remove()}class p{constructor(K,ee,fe,Se){this.f=K,this.g=ee,this.d=fe,this.j=Se||!1,this.f.addEventListener(this.g,this.d,this.j)}dispose(){this.d&&(this.f.removeEventListener(this.g,this.d,this.j),this.f=null,this.d=null)}}function v(V,K,ee,fe){return new p(V,K,ee,fe)}function o(V,K){return function(ee){return K(new H.$ZQ(V,ee))}}function g(V){return function(K){return V(new z.$5Q(K))}}const r=function(K,ee,fe,Se){let xe=fe;return ee==="click"||ee==="mousedown"?xe=o((0,t.getWindow)(K),fe):(ee==="keydown"||ee==="keypress"||ee==="keyup")&&(xe=g(fe)),v(K,ee,xe,Se)};t.$9Q=r;const B=function(K,ee,fe){const Se=o((0,t.getWindow)(K),ee);return L(K,Se,fe)};t.$0Q=B;const C=function(K,ee,fe){const Se=o((0,t.getWindow)(K),ee);return O(K,Se,fe)};t.$$Q=C;function L(V,K,ee){return v(V,c.$r&&N.$WQ.pointerEvents?t.$1R.POINTER_DOWN:t.$1R.MOUSE_DOWN,K,ee)}function M(V,K,ee){return v(V,c.$r&&N.$WQ.pointerEvents?t.$1R.POINTER_MOVE:t.$1R.MOUSE_MOVE,K,ee)}function O(V,K,ee){return v(V,c.$r&&N.$WQ.pointerEvents?t.$1R.POINTER_UP:t.$1R.MOUSE_UP,K,ee)}function y(V,K,ee){return(0,E.$yh)(V,K,ee)}class x extends E.$zh{constructor(K,ee){super(K,ee)}}t.$dR=x;function q(V,K,ee,fe){let Se=0;const xe=V.setInterval(()=>{Se++,(typeof fe=="number"&&Se>=fe||K()===!0)&&je.dispose()},ee),je=(0,w.$Sc)(()=>{V.clearInterval(xe)});return je}class I extends E.$sh{constructor(K){super(),this.f=K&&(0,t.getWindow)(K)}cancelAndSet(K,ee,fe){return super.cancelAndSet(K,ee,fe??this.f)}}t.$hR=I;class j{constructor(K,ee=0){this.d=K,this.priority=ee,this.f=!1}dispose(){this.f=!0}execute(){if(!this.f)try{this.d()}catch(K){(0,k.$1)(K)}}static sort(K,ee){return ee.priority-K.priority}}(function(){const V=new Map,K=new Map,ee=new Map,fe=new Map,Se=xe=>{ee.set(xe,!1);const je=V.get(xe)??[];for(K.set(xe,je),V.set(xe,[]),fe.set(xe,!0);je.length>0;)je.sort(j.sort),je.shift().execute();fe.set(xe,!1)};t.$fR=(xe,je,We=0)=>{const qe=(0,t.getWindowId)(xe),Qe=new j(je,We);let lt=V.get(qe);return lt||(lt=[],V.set(qe,lt)),lt.push(Qe),ee.get(qe)||(ee.set(qe,!0),xe.requestAnimationFrame(()=>Se(qe))),Qe},t.$eR=(xe,je,We)=>{const qe=(0,t.getWindowId)(xe);if(fe.get(qe)){const Qe=new j(je,We);let lt=K.get(qe);return lt||(lt=[],K.set(qe,lt)),lt.push(Qe),Qe}else return(0,t.$fR)(xe,je,We)}})();function T(V,K){return(0,t.$fR)(V,K,1e4)}function Q(V,K){return(0,t.$fR)(V,K,-1e4)}const Z=8,ce=function(V,K){return K};class oe extends w.$Uc{constructor(K,ee,fe,Se=ce,xe=Z){super();let je=null,We=0;const qe=this.B(new E.$rh),Qe=()=>{We=new Date().getTime(),fe(je),je=null};this.B(v(K,ee,lt=>{je=Se(je,lt);const Ft=new Date().getTime()-We;Ft>=xe?(qe.cancel(),Qe()):qe.setIfNotSet(Qe,xe-Ft)}))}}function te(V,K,ee,fe,Se){return new oe(V,K,ee,fe,Se)}function de(V){return(0,t.getWindow)(V).getComputedStyle(V,null)}function Be(V,K){const ee=(0,t.getWindow)(V),fe=ee.document;if(V!==fe.body)return new Pe(V.clientWidth,V.clientHeight);if(c.$r&&ee?.visualViewport)return new Pe(ee.visualViewport.width,ee.visualViewport.height);if(ee?.innerWidth&&ee.innerHeight)return new Pe(ee.innerWidth,ee.innerHeight);if(fe.body&&fe.body.clientWidth&&fe.body.clientHeight)return new Pe(fe.body.clientWidth,fe.body.clientHeight);if(fe.documentElement&&fe.documentElement.clientWidth&&fe.documentElement.clientHeight)return new Pe(fe.documentElement.clientWidth,fe.documentElement.clientHeight);if(K)return Be(K);throw new Error("Unable to figure out browser width and height")}class Fe{static d(K,ee){return parseFloat(ee)||0}static f(K,ee,fe){const Se=de(K),xe=Se?Se.getPropertyValue(ee):"0";return Fe.d(K,xe)}static getBorderLeftWidth(K){return Fe.f(K,"border-left-width","borderLeftWidth")}static getBorderRightWidth(K){return Fe.f(K,"border-right-width","borderRightWidth")}static getBorderTopWidth(K){return Fe.f(K,"border-top-width","borderTopWidth")}static getBorderBottomWidth(K){return Fe.f(K,"border-bottom-width","borderBottomWidth")}static getPaddingLeft(K){return Fe.f(K,"padding-left","paddingLeft")}static getPaddingRight(K){return Fe.f(K,"padding-right","paddingRight")}static getPaddingTop(K){return Fe.f(K,"padding-top","paddingTop")}static getPaddingBottom(K){return Fe.f(K,"padding-bottom","paddingBottom")}static getMarginLeft(K){return Fe.f(K,"margin-left","marginLeft")}static getMarginTop(K){return Fe.f(K,"margin-top","marginTop")}static getMarginRight(K){return Fe.f(K,"margin-right","marginRight")}static getMarginBottom(K){return Fe.f(K,"margin-bottom","marginBottom")}}class Pe{static{this.None=new Pe(0,0)}constructor(K,ee){this.width=K,this.height=ee}with(K=this.width,ee=this.height){return K!==this.width||ee!==this.height?new Pe(K,ee):this}static is(K){return typeof K=="object"&&typeof K.height=="number"&&typeof K.width=="number"}static lift(K){return K instanceof Pe?K:new Pe(K.width,K.height)}static equals(K,ee){return K===ee?!0:!K||!ee?!1:K.width===ee.width&&K.height===ee.height}}t.$nR=Pe;function le(V){let K=V.offsetParent,ee=V.offsetTop,fe=V.offsetLeft;for(;(V=V.parentNode)!==null&&V!==V.ownerDocument.body&&V!==V.ownerDocument.documentElement;){ee-=V.scrollTop;const Se=F(V)?null:de(V);Se&&(fe-=Se.direction!=="rtl"?V.scrollLeft:-V.scrollLeft),V===K&&(fe+=Fe.getBorderLeftWidth(V),ee+=Fe.getBorderTopWidth(V),ee+=V.offsetTop,fe+=V.offsetLeft,K=V.offsetParent)}return{left:fe,top:ee}}function _(V,K,ee){typeof K=="number"&&(V.style.width=`${K}px`),typeof ee=="number"&&(V.style.height=`${ee}px`)}function ae(V,K,ee,fe,Se,xe="absolute"){typeof K=="number"&&(V.style.top=`${K}px`),typeof ee=="number"&&(V.style.right=`${ee}px`),typeof fe=="number"&&(V.style.bottom=`${fe}px`),typeof Se=="number"&&(V.style.left=`${Se}px`),V.style.position=xe}function re(V){const K=V.getBoundingClientRect(),ee=(0,t.getWindow)(V);return{left:K.left+ee.scrollX,top:K.top+ee.scrollY,width:K.width,height:K.height}}function J(V){let K=V,ee=1;do{const fe=de(K).zoom;fe!=null&&fe!=="1"&&(ee*=fe),K=K.parentElement}while(K!==null&&K!==K.ownerDocument.documentElement);return ee}function G(V){const K=Fe.getMarginLeft(V)+Fe.getMarginRight(V);return V.offsetWidth+K}function ie(V){const K=Fe.getBorderLeftWidth(V)+Fe.getBorderRightWidth(V),ee=Fe.getPaddingLeft(V)+Fe.getPaddingRight(V);return V.offsetWidth-K-ee}function ue(V){const K=Fe.getMarginLeft(V)+Fe.getMarginRight(V);return V.scrollWidth+K}function ye(V){const K=Fe.getBorderTopWidth(V)+Fe.getBorderBottomWidth(V),ee=Fe.getPaddingTop(V)+Fe.getPaddingBottom(V);return V.offsetHeight-K-ee}function Ne(V){const K=Fe.getMarginTop(V)+Fe.getMarginBottom(V);return V.offsetHeight+K}function Ae(V,K){if(V===null)return 0;const ee=le(V),fe=le(K);return ee.left-fe.left}function ge(V,K){const ee=K.map(Se=>Math.max(ue(Se),G(Se))+Ae(Se,V)||0);return Math.max(...ee)}function u(V,K){return!!K?.contains(V)}const S="parentFlowToElementId";function D(V,K){V.dataset[S]=K.id}function a(V){const K=V.dataset[S];return typeof K=="string"?V.ownerDocument.getElementById(K):null}function d(V,K){let ee=V;for(;ee;){if(ee===K)return!0;if(ee instanceof HTMLElement){const fe=a(ee);if(fe){ee=fe;continue}}ee=ee.parentNode}return!1}function s(V,K,ee){for(;V&&V.nodeType===V.ELEMENT_NODE;){if(V.classList.contains(K))return V;if(ee){if(typeof ee=="string"){if(V.classList.contains(ee))return null}else if(V===ee)return null}V=V.parentNode}return null}function l(V,K,ee){return!!s(V,K,ee)}function F(V){return V&&!!V.host&&!!V.mode}function A(V){return!!R(V)}function R(V){for(;V.parentNode;){if(V===V.ownerDocument?.body)return null;V=V.parentNode}return F(V)?V:null}function W(){let V=ve().activeElement;for(;V?.shadowRoot;)V=V.shadowRoot.activeElement;return V}function X(V){return W()===V}function U(V){return u(W(),V)}function me(V){return V.ownerDocument===ve()}function ve(){return(0,t.getWindowsCount)()<=1?n.$BQ.document:Array.from((0,t.getWindows)()).map(({window:K})=>K.document).find(K=>K.hasFocus())??n.$BQ.document}function we(){return ve().defaultView?.window??n.$BQ}const Me=new Map;function ke(V){return Me.has(V)}function Ee(){return new Ce}class Ce{constructor(){this.d="",this.f=void 0}setStyle(K){K!==this.d&&(this.d=K,this.f?this.f.innerText=K:this.f=Re(n.$BQ.document.head,ee=>ee.innerText=K))}dispose(){this.f&&(this.f.remove(),this.f=void 0)}}function Re(V=n.$BQ.document.head,K,ee){const fe=document.createElement("style");if(fe.type="text/css",fe.media="screen",K?.(fe),V.appendChild(fe),ee&&ee.add((0,w.$Sc)(()=>V.removeChild(fe))),V===n.$BQ.document.head){const Se=new Set;Me.set(fe,Se);for(const{window:xe,disposables:je}of(0,t.getWindows)()){if(xe===n.$BQ)continue;const We=je.add(st(fe,Se,xe));ee?.add(We)}}return fe}function Ye(V){const K=new w.$Tc;for(const[ee,fe]of Me)K.add(st(ee,fe,V));return K}function st(V,K,ee){const fe=new w.$Tc,Se=V.cloneNode(!0);ee.document.head.appendChild(Se),fe.add((0,w.$Sc)(()=>ee.document.head.removeChild(Se)));for(const xe of De(V))Se.sheet?.insertRule(xe.cssText,Se.sheet?.cssRules.length);return fe.add(t.$RR.observe(V,fe,{childList:!0})(()=>{Se.textContent=V.textContent})),K.add(Se),fe.add((0,w.$Sc)(()=>K.delete(Se))),fe}t.$RR=new class{constructor(){this.mutationObservers=new Map}observe(V,K,ee){let fe=this.mutationObservers.get(V);fe||(fe=new Map,this.mutationObservers.set(V,fe));const Se=(0,e.$8i)(ee);let xe=fe.get(Se);if(xe)xe.users+=1;else{const je=new b.$7d,We=new MutationObserver(Qe=>je.fire(Qe));We.observe(V,ee);const qe=xe={users:1,observer:We,onDidMutate:je.event};K.add((0,w.$Sc)(()=>{qe.users-=1,qe.users===0&&(je.dispose(),We.disconnect(),fe?.delete(Se),fe?.size===0&&this.mutationObservers.delete(V))})),fe.set(Se,xe)}return xe.onDidMutate}};function Ge(V=n.$BQ.document.head){return Y("meta",V)}function Ue(V=n.$BQ.document.head){return Y("link",V)}function Y(V,K=n.$BQ.document.head){const ee=document.createElement(V);return K.appendChild(ee),ee}let se=null;function pe(){return se||(se=Re()),se}function De(V){return V?.sheet?.rules?V.sheet.rules:V?.sheet?.cssRules?V.sheet.cssRules:[]}function Le(V,K,ee=pe()){if(!(!ee||!K)){ee.sheet?.insertRule(`${V} {${K}}`,0);for(const fe of Me.get(ee)??[])Le(V,K,fe)}}function ze(V,K=pe()){if(!K)return;const ee=De(K),fe=[];for(let Se=0;Se<ee.length;Se++){const xe=ee[Se];Ve(xe)&&xe.selectorText.indexOf(V)!==-1&&fe.push(Se)}for(let Se=fe.length-1;Se>=0;Se--)K.sheet?.deleteRule(fe[Se]);for(const Se of Me.get(K)??[])ze(V,Se)}function Ve(V){return typeof V.selectorText=="string"}function _e(V){return V instanceof MouseEvent||V instanceof(0,t.getWindow)(V).MouseEvent}function tt(V){return V instanceof KeyboardEvent||V instanceof(0,t.getWindow)(V).KeyboardEvent}function nt(V){return V instanceof PointerEvent||V instanceof(0,t.getWindow)(V).PointerEvent}function Je(V){return V instanceof DragEvent||V instanceof(0,t.getWindow)(V).DragEvent}t.$1R={CLICK:"click",AUXCLICK:"auxclick",DBLCLICK:"dblclick",MOUSE_UP:"mouseup",MOUSE_DOWN:"mousedown",MOUSE_OVER:"mouseover",MOUSE_MOVE:"mousemove",MOUSE_OUT:"mouseout",MOUSE_ENTER:"mouseenter",MOUSE_LEAVE:"mouseleave",MOUSE_WHEEL:"wheel",POINTER_UP:"pointerup",POINTER_DOWN:"pointerdown",POINTER_MOVE:"pointermove",POINTER_LEAVE:"pointerleave",CONTEXT_MENU:"contextmenu",WHEEL:"wheel",KEY_DOWN:"keydown",KEY_PRESS:"keypress",KEY_UP:"keyup",LOAD:"load",BEFORE_UNLOAD:"beforeunload",UNLOAD:"unload",PAGE_SHOW:"pageshow",PAGE_HIDE:"pagehide",PASTE:"paste",ABORT:"abort",ERROR:"error",RESIZE:"resize",SCROLL:"scroll",FULLSCREEN_CHANGE:"fullscreenchange",WK_FULLSCREEN_CHANGE:"webkitfullscreenchange",SELECT:"select",CHANGE:"change",SUBMIT:"submit",RESET:"reset",FOCUS:"focus",FOCUS_IN:"focusin",FOCUS_OUT:"focusout",BLUR:"blur",INPUT:"input",STORAGE:"storage",DRAG_START:"dragstart",DRAG:"drag",DRAG_ENTER:"dragenter",DRAG_LEAVE:"dragleave",DRAG_OVER:"dragover",DROP:"drop",DRAG_END:"dragend",ANIMATION_START:i.$OQ?"webkitAnimationStart":"animationstart",ANIMATION_END:i.$OQ?"webkitAnimationEnd":"animationend",ANIMATION_ITERATION:i.$OQ?"webkitAnimationIteration":"animationiteration"};function rt(V){const K=V;return!!(K&&typeof K.preventDefault=="function"&&typeof K.stopPropagation=="function")}t.$3R={stop:(V,K)=>(V.preventDefault(),K&&V.stopPropagation(),V)};function et(V){const K=[];for(let ee=0;V&&V.nodeType===V.ELEMENT_NODE;ee++)K[ee]=V.scrollTop,V=V.parentNode;return K}function mt(V,K){for(let ee=0;V&&V.nodeType===V.ELEMENT_NODE;ee++)V.scrollTop!==K[ee]&&(V.scrollTop=K[ee]),V=V.parentNode}class gt extends w.$Uc{static m(K){if(K instanceof HTMLElement){const ee=R(K),fe=ee?ee.activeElement:K.ownerDocument.activeElement;return u(fe,K)}else{const ee=K;return u(ee.document.activeElement,ee.document)}}constructor(K){super(),this.f=this.B(new b.$7d),this.onDidFocus=this.f.event,this.g=this.B(new b.$7d),this.onDidBlur=this.g.event;let ee=gt.m(K),fe=!1;const Se=()=>{fe=!1,ee||(ee=!0,this.f.fire())},xe=()=>{ee&&(fe=!0,(K instanceof HTMLElement?(0,t.getWindow)(K):K).setTimeout(()=>{fe&&(fe=!1,ee=!1,this.g.fire())},0))};this.j=()=>{gt.m(K)!==ee&&(ee?xe():Se())},this.B(v(K,t.$1R.FOCUS,Se,!0)),this.B(v(K,t.$1R.BLUR,xe,!0)),K instanceof HTMLElement&&(this.B(v(K,t.$1R.FOCUS_IN,()=>this.j())),this.B(v(K,t.$1R.FOCUS_OUT,()=>this.j())))}refreshState(){this.j()}}function kt(V){return new gt(V)}function St(V,K){return V.after(K),K}function Bt(V,...K){if(V.append(...K),K.length===1&&typeof K[0]!="string")return K[0]}function Oe(V,K){return V.insertBefore(K,V.firstChild),K}function he(V,...K){V.innerText="",Bt(V,...K)}const Te=/([\w\-]+)?(#([\w\-]+))?((\.([\w\-]+))*)/;var Ie;(function(V){V.HTML="http://www.w3.org/1999/xhtml",V.SVG="http://www.w3.org/2000/svg"})(Ie||(t.Namespace=Ie={}));function Ke(V,K,ee,...fe){const Se=Te.exec(K);if(!Se)throw new Error("Bad use of emmet");const xe=Se[1]||"div";let je;return V!==Ie.HTML?je=document.createElementNS(V,xe):je=document.createElement(xe),Se[3]&&(je.id=Se[3]),Se[4]&&(je.className=Se[4].replace(/\./g," ").trim()),ee&&Object.entries(ee).forEach(([We,qe])=>{typeof qe>"u"||(/^on\w+$/.test(We)?je[We]=qe:We==="selected"?qe&&je.setAttribute(We,"true"):je.setAttribute(We,qe))}),je.append(...fe),je}function it(V,K,...ee){return Ke(Ie.HTML,V,K,...ee)}it.SVG=function(V,K,...ee){return Ke(Ie.SVG,V,K,...ee)};function at(V,K){const ee=[];return V.forEach((fe,Se)=>{Se>0&&(K instanceof Node?ee.push(K.cloneNode()):ee.push(document.createTextNode(K))),ee.push(fe)}),ee}function Xe(V,...K){V?ut(...K):$t(...K)}function ut(...V){for(const K of V)K.style.display="",K.removeAttribute("aria-hidden")}function $t(...V){for(const K of V)K.style.display="none",K.setAttribute("aria-hidden","true")}function Tt(V,K){for(;V&&V.nodeType===V.ELEMENT_NODE;){if(V instanceof HTMLElement&&V.hasAttribute(K))return V;V=V.parentNode}return null}function Xt(V){!V||!V.hasAttribute("tabIndex")||(V.ownerDocument.activeElement===V&&Tt(V.parentElement,"tabIndex")?.focus(),V.removeAttribute("tabindex"))}function Ai(V){return K=>{K.preventDefault(),K.stopPropagation(),V(K)}}function ki(V){return new Promise(K=>{if(V.document.readyState==="complete"||V.document&&V.document.body!==null)K(void 0);else{const fe=()=>{V.window.removeEventListener("DOMContentLoaded",fe,!1),K()};V.window.addEventListener("DOMContentLoaded",fe,!1)}})}function Si(V,K){const ee=V.devicePixelRatio*K;return Math.max(1,Math.floor(ee))/V.devicePixelRatio}function Bi(V){n.$BQ.open(V,"_blank","noopener")}const Zt=780,Jt=640;function Ti(V){const K=Math.floor(n.$BQ.screenLeft+n.$BQ.innerWidth/2-Zt/2),ee=Math.floor(n.$BQ.screenTop+n.$BQ.innerHeight/2-Jt/2);n.$BQ.open(V,"_blank",`width=${Zt},height=${Jt},top=${ee},left=${K}`)}function Fi(V,K=!0){const ee=n.$BQ.open();return ee?(K&&(ee.opener=null),ee.location.href=V,!0):!1}function Ni(V,K){const ee=()=>{K(),fe=(0,t.$fR)(V,ee)};let fe=(0,t.$fR)(V,ee);return(0,w.$Sc)(()=>fe.dispose())}P.$ug.setPreferredWebSchema(/^https:/.test(n.$BQ.location.href)?"https":"http");function Ci(V){return V?`url('${P.$Bg.uriToBrowserUri(V).toString(!0).replace(/'/g,"%27")}')`:"url('')"}function Ri(V){return`'${V.replace(/'/g,"%27")}'`}function Ut(V,K){if(V!==void 0){const ee=V.match(/^\s*var\((.+)\)$/);if(ee){const fe=ee[1].split(",",2);return fe.length===2&&(K=Ut(fe[1].trim(),K)),`var(${fe[0]}, ${K})`}return V}return K}function Li(V,K){let ee;if(f.URI.isUri(V))ee=V.toString(!0);else{const xe=new Blob([V]);ee=URL.createObjectURL(xe),setTimeout(()=>URL.revokeObjectURL(ee))}const fe=we(),Se=document.createElement("a");fe.document.body.appendChild(Se),Se.download=K,Se.href=ee,Se.click(),setTimeout(()=>fe.document.body.removeChild(Se))}function Ii(){return new Promise(V=>{const K=we(),ee=document.createElement("input");K.document.body.appendChild(ee),ee.type="file",ee.multiple=!0,b.Event.once(b.Event.fromDOMEventEmitter(ee,"input"))(()=>{V(ee.files??void 0)}),ee.click(),setTimeout(()=>K.document.body.removeChild(ee))})}var Dt;(function(V){V[V.DOCUMENT=1]="DOCUMENT",V[V.BROWSER=2]="BROWSER"})(Dt||(t.DetectedFullscreenMode=Dt={}));function Mi(V){return V.document.fullscreenElement||V.document.webkitFullscreenElement||V.document.webkitIsFullScreen?{mode:Dt.DOCUMENT,guess:!1}:V.innerHeight===V.screen.height?{mode:Dt.BROWSER,guess:!1}:(c.$j||c.$k)&&V.outerHeight===V.screen.height&&V.outerWidth===V.screen.width?{mode:Dt.BROWSER,guess:!0}:null}function _t(V,K=!1){const ee=document.createElement("a");return $.addHook("afterSanitizeAttributes",fe=>{for(const Se of["href","src"])if(fe.hasAttribute(Se)){const xe=fe.getAttribute(Se);if(Se==="href"&&xe.startsWith("#"))continue;if(ee.href=xe,!V.includes(ee.protocol.replace(/:$/,""))){if(K&&Se==="src"&&ee.href.startsWith("data:"))continue;fe.removeAttribute(Se)}}}),(0,w.$Sc)(()=>{$.removeHook("afterSanitizeAttributes")})}const ji=[P.Schemas.http,P.Schemas.https,P.Schemas.command];t.$sS=Object.freeze(["a","abbr","b","bdo","blockquote","br","caption","cite","code","col","colgroup","dd","del","details","dfn","div","dl","dt","em","figcaption","figure","h1","h2","h3","h4","h5","h6","hr","i","img","input","ins","kbd","label","li","mark","ol","p","pre","q","rp","rt","ruby","samp","small","small","source","span","strike","strong","sub","summary","sup","table","tbody","td","tfoot","th","thead","time","tr","tt","u","ul","var","video","wbr"]);const Pi=Object.freeze({ALLOWED_TAGS:["a","button","blockquote","code","div","h1","h2","h3","h4","h5","h6","hr","input","label","li","p","pre","select","small","span","strong","textarea","ul","ol"],ALLOWED_ATTR:["href","data-href","data-command","target","title","name","src","alt","class","id","role","tabindex","style","data-code","width","height","align","x-dispatch","required","checked","placeholder","type","start"],RETURN_DOM:!1,RETURN_DOM_FRAGMENT:!1,RETURN_TRUSTED_TYPE:!0});function Oi(V,K){const ee=_t(ji);try{const fe=$.sanitize(K,Pi);V.innerHTML=fe}finally{ee.dispose()}}function xi(V){const K=new Uint16Array(V.length);for(let Se=0;Se<K.length;Se++)K[Se]=V.charCodeAt(Se);let ee="";const fe=new Uint8Array(K.buffer);for(let Se=0;Se<fe.length;Se++)ee+=String.fromCharCode(fe[Se]);return ee}function zi(V){return btoa(xi(V))}class pt extends b.$7d{constructor(){super(),this.o=new w.$Tc,this.A={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1},this.o.add(b.Event.runAndSubscribe(t.onDidRegisterWindow,({window:K,disposables:ee})=>this.C(K,ee),{window:n.$BQ,disposables:this.o}))}C(K,ee){ee.add(v(K,"keydown",fe=>{if(fe.defaultPrevented)return;const Se=new z.$5Q(fe);if(!(Se.keyCode===6&&fe.repeat)){if(fe.altKey&&!this.A.altKey)this.A.lastKeyPressed="alt";else if(fe.ctrlKey&&!this.A.ctrlKey)this.A.lastKeyPressed="ctrl";else if(fe.metaKey&&!this.A.metaKey)this.A.lastKeyPressed="meta";else if(fe.shiftKey&&!this.A.shiftKey)this.A.lastKeyPressed="shift";else if(Se.keyCode!==6)this.A.lastKeyPressed=void 0;else return;this.A.altKey=fe.altKey,this.A.ctrlKey=fe.ctrlKey,this.A.metaKey=fe.metaKey,this.A.shiftKey=fe.shiftKey,this.A.lastKeyPressed&&(this.A.event=fe,this.fire(this.A))}},!0)),ee.add(v(K,"keyup",fe=>{fe.defaultPrevented||(!fe.altKey&&this.A.altKey?this.A.lastKeyReleased="alt":!fe.ctrlKey&&this.A.ctrlKey?this.A.lastKeyReleased="ctrl":!fe.metaKey&&this.A.metaKey?this.A.lastKeyReleased="meta":!fe.shiftKey&&this.A.shiftKey?this.A.lastKeyReleased="shift":this.A.lastKeyReleased=void 0,this.A.lastKeyPressed!==this.A.lastKeyReleased&&(this.A.lastKeyPressed=void 0),this.A.altKey=fe.altKey,this.A.ctrlKey=fe.ctrlKey,this.A.metaKey=fe.metaKey,this.A.shiftKey=fe.shiftKey,this.A.lastKeyReleased&&(this.A.event=fe,this.fire(this.A)))},!0)),ee.add(v(K.document.body,"mousedown",()=>{this.A.lastKeyPressed=void 0},!0)),ee.add(v(K.document.body,"mouseup",()=>{this.A.lastKeyPressed=void 0},!0)),ee.add(v(K.document.body,"mousemove",fe=>{fe.buttons&&(this.A.lastKeyPressed=void 0)},!0)),ee.add(v(K,"blur",()=>{this.resetKeyStatus()}))}get keyStatus(){return this.A}get isModifierPressed(){return this.A.altKey||this.A.ctrlKey||this.A.metaKey||this.A.shiftKey}resetKeyStatus(){this.D(),this.fire(this.A)}D(){this.A={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1}}static getInstance(){return pt.B||(pt.B=new pt),pt.B}dispose(){super.dispose(),this.o.dispose()}}t.$vS=pt;function Hi(V){const K=document.cookie.match("(^|[^;]+)\\s*"+V+"\\s*=\\s*([^;]+)");return K?K.pop():void 0}class Wi extends w.$Uc{constructor(K,ee){super(),this.j=K,this.m=ee,this.f=0,this.g=0,this.n()}n(){this.m.onDragStart&&this.B(v(this.j,t.$1R.DRAG_START,K=>{this.m.onDragStart?.(K)})),this.m.onDrag&&this.B(v(this.j,t.$1R.DRAG,K=>{this.m.onDrag?.(K)})),this.B(v(this.j,t.$1R.DRAG_ENTER,K=>{this.f++,this.g=K.timeStamp,this.m.onDragEnter?.(K)})),this.B(v(this.j,t.$1R.DRAG_OVER,K=>{K.preventDefault(),this.m.onDragOver?.(K,K.timeStamp-this.g)})),this.B(v(this.j,t.$1R.DRAG_LEAVE,K=>{this.f--,this.f===0&&(this.g=0,this.m.onDragLeave?.(K))})),this.B(v(this.j,t.$1R.DRAG_END,K=>{this.f=0,this.g=0,this.m.onDragEnd?.(K)})),this.B(v(this.j,t.$1R.DROP,K=>{this.f=0,this.g=0,this.m.onDrop?.(K)}))}}t.$xS=Wi;const Vi=/(?<tag>[\w\-]+)?(?:#(?<id>[\w\-]+))?(?<class>(?:\.(?:[\w\-]+))*)(?:@(?<name>(?:[\w\_])+))?/;function qi(V,...K){let ee,fe;Array.isArray(K[0])?(ee={},fe=K[0]):(ee=K[0]||{},fe=K[1]);const Se=Vi.exec(V);if(!Se||!Se.groups)throw new Error("Bad use of h");const xe=Se.groups.tag||"div",je=document.createElement(xe);Se.groups.id&&(je.id=Se.groups.id);const We=[];if(Se.groups.class)for(const Qe of Se.groups.class.split("."))Qe!==""&&We.push(Qe);if(ee.className!==void 0)for(const Qe of ee.className.split("."))Qe!==""&&We.push(Qe);We.length>0&&(je.className=We.join(" "));const qe={};if(Se.groups.name&&(qe[Se.groups.name]=je),fe)for(const Qe of fe)Qe instanceof HTMLElement?je.appendChild(Qe):typeof Qe=="string"?je.append(Qe):"root"in Qe&&(Object.assign(qe,Qe),je.appendChild(Qe.root));for(const[Qe,lt]of Object.entries(ee))if(Qe!=="className")if(Qe==="style")for(const[Ft,Pt]of Object.entries(lt))je.style.setProperty(ei(Ft),typeof Pt=="number"?Pt+"px":""+Pt);else Qe==="tabIndex"?je.tabIndex=lt:je.setAttribute(ei(Qe),lt.toString());return qe.root=je,qe}function ei(V){return V.replace(/([a-z])([A-Z])/g,"$1-$2").toLowerCase()}function ti(V,K,ee){for(const{name:fe,value:Se}of V.attributes)(!ee||ee.includes(fe))&&K.setAttribute(fe,Se)}function Ki(V,K,ee){const fe=V.getAttribute(ee);fe?K.setAttribute(ee,fe):K.removeAttribute(ee)}function Qi(V,K,ee){ti(V,K,ee);const fe=new w.$Tc;return fe.add(t.$RR.observe(V,fe,{attributes:!0,attributeFilter:ee})(Se=>{for(const xe of Se)xe.type==="attributes"&&xe.attributeName&&Ki(V,K,xe.attributeName)})),fe}}),define(be[57],$e([1,0,2,3,121]),function(ne,t,i,N,z){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$CS=t.$BS=void 0,t.$DS=E;class H extends N.$Uc{constructor(b,$){super(),this.B((0,i.$8Q)(b,"dragover",w=>{w.preventDefault(),this.a||(this.a=setTimeout(()=>{$(),this.a=null},800))})),["dragleave","drop","dragend"].forEach(w=>{this.B((0,i.$8Q)(b,w,()=>{this.b()}))})}b(){this.a&&(clearTimeout(this.a),this.a=null)}dispose(){super.dispose(),this.b()}}t.$BS=H,t.$CS={RESOURCES:"ResourceURLs",DOWNLOAD_URL:"DownloadURL",FILES:"Files",TEXT:z.$ys.text,INTERNAL_URI_LIST:"application/vnd.code.uri-list"};function E(k,b,$,w,P){const c=document.createElement("div");if(c.className=$,c.textContent=b,P&&(c.style.color=P),w&&(c.style.background=w),k.dataTransfer){const f=(0,i.getWindow)(k).document;f.body.appendChild(c),k.dataTransfer.setDragImage(c,-10,-10),setTimeout(()=>f.body.removeChild(c),0)}}}),define(be[58],$e([1,0,2]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$9S=N,t.$0S=z,t.$$S=H;function N(c,f={}){const e=H(f);return e.textContent=c,e}function z(c,f={}){const e=H(f);return b(e,$(c,!!f.renderCodeSegments),f.actionHandler,f.renderCodeSegments),e}function H(c){const f=c.inline?"span":"div",e=document.createElement(f);return c.className&&(e.className=c.className),e}class E{constructor(f){this.b=f,this.c=0}eos(){return this.c>=this.b.length}next(){const f=this.peek();return this.advance(),f}peek(){return this.b[this.c]}advance(){this.c++}}var k;(function(c){c[c.Invalid=0]="Invalid",c[c.Root=1]="Root",c[c.Text=2]="Text",c[c.Bold=3]="Bold",c[c.Italics=4]="Italics",c[c.Action=5]="Action",c[c.ActionClose=6]="ActionClose",c[c.Code=7]="Code",c[c.NewLine=8]="NewLine"})(k||(k={}));function b(c,f,e,n){let h;if(f.type===2)h=document.createTextNode(f.content||"");else if(f.type===3)h=document.createElement("b");else if(f.type===4)h=document.createElement("i");else if(f.type===7&&n)h=document.createElement("code");else if(f.type===5&&e){const m=document.createElement("a");e.disposables.add(i.$9Q(m,"click",p=>{e.callback(String(f.index),p)})),h=m}else f.type===8?h=document.createElement("br"):f.type===1&&(h=c);h&&c!==h&&c.appendChild(h),h&&Array.isArray(f.children)&&f.children.forEach(m=>{b(h,m,e,n)})}function $(c,f){const e={type:1,children:[]};let n=0,h=e;const m=[],p=new E(c);for(;!p.eos();){let v=p.next();const o=v==="\\"&&P(p.peek(),f)!==0;if(o&&(v=p.next()),!o&&w(v,f)&&v===p.peek()){p.advance(),h.type===2&&(h=m.pop());const g=P(v,f);if(h.type===g||h.type===5&&g===6)h=m.pop();else{const r={type:g,children:[]};g===5&&(r.index=n,n++),h.children.push(r),m.push(h),h=r}}else if(v===`
`)h.type===2&&(h=m.pop()),h.children.push({type:8});else if(h.type!==2){const g={type:2,content:v};h.children.push(g),m.push(h),h=g}else h.content+=v}return h.type===2&&(h=m.pop()),m.length,e}function w(c,f){return P(c,f)!==0}function P(c,f){switch(c){case"*":return 3;case"_":return 4;case"[":return 5;case"]":return 6;case"`":return f?7:0;default:return 0}}}),define(be[59],$e([1,0,2,3]),function(ne,t,i,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$HS=void 0;class z{constructor(){this.a=new N.$Tc,this.b=null,this.c=null}dispose(){this.stopMonitoring(!1),this.a.dispose()}stopMonitoring(E,k){if(!this.isMonitoring())return;this.a.clear(),this.b=null;const b=this.c;this.c=null,E&&b&&b(k)}isMonitoring(){return!!this.b}startMonitoring(E,k,b,$,w){this.isMonitoring()&&this.stopMonitoring(!1),this.b=$,this.c=w;let P=E;try{E.setPointerCapture(k),this.a.add((0,N.$Sc)(()=>{try{E.releasePointerCapture(k)}catch{}}))}catch{P=i.getWindow(E)}this.a.add(i.$8Q(P,i.$1R.POINTER_MOVE,c=>{if(c.buttons!==b){this.stopMonitoring(!0);return}c.preventDefault(),this.b(c)})),this.a.add(i.$8Q(P,i.$1R.POINTER_UP,c=>this.stopMonitoring(!0)))}}t.$HS=z});var Ze=this&&this.__decorate||function(ne,t,i,N){var z=arguments.length,H=z<3?t:N===null?N=Object.getOwnPropertyDescriptor(t,i):N,E;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")H=Reflect.decorate(ne,t,i,N);else for(var k=ne.length-1;k>=0;k--)(E=ne[k])&&(H=(z<3?E(H):z>3?E(t,i,H):E(t,i))||H);return z>3&&H&&Object.defineProperty(t,i,H),H};define(be[26],$e([1,0,2,22,12,28,4,3,49]),function(ne,t,i,N,z,H,E,k,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ES=t.EventType=void 0;var $;(function(P){P.Tap="-monaco-gesturetap",P.Change="-monaco-gesturechange",P.Start="-monaco-gesturestart",P.End="-monaco-gesturesend",P.Contextmenu="-monaco-gesturecontextmenu"})($||(t.EventType=$={}));class w extends k.$Uc{static{this.a=-.005}static{this.c=700}static{this.r=400}constructor(){super(),this.f=!1,this.g=new b.$5c,this.h=new b.$5c,this.m={},this.j=null,this.n=0,this.B(E.Event.runAndSubscribe(i.onDidRegisterWindow,({window:c,disposables:f})=>{f.add(i.$8Q(c.document,"touchstart",e=>this.s(e),{passive:!1})),f.add(i.$8Q(c.document,"touchend",e=>this.u(c,e))),f.add(i.$8Q(c.document,"touchmove",e=>this.D(e),{passive:!1}))},{window:N.$BQ,disposables:this.q}))}static addTarget(c){if(!w.isTouchDevice())return k.$Uc.None;w.b||(w.b=(0,k.$Nc)(new w));const f=w.b.g.push(c);return(0,k.$Sc)(f)}static ignoreTarget(c){if(!w.isTouchDevice())return k.$Uc.None;w.b||(w.b=(0,k.$Nc)(new w));const f=w.b.h.push(c);return(0,k.$Sc)(f)}static isTouchDevice(){return"ontouchstart"in N.$BQ||navigator.maxTouchPoints>0}dispose(){this.j&&(this.j.dispose(),this.j=null),super.dispose()}s(c){const f=Date.now();this.j&&(this.j.dispose(),this.j=null);for(let e=0,n=c.targetTouches.length;e<n;e++){const h=c.targetTouches.item(e);this.m[h.identifier]={id:h.identifier,initialTarget:h.target,initialTimeStamp:f,initialPageX:h.pageX,initialPageY:h.pageY,rollingTimestamps:[f],rollingPageX:[h.pageX],rollingPageY:[h.pageY]};const m=this.w($.Start,h.target);m.pageX=h.pageX,m.pageY=h.pageY,this.z(m)}this.f&&(c.preventDefault(),c.stopPropagation(),this.f=!1)}u(c,f){const e=Date.now(),n=Object.keys(this.m).length;for(let h=0,m=f.changedTouches.length;h<m;h++){const p=f.changedTouches.item(h);if(!this.m.hasOwnProperty(String(p.identifier))){console.warn("move of an UNKNOWN touch",p);continue}const v=this.m[p.identifier],o=Date.now()-v.initialTimeStamp;if(o<w.c&&Math.abs(v.initialPageX-z.$sb(v.rollingPageX))<30&&Math.abs(v.initialPageY-z.$sb(v.rollingPageY))<30){const g=this.w($.Tap,v.initialTarget);g.pageX=z.$sb(v.rollingPageX),g.pageY=z.$sb(v.rollingPageY),this.z(g)}else if(o>=w.c&&Math.abs(v.initialPageX-z.$sb(v.rollingPageX))<30&&Math.abs(v.initialPageY-z.$sb(v.rollingPageY))<30){const g=this.w($.Contextmenu,v.initialTarget);g.pageX=z.$sb(v.rollingPageX),g.pageY=z.$sb(v.rollingPageY),this.z(g)}else if(n===1){const g=z.$sb(v.rollingPageX),r=z.$sb(v.rollingPageY),B=z.$sb(v.rollingTimestamps)-v.rollingTimestamps[0],C=g-v.rollingPageX[0],L=r-v.rollingPageY[0],M=[...this.g].filter(O=>v.initialTarget instanceof Node&&O.contains(v.initialTarget));this.C(c,M,e,Math.abs(C)/B,C>0?1:-1,g,Math.abs(L)/B,L>0?1:-1,r)}this.z(this.w($.End,v.initialTarget)),delete this.m[p.identifier]}this.f&&(f.preventDefault(),f.stopPropagation(),this.f=!1)}w(c,f){const e=document.createEvent("CustomEvent");return e.initEvent(c,!1,!0),e.initialTarget=f,e.tapCount=0,e}z(c){if(c.type===$.Tap){const f=new Date().getTime();let e=0;f-this.n>w.r?e=1:e=2,this.n=f,c.tapCount=e}else(c.type===$.Change||c.type===$.Contextmenu)&&(this.n=0);if(c.initialTarget instanceof Node){for(const f of this.h)if(f.contains(c.initialTarget))return;for(const f of this.g)f.contains(c.initialTarget)&&(f.dispatchEvent(c),this.f=!0)}}C(c,f,e,n,h,m,p,v,o){this.j=i.$fR(c,()=>{const g=Date.now(),r=g-e;let B=0,C=0,L=!0;n+=w.a*r,p+=w.a*r,n>0&&(L=!1,B=h*n*r),p>0&&(L=!1,C=v*p*r);const M=this.w($.Change);M.translationX=B,M.translationY=C,f.forEach(O=>O.dispatchEvent(M)),L||this.C(c,f,g,n,h,m+B,p,v,o+C)})}D(c){const f=Date.now();for(let e=0,n=c.changedTouches.length;e<n;e++){const h=c.changedTouches.item(e);if(!this.m.hasOwnProperty(String(h.identifier))){console.warn("end of an UNKNOWN touch",h);continue}const m=this.m[h.identifier],p=this.w($.Change,m.initialTarget);p.translationX=h.pageX-z.$sb(m.rollingPageX),p.translationY=h.pageY-z.$sb(m.rollingPageY),p.pageX=h.pageX,p.pageY=h.pageY,this.z(p),m.rollingPageX.length>3&&(m.rollingPageX.shift(),m.rollingPageY.shift(),m.rollingTimestamps.shift()),m.rollingPageX.push(h.pageX),m.rollingPageY.push(h.pageY),m.rollingTimestamps.push(f)}this.f&&(c.preventDefault(),c.stopPropagation(),this.f=!1)}}t.$ES=w,Ze([H.$Lh],w,"isTouchDevice",null)}),define(be[60],$e([1,0,2,96]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$aT=$,t.$bT=w,t.$cT=P;const N=2e4;let z,H,E,k,b;function $(f){z=document.createElement("div"),z.className="monaco-aria-container";const e=()=>{const h=document.createElement("div");return h.className="monaco-alert",h.setAttribute("role","alert"),h.setAttribute("aria-atomic","true"),z.appendChild(h),h};H=e(),E=e();const n=()=>{const h=document.createElement("div");return h.className="monaco-status",h.setAttribute("aria-live","polite"),h.setAttribute("aria-atomic","true"),z.appendChild(h),h};k=n(),b=n(),f.appendChild(z)}function w(f){z&&(H.textContent!==f?(i.$7Q(E),c(H,f)):(i.$7Q(H),c(E,f)))}function P(f){z&&(k.textContent!==f?(i.$7Q(b),c(k,f)):(i.$7Q(k),c(b,f)))}function c(f,e){i.$7Q(f),e.length>N&&(e=e.substr(0,N)),f.textContent=e,f.style.visibility="hidden",f.style.visibility="visible"}}),define(be[123],$e([1,0,2,19]),function(ne,t,i,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$FT=H,t.$GT=E;const z=new RegExp(`(\\\\)?\\$\\((${N.ThemeIcon.iconNameExpression}(?:${N.ThemeIcon.iconModifierExpression})?)\\)`,"g");function H(k){const b=new Array;let $,w=0,P=0;for(;($=z.exec(k))!==null;){P=$.index||0,w<P&&b.push(k.substring(w,P)),w=($.index||0)+$[0].length;const[,c,f]=$;b.push(c?`$(${f})`:E({id:f}))}return w<k.length&&b.push(k.substring(w)),b}function E(k){const b=i.$("span");return b.classList.add(...N.ThemeIcon.asClassNameArray(k)),b}}),define(be[124],$e([1,0,2]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$iT=void 0;function N(H){try{H.parentElement?.removeChild(H)}catch{}}class z{constructor(E){this.d=E,this.a=new Map,this.b=new Set,this.c=!1}alloc(E){let k=this.h(E).pop(),b=!1;if(k)b=this.b.has(k.domNode),b&&this.b.delete(k.domNode);else{const $=(0,i.$)(".monaco-list-row"),P=this.i(E).renderTemplate($);k={domNode:$,templateId:E,templateData:P}}return{row:k,isReusingConnectedDomNode:b}}release(E){E&&this.f(E)}transact(E){if(this.c)throw new Error("Already in transaction");this.c=!0;try{E()}finally{for(const k of this.b)this.g(k);this.b.clear(),this.c=!1}}f(E){const{domNode:k,templateId:b}=E;k&&(this.c?this.b.add(k):this.g(k)),this.h(b).push(E)}g(E){E.classList.remove("scrolling"),N(E)}h(E){let k=this.a.get(E);return k||(k=[],this.a.set(E,k)),k}dispose(){this.a.forEach((E,k)=>{for(const b of E)this.i(k).disposeTemplate(b.templateData),b.templateData=null}),this.a.clear(),this.b.clear()}i(E){const k=this.d.get(E);if(!k)throw new Error(`No renderer found for ${E}`);return k}}t.$iT=z}),define(be[125],$e([1,0,9,3]),function(ne,t,i,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$MS=void 0;class z extends N.$Uc{constructor(E,k,b){super(),this.a=E,this.b=k,this.c=b,this.f=null,this.m=!1,this.j=!1,this.g=!1,this.h=!1,this.n=this.B(new i.$rh)}setVisibility(E){this.a!==E&&(this.a=E,this.s())}setShouldBeVisible(E){this.g=E,this.s()}r(){return this.a===2?!1:this.a===3?!0:this.g}s(){const E=this.r();this.h!==E&&(this.h=E,this.ensureVisibility())}setIsNeeded(E){this.j!==E&&(this.j=E,this.ensureVisibility())}setDomNode(E){this.f=E,this.f.setClassName(this.c),this.setShouldBeVisible(!1)}ensureVisibility(){if(!this.j){this.u(!1);return}this.h?this.t():this.u(!0)}t(){this.m||(this.m=!0,this.n.setIfNotSet(()=>{this.f?.setClassName(this.b)},0))}u(E){this.n.cancel(),this.m&&(this.m=!1,this.f?.setClassName(this.c+(E?" fade":"")))}}t.$MS=z}),define(be[126],$e([1,0,2,26,12,4,3,5]),function(ne,t,i,N,z,H,E,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$NT=void 0;class b extends E.$Uc{constructor(w,P,c,f){super(),this.f=0,this.b=f||Object.create(null),this.c=[],this.a=document.createElement("select"),this.a.className="monaco-select-box",typeof this.b.ariaLabel=="string"&&this.a.setAttribute("aria-label",this.b.ariaLabel),typeof this.b.ariaDescription=="string"&&this.a.setAttribute("aria-description",this.b.ariaDescription),this.g=this.B(new H.$7d),this.h=c,this.j(),this.setOptions(w,P)}j(){this.B(N.$ES.addTarget(this.a)),[N.EventType.Tap].forEach(w=>{this.B(i.$8Q(this.a,w,P=>{this.a.focus()}))}),this.B(i.$9Q(this.a,"click",w=>{i.$3R.stop(w,!0)})),this.B(i.$9Q(this.a,"change",w=>{this.a.title=w.target.value,this.g.fire({index:w.target.selectedIndex,selected:w.target.value})})),this.B(i.$9Q(this.a,"keydown",w=>{let P=!1;k.$j?(w.keyCode===18||w.keyCode===16||w.keyCode===10)&&(P=!0):(w.keyCode===18&&w.altKey||w.keyCode===10||w.keyCode===3)&&(P=!0),P&&w.stopPropagation()}))}get onDidSelect(){return this.g.event}setOptions(w,P){(!this.c||!z.$ub(this.c,w))&&(this.c=w,this.a.options.length=0,this.c.forEach((c,f)=>{this.a.add(this.m(c.text,f,c.isDisabled))})),P!==void 0&&this.select(P)}select(w){this.c.length===0?this.f=0:w>=0&&w<this.c.length?this.f=w:w>this.c.length-1?this.select(this.c.length-1):this.f<0&&(this.f=0),this.a.selectedIndex=this.f,this.f<this.c.length&&typeof this.c[this.f].text=="string"?this.a.title=this.c[this.f].text:this.a.title=""}setAriaLabel(w){this.b.ariaLabel=w,this.a.setAttribute("aria-label",w)}focus(){this.a&&(this.a.tabIndex=0,this.a.focus())}blur(){this.a&&(this.a.tabIndex=-1,this.a.blur())}setFocusable(w){this.a.tabIndex=w?0:-1}render(w){w.classList.add("select-container"),w.appendChild(this.a),this.setOptions(this.c,this.f),this.applyStyles()}style(w){this.h=w,this.applyStyles()}applyStyles(){this.a&&(this.a.style.backgroundColor=this.h.selectBackground??"",this.a.style.color=this.h.selectForeground??"",this.a.style.borderColor=this.h.selectBorder??"")}m(w,P,c){const f=document.createElement("option");return f.value=w,f.text=w,f.disabled=!!c,f}}t.$NT=b}),define(be[61],$e([1,0,27,12,9,53,90,4,29]),function(ne,t,i,N,z,H,E,k,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$kV=void 0,t.$iV=$,t.$jV=w;function $(f){return typeof f=="object"&&"visibility"in f&&"data"in f}function w(f){switch(f){case!0:return 1;case!1:return 0;default:return f}}function P(f){return typeof f.collapsible=="boolean"}class c{constructor(e,n,h,m={}){this.p=e,this.q=n,this.rootRef=[],this.d=new k.$ce,this.f=new k.$7d,this.onDidChangeCollapseState=this.d.wrapEvent(this.f.event),this.g=new k.$7d,this.onDidChangeRenderNodeCount=this.d.wrapEvent(this.g.event),this.m=new k.$7d,this.onDidSplice=this.m.event,this.o=new z.$eh(H.$4d),this.h=typeof m.collapseByDefault>"u"?!1:m.collapseByDefault,this.j=m.allowNonCollapsibleParents??!1,this.k=m.filter,this.l=typeof m.autoExpandSingleChildren>"u"?!1:m.autoExpandSingleChildren,this.c={parent:void 0,element:h,children:[],depth:0,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:!1,collapsed:!1,renderNodeCount:0,visibility:1,visible:!0,filterData:void 0}}splice(e,n,h=b.Iterable.empty(),m={}){if(e.length===0)throw new i.$gV(this.p,"Invalid tree location");m.diffIdentityProvider?this.s(m.diffIdentityProvider,e,n,h,m):this.t(e,n,h,m)}s(e,n,h,m=b.Iterable.empty(),p,v=p.diffDepth??0){const{parentNode:o}=this.H(n);if(!o.lastDiffIds)return this.t(n,h,m,p);const g=[...m],r=n[n.length-1],B=new E.$ht({getElements:()=>o.lastDiffIds},{getElements:()=>[...o.children.slice(0,r),...g,...o.children.slice(r+h)].map(y=>e.getId(y.element).toString())}).ComputeDiff(!1);if(B.quitEarly)return o.lastDiffIds=void 0,this.t(n,h,g,p);const C=n.slice(0,-1),L=(y,x,q)=>{if(v>0)for(let I=0;I<q;I++)y--,x--,this.s(e,[...C,y,0],Number.MAX_SAFE_INTEGER,g[x].children,p,v-1)};let M=Math.min(o.children.length,r+h),O=g.length;for(const y of B.changes.sort((x,q)=>q.originalStart-x.originalStart))L(M,O,M-(y.originalStart+y.originalLength)),M=y.originalStart,O=y.modifiedStart-r,this.t([...C,M],y.originalLength,b.Iterable.slice(g,O,O+y.modifiedLength),p);L(M,O,M)}t(e,n,h=b.Iterable.empty(),{onDidCreateNode:m,onDidDeleteNode:p,diffIdentityProvider:v}){const{parentNode:o,listIndex:g,revealed:r,visible:B}=this.H(e),C=[],L=b.Iterable.map(h,Q=>this.x(Q,o,o.visible?1:0,r,C,m)),M=e[e.length-1];let O=0;for(let Q=M;Q>=0&&Q<o.children.length;Q--){const Z=o.children[Q];if(Z.visible){O=Z.visibleChildIndex;break}}const y=[];let x=0,q=0;for(const Q of L)y.push(Q),q+=Q.renderNodeCount,Q.visible&&(Q.visibleChildIndex=O+x++);const I=(0,N.$6b)(o.children,M,n,y);v?o.lastDiffIds?(0,N.$6b)(o.lastDiffIds,M,n,y.map(Q=>v.getId(Q.element).toString())):o.lastDiffIds=o.children.map(Q=>v.getId(Q.element).toString()):o.lastDiffIds=void 0;let j=0;for(const Q of I)Q.visible&&j++;if(j!==0)for(let Q=M+y.length;Q<o.children.length;Q++){const Z=o.children[Q];Z.visible&&(Z.visibleChildIndex-=j)}if(o.visibleChildrenCount+=x-j,r&&B){const Q=I.reduce((Z,ce)=>Z+(ce.visible?ce.renderNodeCount:0),0);this.C(o,q-Q),this.q.splice(g,Q,C)}if(I.length>0&&p){const Q=Z=>{p(Z),Z.children.forEach(Q)};I.forEach(Q)}this.m.fire({insertedNodes:y,deletedNodes:I});let T=o;for(;T;){if(T.visibility===2){this.o.trigger(()=>this.refilter());break}T=T.parent}}rerender(e){if(e.length===0)throw new i.$gV(this.p,"Invalid tree location");const{node:n,listIndex:h,revealed:m}=this.G(e);n.visible&&m&&this.q.splice(h,1,[n])}updateElementHeight(e,n){if(e.length===0)throw new i.$gV(this.p,"Invalid tree location");const{listIndex:h}=this.G(e);this.q.updateElementHeight(h,n)}has(e){return this.E(e)}getListIndex(e){const{listIndex:n,visible:h,revealed:m}=this.G(e);return h&&m?n:-1}getListRenderCount(e){return this.F(e).renderNodeCount}isCollapsible(e){return this.F(e).collapsible}setCollapsible(e,n){const h=this.F(e);typeof n>"u"&&(n=!h.collapsible);const m={collapsible:n};return this.d.bufferEvents(()=>this.u(e,m))}isCollapsed(e){return this.F(e).collapsed}setCollapsed(e,n,h){const m=this.F(e);typeof n>"u"&&(n=!m.collapsed);const p={collapsed:n,recursive:h||!1};return this.d.bufferEvents(()=>this.u(e,p))}u(e,n){const{node:h,listIndex:m,revealed:p}=this.G(e),v=this.v(h,m,p,n);if(h!==this.c&&this.l&&v&&!P(n)&&h.collapsible&&!h.collapsed&&!n.recursive){let o=-1;for(let g=0;g<h.children.length;g++)if(h.children[g].visible)if(o>-1){o=-1;break}else o=g;o>-1&&this.u([...e,o],n)}return v}v(e,n,h,m){const p=this.w(e,m,!1);if(!h||!e.visible||!p)return p;const v=e.renderNodeCount,o=this.y(e),g=v-(n===-1?0:1);return this.q.splice(n+1,g,o.slice(1)),p}w(e,n,h){let m;if(e===this.c?m=!1:(P(n)?(m=e.collapsible!==n.collapsible,e.collapsible=n.collapsible):e.collapsible?(m=e.collapsed!==n.collapsed,e.collapsed=n.collapsed):m=!1,m&&this.f.fire({node:e,deep:h})),!P(n)&&n.recursive)for(const p of e.children)m=this.w(p,n,!0)||m;return m}expandTo(e){this.d.bufferEvents(()=>{let n=this.F(e);for(;n.parent;)n=n.parent,e=e.slice(0,e.length-1),n.collapsed&&this.u(e,{collapsed:!1,recursive:!1})})}refilter(){const e=this.c.renderNodeCount,n=this.A(this.c);this.q.splice(0,e,n),this.o.cancel()}x(e,n,h,m,p,v){const o={parent:n,element:e.element,children:[],depth:n.depth+1,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:typeof e.collapsible=="boolean"?e.collapsible:typeof e.collapsed<"u",collapsed:typeof e.collapsed>"u"?this.h:e.collapsed,renderNodeCount:1,visibility:1,visible:!0,filterData:void 0},g=this.D(o,h);o.visibility=g,m&&p.push(o);const r=e.children||b.Iterable.empty(),B=m&&g!==0&&!o.collapsed;let C=0,L=1;for(const M of r){const O=this.x(M,o,g,B,p,v);o.children.push(O),L+=O.renderNodeCount,O.visible&&(O.visibleChildIndex=C++)}return this.j||(o.collapsible=o.collapsible||o.children.length>0),o.visibleChildrenCount=C,o.visible=g===2?C>0:g===1,o.visible?o.collapsed||(o.renderNodeCount=L):(o.renderNodeCount=0,m&&p.pop()),v?.(o),o}y(e){const n=e.renderNodeCount,h=[];return this.z(e,h),this.C(e.parent,h.length-n),h}z(e,n){if(e.visible===!1)return 0;if(n.push(e),e.renderNodeCount=1,!e.collapsed)for(const h of e.children)e.renderNodeCount+=this.z(h,n);return this.g.fire(e),e.renderNodeCount}A(e){const n=e.renderNodeCount,h=[];return this.B(e,e.visible?1:0,h),this.C(e.parent,h.length-n),h}B(e,n,h,m=!0){let p;if(e!==this.c){if(p=this.D(e,n),p===0)return e.visible=!1,e.renderNodeCount=0,!1;m&&h.push(e)}const v=h.length;e.renderNodeCount=e===this.c?0:1;let o=!1;if(!e.collapsed||p!==0){let g=0;for(const r of e.children)o=this.B(r,p,h,m&&!e.collapsed)||o,r.visible&&(r.visibleChildIndex=g++);e.visibleChildrenCount=g}else e.visibleChildrenCount=0;return e!==this.c&&(e.visible=p===2?o:p===1,e.visibility=p),e.visible?e.collapsed||(e.renderNodeCount+=h.length-v):(e.renderNodeCount=0,m&&h.pop()),this.g.fire(e),e.visible}C(e,n){if(n!==0)for(;e;)e.renderNodeCount+=n,this.g.fire(e),e=e.parent}D(e,n){const h=this.k?this.k.filter(e.element,n):1;return typeof h=="boolean"?(e.filterData=void 0,h?1:0):$(h)?(e.filterData=h.data,w(h.visibility)):(e.filterData=void 0,w(h))}E(e,n=this.c){if(!e||e.length===0)return!0;const[h,...m]=e;return h<0||h>n.children.length?!1:this.E(m,n.children[h])}F(e,n=this.c){if(!e||e.length===0)return n;const[h,...m]=e;if(h<0||h>n.children.length)throw new i.$gV(this.p,"Invalid tree location");return this.F(m,n.children[h])}G(e){if(e.length===0)return{node:this.c,listIndex:-1,revealed:!0,visible:!1};const{parentNode:n,listIndex:h,revealed:m,visible:p}=this.H(e),v=e[e.length-1];if(v<0||v>n.children.length)throw new i.$gV(this.p,"Invalid tree location");const o=n.children[v];return{node:o,listIndex:h,revealed:m,visible:p&&o.visible}}H(e,n=this.c,h=0,m=!0,p=!0){const[v,...o]=e;if(v<0||v>n.children.length)throw new i.$gV(this.p,"Invalid tree location");for(let g=0;g<v;g++)h+=n.children[g].renderNodeCount;return m=m&&!n.collapsed,p=p&&n.visible,o.length===0?{parentNode:n,listIndex:h,revealed:m,visible:p}:this.H(o,n.children[v],h+1,m,p)}getNode(e=[]){return this.F(e)}getNodeLocation(e){const n=[];let h=e;for(;h.parent;)n.push(h.parent.children.indexOf(h)),h=h.parent;return n.reverse()}getParentNodeLocation(e){if(e.length!==0)return e.length===1?[]:(0,N.$tb)(e)[0]}getFirstElementChild(e){const n=this.F(e);if(n.children.length!==0)return n.children[0].element}getLastElementAncestor(e=[]){const n=this.F(e);if(n.children.length!==0)return this.I(n)}I(e){return e.children.length===0?e.element:this.I(e.children[e.children.length-1])}}t.$kV=c}),define(be[127],$e([1,0,61,27,29]),function(ne,t,i,N,z){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$rV=void 0;class H{get size(){return this.d.size}constructor(k,b,$={}){this.k=k,this.rootRef=null,this.d=new Map,this.f=new Map,this.c=new i.$kV(k,b,null,$),this.onDidSplice=this.c.onDidSplice,this.onDidChangeCollapseState=this.c.onDidChangeCollapseState,this.onDidChangeRenderNodeCount=this.c.onDidChangeRenderNodeCount,$.sorter&&(this.j={compare(w,P){return $.sorter.compare(w.element,P.element)}}),this.h=$.identityProvider}setChildren(k,b=z.Iterable.empty(),$={}){const w=this.o(k);this.l(w,this.m(b),$)}l(k,b=z.Iterable.empty(),$){const w=new Set,P=new Set,c=e=>{if(e.element===null)return;const n=e;if(w.add(n.element),this.d.set(n.element,n),this.h){const h=this.h.getId(n.element).toString();P.add(h),this.f.set(h,n)}$.onDidCreateNode?.(n)},f=e=>{if(e.element===null)return;const n=e;if(w.has(n.element)||this.d.delete(n.element),this.h){const h=this.h.getId(n.element).toString();P.has(h)||this.f.delete(h)}$.onDidDeleteNode?.(n)};this.c.splice([...k,0],Number.MAX_VALUE,b,{...$,onDidCreateNode:c,onDidDeleteNode:f})}m(k=z.Iterable.empty()){return this.j&&(k=[...k].sort(this.j.compare.bind(this.j))),z.Iterable.map(k,b=>{let $=this.d.get(b.element);if(!$&&this.h){const c=this.h.getId(b.element).toString();$=this.f.get(c)}if(!$){let c;return typeof b.collapsed>"u"?c=void 0:b.collapsed===N.ObjectTreeElementCollapseState.Collapsed||b.collapsed===N.ObjectTreeElementCollapseState.PreserveOrCollapsed?c=!0:b.collapsed===N.ObjectTreeElementCollapseState.Expanded||b.collapsed===N.ObjectTreeElementCollapseState.PreserveOrExpanded?c=!1:c=!!b.collapsed,{...b,children:this.m(b.children),collapsed:c}}const w=typeof b.collapsible=="boolean"?b.collapsible:$.collapsible;let P;return typeof b.collapsed>"u"||b.collapsed===N.ObjectTreeElementCollapseState.PreserveOrCollapsed||b.collapsed===N.ObjectTreeElementCollapseState.PreserveOrExpanded?P=$.collapsed:b.collapsed===N.ObjectTreeElementCollapseState.Collapsed?P=!0:b.collapsed===N.ObjectTreeElementCollapseState.Expanded?P=!1:P=!!b.collapsed,{...b,collapsible:w,collapsed:P,children:this.m(b.children)}})}rerender(k){const b=this.o(k);this.c.rerender(b)}updateElementHeight(k,b){const $=this.o(k);this.c.updateElementHeight($,b)}resort(k=null,b=!0){if(!this.j)return;const $=this.o(k),w=this.c.getNode($);this.l($,this.n(w,b),{})}n(k,b,$=!0){let w=[...k.children];return(b||$)&&(w=w.sort(this.j.compare.bind(this.j))),z.Iterable.map(w,P=>({element:P.element,collapsible:P.collapsible,collapsed:P.collapsed,children:this.n(P,b,!1)}))}getFirstElementChild(k=null){const b=this.o(k);return this.c.getFirstElementChild(b)}getLastElementAncestor(k=null){const b=this.o(k);return this.c.getLastElementAncestor(b)}has(k){return this.d.has(k)}getListIndex(k){const b=this.o(k);return this.c.getListIndex(b)}getListRenderCount(k){const b=this.o(k);return this.c.getListRenderCount(b)}isCollapsible(k){const b=this.o(k);return this.c.isCollapsible(b)}setCollapsible(k,b){const $=this.o(k);return this.c.setCollapsible($,b)}isCollapsed(k){const b=this.o(k);return this.c.isCollapsed(b)}setCollapsed(k,b,$){const w=this.o(k);return this.c.setCollapsed(w,b,$)}expandTo(k){const b=this.o(k);this.c.expandTo(b)}refilter(){this.c.refilter()}getNode(k=null){if(k===null)return this.c.getNode(this.c.rootRef);const b=this.d.get(k);if(!b)throw new N.$gV(this.k,`Tree element not found: ${k}`);return b}getNodeLocation(k){return k.element}getParentNodeLocation(k){if(k===null)throw new N.$gV(this.k,"Invalid getParentNodeLocation call");const b=this.d.get(k);if(!b)throw new N.$gV(this.k,`Tree element not found: ${k}`);const $=this.c.getNodeLocation(b),w=this.c.getParentNodeLocation($);return this.c.getNode(w).element}o(k){if(k===null)return[];const b=this.d.get(k);if(!b)throw new N.$gV(this.k,`Tree element not found: ${k}`);return this.c.getNodeLocation(b)}}t.$rV=H}),define(be[21],$e([1,0,2,15,20,26,3]),function(ne,t,i,N,z,H,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$IS=void 0;class k extends E.$Uc{f($,w){this.B(i.$8Q($,i.$1R.CLICK,P=>w(new z.$ZQ(i.getWindow($),P))))}j($,w){this.B(i.$8Q($,i.$1R.MOUSE_DOWN,P=>w(new z.$ZQ(i.getWindow($),P))))}m($,w){this.B(i.$8Q($,i.$1R.MOUSE_OVER,P=>w(new z.$ZQ(i.getWindow($),P))))}u($,w){this.B(i.$8Q($,i.$1R.MOUSE_LEAVE,P=>w(new z.$ZQ(i.getWindow($),P))))}z($,w){this.B(i.$8Q($,i.$1R.KEY_DOWN,P=>w(new N.$5Q(P))))}C($,w){this.B(i.$8Q($,i.$1R.KEY_UP,P=>w(new N.$5Q(P))))}D($,w){this.B(i.$8Q($,i.$1R.INPUT,w))}F($,w){this.B(i.$8Q($,i.$1R.BLUR,w))}G($,w){this.B(i.$8Q($,i.$1R.FOCUS,w))}H($,w){this.B(i.$8Q($,i.$1R.CHANGE,w))}I($){return H.$ES.ignoreTarget($)}}t.$IS=k}),define(be[42],$e([1,0,59,21,9,19,2]),function(ne,t,i,N,z,H,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$KS=t.$JS=void 0,t.$JS=11;class k extends N.$IS{constructor($){super(),this.a=$.onActivate,this.bgDomNode=document.createElement("div"),this.bgDomNode.className="arrow-background",this.bgDomNode.style.position="absolute",this.bgDomNode.style.width=$.bgWidth+"px",this.bgDomNode.style.height=$.bgHeight+"px",typeof $.top<"u"&&(this.bgDomNode.style.top="0px"),typeof $.left<"u"&&(this.bgDomNode.style.left="0px"),typeof $.bottom<"u"&&(this.bgDomNode.style.bottom="0px"),typeof $.right<"u"&&(this.bgDomNode.style.right="0px"),this.domNode=document.createElement("div"),this.domNode.className=$.className,this.domNode.classList.add(...H.ThemeIcon.asClassNameArray($.icon)),this.domNode.style.position="absolute",this.domNode.style.width=t.$JS+"px",this.domNode.style.height=t.$JS+"px",typeof $.top<"u"&&(this.domNode.style.top=$.top+"px"),typeof $.left<"u"&&(this.domNode.style.left=$.left+"px"),typeof $.bottom<"u"&&(this.domNode.style.bottom=$.bottom+"px"),typeof $.right<"u"&&(this.domNode.style.right=$.right+"px"),this.g=this.B(new i.$HS),this.B(E.$9Q(this.bgDomNode,E.$1R.POINTER_DOWN,w=>this.h(w))),this.B(E.$9Q(this.domNode,E.$1R.POINTER_DOWN,w=>this.h(w))),this.b=this.B(new E.$hR),this.c=this.B(new z.$rh)}h($){if(!$.target||!($.target instanceof Element))return;const w=()=>{this.b.cancelAndSet(()=>this.a(),1e3/24,E.getWindow($))};this.a(),this.b.cancel(),this.c.cancelAndSet(w,200),this.g.startMonitoring($.target,$.pointerId,$.buttons,P=>{},()=>{this.b.cancel(),this.c.cancel()}),$.preventDefault()}}t.$KS=k}),define(be[62],$e([1,0,2,45,59,42,125,21,5]),function(ne,t,i,N,z,H,E,k,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$NS=void 0;const $=140;class w extends k.$IS{constructor(c){super(),this.g=c.lazyRender,this.a=c.host,this.b=c.scrollable,this.c=c.scrollByPage,this.h=c.scrollbarState,this.n=this.B(new E.$MS(c.visibility,"visible scrollbar "+c.extraScrollbarClassName,"invisible scrollbar "+c.extraScrollbarClassName)),this.n.setIsNeeded(this.h.isNeeded()),this.r=this.B(new z.$HS),this.s=!0,this.domNode=(0,N.$GS)(document.createElement("div")),this.domNode.setAttribute("role","presentation"),this.domNode.setAttribute("aria-hidden","true"),this.n.setDomNode(this.domNode),this.domNode.setPosition("absolute"),this.B(i.$8Q(this.domNode.domNode,i.$1R.POINTER_DOWN,f=>this.M(f)))}t(c){const f=this.B(new H.$KS(c));this.domNode.domNode.appendChild(f.bgDomNode),this.domNode.domNode.appendChild(f.domNode)}w(c,f,e,n){this.slider=(0,N.$GS)(document.createElement("div")),this.slider.setClassName("slider"),this.slider.setPosition("absolute"),this.slider.setTop(c),this.slider.setLeft(f),typeof e=="number"&&this.slider.setWidth(e),typeof n=="number"&&this.slider.setHeight(n),this.slider.setLayerHinting(!0),this.slider.setContain("strict"),this.domNode.domNode.appendChild(this.slider.domNode),this.B(i.$8Q(this.slider.domNode,i.$1R.POINTER_DOWN,h=>{h.button===0&&(h.preventDefault(),this.O(h))})),this.f(this.slider.domNode,h=>{h.leftButton&&h.stopPropagation()})}y(c){return this.h.setVisibleSize(c)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}J(c){return this.h.setScrollSize(c)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}L(c){return this.h.setScrollPosition(c)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}beginReveal(){this.n.setShouldBeVisible(!0)}beginHide(){this.n.setShouldBeVisible(!1)}render(){this.s&&(this.s=!1,this.Q(this.h.getRectangleLargeSize(),this.h.getRectangleSmallSize()),this.R(this.h.getSliderSize(),this.h.getArrowSize()+this.h.getSliderPosition()))}M(c){c.target===this.domNode.domNode&&this.N(c)}delegatePointerDown(c){const f=this.domNode.domNode.getClientRects()[0].top,e=f+this.h.getSliderPosition(),n=f+this.h.getSliderPosition()+this.h.getSliderSize(),h=this.U(c);e<=h&&h<=n?c.button===0&&(c.preventDefault(),this.O(c)):this.N(c)}N(c){let f,e;if(c.target===this.domNode.domNode&&typeof c.offsetX=="number"&&typeof c.offsetY=="number")f=c.offsetX,e=c.offsetY;else{const h=i.$rR(this.domNode.domNode);f=c.pageX-h.left,e=c.pageY-h.top}const n=this.S(f,e);this.P(this.c?this.h.getDesiredScrollPositionFromOffsetPaged(n):this.h.getDesiredScrollPositionFromOffset(n)),c.button===0&&(c.preventDefault(),this.O(c))}O(c){if(!c.target||!(c.target instanceof Element))return;const f=this.U(c),e=this.W(c),n=this.h.clone();this.slider.toggleClassName("active",!0),this.r.startMonitoring(c.target,c.pointerId,c.buttons,h=>{const m=this.W(h),p=Math.abs(m-e);if(b.$i&&p>$){this.P(n.getScrollPosition());return}const o=this.U(h)-f;this.P(n.getDesiredScrollPositionFromDelta(o))},()=>{this.slider.toggleClassName("active",!1),this.a.onDragEnd()}),this.a.onDragStart()}P(c){const f={};this.writeScrollPosition(f,c),this.b.setScrollPositionNow(f)}updateScrollbarSize(c){this.X(c),this.h.setScrollbarSize(c),this.s=!0,this.g||this.render()}isNeeded(){return this.h.isNeeded()}}t.$NS=w}),define(be[128],$e([1,0,20,62,42,46,18]),function(ne,t,i,N,z,H,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$OS=void 0;class k extends N.$NS{constructor($,w,P){const c=$.getScrollDimensions(),f=$.getCurrentScrollPosition();if(super({lazyRender:w.lazyRender,host:P,scrollbarState:new H.$LS(w.horizontalHasArrows?w.arrowSize:0,w.horizontal===2?0:w.horizontalScrollbarSize,w.vertical===2?0:w.verticalScrollbarSize,c.width,c.scrollWidth,f.scrollLeft),visibility:w.horizontal,extraScrollbarClassName:"horizontal",scrollable:$,scrollByPage:w.scrollByPage}),w.horizontalHasArrows){const e=(w.arrowSize-z.$JS)/2,n=(w.horizontalScrollbarSize-z.$JS)/2;this.t({className:"scra",icon:E.$Gj.scrollbarButtonLeft,top:n,left:e,bottom:void 0,right:void 0,bgWidth:w.arrowSize,bgHeight:w.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new i.$2Q(null,1,0))}),this.t({className:"scra",icon:E.$Gj.scrollbarButtonRight,top:n,left:void 0,bottom:void 0,right:e,bgWidth:w.arrowSize,bgHeight:w.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new i.$2Q(null,-1,0))})}this.w(Math.floor((w.horizontalScrollbarSize-w.horizontalSliderSize)/2),0,void 0,w.horizontalSliderSize)}R($,w){this.slider.setWidth($),this.slider.setLeft(w)}Q($,w){this.domNode.setWidth($),this.domNode.setHeight(w),this.domNode.setLeft(0),this.domNode.setBottom(0)}onDidScroll($){return this.s=this.J($.scrollWidth)||this.s,this.s=this.L($.scrollLeft)||this.s,this.s=this.y($.width)||this.s,this.s}S($,w){return $}U($){return $.pageX}W($){return $.pageY}X($){this.slider.setHeight($)}writeScrollPosition($,w){$.scrollLeft=w}updateOptions($){this.updateScrollbarSize($.horizontal===2?0:$.horizontalScrollbarSize),this.h.setOppositeScrollbarSize($.vertical===2?0:$.verticalScrollbarSize),this.n.setVisibility($.horizontal),this.c=$.scrollByPage}}t.$OS=k}),define(be[129],$e([1,0,20,62,42,46,18]),function(ne,t,i,N,z,H,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$PS=void 0;class k extends N.$NS{constructor($,w,P){const c=$.getScrollDimensions(),f=$.getCurrentScrollPosition();if(super({lazyRender:w.lazyRender,host:P,scrollbarState:new H.$LS(w.verticalHasArrows?w.arrowSize:0,w.vertical===2?0:w.verticalScrollbarSize,0,c.height,c.scrollHeight,f.scrollTop),visibility:w.vertical,extraScrollbarClassName:"vertical",scrollable:$,scrollByPage:w.scrollByPage}),w.verticalHasArrows){const e=(w.arrowSize-z.$JS)/2,n=(w.verticalScrollbarSize-z.$JS)/2;this.t({className:"scra",icon:E.$Gj.scrollbarButtonUp,top:e,left:n,bottom:void 0,right:void 0,bgWidth:w.verticalScrollbarSize,bgHeight:w.arrowSize,onActivate:()=>this.a.onMouseWheel(new i.$2Q(null,0,1))}),this.t({className:"scra",icon:E.$Gj.scrollbarButtonDown,top:void 0,left:n,bottom:e,right:void 0,bgWidth:w.verticalScrollbarSize,bgHeight:w.arrowSize,onActivate:()=>this.a.onMouseWheel(new i.$2Q(null,0,-1))})}this.w(0,Math.floor((w.verticalScrollbarSize-w.verticalSliderSize)/2),w.verticalSliderSize,void 0)}R($,w){this.slider.setHeight($),this.slider.setTop(w)}Q($,w){this.domNode.setWidth(w),this.domNode.setHeight($),this.domNode.setRight(0),this.domNode.setTop(0)}onDidScroll($){return this.s=this.J($.scrollHeight)||this.s,this.s=this.L($.scrollTop)||this.s,this.s=this.y($.height)||this.s,this.s}S($,w){return w}U($){return $.pageY}W($){return $.pageX}X($){this.slider.setWidth($)}writeScrollPosition($,w){$.scrollTop=w}updateOptions($){this.updateScrollbarSize($.vertical===2?0:$.verticalScrollbarSize),this.h.setOppositeScrollbarSize(0),this.n.setVisibility($.vertical),this.c=$.scrollByPage}}t.$PS=k}),define(be[63],$e([1,0,17,2,45,20,128,129,21,9,4,3,5,51,103]),function(ne,t,i,N,z,H,E,k,b,$,w,P,c,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$US=t.$TS=t.$SS=t.$RS=t.$QS=void 0;const e=500,n=50,h=!0;class m{constructor(L,M,O){this.timestamp=L,this.deltaX=M,this.deltaY=O,this.score=0}}class p{static{this.INSTANCE=new p}constructor(){this.a=5,this.b=[],this.c=-1,this.d=-1}isPhysicalMouseWheel(){if(this.c===-1&&this.d===-1)return!1;let L=1,M=0,O=1,y=this.d;do{const x=y===this.c?L:Math.pow(2,-O);if(L-=x,M+=this.b[y].score*x,y===this.c)break;y=(this.a+y-1)%this.a,O++}while(!0);return M<=.5}acceptStandardWheelEvent(L){if(i.$PQ){const M=N.getWindow(L.browserEvent),O=(0,i.$IQ)(M);this.accept(Date.now(),L.deltaX*O,L.deltaY*O)}else this.accept(Date.now(),L.deltaX,L.deltaY)}accept(L,M,O){let y=null;const x=new m(L,M,O);this.c===-1&&this.d===-1?(this.b[0]=x,this.c=0,this.d=0):(y=this.b[this.d],this.d=(this.d+1)%this.a,this.d===this.c&&(this.c=(this.c+1)%this.a),this.b[this.d]=x),x.score=this.f(x,y)}f(L,M){if(Math.abs(L.deltaX)>0&&Math.abs(L.deltaY)>0)return 1;let O=.5;if((!this.g(L.deltaX)||!this.g(L.deltaY))&&(O+=.25),M){const y=Math.abs(L.deltaX),x=Math.abs(L.deltaY),q=Math.abs(M.deltaX),I=Math.abs(M.deltaY),j=Math.max(Math.min(y,q),1),T=Math.max(Math.min(x,I),1),Q=Math.max(y,q),Z=Math.max(x,I);Q%j===0&&Z%T===0&&(O-=.5)}return Math.min(Math.max(O,0),1)}g(L){return Math.abs(Math.round(L)-L)<.01}}t.$QS=p;class v extends b.$IS{get options(){return this.a}constructor(L,M,O){super(),this.O=this.B(new w.$7d),this.onScroll=this.O.event,this.P=this.B(new w.$7d),this.onWillScroll=this.P.event,L.style.overflow="hidden",this.a=B(M),this.b=O,this.B(this.b.onScroll(x=>{this.P.fire(x),this.S(x),this.O.fire(x)}));const y={onMouseWheel:x=>this.R(x),onDragStart:()=>this.W(),onDragEnd:()=>this.X()};this.c=this.B(new k.$PS(this.b,this.a,y)),this.g=this.B(new E.$OS(this.b,this.a,y)),this.h=document.createElement("div"),this.h.className="monaco-scrollable-element "+this.a.className,this.h.setAttribute("role","presentation"),this.h.style.position="relative",this.h.style.overflow="hidden",this.h.appendChild(L),this.h.appendChild(this.g.domNode.domNode),this.h.appendChild(this.c.domNode.domNode),this.a.useShadows?(this.n=(0,z.$GS)(document.createElement("div")),this.n.setClassName("shadow"),this.h.appendChild(this.n.domNode),this.r=(0,z.$GS)(document.createElement("div")),this.r.setClassName("shadow"),this.h.appendChild(this.r.domNode),this.s=(0,z.$GS)(document.createElement("div")),this.s.setClassName("shadow"),this.h.appendChild(this.s.domNode)):(this.n=null,this.r=null,this.s=null),this.t=this.a.listenOnDomNode||this.h,this.w=[],this.Q(this.a.handleMouseWheel),this.m(this.t,x=>this.Z(x)),this.u(this.t,x=>this.Y(x)),this.L=this.B(new $.$rh),this.y=!1,this.J=!1,this.M=!0,this.N=!0}dispose(){this.w=(0,P.$Pc)(this.w),super.dispose()}getDomNode(){return this.h}getOverviewRulerLayoutInfo(){return{parent:this.h,insertBefore:this.c.domNode.domNode}}delegateVerticalScrollbarPointerDown(L){this.c.delegatePointerDown(L)}getScrollDimensions(){return this.b.getScrollDimensions()}setScrollDimensions(L){this.b.setScrollDimensions(L,!1)}updateClassName(L){this.a.className=L,c.$j&&(this.a.className+=" mac"),this.h.className="monaco-scrollable-element "+this.a.className}updateOptions(L){typeof L.handleMouseWheel<"u"&&(this.a.handleMouseWheel=L.handleMouseWheel,this.Q(this.a.handleMouseWheel)),typeof L.mouseWheelScrollSensitivity<"u"&&(this.a.mouseWheelScrollSensitivity=L.mouseWheelScrollSensitivity),typeof L.fastScrollSensitivity<"u"&&(this.a.fastScrollSensitivity=L.fastScrollSensitivity),typeof L.scrollPredominantAxis<"u"&&(this.a.scrollPredominantAxis=L.scrollPredominantAxis),typeof L.horizontal<"u"&&(this.a.horizontal=L.horizontal),typeof L.vertical<"u"&&(this.a.vertical=L.vertical),typeof L.horizontalScrollbarSize<"u"&&(this.a.horizontalScrollbarSize=L.horizontalScrollbarSize),typeof L.verticalScrollbarSize<"u"&&(this.a.verticalScrollbarSize=L.verticalScrollbarSize),typeof L.scrollByPage<"u"&&(this.a.scrollByPage=L.scrollByPage),this.g.updateOptions(this.a),this.c.updateOptions(this.a),this.a.lazyRender||this.U()}setRevealOnScroll(L){this.N=L}delegateScrollFromMouseWheelEvent(L){this.R(new H.$2Q(L))}Q(L){if(this.w.length>0!==L&&(this.w=(0,P.$Pc)(this.w),L)){const O=y=>{this.R(new H.$2Q(y))};this.w.push(N.$8Q(this.t,N.$1R.MOUSE_WHEEL,O,{passive:!1}))}}R(L){if(L.browserEvent?.defaultPrevented)return;const M=p.INSTANCE;h&&M.acceptStandardWheelEvent(L);let O=!1;if(L.deltaY||L.deltaX){let x=L.deltaY*this.a.mouseWheelScrollSensitivity,q=L.deltaX*this.a.mouseWheelScrollSensitivity;this.a.scrollPredominantAxis&&(this.a.scrollYToX&&q+x===0?q=x=0:Math.abs(x)>=Math.abs(q)?q=0:x=0),this.a.flipAxes&&([x,q]=[q,x]);const I=!c.$j&&L.browserEvent&&L.browserEvent.shiftKey;(this.a.scrollYToX||I)&&!q&&(q=x,x=0),L.browserEvent&&L.browserEvent.altKey&&(q=q*this.a.fastScrollSensitivity,x=x*this.a.fastScrollSensitivity);const j=this.b.getFutureScrollPosition();let T={};if(x){const Q=n*x,Z=j.scrollTop-(Q<0?Math.floor(Q):Math.ceil(Q));this.c.writeScrollPosition(T,Z)}if(q){const Q=n*q,Z=j.scrollLeft-(Q<0?Math.floor(Q):Math.ceil(Q));this.g.writeScrollPosition(T,Z)}T=this.b.validateScrollPosition(T),(j.scrollLeft!==T.scrollLeft||j.scrollTop!==T.scrollTop)&&(h&&this.a.mouseWheelSmoothScroll&&M.isPhysicalMouseWheel()?this.b.setScrollPositionSmooth(T):this.b.setScrollPositionNow(T),O=!0)}let y=O;!y&&this.a.alwaysConsumeMouseWheel&&(y=!0),!y&&this.a.consumeMouseWheelIfScrollbarIsNeeded&&(this.c.isNeeded()||this.g.isNeeded())&&(y=!0),y&&(L.preventDefault(),L.stopPropagation())}S(L){this.M=this.g.onDidScroll(L)||this.M,this.M=this.c.onDidScroll(L)||this.M,this.a.useShadows&&(this.M=!0),this.N&&this.$(),this.a.lazyRender||this.U()}renderNow(){if(!this.a.lazyRender)throw new Error("Please use `lazyRender` together with `renderNow`!");this.U()}U(){if(this.M&&(this.M=!1,this.g.render(),this.c.render(),this.a.useShadows)){const L=this.b.getCurrentScrollPosition(),M=L.scrollTop>0,O=L.scrollLeft>0,y=O?" left":"",x=M?" top":"",q=O||M?" top-left-corner":"";this.n.setClassName(`shadow${y}`),this.r.setClassName(`shadow${x}`),this.s.setClassName(`shadow${q}${x}${y}`)}}W(){this.y=!0,this.$()}X(){this.y=!1,this.ab()}Y(L){this.J=!1,this.ab()}Z(L){this.J=!0,this.$()}$(){this.c.beginReveal(),this.g.beginReveal(),this.bb()}ab(){!this.J&&!this.y&&(this.c.beginHide(),this.g.beginHide())}bb(){!this.J&&!this.y&&this.L.cancelAndSet(()=>this.ab(),e)}}t.$RS=v;class o extends v{constructor(L,M){M=M||{},M.mouseWheelSmoothScroll=!1;const O=new f.$Es({forceIntegerValues:!0,smoothScrollDuration:0,scheduleAtNextAnimationFrame:y=>N.$fR(N.getWindow(L),y)});super(L,M,O),this.B(O)}setScrollPosition(L){this.b.setScrollPositionNow(L)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.$SS=o;class g extends v{constructor(L,M,O){super(L,M,O)}setScrollPosition(L){L.reuseAnimation?this.b.setScrollPositionSmooth(L,L.reuseAnimation):this.b.setScrollPositionNow(L)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.$TS=g;class r extends v{constructor(L,M){M=M||{},M.mouseWheelSmoothScroll=!1;const O=new f.$Es({forceIntegerValues:!1,smoothScrollDuration:0,scheduleAtNextAnimationFrame:y=>N.$fR(N.getWindow(L),y)});super(L,M,O),this.B(O),this.cb=L,this.B(this.onScroll(y=>{y.scrollTopChanged&&(this.cb.scrollTop=y.scrollTop),y.scrollLeftChanged&&(this.cb.scrollLeft=y.scrollLeft)})),this.scanDomNode()}setScrollPosition(L){this.b.setScrollPositionNow(L)}getScrollPosition(){return this.b.getCurrentScrollPosition()}scanDomNode(){this.setScrollDimensions({width:this.cb.clientWidth,scrollWidth:this.cb.scrollWidth,height:this.cb.clientHeight,scrollHeight:this.cb.scrollHeight}),this.setScrollPosition({scrollLeft:this.cb.scrollLeft,scrollTop:this.cb.scrollTop})}}t.$US=r;function B(C){const L={lazyRender:typeof C.lazyRender<"u"?C.lazyRender:!1,className:typeof C.className<"u"?C.className:"",useShadows:typeof C.useShadows<"u"?C.useShadows:!0,handleMouseWheel:typeof C.handleMouseWheel<"u"?C.handleMouseWheel:!0,flipAxes:typeof C.flipAxes<"u"?C.flipAxes:!1,consumeMouseWheelIfScrollbarIsNeeded:typeof C.consumeMouseWheelIfScrollbarIsNeeded<"u"?C.consumeMouseWheelIfScrollbarIsNeeded:!1,alwaysConsumeMouseWheel:typeof C.alwaysConsumeMouseWheel<"u"?C.alwaysConsumeMouseWheel:!1,scrollYToX:typeof C.scrollYToX<"u"?C.scrollYToX:!1,mouseWheelScrollSensitivity:typeof C.mouseWheelScrollSensitivity<"u"?C.mouseWheelScrollSensitivity:1,fastScrollSensitivity:typeof C.fastScrollSensitivity<"u"?C.fastScrollSensitivity:5,scrollPredominantAxis:typeof C.scrollPredominantAxis<"u"?C.scrollPredominantAxis:!0,mouseWheelSmoothScroll:typeof C.mouseWheelSmoothScroll<"u"?C.mouseWheelSmoothScroll:!0,arrowSize:typeof C.arrowSize<"u"?C.arrowSize:11,listenOnDomNode:typeof C.listenOnDomNode<"u"?C.listenOnDomNode:null,horizontal:typeof C.horizontal<"u"?C.horizontal:1,horizontalScrollbarSize:typeof C.horizontalScrollbarSize<"u"?C.horizontalScrollbarSize:10,horizontalSliderSize:typeof C.horizontalSliderSize<"u"?C.horizontalSliderSize:0,horizontalHasArrows:typeof C.horizontalHasArrows<"u"?C.horizontalHasArrows:!1,vertical:typeof C.vertical<"u"?C.vertical:1,verticalScrollbarSize:typeof C.verticalScrollbarSize<"u"?C.verticalScrollbarSize:10,verticalHasArrows:typeof C.verticalHasArrows<"u"?C.verticalHasArrows:!1,verticalSliderSize:typeof C.verticalSliderSize<"u"?C.verticalSliderSize:0,scrollByPage:typeof C.scrollByPage<"u"?C.scrollByPage:!1};return L.horizontalSliderSize=typeof C.horizontalSliderSize<"u"?C.horizontalSliderSize:L.horizontalScrollbarSize,L.verticalSliderSize=typeof C.verticalSliderSize<"u"?C.verticalSliderSize:L.verticalScrollbarSize,c.$j&&(L.className+=" mac"),L}}),define(be[64],$e([1,0,57,2,24,26,63,12,9,28,4,3,50,51,86,124,6,35]),function(ne,t,i,N,z,H,E,k,b,$,w,P,c,f,e,n,h,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$mT=t.$lT=t.$kT=t.$jT=t.ListViewTargetSector=void 0;const p={CurrentDragAndDropData:void 0};var v;(function(O){O[O.TOP=0]="TOP",O[O.CENTER_TOP=1]="CENTER_TOP",O[O.CENTER_BOTTOM=2]="CENTER_BOTTOM",O[O.BOTTOM=3]="BOTTOM"})(v||(t.ListViewTargetSector=v={}));const o={useShadows:!0,verticalScrollMode:1,setRowLineHeight:!0,setRowHeight:!0,supportDynamicHeights:!1,dnd:{getDragElements(O){return[O]},getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){},dispose(){}},horizontalScrolling:!1,transformOptimization:!0,alwaysConsumeMouseWheel:!0};class g{get context(){return this.d}set context(y){this.d=y}constructor(y){this.elements=y}update(){}getData(){return this.elements}}t.$jT=g;class r{constructor(y){this.elements=y}update(){}getData(){return this.elements}}t.$kT=r;class B{constructor(){this.types=[],this.files=[]}update(y){if(y.types&&this.types.splice(0,this.types.length,...y.types),y.files){this.files.splice(0,this.files.length);for(let x=0;x<y.files.length;x++){const q=y.files.item(x);q&&(q.size||q.type)&&this.files.push(q)}}}getData(){return{types:this.types,files:this.files}}}t.$lT=B;function C(O,y){return Array.isArray(O)&&Array.isArray(y)?(0,k.$ub)(O,y):O===y}class L{constructor(y){y?.getSetSize?this.getSetSize=y.getSetSize.bind(y):this.getSetSize=(x,q,I)=>I,y?.getPosInSet?this.getPosInSet=y.getPosInSet.bind(y):this.getPosInSet=(x,q)=>q+1,y?.getRole?this.getRole=y.getRole.bind(y):this.getRole=x=>"listitem",y?.isChecked?this.isChecked=y.isChecked.bind(y):this.isChecked=x=>{}}}class M{static{this.c=0}get contentHeight(){return this.g.size}get contentWidth(){return this.E??0}get onDidScroll(){return this.q.onScroll}get onWillScroll(){return this.q.onWillScroll}get containerDomNode(){return this.o}get scrollableElementDomNode(){return this.q.getDomNode()}get Q(){return this.P}set Q(y){if(y!==this.P){if(y&&this.B)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");if(this.P=y,this.domNode.classList.toggle("horizontal-scrolling",this.P),this.P){for(const x of this.d)this.ab(x);this.X(),this.q.setScrollDimensions({width:(0,N.$uR)(this.domNode)}),this.o.style.width=`${Math.max(this.E||0,this.n)}px`}else this.u.cancel(),this.q.setScrollDimensions({width:this.n,scrollWidth:this.n}),this.o.style.width=""}}constructor(y,x,q,I=o){if(this.R=x,this.domId=`list_id_${++M.c}`,this.j=new Map,this.n=0,this.s=0,this.t=null,this.u=new b.$eh(50),this.v=!1,this.x=P.$Uc.None,this.y=0,this.G=!1,this.K=P.$Uc.None,this.L=P.$Uc.None,this.M=new P.$Tc,this.N=new w.$7d,this.O=new w.$7d,this.onDidChangeContentHeight=w.Event.latch(this.N.event,void 0,this.M),this.onDidChangeContentWidth=w.Event.latch(this.O.event,void 0,this.M),this.P=!1,I.horizontalScrolling&&I.supportDynamicHeights)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");this.d=[],this.f=0,this.g=this.S(I.paddingTop??0);for(const T of q)this.j.set(T.templateId,T);this.h=this.M.add(new n.$iT(this.j)),this.k=0,this.m=0,this.domNode=document.createElement("div"),this.domNode.className="monaco-list",this.domNode.classList.add(this.domId),this.domNode.tabIndex=0,this.domNode.classList.toggle("mouse-support",typeof I.mouseSupport=="boolean"?I.mouseSupport:!0),this.P=I.horizontalScrolling??o.horizontalScrolling,this.domNode.classList.toggle("horizontal-scrolling",this.P),this.C=typeof I.paddingBottom>"u"?0:I.paddingBottom,this.D=new L(I.accessibilityProvider),this.o=document.createElement("div"),this.o.className="monaco-list-rows",(I.transformOptimization??o.transformOptimization)&&(this.o.style.transform="translate3d(0px, 0px, 0px)",this.o.style.overflow="hidden",this.o.style.contain="strict"),this.M.add(H.$ES.addTarget(this.o)),this.p=this.M.add(new f.$Es({forceIntegerValues:!0,smoothScrollDuration:I.smoothScrolling??!1?125:0,scheduleAtNextAnimationFrame:T=>(0,N.$fR)((0,N.getWindow)(this.domNode),T)})),this.q=this.M.add(new E.$TS(this.o,{alwaysConsumeMouseWheel:I.alwaysConsumeMouseWheel??o.alwaysConsumeMouseWheel,horizontal:1,vertical:I.verticalScrollMode??o.verticalScrollMode,useShadows:I.useShadows??o.useShadows,mouseWheelScrollSensitivity:I.mouseWheelScrollSensitivity,fastScrollSensitivity:I.fastScrollSensitivity,scrollByPage:I.scrollByPage},this.p)),this.domNode.appendChild(this.q.getDomNode()),y.appendChild(this.domNode),this.q.onScroll(this.ib,this,this.M),this.M.add((0,N.$8Q)(this.o,H.EventType.Change,T=>this.jb(T))),this.M.add((0,N.$8Q)(this.q.getDomNode(),"scroll",T=>T.target.scrollTop=0)),this.M.add((0,N.$8Q)(this.domNode,"dragover",T=>this.lb(this.hb(T)))),this.M.add((0,N.$8Q)(this.domNode,"drop",T=>this.nb(this.hb(T)))),this.M.add((0,N.$8Q)(this.domNode,"dragleave",T=>this.mb(this.hb(T)))),this.M.add((0,N.$8Q)(this.domNode,"dragend",T=>this.ob(T))),this.z=I.setRowLineHeight??o.setRowLineHeight,this.A=I.setRowHeight??o.setRowHeight,this.B=I.supportDynamicHeights??o.supportDynamicHeights,this.F=I.dnd??this.M.add(o.dnd),this.layout(I.initialSize?.height,I.initialSize?.width)}updateOptions(y){y.paddingBottom!==void 0&&(this.C=y.paddingBottom,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),y.smoothScrolling!==void 0&&this.p.setSmoothScrollDuration(y.smoothScrolling?125:0),y.horizontalScrolling!==void 0&&(this.Q=y.horizontalScrolling);let x;if(y.scrollByPage!==void 0&&(x={...x??{},scrollByPage:y.scrollByPage}),y.mouseWheelScrollSensitivity!==void 0&&(x={...x??{},mouseWheelScrollSensitivity:y.mouseWheelScrollSensitivity}),y.fastScrollSensitivity!==void 0&&(x={...x??{},fastScrollSensitivity:y.fastScrollSensitivity}),x&&this.q.updateOptions(x),y.paddingTop!==void 0&&y.paddingTop!==this.g.paddingTop){const q=this.vb(this.k,this.m),I=y.paddingTop-this.g.paddingTop;this.g.paddingTop=y.paddingTop,this.Y(q,Math.max(0,this.k+I),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.V(),this.B&&this.wb(this.k,this.m)}}delegateScrollFromMouseWheelEvent(y){this.q.delegateScrollFromMouseWheelEvent(y)}delegateVerticalScrollbarPointerDown(y){this.q.delegateVerticalScrollbarPointerDown(y)}updateElementHeight(y,x,q){if(y<0||y>=this.d.length)return;const I=this.d[y].size;if(typeof x>"u"){if(!this.B){console.warn("Dynamic heights not supported");return}this.d[y].lastDynamicHeightWidth=void 0,x=I+this.xb(y)}if(I===x)return;const j=this.vb(this.k,this.m);let T=0;y<j.start||q!==null&&q>y&&q<j.end?T=x-I:T=0,this.g.splice(y,1,[{size:x}]),this.d[y].size=x,this.Y(j,Math.max(0,this.k+T),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.V(),this.B&&this.wb(this.k,this.m)}S(y){return new e.$hT(y)}splice(y,x,q=[]){if(this.v)throw new Error("Can't run recursive splices.");this.v=!0;try{return this.U(y,x,q)}finally{this.v=!1,this.N.fire(this.contentHeight)}}U(y,x,q=[]){const I=this.vb(this.k,this.m),j={start:y,end:y+x},T=c.Range.intersect(I,j),Q=new Map;for(let G=T.end-1;G>=T.start;G--){const ie=this.d[G];if(ie.dragStartDisposable.dispose(),ie.checkedDisposable.dispose(),ie.row){let ue=Q.get(ie.templateId);ue||(ue=[],Q.set(ie.templateId,ue));const ye=this.j.get(ie.templateId);ye&&ye.disposeElement&&ye.disposeElement(ie.element,G,ie.row.templateData,ie.size),ue.push(ie.row)}ie.row=null,ie.stale=!0}const Z={start:y+x,end:this.d.length},ce=c.Range.intersect(Z,I),oe=c.Range.relativeComplement(Z,I),te=q.map(G=>({id:String(this.f++),element:G,templateId:this.R.getTemplateId(G),size:this.R.getHeight(G),width:void 0,hasDynamicHeight:!!this.R.hasDynamicHeight&&this.R.hasDynamicHeight(G),lastDynamicHeightWidth:void 0,row:null,uri:void 0,dropTarget:!1,dragStartDisposable:P.$Uc.None,checkedDisposable:P.$Uc.None,stale:!1}));let de;y===0&&x>=this.d.length?(this.g=this.S(this.g.paddingTop),this.g.splice(0,0,te),de=this.d,this.d=te):(this.g.splice(y,x,te),de=this.d.splice(y,x,...te));const Be=q.length-x,Fe=this.vb(this.k,this.m),Pe=(0,e.$fT)(ce,Be),le=c.Range.intersect(Fe,Pe);for(let G=le.start;G<le.end;G++)this.bb(this.d[G],G);const _=c.Range.relativeComplement(Pe,Fe);for(const G of _)for(let ie=G.start;ie<G.end;ie++)this.db(ie);const ae=oe.map(G=>(0,e.$fT)(G,Be)),J=[{start:y,end:y+q.length},...ae].map(G=>c.Range.intersect(Fe,G)).reverse();for(const G of J)for(let ie=G.end-1;ie>=G.start;ie--){const ue=this.d[ie],Ne=Q.get(ue.templateId)?.pop();this.Z(ie,Ne)}for(const G of Q.values())for(const ie of G)this.h.release(ie);return this.V(),this.B&&this.wb(this.scrollTop,this.renderHeight),de.map(G=>G.element)}V(){this.s=this.contentHeight,this.o.style.height=`${this.s}px`,this.t||(this.t=(0,N.$fR)((0,N.getWindow)(this.domNode),()=>{this.q.setScrollDimensions({scrollHeight:this.scrollHeight}),this.X(),this.t=null}))}W(){if(!this.Q){this.u.cancel();return}this.u.trigger(()=>this.X())}X(){if(!this.Q)return;let y=0;for(const x of this.d)typeof x.width<"u"&&(y=Math.max(y,x.width));this.E=y,this.q.setScrollDimensions({scrollWidth:y===0?0:y+10}),this.O.fire(this.E)}updateWidth(y){if(!this.Q||typeof this.E>"u")return;const x=this.d[y];this.ab(x),typeof x.width<"u"&&x.width>this.E&&(this.E=x.width,this.q.setScrollDimensions({scrollWidth:this.E+10}),this.O.fire(this.E))}rerender(){if(this.B){for(const y of this.d)y.lastDynamicHeightWidth=void 0;this.wb(this.k,this.m)}}get length(){return this.d.length}get renderHeight(){return this.q.getScrollDimensions().height}get firstVisibleIndex(){return this.vb(this.k,this.m).start}get firstMostlyVisibleIndex(){const y=this.firstVisibleIndex,x=this.g.positionAt(y),q=this.g.positionAt(y+1);return q!==-1&&(q-x)/2+x<this.scrollTop?y+1:y}get lastVisibleIndex(){return this.vb(this.k,this.m).end-1}element(y){return this.d[y].element}indexOf(y){return this.d.findIndex(x=>x.element===y)}domElement(y){const x=this.d[y].row;return x&&x.domNode}elementHeight(y){return this.d[y].size}elementTop(y){return this.g.positionAt(y)}indexAt(y){return this.g.indexAt(y)}indexAfter(y){return this.g.indexAfter(y)}layout(y,x){const q={height:typeof y=="number"?y:(0,N.$wR)(this.domNode)};this.t&&(this.t.dispose(),this.t=null,q.scrollHeight=this.scrollHeight),this.q.setScrollDimensions(q),typeof x<"u"&&(this.n=x,this.B&&this.wb(this.scrollTop,this.renderHeight)),this.Q&&this.q.setScrollDimensions({width:typeof x=="number"?x:(0,N.$uR)(this.domNode)})}Y(y,x,q,I,j,T=!1){const Q=this.vb(x,q),Z=c.Range.relativeComplement(Q,y).reverse(),ce=c.Range.relativeComplement(y,Q);if(T){const oe=c.Range.intersect(y,Q);for(let te=oe.start;te<oe.end;te++)this.bb(this.d[te],te)}this.h.transact(()=>{for(const oe of ce)for(let te=oe.start;te<oe.end;te++)this.db(te);for(const oe of Z)for(let te=oe.end-1;te>=oe.start;te--)this.Z(te)}),I!==void 0&&(this.o.style.left=`-${I}px`),this.o.style.top=`-${x}px`,this.Q&&j!==void 0&&(this.o.style.width=`${Math.max(j,this.n)}px`),this.k=x,this.m=q}Z(y,x){const q=this.d[y];if(!q.row)if(x)q.row=x,q.stale=!0;else{const Z=this.h.alloc(q.templateId);q.row=Z.row,q.stale||=Z.isReusingConnectedDomNode}const I=this.D.getRole(q.element)||"listitem";q.row.domNode.setAttribute("role",I);const j=this.D.isChecked(q.element);if(typeof j=="boolean")q.row.domNode.setAttribute("aria-checked",String(!!j));else if(j){const Z=ce=>q.row.domNode.setAttribute("aria-checked",String(!!ce));Z(j.value),q.checkedDisposable=j.onDidChange(Z)}if(q.stale||!q.row.domNode.parentElement){const Z=this.d.at(y+1)?.row?.domNode??null;this.o.insertBefore(q.row.domNode,Z),q.stale=!1}this.bb(q,y);const T=this.j.get(q.templateId);if(!T)throw new Error(`No renderer found for template id ${q.templateId}`);T?.renderElement(q.element,y,q.row.templateData,q.size);const Q=this.F.getDragURI(q.element);q.dragStartDisposable.dispose(),q.row.domNode.draggable=!!Q,Q&&(q.dragStartDisposable=(0,N.$8Q)(q.row.domNode,"dragstart",Z=>this.kb(q.element,Q,Z))),this.Q&&(this.ab(q),this.W())}ab(y){if(!y.row||!y.row.domNode)return;y.row.domNode.style.width="fit-content",y.width=(0,N.$uR)(y.row.domNode);const x=(0,N.getWindow)(y.row.domNode).getComputedStyle(y.row.domNode);x.paddingLeft&&(y.width+=parseFloat(x.paddingLeft)),x.paddingRight&&(y.width+=parseFloat(x.paddingRight)),y.row.domNode.style.width=""}bb(y,x){y.row.domNode.style.top=`${this.elementTop(x)}px`,this.A&&(y.row.domNode.style.height=`${y.size}px`),this.z&&(y.row.domNode.style.lineHeight=`${y.size}px`),y.row.domNode.setAttribute("data-index",`${x}`),y.row.domNode.setAttribute("data-last-element",x===this.length-1?"true":"false"),y.row.domNode.setAttribute("data-parity",x%2===0?"even":"odd"),y.row.domNode.setAttribute("aria-setsize",String(this.D.getSetSize(y.element,x,this.length))),y.row.domNode.setAttribute("aria-posinset",String(this.D.getPosInSet(y.element,x))),y.row.domNode.setAttribute("id",this.getElementDomId(x)),y.row.domNode.classList.toggle("drop-target",y.dropTarget)}db(y){const x=this.d[y];if(x.dragStartDisposable.dispose(),x.checkedDisposable.dispose(),x.row){const q=this.j.get(x.templateId);q&&q.disposeElement&&q.disposeElement(x.element,y,x.row.templateData,x.size),this.h.release(x.row),x.row=null}this.Q&&this.W()}getScrollTop(){return this.q.getScrollPosition().scrollTop}setScrollTop(y,x){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),this.q.setScrollPosition({scrollTop:y,reuseAnimation:x})}getScrollLeft(){return this.q.getScrollPosition().scrollLeft}setScrollLeft(y){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollWidth:this.E})),this.q.setScrollPosition({scrollLeft:y})}get scrollTop(){return this.getScrollTop()}set scrollTop(y){this.setScrollTop(y)}get scrollHeight(){return this.s+(this.Q?10:0)+this.C}get onMouseClick(){return w.Event.map(this.M.add(new z.$_S(this.domNode,"click")).event,y=>this.eb(y),this.M)}get onMouseDblClick(){return w.Event.map(this.M.add(new z.$_S(this.domNode,"dblclick")).event,y=>this.eb(y),this.M)}get onMouseMiddleClick(){return w.Event.filter(w.Event.map(this.M.add(new z.$_S(this.domNode,"auxclick")).event,y=>this.eb(y),this.M),y=>y.browserEvent.button===1,this.M)}get onMouseUp(){return w.Event.map(this.M.add(new z.$_S(this.domNode,"mouseup")).event,y=>this.eb(y),this.M)}get onMouseDown(){return w.Event.map(this.M.add(new z.$_S(this.domNode,"mousedown")).event,y=>this.eb(y),this.M)}get onMouseOver(){return w.Event.map(this.M.add(new z.$_S(this.domNode,"mouseover")).event,y=>this.eb(y),this.M)}get onMouseMove(){return w.Event.map(this.M.add(new z.$_S(this.domNode,"mousemove")).event,y=>this.eb(y),this.M)}get onMouseOut(){return w.Event.map(this.M.add(new z.$_S(this.domNode,"mouseout")).event,y=>this.eb(y),this.M)}get onContextMenu(){return w.Event.any(w.Event.map(this.M.add(new z.$_S(this.domNode,"contextmenu")).event,y=>this.eb(y),this.M),w.Event.map(this.M.add(new z.$_S(this.domNode,H.EventType.Contextmenu)).event,y=>this.gb(y),this.M))}get onTouchStart(){return w.Event.map(this.M.add(new z.$_S(this.domNode,"touchstart")).event,y=>this.fb(y),this.M)}get onTap(){return w.Event.map(this.M.add(new z.$_S(this.o,H.EventType.Tap)).event,y=>this.gb(y),this.M)}eb(y){const x=this.ub(y.target||null),q=typeof x>"u"?void 0:this.d[x],I=q&&q.element;return{browserEvent:y,index:x,element:I}}fb(y){const x=this.ub(y.target||null),q=typeof x>"u"?void 0:this.d[x],I=q&&q.element;return{browserEvent:y,index:x,element:I}}gb(y){const x=this.ub(y.initialTarget||null),q=typeof x>"u"?void 0:this.d[x],I=q&&q.element;return{browserEvent:y,index:x,element:I}}hb(y){const x=this.ub(y.target||null),q=typeof x>"u"?void 0:this.d[x],I=q&&q.element,j=this.tb(y,x);return{browserEvent:y,index:x,element:I,sector:j}}ib(y){try{const x=this.vb(this.k,this.m);this.Y(x,y.scrollTop,y.height,y.scrollLeft,y.scrollWidth),this.B&&this.wb(y.scrollTop,y.height,y.inSmoothScrolling)}catch(x){throw console.error("Got bad scroll event:",y),x}}jb(y){y.preventDefault(),y.stopPropagation(),this.scrollTop-=y.translationY}kb(y,x,q){if(!q.dataTransfer)return;const I=this.F.getDragElements(y);if(q.dataTransfer.effectAllowed="copyMove",q.dataTransfer.setData(i.$CS.TEXT,x),q.dataTransfer.setDragImage){let j;this.F.getDragLabel&&(j=this.F.getDragLabel(I,q)),typeof j>"u"&&(j=String(I.length));const T=(0,N.$)(".monaco-drag-image");T.textContent=j;const Z=(ce=>{for(;ce&&!ce.classList.contains("monaco-workbench");)ce=ce.parentElement;return ce||this.domNode.ownerDocument})(this.domNode);Z.appendChild(T),q.dataTransfer.setDragImage(T,-10,-10),setTimeout(()=>Z.removeChild(T),0)}this.domNode.classList.add("dragging"),this.H=new g(I),p.CurrentDragAndDropData=new r(I),this.F.onDragStart?.(this.H,q)}lb(y){if(y.browserEvent.preventDefault(),this.L.dispose(),p.CurrentDragAndDropData&&p.CurrentDragAndDropData.getData()==="vscode-ui"||(this.qb(y.browserEvent),!y.browserEvent.dataTransfer))return!1;if(!this.H)if(p.CurrentDragAndDropData)this.H=p.CurrentDragAndDropData;else{if(!y.browserEvent.dataTransfer.types)return!1;this.H=new B}const x=this.F.onDragOver(this.H,y.element,y.index,y.sector,y.browserEvent);if(this.G=typeof x=="boolean"?x:x.accept,!this.G)return this.I=void 0,this.K.dispose(),!1;y.browserEvent.dataTransfer.dropEffect=typeof x!="boolean"&&x.effect?.type===0?"copy":"move";let q;typeof x!="boolean"&&x.feedback?q=x.feedback:typeof y.index>"u"?q=[-1]:q=[y.index],q=(0,k.$Mb)(q).filter(j=>j>=-1&&j<this.length).sort((j,T)=>j-T),q=q[0]===-1?[-1]:q;let I=typeof x!="boolean"&&x.effect&&x.effect.position?x.effect.position:"drop-target";if(C(this.I,q)&&this.J===I)return!0;if(this.I=q,this.J=I,this.K.dispose(),q[0]===-1)this.domNode.classList.add(I),this.o.classList.add(I),this.K=(0,P.$Sc)(()=>{this.domNode.classList.remove(I),this.o.classList.remove(I)});else{if(q.length>1&&I!=="drop-target")throw new Error("Can't use multiple feedbacks with position different than 'over'");I==="drop-target-after"&&q[0]<this.length-1&&(q[0]+=1,I="drop-target-before");for(const j of q){const T=this.d[j];T.dropTarget=!0,T.row?.domNode.classList.add(I)}this.K=(0,P.$Sc)(()=>{for(const j of q){const T=this.d[j];T.dropTarget=!1,T.row?.domNode.classList.remove(I)}})}return!0}mb(y){this.L.dispose(),this.L=(0,b.$jh)(()=>this.pb(),100,this.M),this.H&&this.F.onDragLeave?.(this.H,y.element,y.index,y.browserEvent)}nb(y){if(!this.G)return;const x=this.H;this.sb(),this.pb(),this.domNode.classList.remove("dragging"),this.H=void 0,p.CurrentDragAndDropData=void 0,!(!x||!y.browserEvent.dataTransfer)&&(y.browserEvent.preventDefault(),x.update(y.browserEvent.dataTransfer),this.F.drop(x,y.element,y.index,y.sector,y.browserEvent))}ob(y){this.G=!1,this.sb(),this.pb(),this.domNode.classList.remove("dragging"),this.H=void 0,p.CurrentDragAndDropData=void 0,this.F.onDragEnd?.(y)}pb(){this.I=void 0,this.J=void 0,this.K.dispose(),this.K=P.$Uc.None}qb(y){if(!this.w){const x=(0,N.$oR)(this.domNode).top;this.w=(0,N.$kS)((0,N.getWindow)(this.domNode),this.rb.bind(this,x))}this.x.dispose(),this.x=(0,b.$jh)(()=>{this.w&&(this.w.dispose(),this.w=void 0)},1e3,this.M),this.y=y.pageY}rb(y){if(this.y===void 0)return;const x=this.y-y,q=this.renderHeight-35;x<35?this.scrollTop+=Math.max(-14,Math.floor(.3*(x-35))):x>q&&(this.scrollTop+=Math.min(14,Math.floor(.3*(x-q))))}sb(){this.x.dispose(),this.w&&(this.w.dispose(),this.w=void 0)}tb(y,x){if(x===void 0)return;const q=y.offsetY/this.d[x].size,I=Math.floor(q/.25);return(0,m.$mm)(I,0,3)}ub(y){const x=this.q.getDomNode();let q=y;for(;q instanceof HTMLElement&&q!==this.o&&x.contains(q);){const I=q.getAttribute("data-index");if(I){const j=Number(I);if(!isNaN(j))return j}q=q.parentElement}}vb(y,x){return{start:this.g.indexAt(y),end:this.g.indexAfter(y+x-1)}}wb(y,x,q){const I=this.vb(y,x);let j,T;y===this.elementTop(I.start)?(j=I.start,T=0):I.end-I.start>1&&(j=I.start+1,T=this.elementTop(j)-y);let Q=0;for(;;){const Z=this.vb(y,x);let ce=!1;for(let oe=Z.start;oe<Z.end;oe++){const te=this.xb(oe);te!==0&&this.g.splice(oe,1,[this.d[oe]]),Q+=te,ce=ce||te!==0}if(!ce){Q!==0&&this.V();const oe=c.Range.relativeComplement(I,Z);for(const de of oe)for(let Be=de.start;Be<de.end;Be++)this.d[Be].row&&this.db(Be);const te=c.Range.relativeComplement(Z,I).reverse();for(const de of te)for(let Be=de.end-1;Be>=de.start;Be--)this.Z(Be);for(let de=Z.start;de<Z.end;de++)this.d[de].row&&this.bb(this.d[de],de);if(typeof j=="number"){const de=this.p.getFutureScrollPosition().scrollTop-y,Be=this.elementTop(j)-T+de;this.setScrollTop(Be,q)}this.N.fire(this.contentHeight);return}}}xb(y){const x=this.d[y];if(this.R.getDynamicHeight){const T=this.R.getDynamicHeight(x.element);if(T!==null){const Q=x.size;return x.size=T,x.lastDynamicHeightWidth=this.n,T-Q}}if(!x.hasDynamicHeight||x.lastDynamicHeightWidth===this.n||this.R.hasDynamicHeight&&!this.R.hasDynamicHeight(x.element))return 0;const q=x.size;if(x.row)return x.row.domNode.style.height="",x.size=x.row.domNode.offsetHeight,x.lastDynamicHeightWidth=this.n,x.size-q;const{row:I}=this.h.alloc(x.templateId);I.domNode.style.height="",this.o.appendChild(I.domNode);const j=this.j.get(x.templateId);if(!j)throw new h.$cb("Missing renderer for templateId: "+x.templateId);return j.renderElement(x.element,y,I.templateData,void 0),x.size=I.domNode.offsetHeight,j.disposeElement?.(x.element,y,I.templateData,void 0),this.R.setDynamicHeight?.(x.element,x.size),x.lastDynamicHeightWidth=this.n,this.o.removeChild(I.domNode),this.h.release(I),x.size-q}getElementDomId(y){return`${this.domId}_${y}`}dispose(){for(const y of this.d)if(y.dragStartDisposable.dispose(),y.checkedDisposable.dispose(),y.row){const x=this.j.get(y.row.templateId);x&&(x.disposeElement?.(y.element,-1,y.row.templateData,void 0),x.disposeTemplate(y.row.templateData))}this.d=[],this.domNode&&this.domNode.parentNode&&this.domNode.parentNode.removeChild(this.domNode),this.w?.dispose(),this.M.dispose()}}t.$mT=M,Ze([$.$Lh],M.prototype,"onMouseClick",null),Ze([$.$Lh],M.prototype,"onMouseDblClick",null),Ze([$.$Lh],M.prototype,"onMouseMiddleClick",null),Ze([$.$Lh],M.prototype,"onMouseUp",null),Ze([$.$Lh],M.prototype,"onMouseDown",null),Ze([$.$Lh],M.prototype,"onMouseOver",null),Ze([$.$Lh],M.prototype,"onMouseMove",null),Ze([$.$Lh],M.prototype,"onMouseOut",null),Ze([$.$Lh],M.prototype,"onContextMenu",null),Ze([$.$Lh],M.prototype,"onTouchStart",null),Ze([$.$Lh],M.prototype,"onTap",null)}),define(be[43],$e([1,0,2,24,15,26,60,74,12,9,77,28,4,37,3,35,5,7,73,64,20,102]),function(ne,t,i,N,z,H,E,k,b,$,w,P,c,f,e,n,h,m,p,v,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ET=t.$DT=t.$CT=t.$BT=t.$yT=t.TypeNavigationMode=void 0,t.$qT=L,t.$rT=O,t.$sT=y,t.$tT=x,t.$uT=q,t.$vT=I,t.$wT=j,t.$xT=T,t.$zT=de,t.$AT=Be;class g{constructor(u){this.d=u,this.c=[]}get templateId(){return`template:${this.d.name}`}renderTemplate(u){return u}renderElement(u,S,D){const a=this.c.findIndex(d=>d.templateData===D);if(a>=0){const d=this.c[a];this.d.unrender(D),d.index=S}else{const d={index:S,templateData:D};this.c.push(d)}this.d.renderIndex(S,D)}splice(u,S,D){const a=[];for(const d of this.c)d.index<u?a.push(d):d.index>=u+S&&a.push({index:d.index+D-S,templateData:d.templateData});this.c=a}renderIndexes(u){for(const{index:S,templateData:D}of this.c)u.indexOf(S)>-1&&this.d.renderIndex(S,D)}disposeTemplate(u){const S=this.c.findIndex(D=>D.templateData===u);S<0||this.c.splice(S,1)}}class r{get name(){return this.g}get renderer(){return new g(this)}constructor(u){this.g=u,this.c=[],this.d=[],this.f=new c.$7d,this.onChange=this.f.event}splice(u,S,D){const a=D.length-S,d=u+S,s=[];let l=0;for(;l<this.d.length&&this.d[l]<u;)s.push(this.d[l++]);for(let F=0;F<D.length;F++)D[F]&&s.push(F+u);for(;l<this.d.length&&this.d[l]>=d;)s.push(this.d[l++]+a);this.renderer.splice(u,S,D.length),this.h(s,s)}renderIndex(u,S){S.classList.toggle(this.g,this.contains(u))}unrender(u){u.classList.remove(this.g)}set(u,S){return this.h(u,[...u].sort(ie),S)}h(u,S,D){const a=this.c,d=this.d;this.c=u,this.d=S;const s=J(d,u);return this.renderer.renderIndexes(s),this.f.fire({indexes:u,browserEvent:D}),a}get(){return this.c}contains(u){return(0,b.$wb)(this.d,u,ie)>=0}dispose(){(0,e.$Pc)(this.f)}}Ze([P.$Lh],r.prototype,"renderer",null);class B extends r{constructor(u){super("selected"),this.k=u}renderIndex(u,S){super.renderIndex(u,S),this.k&&(this.contains(u)?S.setAttribute("aria-selected","true"):S.setAttribute("aria-selected","false"))}}class C{constructor(u,S,D){this.c=u,this.d=S,this.f=D}splice(u,S,D){if(!this.f)return this.c.splice(u,S,new Array(D.length).fill(!1));const a=this.c.get().map(l=>this.f.getId(this.d.element(l)).toString());if(a.length===0)return this.c.splice(u,S,new Array(D.length).fill(!1));const d=new Set(a),s=D.map(l=>d.has(this.f.getId(l).toString()));this.c.splice(u,S,s)}}function L(ge){return ge.tagName==="INPUT"||ge.tagName==="TEXTAREA"}function M(ge,u){return ge.classList.contains(u)?!0:ge.classList.contains("monaco-list")||!ge.parentElement?!1:M(ge.parentElement,u)}function O(ge){return M(ge,"monaco-editor")}function y(ge){return M(ge,"monaco-custom-toggle")}function x(ge){return M(ge,"action-item")}function q(ge){return M(ge,"monaco-tl-twistie")}function I(ge){return M(ge,"monaco-tree-sticky-row")}function j(ge){return ge.classList.contains("monaco-tree-sticky-container")}function T(ge){return ge.tagName==="A"&&ge.classList.contains("monaco-button")||ge.tagName==="DIV"&&ge.classList.contains("monaco-button-dropdown")?!0:ge.classList.contains("monaco-list")||!ge.parentElement?!1:T(ge.parentElement)}class Q{get g(){return c.Event.chain(this.c.add(new N.$_S(this.k.domNode,"keydown")).event,u=>u.filter(S=>!L(S.target)).map(S=>new z.$5Q(S)))}constructor(u,S,D){this.h=u,this.k=S,this.c=new e.$Tc,this.d=new e.$Tc,this.f=D.multipleSelectionSupport,this.c.add(this.g(a=>{switch(a.keyCode){case 3:return this.l(a);case 16:return this.o(a);case 18:return this.p(a);case 11:return this.q(a);case 12:return this.s(a);case 9:return this.u(a);case 31:this.f&&(h.$j?a.metaKey:a.ctrlKey)&&this.t(a)}}))}updateOptions(u){u.multipleSelectionSupport!==void 0&&(this.f=u.multipleSelectionSupport)}l(u){u.preventDefault(),u.stopPropagation(),this.h.setSelection(this.h.getFocus(),u.browserEvent)}o(u){u.preventDefault(),u.stopPropagation(),this.h.focusPrevious(1,!1,u.browserEvent);const S=this.h.getFocus()[0];this.h.setAnchor(S),this.h.reveal(S),this.k.domNode.focus()}p(u){u.preventDefault(),u.stopPropagation(),this.h.focusNext(1,!1,u.browserEvent);const S=this.h.getFocus()[0];this.h.setAnchor(S),this.h.reveal(S),this.k.domNode.focus()}q(u){u.preventDefault(),u.stopPropagation(),this.h.focusPreviousPage(u.browserEvent);const S=this.h.getFocus()[0];this.h.setAnchor(S),this.h.reveal(S),this.k.domNode.focus()}s(u){u.preventDefault(),u.stopPropagation(),this.h.focusNextPage(u.browserEvent);const S=this.h.getFocus()[0];this.h.setAnchor(S),this.h.reveal(S),this.k.domNode.focus()}t(u){u.preventDefault(),u.stopPropagation(),this.h.setSelection((0,b.$Sb)(this.h.length),u.browserEvent),this.h.setAnchor(void 0),this.k.domNode.focus()}u(u){this.h.getSelection().length&&(u.preventDefault(),u.stopPropagation(),this.h.setSelection([],u.browserEvent),this.h.setAnchor(void 0),this.k.domNode.focus())}dispose(){this.c.dispose(),this.d.dispose()}}Ze([P.$Lh],Q.prototype,"g",null);var Z;(function(ge){ge[ge.Automatic=0]="Automatic",ge[ge.Trigger=1]="Trigger"})(Z||(t.TypeNavigationMode=Z={}));var ce;(function(ge){ge[ge.Idle=0]="Idle",ge[ge.Typing=1]="Typing"})(ce||(ce={})),t.$yT=new class{mightProducePrintableCharacter(ge){return ge.ctrlKey||ge.metaKey||ge.altKey?!1:ge.keyCode>=31&&ge.keyCode<=56||ge.keyCode>=21&&ge.keyCode<=30||ge.keyCode>=98&&ge.keyCode<=107||ge.keyCode>=85&&ge.keyCode<=95}};class oe{constructor(u,S,D,a,d){this.o=u,this.p=S,this.q=D,this.s=a,this.t=d,this.c=!1,this.d=ce.Idle,this.f=Z.Automatic,this.g=!1,this.h=-1,this.k=new e.$Tc,this.l=new e.$Tc,this.updateOptions(u.options)}updateOptions(u){u.typeNavigationEnabled??!0?this.u():this.v(),this.f=u.typeNavigationMode??Z.Automatic}trigger(){this.g=!this.g}u(){if(this.c)return;let u=!1;const S=c.Event.chain(this.k.add(new N.$_S(this.p.domNode,"keydown")).event,d=>d.filter(s=>!L(s.target)).filter(()=>this.f===Z.Automatic||this.g).map(s=>new z.$5Q(s)).filter(s=>u||this.s(s)).filter(s=>this.t.mightProducePrintableCharacter(s)).forEach(s=>i.$3R.stop(s,!0)).map(s=>s.browserEvent.key)),D=c.Event.debounce(S,()=>null,800,void 0,void 0,void 0,this.k);c.Event.reduce(c.Event.any(S,D),(d,s)=>s===null?null:(d||"")+s,void 0,this.k)(this.x,this,this.k),D(this.w,this,this.k),S(()=>u=!0,void 0,this.k),D(()=>u=!1,void 0,this.k),this.c=!0,this.g=!1}v(){this.c&&(this.k.clear(),this.c=!1,this.g=!1)}w(){const u=this.o.getFocus();if(u.length>0&&u[0]===this.h){const S=this.o.options.accessibilityProvider?.getAriaLabel(this.o.element(u[0]));S&&(0,E.$bT)(S)}this.h=-1}x(u){if(!u){this.d=ce.Idle,this.g=!1;return}const S=this.o.getFocus(),D=S.length>0?S[0]:0,a=this.d===ce.Idle?1:0;this.d=ce.Typing;for(let d=0;d<this.o.length;d++){const s=(D+d+a)%this.o.length,l=this.q.getKeyboardNavigationLabel(this.p.element(s)),F=l&&l.toString();if(this.o.options.typeNavigationEnabled){if(typeof F<"u"){if((0,f.$jk)(u,F)){this.h=D,this.o.setFocus([s]),this.o.reveal(s);return}const A=(0,f.$qk)(u,F);if(A&&A[0].end-A[0].start>1&&A.length===1){this.h=D,this.o.setFocus([s]),this.o.reveal(s);return}}}else if(typeof F>"u"||(0,f.$jk)(u,F)){this.h=D,this.o.setFocus([s]),this.o.reveal(s);return}}}dispose(){this.v(),this.k.dispose(),this.l.dispose()}}class te{constructor(u,S){this.d=u,this.f=S,this.c=new e.$Tc;const D=c.Event.chain(this.c.add(new N.$_S(S.domNode,"keydown")).event,d=>d.filter(s=>!L(s.target)).map(s=>new z.$5Q(s)));c.Event.chain(D,d=>d.filter(s=>s.keyCode===2&&!s.ctrlKey&&!s.metaKey&&!s.shiftKey&&!s.altKey))(this.g,this,this.c)}g(u){if(u.target!==this.f.domNode)return;const S=this.d.getFocus();if(S.length===0)return;const D=this.f.domElement(S[0]);if(!D)return;const a=D.querySelector("[tabIndex]");if(!a||!(a instanceof HTMLElement)||a.tabIndex===-1)return;const d=(0,i.getWindow)(a).getComputedStyle(a);d.visibility==="hidden"||d.display==="none"||(u.preventDefault(),u.stopPropagation(),a.focus())}dispose(){this.c.dispose()}}function de(ge){return h.$j?ge.browserEvent.metaKey:ge.browserEvent.ctrlKey}function Be(ge){return ge.browserEvent.shiftKey}function Fe(ge){return(0,i.$WR)(ge)&&ge.button===2}const Pe={isSelectionSingleChangeEvent:de,isSelectionRangeChangeEvent:Be};class le{constructor(u){this.k=u,this.f=new e.$Tc,this.g=new c.$7d,this.onPointer=this.g.event,u.options.multipleSelectionSupport!==!1&&(this.c=this.k.options.multipleSelectionController||Pe),this.d=typeof u.options.mouseSupport>"u"||!!u.options.mouseSupport,this.d&&(u.onMouseDown(this.s,this,this.f),u.onContextMenu(this.t,this,this.f),u.onMouseDblClick(this.v,this,this.f),u.onTouchStart(this.s,this,this.f),this.f.add(H.$ES.addTarget(u.getHTMLElement()))),c.Event.any(u.onMouseClick,u.onMouseMiddleClick,u.onTap)(this.u,this,this.f)}updateOptions(u){u.multipleSelectionSupport!==void 0&&(this.c=void 0,u.multipleSelectionSupport&&(this.c=this.k.options.multipleSelectionController||Pe))}o(u){return this.c?this.c.isSelectionSingleChangeEvent(u):!1}p(u){return this.c?this.c.isSelectionRangeChangeEvent(u):!1}q(u){return this.o(u)||this.p(u)}s(u){O(u.browserEvent.target)||(0,i.$HR)()!==u.browserEvent.target&&this.k.domFocus()}t(u){if(L(u.browserEvent.target)||O(u.browserEvent.target))return;const S=typeof u.index>"u"?[]:[u.index];this.k.setFocus(S,u.browserEvent)}u(u){if(!this.d||L(u.browserEvent.target)||O(u.browserEvent.target)||u.browserEvent.isHandledByList)return;u.browserEvent.isHandledByList=!0;const S=u.index;if(typeof S>"u"){this.k.setFocus([],u.browserEvent),this.k.setSelection([],u.browserEvent),this.k.setAnchor(void 0);return}if(this.q(u))return this.w(u);this.k.setFocus([S],u.browserEvent),this.k.setAnchor(S),Fe(u.browserEvent)||this.k.setSelection([S],u.browserEvent),this.g.fire(u)}v(u){if(L(u.browserEvent.target)||O(u.browserEvent.target)||this.q(u)||u.browserEvent.isHandledByList)return;u.browserEvent.isHandledByList=!0;const S=this.k.getFocus();this.k.setSelection(S,u.browserEvent)}w(u){const S=u.index;let D=this.k.getAnchor();if(this.p(u)){typeof D>"u"&&(D=this.k.getFocus()[0]??S,this.k.setAnchor(D));const a=Math.min(D,S),d=Math.max(D,S),s=(0,b.$Sb)(a,d+1),l=this.k.getSelection(),F=re(J(l,[D]),D);if(F.length===0)return;const A=J(s,G(l,F));this.k.setSelection(A,u.browserEvent),this.k.setFocus([S],u.browserEvent)}else if(this.o(u)){const a=this.k.getSelection(),d=a.filter(s=>s!==S);this.k.setFocus([S]),this.k.setAnchor(S),a.length===d.length?this.k.setSelection([...d,S],u.browserEvent):this.k.setSelection(d,u.browserEvent)}}dispose(){this.f.dispose()}}t.$BT=le;class _{constructor(u,S){this.c=u,this.d=S}style(u){const S=this.d&&`.${this.d}`,D=[];u.listBackground&&D.push(`.monaco-list${S} .monaco-list-rows { background: ${u.listBackground}; }`),u.listFocusBackground&&(D.push(`.monaco-list${S}:focus .monaco-list-row.focused { background-color: ${u.listFocusBackground}; }`),D.push(`.monaco-list${S}:focus .monaco-list-row.focused:hover { background-color: ${u.listFocusBackground}; }`)),u.listFocusForeground&&D.push(`.monaco-list${S}:focus .monaco-list-row.focused { color: ${u.listFocusForeground}; }`),u.listActiveSelectionBackground&&(D.push(`.monaco-list${S}:focus .monaco-list-row.selected { background-color: ${u.listActiveSelectionBackground}; }`),D.push(`.monaco-list${S}:focus .monaco-list-row.selected:hover { background-color: ${u.listActiveSelectionBackground}; }`)),u.listActiveSelectionForeground&&D.push(`.monaco-list${S}:focus .monaco-list-row.selected { color: ${u.listActiveSelectionForeground}; }`),u.listActiveSelectionIconForeground&&D.push(`.monaco-list${S}:focus .monaco-list-row.selected .codicon { color: ${u.listActiveSelectionIconForeground}; }`),u.listFocusAndSelectionBackground&&D.push(`
				.monaco-drag-image,
				.monaco-list${S}:focus .monaco-list-row.selected.focused { background-color: ${u.listFocusAndSelectionBackground}; }
			`),u.listFocusAndSelectionForeground&&D.push(`
				.monaco-drag-image,
				.monaco-list${S}:focus .monaco-list-row.selected.focused { color: ${u.listFocusAndSelectionForeground}; }
			`),u.listInactiveFocusForeground&&(D.push(`.monaco-list${S} .monaco-list-row.focused { color:  ${u.listInactiveFocusForeground}; }`),D.push(`.monaco-list${S} .monaco-list-row.focused:hover { color:  ${u.listInactiveFocusForeground}; }`)),u.listInactiveSelectionIconForeground&&D.push(`.monaco-list${S} .monaco-list-row.focused .codicon { color:  ${u.listInactiveSelectionIconForeground}; }`),u.listInactiveFocusBackground&&(D.push(`.monaco-list${S} .monaco-list-row.focused { background-color:  ${u.listInactiveFocusBackground}; }`),D.push(`.monaco-list${S} .monaco-list-row.focused:hover { background-color:  ${u.listInactiveFocusBackground}; }`)),u.listInactiveSelectionBackground&&(D.push(`.monaco-list${S} .monaco-list-row.selected { background-color:  ${u.listInactiveSelectionBackground}; }`),D.push(`.monaco-list${S} .monaco-list-row.selected:hover { background-color:  ${u.listInactiveSelectionBackground}; }`)),u.listInactiveSelectionForeground&&D.push(`.monaco-list${S} .monaco-list-row.selected { color: ${u.listInactiveSelectionForeground}; }`),u.listHoverBackground&&D.push(`.monaco-list${S}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${u.listHoverBackground}; }`),u.listHoverForeground&&D.push(`.monaco-list${S}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { color:  ${u.listHoverForeground}; }`);const a=(0,i.$nS)(u.listFocusAndSelectionOutline,(0,i.$nS)(u.listSelectionOutline,u.listFocusOutline??""));a&&D.push(`.monaco-list${S}:focus .monaco-list-row.focused.selected { outline: 1px solid ${a}; outline-offset: -1px;}`),u.listFocusOutline&&D.push(`
				.monaco-drag-image,
				.monaco-list${S}:focus .monaco-list-row.focused { outline: 1px solid ${u.listFocusOutline}; outline-offset: -1px; }
				.monaco-workbench.context-menu-visible .monaco-list${S}.last-focused .monaco-list-row.focused { outline: 1px solid ${u.listFocusOutline}; outline-offset: -1px; }
			`);const d=(0,i.$nS)(u.listSelectionOutline,u.listInactiveFocusOutline??"");d&&D.push(`.monaco-list${S} .monaco-list-row.focused.selected { outline: 1px dotted ${d}; outline-offset: -1px; }`),u.listSelectionOutline&&D.push(`.monaco-list${S} .monaco-list-row.selected { outline: 1px dotted ${u.listSelectionOutline}; outline-offset: -1px; }`),u.listInactiveFocusOutline&&D.push(`.monaco-list${S} .monaco-list-row.focused { outline: 1px dotted ${u.listInactiveFocusOutline}; outline-offset: -1px; }`),u.listHoverOutline&&D.push(`.monaco-list${S} .monaco-list-row:hover { outline: 1px dashed ${u.listHoverOutline}; outline-offset: -1px; }`),u.listDropOverBackground&&D.push(`
				.monaco-list${S}.drop-target,
				.monaco-list${S} .monaco-list-rows.drop-target,
				.monaco-list${S} .monaco-list-row.drop-target { background-color: ${u.listDropOverBackground} !important; color: inherit !important; }
			`),u.listDropBetweenBackground&&(D.push(`
			.monaco-list${S} .monaco-list-rows.drop-target-before .monaco-list-row:first-child::before,
			.monaco-list${S} .monaco-list-row.drop-target-before::before {
				content: ""; position: absolute; top: 0px; left: 0px; width: 100%; height: 1px;
				background-color: ${u.listDropBetweenBackground};
			}`),D.push(`
			.monaco-list${S} .monaco-list-rows.drop-target-after .monaco-list-row:last-child::after,
			.monaco-list${S} .monaco-list-row.drop-target-after::after {
				content: ""; position: absolute; bottom: 0px; left: 0px; width: 100%; height: 1px;
				background-color: ${u.listDropBetweenBackground};
			}`)),u.tableColumnsBorder&&D.push(`
				.monaco-table > .monaco-split-view2,
				.monaco-table > .monaco-split-view2 .monaco-sash.vertical::before,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: ${u.tableColumnsBorder};
				}

				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: transparent;
				}
			`),u.tableOddRowsBackgroundColor&&D.push(`
				.monaco-table .monaco-list-row[data-parity=odd]:not(.focused):not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(:focus) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(.focused) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr {
					background-color: ${u.tableOddRowsBackgroundColor};
				}
			`),this.c.textContent=D.join(`
`)}}t.$CT=_,t.$DT={listFocusBackground:"#7FB0D0",listActiveSelectionBackground:"#0E639C",listActiveSelectionForeground:"#FFFFFF",listActiveSelectionIconForeground:"#FFFFFF",listFocusAndSelectionOutline:"#90C2F9",listFocusAndSelectionBackground:"#094771",listFocusAndSelectionForeground:"#FFFFFF",listInactiveSelectionBackground:"#3F3F46",listInactiveSelectionIconForeground:"#FFFFFF",listHoverBackground:"#2A2D2E",listDropOverBackground:"#383B3D",listDropBetweenBackground:"#EEEEEE",treeIndentGuidesStroke:"#a9a9a9",treeInactiveIndentGuidesStroke:w.$Ft.fromHex("#a9a9a9").transparent(.4).toString(),tableColumnsBorder:w.$Ft.fromHex("#cccccc").transparent(.2).toString(),tableOddRowsBackgroundColor:w.$Ft.fromHex("#cccccc").transparent(.04).toString(),listBackground:void 0,listFocusForeground:void 0,listInactiveSelectionForeground:void 0,listInactiveFocusForeground:void 0,listInactiveFocusBackground:void 0,listHoverForeground:void 0,listFocusOutline:void 0,listInactiveFocusOutline:void 0,listSelectionOutline:void 0,listHoverOutline:void 0};const ae={keyboardSupport:!0,mouseSupport:!0,multipleSelectionSupport:!0,dnd:{getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){},dispose(){}}};function re(ge,u){const S=ge.indexOf(u);if(S===-1)return[];const D=[];let a=S-1;for(;a>=0&&ge[a]===u-(S-a);)D.push(ge[a--]);for(D.reverse(),a=S;a<ge.length&&ge[a]===u+(a-S);)D.push(ge[a++]);return D}function J(ge,u){const S=[];let D=0,a=0;for(;D<ge.length||a<u.length;)if(D>=ge.length)S.push(u[a++]);else if(a>=u.length)S.push(ge[D++]);else if(ge[D]===u[a]){S.push(ge[D]),D++,a++;continue}else ge[D]<u[a]?S.push(ge[D++]):S.push(u[a++]);return S}function G(ge,u){const S=[];let D=0,a=0;for(;D<ge.length||a<u.length;)if(D>=ge.length)S.push(u[a++]);else if(a>=u.length)S.push(ge[D++]);else if(ge[D]===u[a]){D++,a++;continue}else ge[D]<u[a]?S.push(ge[D++]):a++;return S}const ie=(ge,u)=>ge-u;class ue{constructor(u,S){this.c=u,this.d=S}get templateId(){return this.c}renderTemplate(u){return this.d.map(S=>S.renderTemplate(u))}renderElement(u,S,D,a){let d=0;for(const s of this.d)s.renderElement(u,S,D[d++],a)}disposeElement(u,S,D,a){let d=0;for(const s of this.d)s.disposeElement?.(u,S,D[d],a),d+=1}disposeTemplate(u){let S=0;for(const D of this.d)D.disposeTemplate(u[S++])}}class ye{constructor(u){this.c=u,this.templateId="a18n"}renderTemplate(u){return u}renderElement(u,S,D){const a=this.c.getAriaLabel(u);a?D.setAttribute("aria-label",a):D.removeAttribute("aria-label");const d=this.c.getAriaLevel&&this.c.getAriaLevel(u);typeof d=="number"?D.setAttribute("aria-level",`${d}`):D.removeAttribute("aria-level")}disposeTemplate(u){}}class Ne{constructor(u,S){this.c=u,this.d=S}getDragElements(u){const S=this.c.getSelectedElements();return S.indexOf(u)>-1?S:[u]}getDragURI(u){return this.d.getDragURI(u)}getDragLabel(u,S){if(this.d.getDragLabel)return this.d.getDragLabel(u,S)}onDragStart(u,S){this.d.onDragStart?.(u,S)}onDragOver(u,S,D,a,d){return this.d.onDragOver(u,S,D,a,d)}onDragLeave(u,S,D,a){this.d.onDragLeave?.(u,S,D,a)}onDragEnd(u){this.d.onDragEnd?.(u)}drop(u,S,D,a,d){this.d.drop(u,S,D,a,d)}dispose(){this.d.dispose()}}class Ae{get onDidChangeFocus(){return c.Event.map(this.g.wrapEvent(this.c.onChange),u=>this.G(u),this.y)}get onDidChangeSelection(){return c.Event.map(this.g.wrapEvent(this.d.onChange),u=>this.G(u),this.y)}get domId(){return this.k.domId}get onDidScroll(){return this.k.onDidScroll}get onMouseClick(){return this.k.onMouseClick}get onMouseDblClick(){return this.k.onMouseDblClick}get onMouseMiddleClick(){return this.k.onMouseMiddleClick}get onPointer(){return this.w.onPointer}get onMouseUp(){return this.k.onMouseUp}get onMouseDown(){return this.k.onMouseDown}get onMouseOver(){return this.k.onMouseOver}get onMouseMove(){return this.k.onMouseMove}get onMouseOut(){return this.k.onMouseOut}get onTouchStart(){return this.k.onTouchStart}get onTap(){return this.k.onTap}get onContextMenu(){let u=!1;const S=c.Event.chain(this.y.add(new N.$_S(this.k.domNode,"keydown")).event,d=>d.map(s=>new z.$5Q(s)).filter(s=>u=s.keyCode===58||s.shiftKey&&s.keyCode===68).map(s=>i.$3R.stop(s,!0)).filter(()=>!1)),D=c.Event.chain(this.y.add(new N.$_S(this.k.domNode,"keyup")).event,d=>d.forEach(()=>u=!1).map(s=>new z.$5Q(s)).filter(s=>s.keyCode===58||s.shiftKey&&s.keyCode===68).map(s=>i.$3R.stop(s,!0)).map(({browserEvent:s})=>{const l=this.getFocus(),F=l.length?l[0]:void 0,A=typeof F<"u"?this.k.element(F):void 0,R=typeof F<"u"?this.k.domElement(F):this.k.domNode;return{index:F,element:A,anchor:R,browserEvent:s}})),a=c.Event.chain(this.k.onContextMenu,d=>d.filter(s=>!u).map(({element:s,index:l,browserEvent:F})=>({element:s,index:l,anchor:new o.$ZQ((0,i.getWindow)(this.k.domNode),F),browserEvent:F})));return c.Event.any(S,D,a)}get onKeyDown(){return this.y.add(new N.$_S(this.k.domNode,"keydown")).event}get onKeyUp(){return this.y.add(new N.$_S(this.k.domNode,"keyup")).event}get onKeyPress(){return this.y.add(new N.$_S(this.k.domNode,"keypress")).event}get onDidFocus(){return c.Event.signal(this.y.add(new N.$_S(this.k.domNode,"focus",!0)).event)}get onDidBlur(){return c.Event.signal(this.y.add(new N.$_S(this.k.domNode,"blur",!0)).event)}constructor(u,S,D,a,d=ae){this.A=u,this.B=d,this.c=new r("focused"),this.f=new r("anchor"),this.g=new c.$ce,this.x="",this.y=new e.$Tc,this.z=new c.$7d,this.onDidDispose=this.z.event;const s=this.B.accessibilityProvider&&this.B.accessibilityProvider.getWidgetRole?this.B.accessibilityProvider?.getWidgetRole():"list";this.d=new B(s!=="listbox");const l=[this.c.renderer,this.d.renderer];this.u=d.accessibilityProvider,this.u&&(l.push(new ye(this.u)),this.u.onDidChangeActiveDescendant?.(this.I,this,this.y)),a=a.map(A=>new ue(A.templateId,[...l,A]));const F={...d,dnd:d.dnd&&new Ne(this,d.dnd)};if(this.k=this.C(S,D,a,F),this.k.domNode.setAttribute("role",s),d.styleController)this.q=d.styleController(this.k.domId);else{const A=(0,i.$PR)(this.k.domNode);this.q=new _(A,this.k.domId)}if(this.o=new k.$dT([new C(this.c,this.k,d.identityProvider),new C(this.d,this.k,d.identityProvider),new C(this.f,this.k,d.identityProvider),this.k]),this.y.add(this.c),this.y.add(this.d),this.y.add(this.f),this.y.add(this.k),this.y.add(this.z),this.y.add(new te(this,this.k)),(typeof d.keyboardSupport!="boolean"||d.keyboardSupport)&&(this.v=new Q(this,this.k,d),this.y.add(this.v)),d.keyboardNavigationLabelProvider){const A=d.keyboardNavigationDelegate||t.$yT;this.t=new oe(this,this.k,d.keyboardNavigationLabelProvider,d.keyboardNavigationEventFilter??(()=>!0),A),this.y.add(this.t)}this.w=this.D(d),this.y.add(this.w),this.onDidChangeFocus(this.H,this,this.y),this.onDidChangeSelection(this.J,this,this.y),this.u&&(this.ariaLabel=this.u.getWidgetAriaLabel()),this.B.multipleSelectionSupport!==!1&&this.k.domNode.setAttribute("aria-multiselectable","true")}C(u,S,D,a){return new v.$mT(u,S,D,a)}D(u){return new le(this)}updateOptions(u={}){this.B={...this.B,...u},this.t?.updateOptions(this.B),this.B.multipleSelectionController!==void 0&&(this.B.multipleSelectionSupport?this.k.domNode.setAttribute("aria-multiselectable","true"):this.k.domNode.removeAttribute("aria-multiselectable")),this.w.updateOptions(u),this.v?.updateOptions(u),this.k.updateOptions(u)}get options(){return this.B}splice(u,S,D=[]){if(u<0||u>this.k.length)throw new p.$oT(this.A,`Invalid start index: ${u}`);if(S<0)throw new p.$oT(this.A,`Invalid delete count: ${S}`);S===0&&D.length===0||this.g.bufferEvents(()=>this.o.splice(u,S,D))}updateWidth(u){this.k.updateWidth(u)}updateElementHeight(u,S){this.k.updateElementHeight(u,S,null)}rerender(){this.k.rerender()}element(u){return this.k.element(u)}indexOf(u){return this.k.indexOf(u)}indexAt(u){return this.k.indexAt(u)}get length(){return this.k.length}get contentHeight(){return this.k.contentHeight}get contentWidth(){return this.k.contentWidth}get onDidChangeContentHeight(){return this.k.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.k.onDidChangeContentWidth}get scrollTop(){return this.k.getScrollTop()}set scrollTop(u){this.k.setScrollTop(u)}get scrollLeft(){return this.k.getScrollLeft()}set scrollLeft(u){this.k.setScrollLeft(u)}get scrollHeight(){return this.k.scrollHeight}get renderHeight(){return this.k.renderHeight}get firstVisibleIndex(){return this.k.firstVisibleIndex}get firstMostlyVisibleIndex(){return this.k.firstMostlyVisibleIndex}get lastVisibleIndex(){return this.k.lastVisibleIndex}get ariaLabel(){return this.x}set ariaLabel(u){this.x=u,this.k.domNode.setAttribute("aria-label",u)}domFocus(){this.k.domNode.focus({preventScroll:!0})}layout(u,S){this.k.layout(u,S)}triggerTypeNavigation(){this.t?.trigger()}setSelection(u,S){for(const D of u)if(D<0||D>=this.length)throw new p.$oT(this.A,`Invalid index ${D}`);this.d.set(u,S)}getSelection(){return this.d.get()}getSelectedElements(){return this.getSelection().map(u=>this.k.element(u))}setAnchor(u){if(typeof u>"u"){this.f.set([]);return}if(u<0||u>=this.length)throw new p.$oT(this.A,`Invalid index ${u}`);this.f.set([u])}getAnchor(){return(0,b.$Ob)(this.f.get(),void 0)}getAnchorElement(){const u=this.getAnchor();return typeof u>"u"?void 0:this.element(u)}setFocus(u,S){for(const D of u)if(D<0||D>=this.length)throw new p.$oT(this.A,`Invalid index ${D}`);this.c.set(u,S)}focusNext(u=1,S=!1,D,a){if(this.length===0)return;const d=this.c.get(),s=this.E(d.length>0?d[0]+u:0,S,a);s>-1&&this.setFocus([s],D)}focusPrevious(u=1,S=!1,D,a){if(this.length===0)return;const d=this.c.get(),s=this.F(d.length>0?d[0]-u:0,S,a);s>-1&&this.setFocus([s],D)}async focusNextPage(u,S){let D=this.k.indexAt(this.k.getScrollTop()+this.k.renderHeight);D=D===0?0:D-1;const a=this.getFocus()[0];if(a!==D&&(a===void 0||D>a)){const d=this.F(D,!1,S);d>-1&&a!==d?this.setFocus([d],u):this.setFocus([D],u)}else{const d=this.k.getScrollTop();let s=d+this.k.renderHeight;D>a&&(s-=this.k.elementHeight(D)),this.k.setScrollTop(s),this.k.getScrollTop()!==d&&(this.setFocus([]),await(0,$.$ih)(0),await this.focusNextPage(u,S))}}async focusPreviousPage(u,S,D=()=>0){let a;const d=D(),s=this.k.getScrollTop()+d;s===0?a=this.k.indexAt(s):a=this.k.indexAfter(s-1);const l=this.getFocus()[0];if(l!==a&&(l===void 0||l>=a)){const F=this.E(a,!1,S);F>-1&&l!==F?this.setFocus([F],u):this.setFocus([a],u)}else{const F=s;this.k.setScrollTop(s-this.k.renderHeight-d),this.k.getScrollTop()+D()!==F&&(this.setFocus([]),await(0,$.$ih)(0),await this.focusPreviousPage(u,S,D))}}focusLast(u,S){if(this.length===0)return;const D=this.F(this.length-1,!1,S);D>-1&&this.setFocus([D],u)}focusFirst(u,S){this.focusNth(0,u,S)}focusNth(u,S,D){if(this.length===0)return;const a=this.E(u,!1,D);a>-1&&this.setFocus([a],S)}E(u,S=!1,D){for(let a=0;a<this.length;a++){if(u>=this.length&&!S)return-1;if(u=u%this.length,!D||D(this.element(u)))return u;u++}return-1}F(u,S=!1,D){for(let a=0;a<this.length;a++){if(u<0&&!S)return-1;if(u=(this.length+u%this.length)%this.length,!D||D(this.element(u)))return u;u--}return-1}getFocus(){return this.c.get()}getFocusedElements(){return this.getFocus().map(u=>this.k.element(u))}reveal(u,S,D=0){if(u<0||u>=this.length)throw new p.$oT(this.A,`Invalid index ${u}`);const a=this.k.getScrollTop(),d=this.k.elementTop(u),s=this.k.elementHeight(u);if((0,m.$Yf)(S)){const l=s-this.k.renderHeight+D;this.k.setScrollTop(l*(0,n.$mm)(S,0,1)+d-D)}else{const l=d+s,F=a+this.k.renderHeight;d<a+D&&l>=F||(d<a+D||l>=F&&s>=this.k.renderHeight?this.k.setScrollTop(d-D):l>=F&&this.k.setScrollTop(l-this.k.renderHeight))}}getRelativeTop(u,S=0){if(u<0||u>=this.length)throw new p.$oT(this.A,`Invalid index ${u}`);const D=this.k.getScrollTop(),a=this.k.elementTop(u),d=this.k.elementHeight(u);if(a<D+S||a+d>D+this.k.renderHeight)return null;const s=d-this.k.renderHeight+S;return Math.abs((D+S-a)/s)}isDOMFocused(){return(0,i.$IR)(this.k.domNode)}getHTMLElement(){return this.k.domNode}getScrollableElement(){return this.k.scrollableElementDomNode}getElementID(u){return this.k.getElementDomId(u)}getElementTop(u){return this.k.elementTop(u)}style(u){this.q.style(u)}G({indexes:u,browserEvent:S}){return{indexes:u,elements:u.map(D=>this.k.element(D)),browserEvent:S}}H(){const u=this.c.get();this.k.domNode.classList.toggle("element-focused",u.length>0),this.I()}I(){const u=this.c.get();if(u.length>0){let S;this.u?.getActiveDescendantId&&(S=this.u.getActiveDescendantId(this.k.element(u[0]))),this.k.domNode.setAttribute("aria-activedescendant",S||this.k.getElementDomId(u[0]))}else this.k.domNode.removeAttribute("aria-activedescendant")}J(){const u=this.d.get();this.k.domNode.classList.toggle("selection-none",u.length===0),this.k.domNode.classList.toggle("selection-single",u.length===1),this.k.domNode.classList.toggle("selection-multiple",u.length>1)}dispose(){this.z.fire(),this.y.dispose(),this.z.dispose()}}t.$ET=Ae,Ze([P.$Lh],Ae.prototype,"onDidChangeFocus",null),Ze([P.$Lh],Ae.prototype,"onDidChangeSelection",null),Ze([P.$Lh],Ae.prototype,"onContextMenu",null),Ze([P.$Lh],Ae.prototype,"onKeyDown",null),Ze([P.$Lh],Ae.prototype,"onKeyUp",null),Ze([P.$Lh],Ae.prototype,"onKeyPress",null),Ze([P.$Lh],Ae.prototype,"onDidFocus",null),Ze([P.$Lh],Ae.prototype,"onDidBlur",null)}),define(be[65],$e([1,0,6,39,41,10,16]),function(ne,t,i,N,z,H,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ek=t.MarkdownStringTextNewlineStyle=void 0,t.$Fk=$,t.$Gk=w,t.$Hk=P,t.$Ik=c,t.$Jk=f,t.$Kk=e,t.$Lk=n,t.$Mk=h;var k;(function(m){m[m.Paragraph=0]="Paragraph",m[m.Break=1]="Break"})(k||(t.MarkdownStringTextNewlineStyle=k={}));class b{constructor(p="",v=!1){if(this.value=p,typeof this.value!="string")throw(0,i.$7)("value");typeof v=="boolean"?(this.isTrusted=v,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=v.isTrusted??void 0,this.supportThemeIcons=v.supportThemeIcons??!1,this.supportHtml=v.supportHtml??!1)}appendText(p,v=0){return this.value+=c(this.supportThemeIcons?(0,N.$yk)(p):p).replace(/([ \t]+)/g,(o,g)=>"&nbsp;".repeat(g.length)).replace(/\>/gm,"\\>").replace(/\n/g,v===1?`\\
`:`

`),this}appendMarkdown(p){return this.value+=p,this}appendCodeblock(p,v){return this.value+=`
${f(v,p)}
`,this}appendLink(p,v,o){return this.value+="[",this.value+=this.c(v,"]"),this.value+="](",this.value+=this.c(String(p),")"),o&&(this.value+=` "${this.c(this.c(o,'"'),")")}"`),this.value+=")",this}c(p,v){const o=new RegExp((0,H.$Ze)(v),"g");return p.replace(o,(g,r)=>p.charAt(r-1)!=="\\"?`\\${g}`:g)}}t.$Ek=b;function $(m){return w(m)?!m.value:Array.isArray(m)?m.every($):!0}function w(m){return m instanceof b?!0:m&&typeof m=="object"?typeof m.value=="string"&&(typeof m.isTrusted=="boolean"||typeof m.isTrusted=="object"||m.isTrusted===void 0)&&(typeof m.supportThemeIcons=="boolean"||m.supportThemeIcons===void 0):!1}function P(m,p){return m===p?!0:!m||!p?!1:m.value===p.value&&m.isTrusted===p.isTrusted&&m.supportThemeIcons===p.supportThemeIcons&&m.supportHtml===p.supportHtml&&(m.baseUri===p.baseUri||!!m.baseUri&&!!p.baseUri&&(0,z.$Ng)(E.URI.from(m.baseUri),E.URI.from(p.baseUri)))}function c(m){return m.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function f(m,p){const v=m.match(/^`+/gm)?.reduce((g,r)=>g.length>r.length?g:r).length??0,o=v>=3?v+1:3;return[`${"`".repeat(o)}${p}`,m,`${"`".repeat(o)}`].join(`
`)}function e(m){return m.replace(/"/g,"&quot;")}function n(m){return m&&m.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function h(m){const p=[],v=m.split("|").map(g=>g.trim());m=v[0];const o=v[1];if(o){const g=/height=(\d+)/.exec(o),r=/width=(\d+)/.exec(o),B=g?g[1]:"",C=r?r[1]:"",L=isFinite(parseInt(C)),M=isFinite(parseInt(B));L&&p.push(`width="${C}"`),M&&p.push(`height="${B}"`)}return{href:m,dimensions:p}}}),define(be[130],$e([1,0,2,122,24,58,15,20,123,6,4,65,39,80,23,3,82,56,32,54,41,10,16]),function(ne,t,i,N,z,H,E,k,b,$,w,P,c,f,e,n,h,m,p,v,o,g,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$IT=void 0,t.$HT=C,t.$JT=x,t.$KT=q,t.$LT=ce;const B=Object.freeze({image:(G,ie,ue)=>{let ye=[],Ne=[];return G&&({href:G,dimensions:ye}=(0,P.$Mk)(G),Ne.push(`src="${(0,P.$Kk)(G)}"`)),ue&&Ne.push(`alt="${(0,P.$Kk)(ue)}"`),ie&&Ne.push(`title="${(0,P.$Kk)(ie)}"`),ye.length&&(Ne=Ne.concat(ye)),"<img "+Ne.join(" ")+">"},paragraph:G=>`<p>${G}</p>`,link:(G,ie,ue)=>typeof G!="string"?"":(G===ue&&(ue=(0,P.$Lk)(ue)),ie=typeof ie=="string"?(0,P.$Kk)((0,P.$Lk)(ie)):"",G=(0,P.$Lk)(G),G=G.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;").replace(/'/g,"&#39;"),`<a href="${G}" title="${ie||G}" draggable="false">${ue}</a>`)});function C(G,ie={},ue={}){const ye=new n.$Tc;let Ne=!1;const Ae=(0,H.$$S)(ie),ge=function(A){let R;try{R=(0,m.$Ph)(decodeURIComponent(A))}catch{}return R?(R=(0,v.$Pn)(R,W=>{if(G.uris&&G.uris[W])return r.URI.revive(G.uris[W])}),encodeURIComponent(JSON.stringify(R))):A},u=function(A,R){const W=G.uris&&G.uris[A];let X=r.URI.revive(W);return R?A.startsWith(p.Schemas.data+":")?A:(X||(X=r.URI.parse(A)),p.$Bg.uriToBrowserUri(X).toString(!0)):!X||r.URI.parse(A).toString()===X.toString()?A:(X.query&&(X=X.with({query:ge(X.query)})),X.toString())},S=new h.marked.Renderer;S.image=B.image,S.link=B.link,S.paragraph=B.paragraph;const D=[],a=[];if(ie.codeBlockRendererSync?S.code=(A,R)=>{const W=f.$KO.nextId(),X=ie.codeBlockRendererSync(L(R),A);return a.push([W,X]),`<div class="code" data-code="${W}">${(0,g.$Ye)(A)}</div>`}:ie.codeBlockRenderer&&(S.code=(A,R)=>{const W=f.$KO.nextId(),X=ie.codeBlockRenderer(L(R),A);return D.push(X.then(U=>[W,U])),`<div class="code" data-code="${W}">${(0,g.$Ye)(A)}</div>`}),ie.actionHandler){const A=function(X){let U=X.target;if(!(U.tagName!=="A"&&(U=U.parentElement,!U||U.tagName!=="A")))try{let me=U.dataset.href;me&&(G.baseUri&&(me=M(r.URI.from(G.baseUri),me)),ie.actionHandler.callback(me,X))}catch(me){(0,$.$1)(me)}finally{X.preventDefault()}},R=ie.actionHandler.disposables.add(new z.$_S(Ae,"click")),W=ie.actionHandler.disposables.add(new z.$_S(Ae,"auxclick"));ie.actionHandler.disposables.add(w.Event.any(R.event,W.event)(X=>{const U=new k.$ZQ(i.getWindow(Ae),X);!U.leftButton&&!U.middleButton||A(U)})),ie.actionHandler.disposables.add(i.$8Q(Ae,"keydown",X=>{const U=new E.$5Q(X);!U.equals(10)&&!U.equals(3)||A(U)}))}G.supportHtml||(ue.sanitizer=A=>(G.isTrusted?A.match(/^(<span[^>]+>)|(<\/\s*span>)$/):void 0)?A:"",ue.sanitize=!0,ue.silent=!0),ue.renderer=S;let d=G.value??"";d.length>1e5&&(d=`${d.substr(0,1e5)}\u2026`),G.supportThemeIcons&&(d=(0,c.$zk)(d));let s;if(ie.fillInIncompleteTokens){const A={...h.marked.defaults,...ue},R=h.marked.lexer(d,A),W=ce(R);s=h.marked.parser(W,A)}else s=h.marked.parse(d,ue);G.supportThemeIcons&&(s=(0,b.$FT)(s).map(R=>typeof R=="string"?R:R.outerHTML).join(""));const F=new DOMParser().parseFromString(O(G,s),"text/html");if(F.body.querySelectorAll("img").forEach(A=>{const R=A.getAttribute("src");if(R){let W=R;try{G.baseUri&&(W=M(r.URI.from(G.baseUri),W))}catch{}A.src=u(W,!0)}}),F.body.querySelectorAll("a").forEach(A=>{const R=A.getAttribute("href");if(A.setAttribute("href",""),!R||/^data:|javascript:/i.test(R)||/^command:/i.test(R)&&!G.isTrusted||/^command:(\/\/\/)?_workbench\.downloadResource/i.test(R))A.replaceWith(...A.childNodes);else{let W=u(R,!1);G.baseUri&&(W=M(r.URI.from(G.baseUri),R)),A.dataset.href=W}}),Ae.innerHTML=O(G,F.body.innerHTML),D.length>0)Promise.all(D).then(A=>{if(Ne)return;const R=new Map(A),W=Ae.querySelectorAll("div[data-code]");for(const X of W){const U=R.get(X.dataset.code??"");U&&i.$0R(X,U)}ie.asyncRenderCallback?.()});else if(a.length>0){const A=new Map(a),R=Ae.querySelectorAll("div[data-code]");for(const W of R){const X=A.get(W.dataset.code??"");X&&i.$0R(W,X)}}if(ie.asyncRenderCallback)for(const A of Ae.getElementsByTagName("img")){const R=ye.add(i.$8Q(A,"load",()=>{R.dispose(),ie.asyncRenderCallback()}))}return{element:Ae,dispose:()=>{Ne=!0,ye.dispose()}}}function L(G){if(!G)return"";const ie=G.split(/[\s+|:|,|\{|\?]/,1);return ie.length?ie[0]:G}function M(G,ie){return/^\w[\w\d+.-]*:/.test(ie)?ie:G.path.endsWith("/")?(0,o.$Xg)(G,ie).toString():(0,o.$Xg)((0,o.$Tg)(G),ie).toString()}function O(G,ie){const{config:ue,allowedSchemes:ye}=y(G);N.addHook("uponSanitizeAttribute",(Ae,ge)=>{if(ge.attrName==="style"||ge.attrName==="class"){if(Ae.tagName==="SPAN"){if(ge.attrName==="style"){ge.keepAttr=/^(color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?(background-color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?$/.test(ge.attrValue);return}else if(ge.attrName==="class"){ge.keepAttr=/^codicon codicon-[a-z\-]+( codicon-modifier-[a-z\-]+)?$/.test(ge.attrValue);return}}ge.keepAttr=!1;return}else if(Ae.tagName==="INPUT"&&Ae.attributes.getNamedItem("type")?.value==="checkbox"){if(ge.attrName==="type"&&ge.attrValue==="checkbox"||ge.attrName==="disabled"||ge.attrName==="checked"){ge.keepAttr=!0;return}ge.keepAttr=!1}}),N.addHook("uponSanitizeElement",(Ae,ge)=>{ge.tagName==="input"&&(Ae.attributes.getNamedItem("type")?.value==="checkbox"?Ae.setAttribute("disabled",""):Ae.parentElement?.removeChild(Ae))});const Ne=i.$rS(ye);try{return N.sanitize(ie,{...ue,RETURN_TRUSTED_TYPE:!0})}finally{N.removeHook("uponSanitizeAttribute"),Ne.dispose()}}t.$IT=["align","autoplay","alt","checked","class","controls","data-code","data-href","disabled","draggable","height","href","loop","muted","playsinline","poster","src","style","target","title","type","width","start"];function y(G){const ie=[p.Schemas.http,p.Schemas.https,p.Schemas.mailto,p.Schemas.data,p.Schemas.file,p.Schemas.vscodeFileResource,p.Schemas.vscodeRemote,p.Schemas.vscodeRemoteResource];return G.isTrusted&&ie.push(p.Schemas.command),{config:{ALLOWED_TAGS:[...i.$sS],ALLOWED_ATTR:t.$IT,ALLOW_UNKNOWN_PROTOCOLS:!0},allowedSchemes:ie}}function x(G){return typeof G=="string"?G:q(G)}function q(G){let ie=G.value??"";ie.length>1e5&&(ie=`${ie.substr(0,1e5)}\u2026`);const ue=h.marked.parse(ie,{renderer:j.value}).replace(/&(#\d+|[a-zA-Z]+);/g,ye=>I.get(ye)??ye);return O({isTrusted:!1},ue).toString()}const I=new Map([["&quot;",'"'],["&nbsp;"," "],["&amp;","&"],["&#39;","'"],["&lt;","<"],["&gt;",">"]]),j=new e.$V(()=>{const G=new h.marked.Renderer;return G.code=ie=>ie,G.blockquote=ie=>ie,G.html=ie=>"",G.heading=(ie,ue,ye)=>ie+`
`,G.hr=()=>"",G.list=(ie,ue)=>ie,G.listitem=ie=>ie+`
`,G.paragraph=ie=>ie+`
`,G.table=(ie,ue)=>ie+ue+`
`,G.tablerow=ie=>ie,G.tablecell=(ie,ue)=>ie+" ",G.strong=ie=>ie,G.em=ie=>ie,G.codespan=ie=>ie,G.br=()=>`
`,G.del=ie=>ie,G.image=(ie,ue,ye)=>"",G.text=ie=>ie,G.link=(ie,ue,ye)=>ye,G});function T(G){let ie="";return G.forEach(ue=>{ie+=ue.raw}),ie}function Q(G){for(let ie=0;ie<G.tokens.length;ie++){const ue=G.tokens[ie];if(ue.type==="text"){const ye=ue.raw.split(`
`),Ne=ye[ye.length-1];if(Ne.includes("`"))return te(G);if(Ne.includes("**"))return _(G);if(Ne.match(/\*\w/))return de(G);if(Ne.match(/(^|\s)__\w/))return ae(G);if(Ne.match(/(^|\s)_\w/))return Be(G);if(Ne.match(/(^|\s)\[.*\]\(\w*/)){const Ae=G.tokens.slice(ie+1);return Ae[0]?.type==="link"&&Ae[1]?.type==="text"&&Ae[1].raw.match(/^ *"[^"]*$/)?Pe(G):Fe(G)}else{if(Z(Ne))return Fe(G);if(Ne.match(/(^|\s)\[\w/)&&!G.tokens.slice(ie+1).some(Ae=>Z(Ae.raw)))return le(G)}}}}function Z(G){return!!G.match(/^[^\[]*\]\([^\)]*$/)}function ce(G){let ie,ue;for(ie=0;ie<G.length;ie++){const ye=G[ie];let Ne;if(ye.type==="paragraph"&&(Ne=ye.raw.match(/(\n|^)(````*)/))){const Ae=Ne[2];ue=oe(G.slice(ie),Ae);break}if(ye.type==="paragraph"&&ye.raw.match(/(\n|^)\|/)){ue=J(G.slice(ie));break}if(ie===G.length-1&&ye.type==="paragraph"){const Ae=Q(ye);if(Ae){ue=[Ae];break}}}if(ue){const ye=[...G.slice(0,ie),...ue];return ye.links=G.links,ye}return G}function oe(G,ie){const ue=T(G);return h.marked.lexer(ue+`
${ie}`)}function te(G){return re(G,"`")}function de(G){return re(G,"*")}function Be(G){return re(G,"_")}function Fe(G){return re(G,")")}function Pe(G){return re(G,'")')}function le(G){return re(G,"](about:blank)")}function _(G){return re(G,"**")}function ae(G){return re(G,"__")}function re(G,ie){const ue=T(Array.isArray(G)?G:[G]);return h.marked.lexer(ue+ie)[0]}function J(G){const ie=T(G),ue=ie.split(`
`);let ye,Ne=!1;for(let Ae=0;Ae<ue.length;Ae++){const ge=ue[Ae].trim();if(typeof ye>"u"&&ge.match(/^\s*\|/)){const u=ge.match(/(\|[^\|]+)(?=\||$)/g);u&&(ye=u.length)}else if(typeof ye=="number")if(ge.match(/^\s*\|/)){if(Ae!==ue.length-1)return;Ne=!0}else return}if(typeof ye=="number"&&ye>0){const Ae=Ne?ue.slice(0,-1).join(`
`):ie,ge=!!Ae.match(/\|\s*$/),u=Ae+(ge?"":"|")+`
|${" --- |".repeat(ye)}`;return h.marked.lexer(u)}}}),define(be[33],$e([1,0,2,9,30,65,39,3,7,112]),function(ne,t,i,N,z,H,E,k,b,$){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$YS=w,t.$ZS=f;function w(e,n){(0,b.$Uf)(n)?e.title=(0,E.$Ak)(n):n?.markdownNotSupportedFallback?e.title=n.markdownNotSupportedFallback:e.removeAttribute("title")}class P{constructor(n,h,m){this.c=n,this.d=h,this.f=m}async update(n,h,m){if(this.b&&(this.b.dispose(!0),this.b=void 0),this.isDisposed)return;let p;if(n===void 0||(0,b.$Uf)(n)||n instanceof HTMLElement)p=n;else if(!(0,b.$9f)(n.markdown))p=n.markdown??n.markdownNotSupportedFallback;else{this.a||this.g((0,$.localize)(0,null),h),this.b=new z.$ee;const v=this.b.token;if(p=await n.markdown(v),p===void 0&&(p=n.markdownNotSupportedFallback),this.isDisposed||v.isCancellationRequested)return}this.g(p,h,m)}g(n,h,m){const p=this.a;if(this.h(n)){const v={content:n,target:this.d,appearance:{showPointer:this.c.placement==="element",skipFadeInAnimation:!this.f||!!p},position:{hoverPosition:2},...m};this.a=this.c.showHover(v,h)}p?.dispose()}h(n){return n?(0,H.$Gk)(n)?!!n.value:!0:!1}get isDisposed(){return this.a?.isDisposed}dispose(){this.a?.dispose(),this.b?.dispose(!0),this.b=void 0}}function c(e,n){for(n=n??i.getWindow(e).document.body;!e.hasAttribute("custom-hover")&&e!==n;)e=e.parentElement;return e}function f(e,n,h,m){n.setAttribute("custom-hover","true"),n.title!==""&&(console.warn("HTML element already has a title attribute, which will conflict with the custom hover. Please remove the title attribute."),console.trace("Stack trace:",n.title),n.title="");let p,v;const o=(j,T)=>{const Q=v!==void 0;j&&(v?.dispose(),v=void 0),T&&(p?.dispose(),p=void 0),Q&&(e.onDidHideHover?.(),v=void 0)},g=(j,T,Q)=>new N.$rh(async()=>{(!v||v.isDisposed)&&(v=new P(e,Q||n,j>0),await v.update(typeof h=="function"?h():h,T,m))},j);let r=!1;const B=i.$8Q(n,i.$1R.MOUSE_DOWN,()=>{r=!0,o(!0,!0)},!0),C=i.$8Q(n,i.$1R.MOUSE_UP,()=>{r=!1},!0),L=i.$8Q(n,i.$1R.MOUSE_LEAVE,j=>{r=!1,o(!1,j.fromElement===n)},!0),M=j=>{if(p)return;const T=new k.$Tc,Q={targetElements:[n],dispose:()=>{}};if(e.placement===void 0||e.placement==="mouse"){const Z=ce=>{Q.x=ce.x+10,ce.target instanceof HTMLElement&&c(ce.target,n)!==n&&o(!0,!0)};T.add(i.$8Q(n,i.$1R.MOUSE_MOVE,Z,!0))}p=T,!(j.target instanceof HTMLElement&&c(j.target,n)!==n)&&T.add(g(e.delay,!1,Q))},O=i.$8Q(n,i.$1R.MOUSE_OVER,M,!0),y=()=>{if(r||p)return;const j={targetElements:[n],dispose:()=>{}},T=new k.$Tc,Q=()=>o(!0,!0);T.add(i.$8Q(n,i.$1R.BLUR,Q,!0)),T.add(g(e.delay,!1,j)),p=T};let x;const q=n.tagName.toLowerCase();return q!=="input"&&q!=="textarea"&&(x=i.$8Q(n,i.$1R.FOCUS,y,!0)),{show:j=>{o(!1,!0),g(0,j)},hide:()=>{o(!0,!0)},update:async(j,T)=>{h=j,await v?.update(h,void 0,T)},dispose:()=>{O.dispose(),L.dispose(),B.dispose(),C.dispose(),x?.dispose(),o(!0,!0)}}}}),define(be[131],$e([1,0,2,24,15,130,14,33,43,12,4,48,3,5,114,105]),function(ne,t,i,N,z,H,E,k,b,$,w,P,c,f,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$MT=void 0;const n=i.$,h="selectOption.entry.template";class m{get templateId(){return h}renderTemplate(o){const g=Object.create(null);return g.root=o,g.text=i.$8R(o,n(".option-text")),g.detail=i.$8R(o,n(".option-detail")),g.decoratorRight=i.$8R(o,n(".option-decorator-right")),g}renderElement(o,g,r){const B=r,C=o.text,L=o.detail,M=o.decoratorRight,O=o.isDisabled;B.text.textContent=C,B.detail.textContent=L||"",B.decoratorRight.innerText=M||"",O?B.root.classList.add("option-disabled"):B.root.classList.remove("option-disabled")}disposeTemplate(o){}}class p extends c.$Uc{static{this.a=32}static{this.b=2}static{this.c=3}constructor(o,g,r,B,C){super(),this.m=[],this.F=0,this.H=!1,this.J=!1,this.N=!1,this.f=!1,this.s=B,this.g=C||Object.create(null),typeof this.g.minBottomMargin!="number"?this.g.minBottomMargin=p.a:this.g.minBottomMargin<0&&(this.g.minBottomMargin=0),this.h=document.createElement("select"),this.h.className="monaco-select-box monaco-select-box-dropdown-padding",typeof this.g.ariaLabel=="string"&&this.h.setAttribute("aria-label",this.g.ariaLabel),typeof this.g.ariaDescription=="string"&&this.h.setAttribute("aria-description",this.g.ariaDescription),this.r=new w.$7d,this.B(this.r),this.Q(),this.P(r),this.n=g||0,o&&this.setOptions(o,g),this.S()}O(o){!this.M&&o?this.M=this.B((0,k.$ZS)((0,E.$2S)("mouse"),this.h,o)):this.M&&this.M.update(o)}getHeight(){return 22}getTemplateId(){return h}P(o){this.u=o,this.w=i.$(".monaco-select-box-dropdown-container"),this.w.classList.add("monaco-select-box-dropdown-padding"),this.I=i.$8R(this.w,n(".select-box-details-pane"));const g=i.$8R(this.w,n(".select-box-dropdown-container-width-control")),r=i.$8R(g,n(".width-control-div"));this.D=document.createElement("span"),this.D.className="option-text-width-control",i.$8R(r,this.D),this.G=0,this.y=i.$PR(this.w),this.w.setAttribute("draggable","true"),this.B(i.$8Q(this.w,i.$1R.DRAG_START,B=>{i.$3R.stop(B,!0)}))}Q(){this.B(i.$9Q(this.h,"change",g=>{this.n=g.target.selectedIndex,this.r.fire({index:g.target.selectedIndex,selected:g.target.value}),this.m[this.n]&&this.m[this.n].text&&this.O(this.m[this.n].text)})),this.B(i.$8Q(this.h,i.$1R.CLICK,g=>{i.$3R.stop(g),this.f?this.Z(!0):this.Y()})),this.B(i.$8Q(this.h,i.$1R.MOUSE_DOWN,g=>{i.$3R.stop(g)}));let o;this.B(i.$8Q(this.h,"touchstart",g=>{o=this.f})),this.B(i.$8Q(this.h,"touchend",g=>{i.$3R.stop(g),o?this.Z(!0):this.Y()})),this.B(i.$8Q(this.h,i.$1R.KEY_DOWN,g=>{const r=new z.$5Q(g);let B=!1;f.$j?(r.keyCode===18||r.keyCode===16||r.keyCode===10||r.keyCode===3)&&(B=!0):(r.keyCode===18&&r.altKey||r.keyCode===16&&r.altKey||r.keyCode===10||r.keyCode===3)&&(B=!0),B&&(this.Y(),i.$3R.stop(g,!0))}))}get onDidSelect(){return this.r.event}setOptions(o,g){$.$ub(this.m,o)||(this.m=o,this.h.options.length=0,this.H=!1,this.L=void 0,this.m.forEach((r,B)=>{this.h.add(this.X(r.text,B,r.isDisabled)),typeof r.description=="string"&&(this.H=!0)})),g!==void 0&&(this.select(g),this.F=this.n)}R(){this.z?.splice(0,this.z.length,this.m)}select(o){o>=0&&o<this.m.length?this.n=o:o>this.m.length-1?this.select(this.m.length-1):this.n<0&&(this.n=0),this.h.selectedIndex=this.n,this.m[this.n]&&this.m[this.n].text&&this.O(this.m[this.n].text)}setAriaLabel(o){this.g.ariaLabel=o,this.h.setAttribute("aria-label",this.g.ariaLabel)}focus(){this.h&&(this.h.tabIndex=0,this.h.focus())}blur(){this.h&&(this.h.tabIndex=-1,this.h.blur())}setFocusable(o){this.h.tabIndex=o?0:-1}render(o){this.j=o,o.classList.add("select-container"),o.appendChild(this.h),this.U()}S(){const o=[];this.s.listFocusBackground&&o.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { background-color: ${this.s.listFocusBackground} !important; }`),this.s.listFocusForeground&&o.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { color: ${this.s.listFocusForeground} !important; }`),this.s.decoratorRightForeground&&o.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.focused) .option-decorator-right { color: ${this.s.decoratorRightForeground}; }`),this.s.selectBackground&&this.s.selectBorder&&this.s.selectBorder!==this.s.selectBackground?(o.push(`.monaco-select-box-dropdown-container { border: 1px solid ${this.s.selectBorder} } `),o.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.s.selectBorder} } `),o.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.s.selectBorder} } `)):this.s.selectListBorder&&(o.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.s.selectListBorder} } `),o.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.s.selectListBorder} } `)),this.s.listHoverForeground&&o.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { color: ${this.s.listHoverForeground} !important; }`),this.s.listHoverBackground&&o.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { background-color: ${this.s.listHoverBackground} !important; }`),this.s.listFocusOutline&&o.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { outline: 1.6px dotted ${this.s.listFocusOutline} !important; outline-offset: -1.6px !important; }`),this.s.listHoverOutline&&o.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { outline: 1.6px dashed ${this.s.listHoverOutline} !important; outline-offset: -1.6px !important; }`),o.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled.focused { background-color: transparent !important; color: inherit !important; outline: none !important; }"),o.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled:hover { background-color: transparent !important; color: inherit !important; outline: none !important; }"),this.y.textContent=o.join(`
`)}U(){const o=this.s.selectBackground??"",g=this.s.selectForeground??"",r=this.s.selectBorder??"";this.h.style.backgroundColor=o,this.h.style.color=g,this.h.style.borderColor=r}W(){const o=this.s.selectBackground??"",g=i.$nS(this.s.selectListBackground,o);this.C.style.backgroundColor=g,this.I.style.backgroundColor=g;const r=this.s.focusBorder??"";this.w.style.outlineColor=r,this.w.style.outlineOffset="-1px",this.z.style(this.s)}X(o,g,r){const B=document.createElement("option");return B.value=o,B.text=o,B.disabled=!!r,B}Y(){this.I.innerText="",!(!this.u||this.f)&&(this.eb(this.w),this.R(),this.u.showContextView({getAnchor:()=>this.h,render:o=>this.ab(o,!0),layout:()=>{this.cb()},onHide:()=>{this.w.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.G},this.g.optionsAsChildren?this.j:void 0),this.f=!0,this.Z(!1),this.u.showContextView({getAnchor:()=>this.h,render:o=>this.ab(o),layout:()=>this.cb(),onHide:()=>{this.w.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.G},this.g.optionsAsChildren?this.j:void 0),this.F=this.n,this.f=!0,this.h.setAttribute("aria-expanded","true"))}Z(o){!this.u||!this.f||(this.f=!1,this.h.setAttribute("aria-expanded","false"),o&&this.h.focus(),this.u.hideContextView())}ab(o,g){return o.appendChild(this.w),this.cb(g),{dispose:()=>{try{o.removeChild(this.w)}catch{}}}}bb(){let o=0;return this.m.forEach((g,r)=>{this.jb(r),this.I.offsetHeight>o&&(o=this.I.offsetHeight)}),o}cb(o){if(this.J)return!1;if(this.z){this.w.classList.add("visible");const g=i.getWindow(this.h),r=i.$rR(this.h),B=i.getWindow(this.h).getComputedStyle(this.h),C=parseFloat(B.getPropertyValue("--dropdown-padding-top"))+parseFloat(B.getPropertyValue("--dropdown-padding-bottom")),L=g.innerHeight-r.top-r.height-(this.g.minBottomMargin||0),M=r.top-p.b,O=this.h.offsetWidth,y=this.db(this.D),x=Math.max(y,Math.round(O)).toString()+"px";this.w.style.width=x,this.z.getHTMLElement().style.height="",this.z.layout();let q=this.z.contentHeight;this.H&&this.L===void 0&&(this.L=this.bb());const I=this.H?this.L:0,j=q+C+I,T=Math.floor((L-C-I)/this.getHeight()),Q=Math.floor((M-C-I)/this.getHeight());if(o)return r.top+r.height>g.innerHeight-22||r.top<p.b||T<1&&Q<1?!1:(T<p.c&&Q>T&&this.m.length>T?(this.G=1,this.w.removeChild(this.C),this.w.removeChild(this.I),this.w.appendChild(this.I),this.w.appendChild(this.C),this.I.classList.remove("border-top"),this.I.classList.add("border-bottom")):(this.G=0,this.w.removeChild(this.C),this.w.removeChild(this.I),this.w.appendChild(this.C),this.w.appendChild(this.I),this.I.classList.remove("border-bottom"),this.I.classList.add("border-top")),!0);if(r.top+r.height>g.innerHeight-22||r.top<p.b||this.G===0&&T<1||this.G===1&&Q<1)return this.Z(!0),!1;if(this.G===0){if(this.f&&T+Q<1)return this.Z(!0),!1;j>L&&(q=T*this.getHeight())}else j>M&&(q=Q*this.getHeight());return this.z.layout(q),this.z.domFocus(),this.z.length>0&&(this.z.setFocus([this.n||0]),this.z.reveal(this.z.getFocus()[0]||0)),this.H?(this.z.getHTMLElement().style.height=q+C+"px",this.w.style.height=""):this.w.style.height=q+C+"px",this.jb(this.n),this.w.style.width=x,this.C.setAttribute("tabindex","0"),this.h.classList.add("synthetic-focus"),this.w.classList.add("synthetic-focus"),!0}else return!1}db(o){let g=0;if(o){let r=0,B=0;this.m.forEach((C,L)=>{const M=C.detail?C.detail.length:0,O=C.decoratorRight?C.decoratorRight.length:0,y=C.text.length+M+O;y>B&&(r=L,B=y)}),o.textContent=this.m[r].text+(this.m[r].decoratorRight?this.m[r].decoratorRight+" ":""),g=i.$tR(o)}return g}eb(o){if(this.z)return;this.C=i.$8R(o,n(".select-box-dropdown-list-container")),this.t=new m,this.z=new b.$ET("SelectBoxCustom",this.C,this,[this.t],{useShadows:!1,verticalScrollMode:3,keyboardSupport:!1,mouseSupport:!1,accessibilityProvider:{getAriaLabel:B=>{let C=B.text;return B.detail&&(C+=`. ${B.detail}`),B.decoratorRight&&(C+=`. ${B.decoratorRight}`),B.description&&(C+=`. ${B.description}`),C},getWidgetAriaLabel:()=>(0,e.localize)(0,null),getRole:()=>f.$j?"":"option",getWidgetRole:()=>"listbox"}}),this.g.ariaLabel&&(this.z.ariaLabel=this.g.ariaLabel);const g=this.B(new N.$_S(this.C,"keydown")),r=w.Event.chain(g.event,B=>B.filter(()=>this.z.length>0).map(C=>new z.$5Q(C)));this.B(w.Event.chain(r,B=>B.filter(C=>C.keyCode===3))(this.lb,this)),this.B(w.Event.chain(r,B=>B.filter(C=>C.keyCode===2))(this.lb,this)),this.B(w.Event.chain(r,B=>B.filter(C=>C.keyCode===9))(this.kb,this)),this.B(w.Event.chain(r,B=>B.filter(C=>C.keyCode===16))(this.nb,this)),this.B(w.Event.chain(r,B=>B.filter(C=>C.keyCode===18))(this.mb,this)),this.B(w.Event.chain(r,B=>B.filter(C=>C.keyCode===12))(this.pb,this)),this.B(w.Event.chain(r,B=>B.filter(C=>C.keyCode===11))(this.ob,this)),this.B(w.Event.chain(r,B=>B.filter(C=>C.keyCode===14))(this.qb,this)),this.B(w.Event.chain(r,B=>B.filter(C=>C.keyCode===13))(this.rb,this)),this.B(w.Event.chain(r,B=>B.filter(C=>C.keyCode>=21&&C.keyCode<=56||C.keyCode>=85&&C.keyCode<=113))(this.sb,this)),this.B(i.$8Q(this.z.getHTMLElement(),i.$1R.POINTER_UP,B=>this.fb(B))),this.B(this.z.onMouseOver(B=>typeof B.index<"u"&&this.z.setFocus([B.index]))),this.B(this.z.onDidChangeFocus(B=>this.ib(B))),this.B(i.$8Q(this.w,i.$1R.FOCUS_OUT,B=>{!this.f||i.$zR(B.relatedTarget,this.w)||this.gb()})),this.z.getHTMLElement().setAttribute("aria-label",this.g.ariaLabel||""),this.z.getHTMLElement().setAttribute("aria-expanded","true"),this.W()}fb(o){if(!this.z.length)return;i.$3R.stop(o);const g=o.target;if(!g||g.classList.contains("slider"))return;const r=g.closest(".monaco-list-row");if(!r)return;const B=Number(r.getAttribute("data-index")),C=r.classList.contains("option-disabled");B>=0&&B<this.m.length&&!C&&(this.n=B,this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0]),this.n!==this.F&&(this.F=this.n,this.r.fire({index:this.h.selectedIndex,selected:this.m[this.n].text}),this.m[this.n]&&this.m[this.n].text&&this.O(this.m[this.n].text)),this.Z(!0))}gb(){this.N||(this.n!==this.F&&this.select(this.F),this.Z(!1))}hb(o,g){const r=C=>{for(let L=0;L<C.childNodes.length;L++){const M=C.childNodes.item(L);(M.tagName&&M.tagName.toLowerCase())==="img"?C.removeChild(M):r(M)}},B=(0,H.$HT)({value:o,supportThemeIcons:!0},{actionHandler:g});return B.element.classList.add("select-box-description-markdown"),r(B.element),B.element}ib(o){!this.f||!this.H||this.jb(o.indexes[0])}jb(o){this.I.innerText="";const g=this.m[o],r=g?.description??"",B=g?.descriptionIsMarkdown??!1;if(r){if(B){const C=g.descriptionMarkdownActionHandler;this.I.appendChild(this.hb(r,C))}else this.I.innerText=r;this.I.style.display="block"}else this.I.style.display="none";this.J=!0,this.u.layout(),this.J=!1}kb(o){i.$3R.stop(o),this.select(this.F),this.Z(!0)}lb(o){i.$3R.stop(o),this.n!==this.F&&(this.F=this.n,this.r.fire({index:this.h.selectedIndex,selected:this.m[this.n].text}),this.m[this.n]&&this.m[this.n].text&&this.O(this.m[this.n].text)),this.Z(!0)}mb(o){if(this.n<this.m.length-1){i.$3R.stop(o,!0);const g=this.m[this.n+1].isDisabled;if(g&&this.m.length>this.n+2)this.n+=2;else{if(g)return;this.n++}this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0])}}nb(o){this.n>0&&(i.$3R.stop(o,!0),this.m[this.n-1].isDisabled&&this.n>1?this.n-=2:this.n--,this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0]))}ob(o){i.$3R.stop(o),this.z.focusPreviousPage(),setTimeout(()=>{this.n=this.z.getFocus()[0],this.m[this.n].isDisabled&&this.n<this.m.length-1&&(this.n++,this.z.setFocus([this.n])),this.z.reveal(this.n),this.select(this.n)},1)}pb(o){i.$3R.stop(o),this.z.focusNextPage(),setTimeout(()=>{this.n=this.z.getFocus()[0],this.m[this.n].isDisabled&&this.n>0&&(this.n--,this.z.setFocus([this.n])),this.z.reveal(this.n),this.select(this.n)},1)}qb(o){i.$3R.stop(o),!(this.m.length<2)&&(this.n=0,this.m[this.n].isDisabled&&this.n>1&&this.n++,this.z.setFocus([this.n]),this.z.reveal(this.n),this.select(this.n))}rb(o){i.$3R.stop(o),!(this.m.length<2)&&(this.n=this.m.length-1,this.m[this.n].isDisabled&&this.n>1&&this.n--,this.z.setFocus([this.n]),this.z.reveal(this.n),this.select(this.n))}sb(o){const g=P.KeyCodeUtils.toString(o.keyCode);let r=-1;for(let B=0;B<this.m.length-1;B++)if(r=(B+this.n+1)%this.m.length,this.m[r].text.charAt(0).toUpperCase()===g&&!this.m[r].isDisabled){this.select(r),this.z.setFocus([r]),this.z.reveal(this.z.getFocus()[0]),i.$3R.stop(o);break}}dispose(){this.Z(!1),super.dispose()}}t.$MT=p}),define(be[132],$e([1,0,43,131,126,21,5,104]),function(ne,t,i,N,z,H,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$PT=t.$OT=void 0,t.$OT={...i.$DT,selectBackground:"#3C3C3C",selectForeground:"#F0F0F0",selectBorder:"#3C3C3C",decoratorRightForeground:void 0,selectListBackground:void 0,selectListBorder:void 0,focusBorder:void 0};class k extends H.$IS{constructor($,w,P,c,f){super(),E.$j&&!f?.useCustomDrawn?this.a=new z.$NT($,w,c,f):this.a=new N.$MT($,w,P,c,f),this.B(this.a)}get onDidSelect(){return this.a.onDidSelect}setOptions($,w){this.a.setOptions($,w)}select($){this.a.select($)}setAriaLabel($){this.a.setAriaLabel($)}focus(){this.a.focus()}blur(){this.a.blur()}setFocusable($){this.a.setFocusable($)}render($){this.a.render($)}}t.$PT=k}),define(be[66],$e([1,0,17,57,2,26,14,33,132,40,3,5,7,109,55]),function(ne,t,i,N,z,H,E,k,b,$,w,P,c,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$XT=t.$WT=t.$VT=void 0;class e extends w.$Uc{get action(){return this._action}constructor(p,v,o={}){super(),this.m=o,this._context=p||this,this._action=v,v instanceof $.$Yi&&this.B(v.onDidChange(g=>{this.element&&this.t(g)}))}t(p){p.enabled!==void 0&&this.u(),p.checked!==void 0&&this.H(),p.class!==void 0&&this.G(),p.label!==void 0&&(this.w(),this.D()),p.tooltip!==void 0&&this.D()}get actionRunner(){return this.j||(this.j=this.B(new $.$Zi)),this.j}set actionRunner(p){this.j=p}isEnabled(){return this._action.enabled}setActionContext(p){this._context=p}render(p){const v=this.element=p;this.B(H.$ES.addTarget(p));const o=this.m&&this.m.draggable;o&&(p.draggable=!0,i.$NQ&&this.B((0,z.$8Q)(p,z.$1R.DRAG_START,g=>g.dataTransfer?.setData(N.$CS.TEXT,this._action.label)))),this.B((0,z.$8Q)(v,H.EventType.Tap,g=>this.onClick(g,!0))),this.B((0,z.$8Q)(v,z.$1R.MOUSE_DOWN,g=>{o||z.$3R.stop(g,!0),this._action.enabled&&g.button===0&&v.classList.add("active")})),P.$j&&this.B((0,z.$8Q)(v,z.$1R.CONTEXT_MENU,g=>{g.button===0&&g.ctrlKey===!0&&this.onClick(g)})),this.B((0,z.$8Q)(v,z.$1R.CLICK,g=>{z.$3R.stop(g,!0),this.m&&this.m.isMenu||this.onClick(g)})),this.B((0,z.$8Q)(v,z.$1R.DBLCLICK,g=>{z.$3R.stop(g,!0)})),[z.$1R.MOUSE_UP,z.$1R.MOUSE_OUT].forEach(g=>{this.B((0,z.$8Q)(v,g,r=>{z.$3R.stop(r),v.classList.remove("active")}))})}onClick(p,v=!1){z.$3R.stop(p,!0);const o=c.$4f(this._context)?this.m?.useEventAsContext?p:{preserveFocus:v}:this._context;this.actionRunner.run(this._action,o)}focus(){this.element&&(this.element.tabIndex=0,this.element.focus(),this.element.classList.add("focused"))}isFocused(){return!!this.element?.classList.contains("focused")}blur(){this.element&&(this.element.blur(),this.element.tabIndex=-1,this.element.classList.remove("focused"))}setFocusable(p){this.element&&(this.element.tabIndex=p?0:-1)}get trapsArrowNavigation(){return!1}u(){}w(){}z(){return this.action.class}C(){return this.action.tooltip}D(){if(!this.element)return;const p=this.C()??"";if(this.F(),this.m.hoverDelegate?.showNativeHover)this.element.title=p;else if(!this.f&&p!==""){const v=this.m.hoverDelegate??(0,E.$2S)("element");this.f=this.q.add((0,k.$ZS)(v,this.element,p))}else this.f&&this.f.update(p)}F(){if(this.element){const p=this.C()??"";this.element.setAttribute("aria-label",p)}}G(){}H(){}dispose(){this.element&&(this.element.remove(),this.element=void 0),this._context=void 0,super.dispose()}}t.$VT=e;class n extends e{constructor(p,v,o){super(p,v,o),this.m=o,this.m.icon=o.icon!==void 0?o.icon:!1,this.m.label=o.label!==void 0?o.label:!0,this.L=""}render(p){super.render(p),c.$5f(this.element);const v=document.createElement("a");if(v.classList.add("action-label"),v.setAttribute("role",this.M()),this.I=v,this.element.appendChild(v),this.m.label&&this.m.keybinding){const o=document.createElement("span");o.classList.add("keybinding"),o.textContent=this.m.keybinding,this.element.appendChild(o)}this.G(),this.w(),this.D(),this.u(),this.H()}M(){return this._action.id===$.$1i.ID?"presentation":this.m.isMenu?"menuitem":"button"}focus(){this.I&&(this.I.tabIndex=0,this.I.focus())}isFocused(){return!!this.I&&this.I?.tabIndex===0}blur(){this.I&&(this.I.tabIndex=-1)}setFocusable(p){this.I&&(this.I.tabIndex=p?0:-1)}w(){this.m.label&&this.I&&(this.I.textContent=this.action.label)}C(){let p=null;return this.action.tooltip?p=this.action.tooltip:!this.m.label&&this.action.label&&this.m.icon&&(p=this.action.label,this.m.keybinding&&(p=f.localize(0,null,p,this.m.keybinding))),p??void 0}G(){this.L&&this.I&&this.I.classList.remove(...this.L.split(" ")),this.m.icon?(this.L=this.z(),this.I&&(this.I.classList.add("codicon"),this.L&&this.I.classList.add(...this.L.split(" "))),this.u()):this.I?.classList.remove("codicon")}u(){this.action.enabled?(this.I&&(this.I.removeAttribute("aria-disabled"),this.I.classList.remove("disabled")),this.element?.classList.remove("disabled")):(this.I&&(this.I.setAttribute("aria-disabled","true"),this.I.classList.add("disabled")),this.element?.classList.add("disabled"))}F(){if(this.I){const p=this.C()??"";this.I.setAttribute("aria-label",p)}}H(){this.I&&(this.action.checked!==void 0?(this.I.classList.toggle("checked",this.action.checked),this.I.setAttribute("aria-checked",this.action.checked?"true":"false"),this.I.setAttribute("role","checkbox")):(this.I.classList.remove("checked"),this.I.removeAttribute("aria-checked"),this.I.setAttribute("role",this.M())))}}t.$WT=n;class h extends e{constructor(p,v,o,g,r,B,C){super(p,v),this.b=new b.$PT(o,g,r,B,C),this.b.setFocusable(!1),this.B(this.b),this.g()}setOptions(p,v){this.b.setOptions(p,v)}select(p){this.b.select(p)}g(){this.B(this.b.onDidSelect(p=>this.n(p.selected,p.index)))}n(p,v){this.actionRunner.run(this._action,this.r(p,v))}r(p,v){return p}setFocusable(p){this.b.setFocusable(p)}focus(){this.b?.focus()}blur(){this.b?.blur()}render(p){this.b.render(p)}}t.$XT=h}),define(be[67],$e([1,0,2,15,66,14,40,4,3,7,55]),function(ne,t,i,N,z,H,E,k,b,$){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4S=t.ActionsOrientation=void 0,t.$5S=c;var w;(function(f){f[f.HORIZONTAL=0]="HORIZONTAL",f[f.VERTICAL=1]="VERTICAL"})(w||(t.ActionsOrientation=w={}));class P extends b.$Uc{constructor(e,n={}){super(),this.j=this.B(new b.$Tc),this.s=this.B(new b.$4c),this.y=!1,this.z=!0,this.D=this.B(new k.$7d),this.onDidBlur=this.D.event,this.F=this.B(new k.$7d({onWillAddFirstListener:()=>this.G=!0})),this.onDidCancel=this.F.event,this.G=!1,this.H=this.B(new k.$7d),this.onDidRun=this.H.event,this.I=this.B(new k.$7d),this.onWillRun=this.I.event,this.b=n,this.m=n.context??null,this.n=this.b.orientation??0,this.r={keyDown:this.b.triggerKeys?.keyDown??!1,keys:this.b.triggerKeys?.keys??[3,10]},this.f=n.hoverDelegate??this.B((0,H.$3S)()),this.b.actionRunner?this.g=this.b.actionRunner:(this.g=new E.$Zi,this.j.add(this.g)),this.j.add(this.g.onDidRun(p=>this.H.fire(p))),this.j.add(this.g.onWillRun(p=>this.I.fire(p))),this.viewItems=[],this.u=void 0,this.domNode=document.createElement("div"),this.domNode.className="monaco-action-bar";let h,m;switch(this.n){case 0:h=[15],m=[17];break;case 1:h=[16],m=[18],this.domNode.className+=" vertical";break}this.B(i.$8Q(this.domNode,i.$1R.KEY_DOWN,p=>{const v=new N.$5Q(p);let o=!0;const g=typeof this.u=="number"?this.viewItems[this.u]:void 0;h&&(v.equals(h[0])||v.equals(h[1]))?o=this.Q():m&&(v.equals(m[0])||v.equals(m[1]))?o=this.P():v.equals(9)&&this.G?this.F.fire():v.equals(14)?o=this.N():v.equals(13)?o=this.O():v.equals(2)&&g instanceof z.$VT&&g.trapsArrowNavigation?o=this.P():this.L(v)?this.r.keyDown?this.S(v):this.y=!0:o=!1,o&&(v.preventDefault(),v.stopPropagation())})),this.B(i.$8Q(this.domNode,i.$1R.KEY_UP,p=>{const v=new N.$5Q(p);this.L(v)?(!this.r.keyDown&&this.y&&(this.y=!1,this.S(v)),v.preventDefault(),v.stopPropagation()):(v.equals(2)||v.equals(1026)||v.equals(16)||v.equals(18)||v.equals(15)||v.equals(17))&&this.M()})),this.w=this.B(i.$6R(this.domNode)),this.B(this.w.onDidBlur(()=>{(i.$HR()===this.domNode||!i.$zR(i.$HR(),this.domNode))&&(this.D.fire(),this.t=this.u,this.u=void 0,this.y=!1)})),this.B(this.w.onDidFocus(()=>this.M())),this.C=document.createElement("ul"),this.C.className="actions-container",this.b.highlightToggledItems&&this.C.classList.add("highlight-toggled"),this.C.setAttribute("role",this.b.ariaRole||"toolbar"),this.b.ariaLabel&&this.C.setAttribute("aria-label",this.b.ariaLabel),this.domNode.appendChild(this.C),e.appendChild(this.domNode)}J(){this.length()>=1?this.C.setAttribute("role",this.b.ariaRole||"toolbar"):this.C.setAttribute("role","presentation")}setAriaLabel(e){e?this.C.setAttribute("aria-label",e):this.C.removeAttribute("aria-label")}setFocusable(e){if(this.z=e,this.z){const n=this.viewItems.find(h=>h instanceof z.$VT&&h.isEnabled());n instanceof z.$VT&&n.setFocusable(!0)}else this.viewItems.forEach(n=>{n instanceof z.$VT&&n.setFocusable(!1)})}L(e){let n=!1;return this.r.keys.forEach(h=>{n=n||e.equals(h)}),n}M(){for(let e=0;e<this.C.children.length;e++){const n=this.C.children[e];if(i.$zR(i.$HR(),n)){this.u=e,this.viewItems[this.u]?.showHover?.();break}}}get context(){return this.m}set context(e){this.m=e,this.viewItems.forEach(n=>n.setActionContext(e))}get actionRunner(){return this.g}set actionRunner(e){this.g=e,this.j.clear(),this.j.add(this.g.onDidRun(n=>this.H.fire(n))),this.j.add(this.g.onWillRun(n=>this.I.fire(n))),this.viewItems.forEach(n=>n.actionRunner=e)}getContainer(){return this.domNode}hasAction(e){return this.viewItems.findIndex(n=>n.action.id===e.id)!==-1}getAction(e){if(typeof e=="number")return this.viewItems[e]?.action;if(e instanceof HTMLElement){for(;e.parentElement!==this.C;){if(!e.parentElement)return;e=e.parentElement}for(let n=0;n<this.C.childNodes.length;n++)if(this.C.childNodes[n]===e)return this.viewItems[n].action}}push(e,n={}){const h=Array.isArray(e)?e:[e];let m=$.$Yf(n.index)?n.index:null;h.forEach(p=>{const v=document.createElement("li");v.className="action-item",v.setAttribute("role","presentation");let o;const g={hoverDelegate:this.f,...n};this.b.actionViewItemProvider&&(o=this.b.actionViewItemProvider(p,g)),o||(o=new z.$WT(this.context,p,g)),this.b.allowContextMenu||this.s.set(o,i.$8Q(v,i.$1R.CONTEXT_MENU,r=>{i.$3R.stop(r,!0)})),o.actionRunner=this.g,o.setActionContext(this.context),o.render(v),this.z&&o instanceof z.$VT&&this.viewItems.length===0&&o.setFocusable(!0),m===null||m<0||m>=this.C.children.length?(this.C.appendChild(v),this.viewItems.push(o)):(this.C.insertBefore(v,this.C.children[m]),this.viewItems.splice(m,0,o),m++)}),typeof this.u=="number"&&this.focus(this.u),this.J()}getWidth(e){if(e>=0&&e<this.C.children.length){const n=this.C.children.item(e);if(n)return n.clientWidth}return 0}getHeight(e){if(e>=0&&e<this.C.children.length){const n=this.C.children.item(e);if(n)return n.clientHeight}return 0}pull(e){e>=0&&e<this.viewItems.length&&(this.C.removeChild(this.C.childNodes[e]),this.s.deleteAndDispose(this.viewItems[e]),(0,b.$Pc)(this.viewItems.splice(e,1)),this.J())}clear(){this.isEmpty()||(this.viewItems=(0,b.$Pc)(this.viewItems),this.s.clearAndDisposeAll(),i.$7Q(this.C),this.J())}length(){return this.viewItems.length}isEmpty(){return this.viewItems.length===0}focus(e){let n=!1,h;if(e===void 0?n=!0:typeof e=="number"?h=e:typeof e=="boolean"&&(n=e),n&&typeof this.u>"u"){const m=this.viewItems.findIndex(p=>p.isEnabled());this.u=m===-1?void 0:m,this.R(void 0,void 0,!0)}else h!==void 0&&(this.u=h),this.R(void 0,void 0,!0)}N(){return this.u=this.length()-1,this.P(!0)}O(){return this.u=0,this.Q(!0)}P(e){if(typeof this.u>"u")this.u=this.viewItems.length-1;else if(this.viewItems.length<=1)return!1;const n=this.u;let h;do{if(!e&&this.b.preventLoopNavigation&&this.u+1>=this.viewItems.length)return this.u=n,!1;this.u=(this.u+1)%this.viewItems.length,h=this.viewItems[this.u]}while(this.u!==n&&(this.b.focusOnlyEnabledItems&&!h.isEnabled()||h.action.id===E.$1i.ID));return this.R(),!0}Q(e){if(typeof this.u>"u")this.u=0;else if(this.viewItems.length<=1)return!1;const n=this.u;let h;do{if(this.u=this.u-1,this.u<0){if(!e&&this.b.preventLoopNavigation)return this.u=n,!1;this.u=this.viewItems.length-1}h=this.viewItems[this.u]}while(this.u!==n&&(this.b.focusOnlyEnabledItems&&!h.isEnabled()||h.action.id===E.$1i.ID));return this.R(!0),!0}R(e,n,h=!1){typeof this.u>"u"&&this.C.focus({preventScroll:n}),this.t!==void 0&&this.t!==this.u&&this.viewItems[this.t]?.blur();const m=this.u!==void 0?this.viewItems[this.u]:void 0;if(m){let p=!0;$.$9f(m.focus)||(p=!1),this.b.focusOnlyEnabledItems&&$.$9f(m.isEnabled)&&!m.isEnabled()&&(p=!1),m.action.id===E.$1i.ID&&(p=!1),p?(h||this.t!==this.u)&&(m.focus(e),this.t=this.u):(this.C.focus({preventScroll:n}),this.t=void 0),p&&m.showHover?.()}}S(e){if(typeof this.u>"u")return;const n=this.viewItems[this.u];if(n instanceof z.$VT){const h=n._context===null||n._context===void 0?e:n._context;this.run(n._action,h)}}async run(e,n){await this.g.run(e,n)}dispose(){this.m=void 0,this.viewItems=(0,b.$Pc)(this.viewItems),this.getContainer().remove(),super.dispose()}}t.$4S=P;function c(f){if(!f.length)return f;let e=-1;for(let h=0;h<f.length;h++)if(f[h].id!==E.$1i.ID){e=h;break}if(e===-1)return[];f=f.slice(e);for(let h=f.length-1;h>=0&&f[h].id===E.$1i.ID;h--)f.splice(h,1);let n=!1;for(let h=f.length-1;h>=0;h--){const m=f[h].id===E.$1i.ID;m&&!n?f.splice(h,1):m?m&&(n=!1):n=!0}return f}}),define(be[68],$e([1,0,2,24,58,67,60,14,33,63,21,4,85,54,113,101]),function(ne,t,i,N,z,H,E,k,b,$,w,P,c,f,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$DU=t.$CU=t.$BU=t.MessageType=void 0;const n=i.$;var h;(function(v){v[v.INFO=1]="INFO",v[v.WARNING=2]="WARNING",v[v.ERROR=3]="ERROR"})(h||(t.MessageType=h={})),t.$BU={inputBackground:"#3C3C3C",inputForeground:"#CCCCCC",inputValidationInfoBorder:"#55AAFF",inputValidationInfoBackground:"#063B49",inputValidationWarningBorder:"#B89500",inputValidationWarningBackground:"#352A05",inputValidationErrorBorder:"#BE1100",inputValidationErrorBackground:"#5A1D1D",inputBorder:void 0,inputValidationErrorForeground:void 0,inputValidationInfoForeground:void 0,inputValidationWarningForeground:void 0};class m extends w.$IS{constructor(o,g,r){super(),this.w="idle",this.M=Number.POSITIVE_INFINITY,this.P=this.B(new P.$7d),this.onDidChange=this.P.event,this.Q=this.B(new P.$7d),this.onDidHeightChange=this.Q.event,this.a=g,this.g=r,this.h=null,this.n=this.g.placeholder||"",this.r=this.g.tooltip??(this.n||""),this.s=this.g.ariaLabel||"",this.g.validationOptions&&(this.t=this.g.validationOptions.validation),this.element=i.$8R(o,n(".monaco-inputbox.idle"));const B=this.g.flexibleHeight?"textarea":"input",C=i.$8R(this.element,n(".ibwrapper"));if(this.b=i.$8R(C,n(B+".input.empty")),this.b.setAttribute("autocorrect","off"),this.b.setAttribute("autocapitalize","off"),this.b.setAttribute("spellcheck","false"),this.G(this.b,()=>this.element.classList.add("synthetic-focus")),this.F(this.b,()=>this.element.classList.remove("synthetic-focus")),this.g.flexibleHeight){this.M=typeof this.g.flexibleMaxHeight=="number"?this.g.flexibleMaxHeight:Number.POSITIVE_INFINITY,this.y=i.$8R(C,n("div.mirror")),this.y.innerText="\xA0",this.N=new $.$SS(this.element,{vertical:1}),this.g.flexibleWidth&&(this.b.setAttribute("wrap","off"),this.y.style.whiteSpace="pre",this.y.style.wordWrap="initial"),i.$8R(o,this.N.getDomNode()),this.B(this.N),this.B(this.N.onScroll(O=>this.b.scrollTop=O.scrollTop));const L=this.B(new N.$_S(o.ownerDocument,"selectionchange")),M=P.Event.filter(L.event,()=>o.ownerDocument.getSelection()?.anchorNode===C);this.B(M(this.U,this)),this.B(this.onDidHeightChange(this.U,this))}else this.b.type=this.g.type||"text",this.b.setAttribute("wrap","off");this.s&&this.b.setAttribute("aria-label",this.s),this.n&&!this.g.showPlaceholderOnFocus&&this.setPlaceHolder(this.n),this.r&&this.setTooltip(this.r),this.D(this.b,()=>this.Z()),this.F(this.b,()=>this.R()),this.G(this.b,()=>this.S()),this.B(this.I(this.b)),setTimeout(()=>this.ab(),0),this.g.actions&&(this.c=this.B(new H.$4S(this.element)),this.c.push(this.g.actions,{icon:!0,label:!1})),this.bb()}R(){this.Y(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder","")}S(){this.X(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder",this.n||"")}setPlaceHolder(o){this.n=o,this.b.setAttribute("placeholder",o)}setTooltip(o){this.r=o,this.O?this.O.update(o):this.O=this.B((0,b.$ZS)((0,k.$2S)("mouse"),this.b,o))}setAriaLabel(o){this.s=o,o?this.b.setAttribute("aria-label",this.s):this.b.removeAttribute("aria-label")}getAriaLabel(){return this.s}get mirrorElement(){return this.y}get inputElement(){return this.b}get value(){return this.b.value}set value(o){this.b.value!==o&&(this.b.value=o,this.Z())}get step(){return this.b.step}set step(o){this.b.step=o}get height(){return typeof this.J=="number"?this.J:i.$xR(this.element)}focus(){this.b.focus()}blur(){this.b.blur()}hasFocus(){return i.$IR(this.b)}select(o=null){this.b.select(),o&&(this.b.setSelectionRange(o.start,o.end),o.end===this.b.value.length&&(this.b.scrollLeft=this.b.scrollWidth))}isSelectionAtEnd(){return this.b.selectionEnd===this.b.value.length&&this.b.selectionStart===this.b.selectionEnd}enable(){this.b.removeAttribute("disabled")}disable(){this.blur(),this.b.disabled=!0,this.Y()}setEnabled(o){o?this.enable():this.disable()}get width(){return i.$tR(this.b)}set width(o){if(this.g.flexibleHeight&&this.g.flexibleWidth){let g=0;if(this.y){const r=parseFloat(this.y.style.paddingLeft||"")||0,B=parseFloat(this.y.style.paddingRight||"")||0;g=r+B}this.b.style.width=o-g+"px"}else this.b.style.width=o+"px";this.y&&(this.y.style.width=o+"px")}set paddingRight(o){this.b.style.width=`calc(100% - ${o}px)`,this.y&&(this.y.style.paddingRight=o+"px")}U(){if(typeof this.L!="number"||typeof this.J!="number"||!this.N)return;const o=this.L,g=this.J,r=this.b.scrollTop;this.N.setScrollDimensions({scrollHeight:o,height:g}),this.N.setScrollPosition({scrollTop:r})}showMessage(o,g){if(this.w==="open"&&(0,f.$Rn)(this.h,o))return;this.h=o,this.element.classList.remove("idle"),this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add(this.W(o.type));const r=this.stylesForType(this.h.type);this.element.style.border=`1px solid ${i.$nS(r.border,"transparent")}`,this.h.content&&(this.hasFocus()||g)&&this.X()}hideMessage(){this.h=null,this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add("idle"),this.Y(),this.bb()}isInputValid(){return!!this.t&&!this.t(this.value)}validate(){let o=null;return this.t&&(o=this.t(this.value),o?(this.inputElement.setAttribute("aria-invalid","true"),this.showMessage(o)):this.inputElement.hasAttribute("aria-invalid")&&(this.inputElement.removeAttribute("aria-invalid"),this.hideMessage())),o?.type}stylesForType(o){const g=this.g.inputBoxStyles;switch(o){case 1:return{border:g.inputValidationInfoBorder,background:g.inputValidationInfoBackground,foreground:g.inputValidationInfoForeground};case 2:return{border:g.inputValidationWarningBorder,background:g.inputValidationWarningBackground,foreground:g.inputValidationWarningForeground};default:return{border:g.inputValidationErrorBorder,background:g.inputValidationErrorBackground,foreground:g.inputValidationErrorForeground}}}W(o){switch(o){case 1:return"info";case 2:return"warning";default:return"error"}}X(){if(!this.a||!this.h)return;let o;const g=()=>o.style.width=i.$tR(this.element)+"px";this.a.showContextView({getAnchor:()=>this.element,anchorAlignment:1,render:B=>{if(!this.h)return null;o=i.$8R(B,n(".monaco-inputbox-container")),g();const C={inline:!0,className:"monaco-inputbox-message"},L=this.h.formatContent?(0,z.$0S)(this.h.content,C):(0,z.$9S)(this.h.content,C);L.classList.add(this.W(this.h.type));const M=this.stylesForType(this.h.type);return L.style.backgroundColor=M.background??"",L.style.color=M.foreground??"",L.style.border=M.border?`1px solid ${M.border}`:"",i.$8R(o,L),null},onHide:()=>{this.w="closed"},layout:g});let r;this.h.type===3?r=e.localize(0,null,this.h.content):this.h.type===2?r=e.localize(1,null,this.h.content):r=e.localize(2,null,this.h.content),E.$bT(r),this.w="open"}Y(){this.a&&(this.w==="open"&&this.a.hideContextView(),this.w="idle")}Z(){this.P.fire(this.value),this.validate(),this.ab(),this.b.classList.toggle("empty",!this.value),this.w==="open"&&this.a&&this.a.layout()}ab(){if(!this.y)return;const o=this.value,r=o.charCodeAt(o.length-1)===10?" ":"";(o+r).replace(/\u000c/g,"")?this.y.textContent=o+r:this.y.innerText="\xA0",this.layout()}bb(){const o=this.g.inputBoxStyles,g=o.inputBackground??"",r=o.inputForeground??"",B=o.inputBorder??"";this.element.style.backgroundColor=g,this.element.style.color=r,this.b.style.backgroundColor="inherit",this.b.style.color=r,this.element.style.border=`1px solid ${i.$nS(B,"transparent")}`}layout(){if(!this.y)return;const o=this.L;this.L=i.$xR(this.y),o!==this.L&&(this.J=Math.min(this.L,this.M),this.b.style.height=this.J+"px",this.Q.fire(this.L))}insertAtCursor(o){const g=this.inputElement,r=g.selectionStart,B=g.selectionEnd,C=g.value;r!==null&&B!==null&&(this.value=C.substr(0,r)+o+C.substr(B),g.setSelectionRange(r+1,r+1),this.layout())}dispose(){this.Y(),this.h=null,this.c?.dispose(),super.dispose()}}t.$CU=m;class p extends m{constructor(o,g,r){const B=e.localize(3,null,"\u21C5"),C=e.localize(4,null,"\u21C5");super(o,g,r),this.eb=this.B(new P.$7d),this.onDidFocus=this.eb.event,this.fb=this.B(new P.$7d),this.onDidBlur=this.fb.event,this.cb=new c.$zU(r.history,100);const L=()=>{if(r.showHistoryHint&&r.showHistoryHint()&&!this.n.endsWith(B)&&!this.n.endsWith(C)&&this.cb.getHistory().length){const M=this.n.endsWith(")")?B:C,O=this.n+M;r.showPlaceholderOnFocus&&!i.$IR(this.b)?this.n=O:this.setPlaceHolder(O)}};this.db=new MutationObserver((M,O)=>{M.forEach(y=>{y.target.textContent||L()})}),this.db.observe(this.b,{attributeFilter:["class"]}),this.G(this.b,()=>L()),this.F(this.b,()=>{const M=O=>{if(this.n.endsWith(O)){const y=this.n.slice(0,this.n.length-O.length);return r.showPlaceholderOnFocus?this.n=y:this.setPlaceHolder(y),!0}else return!1};M(C)||M(B)})}dispose(){super.dispose(),this.db&&(this.db.disconnect(),this.db=void 0)}addToHistory(o){this.value&&(o||this.value!==this.ib())&&this.cb.add(this.value)}prependHistory(o){const g=this.getHistory();this.clearHistory(),o.forEach(r=>{this.cb.add(r)}),g.forEach(r=>{this.cb.add(r)})}getHistory(){return this.cb.getHistory()}isAtFirstInHistory(){return this.cb.isFirst()}isAtLastInHistory(){return this.cb.isLast()}isNowhereInHistory(){return this.cb.isNowhere()}showNextValue(){this.cb.has(this.value)||this.addToHistory();let o=this.kb();o&&(o=o===this.value?this.kb():o),this.value=o??"",E.$cT(this.value?this.value:e.localize(5,null))}showPreviousValue(){this.cb.has(this.value)||this.addToHistory();let o=this.jb();o&&(o=o===this.value?this.jb():o),o&&(this.value=o,E.$cT(this.value))}clearHistory(){this.cb.clear()}setPlaceHolder(o){super.setPlaceHolder(o),this.setTooltip(o)}R(){super.R(),this.fb.fire()}S(){super.S(),this.eb.fire()}ib(){let o=this.cb.current();return o||(o=this.cb.last(),this.cb.next()),o}jb(){return this.cb.previous()||this.cb.first()}kb(){return this.cb.next()}}t.$DU=p}),define(be[69],$e([1,0,66,21,18,19,4,2,33,14,106]),function(ne,t,i,N,z,H,E,k,b,$){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$UT=t.$TT=t.$ST=t.$RT=t.$QT=void 0,t.$QT={inputActiveOptionBorder:"#007ACC00",inputActiveOptionForeground:"#FFFFFF",inputActiveOptionBackground:"#0E639C50"};class w extends i.$VT{constructor(n,h,m){super(n,h,m),this.a=this.B(new P({actionClassName:this._action.class,isChecked:!!this._action.checked,title:this.m.keybinding?`${this._action.label} (${this.m.keybinding})`:this._action.label,notFocusable:!0,inputActiveOptionBackground:m.toggleStyles?.inputActiveOptionBackground,inputActiveOptionBorder:m.toggleStyles?.inputActiveOptionBorder,inputActiveOptionForeground:m.toggleStyles?.inputActiveOptionForeground,hoverDelegate:m.hoverDelegate})),this.B(this.a.onChange(()=>this._action.checked=!!this.a&&this.a.checked))}render(n){this.element=n,this.element.appendChild(this.a.domNode)}u(){this.a&&(this.isEnabled()?this.a.enable():this.a.disable())}H(){this.a.checked=!!this._action.checked}focus(){this.a.domNode.tabIndex=0,this.a.focus()}blur(){this.a.domNode.tabIndex=-1,this.a.domNode.blur()}setFocusable(n){this.a.domNode.tabIndex=n?0:-1}}t.$RT=w;class P extends N.$IS{constructor(n){super(),this.a=this.B(new E.$7d),this.onChange=this.a.event,this.b=this.B(new E.$7d),this.onKeyDown=this.b.event,this.c=n,this.s=this.c.isChecked;const h=["monaco-custom-toggle"];this.c.icon&&(this.g=this.c.icon,h.push(...H.ThemeIcon.asClassNameArray(this.g))),this.c.actionClassName&&h.push(...this.c.actionClassName.split(" ")),this.s&&h.push("checked"),this.domNode=document.createElement("div"),this.t=this.B((0,b.$ZS)(n.hoverDelegate??(0,$.$2S)("mouse"),this.domNode,this.c.title)),this.domNode.classList.add(...h),this.c.notFocusable||(this.domNode.tabIndex=0),this.domNode.setAttribute("role","checkbox"),this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.setAttribute("aria-label",this.c.title),this.w(),this.f(this.domNode,m=>{this.enabled&&(this.checked=!this.s,this.a.fire(!1),m.preventDefault())}),this.B(this.I(this.domNode)),this.z(this.domNode,m=>{if(m.keyCode===10||m.keyCode===3){this.checked=!this.s,this.a.fire(!0),m.preventDefault(),m.stopPropagation();return}this.b.fire(m)})}get enabled(){return this.domNode.getAttribute("aria-disabled")!=="true"}focus(){this.domNode.focus()}get checked(){return this.s}set checked(n){this.s=n,this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.classList.toggle("checked",this.s),this.w()}setIcon(n){this.g&&this.domNode.classList.remove(...H.ThemeIcon.asClassNameArray(this.g)),this.g=n,this.g&&this.domNode.classList.add(...H.ThemeIcon.asClassNameArray(this.g))}width(){return 22}w(){this.domNode&&(this.domNode.style.borderColor=this.s&&this.c.inputActiveOptionBorder||"",this.domNode.style.color=this.s&&this.c.inputActiveOptionForeground||"inherit",this.domNode.style.backgroundColor=this.s&&this.c.inputActiveOptionBackground||"")}enable(){this.domNode.setAttribute("aria-disabled",String(!1))}disable(){this.domNode.setAttribute("aria-disabled",String(!0))}setTitle(n){this.t.update(n),this.domNode.setAttribute("aria-label",n)}}t.$ST=P;class c extends N.$IS{constructor(n,h,m){super(),this.g=n,this.h=h,this.a=this.B(new E.$7d),this.onChange=this.a.event,this.b=new P({title:this.g,isChecked:this.h,icon:z.$Gj.check,actionClassName:"monaco-checkbox",...t.$QT}),this.domNode=this.b.domNode,this.c=m,this.n(),this.B(this.b.onChange(p=>{this.n(),this.a.fire(p)}))}get checked(){return this.b.checked}set checked(n){this.b.checked=n,this.n()}focus(){this.domNode.focus()}hasFocus(){return(0,k.$IR)(this.domNode)}enable(){this.b.enable()}disable(){this.b.disable()}n(){this.domNode.style.color=this.c.checkboxForeground||"",this.domNode.style.backgroundColor=this.c.checkboxBackground||"",this.domNode.style.borderColor=this.c.checkboxBorder||""}}t.$TT=c;class f extends i.$VT{constructor(n,h,m){super(n,h,m),this.a=this.B(new c(this._action.label,!!this._action.checked,m.checkboxStyles)),this.B(this.a.onChange(()=>this.c()))}render(n){if(this.element=n,this.element.classList.add("checkbox-action-item"),this.element.appendChild(this.a.domNode),this.m.label&&this._action.label){const h=this.element.appendChild((0,k.$)("span.checkbox-label",void 0,this._action.label));this.B((0,k.$8Q)(h,k.$1R.CLICK,m=>{this.a.checked=!this.a.checked,m.stopPropagation(),m.preventDefault(),this.c()}))}this.u(),this.G(),this.H()}c(){this._action.checked=!!this.a&&this.a.checked,this.actionRunner.run(this._action,this._context)}u(){this.isEnabled()?this.a.enable():this.a.disable(),this.action.enabled?this.element?.classList.remove("disabled"):this.element?.classList.add("disabled")}H(){this.a.checked=!!this._action.checked}G(){this.b&&this.a.domNode.classList.remove(...this.b.split(" ")),this.b=this.z(),this.b&&this.a.domNode.classList.add(...this.b.split(" "))}focus(){this.a.domNode.tabIndex=0,this.a.focus()}blur(){this.a.domNode.tabIndex=-1,this.a.domNode.blur()}setFocusable(n){this.a.domNode.tabIndex=n?0:-1}}t.$UT=f}),define(be[133],$e([1,0,14,69,18,111]),function(ne,t,i,N,z,H){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$QU=t.$PU=t.$OU=void 0;const E=H.localize(0,null),k=H.localize(1,null),b=H.localize(2,null);class $ extends N.$ST{constructor(f){super({icon:z.$Gj.caseSensitive,title:E+f.appendTitle,isChecked:f.isChecked,hoverDelegate:f.hoverDelegate??(0,i.$2S)("element"),inputActiveOptionBorder:f.inputActiveOptionBorder,inputActiveOptionForeground:f.inputActiveOptionForeground,inputActiveOptionBackground:f.inputActiveOptionBackground})}}t.$OU=$;class w extends N.$ST{constructor(f){super({icon:z.$Gj.wholeWord,title:k+f.appendTitle,isChecked:f.isChecked,hoverDelegate:f.hoverDelegate??(0,i.$2S)("element"),inputActiveOptionBorder:f.inputActiveOptionBorder,inputActiveOptionForeground:f.inputActiveOptionForeground,inputActiveOptionBackground:f.inputActiveOptionBackground})}}t.$PU=w;class P extends N.$ST{constructor(f){super({icon:z.$Gj.regex,title:b+f.appendTitle,isChecked:f.isChecked,hoverDelegate:f.hoverDelegate??(0,i.$2S)("element"),inputActiveOptionBorder:f.inputActiveOptionBorder,inputActiveOptionForeground:f.inputActiveOptionForeground,inputActiveOptionBackground:f.inputActiveOptionBackground})}}t.$QU=P}),define(be[134],$e([1,0,2,133,68,21,4,110,3,14,100]),function(ne,t,i,N,z,H,E,k,b,$){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$RU=void 0;const w=k.localize(0,null);class P extends H.$IS{static{this.OPTION_CHANGE="optionChange"}constructor(f,e,n){super(),this.n=!0,this.s=!1,this.w=this.B(new b.$Vc),this.N=[],this.O=this.B(new E.$7d),this.onDidOptionChange=this.O.event,this.P=this.B(new E.$7d),this.onKeyDown=this.P.event,this.Q=this.B(new E.$7d),this.onMouseDown=this.Q.event,this.R=this.B(new E.$7d),this.onInput=this.R.event,this.S=this.B(new E.$7d),this.onKeyUp=this.S.event,this.U=this.B(new E.$7d),this.onCaseSensitiveKeyDown=this.U.event,this.W=this.B(new E.$7d),this.onRegexKeyDown=this.W.event,this.Y=0,this.a=n.placeholder||"",this.b=n.validation,this.c=n.label||w,this.h=!!n.showCommonFindToggles;const h=n.appendCaseSensitiveLabel||"",m=n.appendWholeWordsLabel||"",p=n.appendRegexLabel||"",v=n.history||[],o=!!n.flexibleHeight,g=!!n.flexibleWidth,r=n.flexibleMaxHeight;this.domNode=document.createElement("div"),this.domNode.classList.add("monaco-findInput"),this.inputBox=this.B(new z.$DU(this.domNode,e,{placeholder:this.a||"",ariaLabel:this.c||"",validationOptions:{validation:this.b},history:v,showHistoryHint:n.showHistoryHint,flexibleHeight:o,flexibleWidth:g,flexibleMaxHeight:r,inputBoxStyles:n.inputBoxStyles}));const B=this.B((0,$.$3S)());if(this.h){this.J=this.B(new N.$QU({appendTitle:p,isChecked:!1,hoverDelegate:B,...n.toggleStyles})),this.B(this.J.onChange(L=>{this.O.fire(L),!L&&this.n&&this.inputBox.focus(),this.validate()})),this.B(this.J.onKeyDown(L=>{this.W.fire(L)})),this.L=this.B(new N.$PU({appendTitle:m,isChecked:!1,hoverDelegate:B,...n.toggleStyles})),this.B(this.L.onChange(L=>{this.O.fire(L),!L&&this.n&&this.inputBox.focus(),this.validate()})),this.M=this.B(new N.$OU({appendTitle:h,isChecked:!1,hoverDelegate:B,...n.toggleStyles})),this.B(this.M.onChange(L=>{this.O.fire(L),!L&&this.n&&this.inputBox.focus(),this.validate()})),this.B(this.M.onKeyDown(L=>{this.U.fire(L)}));const C=[this.M.domNode,this.L.domNode,this.J.domNode];this.z(this.domNode,L=>{if(L.equals(15)||L.equals(17)||L.equals(9)){const M=C.indexOf(this.domNode.ownerDocument.activeElement);if(M>=0){let O=-1;L.equals(17)?O=(M+1)%C.length:L.equals(15)&&(M===0?O=C.length-1:O=M-1),L.equals(9)?(C[M].blur(),this.inputBox.focus()):O>=0&&C[O].focus(),i.$3R.stop(L,!0)}}})}this.y=document.createElement("div"),this.y.className="controls",this.y.style.display=this.h?"":"none",this.M&&this.y.append(this.M.domNode),this.L&&this.y.appendChild(this.L.domNode),this.J&&this.y.appendChild(this.J.domNode),this.setAdditionalToggles(n?.additionalToggles),this.y&&this.domNode.appendChild(this.y),f?.appendChild(this.domNode),this.B(i.$8Q(this.inputBox.inputElement,"compositionstart",C=>{this.s=!0})),this.B(i.$8Q(this.inputBox.inputElement,"compositionend",C=>{this.s=!1,this.R.fire()})),this.z(this.inputBox.inputElement,C=>this.P.fire(C)),this.C(this.inputBox.inputElement,C=>this.S.fire(C)),this.D(this.inputBox.inputElement,C=>this.R.fire()),this.j(this.inputBox.inputElement,C=>this.Q.fire(C))}get isImeSessionInProgress(){return this.s}get onDidChange(){return this.inputBox.onDidChange}layout(f){this.inputBox.layout(),this.X(f.collapsedFindWidget)}enable(){this.domNode.classList.remove("disabled"),this.inputBox.enable(),this.J?.enable(),this.L?.enable(),this.M?.enable();for(const f of this.N)f.enable()}disable(){this.domNode.classList.add("disabled"),this.inputBox.disable(),this.J?.disable(),this.L?.disable(),this.M?.disable();for(const f of this.N)f.disable()}setFocusInputOnOptionClick(f){this.n=f}setEnabled(f){f?this.enable():this.disable()}setAdditionalToggles(f){for(const e of this.N)e.domNode.remove();this.N=[],this.w.value=new b.$Tc;for(const e of f??[])this.w.value.add(e),this.y.appendChild(e.domNode),this.w.value.add(e.onChange(n=>{this.O.fire(n),!n&&this.n&&this.inputBox.focus()})),this.N.push(e);this.N.length>0&&(this.y.style.display=""),this.X()}X(f=!1){f?this.inputBox.paddingRight=0:this.inputBox.paddingRight=(this.M?.width()??0)+(this.L?.width()??0)+(this.J?.width()??0)+this.N.reduce((e,n)=>e+n.width(),0)}clear(){this.Z(),this.setValue(""),this.focus()}getValue(){return this.inputBox.value}setValue(f){this.inputBox.value!==f&&(this.inputBox.value=f)}onSearchSubmit(){this.inputBox.addToHistory()}select(){this.inputBox.select()}focus(){this.inputBox.focus()}getCaseSensitive(){return this.M?.checked??!1}setCaseSensitive(f){this.M&&(this.M.checked=f)}getWholeWords(){return this.L?.checked??!1}setWholeWords(f){this.L&&(this.L.checked=f)}getRegex(){return this.J?.checked??!1}setRegex(f){this.J&&(this.J.checked=f,this.validate())}focusOnCaseSensitive(){this.M?.focus()}focusOnRegex(){this.J?.focus()}highlightFindOptions(){this.domNode.classList.remove("highlight-"+this.Y),this.Y=1-this.Y,this.domNode.classList.add("highlight-"+this.Y)}validate(){this.inputBox.validate()}showMessage(f){this.inputBox.showMessage(f)}clearMessage(){this.inputBox.hideMessage()}Z(){this.inputBox.hideMessage()}}t.$RU=P}),define(be[135],$e([1,0,2,24,15,67,134,68,64,43,69,61,27,40,12,9,18,19,34,4,37,3,35,7,115,14,107]),function(ne,t,i,N,z,H,E,k,b,$,w,P,c,f,e,n,h,m,p,v,o,g,r,B,C,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$qV=t.AbstractTreePart=t.TreeFindMatchType=t.TreeFindMode=t.$pV=t.$oV=t.$nV=t.RenderIndentGuides=t.$mV=t.$lV=void 0;class M extends b.$jT{set context(s){this.c.context=s}get context(){return this.c.context}constructor(s){super(s.elements.map(l=>l.element)),this.c=s}}function O(d){return d instanceof b.$jT?new M(d):d}class y{constructor(s,l){this.d=s,this.f=l,this.b=g.$Uc.None,this.c=new g.$Tc}getDragURI(s){return this.f.getDragURI(s.element)}getDragLabel(s,l){if(this.f.getDragLabel)return this.f.getDragLabel(s.map(F=>F.element),l)}onDragStart(s,l){this.f.onDragStart?.(O(s),l)}onDragOver(s,l,F,A,R,W=!0){const X=this.f.onDragOver(O(s),l&&l.element,F,A,R),U=this.a!==l;if(U&&(this.b.dispose(),this.a=l),typeof l>"u")return X;if(U&&typeof X!="boolean"&&X.autoExpand&&(this.b=(0,n.$jh)(()=>{const ke=this.d(),Ee=ke.getNodeLocation(l);ke.isCollapsed(Ee)&&ke.setCollapsed(Ee,!1),this.a=void 0},500,this.c)),typeof X=="boolean"||!X.accept||typeof X.bubble>"u"||X.feedback){if(!W){const ke=typeof X=="boolean"?X:X.accept,Ee=typeof X=="boolean"?void 0:X.effect;return{accept:ke,effect:Ee,feedback:[F]}}return X}if(X.bubble===1){const ke=this.d(),Ee=ke.getNodeLocation(l),Ce=ke.getParentNodeLocation(Ee),Re=ke.getNode(Ce),Ye=Ce&&ke.getListIndex(Ce);return this.onDragOver(s,Re,Ye,A,R,!1)}const me=this.d(),ve=me.getNodeLocation(l),we=me.getListIndex(ve),Me=me.getListRenderCount(ve);return{...X,feedback:(0,e.$Sb)(we,we+Me)}}drop(s,l,F,A,R){this.b.dispose(),this.a=void 0,this.f.drop(O(s),l&&l.element,F,A,R)}onDragEnd(s){this.f.onDragEnd?.(s)}dispose(){this.c.dispose(),this.f.dispose()}}function x(d,s){return s&&{...s,identityProvider:s.identityProvider&&{getId(l){return s.identityProvider.getId(l.element)}},dnd:s.dnd&&new y(d,s.dnd),multipleSelectionController:s.multipleSelectionController&&{isSelectionSingleChangeEvent(l){return s.multipleSelectionController.isSelectionSingleChangeEvent({...l,element:l.element})},isSelectionRangeChangeEvent(l){return s.multipleSelectionController.isSelectionRangeChangeEvent({...l,element:l.element})}},accessibilityProvider:s.accessibilityProvider&&{...s.accessibilityProvider,getSetSize(l){const F=d(),A=F.getNodeLocation(l),R=F.getParentNodeLocation(A);return F.getNode(R).visibleChildrenCount},getPosInSet(l){return l.visibleChildIndex+1},isChecked:s.accessibilityProvider&&s.accessibilityProvider.isChecked?l=>s.accessibilityProvider.isChecked(l.element):void 0,getRole:s.accessibilityProvider&&s.accessibilityProvider.getRole?l=>s.accessibilityProvider.getRole(l.element):()=>"treeitem",getAriaLabel(l){return s.accessibilityProvider.getAriaLabel(l.element)},getWidgetAriaLabel(){return s.accessibilityProvider.getWidgetAriaLabel()},getWidgetRole:s.accessibilityProvider&&s.accessibilityProvider.getWidgetRole?()=>s.accessibilityProvider.getWidgetRole():()=>"tree",getAriaLevel:s.accessibilityProvider&&s.accessibilityProvider.getAriaLevel?l=>s.accessibilityProvider.getAriaLevel(l.element):l=>l.depth,getActiveDescendantId:s.accessibilityProvider.getActiveDescendantId&&(l=>s.accessibilityProvider.getActiveDescendantId(l.element))},keyboardNavigationLabelProvider:s.keyboardNavigationLabelProvider&&{...s.keyboardNavigationLabelProvider,getKeyboardNavigationLabel(l){return s.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(l.element)}}}}class q{constructor(s){this.a=s}getHeight(s){return this.a.getHeight(s.element)}getTemplateId(s){return this.a.getTemplateId(s.element)}hasDynamicHeight(s){return!!this.a.hasDynamicHeight&&this.a.hasDynamicHeight(s.element)}setDynamicHeight(s,l){this.a.setDynamicHeight?.(s.element,l)}}t.$lV=q;class I{static lift(s){return s instanceof I?s:new I(s)}static empty(s=0){return new I({focus:[],selection:[],expanded:Object.create(null),scrollTop:s})}constructor(s){if(this.focus=new Set(s.focus),this.selection=new Set(s.selection),s.expanded instanceof Array){this.expanded=Object.create(null);for(const l of s.expanded)this.expanded[l]=1}else this.expanded=s.expanded;this.expanded=s.expanded,this.scrollTop=s.scrollTop}toJSON(){return{focus:Array.from(this.focus),selection:Array.from(this.selection),expanded:this.expanded,scrollTop:this.scrollTop}}}t.$mV=I;var j;(function(d){d.None="none",d.OnHover="onHover",d.Always="always"})(j||(t.RenderIndentGuides=j={}));class T{get elements(){return this.b}constructor(s,l=[]){this.b=l,this.a=new g.$Tc,this.onDidChange=v.Event.forEach(s,F=>this.b=F,this.a)}dispose(){this.a.dispose()}}class Q{static{this.a=8}constructor(s,l,F,A,R,W={}){this.o=s,this.p=l,this.q=A,this.s=R,this.b=new Map,this.c=new Map,this.d=Q.a,this.f=!1,this.g=!1,this.j=new Set,this.k=g.$Uc.None,this.m=new g.$Tc,this.templateId=s.templateId,this.updateOptions(W),v.Event.map(F,X=>X.node)(this.u,this,this.m),s.onDidChangeTwistieState?.(this.t,this,this.m)}updateOptions(s={}){if(typeof s.indent<"u"){const l=(0,r.$mm)(s.indent,0,40);if(l!==this.d){this.d=l;for(const[F,A]of this.c)this.v(F,A)}}if(typeof s.renderIndentGuides<"u"){const l=s.renderIndentGuides!==j.None;if(l!==this.g){this.g=l;for(const[F,A]of this.c)this.w(F,A);if(this.k.dispose(),l){const F=new g.$Tc;this.q.onDidChange(this.x,this,F),this.k=F,this.x(this.q.elements)}}}typeof s.hideTwistiesOfChildlessElements<"u"&&(this.f=s.hideTwistiesOfChildlessElements)}renderTemplate(s){const l=(0,i.$8R)(s,(0,i.$)(".monaco-tl-row")),F=(0,i.$8R)(l,(0,i.$)(".monaco-tl-indent")),A=(0,i.$8R)(l,(0,i.$)(".monaco-tl-twistie")),R=(0,i.$8R)(l,(0,i.$)(".monaco-tl-contents")),W=this.o.renderTemplate(R);return{container:s,indent:F,twistie:A,indentGuidesDisposable:g.$Uc.None,templateData:W}}renderElement(s,l,F,A){this.c.set(s,F),this.b.set(s.element,s),this.v(s,F),this.o.renderElement(s,l,F.templateData,A)}disposeElement(s,l,F,A){F.indentGuidesDisposable.dispose(),this.o.disposeElement?.(s,l,F.templateData,A),typeof A=="number"&&(this.c.delete(s),this.b.delete(s.element))}disposeTemplate(s){this.o.disposeTemplate(s.templateData)}t(s){const l=this.b.get(s);l&&this.u(l)}u(s){const l=this.c.get(s);l&&(this.x(this.q.elements),this.v(s,l))}v(s,l){const F=Q.a+(s.depth-1)*this.d;l.twistie.style.paddingLeft=`${F}px`,l.indent.style.width=`${F+this.d-16}px`,s.collapsible?l.container.setAttribute("aria-expanded",String(!s.collapsed)):l.container.removeAttribute("aria-expanded"),l.twistie.classList.remove(...m.ThemeIcon.asClassNameArray(h.$Gj.treeItemExpanded));let A=!1;this.o.renderTwistie&&(A=this.o.renderTwistie(s.element,l.twistie)),s.collapsible&&(!this.f||s.visibleChildrenCount>0)?(A||l.twistie.classList.add(...m.ThemeIcon.asClassNameArray(h.$Gj.treeItemExpanded)),l.twistie.classList.add("collapsible"),l.twistie.classList.toggle("collapsed",s.collapsed)):l.twistie.classList.remove("collapsible","collapsed"),this.w(s,l)}w(s,l){if((0,i.$7Q)(l.indent),l.indentGuidesDisposable.dispose(),!this.g)return;const F=new g.$Tc,A=this.p();for(;;){const R=A.getNodeLocation(s),W=A.getParentNodeLocation(R);if(!W)break;const X=A.getNode(W),U=(0,i.$)(".indent-guide",{style:`width: ${this.d}px`});this.j.has(X)&&U.classList.add("active"),l.indent.childElementCount===0?l.indent.appendChild(U):l.indent.insertBefore(U,l.indent.firstElementChild),this.s.add(X,U),F.add((0,g.$Sc)(()=>this.s.delete(X,U))),s=X}l.indentGuidesDisposable=F}x(s){if(!this.g)return;const l=new Set,F=this.p();s.forEach(A=>{const R=F.getNodeLocation(A);try{const W=F.getParentNodeLocation(R);A.collapsible&&A.children.length>0&&!A.collapsed?l.add(A):W&&l.add(F.getNode(W))}catch{}}),this.j.forEach(A=>{l.has(A)||this.s.forEach(A,R=>R.classList.remove("active"))}),l.forEach(A=>{this.j.has(A)||this.s.forEach(A,R=>R.classList.add("active"))}),this.j=l}dispose(){this.c.clear(),this.b.clear(),this.k.dispose(),(0,g.$Pc)(this.m)}}t.$nV=Q;class Z{get totalCount(){return this.a}get matchCount(){return this.b}set pattern(s){this.c=s,this.d=s.toLowerCase()}constructor(s,l,F){this.g=s,this.j=l,this.k=F,this.a=0,this.b=0,this.c="",this.d="",this.f=new g.$Tc,s.onWillRefilter(this.m,this,this.f)}filter(s,l){let F=1;if(this.k){const W=this.k.filter(s,l);if(typeof W=="boolean"?F=W?1:0:(0,P.$iV)(W)?F=(0,P.$jV)(W.visibility):F=W,F===0)return!1}if(this.a++,!this.c)return this.b++,{data:o.FuzzyScore.Default,visibility:F};const A=this.j.getKeyboardNavigationLabel(s),R=Array.isArray(A)?A:[A];for(const W of R){const X=W&&W.toString();if(typeof X>"u")return{data:o.FuzzyScore.Default,visibility:F};let U;if(this.g.findMatchType===Be.Contiguous){const me=X.toLowerCase().indexOf(this.d);if(me>-1){U=[Number.MAX_SAFE_INTEGER,0];for(let ve=this.d.length;ve>0;ve--)U.push(me+ve-1)}}else U=(0,o.$vk)(this.c,this.d,0,X,X.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(U)return this.b++,R.length===1?{data:U,visibility:F}:{data:{label:X,score:U},visibility:F}}return this.g.findMode===de.Filter?typeof this.g.options.defaultFindVisibility=="number"?this.g.options.defaultFindVisibility:this.g.options.defaultFindVisibility?this.g.options.defaultFindVisibility(s):2:{data:o.FuzzyScore.Default,visibility:F}}m(){this.a=0,this.b=0}dispose(){(0,g.$Pc)(this.f)}}class ce extends w.$ST{constructor(s){super({icon:h.$Gj.listFilter,title:(0,C.localize)(0,null),isChecked:s.isChecked??!1,hoverDelegate:s.hoverDelegate??(0,L.$2S)("element"),inputActiveOptionBorder:s.inputActiveOptionBorder,inputActiveOptionForeground:s.inputActiveOptionForeground,inputActiveOptionBackground:s.inputActiveOptionBackground})}}t.$oV=ce;class oe extends w.$ST{constructor(s){super({icon:h.$Gj.searchFuzzy,title:(0,C.localize)(1,null),isChecked:s.isChecked??!1,hoverDelegate:s.hoverDelegate??(0,L.$2S)("element"),inputActiveOptionBorder:s.inputActiveOptionBorder,inputActiveOptionForeground:s.inputActiveOptionForeground,inputActiveOptionBackground:s.inputActiveOptionBackground})}}t.$pV=oe;const te={inputBoxStyles:k.$BU,toggleStyles:w.$QT,listFilterWidgetBackground:void 0,listFilterWidgetNoMatchesOutline:void 0,listFilterWidgetOutline:void 0,listFilterWidgetShadow:void 0};var de;(function(d){d[d.Highlight=0]="Highlight",d[d.Filter=1]="Filter"})(de||(t.TreeFindMode=de={}));var Be;(function(d){d[d.Fuzzy=0]="Fuzzy",d[d.Contiguous=1]="Contiguous"})(Be||(t.TreeFindMatchType=Be={}));class Fe extends g.$Uc{set mode(s){this.b.checked=s===de.Filter,this.f.inputBox.setPlaceHolder(s===de.Filter?(0,C.localize)(2,null):(0,C.localize)(3,null))}set matchType(s){this.c.checked=s===Be.Fuzzy}get value(){return this.f.inputBox.value}set value(s){this.f.inputBox.value=s}constructor(s,l,F,A,R,W){super(),this.t=l,this.a=(0,i.h)(".monaco-tree-type-filter",[(0,i.h)(".monaco-tree-type-filter-grab.codicon.codicon-debug-gripper@grab",{tabIndex:0}),(0,i.h)(".monaco-tree-type-filter-input@findInput"),(0,i.h)(".monaco-tree-type-filter-actionbar@actionbar")]),this.j=0,this.m=0,this.s=0,this._onDidDisable=new v.$7d,this.onDidDisable=this._onDidDisable.event,s.appendChild(this.a.root),this.B((0,g.$Sc)(()=>s.removeChild(this.a.root)));const X=W?.styles??te;X.listFilterWidgetBackground&&(this.a.root.style.backgroundColor=X.listFilterWidgetBackground),X.listFilterWidgetShadow&&(this.a.root.style.boxShadow=`0 0 8px 2px ${X.listFilterWidgetShadow}`);const U=this.B((0,L.$3S)());this.b=this.B(new ce({...X.toggleStyles,isChecked:A===de.Filter,hoverDelegate:U})),this.c=this.B(new oe({...X.toggleStyles,isChecked:R===Be.Fuzzy,hoverDelegate:U})),this.onDidChangeMode=v.Event.map(this.b.onChange,()=>this.b.checked?de.Filter:de.Highlight,this.q),this.onDidChangeMatchType=v.Event.map(this.c.onChange,()=>this.c.checked?Be.Fuzzy:Be.Contiguous,this.q),this.f=this.B(new E.$RU(this.a.findInput,F,{label:(0,C.localize)(4,null),additionalToggles:[this.b,this.c],showCommonFindToggles:!1,inputBoxStyles:X.inputBoxStyles,toggleStyles:X.toggleStyles,history:W?.history})),this.g=this.B(new H.$4S(this.a.actionbar)),this.mode=A;const me=this.B(new N.$_S(this.f.inputBox.inputElement,"keydown")),ve=v.Event.chain(me.event,Ee=>Ee.map(Ce=>new z.$5Q(Ce)));this.B(ve(Ee=>{if(Ee.equals(3)){Ee.preventDefault(),Ee.stopPropagation(),this.f.inputBox.addToHistory(),this.t.domFocus();return}if(Ee.equals(18)){Ee.preventDefault(),Ee.stopPropagation(),this.f.inputBox.isAtLastInHistory()||this.f.inputBox.isNowhereInHistory()?(this.f.inputBox.addToHistory(),this.t.domFocus()):this.f.inputBox.showNextValue();return}if(Ee.equals(16)){Ee.preventDefault(),Ee.stopPropagation(),this.f.inputBox.showPreviousValue();return}}));const we=this.B(new f.$Yi("close",(0,C.localize)(5,null),"codicon codicon-close",!0,()=>this.dispose()));this.g.push(we,{icon:!0,label:!1});const Me=this.B(new N.$_S(this.a.grab,"mousedown"));this.B(Me.event(Ee=>{const Ce=new g.$Tc,Re=Ce.add(new N.$_S((0,i.getWindow)(Ee),"mousemove")),Ye=Ce.add(new N.$_S((0,i.getWindow)(Ee),"mouseup")),st=this.m,Ge=Ee.pageX,Ue=this.s,Y=Ee.pageY;this.a.grab.classList.add("grabbing");const se=this.a.root.style.transition;this.a.root.style.transition="unset";const pe=De=>{const Le=De.pageX-Ge;this.m=st-Le;const ze=De.pageY-Y;this.s=Ue+ze,this.layout()};Ce.add(Re.event(pe)),Ce.add(Ye.event(De=>{pe(De),this.a.grab.classList.remove("grabbing"),this.a.root.style.transition=se,Ce.dispose()}))}));const ke=v.Event.chain(this.B(new N.$_S(this.a.grab,"keydown")).event,Ee=>Ee.map(Ce=>new z.$5Q(Ce)));this.B(ke(Ee=>{let Ce,Re;if(Ee.keyCode===15?Ce=Number.POSITIVE_INFINITY:Ee.keyCode===17?Ce=0:Ee.keyCode===10&&(Ce=this.m===0?Number.POSITIVE_INFINITY:0),Ee.keyCode===16?Re=0:Ee.keyCode===18&&(Re=Number.POSITIVE_INFINITY),Ce!==void 0&&(Ee.preventDefault(),Ee.stopPropagation(),this.m=Ce,this.layout()),Re!==void 0){Ee.preventDefault(),Ee.stopPropagation(),this.s=Re;const Ye=this.a.root.style.transition;this.a.root.style.transition="unset",this.layout(),setTimeout(()=>{this.a.root.style.transition=Ye},0)}})),this.onDidChangeValue=this.f.onDidChange}getHistory(){return this.f.inputBox.getHistory()}focus(){this.f.focus()}select(){this.f.select(),this.f.inputBox.addToHistory(!0)}layout(s=this.j){this.j=s,this.m=(0,r.$mm)(this.m,0,Math.max(0,s-212)),this.a.root.style.right=`${this.m}px`,this.s=(0,r.$mm)(this.s,0,24),this.a.root.style.top=`${this.s}px`}showMessage(s){this.f.showMessage(s)}clearMessage(){this.f.clearMessage()}async dispose(){this._onDidDisable.fire(),this.a.root.classList.add("disabled"),await(0,n.$ih)(300),super.dispose()}}class Pe{get pattern(){return this.b}get mode(){return this.d}set mode(s){s!==this.d&&(this.d=s,this.g&&(this.g.mode=this.d),this.t.refilter(),this.A(),this.k.fire(s))}get matchType(){return this.f}set matchType(s){s!==this.f&&(this.f=s,this.g&&(this.g.matchType=this.f),this.t.refilter(),this.A(),this.m.fire(s))}constructor(s,l,F,A,R,W={}){this.t=s,this.u=F,this.v=A,this.w=R,this.x=W,this.b="",this.c="",this.j=0,this.k=new v.$7d,this.onDidChangeMode=this.k.event,this.m=new v.$7d,this.onDidChangeMatchType=this.m.event,this.o=new v.$7d,this.onDidChangePattern=this.o.event,this.p=new v.$7d,this.onDidChangeOpenState=this.p.event,this.q=new g.$Tc,this.s=new g.$Tc,this.d=s.options.defaultFindMode??de.Highlight,this.f=s.options.defaultFindMatchType??Be.Fuzzy,l.onDidSplice(this.z,this,this.s)}updateOptions(s={}){s.defaultFindMode!==void 0&&(this.mode=s.defaultFindMode),s.defaultFindMatchType!==void 0&&(this.matchType=s.defaultFindMatchType)}open(){if(this.g){this.g.focus(),this.g.select();return}this.g=new Fe(this.u.getHTMLElement(),this.t,this.w,this.mode,this.matchType,{...this.x,history:this.a}),this.q.add(this.g),this.g.onDidChangeValue(this.y,this,this.q),this.g.onDidChangeMode(s=>this.mode=s,void 0,this.q),this.g.onDidChangeMatchType(s=>this.matchType=s,void 0,this.q),this.g.onDidDisable(this.close,this,this.q),this.g.layout(this.j),this.g.focus(),this.g.value=this.c,this.g.select(),this.p.fire(!0)}close(){this.g&&(this.a=this.g.getHistory(),this.g=void 0,this.q.clear(),this.c=this.pattern,this.y(""),this.t.domFocus(),this.p.fire(!1))}y(s){this.b=s,this.o.fire(s),this.v.pattern=s,this.t.refilter(),s&&this.t.focusNext(0,!0,void 0,F=>!o.FuzzyScore.isDefault(F.filterData));const l=this.t.getFocus();if(l.length>0){const F=l[0];this.t.getRelativeTop(F)===null&&this.t.reveal(F,.5)}this.A()}z(){!this.g||this.pattern.length===0||(this.t.refilter(),this.A())}A(){const s=this.v.totalCount>0&&this.v.matchCount===0;this.pattern&&s?this.t.options.showNotFoundMessage??!0?this.g?.showMessage({type:2,content:(0,C.localize)(6,null)}):this.g?.showMessage({type:2}):this.g?.clearMessage()}shouldAllowFocus(s){return!this.g||!this.pattern||this.v.totalCount>0&&this.v.matchCount<=1?!0:!o.FuzzyScore.isDefault(s.filterData)}layout(s){this.j=s,this.g?.layout(s)}dispose(){this.a=void 0,this.o.dispose(),this.q.dispose(),this.s.dispose()}}function le(d,s){return d.position===s.position&&_(d,s)}function _(d,s){return d.node.element===s.node.element&&d.startIndex===s.startIndex&&d.height===s.height&&d.endIndex===s.endIndex}class ae{constructor(s=[]){this.stickyNodes=s}get count(){return this.stickyNodes.length}equal(s){return(0,e.$ub)(this.stickyNodes,s.stickyNodes,le)}lastNodePartiallyVisible(){if(this.count===0)return!1;const s=this.stickyNodes[this.count-1];if(this.count===1)return s.position!==0;const l=this.stickyNodes[this.count-2];return l.position+l.height!==s.position}animationStateChanged(s){if(!(0,e.$ub)(this.stickyNodes,s.stickyNodes,_)||this.count===0)return!1;const l=this.stickyNodes[this.count-1],F=s.stickyNodes[s.count-1];return l.position!==F.position}}class re{constrainStickyScrollNodes(s,l,F){for(let A=0;A<s.length;A++){const R=s[A];if(R.position+R.height>F||A>=l)return s.slice(0,A)}return s}}class J extends g.$Uc{constructor(s,l,F,A,R,W={}){super(),this.g=s,this.j=l,this.m=F,this.s=R,this.c=.4;const X=this.validateStickySettings(W);this.b=X.stickyScrollMaxItemCount,this.a=W.stickyScrollDelegate??new re,this.f=this.B(new G(F.getScrollableElement(),F,s,A,R,W.accessibilityProvider)),this.onDidChangeHasFocus=this.f.onDidChangeHasFocus,this.onContextMenu=this.f.onContextMenu,this.B(F.onDidScroll(()=>this.u())),this.B(F.onDidChangeContentHeight(()=>this.u())),this.B(s.onDidChangeCollapseState(()=>this.u())),this.u()}get height(){return this.f.height}get count(){return this.f.count}getNode(s){return this.f.getNode(s)}t(s){let l;if(s===0?l=this.m.firstVisibleIndex:l=this.m.indexAt(s+this.m.scrollTop),!(l<0||l>=this.m.length))return this.m.element(l)}u(){const s=this.t(0);if(!s||this.g.scrollTop===0){this.f.setState(void 0);return}const l=this.w(s);this.f.setState(l)}w(s){const l=[];let F=s,A=0,R=this.z(F,void 0,A);for(;R&&(l.push(R),A+=R.height,!(l.length<=this.b&&(F=this.y(R),!F)));)R=this.z(F,R.node,A);const W=this.H(l);return W.length?new ae(W):void 0}y(s){return this.t(s.position+s.height)}z(s,l,F){const A=this.F(s,l);if(A&&!(A===s&&(!this.J(s)||this.C(s,F))))return this.D(A,F)}C(s,l){const F=this.L(s),A=this.m.getElementTop(F),R=l;return this.m.scrollTop===A-R}D(s,l){const F=this.s.getHeight(s),{startIndex:A,endIndex:R}=this.M(s),W=this.G(R,l,F);return{node:s,position:W,height:F,startIndex:A,endIndex:R}}F(s,l=void 0){let F=s,A=this.I(F);for(;A;){if(A===l)return F;F=A,A=this.I(F)}if(l===void 0)return F}G(s,l,F){let A=this.m.getRelativeTop(s);if(A===null&&this.m.firstVisibleIndex===s&&s+1<this.m.length){const me=this.s.getHeight(this.m.element(s)),ve=this.m.getRelativeTop(s+1);A=ve?ve-me/this.m.renderHeight:null}if(A===null)return l;const R=this.m.element(s),W=this.s.getHeight(R),U=A*this.m.renderHeight+W;return l+F>U&&l<=U?U-F:l}H(s){if(s.length===0)return[];const l=this.m.renderHeight*this.c,F=s[s.length-1];if(s.length<=this.b&&F.position+F.height<=l)return s;const A=this.a.constrainStickyScrollNodes(s,this.b,l);if(!A.length)return[];const R=A[A.length-1];if(A.length>this.b||R.position+R.height>l)throw new Error("stickyScrollDelegate violates constraints");return A}I(s){const l=this.j.getNodeLocation(s),F=this.j.getParentNodeLocation(l);return F?this.j.getNode(F):void 0}J(s){const l=this.j.getNodeLocation(s);return this.j.getListRenderCount(l)>1}L(s){const l=this.j.getNodeLocation(s);return this.j.getListIndex(l)}M(s){const l=this.j.getNodeLocation(s),F=this.j.getListIndex(l);if(F<0)throw new Error("Node not found in tree");const A=this.j.getListRenderCount(l),R=F+A-1;return{startIndex:F,endIndex:R}}nodePositionTopBelowWidget(s){const l=[];let F=this.I(s);for(;F;)l.push(F),F=this.I(F);let A=0;for(let R=0;R<l.length&&R<this.b;R++)A+=this.s.getHeight(l[R]);return A}getFocus(){return this.f.getFocus()}domFocus(){this.f.domFocus()}focusedLast(){return this.f.focusedLast()}updateOptions(s={}){if(!s.stickyScrollMaxItemCount)return;const l=this.validateStickySettings(s);this.b!==l.stickyScrollMaxItemCount&&(this.b=l.stickyScrollMaxItemCount,this.u())}validateStickySettings(s){let l=7;return typeof s.stickyScrollMaxItemCount=="number"&&(l=Math.max(s.stickyScrollMaxItemCount,1)),{stickyScrollMaxItemCount:l}}}class G{constructor(s,l,F,A,R,W){this.g=l,this.j=F,this.k=A,this.m=R,this.o=W,this.c=[],this.d=new g.$Tc,this.a=(0,i.$)(".monaco-tree-sticky-container.empty"),s.appendChild(this.a);const X=(0,i.$)(".monaco-tree-sticky-container-shadow");this.a.appendChild(X),this.f=new ie(this.a,l),this.onDidChangeHasFocus=this.f.onDidChangeHasFocus,this.onContextMenu=this.f.onContextMenu}get height(){if(!this.b)return 0;const s=this.b.stickyNodes[this.b.count-1];return s.position+s.height}get count(){return this.b?.count??0}getNode(s){return this.b?.stickyNodes.find(l=>l.node===s)}setState(s){const l=!!this.b&&this.b.count>0,F=!!s&&s.count>0;if(!l&&!F||l&&F&&this.b.equal(s))return;if(l!==F&&this.s(F),!F){this.b=void 0,this.c=[],this.d.clear();return}const A=s.stickyNodes[s.count-1];if(this.b&&s.animationStateChanged(this.b))this.c[this.b.count-1].style.top=`${A.position}px`;else{this.d.clear();const R=Array(s.count);for(let W=s.count-1;W>=0;W--){const X=s.stickyNodes[W],{element:U,disposable:me}=this.p(X,W,s.count);R[W]=U,this.a.appendChild(U),this.d.add(me)}this.f.updateElements(R,s),this.c=R}this.b=s,this.a.style.height=`${A.position+A.height}px`}p(s,l,F){const A=s.startIndex,R=document.createElement("div");R.style.top=`${s.position}px`,this.j.options.setRowHeight!==!1&&(R.style.height=`${s.height}px`),this.j.options.setRowLineHeight!==!1&&(R.style.lineHeight=`${s.height}px`),R.classList.add("monaco-tree-sticky-row"),R.classList.add("monaco-list-row"),R.setAttribute("data-index",`${A}`),R.setAttribute("data-parity",A%2===0?"even":"odd"),R.setAttribute("id",this.g.getElementID(A)),this.q(R,s.node.element,l,F);const W=this.m.getTemplateId(s.node),X=this.k.find(we=>we.templateId===W);if(!X)throw new Error(`No renderer found for template id ${W}`);let U=s.node;U===this.j.getNode(this.j.getNodeLocation(s.node))&&(U=new Proxy(s.node,{}));const me=X.renderTemplate(R);X.renderElement(U,s.startIndex,me,s.height);const ve=(0,g.$Sc)(()=>{X.disposeElement(U,s.startIndex,me,s.height),X.disposeTemplate(me),R.remove()});return{element:R,disposable:ve}}q(s,l,F,A){if(!this.o)return;this.o.getSetSize&&s.setAttribute("aria-setsize",String(this.o.getSetSize(l,F,A))),this.o.getPosInSet&&s.setAttribute("aria-posinset",String(this.o.getPosInSet(l,F))),this.o.getRole&&s.setAttribute("role",this.o.getRole(l)??"treeitem");const R=this.o.getAriaLabel(l);R&&s.setAttribute("aria-label",R);const W=this.o.getAriaLevel&&this.o.getAriaLevel(l);typeof W=="number"&&s.setAttribute("aria-level",`${W}`),s.setAttribute("aria-selected",String(!1))}s(s){this.a.classList.toggle("empty",!s),s||this.f.updateElements([],void 0)}getFocus(){return this.f.getFocus()}domFocus(){this.f.domFocus()}focusedLast(){return this.f.focusedLast()}dispose(){this.f.dispose(),this.d.dispose(),this.a.remove()}}class ie extends g.$Uc{get m(){return this.j}set m(s){s!==this.j&&(this.f.fire(s),this.j=s)}constructor(s,l){super(),this.s=s,this.t=l,this.a=-1,this.b=[],this.f=new v.$7d,this.onDidChangeHasFocus=this.f.event,this.g=new v.$7d,this.onContextMenu=this.g.event,this.j=!1,this.s.addEventListener("focus",()=>this.M()),this.s.addEventListener("blur",()=>this.O()),this.B(this.t.onDidFocus(()=>this.L(!1))),this.B(this.t.onKeyDown(F=>this.w(F))),this.B(this.t.onMouseDown(F=>this.y(F))),this.B(this.t.onContextMenu(F=>this.u(F)))}u(s){const l=s.browserEvent.target;if(!(0,$.$wT)(l)&&!(0,$.$vT)(l)){this.focusedLast()&&this.t.domFocus();return}if(!(0,i.$XR)(s.browserEvent)){if(!this.c)throw new Error("Context menu should not be triggered when state is undefined");const W=this.c.stickyNodes.findIndex(X=>X.node.element===s.element?.element);if(W===-1)throw new Error("Context menu should not be triggered when element is not in sticky scroll widget");this.s.focus(),this.F(W);return}if(!this.c||this.a<0)throw new Error("Context menu key should not be triggered when focus is not in sticky scroll widget");const A=this.c.stickyNodes[this.a].node.element,R=this.b[this.a];this.g.fire({element:A,anchor:R,browserEvent:s.browserEvent,isStickyScroll:!0})}w(s){if(this.m&&this.c){if(s.key==="ArrowUp")this.z(Math.max(0,this.a-1)),s.preventDefault(),s.stopPropagation();else if(s.key==="ArrowDown"||s.key==="ArrowRight"){if(this.a>=this.c.count-1){const l=this.c.stickyNodes[this.c.count-1].startIndex+1;this.t.domFocus(),this.t.setFocus([l]),this.C(l,this.c)}else this.z(this.a+1);s.preventDefault(),s.stopPropagation()}}}y(s){const l=s.browserEvent.target;!(0,$.$wT)(l)&&!(0,$.$vT)(l)||(s.browserEvent.preventDefault(),s.browserEvent.stopPropagation())}updateElements(s,l){if(l&&l.count===0)throw new Error("Sticky scroll state must be undefined when there are no sticky nodes");if(l&&l.count!==s.length)throw new Error("Sticky scroll focus received illigel state");const F=this.a;if(this.D(),this.b=s,this.c=l,l){const A=(0,r.$mm)(F,0,l.count-1);this.F(A)}else this.m&&this.t.domFocus();this.s.tabIndex=l?0:-1}z(s){const l=this.c;if(!l)throw new Error("Cannot set focus when state is undefined");if(this.F(s),!(s<l.count-1)&&l.lastNodePartiallyVisible()){const F=l.stickyNodes[s];this.C(F.endIndex+1,l)}}C(s,l){const F=l.stickyNodes[l.count-1],A=l.count>1?l.stickyNodes[l.count-2]:void 0,R=this.t.getElementTop(s),W=A?A.position+A.height+F.height:F.height;this.t.scrollTop=R-W}getFocus(){if(!(!this.c||this.a===-1))return this.c.stickyNodes[this.a].node.element}domFocus(){if(!this.c)throw new Error("Cannot focus when state is undefined");this.s.focus()}focusedLast(){return this.c?this.t.getHTMLElement().classList.contains("sticky-scroll-focused"):!1}D(){this.a!==-1&&(this.G(this.b[this.a],!1),this.a=-1)}F(s){if(0>s)throw new Error("addFocus() can not remove focus");if(!this.c&&s>=0)throw new Error("Cannot set focus index when state is undefined");if(this.c&&s>=this.c.count)throw new Error("Cannot set focus index to an index that does not exist");const l=this.a;l>=0&&this.G(this.b[l],!1),s>=0&&this.G(this.b[s],!0),this.a=s}G(s,l){this.I(s,l&&this.m),this.J(s,l)}H(s){this.a!==-1&&this.I(this.b[this.a],s)}I(s,l){s.classList.toggle("focused",l)}J(s,l){s.classList.toggle("passive-focused",l)}L(s){this.t.getHTMLElement().classList.toggle("sticky-scroll-focused",s)}M(){if(!this.c||this.b.length===0)throw new Error("Cannot focus when state is undefined or elements are empty");this.m=!0,this.L(!0),this.H(!0),this.a===-1&&this.F(0)}O(){this.m=!1,this.H(!1)}dispose(){this.L(!1),this.f.fire(!1),super.dispose()}}function ue(d){let s=c.TreeMouseEventTarget.Unknown;return(0,i.$DR)(d.browserEvent.target,"monaco-tl-twistie","monaco-tl-row")?s=c.TreeMouseEventTarget.Twistie:(0,i.$DR)(d.browserEvent.target,"monaco-tl-contents","monaco-tl-row")?s=c.TreeMouseEventTarget.Element:(0,i.$DR)(d.browserEvent.target,"monaco-tree-type-filter","monaco-list")&&(s=c.TreeMouseEventTarget.Filter),{browserEvent:d.browserEvent,element:d.element?d.element.element:null,target:s}}function ye(d){const s=(0,$.$wT)(d.browserEvent.target);return{element:d.element?d.element.element:null,browserEvent:d.browserEvent,anchor:d.anchor,isStickyScroll:s}}function Ne(d,s){s(d),d.children.forEach(l=>Ne(l,s))}class Ae{get f(){return this.d||(this.d=this.m()),this.d}constructor(s,l){this.g=s,this.j=l,this.a=[],this.c=new v.$7d,this.onDidChange=this.c.event}set(s,l){!l?.__forceEvent&&(0,e.$ub)(this.a,s)||this.k(s,!1,l)}k(s,l,F){if(this.a=[...s],this.b=void 0,this.d=void 0,!l){const A=this;this.c.fire({get elements(){return A.get()},browserEvent:F})}}get(){return this.b||(this.b=this.a.map(s=>s.element)),[...this.b]}getNodes(){return this.a}has(s){return this.f.has(s)}onDidModelSplice({insertedNodes:s,deletedNodes:l}){if(!this.j){const U=this.m(),me=ve=>U.delete(ve);l.forEach(ve=>Ne(ve,me)),this.set([...U.values()]);return}const F=new Set,A=U=>F.add(this.j.getId(U.element).toString());l.forEach(U=>Ne(U,A));const R=new Map,W=U=>R.set(this.j.getId(U.element).toString(),U);s.forEach(U=>Ne(U,W));const X=[];for(const U of this.a){const me=this.j.getId(U.element).toString();if(!F.has(me))X.push(U);else{const we=R.get(me);we&&we.visible&&X.push(we)}}if(this.a.length>0&&X.length===0){const U=this.g();U&&X.push(U)}this.k(X,!0)}m(){const s=new Set;for(const l of this.a)s.add(l);return s}}class ge extends $.$BT{constructor(s,l,F){super(s),this.x=l,this.y=F}u(s){if((0,$.$xT)(s.browserEvent.target)||(0,$.$qT)(s.browserEvent.target)||(0,$.$rT)(s.browserEvent.target)||s.browserEvent.isHandledByList)return;const l=s.element;if(!l)return super.u(s);if(this.p(s)||this.o(s))return super.u(s);const F=s.browserEvent.target,A=F.classList.contains("monaco-tl-twistie")||F.classList.contains("monaco-icon-label")&&F.classList.contains("folder-icon")&&s.browserEvent.offsetX<16,R=(0,$.$vT)(s.browserEvent.target);let W=!1;if(R?W=!0:typeof this.x.expandOnlyOnTwistieClick=="function"?W=this.x.expandOnlyOnTwistieClick(l.element):W=!!this.x.expandOnlyOnTwistieClick,R)this.A(s,l);else{if(W&&!A&&s.browserEvent.detail!==2)return super.u(s);if(!this.x.expandOnDoubleClick&&s.browserEvent.detail===2)return super.u(s)}if(l.collapsible&&(!R||A)){const X=this.x.getNodeLocation(l),U=s.browserEvent.altKey;if(this.x.setFocus([X]),this.x.toggleCollapsed(X,U),W&&A){s.browserEvent.isHandledByList=!0;return}}R||super.u(s)}A(s,l){if((0,$.$sT)(s.browserEvent.target)||(0,$.$tT)(s.browserEvent.target))return;const F=this.y();if(!F)throw new Error("Sticky scroll controller not found");const A=this.k.indexOf(l),R=this.k.getElementTop(A),W=F.nodePositionTopBelowWidget(l);this.x.scrollTop=R-W,this.k.domFocus(),this.k.setFocus([A]),this.k.setSelection([A])}v(s){s.browserEvent.target.classList.contains("monaco-tl-twistie")||!this.x.expandOnDoubleClick||s.browserEvent.isHandledByList||super.v(s)}s(s){const l=s.browserEvent.target;if(!(0,$.$wT)(l)&&!(0,$.$vT)(l)){super.s(s);return}}t(s){const l=s.browserEvent.target;if(!(0,$.$wT)(l)&&!(0,$.$vT)(l)){super.t(s);return}}}class u extends $.$ET{constructor(s,l,F,A,R,W,X,U){super(s,l,F,A,U),this.p=R,this.s=W,this.K=X}D(s){return new ge(this,s.tree,s.stickyScrollProvider)}splice(s,l,F=[]){if(super.splice(s,l,F),F.length===0)return;const A=[],R=[];let W;F.forEach((X,U)=>{this.p.has(X)&&A.push(s+U),this.s.has(X)&&R.push(s+U),this.K.has(X)&&(W=s+U)}),A.length>0&&super.setFocus((0,e.$Mb)([...super.getFocus(),...A])),R.length>0&&super.setSelection((0,e.$Mb)([...super.getSelection(),...R])),typeof W=="number"&&super.setAnchor(W)}setFocus(s,l,F=!1){super.setFocus(s,l),F||this.p.set(s.map(A=>this.element(A)),l)}setSelection(s,l,F=!1){super.setSelection(s,l),F||this.s.set(s.map(A=>this.element(A)),l)}setAnchor(s,l=!1){super.setAnchor(s),l||(typeof s>"u"?this.K.set([]):this.K.set([this.element(s)]))}}var S;(function(d){d[d.Tree=0]="Tree",d[d.StickyScroll=1]="StickyScroll"})(S||(t.AbstractTreePart=S={}));class D{get onDidScroll(){return this.j.onDidScroll}get onDidChangeFocus(){return this.y.wrapEvent(this.q.onDidChange)}get onDidChangeSelection(){return this.y.wrapEvent(this.w.onDidChange)}get onMouseClick(){return v.Event.map(this.j.onMouseClick,ue)}get onMouseDblClick(){return v.Event.filter(v.Event.map(this.j.onMouseDblClick,ue),s=>s.target!==c.TreeMouseEventTarget.Filter)}get onMouseOver(){return v.Event.map(this.j.onMouseOver,ue)}get onMouseOut(){return v.Event.map(this.j.onMouseOut,ue)}get onContextMenu(){return v.Event.any(v.Event.filter(v.Event.map(this.j.onContextMenu,ye),s=>!s.isStickyScroll),this.B?.onContextMenu??v.Event.None)}get onTap(){return v.Event.map(this.j.onTap,ue)}get onPointer(){return v.Event.map(this.j.onPointer,ue)}get onKeyDown(){return this.j.onKeyDown}get onKeyUp(){return this.j.onKeyUp}get onKeyPress(){return this.j.onKeyPress}get onDidFocus(){return this.j.onDidFocus}get onDidBlur(){return this.j.onDidBlur}get onDidChangeModel(){return v.Event.signal(this.o.onDidSplice)}get onDidChangeCollapseState(){return this.o.onDidChangeCollapseState}get onDidChangeRenderNodeCount(){return this.o.onDidChangeRenderNodeCount}get findMode(){return this.z?.mode??de.Highlight}set findMode(s){this.z&&(this.z.mode=s)}get findMatchType(){return this.z?.matchType??Be.Fuzzy}set findMatchType(s){this.z&&(this.z.matchType=s)}get onDidChangeFindPattern(){return this.z?this.z.onDidChangePattern:v.Event.None}get expandOnDoubleClick(){return typeof this.H.expandOnDoubleClick>"u"?!0:this.H.expandOnDoubleClick}get expandOnlyOnTwistieClick(){return typeof this.H.expandOnlyOnTwistieClick>"u"?!0:this.H.expandOnlyOnTwistieClick}get onDidDispose(){return this.j.onDidDispose}constructor(s,l,F,A,R={}){this.G=s,this.H=R,this.y=new v.$ce,this.onDidChangeFindOpenState=v.Event.None,this.onDidChangeStickyScrollFocused=v.Event.None,this.D=new g.$Tc,this.E=new v.$7d,this.onWillRefilter=this.E.event,this.F=new v.$7d,this.onDidUpdateOptions=this.F.event,this.p=new q(F);const W=new v.$de,X=new v.$de,U=this.D.add(new T(X.event)),me=new p.$Hc;this.k=A.map(Ee=>new Q(Ee,()=>this.o,W.event,U,me,R));for(const Ee of this.k)this.D.add(Ee);let ve;R.keyboardNavigationLabelProvider&&(ve=new Z(this,R.keyboardNavigationLabelProvider,R.filter),R={...R,filter:ve},this.D.add(ve)),this.q=new Ae(()=>this.j.getFocusedElements()[0],R.identityProvider),this.w=new Ae(()=>this.j.getSelectedElements()[0],R.identityProvider),this.x=new Ae(()=>this.j.getAnchorElement(),R.identityProvider),this.j=new u(s,l,this.p,this.k,this.q,this.w,this.x,{...x(()=>this.o,R),tree:this,stickyScrollProvider:()=>this.B}),this.o=this.M(s,this.j,R),W.input=this.o.onDidChangeCollapseState;const we=v.Event.forEach(this.o.onDidSplice,Ee=>{this.y.bufferEvents(()=>{this.q.onDidModelSplice(Ee),this.w.onDidModelSplice(Ee)})},this.D);we(()=>null,null,this.D);const Me=this.D.add(new v.$7d),ke=this.D.add(new n.$eh(0));if(this.D.add(v.Event.any(we,this.q.onDidChange,this.w.onDidChange)(()=>{ke.trigger(()=>{const Ee=new Set;for(const Ce of this.q.getNodes())Ee.add(Ce);for(const Ce of this.w.getNodes())Ee.add(Ce);Me.fire([...Ee.values()])})})),X.input=Me.event,R.keyboardSupport!==!1){const Ee=v.Event.chain(this.j.onKeyDown,Ce=>Ce.filter(Re=>!(0,$.$qT)(Re.target)).map(Re=>new z.$5Q(Re)));v.Event.chain(Ee,Ce=>Ce.filter(Re=>Re.keyCode===15))(this.J,this,this.D),v.Event.chain(Ee,Ce=>Ce.filter(Re=>Re.keyCode===17))(this.K,this,this.D),v.Event.chain(Ee,Ce=>Ce.filter(Re=>Re.keyCode===10))(this.L,this,this.D)}if((R.findWidgetEnabled??!0)&&R.keyboardNavigationLabelProvider&&R.contextViewProvider){const Ee=this.options.findWidgetStyles?{styles:this.options.findWidgetStyles}:void 0;this.z=new Pe(this,this.o,this.j,ve,R.contextViewProvider,Ee),this.A=Ce=>this.z.shouldAllowFocus(Ce),this.onDidChangeFindOpenState=this.z.onDidChangeOpenState,this.D.add(this.z),this.onDidChangeFindMode=this.z.onDidChangeMode,this.onDidChangeFindMatchType=this.z.onDidChangeMatchType}else this.onDidChangeFindMode=v.Event.None,this.onDidChangeFindMatchType=v.Event.None;R.enableStickyScroll&&(this.B=new J(this,this.o,this.j,this.k,this.p,R),this.onDidChangeStickyScrollFocused=this.B.onDidChangeHasFocus),this.C=(0,i.$PR)(this.j.getHTMLElement()),this.getHTMLElement().classList.toggle("always",this.H.renderIndentGuides===j.Always)}updateOptions(s={}){this.H={...this.H,...s};for(const l of this.k)l.updateOptions(s);this.j.updateOptions(this.H),this.z?.updateOptions(s),this.I(s),this.F.fire(this.H),this.getHTMLElement().classList.toggle("always",this.H.renderIndentGuides===j.Always)}get options(){return this.H}I(s){!this.B&&this.H.enableStickyScroll?(this.B=new J(this,this.o,this.j,this.k,this.p,this.H),this.onDidChangeStickyScrollFocused=this.B.onDidChangeHasFocus):this.B&&!this.H.enableStickyScroll&&(this.onDidChangeStickyScrollFocused=v.Event.None,this.B.dispose(),this.B=void 0),this.B?.updateOptions(s)}updateWidth(s){const l=this.o.getListIndex(s);l!==-1&&this.j.updateWidth(l)}getHTMLElement(){return this.j.getHTMLElement()}get contentHeight(){return this.j.contentHeight}get contentWidth(){return this.j.contentWidth}get onDidChangeContentHeight(){return this.j.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.j.onDidChangeContentWidth}get scrollTop(){return this.j.scrollTop}set scrollTop(s){this.j.scrollTop=s}get scrollLeft(){return this.j.scrollLeft}set scrollLeft(s){this.j.scrollLeft=s}get scrollHeight(){return this.j.scrollHeight}get renderHeight(){return this.j.renderHeight}get firstVisibleElement(){let s=this.j.firstVisibleIndex;return this.B&&(s+=this.B.count),s<0||s>=this.j.length?void 0:this.j.element(s).element}get lastVisibleElement(){const s=this.j.lastVisibleIndex;return this.j.element(s).element}get ariaLabel(){return this.j.ariaLabel}set ariaLabel(s){this.j.ariaLabel=s}get selectionSize(){return this.w.getNodes().length}domFocus(){this.B?.focusedLast()?this.B.domFocus():this.j.domFocus()}isDOMFocused(){return(0,i.$IR)(this.getHTMLElement())}layout(s,l){this.j.layout(s,l),(0,B.$Yf)(l)&&this.z?.layout(l)}style(s){const l=`.${this.j.domId}`,F=[];s.treeIndentGuidesStroke&&(F.push(`.monaco-list${l}:hover .monaco-tl-indent > .indent-guide, .monaco-list${l}.always .monaco-tl-indent > .indent-guide  { border-color: ${s.treeInactiveIndentGuidesStroke}; }`),F.push(`.monaco-list${l} .monaco-tl-indent > .indent-guide.active { border-color: ${s.treeIndentGuidesStroke}; }`)),s.listBackground&&(F.push(`.monaco-list${l} .monaco-scrollable-element .monaco-tree-sticky-container { background-color: ${s.listBackground}; }`),F.push(`.monaco-list${l} .monaco-scrollable-element .monaco-tree-sticky-container .monaco-tree-sticky-row { background-color: ${s.listBackground}; }`)),s.listFocusForeground&&(F.push(`.monaco-list${l}.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container:focus .monaco-list-row.focused { color: ${s.listFocusForeground}; }`),F.push(`.monaco-list${l}:not(.sticky-scroll-focused) .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.focused { color: inherit; }`));const A=(0,i.$nS)(s.listFocusAndSelectionOutline,(0,i.$nS)(s.listSelectionOutline,s.listFocusOutline??""));A&&(F.push(`.monaco-list${l}.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container:focus .monaco-list-row.focused.selected { outline: 1px solid ${A}; outline-offset: -1px;}`),F.push(`.monaco-list${l}:not(.sticky-scroll-focused) .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.focused.selected { outline: inherit;}`)),s.listFocusOutline&&(F.push(`.monaco-list${l}.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container:focus .monaco-list-row.focused { outline: 1px solid ${s.listFocusOutline}; outline-offset: -1px; }`),F.push(`.monaco-list${l}:not(.sticky-scroll-focused) .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.focused { outline: inherit; }`),F.push(`.monaco-workbench.context-menu-visible .monaco-list${l}.last-focused.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.passive-focused { outline: 1px solid ${s.listFocusOutline}; outline-offset: -1px; }`),F.push(`.monaco-workbench.context-menu-visible .monaco-list${l}.last-focused.sticky-scroll-focused .monaco-list-rows .monaco-list-row.focused { outline: inherit; }`),F.push(`.monaco-workbench.context-menu-visible .monaco-list${l}.last-focused:not(.sticky-scroll-focused) .monaco-tree-sticky-container .monaco-list-rows .monaco-list-row.focused { outline: inherit; }`)),this.C.textContent=F.join(`
`),this.j.style(s)}getParentElement(s){const l=this.o.getParentNodeLocation(s);return this.o.getNode(l).element}getFirstElementChild(s){return this.o.getFirstElementChild(s)}getNode(s){return this.o.getNode(s)}getNodeLocation(s){return this.o.getNodeLocation(s)}collapse(s,l=!1){return this.o.setCollapsed(s,!0,l)}expand(s,l=!1){return this.o.setCollapsed(s,!1,l)}toggleCollapsed(s,l=!1){return this.o.setCollapsed(s,void 0,l)}expandAll(){this.o.setCollapsed(this.o.rootRef,!1,!0)}collapseAll(){this.o.setCollapsed(this.o.rootRef,!0,!0)}isCollapsible(s){return this.o.isCollapsible(s)}setCollapsible(s,l){return this.o.setCollapsible(s,l)}isCollapsed(s){return this.o.isCollapsed(s)}expandTo(s){this.o.expandTo(s)}triggerTypeNavigation(){this.j.triggerTypeNavigation()}openFind(){this.z?.open()}closeFind(){this.z?.close()}refilter(){this.E.fire(void 0),this.o.refilter()}setAnchor(s){if(typeof s>"u")return this.j.setAnchor(void 0);this.y.bufferEvents(()=>{const l=this.o.getNode(s);this.x.set([l]);const F=this.o.getListIndex(s);F>-1&&this.j.setAnchor(F,!0)})}getAnchor(){return(0,e.$Ob)(this.x.get(),void 0)}setSelection(s,l){this.y.bufferEvents(()=>{const F=s.map(R=>this.o.getNode(R));this.w.set(F,l);const A=s.map(R=>this.o.getListIndex(R)).filter(R=>R>-1);this.j.setSelection(A,l,!0)})}getSelection(){return this.w.get()}setFocus(s,l){this.y.bufferEvents(()=>{const F=s.map(R=>this.o.getNode(R));this.q.set(F,l);const A=s.map(R=>this.o.getListIndex(R)).filter(R=>R>-1);this.j.setFocus(A,l,!0)})}focusNext(s=1,l=!1,F,A=(0,i.$XR)(F)&&F.altKey?void 0:this.A){this.j.focusNext(s,l,F,A)}focusPrevious(s=1,l=!1,F,A=(0,i.$XR)(F)&&F.altKey?void 0:this.A){this.j.focusPrevious(s,l,F,A)}focusNextPage(s,l=(0,i.$XR)(s)&&s.altKey?void 0:this.A){return this.j.focusNextPage(s,l)}focusPreviousPage(s,l=(0,i.$XR)(s)&&s.altKey?void 0:this.A){return this.j.focusPreviousPage(s,l,()=>this.B?.height??0)}focusLast(s,l=(0,i.$XR)(s)&&s.altKey?void 0:this.A){this.j.focusLast(s,l)}focusFirst(s,l=(0,i.$XR)(s)&&s.altKey?void 0:this.A){this.j.focusFirst(s,l)}getFocus(){return this.q.get()}getStickyScrollFocus(){const s=this.B?.getFocus();return s!==void 0?[s]:[]}getFocusedPart(){return this.B?.focusedLast()?1:0}reveal(s,l){this.o.expandTo(s);const F=this.o.getListIndex(s);if(F!==-1)if(!this.B)this.j.reveal(F,l);else{const A=this.B.nodePositionTopBelowWidget(this.getNode(s));this.j.reveal(F,l,A)}}getRelativeTop(s){const l=this.o.getListIndex(s);if(l===-1)return null;const F=this.B?.getNode(this.getNode(s));return this.j.getRelativeTop(l,F?.position??this.B?.height)}getViewState(s=this.options.identityProvider){if(!s)throw new c.$gV(this.G,"Can't get tree view state without an identity provider");const l=W=>s.getId(W).toString(),F=I.empty(this.scrollTop);for(const W of this.getFocus())F.focus.add(l(W));for(const W of this.getSelection())F.selection.add(l(W));const A=this.o.getNode(),R=[A];for(;R.length>0;){const W=R.shift();W!==A&&W.collapsible&&(F.expanded[l(W.element)]=W.collapsed?0:1),R.push(...W.children)}return F}J(s){s.preventDefault(),s.stopPropagation();const l=this.j.getFocusedElements();if(l.length===0)return;const F=l[0],A=this.o.getNodeLocation(F);if(!this.o.setCollapsed(A,!0)){const W=this.o.getParentNodeLocation(A);if(!W)return;const X=this.o.getListIndex(W);this.j.reveal(X),this.j.setFocus([X])}}K(s){s.preventDefault(),s.stopPropagation();const l=this.j.getFocusedElements();if(l.length===0)return;const F=l[0],A=this.o.getNodeLocation(F);if(!this.o.setCollapsed(A,!1)){if(!F.children.some(U=>U.visible))return;const[W]=this.j.getFocus(),X=W+1;this.j.reveal(X),this.j.setFocus([X])}}L(s){s.preventDefault(),s.stopPropagation();const l=this.j.getFocusedElements();if(l.length===0)return;const F=l[0],A=this.o.getNodeLocation(F),R=s.browserEvent.altKey;this.o.setCollapsed(A,void 0,R)}navigate(s){return new a(this.j,this.o,s)}dispose(){(0,g.$Pc)(this.D),this.B?.dispose(),this.j.dispose()}}t.$qV=D;class a{constructor(s,l,F){this.b=s,this.c=l,F?this.a=this.c.getListIndex(F):this.a=-1}current(){return this.a<0||this.a>=this.b.length?null:this.b.element(this.a).element}previous(){return this.a--,this.current()}next(){return this.a++,this.current()}first(){return this.a=0,this.current()}last(){return this.a=this.b.length-1,this.current()}}}),define(be[136],$e([1,0,135,127,27,29]),function(ne,t,i,N,z,H){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$BV=void 0;class E extends i.$qV{constructor(b,$,w,P,c,f={}){super(b,$,w,P,f),this.f=b,this.g=c,this.d=new Map,this.c=f.identityProvider}getInput(){return this.b}setInput(b,$){if($&&!this.c)throw new z.$gV(this.f,"Can't restore tree view state without an identity provider");if(this.b=b,!b){this.d.clear(),this.o.setChildren(null,H.Iterable.empty());return}if(!$){this.m(b);return}const w=[],P=[],c=e=>{const n=this.c.getId(e).toString();return!$.expanded[n]},f=e=>{const n=this.c.getId(e.element).toString();$.focus.has(n)&&w.push(e.element),$.selection.has(n)&&P.push(e.element)};this.m(b,c,f),this.setFocus(w),this.setSelection(P),$&&typeof $.scrollTop=="number"&&(this.scrollTop=$.scrollTop)}updateChildren(b=this.b){if(typeof this.b>"u")throw new z.$gV(this.f,"Tree input not set");let $;this.c&&($=w=>{const P=this.c.getId(w).toString(),c=this.d.get(P);if(c)return c.collapsed}),this.m(b,$)}resort(b=this.b,$=!0){this.o.resort(b===this.b?null:b,$)}refresh(b){if(b===void 0){this.j.rerender();return}this.o.rerender(b)}m(b,$,w){let P;if(this.c){const c=new Set,f=w;w=e=>{const n=this.c.getId(e.element).toString();c.add(n),this.d.set(n,e),f?.(e)},P=e=>{const n=this.c.getId(e.element).toString();c.has(n)||this.d.delete(n)}}this.o.setChildren(b===this.b?null:b,this.s(b,$).elements,{onDidCreateNode:w,onDidDeleteNode:P})}s(b,$){const w=[...this.g.getChildren(b)];return{elements:H.Iterable.map(w,c=>{const{elements:f,size:e}=this.s(c,$),n=this.g.hasChildren?this.g.hasChildren(c):void 0,h=e===0?void 0:$&&$(c);return{element:c,children:f,collapsible:n,collapsed:h}}),size:w.length}}M(b,$,w){return new N.$rV(b,$,w)}}t.$BV=E}),define(be[70],$e([1,0,12,9,36,30,28,6,4,3,56,10,7]),function(ne,t,i,N,z,H,E,k,b,$,w,P,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3h=t.ProxyChannel=t.$2h=t.$Yh=t.$Xh=t.$Wh=t.RequestInitiator=t.$Vh=t.$Sh=t.$Rh=void 0,t.$Th=O,t.$Uh=y,t.$Zh=Q,t.$1h=Z;var f;(function(le){le[le.Promise=100]="Promise",le[le.PromiseCancel=101]="PromiseCancel",le[le.EventListen=102]="EventListen",le[le.EventDispose=103]="EventDispose"})(f||(f={}));function e(le){switch(le){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var n;(function(le){le[le.Initialize=200]="Initialize",le[le.PromiseSuccess=201]="PromiseSuccess",le[le.PromiseError=202]="PromiseError",le[le.PromiseErrorObj=203]="PromiseErrorObj",le[le.EventFire=204]="EventFire"})(n||(n={}));function h(le){switch(le){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var m;(function(le){le[le.Uninitialized=0]="Uninitialized",le[le.Idle=1]="Idle"})(m||(m={}));function p(le){let _=0;for(let ae=0;;ae+=7){const re=le.read(1);if(_|=(re.buffer[0]&127)<<ae,!(re.buffer[0]&128))return _}}const v=C(0);function o(le,_){if(_===0){le.write(v);return}let ae=0;for(let J=_;J!==0;J=J>>>7)ae++;const re=z.$ue.alloc(ae);for(let J=0;_!==0;J++)re.buffer[J]=_&127,_=_>>>7,_>0&&(re.buffer[J]|=128);le.write(re)}class g{constructor(_){this.b=_,this.a=0}read(_){const ae=this.b.slice(this.a,this.a+_);return this.a+=ae.byteLength,ae}}t.$Rh=g;class r{constructor(){this.a=[]}get buffer(){return z.$ue.concat(this.a)}write(_){this.a.push(_)}}t.$Sh=r;var B;(function(le){le[le.Undefined=0]="Undefined",le[le.String=1]="String",le[le.Buffer=2]="Buffer",le[le.VSBuffer=3]="VSBuffer",le[le.Array=4]="Array",le[le.Object=5]="Object",le[le.Int=6]="Int"})(B||(B={}));function C(le){const _=z.$ue.alloc(1);return _.writeUInt8(le,0),_}const L={Undefined:C(B.Undefined),String:C(B.String),Buffer:C(B.Buffer),VSBuffer:C(B.VSBuffer),Array:C(B.Array),Object:C(B.Object),Uint:C(B.Int)},M=typeof Buffer<"u";function O(le,_){if(typeof _>"u")le.write(L.Undefined);else if(typeof _=="string"){const ae=z.$ue.fromString(_);le.write(L.String),o(le,ae.byteLength),le.write(ae)}else if(M&&Buffer.isBuffer(_)){const ae=z.$ue.wrap(_);le.write(L.Buffer),o(le,ae.byteLength),le.write(ae)}else if(_ instanceof z.$ue)le.write(L.VSBuffer),o(le,_.byteLength),le.write(_);else if(Array.isArray(_)){le.write(L.Array),o(le,_.length);for(const ae of _)O(le,ae)}else if(typeof _=="number"&&(_|0)===_)le.write(L.Uint),o(le,_);else{const ae=z.$ue.fromString(JSON.stringify(_));le.write(L.Object),o(le,ae.byteLength),le.write(ae)}}function y(le){switch(le.read(1).readUInt8(0)){case B.Undefined:return;case B.String:return le.read(p(le)).toString();case B.Buffer:return le.read(p(le)).buffer;case B.VSBuffer:return le.read(p(le));case B.Array:{const ae=p(le),re=[];for(let J=0;J<ae;J++)re.push(y(le));return re}case B.Object:return JSON.parse(le.read(p(le)).toString());case B.Int:return p(le)}}class x{constructor(_,ae,re=null,J=1e3){this.h=_,this.j=ae,this.k=re,this.l=J,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(G=>this.q(G)),this.m({type:200})}registerChannel(_,ae){this.b.set(_,ae),setTimeout(()=>this.w(_),0)}m(_){switch(_.type){case 200:{const ae=this.o([_.type]);this.k?.logOutgoing(ae,0,1,h(_.type));return}case 201:case 202:case 204:case 203:{const ae=this.o([_.type,_.id],_.data);this.k?.logOutgoing(ae,_.id,1,h(_.type),_.data);return}}}o(_,ae=void 0){const re=new r;return O(re,_),O(re,ae),this.p(re.buffer)}p(_){try{return this.h.send(_),_.byteLength}catch{return 0}}q(_){const ae=new g(_),re=y(ae),J=y(ae),G=re[0];switch(G){case 100:return this.k?.logIncoming(_.byteLength,re[1],1,`${e(G)}: ${re[2]}.${re[3]}`,J),this.s({type:G,id:re[1],channelName:re[2],name:re[3],arg:J});case 102:return this.k?.logIncoming(_.byteLength,re[1],1,`${e(G)}: ${re[2]}.${re[3]}`,J),this.t({type:G,id:re[1],channelName:re[2],name:re[3],arg:J});case 101:return this.k?.logIncoming(_.byteLength,re[1],1,`${e(G)}`),this.u({type:G,id:re[1]});case 103:return this.k?.logIncoming(_.byteLength,re[1],1,`${e(G)}`),this.u({type:G,id:re[1]})}}s(_){const ae=this.b.get(_.channelName);if(!ae){this.v(_);return}const re=new H.$ee;let J;try{J=ae.call(this.j,_.name,_.arg,re.token)}catch(ue){J=Promise.reject(ue)}const G=_.id;J.then(ue=>{this.m({id:G,data:ue,type:201})},ue=>{ue instanceof Error?this.m({id:G,data:{message:ue.message,name:ue.name,stack:ue.stack?ue.stack.split?ue.stack.split(`
`):ue.stack:void 0},type:202}):this.m({id:G,data:ue,type:203})}).finally(()=>{ie.dispose(),this.d.delete(_.id)});const ie=(0,$.$Sc)(()=>re.cancel());this.d.set(_.id,ie)}t(_){const ae=this.b.get(_.channelName);if(!ae){this.v(_);return}const re=_.id,G=ae.listen(this.j,_.name,_.arg)(ie=>this.m({id:re,data:ie,type:204}));this.d.set(_.id,G)}u(_){const ae=this.d.get(_.id);ae&&(ae.dispose(),this.d.delete(_.id))}v(_){let ae=this.g.get(_.channelName);ae||(ae=[],this.g.set(_.channelName,ae));const re=setTimeout(()=>{console.error(`Unknown channel: ${_.channelName}`),_.type===100&&this.m({id:_.id,data:{name:"Unknown channel",message:`Channel name '${_.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);ae.push({request:_,timeoutTimer:re})}w(_){const ae=this.g.get(_);if(ae){for(const re of ae)switch(clearTimeout(re.timeoutTimer),re.request.type){case 100:this.s(re.request);break;case 102:this.t(re.request);break}this.g.delete(_)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,$.$Pc)(this.d.values()),this.d.clear()}}t.$Vh=x;var q;(function(le){le[le.LocalSide=0]="LocalSide",le[le.OtherSide=1]="OtherSide"})(q||(t.RequestInitiator=q={}));class I{constructor(_,ae=null){this.l=_,this.a=!1,this.b=m.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new b.$7d,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(re=>this.s(re)),this.j=ae}getChannel(_){const ae=this;return{call(re,J,G){return ae.a?Promise.reject(new k.$5):ae.m(_,re,J,G)},listen(re,J){return ae.a?b.Event.None:ae.o(_,re,J)}}}m(_,ae,re,J=H.CancellationToken.None){const G=this.g++,ue={id:G,type:100,channelName:_,name:ae,arg:re};if(J.isCancellationRequested)return Promise.reject(new k.$5);let ye;return new Promise((Ae,ge)=>{if(J.isCancellationRequested)return ge(new k.$5);const u=()=>{const d=s=>{switch(s.type){case 201:this.f.delete(G),Ae(s.data);break;case 202:{this.f.delete(G);const l=new Error(s.data.message);l.stack=Array.isArray(s.data.stack)?s.data.stack.join(`
`):s.data.stack,l.name=s.data.name,ge(l);break}case 203:this.f.delete(G),ge(s.data);break}};this.f.set(G,d),this.p(ue)};let S=null;this.b===m.Idle?u():(S=(0,N.$7g)(d=>this.u()),S.then(()=>{S=null,u()}));const D=()=>{S?(S.cancel(),S=null):this.p({id:G,type:101}),ge(new k.$5)},a=J.onCancellationRequested(D);ye=(0,$.$Rc)((0,$.$Sc)(D),a),this.d.add(ye)}).finally(()=>{ye.dispose(),this.d.delete(ye)})}o(_,ae,re){const J=this.g++,ie={id:J,type:102,channelName:_,name:ae,arg:re};let ue=null;const ye=new b.$7d({onWillAddFirstListener:()=>{ue=(0,N.$7g)(Ae=>this.u()),ue.then(()=>{ue=null,this.d.add(ye),this.p(ie)})},onDidRemoveLastListener:()=>{ue?(ue.cancel(),ue=null):(this.d.delete(ye),this.p({id:J,type:103}))}}),Ne=Ae=>ye.fire(Ae.data);return this.f.set(J,Ne),ye.event}p(_){switch(_.type){case 100:case 102:{const ae=this.q([_.type,_.id,_.channelName,_.name],_.arg);this.j?.logOutgoing(ae,_.id,0,`${e(_.type)}: ${_.channelName}.${_.name}`,_.arg);return}case 101:case 103:{const ae=this.q([_.type,_.id]);this.j?.logOutgoing(ae,_.id,0,e(_.type));return}}}q(_,ae=void 0){const re=new r;return O(re,_),O(re,ae),this.r(re.buffer)}r(_){try{return this.l.send(_),_.byteLength}catch{return 0}}s(_){const ae=new g(_),re=y(ae),J=y(ae),G=re[0];switch(G){case 200:return this.j?.logIncoming(_.byteLength,0,0,h(G)),this.t({type:re[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(_.byteLength,re[1],0,h(G),J),this.t({type:re[0],id:re[1],data:J})}}t(_){if(_.type===200){this.b=m.Idle,this.k.fire();return}this.f.get(_.id)?.(_)}get onDidInitializePromise(){return b.Event.toPromise(this.onDidInitialize)}u(){return this.b===m.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,$.$Pc)(this.d.values()),this.d.clear()}}t.$Wh=I,Ze([E.$Lh],I.prototype,"onDidInitializePromise",null);class j{get connections(){const _=[];return this.f.forEach(ae=>_.push(ae)),_}constructor(_){this.a=new Map,this.f=new Set,this.g=new b.$7d,this.onDidAddConnection=this.g.event,this.h=new b.$7d,this.onDidRemoveConnection=this.h.event,this.j=new $.$Tc,this.j.add(_(({protocol:ae,onDidClientDisconnect:re})=>{const J=b.Event.once(ae.onMessage);this.j.add(J(G=>{const ie=new g(G),ue=y(ie),ye=new x(ae,ue),Ne=new I(ae);this.a.forEach((ge,u)=>ye.registerChannel(u,ge));const Ae={channelServer:ye,channelClient:Ne,ctx:ue};this.f.add(Ae),this.g.fire(Ae),this.j.add(re(()=>{ye.dispose(),Ne.dispose(),this.f.delete(Ae),this.h.fire(Ae)}))}))}))}getChannel(_,ae){const re=this;return{call(J,G,ie){let ue;if((0,c.$9f)(ae)){const Ne=(0,i.$4b)(re.connections.filter(ae));ue=Ne?Promise.resolve(Ne):b.Event.toPromise(b.Event.filter(re.onDidAddConnection,ae))}else ue=ae.routeCall(re,J,G);const ye=ue.then(Ne=>Ne.channelClient.getChannel(_));return Q(ye).call(J,G,ie)},listen(J,G){if((0,c.$9f)(ae))return re.k(_,ae,J,G);const ie=ae.routeEvent(re,J,G).then(ue=>ue.channelClient.getChannel(_));return Q(ie).listen(J,G)}}}k(_,ae,re,J){const G=this;let ie;const ue=new b.$7d({onWillAddFirstListener:()=>{ie=new $.$Tc;const ye=new b.$ae,Ne=new Map,Ae=u=>{const D=u.channelClient.getChannel(_).listen(re,J),a=ye.add(D);Ne.set(u,a)},ge=u=>{const S=Ne.get(u);S&&(S.dispose(),Ne.delete(u))};G.connections.filter(ae).forEach(Ae),b.Event.filter(G.onDidAddConnection,ae)(Ae,void 0,ie),G.onDidRemoveConnection(ge,void 0,ie),ye.event(ue.fire,ue,ie),ie.add(ye)},onDidRemoveLastListener:()=>{ie?.dispose(),ie=void 0}});return ue.event}registerChannel(_,ae){this.a.set(_,ae);for(const re of this.f)re.channelServer.registerChannel(_,ae)}dispose(){this.j.dispose();for(const _ of this.f)_.channelClient.dispose(),_.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}t.$Xh=j;class T{constructor(_,ae,re=null){const J=new r;O(J,ae),_.send(J.buffer),this.a=new I(_,re),this.d=new x(_,ae,re)}getChannel(_){return this.a.getChannel(_)}registerChannel(_,ae){this.d.registerChannel(_,ae)}dispose(){this.a.dispose(),this.d.dispose()}}t.$Yh=T;function Q(le){return{call(_,ae,re){return le.then(J=>J.call(_,ae,re))},listen(_,ae){const re=new b.$de;return le.then(J=>re.input=J.listen(_,ae)),re.event}}}function Z(le){let _=!1;return{call(ae,re,J){return _?le.call(ae,re,J):(0,N.$ih)(0).then(()=>_=!0).then(()=>le.call(ae,re,J))},listen(ae,re){if(_)return le.listen(ae,re);const J=new b.$de;return(0,N.$ih)(0).then(()=>_=!0).then(()=>J.input=le.listen(ae,re)),J.event}}}class ce{constructor(_){this.a=_}routeCall(_){return this.b(_)}routeEvent(_){return this.b(_)}async b(_){for(const ae of _.connections)if(await Promise.resolve(this.a(ae.ctx)))return Promise.resolve(ae);return await b.Event.toPromise(_.onDidAddConnection),await this.b(_)}}t.$2h=ce;var oe;(function(le){function _(G,ie,ue){const ye=G,Ne=ue&&ue.disableMarshalling,Ae=new Map;for(const ge in ye)re(ge)&&Ae.set(ge,b.Event.buffer(ye[ge],!0,void 0,ie));return new class{listen(ge,u,S){const D=Ae.get(u);if(D)return D;const a=ye[u];if(typeof a=="function"){if(J(u))return a.call(ye,S);if(re(u))return Ae.set(u,b.Event.buffer(ye[u],!0,void 0,ie)),Ae.get(u)}throw new k.$bb(`Event not found: ${u}`)}call(ge,u,S){const D=ye[u];if(typeof D=="function"){if(!Ne&&Array.isArray(S))for(let d=0;d<S.length;d++)S[d]=(0,w.$Qh)(S[d]);let a=D.apply(ye,S);return a instanceof Promise||(a=Promise.resolve(a)),a}throw new k.$bb(`Method not found: ${u}`)}}}le.fromService=_;function ae(G,ie){const ue=ie&&ie.disableMarshalling;return new Proxy({},{get(ye,Ne){if(typeof Ne=="string")return ie?.properties?.has(Ne)?ie.properties.get(Ne):J(Ne)?function(Ae){return G.listen(Ne,Ae)}:re(Ne)?G.listen(Ne):async function(...Ae){let ge;ie&&!(0,c.$4f)(ie.context)?ge=[ie.context,...Ae]:ge=Ae;const u=await G.call(Ne,ge);return ue?u:(0,w.$Qh)(u)};throw new k.$bb(`Property not found: ${String(Ne)}`)}})}le.toService=ae;function re(G){return G[0]==="o"&&G[1]==="n"&&P.$kf(G.charCodeAt(2))}function J(G){return/^onDynamic/.test(G)&&P.$kf(G.charCodeAt(9))}})(oe||(t.ProxyChannel=oe={}));const te=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function de(le){if(Array.isArray(le))return le;if(le&&typeof le=="object"&&typeof le.toString=="function"){const _=le.toString();if(_!=="[object Object]")return _}return le}function Be(le){return Array.isArray(le)?le.map(de):de(le)}function Fe(le,_,ae,re,J,G,ie){ie=Be(ie);const ue=te[J],ye=ue[re%ue.length];let Ne=[`%c[${le}]%c[${String(_).padStart(7," ")}]%c[len: ${String(ae).padStart(5," ")}]%c${String(re).padStart(5," ")} - ${G}`,"color: darkgreen","color: grey","color: grey",`color: ${ye}`];/\($/.test(G)?(Ne=Ne.concat(ie),Ne.push(")")):Ne.push(ie),console.log.apply(console,Ne)}class Pe{constructor(_,ae){this.d=_,this.f=ae,this.a=0,this.b=0}logOutgoing(_,ae,re,J,G){this.b+=_,Fe(this.d,this.b,_,ae,re,J,G)}logIncoming(_,ae,re,J,G){this.a+=_,Fe(this.f,this.a,_,ae,re,J,G)}}t.$3h=Pe}),define(be[137],$e([1,0,36,4,70,94,31]),function(ne,t,i,N,z,H,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$_V=void 0;class k extends z.$Yh{static f(){const $=N.Event.fromNodeEventEmitter(E.$O,"vscode:message",(w,P)=>i.$ue.wrap(P));return E.$O.send("vscode:hello"),new H.$8V(E.$O,$)}constructor($){const w=k.f();super(w,$),this.b=w}dispose(){this.b.disconnect(),super.dispose()}}t.$_V=k}),define(be[138],$e([13,11]),function(ne,t){return ne.create("vs/platform/files/common/files",t)}),define(be[139],$e([13,11]),function(ne,t){return ne.create("vs/platform/theme/common/iconRegistry",t)}),define(be[44],$e([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$gi=t._util=void 0,t.$hi=z,t.$ii=H;var i;(function(E){E.serviceIds=new Map,E.DI_TARGET="$di$target",E.DI_DEPENDENCIES="$di$dependencies";function k(b){return b[E.DI_DEPENDENCIES]||[]}E.getServiceDependencies=k})(i||(t._util=i={})),t.$gi=z("instantiationService");function N(E,k,b){k[i.DI_TARGET]===k?k[i.DI_DEPENDENCIES].push({id:E,index:b}):(k[i.DI_DEPENDENCIES]=[{id:E,index:b}],k[i.DI_TARGET]=k)}function z(E){if(i.serviceIds.has(E))return i.serviceIds.get(E);const k=function(b,$,w){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");N(k,b,w)};return k.toString=()=>E,i.serviceIds.set(E,k),k}function H(E){return E}}),define(be[140],$e([1,0,44]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3m=t.$1m=t.ID=void 0,t.$2m=N,t.ID="diagnosticsService",t.$1m=(0,i.$hi)(t.ID);function N(H){return!!H.hostName&&!!H.errorMessage}class z{async getPerformanceInfo(E,k){return{}}async getSystemInfo(E,k){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(E,k){return""}async getWorkspaceFileExtensions(E){return{extensions:[]}}async reportWorkspaceStats(E){}}t.$3m=z}),define(be[141],$e([1,0,91,25,10,7,16,138,44,5,32,23]),function(ne,t,i,N,z,H,E,k,b,$,w,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$jl=t.$gl=t.FileKind=t.$fl=t.$el=t.$dl=t.$cl=t.$bl=t.$al=t.$_k=t.FileOperationResult=t.$$k=t.$0k=t.$9k=t.$7k=t.FileChangeType=t.$6k=t.FileOperation=t.$Zk=t.FileSystemProviderErrorCode=t.FileSystemProviderCapabilities=t.FilePermission=t.FileType=t.$Nk=void 0,t.$Ok=c,t.$Pk=n,t.$Qk=m,t.$Rk=p,t.$Sk=v,t.$Tk=o,t.$Uk=g,t.$Vk=r,t.$Wk=B,t.$Xk=C,t.$Yk=L,t.$1k=y,t.$2k=x,t.$3k=q,t.$4k=I,t.$5k=j,t.$8k=oe,t.$hl=le,t.$il=_,t.$kl=re,t.$Nk=(0,b.$hi)("fileService");function c(J){return J.create===!0}var f;(function(J){J[J.Unknown=0]="Unknown",J[J.File=1]="File",J[J.Directory=2]="Directory",J[J.SymbolicLink=64]="SymbolicLink"})(f||(t.FileType=f={}));var e;(function(J){J[J.Readonly=1]="Readonly",J[J.Locked=2]="Locked"})(e||(t.FilePermission=e={}));function n(J){const G=J;return!!G&&typeof G.onDidChange=="function"}var h;(function(J){J[J.None=0]="None",J[J.FileReadWrite=2]="FileReadWrite",J[J.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",J[J.FileReadStream=16]="FileReadStream",J[J.FileFolderCopy=8]="FileFolderCopy",J[J.PathCaseSensitive=1024]="PathCaseSensitive",J[J.Readonly=2048]="Readonly",J[J.Trash=4096]="Trash",J[J.FileWriteUnlock=8192]="FileWriteUnlock",J[J.FileAtomicRead=16384]="FileAtomicRead",J[J.FileAtomicWrite=32768]="FileAtomicWrite",J[J.FileAtomicDelete=65536]="FileAtomicDelete",J[J.FileClone=131072]="FileClone"})(h||(t.FileSystemProviderCapabilities=h={}));function m(J){return!!(J.capabilities&2)}function p(J){return!!(J.capabilities&8)}function v(J){return!!(J.capabilities&131072)}function o(J){return!!(J.capabilities&4)}function g(J){return!!(J.capabilities&16)}function r(J){return m(J)?!!(J.capabilities&16384):!1}function B(J){return m(J)?!!(J.capabilities&32768):!1}function C(J){return!!(J.capabilities&65536)}function L(J){return!!(J.capabilities&2048)}var M;(function(J){J.FileExists="EntryExists",J.FileNotFound="EntryNotFound",J.FileNotADirectory="EntryNotADirectory",J.FileIsADirectory="EntryIsADirectory",J.FileExceedsStorageQuota="EntryExceedsStorageQuota",J.FileTooLarge="EntryTooLarge",J.FileWriteLocked="EntryWriteLocked",J.NoPermissions="NoPermissions",J.Unavailable="Unavailable",J.Unknown="Unknown"})(M||(t.FileSystemProviderErrorCode=M={}));class O extends Error{static create(G,ie){const ue=new O(G.toString(),ie);return q(ue,ie),ue}constructor(G,ie){super(G),this.code=ie}}t.$Zk=O;function y(J,G){return O.create(J,G)}function x(J){return J||y((0,k.localize)(0,null),M.Unknown)}function q(J,G){return J.name=G?`${G} (FileSystemError)`:"FileSystemError",J}function I(J){if(!J)return M.Unknown;if(J instanceof O)return J.code;const G=/^(.+) \(FileSystemError\)$/.exec(J.name);if(!G)return M.Unknown;switch(G[1]){case M.FileExists:return M.FileExists;case M.FileIsADirectory:return M.FileIsADirectory;case M.FileNotADirectory:return M.FileNotADirectory;case M.FileNotFound:return M.FileNotFound;case M.FileTooLarge:return M.FileTooLarge;case M.FileWriteLocked:return M.FileWriteLocked;case M.NoPermissions:return M.NoPermissions;case M.Unavailable:return M.Unavailable}return M.Unknown}function j(J){if(J instanceof te)return J.fileOperationResult;switch(I(J)){case M.FileNotFound:return 1;case M.FileIsADirectory:return 0;case M.FileNotADirectory:return 9;case M.FileWriteLocked:return 5;case M.NoPermissions:return 6;case M.FileExists:return 4;case M.FileTooLarge:return 7;default:return 10}}var T;(function(J){J[J.CREATE=0]="CREATE",J[J.DELETE=1]="DELETE",J[J.MOVE=2]="MOVE",J[J.COPY=3]="COPY",J[J.WRITE=4]="WRITE"})(T||(t.FileOperation=T={}));class Q{constructor(G,ie,ue){this.resource=G,this.operation=ie,this.target=ue}isOperation(G){return this.operation===G}}t.$6k=Q;var Z;(function(J){J[J.UPDATED=0]="UPDATED",J[J.ADDED=1]="ADDED",J[J.DELETED=2]="DELETED"})(Z||(t.FileChangeType=Z={}));class ce{static{this.a=null}constructor(G,ie){this.c=ie,this.b=void 0,this.d=new P.$V(()=>{const ue=i.$ni.forUris(()=>this.c);return ue.fill(this.rawAdded.map(ye=>[ye,!0])),ue}),this.f=new P.$V(()=>{const ue=i.$ni.forUris(()=>this.c);return ue.fill(this.rawUpdated.map(ye=>[ye,!0])),ue}),this.g=new P.$V(()=>{const ue=i.$ni.forUris(()=>this.c);return ue.fill(this.rawDeleted.map(ye=>[ye,!0])),ue}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const ue of G){switch(ue.type){case 1:this.rawAdded.push(ue.resource);break;case 0:this.rawUpdated.push(ue.resource);break;case 2:this.rawDeleted.push(ue.resource);break}this.b!==ce.a&&(typeof ue.cId=="number"?this.b===void 0?this.b=ue.cId:this.b!==ue.cId&&(this.b=ce.a):this.b!==void 0&&(this.b=ce.a))}}contains(G,...ie){return this.h(G,{includeChildren:!1},...ie)}affects(G,...ie){return this.h(G,{includeChildren:!0},...ie)}h(G,ie,...ue){if(!G)return!1;const ye=ue.length>0;return!!((!ye||ue.includes(1))&&(this.d.value.get(G)||ie.includeChildren&&this.d.value.findSuperstr(G))||(!ye||ue.includes(0))&&(this.f.value.get(G)||ie.includeChildren&&this.f.value.findSuperstr(G))||(!ye||ue.includes(2))&&(this.g.value.findSubstr(G)||ie.includeChildren&&this.g.value.findSuperstr(G)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(G){return this.b===G}hasCorrelation(){return typeof this.b=="number"}}t.$7k=ce;function oe(J,G,ie){return!J||!G||J===G||G.length>J.length?!1:(G.charAt(G.length-1)!==N.sep&&(G+=N.sep),ie?(0,z.$mf)(J,G):J.indexOf(G)===0)}class te extends Error{constructor(G,ie,ue){super(G),this.fileOperationResult=ie,this.options=ue}}t.$9k=te;class de extends te{constructor(G,ie,ue,ye){super(G,ie,ye),this.fileOperationResult=ie,this.size=ue}}t.$0k=de;class Be extends te{constructor(G,ie,ue){super(G,2,ue),this.stat=ie}}t.$$k=Be;var Fe;(function(J){J[J.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",J[J.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",J[J.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",J[J.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",J[J.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",J[J.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",J[J.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",J[J.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",J[J.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",J[J.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",J[J.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Fe||(t.FileOperationResult=Fe={})),t.$_k={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},t.$al={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},t.$bl="files.associations",t.$cl="files.exclude",t.$dl="files.readonlyInclude",t.$el="files.readonlyExclude",t.$fl="files.readonlyFromPermissions";var Pe;(function(J){J[J.FILE=0]="FILE",J[J.FOLDER=1]="FOLDER",J[J.ROOT_FOLDER=2]="ROOT_FOLDER"})(Pe||(t.FileKind=Pe={})),t.$gl="";function le(J){if(!(typeof J.size!="number"||typeof J.mtime!="number"))return J.mtime.toString(29)+J.size.toString(31)}async function _(J,G){if(!G.hasProvider(E.URI.from({scheme:J.scheme})))return new Promise(ie=>{const ue=G.onDidChangeFileSystemProviderRegistrations(ye=>{ye.scheme===J.scheme&&ye.added&&(ue.dispose(),ie())})})}class ae{static{this.KB=1024}static{this.MB=ae.KB*ae.KB}static{this.GB=ae.MB*ae.KB}static{this.TB=ae.GB*ae.KB}static formatSize(G){return(0,H.$Yf)(G)||(G=0),G<ae.KB?(0,k.localize)(1,null,G.toFixed(0)):G<ae.MB?(0,k.localize)(2,null,(G/ae.KB).toFixed(2)):G<ae.GB?(0,k.localize)(3,null,(G/ae.MB).toFixed(2)):G<ae.TB?(0,k.localize)(4,null,(G/ae.GB).toFixed(2)):(0,k.localize)(5,null,(G/ae.TB).toFixed(2))}}t.$jl=ae;function re(J){const G=typeof J=="string"||J?.scheme===w.Schemas.vscodeRemote;return typeof J!="string"&&J?.scheme===w.Schemas.file?1024*ae.MB:G?10*ae.MB:$.$o?50*ae.MB:1024*ae.MB}}),define(be[142],$e([1,0,44]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Lbc=t.$Kbc=void 0,t.$Kbc=(0,i.$hi)("mainProcessService");class N{constructor(H,E){this.a=H,this.b=E}getChannel(H){return this.a.getChannel(H,this.b)}registerChannel(H,E){this.a.registerChannel(H,E)}}t.$Lbc=N}),define(be[143],$e([1,0,3,137]),function(ne,t,i,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Mbc=void 0;class z extends i.$Uc{constructor(E){super(),this.a=this.B(new N.$_V(`window:${E}`))}getChannel(E){return this.a.getChannel(E)}registerChannel(E,k){this.a.registerChannel(E,k)}}t.$Mbc=z});var Ei=this&&this.__param||function(ne,t){return function(i,N){t(i,N,ne)}};define(be[144],$e([1,0,70,142]),function(ne,t,i,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Qbc=void 0;let z=class{constructor(E,k){return this.windowId=E,i.ProxyChannel.toService(k.getChannel("nativeHost"),{context:E,properties:(()=>{const b=new Map;return b.set("windowId",E),b})()})}};t.$Qbc=z,t.$Qbc=z=Ze([Ei(1,N.$Kbc)],z)}),define(be[71],$e([1,0,79,7]),function(ne,t,i,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Zn=void 0;class z{constructor(){this.a=new Map}add(E,k){i.ok(N.$Uf(E)),i.ok(N.$Wf(k)),i.ok(!this.a.has(E),"There is already an extension with this id"),this.a.set(E,k)}knows(E){return this.a.has(E)}as(E){return this.a.get(E)||null}}t.$Zn=new z}),define(be[145],$e([1,0,4,71]),function(ne,t,i,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1n=void 0,t.$1n={JSONContribution:"base.contributions.json"};function z(k){return k.length>0&&k.charAt(k.length-1)==="#"?k.substring(0,k.length-1):k}class H{constructor(){this.b=new i.$7d,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(b,$){this.a[z(b)]=$,this.b.fire(b)}notifySchemaChanged(b){this.b.fire(b)}getSchemaContributions(){return{schemas:this.a}}}const E=new H;N.$Zn.add(t.$1n.JSONContribution,E)}),define(be[146],$e([1,0,9,18,38,19,4,7,16,139,145,71]),function(ne,t,i,N,z,H,E,k,b,$,w,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1w=t.$Zw=t.$Yw=t.$Xw=t.$Ww=t.$Vw=t.IconFontDefinition=t.IconContribution=t.$Sw=void 0,t.$Tw=h,t.$Uw=m,t.$Sw={IconContribution:"base.contributions.icons"};var c;(function(g){function r(B,C){let L=B.defaults;for(;H.ThemeIcon.isThemeIcon(L);){const M=n.getIcon(L.id);if(!M)return;L=M.defaults}return L}g.getDefinition=r})(c||(t.IconContribution=c={}));var f;(function(g){function r(C){return{weight:C.weight,style:C.style,src:C.src.map(L=>({format:L.format,location:L.location.toString()}))}}g.toJSONObject=r;function B(C){const L=M=>(0,k.$Uf)(M)?M:void 0;if(C&&Array.isArray(C.src)&&C.src.every(M=>(0,k.$Uf)(M.format)&&(0,k.$Uf)(M.location)))return{weight:L(C.weight),style:L(C.style),src:C.src.map(M=>({format:M.format,location:b.URI.parse(M.location)}))}}g.fromJSONObject=B})(f||(t.IconFontDefinition=f={}));class e{constructor(){this.a=new E.$7d,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,$.localize)(0,null)},fontCharacter:{type:"string",description:(0,$.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${H.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(r,B,C,L){const M=this.b[r];if(M){if(C&&!M.description){M.description=C,this.d.properties[r].markdownDescription=`${C} $(${r})`;const x=this.e.enum.indexOf(r);x!==-1&&(this.e.enumDescriptions[x]=C),this.a.fire()}return M}const O={id:r,description:C,defaults:B,deprecationMessage:L};this.b[r]=O;const y={$ref:"#/definitions/icons"};return L&&(y.deprecationMessage=L),C&&(y.markdownDescription=`${C}: $(${r})`),this.d.properties[r]=y,this.e.enum.push(r),this.e.enumDescriptions.push(C||""),this.a.fire(),{id:r}}deregisterIcon(r){delete this.b[r],delete this.d.properties[r];const B=this.e.enum.indexOf(r);B!==-1&&(this.e.enum.splice(B,1),this.e.enumDescriptions.splice(B,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(r=>this.b[r])}getIcon(r){return this.b[r]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(r,B){const C=this.f[r];return C||(this.f[r]=B,this.a.fire(),B)}deregisterIconFont(r){delete this.f[r]}getIconFont(r){return this.f[r]}toString(){const r=(M,O)=>M.id.localeCompare(O.id),B=M=>{for(;H.ThemeIcon.isThemeIcon(M.defaults);)M=this.b[M.defaults.id];return`codicon codicon-${M?M.id:""}`},C=[];C.push("| preview     | identifier                        | default codicon ID                | description"),C.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const L=Object.keys(this.b).map(M=>this.b[M]);for(const M of L.filter(O=>!!O.description).sort(r))C.push(`|<i class="${B(M)}"></i>|${M.id}|${H.ThemeIcon.isThemeIcon(M.defaults)?M.defaults.id:M.id}|${M.description||""}|`);C.push("| preview     | identifier                        "),C.push("| ----------- | --------------------------------- |");for(const M of L.filter(O=>!H.ThemeIcon.isThemeIcon(O.defaults)).sort(r))C.push(`|<i class="${B(M)}"></i>|${M.id}|`);return C.join(`
`)}}const n=new e;P.$Zn.add(t.$Sw.IconContribution,n);function h(g,r,B,C){return n.registerIcon(g,r,B,C)}function m(){return n}function p(){const g=(0,z.$Cj)();for(const r in g){const B="\\"+g[r].toString(16);n.registerIcon(r,{fontCharacter:B})}}p(),t.$Vw="vscode://schemas/icons";const v=P.$Zn.as(w.$1n.JSONContribution);v.registerSchema(t.$Vw,n.getIconSchema());const o=new i.$th(()=>v.notifySchemaChanged(t.$Vw),200);n.onDidChange(()=>{o.isScheduled()||o.schedule()}),t.$Ww=h("widget-close",N.$Gj.close,(0,$.localize)(2,null)),t.$Xw=h("goto-previous-location",N.$Gj.arrowUp,(0,$.localize)(3,null)),t.$Yw=h("goto-next-location",N.$Gj.arrowDown,(0,$.localize)(4,null)),t.$Zw=H.ThemeIcon.modify(N.$Gj.sync,"spin"),t.$1w=H.ThemeIcon.modify(N.$Gj.loading,"spin")}),define(be[147],$e([1,0,2,4,3,19,146]),function(ne,t,i,N,z,H,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$$Hb=void 0,t.$0Hb=k;function k($){const w=new z.$Tc,P=w.add(new N.$7d),c=(0,E.$Uw)();return w.add(c.onDidChange(()=>P.fire())),$&&w.add($.onDidProductIconThemeChange(()=>P.fire())),{dispose:()=>w.dispose(),onDidChange:P.event,getCSS(){const f=$?$.getProductIconTheme():new b,e={},n=m=>{const p=f.getIcon(m);if(!p)return;const v=p.font;return v?(e[v.id]=v.definition,`.codicon-${m.id}:before { content: '${p.fontCharacter}'; font-family: ${(0,i.$mS)(v.id)}; }`):`.codicon-${m.id}:before { content: '${p.fontCharacter}'; }`},h=[];for(const m of c.getIcons()){const p=n(m);p&&h.push(p)}for(const m in e){const p=e[m],v=p.weight?`font-weight: ${p.weight};`:"",o=p.style?`font-style: ${p.style};`:"",g=p.src.map(r=>`${(0,i.$lS)(r.location)} format('${r.format}')`).join(", ");h.push(`@font-face { src: ${g}; font-family: ${(0,i.$mS)(m)};${v}${o} font-display: block; }`)}return h.join(`
`)}}}class b{getIcon(w){const P=(0,E.$Uw)();let c=w.defaults;for(;H.ThemeIcon.isThemeIcon(c);){const f=P.getIcon(c.id);if(!f)return;c=f.defaults}return c}}t.$$Hb=b}),define(be[148],$e([1,0,5]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CustomTitleBarVisibility=t.TitlebarStyle=t.TitleBarSetting=t.$$C=void 0,t.$_C=N,t.$aD=z,t.$bD=H,t.$cD=E,t.$dD=k,t.$eD=P,t.$fD=c,t.$gD=f,t.$hD=e,t.$iD=n,t.$jD=h,t.$$C={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function N(m){return typeof m.parentId=="number"}function z(m){return!!m.workspaceUri}function H(m){return!!m.folderUri}function E(m){return!!m.fileUri}function k(m){const p=c(m),v=m.getValue("window.menuBarVisibility");return v==="default"||p&&v==="compact"||i.$j&&i.$m?"classic":v}var b;(function(m){m.TITLE_BAR_STYLE="window.titleBarStyle",m.CUSTOM_TITLE_BAR_VISIBILITY="window.customTitleBarVisibility"})(b||(t.TitleBarSetting=b={}));var $;(function(m){m.NATIVE="native",m.CUSTOM="custom"})($||(t.TitlebarStyle=$={}));var w;(function(m){m.AUTO="auto",m.WINDOWED="windowed",m.NEVER="never"})(w||(t.CustomTitleBarVisibility=w={}));function P(m,p){return!0}function c(m,p){return p||(p=f(m)),p==="native"}function f(m){if(i.$o)return"custom";const p=m.getValue("window");if(p){if(i.$j&&p.nativeTabs===!0||i.$j&&p.nativeFullScreen===!1)return"native";const g=p.titleBarStyle;if(g==="native"||g==="custom")return g}return i.$k?"native":"custom"}function e(m){return!(!i.$i||i.$o||c(m))}function n(m){const p=m.getValue("window");return!p||typeof p.nativeFullScreen!="boolean"||p.nativeTabs?!0:p.nativeFullScreen!==!1}function h(m=0){return Math.pow(1.2,m)}}),define(be[149],$e([1,0,17,2,22,31,148]),function(ne,t,i,N,z,H,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Tbc=t.$Sbc=t.ApplyZoomTarget=void 0,t.$Ubc=b,t.$Vbc=w,t.$Wbc=P;var k;(function(c){c[c.ACTIVE_WINDOW=1]="ACTIVE_WINDOW",c[c.ALL_WINDOWS=2]="ALL_WINDOWS"})(k||(t.ApplyZoomTarget=k={})),t.$Sbc=8,t.$Tbc=-8;function b(c,f){c=Math.min(Math.max(c,t.$Tbc),t.$Sbc);const e=[];f===k.ACTIVE_WINDOW?e.push((0,N.$MR)()):f===k.ALL_WINDOWS?e.push(...Array.from((0,N.getWindows)()).map(({window:n})=>n)):e.push(f);for(const n of e)$(n)?.webFrame?.setZoomLevel(c),(0,i.$JQ)((0,E.$jD)(c),n),(0,i.$FQ)(c,n)}function $(c){if(c===z.$BQ)return{ipcRenderer:H.$O,webFrame:H.$Q};{const f=c;if(f?.vscode?.ipcRenderer&&f?.vscode?.webFrame)return f.vscode}}function w(c){b((0,i.$GQ)(typeof c=="number"?(0,N.$MR)():c)+1,c)}function P(c){b((0,i.$GQ)(typeof c=="number"?(0,N.$MR)():c)-1,c)}}),define(be[150],$e([1,0,11,2,136,9,95,31,140,141,143,144,147,149,15,22,108,99]),function(ne,t,i,N,z,H,E,k,b,$,w,P,c,f,e,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.startup=x;const h=/\s--inspect(?:-brk|port)?=(?<port>\d+)?/,m=/\s--inspect-port=(?<port>\d+)/;class p{getHeight(I){return 22}getTemplateId(I){return M(I)?"process":C(I)?"machine":(0,b.$2m)(I)?"error":L(I)?"header":""}}class v{hasChildren(I){return(0,b.$2m)(I)?!1:M(I)?!!I.children?.length:!0}getChildren(I){return M(I)?I.children?I.children:[]:(0,b.$2m)(I)?[]:L(I)?I.processRoots.length>1?I.processRoots:[I.processRoots[0].rootProcess]:C(I)?[I.rootProcess]:[I.processes]}}class o{constructor(){this.templateId="header"}renderTemplate(I){const j=(0,N.$8R)(I,(0,N.$)(".row")),T=(0,N.$8R)(j,(0,N.$)(".nameLabel")),Q=(0,N.$8R)(j,(0,N.$)(".cpu")),Z=(0,N.$8R)(j,(0,N.$)(".memory")),ce=(0,N.$8R)(j,(0,N.$)(".pid"));return{name:T,CPU:Q,memory:Z,PID:ce}}renderElement(I,j,T,Q){T.name.textContent=(0,i.localize)(0,null),T.CPU.textContent=(0,i.localize)(1,null),T.PID.textContent=(0,i.localize)(2,null),T.memory.textContent=(0,i.localize)(3,null)}disposeTemplate(I){}}class g{constructor(){this.templateId="machine"}renderTemplate(I){const j=Object.create(null),T=(0,N.$8R)(I,(0,N.$)(".row"));return j.name=(0,N.$8R)(T,(0,N.$)(".nameLabel")),j}renderElement(I,j,T,Q){T.name.textContent=I.element.name}disposeTemplate(I){}}class r{constructor(){this.templateId="error"}renderTemplate(I){const j=Object.create(null),T=(0,N.$8R)(I,(0,N.$)(".row"));return j.name=(0,N.$8R)(T,(0,N.$)(".nameLabel")),j}renderElement(I,j,T,Q){T.name.textContent=I.element.errorMessage}disposeTemplate(I){}}class B{constructor(I,j,T){this.a=I,this.b=j,this.c=T,this.templateId="process"}renderTemplate(I){const j=(0,N.$8R)(I,(0,N.$)(".row")),T=(0,N.$8R)(j,(0,N.$)(".nameLabel")),Q=(0,N.$8R)(j,(0,N.$)(".cpu")),Z=(0,N.$8R)(j,(0,N.$)(".memory")),ce=(0,N.$8R)(j,(0,N.$)(".pid"));return{name:T,CPU:Q,PID:ce,memory:Z}}renderElement(I,j,T,Q){const{element:Z}=I,ce=Z.pid.toFixed(0);let oe=Z.name;this.c.has(Z.pid)&&(oe=this.c.get(Z.pid)),T.name.textContent=oe,T.name.title=Z.cmd,T.CPU.textContent=Z.load.toFixed(0),T.PID.textContent=ce,T.PID.parentElement.id=`pid-${ce}`;const te=this.a==="win32"?Z.mem:this.b*(Z.mem/100);T.memory.textContent=(te/$.$jl.MB).toFixed(0)}disposeTemplate(I){}}function C(q){return!!q.name&&!!q.rootProcess}function L(q){return!!q.processRoots}function M(q){return!!q.pid}class O{constructor(I,j){this.f=j,this.b=new Map;const T=new w.$Mbc(I);this.c=new P.$Qbc(I,T),this.k(j.styles),this.g(j),k.$O.on("vscode:pidToNameResponse",(Q,Z)=>{this.b.clear();for(const[ce,oe]of Z)this.b.set(ce,oe)}),k.$O.on("vscode:listProcessesResponse",async(Q,Z)=>{Z.forEach((ce,oe)=>{M(ce.rootProcess)&&(ce.rootProcess.name=oe===0?`${this.f.applicationName} main`:"remote agent")}),this.d?(this.d.setInput({processes:{processRoots:Z}}),this.d.layout(n.$BQ.innerHeight,n.$BQ.innerWidth)):await this.h(Z),this.m(0)}),this.a=Date.now(),k.$O.send("vscode:pidToNameRequest"),k.$O.send("vscode:listProcesses")}g(I){n.$BQ.document.onkeydown=j=>{const T=I.platform==="darwin"?j.metaKey:j.ctrlKey;T&&j.keyCode===87&&(j.stopPropagation(),j.preventDefault(),k.$O.send("vscode:closeProcessExplorer")),T&&j.keyCode===187&&(0,f.$Vbc)(n.$BQ),T&&j.keyCode===189&&(0,f.$Wbc)(n.$BQ)}}async h(I){const j=n.$BQ.document.getElementById("process-list");if(!j)return;const{totalmem:T}=await this.c.getOSStatistics(),Q=[new B(this.f.platform,T,this.b),new o,new g,new r];this.d=new z.$BV("processExplorer",j,new p,Q,new v,{identityProvider:{getId:Z=>M(Z)?Z.pid.toString():(0,b.$2m)(Z)?Z.hostName:L(Z)?"processes":C(Z)?Z.name:"header"}}),this.d.setInput({processes:{processRoots:I}}),this.d.layout(n.$BQ.innerHeight,n.$BQ.innerWidth),this.d.onKeyDown(Z=>{const ce=new e.$5Q(Z);if(ce.keyCode===35&&ce.altKey){const oe=this.n();Promise.all(oe.map(te=>this.c.killProcess(te,"SIGTERM"))).then(()=>this.d?.refresh())}}),this.d.onContextMenu(Z=>{M(Z.element)&&this.l(Z.element,!0)}),j.style.height=`${n.$BQ.innerHeight}px`,n.$BQ.addEventListener("resize",()=>{j.style.height=`${n.$BQ.innerHeight}px`,this.d?.layout(n.$BQ.innerHeight,n.$BQ.innerWidth)})}i(I){const j=h.exec(I);return j&&j.groups.port!=="0"||I.indexOf("node ")>=0||I.indexOf("node.exe")>=0}j(I){const j={type:"node",request:"attach",name:`process ${I.pid}`};let T=h.exec(I.cmd);T?j.port=Number(T.groups.port):j.processId=String(I.pid),T=m.exec(I.cmd),T&&(j.port=Number(T.groups.port)),k.$O.send("vscode:workbenchCommand",{id:"debug.startFromConfig",from:"processExplorer",args:[j]})}k(I){const j=(0,N.$PR)(),T=[];I.listFocusBackground&&(T.push(`.monaco-list:focus .monaco-list-row.focused { background-color: ${I.listFocusBackground}; }`),T.push(`.monaco-list:focus .monaco-list-row.focused:hover { background-color: ${I.listFocusBackground}; }`)),I.listFocusForeground&&T.push(`.monaco-list:focus .monaco-list-row.focused { color: ${I.listFocusForeground}; }`),I.listActiveSelectionBackground&&(T.push(`.monaco-list:focus .monaco-list-row.selected { background-color: ${I.listActiveSelectionBackground}; }`),T.push(`.monaco-list:focus .monaco-list-row.selected:hover { background-color: ${I.listActiveSelectionBackground}; }`)),I.listActiveSelectionForeground&&T.push(`.monaco-list:focus .monaco-list-row.selected { color: ${I.listActiveSelectionForeground}; }`),I.listHoverBackground&&T.push(`.monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${I.listHoverBackground}; }`),I.listHoverForeground&&T.push(`.monaco-list-row:hover:not(.selected):not(.focused) { color: ${I.listHoverForeground}; }`),I.listFocusOutline&&T.push(`.monaco-list:focus .monaco-list-row.focused { outline: 1px solid ${I.listFocusOutline}; outline-offset: -1px; }`),I.listHoverOutline&&T.push(`.monaco-list-row:hover { outline: 1px dashed ${I.listHoverOutline}; outline-offset: -1px; }`),I.scrollbarShadowColor&&T.push(`
				.monaco-scrollable-element > .shadow.top {
					box-shadow: ${I.scrollbarShadowColor} 0 6px 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.left {
					box-shadow: ${I.scrollbarShadowColor} 6px 0 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.top.left {
					box-shadow: ${I.scrollbarShadowColor} 6px 6px 6px -6px inset;
				}
			`),I.scrollbarSliderBackgroundColor&&T.push(`
				.monaco-scrollable-element > .scrollbar > .slider {
					background: ${I.scrollbarSliderBackgroundColor};
				}
			`),I.scrollbarSliderHoverBackgroundColor&&T.push(`
				.monaco-scrollable-element > .scrollbar > .slider:hover {
					background: ${I.scrollbarSliderHoverBackgroundColor};
				}
			`),I.scrollbarSliderActiveBackgroundColor&&T.push(`
				.monaco-scrollable-element > .scrollbar > .slider.active {
					background: ${I.scrollbarSliderActiveBackgroundColor};
				}
			`),j.textContent=T.join(`
`),I.color&&(n.$BQ.document.body.style.color=I.color)}l(I,j){const T=[],Q=Number(I.pid);j&&(T.push({accelerator:"Alt+E",label:(0,i.localize)(4,null),click:()=>{this.c.killProcess(Q,"SIGTERM")}}),T.push({label:(0,i.localize)(5,null),click:()=>{this.c.killProcess(Q,"SIGKILL")}}),T.push({type:"separator"})),T.push({label:(0,i.localize)(6,null),click:()=>{const Z=this.n();Z?.includes(Q)||(Z.length=0,Z.push(Q));const ce=Z?.map(oe=>n.$BQ.document.getElementById(`pid-${oe}`)).filter(oe=>!!oe);if(ce){const oe=ce.map(te=>te.innerText).filter(te=>!!te);this.c.writeClipboardText(oe.join(`
`))}}}),T.push({label:(0,i.localize)(7,null),click:()=>{const Z=n.$BQ.document.getElementById("process-list");Z&&this.c.writeClipboardText(Z.innerText)}}),I&&j&&this.i(I.cmd)&&(T.push({type:"separator"}),T.push({label:(0,i.localize)(8,null),click:()=>{this.j(I)}})),(0,E.$4V)(T)}m(I){setTimeout(()=>{const j=Date.now(),T=I+j-this.a;this.a=j,T>1e3?(k.$O.send("vscode:pidToNameRequest"),k.$O.send("vscode:listProcesses")):this.m(T)},200)}n(){return this.d?.getSelection()?.map(I=>{if(!(!I||!("pid"in I)))return I.pid}).filter(I=>!!I)}}function y(){const q=(0,N.$PR)();q.id="codiconStyles";const I=(0,c.$0Hb)(void 0);function j(){q.textContent=I.getCSS()}const T=new H.$th(j,0);I.onDidChange(()=>T.schedule()),T.schedule()}function x(q){const I=q.data.platform==="win32"?"windows":q.data.platform==="linux"?"linux":"mac";n.$BQ.document.body.classList.add(I),y(),(0,f.$Ubc)(q.data.zoomLevel,n.$BQ),new O(q.windowId,q.data)}})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/be210b3a60c7d60030c1d3d92da00d008edf6ab9/core/vs/code/electron-sandbox/processExplorer/processExplorerMain.js.map
