/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var q=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/observableInternal/autorun","vs/base/common/observableInternal/derived","vs/base/common/errors","vs/editor/common/tokens/lineTokens","vs/base/common/uri","vs/base/common/observable","vs/base/common/buffer","vs/editor/common/core/eolCounter","vs/editor/common/encodedTokenAttributes","vs/editor/common/core/lineRange","vs/editor/common/tokens/contiguousMultilineTokensBuilder","vs/base/common/path","vs/base/common/strings","vs/base/common/network","vs/base/common/resources","vs/base/common/async","vs/editor/common/languages/nullTokenize","vs/base/common/amd","vs/base/common/assert","vs/base/common/observableInternal/utils","vs/base/common/observableInternal/promise","vs/base/common/cancellation","vs/base/common/stream","vs/base/common/lazy","vs/base/common/symbols","vs/editor/common/model/fixedArray","vs/base/common/arrays","vs/editor/common/tokens/contiguousTokensEditing","vs/editor/common/tokens/contiguousMultilineTokens","vs/base/common/extpath","vs/amdX","vs/base/common/event","vs/editor/common/languages","vs/editor/common/model/textModelTokens","vs/base/common/stopwatch","vs/workbench/services/textMate/browser/tokenizationSupport/textMateTokenizationSupport","vs/workbench/services/textMate/browser/tokenizationSupport/tokenizationSupportWithLineLimit","vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateWorkerTokenizer","vs/workbench/services/textMate/common/TMScopeRegistry","vs/workbench/services/textMate/common/TMGrammarFactory","vs/editor/common/core/position","vs/base/common/types","vs/editor/common/core/offsetRange","vs/editor/common/model/mirrorTextModel","vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateTokenizationWorker.worker"],V=function(z){for(var e=[],P=0,T=z.length;P<T;P++)e[P]=q[z[P]];return e};define(q[24],V([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class P{static get(){const k=new Map,C=new Map,r=new Map,c=new Map;function i(o,n){o.has(n.detail)||o.set(n.detail,-n.timestamp)}function u(o,n){const t=o.get(n.detail);t&&(t>=0||o.set(n.detail,t+n.timestamp))}let m=[];typeof z=="function"&&typeof z.getStats=="function"&&(m=z.getStats().slice(0).sort((o,n)=>o.timestamp-n.timestamp));for(const o of m)switch(o.type){case 10:i(k,o);break;case 11:case 12:u(k,o);break;case 21:i(C,o);break;case 22:u(C,o);break;case 33:i(r,o);break;case 34:u(r,o);break;case 31:i(c,o);break;case 32:u(c,o);break}let l=0;r.forEach(o=>l+=o);function b(o){const n=[];return o.forEach((t,s)=>n.push([s,t])),n}return{amdLoad:b(k),amdInvoke:b(C),nodeRequire:b(r),nodeEval:b(c),nodeRequireTotal:l}}static toMarkdownTable(k,C){let r="";const c=[];return k.forEach((i,u)=>{c[u]=i.length}),C.forEach(i=>{i.forEach((u,m)=>{typeof u>"u"&&(u=i[m]="-");const l=u.toString().length;c[m]=Math.max(l,c[m])})}),k.forEach((i,u)=>{r+=`| ${i+" ".repeat(c[u]-i.toString().length)} `}),r+=`|
`,k.forEach((i,u)=>{r+=`| ${"-".repeat(c[u])} `}),r+=`|
`,C.forEach(i=>{i.forEach((u,m)=>{typeof u<"u"&&(r+=`| ${u+" ".repeat(c[m]-u.toString().length)} `)}),r+=`|
`}),r}}e.$U=P}),define(q[4],V([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6c=void 0,e.$7c=C,e.$8c=b;class P{constructor(n,t,s){this.owner=n,this.debugNameSource=t,this.referenceFn=s}getDebugName(n){return C(n,this)}}e.$6c=P;const T=new Map,k=new WeakMap;function C(o,n){const t=k.get(o);if(t)return t;const s=r(o,n);if(s){let d=T.get(s)??0;d++,T.set(s,d);const S=d===1?s:`${s}#${d}`;return k.set(o,S),S}}function r(o,n){const t=k.get(o);if(t)return t;const s=n.owner?m(n.owner)+".":"";let d;const S=n.debugNameSource;if(S!==void 0)if(typeof S=="function"){if(d=S(),d!==void 0)return s+d}else return s+S;const L=n.referenceFn;if(L!==void 0&&(d=b(L),d!==void 0))return s+d;if(n.owner!==void 0){const A=c(n.owner,o);if(A!==void 0)return s+A}}function c(o,n){for(const t in o)if(o[t]===n)return t}const i=new Map,u=new WeakMap;function m(o){const n=u.get(o);if(n)return n;const t=l(o);let s=i.get(t)??0;s++,i.set(t,s);const d=s===1?t:`${t}#${s}`;return u.set(o,d),d}function l(o){const n=o.constructor;return n?n.name:"Object"}function b(o){const n=o.toString(),s=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(n);return(s?s[1]:void 0)?.trim()}}),define(q[5],V([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ad=void 0,e.$yd=T,e.$zd=k;let P;function T(t){P=t}function k(){return P}class C{constructor(){this.a=0,this.d=new WeakMap}b(s){return r([c(o("|  ",this.a)),s])}c(s){return s.hadValue?s.didChange?[c(" "),u(m(s.oldValue,70),{color:"red",strikeThrough:!0}),c(" "),u(m(s.newValue,60),{color:"green"})]:[c(" (unchanged)")]:[c(" "),u(m(s.newValue,60),{color:"green"}),c(" (initial)")]}handleObservableChanged(s,d){console.log(...this.b([i("observable value changed"),u(s.debugName,{color:"BlueViolet"}),...this.c(d)]))}formatChanges(s){if(s.size!==0)return u(" (changed deps: "+[...s].map(d=>d.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(s){const d=s.handleChange;this.d.set(s,new Set),s.handleChange=(S,L)=>(this.d.get(s).add(S),d.apply(s,[S,L]))}handleDerivedRecomputed(s,d){const S=this.d.get(s);console.log(...this.b([i("derived recomputed"),u(s.debugName,{color:"BlueViolet"}),...this.c(d),this.formatChanges(S),{data:[{fn:s._computeFn}]}])),S.clear()}handleFromEventObservableTriggered(s,d){console.log(...this.b([i("observable from event triggered"),u(s.debugName,{color:"BlueViolet"}),...this.c(d),{data:[{fn:s._getValue}]}]))}handleAutorunCreated(s){const d=s.handleChange;this.d.set(s,new Set),s.handleChange=(S,L)=>(this.d.get(s).add(S),d.apply(s,[S,L]))}handleAutorunTriggered(s){const d=this.d.get(s);console.log(...this.b([i("autorun"),u(s.debugName,{color:"BlueViolet"}),this.formatChanges(d),{data:[{fn:s._runFn}]}])),d.clear(),this.a++}handleAutorunFinished(s){this.a--}handleBeginTransaction(s){let d=s.getDebugName();d===void 0&&(d=""),console.log(...this.b([i("transaction"),u(d,{color:"BlueViolet"}),{data:[{fn:s._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$Ad=C;function r(t){const s=new Array,d=[];let S="";function L(E){if("length"in E)for(const a of E)a&&L(a);else"text"in E?(S+=`%c${E.text}`,s.push(E.style),E.data&&d.push(...E.data)):"data"in E&&d.push(...E.data)}L(t);const A=[S,...s];return A.push(...d),A}function c(t){return u(t,{color:"black"})}function i(t){return u(n(`${t}: `,10),{color:"black",bold:!0})}function u(t,s={color:"black"}){function d(L){return Object.entries(L).reduce((A,[E,a])=>`${A}${E}:${a};`,"")}const S={color:s.color};return s.strikeThrough&&(S["text-decoration"]="line-through"),s.bold&&(S["font-weight"]="bold"),{text:t,style:d(S)}}function m(t,s){switch(typeof t){case"number":return""+t;case"string":return t.length+2<=s?`"${t}"`:`"${t.substr(0,s-7)}"+...`;case"boolean":return t?"true":"false";case"undefined":return"undefined";case"object":return t===null?"null":Array.isArray(t)?l(t,s):b(t,s);case"symbol":return t.toString();case"function":return`[[Function${t.name?" "+t.name:""}]]`;default:return""+t}}function l(t,s){let d="[ ",S=!0;for(const L of t){if(S||(d+=", "),d.length-5>s){d+="...";break}S=!1,d+=`${m(L,s-d.length)}`}return d+=" ]",d}function b(t,s){let d="{ ",S=!0;for(const[L,A]of Object.entries(t)){if(S||(d+=", "),d.length-5>s){d+="...";break}S=!1,d+=`${L}: ${m(A,s-d.length)}`}return d+=" }",d}function o(t,s){let d="";for(let S=1;S<=s;S++)d+=t;return d}function n(t,s){for(;t.length<s;)t+=" ";return t}}),define(q[7],V([0,1,25,2,4,5]),function(z,e,P,T,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$id=void 0,e.$cd=r,e.$dd=c,e.$ed=i,e.$fd=u,e.$gd=m,e.$hd=l;function r(n){return new o(new k.$6c(void 0,void 0,n),n,void 0,void 0)}function c(n,t){return new o(new k.$6c(n.owner,n.debugName,n.debugReferenceFn??t),t,void 0,void 0)}function i(n,t){return new o(new k.$6c(n.owner,n.debugName,n.debugReferenceFn??t),t,n.createEmptyChangeSummary,n.handleChange)}function u(n,t){const s=new T.$Tc,d=i({owner:n.owner,debugName:n.debugName,debugReferenceFn:n.debugReferenceFn,createEmptyChangeSummary:n.createEmptyChangeSummary,handleChange:n.handleChange},(S,L)=>{s.clear(),t(S,L,s)});return(0,T.$Sc)(()=>{d.dispose(),s.dispose()})}function m(n){const t=new T.$Tc,s=c({owner:void 0,debugName:void 0,debugReferenceFn:n},d=>{t.clear(),n(d,t)});return(0,T.$Sc)(()=>{s.dispose(),t.dispose()})}function l(n,t){let s;return c({debugReferenceFn:t},d=>{const S=n.read(d),L=s;s=S,t({lastValue:L,newValue:S})})}var b;(function(n){n[n.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",n[n.stale=2]="stale",n[n.upToDate=3]="upToDate"})(b||(b={}));class o{get debugName(){return this.h.getDebugName(this)??"(anonymous)"}constructor(t,s,d,S){this.h=t,this._runFn=s,this.i=d,this.j=S,this.a=2,this.b=0,this.c=!1,this.e=new Set,this.f=new Set,this.g=this.i?.(),(0,C.$zd)()?.handleAutorunCreated(this),this.k(),(0,T.$Lc)(this)}dispose(){this.c=!0;for(const t of this.e)t.removeObserver(this);this.e.clear(),(0,T.$Mc)(this)}k(){if(this.a===3)return;const t=this.f;this.f=this.e,this.e=t,this.a=3;const s=this.c;try{if(!s){(0,C.$zd)()?.handleAutorunTriggered(this);const d=this.g;this.g=this.i?.(),this._runFn(this,d)}}finally{s||(0,C.$zd)()?.handleAutorunFinished(this);for(const d of this.f)d.removeObserver(this);this.f.clear()}}toString(){return`Autorun<${this.debugName}>`}beginUpdate(){this.a===3&&(this.a=1),this.b++}endUpdate(){if(this.b===1)do{if(this.a===1){this.a=3;for(const t of this.e)if(t.reportChanges(),this.a===2)break}this.k()}while(this.a!==3);this.b--,(0,P.$ad)(()=>this.b>=0)}handlePossibleChange(t){this.a===3&&this.e.has(t)&&!this.f.has(t)&&(this.a=1)}handleChange(t,s){this.e.has(t)&&!this.f.has(t)&&(!this.j||this.j({changedObservable:t,change:s,didChange:S=>S===t},this.g))&&(this.a=2)}readObservable(t){if(this.c)return t.get();t.addObserver(this);const s=t.get();return this.e.add(t),this.f.delete(t),s}}e.$id=o,function(n){n.Observer=o}(r||(e.$cd=r={}))}),define(q[6],V([0,1,4,5]),function(z,e,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vd=e.$Td=e.$Rd=e.$Md=e.$Ld=void 0,e.$Id=C,e.$Jd=c,e.$Kd=u,e.$Nd=b,e.$Od=n,e.$Pd=t,e.$Qd=s,e.$Sd=S,e.$Ud=A;let k;function C(a){k=a}let r;function c(a){r=a}let i;function u(a){i=a}class m{get TChange(){return null}reportChanges(){this.get()}read($){return $?$.readObservable(this):this.get()}map($,w){const D=w===void 0?void 0:$,p=w===void 0?$:w;return i({owner:D,debugName:()=>{const f=(0,P.$8c)(p);if(f!==void 0)return f;const N=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(p.toString());if(N)return`${this.debugName}.${N[2]}`;if(!D)return`${this.debugName} (mapped)`}},f=>p(this.read(f),f))}recomputeInitiallyAndOnChange($,w){return $.add(k(this,w)),this}keepObserved($){return $.add(r(this)),this}}e.$Ld=m;class l extends m{constructor(){super(...arguments),this.c=new Set}addObserver($){const w=this.c.size;this.c.add($),w===0&&this.f()}removeObserver($){this.c.delete($)&&this.c.size===0&&this.g()}f(){}g(){}}e.$Md=l;function b(a,$){const w=new d(a,$);try{a(w)}finally{w.finish()}}let o;function n(a){if(o)a(o);else{const $=new d(a,void 0);o=$;try{a($)}finally{$.finish(),o=void 0}}}async function t(a,$){const w=new d(a,$);try{await a(w)}finally{w.finish()}}function s(a,$,w){a?$(a):b($,w)}class d{constructor($,w){this._fn=$,this.b=w,this.a=[],(0,T.$zd)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():(0,P.$8c)(this._fn)}updateObserver($,w){this.a.push({observer:$,observable:w}),$.beginUpdate(w)}finish(){const $=this.a;for(let w=0;w<$.length;w++){const{observer:D,observable:p}=$[w];D.endUpdate(p)}this.a=null,(0,T.$zd)()?.handleEndTransaction()}}e.$Rd=d;function S(a,$){return typeof a=="string"?new L(void 0,a,$):new L(a,void 0,$)}class L extends l{get debugName(){return new P.$6c(this.b,this.d,void 0).getDebugName(this)??"ObservableValue"}constructor($,w,D){super(),this.b=$,this.d=w,this.a=D}get(){return this.a}set($,w,D){if(this.a===$)return;let p;w||(w=p=new d(()=>{},()=>`Setting ${this.debugName}`));try{const f=this.a;this.e($),(0,T.$zd)()?.handleObservableChanged(this,{oldValue:f,newValue:$,change:D,didChange:!0,hadValue:!0});for(const v of this.c)w.updateObserver(v,this),v.handleChange(this,D)}finally{p&&p.finish()}}toString(){return`${this.debugName}: ${this.a}`}e($){this.a=$}}e.$Td=L;function A(a,$){return typeof a=="string"?new E(void 0,a,$):new E(a,void 0,$)}class E extends L{e($){this.a!==$&&(this.a&&this.a.dispose(),this.a=$)}dispose(){this.a?.dispose()}}e.$Vd=E}),define(q[8],V([0,1,25,2,6,4,5]),function(z,e,P,T,k,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hd=e.$Bd=void 0,e.$Cd=i,e.$Dd=u,e.$Ed=m,e.$Fd=l,e.$Gd=b;const c=(t,s)=>t===s;e.$Bd=c;function i(t,s){return s!==void 0?new n(new C.$6c(t,void 0,s),s,void 0,void 0,void 0,e.$Bd):new n(new C.$6c(void 0,void 0,t),t,void 0,void 0,void 0,e.$Bd)}function u(t,s){return new n(new C.$6c(t.owner,t.debugName,t.debugReferenceFn),s,void 0,void 0,t.onLastObserverRemoved,t.equalityComparer??e.$Bd)}(0,k.$Kd)(u);function m(t,s){return new n(new C.$6c(t.owner,t.debugName,void 0),s,t.createEmptyChangeSummary,t.handleChange,void 0,t.equalityComparer??e.$Bd)}function l(t,s){let d,S;s===void 0?(d=t,S=void 0):(S=t,d=s);const L=new T.$Tc;return new n(new C.$6c(S,void 0,d),A=>(L.clear(),d(A,L)),void 0,void 0,()=>L.dispose(),e.$Bd)}function b(t,s){let d,S;s===void 0?(d=t,S=void 0):(S=t,d=s);const L=new T.$Tc;return new n(new C.$6c(S,void 0,d),A=>{L.clear();const E=d(A);return E&&L.add(E),E},void 0,void 0,()=>L.dispose(),e.$Bd)}var o;(function(t){t[t.initial=0]="initial",t[t.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",t[t.stale=2]="stale",t[t.upToDate=3]="upToDate"})(o||(o={}));class n extends k.$Md{get debugName(){return this.n.getDebugName(this)??"(anonymous)"}constructor(s,d,S,L,A=void 0,E){super(),this.n=s,this._computeFn=d,this.p=S,this.q=L,this.s=A,this.t=E,this.e=0,this.h=void 0,this.j=0,this.k=new Set,this.l=new Set,this.m=void 0,this.m=this.p?.(),(0,r.$zd)()?.handleDerivedCreated(this)}g(){this.e=0,this.h=void 0;for(const s of this.k)s.removeObserver(this);this.k.clear(),this.s?.()}get(){if(this.c.size===0){const s=this._computeFn(this,this.p?.());return this.g(),s}else{do{if(this.e===1){for(const s of this.k)if(s.reportChanges(),this.e===2)break}this.e===1&&(this.e=3),this.v()}while(this.e!==3);return this.h}}v(){if(this.e===3)return;const s=this.l;this.l=this.k,this.k=s;const d=this.e!==0,S=this.h;this.e=3;const L=this.m;this.m=this.p?.();try{this.h=this._computeFn(this,L)}finally{for(const E of this.l)E.removeObserver(this);this.l.clear()}const A=d&&!this.t(S,this.h);if((0,r.$zd)()?.handleDerivedRecomputed(this,{oldValue:S,newValue:this.h,change:void 0,didChange:A,hadValue:d}),A)for(const E of this.c)E.handleChange(this,void 0)}toString(){return`LazyDerived<${this.debugName}>`}beginUpdate(s){this.j++;const d=this.j===1;if(this.e===3&&(this.e=1,!d))for(const S of this.c)S.handlePossibleChange(this);if(d)for(const S of this.c)S.beginUpdate(this)}endUpdate(s){if(this.j--,this.j===0){const d=[...this.c];for(const S of d)S.endUpdate(this)}(0,P.$ad)(()=>this.j>=0)}handlePossibleChange(s){if(this.e===3&&this.k.has(s)&&!this.l.has(s)){this.e=1;for(const d of this.c)d.handlePossibleChange(this)}}handleChange(s,d){if(this.k.has(s)&&!this.l.has(s)){const S=this.q?this.q({changedObservable:s,change:d,didChange:A=>A===s},this.m):!0,L=this.e===3;if(S&&(this.e===1||L)&&(this.e=2,L))for(const A of this.c)A.handlePossibleChange(this)}}readObservable(s){s.addObserver(this);const d=s.get();return this.k.add(s),this.l.delete(s),d}addObserver(s){const d=!this.c.has(s)&&this.j>0;super.addObserver(s),d&&s.beginUpdate(this)}removeObserver(s){const d=this.c.has(s)&&this.j>0;super.removeObserver(s),d&&s.endUpdate(this)}}e.$Hd=n}),define(q[26],V([0,1,2,7,6,4,8,5]),function(z,e,P,T,k,C,r,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ud=e.$md=void 0,e.$jd=i,e.$kd=m,e.$ld=l,e.$nd=o,e.$od=t,e.$pd=d,e.$qd=S,e.$rd=L,e.$sd=A,e.$td=E,e.$vd=$,e.$wd=w,e.$xd=D;function i(f){return new u(f)}class u extends k.$Ld{constructor(v){super(),this.a=v}get debugName(){return this.toString()}get(){return this.a}addObserver(v){}removeObserver(v){}toString(){return`Const: ${this.a}`}}function m(f){const v=(0,k.$Sd)("promiseValue",{});return f.then(N=>{v.set({value:N},void 0)}),v}function l(f,v){return new b(f,v)}class b extends k.$Md{constructor(v,N){super(),this.h=v,this._getValue=N,this.b=!1,this.l=U=>{const O=this._getValue(U),g=this.a,M=!this.b||g!==O;let K=!1;M&&(this.a=O,this.b&&(K=!0,(0,k.$Qd)(b.globalTransaction,B=>{(0,c.$zd)()?.handleFromEventObservableTriggered(this,{oldValue:g,newValue:O,change:void 0,didChange:M,hadValue:this.b});for(const G of this.c)B.updateObserver(G,this),G.handleChange(this,void 0)},()=>{const B=this.j();return"Event fired"+(B?`: ${B}`:"")})),this.b=!0),K||(0,c.$zd)()?.handleFromEventObservableTriggered(this,{oldValue:g,newValue:O,change:void 0,didChange:M,hadValue:this.b})}}j(){return(0,C.$8c)(this._getValue)}get debugName(){const v=this.j();return"From Event"+(v?`: ${v}`:"")}f(){this.e=this.h(this.l)}g(){this.e.dispose(),this.e=void 0,this.b=!1,this.a=void 0}get(){return this.e?(this.b||this.l(void 0),this.a):this._getValue(void 0)}}e.$md=b,function(f){f.Observer=b;function v(N,U){let O=!1;b.globalTransaction===void 0&&(b.globalTransaction=N,O=!0);try{U()}finally{O&&(b.globalTransaction=void 0)}}f.batchEventsGlobally=v}(l||(e.$ld=l={}));function o(f,v){return new n(f,v)}class n extends k.$Md{constructor(v,N){super(),this.debugName=v,this.b=N,this.h=()=>{(0,k.$Nd)(U=>{for(const O of this.c)U.updateObserver(O,this),O.handleChange(this,void 0)},()=>this.debugName)}}f(){this.a=this.b(this.h)}g(){this.a.dispose(),this.a=void 0}get(){}}function t(f){return typeof f=="string"?new s(f):new s(void 0,f)}class s extends k.$Md{get debugName(){return new C.$6c(this.b,this.a,void 0).getDebugName(this)??"Observable Signal"}constructor(v,N){super(),this.a=v,this.b=N}trigger(v,N){if(!v){(0,k.$Nd)(U=>{this.trigger(U,N)},()=>`Trigger signal ${this.debugName}`);return}for(const U of this.c)v.updateObserver(U,this),U.handleChange(this,N)}get(){}}function d(f,v,N){const U=(0,k.$Sd)("debounced",void 0);let O;return N.add((0,T.$cd)(g=>{const M=f.read(g);O&&clearTimeout(O),O=setTimeout(()=>{(0,k.$Nd)(K=>{U.set(M,K)})},v)})),U}function S(f,v){let N=!1,U,O;return l(g=>{const M=(0,T.$cd)(K=>{const B=f.read(K);N?(O&&clearTimeout(O),O=setTimeout(()=>{U=B,g()},v)):(N=!0,U=B)});return{dispose(){M.dispose(),N=!1,U=void 0}}},()=>N?U:f.get())}function L(f,v,N){const U=(0,k.$Sd)("triggeredRecently",!1);let O;return N.add(f(()=>{U.set(!0,void 0),O&&clearTimeout(O),O=setTimeout(()=>{U.set(!1,void 0)},v)})),U}function A(f){const v=new a(!1,void 0);return f.addObserver(v),(0,P.$Sc)(()=>{f.removeObserver(v)})}(0,k.$Jd)(A);function E(f,v){const N=new a(!0,v);return f.addObserver(N),v?v(f.get()):f.reportChanges(),(0,P.$Sc)(()=>{f.removeObserver(N)})}(0,k.$Id)(E);class a{constructor(v,N){this.b=v,this.c=N,this.a=0}beginUpdate(v){this.a++}endUpdate(v){this.a--,this.a===0&&this.b&&(this.c?this.c(v.get()):v.reportChanges())}handlePossibleChange(v){}handleChange(v,N){}}e.$ud=a;function $(f){let v;return(0,r.$Cd)(U=>(v=f(U,v),v))}function w(f,v){let N;const U=(0,k.$Sd)("derivedObservableWithWritableCache.counter",0),O=(0,r.$Cd)(f,g=>(U.read(g),N=v(g,N),N));return Object.assign(O,{clearCache:g=>{N=void 0,U.set(U.get()+1,g)}})}function D(f,v,N,U){let O=new p(N,U);return(0,r.$Dd)({debugReferenceFn:N,owner:f,onLastObserverRemoved:()=>{O.dispose(),O=new p(N)}},M=>(O.setItems(v.read(M)),O.getItems()))}class p{constructor(v,N){this.c=v,this.e=N,this.a=new Map,this.b=[]}dispose(){this.a.forEach(v=>v.store.dispose()),this.a.clear()}setItems(v){const N=[],U=new Set(this.a.keys());for(const O of v){const g=this.e?this.e(O):O;let M=this.a.get(g);if(M)U.delete(g);else{const K=new P.$Tc;M={out:this.c(O,K),store:K},this.a.set(g,M)}N.push(M.out)}for(const O of U)this.a.get(O).store.dispose(),this.a.delete(O);this.b=N}getItems(){return this.b}}}),define(q[27],V([0,1,7,6,8,28,4]),function(z,e,P,T,k,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zd=e.$Yd=e.$Xd=e.$Wd=void 0,e.$1d=l,e.$2d=b;class c{get cachedValue(){return this.a}constructor(n){this.b=n,this.a=(0,T.$Sd)(this,void 0)}getValue(){let n=this.a.get();return n||(n=this.b(),this.a.set(n,void 0)),n}}e.$Wd=c;class i{constructor(n){this.a=(0,T.$Sd)(this,void 0),this.promiseResult=this.a,this.promise=n.then(t=>((0,T.$Nd)(s=>{this.a.set(new u(t,void 0),s)}),t),t=>{throw(0,T.$Nd)(s=>{this.a.set(new u(void 0,t),s)}),t})}}e.$Xd=i;class u{constructor(n,t){this.data=n,this.error=t}getDataOrThrow(){if(this.error)throw this.error;return this.data}}e.$Yd=u;class m{constructor(n){this.b=n,this.a=new c(()=>new i(this.b())),this.cachedPromiseResult=(0,k.$Cd)(this,t=>this.a.cachedValue.read(t)?.promiseResult.read(t))}getPromise(){return this.a.getValue().promise}}e.$Zd=m;function l(o,n,t){return new Promise((s,d)=>{let S=!0,L=!1;const A=o.map(a=>({isFinished:n(a),error:t?t(a):!1,state:a})),E=(0,P.$cd)(a=>{const{isFinished:$,error:w,state:D}=A.read(a);($||w)&&(S?L=!0:E.dispose(),w?d(w===!0?D:w):s(D))});S=!1,L&&E.dispose()})}function b(o,n){let t,s;n===void 0?(t=o,s=void 0):(s=o,t=n);let d;return new k.$Hd(new r.$6c(s,void 0,t),S=>(d&&d.dispose(!0),d=new C.$ee,t(S,d.token)),void 0,void 0,()=>d?.dispose(),k.$Bd)}}),define(q[12],V([0,1,6,8,7,26,27,5]),function(z,e,P,T,k,C,r,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.derivedWithCancellationToken=e.waitForState=e.PromiseResult=e.ObservablePromise=e.ObservableLazyPromise=e.ObservableLazy=e.wasEventTriggeredRecently=e.observableSignalFromEvent=e.observableSignal=e.observableFromPromise=e.observableFromEvent=e.recomputeInitiallyAndOnChange=e.keepObserved=e.derivedObservableWithWritableCache=e.derivedObservableWithCache=e.debouncedObservable=e.constObservable=e.autorunWithStoreHandleChanges=e.autorunOpts=e.autorunWithStore=e.autorunHandleChanges=e.autorunDelta=e.autorun=e.derivedWithStore=e.derivedHandleChanges=e.derivedOpts=e.derived=e.subtransaction=e.transaction=e.disposableObservableValue=e.observableValue=void 0,Object.defineProperty(e,"observableValue",{enumerable:!0,get:function(){return P.$Sd}}),Object.defineProperty(e,"disposableObservableValue",{enumerable:!0,get:function(){return P.$Ud}}),Object.defineProperty(e,"transaction",{enumerable:!0,get:function(){return P.$Nd}}),Object.defineProperty(e,"subtransaction",{enumerable:!0,get:function(){return P.$Qd}}),Object.defineProperty(e,"derived",{enumerable:!0,get:function(){return T.$Cd}}),Object.defineProperty(e,"derivedOpts",{enumerable:!0,get:function(){return T.$Dd}}),Object.defineProperty(e,"derivedHandleChanges",{enumerable:!0,get:function(){return T.$Ed}}),Object.defineProperty(e,"derivedWithStore",{enumerable:!0,get:function(){return T.$Fd}}),Object.defineProperty(e,"autorun",{enumerable:!0,get:function(){return k.$cd}}),Object.defineProperty(e,"autorunDelta",{enumerable:!0,get:function(){return k.$hd}}),Object.defineProperty(e,"autorunHandleChanges",{enumerable:!0,get:function(){return k.$ed}}),Object.defineProperty(e,"autorunWithStore",{enumerable:!0,get:function(){return k.$gd}}),Object.defineProperty(e,"autorunOpts",{enumerable:!0,get:function(){return k.$dd}}),Object.defineProperty(e,"autorunWithStoreHandleChanges",{enumerable:!0,get:function(){return k.$fd}}),Object.defineProperty(e,"constObservable",{enumerable:!0,get:function(){return C.$jd}}),Object.defineProperty(e,"debouncedObservable",{enumerable:!0,get:function(){return C.$pd}}),Object.defineProperty(e,"derivedObservableWithCache",{enumerable:!0,get:function(){return C.$vd}}),Object.defineProperty(e,"derivedObservableWithWritableCache",{enumerable:!0,get:function(){return C.$wd}}),Object.defineProperty(e,"keepObserved",{enumerable:!0,get:function(){return C.$sd}}),Object.defineProperty(e,"recomputeInitiallyAndOnChange",{enumerable:!0,get:function(){return C.$td}}),Object.defineProperty(e,"observableFromEvent",{enumerable:!0,get:function(){return C.$ld}}),Object.defineProperty(e,"observableFromPromise",{enumerable:!0,get:function(){return C.$kd}}),Object.defineProperty(e,"observableSignal",{enumerable:!0,get:function(){return C.$od}}),Object.defineProperty(e,"observableSignalFromEvent",{enumerable:!0,get:function(){return C.$nd}}),Object.defineProperty(e,"wasEventTriggeredRecently",{enumerable:!0,get:function(){return C.$rd}}),Object.defineProperty(e,"ObservableLazy",{enumerable:!0,get:function(){return r.$Wd}}),Object.defineProperty(e,"ObservableLazyPromise",{enumerable:!0,get:function(){return r.$Zd}}),Object.defineProperty(e,"ObservablePromise",{enumerable:!0,get:function(){return r.$Xd}}),Object.defineProperty(e,"PromiseResult",{enumerable:!0,get:function(){return r.$Yd}}),Object.defineProperty(e,"waitForState",{enumerable:!0,get:function(){return r.$1d}}),Object.defineProperty(e,"derivedWithCancellationToken",{enumerable:!0,get:function(){return r.$2d}}),!1&&(0,c.$yd)(new c.$Ad)}),define(q[29],V([0,1,9,2]),function(z,e,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fe=k,e.$ge=C,e.$he=r,e.$ie=c,e.$je=u,e.$ke=m,e.$le=l,e.$me=b,e.$ne=o,e.$oe=n,e.$pe=t,e.$qe=s,e.$re=d,e.$se=S,e.$te=L;function k(A){const E=A;return E?typeof E.read=="function":!1}function C(A){const E=A;return E?[E.on,E.pause,E.resume,E.destroy].every(a=>typeof a=="function"):!1}function r(A){const E=A;return E?C(E.stream)&&Array.isArray(E.buffer)&&typeof E.ended=="boolean":!1}function c(A,E){return new i(A,E)}class i{constructor(E,a){this.e=E,this.f=a,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(E){if(!this.a.destroyed){if(this.a.flowing)this.g(E);else if(this.b.data.push(E),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(a=>this.d.push(a))}}error(E){this.a.destroyed||(this.a.flowing?this.h(E):this.b.error.push(E))}end(E){this.a.destroyed||(typeof E<"u"&&this.write(E),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(E){this.c.data.slice(0).forEach(a=>a(E))}h(E){this.c.error.length===0?(0,P.$1)(E):this.c.error.slice(0).forEach(a=>a(E))}i(){this.c.end.slice(0).forEach(E=>E())}on(E,a){if(!this.a.destroyed)switch(E){case"data":this.c.data.push(a),this.resume();break;case"end":this.c.end.push(a),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(a),this.a.flowing&&this.k();break}}removeListener(E,a){if(this.a.destroyed)return;let $;switch(E){case"data":$=this.c.data;break;case"end":$=this.c.end;break;case"error":$=this.c.error;break}if($){const w=$.indexOf(a);w>=0&&$.splice(w,1)}}j(){if(this.b.data.length>0){const E=this.e(this.b.data);this.g(E),this.b.data.length=0;const a=[...this.d];this.d.length=0,a.forEach($=>$())}}k(){if(this.c.error.length>0){for(const E of this.b.error)this.h(E);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function u(A,E){const a=[];let $;for(;($=A.read())!==null;)a.push($);return E(a)}function m(A,E,a){const $=[];let w;for(;(w=A.read())!==null&&$.length<a;)$.push(w);return w===null&&$.length>0?E($):{read:()=>{if($.length>0)return $.shift();if(typeof w<"u"){const D=w;return w=void 0,D}return A.read()}}}function l(A,E){return new Promise((a,$)=>{const w=[];b(A,{onData:D=>{E&&w.push(D)},onError:D=>{E?$(D):a(void 0)},onEnd:()=>{a(E?E(w):void 0)}})})}function b(A,E,a){A.on("error",$=>{a?.isCancellationRequested||E.onError($)}),A.on("end",()=>{a?.isCancellationRequested||E.onEnd()}),A.on("data",$=>{a?.isCancellationRequested||E.onData($)})}function o(A,E){return new Promise((a,$)=>{const w=new T.$Tc,D=[],p=N=>{if(D.push(N),D.length>E)return w.dispose(),A.pause(),a({stream:A,buffer:D,ended:!1})},f=N=>(w.dispose(),$(N)),v=()=>(w.dispose(),a({stream:A,buffer:D,ended:!0}));w.add((0,T.$Sc)(()=>A.removeListener("error",f))),A.on("error",f),w.add((0,T.$Sc)(()=>A.removeListener("end",v))),A.on("end",v),w.add((0,T.$Sc)(()=>A.removeListener("data",p))),A.on("data",p)})}function n(A,E){const a=c(E);return a.end(A),a}function t(){const A=c(()=>{throw new Error("not supported")});return A.end(),A}function s(A){let E=!1;return{read:()=>E?null:(E=!0,A)}}function d(A,E,a){const $=c(a);return b(A,{onData:w=>$.write(E.data(w)),onError:w=>$.error(E.error?E.error(w):w),onEnd:()=>$.end()}),$}function S(A,E,a){let $=!1;return{read:()=>{const w=E.read();return $?w:($=!0,w!==null?a([A,w]):A)}}}function L(A,E,a){let $=!1;const w=c(a);return b(E,{onData:D=>$?w.write(D):($=!0,w.write(a([A,D]))),onError:D=>w.error(D),onEnd:()=>{$||($=!0,w.write(A)),w.end()}}),w}}),define(q[13],V([0,1,30,29]),function(z,e,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ue=void 0,e.$ve=u,e.$we=m,e.$xe=l,e.$ye=b,e.$ze=o,e.$Ae=n,e.$Be=t,e.$Ce=s,e.$De=d,e.$Ee=S,e.$Fe=L,e.$Ge=A,e.$He=E,e.$Ie=a,e.$Je=$,e.$Ke=w,e.$Le=D,e.$Me=p,e.$Ne=f,e.$Oe=U;const k=typeof Buffer<"u",C=new P.$V(()=>new Uint8Array(256));let r,c;class i{static alloc(g){return k?new i(Buffer.allocUnsafe(g)):new i(new Uint8Array(g))}static wrap(g){return k&&!Buffer.isBuffer(g)&&(g=Buffer.from(g.buffer,g.byteOffset,g.byteLength)),new i(g)}static fromString(g,M){return!(M?.dontUseNodeBuffer||!1)&&k?new i(Buffer.from(g)):(r||(r=new TextEncoder),new i(r.encode(g)))}static fromByteArray(g){const M=i.alloc(g.length);for(let K=0,B=g.length;K<B;K++)M.buffer[K]=g[K];return M}static concat(g,M){if(typeof M>"u"){M=0;for(let G=0,Z=g.length;G<Z;G++)M+=g[G].byteLength}const K=i.alloc(M);let B=0;for(let G=0,Z=g.length;G<Z;G++){const W=g[G];K.set(W,B),B+=W.byteLength}return K}constructor(g){this.buffer=g,this.byteLength=this.buffer.byteLength}clone(){const g=i.alloc(this.byteLength);return g.set(this),g}toString(){return k?this.buffer.toString():(c||(c=new TextDecoder),c.decode(this.buffer))}slice(g,M){return new i(this.buffer.subarray(g,M))}set(g,M){if(g instanceof i)this.buffer.set(g.buffer,M);else if(g instanceof Uint8Array)this.buffer.set(g,M);else if(g instanceof ArrayBuffer)this.buffer.set(new Uint8Array(g),M);else if(ArrayBuffer.isView(g))this.buffer.set(new Uint8Array(g.buffer,g.byteOffset,g.byteLength),M);else throw new Error("Unknown argument 'array'")}readUInt32BE(g){return b(this.buffer,g)}writeUInt32BE(g,M){o(this.buffer,g,M)}readUInt32LE(g){return n(this.buffer,g)}writeUInt32LE(g,M){t(this.buffer,g,M)}readUInt8(g){return s(this.buffer,g)}writeUInt8(g,M){d(this.buffer,g,M)}indexOf(g,M=0){return u(this.buffer,g instanceof i?g.buffer:g,M)}}e.$ue=i;function u(O,g,M=0){const K=g.byteLength,B=O.byteLength;if(K===0)return 0;if(K===1)return O.indexOf(g[0]);if(K>B-M)return-1;const G=C.value;G.fill(g.length);for(let J=0;J<g.length;J++)G[g[J]]=g.length-J-1;let Z=M+g.length-1,W=Z,H=-1;for(;Z<B;)if(O[Z]===g[W]){if(W===0){H=Z;break}Z--,W--}else Z+=Math.max(g.length-W,G[O[Z]]),W=g.length-1;return H}function m(O,g){return O[g+0]<<0>>>0|O[g+1]<<8>>>0}function l(O,g,M){O[M+0]=g&255,g=g>>>8,O[M+1]=g&255}function b(O,g){return O[g]*2**24+O[g+1]*2**16+O[g+2]*2**8+O[g+3]}function o(O,g,M){O[M+3]=g,g=g>>>8,O[M+2]=g,g=g>>>8,O[M+1]=g,g=g>>>8,O[M]=g}function n(O,g){return O[g+0]<<0>>>0|O[g+1]<<8>>>0|O[g+2]<<16>>>0|O[g+3]<<24>>>0}function t(O,g,M){O[M+0]=g&255,g=g>>>8,O[M+1]=g&255,g=g>>>8,O[M+2]=g&255,g=g>>>8,O[M+3]=g&255}function s(O,g){return O[g]}function d(O,g,M){O[M]=g}function S(O){return T.$je(O,g=>i.concat(g))}function L(O){return T.$qe(O)}function A(O){return T.$le(O,g=>i.concat(g))}async function E(O){return O.ended?i.concat(O.buffer):i.concat([...O.buffer,await A(O.stream)])}function a(O){return T.$oe(O,g=>i.concat(g))}function $(O){return T.$re(O,{data:g=>typeof g=="string"?i.fromString(g):i.wrap(g)},g=>i.concat(g))}function w(O){return T.$ie(g=>i.concat(g),O)}function D(O,g){return T.$se(O,g,M=>i.concat(M))}function p(O,g){return T.$te(O,g,M=>i.concat(M))}function f(O){let g=0,M=0,K=0;const B=new Uint8Array(Math.floor(O.length/4*3)),G=W=>{switch(M){case 3:B[K++]=g|W,M=0;break;case 2:B[K++]=g|W>>>2,g=W<<6,M=3;break;case 1:B[K++]=g|W>>>4,g=W<<4,M=2;break;default:g=W<<2,M=1}};for(let W=0;W<O.length;W++){const H=O.charCodeAt(W);if(H>=65&&H<=90)G(H-65);else if(H>=97&&H<=122)G(H-97+26);else if(H>=48&&H<=57)G(H-48+52);else if(H===43||H===45)G(62);else if(H===47||H===95)G(63);else{if(H===61)break;throw new SyntaxError(`Unexpected base64 character ${O[W]}`)}}const Z=K;for(;M>0;)G(0);return i.wrap(B).slice(0,Z)}const v="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",N="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function U({buffer:O},g=!0,M=!1){const K=M?N:v;let B="";const G=O.byteLength%3;let Z=0;for(;Z<O.byteLength-G;Z+=3){const W=O[Z+0],H=O[Z+1],J=O[Z+2];B+=K[W>>>2],B+=K[(W<<4|H>>>4)&63],B+=K[(H<<2|J>>>6)&63],B+=K[J&63]}if(G===1){const W=O[Z+0];B+=K[W>>>2],B+=K[W<<4&63],g&&(B+="==")}else if(G===2){const W=O[Z+0],H=O[Z+1];B+=K[W>>>2],B+=K[(W<<4|H>>>4)&63],B+=K[H<<2&63],g&&(B+="=")}return B}}),define(q[31],V([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4d=void 0,e.$4d=Symbol("MicrotaskDelay")}),define(q[14],V([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$Nt=T;var P;(function(k){k[k.Unknown=0]="Unknown",k[k.Invalid=3]="Invalid",k[k.LF=1]="LF",k[k.CRLF=2]="CRLF"})(P||(e.StringEOL=P={}));function T(k){let C=0,r=0,c=0,i=0;for(let u=0,m=k.length;u<m;u++){const l=k.charCodeAt(u);l===13?(C===0&&(r=u),C++,u+1<m&&k.charCodeAt(u+1)===10?(i|=2,u++):i|=3,c=u+1):l===10&&(i|=1,C===0&&(r=u),C++,c=u+1)}return C===0&&(r=k.length),[C,r,k.length-c,i]}}),define(q[15],V([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lt=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var P;(function(i){i[i.Null=0]="Null",i[i.PlainText=1]="PlainText"})(P||(e.LanguageId=P={}));var T;(function(i){i[i.NotSet=-1]="NotSet",i[i.None=0]="None",i[i.Italic=1]="Italic",i[i.Bold=2]="Bold",i[i.Underline=4]="Underline",i[i.Strikethrough=8]="Strikethrough"})(T||(e.FontStyle=T={}));var k;(function(i){i[i.None=0]="None",i[i.DefaultForeground=1]="DefaultForeground",i[i.DefaultBackground=2]="DefaultBackground"})(k||(e.ColorId=k={}));var C;(function(i){i[i.Other=0]="Other",i[i.Comment=1]="Comment",i[i.String=2]="String",i[i.RegEx=3]="RegEx"})(C||(e.StandardTokenType=C={}));var r;(function(i){i[i.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",i[i.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",i[i.BALANCED_BRACKETS_MASK=1024]="BALANCED_BRACKETS_MASK",i[i.FONT_STYLE_MASK=30720]="FONT_STYLE_MASK",i[i.FOREGROUND_MASK=16744448]="FOREGROUND_MASK",i[i.BACKGROUND_MASK=4278190080]="BACKGROUND_MASK",i[i.ITALIC_MASK=2048]="ITALIC_MASK",i[i.BOLD_MASK=4096]="BOLD_MASK",i[i.UNDERLINE_MASK=8192]="UNDERLINE_MASK",i[i.STRIKETHROUGH_MASK=16384]="STRIKETHROUGH_MASK",i[i.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",i[i.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",i[i.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",i[i.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",i[i.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",i[i.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",i[i.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",i[i.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",i[i.BALANCED_BRACKETS_OFFSET=10]="BALANCED_BRACKETS_OFFSET",i[i.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",i[i.FOREGROUND_OFFSET=15]="FOREGROUND_OFFSET",i[i.BACKGROUND_OFFSET=24]="BACKGROUND_OFFSET"})(r||(e.MetadataConsts=r={}));class c{static getLanguageId(u){return(u&255)>>>0}static getTokenType(u){return(u&768)>>>8}static containsBalancedBrackets(u){return(u&1024)!==0}static getFontStyle(u){return(u&30720)>>>11}static getForeground(u){return(u&16744448)>>>15}static getBackground(u){return(u&4278190080)>>>24}static getClassNameFromMetadata(u){let l="mtk"+this.getForeground(u);const b=this.getFontStyle(u);return b&1&&(l+=" mtki"),b&2&&(l+=" mtkb"),b&4&&(l+=" mtku"),b&8&&(l+=" mtks"),l}static getInlineStyleFromMetadata(u,m){const l=this.getForeground(u),b=this.getFontStyle(u);let o=`color: ${m[l]};`;b&1&&(o+="font-style: italic;"),b&2&&(o+="font-weight: bold;");let n="";return b&4&&(n+=" underline"),b&8&&(n+=" line-through"),n&&(o+=`text-decoration:${n};`),o}static getPresentationFromMetadata(u){const m=this.getForeground(u),l=this.getFontStyle(u);return{foreground:m,italic:!!(l&1),bold:!!(l&2),underline:!!(l&4),strikethrough:!!(l&8)}}}e.$Lt=c}),define(q[32],V([0,1,33]),function(z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DC=void 0;class T{constructor(r){this.b=r,this.a=[]}get(r){return r<this.a.length?this.a[r]:this.b}set(r,c){for(;r>=this.a.length;)this.a[this.a.length]=this.b;this.a[r]=c}replace(r,c,i){if(r>=this.a.length)return;if(c===0){this.insert(r,i);return}else if(i===0){this.delete(r,c);return}const u=this.a.slice(0,r),m=this.a.slice(r+c),l=k(i,this.b);this.a=u.concat(l,m)}delete(r,c){c===0||r>=this.a.length||this.a.splice(r,c)}insert(r,c){if(c===0||r>=this.a.length)return;const i=[];for(let u=0;u<c;u++)i[u]=this.b;this.a=(0,P.$Wb)(this.a,r,i)}}e.$DC=T;function k(C,r){const c=[];for(let i=0;i<C;i++)c[i]=r;return c}}),define(q[10],V([0,1,15]),function(z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ot=void 0;class T{static{this.defaultTokenMetadata=(32768|2<<24)>>>0}static createEmpty(r,c){const i=T.defaultTokenMetadata,u=new Uint32Array(2);return u[0]=r.length,u[1]=i,new T(u,r,c)}constructor(r,c,i){this._lineTokensBrand=void 0,this.a=r,this.b=this.a.length>>>1,this.c=c,this.d=i}equals(r){return r instanceof T?this.slicedEquals(r,0,this.b):!1}slicedEquals(r,c,i){if(this.c!==r.c||this.b!==r.b)return!1;const u=c<<1,m=u+(i<<1);for(let l=u;l<m;l++)if(this.a[l]!==r.a[l])return!1;return!0}getLineContent(){return this.c}getCount(){return this.b}getStartOffset(r){return r>0?this.a[r-1<<1]:0}getMetadata(r){return this.a[(r<<1)+1]}getLanguageId(r){const c=this.a[(r<<1)+1],i=P.$Lt.getLanguageId(c);return this.d.decodeLanguageId(i)}getStandardTokenType(r){const c=this.a[(r<<1)+1];return P.$Lt.getTokenType(c)}getForeground(r){const c=this.a[(r<<1)+1];return P.$Lt.getForeground(c)}getClassName(r){const c=this.a[(r<<1)+1];return P.$Lt.getClassNameFromMetadata(c)}getInlineStyle(r,c){const i=this.a[(r<<1)+1];return P.$Lt.getInlineStyleFromMetadata(i,c)}getPresentation(r){const c=this.a[(r<<1)+1];return P.$Lt.getPresentationFromMetadata(c)}getEndOffset(r){return this.a[r<<1]}findTokenIndexAtOffset(r){return T.findIndexInTokensArray(this.a,r)}inflate(){return this}sliceAndInflate(r,c,i){return new k(this,r,c,i)}static convertToEndOffset(r,c){const u=(r.length>>>1)-1;for(let m=0;m<u;m++)r[m<<1]=r[m+1<<1];r[u<<1]=c}static findIndexInTokensArray(r,c){if(r.length<=2)return 0;let i=0,u=(r.length>>>1)-1;for(;i<u;){const m=i+Math.floor((u-i)/2),l=r[m<<1];if(l===c)return m+1;l<c?i=m+1:l>c&&(u=m)}return i}withInserted(r){if(r.length===0)return this;let c=0,i=0,u="";const m=new Array;let l=0;for(;;){const b=c<this.b?this.a[c<<1]:-1,o=i<r.length?r[i]:null;if(b!==-1&&(o===null||b<=o.offset)){u+=this.c.substring(l,b);const n=this.a[(c<<1)+1];m.push(u.length,n),c++,l=b}else if(o){if(o.offset>l){u+=this.c.substring(l,o.offset);const n=this.a[(c<<1)+1];m.push(u.length,n),l=o.offset}u+=o.text,m.push(u.length,o.tokenMetadata),i++}else break}return new T(new Uint32Array(m),u,this.d)}}e.$Ot=T;class k{constructor(r,c,i,u){this.a=r,this.b=c,this.c=i,this.d=u,this.e=r.findTokenIndexAtOffset(c),this.f=0;for(let m=this.e,l=r.getCount();m<l&&!(r.getStartOffset(m)>=i);m++)this.f++}getMetadata(r){return this.a.getMetadata(this.e+r)}getLanguageId(r){return this.a.getLanguageId(this.e+r)}getLineContent(){return this.a.getLineContent().substring(this.b,this.c)}equals(r){return r instanceof k?this.b===r.b&&this.c===r.c&&this.d===r.d&&this.a.slicedEquals(r.a,this.e,this.f):!1}getCount(){return this.f}getForeground(r){return this.a.getForeground(this.e+r)}getEndOffset(r){const c=this.a.getEndOffset(this.e+r);return Math.min(this.c,c)-this.b+this.d}getClassName(r){return this.a.getClassName(this.e+r)}getInlineStyle(r,c){return this.a.getInlineStyle(this.e+r,c)}getPresentation(r){return this.a.getPresentation(this.e+r)}findTokenIndexAtOffset(r){return this.a.findTokenIndexAtOffset(r+this.b-this.d)-this.e}}}),define(q[34],V([0,1,10]),function(z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qt=e.$Pt=void 0,e.$Rt=k,e.$Pt=new Uint32Array(0).buffer;class T{static deleteBeginning(r,c){return r===null||r===e.$Pt?r:T.delete(r,0,c)}static deleteEnding(r,c){if(r===null||r===e.$Pt)return r;const i=k(r),u=i[i.length-2];return T.delete(r,c,u)}static delete(r,c,i){if(r===null||r===e.$Pt||c===i)return r;const u=k(r),m=u.length>>>1;if(c===0&&u[u.length-2]===i)return e.$Pt;const l=P.$Ot.findIndexInTokensArray(u,c),b=l>0?u[l-1<<1]:0,o=u[l<<1];if(i<o){const S=i-c;for(let L=l;L<m;L++)u[L<<1]-=S;return r}let n,t;b!==c?(u[l<<1]=c,n=l+1<<1,t=c):(n=l<<1,t=b);const s=i-c;for(let S=l+1;S<m;S++){const L=u[S<<1]-s;L>t&&(u[n++]=L,u[n++]=u[(S<<1)+1],t=L)}if(n===u.length)return r;const d=new Uint32Array(n);return d.set(u.subarray(0,n),0),d.buffer}static append(r,c){if(c===e.$Pt)return r;if(r===e.$Pt)return c;if(r===null)return r;if(c===null)return null;const i=k(r),u=k(c),m=u.length>>>1,l=new Uint32Array(i.length+u.length);l.set(i,0);let b=i.length;const o=i[i.length-2];for(let n=0;n<m;n++)l[b++]=u[n<<1]+o,l[b++]=u[(n<<1)+1];return l.buffer}static insert(r,c,i){if(r===null||r===e.$Pt)return r;const u=k(r),m=u.length>>>1;let l=P.$Ot.findIndexInTokensArray(u,c);l>0&&u[l-1<<1]===c&&l--;for(let b=l;b<m;b++)u[b<<1]+=i;return r}}e.$Qt=T;function k(C){return C instanceof Uint32Array?C:new Uint32Array(C)}}),define(q[35],V([0,1,33,13,47,14,34,16]),function(z,e,P,T,k,C,r,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$St=void 0;class i{static deserialize(m,l,b){const o=new Uint32Array(m.buffer),n=(0,T.$ye)(m,l);l+=4;const t=(0,T.$ye)(m,l);l+=4;const s=[];for(let d=0;d<t;d++){const S=(0,T.$ye)(m,l);l+=4,s.push(o.subarray(l/4,l/4+S/4)),l+=S}return b.push(new i(n,s)),l}get startLineNumber(){return this.a}get endLineNumber(){return this.a+this.b.length-1}constructor(m,l){this.a=m,this.b=l}getLineRange(){return new c.$kt(this.a,this.a+this.b.length)}getLineTokens(m){return this.b[m-this.a]}appendLineTokens(m){this.b.push(m)}serializeSize(){let m=0;m+=4,m+=4;for(let l=0;l<this.b.length;l++){const b=this.b[l];if(!(b instanceof Uint32Array))throw new Error("Not supported!");m+=4,m+=b.byteLength}return m}serialize(m,l){(0,T.$ze)(m,this.a,l),l+=4,(0,T.$ze)(m,this.b.length,l),l+=4;for(let b=0;b<this.b.length;b++){const o=this.b[b];if(!(o instanceof Uint32Array))throw new Error("Not supported!");(0,T.$ze)(m,o.byteLength,l),l+=4,m.set(new Uint8Array(o.buffer),l),l+=o.byteLength}return l}applyEdit(m,l){const[b,o]=(0,C.$Nt)(l);this.c(m),this.d(new k.$at(m.startLineNumber,m.startColumn),b,o)}c(m){if(m.startLineNumber===m.endLineNumber&&m.startColumn===m.endColumn)return;const l=m.startLineNumber-this.a,b=m.endLineNumber-this.a;if(b<0){const o=b-l;this.a-=o;return}if(!(l>=this.b.length)){if(l<0&&b>=this.b.length){this.a=0,this.b=[];return}if(l===b){this.b[l]=r.$Qt.delete(this.b[l],m.startColumn-1,m.endColumn-1);return}if(l>=0)if(this.b[l]=r.$Qt.deleteEnding(this.b[l],m.startColumn-1),b<this.b.length){const o=r.$Qt.deleteBeginning(this.b[b],m.endColumn-1);this.b[l]=r.$Qt.append(this.b[l],o),this.b.splice(l+1,b-l)}else this.b[l]=r.$Qt.append(this.b[l],null),this.b=this.b.slice(0,l+1);else{const o=-l;this.a-=o,this.b[b]=r.$Qt.deleteBeginning(this.b[b],m.endColumn-1),this.b=this.b.slice(b)}}}d(m,l,b){if(l===0&&b===0)return;const o=m.lineNumber-this.a;if(o<0){this.a+=l;return}if(!(o>=this.b.length)){if(l===0){this.b[o]=r.$Qt.insert(this.b[o],m.column-1,b);return}this.b[o]=r.$Qt.deleteEnding(this.b[o],m.column-1),this.b[o]=r.$Qt.insert(this.b[o],m.column-1,b),this.e(m.lineNumber,l)}}e(m,l){if(l===0)return;const b=[];for(let o=0;o<l;o++)b[o]=null;this.b=P.$Wb(this.b,m,b)}}e.$St=i}),define(q[17],V([0,1,13,35]),function(z,e,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EC=void 0;class k{static deserialize(r){let c=0;const i=(0,P.$ye)(r,c);c+=4;const u=[];for(let m=0;m<i;m++)c=T.$St.deserialize(r,c,u);return u}constructor(){this.a=[]}add(r,c){if(this.a.length>0){const i=this.a[this.a.length-1];if(i.endLineNumber+1===r){i.appendLineTokens(c);return}}this.a.push(new T.$St(r,[c]))}finalize(){return this.a}serialize(){const r=this.b(),c=new Uint8Array(r);return this.c(c),c}b(){let r=0;r+=4;for(let c=0;c<this.a.length;c++)r+=this.a[c].serializeSize();return r}c(r){let c=0;(0,P.$ze)(r,this.a.length,c),c+=4;for(let i=0;i<this.a.length;i++)c=this.a[i].serialize(r,c)}}e.$EC=k}),define(q[36],V([0,1,18,3,19,48]),function(z,e,P,T,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ag=r,e.$bg=c,e.$cg=i,e.$dg=u,e.$eg=m,e.$fg=n,e.$gg=t,e.$hg=s,e.$ig=d,e.$jg=S,e.$kg=L,e.$lg=A,e.$mg=E,e.$ng=a,e.$og=$,e.$pg=p;function r(f){return f===47||f===92}function c(f){return f.replace(/[\\/]/g,P.$hc.sep)}function i(f){return f.indexOf("/")===-1&&(f=c(f)),/^[a-zA-Z]:(\/|$)/.test(f)&&(f="/"+f),f}function u(f,v=P.$hc.sep){if(!f)return"";const N=f.length,U=f.charCodeAt(0);if(r(U)){if(r(f.charCodeAt(1))&&!r(f.charCodeAt(2))){let g=3;const M=g;for(;g<N&&!r(f.charCodeAt(g));g++);if(M!==g&&!r(f.charCodeAt(g+1))){for(g+=1;g<N;g++)if(r(f.charCodeAt(g)))return f.slice(0,g+1).replace(/[\\/]/g,v)}}return v}else if(d(U)&&f.charCodeAt(1)===58)return r(f.charCodeAt(2))?f.slice(0,2)+v:f.slice(0,2);let O=f.indexOf("://");if(O!==-1){for(O+=3;O<N;O++)if(r(f.charCodeAt(O)))return f.slice(0,O+1)}return""}function m(f){if(!T.$i||!f||f.length<5)return!1;let v=f.charCodeAt(0);if(v!==92||(v=f.charCodeAt(1),v!==92))return!1;let N=2;const U=N;for(;N<f.length&&(v=f.charCodeAt(N),v!==92);N++);return!(U===N||(v=f.charCodeAt(N+1),isNaN(v)||v===92))}const l=/[\\/:\*\?"<>\|]/g,b=/[\\/]/g,o=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function n(f,v=T.$i){const N=v?l:b;return!(!f||f.length===0||/^\s+$/.test(f)||(N.lastIndex=0,N.test(f))||v&&o.test(f)||f==="."||f===".."||v&&f[f.length-1]==="."||v&&f.length!==f.trim().length||f.length>255)}function t(f,v,N){const U=f===v;return!N||U?U:!f||!v?!1:(0,k.$lf)(f,v)}function s(f,v,N,U=P.sep){if(f===v)return!0;if(!f||!v||v.length>f.length)return!1;if(N){if(!(0,k.$mf)(f,v))return!1;if(v.length===f.length)return!0;let g=v.length;return v.charAt(v.length-1)===U&&g--,f.charAt(g)===U}return v.charAt(v.length-1)!==U&&(v+=U),f.indexOf(v)===0}function d(f){return f>=65&&f<=90||f>=97&&f<=122}function S(f,v){return T.$i&&f.endsWith(":")&&(f+=P.sep),(0,P.$jc)(f)||(f=(0,P.$kc)(v,f)),f=(0,P.$ic)(f),T.$i?(f=(0,k.$6e)(f,P.sep),f.endsWith(":")&&(f+=P.sep)):(f=(0,k.$6e)(f,P.sep),f||(f=P.sep)),f}function L(f){const v=(0,P.$ic)(f);return T.$i?f.length>3?!1:A(v)&&(f.length===2||v.charCodeAt(2)===92):v===P.$hc.sep}function A(f,v=T.$i){return v?d(f.charCodeAt(0))&&f.charCodeAt(1)===58:!1}function E(f,v=T.$i){return A(f,v)?f[0]:void 0}function a(f,v,N){return v.length>f.length?-1:f===v?0:(N&&(f=f.toLowerCase(),v=v.toLowerCase()),f.indexOf(v))}function $(f){const v=f.split(":");let N,U,O;for(const g of v){const M=Number(g);(0,C.$Yf)(M)?U===void 0?U=M:O===void 0&&(O=M):N=N?[N,g].join(":"):g}if(!N)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:N,line:U!==void 0?U:void 0,column:O!==void 0?O:U!==void 0?1:void 0}}const w="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",D="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function p(f,v,N=8){let U="";for(let g=0;g<N;g++){let M;g===0&&T.$i&&!v&&(N===3||N===4)?M=D:M=w,U+=M.charAt(Math.floor(Math.random()*M.length))}let O;return v?O=`${v}-${U}`:O=U,f?(0,P.$kc)(f,O):O}}),define(q[20],V([0,1,9,3,19,11,18]),function(z,e,P,T,k,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$ug=e.$tg=e.$sg=e.Schemas=void 0,e.$qg=i,e.$rg=u,e.$vg=l;var c;(function(n){n.inMemory="inmemory",n.vscode="vscode",n.internal="private",n.walkThrough="walkThrough",n.walkThroughSnippet="walkThroughSnippet",n.http="http",n.https="https",n.file="file",n.mailto="mailto",n.untitled="untitled",n.data="data",n.command="command",n.vscodeRemote="vscode-remote",n.vscodeRemoteResource="vscode-remote-resource",n.vscodeManagedRemoteResource="vscode-managed-remote-resource",n.vscodeUserData="vscode-userdata",n.vscodeCustomEditor="vscode-custom-editor",n.vscodeNotebookCell="vscode-notebook-cell",n.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",n.vscodeNotebookCellOutput="vscode-notebook-cell-output",n.vscodeInteractiveInput="vscode-interactive-input",n.vscodeSettings="vscode-settings",n.vscodeWorkspaceTrust="vscode-workspace-trust",n.vscodeTerminal="vscode-terminal",n.vscodeChatCodeBlock="vscode-chat-code-block",n.vscodeChatSesssion="vscode-chat-editor",n.webviewPanel="webview-panel",n.vscodeWebview="vscode-webview",n.extension="extension",n.vscodeFileResource="vscode-file",n.tmp="tmp",n.vsls="vsls",n.vscodeSourceControl="vscode-scm",n.codeSetting="code-setting"})(c||(e.Schemas=c={}));function i(n,t){return C.URI.isUri(n)?(0,k.$lf)(n.scheme,t):(0,k.$mf)(n,t+":")}function u(n,...t){return t.some(s=>i(n,s))}e.$sg="vscode-tkn",e.$tg="tkn";class m{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(t){this.d=t}setDelegate(t){this.e=t}setServerRootPath(t,s){this.f=l(t,s)}getServerRootPath(){return this.f}get g(){return r.$hc.join(this.f,c.vscodeRemoteResource)}set(t,s,d){this.a[t]=s,this.b[t]=d}setConnectionToken(t,s){this.c[t]=s}getPreferredWebSchema(){return this.d}rewrite(t){if(this.e)try{return this.e(t)}catch(E){return P.$1(E),t}const s=t.authority;let d=this.a[s];d&&d.indexOf(":")!==-1&&d.indexOf("[")===-1&&(d=`[${d}]`);const S=this.b[s],L=this.c[s];let A=`path=${encodeURIComponent(t.path)}`;return typeof L=="string"&&(A+=`&${e.$tg}=${encodeURIComponent(L)}`),C.URI.from({scheme:T.$o?this.d:c.vscodeRemoteResource,authority:`${d}:${S}`,path:this.g,query:A})}}e.$ug=new m;function l(n,t){return r.$hc.join(t??"/",`${n.quality??"oss"}-${n.commit??"dev"}`)}e.$wg="vs/../../extensions",e.$xg="vs/../../node_modules",e.$yg="vs/../../node_modules.asar",e.$zg="vs/../../node_modules.asar.unpacked",e.$Ag="vscode-app";class b{static{this.a=e.$Ag}asBrowserUri(t){const s=this.b(t,z);return this.uriToBrowserUri(s)}uriToBrowserUri(t){return t.scheme===c.vscodeRemote?e.$ug.rewrite(t):t.scheme===c.file&&(T.$m||T.$q===`${c.vscodeFileResource}://${b.a}`)?t.with({scheme:c.vscodeFileResource,authority:t.authority||b.a,query:null,fragment:null}):t}asFileUri(t){const s=this.b(t,z);return this.uriToFileUri(s)}uriToFileUri(t){return t.scheme===c.vscodeFileResource?t.with({scheme:c.file,authority:t.authority!==b.a?t.authority:null,query:null,fragment:null}):t}b(t,s){return C.URI.isUri(t)?t:C.URI.parse(s.toUrl(t))}}e.$Bg=new b;var o;(function(n){const t=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);n.CoopAndCoep=Object.freeze(t.get("3"));const s="vscode-coi";function d(L){let A;typeof L=="string"?A=new URL(L).searchParams:L instanceof URL?A=L.searchParams:C.URI.isUri(L)&&(A=new URL(L.toString(!0)).searchParams);const E=A?.get(s);if(E)return t.get(E)}n.getHeadersFromQuery=d;function S(L,A,E){if(!globalThis.crossOriginIsolated)return;const a=A&&E?"3":E?"2":"1";L instanceof URLSearchParams?L.set(s,a):L[s]=a}n.addSearchParam=S})(o||(e.COI=o={}))}),define(q[37],V([0,1,24,20,3,11]),function(z,e,P,T,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ED=m;class r{constructor(b,o,n){this.id=b,this.dependencies=o,this.callback=n}}class c{static{this.INSTANCE=new c}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(b,o,n)=>{typeof b!="string"&&(n=o,o=b,b=null),(typeof o!="object"||!Array.isArray(o))&&(n=o,o=null),this.c.push(new r(b,o,n))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(b){if(b.startsWith(window.location.origin)||b.startsWith("vscode-file://vscode-app"))return b;throw new Error(`[trusted_script_src] Invalid script url: ${b}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(b){return b}})))}async load(b){this.g();const o=await(this.a?this.i(b):this.b?this.h(b):this.j(b));if(!o)throw new Error(`Did not receive a define call from script ${b}`);if(Array.isArray(o.dependencies)&&o.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${b}. The dependencies are: ${o.dependencies.join(", ")}`);return typeof o.callback=="function"?o.callback([]):o.callback}h(b){return new Promise((o,n)=>{const t=document.createElement("script");t.setAttribute("async","async"),t.setAttribute("type","text/javascript");const s=()=>{t.removeEventListener("load",d),t.removeEventListener("error",S)},d=L=>{s(),o(this.c.pop())},S=L=>{s(),n(L)};t.addEventListener("load",d),t.addEventListener("error",S),this.f&&(b=this.f.createScriptURL(b)),t.setAttribute("src",b),window.document.getElementsByTagName("head")[0].appendChild(t)})}i(b){return new Promise((o,n)=>{try{this.f&&(b=this.f.createScriptURL(b)),importScripts(b),o(this.c.pop())}catch(t){n(t)}})}async j(b){try{const o=globalThis._VSCODE_NODE_MODULES.fs,n=globalThis._VSCODE_NODE_MODULES.vm,t=globalThis._VSCODE_NODE_MODULES.module,s=C.URI.parse(b).fsPath,d=o.readFileSync(s).toString(),S=t.wrap(d.replace(/^#!.*/,""));return new n.Script(S).runInThisContext().apply(),this.c.pop()}catch(o){throw o}}}const i=new Map;let u={};typeof globalThis.require=="object"&&(u=globalThis.require.paths??{});async function m(l,b,o){if(P.$T){o===void 0&&(o=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),u[l]&&(l=u[l]);const n=`${l}/${b}`;if(i.has(n))return i.get(n);let t;if(/^\w[\w\d+.-]*:\/\//.test(n))t=n;else{const L=`${o&&!k.$o?T.$yg:T.$xg}/${n}`;t=T.$Bg.asBrowserUri(L).toString(!0)}const s=c.INSTANCE.load(t);return i.set(n,s),s}else return await new Promise((n,t)=>{z([l],n,t)})}}),define(q[21],V([0,1,36,20,18,3,19,11]),function(z,e,P,T,k,C,r,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=void 0,e.$Ig=i,e.$4g=m,e.$5g=b;function i(o){return(0,c.$xc)(o,!0)}class u{constructor(n){this.a=n}compare(n,t,s=!1){return n===t?0:(0,r.$ef)(this.getComparisonKey(n,s),this.getComparisonKey(t,s))}isEqual(n,t,s=!1){return n===t?!0:!n||!t?!1:this.getComparisonKey(n,s)===this.getComparisonKey(t,s)}getComparisonKey(n,t=!1){return n.with({path:this.a(n)?n.path.toLowerCase():void 0,fragment:t?null:void 0}).toString()}ignorePathCasing(n){return this.a(n)}isEqualOrParent(n,t,s=!1){if(n.scheme===t.scheme){if(n.scheme===T.Schemas.file)return P.$hg(i(n),i(t),this.a(n))&&n.query===t.query&&(s||n.fragment===t.fragment);if((0,e.$Zg)(n.authority,t.authority))return P.$hg(n.path,t.path,this.a(n),"/")&&n.query===t.query&&(s||n.fragment===t.fragment)}return!1}joinPath(n,...t){return c.URI.joinPath(n,...t)}basenameOrAuthority(n){return(0,e.$Rg)(n)||n.authority}basename(n){return k.$hc.basename(n.path)}extname(n){return k.$hc.extname(n.path)}dirname(n){if(n.path.length===0)return n;let t;return n.scheme===T.Schemas.file?t=c.URI.file(k.$nc(i(n))).path:(t=k.$hc.dirname(n.path),n.authority&&t.length&&t.charCodeAt(0)!==47&&(console.error(`dirname("${n.toString})) resulted in a relative path`),t="/")),n.with({path:t})}normalizePath(n){if(!n.path.length)return n;let t;return n.scheme===T.Schemas.file?t=c.URI.file(k.$ic(i(n))).path:t=k.$hc.normalize(n.path),n.with({path:t})}relativePath(n,t){if(n.scheme!==t.scheme||!(0,e.$Zg)(n.authority,t.authority))return;if(n.scheme===T.Schemas.file){const S=k.$mc(i(n),i(t));return C.$i?P.$bg(S):S}let s=n.path||"/";const d=t.path||"/";if(this.a(n)){let S=0;for(const L=Math.min(s.length,d.length);S<L&&!(s.charCodeAt(S)!==d.charCodeAt(S)&&s.charAt(S).toLowerCase()!==d.charAt(S).toLowerCase());S++);s=d.substr(0,S)+s.substr(S)}return k.$hc.relative(s,d)}resolvePath(n,t){if(n.scheme===T.Schemas.file){const s=c.URI.file(k.$lc(i(n),t));return n.with({authority:s.authority,path:s.path})}return t=P.$cg(t),n.with({path:k.$hc.resolve(n.path,t)})}isAbsolutePath(n){return!!n.path&&n.path[0]==="/"}isEqualAuthority(n,t){return n===t||n!==void 0&&t!==void 0&&(0,r.$lf)(n,t)}hasTrailingPathSeparator(n,t=k.sep){if(n.scheme===T.Schemas.file){const s=i(n);return s.length>P.$dg(s).length&&s[s.length-1]===t}else{const s=n.path;return s.length>1&&s.charCodeAt(s.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(n.fsPath)}}removeTrailingPathSeparator(n,t=k.sep){return(0,e.$1g)(n,t)?n.with({path:n.path.substr(0,n.path.length-1)}):n}addTrailingPathSeparator(n,t=k.sep){let s=!1;if(n.scheme===T.Schemas.file){const d=i(n);s=d!==void 0&&d.length===P.$dg(d).length&&d[d.length-1]===t}else{t="/";const d=n.path;s=d.length===1&&d.charCodeAt(d.length-1)===47}return!s&&!(0,e.$1g)(n,t)?n.with({path:n.path+"/"}):n}}e.$Jg=u,e.$Kg=new u(()=>!1),e.$Lg=new u(o=>o.scheme===T.Schemas.file?!C.$k:!0),e.$Mg=new u(o=>!0),e.$Ng=e.$Kg.isEqual.bind(e.$Kg),e.$Og=e.$Kg.isEqualOrParent.bind(e.$Kg),e.$Pg=e.$Kg.getComparisonKey.bind(e.$Kg),e.$Qg=e.$Kg.basenameOrAuthority.bind(e.$Kg),e.$Rg=e.$Kg.basename.bind(e.$Kg),e.$Sg=e.$Kg.extname.bind(e.$Kg),e.$Tg=e.$Kg.dirname.bind(e.$Kg),e.$Ug=e.$Kg.joinPath.bind(e.$Kg),e.$Vg=e.$Kg.normalizePath.bind(e.$Kg),e.$Wg=e.$Kg.relativePath.bind(e.$Kg),e.$Xg=e.$Kg.resolvePath.bind(e.$Kg),e.$Yg=e.$Kg.isAbsolutePath.bind(e.$Kg),e.$Zg=e.$Kg.isEqualAuthority.bind(e.$Kg),e.$1g=e.$Kg.hasTrailingPathSeparator.bind(e.$Kg),e.$2g=e.$Kg.removeTrailingPathSeparator.bind(e.$Kg),e.$3g=e.$Kg.addTrailingPathSeparator.bind(e.$Kg);function m(o,n){const t=[];for(let s=0;s<o.length;s++){const d=n(o[s]);o.some((S,L)=>L===s?!1:(0,e.$Og)(d,n(S)))||t.push(o[s])}return t}var l;(function(o){o.META_DATA_LABEL="label",o.META_DATA_DESCRIPTION="description",o.META_DATA_SIZE="size",o.META_DATA_MIME="mime";function n(t){const s=new Map;t.path.substring(t.path.indexOf(";")+1,t.path.lastIndexOf(";")).split(";").forEach(L=>{const[A,E]=L.split(":");A&&E&&s.set(A,E)});const S=t.path.substring(0,t.path.indexOf(";"));return S&&s.set(o.META_DATA_MIME,S),s}o.parseMetaData=n})(l||(e.DataUri=l={}));function b(o,n,t){if(n){let s=o.path;return s&&s[0]!==k.$hc.sep&&(s=k.$hc.sep+s),o.with({scheme:t,authority:n,path:s})}return o.with({scheme:t})}}),define(q[22],V([0,1,28,9,38,2,21,3,31,30]),function(z,e,P,T,k,C,r,c,i,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.Promises=e.$Eh=e.$Dh=e.$Ch=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=void 0,e.$6g=m,e.$7g=l,e.$8g=b,e.$9g=o,e.$0g=n,e.$$g=t,e.$_g=s,e.$ah=d,e.$ih=f,e.$jh=v,e.$kh=N,e.$lh=U,e.$mh=O,e.$Bh=ue,e.$Jh=le;function m(j){return!!j&&typeof j.then=="function"}function l(j){const h=new P.$ee,y=j(h.token),I=new Promise((R,F)=>{const Q=h.token.onCancellationRequested(()=>{Q.dispose(),F(new T.$5)});Promise.resolve(y).then(Y=>{Q.dispose(),h.dispose(),R(Y)},Y=>{Q.dispose(),h.dispose(),F(Y)})});return new class{cancel(){h.cancel(),h.dispose()}then(R,F){return I.then(R,F)}catch(R){return this.then(void 0,R)}finally(R){return I.finally(R)}}}function b(j,h,y){return new Promise((I,R)=>{const F=h.onCancellationRequested(()=>{F.dispose(),I(y)});j.then(I,R).finally(()=>F.dispose())})}function o(j,h){return new Promise((y,I)=>{const R=h.onCancellationRequested(()=>{R.dispose(),I(new T.$5)});j.then(y,I).finally(()=>R.dispose())})}async function n(j){let h=-1;const y=j.map((I,R)=>I.then(F=>(h=R,F)));try{return await Promise.race(y)}finally{j.forEach((I,R)=>{R!==h&&I.cancel()})}}function t(j,h,y){let I;const R=setTimeout(()=>{I?.(void 0),y?.()},h);return Promise.race([j.finally(()=>clearTimeout(R)),new Promise(F=>I=F)])}function s(j){return new Promise((h,y)=>{const I=j();m(I)?I.then(h,y):h(I)})}function d(){let j,h;return{promise:new Promise((I,R)=>{j=I,h=R}),resolve:j,reject:h}}class S{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(h){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=h,!this.b){const y=()=>{if(this.b=null,this.f)return;const I=this.queue(this.d);return this.d=null,I};this.b=new Promise(I=>{this.a.then(y,y).then(I)})}return new Promise((y,I)=>{this.b.then(y,I)})}return this.a=h(),new Promise((y,I)=>{this.a.then(R=>{this.a=null,y(R)},R=>{this.a=null,I(R)})})}dispose(){this.f=!0}}e.$bh=S;class L{constructor(){this.a=Promise.resolve(null)}queue(h){return this.a=this.a.then(()=>h(),()=>h())}}e.$ch=L;class A{constructor(){this.a=new Map}queue(h,y){const R=(this.a.get(h)??Promise.resolve()).catch(()=>{}).then(y).finally(()=>{this.a.get(h)===R&&this.a.delete(h)});return this.a.set(h,R),R}}e.$dh=A;const E=(j,h)=>{let y=!0;const I=setTimeout(()=>{y=!1,h()},j);return{isTriggered:()=>y,dispose:()=>{clearTimeout(I),y=!1}}},a=j=>{let h=!0;return queueMicrotask(()=>{h&&(h=!1,j())}),{isTriggered:()=>h,dispose:()=>{h=!1}}};class ${constructor(h){this.defaultDelay=h,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(h,y=this.defaultDelay){this.g=h,this.h(),this.b||(this.b=new Promise((R,F)=>{this.d=R,this.f=F}).then(()=>{if(this.b=null,this.d=null,this.g){const R=this.g;return this.g=null,R()}}));const I=()=>{this.a=null,this.d?.(null)};return this.a=y===i.$4d?a(I):E(y,I),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new T.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$eh=$;class w{constructor(h){this.a=new $(h),this.b=new S}trigger(h,y){return this.a.trigger(()=>this.b.queue(h),y)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$fh=w;class D{constructor(){this.a=!1,this.b=new Promise((h,y)=>{this.d=h})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$gh=D;class p extends D{constructor(h){super(),this.f=setTimeout(()=>this.open(),h)}open(){clearTimeout(this.f),super.open()}}e.$hh=p;function f(j,h){return h?new Promise((y,I)=>{const R=setTimeout(()=>{F.dispose(),y()},j),F=h.onCancellationRequested(()=>{clearTimeout(R),F.dispose(),I(new T.$5)})}):l(y=>f(j,y))}function v(j,h=0,y){const I=setTimeout(()=>{j(),y&&R.dispose()},h),R=(0,C.$Sc)(()=>{clearTimeout(I),y?.deleteAndLeak(R)});return y?.add(R),R}function N(j){const h=[];let y=0;const I=j.length;function R(){return y<I?j[y++]():null}function F(Q){Q!=null&&h.push(Q);const Y=R();return Y?Y.then(F):Promise.resolve(h)}return Promise.resolve(null).then(F)}function U(j,h=I=>!!I,y=null){let I=0;const R=j.length,F=()=>{if(I>=R)return Promise.resolve(y);const Q=j[I++];return Promise.resolve(Q()).then(X=>h(X)?Promise.resolve(X):F())};return F()}function O(j,h=I=>!!I,y=null){if(j.length===0)return Promise.resolve(y);let I=j.length;const R=()=>{I=-1;for(const F of j)F.cancel?.()};return new Promise((F,Q)=>{for(const Y of j)Y.then(X=>{--I>=0&&h(X)?(R(),F(X)):I===0&&F(y)}).catch(X=>{--I>=0&&(R(),Q(X))})})}class g{constructor(h){this.a=0,this.b=!1,this.f=h,this.g=[],this.d=0,this.h=new k.$7d}whenIdle(){return this.size>0?k.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(h){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((y,I)=>{this.g.push({factory:h,c:y,e:I}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const h=this.g.shift();this.d++;const y=h.factory();y.then(h.c,h.e),y.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$nh=g;class M extends g{constructor(){super(1)}}e.$oh=M;class K{constructor(){this.a=new te,this.b=0}queue(h){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,h())):this.a.run(this.b++,h())}}e.$ph=K;class B{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const h=new x;return this.b.add(h),h.p}g(){for(const[,h]of this.a)if(h.size>0)return!1;return!0}queueSize(h,y=r.$Kg){const I=y.getComparisonKey(h);return this.a.get(I)?.size??0}queueFor(h,y,I=r.$Kg){const R=I.getComparisonKey(h);let F=this.a.get(R);if(!F){F=new M;const Q=this.f++,Y=k.Event.once(F.onDrained)(()=>{F?.dispose(),this.a.delete(R),this.h(),this.d?.deleteAndDispose(Q),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new C.$4c),this.d.set(Q,Y),this.a.set(R,F)}return F.queue(y)}h(){this.g()&&this.j()}j(){for(const h of this.b)h.complete();this.b.clear()}dispose(){for(const[,h]of this.a)h.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$qh=B;class G{constructor(h,y){this.a=-1,typeof h=="function"&&typeof y=="number"&&this.setIfNotSet(h,y)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(h,y){this.cancel(),this.a=setTimeout(()=>{this.a=-1,h()},y)}setIfNotSet(h,y){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,h()},y))}}e.$rh=G;class Z{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(h,y,I=globalThis){this.cancel();const R=I.setInterval(()=>{h()},y);this.d=(0,C.$Sc)(()=>{I.clearInterval(R),this.d=void 0})}dispose(){this.cancel()}}e.$sh=Z;class W{constructor(h,y){this.b=-1,this.a=h,this.d=y,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(h=this.d){this.cancel(),this.b=setTimeout(this.f,h)}get delay(){return this.d}set delay(h){this.d=h}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$th=W;class H{constructor(h,y){y%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${y}ms is not a multiple of 1000ms.`),this.a=h,this.b=y,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(h=this.b){h%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${h}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(h/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$uh=H;class J extends W{constructor(h,y){super(h,y),this.j=[]}work(h){this.j.push(h),this.isScheduled()||this.schedule()}h(){const h=this.j;this.j=[],this.a?.(h)}dispose(){this.j=[],super.dispose()}}e.$vh=J;class he extends C.$Uc{constructor(h,y){super(),this.g=h,this.h=y,this.a=[],this.b=this.B(new C.$Vc),this.f=!1}get pending(){return this.a.length}work(h){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+h.length>this.g.maxBufferedWork)return!1}else if(this.pending+h.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const y of h)this.a.push(y);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new W(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$wh=he,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$yh=(j,h)=>{(0,c.$B)(()=>{if(y)return;const I=Date.now()+15;h(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,I-Date.now())}}))});let y=!1;return{dispose(){y||(y=!0)}}}:e.$yh=(j,h,y)=>{const I=j.requestIdleCallback(h,typeof y=="number"?{timeout:y}:void 0);let R=!1;return{dispose(){R||(R=!0,j.cancelIdleCallback(I))}}},e.$xh=j=>(0,e.$yh)(globalThis,j)}();class ee{constructor(h,y){this.g=!1,this.d=()=>{try{this.j=y()}catch(I){this.l=I}finally{this.g=!0}},this.f=(0,e.$yh)(h,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$zh=ee;class oe extends ee{constructor(h){super(globalThis,h)}}e.$Ah=oe;async function ue(j,h,y){let I;for(let R=0;R<y;R++)try{return await j()}catch(F){I=F,await f(h)}throw I}class te{isRunning(h){return typeof h=="number"?this.a?.taskId===h:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(h,y,I){return this.a={taskId:h,cancel:()=>I?.(),promise:y},y.then(()=>this.d(h),()=>this.d(h)),y}d(h){this.a&&h===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const h=this.b;this.b=void 0,h.run().then(h.promiseResolve,h.promiseReject)}}queue(h){if(this.b)this.b.run=h;else{const{promise:y,resolve:I,reject:R}=d();this.b={run:h,promise:y,promiseResolve:I,promiseReject:R}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Ch=te;class ce{constructor(h,y=()=>Date.now()){this.d=h,this.f=y,this.a=0,this.b=0}increment(){const h=this.f();return h-this.a>this.d&&(this.a=h,this.b=0),this.b++,this.b}}e.$Dh=ce;var ne;(function(j){j[j.Resolved=0]="Resolved",j[j.Rejected=1]="Rejected"})(ne||(ne={}));class x{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((h,y)=>{this.a=h,this.b=y})}complete(h){return new Promise(y=>{this.a(h),this.d={outcome:0,value:h},y()})}error(h){return new Promise(y=>{this.b(h),this.d={outcome:1,value:h},y()})}cancel(){return this.error(new T.$5)}}e.$Eh=x;var ie;(function(j){async function h(I){let R;const F=await Promise.all(I.map(Q=>Q.then(Y=>Y,Y=>{R||(R=Y)})));if(typeof R<"u")throw R;return F}j.settled=h;function y(I){return new Promise(async(R,F)=>{try{await I(R,F)}catch(Q){F(Q)}})}j.withAsyncBody=y})(ie||(e.Promises=ie={}));class se{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(h){this.a=void 0,this.b=void 0,this.d=!1,this.promise=h.then(y=>(this.a=y,this.d=!0,y),y=>{throw this.b=y,this.d=!0,y})}requireValue(){if(!this.d)throw new T.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Fh=se;class de{constructor(h){this.b=h,this.a=new u.$V(()=>new se(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Gh=de;var re;(function(j){j[j.Initial=0]="Initial",j[j.DoneOK=1]="DoneOK",j[j.DoneError=2]="DoneError"})(re||(re={}));class _{static fromArray(h){return new _(y=>{y.emitMany(h)})}static fromPromise(h){return new _(async y=>{y.emitMany(await h)})}static fromPromises(h){return new _(async y=>{await Promise.all(h.map(async I=>y.emitOne(await I)))})}static merge(h){return new _(async y=>{await Promise.all(h.map(async I=>{for await(const R of I)y.emitOne(R)}))})}static{this.EMPTY=_.fromArray([])}constructor(h){this.a=0,this.b=[],this.d=null,this.f=new k.$7d,queueMicrotask(async()=>{const y={emitOne:I=>this.g(I),emitMany:I=>this.h(I),reject:I=>this.k(I)};try{await Promise.resolve(h(y)),this.j()}catch(I){this.k(I)}finally{y.emitOne=void 0,y.emitMany=void 0,y.reject=void 0}})}[Symbol.asyncIterator](){let h=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(h<this.b.length)return{done:!1,value:this.b[h++]};if(this.a===1)return{done:!0,value:void 0};await k.Event.toPromise(this.f.event)}while(!0)}}}static map(h,y){return new _(async I=>{for await(const R of h)I.emitOne(y(R))})}map(h){return _.map(this,h)}static filter(h,y){return new _(async I=>{for await(const R of h)y(R)&&I.emitOne(R)})}filter(h){return _.filter(this,h)}static coalesce(h){return _.filter(h,y=>!!y)}coalesce(){return _.coalesce(this)}static async toPromise(h){const y=[];for await(const I of h)y.push(I);return y}toPromise(){return _.toPromise(this)}g(h){this.a===0&&(this.b.push(h),this.f.fire())}h(h){this.a===0&&(this.b=this.b.concat(h),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(h){this.a===0&&(this.a=2,this.d=h,this.f.fire())}}e.$Hh=_;class ae extends _{constructor(h,y){super(y),this.l=h}cancel(){this.l.cancel()}}e.$Ih=ae;function le(j){const h=new P.$ee,y=j(h.token);return new ae(h,async I=>{const R=h.token.onCancellationRequested(()=>{R.dispose(),h.dispose(),I.reject(new T.$5)});try{for await(const F of y){if(h.token.isCancellationRequested)return;I.emitOne(F)}R.dispose(),h.dispose()}catch(F){R.dispose(),h.dispose(),I.reject(F)}})}class fe{constructor(){this.a=new x,this.b=new _(I=>{if(h){I.reject(h);return}return y&&I.emitMany(y),this.d=R=>I.reject(R),this.f=R=>I.emitOne(R),this.a.p});let h,y;this.f=I=>{y||(y=[]),y.push(I)},this.d=I=>{h||(h=I)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(h){this.d(h),this.a.complete()}emitOne(h){this.f(h)}}e.$Kh=fe}),define(q[23],V([0,1,39]),function(z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AC=void 0,e.$BC=T,e.$CC=k,e.$AC=new class{clone(){return this}equals(C){return this===C}};function T(C,r){return new P.$Yt([new P.$Xt(0,"",C)],r)}function k(C,r){const c=new Uint32Array(2);return c[0]=0,c[1]=(C<<0|0|0|32768|2<<24)>>>0,new P.$Zt(c,r===null?e.$AC:r)}}),define(q[40],V([0,1,22,9,3,41,14,16,49,23,32,17,10]),function(z,e,P,T,k,C,r,c,i,u,m,l,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KC=e.$JC=e.$IC=e.$HC=e.$GC=e.$FC=void 0;var o;(function(E){E[E.CHEAP_TOKENIZATION_LENGTH_LIMIT=2048]="CHEAP_TOKENIZATION_LENGTH_LIMIT"})(o||(o={}));class n{constructor(a,$){this.tokenizationSupport=$,this.a=this.tokenizationSupport.getInitialState(),this.store=new s(a)}getStartState(a){return this.store.getStartState(a,this.a)}getFirstInvalidLine(){return this.store.getFirstInvalidLine(this.a)}}e.$FC=n;class t extends n{constructor(a,$,w,D){super(a,$),this._textModel=w,this._languageIdCodec=D}updateTokensUntilLine(a,$){const w=this._textModel.getLanguageId();for(;;){const D=this.getFirstInvalidLine();if(!D||D.lineNumber>$)break;const p=this._textModel.getLineContent(D.lineNumber),f=L(this._languageIdCodec,w,this.tokenizationSupport,p,!0,D.startState);a.add(D.lineNumber,f.tokens),this.store.setEndState(D.lineNumber,f.endState)}}getTokenTypeIfInsertingCharacter(a,$){const w=this.getStartState(a.lineNumber);if(!w)return 0;const D=this._textModel.getLanguageId(),p=this._textModel.getLineContent(a.lineNumber),f=p.substring(0,a.column-1)+$+p.substring(a.column-1),v=L(this._languageIdCodec,D,this.tokenizationSupport,f,!0,w),N=new b.$Ot(v.tokens,f,this._languageIdCodec);if(N.getCount()===0)return 0;const U=N.findTokenIndexAtOffset(a.column-1);return N.getStandardTokenType(U)}tokenizeLineWithEdit(a,$,w){const D=a.lineNumber,p=a.column,f=this.getStartState(D);if(!f)return null;const v=this._textModel.getLineContent(D),N=v.substring(0,p-1)+w+v.substring(p-1+$),U=this._textModel.getLanguageIdAtPosition(D,0),O=L(this._languageIdCodec,U,this.tokenizationSupport,N,!0,f);return new b.$Ot(O.tokens,N,this._languageIdCodec)}isCheapToTokenize(a){const $=this.store.getFirstInvalidEndStateLineNumberOrMax();return a<$||a===$&&this._textModel.getLineLength(a)<2048}tokenizeHeuristically(a,$,w){if(w<=this.store.getFirstInvalidEndStateLineNumberOrMax())return{heuristicTokens:!1};if($<=this.store.getFirstInvalidEndStateLineNumberOrMax())return this.updateTokensUntilLine(a,w),{heuristicTokens:!1};let D=this.b($);const p=this._textModel.getLanguageId();for(let f=$;f<=w;f++){const v=this._textModel.getLineContent(f),N=L(this._languageIdCodec,p,this.tokenizationSupport,v,!0,D);a.add(f,N.tokens),D=N.endState}return{heuristicTokens:!0}}b(a){let $=this._textModel.getLineFirstNonWhitespaceColumn(a);const w=[];let D=null;for(let v=a-1;$>1&&v>=1;v--){const N=this._textModel.getLineFirstNonWhitespaceColumn(v);if(N!==0&&N<$&&(w.push(this._textModel.getLineContent(v)),$=N,D=this.getStartState(v),D))break}D||(D=this.tokenizationSupport.getInitialState()),w.reverse();const p=this._textModel.getLanguageId();let f=D;for(const v of w)f=L(this._languageIdCodec,p,this.tokenizationSupport,v,!1,f).endState;return f}}e.$GC=t;class s{constructor(a){this.d=a,this.a=new d,this.b=new S,this.b.addRange(new i.$it(1,a+1))}getEndState(a){return this.a.getEndState(a)}setEndState(a,$){if(!$)throw new T.$cb("Cannot set null/undefined state");this.b.delete(a);const w=this.a.setEndState(a,$);return w&&a<this.d&&this.b.addRange(new i.$it(a+1,a+2)),w}acceptChange(a,$){this.d+=$-a.length,this.a.acceptChange(a,$),this.b.addRangeAndResize(new i.$it(a.startLineNumber,a.endLineNumberExclusive),$)}acceptChanges(a){for(const $ of a){const[w]=(0,r.$Nt)($.text);this.acceptChange(new c.$kt($.range.startLineNumber,$.range.endLineNumber+1),w+1)}}invalidateEndStateRange(a){this.b.addRange(new i.$it(a.startLineNumber,a.endLineNumberExclusive))}getFirstInvalidEndStateLineNumber(){return this.b.min}getFirstInvalidEndStateLineNumberOrMax(){return this.getFirstInvalidEndStateLineNumber()||Number.MAX_SAFE_INTEGER}allStatesValid(){return this.b.min===null}getStartState(a,$){return a===1?$:this.getEndState(a-1)}getFirstInvalidLine(a){const $=this.getFirstInvalidEndStateLineNumber();if($===null)return null;const w=this.getStartState($,a);if(!w)throw new T.$cb("Start state must be defined");return{lineNumber:$,startState:w}}}e.$HC=s;class d{constructor(){this.a=new m.$DC(null)}getEndState(a){return this.a.get(a)}setEndState(a,$){const w=this.a.get(a);return w&&w.equals($)?!1:(this.a.set(a,$),!0)}acceptChange(a,$){let w=a.length;$>0&&w>0&&(w--,$--),this.a.replace(a.startLineNumber,w,$)}acceptChanges(a){for(const $ of a){const[w]=(0,r.$Nt)($.text);this.acceptChange(new c.$kt($.range.startLineNumber,$.range.endLineNumber+1),w+1)}}}e.$IC=d;class S{constructor(){this.a=[]}getRanges(){return this.a}get min(){return this.a.length===0?null:this.a[0].start}removeMin(){if(this.a.length===0)return null;const a=this.a[0];return a.start+1===a.endExclusive?this.a.shift():this.a[0]=new i.$it(a.start+1,a.endExclusive),a.start}delete(a){const $=this.a.findIndex(w=>w.contains(a));if($!==-1){const w=this.a[$];w.start===a?w.endExclusive===a+1?this.a.splice($,1):this.a[$]=new i.$it(a+1,w.endExclusive):w.endExclusive===a+1?this.a[$]=new i.$it(w.start,a):this.a.splice($,1,new i.$it(w.start,a),new i.$it(a+1,w.endExclusive))}}addRange(a){i.$it.addRange(a,this.a)}addRangeAndResize(a,$){let w=0;for(;!(w>=this.a.length||a.start<=this.a[w].endExclusive);)w++;let D=w;for(;!(D>=this.a.length||a.endExclusive<this.a[D].start);)D++;const p=$-a.length;for(let f=D;f<this.a.length;f++)this.a[f]=this.a[f].delta(p);if(w===D){const f=new i.$it(a.start,a.start+$);f.isEmpty||this.a.splice(w,0,f)}else{const f=Math.min(a.start,this.a[w].start),v=Math.max(a.endExclusive,this.a[D-1].endExclusive),N=new i.$it(f,v+p);N.isEmpty?this.a.splice(w,D-w):this.a.splice(w,D-w,N)}}toString(){return this.a.map(a=>a.toString()).join(" + ")}}e.$JC=S;function L(E,a,$,w,D,p){let f=null;if($)try{f=$.tokenizeEncoded(w,D,p.clone())}catch(v){(0,T.$1)(v)}return f||(f=(0,u.$CC)(E.encodeLanguageId(a),p)),b.$Ot.convertToEndOffset(f.tokens,w.length),f}class A{constructor(a,$){this.b=a,this.d=$,this.a=!1,this.f=!1}dispose(){this.a=!0}handleChanges(){this.g()}g(){this.f||!this.b._textModel.isAttachedToEditor()||!this.k()||(this.f=!0,(0,P.$xh)(a=>{this.f=!1,this.h(a)}))}h(a){const $=Date.now()+a.timeRemaining(),w=()=>{this.a||!this.b._textModel.isAttachedToEditor()||!this.k()||(this.j(),Date.now()<$?(0,k.$B)(w):this.g())};w()}j(){const a=this.b._textModel.getLineCount(),$=new l.$EC,w=C.$3d.create(!1);do if(w.elapsed()>1||this.l($)>=a)break;while(this.k());this.d.setTokens($.finalize()),this.checkFinished()}k(){return this.b?!this.b.store.allStatesValid():!1}l(a){const $=this.b?.getFirstInvalidLine();return $?(this.b.updateTokensUntilLine(a,$.lineNumber),$.lineNumber):this.b._textModel.getLineCount()+1}checkFinished(){this.a||this.b.store.allStatesValid()&&this.d.backgroundTokenizationFinished()}requestTokens(a,$){this.b.store.invalidateEndStateRange(new c.$kt(a,$))}}e.$KC=A}),define(q[42],V([0,1,38,2,41,15,39]),function(z,e,P,T,k,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aKb=void 0;class c extends T.$Uc{constructor(u,m,l,b,o,n,t){super(),this.c=u,this.f=m,this.g=l,this.h=b,this.j=o,this.m=n,this.n=t,this.a=[],this.b=this.B(new P.$7d),this.onDidEncounterLanguage=this.b.event}get backgroundTokenizerShouldOnlyVerifyTokens(){return this.j()}getInitialState(){return this.f}tokenize(u,m,l){throw new Error("Not supported!")}createBackgroundTokenizer(u,m){if(this.h)return this.h(u,m)}tokenizeEncoded(u,m,l){const b=Math.random()*1e4<1,o=this.n||b,n=o?new k.$3d(!0):void 0,t=this.c.tokenizeLine2(u,l,500);if(o){const d=n.elapsed();(b||d>32)&&this.m(d,u.length,b)}if(t.stoppedEarly)return console.warn(`Time limit reached when tokenizing line: ${u.substring(0,100)}`),new r.$Zt(t.tokens,l);if(this.g){const d=this.a,S=t.tokens;for(let L=0,A=S.length>>>1;L<A;L++){const E=S[(L<<1)+1],a=C.$Lt.getLanguageId(E);d[a]||(d[a]=!0,this.b.fire(a))}}let s;return l.equals(t.ruleStack)?s=l:s=t.ruleStack,new r.$Zt(t.tokens,s)}}e.$aKb=c}),define(q[43],V([0,1,23,2,12]),function(z,e,P,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bKb=void 0;class C extends T.$Uc{get backgroundTokenizerShouldOnlyVerifyTokens(){return this.b.backgroundTokenizerShouldOnlyVerifyTokens}constructor(c,i,u){super(),this.a=c,this.b=i,this.c=u,this.B((0,k.keepObserved)(this.c))}getInitialState(){return this.b.getInitialState()}tokenize(c,i,u){throw new Error("Not supported!")}tokenizeEncoded(c,i,u){return c.length>=this.c.get()?(0,P.$CC)(this.a,u):this.b.tokenizeEncoded(c,i,u)}createBackgroundTokenizer(c,i){if(this.b.createBackgroundTokenizer)return this.b.createBackgroundTokenizer(c,i)}}e.$bKb=C}),define(q[44],V([0,1,37,22,12,3,16,50,40,17,10,42,43]),function(z,e,P,T,k,C,r,c,i,u,m,l,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gKb=void 0;class o extends c.$Gv{constructor(s,d,S,L,A,E,a,$){super(s,d,S,L),this.s=A,this.t=E,this.u=a,this.a=null,this.b=!1,this.c=(0,k.observableValue)(this,-1),this.q=new T.$th(()=>this.w(),10),this.c.set($,void 0),this.v()}dispose(){this.b=!0,super.dispose()}onLanguageId(s,d){this.t=s,this.u=d,this.v()}onEvents(s){super.onEvents(s),this.a?.store.acceptChanges(s.changes),this.q.schedule()}acceptMaxTokenizationLineLength(s){this.c.set(s,void 0)}retokenize(s,d){this.a&&(this.a.store.invalidateEndStateRange(new r.$kt(s,d)),this.q.schedule())}async v(){this.a=null;const s=this.t,d=this.u,S=await this.s.getOrCreateGrammar(s,d);if(!(this.b||s!==this.t||d!==this.u||!S)){if(S.grammar){const L=new b.$bKb(this.u,new l.$aKb(S.grammar,S.initialState,!1,void 0,()=>!1,(A,E,a)=>{this.s.reportTokenizationTime(A,s,S.sourceExtensionId,E,a)},!1),this.c);this.a=new i.$FC(this.f.length,L)}else this.a=null;this.w()}}async w(){if(this.b||!this.a)return;if(!this.m){const{diffStateStacksRefEq:d}=await(0,P.$ED)("vscode-textmate","release/main.js");this.m=d}const s=new Date().getTime();for(;;){let d=0;const S=new u.$EC,L=new n;for(;;){const a=this.a.getFirstInvalidLine();if(a===null||d>200)break;d++;const $=this.f[a.lineNumber-1],w=this.a.tokenizationSupport.tokenizeEncoded($,!0,a.startState);if(this.a.store.setEndState(a.lineNumber,w.endState)){const p=this.m(a.startState,w.endState);L.setState(a.lineNumber,p)}else L.setState(a.lineNumber,null);if(m.$Ot.convertToEndOffset(w.tokens,$.length),S.add(a.lineNumber,w.tokens),new Date().getTime()-s>20)break}if(d===0)break;const A=L.getStateDeltas();if(this.s.setTokensAndStates(this.h,S.serialize(),A),new Date().getTime()-s>20){(0,C.$B)(()=>this.w());return}}}}e.$gKb=o;class n{constructor(){this.a=-1,this.b=[]}setState(s,d){s===this.a+1?this.b[this.b.length-1].stateDeltas.push(d):this.b.push({startLineNumber:s,stateDeltas:[d]}),this.a=s}getStateDeltas(){return this.b}}}),define(q[45],V([0,1,21]),function(z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dKb=void 0;class T{constructor(){this.a=Object.create(null)}reset(){this.a=Object.create(null)}register(C){if(this.a[C.scopeName]){const r=this.a[C.scopeName];P.$Ng(r.location,C.location)||console.warn(`Overwriting grammar scope name to file mapping for scope ${C.scopeName}.
Old grammar file: ${r.location.toString()}.
New grammar file: ${C.location.toString()}`)}this.a[C.scopeName]=C}getGrammarDefinition(C){return this.a[C]||null}}e.$dKb=T}),define(q[46],V([0,1,2,45]),function(z,e,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fKb=e.$eKb=void 0,e.$eKb="No TM Grammar registered for this language.";class k extends P.$Uc{constructor(r,c,i,u){super(),this.a=r,this.b=i.INITIAL,this.c=new T.$dKb,this.f={},this.g={},this.h=new Map,this.j=this.B(new i.Registry({onigLib:u,loadGrammar:async m=>{const l=this.c.getGrammarDefinition(m);if(!l)return this.a.logTrace(`No grammar found for scope ${m}`),null;const b=l.location;try{const o=await this.a.readFile(b);return i.parseRawGrammar(o,b.path)}catch(o){return this.a.logError(`Unable to load and parse grammar for scope ${m} from ${b}`,o),null}},getInjections:m=>{const l=m.split(".");let b=[];for(let o=1;o<=l.length;o++){const n=l.slice(0,o).join(".");b=[...b,...this.f[n]||[]]}return b}}));for(const m of c){if(this.c.register(m),m.injectTo){for(const l of m.injectTo){let b=this.f[l];b||(this.f[l]=b=[]),b.push(m.scopeName)}if(m.embeddedLanguages)for(const l of m.injectTo){let b=this.g[l];b||(this.g[l]=b=[]),b.push(m.embeddedLanguages)}}m.language&&this.h.set(m.language,m.scopeName)}}has(r){return this.h.has(r)}setTheme(r,c){this.j.setTheme(r,c)}getColorMap(){return this.j.getColorMap()}async createGrammar(r,c){const i=this.h.get(r);if(typeof i!="string")throw new Error(e.$eKb);const u=this.c.getGrammarDefinition(i);if(!u)throw new Error(e.$eKb);const m=u.embeddedLanguages;if(this.g[i]){const o=this.g[i];for(const n of o)for(const t of Object.keys(n))m[t]=n[t]}const l=Object.keys(m).length>0;let b;try{b=await this.j.loadGrammarWithConfiguration(i,c,{embeddedLanguages:m,tokenTypes:u.tokenTypes,balancedBracketSelectors:u.balancedBracketSelectors,unbalancedBracketSelectors:u.unbalancedBracketSelectors})}catch(o){throw o.message&&o.message.startsWith("No grammar provided for")?new Error(e.$eKb):o}return{languageId:r,grammar:b,initialState:this.b,containsEmbeddedLanguages:l,sourceExtensionId:u.sourceExtensionId}}}e.$fKb=k}),define(q[51],V([0,1,11,46,44]),function(z,e,P,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextMateTokenizationWorker=void 0,e.create=C;function C(c,i){return new r(c,i)}class r{constructor(i,u){this.f=u,this.b=new Map,this.c=[],this.a=i.host;const m=u.grammarDefinitions.map(l=>({location:P.URI.revive(l.location),language:l.language,scopeName:l.scopeName,embeddedLanguages:l.embeddedLanguages,tokenTypes:l.tokenTypes,injectTo:l.injectTo,balancedBracketSelectors:l.balancedBracketSelectors,unbalancedBracketSelectors:l.unbalancedBracketSelectors,sourceExtensionId:l.sourceExtensionId}));this.d=this.g(m)}async g(i){const u=this.f.textmateMainUri,m=await new Promise((t,s)=>{z([u],t,s)}),l=await new Promise((t,s)=>{z([this.f.onigurumaMainUri],t,s)}),o=await(await fetch(this.f.onigurumaWASMUri)).arrayBuffer();await l.loadWASM(o);const n=Promise.resolve({createOnigScanner:t=>l.createOnigScanner(t),createOnigString:t=>l.createOnigString(t)});return new T.$fKb({logTrace:t=>{},logError:(t,s)=>console.error(t,s),readFile:t=>this.a.readFile(t)},i,m,n)}acceptNewModel(i){const u=P.URI.revive(i.uri),m=this;this.b.set(i.controllerId,new k.$gKb(u,i.lines,i.EOL,i.versionId,{async getOrCreateGrammar(l,b){const o=await m.d;return o?(m.c[b]||(m.c[b]=o.createGrammar(l,b)),m.c[b]):Promise.resolve(null)},setTokensAndStates(l,b,o){m.a.setTokensAndStates(i.controllerId,l,b,o)},reportTokenizationTime(l,b,o,n,t){m.a.reportTokenizationTime(l,b,o,n,t)}},i.languageId,i.encodedLanguageId,i.maxTokenizationLineLength))}acceptModelChanged(i,u){this.b.get(i).onEvents(u)}retokenize(i,u,m){this.b.get(i).retokenize(u,m)}acceptModelLanguageChanged(i,u,m){this.b.get(i).onLanguageId(u,m)}acceptRemovedModel(i){const u=this.b.get(i);u&&(u.dispose(),this.b.delete(i))}async acceptTheme(i,u){(await this.d)?.setTheme(i,u)}acceptMaxTokenizationLineLength(i,u){this.b.get(i).acceptMaxTokenizationLineLength(u)}}e.TextMateTokenizationWorker=r})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/be210b3a60c7d60030c1d3d92da00d008edf6ab9/core/vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateTokenizationWorker.worker.js.map
